/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/uri","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/errors","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/platform/log/common/log","vs/base/common/resources","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/base/common/arrays","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/base/common/json","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","child_process","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/platform/product/common/product","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","minimist","assert","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ne=function(Y){for(var e=[],D=0,L=Y.length;D<L;D++)e[D]=te[Y[D]];return e};define(te[90],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(L,R){if(!L)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=D}),define(te[63],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function L(i){const E=[];for(let h in i)D.call(i,h)&&E.push(i[h]);return E}e.values=L;function R(i,E){for(let h in i)if(D.call(i,h)&&E({key:h,value:i[h]},function(){delete i[h]})===!1)return}e.forEach=R;function k(i,E){const h=Object.create(null);for(const b of i){const c=E(b);let y=h[c];y||(y=h[c]=[]),y.push(b)}return h}e.groupBy=k;function A(i){const E=Object.create(null);return i&&i.forEach((h,b)=>{E[b]=h}),E}e.fromMap=A;function P(i,E){const h=[],b=[];for(let c of i)E.has(c)||h.push(c);for(let c of E)i.has(c)||b.push(c);return{removed:h,added:b}}e.diffSets=P;function m(i,E){const h=[],b=[];for(let[c,y]of i)E.has(c)||h.push(y);for(let[c,y]of E)i.has(c)||b.push(y);return{removed:h,added:b}}e.diffMaps=m;class w{constructor(){this.map=new Map}add(E,h){let b=this.map.get(E);b||(b=new Set,this.map.set(E,b)),b.add(h)}delete(E,h){const b=this.map.get(E);!b||(b.delete(h),b.size===0&&this.map.delete(E))}forEach(E,h){const b=this.map.get(E);!b||b.forEach(h)}}e.SetMap=w}),define(te[64],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(A){return(P,m,w)=>{let i=null,E=null;if(typeof w.value=="function"?(i="value",E=w.value):typeof w.get=="function"&&(i="get",E=w.get),!E)throw new Error("not supported");w[i]=A(E,m)}}e.createDecorator=D;function L(A,P,m){let w=null,i=null;if(typeof m.value=="function"?(w="value",i=m.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(w="get",i=m.get),!i)throw new Error("not supported");const E=`$memoize$${P}`;m[w]=function(...h){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,h)}),this[E]}}e.memoize=L;function R(A,P,m){return D((w,i)=>{const E=`$debounce$${i}`,h=`$debounce$result$${i}`;return function(...b){this[h]||(this[h]=m?m():void 0),clearTimeout(this[E]),P&&(this[h]=P(this[h],...b),b=[this[h]]),this[E]=setTimeout(()=>{w.apply(this,b),this[h]=m?m():void 0},A)}})}e.debounce=R;function k(A,P,m){return D((w,i)=>{const E=`$throttle$timer$${i}`,h=`$throttle$result$${i}`,b=`$throttle$lastRun$${i}`,c=`$throttle$pending$${i}`;return function(...y){if(this[h]||(this[h]=m?m():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),P&&(this[h]=P(this[h],...y)),this[c])return;const I=this[b]+A;I<=Date.now()?(this[b]=Date.now(),w.apply(this,[this[h]]),this[h]=m?m():void 0):(this[c]=!0,this[E]=setTimeout(()=>{this[c]=!1,this[b]=Date.now(),w.apply(this,[this[h]]),this[h]=m?m():void 0},I-Date.now()))}})}e.throttle=k}),define(te[11],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=D,e.errorHandler=new D;function L(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=L;function R(a){m(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=R;function k(a){m(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=k;function A(a){if(a instanceof Error){let{name:t,message:r}=a;const n=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:n}}return a}e.transformErrorForSerialization=A;const P="Canceled";function m(a){return a instanceof Error&&a.name===P&&a.message===P}e.isPromiseCanceledError=m;class w extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=w;function i(){const a=new Error(P);return a.name=a.message,a}e.canceled=i;function E(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=E;function h(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=h;function b(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function c(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function y(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=y;class I extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=I;class g extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=g;class C extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=C;function v(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=v;function o(a,t=Object.create(null)){const r=new Error(a);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=o}),define(te[19],ne([0,1,11]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(q,$=0){return q[q.length-(1+$)]}e.tail=L;function R(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=R;function k(q,$,_=(J,G)=>J===G){if(q===$)return!0;if(!q||!$||q.length!==$.length)return!1;for(let J=0,G=q.length;J<G;J++)if(!_(q[J],$[J]))return!1;return!0}e.equals=k;function A(q,$,_){let J=0,G=q.length-1;for(;J<=G;){const ee=(J+G)/2|0,Z=_(q[ee],$);if(Z<0)J=ee+1;else if(Z>0)G=ee-1;else return ee}return-(J+1)}e.binarySearch=A;function P(q,$){let _=0,J=q.length;if(J===0)return 0;for(;_<J;){const G=Math.floor((_+J)/2);$(q[G])?J=G:_=G+1}return _}e.findFirstInSorted=P;function m(q,$,_){if(q=q|0,q>=$.length)throw new TypeError("invalid index");let J=$[Math.floor($.length*Math.random())],G=[],ee=[],Z=[];for(let ce of $){const ae=_(ce,J);ae<0?G.push(ce):ae>0?ee.push(ce):Z.push(ce)}return q<G.length?m(q,G,_):q<G.length+Z.length?Z[0]:m(q-(G.length+Z.length),ee,_)}e.quickSelect=m;function w(q,$){const _=[];let J;for(const G of q.slice(0).sort($))!J||$(J[0],G)!==0?(J=[G],_.push(J)):J.push(G);return _}e.groupBy=w;function i(q,$,_){const J=[];function G(ce,ae,fe){if(ae===0&&fe.length===0)return;const ye=J[J.length-1];ye&&ye.start+ye.deleteCount===ce?(ye.deleteCount+=ae,ye.toInsert.push(...fe)):J.push({start:ce,deleteCount:ae,toInsert:fe})}let ee=0,Z=0;for(;;){if(ee===q.length){G(ee,0,$.slice(Z));break}if(Z===$.length){G(ee,q.length-ee,[]);break}const ce=q[ee],ae=$[Z],fe=_(ce,ae);fe===0?(ee+=1,Z+=1):fe<0?(G(ee,1,[]),ee+=1):fe>0&&(G(ee,0,[ae]),Z+=1)}return J}e.sortedDiff=i;function E(q,$,_){const J=i(q,$,_),G=[],ee=[];for(const Z of J)G.push(...q.slice(Z.start,Z.start+Z.deleteCount)),ee.push(...Z.toInsert);return{removed:G,added:ee}}e.delta=E;function h(q,$,_){if(_===0)return[];const J=q.slice(0,_).sort($);return c(q,$,J,_,q.length),J}e.top=h;function b(q,$,_,J,G){return _===0?Promise.resolve([]):new Promise((ee,Z)=>{(async()=>{const ce=q.length,ae=q.slice(0,_).sort($);for(let fe=_,ye=Math.min(_+J,ce);fe<ce;fe=ye,ye=Math.min(ye+J,ce)){if(fe>_&&await new Promise(Se=>setTimeout(Se)),G&&G.isCancellationRequested)throw(0,D.canceled)();c(q,$,ae,fe,ye)}return ae})().then(ee,Z)})}e.topAsync=b;function c(q,$,_,J,G){for(const ee=_.length;J<G;J++){const Z=q[J];if($(Z,_[ee-1])<0){_.pop();const ce=P(_,ae=>$(Z,ae)<0);_.splice(ce,0,Z)}}}function y(q){return q.filter($=>!!$)}e.coalesce=y;function I(q){let $=0;for(let _=0;_<q.length;_++)q[_]&&(q[$]=q[_],$+=1);q.length=$}e.coalesceInPlace=I;function g(q,$,_){q.splice(_,0,q.splice($,1)[0])}e.move=g;function C(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=C;function v(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=v;function o(q,$){if(!$)return q.filter((J,G)=>q.indexOf(J)===G);const _=Object.create(null);return q.filter(J=>{const G=$(J);return _[G]?!1:(_[G]=!0,!0)})}e.distinct=o;function a(q){const $=new Set;return q.filter(_=>$.has(_)?!1:($.add(_),!0))}e.distinctES6=a;function t(q){const $=Object.create(null);return _=>{const J=q(_);return $[J]?!1:($[J]=!0,!0)}}e.uniqueFilter=t;function r(q,$){for(let _=q.length-1;_>=0;_--){const J=q[_];if($(J))return _}return-1}e.lastIndex=r;function n(q,$){return q.length>0?q[0]:$}e.firstOrDefault=n;function s(q,$,_=(J,G)=>J===G){let J=0;for(let G=0,ee=Math.min(q.length,$.length);G<ee&&_(q[G],$[G]);G++)J++;return J}e.commonPrefixLength=s;function u(q){return[].concat(...q)}e.flatten=u;function l(q,$){let _=typeof $=="number"?q:0;typeof $=="number"?_=q:(_=0,$=q);const J=[];if(_<=$)for(let G=_;G<$;G++)J.push(G);else for(let G=_;G>$;G--)J.push(G);return J}e.range=l;function f(q,$,_){return q.reduce((J,G)=>(J[$(G)]=_?_(G):G,J),Object.create(null))}e.index=f;function d(q,$){return q.push($),()=>S(q,$)}e.insert=d;function S(q,$){const _=q.indexOf($);if(_>-1)return q.splice(_,1),$}e.remove=S;function T(q,$,_){const J=q.slice(0,$),G=q.slice($);return J.concat(_,G)}e.arrayInsert=T;function O(q,$){let _;if(typeof $=="number"){let J=$;_=()=>{const G=Math.sin(J++)*179426549;return G-Math.floor(G)}}else _=Math.random;for(let J=q.length-1;J>0;J-=1){const G=Math.floor(_()*(J+1)),ee=q[J];q[J]=q[G],q[G]=ee}}e.shuffle=O;function p(q,$){const _=q.indexOf($);_>-1&&(q.splice(_,1),q.unshift($))}e.pushToStart=p;function F(q,$){const _=q.indexOf($);_>-1&&(q.splice(_,1),q.push($))}e.pushToEnd=F;function M(q,$){return Array.isArray(q)?q.map($):$(q)}e.mapArrayOrNot=M;function W(q){return Array.isArray(q)?q:[q]}e.asArray=W;function j(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=j;function U(q,$){for(const _ of q){const J=$(_);if(J!==void 0)return J}}e.mapFind=U;function N(q,$,_){const J=H(q,$),G=q.length,ee=_.length;q.length=G+ee;for(let Z=G-1;Z>=J;Z--)q[Z+ee]=q[Z];for(let Z=0;Z<ee;Z++)q[Z+J]=_[Z]}e.insertInto=N;function z(q,$,_,J){const G=H(q,$),ee=q.splice(G,_);return N(q,G,J),ee}e.splice=z;function H(q,$){return $<0?Math.max($+q.length,0):Math.min($,q.length)}function V(q,$){let _=Number.MAX_SAFE_INTEGER,J=0;return q.forEach((G,ee)=>{const Z=$(G);Z<_&&(_=Z,J=ee)}),J}e.minIndex=V;function x(q,$){let _=Number.MIN_SAFE_INTEGER,J=0;return q.forEach((G,ee)=>{const Z=$(G);Z>_&&(_=Z,J=ee)}),J}e.maxIndex=x;class K{constructor($){this.items=$,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile($){let _=this.firstIdx;for(;_<this.items.length&&$(this.items[_]);)_++;const J=_===this.firstIdx?null:this.items.slice(this.firstIdx,_);return this.firstIdx=_,J}takeFromEndWhile($){let _=this.lastIdx;for(;_>=0&&$(this.items[_]);)_--;const J=_===this.lastIdx?null:this.items.slice(_+1,this.lastIdx+1);return this.lastIdx=_,J}}e.ArrayQueue=K}),define(te[65],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(L){const R=this;let k=!1,A;return function(){return k||(k=!0,A=L.apply(R,arguments)),A}}e.once=D}),define(te[55],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(L){function R(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}L.is=R;const k=Object.freeze([]);function A(){return k}L.empty=A;function*P(a){yield a}L.single=P;function m(a){return a||k}L.from=m;function w(a){return!a||a[Symbol.iterator]().next().done===!0}L.isEmpty=w;function i(a){return a[Symbol.iterator]().next().value}L.first=i;function E(a,t){for(const r of a)if(t(r))return!0;return!1}L.some=E;function h(a,t){for(const r of a)if(t(r))return r}L.find=h;function*b(a,t){for(const r of a)t(r)&&(yield r)}L.filter=b;function*c(a,t){let r=0;for(const n of a)yield t(n,r++)}L.map=c;function*y(...a){for(const t of a)for(const r of t)yield r}L.concat=y;function*I(a){for(const t of a)for(const r of t)yield r}L.concatNested=I;function g(a,t,r){let n=r;for(const s of a)n=t(n,s);return n}L.reduce=g;function*C(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}L.slice=C;function v(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const n=a[Symbol.iterator]();for(let s=0;s<t;s++){const u=n.next();if(u.done)return[r,L.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return n}}]}L.consume=v;function o(a,t,r=(n,s)=>n===s){const n=a[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const u=n.next(),l=s.next();if(u.done!==l.done)return!1;if(u.done)return!0;if(!r(u.value,l.value))return!1}}L.equals=o})(D=e.Iterable||(e.Iterable={}))}),define(te[33],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function A(t,r=!1){let n=0,s=t.length,u="",l=0,f=16,d=0;function S(j){let U=0,N=0;for(;U<j;){const z=t.charCodeAt(n);if(z>=48&&z<=57)N=N*16+z-48;else if(z>=65&&z<=70)N=N*16+z-65+10;else if(z>=97&&z<=102)N=N*16+z-97+10;else break;n++,U++}return U<j&&(N=-1),N}function T(j){n=j,u="",l=0,f=16,d=0}function O(){const j=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&w(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&w(t.charCodeAt(n)))for(n++;n<t.length&&w(t.charCodeAt(n));)n++;else return d=3,t.substring(j,n);let U=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&w(t.charCodeAt(n))){for(n++;n<t.length&&w(t.charCodeAt(n));)n++;U=n}else d=3;return t.substring(j,U)}function p(){let j="",U=n;for(;;){if(n>=s){j+=t.substring(U,n),d=2;break}const N=t.charCodeAt(n);if(N===34){j+=t.substring(U,n),n++;break}if(N===92){if(j+=t.substring(U,n),n++,n>=s){d=2;break}switch(t.charCodeAt(n++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:const H=S(4);H>=0?j+=String.fromCharCode(H):d=4;break;default:d=5}U=n;continue}if(N>=0&&N<=31)if(m(N)){j+=t.substring(U,n),d=2;break}else d=6;n++}return j}function F(){if(u="",d=0,l=n,n>=s)return l=s,f=17;let j=t.charCodeAt(n);if(P(j)){do n++,u+=String.fromCharCode(j),j=t.charCodeAt(n);while(P(j));return f=15}if(m(j))return n++,u+=String.fromCharCode(j),j===13&&t.charCodeAt(n)===10&&(n++,u+=`
`),f=14;switch(j){case 123:return n++,f=1;case 125:return n++,f=2;case 91:return n++,f=3;case 93:return n++,f=4;case 58:return n++,f=6;case 44:return n++,f=5;case 34:return n++,u=p(),f=10;case 47:const U=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<s&&!m(t.charCodeAt(n));)n++;return u=t.substring(U,n),f=12}if(t.charCodeAt(n+1)===42){n+=2;const N=s-1;let z=!1;for(;n<N;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,z=!0;break}n++}return z||(n++,d=1),u=t.substring(U,n),f=13}return u+=String.fromCharCode(j),n++,f=16;case 45:if(u+=String.fromCharCode(j),n++,n===s||!w(t.charCodeAt(n)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=O(),f=11;default:for(;n<s&&M(j);)n++,j=t.charCodeAt(n);if(l!==n){switch(u=t.substring(l,n),u){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return u+=String.fromCharCode(j),n++,f=16}}function M(j){if(P(j)||m(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let j;do j=F();while(j>=12&&j<=15);return j}return{setPosition:T,getPosition:()=>n,scan:r?W:F,getToken:()=>f,getTokenValue:()=>u,getTokenOffset:()=>l,getTokenLength:()=>n-l,getTokenError:()=>d}}e.createScanner=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function E(t,r){const n=[],s=new Object;let u;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function d(S,T,O,p){l.value=S,l.offset=T,l.length=O,l.type=p,l.colonOffset=void 0,u=l}try{v(t,{onObjectBegin:(S,T)=>{if(r<=S)throw s;u=void 0,f=r>S,n.push("")},onObjectProperty:(S,T,O)=>{if(r<T||(d(S,T,O,"property"),n[n.length-1]=S,r<=T+O))throw s},onObjectEnd:(S,T)=>{if(r<=S)throw s;u=void 0,n.pop()},onArrayBegin:(S,T)=>{if(r<=S)throw s;u=void 0,n.push(0)},onArrayEnd:(S,T)=>{if(r<=S)throw s;u=void 0,n.pop()},onLiteralValue:(S,T,O)=>{if(r<T||(d(S,T,O,a(S)),r<=T+O))throw s},onSeparator:(S,T,O)=>{if(r<=T)throw s;if(S===":"&&u&&u.type==="property")u.colonOffset=T,f=!1,u=void 0;else if(S===","){const p=n[n.length-1];typeof p=="number"?n[n.length-1]=p+1:(f=!0,n[n.length-1]=""),u=void 0}}})}catch(S){if(S!==s)throw S}return{path:n,previousNode:u,isAtPropertyKey:f,matches:S=>{let T=0;for(let O=0;T<S.length&&O<n.length;O++)if(S[T]===n[O]||S[T]==="*")T++;else if(S[T]!=="**")return!1;return T===S.length}}}e.getLocation=E;function h(t,r=[],n=k.DEFAULT){let s=null,u=[];const l=[];function f(S){Array.isArray(u)?u.push(S):s!==null&&(u[s]=S)}return v(t,{onObjectBegin:()=>{const S={};f(S),l.push(u),u=S,s=null},onObjectProperty:S=>{s=S},onObjectEnd:()=>{u=l.pop()},onArrayBegin:()=>{const S=[];f(S),l.push(u),u=S,s=null},onArrayEnd:()=>{u=l.pop()},onLiteralValue:f,onError:(S,T,O)=>{r.push({error:S,offset:T,length:O})}},n),u[0]}e.parse=h;function b(t,r=[],n=k.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(S){s.type==="property"&&(s.length=S-s.offset,s=s.parent)}function l(S){return s.children.push(S),S}v(t,{onObjectBegin:S=>{s=l({type:"object",offset:S,length:-1,parent:s,children:[]})},onObjectProperty:(S,T,O)=>{s=l({type:"property",offset:T,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:S,offset:T,length:O,parent:s})},onObjectEnd:(S,T)=>{s.length=S+T-s.offset,s=s.parent,u(S+T)},onArrayBegin:(S,T)=>{s=l({type:"array",offset:S,length:-1,parent:s,children:[]})},onArrayEnd:(S,T)=>{s.length=S+T-s.offset,s=s.parent,u(S+T)},onLiteralValue:(S,T,O)=>{l({type:a(S),offset:T,length:O,parent:s,value:S}),u(T+O)},onSeparator:(S,T,O)=>{s.type==="property"&&(S===":"?s.colonOffset=T:S===","&&u(T))},onError:(S,T,O)=>{r.push({error:S,offset:T,length:O})}},n);const d=s.children[0];return d&&delete d.parent,d}e.parseTree=b;function c(t,r){if(!t)return;let n=t;for(let s of r)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let u=!1;for(const l of n.children)if(Array.isArray(l.children)&&l.children[0].value===s){n=l.children[1],u=!0;break}if(!u)return}else{const u=s;if(n.type!=="array"||u<0||!Array.isArray(n.children)||u>=n.children.length)return;n=n.children[u]}return n}e.findNodeAtLocation=c;function y(t){if(!t.parent||!t.parent.children)return[];const r=y(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;r.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&r.push(n)}return r}e.getNodePath=y;function I(t){switch(t.type){case"array":return t.children.map(I);case"object":const r=Object.create(null);for(let n of t.children){const s=n.children[1];s&&(r[n.children[0].value]=I(s))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=I;function g(t,r,n=!1){return r>=t.offset&&r<t.offset+t.length||n&&r===t.offset+t.length}e.contains=g;function C(t,r,n=!1){if(g(t,r,n)){const s=t.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=r;u++){const l=C(s[u],r,n);if(l)return l}return t}}e.findNodeAtOffset=C;function v(t,r,n=k.DEFAULT){const s=A(t,!1);function u(_){return _?()=>_(s.getTokenOffset(),s.getTokenLength()):()=>!0}function l(_){return _?J=>_(J,s.getTokenOffset(),s.getTokenLength()):()=>!0}const f=u(r.onObjectBegin),d=l(r.onObjectProperty),S=u(r.onObjectEnd),T=u(r.onArrayBegin),O=u(r.onArrayEnd),p=l(r.onLiteralValue),F=l(r.onSeparator),M=u(r.onComment),W=l(r.onError),j=n&&n.disallowComments,U=n&&n.allowTrailingComma;function N(){for(;;){const _=s.scan();switch(s.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:j||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(_){case 12:case 13:j?z(10):M();break;case 16:z(1);break;case 15:case 14:break;default:return _}}}function z(_,J=[],G=[]){if(W(_),J.length+G.length>0){let ee=s.getToken();for(;ee!==17;){if(J.indexOf(ee)!==-1){N();break}else if(G.indexOf(ee)!==-1)break;ee=N()}}}function H(_){const J=s.getTokenValue();return _?p(J):d(J),N(),!0}function V(){switch(s.getToken()){case 11:let _=0;try{_=JSON.parse(s.getTokenValue()),typeof _!="number"&&(z(2),_=0)}catch(J){z(2)}p(_);break;case 7:p(null);break;case 8:p(!0);break;case 9:p(!1);break;default:return!1}return N(),!0}function x(){return s.getToken()!==10?(z(3,[],[2,5]),!1):(H(!1),s.getToken()===6?(F(":"),N(),$()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function K(){f(),N();let _=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(_||z(4,[],[]),F(","),N(),s.getToken()===2&&U)break}else _&&z(6,[],[]);x()||z(4,[],[2,5]),_=!0}return S(),s.getToken()!==2?z(7,[2],[]):N(),!0}function q(){T(),N();let _=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(_||z(4,[],[]),F(","),N(),s.getToken()===4&&U)break}else _&&z(6,[],[]);$()||z(4,[],[4,5]),_=!0}return O(),s.getToken()!==4?z(8,[4],[]):N(),!0}function $(){switch(s.getToken()){case 3:return q();case 1:return K();case 10:return H(!0);default:return V()}}return N(),s.getToken()===17?n.allowEmptyContent?!0:(z(4,[],[]),!1):$()?(s.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=v;function o(t,r){let n=A(t),s=[],u,l=0,f;do switch(f=n.getPosition(),u=n.scan(),u){case 12:case 13:case 17:l!==f&&s.push(t.substring(l,f)),r!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,r)),l=n.getPosition();break}while(u!==17);return s.join("")}e.stripComments=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(te[47],ne([0,1,33]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(m,w,i){let E,h,b,c,y;if(w){for(c=w.offset,y=c+w.length,b=c;b>0&&!P(m,b-1);)b--;let l=y;for(;l<m.length&&!P(m,l);)l++;h=m.substring(b,l),E=k(h,i)}else h=m,E=0,b=0,c=0,y=m.length;const I=A(i,m);let g=!1,C=0,v;i.insertSpaces?v=R(" ",i.tabSize||4):v="	";const o=(0,D.createScanner)(h,!1);let a=!1;function t(){return I+R(v,E+C)}function r(){let l=o.scan();for(g=!1;l===15||l===14;)g=g||l===14,l=o.scan();return a=l===16||o.getTokenError()!==0,l}const n=[];function s(l,f,d){!a&&f<y&&d>c&&m.substring(f,d)!==l&&n.push({offset:f,length:d-f,content:l})}let u=r();if(u!==17){const l=o.getTokenOffset()+b,f=R(v,E);s(f,b,l)}for(;u!==17;){let l=o.getTokenOffset()+o.getTokenLength()+b,f=r(),d="";for(;!g&&(f===12||f===13);){const T=o.getTokenOffset()+b;s(" ",l,T),l=o.getTokenOffset()+o.getTokenLength()+b,d=f===12?t():"",f=r()}if(f===2)u!==1&&(C--,d=t());else if(f===4)u!==3&&(C--,d=t());else{switch(u){case 3:case 1:C++,d=t();break;case 5:case 12:d=t();break;case 13:g?d=t():d=" ";break;case 6:d=" ";break;case 10:if(f===6){d="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?d=" ":f!==5&&f!==17&&(a=!0);break;case 16:a=!0;break}g&&(f===12||f===13)&&(d=t())}const S=o.getTokenOffset()+b;s(d,l,S),u=f}return n}e.format=L;function R(m,w){let i="";for(let E=0;E<w;E++)i+=m;return i}function k(m,w){let i=0,E=0;const h=w.tabSize||4;for(;i<m.length;){const b=m.charAt(i);if(b===" ")E++;else if(b==="	")E+=h;else break;i++}return Math.floor(E/h)}function A(m,w){for(let i=0;i<w.length;i++){const E=w.charAt(i);if(E==="\r")return i+1<w.length&&w.charAt(i+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=A;function P(m,w){return`\r
`.indexOf(m.charAt(w))!==-1}e.isEOL=P}),define(te[43],ne([0,1,33,47]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(w,i,E){return k(w,i,void 0,E)}e.removeProperty=R;function k(w,i,E,h,b){const c=i.slice(),y=[],I=(0,D.parseTree)(w,y);let g,C;for(;c.length>0&&(C=c.pop(),g=(0,D.findNodeAtLocation)(I,c),g===void 0&&E!==void 0);)typeof C=="string"?E={[C]:E}:E=[E];if(g)if(g.type==="object"&&typeof C=="string"&&Array.isArray(g.children)){const v=(0,D.findNodeAtLocation)(g,[C]);if(v!==void 0)if(E===void 0){if(!v.parent)throw new Error("Malformed AST");const o=g.children.indexOf(v.parent);let a,t=v.parent.offset+v.parent.length;if(o>0){const r=g.children[o-1];a=r.offset+r.length}else a=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return A(w,{offset:a,length:t-a,content:""},h)}else return A(w,{offset:v.offset,length:v.length,content:JSON.stringify(E)},h);else{if(E===void 0)return[];const o=`${JSON.stringify(C)}: ${JSON.stringify(E)}`,a=b?b(g.children.map(r=>r.children[0].value)):g.children.length;let t;if(a>0){const r=g.children[a-1];t={offset:r.offset+r.length,length:0,content:","+o}}else g.children.length===0?t={offset:g.offset+1,length:0,content:o}:t={offset:g.offset+1,length:0,content:o+","};return A(w,t,h)}}else if(g.type==="array"&&typeof C=="number"&&Array.isArray(g.children))if(E!==void 0){const v=`${JSON.stringify(E)}`;let o;if(g.children.length===0||C===0)o={offset:g.offset+1,length:0,content:g.children.length===0?v:v+","};else{const a=C===-1||C>g.children.length?g.children.length:C,t=g.children[a-1];o={offset:t.offset+t.length,length:0,content:","+v}}return A(w,o,h)}else{const v=C,o=g.children[v];let a;if(g.children.length===1)a={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===v){const t=g.children[v-1],r=t.offset+t.length,n=g.offset+g.length;a={offset:r,length:n-2-r,content:""}}else a={offset:o.offset,length:g.children[v+1].offset-o.offset,content:""};return A(w,a,h)}else throw new Error(`Can not add ${typeof C!="number"?"index":"property"} to parent of type ${g.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return A(w,{offset:I?I.offset:0,length:I?I.length:0,content:JSON.stringify(E)},h)}}e.setProperty=k;function A(w,i,E){let h=P(w,i),b=i.offset,c=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;b>0&&!(0,L.isEOL)(h,b-1);)b--;for(;c<h.length&&!(0,L.isEOL)(h,c);)c++}const y=(0,L.format)(h,{offset:b,length:c-b},E);for(let g=y.length-1;g>=0;g--){const C=y[g];h=P(h,C),b=Math.min(b,C.offset),c=Math.max(c,C.offset+C.length),c+=C.content.length-C.length}const I=w.length-(h.length-c)-b;return[{offset:b,length:I,content:h.substring(b,c)}]}e.withFormatting=A;function P(w,i){return w.substring(0,i.offset)+i.content+w.substring(i.offset+i.length)}e.applyEdit=P;function m(w,i){let E=i.slice(0).sort((b,c)=>{const y=b.offset-c.offset;return y===0?b.length-c.length:y}),h=w.length;for(let b=E.length-1;b>=0;b--){let c=E[b];if(c.offset+c.length<=h)w=P(w,c);else throw new Error("Overlapping edit");h=c.offset}return w}e.applyEdits=m}),define(te[2],ne([0,1,65,55]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let k=null;function A(n){k=n}if(e.setDisposableTracker=A,R){const n="__is_disposable_tracked__";A(new class{trackDisposable(s){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[n]||console.log(u)},3e3)}setParent(s,u){if(s&&s!==C.None)try{s[n]=!0}catch{}}markAsDisposed(s){if(s&&s!==C.None)try{s[n]=!0}catch{}}markAsSingleton(s){}})}function P(n){return k?.trackDisposable(n),n}function m(n){k?.markAsDisposed(n)}function w(n,s){k?.setParent(n,s)}function i(n,s){if(!!k)for(const u of n)k.setParent(u,s)}function E(n){return k?.markAsSingleton(n),n}e.markAsSingleton=E;class h extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=h;function b(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=b;function c(n){if(L.Iterable.is(n)){let s=[];for(const u of n)if(u)try{u.dispose()}catch(l){s.push(l)}if(s.length===1)throw s[0];if(s.length>1)throw new h(s);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=c;function y(...n){const s=I(()=>c(n));return i(n,s),s}e.combinedDisposable=y;function I(n){const s=P({dispose:(0,D.once)(()=>{m(s),n()})});return s}e.toDisposable=I;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(m(this),this._isDisposed=!0,this.clear())}clear(){try{c(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return w(s,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new g,P(this),w(this._store,this)}dispose(){m(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class v{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&w(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,m(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&w(s,null),s}}e.MutableDisposable=v;class o{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class a{constructor(){this.references=new Map}acquire(s,...u){let l=this.references.get(s);l||(l={counter:0,object:this.createReferencedObject(s,...u)},this.references.set(s,l));const{object:f}=l,d=(0,D.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(s,l.object),this.references.delete(s))});return l.counter++,{object:f,dispose:d}}}e.ReferenceCollection=a;class t{constructor(s){this.referenceCollection=s}async acquire(s,...u){const l=this.referenceCollection.acquire(s,...u);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(f){throw l.dispose(),f}}}e.AsyncReferenceCollection=t;class r{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=r}),define(te[91],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(k){this.element=k,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class L{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let k=this._first;for(;k!==D.Undefined;){const A=k.next;k.prev=D.Undefined,k.next=D.Undefined,k=A}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,A){const P=new D(k);if(this._first===D.Undefined)this._first=P,this._last=P;else if(A){const w=this._last;this._last=P,P.prev=w,w.next=P}else{const w=this._first;this._first=P,P.next=w,w.prev=P}this._size+=1;let m=!1;return()=>{m||(m=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==D.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==D.Undefined&&k.next!==D.Undefined){const A=k.prev;A.next=k.next,k.next.prev=A}else k.prev===D.Undefined&&k.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):k.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):k.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==D.Undefined;)yield k.element,k=k.next}}e.LinkedList=L}),function(){function Y(R){const k=[];typeof R=="number"&&k.push("code/timeOrigin",R);function A(m){k.push(m,Date.now())}function P(){const m=[];for(let w=0;w<k.length;w+=2)m.push({name:k[w],startTime:k[w+1]});return m}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))k.push({name:A.name,startTime:Math.round(R+A.startTime)});return k}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=D(L))}(),define(te[4],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let L=!1,R=!1,k=!1,A=!1,P=!1,m=!1,w=!1,i,E=D,h,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?c=e.globals.vscode.process:typeof process!="undefined"&&(c=process);const y=typeof c?.versions?.electron=="string"&&c.type==="renderer";if(e.isElectronSandboxed=y&&c?.sandboxed,typeof navigator=="object"&&!y)b=navigator.userAgent,L=b.indexOf("Windows")>=0,R=b.indexOf("Macintosh")>=0,w=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=b.indexOf("Linux")>=0,m=!0,i=navigator.language,E=i;else if(typeof c=="object"){L=c.platform==="win32",R=c.platform==="darwin",k=c.platform==="linux",A=k&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,i=D,E=D;const n=c.env.VSCODE_NLS_CONFIG;if(n)try{const s=JSON.parse(n),u=s.availableLanguages["*"];i=s.locale,E=u||D,h=s._translationsConfigFile}catch(s){}P=!0}else console.error("Unable to resolve platform.");var I;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(I=e.Platform||(e.Platform={}));function g(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let C=0;R?C=1:L?C=3:k&&(C=2),e.isWindows=L,e.isMacintosh=R,e.isLinux=k,e.isLinuxSnap=A,e.isNative=P,e.isWeb=m,e.isIOS=w,e.platform=C,e.userAgent=b,e.language=E;var v;(function(n){function s(){return e.language}n.value=s;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=u;function l(){return e.language==="en"}n.isDefault=l})(v=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeSetImmediateId)for(let d=0,S=u.length;d<S;d++){const T=u[d];if(T.id===f.data.vscodeSetImmediateId){u.splice(d,1),T.callback();return}}});let l=0;return f=>{const d=++l;u.push({id:d,callback:f}),e.globals.postMessage({vscodeSetImmediateId:d},"*")}}if(typeof c?.nextTick=="function")return c.nextTick.bind(c);const s=Promise.resolve();return u=>s.then(u)}();var o;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||w?2:L?1:3;let a=!0,t=!1;function r(){if(!t){t=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,a=new Uint16Array(n.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=r}),define(te[34],ne([0,1,4]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const R=D.globals.vscode.process;L={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()},nextTick(k){return(0,D.setImmediate)(k)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}}:L={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},nextTick(R){return(0,D.setImmediate)(R)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(te[8],ne([0,1,34]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,R=97,k=90,A=122,P=46,m=47,w=92,i=58,E=63;class h extends Error{constructor(o,a,t){let r;typeof a=="string"&&a.indexOf("not ")===0?(r="must not be",a=a.replace(/^not /,"")):r="must be";const n=o.indexOf(".")!==-1?"property":"argument";let s=`The "${o}" ${n} ${r} of type ${a}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function b(v,o){if(typeof v!="string")throw new h(o,"string",v)}function c(v){return v===m||v===w}function y(v){return v===m}function I(v){return v>=L&&v<=k||v>=R&&v<=A}function g(v,o,a,t){let r="",n=0,s=-1,u=0,l=0;for(let f=0;f<=v.length;++f){if(f<v.length)l=v.charCodeAt(f);else{if(t(l))break;l=m}if(t(l)){if(!(s===f-1||u===1))if(u===2){if(r.length<2||n!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const d=r.lastIndexOf(a);d===-1?(r="",n=0):(r=r.slice(0,d),n=r.length-1-r.lastIndexOf(a)),s=f,u=0;continue}else if(r.length!==0){r="",n=0,s=f,u=0;continue}}o&&(r+=r.length>0?`${a}..`:"..",n=2)}else r.length>0?r+=`${a}${v.slice(s+1,f)}`:r=v.slice(s+1,f),n=f-s-1;s=f,u=0}else l===P&&u!==-1?++u:u=-1}return r}function C(v,o){if(o===null||typeof o!="object")throw new h("pathObject","Object",o);const a=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return a?a===o.root?`${a}${t}`:`${a}${v}${t}`:t}e.win32={resolve(...v){let o="",a="",t=!1;for(let r=v.length-1;r>=-1;r--){let n;if(r>=0){if(n=v[r],b(n,"path"),n.length===0)continue}else o.length===0?n=D.cwd():(n=D.env[`=${o}`]||D.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==o.toLowerCase()&&n.charCodeAt(2)===w)&&(n=`${o}\\`));const s=n.length;let u=0,l="",f=!1;const d=n.charCodeAt(0);if(s===1)c(d)&&(u=1,f=!0);else if(c(d))if(f=!0,c(n.charCodeAt(1))){let S=2,T=S;for(;S<s&&!c(n.charCodeAt(S));)S++;if(S<s&&S!==T){const O=n.slice(T,S);for(T=S;S<s&&c(n.charCodeAt(S));)S++;if(S<s&&S!==T){for(T=S;S<s&&!c(n.charCodeAt(S));)S++;(S===s||S!==T)&&(l=`\\\\${O}\\${n.slice(T,S)}`,u=S)}}}else u=1;else I(d)&&n.charCodeAt(1)===i&&(l=n.slice(0,2),u=2,s>2&&c(n.charCodeAt(2))&&(f=!0,u=3));if(l.length>0)if(o.length>0){if(l.toLowerCase()!==o.toLowerCase())continue}else o=l;if(t){if(o.length>0)break}else if(a=`${n.slice(u)}\\${a}`,t=f,f&&o.length>0)break}return a=g(a,!t,"\\",c),t?`${o}\\${a}`:`${o}${a}`||"."},normalize(v){b(v,"path");const o=v.length;if(o===0)return".";let a=0,t,r=!1;const n=v.charCodeAt(0);if(o===1)return y(n)?"\\":v;if(c(n))if(r=!0,c(v.charCodeAt(1))){let u=2,l=u;for(;u<o&&!c(v.charCodeAt(u));)u++;if(u<o&&u!==l){const f=v.slice(l,u);for(l=u;u<o&&c(v.charCodeAt(u));)u++;if(u<o&&u!==l){for(l=u;u<o&&!c(v.charCodeAt(u));)u++;if(u===o)return`\\\\${f}\\${v.slice(l)}\\`;u!==l&&(t=`\\\\${f}\\${v.slice(l,u)}`,a=u)}}}else a=1;else I(n)&&v.charCodeAt(1)===i&&(t=v.slice(0,2),a=2,o>2&&c(v.charCodeAt(2))&&(r=!0,a=3));let s=a<o?g(v.slice(a),!r,"\\",c):"";return s.length===0&&!r&&(s="."),s.length>0&&c(v.charCodeAt(o-1))&&(s+="\\"),t===void 0?r?`\\${s}`:s:r?`${t}\\${s}`:`${t}${s}`},isAbsolute(v){b(v,"path");const o=v.length;if(o===0)return!1;const a=v.charCodeAt(0);return c(a)||o>2&&I(a)&&v.charCodeAt(1)===i&&c(v.charCodeAt(2))},join(...v){if(v.length===0)return".";let o,a;for(let n=0;n<v.length;++n){const s=v[n];b(s,"path"),s.length>0&&(o===void 0?o=a=s:o+=`\\${s}`)}if(o===void 0)return".";let t=!0,r=0;if(typeof a=="string"&&c(a.charCodeAt(0))){++r;const n=a.length;n>1&&c(a.charCodeAt(1))&&(++r,n>2&&(c(a.charCodeAt(2))?++r:t=!1))}if(t){for(;r<o.length&&c(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(v,o){if(b(v,"from"),b(o,"to"),v===o)return"";const a=e.win32.resolve(v),t=e.win32.resolve(o);if(a===t||(v=a.toLowerCase(),o=t.toLowerCase(),v===o))return"";let r=0;for(;r<v.length&&v.charCodeAt(r)===w;)r++;let n=v.length;for(;n-1>r&&v.charCodeAt(n-1)===w;)n--;const s=n-r;let u=0;for(;u<o.length&&o.charCodeAt(u)===w;)u++;let l=o.length;for(;l-1>u&&o.charCodeAt(l-1)===w;)l--;const f=l-u,d=s<f?s:f;let S=-1,T=0;for(;T<d;T++){const p=v.charCodeAt(r+T);if(p!==o.charCodeAt(u+T))break;p===w&&(S=T)}if(T!==d){if(S===-1)return t}else{if(f>d){if(o.charCodeAt(u+T)===w)return t.slice(u+T+1);if(T===2)return t.slice(u+T)}s>d&&(v.charCodeAt(r+T)===w?S=T:T===2&&(S=3)),S===-1&&(S=0)}let O="";for(T=r+S+1;T<=n;++T)(T===n||v.charCodeAt(T)===w)&&(O+=O.length===0?"..":"\\..");return u+=S,O.length>0?`${O}${t.slice(u,l)}`:(t.charCodeAt(u)===w&&++u,t.slice(u,l))},toNamespacedPath(v){if(typeof v!="string")return v;if(v.length===0)return"";const o=e.win32.resolve(v);if(o.length<=2)return v;if(o.charCodeAt(0)===w){if(o.charCodeAt(1)===w){const a=o.charCodeAt(2);if(a!==E&&a!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(I(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===w)return`\\\\?\\${o}`;return v},dirname(v){b(v,"path");const o=v.length;if(o===0)return".";let a=-1,t=0;const r=v.charCodeAt(0);if(o===1)return c(r)?v:".";if(c(r)){if(a=t=1,c(v.charCodeAt(1))){let u=2,l=u;for(;u<o&&!c(v.charCodeAt(u));)u++;if(u<o&&u!==l){for(l=u;u<o&&c(v.charCodeAt(u));)u++;if(u<o&&u!==l){for(l=u;u<o&&!c(v.charCodeAt(u));)u++;if(u===o)return v;u!==l&&(a=t=u+1)}}}}else I(r)&&v.charCodeAt(1)===i&&(a=o>2&&c(v.charCodeAt(2))?3:2,t=a);let n=-1,s=!0;for(let u=o-1;u>=t;--u)if(c(v.charCodeAt(u))){if(!s){n=u;break}}else s=!1;if(n===-1){if(a===-1)return".";n=a}return v.slice(0,n)},basename(v,o){o!==void 0&&b(o,"ext"),b(v,"path");let a=0,t=-1,r=!0,n;if(v.length>=2&&I(v.charCodeAt(0))&&v.charCodeAt(1)===i&&(a=2),o!==void 0&&o.length>0&&o.length<=v.length){if(o===v)return"";let s=o.length-1,u=-1;for(n=v.length-1;n>=a;--n){const l=v.charCodeAt(n);if(c(l)){if(!r){a=n+1;break}}else u===-1&&(r=!1,u=n+1),s>=0&&(l===o.charCodeAt(s)?--s==-1&&(t=n):(s=-1,t=u))}return a===t?t=u:t===-1&&(t=v.length),v.slice(a,t)}for(n=v.length-1;n>=a;--n)if(c(v.charCodeAt(n))){if(!r){a=n+1;break}}else t===-1&&(r=!1,t=n+1);return t===-1?"":v.slice(a,t)},extname(v){b(v,"path");let o=0,a=-1,t=0,r=-1,n=!0,s=0;v.length>=2&&v.charCodeAt(1)===i&&I(v.charCodeAt(0))&&(o=t=2);for(let u=v.length-1;u>=o;--u){const l=v.charCodeAt(u);if(c(l)){if(!n){t=u+1;break}continue}r===-1&&(n=!1,r=u+1),l===P?a===-1?a=u:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||r===-1||s===0||s===1&&a===r-1&&a===t+1?"":v.slice(a,r)},format:C.bind(null,"\\"),parse(v){b(v,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return o;const a=v.length;let t=0,r=v.charCodeAt(0);if(a===1)return c(r)?(o.root=o.dir=v,o):(o.base=o.name=v,o);if(c(r)){if(t=1,c(v.charCodeAt(1))){let S=2,T=S;for(;S<a&&!c(v.charCodeAt(S));)S++;if(S<a&&S!==T){for(T=S;S<a&&c(v.charCodeAt(S));)S++;if(S<a&&S!==T){for(T=S;S<a&&!c(v.charCodeAt(S));)S++;S===a?t=S:S!==T&&(t=S+1)}}}}else if(I(r)&&v.charCodeAt(1)===i){if(a<=2)return o.root=o.dir=v,o;if(t=2,c(v.charCodeAt(2))){if(a===3)return o.root=o.dir=v,o;t=3}}t>0&&(o.root=v.slice(0,t));let n=-1,s=t,u=-1,l=!0,f=v.length-1,d=0;for(;f>=t;--f){if(r=v.charCodeAt(f),c(r)){if(!l){s=f+1;break}continue}u===-1&&(l=!1,u=f+1),r===P?n===-1?n=f:d!==1&&(d=1):n!==-1&&(d=-1)}return u!==-1&&(n===-1||d===0||d===1&&n===u-1&&n===s+1?o.base=o.name=v.slice(s,u):(o.name=v.slice(s,n),o.base=v.slice(s,u),o.ext=v.slice(n,u))),s>0&&s!==t?o.dir=v.slice(0,s-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...v){let o="",a=!1;for(let t=v.length-1;t>=-1&&!a;t--){const r=t>=0?v[t]:D.cwd();b(r,"path"),r.length!==0&&(o=`${r}/${o}`,a=r.charCodeAt(0)===m)}return o=g(o,!a,"/",y),a?`/${o}`:o.length>0?o:"."},normalize(v){if(b(v,"path"),v.length===0)return".";const o=v.charCodeAt(0)===m,a=v.charCodeAt(v.length-1)===m;return v=g(v,!o,"/",y),v.length===0?o?"/":a?"./":".":(a&&(v+="/"),o?`/${v}`:v)},isAbsolute(v){return b(v,"path"),v.length>0&&v.charCodeAt(0)===m},join(...v){if(v.length===0)return".";let o;for(let a=0;a<v.length;++a){const t=v[a];b(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(v,o){if(b(v,"from"),b(o,"to"),v===o||(v=e.posix.resolve(v),o=e.posix.resolve(o),v===o))return"";const a=1,t=v.length,r=t-a,n=1,s=o.length-n,u=r<s?r:s;let l=-1,f=0;for(;f<u;f++){const S=v.charCodeAt(a+f);if(S!==o.charCodeAt(n+f))break;S===m&&(l=f)}if(f===u)if(s>u){if(o.charCodeAt(n+f)===m)return o.slice(n+f+1);if(f===0)return o.slice(n+f)}else r>u&&(v.charCodeAt(a+f)===m?l=f:f===0&&(l=0));let d="";for(f=a+l+1;f<=t;++f)(f===t||v.charCodeAt(f)===m)&&(d+=d.length===0?"..":"/..");return`${d}${o.slice(n+l)}`},toNamespacedPath(v){return v},dirname(v){if(b(v,"path"),v.length===0)return".";const o=v.charCodeAt(0)===m;let a=-1,t=!0;for(let r=v.length-1;r>=1;--r)if(v.charCodeAt(r)===m){if(!t){a=r;break}}else t=!1;return a===-1?o?"/":".":o&&a===1?"//":v.slice(0,a)},basename(v,o){o!==void 0&&b(o,"ext"),b(v,"path");let a=0,t=-1,r=!0,n;if(o!==void 0&&o.length>0&&o.length<=v.length){if(o===v)return"";let s=o.length-1,u=-1;for(n=v.length-1;n>=0;--n){const l=v.charCodeAt(n);if(l===m){if(!r){a=n+1;break}}else u===-1&&(r=!1,u=n+1),s>=0&&(l===o.charCodeAt(s)?--s==-1&&(t=n):(s=-1,t=u))}return a===t?t=u:t===-1&&(t=v.length),v.slice(a,t)}for(n=v.length-1;n>=0;--n)if(v.charCodeAt(n)===m){if(!r){a=n+1;break}}else t===-1&&(r=!1,t=n+1);return t===-1?"":v.slice(a,t)},extname(v){b(v,"path");let o=-1,a=0,t=-1,r=!0,n=0;for(let s=v.length-1;s>=0;--s){const u=v.charCodeAt(s);if(u===m){if(!r){a=s+1;break}continue}t===-1&&(r=!1,t=s+1),u===P?o===-1?o=s:n!==1&&(n=1):o!==-1&&(n=-1)}return o===-1||t===-1||n===0||n===1&&o===t-1&&o===a+1?"":v.slice(o,t)},format:C.bind(null,"/"),parse(v){b(v,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return o;const a=v.charCodeAt(0)===m;let t;a?(o.root="/",t=1):t=0;let r=-1,n=0,s=-1,u=!0,l=v.length-1,f=0;for(;l>=t;--l){const d=v.charCodeAt(l);if(d===m){if(!u){n=l+1;break}continue}s===-1&&(u=!1,s=l+1),d===P?r===-1?r=l:f!==1&&(f=1):r!==-1&&(f=-1)}if(s!==-1){const d=n===0&&a?1:n;r===-1||f===0||f===1&&r===s-1&&r===n+1?o.base=o.name=v.slice(d,s):(o.name=v.slice(d,r),o.base=v.slice(d,s),o.ext=v.slice(r,s))}return n>0?o.dir=v.slice(0,n-1):a&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var L in D)(typeof exports=="object"?exports:Y)[L]=D[L]}}(typeof self!="undefined"?self:this,function(){return function(Y){var e={};function D(L){if(e[L])return e[L].exports;var R=e[L]={i:L,l:!1,exports:{}};return Y[L].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=Y,D.c=e,D.d=function(L,R,k){D.o(L,R)||Object.defineProperty(L,R,{enumerable:!0,get:k})},D.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},D.t=function(L,R){if(1&R&&(L=D(L)),8&R||4&R&&typeof L=="object"&&L&&L.__esModule)return L;var k=Object.create(null);if(D.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:L}),2&R&&typeof L!="string")for(var A in L)D.d(k,A,function(P){return L[P]}.bind(null,A));return k},D.n=function(L){var R=L&&L.__esModule?function(){return L.default}:function(){return L};return D.d(R,"a",R),R},D.o=function(L,R){return Object.prototype.hasOwnProperty.call(L,R)},D.p="",D(D.s=0)}([function(Y,e,D){(function(L){var R;e=Y.exports=G,R=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],m=e.src=[],w=0,i=w++;m[i]="0|[1-9]\\d*";var E=w++;m[E]="[0-9]+";var h=w++;m[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=w++;m[b]="("+m[i]+")\\.("+m[i]+")\\.("+m[i]+")";var c=w++;m[c]="("+m[E]+")\\.("+m[E]+")\\.("+m[E]+")";var y=w++;m[y]="(?:"+m[i]+"|"+m[h]+")";var I=w++;m[I]="(?:"+m[E]+"|"+m[h]+")";var g=w++;m[g]="(?:-("+m[y]+"(?:\\."+m[y]+")*))";var C=w++;m[C]="(?:-?("+m[I]+"(?:\\."+m[I]+")*))";var v=w++;m[v]="[0-9A-Za-z-]+";var o=w++;m[o]="(?:\\+("+m[v]+"(?:\\."+m[v]+")*))";var a=w++,t="v?"+m[b]+m[g]+"?"+m[o]+"?";m[a]="^"+t+"$";var r="[v=\\s]*"+m[c]+m[C]+"?"+m[o]+"?",n=w++;m[n]="^"+r+"$";var s=w++;m[s]="((?:<|>)?=?)";var u=w++;m[u]=m[E]+"|x|X|\\*";var l=w++;m[l]=m[i]+"|x|X|\\*";var f=w++;m[f]="[v=\\s]*("+m[l]+")(?:\\.("+m[l]+")(?:\\.("+m[l]+")(?:"+m[g]+")?"+m[o]+"?)?)?";var d=w++;m[d]="[v=\\s]*("+m[u]+")(?:\\.("+m[u]+")(?:\\.("+m[u]+")(?:"+m[C]+")?"+m[o]+"?)?)?";var S=w++;m[S]="^"+m[s]+"\\s*"+m[f]+"$";var T=w++;m[T]="^"+m[s]+"\\s*"+m[d]+"$";var O=w++;m[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var p=w++;m[p]="(?:~>?)";var F=w++;m[F]="(\\s*)"+m[p]+"\\s+",P[F]=new RegExp(m[F],"g");var M=w++;m[M]="^"+m[p]+m[f]+"$";var W=w++;m[W]="^"+m[p]+m[d]+"$";var j=w++;m[j]="(?:\\^)";var U=w++;m[U]="(\\s*)"+m[j]+"\\s+",P[U]=new RegExp(m[U],"g");var N=w++;m[N]="^"+m[j]+m[f]+"$";var z=w++;m[z]="^"+m[j]+m[d]+"$";var H=w++;m[H]="^"+m[s]+"\\s*("+r+")$|^$";var V=w++;m[V]="^"+m[s]+"\\s*("+t+")$|^$";var x=w++;m[x]="(\\s*)"+m[s]+"\\s*("+r+"|"+m[f]+")",P[x]=new RegExp(m[x],"g");var K=w++;m[K]="^\\s*("+m[f]+")\\s+-\\s+("+m[f]+")\\s*$";var q=w++;m[q]="^\\s*("+m[d]+")\\s+-\\s+("+m[d]+")\\s*$";var $=w++;m[$]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)R(_,m[_]),P[_]||(P[_]=new RegExp(m[_]));function J(Q,re){if(Q instanceof G)return Q;if(typeof Q!="string"||Q.length>k||!(re?P[n]:P[a]).test(Q))return null;try{return new G(Q,re)}catch(se){return null}}function G(Q,re){if(Q instanceof G){if(Q.loose===re)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof G))return new G(Q,re);R("SemVer",Q,re),this.loose=re;var se=Q.trim().match(re?P[n]:P[a]);if(!se)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var pe=+me;if(pe>=0&&pe<A)return pe}return me}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=J,e.valid=function(Q,re){var se=J(Q,re);return se?se.version:null},e.clean=function(Q,re){var se=J(Q.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(Q){return R("SemVer.compare",this.version,this.loose,Q),Q instanceof G||(Q=new G(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},G.prototype.compareMain=function(Q){return Q instanceof G||(Q=new G(Q,this.loose)),Z(this.major,Q.major)||Z(this.minor,Q.minor)||Z(this.patch,Q.patch)},G.prototype.comparePre=function(Q){if(Q instanceof G||(Q=new G(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],me=Q.prerelease[re];if(R("prerelease compare",re,se,me),se===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(se===void 0)return-1;if(se!==me)return Z(se,me)}while(++re)},G.prototype.inc=function(Q,re){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,re,se,me){typeof se=="string"&&(me=se,se=void 0);try{return new G(Q,se).inc(re,me).version}catch(pe){return null}},e.diff=function(Q,re){if(ye(Q,re))return null;var se=J(Q),me=J(re);if(se.prerelease.length||me.prerelease.length){for(var pe in se)if((pe==="major"||pe==="minor"||pe==="patch")&&se[pe]!==me[pe])return"pre"+pe;return"prerelease"}for(var pe in se)if((pe==="major"||pe==="minor"||pe==="patch")&&se[pe]!==me[pe])return pe},e.compareIdentifiers=Z;var ee=/^[0-9]+$/;function Z(Q,re){var se=ee.test(Q),me=ee.test(re);return se&&me&&(Q=+Q,re=+re),se&&!me?-1:me&&!se?1:Q<re?-1:Q>re?1:0}function ce(Q,re,se){return new G(Q,se).compare(new G(re,se))}function ae(Q,re,se){return ce(Q,re,se)>0}function fe(Q,re,se){return ce(Q,re,se)<0}function ye(Q,re,se){return ce(Q,re,se)===0}function Se(Q,re,se){return ce(Q,re,se)!==0}function Pe(Q,re,se){return ce(Q,re,se)>=0}function Te(Q,re,se){return ce(Q,re,se)<=0}function Re(Q,re,se,me){var pe;switch(re){case"===":typeof Q=="object"&&(Q=Q.version),typeof se=="object"&&(se=se.version),pe=Q===se;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof se=="object"&&(se=se.version),pe=Q!==se;break;case"":case"=":case"==":pe=ye(Q,se,me);break;case"!=":pe=Se(Q,se,me);break;case">":pe=ae(Q,se,me);break;case">=":pe=Pe(Q,se,me);break;case"<":pe=fe(Q,se,me);break;case"<=":pe=Te(Q,se,me);break;default:throw new TypeError("Invalid operator: "+re)}return pe}function Ce(Q,re){if(Q instanceof Ce){if(Q.loose===re)return Q;Q=Q.value}if(!(this instanceof Ce))return new Ce(Q,re);R("comparator",Q,re),this.loose=re,this.parse(Q),this.semver===Ne?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(Q,re){return Z(re,Q)},e.major=function(Q,re){return new G(Q,re).major},e.minor=function(Q,re){return new G(Q,re).minor},e.patch=function(Q,re){return new G(Q,re).patch},e.compare=ce,e.compareLoose=function(Q,re){return ce(Q,re,!0)},e.rcompare=function(Q,re,se){return ce(re,Q,se)},e.sort=function(Q,re){return Q.sort(function(se,me){return e.compare(se,me,re)})},e.rsort=function(Q,re){return Q.sort(function(se,me){return e.rcompare(se,me,re)})},e.gt=ae,e.lt=fe,e.eq=ye,e.neq=Se,e.gte=Pe,e.lte=Te,e.cmp=Re,e.Comparator=Ce;var Ne={};function De(Q,re){if(Q instanceof De)return Q.loose===re?Q:new De(Q.raw,re);if(Q instanceof Ce)return new De(Q.value,re);if(!(this instanceof De))return new De(Q,re);if(this.loose=re,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function ke(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function Ye(Q,re,se,me,pe,Ae,Ie,Oe,Le,B,ie,oe,le){return((re=ke(se)?"":ke(me)?">="+se+".0.0":ke(pe)?">="+se+"."+me+".0":">="+re)+" "+(Oe=ke(Le)?"":ke(B)?"<"+(+Le+1)+".0.0":ke(ie)?"<"+Le+"."+(+B+1)+".0":oe?"<="+Le+"."+B+"."+ie+"-"+oe:"<="+Oe)).trim()}function Je(Q,re){for(var se=0;se<Q.length;se++)if(!Q[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<Q.length;se++)if(R(Q[se].semver),Q[se].semver!==Ne&&Q[se].semver.prerelease.length>0){var me=Q[se].semver;if(me.major===re.major&&me.minor===re.minor&&me.patch===re.patch)return!0}return!1}return!0}function $e(Q,re,se){try{re=new De(re,se)}catch(me){return!1}return re.test(Q)}function qe(Q,re,se,me){var pe,Ae,Ie,Oe,Le;switch(Q=new G(Q,me),re=new De(re,me),se){case">":pe=ae,Ae=Te,Ie=fe,Oe=">",Le=">=";break;case"<":pe=fe,Ae=Pe,Ie=ae,Oe="<",Le="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(Q,re,me))return!1;for(var B=0;B<re.set.length;++B){var ie=re.set[B],oe=null,le=null;if(ie.forEach(function(de){de.semver===Ne&&(de=new Ce(">=0.0.0")),oe=oe||de,le=le||de,pe(de.semver,oe.semver,me)?oe=de:Ie(de.semver,le.semver,me)&&(le=de)}),oe.operator===Oe||oe.operator===Le||(!le.operator||le.operator===Oe)&&Ae(Q,le.semver)||le.operator===Le&&Ie(Q,le.semver))return!1}return!0}Ce.prototype.parse=function(Q){var re=this.loose?P[H]:P[V],se=Q.match(re);if(!se)throw new TypeError("Invalid comparator: "+Q);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new G(se[2],this.loose):this.semver=Ne},Ce.prototype.toString=function(){return this.value},Ce.prototype.test=function(Q){return R("Comparator.test",Q,this.loose),this.semver===Ne||(typeof Q=="string"&&(Q=new G(Q,this.loose)),Re(Q,this.operator,this.semver,this.loose))},Ce.prototype.intersects=function(Q,re){if(!(Q instanceof Ce))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new De(Q.value,re),$e(this.value,se,re);if(Q.operator==="")return se=new De(this.value,re),$e(Q.semver,se,re);var me=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),Ae=this.semver.version===Q.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),Oe=Re(this.semver,"<",Q.semver,re)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),Le=Re(this.semver,">",Q.semver,re)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return me||pe||Ae&&Ie||Oe||Le},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(Q){var re=this.loose;Q=Q.trim(),R("range",Q,re);var se=re?P[q]:P[K];Q=Q.replace(se,Ye),R("hyphen replace",Q),Q=Q.replace(P[x],"$1$2$3"),R("comparator trim",Q,P[x]),Q=(Q=(Q=Q.replace(P[F],"$1~")).replace(P[U],"$1^")).split(/\s+/).join(" ");var me=re?P[H]:P[V],pe=Q.split(" ").map(function(Ae){return function(Ie,Oe){return R("comp",Ie),Ie=function(Le,B){return Le.trim().split(/\s+/).map(function(ie){return function(oe,le){R("caret",oe,le);var de=le?P[z]:P[N];return oe.replace(de,function(we,ge,ve,Ee,be){var ue;return R("caret",oe,we,ge,ve,Ee,be),ke(ge)?ue="":ke(ve)?ue=">="+ge+".0.0 <"+(+ge+1)+".0.0":ke(Ee)?ue=ge==="0"?">="+ge+"."+ve+".0 <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+".0 <"+(+ge+1)+".0.0":be?(R("replaceCaret pr",be),be.charAt(0)!=="-"&&(be="-"+be),ue=ge==="0"?ve==="0"?">="+ge+"."+ve+"."+Ee+be+" <"+ge+"."+ve+"."+(+Ee+1):">="+ge+"."+ve+"."+Ee+be+" <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+"."+Ee+be+" <"+(+ge+1)+".0.0"):(R("no pr"),ue=ge==="0"?ve==="0"?">="+ge+"."+ve+"."+Ee+" <"+ge+"."+ve+"."+(+Ee+1):">="+ge+"."+ve+"."+Ee+" <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+"."+Ee+" <"+(+ge+1)+".0.0"),R("caret return",ue),ue})}(ie,B)}).join(" ")}(Ie,Oe),R("caret",Ie),Ie=function(Le,B){return Le.trim().split(/\s+/).map(function(ie){return function(oe,le){var de=le?P[W]:P[M];return oe.replace(de,function(we,ge,ve,Ee,be){var ue;return R("tilde",oe,we,ge,ve,Ee,be),ke(ge)?ue="":ke(ve)?ue=">="+ge+".0.0 <"+(+ge+1)+".0.0":ke(Ee)?ue=">="+ge+"."+ve+".0 <"+ge+"."+(+ve+1)+".0":be?(R("replaceTilde pr",be),be.charAt(0)!=="-"&&(be="-"+be),ue=">="+ge+"."+ve+"."+Ee+be+" <"+ge+"."+(+ve+1)+".0"):ue=">="+ge+"."+ve+"."+Ee+" <"+ge+"."+(+ve+1)+".0",R("tilde return",ue),ue})}(ie,B)}).join(" ")}(Ie,Oe),R("tildes",Ie),Ie=function(Le,B){return R("replaceXRanges",Le,B),Le.split(/\s+/).map(function(ie){return function(oe,le){oe=oe.trim();var de=le?P[T]:P[S];return oe.replace(de,function(we,ge,ve,Ee,be,ue){R("xRange",oe,we,ge,ve,Ee,be,ue);var Ue=ke(ve),Fe=Ue||ke(Ee),Me=Fe||ke(be);return ge==="="&&Me&&(ge=""),Ue?we=ge===">"||ge==="<"?"<0.0.0":"*":ge&&Me?(Fe&&(Ee=0),Me&&(be=0),ge===">"?(ge=">=",Fe?(ve=+ve+1,Ee=0,be=0):Me&&(Ee=+Ee+1,be=0)):ge==="<="&&(ge="<",Fe?ve=+ve+1:Ee=+Ee+1),we=ge+ve+"."+Ee+"."+be):Fe?we=">="+ve+".0.0 <"+(+ve+1)+".0.0":Me&&(we=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0"),R("xRange return",we),we})}(ie,B)}).join(" ")}(Ie,Oe),R("xrange",Ie),Ie=function(Le,B){return R("replaceStars",Le,B),Le.trim().replace(P[$],"")}(Ie,Oe),R("stars",Ie),Ie}(Ae,re)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(Ae){return!!Ae.match(me)})),pe=pe.map(function(Ae){return new Ce(Ae,re)})},De.prototype.intersects=function(Q,re){if(!(Q instanceof De))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(me){return Q.set.some(function(pe){return pe.every(function(Ae){return me.intersects(Ae,re)})})})})},e.toComparators=function(Q,re){return new De(Q,re).set.map(function(se){return se.map(function(me){return me.value}).join(" ").trim().split(" ")})},De.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new G(Q,this.loose));for(var re=0;re<this.set.length;re++)if(Je(this.set[re],Q))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(Q,re,se){var me=null,pe=null;try{var Ae=new De(re,se)}catch(Ie){return null}return Q.forEach(function(Ie){Ae.test(Ie)&&(me&&pe.compare(Ie)!==-1||(pe=new G(me=Ie,se)))}),me},e.minSatisfying=function(Q,re,se){var me=null,pe=null;try{var Ae=new De(re,se)}catch(Ie){return null}return Q.forEach(function(Ie){Ae.test(Ie)&&(me&&pe.compare(Ie)!==1||(pe=new G(me=Ie,se)))}),me},e.validRange=function(Q,re){try{return new De(Q,re).range||"*"}catch(se){return null}},e.ltr=function(Q,re,se){return qe(Q,re,"<",se)},e.gtr=function(Q,re,se){return qe(Q,re,">",se)},e.outside=qe,e.prerelease=function(Q,re){var se=J(Q,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(Q,re,se){return Q=new De(Q,se),re=new De(re,se),Q.intersects(re)},e.coerce=function(Q){if(Q instanceof G)return Q;if(typeof Q!="string")return null;var re=Q.match(P[O]);return re==null?null:J((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,D(1))},function(Y,e){var D,L,R=Y.exports={};function k(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(I){if(D===setTimeout)return setTimeout(I,0);if((D===k||!D)&&setTimeout)return D=setTimeout,setTimeout(I,0);try{return D(I,0)}catch(g){try{return D.call(null,I,0)}catch(C){return D.call(this,I,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:k}catch(I){D=k}try{L=typeof clearTimeout=="function"?clearTimeout:A}catch(I){L=A}})();var m,w=[],i=!1,E=-1;function h(){i&&m&&(i=!1,m.length?w=m.concat(w):E=-1,w.length&&b())}function b(){if(!i){var I=P(h);i=!0;for(var g=w.length;g;){for(m=w,w=[];++E<g;)m&&m[E].run();E=-1,g=w.length}m=null,i=!1,function(C){if(L===clearTimeout)return clearTimeout(C);if((L===A||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(C);try{L(C)}catch(v){try{return L.call(null,C)}catch(o){return L.call(this,C)}}}(I)}}function c(I,g){this.fun=I,this.array=g}function y(){}R.nextTick=function(I){var g=new Array(arguments.length-1);if(arguments.length>1)for(var C=1;C<arguments.length;C++)g[C-1]=arguments[C];w.push(new c(I,g)),w.length!==1||i||P(b)},c.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=y,R.addListener=y,R.once=y,R.off=y,R.removeListener=y,R.removeAllListeners=y,R.emit=y,R.prependListener=y,R.prependOnceListener=y,R.listeners=function(I){return[]},R.binding=function(I){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(I){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(te[92],ne([0,1,4]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=D.globals.performance&&typeof D.globals.performance.now=="function";class R{constructor(A){this._highResolution=L&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new R(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(te[3],ne([0,1,11,65,2,91,92]),function(Y,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(v){v.None=()=>R.Disposable.None;function o(j){return(U,N=null,z)=>{let H=!1,V;return V=j(x=>{if(!H)return V?V.dispose():H=!0,U.call(N,x)},null,z),H&&V.dispose(),V}}v.once=o;function a(j,U){return l((N,z=null,H)=>j(V=>N.call(z,U(V)),null,H))}v.map=a;function t(j,U){return l((N,z=null,H)=>j(V=>{U(V),N.call(z,V)},null,H))}v.forEach=t;function r(j,U){return l((N,z=null,H)=>j(V=>U(V)&&N.call(z,V),null,H))}v.filter=r;function n(j){return j}v.signal=n;function s(...j){return(U,N=null,z)=>(0,R.combinedDisposable)(...j.map(H=>H(V=>U.call(N,V),null,z)))}v.any=s;function u(j,U,N){let z=N;return a(j,H=>(z=U(z,H),z))}v.reduce=u;function l(j){let U;const N=new h({onFirstListenerAdd(){U=j(N.fire,N)},onLastListenerRemove(){U.dispose()}});return N.event}function f(j,U,N=100,z=!1,H){let V,x,K,q=0;const $=new h({leakWarningThreshold:H,onFirstListenerAdd(){V=j(_=>{q++,x=U(x,_),z&&!K&&($.fire(x),x=void 0),clearTimeout(K),K=setTimeout(()=>{const J=x;x=void 0,K=void 0,(!z||q>1)&&$.fire(J),q=0},N)})},onLastListenerRemove(){V.dispose()}});return $.event}v.debounce=f;function d(j,U=(N,z)=>N===z){let N=!0,z;return r(j,H=>{const V=N||!U(H,z);return N=!1,z=H,V})}v.latch=d;function S(j,U){return[v.filter(j,U),v.filter(j,N=>!U(N))]}v.split=S;function T(j,U=!1,N=[]){let z=N.slice(),H=j(K=>{z?z.push(K):x.fire(K)});const V=()=>{z&&z.forEach(K=>x.fire(K)),z=null},x=new h({onFirstListenerAdd(){H||(H=j(K=>x.fire(K)))},onFirstListenerDidAdd(){z&&(U?setTimeout(V):V())},onLastListenerRemove(){H&&H.dispose(),H=null}});return x.event}v.buffer=T;class O{constructor(U){this.event=U}map(U){return new O(a(this.event,U))}forEach(U){return new O(t(this.event,U))}filter(U){return new O(r(this.event,U))}reduce(U,N){return new O(u(this.event,U,N))}latch(){return new O(d(this.event))}debounce(U,N=100,z=!1,H){return new O(f(this.event,U,N,z,H))}on(U,N,z){return this.event(U,N,z)}once(U,N,z){return o(this.event)(U,N,z)}}function p(j){return new O(j)}v.chain=p;function F(j,U,N=z=>z){const z=(...K)=>x.fire(N(...K)),H=()=>j.on(U,z),V=()=>j.removeListener(U,z),x=new h({onFirstListenerAdd:H,onLastListenerRemove:V});return x.event}v.fromNodeEventEmitter=F;function M(j,U,N=z=>z){const z=(...K)=>x.fire(N(...K)),H=()=>j.addEventListener(U,z),V=()=>j.removeEventListener(U,z),x=new h({onFirstListenerAdd:H,onLastListenerRemove:V});return x.event}v.fromDOMEventEmitter=M;function W(j){return new Promise(U=>o(j)(U))}v.toPromise=W})(P=e.Event||(e.Event={}));class m{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${m._idPool++}`}start(o){this._stopWatch=new A.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}m._idPool=0;let w=-1;function i(v){const o=w;return w=v,{dispose(){w=o}}}e.setGlobalLeakWarningThreshold=i;class E{constructor(o,a=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let a=w;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||o<a)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let n,s=0;for(const[u,l]of this._stacks)(!n||s<l)&&(n=u,s=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${s}):`),console.warn(n)}return()=>{const n=this._stacks.get(t)||0;this._stacks.set(t,n-1)}}}class h{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=w>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new m(this._options._profName):void 0}get event(){return this._event||(this._event=(o,a,t)=>{this._listeners||(this._listeners=new k.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(a?[o,a]:o);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,a);const s=this._leakageMon?.check(this._listeners.size),u=(0,R.toDisposable)(()=>{s&&s(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof R.DisposableStore?t.add(u):Array.isArray(t)&&t.push(u),u}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,o]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(r){(0,D.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=h;class b extends h{async fireAsync(o,a,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,o]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[r,n]=this._asyncDeliveryQueue.shift(),s=[],u={...n,waitUntil:l=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");t&&(l=t(l,typeof r=="function"?r:r[0])),s.push(l)}};try{typeof r=="function"?r.call(void 0,u):r[0].call(r[1],u)}catch(l){(0,D.onUnexpectedError)(l);continue}Object.freeze(s),await Promise.allSettled(s).then(l=>{for(const f of l)f.status==="rejected"&&(0,D.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=b;class c extends h{constructor(o){super(o);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=c;class y extends c{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}e.DebounceEmitter=y;class I{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const a={event:o,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const t=()=>{this.hasListeners&&this.unhook(a);const r=this.events.indexOf(a);this.events.splice(r,1)};return(0,R.toDisposable)((0,L.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(a=>this.emitter.fire(a))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=I;class g{constructor(){this.buffers=[]}wrapEvent(o){return(a,t,r)=>o(n=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>a.call(t,n)):a.call(t,n)},void 0,r)}bufferEvents(o){const a=[];this.buffers.push(a);const t=o();return this.buffers.pop(),a.forEach(r=>r()),t}}e.EventBufferer=g;class C{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=R.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=C}),define(te[29],ne([0,1,3]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,m){const w=setTimeout(P.bind(m),0);return{dispose(){clearTimeout(w)}}});var R;(function(P){function m(w){return w===P.None||w===P.Cancelled||w instanceof k?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}P.isCancellationToken=m,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(R=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(m){this._token=void 0,this._parentListener=void 0,this._parentListener=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=R.Cancelled}dispose(m=!1){m&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=A}),define(te[48],ne([0,1,3]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new D.Emitter}add(E){const h=this._icons.get(E.id);h?E.description?h.description=E.description:console.error(`Duplicate registration of codicon ${E.id}`):(this._icons.set(E.id,E),this._onDidRegister.fire(E))}get(E){return this._icons.get(E)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new L;e.iconRegistry=R;function k(i,E){return new P(i,E)}e.registerCodicon=k;function A(i){return i?i.replace(/\$\((.*?)\)/g,(E,h)=>` ${h} `).trim():""}e.getCodiconAriaLabel=A;class P{constructor(E,h,b){this.id=E,this.definition=h,this.description=b,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function m(i,E){const h=["codicon","codicon-"+i];return E&&h.push("codicon-modifier-"+E),h}e.getClassNamesArray=m;var w;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const E=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function h(y){if(y instanceof P)return["codicon","codicon-"+y.id];const I=E.exec(y.id);if(!I)return h(P.error);let[,g,C]=I;const v=["codicon","codicon-"+g];return C&&v.push("codicon-modifier-"+C.substr(1)),v}i.asClassNameArray=h;function b(y){return h(y).join(" ")}i.asClassName=b;function c(y){return"."+h(y).join(".")}i.asCSSSelector=c})(w=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(te[49],ne([0,1,11,2]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(v){const o=v;return o?[o.on,o.pause,o.resume,o.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=R;function k(v){const o=v;return o?R(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=k;function A(v,o){return new P(v,o)}e.newWriteableStream=A;class P{constructor(o,a){this.reducer=o,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(a=>a(o))}emitError(o){this.listeners.error.length===0?(0,D.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(a=>a(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,a){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(o,a){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(a);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(v,o){const a=[];let t;for(;(t=v.read())!==null;)a.push(t);return o(a)}e.consumeReadable=m;function w(v,o,a){const t=[];let r;for(;(r=v.read())!==null&&t.length<a;)t.push(r);return r===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const n=r;return r=void 0,n}return v.read()}}}e.peekReadable=w;function i(v,o){return new Promise((a,t)=>{const r=[];E(v,{onData:n=>{o&&r.push(n)},onError:n=>{o?t(n):a(void 0)},onEnd:()=>{a(o?o(r):void 0)}})})}e.consumeStream=i;function E(v,o){v.on("error",a=>o.onError(a)),v.on("end",()=>o.onEnd()),v.on("data",a=>o.onData(a))}e.listenStream=E;function h(v,o){return new Promise((a,t)=>{const r=new L.DisposableStore,n=[],s=f=>{if(n.push(f),n.length>o)return r.dispose(),v.pause(),a({stream:v,buffer:n,ended:!1})},u=f=>t(f),l=()=>a({stream:v,buffer:n,ended:!0});r.add((0,L.toDisposable)(()=>v.removeListener("error",u))),v.on("error",u),r.add((0,L.toDisposable)(()=>v.removeListener("end",l))),v.on("end",l),r.add((0,L.toDisposable)(()=>v.removeListener("data",s))),v.on("data",s)})}e.peekStream=h;function b(v,o){const a=A(o);return a.end(v),a}e.toStream=b;function c(){const v=A(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=c;function y(v){let o=!1;return{read:()=>o?null:(o=!0,v)}}e.toReadable=y;function I(v,o,a){const t=A(a);return E(v,{onData:r=>t.write(o.data(r)),onError:r=>t.error(o.error?o.error(r):r),onEnd:()=>t.end()}),t}e.transform=I;function g(v,o,a){let t=!1;return{read:()=>{const r=o.read();return t?r:(t=!0,r!==null?a([v,r]):v)}}}e.prefixedReadable=g;function C(v,o,a){let t=!1;const r=A(a);return E(o,{onData:n=>t?r.write(n):(t=!0,r.write(a([v,n]))),onError:n=>r.error(n),onEnd:()=>{t||(t=!0,r.write(v)),r.end()}}),r}e.prefixedStream=C}),define(te[25],ne([0,1,49]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let R,k;class A{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return L?new A(Buffer.allocUnsafe(s)):new A(new Uint8Array(s))}static wrap(s){return L&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new A(s)}static fromString(s,u){return!(u?.dontUseNodeBuffer||!1)&&L?new A(Buffer.from(s)):(R||(R=new TextEncoder),new A(R.encode(s)))}static concat(s,u){if(typeof u=="undefined"){u=0;for(let d=0,S=s.length;d<S;d++)u+=s[d].byteLength}const l=A.alloc(u);let f=0;for(let d=0,S=s.length;d<S;d++){const T=s[d];l.set(T,f),f+=T.byteLength}return l}toString(){return L?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(s,u){return new A(this.buffer.subarray(s,u))}set(s,u){s instanceof A?this.buffer.set(s.buffer,u):this.buffer.set(s,u)}readUInt32BE(s){return w(this.buffer,s)}writeUInt32BE(s,u){i(this.buffer,s,u)}readUInt32LE(s){return E(this.buffer,s)}writeUInt32LE(s,u){h(this.buffer,s,u)}readUInt8(s){return b(this.buffer,s)}writeUInt8(s,u){c(this.buffer,s,u)}}e.VSBuffer=A;function P(n,s){return n[s+0]<<0>>>0|n[s+1]<<8>>>0}e.readUInt16LE=P;function m(n,s,u){n[u+0]=s&255,s=s>>>8,n[u+1]=s&255}e.writeUInt16LE=m;function w(n,s){return n[s]*2**24+n[s+1]*2**16+n[s+2]*2**8+n[s+3]}e.readUInt32BE=w;function i(n,s,u){n[u+3]=s,s=s>>>8,n[u+2]=s,s=s>>>8,n[u+1]=s,s=s>>>8,n[u]=s}e.writeUInt32BE=i;function E(n,s){return n[s+0]<<0>>>0|n[s+1]<<8>>>0|n[s+2]<<16>>>0|n[s+3]<<24>>>0}e.readUInt32LE=E;function h(n,s,u){n[u+0]=s&255,s=s>>>8,n[u+1]=s&255,s=s>>>8,n[u+2]=s&255,s=s>>>8,n[u+3]=s&255}e.writeUInt32LE=h;function b(n,s){return n[s]}e.readUInt8=b;function c(n,s,u){n[u]=s}e.writeUInt8=c;function y(n){return D.consumeReadable(n,s=>A.concat(s))}e.readableToBuffer=y;function I(n){return D.toReadable(n)}e.bufferToReadable=I;function g(n){return D.consumeStream(n,s=>A.concat(s))}e.streamToBuffer=g;async function C(n){return n.ended?A.concat(n.buffer):A.concat([...n.buffer,await g(n.stream)])}e.bufferedStreamToBuffer=C;function v(n){return D.toStream(n,s=>A.concat(s))}e.bufferToStream=v;function o(n){return D.transform(n,{data:s=>typeof s=="string"?A.fromString(s):A.wrap(s)},s=>A.concat(s))}e.streamToBufferReadableStream=o;function a(n){return D.newWriteableStream(s=>A.concat(s),n)}e.newWriteableBufferStream=a;function t(n,s){return D.prefixedReadable(n,s,u=>A.concat(u))}e.prefixedBufferReadable=t;function r(n,s){return D.prefixedStream(n,s,u=>A.concat(u))}e.prefixedBufferStream=r}),define(te[23],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(B){return!B||typeof B!="string"?!0:B.trim().length===0}e.isFalsyOrWhitespace=D;const L=/{(\d+)}/g;function R(B,...ie){return ie.length===0?B:B.replace(L,function(oe,le){const de=parseInt(le,10);return isNaN(de)||de<0||de>=ie.length?oe:ie[de]})}e.format=R;const k=/{([^}]+)}/g;function A(B,ie){return B.replace(k,(oe,le)=>ie[le]??oe)}e.format2=A;function P(B){return B.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=P;function m(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=m;function w(B,ie){let oe=0;const le=ie.charCodeAt(0);for(let de=B.length-1;de>=0;de--)B.charCodeAt(de)===le&&oe++;return oe}e.count=w;function i(B,ie,oe="\u2026"){return B.length<=ie?B:`${B.substr(0,ie)}${oe}`}e.truncate=i;function E(B,ie=" "){const oe=h(B,ie);return b(oe,ie)}e.trim=E;function h(B,ie){if(!B||!ie)return B;const oe=ie.length;if(oe===0||B.length===0)return B;let le=0;for(;B.indexOf(ie,le)===le;)le=le+oe;return B.substring(le)}e.ltrim=h;function b(B,ie){if(!B||!ie)return B;const oe=ie.length,le=B.length;if(oe===0||le===0)return B;let de=le,we=-1;for(;we=B.lastIndexOf(ie,de-1),!(we===-1||we+oe!==de);){if(we===0)return"";de=we}return B.substring(0,de)}e.rtrim=b;function c(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=c;function y(B){return B.replace(/\*/g,"")}e.stripWildcards=y;function I(B,ie,oe={}){if(!B)throw new Error("Cannot create regex from empty string");ie||(B=m(B)),oe.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let le="";return oe.global&&(le+="g"),oe.matchCase||(le+="i"),oe.multiline&&(le+="m"),oe.unicode&&(le+="u"),new RegExp(B,le)}e.createRegExp=I;function g(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function C(B){return!!B.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=C;function v(B){return(B.global?"g":"")+(B.ignoreCase?"i":"")+(B.multiline?"m":"")+(B.unicode?"u":"")}e.regExpFlags=v;function o(B){return B.split(/\r\n|\r|\n/)}e.splitLines=o;function a(B){for(let ie=0,oe=B.length;ie<oe;ie++){const le=B.charCodeAt(ie);if(le!==32&&le!==9)return ie}return-1}e.firstNonWhitespaceIndex=a;function t(B,ie=0,oe=B.length){for(let le=ie;le<oe;le++){const de=B.charCodeAt(le);if(de!==32&&de!==9)return B.substring(ie,le)}return B.substring(ie,oe)}e.getLeadingWhitespace=t;function r(B,ie=B.length-1){for(let oe=ie;oe>=0;oe--){const le=B.charCodeAt(oe);if(le!==32&&le!==9)return oe}return-1}e.lastNonWhitespaceIndex=r;function n(B,ie){return B<ie?-1:B>ie?1:0}e.compare=n;function s(B,ie,oe=0,le=B.length,de=0,we=ie.length){for(;oe<le&&de<we;oe++,de++){let Ee=B.charCodeAt(oe),be=ie.charCodeAt(de);if(Ee<be)return-1;if(Ee>be)return 1}const ge=le-oe,ve=we-de;return ge<ve?-1:ge>ve?1:0}e.compareSubstring=s;function u(B,ie){return l(B,ie,0,B.length,0,ie.length)}e.compareIgnoreCase=u;function l(B,ie,oe=0,le=B.length,de=0,we=ie.length){for(;oe<le&&de<we;oe++,de++){let Ee=B.charCodeAt(oe),be=ie.charCodeAt(de);if(Ee===be)continue;const ue=Ee-be;if(!(ue===32&&d(be))&&!(ue===-32&&d(Ee)))return f(Ee)&&f(be)?ue:s(B.toLowerCase(),ie.toLowerCase(),oe,le,de,we)}const ge=le-oe,ve=we-de;return ge<ve?-1:ge>ve?1:0}e.compareSubstringIgnoreCase=l;function f(B){return B>=97&&B<=122}e.isLowerAsciiLetter=f;function d(B){return B>=65&&B<=90}e.isUpperAsciiLetter=d;function S(B){return f(B)||d(B)}function T(B,ie){return B.length===ie.length&&O(B,ie)}e.equalsIgnoreCase=T;function O(B,ie,oe=B.length){for(let le=0;le<oe;le++){const de=B.charCodeAt(le),we=ie.charCodeAt(le);if(de!==we){if(S(de)&&S(we)){const ge=Math.abs(de-we);if(ge!==0&&ge!==32)return!1}else if(String.fromCharCode(de).toLowerCase()!==String.fromCharCode(we).toLowerCase())return!1}}return!0}function p(B,ie){const oe=ie.length;return ie.length>B.length?!1:O(B,ie,oe)}e.startsWithIgnoreCase=p;function F(B,ie){let oe,le=Math.min(B.length,ie.length);for(oe=0;oe<le;oe++)if(B.charCodeAt(oe)!==ie.charCodeAt(oe))return oe;return le}e.commonPrefixLength=F;function M(B,ie){let oe,le=Math.min(B.length,ie.length);const de=B.length-1,we=ie.length-1;for(oe=0;oe<le;oe++)if(B.charCodeAt(de-oe)!==ie.charCodeAt(we-oe))return oe;return le}e.commonSuffixLength=M;function W(B){return 55296<=B&&B<=56319}e.isHighSurrogate=W;function j(B){return 56320<=B&&B<=57343}e.isLowSurrogate=j;function U(B,ie){return(B-55296<<10)+(ie-56320)+65536}e.computeCodePoint=U;function N(B,ie,oe){const le=B.charCodeAt(oe);if(W(le)&&oe+1<ie){const de=B.charCodeAt(oe+1);if(j(de))return U(le,de)}return le}e.getNextCodePoint=N;function z(B,ie){const oe=B.charCodeAt(ie-1);if(j(oe)&&ie>1){const le=B.charCodeAt(ie-2);if(W(le))return U(le,oe)}return oe}function H(B,ie){const oe=se.getInstance(),le=ie,de=B.length,we=N(B,de,ie);ie+=we>=65536?2:1;let ge=oe.getGraphemeBreakType(we);for(;ie<de;){const ve=N(B,de,ie),Ee=oe.getGraphemeBreakType(ve);if(Q(ge,Ee))break;ie+=ve>=65536?2:1,ge=Ee}return ie-le}e.nextCharLength=H;function V(B,ie){const oe=se.getInstance(),le=ie,de=z(B,ie);ie-=de>=65536?2:1;let we=oe.getGraphemeBreakType(de);for(;ie>0;){const ge=z(B,ie),ve=oe.getGraphemeBreakType(ge);if(Q(ve,we))break;ie-=ge>=65536?2:1,we=ve}return le-ie}e.prevCharLength=V;function x(B,ie){const oe=se.getInstance(),le=B.length,de=ie,we=N(B,le,ie),ge=oe.getGraphemeBreakType(we);ie+=we>=65536?2:1;let ve=ge;for(;ie<le;){const be=N(B,le,ie),ue=oe.getGraphemeBreakType(be);if(Q(ve,ue))break;ie+=be>=65536?2:1,ve=ue}const Ee=ie;for(ie=de,ve=ge;ie>0;){const be=z(B,ie),ue=oe.getGraphemeBreakType(be);if(Q(ue,ve))break;ie-=be>=65536?2:1,ve=ue}return[ie,Ee]}function K(B,ie){return ie>0&&j(B.charCodeAt(ie))?x(B,ie-1):x(B,ie)}e.getCharContainingOffset=K;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function $(B){return q.test(B)}e.containsRTL=$;const _=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function J(B){return _.test(B)}e.containsEmoji=J;const G=/^[\t\n\r\x20-\x7E]*$/;function ee(B){return G.test(B)}e.isBasicASCII=ee,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(B){return e.UNUSUAL_LINE_TERMINATORS.test(B)}e.containsUnusualLineTerminators=Z;function ce(B){for(let ie=0,oe=B.length;ie<oe;ie++)if(ae(B.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=ce;function ae(B){return B=+B,B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}e.isFullWidthCharacter=ae;function fe(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129003||B>=129280&&B<=129535||B>=129648&&B<=129750}e.isEmojiImprecise=fe;function ye(B,ie){if(B.length<ie)return B;const oe=/\b/g;let le=0;for(;oe.test(B)&&!(B.length-oe.lastIndex<ie);)le=oe.lastIndex,oe.lastIndex+=1;return B.substring(le).replace(/^\s/,"")}e.lcut=ye;const Se=/\x1B\x5B[12]?K/g,Pe=/\x1b\[\d+m/g,Te=/\x1b\[0?m/g;function Re(B){return B&&(B=B.replace(Se,""),B=B.replace(Pe,""),B=B.replace(Te,"")),B}e.removeAnsiEscapeCodes=Re,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(B){return!!(B&&B.length>0&&B.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Ne(B){return Ce(B)?B.substr(1):B}e.stripUTF8BOM=Ne;function De(B,ie){if(!B||!ie||B.length<ie.length)return!1;const oe=ie.length,le=B.toLowerCase();let de=0,we=-1;for(;de<oe;){const ge=le.indexOf(ie[de],we+1);if(ge<0)return!1;we=ge,de++}return!0}e.fuzzyContains=De;function ke(B,ie=!1){return B?(ie&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}e.containsUppercaseCharacter=ke;function Ye(B){return B.charAt(0).toUpperCase()+B.slice(1)}e.uppercaseFirstLetter=Ye;function Je(B,ie=1){if(ie===0)return"";let oe=-1;do oe=B.indexOf(`
`,oe+1),ie--;while(ie>0&&oe>=0);return oe===-1?B:(B[oe-1]==="\r"&&oe--,B.substr(0,oe))}e.getNLines=Je;function $e(B){const ie=90-65+1;return B=B%(2*ie),B<ie?String.fromCharCode(97+B):String.fromCharCode(65+B-ie)}e.singleLetterHash=$e;function qe(B){return se.getInstance().getGraphemeBreakType(B)}e.getGraphemeBreakType=qe;function Q(B,ie){return B===0?ie!==5&&ie!==7:B===2&&ie===3?!1:B===4||B===2||B===3||ie===4||ie===2||ie===3?!0:!(B===8&&(ie===8||ie===9||ie===11||ie===12)||(B===11||B===9)&&(ie===9||ie===10)||(B===12||B===10)&&ie===10||ie===5||ie===13||ie===7||B===1||B===13&&ie===14||B===6&&ie===6)}e.breakBetweenGraphemeBreakType=Q;var re;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class se{constructor(){this._data=me()}static getInstance(){return se._INSTANCE||(se._INSTANCE=new se),se._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const oe=this._data,le=oe.length/3;let de=1;for(;de<=le;)if(ie<oe[3*de])de=2*de;else if(ie>oe[3*de+1])de=2*de+1;else return oe[3*de+2];return 0}}se._INSTANCE=null;function me(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function pe(B,ie){if(B===0)return 0;const oe=Ae(B,ie);if(oe!==void 0)return oe;const le=z(ie,B);return B-=Ie(le),B}e.getLeftDeleteOffset=pe;function Ae(B,ie){let oe=z(ie,B);for(B-=Ie(oe);Oe(oe)||oe===65039||oe===8419;){if(B===0)return;oe=z(ie,B),B-=Ie(oe)}if(!!fe(oe)){if(B>=0){const le=z(ie,B);le===8205&&(B-=Ie(le))}return B}}function Ie(B){return B>=65536?2:1}function Oe(B){return 127995<=B&&B<=127999}var Le;(function(B){B[B.zwj=8205]="zwj",B[B.emojiVariantSelector=65039]="emojiVariantSelector",B[B.enclosingKeyCap=8419]="enclosingKeyCap"})(Le||(Le={}))}),define(te[16],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(d){return Array.isArray(d)}e.isArray=D;function L(d){return typeof d=="string"}e.isString=L;function R(d){return Array.isArray(d)&&d.every(S=>L(S))}e.isStringArray=R;function k(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=k;function A(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=A;function P(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=P;function m(d){return d===!0||d===!1}e.isBoolean=m;function w(d){return typeof d=="undefined"}e.isUndefined=w;function i(d){return!E(d)}e.isDefined=i;function E(d){return w(d)||d===null}e.isUndefinedOrNull=E;function h(d,S){if(!d)throw new Error(S?`Unexpected type, expected '${S}'`:"Unexpected type")}e.assertType=h;function b(d){if(E(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=b;function c(...d){const S=[];for(let T=0;T<d.length;T++){const O=d[T];if(E(O))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);S.push(O)}return S}e.assertAllDefined=c;const y=Object.prototype.hasOwnProperty;function I(d){if(!k(d))return!1;for(let S in d)if(y.call(d,S))return!1;return!0}e.isEmptyObject=I;function g(d){return typeof d=="function"}e.isFunction=g;function C(...d){return d.length>0&&d.every(g)}e.areFunctions=C;function v(d,S){const T=Math.min(d.length,S.length);for(let O=0;O<T;O++)o(d[O],S[O])}e.validateConstraints=v;function o(d,S){if(L(S)){if(typeof d!==S)throw new Error(`argument does not match constraint: typeof ${S}`)}else if(g(S)){try{if(d instanceof S)return}catch{}if(!E(d)&&d.constructor===S||S.length===1&&S.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function a(d){let S=[],T=Object.getPrototypeOf(d);for(;Object.prototype!==T;)S=S.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return S}e.getAllPropertyNames=a;function t(d){const S=[];for(const T of a(d))typeof d[T]=="function"&&S.push(T);return S}e.getAllMethodNames=t;function r(d,S){const T=p=>function(){const F=Array.prototype.slice.call(arguments,0);return S(p,F)};let O={};for(const p of d)O[p]=T(p);return O}e.createProxyObject=r;function n(d){return d===null?void 0:d}e.withNullAsUndefined=n;function s(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=s;function u(d){return class{constructor(){return new Proxy({},{get(S,T){if(S[T])return S[T];throw new Error(`Not Implemented: ${d}->${String(T)}`)}})}}}e.NotImplementedProxy=u;function l(d,S="Unreachable"){throw new Error(S)}e.assertNever=l;function f(d){return!!d&&typeof d.then=="function"&&typeof d.catch=="function"}e.isPromise=f}),define(te[39],ne([0,1,8,4,23,16]),function(Y,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(n){return n===47||n===92}e.isPathSeparator=A;function P(n){return n.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function m(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=m;function w(n,s=D.posix.sep){if(!n)return"";const u=n.length,l=n.charCodeAt(0);if(A(l)){if(A(n.charCodeAt(1))&&!A(n.charCodeAt(2))){let d=3;const S=d;for(;d<u&&!A(n.charCodeAt(d));d++);if(S!==d&&!A(n.charCodeAt(d+1))){for(d+=1;d<u;d++)if(A(n.charCodeAt(d)))return n.slice(0,d+1).replace(/[\\/]/g,s)}}return s}else if(g(l)&&n.charCodeAt(1)===58)return A(n.charCodeAt(2))?n.slice(0,2)+s:n.slice(0,2);let f=n.indexOf("://");if(f!==-1){for(f+=3;f<u;f++)if(A(n.charCodeAt(f)))return n.slice(0,f+1)}return""}e.getRoot=w;function i(n){if(!L.isWindows||!n||n.length<5)return!1;let s=n.charCodeAt(0);if(s!==92||(s=n.charCodeAt(1),s!==92))return!1;let u=2;const l=u;for(;u<n.length&&(s=n.charCodeAt(u),s!==92);u++);return!(l===u||(s=n.charCodeAt(u+1),isNaN(s)||s===92))}e.isUNC=i;const E=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(n,s=L.isWindows){const u=s?E:h;return!(!n||n.length===0||/^\s+$/.test(n)||(u.lastIndex=0,u.test(n))||s&&b.test(n)||n==="."||n===".."||s&&n[n.length-1]==="."||s&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=c;function y(n,s,u){const l=n===s;return!u||l?l:!n||!s?!1:(0,R.equalsIgnoreCase)(n,s)}e.isEqual=y;function I(n,s,u,l=D.sep){if(n===s)return!0;if(!n||!s||s.length>n.length)return!1;if(u){if(!(0,R.startsWithIgnoreCase)(n,s))return!1;if(s.length===n.length)return!0;let d=s.length;return s.charAt(s.length-1)===l&&d--,n.charAt(d)===l}return s.charAt(s.length-1)!==l&&(s+=l),n.indexOf(s)===0}e.isEqualOrParent=I;function g(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=g;function C(n,s){return L.isWindows&&n.endsWith(":")&&(n+=D.sep),(0,D.isAbsolute)(n)||(n=(0,D.join)(s,n)),n=(0,D.normalize)(n),L.isWindows?(n=(0,R.rtrim)(n,D.sep),n.endsWith(":")&&(n+=D.sep)):(n=(0,R.rtrim)(n,D.sep),n||(n=D.sep)),n}e.sanitizeFilePath=C;function v(n){const s=(0,D.normalize)(n);return L.isWindows?n.length>3?!1:o(s)&&(n.length===2||s.charCodeAt(2)===92):s===D.posix.sep}e.isRootOrDriveLetter=v;function o(n){return L.isWindows?g(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function a(n){return o(n)?n[0]:void 0}e.getDriveLetter=a;function t(n,s,u){return s.length>n.length?-1:n===s?0:(u&&(n=n.toLowerCase(),s=s.toLowerCase()),n.indexOf(s))}e.indexOfPath=t;function r(n){const s=n.split(":");let u,l,f;if(s.forEach(d=>{const S=Number(d);(0,k.isNumber)(S)?l===void 0?l=S:f===void 0&&(f=S):u=u?[u,d].join(":"):d}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:l!==void 0?l:void 0,column:f!==void 0?f:l!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(te[26],ne([0,1,16]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(y){if(!y||typeof y!="object"||y instanceof RegExp)return y;const I=Array.isArray(y)?[]:{};return Object.keys(y).forEach(g=>{y[g]&&typeof y[g]=="object"?I[g]=L(y[g]):I[g]=y[g]}),I}e.deepClone=L;function R(y){if(!y||typeof y!="object")return y;const I=[y];for(;I.length>0;){const g=I.shift();Object.freeze(g);for(const C in g)if(k.call(g,C)){const v=g[C];typeof v=="object"&&!Object.isFrozen(v)&&I.push(v)}}return y}e.deepFreeze=R;const k=Object.prototype.hasOwnProperty;function A(y,I){return P(y,I,new Set)}e.cloneAndChange=A;function P(y,I,g){if((0,D.isUndefinedOrNull)(y))return y;const C=I(y);if(typeof C!="undefined")return C;if((0,D.isArray)(y)){const v=[];for(const o of y)v.push(P(o,I,g));return v}if((0,D.isObject)(y)){if(g.has(y))throw new Error("Cannot clone recursive data-structure");g.add(y);const v={};for(let o in y)k.call(y,o)&&(v[o]=P(y[o],I,g));return g.delete(y),v}return y}function m(y,I,g=!0){return(0,D.isObject)(y)?((0,D.isObject)(I)&&Object.keys(I).forEach(C=>{C in y?g&&((0,D.isObject)(y[C])&&(0,D.isObject)(I[C])?m(y[C],I[C],g):y[C]=I[C]):y[C]=I[C]}),y):I}e.mixin=m;function w(y,I){if(y===I)return!0;if(y==null||I===null||I===void 0||typeof y!=typeof I||typeof y!="object"||Array.isArray(y)!==Array.isArray(I))return!1;let g,C;if(Array.isArray(y)){if(y.length!==I.length)return!1;for(g=0;g<y.length;g++)if(!w(y[g],I[g]))return!1}else{const v=[];for(C in y)v.push(C);v.sort();const o=[];for(C in I)o.push(C);if(o.sort(),!w(v,o))return!1;for(g=0;g<v.length;g++)if(!w(y[v[g]],I[v[g]]))return!1}return!0}e.equals=w;function i(y){const I=new Set;return JSON.stringify(y,(g,C)=>{if((0,D.isObject)(C)||Array.isArray(C)){if(I.has(C))return"[Circular]";I.add(C)}return C})}e.safeStringify=i;function E(y,I,g){const C=I(y);return typeof C=="undefined"?g:C}e.getOrDefault=E;function h(y,I){const g=Object.create(null);return!y||!I||Object.keys(I).forEach(v=>{const o=y[v],a=I[v];w(o,a)||(g[v]=a)}),g}e.distinct=h;function b(y,I){const g=I.toLowerCase(),C=Object.keys(y).find(v=>v.toLowerCase()===g);return C?y[C]:y[I]}e.getCaseInsensitive=b;function c(y,I){const g=Object.create(null);for(const C of Object.keys(y))I(C,y[C])&&(g[C]=y[C]);return g}e.filter=c}),define(te[5],ne([0,1,8,4]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,k=/^\//,A=/^\/\//;function P(n,s){if(!n.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!R.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!k.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(n,s){return!n&&!s?"file":n}function w(n,s){switch(n){case"https":case"http":case"file":s?s[0]!==E&&(s=E+s):s=E;break}return s}const i="",E="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(s,u,l,f,d,S=!1){typeof s=="object"?(this.scheme=s.scheme||i,this.authority=s.authority||i,this.path=s.path||i,this.query=s.query||i,this.fragment=s.fragment||i):(this.scheme=m(s,S),this.authority=u||i,this.path=w(this.scheme,l||i),this.query=f||i,this.fragment=d||i,P(this,S))}static isUri(s){return s instanceof b?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return v(this,!1)}with(s){if(!s)return this;let{scheme:u,authority:l,path:f,query:d,fragment:S}=s;return u===void 0?u=this.scheme:u===null&&(u=i),l===void 0?l=this.authority:l===null&&(l=i),f===void 0?f=this.path:f===null&&(f=i),d===void 0?d=this.query:d===null&&(d=i),S===void 0?S=this.fragment:S===null&&(S=i),u===this.scheme&&l===this.authority&&f===this.path&&d===this.query&&S===this.fragment?this:new y(u,l,f,d,S)}static parse(s,u=!1){const l=h.exec(s);return l?new y(l[2]||i,r(l[4]||i),r(l[5]||i),r(l[7]||i),r(l[9]||i),u):new y(i,i,i,i,i)}static file(s){let u=i;if(L.isWindows&&(s=s.replace(/\\/g,E)),s[0]===E&&s[1]===E){const l=s.indexOf(E,2);l===-1?(u=s.substring(2),s=E):(u=s.substring(2,l),s=s.substring(l)||E)}return new y("file",u,s,i,i)}static from(s){const u=new y(s.scheme,s.authority,s.path,s.query,s.fragment);return P(u,!0),u}static joinPath(s,...u){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return L.isWindows&&s.scheme==="file"?l=b.file(D.win32.join(v(s,!0),...u)).path:l=D.posix.join(s.path,...u),s.with({path:l})}toString(s=!1){return o(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof b)return s;{const u=new y(s);return u._formatted=s.external,u._fsPath=s._sep===c?s.fsPath:null,u}}else return s}}e.URI=b;const c=L.isWindows?1:void 0;class y extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(s=!1){return s?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=c),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const I={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(n,s){let u,l=-1;for(let f=0;f<n.length;f++){const d=n.charCodeAt(f);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||s&&d===47)l!==-1&&(u+=encodeURIComponent(n.substring(l,f)),l=-1),u!==void 0&&(u+=n.charAt(f));else{u===void 0&&(u=n.substr(0,f));const S=I[d];S!==void 0?(l!==-1&&(u+=encodeURIComponent(n.substring(l,f)),l=-1),u+=S):l===-1&&(l=f)}}return l!==-1&&(u+=encodeURIComponent(n.substring(l))),u!==void 0?u:n}function C(n){let s;for(let u=0;u<n.length;u++){const l=n.charCodeAt(u);l===35||l===63?(s===void 0&&(s=n.substr(0,u)),s+=I[l]):s!==void 0&&(s+=n[u])}return s!==void 0?s:n}function v(n,s){let u;return n.authority&&n.path.length>1&&n.scheme==="file"?u=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?s?u=n.path.substr(1):u=n.path[1].toLowerCase()+n.path.substr(2):u=n.path,L.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=v;function o(n,s){const u=s?C:g;let l="",{scheme:f,authority:d,path:S,query:T,fragment:O}=n;if(f&&(l+=f,l+=":"),(d||f==="file")&&(l+=E,l+=E),d){let p=d.indexOf("@");if(p!==-1){const F=d.substr(0,p);d=d.substr(p+1),p=F.indexOf(":"),p===-1?l+=u(F,!1):(l+=u(F.substr(0,p),!1),l+=":",l+=u(F.substr(p+1),!1)),l+="@"}d=d.toLowerCase(),p=d.indexOf(":"),p===-1?l+=u(d,!1):(l+=u(d.substr(0,p),!1),l+=d.substr(p))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const p=S.charCodeAt(1);p>=65&&p<=90&&(S=`/${String.fromCharCode(p+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const p=S.charCodeAt(0);p>=65&&p<=90&&(S=`${String.fromCharCode(p+32)}:${S.substr(2)}`)}l+=u(S,!0)}return T&&(l+="?",l+=u(T,!1)),O&&(l+="#",l+=s?O:g(O,!1)),l}function a(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+a(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(t)?n.replace(t,s=>a(s)):n}}),define(te[93],ne([0,1,5]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(w){const i=w;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function R(w){const i=[];let E;try{const h=JSON.parse(w.arguments),b=h[h.length-1];b&&b.__$stack&&(h.pop(),E=b.__$stack),i.push(...h)}catch(h){i.push("Unable to log remote console arguments",w.arguments)}return{args:i,stack:E}}e.parse=R;function k(w){if(typeof w!="string")return k(R(w).stack);const i=w;if(i){const E=A(i),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(h&&h.length===4)return{uri:D.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}e.getFirstFrame=k;function A(w){if(!w)return w;const i=w.indexOf(`
`);return i===-1?w:w.substring(0,i)}function P(w,i){const{args:E,stack:h}=R(w),b=typeof E[0]=="string"&&E.length===1;let c=A(h);c&&(c=`(${c.trim()})`);let y=[];if(typeof E[0]=="string"?c&&b?y=[`%c[${i}] %c${E[0]} %c${c}`,m("blue"),m(""),m("grey")]:y=[`%c[${i}] %c${E[0]}`,m("blue"),m(""),...E.slice(1)]:y=[`%c[${i}]%`,m("blue"),...E],c&&!b&&y.push(c),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,y)}e.log=P;function m(w){return`color: ${w}`}});var ut=this&&this.__classPrivateFieldSet||function(Y,e,D,L,R){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!R:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?R.call(Y,D):R?R.value=D:e.set(Y,D),D},xe=this&&this.__classPrivateFieldGet||function(Y,e,D,L){if(D==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?L:D==="a"?L.call(Y):L?L.value:e.get(Y)};define(te[40],ne([0,1,23,5]),function(Y,e,D,L){"use strict";var R,k,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,r,n){let s=t.get(r);return s===void 0&&(s=n,t.set(r,s)),s}e.getOrSet=P;function m(t){const r=[];return t.forEach((n,s)=>{r.push(`${s} => ${n}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=m;function w(t){const r=[];return t.forEach(n=>{r.push(n)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=w;class i{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const n=r.charCodeAt(0),s=this._value.charCodeAt(this._pos);return n-s}value(){return this._value[this._pos]}}e.StringIterator=i;class E{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,D.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class h{constructor(r=!0,n=!0){this._splitOnBackslash=r,this._caseSensitive=n}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,D.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=h;var b;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(b||(b={}));class c{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new h(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,D.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class y{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class I{constructor(r){this._iter=r}static forUris(r=()=>!1){return new I(new c(r))}static forPaths(){return new I(new h)}static forStrings(){return new I(new i)}static forConfigKeys(){return new I(new E)}clear(){this._root=void 0}set(r,n){const s=this._iter.reset(r);let u;for(this._root||(this._root=new y,this._root.segment=s.value()),u=this._root;;){const f=s.cmp(u.segment);if(f>0)u.left||(u.left=new y,u.left.segment=s.value()),u=u.left;else if(f<0)u.right||(u.right=new y,u.right.segment=s.value()),u=u.right;else if(s.hasNext())s.next(),u.mid||(u.mid=new y,u.mid.segment=s.value()),u=u.mid;else break}const l=u.value;return u.value=n,u.key=r,l}get(r){return this._getNode(r)?.value}_getNode(r){const n=this._iter.reset(r);let s=this._root;for(;s;){const u=n.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(n.hasNext())n.next(),s=s.mid;else break}return s}has(r){const n=this._getNode(r);return!(n?.value===void 0&&n?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,n){const s=this._iter.reset(r),u=[];let l=this._root;for(;l;){const f=s.cmp(l.segment);if(f>0)u.push([1,l]),l=l.left;else if(f<0)u.push([-1,l]),l=l.right;else if(s.hasNext())s.next(),u.push([0,l]),l=l.mid;else{for(n?(l.left=void 0,l.mid=void 0,l.right=void 0):l.value=void 0;u.length>0&&l.isEmpty();){let[d,S]=u.pop();switch(d){case 1:S.left=void 0;break;case 0:S.mid=void 0;break;case-1:S.right=void 0;break}l=S}break}}}findSubstr(r){const n=this._iter.reset(r);let s=this._root,u;for(;s;){const l=n.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(n.hasNext())n.next(),u=s.value||u,s=s.mid;else break}return s&&s.value||u}findSuperstr(r){const n=this._iter.reset(r);let s=this._root;for(;s;){const u=n.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(n.hasNext())n.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(r){for(const[n,s]of this)r(s,n)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const n=[r];for(;n.length>0;){const s=n.pop();s&&(s.value&&(yield[s.key,s.value]),s.left&&n.push(s.left),s.mid&&n.push(s.mid),s.right&&n.push(s.right))}}}e.TernarySearchTree=I;class g{constructor(r,n){this[R]="ResourceMap",r instanceof g?(this.map=new Map(r.map),this.toKey=n??g.defaultToKey):(this.map=new Map,this.toKey=r??g.defaultToKey)}set(r,n){return this.map.set(this.toKey(r),n),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,n){typeof n!="undefined"&&(r=r.bind(n));for(let[s,u]of this.map)r(u,L.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield L.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[L.URI.parse(r[0]),r[1]]}*[(R=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[L.URI.parse(r[0]),r[1]]}}e.ResourceMap=g,g.defaultToKey=t=>t.toString();var C;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(C=e.Touch||(e.Touch={}));class v{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,n=0){const s=this._map.get(r);if(!!s)return n!==0&&this.touch(s,n),s.value}set(r,n,s=0){let u=this._map.get(r);if(u)u.value=n,s!==0&&this.touch(u,s);else{switch(u={key:r,value:n,next:void 0,previous:void 0},s){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const n=this._map.get(r);if(!!n)return this._map.delete(r),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,n){const s=this._state;let u=this._head;for(;u;){if(n?r.bind(n)(u.value,u.key,this):r(u.value,u.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,n=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const l={value:s.key,done:!1};return s=s.next,l}else return{value:void 0,done:!0}}};return u}values(){const r=this,n=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const l={value:s.value,done:!1};return s=s.next,l}else return{value:void 0,done:!0}}};return u}entries(){const r=this,n=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const l={value:[s.key,s.value],done:!1};return s=s.next,l}else return{value:void 0,done:!0}}};return u}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let n=this._head,s=this.size;for(;n&&s>r;)this._map.delete(n.key),n=n.next,s--;this._head=n,this._size=s,n&&(n.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const n=r.next,s=r.previous;if(!n||!s)throw new Error("Invalid list");n.previous=s,s.next=n}r.next=void 0,r.previous=void 0,this._state++}touch(r,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(r===this._head)return;const s=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(s.previous=u,u.next=s),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(n===2){if(r===this._tail)return;const s=r.next,u=r.previous;r===this._head?(s.previous=void 0,this._head=s):(s.previous=u,u.next=s),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((n,s)=>{r.push([s,n])}),r}fromJSON(r){this.clear();for(const[n,s]of r)this.set(n,s)}}e.LinkedMap=v;class o extends v{constructor(r,n=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,n=2){return super.get(r,n)}peek(r){return super.get(r,0)}set(r,n){return super.set(r,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class a{constructor(r){A.set(this,void 0),ut(this,A,r,"f")}get size(){return xe(this,A,"f").size}forEach(r,n){xe(this,A,"f").forEach(r,n)}get(r){return xe(this,A,"f").get(r)}has(r){return xe(this,A,"f").has(r)}entries(){return xe(this,A,"f").entries()}keys(){return xe(this,A,"f").keys()}values(){return xe(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return xe(this,A,"f").entries()}}e.ReadonlyMapView=a}),define(te[94],ne([0,1,25,23,5]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(i){return JSON.stringify(i,m)}e.stringify=k;function A(i){let E=JSON.parse(i);return E=w(E),E}e.parse=A;var P;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function m(i,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,L.regExpFlags)(E)}:E}function w(i,E=0){if(!i||E>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return R.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof D.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let h=0;h<i.length;++h)i[h]=w(i[h],E+1);else for(const h in i)Object.hasOwnProperty.call(i,h)&&(i[h]=w(i[h],E+1))}return i}e.revive=w}),define(te[17],ne([0,1,4,5]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(R=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}set(m,w,i){this._hosts[m]=w,this._ports[m]=i}setConnectionToken(m,w){this._connectionTokens[m]=w}rewrite(m){if(this._delegate)return this._delegate(m);const w=m.authority;let i=this._hosts[w];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const E=this._ports[w],h=this._connectionTokens[w];let b=`path=${encodeURIComponent(m.path)}`;return typeof h=="string"&&(b+=`&tkn=${encodeURIComponent(h)}`),L.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${i}:${E}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new k;class A{asBrowserUri(m,w){const i=this.toUri(m,w);return i.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===R.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${R.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?i.with({scheme:R.vscodeFileResource,authority:i.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(m,w){const i=this.toUri(m,w);return i.scheme===R.vscodeFileResource?i.with({scheme:R.file,authority:i.authority!==A.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(m,w){return L.URI.isUri(m)?m:L.URI.parse(w.toUrl(m))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(te[66],ne([0,1,40]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new D.LRUCache(1e4);function R(w){return m(w,"NFC",L)}e.normalizeNFC=R;const k=new D.LRUCache(1e4);function A(w){return m(w,"NFD",k)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function m(w,i,E){if(!w)return w;const h=E.get(w);if(h)return h;let b;return P.test(w)?b=w.normalize(i):b=w,E.set(w,b),b}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(i){return A(i).replace(w,"")}}()}),define(te[15],ne([0,1,39,17,8,4,23,5]),function(Y,e,D,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function m(b){return(0,P.uriToFsPath)(b,!0)}e.originalFSPath=m;class w{constructor(c){this._ignorePathCasing=c}compare(c,y,I=!1){return c===y?0:(0,A.compare)(this.getComparisonKey(c,I),this.getComparisonKey(y,I))}isEqual(c,y,I=!1){return c===y?!0:!c||!y?!1:this.getComparisonKey(c,I)===this.getComparisonKey(y,I)}getComparisonKey(c,y=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,y,I=!1){if(c.scheme===y.scheme){if(c.scheme===L.Schemas.file)return D.isEqualOrParent(m(c),m(y),this._ignorePathCasing(c))&&c.query===y.query&&(I||c.fragment===y.fragment);if((0,e.isEqualAuthority)(c.authority,y.authority))return D.isEqualOrParent(c.path,y.path,this._ignorePathCasing(c),"/")&&c.query===y.query&&(I||c.fragment===y.fragment)}return!1}joinPath(c,...y){return P.URI.joinPath(c,...y)}basenameOrAuthority(c){return(0,e.basename)(c)||c.authority}basename(c){return R.posix.basename(c.path)}extname(c){return R.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let y;return c.scheme===L.Schemas.file?y=P.URI.file(R.dirname(m(c))).path:(y=R.posix.dirname(c.path),c.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),y="/")),c.with({path:y})}normalizePath(c){if(!c.path.length)return c;let y;return c.scheme===L.Schemas.file?y=P.URI.file(R.normalize(m(c))).path:y=R.posix.normalize(c.path),c.with({path:y})}relativePath(c,y){if(c.scheme!==y.scheme||!(0,e.isEqualAuthority)(c.authority,y.authority))return;if(c.scheme===L.Schemas.file){const C=R.relative(m(c),m(y));return k.isWindows?D.toSlashes(C):C}let I=c.path||"/",g=y.path||"/";if(this._ignorePathCasing(c)){let C=0;for(const v=Math.min(I.length,g.length);C<v&&!(I.charCodeAt(C)!==g.charCodeAt(C)&&I.charAt(C).toLowerCase()!==g.charAt(C).toLowerCase());C++);I=g.substr(0,C)+I.substr(C)}return R.posix.relative(I,g)}resolvePath(c,y){if(c.scheme===L.Schemas.file){const I=P.URI.file(R.resolve(m(c),y));return c.with({authority:I.authority,path:I.path})}return y=D.toPosixPath(y),c.with({path:R.posix.resolve(c.path,y)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,y){return c===y||(0,A.equalsIgnoreCase)(c,y)}hasTrailingPathSeparator(c,y=R.sep){if(c.scheme===L.Schemas.file){const I=m(c);return I.length>D.getRoot(I).length&&I[I.length-1]===y}else{const I=c.path;return I.length>1&&I.charCodeAt(I.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,y=R.sep){return(0,e.hasTrailingPathSeparator)(c,y)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,y=R.sep){let I=!1;if(c.scheme===L.Schemas.file){const g=m(c);I=g!==void 0&&g.length===D.getRoot(g).length&&g[g.length-1]===y}else{y="/";const g=c.path;I=g.length===1&&g.charCodeAt(g.length-1)===47}return!I&&!(0,e.hasTrailingPathSeparator)(c,y)?c.with({path:c.path+"/"}):c}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(b=>b.scheme===L.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new w(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(b,c){const y=[];for(let I=0;I<b.length;I++){const g=c(b[I]);b.some((C,v)=>v===I?!1:(0,e.isEqualOrParent)(g,c(C)))||y.push(b[I])}return y}e.distinctParents=i;var E;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function c(y){const I=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(v=>{const[o,a]=v.split(":");o&&a&&I.set(o,a)});const C=y.path.substring(0,y.path.indexOf(";"));return C&&I.set(b.META_DATA_MIME,C),I}b.parseMetaData=c})(E=e.DataUri||(e.DataUri={}));function h(b,c,y){if(c){let I=b.path;return I&&I[0]!==R.posix.sep&&(I=R.posix.sep+I),b.with({scheme:y,authority:c,path:I})}return b.with({scheme:y})}e.toLocalResource=h}),define(te[6],ne([0,1,29,11,3,2,15]),function(Y,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(N){return!!N&&typeof N.then=="function"}e.isThenable=P;function m(N){const z=new D.CancellationTokenSource,H=N(z.token),V=new Promise((x,K)=>{const q=z.token.onCancellationRequested(()=>{q.dispose(),z.dispose(),K((0,L.canceled)())});Promise.resolve(H).then($=>{q.dispose(),z.dispose(),x($)},$=>{q.dispose(),z.dispose(),K($)})});return new class{cancel(){z.cancel()}then(x,K){return V.then(x,K)}catch(x){return this.then(void 0,x)}finally(x){return V.finally(x)}}}e.createCancelablePromise=m;function w(N,z,H){return Promise.race([N,new Promise(V=>z.onCancellationRequested(()=>V(H)))])}e.raceCancellation=w;async function i(N){let z=-1;const H=N.map((x,K)=>x.then(q=>(z=K,q))),V=await Promise.race(H);return N.forEach((x,K)=>{K!==z&&x.cancel()}),V}e.raceCancellablePromises=i;function E(N,z,H){let V;const x=setTimeout(()=>{V?.(void 0),H?.()},z);return Promise.race([N.finally(()=>clearTimeout(x)),new Promise(K=>V=K)])}e.raceTimeout=E;function h(N){return new Promise((z,H)=>{const V=N();P(V)?V.then(z,H):z(V)})}e.asPromise=h;class b{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(z){if(this.activePromise){if(this.queuedPromiseFactory=z,!this.queuedPromise){const H=()=>{this.queuedPromise=null;const V=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,V};this.queuedPromise=new Promise(V=>{this.activePromise.then(H,H).then(V)})}return new Promise((H,V)=>{this.queuedPromise.then(H,V)})}return this.activePromise=z(),new Promise((H,V)=>{this.activePromise.then(x=>{this.activePromise=null,H(x)},x=>{this.activePromise=null,V(x)})})}}e.Throttler=b;class c{constructor(){this.current=Promise.resolve(null)}queue(z){return this.current=this.current.then(()=>z(),()=>z())}}e.Sequencer=c;class y{constructor(){this.promiseMap=new Map}queue(z,H){const x=(this.promiseMap.get(z)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.promiseMap.get(z)===x&&this.promiseMap.delete(z)});return this.promiseMap.set(z,x),x}}e.SequencerByKey=y;class I{constructor(z){this.defaultDelay=z,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(z,H=this.defaultDelay){return this.task=z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((V,x)=>{this.doResolve=V,this.doReject=x}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const V=this.task;return this.task=null,V()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},H),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=I;class g{constructor(z){this.delayer=new I(z),this.throttler=new b}trigger(z,H){return this.delayer.trigger(()=>this.throttler.queue(z),H)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=g;class C{constructor(){this._isOpen=!1,this._promise=new Promise((z,H)=>{this._completePromise=z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=C;class v extends C{constructor(z){super();this._timeout=setTimeout(()=>this.open(),z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=v;function o(N,z){return z?new Promise((H,V)=>{const x=setTimeout(()=>{K.dispose(),H()},N),K=z.onCancellationRequested(()=>{clearTimeout(x),K.dispose(),V((0,L.canceled)())})}):m(H=>o(N,H))}e.timeout=o;function a(N,z=0){const H=setTimeout(N,z);return(0,k.toDisposable)(()=>clearTimeout(H))}e.disposableTimeout=a;function t(N){const z=[];let H=0;const V=N.length;function x(){return H<V?N[H++]():null}function K(q){q!=null&&z.push(q);const $=x();return $?$.then(K):Promise.resolve(z)}return Promise.resolve(null).then(K)}e.sequence=t;function r(N,z=V=>!!V,H=null){let V=0;const x=N.length,K=()=>{if(V>=x)return Promise.resolve(H);const q=N[V++];return Promise.resolve(q()).then(_=>z(_)?Promise.resolve(_):K())};return K()}e.first=r;function n(N,z=V=>!!V,H=null){if(N.length===0)return Promise.resolve(H);let V=N.length;const x=()=>{V=-1;for(const K of N)K.cancel?.()};return new Promise((K,q)=>{for(const $ of N)$.then(_=>{--V>=0&&z(_)?(x(),K(_)):V===0&&K(H)}).catch(_=>{--V>=0&&(x(),q(_))})})}e.firstParallel=n;class s{constructor(z){this._size=0,this.maxDegreeOfParalellism=z,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(z){return this._size++,new Promise((H,V)=>{this.outstandingPromises.push({factory:z,c:H,e:V}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const z=this.outstandingPromises.shift();this.runningPromises++;const H=z.factory();H.then(z.c,z.e),H.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class u extends s{constructor(){super(1)}}e.Queue=u;class l{constructor(){this.queues=new Map}queueFor(z,H=A.extUri){const V=H.getComparisonKey(z);let x=this.queues.get(V);return x||(x=new u,R.Event.once(x.onFinished)(()=>{x?.dispose(),this.queues.delete(V)}),this.queues.set(V,x)),x}dispose(){this.queues.forEach(z=>z.dispose()),this.queues.clear()}}e.ResourceQueue=l;class f{constructor(z,H){this._token=-1,typeof z=="function"&&typeof H=="number"&&this.setIfNotSet(z,H)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(z,H){this.cancel(),this._token=setTimeout(()=>{this._token=-1,z()},H)}setIfNotSet(z,H){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,z()},H))}}e.TimeoutTimer=f;class d{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(z,H){this.cancel(),this._token=setInterval(()=>{z()},H)}}e.IntervalTimer=d;class S{constructor(z,H){this.timeoutToken=-1,this.runner=z,this.timeout=H,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,z)}get delay(){return this.timeout}set delay(z){this.timeout=z}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=S;class T extends S{constructor(z,H){super(z,H);this.units=[]}work(z){this.units.push(z),this.isScheduled()||this.schedule()}doRun(){const z=this.units;this.units=[],this.runner&&this.runner(z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=T;class O extends k.Disposable{constructor(z,H,V,x){super();this.maxWorkChunkSize=z,this.maxPendingWork=H,this.throttleDelay=V,this.handler=x,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(z){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+z.length>this.maxPendingWork)return!1}else if(this.pending+z.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...z),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new S(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=O,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=z=>{const H=setTimeout(()=>z(N));let V=!1;return{dispose(){V||(V=!0,clearTimeout(H))}}}}else e.runWhenIdle=(N,z)=>{const H=requestIdleCallback(N,typeof z=="number"?{timeout:z}:void 0);let V=!1;return{dispose(){V||(V=!0,cancelIdleCallback(H))}}}}();class p{constructor(z){this._didRun=!1,this._executor=()=>{try{this._value=z()}catch(H){this._error=H}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=p;async function F(N,z,H){let V;for(let x=0;x<H;x++)try{return await N()}catch(K){V=K,await o(z)}throw V}e.retry=F;class M{hasPending(z){return this._pending?typeof z=="number"?this._pending.taskId===z:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(z,H,V){return this._pending={taskId:z,cancel:()=>V?.(),promise:H},H.then(()=>this.donePending(z),()=>this.donePending(z)),H}donePending(z){this._pending&&z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const z=this._next;this._next=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}setNext(z){if(this._next)this._next.run=z;else{let H,V;const x=new Promise((K,q)=>{H=K,V=q});this._next={run:z,promise:x,promiseResolve:H,promiseReject:V}}return this._next.promise}}e.TaskSequentializer=M;class W{constructor(z){this.interval=z,this.lastIncrementTime=0,this.value=0}increment(){const z=Date.now();return z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=z,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class j{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((z,H)=>{this.completeCallback=z,this.errorCallback=H})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(z){return new Promise(H=>{this.completeCallback(z),this.resolved=!0,H()})}error(z){return new Promise(H=>{this.errorCallback(z),this.rejected=!0,H()})}cancel(){new Promise(z=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,z()})}}e.DeferredPromise=j;var U;(function(N){async function z(H){let V;const x=await Promise.all(H.map(K=>K.then(q=>q,q=>{V||(V=q)})));if(typeof V!="undefined")throw V;return x}N.settled=z})(U=e.Promises||(e.Promises={}))}),define(te[67],ne([0,1,6,39,40,8,23]),function(Y,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const m="**",w="/",i="[/\\\\]",E="[^/\\\\]",h=/\//g;function b(x){switch(x){case 0:return"";case 1:return`${E}*?`;default:return`(?:${i}|${E}+${i}|${i}${E}+)*?`}}function c(x,K){if(!x)return[];const q=[];let $=!1,_=!1,J="";for(const G of x){switch(G){case K:if(!$&&!_){q.push(J),J="";continue}break;case"{":$=!0;break;case"}":$=!1;break;case"[":_=!0;break;case"]":_=!1;break}J+=G}return J&&q.push(J),q}e.splitGlobAware=c;function y(x){if(!x)return"";let K="";const q=c(x,w);if(q.every($=>$===m))K=".*";else{let $=!1;q.forEach((_,J)=>{if(_===m){$||(K+=b(2),$=!0);return}let G=!1,ee="",Z=!1,ce="";for(const ae of _){if(ae!=="}"&&G){ee+=ae;continue}if(Z&&(ae!=="]"||!ce)){let fe;ae==="-"?fe=ae:(ae==="^"||ae==="!")&&!ce?fe="^":ae===w?fe="":fe=A.escapeRegExpCharacters(ae),ce+=fe;continue}switch(ae){case"{":G=!0;continue;case"[":Z=!0;continue;case"}":K+=`(?:${c(ee,",").map(Se=>y(Se)).join("|")})`,G=!1,ee="";break;case"]":K+="["+ce+"]",Z=!1,ce="";break;case"?":K+=E;continue;case"*":K+=b(1);continue;default:K+=A.escapeRegExpCharacters(ae)}}J<q.length-1&&(q[J+1]!==m||J+2<q.length)&&(K+=i),$=!1})}return K}const I=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,C=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),r=function(){return!1},n=function(){return null};function s(x,K){if(!x)return n;let q;typeof x!="string"?q=x.pattern:q=x,q=q.trim();const $=`${q}_${!!K.trimForExclusions}`;let _=t.get($);if(_)return u(_,x);let J;if(I.test(q)){const G=q.substr(4);_=function(ee,Z){return typeof ee=="string"&&ee.endsWith(G)?q:null}}else(J=g.exec(l(q,K)))?_=f(J[1],q):(K.trimForExclusions?v:C).test(q)?_=d(q,K):(J=o.exec(l(q,K)))?_=S(J[1].substr(1),q,!0):(J=a.exec(l(q,K)))?_=S(J[1],q,!1):_=T(q);return t.set($,_),u(_,x)}function u(x,K){return typeof K=="string"?x:function(q,$){return L.isEqualOrParent(q,K.base)?x(k.relative(K.base,q),$):null}}function l(x,K){return K.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function f(x,K){const q=`/${x}`,$=`\\${x}`,_=function(G,ee){return typeof G!="string"?null:ee?ee===x?K:null:G===x||G.endsWith(q)||G.endsWith($)?K:null},J=[x];return _.basenames=J,_.patterns=[K],_.allBasenames=J,_}function d(x,K){const q=V(x.slice(1,-1).split(",").map(ee=>s(ee,K)).filter(ee=>ee!==n),x),$=q.length;if(!$)return n;if($===1)return q[0];const _=function(ee,Z){for(let ce=0,ae=q.length;ce<ae;ce++)if(q[ce](ee,Z))return x;return null},J=q.find(ee=>!!ee.allBasenames);J&&(_.allBasenames=J.allBasenames);const G=q.reduce((ee,Z)=>Z.allPaths?ee.concat(Z.allPaths):ee,[]);return G.length&&(_.allPaths=G),_}function S(x,K,q){const $=k.sep===k.posix.sep,_=$?x:x.replace(h,k.sep),J=k.sep+_,G=k.posix.sep+x,ee=q?function(Z,ce){return typeof Z=="string"&&(Z===_||Z.endsWith(J)||!$&&(Z===x||Z.endsWith(G)))?K:null}:function(Z,ce){return typeof Z=="string"&&(Z===_||!$&&Z===x)?K:null};return ee.allPaths=[(q?"*/":"./")+x],ee}function T(x){try{const K=new RegExp(`^${y(x)}$`);return function(q){return K.lastIndex=0,typeof q=="string"&&K.test(q)?x:null}}catch(K){return n}}function O(x,K,q){return!x||typeof K!="string"?!1:p(x)(K,void 0,q)}e.match=O;function p(x,K={}){if(!x)return r;if(typeof x=="string"||j(x)){const q=s(x,K);if(q===n)return r;const $=function(_,J){return!!q(_,J)};return q.allBasenames&&($.allBasenames=q.allBasenames),q.allPaths&&($.allPaths=q.allPaths),$}return z(x,K)}e.parse=p;function F(x){if(!x)return;let K;return q=>(K||(K=(x()||Promise.resolve([])).then($=>$?W($):{})),K.then($=>!!$[q]))}e.hasSiblingPromiseFn=F;function M(x){if(!x)return;let K;return q=>{if(!K){const $=x();K=$?W($):{}}return!!K[q]}}e.hasSiblingFn=M;function W(x){const K={};for(const q of x)K[q]=!0;return K}function j(x){const K=x;return K&&typeof K.base=="string"&&typeof K.pattern=="string"}e.isRelativePattern=j;function U(x){return x.allBasenames||[]}e.getBasenameTerms=U;function N(x){return x.allPaths||[]}e.getPathTerms=N;function z(x,K){const q=V(Object.getOwnPropertyNames(x).map(ee=>H(ee,x[ee],K)).filter(ee=>ee!==n)),$=q.length;if(!$)return n;if(!q.some(ee=>!!ee.requiresSiblings)){if($===1)return q[0];const ee=function(ae,fe){for(let ye=0,Se=q.length;ye<Se;ye++){const Pe=q[ye](ae,fe);if(Pe)return Pe}return null},Z=q.find(ae=>!!ae.allBasenames);Z&&(ee.allBasenames=Z.allBasenames);const ce=q.reduce((ae,fe)=>fe.allPaths?ae.concat(fe.allPaths):ae,[]);return ce.length&&(ee.allPaths=ce),ee}const _=function(ee,Z,ce){let ae;for(let fe=0,ye=q.length;fe<ye;fe++){const Se=q[fe];Se.requiresSiblings&&ce&&(Z||(Z=k.basename(ee)),ae||(ae=Z.substr(0,Z.length-k.extname(ee).length)));const Pe=Se(ee,Z,ae,ce);if(Pe)return Pe}return null},J=q.find(ee=>!!ee.allBasenames);J&&(_.allBasenames=J.allBasenames);const G=q.reduce((ee,Z)=>Z.allPaths?ee.concat(Z.allPaths):ee,[]);return G.length&&(_.allPaths=G),_}function H(x,K,q){if(K===!1)return n;const $=s(x,q);if($===n)return n;if(typeof K=="boolean")return $;if(K){const _=K.when;if(typeof _=="string"){const J=(G,ee,Z,ce)=>{if(!ce||!$(G,ee))return null;const ae=_.replace("$(basename)",Z),fe=ce(ae);return(0,D.isThenable)(fe)?fe.then(ye=>ye?x:null):fe?x:null};return J.requiresSiblings=!0,J}}return $}function V(x,K){const q=x.filter(ee=>!!ee.basenames);if(q.length<2)return x;const $=q.reduce((ee,Z)=>{const ce=Z.basenames;return ce?ee.concat(ce):ee},[]);let _;if(K){_=[];for(let ee=0,Z=$.length;ee<Z;ee++)_.push(K)}else _=q.reduce((ee,Z)=>{const ce=Z.patterns;return ce?ee.concat(ce):ee},[]);const J=function(ee,Z){if(typeof ee!="string")return null;if(!Z){let ae;for(ae=ee.length;ae>0;ae--){const fe=ee.charCodeAt(ae-1);if(fe===47||fe===92)break}Z=ee.substr(ae)}const ce=$.indexOf(Z);return ce!==-1?_[ce]:null};J.basenames=$,J.patterns=_,J.allBasenames=$;const G=x.filter(ee=>!ee.basenames);return G.push(J),G}}),define(te[95],ne([0,1,67,17,8,15,23]),function(Y,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(s){s.text="text/plain",s.binary="application/octet-stream",s.unknown="application/unknown",s.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let m=[],w=[],i=[];function E(s,u=!1){const l=h(s);m.push(l),l.userConfigured?i.push(l):w.push(l),u&&!l.userConfigured&&m.forEach(f=>{f.mime===l.mime||f.userConfigured||(l.extension&&f.extension===l.extension&&console.warn(`Overwriting extension <<${l.extension}>> to now point to mime <<${l.mime}>>`),l.filename&&f.filename===l.filename&&console.warn(`Overwriting filename <<${l.filename}>> to now point to mime <<${l.mime}>>`),l.filepattern&&f.filepattern===l.filepattern&&console.warn(`Overwriting filepattern <<${l.filepattern}>> to now point to mime <<${l.mime}>>`),l.firstline&&f.firstline===l.firstline&&console.warn(`Overwriting firstline <<${l.firstline}>> to now point to mime <<${l.mime}>>`))})}e.registerTextMime=E;function h(s){return{id:s.id,mime:s.mime,filename:s.filename,extension:s.extension,filepattern:s.filepattern,firstline:s.firstline,userConfigured:s.userConfigured,filenameLowercase:s.filename?s.filename.toLowerCase():void 0,extensionLowercase:s.extension?s.extension.toLowerCase():void 0,filepatternLowercase:s.filepattern?(0,D.parse)(s.filepattern.toLowerCase()):void 0,filepatternOnPath:s.filepattern?s.filepattern.indexOf(R.posix.sep)>=0:!1}}function b(s){s?(m=m.filter(u=>!u.userConfigured),i=[]):(m=[],w=[],i=[])}e.clearTextMimes=b;function c(s,u){let l;if(s)switch(s.scheme){case L.Schemas.file:l=s.fsPath;break;case L.Schemas.data:l=k.DataUri.parseMetaData(s).get(k.DataUri.META_DATA_LABEL);break;default:l=s.path}if(!l)return[P.unknown];l=l.toLowerCase();const f=(0,R.basename)(l),d=y(l,f,i);if(d)return[d,P.text];const S=y(l,f,w);if(S)return[S,P.text];if(u){const T=I(u);if(T)return[T,P.text]}return[P.unknown]}e.guessMimeTypes=c;function y(s,u,l){let f=null,d=null,S=null;for(let T=l.length-1;T>=0;T--){const O=l[T];if(u===O.filenameLowercase){f=O;break}if(O.filepattern&&(!d||O.filepattern.length>d.filepattern.length)){const p=O.filepatternOnPath?s:u;O.filepatternLowercase?.(p)&&(d=O)}O.extension&&(!S||O.extension.length>S.extension.length)&&u.endsWith(O.extensionLowercase)&&(S=O)}return f?f.mime:d?d.mime:S?S.mime:null}function I(s){if((0,A.startsWithUTF8BOM)(s)&&(s=s.substr(1)),s.length>0)for(let u=m.length-1;u>=0;u--){const l=m[u];if(!l.firstline)continue;const f=s.match(l.firstline);if(f&&f.length>0)return l.mime}return null}function g(s){return s?typeof s=="string"?s===P.binary||s===P.text||s===P.unknown:s.length===1&&g(s[0]):!0}e.isUnspecific=g;const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},v={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function o(s){const u=(0,R.extname)(s),l=C[u.toLowerCase()];return l!==void 0?l:a(s)}e.getMediaOrTextMime=o;function a(s){const u=(0,R.extname)(s);return v[u.toLowerCase()]}e.getMediaMime=a;function t(s){for(const u in v)if(v[u]===s)return u}e.getExtensionForMimeType=t;const r=/^(.+)\/(.+?)(;.+)?$/;function n(s,u){const l=r.exec(s);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:u?void 0:s}e.normalizeMimeType=n}),define(te[96],ne([0,1,5]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class R{constructor(E){this._uriTransformer=E}transformIncoming(E){const h=this._uriTransformer.transformIncoming(E);return h===E?E:L(D.URI.from(h))}transformOutgoing(E){const h=this._uriTransformer.transformOutgoing(E);return h===E?E:L(D.URI.from(h))}transformOutgoingURI(E){const h=this._uriTransformer.transformOutgoing(E);return h===E?E:D.URI.from(h)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function k(i,E,h){if(!i||h>200)return null;if(typeof i=="object"){if(i instanceof D.URI)return E.transformOutgoing(i);for(let b in i)if(Object.hasOwnProperty.call(i,b)){const c=k(i[b],E,h+1);c!==null&&(i[b]=c)}}return null}function A(i,E){const h=k(i,E,0);return h===null?i:h}e.transformOutgoingURIs=A;function P(i,E,h,b){if(!i||b>200)return null;if(typeof i=="object"){if(i.$mid===1)return h?D.URI.revive(E.transformIncoming(i)):E.transformIncoming(i);for(let c in i)if(Object.hasOwnProperty.call(i,c)){const y=P(i[c],E,h,b+1);y!==null&&(i[c]=y)}}return null}function m(i,E){const h=P(i,E,!1,0);return h===null?i:h}e.transformIncomingURIs=m;function w(i,E){const h=P(i,E,!0,0);return h===null?i:h}e.transformAndReviveIncomingURIs=w}),define(te[30],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(m){return D.test(m)}e.isUUID=L;const R=new Uint8Array(16),k=[];for(let m=0;m<256;m++)k.push(m.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(m){for(let w=0;w<m.length;w++)m[w]=Math.floor(Math.random()*256);return m};function P(){A(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let m=0,w="";return w+=k[R[m++]],w+=k[R[m++]],w+=k[R[m++]],w+=k[R[m++]],w+="-",w+=k[R[m++]],w+=k[R[m++]],w+="-",w+=k[R[m++]],w+=k[R[m++]],w+="-",w+=k[R[m++]],w+=k[R[m++]],w+="-",w+=k[R[m++]],w+=k[R[m++]],w+=k[R[m++]],w+=k[R[m++]],w+=k[R[m++]],w+=k[R[m++]],w}e.generateUuid=P}),define(te[68],ne([0,1,218]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(k="utf8"){this.stringDecoder=new D.StringDecoder(k),this.remaining=null}write(k){const A=[],P=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(P.length<1)return A;let m=0,w,i=m;for(;i<P.length;)if(w=P.charCodeAt(i),w===13||w===10){if(A.push(P.substring(m,i)),i++,i<P.length){const E=w;w=P.charCodeAt(i),(E===13&&w===10||E===10&&w===13)&&i++}m=i}else i++;return this.remaining=m<P.length?P.substr(m):null,A}end(){return this.remaining}}e.LineDecoder=L}),define(te[97],ne([0,1,35]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(P){const m=P.replace(/\-/g,":").toLowerCase();return!L.has(m)}function k(){return new Promise(async(P,m)=>{const w=setTimeout(()=>m("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await A())}catch(i){m(i)}finally{clearTimeout(w)}})}e.getMac=k;function A(){return new Promise((P,m)=>{try{const w=(0,D.networkInterfaces)();for(let i in w){const E=w[i];if(E){for(const{mac:h}of E)if(R(h))return P(h)}}m("Unable to retrieve mac address (unexpected format)")}catch(w){m(w)}})}}),define(te[98],ne([0,1,35,11,40,30,97]),function(Y,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,E=0;const h=(0,D.networkInterfaces)();for(let b in h){const c=h[b];if(c)for(const{mac:y,internal:I}of c)I||(E+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(i+=1))}this._value=E>0?i/E:0}return this._value}};let P;async function m(){return P||(P=(async()=>await w()||k.generateUuid())()),P}e.getMachineId=m;async function w(){try{const i=await new Promise((h,b)=>{Y(["crypto"],h,b)}),E=await(0,A.getMac)();return i.createHash("sha256").update(E,"utf8").digest("hex")}catch(i){L.onUnexpectedError(i);return}}}),define(te[18],ne([0,1,50,35,219,6,39,66,8,4,15,5,30]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function c(U,N=b.UNLINK){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return N===b.UNLINK?I(U):y(U)}async function y(U){try{const N=(0,m.join)((0,L.tmpdir)(),(0,h.generateUuid)());try{await e.Promises.rename(U,N)}catch(z){return I(U)}I(N).catch(z=>{})}catch(N){if(N.code!=="ENOENT")throw N}}async function I(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function g(U){if((0,A.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(U,{recursive:!0})}e.rimrafSync=g;async function C(U,N){return a(await(N?v(U):(0,R.promisify)(D.readdir)(U)))}async function v(U){try{return await(0,R.promisify)(D.readdir)(U,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const N=[],z=await C(U);for(const H of z){let V=!1,x=!1,K=!1;try{const q=await e.Promises.lstat((0,m.join)(U,H));V=q.isFile(),x=q.isDirectory(),K=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}N.push({name:H,isFile:()=>V,isDirectory:()=>x,isSymbolicLink:()=>K})}return N}function o(U){return a(D.readdirSync(U))}e.readdirSync=o;function a(U){return U.map(N=>typeof N=="string"?w.isMacintosh?(0,P.normalizeNFC)(N):N:(N.name=w.isMacintosh?(0,P.normalizeNFC)(N.name):N.name,N))}async function t(U){const N=await C(U),z=[];for(const H of N)await n.existsDirectory((0,m.join)(U,H))&&z.push(H);return z}function r(U,N=1e3){return new Promise(z=>{let H=!1;const V=setInterval(()=>{H||(H=!0,D.access(U,x=>{H=!1,x&&(clearInterval(V),z(void 0))}))},N)})}e.whenDeleted=r;var n;(function(U){async function N(V){let x;try{if(x=await e.Promises.lstat(V),!x.isSymbolicLink())return{stat:x}}catch(K){}try{return{stat:await e.Promises.stat(V),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(w.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw q}throw K}}U.stat=N;async function z(V){try{const{stat:x,symbolicLink:K}=await U.stat(V);return x.isFile()&&K?.dangling!==!0}catch(x){}return!1}U.existsFile=z;async function H(V){try{const{stat:x,symbolicLink:K}=await U.stat(V);return x.isDirectory()&&K?.dangling!==!0}catch(x){}return!1}U.existsDirectory=H})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new k.ResourceQueue;function u(U,N,z){return s.queueFor(E.URI.file(U),i.extUriBiasedIgnorePathCase).queue(()=>{const H=S(z);return new Promise((V,x)=>f(U,N,H,K=>K?x(K):V()))})}let l=!0;function f(U,N,z,H){if(!l)return D.writeFile(U,N,{mode:z.mode,flag:z.flag},H);D.open(U,z.flag,z.mode,(V,x)=>{if(V)return H(V);D.writeFile(x,N,K=>{if(K)return D.close(x,()=>H(K));D.fdatasync(x,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),l=!1),D.close(x,$=>H($))))})})}function d(U,N,z){const H=S(z);if(!l)return D.writeFileSync(U,N,{mode:H.mode,flag:H.flag});const V=D.openSync(U,H.flag,H.mode);try{D.writeFileSync(V,N);try{D.fdatasyncSync(V)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),l=!1}}finally{D.closeSync(V)}}e.writeFileSync=d;function S(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function T(U,N){if(U===N)return;async function z(H){try{const V=await e.Promises.lstat(H);if(V.isDirectory()||V.isSymbolicLink())return;await e.Promises.utimes(H,V.atime,new Date)}catch(V){}}try{await e.Promises.rename(U,N),await z(N)}catch(H){if(U.toLowerCase()!==N.toLowerCase()&&H.code==="EXDEV"||U.endsWith("."))await O(U,N,{preserveSymlinks:!1}),await c(U,b.MOVE),await z(N);else throw H}}async function O(U,N,z){return F(U,N,{root:{source:U,target:N},options:z,handledSourcePaths:new Set})}const p=511;async function F(U,N,z){if(z.handledSourcePaths.has(U))return;z.handledSourcePaths.add(U);const{stat:H,symbolicLink:V}=await n.stat(U);if(V){if(z.options.preserveSymlinks)try{return await j(U,N,z)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(V.dangling)return}return H.isDirectory()?M(U,N,H.mode&p,z):W(U,N,H.mode&p)}async function M(U,N,z,H){await e.Promises.mkdir(N,{recursive:!0,mode:z});const V=await C(U);for(const x of V)await F((0,m.join)(U,x),(0,m.join)(N,x),H)}async function W(U,N,z){await e.Promises.copyFile(U,N),await e.Promises.chmod(N,z)}async function j(U,N,z){let H=await e.Promises.readlink(U);(0,A.isEqualOrParent)(H,z.root.source,!w.isLinux)&&(H=(0,m.join)(z.root.target,H.substr(z.root.source.length+1))),await e.Promises.symlink(H,N)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(0,R.promisify)(D.read)}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(0,R.promisify)(D.write)}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return C}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return c}get move(){return T}get copy(){return O}}}),define(te[99],ne([0,1,50,8,23,18]),function(Y,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(i){const E=(0,L.dirname)(i);if(i===E)return i;const h=((0,L.basename)(i)||i).toLowerCase();try{const c=(0,k.readdirSync)(E).filter(y=>y.toLowerCase()===h);if(c.length===1){const y=A(E);if(y)return(0,L.join)(y,c[0])}else if(c.length>1){const y=c.indexOf(h);if(y>=0){const I=A(E);if(I)return(0,L.join)(I,c[y])}}}catch(b){}return null}e.realcaseSync=A;async function P(i){try{return await k.Promises.realpath(i)}catch(E){const h=w(i);return await k.Promises.access(h,D.constants.R_OK),h}}e.realpath=P;function m(i){try{return D.realpathSync(i)}catch(E){const h=w(i);return D.accessSync(h,D.constants.R_OK),h}}e.realpathSync=m;function w(i){return(0,R.rtrim)((0,L.normalize)(i),L.sep)}}),define(te[69],ne([0,1,35,8,18]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var m;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(m||(m={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class E{constructor(a,t,r){this.exePath=a,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:o=!1}={}){return o?w===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:o=!1,findPreview:a=!1}={}){const t=h({useAlternateBitness:o});if(!t)return null;const r=L.join(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(r))return null;let n=-1,s=null;for(const f of await R.Promises.readdir(r)){let d=-1;if(a){const T=f.indexOf("-");if(T<0)continue;const O=f.substring(0,T);if(!k.test(O)||f.substring(T+1)!=="preview")continue;d=parseInt(O,10)}else{if(!k.test(f))continue;d=parseInt(f,10)}if(d<=n)continue;const S=L.join(r,f,"pwsh.exe");!await R.SymlinkSupport.existsFile(S)||(s=S,n=d)}if(!s)return null;const u=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new E(s,`PowerShell${l}${u}`,!0)}async function c({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const a=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=o?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const n of await R.Promises.readdir(a))if(t.test(n)){const s=L.join(a,n,"pwsh.exe");return new E(s,r)}return null}function y(){const o=L.join(D.homedir(),".dotnet","tools","pwsh.exe");return new E(o,".NET Core PowerShell Global Tool")}function I(){const o=L.join(process.env.windir,w===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(o,"Windows PowerShell",!0)}async function*g(){let o=await b();o&&(yield o),o=await b({useAlternateBitness:!0}),o&&(yield o),o=await c(),o&&(yield o),o=y(),o&&(yield o),o=await b({findPreview:!0}),o&&(yield o),o=await c({findPreview:!0}),o&&(yield o),o=await b({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=I(),o&&(yield o)}async function*C(){for await(const o of g())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=C;async function v(){for await(const o of C())return o;return null}e.getFirstAvailablePowerShellInstallation=v}),define(te[100],ne([0,1,41,17]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(A){return new Promise((P,m)=>{let w;const i=new Map;function E(b,c,y,I,g){const C=i.get(c);if(b===A||C){const v={name:h(y),cmd:y,pid:b,ppid:c,load:I,mem:g};i.set(b,v),b===A&&(w=v),C&&(C.children||(C.children=[]),C.children.push(v),C.children.length>1&&(C.children=C.children.sort((o,a)=>o.pid-a.pid)))}}function h(b){const c=/--disable-blink-features=Auxclick/,y=/\\watcher\\win32\\CodeHelper\.exe/,I=/--crashes-directory/,g=/\\pipe\\winpty-control/,C=/conhost\.exe/,v=/--type=([a-zA-Z-]+)/;if(y.exec(b))return"watcherService ";if(I.exec(b))return"electron-crash-reporter";if(g.exec(b))return"winpty-process";if(C.exec(b))return"console-window-host (Windows internal process)";let o=v.exec(b);if(o&&o.length===2)return o[1]==="renderer"?c.exec(b)?"shared-process":"window":o[1];const a=/[a-zA-Z-]+\.js/g;let t="";do o=a.exec(b),o&&(t+=o+" ");while(o);return t&&b.indexOf("node ")<0&&b.indexOf("node.exe")<0?`electron_node ${t}`:b}if(process.platform==="win32"){const b=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substr(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substr(5):c;new Promise((c,y)=>{Y(["windows-process-tree"],c,y)}).then(c=>{c.getProcessList(A,y=>{c.getProcessCpuUsage(y,I=>{const g=new Map;I.forEach(C=>{const v=b(C.commandLine||"");g.set(C.pid,{name:h(v),cmd:v,pid:C.pid,ppid:C.ppid,load:C.cpu||0,mem:C.memory||0})}),w=g.get(A),w?(g.forEach(C=>{const v=g.get(C.ppid);v&&(v.children||(v.children=[]),v.children.push(C))}),g.forEach(C=>{C.children&&(C.children=C.children.sort((v,o)=>v.pid-o.pid))}),P(w)):m(new Error(`Root process ${A} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let b=function(){let c=[w];const y=[];for(;c.length;){const g=c.shift();g&&(y.push(g.pid),g.children&&(c=c.concat(g.children)))}let I=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Y).fsPath);I+=" "+y.join(" "),(0,D.exec)(I,{},(g,C,v)=>{if(g||v)m(g||new Error(v.toString()));else{const o=C.toString().split(`
`);for(let a=0;a<y.length;a++){const t=i.get(y[a]);t.load=parseFloat(o[a])}if(!w){m(new Error(`Root process ${A} not found`));return}P(w)}})};(0,D.exec)("which ps",{},(c,y,I)=>{if(c||I)if(process.platform!=="linux")m(c||new Error(I.toString()));else{const g=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",Y).fsPath);(0,D.exec)(g,{},(C,v,o)=>{C||o?m(C||new Error(o.toString())):(k(v,E),b())})}else{const g=y.toString().trim(),C="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${g} ${C}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,o,a)=>{v||a&&!a.includes("screen size is bogus")?m(v||new Error(a.toString())):(k(o,E),process.platform==="linux"?b():w?P(w):m(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=R;function k(A,P){const m=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=A.toString().split(`
`);for(const i of w){const E=m.exec(i.trim());E&&E.length===6&&P(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(te[101],ne([0,1,50,39,2,66,8,4,18]),function(Y,e,D,L,R,k,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function w(h,b,c){return E({path:h,isDirectory:!1},b,c)}e.watchFile=w;function i(h,b,c){return E({path:h,isDirectory:!0},b,c)}e.watchFolder=i,e.CHANGE_BUFFER_DELAY=100;function E(h,b,c){if(P.isMacintosh&&(0,L.isEqualOrParent)(h.path,"/Volumes/"))return c(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const y=(0,A.basename)(h.path),I=new Map;let g=!1,C=[(0,R.toDisposable)(()=>{I.forEach(v=>(0,R.dispose)(v)),I.clear()})];try{const v=(0,D.watch)(h.path);C.push((0,R.toDisposable)(()=>{v.removeAllListeners(),v.close()}));const o=new Set;h.isDirectory&&m.Promises.readdir(h.path).then(a=>a.forEach(t=>o.add(t))),v.on("error",(a,t)=>{g||c(`Failed to watch ${h.path} for changes using fs.watch() (${a}, ${t})`)}),v.on("change",(a,t)=>{if(g)return;let r="";if(t&&(r=t.toString(),P.isMacintosh&&(r=(0,k.normalizeNFC)(r))),!r||a!=="change"&&a!=="rename")return;const n=h.isDirectory?(0,A.join)(h.path,r):h.path;if(h.isDirectory)if(a==="rename"){const s=I.get(n);s&&(0,R.dispose)(s);const u=setTimeout(async()=>{I.delete(n);const l=await m.Promises.exists(n);if(g)return;let f;l?o.has(r)?f="changed":(f="added",o.add(r)):(o.delete(r),f="deleted"),b(f,n)},e.CHANGE_BUFFER_DELAY);I.set(n,(0,R.toDisposable)(()=>clearTimeout(u)))}else{let s;o.has(r)?s="changed":(s="added",o.add(r)),b(s,n)}else if(a==="rename"||r!==y){const s=setTimeout(async()=>{const u=await m.Promises.exists(n);g||(u?(b("changed",n),C=[E(h,b,c)]):b("deleted",n))},e.CHANGE_BUFFER_DELAY);(0,R.dispose)(C),C=[(0,R.toDisposable)(()=>clearTimeout(s))]}else b("changed",n)})}catch(v){m.Promises.exists(h.path).then(o=>{o&&!g&&c(`Failed to watch ${h.path} for changes using fs.watch() (${v.toString()})`)})}return(0,R.toDisposable)(()=>{g=!0,C=(0,R.dispose)(C)})}});var he=this&&this.__decorate||function(Y,e,D,L){var R=arguments.length,k=R<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,D):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(Y,e,D,L);else for(var P=Y.length-1;P>=0;P--)(A=Y[P])&&(k=(R<3?A(k):R>3?A(e,D,k):A(e,D))||k);return R>3&&k&&Object.defineProperty(e,D,k),k};define(te[36],ne([0,1,19,6,25,29,64,11,3,2,94,23,16]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function c(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(y=e.ResponseType||(e.ResponseType={}));function I(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(g||(g={}));class C{constructor(x){this.buffer=x,this.pos=0}read(x){const K=this.buffer.slice(this.pos,this.pos+x);return this.pos+=K.byteLength,K}}class v{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(x){this.buffers.push(x)}}var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(o||(o={}));function a(V){const x=R.VSBuffer.alloc(4);return x.writeUInt32BE(V,0),x}function t(V){return V.read(4).readUInt32BE(0)}function r(V){const x=R.VSBuffer.alloc(1);return x.writeUInt8(V,0),x}const n={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object)},s=typeof Buffer!="undefined";function u(V,x){if(typeof x=="undefined")V.write(n.Undefined);else if(typeof x=="string"){const K=R.VSBuffer.fromString(x);V.write(n.String),V.write(a(K.byteLength)),V.write(K)}else if(s&&Buffer.isBuffer(x)){const K=R.VSBuffer.wrap(x);V.write(n.Buffer),V.write(a(K.byteLength)),V.write(K)}else if(x instanceof R.VSBuffer)V.write(n.VSBuffer),V.write(a(x.byteLength)),V.write(x);else if(Array.isArray(x)){V.write(n.Array),V.write(a(x.length));for(const K of x)u(V,K)}else{const K=R.VSBuffer.fromString(JSON.stringify(x));V.write(n.Object),V.write(a(K.byteLength)),V.write(K)}}function l(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(t(V)).toString();case o.Buffer:return V.read(t(V)).buffer;case o.VSBuffer:return V.read(t(V));case o.Array:{const K=t(V),q=[];for(let $=0;$<K;$++)q.push(l(V));return q}case o.Object:return JSON.parse(V.read(t(V)).toString())}}class f{constructor(x,K,q=null,$=1e3){this.protocol=x,this.ctx=K,this.logger=q,this.timeoutDelay=$,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(_=>this.onRawMessage(_)),this.sendResponse({type:200})}registerChannel(x,K){this.channels.set(x,K),setTimeout(()=>this.flushPendingRequests(x),0)}sendResponse(x){switch(x.type){case 200:{const K=this.send([x.type]);this.logger&&this.logger.logOutgoing(K,0,1,I(x.type));return}case 201:case 202:case 204:case 203:{const K=this.send([x.type,x.id],x.data);this.logger&&this.logger.logOutgoing(K,x.id,1,I(x.type),x.data);return}}}send(x,K=void 0){const q=new v;return u(q,x),u(q,K),this.sendBuffer(q.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch(K){return 0}}onRawMessage(x){const K=new C(x),q=l(K),$=l(K),_=q[0];switch(_){case 100:return this.logger&&this.logger.logIncoming(x.byteLength,q[1],1,`${c(_)}: ${q[2]}.${q[3]}`,$),this.onPromise({type:_,id:q[1],channelName:q[2],name:q[3],arg:$});case 102:return this.logger&&this.logger.logIncoming(x.byteLength,q[1],1,`${c(_)}: ${q[2]}.${q[3]}`,$),this.onEventListen({type:_,id:q[1],channelName:q[2],name:q[3],arg:$});case 101:return this.logger&&this.logger.logIncoming(x.byteLength,q[1],1,`${c(_)}`),this.disposeActiveRequest({type:_,id:q[1]});case 103:return this.logger&&this.logger.logIncoming(x.byteLength,q[1],1,`${c(_)}`),this.disposeActiveRequest({type:_,id:q[1]})}}onPromise(x){const K=this.channels.get(x.channelName);if(!K){this.collectPendingRequest(x);return}const q=new k.CancellationTokenSource;let $;try{$=K.call(this.ctx,x.name,x.arg,q.token)}catch(G){$=Promise.reject(G)}const _=x.id;$.then(G=>{this.sendResponse({id:_,data:G,type:201}),this.activeRequests.delete(x.id)},G=>{G instanceof Error?this.sendResponse({id:_,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:_,data:G,type:203}),this.activeRequests.delete(x.id)});const J=(0,w.toDisposable)(()=>q.cancel());this.activeRequests.set(x.id,J)}onEventListen(x){const K=this.channels.get(x.channelName);if(!K){this.collectPendingRequest(x);return}const q=x.id,_=K.listen(this.ctx,x.name,x.arg)(J=>this.sendResponse({id:q,data:J,type:204}));this.activeRequests.set(x.id,_)}disposeActiveRequest(x){const K=this.activeRequests.get(x.id);K&&(K.dispose(),this.activeRequests.delete(x.id))}collectPendingRequest(x){let K=this.pendingRequests.get(x.channelName);K||(K=[],this.pendingRequests.set(x.channelName,K));const q=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.sendResponse({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:x,timeoutTimer:q})}flushPendingRequests(x){const K=this.pendingRequests.get(x);if(K){for(const q of K)switch(clearTimeout(q.timeoutTimer),q.request.type){case 100:this.onPromise(q.request);break;case 102:this.onEventListen(q.request);break}this.pendingRequests.delete(x)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(x=>x.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var d;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(x,K=null){this.protocol=x,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(q=>this.onBuffer(q)),this.logger=K}getChannel(x){const K=this;return{call(q,$,_){return K.isDisposed?Promise.reject(P.canceled()):K.requestPromise(x,q,$,_)},listen(q,$){return K.isDisposed?Promise.reject(P.canceled()):K.requestEvent(x,q,$)}}}requestPromise(x,K,q,$=k.CancellationToken.None){const _=this.lastRequestId++,G={id:_,type:100,channelName:x,name:K,arg:q};if($.isCancellationRequested)return Promise.reject(P.canceled());let ee;return new Promise((ce,ae)=>{if($.isCancellationRequested)return ae(P.canceled());const fe=()=>{const Te=Re=>{switch(Re.type){case 201:this.handlers.delete(_),ce(Re.data);break;case 202:this.handlers.delete(_);const Ce=new Error(Re.data.message);Ce.stack=Re.data.stack,Ce.name=Re.data.name,ae(Ce);break;case 203:this.handlers.delete(_),ae(Re.data);break}};this.handlers.set(_,Te),this.sendRequest(G)};let ye=null;this.state===g.Idle?fe():(ye=(0,L.createCancelablePromise)(Te=>this.whenInitialized()),ye.then(()=>{ye=null,fe()}));const Se=()=>{ye?(ye.cancel(),ye=null):this.sendRequest({id:_,type:101}),ae(P.canceled())},Pe=$.onCancellationRequested(Se);ee=(0,w.combinedDisposable)((0,w.toDisposable)(Se),Pe),this.activeRequests.add(ee)}).finally(()=>{this.activeRequests.delete(ee)})}requestEvent(x,K,q){const $=this.lastRequestId++,J={id:$,type:102,channelName:x,name:K,arg:q};let G=null;const ee=new m.Emitter({onFirstListenerAdd:()=>{G=(0,L.createCancelablePromise)(ce=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(ee),this.sendRequest(J)})},onLastListenerRemove:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(ee),this.sendRequest({id:$,type:103}))}}),Z=ce=>ee.fire(ce.data);return this.handlers.set($,Z),ee.event}sendRequest(x){switch(x.type){case 100:case 102:{const K=this.send([x.type,x.id,x.channelName,x.name],x.arg);this.logger&&this.logger.logOutgoing(K,x.id,0,`${c(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const K=this.send([x.type,x.id]);this.logger&&this.logger.logOutgoing(K,x.id,0,c(x.type));return}}}send(x,K=void 0){const q=new v;return u(q,x),u(q,K),this.sendBuffer(q.buffer)}sendBuffer(x){try{return this.protocol.send(x),x.byteLength}catch(K){return 0}}onBuffer(x){const K=new C(x),q=l(K),$=l(K),_=q[0];switch(_){case 200:return this.logger&&this.logger.logIncoming(x.byteLength,0,0,I(_)),this.onResponse({type:q[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(x.byteLength,q[1],0,I(_),$),this.onResponse({type:q[0],id:q[1],data:$})}}onResponse(x){if(x.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}const K=this.handlers.get(x.id);K&&K(x)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(x=>x.dispose()),this.activeRequests.clear()}}he([A.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class T{constructor(x){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,x(({protocol:K,onDidClientDisconnect:q})=>{m.Event.once(K.onMessage)(_=>{const J=new C(_),G=l(J),ee=new f(K,G),Z=new S(K);this.channels.forEach((ae,fe)=>ee.registerChannel(fe,ae));const ce={channelServer:ee,channelClient:Z,ctx:G};this._connections.add(ce),this._onDidAddConnection.fire(ce),q(()=>{ee.dispose(),Z.dispose(),this._connections.delete(ce),this._onDidRemoveConnection.fire(ce)})})})}get connections(){const x=[];return this._connections.forEach(K=>x.push(K)),x}getChannel(x,K){const q=this;return{call($,_,J){let G;if((0,h.isFunction)(K)){let Z=(0,D.getRandomElement)(q.connections.filter(K));G=Z?Promise.resolve(Z):m.Event.toPromise(m.Event.filter(q.onDidAddConnection,K))}else G=K.routeCall(q,$,_);const ee=G.then(Z=>Z.channelClient.getChannel(x));return p(ee).call($,_,J)},listen($,_){if((0,h.isFunction)(K))return q.getMulticastEvent(x,K,$,_);const J=K.routeEvent(q,$,_).then(G=>G.channelClient.getChannel(x));return p(J).listen($,_)}}}getMulticastEvent(x,K,q,$){const _=this;let J=new w.DisposableStore;const G=new m.Emitter({onFirstListenerAdd:()=>{J=new w.DisposableStore;const ee=new m.EventMultiplexer,Z=new Map,ce=fe=>{const Se=fe.channelClient.getChannel(x).listen(q,$),Pe=ee.add(Se);Z.set(fe,Pe)},ae=fe=>{const ye=Z.get(fe);!ye||(ye.dispose(),Z.delete(fe))};_.connections.filter(K).forEach(ce),m.Event.filter(_.onDidAddConnection,K)(ce,void 0,J),_.onDidRemoveConnection(ae,void 0,J),ee.event(G.fire,G,J),J.add(ee)},onLastListenerRemove:()=>{J.dispose()}});return G.event}registerChannel(x,K){this.channels.set(x,K),this._connections.forEach(q=>{q.channelServer.registerChannel(x,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class O{constructor(x,K,q=null){const $=new v;u($,K),x.send($.buffer),this.channelClient=new S(x,q),this.channelServer=new f(x,K,q)}getChannel(x){return this.channelClient.getChannel(x)}registerChannel(x,K){this.channelServer.registerChannel(x,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function p(V){return{call(x,K,q){return V.then($=>$.call(x,K,q))},listen(x,K){const q=new m.Relay;return V.then($=>q.input=$.listen(x,K)),q.event}}}e.getDelayedChannel=p;function F(V){let x=!1;return{call(K,q,$){return x?V.call(K,q,$):(0,L.timeout)(0).then(()=>x=!0).then(()=>V.call(K,q,$))},listen(K,q){if(x)return V.listen(K,q);const $=new m.Relay;return(0,L.timeout)(0).then(()=>x=!0).then(()=>$.input=V.listen(K,q)),$.event}}}e.getNextTickChannel=F;class M{constructor(x){this.fn=x}routeCall(x){return this.route(x)}routeEvent(x){return this.route(x)}async route(x){for(const K of x.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await m.Event.toPromise(x.onDidAddConnection),await this.route(x)}}e.StaticRouter=M;var W;(function(V){function x($,_){const J=$,G=_&&_.disableMarshalling,ee=new Map;for(const Z in J)q(Z)&&ee.set(Z,m.Event.buffer(J[Z],!0));return new class{listen(Z,ce){const ae=ee.get(ce);if(ae)return ae;throw new Error(`Event not found: ${ce}`)}call(Z,ce,ae){const fe=J[ce];if(typeof fe=="function"){if(!G&&Array.isArray(ae))for(let ye=0;ye<ae.length;ye++)ae[ye]=(0,i.revive)(ae[ye]);return fe.apply(J,ae)}throw new Error(`Method not found: ${ce}`)}}}V.fromService=x;function K($,_){const J=_&&_.disableMarshalling;return new Proxy({},{get(G,ee){if(typeof ee=="string")return _?.properties?.has(ee)?_.properties.get(ee):q(ee)?$.listen(ee):async function(...Z){let ce;_&&!(0,h.isUndefinedOrNull)(_.context)?ce=[_.context,...Z]:ce=Z;const ae=await $.call(ee,ce);return J?ae:(0,i.revive)(ae)};throw new Error(`Property not found: ${String(ee)}`)}})}V.toService=K;function q($){return $[0]==="o"&&$[1]==="n"&&E.isUpperAsciiLetter($.charCodeAt(2))}})(W=e.ProxyChannel||(e.ProxyChannel={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){let x=V.toString();if(x!=="[object Object]")return x}return V}function N(V){return Array.isArray(V)?V.map(U):U(V)}function z(V,x,K,q,$,_,J){J=N(J);const G=j[$],ee=G[q%G.length];let Z=[`%c[${V}]%c[${String(x).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${ee}`];/\($/.test(_)?(Z=Z.concat(J),Z.push(")")):Z.push(J),console.log.apply(console,Z)}e.logWithColors=z;class H{constructor(x,K){this._outgoingPrefix=x,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(x,K,q,$,_){this._totalOutgoing+=x,z(this._outgoingPrefix,this._totalOutgoing,x,K,q,$,_)}logIncoming(x,K,q,$,_){this._totalIncoming+=x,z(this._incomingPrefix,this._totalIncoming,x,K,q,$,_)}}e.IPCLogger=H}),define(te[102],ne([0,1,25,3,36]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(m){this.port=m,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",w=>D.VSBuffer.wrap(w.data)),m.start()}send(m){this.port.postMessage(m.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class A extends R.IPCClient{constructor(m,w){const i=new k(m);super(i,w);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=A}),define(te[103],ne([0,1,104,3,36,102]),function(Y,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends R.IPCServer{static getOnDidClientConnect(){const m=L.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(w,i)=>i);return L.Event.map(m,w=>{const{port1:i,port2:E}=new MessageChannel,b={protocol:new k.Protocol(i),onDidClientDisconnect:L.Event.fromDOMEventEmitter(i,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",w,[E]),b})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(te[105],ne([0,1,25,11]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function R(P,m){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const w=new XMLHttpRequest;return new Promise((i,E)=>{w.open(P.type||"GET",P.url||"",!0,P.user,P.password),k(w,P),w.responseType="arraybuffer",w.onerror=h=>E(new Error(w.statusText&&"XHR failed: "+w.statusText||"XHR failed")),w.onload=h=>{i({res:{statusCode:w.status,headers:A(w)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(w.response)))})},w.ontimeout=h=>E(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(w.timeout=P.timeout),w.send(P.data),m.onCancellationRequested(()=>{w.abort(),E((0,L.canceled)())})})}e.request=R;function k(P,m){if(m.headers){e:for(let w in m.headers){switch(w){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(w,m.headers[w])}}}function A(P){const m=Object.create(null);for(const w of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(w){const i=w.indexOf(":");m[w.substr(0,i).trim().toLowerCase()]=w.substr(i+1).trim()}return m}}),define(te[70],ne([0,1,6,3,2,16]),function(Y,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var A;(function(i){i[i.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));var P;(function(i){i[i.None=0]="None",i[i.Initialized=1]="Initialized",i[i.Closed=2]="Closed"})(P||(P={}));class m extends R.Disposable{constructor(E,h=Object.create(null)){super();this.database=E,this.options=h,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(E=>this.onDidChangeItemsExternal(E)))}onDidChangeItemsExternal(E){E.changed?.forEach((h,b)=>this.accept(b,h)),E.deleted?.forEach(h=>this.accept(h,void 0))}accept(E,h){if(this.state===P.Closed)return;let b=!1;(0,k.isUndefinedOrNull)(h)?b=this.cache.delete(E):this.cache.get(E)!==h&&(this.cache.set(E,h),b=!0),b&&this._onDidChangeStorage.fire(E)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(E,h){const b=this.cache.get(E);return(0,k.isUndefinedOrNull)(b)?h:b}getBoolean(E,h){const b=this.get(E);return(0,k.isUndefinedOrNull)(b)?h:b==="true"}getNumber(E,h){const b=this.get(E);return(0,k.isUndefinedOrNull)(b)?h:parseInt(b,10)}async set(E,h){if(this.state===P.Closed)return;if((0,k.isUndefinedOrNull)(h))return this.delete(E);const b=String(h);if(this.cache.get(E)!==b)return this.cache.set(E,b),this.pendingInserts.set(E,b),this.pendingDeletes.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}async delete(E){if(!(this.state===P.Closed||!this.cache.delete(E)))return this.pendingDeletes.has(E)||this.pendingDeletes.add(E),this.pendingInserts.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(E){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const E={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(E).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(E=>this.whenFlushedCallbacks.push(E))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class w{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(E){E.insert&&E.insert.forEach((h,b)=>this.items.set(b,h)),E.delete&&E.delete.forEach(h=>this.items.delete(h))}async close(){}}e.InMemoryStorageDatabase=w}),define(te[106],ne([9,10]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(te[56],ne([0,1,106]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,R=L*60,k=R*24,A=k*7,P=k*30,m=k*365;function w(E,h){typeof E!="number"&&(E=E.getTime());const b=Math.round((new Date().getTime()-E)/1e3);if(b<-30)return(0,D.localize)(0,null,w(new Date().getTime()+b*1e3,!1));if(b<30)return(0,D.localize)(1,null);let c;return b<L?(c=b,h?c===1?(0,D.localize)(2,null,c):(0,D.localize)(3,null,c):c===1?(0,D.localize)(4,null,c):(0,D.localize)(5,null,c)):b<R?(c=Math.floor(b/L),h?c===1?(0,D.localize)(6,null,c):(0,D.localize)(7,null,c):c===1?(0,D.localize)(8,null,c):(0,D.localize)(9,null,c)):b<k?(c=Math.floor(b/R),h?c===1?(0,D.localize)(10,null,c):(0,D.localize)(11,null,c):c===1?(0,D.localize)(12,null,c):(0,D.localize)(13,null,c)):b<A?(c=Math.floor(b/k),h?c===1?(0,D.localize)(14,null,c):(0,D.localize)(15,null,c):c===1?(0,D.localize)(16,null,c):(0,D.localize)(17,null,c)):b<P?(c=Math.floor(b/A),h?c===1?(0,D.localize)(18,null,c):(0,D.localize)(19,null,c):c===1?(0,D.localize)(20,null,c):(0,D.localize)(21,null,c)):b<m?(c=Math.floor(b/P),h?c===1?(0,D.localize)(22,null,c):(0,D.localize)(23,null,c):c===1?(0,D.localize)(24,null,c):(0,D.localize)(25,null,c)):(c=Math.floor(b/m),h?c===1?(0,D.localize)(26,null,c):(0,D.localize)(27,null,c):c===1?(0,D.localize)(28,null,c):(0,D.localize)(29,null,c))}e.fromNow=w;function i(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(te[107],ne([9,10]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(te[37],ne([0,1,19,16,107]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(w,i){return i&&(w.stack||w.stacktrace)?R.localize(0,null,P(w),A(w.stack)||A(w.stacktrace)):P(w)}function A(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?R.localize(1,null,w.message):w.message||R.localize(2,null)}function m(w=null,i=!1){if(!w)return R.localize(3,null);if(Array.isArray(w)){const E=D.coalesce(w),h=m(E[0],i);return E.length>1?R.localize(4,null,h,E.length):h}if(L.isString(w))return w;if(w.detail){const E=w.detail;if(E.error)return k(E.error,i);if(E.exception)return k(E.exception,i)}return w.stack?k(w,i):w.message?w.message:R.localize(5,null)}e.toErrorMessage=m}),define(te[108],ne([9,10]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(te[71],ne([0,1,41,39,17,26,8,4,34,16,68,18,108]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function b(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(o,a){if(P.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const r=D.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(n=>{r.once("error",s=>{n({success:!1,error:s})}),r.once("exit",(s,u)=>{n(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?b(t.status):1})}else if(P.isLinux||P.isMacintosh)try{const t=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(r=>{D.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(n,s,u)=>{r(n?{success:!1,error:n}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function y(o=m.env){return o.comspec||"cmd.exe"}e.getWindowsShell=y;class I{constructor(a,t,r,n){if(t!==void 0&&r!==void 0&&n!==void 0)this.cmd=a,this.args=t,this.shell=r,this.options=n;else{const s=a;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(m.env).forEach(u=>{s[u]=m.env[u]}),Object.keys(this.options.env).forEach(u=>{s[u]=this.options.env[u]}),this.options.env=s}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(A.sep);return t!==-1&&(a=a.substring(t+1)),I.WellKnowCommands[a]?a:"other"}start(a){return P.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(m.cwd()))?Promise.reject(new Error(h.localize(0,null))):this.useExec().then(t=>{let r,n;const s=new Promise((u,l)=>{r=u,n=l});if(t){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=D.exec(u,this.options,(l,f,d)=>{this.childProcess=null;const S=l;S&&S.killed?n({killed:this.terminateRequested,stdout:f.toString(),stderr:d.toString()}):this.handleExec(r,a,l,f,d)})}else{let u=null;const l=f=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(f,r,a,n);const d={terminated:this.terminateRequested};w.isNumber(f)&&(d.cmdCode=f),r(d)};if(this.shell&&P.isWindows){const f=k.deepClone(this.options);f.windowsVerbatimArguments=!0,f.detached=!1;let d=!1,S=!1;const T=[];let O=this.ensureQuotes(this.cmd);T.push(O.value),d=O.quoted,this.args&&this.args.forEach(F=>{O=this.ensureQuotes(F),T.push(O.value),S=S&&O.quoted});const p=["/s","/c"];d?S?p.push('"'+T.join(" ")+'"'):T.length>1?p.push('"'+T[0]+'" '+T.slice(1).join(" ")):p.push('"'+T[0]+'"'):p.push(T.join(" ")),u=D.spawn(y(),p,f)}else this.cmd&&(u=D.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(w.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",f=>{this.childProcess=null,n({terminated:this.terminateRequested,error:f})}),u.pid&&(this.childProcess.on("close",l),this.handleSpawn(u,r,a,n,!0)))}return s})}handleClose(a,t,r,n){}ensureQuotes(a){return I.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,c(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!P.isWindows)return a(!1);const t=D.spawn(y(),["/s","/c"]);t.on("error",r=>a(!0)),t.on("exit",r=>a(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class g extends I{constructor(a,t,r,n){super(a,t,r,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,r,n,s){[n,s].forEach((u,l)=>{const f=new i.LineDecoder;f.write(u).forEach(T=>{t({line:T,source:l===0?0:1})});const S=f.end();S&&t({line:S,source:l===0?0:1})}),a({terminated:this.terminateRequested,error:r})}handleSpawn(a,t,r,n,s){const u=new i.LineDecoder,l=new i.LineDecoder;a.stdout.on("data",f=>{u.write(f).forEach(S=>r({line:S,source:0}))}),a.stderr.on("data",f=>{l.write(f).forEach(S=>r({line:S,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=l}handleClose(a,t,r,n){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&r({line:s,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&r({line:u,source:1})}}e.LineProcess=g;function C(o){let a=[],t=!1;const r=function(n){if(t){a.push(n);return}(!o.send(n,u=>{if(u&&console.error(u),t=!1,a.length>0){const l=a.slice(0);a=[],l.forEach(f=>r(f))}})||P.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=C;var v;(function(o){async function a(t,r,n){if(A.isAbsolute(t))return t;if(r===void 0&&(r=m.cwd()),A.dirname(t)!=="."||(n===void 0&&w.isString(m.env.PATH)&&(n=m.env.PATH.split(A.delimiter)),n===void 0||n.length===0))return A.join(r,t);async function u(l){if(await E.Promises.exists(l)){let f;try{f=await E.Promises.stat(l)}catch(d){d.message.startsWith("EACCES")&&(f=await E.Promises.lstat(l))}return f?!f.isDirectory():!1}return!1}for(let l of n){let f;if(A.isAbsolute(l)?f=A.join(l,t):f=A.join(r,l,t),await u(f))return f;let d=f+".com";if(await u(d)||(d=f+".exe",await u(d)))return d}return A.join(r,t)}o.findExecutable=a})(v=e.win32||(e.win32={}))}),define(te[109],ne([0,1,35,4,69,71]),function(Y,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(b,c){return b===1?L.isWindows?E():k.getWindowsShell(c):w(b,c)}e.getSystemShell=A;function P(b,c){return b===1?L.isWindows?h(c):k.getWindowsShell(c):w(b,c)}e.getSystemShellSync=P;let m=null;function w(b,c){if(L.isLinux&&b===2||L.isMacintosh&&b===3)return"/bin/bash";if(!m){let y;if(L.isWindows)y="/bin/bash";else{if(y=c.SHELL,!y)try{y=(0,D.userInfo)().shell}catch(I){}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}m=y}return m}let i=null;async function E(){return i||(i=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),i}function h(b){if(i)return i;const c=L.isWindows&&parseFloat((0,D.release)())>=10,y=b.hasOwnProperty("PROCESSOR_ARCHITEW6432"),I=`${b.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return c?I:k.getWindowsShell(b)}}),define(te[51],ne([0,1,41,6,25,29,93,11,3,2,26,4,71,36]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class c extends b.ChannelServer{constructor(g){super({send:C=>{try{process.send&&process.send(C.buffer.toString("base64"))}catch(v){}},onMessage:m.Event.fromNodeEventEmitter(process,"message",C=>R.VSBuffer.wrap(Buffer.from(C,"base64")))},g);process.once("disconnect",()=>this.dispose())}}e.Server=c;class y{constructor(g,C){this.modulePath=g,this.options=C,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new m.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=C&&C.timeout?C.timeout:6e4;this.disposeDelayer=new L.Delayer(v),this.child=null,this._client=null}getChannel(g){const C=this;return{call(v,o,a){return C.requestPromise(g,v,o,a)},listen(v,o){return C.requestEvent(g,v,o)}}}requestPromise(g,C,v,o=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(g),t=(0,L.createCancelablePromise)(s=>a.call(C,v,s)),r=o.onCancellationRequested(()=>t.cancel()),n=(0,w.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{r.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(g,C,v){if(!this.disposeDelayer)return m.Event.None;this.disposeDelayer.cancel();let o;const a=new m.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(g).listen(C,v)(a.fire,a),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],C=Object.create(null);C.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(C.env={...C.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(C.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(C.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(C.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),C.execArgv===void 0&&(C.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),E.isMacintosh&&C.env&&delete C.env.DYLD_LIBRARY_PATH,this.child=(0,D.fork)(this.modulePath,g,C);const v=new m.Emitter;m.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if((0,A.isRemoteConsoleLog)(u)){(0,A.log)(u,`IPC Library: ${this.options.serverName}`);return}v.fire(R.VSBuffer.wrap(Buffer.from(u,"base64")))});const a=this.options.useQueue?(0,h.createQueuedSender)(this.child):this.child,t=u=>this.child&&this.child.connected&&a.send(u.buffer.toString("base64")),r=v.event,n={send:t,onMessage:r};this._client=new b.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,l)=>{process.removeListener("exit",s),this.activeRequests.forEach(f=>(0,w.dispose)(f)),this.activeRequests.clear(),u!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:l})})}return this._client}getCachedChannel(g){let C=this.channels.get(g);return C||(C=this.client.getChannel(g),this.channels.set(g,C)),C}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=y}),define(te[110],ne([9,10]),function(Y,e){return Y.create("vs/base/node/zip",e)}),define(te[111],ne([9,10]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[112],ne([9,10]),function(Y,e){return Y.create("vs/platform/environment/node/argv",e)}),define(te[113],ne([9,10]),function(Y,e){return Y.create("vs/platform/environment/node/argvHelper",e)}),define(te[114],ne([9,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[115],ne([9,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[116],ne([9,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[117],ne([9,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[118],ne([9,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[119],ne([9,10]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[120],ne([9,10]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[121],ne([9,10]),function(Y,e){return Y.create("vs/platform/files/common/fileService",e)}),define(te[122],ne([9,10]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(te[123],ne([9,10]),function(Y,e){return Y.create("vs/platform/files/common/io",e)}),define(te[124],ne([9,10]),function(Y,e){return Y.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[125],ne([9,10]),function(Y,e){return Y.create("vs/platform/request/common/request",e)}),define(te[126],ne([9,10]),function(Y,e){return Y.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[127],ne([9,10]),function(Y,e){return Y.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[128],ne([9,10]),function(Y,e){return Y.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[129],ne([9,10]),function(Y,e){return Y.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[130],ne([9,10]),function(Y,e){return Y.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[131],ne([9,10]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[132],ne([9,10]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[133],ne([9,10]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[134],ne([0,1,56,64,17,8,34,15,5]),function(Y,e,D,L,R,k,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(c,y,I){this._args=c,this.paths=y,this.productService=I}get appRoot(){return(0,k.dirname)(R.FileAccess.asFileUri("",Y).fsPath)}get userHome(){return m.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return m.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return m.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const c=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",c)}return this.args.logsPath}get userDataSyncLogResource(){return m.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(m.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return m.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return m.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=A.env.VSCODE_PORTABLE;return c?m.URI.file((0,k.join)(c,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return m.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,k.resolve)(c):(0,k.normalize)((0,k.join)(R.FileAccess.asFileUri("",Y).fsPath,"..","extensions"))}get extensionsDownloadPath(){const c=this.args["extensions-download-dir"];return c?(0,k.resolve)(c):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,k.resolve)(c);const y=A.env.VSCODE_EXTENSIONS;if(y)return y;const I=A.env.VSCODE_PORTABLE;return I?(0,k.join)(I,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(y=>/^[^:/?#]+?:\/\//.test(y)?m.URI.parse(y):m.URI.file((0,k.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?m.URI.parse(c):m.URI.file((0,k.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(m.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return m.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],w.prototype,"appRoot",null),he([L.memoize],w.prototype,"userHome",null),he([L.memoize],w.prototype,"userDataPath",null),he([L.memoize],w.prototype,"appSettingsHome",null),he([L.memoize],w.prototype,"tmpDir",null),he([L.memoize],w.prototype,"userRoamingDataHome",null),he([L.memoize],w.prototype,"settingsResource",null),he([L.memoize],w.prototype,"userDataSyncHome",null),he([L.memoize],w.prototype,"userDataSyncLogResource",null),he([L.memoize],w.prototype,"sync",null),he([L.memoize],w.prototype,"machineSettingsResource",null),he([L.memoize],w.prototype,"globalStorageHome",null),he([L.memoize],w.prototype,"workspaceStorageHome",null),he([L.memoize],w.prototype,"keybindingsResource",null),he([L.memoize],w.prototype,"keyboardLayoutResource",null),he([L.memoize],w.prototype,"argvResource",null),he([L.memoize],w.prototype,"snippetsHome",null),he([L.memoize],w.prototype,"isExtensionDevelopment",null),he([L.memoize],w.prototype,"untitledWorkspacesHome",null),he([L.memoize],w.prototype,"installSourcePath",null),he([L.memoize],w.prototype,"builtinExtensionsPath",null),he([L.memoize],w.prototype,"extensionsPath",null),he([L.memoize],w.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],w.prototype,"extensionDevelopmentKind",null),he([L.memoize],w.prototype,"extensionTestsLocationURI",null),he([L.memoize],w.prototype,"debugExtensionHost",null),he([L.memoize],w.prototype,"serviceMachineIdResource",null),he([L.memoize],w.prototype,"telemetryLogResource",null),he([L.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function i(b,c){return h(b["inspect-extensions"],b["inspect-brk-extensions"],5870,c,b.debugId)}e.parseExtensionHostPort=i;function E(b,c){return h(b["inspect-search"],b["inspect-brk-search"],5876,c)}e.parseSearchPort=E;function h(b,c,y,I,g){const v=Number(c||b)||(I?null:y),o=v?Boolean(!!c):!1;return{port:v,break:o,debugId:g}}}),define(te[135],ne([0,1,220,4,112]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(c,y,I=A){const g={},C=[],v=[];for(let r in y){const n=y[r];n.alias&&(g[r]=n.alias),n.type==="string"||n.type==="string[]"?(C.push(r),n.deprecates&&C.push(n.deprecates)):n.type==="boolean"&&(v.push(r),n.deprecates&&v.push(n.deprecates))}const o=D(c,{string:C,boolean:v,alias:g}),a={},t=o;a._=o._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in y){const n=y[r];n.alias&&delete t[n.alias];let s=t[r];n.deprecates&&t.hasOwnProperty(n.deprecates)&&(s||(s=t[n.deprecates]),delete t[n.deprecates]),typeof s!="undefined"&&(n.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):n.type==="string"&&Array.isArray(s)&&(s=s.pop(),I.onMultipleValues(r,s)),a[r]=s),delete t[r]}for(let r in t)I.onUnknownOption(r);return a}e.parseArgs=P;function m(c,y){let I="";return y.args&&(Array.isArray(y.args)?I=` <${y.args.join("> <")}>`:I=` <${y.args}>`),y.alias?`-${y.alias} --${c}${I}`:`--${c}${I}`}function w(c,y){let I=0,g=[];for(const a in c){const t=c[a],r=m(a,t);I=Math.max(I,r.length),g.push([r,t.description])}let C=I+2+1;if(y-C<25)return g.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let v=y-C-1,o=[];for(const a of g){let t=a[0],r=E(a[1],v),n=i(C-t.length-2);o.push("  "+t+n+r[0]);for(let s=1;s<r.length;s++)o.push(i(C)+r[s])}return o}e.formatOptions=w;function i(c){return" ".repeat(c)}function E(c,y){let I=[];for(;c.length;){let g=c.length<y?c.length:c.lastIndexOf(" ",y),C=c.slice(0,g).trim();c=c.slice(g),I.push(C)}return I}function h(c,y,I,g,C=!0){const v=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${c} ${I}`];o.push(""),o.push(`${(0,R.localize)(32,null)}: ${y} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),o.push(""),C&&(L.isWindows?o.push((0,R.localize)(35,null,y)):o.push((0,R.localize)(36,null,y)),o.push(""));const a={};for(const t in g){const r=g[t];if(r.description&&r.cat){let n=a[r.cat];n||(a[r.cat]=n={}),n[t]=r}}for(let t in a){const r=t;let n=a[r];n&&(o.push(k[r]),o.push(...w(n,v)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=h;function b(c,y){return`${c||(0,R.localize)(37,null)}
${y||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=b}),function(){"use strict";function Y(e,D,L,R){function k(P){const m=A(P),w=[m];return e.isAbsolute(m)||w.unshift(R),e.resolve(...w)}function A(P){const m=process.env.VSCODE_PORTABLE;if(m)return e.join(m,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,L);const i=P["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(E,"AppData","Roaming")}break;case"darwin":w=e.join(D.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,L)}return{getUserDataPath:k}}if(typeof define=="function")define(te[136],ne([0,137,35,17,15,34]),function(e,D,L,R,k,A){const P=k.dirname(R.FileAccess.asFileUri("",e)),m=e.__$__nodeRequire(k.joinPath(P,"package.json").fsPath);return Y(D,L,m.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),L=require("os");module.exports=Y(D,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[138],ne([0,1,35,134,136]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends L.AbstractNativeEnvironmentService{constructor(P,m){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P)},m)}}e.NativeEnvironmentService=k}),define(te[139],ne([0,1,5]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,m=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function w(I){const g=I.match(A);return g?g[1]:null}function i(I){if(I.indexOf("://")===-1){const g=I.match(L);return g?w(g[2]):null}try{const g=D.URI.parse(I);if(g.authority)return w(g.authority)}catch(g){}return null}function E(I,g){const C=new Set;let v;for(;v=P.exec(I);){const a=i(v[1]);a&&C.add(a)}const o=new Set(g);return Array.from(C).map(a=>o.has(a)?a:a.replace(m,"a"))}e.getDomainsOfRemotes=E;function h(I){const g=I.match(k);return g?g[2]:null}function b(I,g,C){return I&&g?(C&&g.endsWith(".git")&&(g=g.substr(0,g.length-4)),g.indexOf("/")===0?`${I}${g}`:`${I}/${g}`):null}function c(I,g){if(I.indexOf("://")===-1){const C=I.match(R);if(C)return b(C[2],C[3],g)}try{const C=D.URI.parse(I);if(C.authority)return b(h(C.authority),C.path,g)}catch(C){}return null}function y(I,g=!1){const C=[];let v;for(;v=P.exec(I);){const o=c(v[1],g);o&&C.push(o)}return C}e.getRemotes=y}),define(te[140],ne([0,1,3,2,26,5,96]),function(Y,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(c,y){return k.URI.revive(y?y.transformIncoming(c):c)}function m(c,y){return y?y.transformOutgoingURI(c):c}function w(c,y){y=y||A.DefaultURITransformer;const I=c.manifest;return{...(0,A.transformAndReviveIncomingURIs)({...c,manifest:void 0},y),manifest:I}}function i(c,y){return y?(0,R.cloneAndChange)(c,I=>I instanceof k.URI?y.transformOutgoingURI(I):void 0):c}class E{constructor(y,I){this.service=y,this.getUriTransformer=I,this.onInstallExtension=D.Event.buffer(y.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(y.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(y.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(y.onDidUninstallExtension,!0)}listen(y,I){const g=this.getUriTransformer(y);switch(I){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,C=>C.map(v=>({...v,local:v.local?i(v.local,g):v.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(y,I,g){const C=this.getUriTransformer(y);switch(I){case"zip":return this.service.zip(w(g[0],C)).then(v=>m(v,C));case"unzip":return this.service.unzip(P(g[0],C));case"install":return this.service.install(P(g[0],C),g[1]);case"getManifest":return this.service.getManifest(P(g[0],C));case"canInstall":return this.service.canInstall(g[0]);case"installFromGallery":return this.service.installFromGallery(g[0],g[1]);case"uninstall":return this.service.uninstall(w(g[0],C),g[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(w(g[0],C));case"getInstalled":return this.service.getInstalled(g[0]).then(v=>v.map(o=>i(o,C)));case"updateMetadata":return this.service.updateMetadata(w(g[0],C),g[1]).then(v=>i(v,C));case"updateExtensionScope":return this.service.updateExtensionScope(w(g[0],C),g[1]).then(v=>i(v,C));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=E;class h extends L.Disposable{constructor(y){super();this.channel=y,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(I=>this._onInstallExtension.fire({identifier:I.identifier,source:this.isUriComponents(I.source)?k.URI.revive(I.source):I.source}))),this._register(this.channel.listen("onDidInstallExtensions")(I=>this._onDidInstallExtensions.fire(I.map(g=>({...g,local:g.local?w(g.local,null):g.local,source:this.isUriComponents(g.source)?k.URI.revive(g.source):g.source}))))),this._register(this.channel.listen("onUninstallExtension")(I=>this._onUninstallExtension.fire(I))),this._register(this.channel.listen("onDidUninstallExtension")(I=>this._onDidUninstallExtension.fire(I)))}isUriComponents(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}zip(y){return Promise.resolve(this.channel.call("zip",[y]).then(I=>k.URI.revive(I)))}unzip(y){return Promise.resolve(this.channel.call("unzip",[y]))}install(y,I){return Promise.resolve(this.channel.call("install",[y,I])).then(g=>w(g,null))}getManifest(y){return Promise.resolve(this.channel.call("getManifest",[y]))}async canInstall(y){return!0}installFromGallery(y,I){return Promise.resolve(this.channel.call("installFromGallery",[y,I])).then(g=>w(g,null))}uninstall(y,I){return Promise.resolve(this.channel.call("uninstall",[y,I]))}reinstallFromGallery(y){return Promise.resolve(this.channel.call("reinstallFromGallery",[y]))}getInstalled(y=null){return Promise.resolve(this.channel.call("getInstalled",[y])).then(I=>I.map(g=>w(g,null)))}updateMetadata(y,I){return Promise.resolve(this.channel.call("updateMetadata",[y,I])).then(g=>w(g,null))}updateExtensionScope(y,I){return Promise.resolve(this.channel.call("updateExtensionScope",[y,I])).then(g=>w(g,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class b{constructor(y){this.service=y}listen(y,I){throw new Error("Invalid listen")}call(y,I,g){switch(I){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(te[141],ne([0,1,26]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function R(k,A){const P=m=>{if(typeof m!="string")return;const w=L.exec(m);if(!w)return;const i=A[w[1]]??m;return typeof i=="string"?i:typeof i.message=="string"?i.message:m};return(0,D.cloneAndChange)(k,P)}e.localizeManifest=R}),define(te[142],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(k){this.channel=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,A,P,m){return this.channel.call("promptImportantExtensionsInstallNotification",[k,A,P,m])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class L{constructor(k){this.service=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,P){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(te[72],ne([0,1,120]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function k(h){return h=h.trim(),h==="*"||L.test(h)}e.isValidVersionStr=k;function A(h){if(!k(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=h.match(L);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=A;function P(h){if(!h)return null;let b=h.majorBase,c=h.majorMustEqual,y=h.minorBase,I=h.minorMustEqual,g=h.patchBase,C=h.patchMustEqual;h.hasCaret&&(b===0||(I=!1),C=!1);let v=0;if(h.preRelease){const o=R.exec(h.preRelease);if(o){const[,a,t,r]=o;v=Date.UTC(Number(a),Number(t)-1,Number(r))}}return{majorBase:b,majorMustEqual:c,minorBase:y,minorMustEqual:I,patchBase:g,patchMustEqual:C,isMinimum:h.hasGreaterEquals,notBefore:v}}e.normalizeVersion=P;function m(h,b,c){let y;typeof h=="string"?y=P(A(h)):y=h;let I;b instanceof Date?I=b.getTime():typeof b=="string"&&(I=new Date(b).getTime());let g;if(typeof c=="string"?g=P(A(c)):g=c,!y||!g)return!1;let C=y.majorBase,v=y.minorBase,o=y.patchBase,a=g.majorBase,t=g.minorBase,r=g.patchBase,n=g.notBefore,s=g.majorMustEqual,u=g.minorMustEqual,l=g.patchMustEqual;return g.isMinimum?C>a?!0:C<a?!1:v>t?!0:v<t||I&&I<n?!1:o>=r:(C===1&&a===0&&(!s||!u||!l)&&(a=1,t=0,r=0,s=!0,u=!1,l=!1),C<a?!1:C>a?!s:v<t?!1:v>t?!u:o<r?!1:o>r?!l:!(I&&I<n))}e.isValidVersion=m;function w(h,b,c,y){return c.isBuiltin||typeof c.main=="undefined"?!0:E(h,b,c.engines.vscode,y)}e.isValidExtensionVersion=w;function i(h,b,c){return h==="*"||E(b,c,h)}e.isEngineValid=i;function E(h,b,c,y=[]){let I=P(A(c));if(!I)return y.push(D.localize(0,null,c)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return y.push(D.localize(1,null,c)),!1}else if(!I.majorMustEqual)return y.push(D.localize(2,null,c)),!1;return m(h,b,I)?!0:(y.push(D.localize(3,null,h,c)),!1)}}),define(te[143],ne([0,1,2,17,36,51]),function(Y,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends D.Disposable{constructor(m,w,i,E){super();this.folders=m,this.onDidFilesChange=w,this.onLogMessage=i,this.verboseLogging=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new k.Client(L.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(m.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.setFolders(this.folders)}setVerboseLogging(m){this.verboseLogging=m,!this.isDisposed&&this.service&&this.service.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${m}`})}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(te[144],ne([0,1,2,17,36,51]),function(Y,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A extends D.Disposable{constructor(m,w,i,E,h={}){super();this.folders=m,this.onDidFilesChange=w,this.onLogMessage=i,this.verboseLogging=E,this.watcherOptions=h,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new k.Client(L.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=A.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(m.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.setRoots(this.folders)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${m}`})}setVerboseLogging(m){this.verboseLogging=m,this.service&&this.service.setVerboseLogging(m)}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=A,A.MAX_RESTARTS=5}),define(te[145],ne([0,1,41,67,17,68]),function(Y,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class A{constructor(m,w,i,E,h){this.watchedFolder=m,this.eventCallback=i,this.logCallback=E,this.verboseLogging=h,this.restartCounter=0,Array.isArray(w)?this.ignored=w.map(b=>(0,L.parse)(b)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${m}, excludes: ${w.join(",")}`),this.startWatcher()}startWatcher(){const m=[this.watchedFolder];this.verboseLogging&&m.push("-verbose"),this.handle=(0,D.spawn)(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",Y).fsPath,m);const w=new k.LineDecoder;this.handle.stdout.on("data",i=>{const E=[];for(const h of w.write(i)){const b=h.split("|");if(b.length===2){const c=Number(b[0]),y=b[1];if(c>=0&&c<3){if(this.ignored&&this.ignored.some(I=>I(y))){this.verboseLogging&&this.log(y);continue}E.push({type:A.changeTypeMap[c],path:y})}else this.log(b[1])}}E.length>0&&this.eventCallback(E)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,E)=>this.onExit(i,E))}onError(m){this.error("process error: "+m.toString())}onExit(m,w){this.handle&&(this.error(`terminated unexpectedly (code: ${m}, signal: ${w})`),this.restartCounter<=A.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(m){this.logCallback({type:"error",message:`[File Watcher (C#)] ${m}`})}log(m){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${m}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=A,A.MAX_RESTARTS=5,A.changeTypeMap=[0,1,2]}),define(te[146],ne([0,1,8,23,145]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k{constructor(P,m,w,i){this.onDidFilesChange=m,this.onLogMessage=w,this.verboseLogging=i,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(D.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,D.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new R.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=k}),define(te[52],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,k=[],A=!1){this.ctor=R,this.staticArguments=k,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=D}),define(te[147],ne([0,1,52]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function R(A,P,m){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],m)),L.push([A,P])}e.registerSingleton=R;function k(){return L}e.getSingletonServiceDescriptors=k}),define(te[148],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=D;class L{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let A of this._nodes.values())A.outgoing.size===0&&k.push(A);return k}insertEdge(k,A){const P=this.lookupOrInsertNode(k),m=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),m),m.incoming.set(this._hashFn(k),P)}removeNode(k){const A=this._hashFn(k);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(k){const A=this._hashFn(k);let P=this._nodes.get(A);return P||(P=new D(k),this._nodes.set(A,P)),P}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[A,P]of this._nodes)k.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,A]of this._nodes){const P=new Set([k]),m=this._findCycle(A,P);if(m)return m}}_findCycle(k,A){for(let[P,m]of k.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const w=this._findCycle(m,A);if(w)return w;A.delete(P)}}}e.Graph=L}),define(te[7],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function m(w){return w[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=m})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function L(P,m,w,i){m[D.DI_TARGET]===m?m[D.DI_DEPENDENCIES].push({id:P,index:w,optional:i}):(m[D.DI_DEPENDENCIES]=[{id:P,index:w,optional:i}],m[D.DI_TARGET]=m)}function R(P){if(D.serviceIds.has(P))return D.serviceIds.get(P);const m=function(w,i,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(m,w,E,!1)};return m.toString=()=>P,D.serviceIds.set(P,m),m}e.createDecorator=R;function k(P){return P}e.refineServiceDecorator=k;function A(P){return function(m,w,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(P,m,i,!0)}}e.optional=A}),define(te[149],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(te[150],ne([0,1,4,23,7]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=D.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",D.isMacintosh),A.set("isLinux",D.isLinux),A.set("isWindows",D.isWindows),A.set("isWeb",D.isWeb),A.set("isMacNative",D.isMacintosh&&!D.isWeb),A.set("isEdge",k.indexOf("Edg/")>=0),A.set("isFirefox",k.indexOf("Firefox")>=0),A.set("isChrome",k.indexOf("Chrome")>=0),A.set("isSafari",k.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var m;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(m=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return E.INSTANCE}static true(){return h.INSTANCE}static has(p){return b.create(p)}static equals(p,F){return c.create(p,F)}static notEquals(p,F){return g.create(p,F)}static regex(p,F){return r.create(p,F)}static in(p,F){return y.create(p,F)}static not(p){return C.create(p)}static and(...p){return s.create(p,null)}static or(...p){return u.create(p,null,!0)}static greater(p,F){return v.create(p,F)}static less(p,F){return a.create(p,F)}static deserialize(p,F=!1){if(!!p)return this._deserializeOrExpression(p,F)}static _deserializeOrExpression(p,F){let M=p.split("||");return u.create(M.map(W=>this._deserializeAndExpression(W,F)),null,!0)}static _deserializeAndExpression(p,F){let M=p.split("&&");return s.create(M.map(W=>this._deserializeOne(W,F)),null)}static _deserializeOne(p,F){if(p=p.trim(),p.indexOf("!=")>=0){let M=p.split("!=");return g.create(M[0].trim(),this._deserializeValue(M[1],F))}if(p.indexOf("==")>=0){let M=p.split("==");return c.create(M[0].trim(),this._deserializeValue(M[1],F))}if(p.indexOf("=~")>=0){let M=p.split("=~");return r.create(M[0].trim(),this._deserializeRegexValue(M[1],F))}if(p.indexOf(" in ")>=0){let M=p.split(" in ");return y.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(p)){const M=p.split(">=");return o.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(p)){const M=p.split(">");return v.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(p)){const M=p.split("<=");return t.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(p)){const M=p.split("<");return a.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(p)?C.create(p.substr(1).trim()):b.create(p)}static _deserializeValue(p,F){if(p=p.trim(),p==="true")return!0;if(p==="false")return!1;let M=/^'([^']*)'$/.exec(p);return M?M[1].trim():p}static _deserializeRegexValue(p,F){if((0,L.isFalsyOrWhitespace)(p)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=p.indexOf("/"),W=p.lastIndexOf("/");if(M===W||M<0){if(F)throw new Error(`bad regexp-value '${p}', missing /-enclosure`);return console.warn(`bad regexp-value '${p}', missing /-enclosure`),null}let j=p.slice(M+1,W),U=p[W+1]==="i"?"i":"";try{return new RegExp(j,U)}catch(N){if(F)throw new Error(`bad regexp-value '${p}', parse error: ${N}`);return console.warn(`bad regexp-value '${p}', parse error: ${N}`),null}}}e.ContextKeyExpr=w;function i(O,p){return O.cmp(p)}class E{constructor(){this.type=0}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}evaluate(p){return!1}serialize(){return"false"}keys(){return[]}map(p){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class h{constructor(){this.type=1}cmp(p){return this.type-p.type}equals(p){return p.type===this.type}evaluate(p){return!0}serialize(){return"true"}keys(){return[]}map(p){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class b{constructor(p,F){this.key=p,this.negated=F,this.type=2}static create(p,F=null){const M=A.get(p);return typeof M=="boolean"?M?h.INSTANCE:E.INSTANCE:new b(p,F)}cmp(p){return p.type!==this.type?this.type-p.type:f(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}evaluate(p){return!!p.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(p){return p.mapDefined(this.key)}negate(){return this.negated||(this.negated=C.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=b;class c{constructor(p,F,M){this.key=p,this.value=F,this.negated=M,this.type=4}static create(p,F,M=null){if(typeof F=="boolean")return F?b.create(p,M):C.create(p,M);const W=A.get(p);return typeof W=="boolean"?F===(W?"true":"false")?h.INSTANCE:E.INSTANCE:new c(p,F,M)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return p.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(p){return p.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=c;class y{constructor(p,F){this.key=p,this.valueKey=F,this.type=10,this.negated=null}static create(p,F){return new y(p,F)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.valueKey,p.key,p.valueKey)}equals(p){return p.type===this.type?this.key===p.key&&this.valueKey===p.valueKey:!1}evaluate(p){const F=p.getValue(this.valueKey),M=p.getValue(this.key);return Array.isArray(F)?F.indexOf(M)>=0:typeof M=="string"&&typeof F=="object"&&F!==null?P.call(F,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(p){return p.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=I.create(this)),this.negated}}e.ContextKeyInExpr=y;class I{constructor(p){this._actual=p,this.type=11}static create(p){return new I(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new I(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotInExpr=I;class g{constructor(p,F,M){this.key=p,this.value=F,this.negated=M,this.type=5}static create(p,F,M=null){if(typeof F=="boolean")return F?C.create(p,M):b.create(p,M);const W=A.get(p);return typeof W=="boolean"?F===(W?"true":"false")?E.INSTANCE:h.INSTANCE:new g(p,F,M)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return p.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(p){return p.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=g;class C{constructor(p,F){this.key=p,this.negated=F,this.type=3}static create(p,F=null){const M=A.get(p);return typeof M=="boolean"?M?E.INSTANCE:h.INSTANCE:new C(p,F)}cmp(p){return p.type!==this.type?this.type-p.type:f(this.key,p.key)}equals(p){return p.type===this.type?this.key===p.key:!1}evaluate(p){return!p.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(p){return p.mapNot(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=C;class v{constructor(p,F,M){this.key=p,this.value=F,this.negated=M,this.type=12}static create(p,F,M=null){return new v(p,F,M)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=v;class o{constructor(p,F,M){this.key=p,this.value=F,this.negated=M,this.type=13}static create(p,F,M=null){return new o(p,F,M)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(p){return p.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=o;class a{constructor(p,F,M){this.key=p,this.value=F,this.negated=M,this.type=14}static create(p,F,M=null){return new a(p,F,M)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class t{constructor(p,F,M){this.key=p,this.value=F,this.negated=M,this.type=15}static create(p,F,M=null){return new t(p,F,M)}cmp(p){return p.type!==this.type?this.type-p.type:d(this.key,this.value,p.key,p.value)}equals(p){return p.type===this.type?this.key===p.key&&this.value===p.value:!1}evaluate(p){return parseFloat(p.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(p){return p.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(p,F){this.key=p,this.regexp=F,this.type=7,this.negated=null}static create(p,F){return new r(p,F)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.key<p.key)return-1;if(this.key>p.key)return 1;const F=this.regexp?this.regexp.source:"",M=p.regexp?p.regexp.source:"";return F<M?-1:F>M?1:0}equals(p){if(p.type===this.type){const F=this.regexp?this.regexp.source:"",M=p.regexp?p.regexp.source:"";return this.key===p.key&&F===M}return!1}evaluate(p){let F=p.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const p=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${p}`}keys(){return[this.key]}map(p){return p.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class n{constructor(p){this._actual=p,this.type=8}static create(p){return new n(p)}cmp(p){return p.type!==this.type?this.type-p.type:this._actual.cmp(p._actual)}equals(p){return p.type===this.type?this._actual.equals(p._actual):!1}evaluate(p){return!this._actual.evaluate(p)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(p){return new n(this._actual.map(p))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class s{constructor(p,F){this.expr=p,this.negated=F,this.type=6}static create(p,F){return s._normalizeArr(p,F)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let F=0,M=this.expr.length;F<M;F++){const W=i(this.expr[F],p.expr[F]);if(W!==0)return W}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].equals(p.expr[F]))return!1;return!0}return!1}evaluate(p){for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].evaluate(p))return!1;return!0}static _normalizeArr(p,F){const M=[];let W=!1;for(const j of p)if(!!j){if(j.type===1){W=!0;continue}if(j.type===0)return E.INSTANCE;if(j.type===6){M.push(...j.expr);continue}M.push(j)}if(M.length===0&&W)return h.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(i);for(let j=1;j<M.length;j++)M[j-1].equals(M[j])&&(M.splice(j,1),j--);if(M.length===1)return M[0];for(;M.length>1;){const j=M[M.length-1];if(j.type!==9)break;M.pop();const U=M.pop(),N=M.length===0,z=u.create(j.expr.map(H=>s.create([H,U],null)),null,N);z&&(M.push(z),M.sort(i))}return M.length===1?M[0]:new s(M,F)}}serialize(){return this.expr.map(p=>p.serialize()).join(" && ")}keys(){const p=[];for(let F of this.expr)p.push(...F.keys());return p}map(p){return new s(this.expr.map(F=>F.map(p)),null)}negate(){if(!this.negated){const p=[];for(let F of this.expr)p.push(F.negate());this.negated=u.create(p,this,!0)}return this.negated}}class u{constructor(p,F){this.expr=p,this.negated=F,this.type=9}static create(p,F,M){return u._normalizeArr(p,F,M)}cmp(p){if(p.type!==this.type)return this.type-p.type;if(this.expr.length<p.expr.length)return-1;if(this.expr.length>p.expr.length)return 1;for(let F=0,M=this.expr.length;F<M;F++){const W=i(this.expr[F],p.expr[F]);if(W!==0)return W}return 0}equals(p){if(p.type===this.type){if(this.expr.length!==p.expr.length)return!1;for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].equals(p.expr[F]))return!1;return!0}return!1}evaluate(p){for(let F=0,M=this.expr.length;F<M;F++)if(this.expr[F].evaluate(p))return!0;return!1}static _normalizeArr(p,F,M){let W=[],j=!1;if(p){for(let U=0,N=p.length;U<N;U++){const z=p[U];if(!!z){if(z.type===0){j=!0;continue}if(z.type===1)return h.INSTANCE;if(z.type===9){W=W.concat(z.expr);continue}W.push(z)}}if(W.length===0&&j)return E.INSTANCE;W.sort(i)}if(W.length!==0){if(W.length===1)return W[0];for(let U=1;U<W.length;U++)W[U-1].equals(W[U])&&(W.splice(U,1),U--);if(W.length===1)return W[0];if(M){for(let U=0;U<W.length;U++)for(let N=U+1;N<W.length;N++)S(W[U],W[N])&&(W.splice(N,1),N--);if(W.length===1)return W[0]}return new u(W,F)}}serialize(){return this.expr.map(p=>p.serialize()).join(" || ")}keys(){const p=[];for(let F of this.expr)p.push(...F.keys());return p}map(p){return new u(this.expr.map(F=>F.map(p)),null)}negate(){if(!this.negated){let p=[];for(let F of this.expr)p.push(F.negate());for(;p.length>1;){const F=p.shift(),M=p.shift(),W=[];for(const U of T(F))for(const N of T(M))W.push(s.create([U,N],null));const j=p.length===0;p.unshift(u.create(W,null,j))}this.negated=p[0]}return this.negated}}class l extends b{constructor(p,F,M){super(p,null);this._defaultValue=F,typeof M=="object"?l._info.push({...M,key:p}):M!==!0&&l._info.push({key:p,description:M,type:F!=null?typeof F:void 0})}static all(){return l._info.values()}bindTo(p){return p.createKey(this.key,this._defaultValue)}getValue(p){return p.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(p){return c.create(this.key,p)}notEqualsTo(p){return g.create(this.key,p)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(O,p){return O<p?-1:O>p?1:0}function d(O,p,F,M){return O<F?-1:O>F?1:p<M?-1:p>M?1:0}function S(O,p){if(p.type===6&&O.type!==9&&O.type!==6){for(const W of p.expr)if(O.equals(W))return!0}const F=O.negate(),M=T(F).concat(T(p));M.sort(i);for(let W=0;W<M.length;W++){const U=M[W].negate();for(let N=W+1;N<M.length;N++){const z=M[N];if(U.equals(z))return!0}}return!1}e.implies=S;function T(O){return O.type===9?O.expr:[O]}}),define(te[73],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function L(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=L}),define(te[74],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(te[12],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(te[27],ne([0,1,17,4,34,115,7]),function(Y,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.CURRENT_TARGET_PLATFORM=e.getTargetPlatform=e.getTargetPlatformFromOS=e.toTargetPlatform=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var P;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));function m(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=m;function w(g,C){let v;switch(g){case 1:v=3;break;case 3:v=2;break;case 2:v=1;break}return i(v,C)}e.getTargetPlatformFromOS=w;function i(g,C){switch(g){case 3:return C==="x64"?"win32-x64":C==="ia32"?"win32-ia32":C==="arm64"?"win32-arm64":"unknown";case 2:return C==="x64"?"linux-x64":C==="arm64"?"linux-arm64":C==="arm"?"linux-armhf":"unknown";case 1:return C==="x64"?"darwin-x64":C==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=i,e.CURRENT_TARGET_PLATFORM=L.isWeb?"web":i(L.platform,R.arch);function E(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=E;var h;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=5]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(h=e.SortBy||(e.SortBy={}));var b;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var c;(function(g){g.Install="install",g.Uninstall="uninstall"})(c=e.StatisticType||(e.StatisticType={}));var y;(function(g){g[g.None=0]="None",g[g.Install=1]="Install",g[g.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class I extends Error{constructor(C,v){super(C);this.code=v,this.name=v}}e.ExtensionManagementError=I,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,A.createDecorator)("IExtensionManagementCLIService")});var X=this&&this.__param||function(Y,e){return function(D,L){e(D,L,Y)}};define(te[151],ne([0,1,2,27]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(A){super();this.extensionManagementService=A,this._register(A),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};R=he([X(0,L.IExtensionManagementService)],R),e.DeprecatedExtensionsCleaner=R}),define(te[75],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function R(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var k;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[76],ne([0,1,23,7]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=R;function k(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class P{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,h){if(typeof E=="undefined"||E===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof E=="string"||typeof h=="string"){let b=typeof E=="string"?E:E.value,c=typeof h=="string"?h:h.value;return D.equalsIgnoreCase(b,c)}return E._lower===h._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=P;function m(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function w(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[31],ne([0,1,23,76]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(c,y){return c.uuid&&y.uuid?c.uuid===y.uuid:c.id===y.id?!0:(0,D.compareIgnoreCase)(c.id,y.id)===0}e.areSameExtensions=R;class k{constructor(y,I){this.version=I,this.id=y.id,this.uuid=y.uuid}key(){return`${this.id}-${this.version}`}equals(y){return y instanceof k?R(this,y)&&this.version===y.version:!1}}e.ExtensionIdentifierWithVersion=k;function A(c,y){return`${c}.${y}`}e.getExtensionId=A;function P(c){return c.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function m(c,y){return P(A(c,y))}e.getGalleryExtensionId=m;function w(c,y){const I=[],g=C=>{for(const v of I)if(v.some(o=>R(y(o),y(C))))return v;return null};for(const C of c){const v=g(C);v?v.push(C):I.push([C])}return I}e.groupByExtension=w;function i(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function E(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),...c.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function h(c){const y=new Set;for(const I of c)I.malicious&&y.add(I.id.id);return y}e.getMaliciousExtensionsSet=h;function b(c,y){const I=[],g=y.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const C=g.shift();if(C&&I.every(v=>!R(v.identifier,{id:C}))){const v=c.filter(o=>R(o.identifier,{id:C}));v.length===1&&(I.push(v[0]),g.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return I}e.getExtensionDependencies=b}),define(te[152],ne([0,1,2,8,18,76]),function(Y,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends D.Disposable{constructor(m,w){super();this.environmentService=m,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(w.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this._register(w.onDidUninstallExtension(i=>this.onDidUnInstallExtension(i)))}onDidInstallExtensions(m){m.some(w=>!!w.local)&&this.invalidate()}onDidUnInstallExtension(m){m.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(te[13],ne([0,1,40,8,23,16,5,122,7]),function(Y,e,D,L,R,k,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,m.createDecorator)("fileService");function w(U){return U.create===!0}e.isFileOpenForWriteOptions=w;var i;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var E;(function(U){U[U.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var h;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(h=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=b;function c(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=c;function y(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function I(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=I;var g;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class C extends Error{constructor(N,z){super(N);this.code=z}}e.FileSystemProviderError=C;function v(U,N){const z=new C(U.toString(),N);return a(z,N),z}e.createFileSystemProviderError=v;function o(U){return U||v((0,P.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=o;function a(U,N){return U.name=N?`${N} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=a;function t(U){if(!U)return g.Unknown;if(U instanceof C)return U.code;const N=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!N)return g.Unknown;switch(N[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=t;function r(U){if(U instanceof d)return U.fileOperationResult;switch(t(U)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var n;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class s{constructor(N,z,H){this.resource=N,this.operation=z,this.target=H}isOperation(N){return this.operation===N}}e.FileOperationEvent=s;var u;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class l{constructor(N,z){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const H of N)switch(H.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>z)),this.added.set(H.resource,H);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>z)),this.updated.set(H.resource,H);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>z)),this.deleted.set(H.resource,H);break}}contains(N,...z){return this.doContains(N,{includeChildren:!1},...z)}affects(N,...z){return this.doContains(N,{includeChildren:!0},...z)}doContains(N,z,...H){if(!N)return!1;const V=H.length>0;return!!((!V||H.includes(1))&&(this.added?.get(N)||z.includeChildren&&this.added?.findSuperstr(N))||(!V||H.includes(0))&&(this.updated?.get(N)||z.includeChildren&&this.updated?.findSuperstr(N))||(!V||H.includes(2))&&(this.deleted?.findSubstr(N)||z.includeChildren&&this.deleted?.findSuperstr(N)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function f(U,N,z){return!U||!N||U===N||N.length>U.length?!1:(N.charAt(N.length-1)!==L.sep&&(N+=L.sep),z?(0,R.startsWithIgnoreCase)(U,N):U.indexOf(N)===0)}e.isParent=f;class d extends Error{constructor(N,z,H){super(N);this.fileOperationResult=z,this.options=H}}e.FileOperationError=d;class S extends d{constructor(N,z,H){super(N,2,H);this.stat=z}}e.NotModifiedSinceFileOperationError=S;var T;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function p(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=p;async function F(U,N){if(!N.canHandleResource(A.URI.from({scheme:U.scheme})))return new Promise(z=>{const H=N.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===U.scheme&&V.added&&(H.dispose(),z())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(N){return(0,k.isNumber)(N)||(N=0),N<M.KB?(0,P.localize)(1,null,N.toFixed(0)):N<M.MB?(0,P.localize)(2,null,(N/M.KB).toFixed(2)):N<M.GB?(0,P.localize)(3,null,(N/M.MB).toFixed(2)):N<M.TB?(0,P.localize)(4,null,(N/M.GB).toFixed(2)):(0,P.localize)(5,null,(N/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var W;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(W=e.Arch||(e.Arch={}));function j(U){return{maxFileSize:U===0?300*M.MB:16*M.GB,maxHeapSize:U===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=j}),define(te[153],ne([0,1,154,49,13]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(m,w)=>{const i=(0,D.createHash)("md5"),E=(await this.fileService.readFileStream(P)).value;(0,L.listenStream)(E,{onData:h=>i.update(h.buffer),onError:h=>w(h),onEnd:()=>m(i.digest("base64").replace(/=+$/,""))})})}};k=he([X(0,R.IFileService)],k),e.ChecksumService=k}),define(te[155],ne([0,1,221,113,135,13]),function(Y,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function A(h,b){const c={onUnknownOption:I=>{console.warn((0,L.localize)(0,null,I))},onMultipleValues:(I,g)=>{console.warn((0,L.localize)(1,null,I,g))}},y=(0,R.parseArgs)(h,R.OPTIONS,b?c:void 0);return y.goto&&y._.forEach(I=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(I),(0,L.localize)(2,null))),y["max-memory"]&&D(parseInt(y["max-memory"])>=k.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${k.MIN_MAX_MEMORY_SIZE_MB} MB.`),y}function P(h){const b=h.findIndex(c=>!/^-/.test(c));if(b>-1)return[...h.slice(0,b),...h.slice(b+1)]}function m(h){let[,...b]=h;process.env.VSCODE_DEV&&(b=P(b)||[]);const c=!E(process.env);return A(b,c)}e.parseMainProcessArgv=m;function w(h){const[,,...b]=h;return A(b,!0)}e.parseCLIProcessArgv=w;function i(h,...b){const c=h.indexOf("--");return c===-1?h.push(...b):h.splice(c,0,...b),h}e.addArg=i;function E(h){return h.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(te[156],ne([0,1,41,137,29,37,11,4,30,109,155]),function(Y,e,D,L,R,k,A,P,m,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function E(c,y,I){return y["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,i.isLaunchedFromCli)(I)&&!y["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,i.isLaunchedFromCli)(I)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=new Promise(async g=>{const C=new R.CancellationTokenSource,v=setTimeout(()=>{c.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),C.dispose(!0),g({})},1e4);try{const o=await b(c,C.token);g(o)}catch(o){(0,A.isPromiseCanceledError)(o)||c.error(`[resolve shell env] Unable to resolve shell environment (${o}). Proceeding without shell environment...`),g({})}finally{clearTimeout(v),C.dispose()}})),h)}e.resolveShellEnv=E;let h;async function b(c,y){const I=new Promise(async(g,C)=>{const v=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",v);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",o);const a=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"(.*)"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};c.trace("getUnixShellEnvironment#env",r);const n=await(0,w.getSystemShell)(P.OS,r);if(c.trace("getUnixShellEnvironment#shell",n),y.isCancellationRequested)return C(A.canceled);const s=L.basename(n);let u,l;/^pwsh(-preview)?$/.test(s)?(u=`& '${process.execPath}' -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,l=["-Login","-Command"]):(u=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,l=["-ilc"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),u);const f=(0,D.spawn)(n,[...l,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});y.onCancellationRequested(()=>(f.kill(),C(A.canceled))),f.on("error",T=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(T)),g({})});const d=[];f.stdout.on("data",T=>d.push(T));const S=[];f.stderr.on("data",T=>S.push(T)),f.on("close",(T,O)=>{const p=Buffer.concat(d).toString("utf8");c.trace("getUnixShellEnvironment#raw",p);const F=Buffer.concat(S).toString("utf8");if(F.trim()&&c.trace("getUnixShellEnvironment#stderr",F),T||O)return C(new Error(`Failed to get environment (code ${T}, signal ${O})`));const M=t.exec(p),W=M?M[1]:"{}";try{const j=JSON.parse(W);v?j.ELECTRON_RUN_AS_NODE=v:delete j.ELECTRON_RUN_AS_NODE,o?j.ELECTRON_NO_ATTACH_CONSOLE=o:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",j),g(j)}catch(j){c.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(j)),C(j)}})});try{return await I}catch(g){return c.error("getUnixShellEnvironment#error",(0,k.toErrorMessage)(g)),{}}}}),define(te[77],ne([0,1,4,5,13]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function k(m){return m.map(w=>({type:w.type,resource:L.URI.file(w.path)}))}e.toFileChanges=k;function A(m){const w=new P;for(const i of m)w.processEvent(i);return w.normalize()}e.normalizeFileChanges=A;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(w){const i=this.mapPathToChange.get(w.path);if(i){const E=i.type,h=w.type;E===1&&h===2?(this.mapPathToChange.delete(w.path),this.normalized.splice(this.normalized.indexOf(i),1)):E===2&&h===1?i.type=0:E===1&&h===0||(i.type=h)}else this.normalized.push(w),this.mapPathToChange.set(w.path,w)}normalize(){const w=[],i=[];return this.normalized.filter(E=>E.type!==2?(w.push(E),!1):!0).sort((E,h)=>E.path.length-h.path.length).filter(E=>i.some(h=>(0,R.isParent)(E.path,h,!D.isLinux))?!1:(i.push(E.path),!0)).concat(w)}}}),define(te[157],ne([0,1,6,2,8,99,18,101,77]),function(Y,e,D,L,R,k,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends L.Disposable{constructor(E,h,b,c){super();this.path=E,this.onDidFilesChange=h,this.onLogMessage=b,this.verboseLogging=c,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(E){this.verboseLogging=E}async startWatching(){try{const{stat:E,symbolicLink:h}=await A.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(h)try{b=await(0,k.realpath)(b)}catch(c){if(this.onError(c),h.dangling)return}E.isDirectory()?this._register((0,P.watchFolder)(b,(c,y)=>{this.onFileChange({type:c==="changed"?0:c==="added"?1:2,path:(0,R.join)(this.path,(0,R.basename)(y))})},c=>this.onError(c))):this._register((0,P.watchFile)(b,c=>{this.onFileChange({type:c==="changed"?0:2,path:this.path})},c=>this.onError(c)))}catch(E){E.code!=="ENOENT"&&this.onError(E)}}onFileChange(E){this.fileChangesBuffer.push(E),this.verboseLogging&&this.onVerbose(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),this.fileChangesDelayer.trigger(async()=>{const h=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=(0,m.normalizeFileChanges)(h);if(this.verboseLogging)for(const c of b)this.onVerbose(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);b.length>0&&this.onDidFilesChange(b)})}onError(E){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${E}`})}onVerbose(E){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(te[78],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(let[k,A]of R)this.set(k,A)}set(R,k){const A=this._entries.get(R);return this._entries.set(R,k),A}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(te[158],ne([0,1,6,11,52,148,7,78]),function(Y,e,D,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const m=!1;class w extends Error{constructor(c){super("cyclic dependency between services");this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class i{constructor(c=new P.ServiceCollection,y=!1,I){this._activeInstantiations=new Set,this._services=c,this._strict=y,this._parent=I,this._services.set(A.IInstantiationService,this)}createChild(c){return new i(c,this._strict,this)}invokeFunction(c,...y){let I=h.traceInvocation(c),g=!1;try{return c({get:(v,o)=>{if(g)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(v,I);if(!a&&o!==A.optional)throw new Error(`[invokeFunction] unknown service '${v}'`);return a}},...y)}finally{g=!0,I.stop()}}createInstance(c,...y){let I,g;return c instanceof R.SyncDescriptor?(I=h.traceCreation(c.ctor),g=this._createInstance(c.ctor,c.staticArguments.concat(y),I)):(I=h.traceCreation(c),g=this._createInstance(c,y,I)),I.stop(),g}_createInstance(c,y=[],I){let g=A._util.getServiceDependencies(c).sort((o,a)=>o.index-a.index),C=[];for(const o of g){let a=this._getOrCreateServiceInstance(o.id,I);if(!a&&this._strict&&!o.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${o.id}.`);C.push(a)}let v=g.length>0?g[0].index:y.length;if(y.length!==v){console.warn(`[createInstance] First service dependency of ${c.name} at position ${v+1} conflicts with ${y.length} static arguments`);let o=v-y.length;o>0?y=y.concat(new Array(o)):y=y.slice(0,v)}return new c(...[...y,...C])}_setServiceInstance(c,y){if(this._services.get(c)instanceof R.SyncDescriptor)this._services.set(c,y);else if(this._parent)this._parent._setServiceInstance(c,y);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let y=this._services.get(c);return!y&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):y}_getOrCreateServiceInstance(c,y){let I=this._getServiceInstanceOrDescriptor(c);return I instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,I,y.branch(c,!0)):(y.branch(c,!1),I)}_safeCreateAndCacheServiceInstance(c,y,I){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,y,I)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,y,I){const g=new k.Graph(o=>o.id.toString());let C=0;const v=[{id:c,desc:y,_trace:I}];for(;v.length;){const o=v.pop();if(g.lookupOrInsertNode(o),C++>1e3)throw new w(g);for(let a of A._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${c} depends on ${a.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const r={id:a.id,desc:t,_trace:o._trace.branch(a.id,!0)};g.insertEdge(o,r),v.push(r)}}}for(;;){const o=g.roots();if(o.length===0){if(!g.isEmpty())throw new w(g);break}for(const{data:a}of o){if(this._getServiceInstanceOrDescriptor(a.id)instanceof R.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}g.removeNode(a)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,y,I=[],g,C){if(this._services.get(c)instanceof R.SyncDescriptor)return this._createServiceInstance(y,I,g,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,y,I,g,C);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}_createServiceInstance(c,y=[],I,g){if(I){const C=new D.IdleValue(()=>this._createInstance(c,y,g));return new Proxy(Object.create(null),{get(v,o){if(o in v)return v[o];let a=C.value,t=a[o];return typeof t!="function"||(t=t.bind(a),v[o]=t),t},set(v,o,a){return C.value[o]=a,!0}})}else return this._createInstance(c,y,g)}}e.InstantiationService=i;var E;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(E||(E={}));class h{constructor(c,y){this.type=c,this.name=y,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return m?new h(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(c){return m?new h(0,c.name):h._None}branch(c,y){let I=new h(2,c.toString());return this._dep.push([c,y,I]),I}stop(){let c=Date.now()-this._start;h._totals+=c;let y=!1;function I(C,v){let o=[],a=new Array(C+1).join("	");for(const[t,r,n]of v._dep)if(r&&n){y=!0,o.push(`${a}CREATES -> ${t}`);let s=I(C+1,n);s&&o.push(s)}else o.push(`${a}uses -> ${t}`);return o.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${I(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(c>2||y)&&console.log(g.join(`
`))}}h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(te[159],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,k){this.server=R,this.router=k}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,k){this.server.registerChannel(R,k)}}e.MessagePortMainProcessService=D}),define(te[160],ne([0,1,36,52,147,7]),function(Y,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(b,c,y){const I=y.getChannel(b);return P(c)?new c.channelClientCtor(I):D.ProxyChannel.toService(I,c?.proxyOptions)}}function P(h){return!!h?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let m=class extends A{constructor(b,c,y){super(b,c,y)}};m=he([X(2,e.IMainProcessService)],m);function w(h,b,c){(0,R.registerSingleton)(h,new L.SyncDescriptor(m,[b,c],c?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=w,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let i=class extends A{constructor(b,c,y){super(b,c,y)}};i=he([X(2,e.ISharedProcessService)],i);function E(h,b,c){(0,R.registerSingleton)(h,new L.SyncDescriptor(i,[b,c],c?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=E}),define(te[57],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function L(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const k of R.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}e.isValidLocalization=L}),define(te[161],ne([0,1,2,57]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=he([X(0,L.ILocalizationsService)],R),e.LocalizationsUpdater=R}),define(te[14],ne([0,1,37,3,2,4,7]),function(Y,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function P(){return new Date().toISOString()}var m;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;class w extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class i extends w{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(m.Trace)&&this.log(m.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(m.Debug)&&this.log(m.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(m.Info)&&this.log(m.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(m.Warning)&&this.log(m.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(m.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(m.Error,this.format(n))}else this.log(m.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(m.Critical)&&this.log(m.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let n=0;n<t.length;n++){let s=t[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}r+=(n>0?" ":"")+s}return r}}e.AbstractMessageLogger=i;class E extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...r){this.getLevel()<=m.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}debug(t,...r){this.getLevel()<=m.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}info(t,...r){this.getLevel()<=m.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}warn(t,...r){this.getLevel()<=m.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...r):console.warn(`[main ${P()}]`,t,...r))}error(t,...r){this.getLevel()<=m.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}critical(t,...r){this.getLevel()<=m.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class h extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=m.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=m.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=m.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=m.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=m.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=m.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=h;class b extends w{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=m.Trace&&this.adapter.log(m.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=m.Debug&&this.adapter.log(m.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=m.Info&&this.adapter.log(m.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=m.Warning&&this.adapter.log(m.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=m.Error&&this.adapter.log(m.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=m.Critical&&this.adapter.log(m.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=m.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class c extends w{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const n of this.logServices)n.trace(t,...r)}debug(t,...r){for(const n of this.logServices)n.debug(t,...r)}info(t,...r){for(const n of this.logServices)n.info(t,...r)}warn(t,...r){for(const n of this.logServices)n.warn(t,...r)}error(t,...r){for(const n of this.logServices)n.error(t,...r)}critical(t,...r){for(const n of this.logServices)n.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class y extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=y;class I extends R.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(n))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,r?.always?m.Trace:this.logLevel,r),this.loggers.set(t.toString(),n),r?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=I;class g{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return m.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=g;function C(a){if(a.verbose)return m.Trace;if(typeof a.logLevel=="string"){const t=v(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=C;function v(a){switch(a){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Critical;case"off":return m.Off}}e.parseLogLevel=v;function o(a){switch(a){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Critical:return"critical";case m.Off:return"off"}}e.LogLevelToString=o}),define(te[162],ne([0,1,6,11,2,8,18,12,14]),function(Y,e,D,L,R,k,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let w=class extends R.Disposable{constructor(E,h){super();this.environmentService=E,this.logService=h,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,k.basename)(this.environmentService.logsPath),h=(0,k.dirname)(this.environmentService.logsPath),y=(await A.Promises.readdir(h)).filter(g=>/^\d{8}T\d{6}$/.test(g)).sort().filter(g=>g!==E),I=y.slice(0,Math.max(0,y.length-9));I.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${I.join(", ")}'`),await Promise.all(I.map(g=>A.Promises.rm((0,k.join)(h,g)))))}catch(E){(0,L.onUnexpectedError)(E)}}};w=he([X(0,P.IEnvironmentService),X(1,m.ILogService)],w),e.LogsDataCleaner=w}),define(te[163],ne([0,1,6,11,2,8,18,12,14]),function(Y,e,D,L,R,k,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let w=class lt extends R.Disposable{constructor(E,h,b){super();this.backupWorkspacesPath=E,this.environmentService=h,this.logService=b,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const E=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),b=JSON.parse(E).emptyWorkspaceInfos.map(y=>y.backupFolder),c=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(c.map(async y=>{y.length!==lt.NON_EMPTY_WORKSPACE_ID_LENGTH&&b.indexOf(y)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${y}.`),await A.Promises.rm((0,k.join)(this.environmentService.workspaceStorageHome.fsPath,y)))}))}catch(E){(0,L.onUnexpectedError)(E)}}};w.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,w=he([X(1,P.INativeEnvironmentService),X(2,m.ILogService)],w),e.StorageDataCleaner=w}),define(te[164],ne([0,1,6,11,2,4,15,58,5,30,18,12,27,31,13,14]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let g=class extends R.Disposable{constructor(v,o,a,t){super();this.fileService=o,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=m.URI.file(v.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(v,o){await this.cleanUpPromise;const a=this.getName(v),t=(0,A.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const r=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,w.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(v,r,o);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(r)}catch(s){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",v.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,r.path),n}}return t}async delete(v){}async rename(v,o,a){try{await i.Promises.rename(v.fsPath,o.fsPath)}catch(t){if(k.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${v} to ${o} with 'EPERM' error. Trying again...`),this.rename(v,o,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const v=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(v.children){const o=[],a=[];for(const n of v.children){const s=this.parse(n.name);s&&a.push([s,n])}const t=(0,b.groupByExtension)(a,([n])=>n),r=[];for(const n of t)n.sort((s,u)=>P.rcompare(s[0].version,u[0].version)),o.push(...n.slice(1).map(s=>s[1].resource)),r.push(n[0][1]);r.sort((n,s)=>n.mtime-s.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(n=>n.resource)),await D.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(v){this.logService.error(v)}}getName(v){return this.cache?new b.ExtensionIdentifierWithVersion(v.identifier,v.version).key().toLowerCase():(0,w.generateUuid)()}parse(v){const o=I.exec(v);return o&&o[1]&&o[2]?new b.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};g=he([X(0,E.INativeEnvironmentService),X(1,c.IFileService),X(2,h.IExtensionGalleryService),X(3,y.ILogService)],g),e.ExtensionsDownloader=g}),define(te[165],ne([0,1,41,6,37,3,2,17,8,18,12,14]),function(Y,e,D,L,R,k,A,P,m,w,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let h=class extends A.Disposable{constructor(c,y){super();this.environmentService=c,this.logService=y,this.processesLimiter=new L.Limiter(5)}async postUninstall(c){const y=this.parseScript(c,"uninstall");return y&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(y.script,"uninstall",y.args,!0,c).then(()=>this.logService.info(c.identifier.id,c.manifest.version,"Finished running post uninstall script"),I=>this.logService.error(c.identifier.id,c.manifest.version,`Failed to run post uninstall script: ${I}`)))),w.Promises.rm(this.getExtensionStoragePath(c)).then(void 0,I=>this.logService.error("Error while removing extension storage path",I))}parseScript(c,y){const I=`vscode:${y}`;if(c.location.scheme===P.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[I]=="string"){const g=c.manifest.scripts[I].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${I} should be a node script`),null):{script:(0,m.join)(c.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(c,y,I,g,C){return new Promise((v,o)=>{const a=this.start(c,y,I,C);let t;const r=n=>{t&&(clearTimeout(t),t=null),n?o(n):v(void 0)};a.on("error",n=>{r((0,R.toErrorMessage)(n)||"Unknown")}),a.on("exit",(n,s)=>{r(n?`post-${y} process exited with code ${n}`:void 0)}),g&&(t=setTimeout(()=>{t=null,a.kill(),o("timed out")},5e3))})}start(c,y,I,g){const C={silent:!0,execArgv:void 0},v=(0,D.fork)(c,[`--type=extension-post-${y}`,...I],C);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const o=k.Event.fromNodeEventEmitter(v.stdout,"data"),a=k.Event.fromNodeEventEmitter(v.stderr,"data");o(n=>this.logService.info(g.identifier.id,g.manifest.version,`post-${y}`,n)),a(n=>this.logService.error(g.identifier.id,g.manifest.version,`post-${y}`,n));const t=k.Event.any(k.Event.map(o,n=>({data:`%c${n}`,format:[""]})),k.Event.map(a,n=>({data:`%c${n}`,format:["color: red"]})));return k.Event.debounce(t,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(g.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),v}getExtensionStoragePath(c){return(0,m.join)(this.environmentService.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};h=he([X(0,i.IEnvironmentService),X(1,E.ILogService)],h),e.ExtensionsLifecycle=h}),define(te[166],ne([0,1,3,2,15,5,12,31,13,14]),function(Y,e,D,L,R,k,A,P,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let i=class extends L.Disposable{constructor(h,b,c,y){super();this.extensionsManagementService=h,this.logService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(C=>{this.installedExtensions=C.map(v=>v.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(C=>this.onInstallExtension(C))),this._register(h.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(h.onDidUninstallExtension(C=>this.onDidUninstallExtension(C)));const I=k.URI.file(c.extensionsPath),g=new R.ExtUri(C=>!b.hasCapability(C,1024));this._register(b.watch(I)),this._register(D.Event.filter(b.onDidChangeFilesRaw,C=>C.changes.some(v=>this.doesChangeAffects(v,I,g)))(()=>this.onDidChange()))}doesChangeAffects(h,b,c){return c.isEqual(c.dirname(h.resource),b)?c.isEqual(h.resource,c.joinPath(b,".obsolete"))?!0:!(h.type!==1&&h.type!==2||c.basename(h.resource).startsWith(".")):!1}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const b of h)this.removeInstallingExtension(b.identifier),b.local&&this.addInstalledExtension(b.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(b=>!(0,P.areSameExtensions)(b,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!(0,P.areSameExtensions)(b,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(1),b=h.filter(y=>[...this.installingExtensions,...this.installedExtensions].some(I=>(0,P.areSameExtensions)(I,y.identifier))?!1:y.installedTimestamp&&y.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",y.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",y.identifier.id),!1)),c=this.installedExtensions.filter(y=>this.installingExtensions.some(I=>(0,P.areSameExtensions)(I,y))?!1:h.every(I=>!(0,P.areSameExtensions)(I.identifier,y))?(this.logService.info("Detected extension removed from another source",y.id),!0):!1);this.installedExtensions=h.map(y=>y.identifier),(b.length||c.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:c})}}};i=he([X(1,m.IFileService),X(2,A.INativeEnvironmentService),X(3,w.ILogService)],i),e.ExtensionsWatcher=i}),define(te[167],ne([0,1,154,19,6,2,17,8,18,12,27,31,57,14]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let c=class extends k.Disposable{constructor(g,C,v){super();this.extensionManagementService=g,this.logService=v,this.cache=this._register(new y(C,v)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const g=await this.cache.getLanguagePacks(),C=["en",...Object.keys(g)];return(0,L.distinct)(C)}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const C=await this.cache.getLanguagePacks();Object.keys(C).some(v=>C[v]&&C[v].extensions.some(o=>(0,E.areSameExtensions)(o.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,C]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),v=await this.cache.update(C);return!(0,L.equals)(Object.keys(g),Object.keys(v))}};c=he([X(0,i.IExtensionManagementService),X(1,w.INativeEnvironmentService),X(2,b.ILogService)],c),e.LocalizationsService=c;let y=class extends k.Disposable{constructor(g,C){super();this.logService=C,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(C=>{Object.keys(C).forEach(v=>delete C[v]),this.createLanguagePacksFromExtensions(C,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...C){for(const v of C)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,v);Object.keys(g).forEach(v=>this.updateHash(g[v]))}createLanguagePacksFromExtension(g,C){const v=C.identifier,o=C.manifest.contributes&&C.manifest.contributes.localizations?C.manifest.contributes.localizations:[];for(const a of o)if(C.location.scheme===A.Schemas.file&&(0,h.isValidLocalization)(a)){let t=g[a.languageId];t||(t={hash:"",extensions:[],translations:{}},g[a.languageId]=t);let r=t.extensions.filter(n=>(0,E.areSameExtensions)(n.extensionIdentifier,v))[0];r?r.version=C.manifest.version:t.extensions.push({extensionIdentifier:v,version:C.manifest.version});for(const n of a.translations)t.translations[n.id]=(0,P.join)(C.location.fsPath,n.path)}}updateHash(g){if(g){const C=(0,D.createHash)("md5");for(const v of g.extensions)C.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);g.hash=C.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let C=null;return m.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch(o){return{}}}).then(v=>(C=g(v),v)).then(v=>{for(const a of Object.keys(v))v[a]||delete v[a];this.languagePacks=v,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),m.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>C,v=>this.logService.error(v))})}};y=he([X(0,w.INativeEnvironmentService),X(1,b.ILogService)],y)}),define(te[79],ne([0,1,3,5,14]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(h){this.service=h,this.onDidChangeLogLevel=D.Event.buffer(h.onDidChangeLogLevel,!0)}listen(h,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(h,b,c){switch(b){case"setLevel":return this.service.setLevel(c)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=k;class A{constructor(h){this.channel=h}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(h){A.setLevel(this.channel,h)}static setLevel(h,b){return h.call("setLevel",b)}}e.LogLevelChannelClient=A;class P{constructor(h){this.loggerService=h,this.loggers=new Map}listen(h,b){throw new Error(`Event not found: ${b}`)}async call(h,b,c){switch(b){case"createLogger":this.createLogger(L.URI.revive(c[0]),c[1]);return;case"log":return this.log(L.URI.revive(c[0]),c[1]);case"consoleLog":return this.consoleLog(c[0],c[1])}throw new Error(`Call not found: ${b}`)}createLogger(h,b){this.loggers.set(h.toString(),this.loggerService.createLogger(h,b))}consoleLog(h,b){let c=console.log;switch(h){case R.LogLevel.Error:c=console.error;break;case R.LogLevel.Warning:c=console.warn;break;case R.LogLevel.Info:c=console.info;break}c.call(console,...b)}log(h,b){const c=this.loggers.get(h.toString());if(!c)throw new Error("Create the logger before logging");for(const[y,I]of b)switch(y){case R.LogLevel.Trace:c.trace(I);break;case R.LogLevel.Debug:c.debug(I);break;case R.LogLevel.Info:c.info(I);break;case R.LogLevel.Warning:c.warn(I);break;case R.LogLevel.Error:c.error(I);break;case R.LogLevel.Critical:c.critical(I);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class m extends R.AbstractLoggerService{constructor(h,b,c){super(h,b);this.channel=c}createConsoleMainLogger(){return new R.AdapterLogger({log:(h,b)=>{this.channel.call("consoleLog",[h,b])}})}doCreateLogger(h,b,c){return new w(this.channel,h,b,c)}}e.LoggerChannelClient=m;class w extends R.AbstractMessageLogger{constructor(h,b,c,y){super(y?.always);this.channel=h,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.channel.call("createLogger",[b,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(h,b){const c=[[h,b]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(h){this.channel.call("log",[this.file,h])}}class i extends R.LogService{constructor(h,b){super(b);this.parent=h,this._register(h.onDidChangeLogLevel(c=>b.setLevel(c)))}setLevel(h){super.setLevel(h),this.parent.setLevel(h)}}e.FollowerLogService=i}),define(te[59],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(te[44],ne([0,1,17,4,34,15]),function(Y,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const P=L.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const P=(0,k.dirname)(D.FileAccess.asFileUri("",Y));A=Y.__$__nodeRequire((0,k.joinPath)(P,"product.json").fsPath);const m=Y.__$__nodeRequire((0,k.joinPath)(P,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:m.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.60.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A}),define(te[80],ne([0,1,25,11,123,13,44]),function(Y,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(E,h,b,c,y,I){let g;try{await m(E,h,b,c,y,I)}catch(C){g=C}finally{g&&y.errorTransformer&&(g=y.errorTransformer(g)),typeof g!="undefined"&&b.error(g),b.end()}}e.readFileIntoStream=P;async function m(E,h,b,c,y,I){w(I);const g=await E.open(h,{create:!1});try{w(I);let C=0,v=0,o=y&&typeof y.length=="number"?y.length:void 0,a=D.VSBuffer.alloc(Math.min(y.bufferSize,typeof o=="number"?o:y.bufferSize)),t=y&&typeof y.position=="number"?y.position:0,r=0;do v=await E.read(g,t,a.buffer,r,a.byteLength-r),t+=v,r+=v,C+=v,typeof o=="number"&&(o-=v),r===a.byteLength&&(await b.write(c(a)),a=D.VSBuffer.alloc(Math.min(y.bufferSize,typeof o=="number"?o:y.bufferSize)),r=0);while(v>0&&(typeof o!="number"||o>0)&&w(I)&&i(C,y));if(r>0){let n=r;typeof o=="number"&&(n=Math.min(r,o)),b.write(c(a.slice(0,n)))}}catch(C){throw(0,k.ensureFileSystemProviderError)(C)}finally{await E.close(g)}}function w(E){if(E.isCancellationRequested)throw(0,L.canceled)();return!0}function i(E,h){if(h?.limits){if(typeof h.limits.memory=="number"&&E>h.limits.memory)throw(0,k.createFileSystemProviderError)((0,R.localize)(0,null,A.default.nameShort),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof h.limits.size=="number"&&E>h.limits.size)throw(0,k.createFileSystemProviderError)((0,R.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[168],ne([0,1,19,6,25,29,3,55,2,40,17,169,15,49,121,13,80,14]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let C=class je extends m.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new A.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new y.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new y.FileChangesEvent(a,!0)))),this.watchedResources=w.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,a){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:a});const t=new m.DisposableStore;return t.add(a.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:o}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,m.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:a}),this.provider.delete(o),(0,m.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){a.push(t)}}),!this.provider.has(o)&&await L.Promises.settled(a)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,a){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return P.Iterable.map(this.provider,([o,a])=>({scheme:o,capabilities:a.capabilities}))}async withProvider(o){if(!(0,h.isAbsolutePath)(o))throw new y.FileOperationError((0,c.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const a=this.provider.get(o.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=(0,c.localize)(1,null,o.toString()),t}return a}async withReadProvider(o){const a=await this.withProvider(o);if((0,y.hasOpenReadWriteCloseCapability)(a)||(0,y.hasReadWriteCapability)(a)||(0,y.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const a=await this.withProvider(o);if((0,y.hasOpenReadWriteCloseCapability)(a)||(0,y.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,a){try{return await this.doResolveFile(o,a)}catch(t){throw(0,y.toFileSystemProviderErrorCode)(t)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,c.localize)(2,null,this.resourceForError(o)),1):(0,y.ensureFileSystemProviderError)(t)}}async doResolveFile(o,a){const t=await this.withProvider(o),r=this.isPathCaseSensitive(t),n=a?.resolveTo,s=a?.resolveSingleChildDescendants,u=a?.resolveMetadata,l=await t.stat(o);let f;return this.toFileStat(t,o,l,void 0,!!u,(d,S)=>{if(!f&&(f=w.TernarySearchTree.forUris(()=>!r),f.set(o,!0),n))for(const T of n)f.set(T,!0);return f.get(d.resource)||f.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&s?S===1:!1})}async toFileStat(o,a,t,r,n,s){const{providerExtUri:u}=this.getExtUri(o),l={resource:a,name:u.basename(a),isFile:(t.type&y.FileType.File)!=0,isDirectory:(t.type&y.FileType.Directory)!=0,isSymbolicLink:(t.type&y.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&y.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,y.etag)({mtime:t.mtime,size:t.size})};if(l.isDirectory&&s(l,r)){try{const f=await o.readdir(a),d=await L.Promises.settled(f.map(async([S,T])=>{try{const O=u.joinPath(a,S),p=n?await o.stat(O):{type:T};return await this.toFileStat(o,O,p,f.length,n,s)}catch(O){return this.logService.trace(O),null}}));l.children=(0,D.coalesce)(d)}catch(f){this.logService.trace(f),l.children=[]}return l}return l}async resolveAll(o){return L.Promises.settled(o.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const a=await this.withProvider(o);try{return!!await a.stat(o)}catch(t){return!1}}async canCreateFile(o,a){try{await this.doValidateCreateFile(o,a)}catch(t){return t}return!0}async doValidateCreateFile(o,a){if(!a?.overwrite&&await this.exists(o))throw new y.FileOperationError((0,c.localize)(3,null,this.resourceForError(o)),3,a)}async createFile(o,a=R.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const r=await this.writeFile(o,a);return this._onDidRunOperation.fire(new y.FileOperationEvent(o,0,r)),r}async writeFile(o,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(r);try{await this.validateWriteFile(r,o,t)||await this.mkdirp(r,n.dirname(o));let u;if((0,y.hasReadWriteCapability)(r)&&!(a instanceof R.VSBuffer))if((0,b.isReadableStream)(a)){const l=await(0,b.peekStream)(a,3);l.ended?u=R.VSBuffer.concat(l.buffer):u=l}else u=(0,b.peekReadable)(a,l=>R.VSBuffer.concat(l),3);else u=a;!(0,y.hasOpenReadWriteCloseCapability)(r)||(0,y.hasReadWriteCapability)(r)&&u instanceof R.VSBuffer?await this.doWriteUnbuffered(r,o,t,u):await this.doWriteBuffered(r,o,t,u instanceof R.VSBuffer?(0,R.bufferToReadable)(u):u)}catch(s){throw new y.FileOperationError((0,c.localize)(4,null,this.resourceForError(o),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,a,t){if(!!t?.unlock&&!(o.capabilities&8192))throw new Error((0,c.localize)(5,null,this.resourceForError(a)));let n;try{n=await o.stat(a)}catch(s){return}if((n.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,c.localize)(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,n),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==y.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==(0,y.etag)({mtime:t.mtime,size:n.size}))throw new y.FileOperationError((0,c.localize)(7,null),3,t);return n}async readFile(o,a){const t=await this.withReadProvider(o);return a?.atomic?this.doReadFileAtomic(t,o,a):this.doReadFile(t,o,a)}async doReadFileAtomic(o,a,t){return new Promise((r,n)=>{this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(o,a,t);r(s)}catch(s){n(s)}})})}async doReadFile(o,a,t){const r=await this.doReadFileStream(o,a,{...t,preferUnbuffered:!0});return{...r,value:await(0,R.streamToBuffer)(r.value)}}async readFileStream(o,a){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,a)}async doReadFileStream(o,a,t){const r=new k.CancellationTokenSource,n=this.validateReadFile(a,t).then(u=>u,u=>{throw r.cancel(),u});let s;try{return typeof t?.etag=="string"&&t.etag!==y.ETAG_DISABLED&&await n,!((0,y.hasOpenReadWriteCloseCapability)(o)||(0,y.hasFileReadStreamCapability)(o))||(0,y.hasReadWriteCapability)(o)&&t?.preferUnbuffered?s=this.readFileUnbuffered(o,a,t):(0,y.hasFileReadStreamCapability)(o)?s=this.readFileStreamed(o,a,r.token,t):s=this.readFileBuffered(o,a,r.token,t),{...await n,value:s}}catch(u){s&&await(0,b.consumeStream)(s);const l=(0,c.localize)(8,null,this.resourceForError(a),(0,y.ensureFileSystemProviderError)(u).toString());throw u instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(l,u.stat,t):new y.FileOperationError(l,(0,y.toFileOperationResult)(u),t)}}readFileStreamed(o,a,t,r=Object.create(null)){const n=o.readFileStream(a,r,t);return(0,b.transform)(n,{data:s=>s instanceof R.VSBuffer?s:R.VSBuffer.wrap(s),error:s=>new y.FileOperationError((0,c.localize)(9,null,this.resourceForError(a),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),r)},s=>R.VSBuffer.concat(s))}readFileBuffered(o,a,t,r=Object.create(null)){const n=(0,R.newWriteableBufferStream)();return(0,I.readFileIntoStream)(o,a,n,s=>s,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new y.FileOperationError((0,c.localize)(10,null,this.resourceForError(a),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),r)},t),n}readFileUnbuffered(o,a,t){const r=(0,b.newWriteableStream)(n=>R.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(a);typeof t?.position=="number"&&(n=n.slice(t.position)),typeof t?.length=="number"&&(n=n.slice(0,t.length)),this.validateReadFileLimits(a,n.byteLength,t),r.end(R.VSBuffer.wrap(n))}catch(n){r.error(n),r.end()}})(),r}async validateReadFile(o,a){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new y.FileOperationError((0,c.localize)(11,null,this.resourceForError(o)),0,a);if(typeof a?.etag=="string"&&a.etag!==y.ETAG_DISABLED&&a.etag===t.etag)throw new y.NotModifiedSinceFileOperationError((0,c.localize)(12,null),t,a);return this.validateReadFileLimits(o,t.size,a),t}validateReadFileLimits(o,a,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&a>t.limits.size&&(r=7),typeof r=="number")throw new y.FileOperationError((0,c.localize)(13,null,this.resourceForError(o)),r)}}async canMove(o,a,t){return this.doCanMoveCopy(o,a,"move",t)}async canCopy(o,a,t){return this.doCanMoveCopy(o,a,"copy",t)}async doCanMoveCopy(o,a,t,r){if(o.toString()!==a.toString())try{const n=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(n,o,s,a,t,r)}catch(n){return n}return!0}async move(o,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,o,n,a,"move",!!t),u=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(o,s==="move"?2:3,u)),u}async copy(o,a,t){const r=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(r,o,n,a,"copy",!!t),u=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(o,s==="copy"?3:2,u)),u}async doMoveCopy(o,a,t,r,n,s){if(a.toString()===r.toString())return n;const{exists:u,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(o,a,t,r,n,s);if(u&&!l&&s&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),n==="copy"){if(o===t&&(0,y.hasFileFolderCopyCapability)(o))await o.copy(a,r,{overwrite:s});else{const f=await this.resolve(a);f.isDirectory?await this.doCopyFolder(o,f,t,r):await this.doCopyFile(o,a,t,r)}return n}else return o===t?(await o.rename(a,r,{overwrite:s}),n):(await this.doMoveCopy(o,a,t,r,"copy",s),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(o,a,t,r){if((0,y.hasOpenReadWriteCloseCapability)(o)&&(0,y.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,a,t,r);if((0,y.hasOpenReadWriteCloseCapability)(o)&&(0,y.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,a,t,r);if((0,y.hasReadWriteCapability)(o)&&(0,y.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,a,t,r);if((0,y.hasReadWriteCapability)(o)&&(0,y.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,a,t,r)}async doCopyFolder(o,a,t,r){await t.mkdir(r),Array.isArray(a.children)&&await L.Promises.settled(a.children.map(async n=>{const s=this.getExtUri(t).providerExtUri.joinPath(r,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),t,s):this.doCopyFile(o,n.resource,t,s)}))}async doValidateMoveCopy(o,a,t,r,n,s){let u=!1;if(o===t){const{providerExtUri:f,isPathCaseSensitive:d}=this.getExtUri(o);if(d||(u=f.isEqual(a,r)),u&&n==="copy")throw new Error((0,c.localize)(14,null,this.resourceForError(a),this.resourceForError(r)));if(!u&&f.isEqualOrParent(r,a))throw new Error((0,c.localize)(15,null,this.resourceForError(a),this.resourceForError(r)))}const l=await this.exists(r);if(l&&!u){if(!s)throw new y.FileOperationError((0,c.localize)(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(o===t){const{providerExtUri:f}=this.getExtUri(o);if(f.isEqualOrParent(a,r))throw new Error((0,c.localize)(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:l,isSameResourceWithDifferentPathCase:u}}getExtUri(o){const a=this.isPathCaseSensitive(o);return{providerExtUri:a?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(a,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(o,0,t)),t}async mkdirp(o,a){const t=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(a,r.dirname(a));)try{if(((await o.stat(a)).type&y.FileType.Directory)==0)throw new Error((0,c.localize)(18,null,this.resourceForError(a)));break}catch(n){if((0,y.toFileSystemProviderErrorCode)(n)!==y.FileSystemProviderErrorCode.FileNotFound)throw n;t.push(r.basename(a)),a=r.dirname(a)}for(let n=t.length-1;n>=0;n--){a=r.joinPath(a,t[n]);try{await o.mkdir(a)}catch(s){if((0,y.toFileSystemProviderErrorCode)(s)!==y.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,a){try{await this.doValidateDelete(o,a)}catch(t){return t}return!0}async doValidateDelete(o,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error((0,c.localize)(19,null,this.resourceForError(o)));let n;try{n=await t.stat(o)}catch(u){}if(n)this.throwIfFileIsReadonly(o,n);else throw new y.FileOperationError((0,c.localize)(20,null,this.resourceForError(o)),1);if(!!!a?.recursive){const u=await this.resolve(o);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error((0,c.localize)(21,null,this.resourceForError(o)))}return t}async del(o,a){const t=await this.doValidateDelete(o,a),r=!!a?.useTrash,n=!!a?.recursive;await t.delete(o,{recursive:n,useTrash:r}),this._onDidRunOperation.fire(new y.FileOperationEvent(o,1))}onDidChangeFile(o,a){this._onDidChangeFilesRaw.fire({changes:o});let t,r;{for(const n of o)this.watchedResources.has(n.resource)?(t||(t=[]),t.push(n)):(r||(r=[]),r.push(n));t&&this._onDidFilesChange.fire(new y.FileChangesEvent(t,!a))}if(r){const n=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(r)&&je.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,a={recursive:!1,excludes:[]}){const t=new m.DisposableStore;{let r=!1,n=()=>{r=!0};t.add((0,m.toDisposable)(()=>n())),this.doWatch(o,a).then(s=>{r?(0,m.dispose)(s):n=()=>(0,m.dispose)(s)},s=>this.logService.error(s))}return a.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),t.add((0,m.toDisposable)(()=>{const r=this.watchedResources.get(o);typeof r=="number"&&(r<=1?this.watchedResources.delete(o):this.watchedResources.set(o,r-1))}))),t}async doWatch(o,a){const t=await this.withProvider(o),r=this.toWatchKey(t,o,a),n=this.activeWatchers.get(r)||{count:0,disposable:t.watch(o,a)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,n),n.count+=1,(0,m.toDisposable)(()=>{n.count--,n.count===0&&((0,m.dispose)(n.disposable),this.activeWatchers.delete(r))})}toWatchKey(o,a,t){const{providerExtUri:r}=this.getExtUri(o);return[r.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,m.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,b.isReadableStream)(r)||(0,b.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(o,n,r):await this.doWriteReadableBufferedQueued(o,n,r)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,a,t){let r=0,n;if((0,b.isReadableBufferedStream)(t)){if(t.buffer.length>0){const s=R.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,a,s,s.byteLength,r,0),r+=s.byteLength}if(t.ended)return;n=t.stream}else n=t;return new Promise(async(s,u)=>{(0,b.listenStream)(n,{onData:async l=>{n.pause();try{await this.doWriteBuffer(o,a,l,l.byteLength,r,0)}catch(f){return u(f)}r+=l.byteLength,setTimeout(()=>n.resume())},onError:l=>u(l),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,a,t){let r=0,n;for(;(n=t.read())!==null;)await this.doWriteBuffer(o,a,n,n.byteLength,r,0),r+=n.byteLength}async doWriteBuffer(o,a,t,r,n,s){let u=0;for(;u<r;)u+=await o.write(a,n+u,t.buffer,s+u,r-u)}async doWriteUnbuffered(o,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,a,t,r))}async doWriteUnbufferedQueued(o,a,t,r){let n;r instanceof R.VSBuffer?n=r:(0,b.isReadableStream)(r)?n=await(0,R.streamToBuffer)(r):(0,b.isReadableBufferedStream)(r)?n=await(0,R.bufferedStreamToBuffer)(r):n=(0,R.readableToBuffer)(r),await o.writeFile(a,n.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,a,t,r))}async doPipeBufferedQueued(o,a,t,r){let n,s;try{n=await o.open(a,{create:!1}),s=await t.open(r,{create:!0,unlock:!1});const u=R.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,f=0,d=0;do d=await o.read(n,l,u.buffer,f,u.byteLength-f),await this.doWriteBuffer(t,s,u,d,l,f),l+=d,f+=d,f===u.byteLength&&(f=0);while(d>0)}catch(u){throw(0,y.ensureFileSystemProviderError)(u)}finally{await L.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof s=="number"?t.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,a,t,r))}async doPipeUnbufferedQueued(o,a,t,r){return t.writeFile(r,await o.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,a,t,r))}async doPipeUnbufferedToBufferedQueued(o,a,t,r){const n=await t.open(r,{create:!0,unlock:!1});try{const s=await o.readFile(a);await this.doWriteBuffer(t,n,R.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await t.close(n)}}async doPipeBufferedToUnbuffered(o,a,t,r){const n=await(0,R.streamToBuffer)(this.readFileBuffered(o,a,k.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,n)}throwIfFileSystemIsReadonly(o,a){if(o.capabilities&2048)throw new y.FileOperationError((0,c.localize)(22,null,this.resourceForError(a)),6);return o}throwIfFileIsReadonly(o,a){if((a.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,c.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===i.Schemas.file?o.fsPath:o.toString(!0)}};C.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},C=he([X(0,g.ILogService)],C),e.FileService=C}),define(te[170],ne([0,1,19,6,25,3,39,2,8,4,15,49,18,124,13,80,157,143,144,77,146,14]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y,I,g,C,v,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends P.Disposable{constructor(n,s){super();this.logService=n,this.options=s,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=k.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:u}=await h.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,u),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(n){try{const s=await h.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),u=[];return await Promise.all(s.map(async l=>{try{let f;l.isSymbolicLink()?f=(await this.stat((0,i.joinPath)(n,l.name))).type:f=this.toType(l),u.push([l.name,f])}catch(f){this.logService.trace(f)}})),u}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let u;return s?.dangling?u=c.FileType.Unknown:n.isFile()?u=c.FileType.File:n.isDirectory()?u=c.FileType.Directory:u=c.FileType.Unknown,s&&(u|=c.FileType.SymbolicLink),u}async readFile(n){try{const s=this.toFilePath(n);return await h.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(n,s,u){const l=(0,E.newWriteableStream)(f=>R.VSBuffer.concat(f.map(d=>R.VSBuffer.wrap(d))).buffer);return(0,y.readFileIntoStream)(this,n,l,f=>f.buffer,{...s,bufferSize:this.BUFFER_SIZE},u),l}async writeFile(n,s,u){let l;try{const f=this.toFilePath(n);if(!u.create||!u.overwrite){if(await h.Promises.exists(f)){if(!u.overwrite)throw(0,c.createFileSystemProviderError)((0,b.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,c.createFileSystemProviderError)((0,b.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(n,{create:!0,unlock:u.unlock}),await this.write(l,0,s,0,s.byteLength)}catch(f){throw await this.toFileSystemProviderWriteError(n,f)}finally{typeof l=="number"&&await this.close(l)}}async open(n,s){try{const u=this.toFilePath(n);if((0,c.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:d}=await h.SymlinkSupport.stat(u);d.mode&128||await h.Promises.chmod(u,d.mode|128)}catch(d){this.logService.trace(d)}let l;if((0,c.isFileOpenForWriteOptions)(s)){if(w.isWindows)try{await h.Promises.truncate(u,0),l="r+"}catch(d){d.code!=="ENOENT"&&this.logService.trace(d)}l||(l="w")}else l="r";const f=await h.Promises.open(u,l);return this.mapHandleToPos.set(f,0),(0,c.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(f,n),f}catch(u){throw(0,c.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(n,u):this.toFileSystemProviderError(u)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await h.Promises.fdatasync(n)}catch(s){this.canFlush=!1,this.logService.error(s)}return await h.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}}async read(n,s,u,l,f){const d=this.normalizePos(n,s);let S=null;try{const T=await h.Promises.read(n,u,l,f,d);return typeof T=="number"?S=T:S=T.bytesRead,S}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(n,d,S)}}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,u){const l=this.mapHandleToPos.get(n);typeof l=="number"&&(typeof s=="number"||(typeof u=="number"?this.mapHandleToPos.set(n,l+u):this.mapHandleToPos.delete(n)))}async write(n,s,u,l,f){return(0,L.retry)(()=>this.doWrite(n,s,u,l,f),100,3)}async doWrite(n,s,u,l,f){const d=this.normalizePos(n,s);let S=null;try{const T=await h.Promises.write(n,u,l,f,d);return typeof T=="number"?S=T:S=T.bytesWritten,S}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),T)}finally{this.updatePos(n,d,S)}}async mkdir(n){try{await h.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const u=this.toFilePath(n);await this.doDelete(u,s)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(n,s){s.recursive?await h.Promises.rm(n,h.RimRafMode.MOVE):await h.Promises.unlink(n)}async rename(n,s,u){const l=this.toFilePath(n),f=this.toFilePath(s);if(l!==f)try{await this.validateTargetDeleted(n,s,"move",u.overwrite),await h.Promises.move(l,f)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,b.localize)(2,null,(0,m.basename)(l),(0,m.basename)((0,m.dirname)(f)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(n,s,u){const l=this.toFilePath(n),f=this.toFilePath(s);if(l!==f)try{await this.validateTargetDeleted(n,s,"copy",u.overwrite),await h.Promises.copy(l,f,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,b.localize)(3,null,(0,m.basename)(l),(0,m.basename)((0,m.dirname)(f)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(n,s,u,l){const f=this.toFilePath(n),d=this.toFilePath(s);let S=!1;if(!!(this.capabilities&1024)||(S=(0,A.isEqual)(f,d,!0)),S&&u==="copy")throw(0,c.createFileSystemProviderError)((0,b.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(!S&&await h.Promises.exists(d)){if(!l)throw(0,c.createFileSystemProviderError)((0,b.localize)(5,null),c.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(n,s){return s.recursive?this.watchRecursive(n,s.excludes):this.watchNonRecursive(n)}watchRecursive(n,s){const u={path:this.toFilePath(n),excludes:s},l=(0,D.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{l(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof g.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,s;this.options?.watcher?.usePolling?(n=C.FileWatcher,s=this.options?.watcher):this.recursiveFoldersToWatch.length===1?w.isWindows?n=o.FileWatcher:n=C.FileWatcher:n=g.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire((0,v.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===a.LogLevel.Trace,s),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)}))}}watchNonRecursive(n){const s=new I.FileWatcher(this.toFilePath(n),l=>this._onDidChangeFile.fire((0,v.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===a.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===a.LogLevel.Trace)});return(0,P.combinedDisposable)(s,u)}toFilePath(n){return(0,m.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof c.FileSystemProviderError)return n;let s;switch(n.code){case"ENOENT":s=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=c.FileSystemProviderErrorCode.NoPermissions;break;default:s=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(n,s)}async toFileSystemProviderWriteError(n,s){let u=this.toFileSystemProviderError(s);if(n&&u.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await h.SymlinkSupport.stat(this.toFilePath(n));l.mode&128||(u=(0,c.createFileSystemProviderError)(s,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return u}dispose(){super.dispose(),(0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,P.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(te[28],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService")}),define(te[171],ne([0,1,6,11,2,8,18,14,28]),function(Y,e,D,L,R,k,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let w=class extends R.Disposable{constructor(E,h,b){super();this.productService=h,this.logService=b,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},30*1e3)).schedule()}async cleanUpCodeCaches(E){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const h=Date.now(),b=(0,k.dirname)(E),c=(0,k.basename)(E),y=await A.Promises.readdir(b);await Promise.all(y.map(async I=>{if(I===c)return;const g=(0,k.join)(b,I),C=await A.Promises.stat(g);if(C.isDirectory()&&h-C.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${I}.`),A.Promises.rm(g)}))}catch(h){(0,L.onUnexpectedError)(h)}}};w=he([X(1,m.IProductService),X(2,P.ILogService)],w),e.CodeCacheCleaner=w}),define(te[172],ne([0,1,6,11,2,8,18,12,14,28]),function(Y,e,D,L,R,k,A,P,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let i=class extends R.Disposable{constructor(h,b,c){super();this.environmentService=h,this.logService=b,this.productService=c,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const h=Object.create(null),b=JSON.parse(await A.Promises.readFile((0,k.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let C of Object.keys(b)){const v=b[C];h[`${v.hash}.${C}`]=!0}const c=(0,k.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(c))return;const I=await A.Promises.readdir(c);for(const C of I){if(h[C]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${C}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${C}`),await A.Promises.rm((0,k.join)(c,C))}const g=Date.now();for(const C of Object.keys(h)){const v=(0,k.join)(c,C),o=await A.Promises.readdir(v);for(const a of o){if(a==="tcf.json")continue;const t=(0,k.join)(v,a),r=await A.Promises.stat(t);r.isDirectory()&&g-r.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,k.join)(C,a)}`),await A.Promises.rm(t))}}}catch(h){(0,L.onUnexpectedError)(h)}}};i=he([X(0,P.INativeEnvironmentService),X(1,m.ILogService),X(2,w.IProductService)],i),e.LanguagePackCachedDataCleaner=i}),define(te[32],ne([0,1,90,16]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(A,P){D.ok(L.isString(A)),D.ok(L.isObject(P)),D.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new R}),define(te[81],ne([0,1,3,32]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class k{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,w){this.schemasById[R(m)]=w,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new k;L.Registry.add(e.Extensions.JSONContribution,A)}),define(te[38],ne([0,1,3,16,111,81,32]),function(Y,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=A.Registry.as(k.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(C,v=!0){this.registerConfigurations([C],v)}registerConfigurations(C,v=!0){const o=[];C.forEach(a=>{o.push(...this.validateAndRegisterProperties(a,v,a.extensionInfo)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(C){const v=[],o=a=>{if(a.properties)for(const t in a.properties)v.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,a.properties[t]);a.allOf&&a.allOf.forEach(t=>o(t))};for(const a of C){o(a);const t=this.configurationContributors.indexOf(a);t!==-1&&this.configurationContributors.splice(t,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}registerDefaultConfigurations(C){const v=[],o=[];for(const a of C)for(const t in a)if(v.push(t),e.OVERRIDE_PROPERTY_PATTERN.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...a[t]};const r={type:"object",default:this.defaultValues[t],description:R.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};o.push(h(t)),this.configurationProperties[t]=r,this.defaultLanguageConfigurationOverridesNode.properties[t]=r}else{this.defaultValues[t]=a[t];const r=this.configurationProperties[t];r&&(this.updatePropertyDefaultValue(t,r),this.updateSchema(t,r))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterDefaultConfigurations(C){const v=[];for(const o of C)for(const a in o)if(v.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}notifyConfigurationSchemaUpdated(...C){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(C){for(const v of C)this.overrideIdentifiers.add(v);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(C,v=!0,o,a=3){a=L.isUndefinedOrNull(C.scope)?a:C.scope;let t=[],r=C.properties;if(r)for(let s in r){if(v&&y(s)){delete r[s];continue}const u=r[s];if(this.updatePropertyDefaultValue(s,u),e.OVERRIDE_PROPERTY_PATTERN.test(s)?u.scope=void 0:(u.scope=L.isUndefinedOrNull(u.scope)?a:u.scope,u.restricted=L.isUndefinedOrNull(u.restricted)?!!o?.restrictedConfigurations?.includes(s):u.restricted),r[s].hasOwnProperty("included")&&!r[s].included){this.excludedConfigurationProperties[s]=r[s],delete r[s];continue}else this.configurationProperties[s]=r[s];!r[s].deprecationMessage&&r[s].markdownDeprecationMessage&&(r[s].deprecationMessage=r[s].markdownDeprecationMessage),t.push(s)}let n=C.allOf;if(n)for(let s of n)t.push(...this.validateAndRegisterProperties(s,v,o,a));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(C){const v=o=>{let a=o.properties;if(a)for(const r in a)this.updateSchema(r,a[r]);let t=o.allOf;t&&t.forEach(v)};v(C)}updateSchema(C,v){switch(e.allSettings.properties[C]=v,v.scope){case 1:e.applicationSettings.properties[C]=v;break;case 2:e.machineSettings.properties[C]=v;break;case 6:e.machineOverridableSettings.properties[C]=v;break;case 3:e.windowSettings.properties[C]=v;break;case 4:e.resourceSettings.properties[C]=v;break;case 5:e.resourceSettings.properties[C]=v,this.resourceLanguageSettingsSchema.properties[C]=v;break}}removeFromSchema(C,v){switch(delete e.allSettings.properties[C],v.scope){case 1:delete e.applicationSettings.properties[C];break;case 2:delete e.machineSettings.properties[C];break;case 6:delete e.machineOverridableSettings.properties[C];break;case 3:delete e.windowSettings.properties[C];break;case 4:case 5:delete e.resourceSettings.properties[C];break}}updateOverridePropertyPatternKey(){for(const C of this.overrideIdentifiers.values()){const v=`[${C}]`,o={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(v,o),e.allSettings.properties[v]=o,e.applicationSettings.properties[v]=o,e.machineSettings.properties[v]=o,e.machineOverridableSettings.properties[v]=o,e.windowSettings.properties[v]=o,e.resourceSettings.properties[v]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(C,v){let o=this.defaultValues[C];L.isUndefined(o)&&(o=v.default),L.isUndefined(o)&&(o=b(v.type)),v.default=o}}const E="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(E);function h(g){return g.substring(1,g.length-1)}e.overrideIdentifierFromKey=h;function b(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=b;const c=new i;A.Registry.add(e.Extensions.Configuration,c);function y(g){return g.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(g)?R.localize(5,null,g):c.getConfigurationProperties()[g]!==void 0?R.localize(6,null,g):null:R.localize(4,null)}e.validateProperty=y;function I(){const g=[],C=c.getConfigurationProperties();for(const v of Object.keys(C))g.push([v,C[v].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=I}),define(te[24],ne([0,1,26,16,5,38,7,32]),function(Y,e,D,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function m(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof R.URI)}e.isConfigurationOverrides=m;var w;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function E(r,n){const s=n?r?n.keys.filter(O=>r.keys.indexOf(O)===-1):[...n.keys]:[],u=r?n?r.keys.filter(O=>n.keys.indexOf(O)===-1):[...r.keys]:[],l=[];if(n&&r){for(const O of r.keys)if(n.keys.indexOf(O)!==-1){const p=g(r.contents,O),F=g(n.contents,O);D.equals(p,F)||l.push(O)}}const f=[],d=O=>{const p={};for(const F of O)for(const M of F.identifiers)p[a(M)]=F;return p},S=n?d(n.overrides):{},T=r?d(r.overrides):{};if(Object.keys(S).length)for(const O of s){const p=S[O];p&&f.push([(0,k.overrideIdentifierFromKey)(O),p.keys])}if(Object.keys(T).length)for(const O of u){const p=T[O];p&&f.push([(0,k.overrideIdentifierFromKey)(O),p.keys])}if(Object.keys(S).length&&Object.keys(T).length)for(const O of l){const p=T[O],F=S[O];if(p&&F){const M=E({contents:p.contents,keys:p.keys,overrides:[]},{contents:F.contents,keys:F.keys,overrides:[]});f.push([(0,k.overrideIdentifierFromKey)(O),[...M.added,...M.removed,...M.updated]])}}return{added:s,removed:u,updated:l,overrides:f}}e.compare=E;function h(r,n){const s=[];for(const u of Object.keys(r))if(k.OVERRIDE_PROPERTY_PATTERN.test(u)){const l={};for(const f in r[u])l[f]=r[u][f];s.push({identifiers:[(0,k.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(l),contents:b(l,n)})}return s}e.toOverrides=h;function b(r,n){const s=Object.create(null);for(let u in r)c(s,u,r[u],n);return s}e.toValuesTree=b;function c(r,n,s,u){const l=n.split("."),f=l.pop();let d=r;for(let S=0;S<l.length;S++){let T=l[S],O=d[T];switch(typeof O){case"undefined":O=d[T]=Object.create(null);break;case"object":break;default:u(`Ignoring ${n} as ${l.slice(0,S+1).join(".")} is ${JSON.stringify(O)}`);return}d=O}if(typeof d=="object"&&d!==null)try{d[f]=s}catch(S){u(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}else u(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=c;function y(r,n){const s=n.split(".");I(r,s)}e.removeFromValueTree=y;function I(r,n){const s=n.shift();if(n.length===0){delete r[s];return}if(Object.keys(r).indexOf(s)!==-1){const u=r[s];typeof u=="object"&&!Array.isArray(u)&&(I(u,n),Object.keys(u).length===0&&delete r[s])}}function g(r,n,s){function u(d,S){let T=d;for(const O of S){if(typeof T!="object"||T===null)return;T=T[O]}return T}const l=n.split("."),f=u(r,l);return typeof f=="undefined"?s:f}e.getConfigurationValue=g;function C(r,n,s){Object.keys(n).forEach(u=>{u!=="__proto__"&&(u in r?L.isObject(r[u])&&L.isObject(n[u])?C(r[u],n[u],s):s&&(r[u]=n[u]):r[u]=n[u])})}e.merge=C;function v(){const r=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=v;function o(){const r=Object.create(null),n=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let s in n){let u=n[s].default;c(r,s,u,l=>console.error(`Conflict in default settings: ${l}`))}return r}e.getDefaultValues=o;function a(r){return`[${r}]`}e.keyFromOverrideIdentifier=a;function t(r,n,s){const u=r.inspect(n),l=r.inspect(s);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:u.defaultValue}e.getMigratedSettingValue=t}),define(te[173],ne([0,1,19,3,33,2,40,26,16,5,24,38,32]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(t={},r=[],n=[]){this._contents=t,this._keys=r,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const n=this.getContentsForOverrideIdentifer(r);return n?t?(0,i.getConfigurationValue)(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let n={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(r)])){let u=this.contents[s],l=r[s];l&&(typeof u=="object"&&typeof l=="object"?(u=P.deepClone(u),this.mergeContents(u,l)):u=l),n[s]=u}return new b(n,this.keys,this.overrides)}merge(...t){const r=P.deepClone(this.contents),n=P.deepClone(this.overrides),s=[...this.keys];for(const u of t){this.mergeContents(r,u.contents);for(const l of u.overrides){const[f]=n.filter(d=>D.equals(d.identifiers,l.identifiers));f?this.mergeContents(f.contents,l.contents):n.push(P.deepClone(l))}for(const l of u.keys)s.indexOf(l)===-1&&s.push(l)}return new b(r,s,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const n of Object.keys(r)){if(n in t&&m.isObject(t[n])&&m.isObject(r[n])){this.mergeContents(t[n],r[n]);continue}t[n]=P.deepClone(r[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?P.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,i.addToValueTree)(this.contents,t,r,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let n=0;n<r;n++)t.indexOf(this.keys[n])===0&&(r=n);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=b;class c extends b{constructor(){const t=(0,i.getDefaultValues)(),r=(0,i.getConfigurationKeys)(),n=[];for(const s of Object.keys(t))E.OVERRIDE_PROPERTY_PATTERN.test(s)&&n.push({identifiers:[(0,E.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,i.toValuesTree)(t[s],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,r,n)}}e.DefaultConfigurationModel=c;class y{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!m.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:n,keys:s,overrides:u,restricted:l}=this.doParseRaw(t,r);this._configurationModel=new b(n,s,u),this._restrictedConfigurations=l||[]}doParseContent(t){let r={},n=null,s=[],u=[],l=[];function f(S){Array.isArray(s)?s.push(S):n!==null&&(s[n]=S)}let d={onObjectBegin:()=>{let S={};f(S),u.push(s),s=S,n=null},onObjectProperty:S=>{n=S},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{let S=[];f(S),u.push(s),s=S,n=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:f,onError:(S,T,O)=>{l.push({error:S,offset:T,length:O})}};if(t)try{R.visit(t,d),r=s[0]||{}}catch(S){console.error(`Error while parsing settings file ${this._name}: ${S}`),this._parseErrors=[S]}return r}doParseRaw(t,r){const n=h.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,n,!0,r);t=s.raw;const u=(0,i.toValuesTree)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),l=Object.keys(t),f=(0,i.toOverrides)(t,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:u,keys:l,overrides:f,restricted:s.restricted}}filter(t,r,n,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:t,restricted:[]};const u={},l=[];for(let f in t)if(E.OVERRIDE_PROPERTY_PATTERN.test(f)&&n){const d=this.filter(t[f],r,!1,s);u[f]=d.raw,l.push(...d.restricted)}else{const d=r[f],S=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&l.push(f),(S===void 0||s.scopes===void 0||s.scopes.includes(S))&&(s.skipRestricted&&d?.restricted||(u[f]=t[f]))}return{raw:u,restricted:l}}}e.ConfigurationModelParser=y;class I extends k.Disposable{constructor(t,r,n,s){super();this.userSettingsResource=t,this.scopes=r,this.fileService=s,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=I;class g{constructor(t,r,n=new b,s=new b,u=new A.ResourceMap,l=new b,f=new A.ResourceMap,d=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=l,this._memoryConfigurationByResource=f,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,r,n){return this.getConsolidateConfigurationModel(r,n).getValue(t)}updateValue(t,r,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new b,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,r===void 0?s.removeValue(t):s.setValue(t,r),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,n){const s=this.getConsolidateConfigurationModel(r,n),u=this.getFolderConfigurationModelForResource(r.resource,n),l=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,f=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),d=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),S=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),T=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),O=n?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,p=u?r.overrideIdentifier?u.freeze().override(r.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,F=r.overrideIdentifier?l.override(r.overrideIdentifier).getValue(t):l.getValue(t),M=s.getValue(t),W=D.distinct(D.flatten(s.overrides.map(j=>j.identifiers))).filter(j=>s.getOverrideValue(t,j)!==void 0);return{defaultValue:f,userValue:d,userLocalValue:S,userRemoteValue:T,workspaceValue:O,workspaceFolderValue:p,memoryValue:F,value:M,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:S!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:T!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:p!==void 0?{value:u?.freeze().getValue(t),override:r.overrideIdentifier?u?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:l.getValue(t),override:r.overrideIdentifier?l.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const n=r.filter(s=>E.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const u=(0,E.overrideIdentifierFromKey)(s),l=this._defaultConfiguration.getKeysForOverrideIdentifier(u),f=t.getKeysForOverrideIdentifier(u),d=[...f.filter(S=>l.indexOf(S)===-1),...l.filter(S=>f.indexOf(S)===-1),...l.filter(S=>!P.equals(this._defaultConfiguration.override(u).getValue(S),t.override(u).getValue(S)))];return[u,d]});return this.updateDefaultConfiguration(t),{keys:r,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:n,removed:s,overrides:u}=(0,i.compare)(this.localUserConfiguration,t),l=[...r,...n,...s];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:n,removed:s,overrides:u}=(0,i.compare)(this.remoteUserConfiguration,t);let l=[...r,...n,...s];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:n,removed:s,overrides:u}=(0,i.compare)(this.workspaceConfiguration,t);let l=[...r,...n,...s];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:u}}compareAndUpdateFolderConfiguration(t,r){const n=this.folderConfigurations.get(t),{added:s,updated:u,removed:l,overrides:f}=(0,i.compare)(n,r);let d=[...s,...u,...l];return(d.length||!n)&&this.updateFolderConfiguration(t,r),{keys:d,overrides:f}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:s,removed:u,overrides:l}=(0,i.compare)(r,void 0);return{keys:[...n,...s,...u],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let n=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},r){let n=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const s=r.getFolder(t);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const u=this._memoryConfigurationByResource.get(t);u&&(n=n.merge(u))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(r=n.merge(s),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=n}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const n=r.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:n,overrides:s,keys:u}=this._folderConfigurations.get(r);return t.push([r,{contents:n,overrides:s,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((l,f)=>(l.set(w.URI.revive(f[0]),this.parseConfigurationModel(f[1])),l),new A.ResourceMap);return new g(r,n,new b,s,u,new b,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new b(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=g;function C(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,r=new Map;for(const s of a)s.keys.forEach(u=>t.add(u)),s.overrides.forEach(([u,l])=>{const f=(0,A.getOrSet)(r,u,new Set);l.forEach(d=>f.add(d))});const n=[];return r.forEach((s,u)=>n.push([u,[...s.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=C;class v{constructor(t,r,n,s){this.change=t,this.previous=r,this.currentConfiguraiton=n,this.currentWorkspace=s,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(f=>u.add(f)),t.overrides.forEach(([,f])=>f.forEach(d=>u.add(d))),this.affectedKeys=[...u.values()];const l=new b;this.affectedKeys.forEach(f=>l.setValue(f,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!P.equals(n,s)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let n=(0,i.toValuesTree)({[r]:!0},()=>{}),s;for(;typeof n=="object"&&(s=Object.keys(n)[0]);){if(t=t[s],!t)return!1;n=n[s]}return!0}}e.ConfigurationChangeEvent=v;class o extends v{constructor(t,r,n,s){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=n,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=o}),define(te[174],ne([0,1,6,3,2,15,24,173,38,32]),function(Y,e,D,L,R,k,A,P,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends R.Disposable{constructor(h,b){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,b)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(c=>this.onDidDefaultConfigurationChange(c))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const h=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(h,b){const c=typeof h=="string"?h:void 0,y=(0,A.isConfigurationOverrides)(h)?h:(0,A.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(c,y,void 0)}updateValue(h,b,c,y){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const b=this.configuration.toData(),c=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(c,b,1)}onDidDefaultConfigurationChange(h){const b=this.configuration.toData(),c=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,h);this.trigger(c,b,6)}trigger(h,b,c){const y=new P.ConfigurationChangeEvent(h,{data:b},this.configuration);y.source=c,y.sourceConfig=this.getTargetConfiguration(c),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(h){switch(h){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(te[175],ne([0,1,105,24,14]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(P,m){this.configurationService=P,this.logService=m}request(P,m){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(P,m)}async resolveProxy(P){}};k=he([X(0,L.IConfigurationService),X(1,R.ILogService)],k),e.RequestService=k}),define(te[42],ne([0,1,25,125,38,7,32]),function(Y,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function P(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}e.isSuccess=P;function m(c){return c.res.statusCode===204}async function w(c){if(!P(c))throw new Error("Server returned "+c.res.statusCode);return m(c)?null:(await(0,D.streamToBuffer)(c.stream)).toString()}e.asText=w;async function i(c){if(!P(c))throw new Error("Server returned "+c.res.statusCode);if(m(c))return null;const I=(await(0,D.streamToBuffer)(c.stream)).toString();try{return JSON.parse(I)}catch(g){throw g.message+=`:
`+I,g}}e.asJson=i;function E(c){b(c)}e.updateProxyConfigurationsScope=E;let h;function b(c){const y=A.Registry.as(R.Extensions.Configuration);h&&y.deregisterConfigurations([h]),h={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},y.registerConfiguration(h)}b(2)}),define(te[176],ne([0,1,29,17,13,42]),function(Y,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(m,w){this.requestService=m,this.fileService=w}async download(m,w,i=D.CancellationToken.None){if(m.scheme===L.Schemas.file||m.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(m,w);return}const E={type:"GET",url:m.toString()},h=await this.requestService.request(E,i);if(h.res.statusCode===200)await this.fileService.writeFile(w,h.stream);else{const b=await(0,k.asText)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${b}`)}}};A=he([X(0,k.IRequestService),X(1,R.IFileService)],A),e.DownloadService=A}),define(te[177],ne([0,1,19,29,63,2,15,139,13,14,28,42]),function(Y,e,D,L,R,k,A,P,m,w,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let h=class extends k.Disposable{constructor(c,y,I,g){super();this.fileService=c,this.productService=y,this.requestService=I,this.logService=g,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:C})=>this.allConfigBasedTips.set(C.configPath,C))}getConfigBasedTips(c){return this.getValidConfigBasedTips(c)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(c){const y=[];for(const[I,g]of this.allConfigBasedTips)try{const C=await this.fileService.readFile((0,A.joinPath)(c,I)),v=new Map;(0,R.forEach)(g.recommendations,({key:a,value:t})=>{if((0,D.isNonEmptyArray)(t.remotes))for(const r of t.remotes)v.set(r,{extensionId:a,extensionName:t.name,configName:g.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else y.push({extensionId:a,extensionName:t.name,configName:g.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const o=(0,P.getDomainsOfRemotes)(C.value.toString(),[...v.keys()]);for(const a of o){const t=v.get(a);t&&y.push(t)}}catch(C){}return y}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const c=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},L.CancellationToken.None);if(c.res.statusCode!==200)return[];const y=await(0,E.asJson)(c);return y?y.workspaceRecommendations||[]:[]}catch(c){return this.logService.error(c),[]}}};h=he([X(0,m.IFileService),X(1,i.IProductService),X(2,E.IRequestService),X(3,w.ILogService)],h),e.ExtensionTipsService=h}),define(te[45],ne([0,1,25,30]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(k,A,P){let m=P&&P.get("storage.serviceMachineId",0)||null;if(m)return m;try{const i=(await A.readFile(k.serviceMachineIdResource)).value.toString();m=(0,L.isUUID)(i)?i:null}catch(w){m=null}if(!m){m=(0,L.generateUuid)();try{await A.writeFile(k.serviceMachineIdResource,D.VSBuffer.fromString(m))}catch(w){}}return P&&P.store("storage.serviceMachineId",m,0,1),m}e.getServiceMachineId=R}),define(te[20],ne([0,1,6,3,2,16,70,7]),function(Y,e,D,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const m="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var w;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(y){y[y.GLOBAL=0]="GLOBAL",y[y.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var E;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(E=e.StorageTarget||(e.StorageTarget={}));class h extends R.Disposable{constructor(I={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super();this.options=I,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,g){g===m?(I===0?this._globalKeyTargets=void 0:I===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:I})):this._onDidChangeValue.fire({scope:I,key:g,target:this.getKeyTargets(I)[g]})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,g,C){return this.getStorage(g)?.get(I,C)}getBoolean(I,g,C){return this.getStorage(g)?.getBoolean(I,C)}getNumber(I,g,C){return this.getStorage(g)?.getNumber(I,C)}store(I,g,C,v){if((0,k.isUndefinedOrNull)(g)){this.remove(I,C);return}this.withPausedEmitters(()=>{this.updateKeyTarget(I,C,v),this.getStorage(C)?.set(I,g)})}remove(I,g){this.withPausedEmitters(()=>{this.updateKeyTarget(I,g,void 0),this.getStorage(g)?.delete(I)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,g){const C=[],v=this.getKeyTargets(I);for(const o of Object.keys(v))v[o]===g&&C.push(o);return C}updateKeyTarget(I,g,C){const v=this.getKeyTargets(g);typeof C=="number"?v[I]!==C&&(v[I]=C,this.getStorage(g)?.set(m,JSON.stringify(v))):typeof v[I]=="number"&&(delete v[I],this.getStorage(g)?.set(m,JSON.stringify(v)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(I){return I===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(I){const g=this.get(m,I);if(g)try{return JSON.parse(g)}catch(C){}return Object.create(null)}isNew(I){return this.getBoolean(e.IS_NEW_KEY,I)===!0}async flush(I=w.NONE){this._onWillSaveState.fire({reason:I}),await D.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const I=this.getStorage(0)?.items??new Map,g=this.getStorage(1)?.items??new Map;return c(I,g,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends h{constructor(){super();this.globalStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new A.Storage(new A.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(1,I))),this._register(this.globalStorage.onDidChangeStorage(I=>this.emitDidChangeValue(0,I)))}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(I){}}e.InMemoryStorageService=b;async function c(y,I,g,C){const v=u=>{try{return JSON.parse(u)}catch(l){return u}},o=new Map,a=new Map;y.forEach((u,l)=>{o.set(l,u),a.set(l,v(u))});const t=new Map,r=new Map;I.forEach((u,l)=>{t.set(l,u),r.set(l,v(u))}),console.group(`Storage: Global (path: ${g})`);let n=[];o.forEach((u,l)=>{n.push({key:l,value:u})}),console.table(n),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${C})`);let s=[];t.forEach((u,l)=>{s.push({key:l,value:u})}),console.table(s),console.groupEnd(),console.log(r)}e.logStorage=c}),define(te[178],ne([0,1,3,2,16,27,31,20]),function(Y,e,D,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let m=class extends L.Disposable{constructor(E){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new w(E)),this._register(this.storageManger.onDidChange(h=>this._onDidChangeEnablement.fire({extensions:h,source:"storage"})))}async enableExtension(E,h){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:h}),!0):!1}async disableExtension(E,h){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:h}),!0):!1}getDisabledExtensions(){return this._getExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){let h=this.getDisabledExtensions();return h.every(b=>!(0,A.areSameExtensions)(b,E))?(h.push(E),this._setDisabledExtensions(h),!0):!1}_removeFromDisabledExtensions(E){let h=this.getDisabledExtensions();for(let b=0;b<h.length;b++){const c=h[b];if((0,A.areSameExtensions)(c,E))return h.splice(b,1),this._setDisabledExtensions(h),!0}return!1}_setDisabledExtensions(E){this._setExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,h){this.storageManger.set(E,h,0)}};m=he([X(0,P.IStorageService)],m),e.GlobalExtensionEnablementService=m;class w extends L.Disposable{constructor(E){super();this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(h=>this.onDidStorageChange(h)))}get(E,h){let b;return h===0?((0,R.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,h)),b=this.storage[E]):b=this._get(E,h),JSON.parse(b)}set(E,h,b){let c=JSON.stringify(h.map(({id:I,uuid:g})=>({id:I,uuid:g})));this._get(E,b)!==c&&(b===0&&(h.length?this.storage[E]=c:delete this.storage[E]),this._set(E,h.length?c:void 0,b))}onDidStorageChange(E){if(E.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const b=this.get(E.key,E.scope);delete this.storage[E.key];const c=this.get(E.key,E.scope),y=b.filter(g=>!c.some(C=>(0,A.areSameExtensions)(g,C))),I=c.filter(g=>!b.some(C=>(0,A.areSameExtensions)(C,g)));(y.length||I.length)&&this._onDidChange.fire([...y,...I])}}_get(E,h){return this.storageService.get(E,h,"[]")}_set(E,h,b){h?this.storageService.store(E,h,b,1):this.storageService.remove(E,b)}}e.StorageManager=w}),define(te[179],ne([0,1,3,2]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class R extends L.Disposable{constructor(w,i){super();this.channel=w,this.workspace=i}async getItems(){const w={workspace:this.workspace},i=await this.channel.call("getItems",w);return new Map(i)}updateItems(w){const i={workspace:this.workspace};return w.insert&&(i.insert=Array.from(w.insert.entries())),w.delete&&(i.delete=Array.from(w.delete.values())),this.channel.call("updateItems",i)}}class k extends R{constructor(w){super(w,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(w=>this.onDidChangeGlobalStorage(w)))}onDidChangeGlobalStorage(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this._onDidChangeItemsExternal.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}async close(){this.dispose()}}class A extends R{constructor(w,i){super(w,i);this.onDidChangeItemsExternal=D.Event.None}async close(){const w={workspace:this.workspace};return this.channel.call("close",w)}}class P extends L.Disposable{constructor(w,i){super();this.channel=w,this.workspace=i,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new k(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new A(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(te[180],ne([0,1,6,2,169,15,70,20,179]),function(Y,e,D,L,R,k,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class w extends P.AbstractStorageService{constructor(E,h,b){super();this.mainProcessService=h,this.environmentService=b,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new L.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(E)}createGlobalStorage(){const E=new m.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),h=new A.Storage(E.globalStorage);return this._register(h.onDidChangeStorage(b=>this.emitDidChangeValue(0,b))),h}createWorkspaceStorage(E){const h=new m.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),E);if(h.workspaceStorage){const b=new A.Storage(h.workspaceStorage);return this.workspaceStorageDisposable.value=b.onDidChangeStorage(c=>this.emitDidChangeValue(1,c)),this.workspaceStorageId=E?.id,b}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,R.mark)("code/willInitStorage");try{await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,R.mark)("code/didInitStorage")}}getStorage(E){return E===0?this.globalStorage:this.workspaceStorage}getLogDetails(E){return E===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,k.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(P.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(E){const h=this.workspaceStorage,b=h?.items??new Map;h&&(await h.close(),h.dispose()),this.workspaceStorage=this.createWorkspaceStorage(E),await this.workspaceStorage.init();for(const[c,y]of b)this.workspaceStorage.set(c,y)}}e.NativeStorageService=w}),define(te[181],ne([0,1,4,34,5,30]),function(Y,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(w){if(D.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function P(w,i,E,h,b,c,y,I,g,C){const v=Object.create(null);v["common.machineId"]=y,v.sessionID=(0,k.generateUuid)()+Date.now(),v.commitHash=b,v.version=c,v["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,D.PlatformToString)(D.platform),v["common.nodePlatform"]=L.platform,v["common.nodeArch"]=h,v["common.product"]=C||"desktop";const o=m(I||[]);o&&(v["common.msftInternal"]=o);let a=0;const t=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),D.isLinuxSnap&&(v["common.snap"]="true");const r=A(E);r&&(v["common.platformDetail"]=r);try{const n=await w.readFile(R.URI.file(g));v["common.source"]=n.value.toString().slice(0,30)}catch(n){}return v}e.resolveCommonProperties=P;function m(w){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const E=i.toLowerCase();return w.some(h=>E===h)}e.verifyMicrosoftInternalDomain=m}),define(te[21],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(te[182],ne([0,1,35,55,33,17,8,4,5,98,18,100,73,13,28,21]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function I(a,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],n=new Map,s=new Map,u=2e4;function l(S,T,O,p){const F=T.substring(S.length+1);return new Promise(async M=>{let W;try{W=await i.Promises.readdir(T,{withFileTypes:!0})}catch(N){M();return}if(p.count>=u){p.count+=W.length,p.maxReached=!0,M();return}let j=W.length;if(j===0){M();return}let U=W;p.count+W.length>u&&(p.maxReached=!0,j=u-p.count,U=W.slice(0,j)),p.count+=W.length;for(const N of U)if(N.isDirectory()){if(O.includes(N.name)||await l(S,(0,A.join)(T,N.name),O,p),--j==0){M();return}}else{const z=N.name.lastIndexOf(".");if(z>=0){const H=N.name.substring(z+1);H&&n.set(H,(n.get(H)??0)+1)}for(const H of r)H.relativePathPattern?.test(F)!==!1&&H.filePattern.test(N.name)&&s.set(H.tag,(s.get(H.tag)??0)+1);if(--j==0){M();return}}})}const f={count:0,maxReached:!1};await l(a,a,t,f);const d=await v(a);return{configFiles:g(s),fileTypes:g(n),fileCount:f.count,maxFilesReached:f.maxReached,launchConfigFiles:d}}e.collectWorkspaceStats=I;function g(a){return[...L.Iterable.map(a.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function C(){const a={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/b.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/b.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},t=D.cpus();return t&&t.length>0&&(a.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),a}e.getMachineInfo=C;async function v(a){try{const t=new Map,r=(0,A.join)(a,".vscode","launch.json"),n=await i.Promises.readFile(r),s=[],u=(0,R.parse)(n.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,R.getNodeType)(u)==="object"&&u.configurations)for(const l of u.configurations){const f=l.type;f&&(t.has(f)?t.set(f,t.get(f)+1):t.set(f,1))}return g(t)}catch(t){return[]}}e.collectLaunchConfigs=v;let o=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const n=D.cpus();return n&&n.length>0&&r.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),r.push(`Memory (System):  ${(D.totalmem()/b.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/b.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||r.push(`Load (avg):       ${D.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([(0,E.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async n=>{let[s,u]=n,l=this.formatProcessList(t,s);return r.forEach(f=>{if((0,h.isRemoteDiagnosticError)(f))l+=`
${f.errorMessage}`,u+=`
${f.errorMessage}`;else if(l+=`

Remote: ${f.hostName}`,f.processes&&(l+=`
${this.formatProcessList(t,f.processes)}`),f.workspaceMetadata){u+=`
|  Remote: ${f.hostName}`;for(const d of Object.keys(f.workspaceMetadata)){const S=f.workspaceMetadata[d];let T=`${S.fileCount} files`;S.maxFilesReached&&(T=`more than ${T}`),u+=`|    Folder (${d}): ${T}`,u+=this.formatWorkspaceStats(S)}}}),{processInfo:l,workspaceInfo:u}})}async getSystemInfo(t,r){const{memory:n,vmHint:s,os:u,cpus:l}=C(),f={os:u,memory:n,cpus:l,vmHint:s,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return P.isWindows||(f.load=`${D.loadavg().map(d=>Math.round(d)).join(", ")}`),P.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(t,r){const n=[];return(0,E.listProcesses)(t.mainPID).then(async s=>(n.push(""),n.push(this.formatEnvironment(t)),n.push(""),n.push(this.formatProcessList(t,s)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(t))),r.forEach(u=>{if((0,h.isRemoteDiagnosticError)(u))n.push(`
${u.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${u.hostName}`),n.push(this.formatMachineInfo(u.machineInfo)),u.processes&&n.push(this.formatProcessList(t,u.processes)),u.workspaceMetadata)for(const l of Object.keys(u.workspaceMetadata)){const f=u.workspaceMetadata[l];let d=`${f.fileCount} files`;f.maxFilesReached&&(d=`more than ${d}`),n.push(`Folder (${l}): ${d}`),n.push(this.formatWorkspaceStats(f))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(t){const r=[],n=60;let s=0;const u=(S,T)=>{const O=` ${S}(${T})`;s+O.length>n?(r.push(l),l="|                 ",s=l.length):s+=O.length,l+=O};let l="|      File types:";const f=10;let d=t.fileTypes.length>f?f:t.fileTypes.length;for(let S=0;S<d;S++){const T=t.fileTypes[S];u(T.name,T.count)}if(r.push(l),t.configFiles.length>=0&&(l="|      Conf files:",s=0,t.configFiles.forEach(S=>{u(S.name,S.count)}),r.push(l)),t.launchConfigFiles.length>0){let S="|      Launch Configs:";t.launchConfigFiles.forEach(T=>{S+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),r.push(S)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(n=>n.length));return Object.keys(t).map(n=>`${n}:  ${" ".repeat(r-n.length)}  ${t[n]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],n=[];return t.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(u=>{const l=m.URI.revive(u);if(l.scheme===k.Schemas.file){const f=l.fsPath;n.push(I(f,["node_modules",".git"]).then(d=>{let S=`${d.fileCount} files`;d.maxFilesReached&&(S=`more than ${S}`),r.push(`|    Folder (${(0,A.basename)(f)}): ${S}`),r.push(this.formatWorkspaceStats(d))}).catch(d=>{r.push(`|      Error: Unable to collect workspace stats for folder ${f} (${d.toString()})`)}))}else r.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(t,r){const n=new Map;t.windows.forEach(u=>n.set(u.pid,u.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,n,s,r,0),s.join(`
`)}formatProcessItem(t,r,n,s,u){const l=u===0;let f;l?f=s.pid===t?`${this.productService.applicationName} main`:"remote agent":(f=`${"  ".repeat(u)} ${s.name}`,s.name==="window"&&(f=`${f} (${r.get(s.pid)})`));const d=process.platform==="win32"?s.mem:D.totalmem()*(s.mem/100);n.push(`${s.load.toFixed(0).padStart(5," ")}	${(d/b.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(s.children)&&s.children.forEach(S=>this.formatProcessItem(t,r,n,S,u+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const n=m.URI.revive(r);if(n.scheme!==k.Schemas.file)continue;const s=n.fsPath;try{const u=await I(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),u.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),u.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};o=he([X(0,y.ITelemetryService),X(1,c.IProductService)],o),e.DiagnosticsService=o}),define(te[183],ne([0,1,19,6,29,11,3,2,4,5,114,27,31,14,44,21]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let I=class extends P.Disposable{constructor(a,t,r){super();this.galleryService=a,this.telemetryService=t,this.logService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(a,t={}){if(!this.galleryService.isEnabled())throw new Error(i.localize(0,null));try{a=await this.checkAndGetCompatibleVersion(a,!t.installGivenVersion)}catch(n){throw this.logService.error((0,k.getErrorMessage)(n)),C(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(a),void 0,n),n}if(!await this.canInstall(a)){const n=new E.ExtensionManagementError("Not supported",e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension as it is not supported.",a.identifier.id,n.message),C(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(a),void 0,n),n}const r=await this.galleryService.getManifest(a,R.CancellationToken.None);if(r===null){const n=new E.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",a.identifier.id,n.message),C(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(a),void 0,n),n}if(r.version!==a.version){const n=new E.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error(n.message),C(this.telemetryService,"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(a),void 0,n),n}return this.installExtension(r,a,t)}async uninstall(a,t={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,t)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(i.localize(1,null));const t=await this.findGalleryExtension(a);if(!t)throw new Error(i.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsReport(){const a=new Date().getTime();return(!this.reportedExtensions||a-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=a),this.reportedExtensions}registerParticipant(a){this.participants.push(a)}async installExtension(a,t,r){if(!w.URI.isUri(t)){let f=this.installingExtensions.get(new h.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(f)return this.logService.info("Extensions is already requested to install",t.identifier.id),f.waitUntilTaskIsFinished();r={...r,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],s=[],u=this.createInstallExtensionTask(a,t,r);w.URI.isUri(t)||this.installingExtensions.set(new h.ExtensionIdentifierWithVersion(u.identifier,a.version).key(),u),this._onInstallExtension.fire({identifier:u.identifier,source:t}),this.logService.info("Installing extension:",u.identifier.id),n.push({task:u,manifest:a});let l=!1;try{if(r.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",u.identifier.id);else try{const d=await this.getAllDepsAndPackExtensionsToInstall(u.identifier,a,!!r.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:S,manifest:T}of d)if(l=l||!!T.extensionDependencies?.some(O=>(0,h.areSameExtensions)({id:O},u.identifier)),this.installingExtensions.has(new h.ExtensionIdentifierWithVersion(S.identifier,S.version).key()))this.logService.info("Extension is already requested to install",S.identifier.id);else{const O=this.createInstallExtensionTask(T,S,{...r,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new h.ExtensionIdentifierWithVersion(O.identifier,T.version).key(),O),this._onInstallExtension.fire({identifier:O.identifier,source:S}),this.logService.info("Installing extension:",O.identifier.id),n.push({task:O,manifest:T})}}catch(d){if(w.URI.isUri(u.source))(0,D.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",u.identifier.id,d.message),(0,D.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",u.identifier.id,d.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",u.identifier.id),this.logService.error(d),d}const f=n.reduce((d,{task:S,manifest:T})=>(d.set(S.identifier.id.toLowerCase(),{task:S,manifest:T}),d),new Map);for(;f.size;){let d;const S=[...f.values()].filter(({manifest:T})=>!T.extensionDependencies?.some(O=>f.has(O.toLowerCase())));S.length?d=f.size===1?S:S.filter(({task:T})=>!(T===u&&!l)):(this.logService.info("Found extensions with circular dependencies",S.map(({task:T})=>T.identifier.id)),d=[...f.values()]),await this.joinAllSettled(d.map(async({task:T})=>{const O=new Date().getTime();try{const p=await T.run();if(await this.joinAllSettled(this.participants.map(F=>F.postInstall(p,T.source,r,R.CancellationToken.None))),!w.URI.isUri(T.source)&&(C(this.telemetryService,T.operation===2?"extensionGallery:update":"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(T.source),new Date().getTime()-O,void 0),m.isWeb&&T.operation===1))try{await this.galleryService.reportStatistic(p.manifest.publisher,p.manifest.name,p.manifest.version,"install")}catch(F){}s.push({local:p,identifier:T.identifier,operation:T.operation,source:T.source})}catch(p){throw w.URI.isUri(T.source)||C(this.telemetryService,T.operation===2?"extensionGallery:update":"extensionGallery:install",(0,h.getGalleryExtensionTelemetryData)(T.source),new Date().getTime()-O,p),this.logService.error("Error while installing the extension:",T.identifier.id),this.logService.error(p),p}finally{f.delete(T.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:d})=>this.logService.info("Extension installed successfully:",d.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:d})=>(0,h.areSameExtensions)(d,u.identifier))[0].local}catch(f){if(n.forEach(({task:d})=>d.cancel()),s.length)try{const d=await Promise.allSettled(s.map(({local:S})=>this.createUninstallExtensionTask(S,{versionOnly:!0}).run()));for(let S=0;S<d.length;S++){const T=d[S],{identifier:O}=s[S];T.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",O.id):this.logService.warn("Rollback: Error while uninstalling extension",O.id,(0,k.getErrorMessage)(T.reason))}}catch(d){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(d),s.map(({identifier:S})=>S.id))}throw this.logService.error("Failed to install extension:",u.identifier.id,(0,k.getErrorMessage)(f)),this._onDidInstallExtensions.fire(n.map(({task:d})=>({identifier:d.identifier,operation:1,source:d.source}))),f instanceof Error&&(f.name=f&&f.code?f.code:e.ERROR_UNKNOWN),f}finally{for(const{task:f,manifest:d}of n)if(!w.URI.isUri(f.source)){const S=new h.ExtensionIdentifierWithVersion(f.identifier,d.version).key();this.installingExtensions.delete(S)||this.logService.warn("Installation task is not found in the cache",S)}}}async joinAllSettled(a){const t=[],r=[],n=await Promise.allSettled(a);for(const s of n)s.status==="fulfilled"?t.push(s.value):r.push(s.reason);if(r.length)throw g(r);return t}async getAllDepsAndPackExtensionsToInstall(a,t,r){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const s=[a,...n.map(f=>f.identifier)],u=[],l=async(f,d)=>{const S=d.extensionDependencies||[],T=[...S];if(d.extensionPack){const O=r?n.find(p=>(0,h.areSameExtensions)(p.identifier,f)):void 0;for(const p of d.extensionPack)O&&O.manifest.extensionPack&&O.manifest.extensionPack.some(F=>(0,h.areSameExtensions)({id:F},{id:p}))||T.every(F=>!(0,h.areSameExtensions)({id:F},{id:p}))&&T.push(p)}if(T.length){const O=[...s,...u.map(F=>F.gallery.identifier)],p=T.filter(F=>O.every(M=>!(0,h.areSameExtensions)(M,{id:F})));if(p.length){const F=await this.galleryService.query({names:p,pageSize:T.length},R.CancellationToken.None);for(const M of F.firstPage){if(O.find(N=>(0,h.areSameExtensions)(N,M.identifier)))continue;if(!S.some(N=>(0,h.areSameExtensions)({id:N},M.identifier))&&!await this.canInstall(M)){this.logService.info("Skipping the packed extension as it cannot be installed",M.identifier.id);continue}const j=await this.checkAndGetCompatibleVersion(M,!0),U=await this.galleryService.getManifest(j,R.CancellationToken.None);if(U===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${j.identifier.id}`,e.INSTALL_ERROR_VALIDATING);u.push({gallery:j,manifest:U}),await l(j.identifier,U)}}}};return await l(a,t),n=await this.getInstalled(),u.filter(f=>!n.some(d=>(0,h.areSameExtensions)(d.identifier,f.gallery.identifier)))}async checkAndGetCompatibleVersion(a,t){if(await this.isMalicious(a))throw new E.ExtensionManagementError(i.localize(3,null,a.identifier.id),E.INSTALL_ERROR_MALICIOUS);let r=null;if(await this.galleryService.isExtensionCompatible(a,E.CURRENT_TARGET_PLATFORM)&&(r=a),!r&&t&&(r=await this.galleryService.getCompatibleExtension(a,E.CURRENT_TARGET_PLATFORM)),!r)throw new E.ExtensionManagementError(i.localize(4,null,a.identifier.id,c.default.version),E.INSTALL_ERROR_INCOMPATIBLE);return r}async isMalicious(a){const t=await this.getExtensionsReport();return(0,h.getMaliciousExtensionsSet)(t).has(a.identifier.id)}async unininstallExtension(a,t){const r=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(r)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),r.waitUntilTaskIsFinished();const n=(f,d)=>{const S=this.createUninstallExtensionTask(f,d);return this.uninstallingExtensions.set(S.extension.identifier.id.toLowerCase(),S),this.logService.info("Uninstalling extension:",f.identifier.id),this._onUninstallExtension.fire(f.identifier),S},s=(f,d)=>{d?this.logService.error("Failed to uninstall extension:",f.identifier.id,d.message):this.logService.info("Successfully uninstalled extension:",f.identifier.id),C(this.telemetryService,"extensionGallery:uninstall",(0,h.getLocalExtensionTelemetryData)(f),void 0,d),this._onDidUninstallExtension.fire({identifier:f.identifier,error:d?.code})},u=[],l=[];try{u.push(n(a,{}));const f=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const d=this.getAllPackExtensionsToUninstall(a,f);for(const S of d)this.uninstallingExtensions.has(S.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",S.identifier.id):u.push(n(S,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(u.map(d=>d.extension),f,a),await this.joinAllSettled(u.map(async d=>{try{if(await d.run(),await this.joinAllSettled(this.participants.map(S=>S.postUninstall(d.extension,t,R.CancellationToken.None))),d.extension.identifier.uuid)try{await this.galleryService.reportStatistic(d.extension.manifest.publisher,d.extension.manifest.name,d.extension.manifest.version,"uninstall")}catch(S){}s(d.extension)}catch(S){const T=S instanceof E.ExtensionManagementError?S:new E.ExtensionManagementError((0,k.getErrorMessage)(S),e.ERROR_UNKNOWN);throw s(d.extension,T),T}finally{l.push(d)}}))}catch(f){const d=f instanceof E.ExtensionManagementError?f:new E.ExtensionManagementError((0,k.getErrorMessage)(f),e.ERROR_UNKNOWN);for(const S of u){try{S.cancel()}catch(T){}l.includes(S)||s(S.extension,d)}throw d}finally{for(const f of u)this.uninstallingExtensions.delete(f.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",f.extension.identifier.id)}}checkForDependents(a,t,r){for(const n of a){const s=this.getDependents(n,t);if(s.length){const u=s.filter(l=>!a.some(f=>(0,h.areSameExtensions)(f.identifier,l.identifier)));if(u.length)throw new Error(this.getDependentsErrorMessage(n,u,r))}}}getDependentsErrorMessage(a,t,r){return r===a?t.length===1?i.localize(5,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(6,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(7,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?i.localize(8,null,r.manifest.displayName||r.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?i.localize(9,null,r.manifest.displayName||r.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):i.localize(10,null,r.manifest.displayName||r.manifest.name,a.manifest.displayName||a.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(a,t,r=[]){if(r.indexOf(a)!==-1)return[];r.push(a);const n=a.manifest.extensionPack?a.manifest.extensionPack:[];if(n.length){const s=t.filter(l=>!l.isBuiltin&&n.some(f=>(0,h.areSameExtensions)({id:f},l.identifier))),u=[];for(const l of s)u.push(...this.getAllPackExtensionsToUninstall(l,t,r));return[...s,...u]}return[]}getDependents(a,t){return t.filter(r=>r.manifest.extensionDependencies&&r.manifest.extensionDependencies.some(n=>(0,h.areSameExtensions)({id:n},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const t=await this.findGalleryExtensionById(a.identifier.uuid);return t||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},R.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},R.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${a.length} reported extensions from service`),a}catch(a){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};I=he([X(0,E.IExtensionGalleryService),X(1,y.ITelemetryService),X(2,b.ILogService)],I),e.AbstractExtensionManagementService=I;function g(o){const a=Array.isArray(o)?o:[o];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((t,r)=>new Error(`${t.message}${t.message?",":""}${r instanceof Error?r.message:r}`),new Error(""))}e.joinErrors=g;function C(o,a,t,r,n){const s=n?n instanceof E.ExtensionManagementError?n.code:e.ERROR_UNKNOWN:void 0;o.publicLogError(a,{...t,success:!n,duration:r,errorcode:s})}e.reportTelemetry=C;class v{constructor(){this.barrier=new L.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(a=>new Promise((t,r)=>{const n=a.onCancellationRequested(()=>{n.dispose(),r((0,k.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=v}),define(te[184],ne([0,1,19,29,11,26,4,5,12,27,31,72,13,7,14,28,42,45,20,21]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y,I,g,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var o;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished"})(o||(o={}));function a(...$){return String($.reduce((_,J)=>_|J,0))}var t;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},n={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class l{constructor(_=u){this.state=_}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(_,J=this.state.pageSize){return new l({...this.state,pageNumber:_,pageSize:J})}withFilter(_,...J){const G=[...this.state.criteria,...J.length?J.map(ee=>({filterType:_,value:ee})):[{filterType:_}]];return new l({...this.state,criteria:G})}withSortBy(_){return new l({...this.state,sortBy:_})}withSortOrder(_){return new l({...this.state,sortOrder:_})}withFlags(..._){return new l({...this.state,flags:_.reduce((J,G)=>J|G,0)})}withAssetTypes(..._){return new l({...this.state,assetTypes:_})}get raw(){const{criteria:_,pageNumber:J,pageSize:G,sortBy:ee,sortOrder:Z,flags:ce,assetTypes:ae}=this.state;return{filters:[{criteria:_,pageNumber:J,pageSize:G,sortBy:ee,sortOrder:Z}],assetTypes:ae,flags:ce}}get searchText(){const _=this.state.criteria.filter(J=>J.filterType===t.SearchText)[0];return _&&_.value?_.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(_=>String(_.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function f($,_){const J=($||[]).filter(G=>G.statisticName===_)[0];return J?J.value:0}function d($){const _="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(G=>G.assetType.indexOf(_)===0).reduce((G,ee)=>{const Z=p($,ee.assetType);return Z&&G.push([ee.assetType.substring(_.length),Z]),G},[])}function S($){if($.properties){const _=$.properties.filter(ee=>ee.key===r.Repository),J=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=_.filter(ee=>J.test(ee.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return p($,r.Repository)}function T($){return{uri:`${$.fallbackAssetUri}/${r.VSIX}?redirect=true${$.targetPlatform?`&targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${r.VSIX}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}}function O($){const _=p($,r.Icon);if(_)return _;const J=w.DefaultIconPath;return{uri:J,fallbackUri:J}}function p($,_){return $.files.filter(G=>G.assetType===_)[0]?{uri:`${$.assetUri}/${_}`,fallbackUri:`${$.fallbackAssetUri}/${_}`}:null}function F($,_){const J=$.properties?$.properties.filter(ee=>ee.key===_):[],G=J.length>0&&J[0].value;return G?G.split(",").map(ee=>(0,i.adoptToGalleryExtensionId)(ee)):[]}function M($){const _=$.properties?$.properties.filter(J=>J.key===n.Engine):[];return _.length>0&&_[0].value||""}function W($){const _=$.properties?$.properties.filter(G=>G.key===n.LocalizedLanguages):[],J=_.length>0&&_[0].value||"";return J?J.split(","):[]}function j($){return $.indexOf("preview")!==-1}function U($){return $.targetPlatform?(0,w.toTargetPlatform)($.targetPlatform):"undefined"}function N($){const _=(0,D.distinct)($.versions.map(U)),J=!!$.tags?.includes(w.WEB_EXTENSION_TAG),G=_.indexOf("web");return J?G===-1&&_.push("web"):G!==-1&&_.splice(G,1),_}function z($,_){return _==="web"&&!$.includes("web")}function H($,_,J){if(z(_,J))return!1;if($==="undefined"||$==="universal")return!0;if($==="unknown")return!1;if($===J)return!0;switch(J){case"win32-x64":return $==="win32-ia32";case"win32-arm64":return $==="win32-ia32";default:return!1}}function V($,_,J,G){const ee=N($);let Z=$.versions[0];return Z=$.versions.find(ce=>ce.version===Z.version&&H(U(ce),ee,w.CURRENT_TARGET_PLATFORM))||Z,x($,Z,ee,_,J,G)}function x($,_,J,G,ee,Z){const ce={manifest:p(_,r.Manifest),readme:p(_,r.Details),changelog:p(_,r.Changelog),license:p(_,r.License),repository:S(_),download:T(_),icon:O(_),coreTranslations:d(_)};return{identifier:{id:(0,i.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:_.version,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,description:$.shortDescription||"",installCount:f($.statistics,"install"),rating:f($.statistics,"averagerating"),ratingCount:f($.statistics,"ratingcount"),categories:$.categories||[],tags:$.tags||[],releaseDate:Date.parse($.releaseDate),lastUpdated:Date.parse($.lastUpdated),allTargetPlatforms:J,assets:ce,properties:{dependencies:F(_,n.Dependency),extensionPack:F(_,n.ExtensionPack),engine:M(_),localizedLanguages:W(_),targetPlatform:U(_)},preview:j($.flags),telemetryData:{index:(ee.pageNumber-1)*ee.pageSize+G,querySource:Z}}}let K=class{constructor(_,J,G,ee,Z,ce,ae){this.requestService=_,this.logService=J,this.environmentService=G,this.telemetryService=ee,this.fileService=Z,this.productService=ce;const fe=ce.extensionsGallery;this.extensionsGalleryUrl=fe&&fe.serviceUrl,this.extensionsControlUrl=fe&&fe.controlUrl,this.commonHeadersPromise=q(ce.version,this.environmentService,this.fileService,ae)}api(_=""){return`${this.extensionsGalleryUrl}${_}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(_,J){const G=[];let ee=new l().withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,_.length).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExtensionName,..._.map(({id:ce})=>ce.toLowerCase()));_.every(ce=>!ce.version)&&(ee=ee.withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties,o.IncludeLatestVersionOnly));const{galleryExtensions:Z}=await this.queryGallery(ee,L.CancellationToken.None);for(let ce=0;ce<Z.length;ce++){const ae=Z[ce];if(!ae.versions.length)continue;const fe=(0,i.getGalleryExtensionId)(ae.publisher.publisherName,ae.extensionName),ye=_.find(Se=>(0,i.areSameExtensions)(Se,{id:fe}))?.version;if(ye){const Se=ae.versions.find(Pe=>Pe.version===ye);Se&&G.push(x(ae,Se,N(ae),ce,ee))}else G.push(V(ae,ce,ee))}return G}async getCompatibleExtension(_,J){const G=(0,w.isIExtensionIdentifier)(_)?null:_;if(G){if(z(G.allTargetPlatforms,J))return null;if(await this.isExtensionCompatible(G,J))return G}const{id:ee,uuid:Z}=G?G.identifier:_;let ce=new l().withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1).withFilter(t.Target,"Microsoft.VisualStudio.Code");Z?ce=ce.withFilter(t.ExtensionId,Z):ce=ce.withFilter(t.ExtensionName,ee);const{galleryExtensions:ae}=await this.queryGallery(ce,L.CancellationToken.None),[fe]=ae;if(!fe||!fe.versions.length)return null;const ye=N(fe);if(z(ye,J))return null;for(let Se of fe.versions){if(!M(Se)){const Pe=await this.getEngine(Se);Se={...Se,properties:[...Se.properties||[],{key:n.Engine,value:Pe}]}}if(await this.isRawExtensionVersionCompatible(Se,ye,J))return x(fe,Se,ye,0,ce)}return null}async isExtensionCompatible(_,J){if(!H(_.properties.targetPlatform,_.allTargetPlatforms,J))return!1;let G=_.properties.engine;if(!G){const ee=await this.getManifest(_,L.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");G=ee.engines.vscode}return(0,E.isEngineValid)(G,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(_,J,G){if(!H(U(_),J,G))return!1;const ee=await this.getEngine(_);return(0,E.isEngineValid)(ee,this.productService.version,this.productService.date)}async query(_,J){const G=L.CancellationToken.isCancellationToken(_)?{}:_,ee=L.CancellationToken.isCancellationToken(_)?_:J;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let Z=G.text||"";const ce=(0,k.getOrDefault)(G,Te=>Te.pageSize,50);let ae=new l().withFlags(o.IncludeLatestVersionOnly,o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,ce).withFilter(t.Target,"Microsoft.VisualStudio.Code");Z?(Z=Z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Te,Re,Ce)=>(ae=ae.withFilter(t.Category,Ce||Re),"")),Z=Z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Te,Re,Ce)=>(ae=ae.withFilter(t.Tag,Ce||Re),"")),Z=Z.replace(/\bfeatured(\s+|\b|$)/g,()=>(ae=ae.withFilter(t.Featured),"")),Z=Z.trim(),Z&&(Z=Z.length<200?Z:Z.substring(0,200),ae=ae.withFilter(t.SearchText,Z)),ae=ae.withSortBy(0)):G.ids?ae=ae.withFilter(t.ExtensionId,...G.ids):G.names?ae=ae.withFilter(t.ExtensionName,...G.names):ae=ae.withSortBy(4),typeof G.sortBy=="number"&&(ae=ae.withSortBy(G.sortBy)),typeof G.sortOrder=="number"&&(ae=ae.withSortOrder(G.sortOrder));const{galleryExtensions:fe,total:ye}=await this.queryGallery(ae,ee),Se=fe.map((Te,Re)=>V(Te,Re,ae,G.source)),Pe=async(Te,Re)=>{if(Re.isCancellationRequested)throw(0,R.canceled)();const Ce=ae.withPage(Te+1),{galleryExtensions:Ne}=await this.queryGallery(Ce,Re);return Ne.map((De,ke)=>V(De,ke,Ce,G.source))};return{firstPage:Se,total:ye,pageSize:ae.pageSize,getPage:Pe}}async queryGallery(_,J){if(!this.isEnabled())throw new Error("No extension gallery service configured.");_=_.withFlags(_.flags,o.ExcludeNonValidated).withFilter(t.ExcludeWithFlags,a(o.Unpublished));const G=await this.commonHeadersPromise,ee=JSON.stringify(_.raw),Z={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},ce=new Date().getTime();let ae,fe,ye=0;try{if(ae=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ee,headers:Z},J),ae.res.statusCode&&ae.res.statusCode>=400&&ae.res.statusCode<500)return{galleryExtensions:[],total:ye};const Se=await(0,I.asJson)(ae);if(Se){const Pe=Se.results[0],Te=Pe.extensions,Re=Pe.resultMetadata&&Pe.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ye=Re&&Re.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:Te,total:ye}}return{galleryExtensions:[],total:ye}}catch(Se){throw fe=Se,Se}finally{this.telemetryService.publicLog2("galleryService:query",{..._.telemetryData,requestBodySize:String(ee.length),duration:new Date().getTime()-ce,success:!!ae&&(0,I.isSuccess)(ae),responseBodySize:ae?.res.headers["Content-Length"],statusCode:ae?String(ae.res.statusCode):void 0,errorCode:fe?(0,R.isPromiseCanceledError)(fe)?"canceled":(0,R.getErrorMessage)(fe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ye)})}}async reportStatistic(_,J,G,ee){if(!this.isEnabled())return;const Z=A.isWeb?this.api(`/itemName/${_}.${J}/version/${G}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${_}/extensions/${J}/${G}/stats?statType=${ee}`),ce=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",fe={...await this.commonHeadersPromise,Accept:ce};try{await this.requestService.request({type:"POST",url:Z,headers:fe},L.CancellationToken.None)}catch(ye){}}async download(_,J,G){this.logService.trace("ExtensionGalleryService#download",_.identifier.id);const ee=(0,i.getGalleryExtensionTelemetryData)(_),Z=new Date().getTime(),ce=Se=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ee,duration:Se}),ae=G===1?"install":G===2?"update":"",fe=ae?{uri:`${_.assets.download.uri}${P.URI.parse(_.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${_.assets.download.fallbackUri}${P.URI.parse(_.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:_.assets.download,ye=await this.getAsset(fe);await this.fileService.writeFile(J,ye.stream),ce(new Date().getTime()-Z)}async getReadme(_,J){if(_.assets.readme){const G=await this.getAsset(_.assets.readme,{},J);return await(0,I.asText)(G)||""}return""}async getManifest(_,J){if(_.assets.manifest){const G=await this.getAsset(_.assets.manifest,{},J),ee=await(0,I.asText)(G);return ee?JSON.parse(ee):null}return null}async getManifestFromRawExtensionVersion(_,J){const G=p(_,r.Manifest);if(!G)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},Z=await this.getAsset(G,{headers:ee});return await(0,I.asJson)(Z)}async getCoreTranslation(_,J){const G=_.assets.coreTranslations.filter(ee=>ee[0]===J.toUpperCase())[0];if(G){const ee=await this.getAsset(G[1]),Z=await(0,I.asText)(ee);return Z?JSON.parse(Z):null}return null}async getChangelog(_,J){if(_.assets.changelog){const G=await this.getAsset(_.assets.changelog,{},J);return await(0,I.asText)(G)||""}return""}async getAllCompatibleVersions(_,J){let G=new l().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1).withFilter(t.Target,"Microsoft.VisualStudio.Code");_.identifier.uuid?G=G.withFilter(t.ExtensionId,_.identifier.uuid):G=G.withFilter(t.ExtensionName,_.identifier.id);const{galleryExtensions:ee}=await this.queryGallery(G,L.CancellationToken.None);if(!ee.length)return[];const Z=N(ee[0]);if(z(Z,J))return[];const ce=[];for(const ae of ee[0].versions)try{await this.isRawExtensionVersionCompatible(ae,Z,J)&&ce.push({version:ae.version,date:ae.lastUpdated})}catch(fe){}return ce}async getAsset(_,J={},G=L.CancellationToken.None){const ee=await this.commonHeadersPromise,Z={type:"GET"},ce={...ee,...J.headers||{}};J={...J,...Z,headers:ce};const ae=_.uri,fe=_.fallbackUri,ye={...J,url:ae};try{const Se=await this.requestService.request(ye,G);if(Se.res.statusCode===200)return Se;const Pe=await(0,I.asText)(Se);throw new Error(`Expected 200, got back ${Se.res.statusCode} instead.

${Pe}`)}catch(Se){if((0,R.isPromiseCanceledError)(Se))throw Se;const Pe=(0,R.getErrorMessage)(Se);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:Pe});const Te={...J,url:fe};return this.requestService.request(Te,G)}}async getEngine(_){let J=M(_);if(!J){const G=await this.getManifestFromRawExtensionVersion(_,L.CancellationToken.None);if(!G)throw new Error("Manifest was not found");J=G.engines.vscode}return J}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const _=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(_.res.statusCode!==200)throw new Error("Could not get extensions report.");const J=await(0,I.asJson)(_),G=new Map;if(J)for(const ee of J.malicious){const Z=G.get(ee)||{id:{id:ee},malicious:!0,slow:!1};Z.malicious=!0,G.set(ee,Z)}return[...G.values()]}};K=he([X(0,I.IRequestService),X(1,c.ILogService),X(2,m.IEnvironmentService),X(3,v.ITelemetryService),X(4,h.IFileService),X(5,y.IProductService),X(6,(0,b.optional)(C.IStorageService))],K),e.ExtensionGalleryService=K;async function q($,_,J,G){const ee={"X-Market-Client-Id":`VSCode ${$}`,"User-Agent":`VSCode ${$}`},Z=await(0,g.getServiceMachineId)(_,J,G);return ee["X-Market-User-Id"]=Z,ee}e.resolveMarketplaceHeaders=q}),define(te[185],ne([0,1,19,6,63,3,8,4,34,5,116,12,27,177,75,13,14,59,28,42,20,21]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y,I,g,C,v,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let n=class extends b.ExtensionTipsService{constructor(u,l,f,d,S,T,O,p,F,M){super(O,p,F,M);this.environmentService=u,this.telemetryService=l,this.extensionManagementService=f,this.storageService=d,this.nativeHostService=S,this.extensionRecommendationNotificationService=T,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,p.exeBasedExtensionTips&&(0,R.forEach)(p.exeBasedExtensionTips,({key:W,value:j})=>{const U=[],N=[],z=[];(0,R.forEach)(j.recommendations,({key:H,value:V})=>{V.important?j.important?U.push({extensionId:H,extensionName:V.name,isExtensionPack:!!V.isExtensionPack}):N.push({extensionId:H,extensionName:V.name,isExtensionPack:!!V.isExtensionPack}):z.push({extensionId:H,extensionName:V.name,isExtensionPack:!!V.isExtensionPack})}),U.length&&this.highImportanceExecutableTips.set(W,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:U}),N.length&&this.mediumImportanceExecutableTips.set(W,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:N}),z.length&&this.allOtherExecutableTips.set(W,{exeFriendlyName:j.friendlyName,windowsPath:j.windowsPath,recommendations:z})}),(0,L.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...u,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),f=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(u,f),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,f)}groupImportantTipsByExe(u,l){const f=new Map;u.forEach(p=>f.set(p.extensionId.toLowerCase(),p));const{installed:d,uninstalled:S}=this.groupByInstalled([...f.keys()],l);for(const p of d){const F=f.get(p);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:p,exeName:F.exeName})}for(const p of S){const F=f.get(p);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:p,exeName:F.exeName})}const T=this.getPromptedExecutableTips(),O=new Map;for(const p of S){const F=f.get(p);if(F&&(!T[F.exeName]||!T[F.exeName].includes(F.extensionId))){let M=O.get(F.exeName);M||(M=[],O.set(F.exeName,M)),M.push(F)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[u,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(f=>{switch(f){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(u);break;case"incompatibleWindow":const d=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const S=this._register((0,L.disposableTimeout)(()=>{S.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const u=this.getLastPromptedMediumExeTime(),l=Date.now()-u,f=7*24*60*60*1e3;if(l<f){const T=this._register((0,L.disposableTimeout)(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},f-l));return}const[d,S]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(S).then(T=>{switch(T){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(S[0].exeName,S);const O=this._register((0,L.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},f));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const p=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(p(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const F=this._register((0,L.disposableTimeout)(()=>{F.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(u){const l=u.map(({extensionId:d})=>d.toLowerCase()),f=(0,i.localize)(0,null,u[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,f,`@exe:"${u[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let u=this.storageService.getNumber(r,0);return u||(u=Date.now(),this.updateLastPromptedMediumExeTime(u)),u}updateLastPromptedMediumExeTime(u){this.storageService.store(r,u,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(u,l){const f=this.getPromptedExecutableTips();f[u]=l.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(t,JSON.stringify(f),0,0)}groupByInstalled(u,l){const f=[],d=[],S=l.reduce((T,O)=>(T.add(O.identifier.id.toLowerCase()),T),new Set);return u.forEach(T=>{S.has(T.toLowerCase())?f.push(T):d.push(T)}),{installed:f,uninstalled:d}}async getValidExecutableBasedExtensionTips(u){const l=[],f=new Map;for(const d of u.keys()){const S=u.get(d);if(!S||!(0,D.isNonEmptyArray)(S.recommendations))continue;const T=[];P.isWindows?S.windowsPath&&T.push(S.windowsPath.replace("%USERPROFILE%",m.env.USERPROFILE).replace("%ProgramFiles(x86)%",m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",m.env.ProgramFiles).replace("%APPDATA%",m.env.APPDATA).replace("%WINDIR%",m.env.WINDIR)):(T.push((0,A.join)("/usr/local/bin",d)),T.push((0,A.join)("/usr/bin",d)),T.push((0,A.join)(this.environmentService.userHome.fsPath,d)));for(const O of T){let p=f.get(O);if(p===void 0&&(p=await this.fileService.exists(w.URI.file(O)),f.set(O,p)),p)for(const{extensionId:F,extensionName:M,isExtensionPack:W}of S.recommendations)l.push({extensionId:F,extensionName:M,isExtensionPack:W,exeName:d,exeFriendlyName:S.exeFriendlyName,windowsPath:S.windowsPath})}}return l}};n=he([X(0,E.INativeEnvironmentService),X(1,a.ITelemetryService),X(2,h.IExtensionManagementService),X(3,o.IStorageService),X(4,g.INativeHostService),X(5,c.IExtensionRecommendationNotificationService),X(6,y.IFileService),X(7,C.IProductService),X(8,v.IRequestService),X(9,I.ILogService)],n),e.ExtensionTipsService=n}),define(te[82],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(k){this.appender=k}listen(k,A){throw new Error(`Event not found: ${A}`)}call(k,A,{eventName:P,data:m}){return this.appender.log(P,m),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class L{constructor(k){this.channel=k}log(k,A){return this.channel.call("log",{eventName:k,data:A}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(te[83],ne([0,1,2,26,23,126,24,38,7,44,32]),function(Y,e,D,L,R,k,A,P,m,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(c,y){this._configurationService=y,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appender=c.appender,this._commonProperties=c.commonProperties||Promise.resolve({}),this._piiPaths=c.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let I of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(I),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(I=>{const g=/^[a-f0-9]+$/i.test(I["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!g})}))}setExperimentProperty(c,y){this._experimentProperties[c]=y}setEnabled(c){this._enabled=c}_updateUserOptIn(){const c=this._configurationService?.getValue(h);this._userOptIn=c?c.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const c=await this._commonProperties;let y=c.sessionID,I=c["common.instanceId"],g=c["common.machineId"],C=c["common.firstSessionDate"],v=c["common.msftInternal"];return{sessionId:y,instanceId:I,machineId:g,firstSessionDate:C,msftInternal:v}}dispose(){this._disposables.dispose()}publicLog(c,y,I){return this.isOptedIn?this._commonProperties.then(g=>{y=(0,L.mixin)(y,g),y=(0,L.mixin)(y,this._experimentProperties),y=(0,L.cloneAndChange)(y,C=>{if(typeof C=="string")return this._cleanupInfo(C,I)}),this._appender.log(c,y)},g=>{console.error(g)}):Promise.resolve(void 0)}publicLog2(c,y,I){return this.publicLog(c,y,I)}publicLogError(c,y){return this.sendErrorTelemetry?this.publicLog(c,y,!0):Promise.resolve(void 0)}publicLogError2(c,y){return this.publicLogError(c,y)}_cleanupInfo(c,y){let I=c;if(y){const g=[];for(let a of this._cleanupPatterns)for(;;){const t=a.exec(c);if(!t)break;g.push([t.index,a.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(I="";;){const a=v.exec(c);if(!a)break;!C.test(a[0])&&g.every(([t,r])=>a.index<t||a.index>=r)&&(I+=c.substring(o,a.index)+"<REDACTED: user-file-path>",o=v.lastIndex)}o<c.length&&(I+=c.substr(o))}for(let g of this._cleanupPatterns)I=I.replace(g,"");return I}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=he([X(1,(0,m.optional)(A.IConfigurationService))],E),e.TelemetryService=E;const h="telemetry";i.Registry.as(P.Extensions.Configuration).registerConfiguration({id:h,order:110,type:"object",title:(0,k.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,k.localize)(2,null,w.default.nameLong,w.default.privacyStatementUrl):(0,k.localize)(1,null,w.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[53],ne([0,1,6,26,16,24]),function(Y,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(c,y){return Promise.resolve(void 0)}publicLog2(c,y){return this.publicLog(c,y)}publicLogError(c,y){return Promise.resolve(void 0)}publicLogError2(c,y){return this.publicLogError(c,y)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class A{async publicLog(y,I,g){}async publicLogError(y,I,g){}}e.NullEndpointTelemetryService=A;function P(...c){return{log:(y,I)=>c.forEach(g=>g.log(y,I)),flush:()=>D.Promises.settled(c.map(y=>y.flush()))}}e.combinedAppender=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(c,y){return y.onDidChangeConfiguration(I=>{I.source!==6&&c.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(I.source),configurationKeys:h(I.sourceConfig)})})}e.configurationTelemetry=m;function w(c){const y=Object.create(null),I=Object.create(null),g=Object.create(null);E(c,g);for(let C in g){C=C.length>150?C.substr(C.length-149):C;const v=g[C];typeof v=="number"?I[C]=v:typeof v=="boolean"?I[C]=v?1:0:typeof v=="string"?y[C]=v.substring(0,1023):typeof v!="undefined"&&v!==null&&(y[C]=v)}return{properties:y,measurements:I}}e.validateTelemetryData=w;function i(c){if(!c)return"none";let y="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(g=>{c.indexOf(`${g}+`)===0&&(y=g)}),y}e.cleanRemoteAuthority=i;function E(c,y,I=0,g){if(!!c)for(let C of Object.getOwnPropertyNames(c)){const v=c[C],o=g?g+C:C;Array.isArray(v)?y[o]=(0,L.safeStringify)(v):v instanceof Date?y[o]=v.toISOString():(0,R.isObject)(v)?I<2?E(v,y,I+1,o+"."):y[o]=(0,L.safeStringify)(v):y[o]=v}}function h(c){if(!c)return[];const y=[];return b(y,"",c),y}function b(c,y,I){I&&typeof I=="object"&&!Array.isArray(I)?Object.keys(I).forEach(g=>b(c,y?`${y}.${g}`:g,I[g])):c.push(y)}}),define(te[84],ne([0,1,2,12,14,53]),function(Y,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends D.Disposable{constructor(m,w,i=""){super();this.prefix=i;const E=m.getLogger(w.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(m.createLogger(w.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(m,w){this.logger.trace(`${this.prefix}telemetry/${m}`,(0,k.validateTelemetryData)(w))}};A=he([X(0,R.ILoggerService),X(1,L.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(te[186],ne([0,1,11,26,53]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function k(P){const m=await new Promise((i,E)=>{Y(["applicationinsights"],i,E)});let w;return m.defaultClient?(w=new m.TelemetryClient(P),w.channel.setUseDiskRetryCaching(!0)):(m.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),w=m.defaultClient),P.indexOf("AIF-")===0&&(w.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),w}class A{constructor(m,w,i){this._eventPrefix=m,this._defaultData=w,this._defaultData||(this._defaultData=Object.create(null)),typeof i=="function"?this._aiClient=i():this._aiClient=i,this._asyncAIClient=null}_withAIClient(m){if(!!this._aiClient){if(typeof this._aiClient!="string"){m(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient)),this._asyncAIClient.then(w=>{m(w)},w=>{(0,D.onUnexpectedError)(w),console.error(w)})}}log(m,w){!this._aiClient||(w=(0,L.mixin)(w,this._defaultData),w=(0,R.validateTelemetryData)(w),this._withAIClient(i=>i.trackEvent({name:this._eventPrefix+"/"+m,properties:w.properties,measurements:w.measurements})))}flush(){return this._aiClient?new Promise(m=>{this._withAIClient(w=>{w.flush({callback:()=>{this._aiClient=void 0,m(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=A}),define(te[187],ne([0,1,17,51,24,12,14,21,82,84,83,53]),function(Y,e,D,L,R,k,A,P,m,w,i,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let h=class{constructor(c,y,I,g){this.configurationService=c,this.telemetryService=y,this.loggerService=I,this.environmentService=g,this.customTelemetryServices=new Map}async getCustomTelemetryService(c){if(!this.customTelemetryServices.has(c.id)){const{machineId:y,sessionId:I}=await this.telemetryService.getTelemetryInfo(),g=Object.create(null);g["common.vscodemachineid"]=y,g["common.vscodesessionid"]=I;const C=[c.id,JSON.stringify(g),c.aiKey],o=new L.Client(D.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:C,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),a=(0,E.combinedAppender)(new m.TelemetryAppenderClient(o),new w.TelemetryLogAppender(this.loggerService,this.environmentService,`[${c.id}] `));this.customTelemetryServices.set(c.id,new i.TelemetryService({appender:a,sendErrorTelemetry:c.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(c.id)}async publicLog(c,y,I){await(await this.getCustomTelemetryService(c)).publicLog(y,I)}async publicLogError(c,y,I){await(await this.getCustomTelemetryService(c)).publicLogError(y,I)}};h=he([X(0,R.IConfigurationService),X(1,P.ITelemetryService),X(2,A.ILoggerService),X(3,k.IEnvironmentService)],h),e.CustomEndpointTelemetryService=h}),define(te[188],ne([0,1,6,29,3,2,14]),function(Y,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends k.Disposable{constructor(w,i){super();this._logService=i,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=w===void 0?15e3:w}createRequest(w){return new Promise((i,E)=>{const h=++this._lastRequestId;this._pendingRequests.set(h,i),this._onCreateRequest.fire({requestId:h,...w});const b=new L.CancellationTokenSource;(0,D.timeout)(this._timeout,b.token).then(()=>E(`Request ${h} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(h,[(0,k.toDisposable)(()=>b.cancel())])})}acceptReply(w,i){const E=this._pendingRequests.get(w);E?(this._pendingRequests.delete(w),(0,k.dispose)(this._pendingRequestDisposables.get(w)||[]),this._pendingRequestDisposables.delete(w),E(i)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${w}`)}};P=he([X(1,A.ILogService)],P),e.RequestStore=P}),define(te[85],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(c){c.Shell="terminal.integrated.shell.",c.ShellArgs="terminal.integrated.shellArgs.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(c){c.ShellLinux="terminal.integrated.shell.linux",c.ShellMacOs="terminal.integrated.shell.osx",c.ShellWindows="terminal.integrated.shell.windows",c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationShellLinux="terminal.integrated.automationShell.linux",c.AutomationShellMacOs="terminal.integrated.automationShell.osx",c.AutomationShellWindows="terminal.integrated.automationShell.windows",c.ShellArgsLinux="terminal.integrated.shellArgs.linux",c.ShellArgsMacOs="terminal.integrated.shellArgs.osx",c.ShellArgsWindows="terminal.integrated.shellArgs.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.TitleMode="terminal.integrated.titleMode",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.PersistentSessionExperimentalSerializer="terminal.integrated.persistentSessionExperimentalSerializer",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence"})(A=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.Log="log",c.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var m;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(m=e.HeartbeatConstants||(e.HeartbeatConstants={}));var w;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(w=e.TerminalLocation||(e.TerminalLocation={}));var i;(function(c){c.TerminalView="view",c.Editor="editor"})(i=e.TerminalLocationString||(e.TerminalLocationString={}));var E;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(E=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var b;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(b=e.ProfileSource||(e.ProfileSource={}))}),define(te[189],ne([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(te[190],ne([0,1,35,26,8,4,34,16,18]),function(Y,e,D,L,R,k,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function w(){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let h=0;return E&&E.length===4&&(h=parseInt(E[3])),h}e.getWindowsBuildNumber=w;async function i(E,h,b,c=A.env,y=m.Promises.exists){if(R.isAbsolute(E))return await y(E)?E:void 0;if(h===void 0&&(h=A.cwd()),R.dirname(E)!=="."){const v=R.join(h,E);return await y(v)?v:void 0}const g=(0,L.getCaseInsensitive)(c,"PATH");if(b===void 0&&(0,P.isString)(g)&&(b=g.split(R.delimiter)),b===void 0||b.length===0){const v=R.join(h,E);return await y(v)?v:void 0}for(let v of b){let o;if(R.isAbsolute(v)?o=R.join(v,E):o=R.join(h,v,E),await y(o))return o;if(k.isWindows){let a=o+".com";if(await y(a)||(a=o+".exe",await y(a)))return a}}const C=R.join(h,E);return await y(C)?C:void 0}e.findExecutable=i}),define(te[191],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(te[86],ne([0,1,48,3,2,7,32,191]),function(Y,e,D,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var m;(function(I){function g(C){return C&&typeof C=="object"&&typeof C.id=="string"}I.isThemeColor=g})(m=e.ThemeColor||(e.ThemeColor={}));function w(I){return{id:I}}e.themeColorFromId=w;var i;(function(I){function g(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||m.isThemeColor(r.color))}I.isThemeIcon=g;const C=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function v(r){const n=C.exec(r);if(!n)return;let[,s]=n;return{id:s}}I.fromString=v;function o(r,n){let s=r.id;const u=s.lastIndexOf("~");return u!==-1&&(s=s.substring(0,u)),n&&(s=`${s}~${n}`),{id:s}}I.modify=o;function a(r,n){return r.id===n.id&&r.color?.id===n.color?.id}I.isEqual=a;function t(r,n){return{id:r.id,color:n?w(n):void 0}}I.asThemeIcon=t,I.asClassNameArray=D.CSSIcon.asClassNameArray,I.asClassName=D.CSSIcon.asClassName,I.asCSSSelector=D.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function E(I){switch(I){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class h{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,R.toDisposable)(()=>{const C=this.themingParticipants.indexOf(g);this.themingParticipants.splice(C,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new h;A.Registry.add(e.Extensions.ThemingContribution,b);function c(I){return b.onColorThemeChange(I)}e.registerThemingParticipant=c;class y extends R.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(C=>this.onThemeChange(C)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,C){let v=this.theme.getColor(g);return v&&C&&(v=C(v,this.theme)),v?v.toString():null}}e.Themable=y}),define(te[192],ne([0,1,48,86]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function R(P,m){const w=P.map(i=>({name:i.profileName,description:k(i)}));return m&&w.push(...m.map(i=>({name:i.title,description:A(i)}))),{values:w.map(i=>i.name),markdownDescriptions:w.map(i=>i.description)}}e.createProfileSchemaEnums=R;function k(P){let m=`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.profileName}
- path: ${P.path}`;return P.args&&(typeof P.args=="string"?m+=`
- args: "${P.args}"`:m+=`
- args: [${P.args.length===0?"":`'${P.args.join("','")}'`}]`),P.overrideName!==void 0&&(m+=`
- overrideName: ${P.overrideName}`),P.color&&(m+=`
- color: ${P.color}`),P.env&&(m+=`
- env: ${JSON.stringify(P.env)}`),m}function A(P){return`$(${L.ThemeIcon.isThemeIcon(P.icon)?P.icon.id:P.icon?P.icon:D.Codicon.terminal.id}) ${P.title}
- extensionIdenfifier: ${P.extensionIdentifier}`}}),define(te[193],ne([0,1,48,127,38,32,192]),function(Y,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(D.iconRegistry.all,I=>I.id),markdownEnumDescriptions:Array.from(D.iconRegistry.all,I=>`$(${I.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},w=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),i=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),E=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),h={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:i},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:i},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:E},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(23,null),type:"string"},id:{description:(0,L.localize)(24,null),type:"string"},title:{description:(0,L.localize)(25,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(27,null),type:"string"},id:{description:(0,L.localize)(28,null),type:"string"},title:{description:(0,L.localize)(29,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(31,null),type:"string"},id:{description:(0,L.localize)(32,null),type:"string"},title:{description:(0,L.localize)(33,null),type:"string"},...P}},{type:"null"},m]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(36,null),type:"number",default:100},["terminal.integrated.persistentSessionExperimentalSerializer"]:{scope:1,description:(0,L.localize)(37,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(38,null),type:"boolean",default:!0}}};function b(){k.Registry.as(R.Extensions.Configuration).registerConfiguration(h),y()}e.registerTerminalPlatformConfiguration=b;let c;function y(I,g){const C=k.Registry.as(R.Extensions.Configuration);c&&C.deregisterConfigurations([c]);let v;I&&(v=(0,A.createProfileSchemaEnums)(I?.profiles,g)),c={id:"terminal",order:100,title:(0,L.localize)(39,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(40,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:I?.os===3?v?.values:void 0,markdownEnumDescriptions:I?.os===3?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(41,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:I?.os===2?v?.values:void 0,markdownEnumDescriptions:I?.os===2?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(42,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:I?.os===1?v?.values:void 0,markdownEnumDescriptions:I?.os===1?v?.markdownDescriptions:void 0}}},C.registerConfiguration(c)}e.registerTerminalDefaultProfileConfiguration=y}),define(te[194],ne([0,1,41,48,8,4,18,69,190,86]),function(Y,e,D,L,R,k,A,P,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let i;function E(t,r,n,s,u=process.env,l,f,d,S){return l=l||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},k.isWindows?h(n,l,u,f,s.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:s.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:s.getValue("terminal.integrated.defaultProfile.windows"),S,d):v(l,f,n,t&&typeof t=="object"?{...t}:s.getValue(k.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:s.getValue(k.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),S,d,u)}e.detectAvailableProfiles=E;async function h(t,r,n,s,u,l,f,d,S){const T=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${T?"Sysnative":"System32"}`;let p=!1;(0,m.getWindowsBuildNumber)()>=16299&&(p=!0),await y(d);const F=new Map;t&&(F.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),F.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),F.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0})),o(l,F);const M=await b(F.entries(),f,r,n,s,S);if(t||!t&&u)try{const W=await g(`${O}\\${p?"wsl":"bash"}.exe`,f);for(const j of W)(!l||!(j.profileName in l))&&M.push(j)}catch(W){s?.info("WSL is not installed, so could not detect WSL profiles")}return M}async function b(t,r,n,s=process.env,u,l){const f=[];for(const[d,S]of t){if(S===null)continue;let T,O,p;if("source"in S){const W=i?.get(S.source);if(!W)continue;T=W.paths,O=S.args||W.args,S.icon?p=c(S.icon):W.icon&&(p=W.icon)}else T=Array.isArray(S.path)?S.path:[S.path],O=k.isWindows||Array.isArray(S.args)?S.args:void 0,p=c(S.icon)||void 0;const F=await l?.(T)||T.slice(),M=await a(d,r,F,n,s,O,S.env,S.overrideName,S.isAutoDetected,u);M?(M.isAutoDetected=S.isAutoDetected,M.icon=p,M.color=S.color,f.push(M)):u?.trace("profile not validated",d,T)}return f}function c(t){return typeof t=="string"?{id:t}:t}async function y(t){i&&!t||(i=new Map,i.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),i.set("PowerShell",{profileName:"PowerShell",paths:t||await I(),icon:w.ThemeIcon.asThemeIcon(L.Codicon.terminalPowershell)}))}async function I(){const t=[];for await(const r of(0,P.enumeratePowerShellInstallations)())t.push(r.exePath);return t}async function g(t,r){const n=[],s=await new Promise((f,d)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le"},(S,T)=>{if(S)return d("Problem occurred when getting wsl distros");f(T)})});if(!s)return[];const u=new RegExp(/[\r?\n]/),l=s.split(u).filter(f=>f.trim().length>0&&f!=="");for(const f of l){if(f===""||f.startsWith("docker-desktop"))continue;const d=`${f} (WSL)`,S={profileName:d,path:t,args:["-d",`${f}`],isDefault:d===r,icon:C(f)};n.push(S)}return n}function C(t){return t.includes("Ubuntu")?w.ThemeIcon.asThemeIcon(L.Codicon.terminalUbuntu):t.includes("Debian")?w.ThemeIcon.asThemeIcon(L.Codicon.terminalDebian):w.ThemeIcon.asThemeIcon(L.Codicon.terminalLinux)}async function v(t,r,n,s,u,l,f,d){const S=new Map;if(n){const T=(await t.readFile("/etc/shells")).toString(),O=l||T.split(`
`).filter(F=>F.trim().indexOf("#")!==0&&F.trim().length>0),p=new Map;for(const F of O){let M=(0,R.basename)(F),W=p.get(M)||0;W++,W>1&&(M=`${M} (${W})`),p.set(M,W),S.set(M,{path:F,isAutoDetected:!0})}}return o(s,S),await b(S.entries(),u,t,d,r,f)}function o(t,r){if(!!t)for(const[n,s]of Object.entries(t))s===null||!("path"in s)&&!("source"in s)?r.delete(n):r.set(n,s)}async function a(t,r,n,s,u,l,f,d,S,T){if(n.length===0)return Promise.resolve(void 0);const O=n.shift();if(O==="")return a(t,r,n,s,u,l,f,d,S);const p={profileName:t,path:O,args:l,env:f,overrideName:d,isAutoDetected:S,isDefault:t===r};if((0,R.basename)(O)===O){const M=u.PATH?u.PATH.split(R.delimiter):void 0;return await(0,m.findExecutable)(O,void 0,M,void 0,s.existsFile)?p:a(t,r,n,s,u,l)}return await s.existsFile((0,R.normalize)(O))?p:a(t,r,n,s,u,l,f,d,S)}}),define(te[195],ne([0,1,3,2,17,4,36,51,24,156,14,79,21,188,85,193,194]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(o){o[o.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let C=0,v=class extends L.Disposable{constructor(a,t,r,n){super();this._reconnectConstants=a,this._configurationService=t,this._logService=r,this._telemetryService=n,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new D.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new D.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new D.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new D.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new D.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,(0,y.registerTerminalPlatformConfiguration)(),this._shellEnv=k.isWindows?Promise.resolve(process.env):(0,w.resolveShellEnv)(this._logService,{_:[]},process.env),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new b.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const a=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:C,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback,VSCODE_RECONNECT_EXPERIMENTAL_SERIALIZATION:this._reconnectConstants.useExperimentalSerialization?1:0}});this._onPtyHostStart.fire(),A.ProxyChannel.toService(a.getChannel(c.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(a.onDidProcessExit(s=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(s.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))}));const r=a.getChannel(c.TerminalIpcChannels.Log);E.LogLevelChannelClient.setLevel(r,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{E.LogLevelChannelClient.setLevel(r,this._logService.getLevel())}));const n=A.ProxyChannel.toService(a.getChannel(c.TerminalIpcChannels.PtyHost));return this._register(n.onProcessData(s=>this._onProcessData.fire(s))),this._register(n.onProcessExit(s=>this._onProcessExit.fire(s))),this._register(n.onProcessReady(s=>this._onProcessReady.fire(s))),this._register(n.onProcessTitleChanged(s=>this._onProcessTitleChanged.fire(s))),this._register(n.onProcessShellTypeChanged(s=>this._onProcessShellTypeChanged.fire(s))),this._register(n.onProcessOverrideDimensions(s=>this._onProcessOverrideDimensions.fire(s))),this._register(n.onProcessResolvedShellLaunchConfig(s=>this._onProcessResolvedShellLaunchConfig.fire(s))),this._register(n.onProcessDidChangeHasChildProcesses(s=>this._onProcessDidChangeHasChildProcesses.fire(s))),this._register(n.onProcessReplay(s=>this._onProcessReplay.fire(s))),this._register(n.onProcessOrphanQuestion(s=>this._onProcessOrphanQuestion.fire(s))),this._register(n.onDidRequestDetach(s=>this._onDidRequestDetach.fire(s))),[a,n]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,t,r,n,s,u,l,f,d,S,T){const O=setTimeout(()=>this._handleUnresponsiveCreateProcess(),c.HeartbeatConstants.CreateProcessTimeout),p=await this._proxy.createProcess(a,t,r,n,s,u,l,f,d,S,T);return clearTimeout(O),C=Math.max(C,p),p}updateTitle(a,t,r){return this._proxy.updateTitle(a,t,r)}updateIcon(a,t,r){return this._proxy.updateIcon(a,t,r)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,t){return this._proxy.shutdown(a,t)}input(a,t){return this._proxy.input(a,t)}processBinary(a,t){return this._proxy.processBinary(a,t)}resize(a,t,r){return this._proxy.resize(a,t,r)}acknowledgeDataEvent(a,t){return this._proxy.acknowledgeDataEvent(a,t)}setUnicodeVersion(a,t){return this._proxy.setUnicodeVersion(a,t)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,t,r,n=!1){const s=await this._shellEnv;return(0,I.detectAvailableProfiles)(t,r,n,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,t){return this._proxy.requestDetachInstance(a,t)}async acceptDetachInstanceReply(a,t){return this._proxy.acceptDetachInstanceReply(a,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),c.HeartbeatConstants.BeatInterval*c.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${c.HeartbeatConstants.BeatInterval*c.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),c.HeartbeatConstants.BeatInterval*c.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(c.HeartbeatConstants.BeatInterval*c.HeartbeatConstants.FirstWaitMultiplier+c.HeartbeatConstants.BeatInterval*c.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${c.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,t){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:t})}async acceptPtyHostResolvedVariables(a,t){this._resolveVariablesRequestStore.acceptReply(a,t)}};v=he([X(1,m.IConfigurationService),X(2,i.ILogService),X(3,h.ITelemetryService)],v),e.PtyHostService=v}),define(te[54],ne([0,1,43]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(A,P,m,w){const i=(0,D.setProperty)(A,P,m,w)[0];return i&&(A=A.substring(0,i.offset)+i.content+A.substring(i.offset+i.length)),A}e.edit=L;function R(A,P,m){let w=m;for(;w>=0;){if(A.charAt(w)===P.charAt(P.length-1)&&P.length===1)return w+1;if(w--,P.length===2&&w>=0&&A.charAt(w)===P.charAt(0))return w+2}return 0}e.getLineStartOffset=R;function k(A,P,m){let w=m;for(;w>=0;)if(A.charAt(w)===P.charAt(P.length-1)&&P.length===1||(w++,P.length===2&&w>=0&&A.charAt(w)===P.charAt(1)))return w;return A.length-1}e.getLineEndOffset=k}),define(te[196],ne([0,1,26,58]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(E,h,b,c,y){const I=[],g=[],C=[];if(!h){const O=E.filter(({identifier:p})=>y.every(F=>F.toLowerCase()!==p.id.toLowerCase()));return{local:{added:I,removed:g,updated:C},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}E=E.map(w),h=h.map(w),b=b?b.map(w):null;const v=new Map,o=O=>{O.uuid&&v.set(O.id.toLowerCase(),O.uuid)};E.forEach(({identifier:O})=>o(O)),h.forEach(({identifier:O})=>o(O)),b&&b.forEach(({identifier:O})=>o(O));const a=O=>{const p=O.identifier.uuid||v.get(O.identifier.id.toLowerCase());return p?`uuid:${p}`:`id:${O.identifier.id.toLowerCase()}`},t=(O,p)=>(O.set(a(p),p),O),r=E.reduce(t,new Map),n=h.reduce(t,new Map),s=h.reduce((O,p)=>{const F=a(p);p=(0,D.deepClone)(p);const M=r.get(F);return M&&(M.installed&&(p.installed=!0),p.version||(p.version=M.version)),t(O,p)},new Map),u=b?b.reduce(t,new Map):null,l=c.reduce(t,new Map),f=y.reduce((O,p)=>{const F=v.get(p.toLowerCase());return O.add(F?`uuid:${F}`:`id:${p.toLowerCase()}`)},new Set),d=k(r,n,f);if(d.added.size>0||d.removed.size>0||d.updated.size>0){const O=k(u,r,f),p=k(u,n,f),F=(M,W)=>{const j=r.get(M);if(j){const U=n.get(M);return{...W?U:j,version:(U.version&&L.gt(U.version,j.version),j.version),state:A(j,U,u?.get(M))}}};for(const M of p.removed.values()){const W=r.get(M);W&&g.push(W.identifier)}for(const M of p.added.values())if(O.added.has(M)){if(d.updated.has(M)){const W=F(M,!0);W&&(C.push(i(W,M)),s.set(M,W))}}else{const W=n.get(M);W.installed&&I.push(i(W,M))}for(const M of p.updated.values()){const W=F(M,!0);W&&(C.push(i(W,M)),s.set(M,W))}for(const M of O.added.values())p.added.has(M)||s.set(M,r.get(M));for(const M of O.updated.values())if(!p.removed.has(M)&&!p.updated.has(M)){const W=F(M,!1);W&&(s.get(M)?.installed&&(W.installed=!0),s.set(M,W))}for(const M of O.removed.values())!l.has(M)&&!p.updated.has(M)&&u?.get(M)?.installed&&s.delete(M)}const S=[],T=k(n,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(T.added.size>0||T.updated.size>0||T.removed.size>0)&&s.forEach((O,p)=>S.push(i(O,p))),{local:{added:I,removed:g,updated:C},remote:S.length?{added:[...T.added].map(O=>s.get(O)),updated:[...T.updated].map(O=>s.get(O)),removed:[...T.removed].map(O=>n.get(O)),all:S}:null}}e.merge=R;function k(E,h,b,{checkInstalledProperty:c,checkVersionProperty:y}={checkInstalledProperty:!1,checkVersionProperty:!1}){const I=E?[...E.keys()].filter(a=>!b.has(a)):[],g=[...h.keys()].filter(a=>!b.has(a)),C=g.filter(a=>I.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),v=I.filter(a=>g.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),o=new Set;for(const a of I){if(v.has(a))continue;const t=E.get(a),r=h.get(a);(!r||t.disabled!==r.disabled||!m(t.state,r.state)||y&&t.version!==r.version||c&&t.installed!==r.installed)&&o.add(a)}return{added:C,removed:v,updated:o}}function A(E,h,b){const c=E.state,y=h.state,I=b?.state;if(!h.version||c&&L.gt(E.version,h.version))return c;if(y&&L.gt(h.version,E.version)||!c)return y;if(!y)return c;const g=(0,D.deepClone)(c),C=I?P(I,y):{added:Object.keys(y).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set},v=I?P(I,c):{added:Object.keys(c).reduce((o,a)=>(o.add(a),o),new Set),removed:new Set,updated:new Set};for(const o of[...C.added.values(),...C.updated.values()])g[o]=y[o];for(const o of C.removed.values())v.updated.has(o)||delete g[o];return g}function P(E,h){const b=Object.keys(E),c=Object.keys(h),y=c.filter(C=>b.indexOf(C)===-1).reduce((C,v)=>(C.add(v),C),new Set),I=b.filter(C=>c.indexOf(C)===-1).reduce((C,v)=>(C.add(v),C),new Set),g=new Set;for(const C of b){if(I.has(C))continue;const v=E[C],o=h[C];(0,D.equals)(v,o)||g.add(C)}return{added:y,removed:I,updated:g}}function m(E={},h={}){const{added:b,removed:c,updated:y}=P(E,h);return b.size===0&&c.size===0&&y.size===0}function w(E){return{...E,disabled:!!E.disabled,installed:!!E.installed}}function i(E,h){const b={identifier:{id:E.identifier.id,uuid:h.startsWith("uuid:")?h.substring("uuid:".length):void 0}};return E.version&&(b.version=E.version),E.disabled&&(b.disabled=!0),E.installed&&(b.installed=!0),E.state&&(b.state=E.state),b}}),define(te[87],ne([0,1,19,3,2,31,7,28,20]),function(Y,e,D,L,R,k,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,A.createDecorator)("IExtensionsStorageSyncService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let i=class Ze extends R.Disposable{constructor(h,b){super();this.storageService=h,this.productService=b,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(c=>this.onDidChangeStorageValue(c)))}static toKey(h){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static fromKey(h){const b=w.exec(h);if(b&&b[1])return{id:b[1],version:b[2]}}initialize(){const h=this.storageService.keys(0,1);for(const b of h){const c=Ze.fromKey(b);c&&this.extensionsWithKeysForSync.add(c.id.toLowerCase())}}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const b=Ze.fromKey(h.key);if(b){this.extensionsWithKeysForSync.add(b.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(h,b){this.storageService.store(Ze.toKey(h),JSON.stringify(b),0,1)}getKeysForSync(h){const b=this.productService.extensionSyncedKeys?.[h.id.toLowerCase()],c=this.storageService.get(Ze.toKey(h),0),y=c?JSON.parse(c):void 0;return y&&b?(0,D.distinct)([...y,...b]):y||b}};i=he([X(0,m.IStorageService),X(1,P.IProductService)],i),e.ExtensionsStorageSyncService=i}),define(te[88],ne([0,1,19,24,7]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,m){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return w=w.filter(i=>i!==P&&i!==`-${P}`),m&&w.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,1)}updateSynchronizedExtensions(P,m){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(i=>i.toLowerCase());return w=w.filter(i=>i!==P&&i!==`-${P}`),m&&w.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,1)}getIgnoredExtensions(P){const m=P.filter(h=>h.isMachineScoped).map(h=>h.identifier.id.toLowerCase()),w=this.getConfiguredIgnoredExtensions().map(h=>h.toLowerCase()),i=[],E=[];if(Array.isArray(w))for(const h of w)h.startsWith("-")?E.push(h.substring(1)):i.push(h);return(0,D.distinct)([...m,...i].filter(h=>E.indexOf(h)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(m=>m.toLowerCase())}};k=he([X(0,L.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(te[197],ne([0,1,19,33,26,150,54]),function(Y,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(o){return(0,L.parse)(o)||[]}e.parseKeybindings=P;async function m(o,a,t,r,n){const s=P(o),u=P(a),l=t?P(t):null,f=[...s,...u,...l||[]].map(N=>N.key),d=await n.resolveUserBindings(f);let S=i(s,u,l,d);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:o,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:o,hasChanges:!0,hasConflicts:!1};const T=h(s),O=h(u),p=l?h(l):null,F=c(T,O,d),M=p?c(p,T,d):{added:[...T.keys()].reduce((N,z)=>(N.add(z),N),new Set),removed:new Set,updated:new Set},W=p?c(p,O,d):{added:[...O.keys()].reduce((N,z)=>(N.add(z),N),new Set),removed:new Set,updated:new Set},j=w(F,M,W);let U=o;for(const N of j.removed.values())j.conflicts.has(N)||(U=C(U,N,r));for(const N of j.added.values()){if(j.conflicts.has(N))continue;const z=O.get(N);if(z.some(H=>H.command!==`-${N}`&&S.conflicts.has(d[H.key]))){j.conflicts.add(N);continue}U=g(U,z,r)}for(const N of j.updated.values()){if(j.conflicts.has(N))continue;const z=O.get(N);if(z.some(H=>H.command!==`-${N}`&&S.conflicts.has(d[H.key]))){j.conflicts.add(N);continue}U=v(U,N,z,r)}return{mergeContent:U,hasChanges:!0,hasConflicts:j.conflicts.size>0}}e.merge=m;function w(o,a,t){const r=new Set,n=new Set,s=new Set,u=new Set;for(const l of a.removed.values())t.updated.has(l)&&u.add(l);for(const l of t.removed.values())u.has(l)||(a.updated.has(l)?u.add(l):n.add(l));for(const l of a.added.values())u.has(l)||t.added.has(l)&&o.updated.has(l)&&u.add(l);for(const l of t.added.values())u.has(l)||(a.added.has(l)?o.updated.has(l)&&u.add(l):r.add(l));for(const l of a.updated.values())u.has(l)||t.updated.has(l)&&o.updated.has(l)&&u.add(l);for(const l of t.updated.values())u.has(l)||(a.updated.has(l)?o.updated.has(l)&&u.add(l):s.add(l));return{added:r,removed:n,updated:s,conflicts:u}}function i(o,a,t,r){const n=new Set,s=E(o,r),u=E(a,r),l=t?E(t,r):null,f=b(s,u);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const d=l?b(l,s):{added:[...s.keys()].reduce((M,W)=>(M.add(W),M),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const S=l?b(l,u):{added:[...u.keys()].reduce((M,W)=>(M.add(W),M),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:T,removed:O,updated:p,conflicts:F}=w(f,d,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:T,removed:O,updated:p,conflicts:F}}function E(o,a){const t=new Map;for(const r of o){const n=a[r.key];let s=t.get(n);s||(s=[],t.set(n,s)),s.push(r)}return t}function h(o){const a=new Map;for(const t of o){const r=t.command[0]==="-"?t.command.substring(1):t.command;let n=a.get(r);n||(n=[],a.set(r,n)),n.push(t)}return a}function b(o,a){const t=[...o.keys()],r=[...a.keys()],n=r.filter(l=>t.indexOf(l)===-1).reduce((l,f)=>(l.add(f),l),new Set),s=t.filter(l=>r.indexOf(l)===-1).reduce((l,f)=>(l.add(f),l),new Set),u=new Set;for(const l of t){if(s.has(l))continue;const f=o.get(l).map(S=>({...S,key:l})),d=a.get(l).map(S=>({...S,key:l}));(0,D.equals)(f,d,(S,T)=>I(S,T))||u.add(l)}return{added:n,removed:s,updated:u}}function c(o,a,t){const r=[...o.keys()],n=[...a.keys()],s=n.filter(f=>r.indexOf(f)===-1).reduce((f,d)=>(f.add(d),f),new Set),u=r.filter(f=>n.indexOf(f)===-1).reduce((f,d)=>(f.add(d),f),new Set),l=new Set;for(const f of r){if(u.has(f))continue;const d=o.get(f).map(T=>({...T,key:t[T.key]})),S=a.get(f).map(T=>({...T,key:t[T.key]}));y(d,S)||l.add(f)}return{added:s,removed:u,updated:l}}function y(o,a){return!(!(0,D.equals)(o.filter(({command:t})=>t[0]!=="-"),a.filter(({command:t})=>t[0]!=="-"),(t,r)=>I(t,r))||!(0,D.equals)(o.filter(({command:t})=>t[0]==="-"),a.filter(({command:t})=>t[0]==="-"),(t,r)=>I(t,r)))}function I(o,a){if(o.command!==a.command||o.key!==a.key)return!1;const t=k.ContextKeyExpr.deserialize(o.when),r=k.ContextKeyExpr.deserialize(a.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!R.equals(o.args,a.args))}function g(o,a,t){for(const r of a)o=A.edit(o,[-1],r,t);return o}function C(o,a,t){const r=P(o);for(let n=r.length-1;n>=0;n--)(r[n].command===a||r[n].command===`-${a}`)&&(o=A.edit(o,[n],void 0,t));return o}function v(o,a,t,r){const n=P(o),s=n.findIndex(u=>u.command===a||u.command===`-${a}`);for(let u=n.length-1;u>=0;u--)(n[u].command===a||n[u].command===`-${a}`)&&(o=A.edit(o,[u],void 0,r));for(let u=t.length-1;u>=0;u--)o=A.edit(o,[s],t[u],r);return o}}),define(te[198],ne([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(k,A,P){const m={},w={},i=new Set;if(!A)return{local:{added:m,updated:w,removed:[...i.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const E=L(k,A);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:m,updated:w,removed:[...i.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const h=L(P,k),b=L(P,A),c={},y={},I=new Set,g=new Set;for(const C of h.removed.values())b.updated.has(C)?m[C]=A[C]:I.add(C);for(const C of b.removed.values())g.has(C)||(h.updated.has(C)?g.add(C):i.add(C));for(const C of h.updated.values())g.has(C)||(b.updated.has(C)?E.updated.has(C)&&g.add(C):y[C]=k[C]);for(const C of b.updated.values())g.has(C)||(h.updated.has(C)?E.updated.has(C)&&g.add(C):k[C]!==void 0&&(w[C]=A[C]));for(const C of h.added.values())g.has(C)||(b.added.has(C)?E.updated.has(C)&&g.add(C):c[C]=k[C]);for(const C of b.added.values())g.has(C)||(h.added.has(C)?E.updated.has(C)&&g.add(C):m[C]=A[C]);return{local:{added:m,removed:[...i.values()],updated:w},remote:{added:c,removed:[...I.values()],updated:y},conflicts:[...g.values()]}}e.merge=D;function L(k,A){const P=k?Object.keys(k):[],m=A?Object.keys(A):[],w=m.filter(h=>P.indexOf(h)===-1).reduce((h,b)=>(h.add(b),h),new Set),i=P.filter(h=>m.indexOf(h)===-1).reduce((h,b)=>(h.add(b),h),new Set),E=new Set;for(const h of P){if(i.has(h))continue;const b=k[h],c=A[h];b!==c&&E.add(h)}return{added:w,removed:i,updated:E}}function R(k,A){const{added:P,removed:m,updated:w}=L(k,A);return P.size===0&&m.size===0&&w.size===0}e.areSame=R}),define(te[22],ne([0,1,19,15,16,132,38,27,7,81,32]),function(Y,e,D,L,R,k,A,P,m,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const l=i.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(l).filter(f=>!!l[f].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function h(){const l=i.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(l).filter(T=>!!l[T].ignoreSync),d=Object.keys(l).filter(T=>l[T].scope===2||l[T].scope===6),S=E();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...f,...d,...S])}e.getDefaultIgnoredSettings=h;function b(){const l="vscode://schemas/ignoredSettings",f=i.Registry.as(A.Extensions.Configuration);f.registerConfiguration({id:"settingsSync",order:30,title:(0,k.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,k.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,k.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,k.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,k.localize)(4,null),default:[],scope:1,$ref:l,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=i.Registry.as(w.Extensions.JSONContribution),S=()=>{const T=E(),O=h().filter(W=>W!==e.CONFIGURATION_SYNC_STORE_KEY),p=Object.keys(A.allSettings.properties).filter(W=>O.indexOf(W)===-1),F=O.filter(W=>T.indexOf(W)===-1),M={items:{type:"string",enum:[...p,...F.map(W=>`-${W}`)]}};d.registerSchema(l,M)};return f.onDidUpdateConfiguration(()=>S())}e.registerConfiguration=b;function c(l){return l&&(0,R.isObject)(l)&&(0,R.isString)(l.id)&&(0,R.isArray)(l.scopes)}e.isAuthenticationProvider=c;var y;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Extensions="extensions",l.GlobalState="globalState"})(y=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function I(l,f,d){return d.joinPath(f.userDataSyncHome,l,`lastSync${l}.json`)}e.getLastSyncResourceUri=I,e.IUserDataSyncStoreManagementService=(0,m.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,m.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,m.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function g(l){const f={};return f[e.HEADER_EXECUTION_ID]=l,f}e.createSyncHeaders=g;var C;(function(l){l.Unauthorized="Unauthorized",l.Conflict="Conflict",l.Gone="Gone",l.PreconditionFailed="PreconditionFailed",l.TooLarge="TooLarge",l.UpgradeRequired="UpgradeRequired",l.PreconditionRequired="PreconditionRequired",l.TooManyRequests="RemoteTooManyRequests",l.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",l.RequestFailed="RequestFailed",l.RequestCanceled="RequestCanceled",l.RequestTimeout="RequestTimeout",l.RequestProtocolNotSupported="RequestProtocolNotSupported",l.RequestPathNotEscaped="RequestPathNotEscaped",l.RequestHeadersNotObject="RequestHeadersNotObject",l.NoRef="NoRef",l.EmptyResponse="EmptyResponse",l.TurnedOff="TurnedOff",l.SessionExpired="SessionExpired",l.ServiceChanged="ServiceChanged",l.DefaultServiceChanged="DefaultServiceChanged",l.LocalTooManyRequests="LocalTooManyRequests",l.LocalPreconditionFailed="LocalPreconditionFailed",l.LocalInvalidContent="LocalInvalidContent",l.LocalError="LocalError",l.IncompatibleLocalContent="IncompatibleLocalContent",l.IncompatibleRemoteContent="IncompatibleRemoteContent",l.UnresolvedConflicts="UnresolvedConflicts",l.Unknown="Unknown"})(C=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class v extends Error{constructor(f,d,S,T){super(f);this.code=d,this.resource=S,this.operationId=T,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=v;class o extends v{constructor(f,d,S,T,O){super(f,S,void 0,O);this.url=d,this.serverCode=T}}e.UserDataSyncStoreError=o;class a extends v{constructor(f,d){super(f,d)}}e.UserDataAutoSyncError=a,function(l){function f(d){if(d instanceof l)return d;const S=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(S&&S[1]){const T=S[2]==="unknown"?void 0:S[2],O=S[3]==="unknown"?void 0:S[3];return new l(d.message,S[1],T,O)}return new l(d.message,"Unknown")}l.toUserDataSyncError=f}(v=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(l){l.Uninitialized="uninitialized",l.Idle="idle",l.Syncing="syncing",l.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(l){l[l.None=0]="None",l[l.Added=1]="Added",l[l.Modified=2]="Modified",l[l.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var n;(function(l){l.Preview="preview",l.Conflict="conflict",l.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(l){return`sync.enable.${l}`}e.getEnablementKey=s,e.IUserDataSyncResourceEnablementService=(0,m.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,m.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,m.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,m.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,m.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,m.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function u(l,f){if(l.scheme!==e.USER_DATA_SYNC_SCHEME)return l=l.with({scheme:f.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,L.isEqualOrParent)(l,(0,L.joinPath)(f.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=u}),define(te[46],ne([0,1,19,6,25,29,3,33,2,15,23,16,5,128,24,12,13,45,20,21,22]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y,I,g,C,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function a(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=a;let t=class extends m.Disposable{constructor(l,f,d,S,T,O,p,F,M,W){super();this.resource=l,this.fileService=f,this.environmentService=d,this.userDataSyncStoreService=T,this.userDataSyncBackupStoreService=O,this.userDataSyncResourceEnablementService=p,this.telemetryService=F,this.logService=M,this.configurationService=W,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new L.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,i.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(d.userDataSyncHome,1024)?w.extUri:w.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(d.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,o.PREVIEW_DIR_NAME),this.lastSyncResource=(0,o.getLastSyncResourceUri)(l,d,this.extUri),this.currentMachineIdPromise=(0,g.getServiceMachineId)(d,f,S)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const f=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0);this.setStatus(f)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?(await this.doGenerateSyncResourcePreview(l,l,!0,k.CancellationToken.None)).resourcePreviews.some(({remoteChange:d})=>d!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){if(this._status!==l){const f=this._status;l==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),f==="hasConflicts"&&l==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=l,this._onDidChangStatus.fire(l)}}async sync(l,f={}){await this._sync(l,!0,f)}async preview(l,f={}){return this._sync(l,!1,f)}async apply(l,f={}){try{this.syncHeaders={...f};const d=await this.doApply(l);return this.setStatus(d),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,f,d){try{if(this.syncHeaders={...d},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let S="idle";try{const T=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(l,T);return S=await this.performSync(O,T,f),S==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):S==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(S)}}finally{this.syncHeaders={}}}async replace(l){const f=await this.resolveContent(l);if(!f)return!1;const d=this.parseSyncData(f);if(!d)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const S=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(null,S),O=await this.isRemoteDataFromCurrentMachine(T),p=await this.generateSyncPreview({ref:T.ref,syncData:d},S,O,k.CancellationToken.None),F=[];for(const M of p){const W=await this.getAcceptResult(M,M.remoteResource,void 0,k.CancellationToken.None),{remoteChange:j}=await this.getAcceptResult(M,M.previewResource,M.remoteContent,k.CancellationToken.None);F.push([M,{...W,remoteChange:j!==0?j:2}])}await this.applyResult(T,S,F,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const f=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===f}async getLatestRemoteUserData(l,f){if(f){const d=l&&l.latest?l.latest[this.resource]:void 0;if(f.ref===d||d===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async performSync(l,f,d){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new o.UserDataSyncError((0,b.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,f,d)}catch(S){if(S instanceof o.UserDataSyncError)switch(S.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,f,d);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.performSync(l,f,d)}throw S}}async doSync(l,f,d){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,L.createCancelablePromise)(T=>this.doGenerateSyncResourcePreview(l,f,d,T)));const S=await this.syncPreviewPromise;return this.updateConflicts(S.resourcePreviews),S.resourcePreviews.some(({mergeState:T})=>T==="conflict")?"hasConflicts":d?await this.doApply(!1):"syncing"}catch(S){throw this.syncPreviewPromise=null,S}}async merge(l){return await this.updateSyncResourcePreview(l,async f=>{const d=await this.getMergeResult(f,k.CancellationToken.None);await this.fileService.writeFile(f.previewResource,R.VSBuffer.fromString(d?.content||""));const S=d&&!d.hasConflicts?await this.getAcceptResult(f,f.previewResource,void 0,k.CancellationToken.None):void 0;return f.acceptResult=S,f.mergeState=d.hasConflicts?"conflict":S?"accepted":"preview",f.localChange=S?S.localChange:d.localChange,f.remoteChange=S?S.remoteChange:d.remoteChange,f}),this.syncPreviewPromise}async accept(l,f){return await this.updateSyncResourcePreview(l,async d=>{const S=await this.getAcceptResult(d,l,f,k.CancellationToken.None);return d.acceptResult=S,d.mergeState="accepted",d.localChange=S.localChange,d.remoteChange=S.remoteChange,d}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async f=>{const d=await this.getMergeResult(f,k.CancellationToken.None);return await this.fileService.writeFile(f.previewResource,R.VSBuffer.fromString(d.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=d.localChange,f.remoteChange=d.remoteChange,f}),this.syncPreviewPromise}async updateSyncResourcePreview(l,f){if(!this.syncPreviewPromise)return;let d=await this.syncPreviewPromise;const S=d.resourcePreviews.findIndex(({localResource:T,remoteResource:O,previewResource:p})=>this.extUri.isEqual(T,l)||this.extUri.isEqual(O,l)||this.extUri.isEqual(p,l));S!==-1&&(this.syncPreviewPromise=(0,L.createCancelablePromise)(async T=>{const O=[...d.resourcePreviews];return O[S]=await f(O[S]),{...d,resourcePreviews:O}}),d=await this.syncPreviewPromise,this.updateConflicts(d.resourcePreviews),d.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const f=await this.syncPreviewPromise;return f.resourcePreviews.some(({mergeState:d})=>d==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:d})=>d!=="accepted")?"syncing":(await this.applyResult(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(d=>[d,d.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(l){}}updateConflicts(l){const f=l.filter(({mergeState:d})=>d==="conflict");(0,D.equals)(this._conflicts,f,(d,S)=>this.extUri.isEqual(d.previewResource,S.previewResource))||(this._conflicts=f,this._onDidChangeConflicts.fire(f))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:f,ref:d})=>({created:f,uri:this.toRemoteBackupResource(d)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:f,ref:d})=>({created:f,uri:this.toLocalBackupResource(d)}))}toRemoteBackupResource(l){return h.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return h.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const f=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(f))){const{content:d}=await this.getUserData(f);if(d)return this.parseSyncData(d)?.machineId}}async resolveContent(l){const f=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(f))){const{content:d}=await this.getUserData(f);return d}return this.extUri.isEqual(l,this.toLocalBackupResource(f))?this.userDataSyncBackupStoreService.resolveContent(this.resource,f):null}async resolvePreviewContent(l){const f=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(f)for(const d of f.resourcePreviews){if(this.extUri.isEqual(d.acceptedResource,l))return d.acceptResult?d.acceptResult.content:null;if(this.extUri.isEqual(d.remoteResource,l))return d.remoteContent;if(this.extUri.isEqual(d.localResource,l))return d.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(l){}}async doGenerateSyncResourcePreview(l,f,d,S){const T=await this.isRemoteDataFromCurrentMachine(l),O=await this.generateSyncPreview(l,f,T,S),p=[];for(const F of O){const M=F.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(F.localChange===0&&F.remoteChange===0)p.push({...F,acceptedResource:M,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const W=d?await this.getMergeResult(F,S):void 0;if(S.isCancellationRequested)break;await this.fileService.writeFile(F.previewResource,R.VSBuffer.fromString(W?.content||""));const j=W&&!W.hasConflicts?await this.getAcceptResult(F,F.previewResource,void 0,S):void 0;p.push({...F,acceptResult:j,mergeState:W?.hasConflicts?"conflict":j?"accepted":"preview",localChange:j?j.localChange:W?W.localChange:F.localChange,remoteChange:j?j.remoteChange:W?W.remoteChange:F.remoteChange})}}return{remoteUserData:l,lastSyncUserData:f,resourcePreviews:p,isLastSyncFromCurrentMachine:T}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),f=JSON.parse(l.value.toString()),d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=f.version&&d&&f.version!==d,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${d}.`),await this.resetLocal(),null;const S=f;if(S.content===null)return{ref:f.ref,syncData:null};const T=JSON.parse(S.content);if(a(T))return{...f,syncData:T,content:void 0}}catch(l){l instanceof I.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,f={}){if(f.ref||f.content||f.version)throw new Error("Cannot have core properties as additional");const d=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),S={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:d,...f};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(S)))}async getRemoteUserData(l){const{ref:f,content:d}=await this.getUserData(l);let S=null;return d!==null&&(S=this.parseSyncData(d)),{ref:f,syncData:S}}parseSyncData(l){try{const f=JSON.parse(l);if(a(f))return f}catch(f){this.logService.error(f)}throw new o.UserDataSyncError((0,b.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,E.isString)(l)){const f=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:f}}else{const f=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,f,this.syncHeaders)}}async updateRemoteUserData(l,f){const d=await this.currentMachineIdPromise,S={version:this.version,machineId:d,content:l};return f=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(S),f,this.syncHeaders),{ref:f,syncData:S}}async backupLocal(l){const f={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(f))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=he([X(1,I.IFileService),X(2,y.IEnvironmentService),X(3,C.IStorageService),X(4,o.IUserDataSyncStoreService),X(5,o.IUserDataSyncBackupStoreService),X(6,o.IUserDataSyncResourceEnablementService),X(7,v.ITelemetryService),X(8,o.IUserDataSyncLogService),X(9,c.IConfigurationService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(l,f,d,S,T,O,p,F,M,W,j){super(f,d,S,T,O,p,F,M,W,j);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(U=>this.onFileChanges(U)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(l){return null}}async updateLocalFileContent(l,f,d){try{f?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(l),d?void 0:f):await this.fileService.createFile(this.file,R.VSBuffer.fromString(l),{overwrite:d})}catch(S){throw S instanceof I.FileOperationError&&S.fileOperationResult===1||S instanceof I.FileOperationError&&S.fileOperationResult===3?new o.UserDataSyncError(S.message,"LocalPreconditionFailed"):S}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};r=he([X(2,I.IFileService),X(3,y.IEnvironmentService),X(4,C.IStorageService),X(5,o.IUserDataSyncStoreService),X(6,o.IUserDataSyncBackupStoreService),X(7,o.IUserDataSyncResourceEnablementService),X(8,v.ITelemetryService),X(9,o.IUserDataSyncLogService),X(10,c.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let n=class extends r{constructor(l,f,d,S,T,O,p,F,M,W,j,U){super(l,f,d,S,T,O,p,F,M,W,U);this.userDataSyncUtilService=j,this._formattingOptions=void 0}hasErrors(l){const f=[];return(0,P.parse)(l,f,{allowEmptyContent:!0,allowTrailingComma:!0}),f.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};n=he([X(2,I.IFileService),X(3,y.IEnvironmentService),X(4,C.IStorageService),X(5,o.IUserDataSyncStoreService),X(6,o.IUserDataSyncBackupStoreService),X(7,o.IUserDataSyncResourceEnablementService),X(8,v.ITelemetryService),X(9,o.IUserDataSyncLogService),X(10,o.IUserDataSyncUtilService),X(11,c.IConfigurationService)],n),e.AbstractJsonFileSynchroniser=n;let s=class{constructor(l,f,d,S){this.resource=l,this.environmentService=f,this.logService=d,this.fileService=S,this.extUri=this.fileService.hasCapability(f.userDataSyncHome,1024)?w.extUri:w.extUriIgnorePathCase,this.lastSyncResource=(0,o.getLastSyncResourceUri)(this.resource,f,w.extUri)}async initialize({ref:l,content:f}){if(!f){this.logService.info("Remote content does not exist.",this.resource);return}const d=this.parseSyncData(f);if(!d)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:l,syncData:d})}catch(T){this.logService.error(T)}}parseSyncData(l){try{const f=JSON.parse(l);if(a(f))return f}catch(f){this.logService.error(f)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,f={}){const d={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...f};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(d)))}};s=he([X(1,y.IEnvironmentService),X(2,o.IUserDataSyncLogService),X(3,I.IFileService)],s),e.AbstractInitializer=s}),define(te[199],ne([0,1,6,11,3,43,47,23,5,24,12,27,31,13,20,21,46,196,87,88,22]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y,I,g,C,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function a(u,l){const f=JSON.parse(u.content);if(u.version===1||u.version===2){const d=(await l.getInstalled(0)).filter(S=>S.isBuiltin);for(const S of f)u.version===1&&(S.enabled===!1&&(S.disabled=!0),delete S.enabled),u.version===2&&d.every(T=>!(0,h.areSameExtensions)(T.identifier,S.identifier))&&(S.installed=!0)}return f}function t(u,l,f){const d=f.get((0,h.getExtensionId)(u,l),0)||"{}";return JSON.parse(d)}e.getExtensionStorageState=t;function r(u,l,f,d){d.store((0,h.getExtensionId)(u,l),JSON.stringify(f),0,1)}e.storeExtensionStorageState=r;let n=class at extends I.AbstractSynchroniser{constructor(l,f,d,S,T,O,p,F,M,W,j,U,N,z){super("extensions",f,l,d,S,T,U,N,M,j);this.storageService=d,this.extensionManagementService=O,this.extensionEnablementService=p,this.ignoredExtensionsManagementService=F,this.extensionGalleryService=W,this.extensionsStorageSyncService=z,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.debounce(R.Event.any(R.Event.filter(this.extensionManagementService.onDidInstallExtensions,H=>H.some(({local:V})=>!!V)),R.Event.filter(this.extensionManagementService.onDidUninstallExtension,H=>!H.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(l,f){const d=l.syncData?await a(l.syncData,this.extensionManagementService):null,S=f?.skippedExtensions||[],T=f?.syncData?await a(f.syncData,this.extensionManagementService):null,O=await this.extensionManagementService.getInstalled(),p=this.getLocalExtensions(O),F=this.ignoredExtensionsManagementService.getIgnoredExtensions(O);d?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:M,remote:W}=(0,g.merge)(p,d,T,S,F),j={local:M,remote:W,content:this.getPreviewContent(p,M.added,M.updated,M.removed),localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:W!==null?2:0};return[{skippedExtensions:S,localResource:this.localResource,localContent:this.format(p),localExtensions:p,remoteResource:this.remoteResource,remoteContent:d?this.format(d):null,previewResource:this.previewResource,previewResult:j,localChange:j.localChange,remoteChange:j.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(l,f,d,S){const T=[...f,...d],O=new Set,p=F=>{O.add(F.id.toLowerCase()),F.uuid&&O.add(F.uuid)};T.forEach(({identifier:F})=>p(F)),S.forEach(p);for(const F of l)O.has(F.identifier.id.toLowerCase())||F.identifier.uuid&&O.has(F.identifier.uuid)||T.push(F);return this.format(T)}async getMergeResult(l,f){return{...l.previewResult,hasConflicts:!1}}async getAcceptResult(l,f,d,S){if(this.extUri.isEqual(f,this.localResource))return this.acceptLocal(l);if(this.extUri.isEqual(f,this.remoteResource))return this.acceptRemote(l);if(this.extUri.isEqual(f,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async acceptLocal(l){const f=await this.extensionManagementService.getInstalled(),d=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),S=(0,g.merge)(l.localExtensions,null,null,l.skippedExtensions,d),{local:T,remote:O}=S;return{content:l.localContent,local:T,remote:O,localChange:T.added.length>0||T.removed.length>0||T.updated.length>0?2:0,remoteChange:O!==null?2:0}}async acceptRemote(l){const f=await this.extensionManagementService.getInstalled(),d=this.ignoredExtensionsManagementService.getIgnoredExtensions(f),S=l.remoteContent?JSON.parse(l.remoteContent):null;if(S!==null){const T=(0,g.merge)(l.localExtensions,S,l.localExtensions,[],d),{local:O,remote:p}=T;return{content:l.remoteContent,local:O,remote:p,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:p!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(l,f,d,S){let{skippedExtensions:T,localExtensions:O}=d[0][0],{local:p,remote:F,localChange:M,remoteChange:W}=d[0][1];if(M===0&&W===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),M!==0&&(await this.backupLocal(JSON.stringify(O)),T=await this.updateLocalExtensions(p.added,p.removed,p.updated,T)),F){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const j=JSON.stringify(F.all);l=await this.updateRemoteUserData(j,S?null:l.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${F.added.length?` Added: ${JSON.stringify(F.added.map(U=>U.identifier.id))}.`:""}${F.updated.length?` Updated: ${JSON.stringify(F.updated.map(U=>U.identifier.id))}.`:""}${F.removed.length?` Removed: ${JSON.stringify(F.removed.map(U=>U.identifier.id))}.`:""}`)}f?.ref!==l.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(l,{skippedExtensions:T}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${T.length?` Skipped: ${JSON.stringify(T.map(j=>j.identifier.id))}.`:""}`))}async getAssociatedResources({uri:l}){return[{resource:this.extUri.joinPath(l,"extensions.json"),comparableResource:at.EXTENSIONS_DATA_URI}]}async resolveContent(l){if(this.extUri.isEqual(l,at.EXTENSIONS_DATA_URI)){const d=await this.extensionManagementService.getInstalled(),S=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),T=this.getLocalExtensions(d).filter(O=>!S.some(p=>(0,h.areSameExtensions)({id:p},O.identifier)));return this.format(T)}if(this.extUri.isEqual(this.remoteResource,l)||this.extUri.isEqual(this.localResource,l)||this.extUri.isEqual(this.acceptedResource,l))return this.resolvePreviewContent(l);let f=await super.resolveContent(l);if(f)return f;if(f=await super.resolveContent(this.extUri.dirname(l)),f){const d=this.parseSyncData(f);if(d)switch(this.extUri.basename(l)){case"extensions.json":return this.format(this.parseExtensions(d))}}return null}format(l){l.sort((S,T)=>!S.identifier.uuid&&T.identifier.uuid?-1:S.identifier.uuid&&!T.identifier.uuid?1:(0,P.compare)(S.identifier.id,T.identifier.id));const f=JSON.stringify(l),d=(0,A.format)(f,void 0,{});return(0,k.applyEdits)(f,d)}async hasLocalData(){try{const l=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(l).some(d=>d.installed||d.disabled))return!0}catch(l){}return!1}async updateLocalExtensions(l,f,d,S){const T=[],O=[],p=await this.extensionManagementService.getInstalled();if(f.length){const M=p.filter(({identifier:W,isBuiltin:j})=>!j&&f.some(U=>(0,h.areSameExtensions)(W,U)));await D.Promises.settled(M.map(async W=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,W.identifier.id),await this.extensionManagementService.uninstall(W,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,W.identifier.id),T.push(W.identifier)}))}(l.length||d.length)&&await D.Promises.settled([...l,...d].map(async M=>{const W=p.find(U=>(0,h.areSameExtensions)(U.identifier,M.identifier));if(W&&W.isBuiltin){M.state&&W.manifest.version===M.version&&this.updateExtensionState(M.state,W.manifest.publisher,W.manifest.name,W.manifest.version),M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id)),T.push(M.identifier);return}const j=await this.extensionGalleryService.getCompatibleExtension(M.identifier,E.CURRENT_TARGET_PLATFORM);if(M.state&&(W?W.manifest.version===M.version:!!j)){const U=W?W.manifest.publisher:j.publisher,N=W?W.manifest.name:j.name;this.updateExtensionState(M.state,U,N,W?.manifest.version)}if(j)try{M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id,j.version),await this.extensionEnablementService.disableExtension(j.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id,j.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id,j.version),await this.extensionEnablementService.enableExtension(j.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id,j.version)),W||(await this.extensionManagementService.canInstall(j)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,M.identifier.id,j.version),await this.extensionManagementService.installFromGallery(j,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,M.identifier.id,j.version),T.push(j.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,j.displayName||j.identifier.id),O.push(M)))}catch(U){O.push(M),this.logService.error(U),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,j.displayName||j.identifier.id)}else this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,M.identifier.id),O.push(M)}));const F=[];for(const M of S)T.some(W=>(0,h.areSameExtensions)(W,M.identifier))||F.push(M);for(const M of O)F.some(W=>(0,h.areSameExtensions)(W.identifier,M.identifier))||F.push(M);return F}updateExtensionState(l,f,d,S){const T=t(f,d,this.storageService),O=S?this.extensionsStorageSyncService.getKeysForSync({id:(0,h.getGalleryExtensionId)(f,d),version:S}):void 0;O?O.forEach(p=>{T[p]=l[p]}):Object.keys(l).forEach(p=>T[p]=l[p]),r(f,d,T,this.storageService)}parseExtensions(l){return JSON.parse(l.content)}getLocalExtensions(l){const f=this.extensionEnablementService.getDisabledExtensions();return l.map(({identifier:d,isBuiltin:S,manifest:T})=>{const O={identifier:d,version:T.version};f.some(p=>(0,h.areSameExtensions)(p,d))&&(O.disabled=!0),S||(O.installed=!0);try{const p=this.extensionsStorageSyncService.getKeysForSync({id:d.id,version:T.version});if(p){const F=t(T.publisher,T.name,this.storageService);O.state=Object.keys(F).reduce((M,W)=>(p.includes(W)&&(M[W]=F[W]),M),{})}}catch(p){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)(p))}return O})}};n.EXTENSIONS_DATA_URI=m.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),n=he([X(0,i.IEnvironmentService),X(1,b.IFileService),X(2,c.IStorageService),X(3,o.IUserDataSyncStoreService),X(4,o.IUserDataSyncBackupStoreService),X(5,E.IExtensionManagementService),X(6,E.IGlobalExtensionEnablementService),X(7,v.IIgnoredExtensionsManagementService),X(8,o.IUserDataSyncLogService),X(9,E.IExtensionGalleryService),X(10,w.IConfigurationService),X(11,o.IUserDataSyncResourceEnablementService),X(12,y.ITelemetryService),X(13,C.IExtensionsStorageSyncService)],n),e.ExtensionsSynchroniser=n;let s=class extends I.AbstractInitializer{constructor(l,f,d,S,T){super("extensions",S,T,d);this.extensionManagementService=l,this.ignoredExtensionsManagementService=f}async parseExtensions(l){return l.syncData?await a(l.syncData,this.extensionManagementService):null}generatePreview(l,f){const d=[],S=[],T=[];for(const O of l){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(O.identifier.id))continue;const p=f.find(F=>(0,h.areSameExtensions)(F.identifier,O.identifier));p?(d.push(p),O.disabled&&T.push(O.identifier)):O.installed&&(S.push(O.identifier),O.disabled&&T.push(O.identifier))}return{installedExtensions:d,newExtensions:S,disabledExtensions:T,remoteExtensions:l}}};s=he([X(0,E.IExtensionManagementService),X(1,v.IIgnoredExtensionsManagementService),X(2,b.IFileService),X(3,i.IEnvironmentService),X(4,o.IUserDataSyncLogService)],s),e.AbstractExtensionsInitializer=s}),define(te[200],ne([0,1,26,22]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(P,m,w,i,E){if(!m)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const h=k(P,m);if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const b=w?k(w,m):{added:Object.keys(m).reduce((C,v)=>(C.add(v),C),new Set),removed:new Set,updated:new Set},c=w?k(w,P):{added:Object.keys(P).reduce((C,v)=>(C.add(v),C),new Set),removed:new Set,updated:new Set},y={added:{},removed:[],updated:{}},I=D.deepClone(m),g=!w;for(const C of c.added.values())C!==L.SYNC_SERVICE_URL_TYPE&&g&&b.added.has(C)||(I[C]=P[C]);for(const C of c.updated.values())I[C]=P[C];for(const C of c.removed.values())i.unregistered.includes(C)||delete I[C];for(const C of b.added.values()){const v=m[C];if(i.machine.includes(C)){E.info(`GlobalState: Skipped adding ${C} in local storage because it is declared as machine scoped.`);continue}if(w&&c.added.has(C))continue;const o=P[C];o&&o.value===v.value||C===L.SYNC_SERVICE_URL_TYPE&&g&&c.added.has(C)||(o?y.updated[C]=v:y.added[C]=v)}for(const C of b.updated.values()){const v=m[C];if(i.machine.includes(C)){E.info(`GlobalState: Skipped updating ${C} in local storage because it is declared as machine scoped.`);continue}if(c.updated.has(C)||c.removed.has(C))continue;const o=P[C];o&&o.value===v.value||(y.updated[C]=v)}for(const C of b.removed.values()){if(i.machine.includes(C)){E.trace(`GlobalState: Skipped removing ${C} in local storage because it is declared as machine scoped.`);continue}c.updated.has(C)||c.removed.has(C)||y.removed.push(C)}return{local:y,remote:A(I,m)?null:I}}e.merge=R;function k(P,m){const w=Object.keys(P),i=Object.keys(m),E=i.filter(c=>w.indexOf(c)===-1).reduce((c,y)=>(c.add(y),c),new Set),h=w.filter(c=>i.indexOf(c)===-1).reduce((c,y)=>(c.add(y),c),new Set),b=new Set;for(const c of w){if(h.has(c))continue;const y=P[c],I=m[c];D.equals(y,I)||b.add(c)}return{added:E,removed:h,updated:b}}function A(P,m){const{added:w,removed:i,updated:E}=k(P,m);return w.size===0&&i.size===0&&E.size===0}}),define(te[201],ne([0,1,25,3,33,43,47,4,5,30,24,12,13,14,45,20,21,46,54,200,22]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y,I,g,C,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const a="globalState.argv.",t=["locale"];function r(f){const d=f.storage?Object.keys(f.storage).sort():[],S={};d.forEach(p=>S[p]=f.storage[p]),f.storage=S;const T=JSON.stringify(f),O=(0,A.format)(T,void 0,{});return(0,k.applyEdits)(T,O)}const n=1;let s=class ot extends g.AbstractSynchroniser{constructor(d,S,T,O,p,F,M,W,j){super("globalState",d,p,j,S,T,F,M,O,W);this.storageService=j,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(d.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(d.onDidFilesChange,U=>U.contains(this.environmentService.argvResource)),L.Event.filter(j.onDidChangeValue,U=>U.scope===0&&U.target!==void 0?U.target===0:j.keys(0,0).includes(U.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(d,S,T,O){const p=d.syncData?JSON.parse(d.syncData.content):null;S=S===null&&T?d:S;const F=S&&S.syncData?JSON.parse(S.syncData.content):null,M=await this.getLocalGlobalState();p?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const W=this.getStorageKeys(F),{local:j,remote:U}=(0,v.merge)(M.storage,p?p.storage:null,F?F.storage:null,W,this.logService),N={content:null,local:j,remote:U,localChange:Object.keys(j.added).length>0||Object.keys(j.updated).length>0||j.removed.length>0?2:0,remoteChange:U!==null?2:0};return[{localResource:this.localResource,localContent:r(M),localUserData:M,remoteResource:this.remoteResource,remoteContent:p?r(p):null,previewResource:this.previewResource,previewResult:N,localChange:N.localChange,remoteChange:N.remoteChange,acceptedResource:this.acceptedResource,storageKeys:W}]}async getMergeResult(d,S){return{...d.previewResult,hasConflicts:!1}}async getAcceptResult(d,S,T,O){if(this.extUri.isEqual(S,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(S,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(S,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${S.toString()}`)}async acceptLocal(d){return{content:d.localContent,local:{added:{},removed:[],updated:{}},remote:d.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(d){if(d.remoteContent!==null){const S=JSON.parse(d.remoteContent),{local:T,remote:O}=(0,v.merge)(d.localUserData.storage,S.storage,null,d.storageKeys,this.logService);return{content:d.remoteContent,local:T,remote:O,localChange:Object.keys(T.added).length>0||Object.keys(T.updated).length>0||T.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:d.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(d,S,T,O){let{localUserData:p}=T[0][0],{local:F,remote:M,localChange:W,remoteChange:j}=T[0][1];if(W===0&&j===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),W!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(p)),await this.writeLocalGlobalState(F),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:M});d=await this.updateRemoteUserData(U,O?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}S?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,ot.GLOBAL_STATE_DATA_URI)){const T=await this.getLocalGlobalState();return r(T)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d))return this.resolvePreviewContent(d);let S=await super.resolveContent(d);if(S)return S;if(S=await super.resolveContent(this.extUri.dirname(d)),S){const T=this.parseSyncData(S);if(T)switch(this.extUri.basename(d)){case"globalState.json":return r(JSON.parse(T.content))}}return null}async hasLocalData(){try{const{storage:d}=await this.getLocalGlobalState();if(Object.keys(d).length>1||d[`${a}.locale`]?.value!=="en")return!0}catch(d){}return!1}async getLocalGlobalState(){const d={},S=await this.getLocalArgvContent(),T=(0,R.parse)(S);for(const O of t)T[O]!==void 0&&(d[`${a}${O}`]={version:1,value:T[O]});for(const O of this.storageService.keys(0,0)){const p=this.storageService.get(O,0);p&&(d[O]={version:1,value:p})}return{storage:d}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(d){}return"{}"}async writeLocalGlobalState({added:d,removed:S,updated:T}){const O={},p={},F=(W,j)=>{for(const U of W){if(U.startsWith(a)){O[U.substring(a.length)]=j?j[U].value:void 0;continue}if(j){const N=j[U];N.value!==String(this.storageService.get(U,0))&&(p[U]=N.value)}else this.storageService.get(U,0)!==void 0&&(p[U]=void 0)}};if(F(Object.keys(d),d),F(Object.keys(T),T),F(S),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(p).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const W of Object.keys(p))this.storageService.store(W,p[W],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(p))}}async updateArgv(d){const S=await this.getLocalArgvContent();let T=S;for(const O of Object.keys(d))T=(0,C.edit)(T,[O],d[O],{});S!==T&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(T)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(d){const S=this.storageService.keys(0,0),T=this.storageService.keys(0,1),O=[...S,...T],p=d?.storage?Object.keys(d.storage).filter(F=>!F.startsWith(a)&&!O.includes(F)&&this.storageService.get(F,0)!==void 0):[];if(!P.isWeb){const F=[...o.ALL_SYNC_RESOURCES.map(M=>(0,o.getEnablementKey)(M)),o.SYNC_SERVICE_URL_TYPE];p.push(...F),T.push(...F)}return{user:S,machine:T,unregistered:p}}};s.GLOBAL_STATE_DATA_URI=m.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=he([X(0,h.IFileService),X(1,o.IUserDataSyncStoreService),X(2,o.IUserDataSyncBackupStoreService),X(3,o.IUserDataSyncLogService),X(4,E.IEnvironmentService),X(5,o.IUserDataSyncResourceEnablementService),X(6,I.ITelemetryService),X(7,i.IConfigurationService),X(8,y.IStorageService)],s),e.GlobalStateSynchroniser=s;let u=class extends g.AbstractInitializer{constructor(d,S,T,O){super("globalState",T,O,S);this.storageService=d}async doInitialize(d){const S=d.syncData?JSON.parse(d.syncData.content):null;if(!S){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const T={},O={};for(const p of Object.keys(S.storage))p.startsWith(a)?T[p.substring(a.length)]=S.storage[p].value:this.storageService.get(p,0)===void 0&&(O[p]=S.storage[p].value);if(Object.keys(T).length){let p="{}";try{p=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(F){}for(const F of Object.keys(T))p=(0,C.edit)(p,[F],T[F],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(p))}if(Object.keys(O).length)for(const p of Object.keys(O))this.storageService.store(p,O[p],0,0)}};u=he([X(0,y.IStorageService),X(1,h.IFileService),X(2,E.IEnvironmentService),X(3,o.IUserDataSyncLogService)],u),e.GlobalStateInitializer=u;let l=class{constructor(d,S,T,O,p){this.userDataSyncStoreClient=d,this.storageService=S,this.environmentService=T,this.fileService=O,this.logService=p}getSyncStoreType(d){return this.parseGlobalState(d)?.storage[o.SYNC_SERVICE_URL_TYPE]?.value}async sync(d){const S=(0,o.createSyncHeaders)((0,w.generateUuid)());try{return await this.doSync(d,S)}catch(T){if(T instanceof o.UserDataSyncError)switch(T.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(d,S)}throw T}}async doSync(d,S){const T=await this.userDataSyncStoreClient.read("globalState",null,S),O=this.parseGlobalState(T)||{storage:{}};O.storage[o.SYNC_SERVICE_URL_TYPE]={value:d,version:n};const p=await(0,c.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),F={version:n,machineId:p,content:r(O)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(F),T.ref,S)}parseGlobalState({content:d}){if(!d)return null;const S=JSON.parse(d);if((0,g.isSyncData)(S))return S?JSON.parse(S.content):null;throw new Error("Invalid remote data")}};l=he([X(1,y.IStorageService),X(2,E.IEnvironmentService),X(3,h.IFileService),X(4,b.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(te[202],ne([0,1,19,25,3,33,4,16,129,24,12,13,20,21,46,197,22]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function g(o,a){const t=JSON.parse(o);if(!a)return(0,P.isUndefined)(t.all)?null:t.all;switch(A.OS){case 2:return(0,P.isUndefined)(t.mac)?null:t.mac;case 3:return(0,P.isUndefined)(t.linux)?null:t.linux;case 1:return(0,P.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=g;let C=class extends c.AbstractJsonFileSynchroniser{constructor(a,t,r,n,s,u,l,f,d,S){super(l.keybindingsResource,"keybindings",u,l,f,a,t,s,S,r,d,n);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:I.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(n.onDidChangeConfiguration,T=>T.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(a,t,r,n){const s=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;t=t===null&&r?a:t;const u=t?this.getKeybindingsContentFromLastSyncUserData(t):null,l=await this.getLocalFileContent(),f=await this.getFormattingOptions();let d=null,S=!1,T=!1,O=!1;if(s){let F=l?l.value.toString():"[]";if(F=F||"[]",this.hasErrors(F))throw new I.UserDataSyncError((0,m.localize)(0,null),"LocalInvalidContent",this.resource);if(!u||u!==F||u!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const M=await(0,y.merge)(F,s,u,f,this.userDataSyncUtilService);M.hasChanges&&(d=M.mergeContent,O=M.hasConflicts,S=O||M.mergeContent!==F,T=O||M.mergeContent!==s)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),d=l.value.toString(),T=!0);const p={content:d,localChange:S?l?2:1:0,remoteChange:T?2:0,hasConflicts:O};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:p.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:p.remoteChange,previewResource:this.previewResource,previewResult:p,acceptedResource:this.acceptedResource}]}async getMergeResult(a,t){return a.previewResult}async getAcceptResult(a,t,r,n){if(this.extUri.isEqual(t,this.localResource))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(a,t,r,n){const{fileContent:s}=r[0][0];let{content:u,localChange:l,remoteChange:f}=r[0][1];if(l===0&&f===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),u!==null&&(u=u.trim(),u=u||"[]",this.hasErrors(u)))throw new I.UserDataSyncError((0,m.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(u||"[]",s,n),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),f!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const d=this.toSyncContent(u||"[]",a.syncData?.content);a=await this.updateRemoteUserData(d,n?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(d){}t?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(a,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.getLocalFileContent();if(a){const t=(0,k.parse)(a.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:a}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(a,"keybindings.json"),comparableResource:t}]}async resolveContent(a){if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a))return this.resolvePreviewContent(a);let t=await super.resolveContent(a);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(a)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(a)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(a.syncData.content)}getKeybindingsContentFromSyncContent(a){try{return g(a,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(a,t){let r={};try{r=JSON.parse(t||"{}")}catch(n){this.logService.error(n)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=a,A.OS){case 2:r.mac=a;break;case 3:r.linux=a;break;case 1:r.windows=a;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};C=he([X(0,I.IUserDataSyncStoreService),X(1,I.IUserDataSyncBackupStoreService),X(2,I.IUserDataSyncLogService),X(3,w.IConfigurationService),X(4,I.IUserDataSyncResourceEnablementService),X(5,E.IFileService),X(6,i.IEnvironmentService),X(7,h.IStorageService),X(8,I.IUserDataSyncUtilService),X(9,b.ITelemetryService)],C),e.KeybindingsSynchroniser=C;let v=class extends c.AbstractInitializer{constructor(a,t,r){super("keybindings",t,r,a)}async doInitialize(a){const t=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,L.VSBuffer.fromString(t)),await this.updateLastSyncUserData(a)}async isEmpty(){try{const a=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,k.parse)(a.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(a){return a.fileOperationResult===1}}getKeybindingsContentFromSyncContent(a){try{return g(a,!0)}catch(t){return this.logService.error(t),null}}};v=he([X(0,E.IFileService),X(1,i.IEnvironmentService),X(2,I.IUserDataSyncLogService)],v),e.KeybindingsInitializer=v}),define(te[203],ne([0,1,19,33,43,47,26,54,22]),function(Y,e,D,L,R,k,A,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function w(l,f,d){let S=[];d?S=E(d):S=i(f);const T=[],O=[...(0,m.getDisallowedIgnoredSettings)()];if(Array.isArray(S))for(const p of S)p.startsWith("-")?O.push(p.substring(1)):T.push(p);return(0,D.distinct)([...l,...T].filter(p=>O.indexOf(p)===-1))}e.getIgnoredSettings=w;function i(l){let f=l.inspect("settingsSync.ignoredSettings").userValue;return f!==void 0||(f=l.inspect("sync.ignoredSettings").userValue,f!==void 0)?f:l.getValue("settingsSync.ignoredSettings")||[]}function E(l){const f=(0,L.parse)(l);return f?f["settingsSync.ignoredSettings"]||f["sync.ignoredSettings"]||[]:[]}function h(l,f,d,S){if(d.length){const T=u(f),O=(0,L.parse)(f),p=(0,L.parse)(l),F=[];for(const M of d){const W=O[M],j=p[M];W===void 0?l=P.edit(l,[M],void 0,S):j!==void 0?l=P.edit(l,[M],W,S):F.push(a(M,T))}F.sort((M,W)=>M.startOffset-W.startOffset),F.forEach(M=>l=g(M.setting.key,f,l,S))}return l}e.updateIgnoredSettings=h;function b(l,f,d,S,T,O){const p=h(l,f,S,O),F=d!==p,M=d!==f;if(!F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:p,hasConflicts:!1};if(M&&!F)return{conflictsSettings:[],localContent:h(f,l,S,O),remoteContent:null,hasConflicts:!1};if(d===null&&y(l)){const Z=c(l,f,S)?null:h(f,l,S,O);return{conflictsSettings:[],localContent:Z,remoteContent:null,hasConflicts:!1}}let W=l,j=f;const U=(0,L.parse)(l),N=(0,L.parse)(f),z=d?(0,L.parse)(d):null,H=S.reduce((Z,ce)=>(Z.add(ce),Z),new Set),V=I(U,N,H),x=I(z,U,H),K=I(z,N,H),q=new Map,$=new Set,_=Z=>{$.add(Z);const ce=T.filter(({key:ae})=>ae===Z)[0];ce?(W=P.edit(W,[Z],ce.value,O),j=P.edit(j,[Z],ce.value,O)):q.set(Z,{key:Z,localValue:U[Z],remoteValue:N[Z]})};for(const Z of x.removed.values())K.updated.has(Z)?_(Z):j=P.edit(j,[Z],void 0,O);for(const Z of K.removed.values())$.has(Z)||(x.updated.has(Z)?_(Z):W=P.edit(W,[Z],void 0,O));for(const Z of x.updated.values())$.has(Z)||(K.updated.has(Z)?V.updated.has(Z)&&_(Z):j=P.edit(j,[Z],U[Z],O));for(const Z of K.updated.values())$.has(Z)||(x.updated.has(Z)?V.updated.has(Z)&&_(Z):W=P.edit(W,[Z],N[Z],O));for(const Z of x.added.values())$.has(Z)||(K.added.has(Z)?V.updated.has(Z)&&_(Z):j=g(Z,W,j,O));for(const Z of K.added.values())$.has(Z)||(x.added.has(Z)?V.updated.has(Z)&&_(Z):W=g(Z,j,W,O));const J=q.size>0||!c(W,j,S),G=J||!c(W,l,[]),ee=J||!c(j,f,[]);return{localContent:G?W:null,remoteContent:ee?j:null,conflictsSettings:[...q.values()],hasConflicts:J}}e.merge=b;function c(l,f,d){if(l===f)return!0;const S=(0,L.parse)(l),T=(0,L.parse)(f),O=d.reduce((M,W)=>(M.add(W),M),new Set),p=u(l).filter(M=>!(M.setting&&O.has(M.setting.key))),F=u(f).filter(M=>!(M.setting&&O.has(M.setting.key)));if(p.length!==F.length)return!1;for(let M=0;M<p.length;M++){const W=p[M],j=F[M];if(W.setting&&j.setting){if(W.setting.key!==j.setting.key||!A.equals(S[W.setting.key],T[W.setting.key]))return!1}else if(!W.setting&&!j.setting){if(W.value!==j.value)return!1}else return!1}return!0}e.areSame=c;function y(l){return l?u(l).length===0:!0}e.isEmpty=y;function I(l,f,d){const S=l?Object.keys(l).filter(M=>!d.has(M)):[],T=Object.keys(f).filter(M=>!d.has(M)),O=T.filter(M=>S.indexOf(M)===-1).reduce((M,W)=>(M.add(W),M),new Set),p=S.filter(M=>T.indexOf(M)===-1).reduce((M,W)=>(M.add(W),M),new Set),F=new Set;if(l)for(const M of S){if(p.has(M))continue;const W=l[M],j=f[M];A.equals(W,j)||F.add(M)}return{added:O,removed:p,updated:F}}function g(l,f,d,S){const T=(0,L.parse)(f),O=u(f),p=u(d),F=C(l,O,p);return v(d,l,T[l],F,p,S)}e.addSetting=g;function C(l,f,d){const S=f.findIndex(O=>O.setting?.key===l),T=f[S-1];if(T){if(T.setting){const p=a(T.setting.key,d);if(p)return{index:d.indexOf(p),insertAfter:!0}}else{const p=t(S,f);if(p){const F=a(p.setting.key,d);if(F){const M=r(d.indexOf(F),d),W=n(f,p,f[S]);if(M){const j=n(d,F,M),U=s(W,j);return U?{index:d.indexOf(U),insertAfter:!0}:{index:d.indexOf(M),insertAfter:!1}}else{const j=n(d,F,d[d.length-1]),U=s(W,j);return U?{index:d.indexOf(U),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const O=f[S+1];if(O)if(O.setting){const p=a(O.setting.key,d);if(p)return{index:d.indexOf(p),insertAfter:!1}}else{const p=r(S,f);if(p){const F=a(p.setting.key,d);if(F){const M=t(d.indexOf(F),d),W=n(f,f[S],p);if(M){const j=n(d,M,F),U=s(W.reverse(),j.reverse());return U?{index:d.indexOf(U),insertAfter:!1}:{index:d.indexOf(M),insertAfter:!0}}else{const j=n(d,d[0],F),U=s(W.reverse(),j.reverse());return U?{index:d.indexOf(U),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function v(l,f,d,S,T,O){let p;return S.index===-1?p=(0,R.setProperty)(l,[f],d,O):p=o(l,f,d,S,T,O).map(F=>(0,R.withFormatting)(l,F,O)[0]),(0,R.applyEdits)(l,p)}function o(l,f,d,S,T,O){const p=`${JSON.stringify(f)}: ${JSON.stringify(d)}`,F=(0,k.getEOL)(O,l),M=T[S.index];if(S.insertAfter){const W=[];if(M.setting)W.push({offset:M.endOffset,length:0,content:","+p});else{const j=r(S.index,T),U=t(S.index,T),N=U?.setting?.commaOffset;U&&N===void 0&&W.push({offset:U.endOffset,length:0,content:","});const z=N!==void 0&&N>M.endOffset;W.push({offset:z?N+1:M.endOffset,length:0,content:j?F+p+",":F+p})}return W}else{if(M.setting)return[{offset:M.startOffset,length:0,content:p+","}];const W=(T[S.index-1]&&!T[S.index-1].setting?F:"")+p+(r(S.index,T)?",":"")+F;return[{offset:M.startOffset,length:0,content:W}]}}function a(l,f){return f.filter(d=>d.setting?.key===l)[0]}function t(l,f){for(let d=l-1;d>=0;d--)if(f[d].setting)return f[d]}function r(l,f){for(let d=l+1;d<f.length;d++)if(f[d].setting)return f[d]}function n(l,f,d){const S=l.indexOf(f),T=l.indexOf(d);return l.filter((O,p)=>S<p&&p<T)}function s(l,f){if(l.length&&f.length){let d=0;for(;d<f.length&&d<l.length;d++)if(l[d].value!==f[d].value)return f[d-1];return f[d-1]}}function u(l){const f=[];let d=-1,S,T;const O={onObjectBegin:p=>{d++},onObjectProperty:(p,F,M)=>{d===0&&(S=F,T=p)},onObjectEnd:(p,F)=>{d--,d===0&&f.push({startOffset:S,endOffset:p+F,value:l.substring(S,p+F),setting:{key:T,commaOffset:void 0}})},onArrayBegin:(p,F)=>{d++},onArrayEnd:(p,F)=>{d--,d===0&&f.push({startOffset:S,endOffset:p+F,value:l.substring(S,p+F),setting:{key:T,commaOffset:void 0}})},onLiteralValue:(p,F,M)=>{d===0&&f.push({startOffset:S,endOffset:F+M,value:l.substring(S,F+M),setting:{key:T,commaOffset:void 0}})},onSeparator:(p,F,M)=>{if(d===0&&p===","){let W=f.length-1;for(;W>=0&&!f[W].setting;W--);const j=f[W];j&&f.splice(W,1,{startOffset:j.startOffset,endOffset:j.endOffset,value:j.value,setting:{key:j.setting.key,commaOffset:F}})}},onComment:(p,F)=>{d===0&&f.push({startOffset:p,endOffset:p+F,value:l.substring(p,p+F)})}};return(0,L.visit)(l,O),f}}),define(te[204],ne([0,1,25,3,43,130,24,12,27,13,20,21,46,54,203,22]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function I(a){return a&&a.settings&&typeof a.settings=="string"&&Object.keys(a).length===1}function g(a){const t=JSON.parse(a);return I(t)?t:{settings:a}}e.parseSettingsSyncContent=g;let C=class extends h.AbstractJsonFileSynchroniser{constructor(t,r,n,s,u,l,f,d,S,T,O){super(r.settingsResource,"settings",t,r,n,s,u,S,T,l,f,d);this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,n,s){const u=await this.getLocalFileContent(),l=await this.getFormattingOptions(),f=this.getSettingsSyncContent(t);r=r===null&&n?t:r;const d=r?this.getSettingsSyncContent(r):null,S=await this.getIgnoredSettings();let T=null,O=!1,p=!1,F=!1;if(f){let W=u?u.value.toString().trim():"{}";W=W||"{}",this.validateContent(W),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const j=(0,c.merge)(W,f.settings,d?d.settings:null,S,[],l);T=j.localContent||j.remoteContent,O=j.localContent!==null,p=j.remoteContent!==null,F=j.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),T=u.value.toString(),p=!0);const M={content:T,localChange:O?2:0,remoteChange:p?2:0,hasConflicts:F};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:f?f.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,c.updateIgnoredSettings)(t.previewResult.content,"{}",s,n):null}}async getAcceptResult(t,r,n,s){const u=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,c.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",l,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,c.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",l,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,c.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",l,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,n,s){const{fileContent:u}=n[0][0];let{content:l,localChange:f,remoteChange:d}=n[0][1];if(f===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),f!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(l,u,s),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),d!==0){const S=await this.getFormattingOptions(),T=this.getSettingsSyncContent(t),O=await this.getIgnoredSettings(l);l=(0,c.updateIgnoredSettings)(l,T?T.settings:"{}",O,S),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),s?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(S){}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),n=(0,b.edit)(t.value.toString(),[y.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,c.isEmpty)(n)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const n=this.parseSyncData(r);if(n){const s=this.parseSettingsSyncContent(n.content);if(s)switch(this.extUri.basename(t)){case"settings.json":return s.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();r=(0,c.updateIgnoredSettings)(r,"{}",s,n)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return g(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:u})=>!!u)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,c.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new y.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!o(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const n=this.parseSettingsSyncContent(r.content);if(!n||!n.settings)return;let s=n.settings;const u=await this.getFormattingOptions();for(const l in r)if(["version","content","machineId"].indexOf(l)===-1&&r[l]!==void 0){const f=(0,R.setProperty)(s,[l],r[l],u);f.length&&(s=(0,R.applyEdits)(s,f))}await this.fileService.writeFile(this.file,D.VSBuffer.fromString(s))}catch(t){}}};C=he([X(0,w.IFileService),X(1,P.IEnvironmentService),X(2,i.IStorageService),X(3,y.IUserDataSyncStoreService),X(4,y.IUserDataSyncBackupStoreService),X(5,y.IUserDataSyncLogService),X(6,y.IUserDataSyncUtilService),X(7,A.IConfigurationService),X(8,y.IUserDataSyncResourceEnablementService),X(9,E.ITelemetryService),X(10,m.IExtensionManagementService)],C),e.SettingsSynchroniser=C;let v=class extends h.AbstractInitializer{constructor(t,r,n){super("settings",r,n,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,c.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return g(t)}catch(r){this.logService.error(r)}return null}};v=he([X(0,w.IFileService),X(1,P.IEnvironmentService),X(2,y.IUserDataSyncLogService)],v),e.SettingsInitializer=v;function o(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&a.machineId!==void 0&&typeof a.machineId=="string")}}),define(te[205],ne([0,1,25,3,26,24,12,13,20,21,46,198,22]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let b=class extends i.AbstractSynchroniser{constructor(I,g,C,v,o,a,t,r,n){super("snippets",g,I,C,v,o,r,n,a,t);this.version=1,this.snippetsFolder=I.snippetsHome,this._register(this.fileService.watch(I.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(L.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(I,g,C,v){const o=await this.getSnippetsFileContents(),a=this.toSnippetsContents(o),t=I.syncData?this.parseSnippets(I.syncData):null;g=g===null&&C?I:g;const r=g&&g.syncData?this.parseSnippets(g.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,E.merge)(a,t,r);return this.getResourcePreviews(n,o,t||{})}async getMergeResult(I,g){return I.previewResult}async getAcceptResult(I,g,C,v){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:I.fileContent?I.fileContent.value.toString():null,localChange:0,remoteChange:I.fileContent?I.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:I.remoteContent,localChange:I.remoteContent!==null?I.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder))return C===void 0?{content:I.previewResult.content,localChange:I.previewResult.localChange,remoteChange:I.previewResult.remoteChange}:{content:C,localChange:C===null?I.fileContent!==null?3:0:2,remoteChange:C===null?I.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(I,g,C,v){const o=C.map(([a,t])=>({...a,acceptResult:t}));o.every(({localChange:a,remoteChange:t})=>a===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:a})=>a!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,v)),o.some(({remoteChange:a})=>a!==0)&&(I=await this.updateRemoteSnippets(o,I,v)),g?.ref!==I.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(I),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:a}of o)try{await this.fileService.del(a)}catch(t){}}getResourcePreviews(I,g,C){const v=new Map;for(const o of Object.keys(I.local.added)){const a={content:I.local.added[o],hasConflicts:!1,localChange:1,remoteChange:0};v.set(o,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(I.local.updated)){const a={content:I.local.updated[o],hasConflicts:!1,localChange:2,remoteChange:0};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o],localContent:g[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of I.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o],localContent:g[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(I.remote.added)){const a={content:I.remote.added[o],hasConflicts:!1,localChange:0,remoteChange:1};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o],localContent:g[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(I.remote.updated)){const a={content:I.remote.updated[o],hasConflicts:!1,localChange:0,remoteChange:2};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o],localContent:g[o].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of I.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o],previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of I.conflicts){const a={content:g[o]?g[o].value.toString():null,hasConflicts:!0,localChange:g[o]?2:1,remoteChange:C[o]?2:1};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o]||null,localContent:g[o]?g[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const o of Object.keys(g))if(!v.has(o)){const a={content:g[o]?g[o].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};v.set(o,{localResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:g[o]||null,localContent:g[o]?g[o].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:C[o]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,o),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,o).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...v.values()]}async getAssociatedResources({uri:I}){let g=await super.resolveContent(I);if(g){const C=this.parseSyncData(g);if(C){const v=this.parseSnippets(C),o=[];for(const a of Object.keys(v)){const t=this.extUri.joinPath(I,a),r=this.extUri.joinPath(this.snippetsFolder,a),n=await this.fileService.exists(r);o.push({resource:t,comparableResource:n?r:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})})}return o}}return[]}async resolveContent(I){if(this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(I);let g=await super.resolveContent(I);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(I)),g){const C=this.parseSyncData(g);if(C)return this.parseSnippets(C)[this.extUri.basename(I)]||null}return null}async hasLocalData(){try{const I=await this.getSnippetsFileContents();if(Object.keys(I).length)return!0}catch(I){}return!1}async updateLocalBackup(I){const g={};for(const C of I)C.fileContent&&(g[this.extUri.basename(C.localResource)]=C.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(g)))}async updateLocalSnippets(I,g){for(const{fileContent:C,acceptResult:v,localResource:o,remoteResource:a,localChange:t}of I)if(t!==0){const r=a?this.extUri.basename(a):this.extUri.basename(o),n=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(n)),await this.fileService.del(n),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(n))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(n)),await this.fileService.createFile(n,D.VSBuffer.fromString(v.content),{overwrite:g}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(n))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(n)),await this.fileService.writeFile(n,D.VSBuffer.fromString(v.content),g?void 0:C),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(n)))}}async updateRemoteSnippets(I,g,C){const v=g.syncData?this.parseSnippets(g.syncData):{},o=(0,R.deepClone)(v);for(const{acceptResult:a,localResource:t,remoteResource:r,remoteChange:n}of I)if(n!==0){const s=t?this.extUri.basename(t):this.extUri.basename(r);n===3?delete o[s]:o[s]=a.content}return(0,E.areSame)(v,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),g=await this.updateRemoteUserData(JSON.stringify(o),C?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),g}parseSnippets(I){return JSON.parse(I.content)}toSnippetsContents(I){const g={};for(const C of Object.keys(I))g[C]=I[C].value.toString();return g}async getSnippetsFileContents(){const I={};let g;try{g=await this.fileService.resolve(this.snippetsFolder)}catch(C){if(C instanceof P.FileOperationError&&C.fileOperationResult===1)return I;throw C}for(const C of g.children||[]){const v=C.resource,o=this.extUri.extname(v);if(o===".json"||o===".code-snippets"){const a=this.extUri.relativePath(this.snippetsFolder,v),t=await this.fileService.readFile(v);I[a]=t}}return I}};b=he([X(0,A.IEnvironmentService),X(1,P.IFileService),X(2,m.IStorageService),X(3,h.IUserDataSyncStoreService),X(4,h.IUserDataSyncBackupStoreService),X(5,h.IUserDataSyncLogService),X(6,k.IConfigurationService),X(7,h.IUserDataSyncResourceEnablementService),X(8,w.ITelemetryService)],b),e.SnippetsSynchroniser=b;let c=class extends i.AbstractInitializer{constructor(I,g,C){super("snippets",g,C,I)}async doInitialize(I){const g=I.syncData?JSON.parse(I.syncData.content):null;if(!g){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const v of Object.keys(g)){const o=g[v];if(o){const a=this.extUri.joinPath(this.environmentService.snippetsHome,v);await this.fileService.createFile(a,D.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(a))}}await this.updateLastSyncUserData(I)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(I){return I.fileOperationResult===1}}};c=he([X(0,P.IFileService),X(1,A.IEnvironmentService),X(2,h.IUserDataSyncLogService)],c),e.SnippetsInitializer=c}),define(te[60],ne([0,1,3,2,7,22]),function(Y,e,D,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let A=class extends L.Disposable{constructor(m){super();this.userDataSyncStoreService=m,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(m.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(m.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(m){(m&&this._account?m.token!==this._account.token||m.authenticationProviderId!==this._account.authenticationProviderId:m!==this._account)&&(this._account=m,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(m))}};A=he([X(0,k.IUserDataSyncStoreService)],A),e.UserDataSyncAccountService=A}),define(te[206],ne([0,1,6,25,56,2,15,24,12,13,22]),function(Y,e,D,L,R,k,A,P,m,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let E=class extends k.Disposable{constructor(b,c,y,I){super();this.environmentService=b,this.fileService=c,this.configurationService=y,this.logService=I,i.ALL_SYNC_RESOURCES.forEach(g=>this.cleanUpBackup(g))}async getAllRefs(b){const c=(0,A.joinPath)(this.environmentService.userDataSyncHome,b),y=await this.fileService.resolve(c);return y.children?y.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort().reverse().map(g=>({ref:g.name,created:this.getCreationTime(g)})):[]}async resolveContent(b,c){if(!c){const y=await this.getAllRefs(b);y.length&&(c=y[y.length-1].ref)}if(c){const y=(0,A.joinPath)(this.environmentService.userDataSyncHome,b,c);return(await this.fileService.readFile(y)).value.toString()}return null}async backup(b,c){const y=(0,A.joinPath)(this.environmentService.userDataSyncHome,b),I=(0,A.joinPath)(y,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(I,L.VSBuffer.fromString(c))}catch(g){this.logService.error(g)}try{this.cleanUpBackup(b)}catch(g){}}async cleanUpBackup(b){const c=(0,A.joinPath)(this.environmentService.userDataSyncHome,b);try{try{if(!await this.fileService.exists(c))return}catch(I){return}const y=await this.fileService.resolve(c);if(y.children){const I=y.children.filter(o=>o.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(o.name)).sort(),g=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let C=I.filter(o=>Date.now()-this.getCreationTime(o)>g);const v=I.length-C.length;v<10&&(C=C.slice(10-v)),await D.Promises.settled(C.map(async o=>{this.logService.info("Deleting from backup",o.resource.path),await this.fileService.del(o.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(b){return b.ctime||new Date(parseInt(b.name.substring(0,4)),parseInt(b.name.substring(4,6))-1,parseInt(b.name.substring(6,8)),parseInt(b.name.substring(9,11)),parseInt(b.name.substring(11,13)),parseInt(b.name.substring(13,15))).getTime()}};E=he([X(0,m.IEnvironmentService),X(1,w.IFileService),X(2,P.IConfigurationService),X(3,i.IUserDataSyncLogService)],E),e.UserDataSyncBackupStoreService=E}),define(te[207],ne([0,1,2,5]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(h){this.service=h}listen(h,b){switch(b){case"onError":return this.service.onError}throw new Error(`Event not found: ${b}`)}call(h,b,c){switch(b){case"triggerSync":return this.service.triggerSync(c[0],c[1],c[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(c[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class k{constructor(h){this.service=h}listen(h,b){throw new Error(`Event not found: ${b}`)}call(h,b,c){switch(b){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(c[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(L.URI.revive(c[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class A{constructor(h){this.channel=h}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(h){return this.channel.call("resolveUserKeybindings",[h])}async resolveFormattingOptions(h){return this.channel.call("resolveFormattingOptions",[h])}}e.UserDataSyncUtilServiceClient=A;class P{constructor(h){this.service=h}listen(h,b){switch(b){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${b}`)}async call(h,b,c){switch(b){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(c[0],c[1]);case"setEnablement":return this.service.setEnablement(c[0],c[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class m{constructor(h){this.service=h}listen(h,b){switch(b){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${b}`)}call(h,b,c){switch(b){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(c)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=m;class w{constructor(h){this.service=h}listen(h,b){switch(b){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${b}`)}call(h,b,c){switch(b){case"switch":return this.service.switch(c[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=w;class i extends D.Disposable{constructor(h){super();this.channel=h,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(h){return this.channel.call("switch",[h])}async getPreviousUserDataSyncStore(){const h=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(h)}revive(h){return{url:L.URI.revive(h.url),type:h.type,defaultUrl:L.URI.revive(h.defaultUrl),insidersUrl:L.URI.revive(h.insidersUrl),stableUrl:L.URI.revive(h.stableUrl),canSwitch:h.canSwitch,authenticationProviders:h.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=i}),define(te[208],ne([0,1,12,14]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends L.AbstractLogger{constructor(A,P){super();this.logger=this._register(A.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...P){this.logger.trace(A,...P)}debug(A,...P){this.logger.debug(A,...P)}info(A,...P){this.logger.info(A,...P)}warn(A,...P){this.logger.warn(A,...P)}error(A,...P){this.logger.error(A,...P)}critical(A,...P){this.logger.critical(A,...P)}flush(){this.logger.flush()}};R=he([X(0,L.ILoggerService),X(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(te[61],ne([0,1,3,2,4,23,133,12,13,7,28,45,20,22]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,w.createDecorator)("IUserDataSyncMachinesService");const c="sync.currentMachineName";let y=class Ke extends L.Disposable{constructor(g,C,v,o,a,t){super();this.storageService=v,this.userDataSyncStoreService=o,this.logService=a,this.productService=t,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(g,C,v)}async getMachines(g){const C=await this.currentMachineIdPromise;return(await this.readMachinesData(g)).machines.map(o=>({...o,isCurrent:o.id===C}))}async addCurrentMachine(g){const C=await this.currentMachineIdPromise,v=await this.readMachinesData(g);v.machines.some(({id:o})=>o===C)||(v.machines.push({id:C,name:this.computeCurrentMachineName(v.machines)}),await this.writeMachinesData(v))}async removeCurrentMachine(g){const C=await this.currentMachineIdPromise,v=await this.readMachinesData(g),o=v.machines.filter(({id:a})=>a!==C);o.length!==v.machines.length&&(v.machines=o,await this.writeMachinesData(v))}async renameMachine(g,C,v){const o=await this.currentMachineIdPromise,a=await this.readMachinesData(v),t=a.machines.find(({id:r})=>r===g);t&&(t.name=C,await this.writeMachinesData(a),a.machines.some(({id:r})=>r===o)&&this.storageService.store(c,C,0,1))}async setEnablement(g,C){const v=await this.readMachinesData(),o=v.machines.find(({id:a})=>a===g);o&&(o.disabled=C?void 0:!0,await this.writeMachinesData(v))}computeCurrentMachineName(g){const C=this.storageService.get(c,0);if(C)return C;const v=`${this.productService.nameLong} (${(0,R.PlatformToString)(R.isWeb?0:R.platform)})`,o=new RegExp(`${(0,k.escapeRegExpCharacters)(v)}\\s#(\\d+)`);let a=0;for(const t of g){const r=o.exec(t.name),n=r?parseInt(r[1]):0;a=n>a?n:a}return`${v} #${a+1}`}async readMachinesData(g){this.userData=await this.readUserData(g);const C=this.parse(this.userData);if(C.version!==Ke.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return C}async writeMachinesData(g){const C=JSON.stringify(g),v=await this.userDataSyncStoreService.write(Ke.RESOURCE,C,this.userData?.ref||null);this.userData={ref:v,content:C},this._onDidChange.fire()}async readUserData(g){if(this.userData){const C=g&&g.latest?g.latest[Ke.RESOURCE]:void 0;if(this.userData.ref===C)return this.userData;if(C===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ke.RESOURCE,this.userData)}parse(g){if(g.content!==null)try{return JSON.parse(g.content)}catch(C){this.logService.error(C)}return{version:Ke.VERSION,machines:[]}}};y.VERSION=1,y.RESOURCE="machines",y=he([X(0,P.IEnvironmentService),X(1,m.IFileService),X(2,h.IStorageService),X(3,b.IUserDataSyncStoreService),X(4,b.IUserDataSyncLogService),X(5,i.IProductService)],y),e.UserDataSyncMachinesService=y}),define(te[89],ne([0,1,6,56,37,11,3,2,4,15,5,131,12,28,20,21,22,60,61]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y,I,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const v="sync.enable",o="sync.disableMachineEventually",a="sync.sessionId",t="sync.storeUrl",r="sync.productQuality";let n=class extends P.Disposable{constructor(f,d,S){super();this.storageService=f,this.environmentService=d,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new A.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(f.onDidChangeValue(T=>this.onDidStorageChange(T)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(v,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(f){f&&!this.canToggleEnablement()||this.storageService.store(v,f,0,1)}onDidStorageChange(f){if(f.scope===0&&v===f.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=he([X(0,c.IStorageService),X(1,h.IEnvironmentService),X(2,I.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let s=class extends P.Disposable{constructor(f,d,S,T,O,p,F,M,W,j,U){super();this.userDataSyncStoreManagementService=d,this.userDataSyncStoreService=S,this.userDataSyncResourceEnablementService=T,this.userDataSyncService=O,this.logService=p,this.userDataSyncAccountService=F,this.telemetryService=M,this.userDataSyncMachinesService=W,this.storageService=j,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=U,this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=f.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(d.onDidChangeUserDataSyncStore(()=>{(0,w.isEqual)(this.syncUrl,d.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=d.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(F.onDidChangeAccount(()=>this.updateAutoSync())),this._register(S.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(A.Event.debounce(O.onDidChangeLocal,(N,z)=>N?[...N,z]:[z],1e3)(N=>this.triggerSync(N,!1,!1))),this._register(A.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,N])=>N)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const f=this.storageService.get(t,0);return f?i.URI.parse(f):void 0}set syncUrl(f){f?this.storageService.store(t,f.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(r,0)}set productQuality(f){f?this.storageService.store(r,f,0,1):this.storageService.remove(r,0)}updateAutoSync(){const{enabled:f,message:d}=this.isAutoSyncEnabled();f?this.autoSync.value===void 0&&(this.autoSync.value=new u(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(S=>this.onDidFinishSync(S))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(d&&this.logService.info(d),this.autoSync.clear()):d&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(d))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(f,d,S){try{this.userDataSyncAccountService.account&&!S&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,0),f?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(T){if(d)this.logService.error(T),this.updateEnablement(!1);else throw T}}updateEnablement(f){this.userDataAutoSyncEnablementService.isEnabled()!==f&&(this.telemetryService.publicLog2(v,{enabled:f}),this.userDataAutoSyncEnablementService.setEnablement(f),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(f){if(!f){this.successiveFailures=0;return}const d=I.UserDataSyncError.toUserDataSyncError(f);d instanceof I.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:d.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),d.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):d.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):d.code==="LocalTooManyRequests"||d.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):d.code==="UpgradeRequired"||d.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):d.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with newer version than of client. Requires client upgrade.`)):d.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${d.resource} content with older version than of client. Requires server reset.`)):d.code==="ServiceChanged"||d.code==="DefaultServiceChanged"?m.isWeb&&d.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(d),this.successiveFailures++),this._onError.fire(d)}async disableMachineEventually(){this.storageService.store(o,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(o,0,!1)}stopDisableMachineEventually(){this.storageService.remove(o,0)}async triggerSync(f,d,S){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(d&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...f),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",S)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};s=he([X(0,b.IProductService),X(1,I.IUserDataSyncStoreManagementService),X(2,I.IUserDataSyncStoreService),X(3,I.IUserDataSyncResourceEnablementService),X(4,I.IUserDataSyncService),X(5,I.IUserDataSyncLogService),X(6,g.IUserDataSyncAccountService),X(7,y.ITelemetryService),X(8,C.IUserDataSyncMachinesService),X(9,c.IStorageService),X(10,I.IUserDataAutoSyncEnablementService)],s),e.UserDataAutoSyncService=s;class u extends P.Disposable{constructor(f,d,S,T,O,p,F,M){super();this.lastSyncUrl=f,this.interval=d,this.userDataSyncStoreManagementService=S,this.userDataSyncStoreService=T,this.userDataSyncService=O,this.userDataSyncMachinesService=p,this.logService=F,this.storageService=M,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(u.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(u.INTERVAL_SYNCING,!1),this.interval)}sync(f,d){const S=(0,D.createCancelablePromise)(async T=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(O){if((0,k.isPromiseCanceledError)(O))return}return this.doSync(f,d,T)});return this.syncPromise=S,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,w.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const f=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),d=this.userDataSyncStoreManagementService.userDataSyncStore;return!!d&&!!f&&(!(0,w.isEqual)(d.defaultUrl,f.defaultUrl)||!(0,w.isEqual)(d.insidersUrl,f.insidersUrl)||!(0,w.isEqual)(d.stableUrl,f.stableUrl))}async doSync(f,d,S){this.logService.info(`Auto Sync: Triggered by ${f}`),this._onDidStartSync.fire();let T;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,d),S.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new I.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new I.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new I.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const O=this.storageService.get(a,0);if(O&&this.manifest&&O!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new I.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new I.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new I.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const p=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(S.isCancellationRequested)return;const F=p.find(M=>M.isCurrent);if(F?.disabled)throw new I.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(M){throw new I.UserDataAutoSyncError((0,R.toErrorMessage)(M),M instanceof I.UserDataSyncError?M.code:"Unknown")}if(this.manifest&&this.manifest.session!==O&&this.storageService.store(a,this.manifest.session,0,1),S.isCancellationRequested)return;F||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(O){this.logService.error(O),T=O}this._onDidFinishSync.fire(T)}register(f){return super._register(f)}}u.INTERVAL_SYNCING="Interval"}),define(te[209],ne([0,1,3,2,4,20,21,22]),function(Y,e,D,L,R,k,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let m=class extends L.Disposable{constructor(i,E){super();this.storageService=i,this.telemetryService=E,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(i.onDidChangeValue(h=>this.onDidStorageChange(h)))}isResourceEnabled(i){return this.storageService.getBoolean((0,P.getEnablementKey)(i),0,!0)}setResourceEnablement(i,E){if(this.isResourceEnabled(i)!==E){const h=(0,P.getEnablementKey)(i);this.telemetryService.publicLog2(h,{enabled:E}),this.storeResourceEnablement(h,E)}}getResourceSyncStateVersion(i){}storeResourceEnablement(i,E){this.storageService.store(i,E,0,R.isWeb?0:1)}onDidStorageChange(i){if(i.scope===0){const E=P.ALL_SYNC_RESOURCES.filter(h=>(0,P.getEnablementKey)(h)===i.key)[0];if(E){this._onDidChangeResourceEnablement.fire([E,this.isResourceEnabled(E)]);return}}}};m=he([X(0,k.IStorageService),X(1,A.ITelemetryService)],m),e.UserDataSyncResourceEnablementService=m}),define(te[210],ne([0,1,19,6,37,11,3,2,15,30,7,20,21,199,201,202,204,205,22]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y,I,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const v="sync.lastSyncTime";let o=class extends P.Disposable{constructor(n,s,u,l,f,d){super();this.userDataSyncStoreService=n,this.userDataSyncStoreManagementService=s,this.instantiationService=u,this.logService=l,this.telemetryService=f,this.storageService=d,this._status="uninitialized",this._onDidChangeStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new A.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new A.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new A.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new A.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(I.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(y.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(g.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(c.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(b.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(A.Event.any(...this.synchronisers.map(S=>A.Event.map(S.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(A.Event.any(...this.synchronisers.map(S=>A.Event.map(S.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(v,0,void 0),this.onDidChangeLocal=A.Event.any(...this.synchronisers.map(S=>A.Event.map(S.onDidChangeLocal,()=>S.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(n,s){await this.checkEnablement();const u=(0,w.generateUuid)();try{const S=(0,C.createSyncHeaders)(u);s&&(S["Cache-Control"]="no-cache"),n=await this.userDataSyncStoreService.manifest(n,S)}catch(S){const T=C.UserDataSyncError.toUserDataSyncError(S);throw this.reportUserDataSyncError(T,u),T}let l=!1;const f=this;let d;return{manifest:n,run(){if(l)throw new Error("Can run a task only once");return d=(0,L.createCancelablePromise)(S=>f.sync(n,u,S)),d.finally(()=>d=void 0)},async stop(){if(d&&d.cancel(),f.status!=="idle")return f.stop()}}}async createManualSyncTask(){await this.checkEnablement();const n=(0,w.generateUuid)(),s=(0,C.createSyncHeaders)(n);let u;try{u=await this.userDataSyncStoreService.manifest(null,s)}catch(l){const f=C.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(f,n),f}return new a(n,u,s,this.synchronisers,this.logService)}async sync(n,s,u){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),u.isCancellationRequested)return;const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const f=(0,C.createSyncHeaders)(s);for(const d of this.synchronisers){if(u.isCancellationRequested)return;try{await d.sync(n,f)}catch(S){let T=!1;if(S instanceof C.UserDataSyncError)switch(S.code){case"TooLarge":S=new C.UserDataSyncError(S.message,S.code,d.resource),T=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":T=!0;break}const O=C.UserDataSyncError.toUserDataSyncError(S);if(this.reportUserDataSyncError(O,s),T)throw O;this.logService.error(S),this.logService.error(`${d.resource}: ${(0,R.toErrorMessage)(S)}`),this._syncErrors.push([d.resource,O])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(f){const d=C.UserDataSyncError.toUserDataSyncError(f);throw this.reportUserDataSyncError(d,s),d}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const n of this.synchronisers)try{n.status!=="idle"&&await n.stop()}catch(s){this.logService.error(s)}}async replace(n){await this.checkEnablement();for(const s of this.synchronisers)if(await s.replace(n))return}async accept(n,s,u,l){await this.checkEnablement();const f=this.getSynchroniser(n);await f.accept(s,u),l&&await f.apply(!1,(0,C.createSyncHeaders)((0,w.generateUuid)()))}async resolveContent(n){for(const s of this.synchronisers){const u=await s.resolveContent(n);if(u)return u}return null}getRemoteSyncResourceHandles(n){return this.getSynchroniser(n).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(n){return this.getSynchroniser(n).getLocalSyncResourceHandles()}getAssociatedResources(n,s){return this.getSynchroniser(n).getAssociatedResources(s)}getMachineId(n,s){return this.getSynchroniser(n).getMachineId(s)}async hasLocalData(){const n=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const s of n)if(await s.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(n){this.logService.error(n)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(v,0);for(const n of this.synchronisers)try{await n.resetLocal()}catch(s){this.logService.error(`${n.resource}: ${(0,R.toErrorMessage)(s)}`),this.logService.error(s)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const n of this.synchronisers)if(await n.hasPreviouslySynced())return!0;return!1}setStatus(n){const s=this._status;this._status!==n&&(this._status=n,this._onDidChangeStatus.fire(n),s==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const n=this.computeStatus();this.setStatus(n)}updateConflicts(){const n=this.computeConflicts();(0,D.equals)(this._conflicts,n,([s,u],[l,f])=>s===s&&(0,D.equals)(u,f,(d,S)=>(0,m.isEqual)(d.previewResource,S.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(n))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(v,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(n,s){this.telemetryService.publicLog2("sync/error",{code:n.code,serverCode:n instanceof C.UserDataSyncStoreError?String(n.serverCode):void 0,url:n instanceof C.UserDataSyncStoreError?n.url:void 0,resource:n.resource,executionId:s,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(n=>n.status==="hasConflicts").map(n=>[n.resource,n.conflicts.map(t)])}getSynchroniser(n){return this.synchronisers.find(s=>s.resource===n)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};o=he([X(0,C.IUserDataSyncStoreService),X(1,C.IUserDataSyncStoreManagementService),X(2,i.IInstantiationService),X(3,C.IUserDataSyncLogService),X(4,h.ITelemetryService),X(5,E.IStorageService)],o),e.UserDataSyncService=o;class a extends P.Disposable{constructor(n,s,u,l,f){super();this.id=n,this.manifest=s,this.syncHeaders=u,this.synchronisers=l,this.logService=f,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new A.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(n=>n.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(n=>n.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,L.createCancelablePromise)(n=>this.getPreviews(n))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(n){throw this.logService.error(n),n}}async accept(n,s){try{return await this.performAction(n,u=>u.accept(n,s))}catch(u){throw this.logService.error(u),u}}async merge(n){try{return n?await this.performAction(n,s=>s.merge(n)):await this.mergeAll()}catch(s){throw this.logService.error(s),s}}async discard(n){try{return await this.performAction(n,s=>s.discard(n))}catch(s){throw this.logService.error(s),s}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const n=[];for(const[,s]of this.previews)for(const u of s.resourcePreviews)u.mergeState==="conflict"&&n.push(u.previewResource);for(const s of n)await this.discard(s);return this.previews}catch(n){throw this.logService.error(n),n}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const n=[];for(const[s,u]of this.previews){this.synchronizingResources.push([s,u.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===s);for(const d of u.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&await l.merge(d.previewResource);const f=await l.apply(!1,this.syncHeaders);f&&n.push(this.toSyncResourcePreview(l.resource,f)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}catch(n){throw this.logService.error(n),n}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,s]of this.previews){this.synchronizingResources.push([n,s.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(l=>l.resource===n);for(const l of s.resourcePreviews)await u.accept(l.remoteResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[n,s]of this.previews){this.synchronizingResources.push([n,s.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(l=>l.resource===n);for(const l of s.resourcePreviews)await u.accept(l.localResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===n),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(n){throw this.logService.error(n),n}}async stop(){for(const n of this.synchronisers)try{await n.stop()}catch(s){(0,k.isPromiseCanceledError)(s)||this.logService.error(s)}this.reset()}async performAction(n,s){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const u=this.previews.findIndex(([,F])=>F.resourcePreviews.some(({localResource:M,previewResource:W,remoteResource:j})=>(0,m.isEqual)(n,M)||(0,m.isEqual)(n,W)||(0,m.isEqual)(n,j)));if(u===-1)return this.previews;const[l,f]=this.previews[u],d=f.resourcePreviews.find(({localResource:F,remoteResource:M,previewResource:W})=>(0,m.isEqual)(F,n)||(0,m.isEqual)(M,n)||(0,m.isEqual)(W,n));if(!d)return this.previews;let S=this.synchronizingResources.find(F=>F[0]===l);S||(S=[l,[]],this.synchronizingResources.push(S)),S[1].some(F=>(0,m.isEqual)(F,d.localResource))||(S[1].push(d.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const T=this.synchronisers.find(F=>F.resource===this.previews[u][0]),O=await s(T);O?this.previews.splice(u,1,this.toSyncResourcePreview(T.resource,O)):this.previews.splice(u,1);const p=this.synchronizingResources.findIndex(F=>F[0]===l);return this.synchronizingResources[p][1].splice(S[1].findIndex(F=>(0,m.isEqual)(F,d.localResource)),1),S[1].length||(this.synchronizingResources.splice(p,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const n=[];for(const[s,u]of this.previews){this.synchronizingResources.push([s,u.resourcePreviews.map(d=>d.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(d=>d.resource===s);let f=u;for(const d of u.resourcePreviews)(d.localChange!==0||d.remoteChange!==0)&&d.mergeState==="preview"&&(f=await l.merge(d.previewResource));f&&n.push(this.toSyncResourcePreview(l.resource,f)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(d=>d[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=n,this.previews}async getPreviews(n){const s=[];for(const u of this.synchronisers){if(n.isCancellationRequested)return[];const l=await u.preview(this.manifest,this.syncHeaders);l&&s.push(this.toSyncResourcePreview(u.resource,l))}return s}toSyncResourcePreview(n,s){return[n,{isLastSyncFromCurrentMachine:s.isLastSyncFromCurrentMachine,resourcePreviews:s.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(te[211],ne([0,1,3,2,16,5,22]),function(Y,e,D,L,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(E,h){this.service=E,this.logService=h,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(E,h){switch(h){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${h}`)}async call(E,h,b){try{return await this._call(E,h,b)}catch(c){throw this.logService.error(c),c}}async _call(E,h,b){switch(h){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(k.URI.revive(b[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(b[0],k.URI.revive(b[1]),b[2],b[3]);case"resolveContent":return this.service.resolveContent(k.URI.revive(b[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(b[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(b[0]);case"getAssociatedResources":return this.service.getAssociatedResources(b[0],{created:b[1].created,uri:k.URI.revive(b[1].uri)});case"getMachineId":return this.service.getMachineId(b[0],{created:b[1].created,uri:k.URI.revive(b[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(h.startsWith("manualSync/")){const c=h.substring("manualSync/".length),y=b[0],I=this.getManualSyncTask(y);switch(b=b.slice(1),c){case"preview":return I.preview();case"accept":return I.accept(k.URI.revive(b[0]),b[1]);case"merge":return I.merge(k.URI.revive(b[0]));case"discard":return I.discard(k.URI.revive(b[0]));case"discardConflicts":return I.discardConflicts();case"apply":return I.apply();case"pull":return I.pull();case"push":return I.push();case"stop":return I.stop();case"_getStatus":return I.status;case"dispose":return this.disposeManualSyncTask(I)}}throw new Error("Invalid call")}getManualSyncTask(E){const h=this.manualSyncTasks.get(this.createKey(E));if(!h)throw new Error(`Manual sync taks not found: ${E}`);return h.manualSyncTask}async createManualSyncTask(){const E=new L.DisposableStore,h=E.add(await this.service.createManualSyncTask());return E.add(h.onSynchronizeResources(b=>this.onManualSynchronizeResources.fire({manualSyncTaskId:h.id,data:b}))),this.manualSyncTasks.set(this.createKey(h.id),{manualSyncTask:h,disposables:E}),{id:h.id,manifest:h.manifest,status:h.status}}disposeManualSyncTask(E){E.dispose();const h=this.createKey(E.id);this.manualSyncTasks.get(h)?.disposables.dispose(),this.manualSyncTasks.delete(h)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=P;class m extends L.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(h,b,c){return E.call(h,b,c).then(null,y=>{throw A.UserDataSyncError.toUserDataSyncError(y)})},listen(h,b){return E.listen(h,b)}},this.channel.call("_getInitialData").then(([h,b,c])=>{this.updateStatus(h),this.updateConflicts(b),c&&this.updateLastSyncTime(c),this._register(this.channel.listen("onDidChangeStatus")(y=>this.updateStatus(y))),this._register(this.channel.listen("onDidChangeLastSyncTime")(y=>this.updateLastSyncTime(y)))}),this._register(this.channel.listen("onDidChangeConflicts")(h=>this.updateConflicts(h))),this._register(this.channel.listen("onSyncErrors")(h=>this._onSyncErrors.fire(h.map(([b,c])=>[b,A.UserDataSyncError.toUserDataSyncError(c)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:h,status:b}=await this.channel.call("createManualSyncTask"),c=this,y=new w(E,h,b,{async call(I,g,C){return c.channel.call(`manualSync/${I}`,[E,...(0,R.isArray)(g)?g:[g]],C)},listen(I,g){return D.Event.map(D.Event.filter(c.channel.listen(`manualSync/${I}`,g),C=>!y.isDiposed()&&C.manualSyncTaskId===E),C=>C.data)}});return y}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,h,b,c){return this.channel.call("accept",[E,h,b,c])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:b,uri:c})=>({created:b,uri:k.URI.revive(c)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:b,uri:c})=>({created:b,uri:k.URI.revive(c)}))}async getAssociatedResources(E,h){return(await this.channel.call("getAssociatedResources",[E,h])).map(({resource:c,comparableResource:y})=>({resource:k.URI.revive(c),comparableResource:k.URI.revive(y)}))}async getMachineId(E,h){return this.channel.call("getMachineId",[E,h])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([h,b])=>[h,b.map(c=>({...c,localResource:k.URI.revive(c.localResource),remoteResource:k.URI.revive(c.remoteResource),previewResource:k.URI.revive(c.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=m;class w extends L.Disposable{constructor(E,h,b,c){super();this.id=E,this.manifest=h,this._disposed=!1,this._status=b;const y=this;this.channel={async call(I,g,C){try{const v=await c.call(I,g,C);return y.isDiposed()||(y._status=await c.call("_getStatus")),v}catch(v){throw A.UserDataSyncError.toUserDataSyncError(v)}},listen(I,g){return c.listen(I,g)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,h){const b=await this.channel.call("accept",[E,h]);return this.deserializePreviews(b)}async merge(E){const h=await this.channel.call("merge",[E]);return this.deserializePreviews(h)}async discard(E){const h=await this.channel.call("discard",[E]);return this.deserializePreviews(h)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([h,b])=>[h,{isLastSyncFromCurrentMachine:b.isLastSyncFromCurrentMachine,resourcePreviews:b.resourcePreviews.map(c=>({...c,localResource:k.URI.revive(c.localResource),remoteResource:k.URI.revive(c.remoteResource),previewResource:k.URI.revive(c.previewResource),acceptedResource:k.URI.revive(c.acceptedResource)}))}])}}}),define(te[212],ne([0,1,6,29,11,3,2,95,4,15,16,5,30,24,12,13,28,42,45,20,22]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y,I,g,C,v,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const a="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",n="sync.machine-session-id",s=100,u=1e3*60*5;let l=class extends A.Disposable{constructor(p,F,M){super();this.productService=p,this.configurationService=F,this.storageService=M,this._onDidChangeUserDataSyncStore=this._register(new k.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(k.Event.filter(M.onDidChangeValue,W=>W.key===o.SYNC_SERVICE_URL_TYPE&&W.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(o.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(p){this.storageService.store(o.SYNC_SERVICE_URL_TYPE,p,0,m.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[o.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(o.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(p,F){p=m.isWeb&&p?.web?{...p,...p.web}:p;const M={...p||{},...F||{}};if(M&&(0,i.isString)(M.url)&&(0,i.isObject)(M.authenticationProviders)&&Object.keys(M.authenticationProviders).every(W=>(0,i.isArray)(M.authenticationProviders[W].scopes))){const W=M,j=!!W.canSwitch&&!F?.url,U=W.url===W.insidersUrl?"insiders":"stable",N=(j?this.userDataSyncStoreType:void 0)||U,z=F?.url||(N==="insiders"?W.insidersUrl:N==="stable"?W.stableUrl:W.url);return{url:E.URI.parse(z),type:N,defaultType:U,defaultUrl:E.URI.parse(W.url),stableUrl:E.URI.parse(W.stableUrl),insidersUrl:E.URI.parse(W.insidersUrl),canSwitch:j,authenticationProviders:Object.keys(W.authenticationProviders).reduce((H,V)=>(H.push({id:V,scopes:W.authenticationProviders[V].scopes}),H),[])}}}};l=he([X(0,I.IProductService),X(1,b.IConfigurationService),X(2,v.IStorageService)],l),e.AbstractUserDataSyncStoreManagementService=l;let f=class extends l{constructor(p,F,M){super(p,F,M);const W=this.storageService.get(a,0);W&&(this.previousConfigurationSyncStore=JSON.parse(W));const j=this.productService[o.CONFIGURATION_SYNC_STORE_KEY];j?this.storageService.store(a,JSON.stringify(j),0,1):this.storageService.remove(a,0)}async switch(p){p!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=p,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};f=he([X(0,I.IProductService),X(1,b.IConfigurationService),X(2,v.IStorageService)],f),e.UserDataSyncStoreManagementService=f;let d=class extends A.Disposable{constructor(p,F,M,W,j,U,N){super();this.requestService=M,this.logService=W,this.storageService=N,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new k.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new k.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(p),this.commonHeadersPromise=(0,C.getServiceMachineId)(j,U,N).then(z=>{const H={"X-Client-Name":`${F.applicationName}${m.isWeb?"-web":""}`,"X-Client-Version":F.version,"X-Machine-Id":z};return F.commit&&(H["X-Client-Commit"]=F.commit),H}),this.session=new T(s,u,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(p,F){this.authToken={token:p,type:F}}updateUserDataSyncStoreUrl(p){this.userDataSyncStoreUrl=p?(0,w.joinPath)(p,"v1"):void 0}initDonotMakeRequestsUntil(){const p=this.storageService.getNumber(t,0);p&&Date.now()<p&&this.setDonotMakeRequestsUntil(new Date(p))}setDonotMakeRequestsUntil(p){this._donotMakeRequestsUntil?.getTime()!==p?.getTime()&&(this._donotMakeRequestsUntil=p,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(F=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(p){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,w.joinPath)(this.userDataSyncStoreUrl,"resource",p),M={},W=await this.request(F.toString(),{type:"GET",headers:M},[],L.CancellationToken.None);return(await(0,g.asJson)(W)||[]).map(({url:U,created:N})=>({ref:(0,w.relativePath)(F,F.with({path:U})),created:N*1e3}))}async resolveContent(p,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,w.joinPath)(this.userDataSyncStoreUrl,"resource",p,F).toString(),W={};W["Cache-Control"]="no-cache";const j=await this.request(M,{type:"GET",headers:W},[],L.CancellationToken.None);return await(0,g.asText)(j)}async delete(p){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,w.joinPath)(this.userDataSyncStoreUrl,"resource",p).toString(),M={};await this.request(F,{type:"DELETE",headers:M},[],L.CancellationToken.None)}async read(p,F,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=(0,w.joinPath)(this.userDataSyncStoreUrl,"resource",p,"latest").toString();M={...M},M["Cache-Control"]="no-cache",F&&(M["If-None-Match"]=F.ref);const j=await this.request(W,{type:"GET",headers:M},[304],L.CancellationToken.None);let U=null;if(j.res.statusCode===304&&(U=F),U===null){const N=j.res.headers.etag;if(!N)throw new o.UserDataSyncStoreError("Server did not return the ref",W,"NoRef",j.res.statusCode,j.res.headers[o.HEADER_OPERATION_ID]);const z=await(0,g.asText)(j);if(!z&&j.res.statusCode===304)throw new o.UserDataSyncStoreError("Empty response",W,"EmptyResponse",j.res.statusCode,j.res.headers[o.HEADER_OPERATION_ID]);U={ref:N,content:z}}return U}async write(p,F,M,W={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=(0,w.joinPath)(this.userDataSyncStoreUrl,"resource",p).toString();W={...W},W["Content-Type"]=P.Mimes.text,M&&(W["If-Match"]=M);const U=await this.request(j,{type:"POST",data:F,headers:W},[],L.CancellationToken.None),N=U.res.headers.etag;if(!N)throw new o.UserDataSyncStoreError("Server did not return the ref",j,"NoRef",U.res.statusCode,U.res.headers[o.HEADER_OPERATION_ID]);return N}async manifest(p,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,w.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",p&&(F["If-None-Match"]=p.ref);const W=await this.request(M,{type:"GET",headers:F},[304],L.CancellationToken.None);let j=null;if(W.res.statusCode===304&&(j=p),!j){const N=W.res.headers.etag;if(!N)throw new o.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",W.res.statusCode,W.res.headers[o.HEADER_OPERATION_ID]);const z=await(0,g.asText)(W);if(!z&&W.res.statusCode===304)throw new o.UserDataSyncStoreError("Empty response",M,"EmptyResponse",W.res.statusCode,W.res.headers[o.HEADER_OPERATION_ID]);z&&(j={...JSON.parse(z),ref:N})}const U=this.storageService.get(r,0);return U&&j&&U!==j.session&&this.clearSession(),j===null&&U&&this.clearSession(),j&&this.storageService.store(r,j.session,0,1),j}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const p=(0,w.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":P.Mimes.text};await this.request(p,{type:"DELETE",headers:F},[],L.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(n,0)}async request(p,F,M,W){if(!this.authToken)throw new o.UserDataSyncStoreError("No Auth Token Available",p,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new o.UserDataSyncStoreError(`${F.type} request '${p}' failed because of too many requests (429).`,p,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const j=await this.commonHeadersPromise;F.headers={...F.headers||{},...j,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:p,type:F.type,headers:{...F.headers,authorization:void 0}});let U;try{U=await this.session.request(p,F,W)}catch(V){if(!(V instanceof o.UserDataSyncStoreError)){let x="RequestFailed";const K=(0,R.getErrorMessage)(V).toLowerCase();K.includes("xhr timeout")?x="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?x="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?x="RequestPathNotEscaped":K.includes("headers must be an object")?x="RequestHeadersNotObject":(0,R.isPromiseCanceledError)(V)&&(x="RequestCanceled"),V=new o.UserDataSyncStoreError(`Connection refused for the request '${p}'.`,p,x,void 0,void 0)}throw this.logService.info("Request failed",p),V}const N=U.res.headers[o.HEADER_OPERATION_ID],z={url:p,status:U.res.statusCode,"execution-id":F.headers[o.HEADER_EXECUTION_ID],"operation-id":N},H=(0,g.isSuccess)(U)||U.res.statusCode&&M.indexOf(U.res.statusCode)!==-1;if(H?this.logService.trace("Request succeeded",z):this.logService.info("Request failed",z),U.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new o.UserDataSyncStoreError(`Request '${p}' failed because of Unauthorized (401).`,p,"Unauthorized",U.res.statusCode,N);if(this._onTokenSucceed.fire(),U.res.statusCode===409)throw new o.UserDataSyncStoreError(`${F.type} request '${p}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,p,"Conflict",U.res.statusCode,N);if(U.res.statusCode===410)throw new o.UserDataSyncStoreError(`${F.type} request '${p}' failed because the requested resource is not longer available (410).`,p,"Gone",U.res.statusCode,N);if(U.res.statusCode===412)throw new o.UserDataSyncStoreError(`${F.type} request '${p}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,p,"PreconditionFailed",U.res.statusCode,N);if(U.res.statusCode===413)throw new o.UserDataSyncStoreError(`${F.type} request '${p}' failed because of too large payload (413).`,p,"TooLarge",U.res.statusCode,N);if(U.res.statusCode===426)throw new o.UserDataSyncStoreError(`${F.type} request '${p}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,p,"UpgradeRequired",U.res.statusCode,N);if(U.res.statusCode===429){const V=U.res.headers["retry-after"];throw V?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(V)*1e3)),new o.UserDataSyncStoreError(`${F.type} request '${p}' failed because of too many requests (429).`,p,"TooManyRequestsAndRetryAfter",U.res.statusCode,N)):new o.UserDataSyncStoreError(`${F.type} request '${p}' failed because of too many requests (429).`,p,"RemoteTooManyRequests",U.res.statusCode,N)}if(!H)throw new o.UserDataSyncStoreError("Server returned "+U.res.statusCode,p,"Unknown",U.res.statusCode,N);return U}addSessionHeaders(p){let F=this.storageService.get(n,0);F===void 0&&(F=(0,h.generateUuid)(),this.storageService.store(n,F,0,1)),p["X-Machine-Session-Id"]=F;const M=this.storageService.get(r,0);M!==void 0&&(p["X-User-Session-Id"]=M)}};d=he([X(1,I.IProductService),X(2,g.IRequestService),X(3,o.IUserDataSyncLogService),X(4,c.IEnvironmentService),X(5,y.IFileService),X(6,v.IStorageService)],d),e.UserDataSyncStoreClient=d;let S=class extends d{constructor(p,F,M,W,j,U,N){super(p.userDataSyncStore?.url,F,M,W,j,U,N);this._register(p.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(p.userDataSyncStore?.url)))}};S=he([X(0,o.IUserDataSyncStoreManagementService),X(1,I.IProductService),X(2,g.IRequestService),X(3,o.IUserDataSyncLogService),X(4,c.IEnvironmentService),X(5,y.IFileService),X(6,v.IStorageService)],S),e.UserDataSyncStoreService=S;class T{constructor(p,F,M,W){this.limit=p,this.interval=F,this.requestService=M,this.logService=W,this.requests=[],this.startTime=void 0}request(p,F,M){if(this.isExpired()&&this.reset(),F.url=p,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new o.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,p,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(p),this.requestService.request(F,M)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=T}),define(te[213],ne([0,1,3,59,28,20,21,89,22,60,61]),function(Y,e,D,L,R,k,A,P,m,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends P.UserDataAutoSyncService{constructor(b,c,y,I,g,C,v,o,a,t,r,n){super(b,c,y,I,g,v,o,a,t,r,n);this._register(D.Event.debounce(D.Event.any(D.Event.map(C.onDidFocusWindow,()=>"windowFocus"),D.Event.map(C.onDidOpenWindow,()=>"windowOpen")),(s,u)=>s?[...s,u]:[u],1e3)(s=>this.triggerSync(s,!0,!1)))}};E=he([X(0,R.IProductService),X(1,m.IUserDataSyncStoreManagementService),X(2,m.IUserDataSyncStoreService),X(3,m.IUserDataSyncResourceEnablementService),X(4,m.IUserDataSyncService),X(5,L.INativeHostService),X(6,m.IUserDataSyncLogService),X(7,w.IUserDataSyncAccountService),X(8,A.ITelemetryService),X(9,i.IUserDataSyncMachinesService),X(10,k.IStorageService),X(11,m.IUserDataAutoSyncEnablementService)],E),e.UserDataAutoSyncService=E}),define(te[214],ne([0,1,6,3,2]),function(Y,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:m,getActiveWindowId:w}){super();this.disposables=this._register(new R.DisposableStore),L.Event.latch(L.Event.any(P,m))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>w()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch(E){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(te[62],ne([0,1,50,6,8,16,18,110,222,223]),function(Y,e,D,L,R,k,A,P,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class i extends Error{constructor(t,r){let n=r.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=r}}e.ExtractError=i;function E(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,n)=>r+n,t&61440)}function h(a){if(a instanceof i)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new i(t,a)}function b(a,t,r,n,s,u){const l=R.dirname(t),f=R.join(n,l);if(!f.startsWith(n))return Promise.reject(new Error(P.localize(0,null,t)));const d=R.join(n,t);let S;return u.onCancellationRequested(()=>{S&&S.destroy()}),Promise.resolve(A.Promises.mkdir(f,{recursive:!0})).then(()=>new Promise((T,O)=>{if(!u.isCancellationRequested)try{S=(0,D.createWriteStream)(d,{mode:r}),S.once("close",()=>T()),S.once("error",O),a.once("error",O),a.pipe(S)}catch(p){O(p)}}))}function c(a,t,r,n){let s=(0,L.createCancelablePromise)(()=>Promise.resolve()),u=0;return n.onCancellationRequested(()=>{s.cancel(),a.close()}),new Promise((l,f)=>{const d=new L.Sequencer,S=T=>{T.isCancellationRequested||(u++,a.readEntry())};a.once("error",f),a.once("close",()=>s.then(()=>{n.isCancellationRequested||a.entryCount===u?l():f(new i("Incomplete",new Error(P.localize(1,null,u,a.entryCount))))},f)),a.readEntry(),a.on("entry",T=>{if(n.isCancellationRequested)return;if(!r.sourcePathRegex.test(T.fileName)){S(n);return}const O=T.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(O)){const M=R.join(t,O);s=(0,L.createCancelablePromise)(W=>A.Promises.mkdir(M,{recursive:!0}).then(()=>S(W)).then(void 0,f));return}const p=I(a,T),F=E(T);s=(0,L.createCancelablePromise)(M=>d.queue(()=>p.then(W=>b(W,O,F,t,r,M).then(()=>S(M)))).then(null,f))})})}function y(a,t=!1){return new Promise((r,n)=>{(0,m.open)(a,t?{lazyEntries:!0}:void 0,(s,u)=>{s?n(h(s)):r((0,k.assertIsDefined)(u))})})}function I(a,t){return new Promise((r,n)=>{a.openReadStream(t,(s,u)=>{s?n(h(s)):r((0,k.assertIsDefined)(u))})})}function g(a,t){return new Promise((r,n)=>{const s=new w.ZipFile;t.forEach(l=>{l.contents?s.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&s.addFile(l.localPath,l.path)}),s.end();const u=(0,D.createWriteStream)(a);s.outputStream.pipe(u),s.outputStream.once("error",n),u.once("error",n),u.once("finish",()=>r(a))})}e.zip=g;function C(a,t,r={},n){const s=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let u=y(a,!0);return r.overwrite&&(u=u.then(l=>A.Promises.rm(t).then(()=>l))),u.then(l=>c(l,t,{sourcePathRegex:s},n))}e.extract=C;function v(a,t){return y(a).then(r=>new Promise((n,s)=>{r.on("entry",u=>{u.fileName===t&&I(r,u).then(l=>n(l),l=>s(l))}),r.once("close",()=>s(new Error(P.localize(2,null,t))))}))}function o(a,t){return v(a,t).then(r=>new Promise((n,s)=>{const u=[];r.once("error",s),r.on("data",l=>u.push(l)),r.on("end",()=>n(Buffer.concat(u)))}))}e.buffer=o}),define(te[215],ne([0,1,62,118]),function(Y,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(k){return(0,D.buffer)(k,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch(P){throw new Error((0,L.localize)(0,null))}})}e.getManifest=R}),define(te[216],ne([0,1,19,6,11,2,17,8,4,15,58,5,30,18,62,119,12,27,31,141,13,14,28]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y,I,g,C,v,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",n="scanningUser",s="extracting",u="deleting",l="renaming";let f=class extends k.Disposable{constructor(S,T,O,p,F){super();this.beforeRemovingExtension=S,this.fileService=T,this.logService=O,this.environmentService=p,this.productService=F,this._devSystemExtensionsPath=null,this.systemExtensionsPath=p.builtinExtensionsPath,this.extensionsPath=p.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(S){const T=[];(S===null||S===0)&&T.push(this.scanSystemExtensions().then(null,O=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(O).message,r)))),(S===null||S===1)&&T.push(this.scanUserExtensions(!0).then(null,O=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(O).message,n))));try{const O=await Promise.all(T);return(0,D.flatten)(O)}catch(O){throw this.joinErrors(O)}}async scanUserExtensions(S){this.logService.trace("Started scanning user extensions");let[T,O]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return O=O.filter(p=>!T[new C.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()]),S&&(O=(0,C.groupByExtension)(O,F=>F.identifier).map(F=>F.sort((M,W)=>i.rcompare(M.manifest.version,W.manifest.version))[0])),this.logService.trace("Scanned user extensions:",O.length),O}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(S,T,O){const p=S.key(),F=P.join(this.extensionsPath,`.${(0,h.generateUuid)()}`),M=P.join(this.extensionsPath,p);try{await b.Promises.rm(M)}catch(j){try{await b.Promises.rm(M)}catch(U){}throw new g.ExtensionManagementError((0,y.localize)(0,null,M,S.id),u)}await this.extractAtLocation(S,T,F,O);let W=await this.scanExtension(E.URI.file(F),1);if(!W)throw new Error((0,y.localize)(1,null,F));await this.storeMetadata(W,{installedTimestamp:Date.now()});try{await this.rename(S,F,M,Date.now()+2*60*1e3),this.logService.info("Renamed to",M)}catch(j){try{await b.Promises.rm(F)}catch(U){}if(j.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",S.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(j)}. Deleted from extracted location`,F),j}try{W=await this.scanExtension(E.URI.file(M),1)}catch(j){}if(W)return W;throw new Error((0,y.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(S,T){return this.setMetadata(S,T),await this.storeMetadata(S,{...T,installedTimestamp:S.installedTimestamp}),S}async storeMetadata(S,T){T.isMachineScoped=T.isMachineScoped||void 0,T.isBuiltin=T.isBuiltin||void 0,T.installedTimestamp=T.installedTimestamp||void 0;const O=P.join(S.location.fsPath,"package.json"),p=await b.Promises.readFile(O,"utf8"),{manifest:F}=await this.parseManifest(p);return F.__metadata=T,await b.Promises.writeFile(O,JSON.stringify(F,null,"	")),S}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...S){const T=S.map(O=>new C.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version));await this.withUninstalledExtensions(O=>{T.forEach(p=>O[p.key()]=!0)})}async setInstalled(S){await this.withUninstalledExtensions(p=>delete p[S.key()]);const O=(await this.scanExtensions(1)).find(p=>new C.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).equals(S))||null;return O?(await this.storeMetadata(O,{installedTimestamp:Date.now()}),this.scanExtension(O.location,1)):null}async withUninstalledExtensions(S){return this.uninstalledFileLimiter.queue(async()=>{let T;try{T=await b.Promises.readFile(this.uninstalledPath,"utf8")}catch(p){if(p.code!=="ENOENT")throw p}let O={};if(T)try{O=JSON.parse(T)}catch(p){}return S&&(S(O),Object.keys(O).length?await b.Promises.writeFile(this.uninstalledPath,JSON.stringify(O)):await b.Promises.rm(this.uninstalledPath)),O})}async removeExtension(S,T){this.logService.trace(`Deleting ${T} extension from disk`,S.identifier.id,S.location.fsPath),await b.Promises.rm(S.location.fsPath),this.logService.info("Deleted from disk",S.identifier.id,S.location.fsPath)}async removeUninstalledExtension(S){await this.removeExtension(S,"uninstalled"),await this.withUninstalledExtensions(T=>delete T[new C.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).key()])}async extractAtLocation(S,T,O,p){this.logService.trace(`Started extracting the extension from ${T} to ${O}`);try{await b.Promises.rm(O)}catch(F){throw new g.ExtensionManagementError(this.joinErrors(F).message,u)}try{await(0,c.extract)(T,O,{sourcePath:"extension",overwrite:!0},p),this.logService.info(`Extracted extension to ${O}:`,S.id)}catch(F){try{await b.Promises.rm(O)}catch(M){}throw new g.ExtensionManagementError(F.message,F instanceof c.ExtractError&&F.type?F.type:s)}}async rename(S,T,O,p){try{await b.Promises.rename(T,O)}catch(F){if(m.isWindows&&F&&F.code==="EPERM"&&Date.now()<p)return this.logService.info(`Failed renaming ${T} to ${O} with 'EPERM' error. Trying again...`,S.id),this.rename(S,T,O,p);throw new g.ExtensionManagementError(F.message||(0,y.localize)(3,null,T,O),F.code||l)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const S=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return S;const T=this.scanDevSystemExtensions(),[O,p]=await Promise.all([S,T]);return[...O,...p]}async scanExtensionsInDir(S,T){const O=new L.Limiter(10),p=await this.fileService.resolve(E.URI.file(S));return p.children?(await Promise.all(p.children.filter(M=>M.isDirectory).map(M=>O.queue(async()=>T===1&&(0,w.basename)(M.resource).indexOf(".")===0?null:this.scanExtension(M.resource,T))))).filter(M=>M&&M.identifier):[]}async scanExtension(S,T){try{const O=await this.fileService.resolve(S);if(O.children){const{manifest:p,metadata:F}=await this.readManifest(S.fsPath),M=O.children.find(({name:N})=>/^readme(\.txt|\.md|)$/i.test(N))?.resource,W=O.children.find(({name:N})=>/^changelog(\.txt|\.md|)$/i.test(N))?.resource,j={id:(0,C.getGalleryExtensionId)(p.publisher,p.name)},U={type:T,identifier:j,manifest:p,location:S,readmeUrl:M,changelogUrl:W,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:T===0};return F&&(this.setMetadata(U,F),U.installedTimestamp=F.installedTimestamp),U}}catch(O){T!==0&&this.logService.trace(O)}return null}async scanDefaultSystemExtensions(){const S=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",S.length),S}async scanDevSystemExtensions(){const S=this.getDevSystemExtensionsList();if(S.length){const T=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",T.length),T.filter(O=>S.some(p=>(0,C.areSameExtensions)(O.identifier,{id:p})))}else return[]}setMetadata(S,T){S.publisherDisplayName=T.publisherDisplayName||null,S.publisherId=T.publisherId||null,S.identifier.uuid=T.id,S.isMachineScoped=!!T.isMachineScoped,S.isBuiltin=S.type===0||!!T.isBuiltin}async removeUninstalledExtensions(){const S=await this.getUninstalledExtensions(),T=await this.scanAllUserExtensions(),O=new Set;for(const M of T)S[new C.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()]||O.add(M.identifier.id.toLowerCase());const p=(0,C.groupByExtension)(T,M=>M.identifier);await L.Promises.settled(p.map(async M=>{const W=M.sort((j,U)=>i.rcompare(j.manifest.version,U.manifest.version))[0];O.has(W.identifier.id.toLowerCase())||await this.beforeRemovingExtension(W)}));const F=T.filter(M=>S[new C.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version).key()]);await L.Promises.settled(F.map(M=>this.removeUninstalledExtension(M)))}async removeOutdatedExtensions(){const S=await this.scanAllUserExtensions(),T=[],O=(0,C.groupByExtension)(S,p=>p.identifier);T.push(...(0,D.flatten)(O.map(p=>p.sort((F,M)=>i.rcompare(F.manifest.version,M.manifest.version)).slice(1)))),await L.Promises.settled(T.map(p=>this.removeExtension(p,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(S=>S.name)}joinErrors(S){const T=Array.isArray(S)?S:[S];return T.length===1?T[0]instanceof Error?T[0]:new Error(T[0]):T.reduce((O,p)=>new Error(`${O.message}${O.message?",":""}${p instanceof Error?p.message:p}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(A.FileAccess.asFileUri("",Y).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(S){const T=[b.Promises.readFile(P.join(S,"package.json"),"utf8").then(M=>this.parseManifest(M)),b.Promises.readFile(P.join(S,"package.nls.json"),"utf8").then(void 0,M=>M.code!=="ENOENT"?Promise.reject(M):"{}").then(M=>JSON.parse(M))],[{manifest:O,metadata:p},F]=await Promise.all(T);return{manifest:(0,v.localizeManifest)(O,F),metadata:p}}parseManifest(S){return new Promise((T,O)=>{try{const p=JSON.parse(S),F=p.__metadata||null;T({manifest:p,metadata:F})}catch(p){O(new Error((0,y.localize)(4,null)))}})}};f=he([X(1,o.IFileService),X(2,a.ILogService),X(3,I.INativeEnvironmentService),X(4,t.IProductService)],f),e.ExtensionsScanner=f}),define(te[217],ne([0,1,37,17,8,4,15,58,5,30,18,62,117,74,12,183,27,31,164,165,215,152,216,166,72,13,7,14,44,21]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y,I,g,C,v,o,a,t,r,n,s,u,l,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const S="unsetUninstalled",T="downloading";let O=class extends y.AbstractExtensionManagementService{constructor(U,N,z,H,V,x,K){super(U,N,z);this.environmentService=H,this.downloadService=V;const q=this._register(x.createInstance(v.ExtensionsLifecycle));this.extensionsScanner=this._register(x.createInstance(t.ExtensionsScanner,_=>q.postUninstall(_))),this.manifestCache=this._register(new a.ExtensionsManifestCache(H,this)),this.extensionsDownloader=this._register(x.createInstance(C.ExtensionsDownloader));const $=this._register(new r.ExtensionsWatcher(this,K,H,z));this._register($.onDidChangeExtensionsByAnotherSource(({added:_,removed:J})=>{_.length&&this._onDidInstallExtensions.fire(_.map(G=>({identifier:G.identifier,operation:0,local:G}))),J.forEach(G=>this._onDidUninstallExtension.fire({identifier:G}))}))}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const N=await this.collectFiles(U),z=await(0,E.zip)((0,A.joinPath)(this.environmentService.tmpDir,(0,w.generateUuid)()).fsPath,N);return m.URI.file(z)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const N=await this.downloadVsix(U),z=R.resolve(N.fsPath);return(0,o.getManifest)(z)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async canInstall(U){return!0}async install(U,N={}){this.logService.trace("ExtensionManagementService#install",U.toString());const z=await this.downloadVsix(U),H=await(0,o.getManifest)(R.resolve(z.fsPath));if(H.engines&&H.engines.vscode&&!(0,n.isEngineValid)(H.engines.vscode,f.default.version,f.default.date))throw new Error(h.localize(0,null,(0,g.getGalleryExtensionId)(H.publisher,H.name),f.default.version));return this.installExtension(H,z,N)}async updateMetadata(U,N){return this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},...N}),this.manifestCache.invalidate(),U}async updateExtensionScope(U,N){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:N}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===L.Schemas.file)return U;if(!this.downloadService)throw new Error("Download service is not available");const N=(0,A.joinPath)(this.environmentService.tmpDir,(0,w.generateUuid)());return await this.downloadService.download(U,N),N}createInstallExtensionTask(U,N,z){return m.URI.isUri(N)?new M(U,N,z,this.galleryService,this.extensionsScanner,this.logService):new F(N,z,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,N){return new W(U,N,this.extensionsScanner)}async collectFiles(U){const N=async H=>{let V=await i.Promises.readdir(H);V=V.map(q=>R.join(H,q));const x=await Promise.all(V.map(q=>i.Promises.stat(q)));let K=Promise.resolve([]);return x.forEach((q,$)=>{const _=V[$];q.isFile()&&(K=K.then(J=>[...J,_])),q.isDirectory()&&(K=K.then(J=>N(_).then(G=>[...J,...G])))}),K};return(await N(U.location.fsPath)).map(H=>({path:`extension/${R.relative(U.location.fsPath,H)}`,localPath:H}))}};O=he([X(0,I.IExtensionGalleryService),X(1,d.ITelemetryService),X(2,l.ILogService),X(3,c.INativeEnvironmentService),X(4,(0,u.optional)(b.IDownloadService)),X(5,u.IInstantiationService),X(6,s.IFileService)],O),e.ExtensionManagementService=O;class p extends y.AbstractExtensionTask{constructor(U,N,z,H){super();this.identifier=U,this.source=N,this.extensionsScanner=z,this.logService=H,this._operation=1}get operation(){return this._operation}async installExtension(U,N){try{const z=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(z)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(z,U.metadata):z}catch(z){throw k.isMacintosh?new I.ExtensionManagementError(h.localize(1,null),S):new I.ExtensionManagementError(h.localize(2,null),S)}return this.extract(U,N)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const z=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),z}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:N,metadata:z},H){let V=await this.extensionsScanner.extractUserExtension(N,U,H);return this.logService.info("Extracting completed.",N.id),z&&(V=await this.extensionsScanner.saveMetadataForLocalExtension(V,z)),V}}class F extends p{constructor(U,N,z,H,V){super(U.identifier,U,H,V);this.gallery=U,this.options=N,this.extensionsDownloader=z}async doRun(U){const z=(await this.extensionsScanner.scanExtensions(null)).find(x=>(0,g.areSameExtensions)(x.identifier,this.gallery.identifier));z&&(this._operation=2);const H=await this.downloadInstallableExtension(this.gallery,this._operation);H.metadata.isMachineScoped=this.options.isMachineScoped||z?.isMachineScoped,H.metadata.isBuiltin=this.options.isBuiltin||z?.isBuiltin;const V=await this.installExtension(H,U);z&&P.neq(z.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(z);try{await this.extensionsDownloader.delete(m.URI.file(H.zipPath))}catch(x){}return V}async downloadInstallableExtension(U,N){const z={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let H;try{this.logService.trace("Started downloading extension:",U.identifier.id),H=(await this.extensionsDownloader.downloadExtension(U,N)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,H)}catch(V){throw new I.ExtensionManagementError((0,y.joinErrors)(V).message,T)}try{const V=await(0,o.getManifest)(H);return{zipPath:H,identifierWithVersion:new g.ExtensionIdentifierWithVersion(U.identifier,V.version),metadata:z}}catch(V){throw new I.ExtensionManagementError((0,y.joinErrors)(V).message,y.INSTALL_ERROR_VALIDATING)}}}class M extends p{constructor(U,N,z,H,V,x){super({id:(0,g.getGalleryExtensionId)(U.publisher,U.name)},N,V,x);this.manifest=U,this.location=N,this.options=z,this.galleryService=H}async doRun(U){const N=new g.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),H=(await this.extensionsScanner.scanExtensions(1)).find(x=>(0,g.areSameExtensions)(this.identifier,x.identifier)),V=await this.getMetadata(this.identifier.id,U);if(H)if(V.isMachineScoped=this.options.isMachineScoped||H.isMachineScoped,V.isBuiltin=this.options.isBuiltin||H.isBuiltin,this._operation=2,N.equals(new g.ExtensionIdentifierWithVersion(H.identifier,H.manifest.version)))try{await this.extensionsScanner.removeExtension(H,"existing")}catch(x){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else P.gt(H.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(H);else{const x=await this.unsetUninstalledAndGetLocal(N);if(x)try{await this.extensionsScanner.removeExtension(x,"existing")}catch(K){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:N,metadata:V},U)}async getMetadata(U,N){try{const z=(await this.galleryService.query({names:[U],pageSize:1},N)).firstPage[0];if(z)return{id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId}}catch(z){}return{}}}class W extends y.AbstractExtensionTask{constructor(U,N,z){super();this.extension=U,this.options=N,this.extensionsScanner=z}async doRun(U){const N=[],z=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const H=new g.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);N.push(...z.filter(V=>H.equals(new g.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version))))}else N.push(...z.filter(H=>(0,g.areSameExtensions)(H.identifier,this.extension.identifier)));if(!N.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...N),this.options.remove)for(const H of N)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(H)}catch(V){throw new Error(h.localize(6,null,(0,D.toErrorMessage)(V)))}}}}),define(te[224],ne([0,1,104,50,225,35,37,11,2,17,15,5,36,103,171,151,172,161,162,163,149,153,24,174,73,182,74,176,12,138,178,184,27,140,185,217,75,142,13,168,170,52,7,158,78,159,160,57,167,14,79,59,44,28,175,42,20,180,181,21,82,84,83,53,186,187,85,189,195,87,88,89,22,60,206,207,208,61,209,210,211,212,213,214]),function(Y,e,D,L,R,k,A,P,m,w,i,E,h,b,c,y,I,g,C,v,o,a,t,r,n,s,u,l,f,d,S,T,O,p,F,M,W,j,U,N,z,H,V,x,K,q,$,_,J,G,ee,Z,ce,ae,fe,ye,Se,Pe,Te,Re,Ce,Ne,De,ke,Ye,Je,$e,qe,Q,re,se,me,pe,Ae,Ie,Oe,Le,B,ie,oe,le,de,we,ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ve extends m.Disposable{constructor(ue){super();this.configuration=ue,this.server=this._register(new b.Server),(0,R.gracefulify)(L),this.registerListeners()}registerListeners(){const ue=()=>this.dispose();process.once("exit",ue),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ue)}async open(){const ue=await this.initServices();(0,pe.registerConfiguration)(),ue.invokeFunction(Ue=>{const Fe=Ue.get(G.ILogService);Fe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(Fe)}),this._register((0,m.combinedDisposable)(ue.createInstance(c.CodeCacheCleaner,this.configuration.codeCachePath),ue.createInstance(I.LanguagePackCachedDataCleaner),ue.createInstance(v.StorageDataCleaner,this.configuration.backupWorkspacesPath),ue.createInstance(C.LogsDataCleaner),ue.createInstance(g.LocalizationsUpdater),ue.createInstance(y.DeprecatedExtensionsCleaner)))}async initServices(){const ue=new K.ServiceCollection,Ue={_serviceBrand:void 0,...ce.default};ue.set(ae.IProductService,Ue);const Fe=new h.StaticRouter(We=>We==="main"),Me=new q.MessagePortMainProcessService(this.server,Fe);ue.set($.IMainProcessService,Me);const _e=new d.NativeEnvironmentService(this.configuration.args,Ue);ue.set(f.INativeEnvironmentService,_e);const et=new ee.LogLevelChannelClient(this.server.getChannel("logLevel",Fe)),Be=new ee.LoggerChannelClient(this.configuration.logLevel,et.onDidChangeLogLevel,Me.getChannel("logger"));ue.set(G.ILoggerService,Be);const nt=this._register(new G.MultiplexLogService([this._register(new G.ConsoleLogger(this.configuration.logLevel)),this._register(Be.createLogger((0,i.joinPath)(E.URI.file(_e.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ve=this._register(new ee.FollowerLogService(et,nt));ue.set(G.ILogService,Ve);const He=this._register(new N.FileService(Ve));ue.set(U.IFileService,He);const it=this._register(new z.DiskFileSystemProvider(Ve));He.registerProvider(w.Schemas.file,it);const ze=this._register(new r.ConfigurationService(_e.settingsResource,He));ue.set(t.IConfigurationService,ze),await ze.initialize();const Xe=new Pe.NativeStorageService(void 0,Me,_e);ue.set(Se.IStorageService,Xe),await Xe.initialize(),this._register((0,m.toDisposable)(()=>Xe.flush())),ue.set(ye.IRequestService,new H.SyncDescriptor(fe.RequestService)),ue.set(o.IChecksumService,new H.SyncDescriptor(a.ChecksumService));const tt=h.ProxyChannel.toService(Me.getChannel("nativeHost"),{context:this.configuration.windowId});ue.set(Z.INativeHostService,tt),ue.set(u.IDownloadService,new H.SyncDescriptor(l.DownloadService));const rt=this._register(new ge.ActiveWindowManager(tt)),ht=new h.StaticRouter(We=>rt.getActiveClientId().then(st=>We===st));ue.set(W.IExtensionRecommendationNotificationService,new j.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));let Qe,Ge;if(!_e.isExtensionDevelopment&&!_e.disableTelemetry&&Ue.enableTelemetry){Ge=new Ne.TelemetryLogAppender(Be,_e);const{appRoot:We,extensionsPath:st,isBuilt:dt,installSourcePath:gt}=_e;if(Ue.aiConfig&&Ue.aiConfig.asimovKey&&dt){const ct=new Ye.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey);this._register((0,m.toDisposable)(()=>ct.flush())),Ge=(0,ke.combinedAppender)(ct,Ge)}Qe=new De.TelemetryService({appender:Ge,commonProperties:(0,Te.resolveCommonProperties)(He,(0,k.release)(),(0,k.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:[We,st]},ze)}else Qe=ke.NullTelemetryService,Ge=ke.NullAppender;this.server.registerChannel("telemetryAppender",new Ce.TelemetryAppenderChannel(Ge)),ue.set(Re.ITelemetryService,Qe);const ft=new Je.CustomEndpointTelemetryService(ze,Qe,Be,_e);return ue.set(Re.ICustomEndpointTelemetryService,ft),ue.set(O.IExtensionManagementService,new H.SyncDescriptor(M.ExtensionManagementService)),ue.set(O.IExtensionGalleryService,new H.SyncDescriptor(T.ExtensionGalleryService)),ue.set(O.IExtensionTipsService,new H.SyncDescriptor(F.ExtensionTipsService)),ue.set(_.ILocalizationsService,new H.SyncDescriptor(J.LocalizationsService)),ue.set(n.IDiagnosticsService,new H.SyncDescriptor(s.DiagnosticsService)),ue.set(Ae.IUserDataSyncAccountService,new H.SyncDescriptor(Ae.UserDataSyncAccountService)),ue.set(pe.IUserDataSyncLogService,new H.SyncDescriptor(Le.UserDataSyncLogService)),ue.set(pe.IUserDataSyncUtilService,new Oe.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),ue.set(O.IGlobalExtensionEnablementService,new H.SyncDescriptor(S.GlobalExtensionEnablementService)),ue.set(se.IIgnoredExtensionsManagementService,new H.SyncDescriptor(se.IgnoredExtensionsManagementService)),ue.set(re.IExtensionsStorageSyncService,new H.SyncDescriptor(re.ExtensionsStorageSyncService)),ue.set(pe.IUserDataSyncStoreManagementService,new H.SyncDescriptor(de.UserDataSyncStoreManagementService)),ue.set(pe.IUserDataSyncStoreService,new H.SyncDescriptor(de.UserDataSyncStoreService)),ue.set(B.IUserDataSyncMachinesService,new H.SyncDescriptor(B.UserDataSyncMachinesService)),ue.set(pe.IUserDataSyncBackupStoreService,new H.SyncDescriptor(Ie.UserDataSyncBackupStoreService)),ue.set(pe.IUserDataAutoSyncEnablementService,new H.SyncDescriptor(me.UserDataAutoSyncEnablementService)),ue.set(pe.IUserDataSyncResourceEnablementService,new H.SyncDescriptor(ie.UserDataSyncResourceEnablementService)),ue.set(pe.IUserDataSyncService,new H.SyncDescriptor(oe.UserDataSyncService)),ue.set(qe.ILocalPtyService,this._register(new Q.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:ze.getValue("terminal.integrated.persistentSessionScrollback")??100,useExperimentalSerialization:ze.getValue("terminal.integrated.persistentSessionExperimentalSerializer")??!0},ze,Ve,Qe))),new x.InstantiationService(ue)}initChannels(ue){const Ue=new p.ExtensionManagementChannel(ue.get(O.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const Fe=h.ProxyChannel.fromService(ue.get(_.ILocalizationsService));this.server.registerChannel("localizations",Fe);const Me=h.ProxyChannel.fromService(ue.get(n.IDiagnosticsService));this.server.registerChannel("diagnostics",Me);const _e=new p.ExtensionTipsChannel(ue.get(O.IExtensionTipsService));this.server.registerChannel("extensionTipsService",_e);const et=h.ProxyChannel.fromService(ue.get(o.IChecksumService));this.server.registerChannel("checksum",et);const Be=new Oe.UserDataSyncMachinesServiceChannel(ue.get(B.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Be);const nt=h.ProxyChannel.fromService(ue.get(Re.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",nt);const Ve=new Oe.UserDataSyncAccountServiceChannel(ue.get(Ae.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const He=new Oe.UserDataSyncStoreManagementServiceChannel(ue.get(pe.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",He);const it=new le.UserDataSyncChannel(ue.get(pe.IUserDataSyncService),ue.get(G.ILogService));this.server.registerChannel("userDataSync",it);const ze=this._register(ue.get(V.IInstantiationService).createInstance(we.UserDataAutoSyncService)),Xe=new Oe.UserDataAutoSyncChannel(ze);this.server.registerChannel("userDataAutoSync",Xe);const tt=ue.get(qe.ILocalPtyService),rt=h.ProxyChannel.fromService(tt);this.server.registerChannel($e.TerminalIpcChannels.LocalPty,rt)}registerErrorHandler(ue){window.addEventListener("unhandledrejection",Ue=>{(0,P.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,P.setUnexpectedErrorHandler)(Ue=>{const Fe=(0,A.toErrorMessage)(Ue,!0);!Fe||ue.error(`[uncaught exception in sharedProcess]: ${Fe}`)})}}async function Ee(be){const ue=new ve(be);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ue.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ee})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e7d7e9a9348e6a8cc8c03f877d39cb72e5dfb1ff/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
