/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","vs/base/common/extpath","fs","vs/base/common/process","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],Z=function(q){for(var e=[],w=0,A=q.length;w<A;w++)e[w]=J[q[w]];return e};define(J[102],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(A,k){if(!A)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=w}),define(J[46],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function w(S){return(n,f,m)=>{let t=null,b=null;if(typeof m.value=="function"?(t="value",b=m.value):typeof m.get=="function"&&(t="get",b=m.get),!b)throw new Error("not supported");m[t]=S(b,f)}}e.createDecorator=w;function A(S,n,f){let m=null,t=null;if(typeof f.value=="function"?(m="value",t=f.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(m="get",t=f.get),!t)throw new Error("not supported");const b=`$memoize$${n}`;f[m]=function(...I){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,I)}),this[b]}}e.memoize=A;function k(S,n,f){return w((m,t)=>{const b=`$debounce$${t}`,I=`$debounce$result$${t}`;return function(...y){this[I]||(this[I]=f?f():void 0),clearTimeout(this[b]),n&&(this[I]=n(this[I],...y),y=[this[I]]),this[b]=setTimeout(()=>{m.apply(this,y),this[I]=f?f():void 0},S)}})}e.debounce=k;function M(S,n,f){return w((m,t)=>{const b=`$throttle$timer$${t}`,I=`$throttle$result$${t}`,y=`$throttle$lastRun$${t}`,h=`$throttle$pending$${t}`;return function(...g){if(this[I]||(this[I]=f?f():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),n&&(this[I]=n(this[I],...g)),this[h])return;const P=this[y]+S;P<=Date.now()?(this[y]=Date.now(),m.apply(this,[this[I]]),this[I]=f?f():void 0):(this[h]=!0,this[b]=setTimeout(()=>{this[h]=!1,this[y]=Date.now(),m.apply(this,[this[I]]),this[I]=f?f():void 0},P-Date.now()))}})}e.throttle=M}),define(J[16],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(s=>{s(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=w,e.errorHandler=new w;function A(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=A;function k(c){f(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=k;function M(c){f(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=M;function S(c){if(c instanceof Error){let{name:i,message:s}=c;const r=c.stacktrace||c.stack;return{$isError:!0,name:i,message:s,stack:r}}return c}e.transformErrorForSerialization=S;const n="Canceled";function f(c){return c instanceof Error&&c.name===n&&c.message===n}e.isPromiseCanceledError=f;class m extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=m;function t(){const c=new Error(n);return c.name=c.message,c}e.canceled=t;function b(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=b;function I(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=I;function y(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function h(c){const i=new Error(`${c} has been disposed`);return i.name="DISPOSED",i}e.disposed=h;function g(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=g;class P extends Error{constructor(i){super("NotImplemented");i&&(this.message=i)}}e.NotImplementedError=P;class v extends Error{constructor(i){super("NotSupported");i&&(this.message=i)}}e.NotSupportedError=v;class u extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=u;function d(c){const i=c;return i instanceof Error&&Array.isArray(i.actions)}e.isErrorWithActions=d;function a(c,i=Object.create(null)){const s=new Error(c);return i.actions&&(s.actions=i.actions),s}e.createErrorWithActions=a}),define(J[34],Z([0,1,16]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function A(F,D=0){return F[F.length-(1+D)]}e.tail=A;function k(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=k;function M(F,D,R=(N,B)=>N===B){if(F===D)return!0;if(!F||!D||F.length!==D.length)return!1;for(let N=0,B=F.length;N<B;N++)if(!R(F[N],D[N]))return!1;return!0}e.equals=M;function S(F,D,R){let N=0,B=F.length-1;for(;N<=B;){const $=(N+B)/2|0,Y=R(F[$],D);if(Y<0)N=$+1;else if(Y>0)B=$-1;else return $}return-(N+1)}e.binarySearch=S;function n(F,D){let R=0,N=F.length;if(N===0)return 0;for(;R<N;){const B=Math.floor((R+N)/2);D(F[B])?N=B:R=B+1}return R}e.findFirstInSorted=n;function f(F,D,R){if(F=F|0,F>=D.length)throw new TypeError("invalid index");let N=D[Math.floor(D.length*Math.random())],B=[],$=[],Y=[];for(let ee of D){const ie=R(ee,N);ie<0?B.push(ee):ie>0?$.push(ee):Y.push(ee)}return F<B.length?f(F,B,R):F<B.length+Y.length?Y[0]:f(F-(B.length+Y.length),$,R)}e.quickSelect=f;function m(F,D){const R=[];let N;for(const B of F.slice(0).sort(D))!N||D(N[0],B)!==0?(N=[B],R.push(N)):N.push(B);return R}e.groupBy=m;function t(F,D,R){const N=[];function B(ee,ie,oe){if(ie===0&&oe.length===0)return;const ce=N[N.length-1];ce&&ce.start+ce.deleteCount===ee?(ce.deleteCount+=ie,ce.toInsert.push(...oe)):N.push({start:ee,deleteCount:ie,toInsert:oe})}let $=0,Y=0;for(;;){if($===F.length){B($,0,D.slice(Y));break}if(Y===D.length){B($,F.length-$,[]);break}const ee=F[$],ie=D[Y],oe=R(ee,ie);oe===0?($+=1,Y+=1):oe<0?(B($,1,[]),$+=1):oe>0&&(B($,0,[ie]),Y+=1)}return N}e.sortedDiff=t;function b(F,D,R){const N=t(F,D,R),B=[],$=[];for(const Y of N)B.push(...F.slice(Y.start,Y.start+Y.deleteCount)),$.push(...Y.toInsert);return{removed:B,added:$}}e.delta=b;function I(F,D,R){if(R===0)return[];const N=F.slice(0,R).sort(D);return h(F,D,N,R,F.length),N}e.top=I;function y(F,D,R,N,B){return R===0?Promise.resolve([]):new Promise(($,Y)=>{(async()=>{const ee=F.length,ie=F.slice(0,R).sort(D);for(let oe=R,ce=Math.min(R+N,ee);oe<ee;oe=ce,ce=Math.min(ce+N,ee)){if(oe>R&&await new Promise(ne=>setTimeout(ne)),B&&B.isCancellationRequested)throw(0,w.canceled)();h(F,D,ie,oe,ce)}return ie})().then($,Y)})}e.topAsync=y;function h(F,D,R,N,B){for(const $=R.length;N<B;N++){const Y=F[N];if(D(Y,R[$-1])<0){R.pop();const ee=n(R,ie=>D(Y,ie)<0);R.splice(ee,0,Y)}}}function g(F){return F.filter(D=>!!D)}e.coalesce=g;function P(F){let D=0;for(let R=0;R<F.length;R++)F[R]&&(F[D]=F[R],D+=1);F.length=D}e.coalesceInPlace=P;function v(F,D,R){F.splice(R,0,F.splice(D,1)[0])}e.move=v;function u(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=u;function d(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=d;function a(F,D){if(!D)return F.filter((N,B)=>F.indexOf(N)===B);const R=Object.create(null);return F.filter(N=>{const B=D(N);return R[B]?!1:(R[B]=!0,!0)})}e.distinct=a;function c(F){const D=new Set;return F.filter(R=>D.has(R)?!1:(D.add(R),!0))}e.distinctES6=c;function i(F){const D=Object.create(null);return R=>{const N=F(R);return D[N]?!1:(D[N]=!0,!0)}}e.uniqueFilter=i;function s(F,D){for(let R=F.length-1;R>=0;R--){const N=F[R];if(D(N))return R}return-1}e.lastIndex=s;function r(F,D){return F.length>0?F[0]:D}e.firstOrDefault=r;function o(F,D,R=(N,B)=>N===B){let N=0;for(let B=0,$=Math.min(F.length,D.length);B<$&&R(F[B],D[B]);B++)N++;return N}e.commonPrefixLength=o;function l(F){return[].concat(...F)}e.flatten=l;function p(F,D){let R=typeof D=="number"?F:0;typeof D=="number"?R=F:(R=0,D=F);const N=[];if(R<=D)for(let B=R;B<D;B++)N.push(B);else for(let B=R;B>D;B--)N.push(B);return N}e.range=p;function E(F,D,R){return F.reduce((N,B)=>(N[D(B)]=R?R(B):B,N),Object.create(null))}e.index=E;function L(F,D){return F.push(D),()=>T(F,D)}e.insert=L;function T(F,D){const R=F.indexOf(D);if(R>-1)return F.splice(R,1),D}e.remove=T;function W(F,D,R){const N=F.slice(0,D),B=F.slice(D);return N.concat(R,B)}e.arrayInsert=W;function C(F,D){let R;if(typeof D=="number"){let N=D;R=()=>{const B=Math.sin(N++)*179426549;return B-Math.floor(B)}}else R=Math.random;for(let N=F.length-1;N>0;N-=1){const B=Math.floor(R()*(N+1)),$=F[N];F[N]=F[B],F[B]=$}}e.shuffle=C;function V(F,D){const R=F.indexOf(D);R>-1&&(F.splice(R,1),F.unshift(D))}e.pushToStart=V;function x(F,D){const R=F.indexOf(D);R>-1&&(F.splice(R,1),F.push(D))}e.pushToEnd=x;function se(F,D){return Array.isArray(F)?F.map(D):D(F)}e.mapArrayOrNot=se;function G(F){return Array.isArray(F)?F:[F]}e.asArray=G;function Q(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=Q;function O(F,D){for(const R of F){const N=D(R);if(N!==void 0)return N}}e.mapFind=O;function z(F,D,R){const N=X(F,D),B=F.length,$=R.length;F.length=B+$;for(let Y=B-1;Y>=N;Y--)F[Y+$]=F[Y];for(let Y=0;Y<$;Y++)F[Y+N]=R[Y]}e.insertInto=z;function U(F,D,R,N){const B=X(F,D),$=F.splice(B,R);return z(F,B,N),$}e.splice=U;function X(F,D){return D<0?Math.max(D+F.length,0):Math.min(D,F.length)}function H(F,D){let R=Number.MAX_SAFE_INTEGER,N=0;return F.forEach((B,$)=>{const Y=D(B);Y<R&&(R=Y,N=$)}),N}e.minIndex=H;function _(F,D){let R=Number.MIN_SAFE_INTEGER,N=0;return F.forEach((B,$)=>{const Y=D(B);Y>R&&(R=Y,N=$)}),N}e.maxIndex=_;class j{constructor(D){this.items=D,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(D){let R=this.firstIdx;for(;R<this.items.length&&D(this.items[R]);)R++;const N=R===this.firstIdx?null:this.items.slice(this.firstIdx,R);return this.firstIdx=R,N}takeFromEndWhile(D){let R=this.lastIdx;for(;R>=0&&D(this.items[R]);)R--;const N=R===this.lastIdx?null:this.items.slice(R+1,this.lastIdx+1);return this.lastIdx=R,N}}e.ArrayQueue=j}),define(J[43],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(A){const k=this;let M=!1,S;return function(){return M||(M=!0,S=A.apply(k,arguments)),S}}e.once=w}),define(J[63],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(A){function k(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}A.is=k;const M=Object.freeze([]);function S(){return M}A.empty=S;function*n(c){yield c}A.single=n;function f(c){return c||M}A.from=f;function m(c){return!c||c[Symbol.iterator]().next().done===!0}A.isEmpty=m;function t(c){return c[Symbol.iterator]().next().value}A.first=t;function b(c,i){for(const s of c)if(i(s))return!0;return!1}A.some=b;function I(c,i){for(const s of c)if(i(s))return s}A.find=I;function*y(c,i){for(const s of c)i(s)&&(yield s)}A.filter=y;function*h(c,i){let s=0;for(const r of c)yield i(r,s++)}A.map=h;function*g(...c){for(const i of c)for(const s of i)yield s}A.concat=g;function*P(c){for(const i of c)for(const s of i)yield s}A.concatNested=P;function v(c,i,s){let r=s;for(const o of c)r=i(r,o);return r}A.reduce=v;function*u(c,i,s=c.length){for(i<0&&(i+=c.length),s<0?s+=c.length:s>c.length&&(s=c.length);i<s;i++)yield c[i]}A.slice=u;function d(c,i=Number.POSITIVE_INFINITY){const s=[];if(i===0)return[s,c];const r=c[Symbol.iterator]();for(let o=0;o<i;o++){const l=r.next();if(l.done)return[s,A.empty()];s.push(l.value)}return[s,{[Symbol.iterator](){return r}}]}A.consume=d;function a(c,i,s=(r,o)=>r===o){const r=c[Symbol.iterator](),o=i[Symbol.iterator]();for(;;){const l=r.next(),p=o.next();if(l.done!==p.done)return!1;if(l.done)return!0;if(!s(l.value,p.value))return!1}}A.equals=a})(w=e.Iterable||(e.Iterable={}))}),define(J[40],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function S(i,s=!1){let r=0,o=i.length,l="",p=0,E=16,L=0;function T(Q){let O=0,z=0;for(;O<Q;){const U=i.charCodeAt(r);if(U>=48&&U<=57)z=z*16+U-48;else if(U>=65&&U<=70)z=z*16+U-65+10;else if(U>=97&&U<=102)z=z*16+U-97+10;else break;r++,O++}return O<Q&&(z=-1),z}function W(Q){r=Q,l="",p=0,E=16,L=0}function C(){const Q=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&m(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&m(i.charCodeAt(r)))for(r++;r<i.length&&m(i.charCodeAt(r));)r++;else return L=3,i.substring(Q,r);let O=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&m(i.charCodeAt(r))){for(r++;r<i.length&&m(i.charCodeAt(r));)r++;O=r}else L=3;return i.substring(Q,O)}function V(){let Q="",O=r;for(;;){if(r>=o){Q+=i.substring(O,r),L=2;break}const z=i.charCodeAt(r);if(z===34){Q+=i.substring(O,r),r++;break}if(z===92){if(Q+=i.substring(O,r),r++,r>=o){L=2;break}switch(i.charCodeAt(r++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const X=T(4);X>=0?Q+=String.fromCharCode(X):L=4;break;default:L=5}O=r;continue}if(z>=0&&z<=31)if(f(z)){Q+=i.substring(O,r),L=2;break}else L=6;r++}return Q}function x(){if(l="",L=0,p=r,r>=o)return p=o,E=17;let Q=i.charCodeAt(r);if(n(Q)){do r++,l+=String.fromCharCode(Q),Q=i.charCodeAt(r);while(n(Q));return E=15}if(f(Q))return r++,l+=String.fromCharCode(Q),Q===13&&i.charCodeAt(r)===10&&(r++,l+=`
`),E=14;switch(Q){case 123:return r++,E=1;case 125:return r++,E=2;case 91:return r++,E=3;case 93:return r++,E=4;case 58:return r++,E=6;case 44:return r++,E=5;case 34:return r++,l=V(),E=10;case 47:const O=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<o&&!f(i.charCodeAt(r));)r++;return l=i.substring(O,r),E=12}if(i.charCodeAt(r+1)===42){r+=2;const z=o-1;let U=!1;for(;r<z;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,U=!0;break}r++}return U||(r++,L=1),l=i.substring(O,r),E=13}return l+=String.fromCharCode(Q),r++,E=16;case 45:if(l+=String.fromCharCode(Q),r++,r===o||!m(i.charCodeAt(r)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=C(),E=11;default:for(;r<o&&se(Q);)r++,Q=i.charCodeAt(r);if(p!==r){switch(l=i.substring(p,r),l){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return l+=String.fromCharCode(Q),r++,E=16}}function se(Q){if(n(Q)||f(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let Q;do Q=x();while(Q>=12&&Q<=15);return Q}return{setPosition:W,getPosition:()=>r,scan:s?G:x,getToken:()=>E,getTokenValue:()=>l,getTokenOffset:()=>p,getTokenLength:()=>r-p,getTokenError:()=>L}}e.createScanner=S;function n(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function f(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function b(i,s){const r=[],o=new Object;let l;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function L(T,W,C,V){p.value=T,p.offset=W,p.length=C,p.type=V,p.colonOffset=void 0,l=p}try{d(i,{onObjectBegin:(T,W)=>{if(s<=T)throw o;l=void 0,E=s>T,r.push("")},onObjectProperty:(T,W,C)=>{if(s<W||(L(T,W,C,"property"),r[r.length-1]=T,s<=W+C))throw o},onObjectEnd:(T,W)=>{if(s<=T)throw o;l=void 0,r.pop()},onArrayBegin:(T,W)=>{if(s<=T)throw o;l=void 0,r.push(0)},onArrayEnd:(T,W)=>{if(s<=T)throw o;l=void 0,r.pop()},onLiteralValue:(T,W,C)=>{if(s<W||(L(T,W,C,c(T)),s<=W+C))throw o},onSeparator:(T,W,C)=>{if(s<=W)throw o;if(T===":"&&l&&l.type==="property")l.colonOffset=W,E=!1,l=void 0;else if(T===","){const V=r[r.length-1];typeof V=="number"?r[r.length-1]=V+1:(E=!0,r[r.length-1]=""),l=void 0}}})}catch(T){if(T!==o)throw T}return{path:r,previousNode:l,isAtPropertyKey:E,matches:T=>{let W=0;for(let C=0;W<T.length&&C<r.length;C++)if(T[W]===r[C]||T[W]==="*")W++;else if(T[W]!=="**")return!1;return W===T.length}}}e.getLocation=b;function I(i,s=[],r=M.DEFAULT){let o=null,l=[];const p=[];function E(T){Array.isArray(l)?l.push(T):o!==null&&(l[o]=T)}return d(i,{onObjectBegin:()=>{const T={};E(T),p.push(l),l=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{l=p.pop()},onArrayBegin:()=>{const T=[];E(T),p.push(l),l=T,o=null},onArrayEnd:()=>{l=p.pop()},onLiteralValue:E,onError:(T,W,C)=>{s.push({error:T,offset:W,length:C})}},r),l[0]}e.parse=I;function y(i,s=[],r=M.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(T){o.type==="property"&&(o.length=T-o.offset,o=o.parent)}function p(T){return o.children.push(T),T}d(i,{onObjectBegin:T=>{o=p({type:"object",offset:T,length:-1,parent:o,children:[]})},onObjectProperty:(T,W,C)=>{o=p({type:"property",offset:W,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:T,offset:W,length:C,parent:o})},onObjectEnd:(T,W)=>{o.length=T+W-o.offset,o=o.parent,l(T+W)},onArrayBegin:(T,W)=>{o=p({type:"array",offset:T,length:-1,parent:o,children:[]})},onArrayEnd:(T,W)=>{o.length=T+W-o.offset,o=o.parent,l(T+W)},onLiteralValue:(T,W,C)=>{p({type:c(T),offset:W,length:C,parent:o,value:T}),l(W+C)},onSeparator:(T,W,C)=>{o.type==="property"&&(T===":"?o.colonOffset=W:T===","&&l(W))},onError:(T,W,C)=>{s.push({error:T,offset:W,length:C})}},r);const L=o.children[0];return L&&delete L.parent,L}e.parseTree=y;function h(i,s){if(!i)return;let r=i;for(let o of s)if(typeof o=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const p of r.children)if(Array.isArray(p.children)&&p.children[0].value===o){r=p.children[1],l=!0;break}if(!l)return}else{const l=o;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}e.findNodeAtLocation=h;function g(i){if(!i.parent||!i.parent.children)return[];const s=g(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;s.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&s.push(r)}return s}e.getNodePath=g;function P(i){switch(i.type){case"array":return i.children.map(P);case"object":const s=Object.create(null);for(let r of i.children){const o=r.children[1];o&&(s[r.children[0].value]=P(o))}return s;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=P;function v(i,s,r=!1){return s>=i.offset&&s<i.offset+i.length||r&&s===i.offset+i.length}e.contains=v;function u(i,s,r=!1){if(v(i,s,r)){const o=i.children;if(Array.isArray(o))for(let l=0;l<o.length&&o[l].offset<=s;l++){const p=u(o[l],s,r);if(p)return p}return i}}e.findNodeAtOffset=u;function d(i,s,r=M.DEFAULT){const o=S(i,!1);function l(R){return R?()=>R(o.getTokenOffset(),o.getTokenLength()):()=>!0}function p(R){return R?N=>R(N,o.getTokenOffset(),o.getTokenLength()):()=>!0}const E=l(s.onObjectBegin),L=p(s.onObjectProperty),T=l(s.onObjectEnd),W=l(s.onArrayBegin),C=l(s.onArrayEnd),V=p(s.onLiteralValue),x=p(s.onSeparator),se=l(s.onComment),G=p(s.onError),Q=r&&r.disallowComments,O=r&&r.allowTrailingComma;function z(){for(;;){const R=o.scan();switch(o.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:Q||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(R){case 12:case 13:Q?U(10):se();break;case 16:U(1);break;case 15:case 14:break;default:return R}}}function U(R,N=[],B=[]){if(G(R),N.length+B.length>0){let $=o.getToken();for(;$!==17;){if(N.indexOf($)!==-1){z();break}else if(B.indexOf($)!==-1)break;$=z()}}}function X(R){const N=o.getTokenValue();return R?V(N):L(N),z(),!0}function H(){switch(o.getToken()){case 11:let R=0;try{R=JSON.parse(o.getTokenValue()),typeof R!="number"&&(U(2),R=0)}catch(N){U(2)}V(R);break;case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return z(),!0}function _(){return o.getToken()!==10?(U(3,[],[2,5]),!1):(X(!1),o.getToken()===6?(x(":"),z(),D()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function j(){E(),z();let R=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(R||U(4,[],[]),x(","),z(),o.getToken()===2&&O)break}else R&&U(6,[],[]);_()||U(4,[],[2,5]),R=!0}return T(),o.getToken()!==2?U(7,[2],[]):z(),!0}function F(){W(),z();let R=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(R||U(4,[],[]),x(","),z(),o.getToken()===4&&O)break}else R&&U(6,[],[]);D()||U(4,[],[4,5]),R=!0}return C(),o.getToken()!==4?U(8,[4],[]):z(),!0}function D(){switch(o.getToken()){case 3:return F();case 1:return j();case 10:return X(!0);default:return H()}}return z(),o.getToken()===17?r.allowEmptyContent?!0:(U(4,[],[]),!1):D()?(o.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=d;function a(i,s){let r=S(i),o=[],l,p=0,E;do switch(E=r.getPosition(),l=r.scan(),l){case 12:case 13:case 17:p!==E&&o.push(i.substring(p,E)),s!==void 0&&o.push(r.getTokenValue().replace(/[^\r\n]/g,s)),p=r.getPosition();break}while(l!==17);return o.join("")}e.stripComments=a;function c(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(J[103],Z([0,1,40]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function A(f,m,t){let b,I,y,h,g;if(m){for(h=m.offset,g=h+m.length,y=h;y>0&&!n(f,y-1);)y--;let p=g;for(;p<f.length&&!n(f,p);)p++;I=f.substring(y,p),b=M(I,t)}else I=f,b=0,y=0,h=0,g=f.length;const P=S(t,f);let v=!1,u=0,d;t.insertSpaces?d=k(" ",t.tabSize||4):d="	";const a=(0,w.createScanner)(I,!1);let c=!1;function i(){return P+k(d,b+u)}function s(){let p=a.scan();for(v=!1;p===15||p===14;)v=v||p===14,p=a.scan();return c=p===16||a.getTokenError()!==0,p}const r=[];function o(p,E,L){!c&&E<g&&L>h&&f.substring(E,L)!==p&&r.push({offset:E,length:L-E,content:p})}let l=s();if(l!==17){const p=a.getTokenOffset()+y,E=k(d,b);o(E,y,p)}for(;l!==17;){let p=a.getTokenOffset()+a.getTokenLength()+y,E=s(),L="";for(;!v&&(E===12||E===13);){const W=a.getTokenOffset()+y;o(" ",p,W),p=a.getTokenOffset()+a.getTokenLength()+y,L=E===12?i():"",E=s()}if(E===2)l!==1&&(u--,L=i());else if(E===4)l!==3&&(u--,L=i());else{switch(l){case 3:case 1:u++,L=i();break;case 5:case 12:L=i();break;case 13:v?L=i():L=" ";break;case 6:L=" ";break;case 10:if(E===6){L="";break}case 7:case 8:case 9:case 11:case 2:case 4:E===12||E===13?L=" ":E!==5&&E!==17&&(c=!0);break;case 16:c=!0;break}v&&(E===12||E===13)&&(L=i())}const T=a.getTokenOffset()+y;o(L,p,T),l=E}return r}e.format=A;function k(f,m){let t="";for(let b=0;b<m;b++)t+=f;return t}function M(f,m){let t=0,b=0;const I=m.tabSize||4;for(;t<f.length;){const y=f.charAt(t);if(y===" ")b++;else if(y==="	")b+=I;else break;t++}return Math.floor(b/I)}function S(f,m){for(let t=0;t<m.length;t++){const b=m.charAt(t);if(b==="\r")return t+1<m.length&&m.charAt(t+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=S;function n(f,m){return`\r
`.indexOf(f.charAt(m))!==-1}e.isEOL=n}),define(J[76],Z([0,1,40,103]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(m,t,b){return M(m,t,void 0,b)}e.removeProperty=k;function M(m,t,b,I,y){const h=t.slice(),g=[],P=(0,w.parseTree)(m,g);let v,u;for(;h.length>0&&(u=h.pop(),v=(0,w.findNodeAtLocation)(P,h),v===void 0&&b!==void 0);)typeof u=="string"?b={[u]:b}:b=[b];if(v)if(v.type==="object"&&typeof u=="string"&&Array.isArray(v.children)){const d=(0,w.findNodeAtLocation)(v,[u]);if(d!==void 0)if(b===void 0){if(!d.parent)throw new Error("Malformed AST");const a=v.children.indexOf(d.parent);let c,i=d.parent.offset+d.parent.length;if(a>0){const s=v.children[a-1];c=s.offset+s.length}else c=v.offset+1,v.children.length>1&&(i=v.children[1].offset);return S(m,{offset:c,length:i-c,content:""},I)}else return S(m,{offset:d.offset,length:d.length,content:JSON.stringify(b)},I);else{if(b===void 0)return[];const a=`${JSON.stringify(u)}: ${JSON.stringify(b)}`,c=y?y(v.children.map(s=>s.children[0].value)):v.children.length;let i;if(c>0){const s=v.children[c-1];i={offset:s.offset+s.length,length:0,content:","+a}}else v.children.length===0?i={offset:v.offset+1,length:0,content:a}:i={offset:v.offset+1,length:0,content:a+","};return S(m,i,I)}}else if(v.type==="array"&&typeof u=="number"&&Array.isArray(v.children))if(b!==void 0){const d=`${JSON.stringify(b)}`;let a;if(v.children.length===0||u===0)a={offset:v.offset+1,length:0,content:v.children.length===0?d:d+","};else{const c=u===-1||u>v.children.length?v.children.length:u,i=v.children[c-1];a={offset:i.offset+i.length,length:0,content:","+d}}return S(m,a,I)}else{const d=u,a=v.children[d];let c;if(v.children.length===1)c={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===d){const i=v.children[d-1],s=i.offset+i.length,r=v.offset+v.length;c={offset:s,length:r-2-s,content:""}}else c={offset:a.offset,length:v.children[d+1].offset-a.offset,content:""};return S(m,c,I)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${v.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return S(m,{offset:P?P.offset:0,length:P?P.length:0,content:JSON.stringify(b)},I)}}e.setProperty=M;function S(m,t,b){let I=n(m,t),y=t.offset,h=t.offset+t.content.length;if(t.length===0||t.content.length===0){for(;y>0&&!(0,A.isEOL)(I,y-1);)y--;for(;h<I.length&&!(0,A.isEOL)(I,h);)h++}const g=(0,A.format)(I,{offset:y,length:h-y},b);for(let v=g.length-1;v>=0;v--){const u=g[v];I=n(I,u),y=Math.min(y,u.offset),h=Math.max(h,u.offset+u.length),h+=u.content.length-u.length}const P=m.length-(I.length-h)-y;return[{offset:y,length:P,content:I.substring(y,h)}]}e.withFormatting=S;function n(m,t){return m.substring(0,t.offset)+t.content+m.substring(t.offset+t.length)}e.applyEdit=n;function f(m,t){let b=t.slice(0).sort((y,h)=>{const g=y.offset-h.offset;return g===0?y.length-h.length:g}),I=m.length;for(let y=b.length-1;y>=0;y--){let h=b[y];if(h.offset+h.length<=I)m=n(m,h);else throw new Error("Overlapping edit");I=h.offset}return m}e.applyEdits=f}),define(J[57],Z([0,1,16]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var A;(function(u){u[u.DependsOnKbLayout=-1]="DependsOnKbLayout",u[u.Unknown=0]="Unknown",u[u.Backspace=1]="Backspace",u[u.Tab=2]="Tab",u[u.Enter=3]="Enter",u[u.Shift=4]="Shift",u[u.Ctrl=5]="Ctrl",u[u.Alt=6]="Alt",u[u.PauseBreak=7]="PauseBreak",u[u.CapsLock=8]="CapsLock",u[u.Escape=9]="Escape",u[u.Space=10]="Space",u[u.PageUp=11]="PageUp",u[u.PageDown=12]="PageDown",u[u.End=13]="End",u[u.Home=14]="Home",u[u.LeftArrow=15]="LeftArrow",u[u.UpArrow=16]="UpArrow",u[u.RightArrow=17]="RightArrow",u[u.DownArrow=18]="DownArrow",u[u.Insert=19]="Insert",u[u.Delete=20]="Delete",u[u.KEY_0=21]="KEY_0",u[u.KEY_1=22]="KEY_1",u[u.KEY_2=23]="KEY_2",u[u.KEY_3=24]="KEY_3",u[u.KEY_4=25]="KEY_4",u[u.KEY_5=26]="KEY_5",u[u.KEY_6=27]="KEY_6",u[u.KEY_7=28]="KEY_7",u[u.KEY_8=29]="KEY_8",u[u.KEY_9=30]="KEY_9",u[u.KEY_A=31]="KEY_A",u[u.KEY_B=32]="KEY_B",u[u.KEY_C=33]="KEY_C",u[u.KEY_D=34]="KEY_D",u[u.KEY_E=35]="KEY_E",u[u.KEY_F=36]="KEY_F",u[u.KEY_G=37]="KEY_G",u[u.KEY_H=38]="KEY_H",u[u.KEY_I=39]="KEY_I",u[u.KEY_J=40]="KEY_J",u[u.KEY_K=41]="KEY_K",u[u.KEY_L=42]="KEY_L",u[u.KEY_M=43]="KEY_M",u[u.KEY_N=44]="KEY_N",u[u.KEY_O=45]="KEY_O",u[u.KEY_P=46]="KEY_P",u[u.KEY_Q=47]="KEY_Q",u[u.KEY_R=48]="KEY_R",u[u.KEY_S=49]="KEY_S",u[u.KEY_T=50]="KEY_T",u[u.KEY_U=51]="KEY_U",u[u.KEY_V=52]="KEY_V",u[u.KEY_W=53]="KEY_W",u[u.KEY_X=54]="KEY_X",u[u.KEY_Y=55]="KEY_Y",u[u.KEY_Z=56]="KEY_Z",u[u.Meta=57]="Meta",u[u.ContextMenu=58]="ContextMenu",u[u.F1=59]="F1",u[u.F2=60]="F2",u[u.F3=61]="F3",u[u.F4=62]="F4",u[u.F5=63]="F5",u[u.F6=64]="F6",u[u.F7=65]="F7",u[u.F8=66]="F8",u[u.F9=67]="F9",u[u.F10=68]="F10",u[u.F11=69]="F11",u[u.F12=70]="F12",u[u.F13=71]="F13",u[u.F14=72]="F14",u[u.F15=73]="F15",u[u.F16=74]="F16",u[u.F17=75]="F17",u[u.F18=76]="F18",u[u.F19=77]="F19",u[u.NumLock=78]="NumLock",u[u.ScrollLock=79]="ScrollLock",u[u.US_SEMICOLON=80]="US_SEMICOLON",u[u.US_EQUAL=81]="US_EQUAL",u[u.US_COMMA=82]="US_COMMA",u[u.US_MINUS=83]="US_MINUS",u[u.US_DOT=84]="US_DOT",u[u.US_SLASH=85]="US_SLASH",u[u.US_BACKTICK=86]="US_BACKTICK",u[u.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",u[u.US_BACKSLASH=88]="US_BACKSLASH",u[u.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",u[u.US_QUOTE=90]="US_QUOTE",u[u.OEM_8=91]="OEM_8",u[u.OEM_102=92]="OEM_102",u[u.NUMPAD_0=93]="NUMPAD_0",u[u.NUMPAD_1=94]="NUMPAD_1",u[u.NUMPAD_2=95]="NUMPAD_2",u[u.NUMPAD_3=96]="NUMPAD_3",u[u.NUMPAD_4=97]="NUMPAD_4",u[u.NUMPAD_5=98]="NUMPAD_5",u[u.NUMPAD_6=99]="NUMPAD_6",u[u.NUMPAD_7=100]="NUMPAD_7",u[u.NUMPAD_8=101]="NUMPAD_8",u[u.NUMPAD_9=102]="NUMPAD_9",u[u.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",u[u.NUMPAD_ADD=104]="NUMPAD_ADD",u[u.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",u[u.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",u[u.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",u[u.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",u[u.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",u[u.ABNT_C1=110]="ABNT_C1",u[u.ABNT_C2=111]="ABNT_C2",u[u.MAX_VALUE=112]="MAX_VALUE"})(A=e.KeyCode||(e.KeyCode={}));class k{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(d,a){this._keyCodeToStr[d]=a,this._strToKeyCode[a.toLowerCase()]=d}keyCodeToStr(d){return this._keyCodeToStr[d]}strToKeyCode(d){return this._strToKeyCode[d.toLowerCase()]||0}}const M=new k,S=new k,n=new k;(function(){function u(d,a,c=a,i=c){M.define(d,a),S.define(d,c),n.define(d,i)}u(0,"unknown"),u(1,"Backspace"),u(2,"Tab"),u(3,"Enter"),u(4,"Shift"),u(5,"Ctrl"),u(6,"Alt"),u(7,"PauseBreak"),u(8,"CapsLock"),u(9,"Escape"),u(10,"Space"),u(11,"PageUp"),u(12,"PageDown"),u(13,"End"),u(14,"Home"),u(15,"LeftArrow","Left"),u(16,"UpArrow","Up"),u(17,"RightArrow","Right"),u(18,"DownArrow","Down"),u(19,"Insert"),u(20,"Delete"),u(21,"0"),u(22,"1"),u(23,"2"),u(24,"3"),u(25,"4"),u(26,"5"),u(27,"6"),u(28,"7"),u(29,"8"),u(30,"9"),u(31,"A"),u(32,"B"),u(33,"C"),u(34,"D"),u(35,"E"),u(36,"F"),u(37,"G"),u(38,"H"),u(39,"I"),u(40,"J"),u(41,"K"),u(42,"L"),u(43,"M"),u(44,"N"),u(45,"O"),u(46,"P"),u(47,"Q"),u(48,"R"),u(49,"S"),u(50,"T"),u(51,"U"),u(52,"V"),u(53,"W"),u(54,"X"),u(55,"Y"),u(56,"Z"),u(57,"Meta"),u(58,"ContextMenu"),u(59,"F1"),u(60,"F2"),u(61,"F3"),u(62,"F4"),u(63,"F5"),u(64,"F6"),u(65,"F7"),u(66,"F8"),u(67,"F9"),u(68,"F10"),u(69,"F11"),u(70,"F12"),u(71,"F13"),u(72,"F14"),u(73,"F15"),u(74,"F16"),u(75,"F17"),u(76,"F18"),u(77,"F19"),u(78,"NumLock"),u(79,"ScrollLock"),u(80,";",";","OEM_1"),u(81,"=","=","OEM_PLUS"),u(82,",",",","OEM_COMMA"),u(83,"-","-","OEM_MINUS"),u(84,".",".","OEM_PERIOD"),u(85,"/","/","OEM_2"),u(86,"`","`","OEM_3"),u(110,"ABNT_C1"),u(111,"ABNT_C2"),u(87,"[","[","OEM_4"),u(88,"\\","\\","OEM_5"),u(89,"]","]","OEM_6"),u(90,"'","'","OEM_7"),u(91,"OEM_8"),u(92,"OEM_102"),u(93,"NumPad0"),u(94,"NumPad1"),u(95,"NumPad2"),u(96,"NumPad3"),u(97,"NumPad4"),u(98,"NumPad5"),u(99,"NumPad6"),u(100,"NumPad7"),u(101,"NumPad8"),u(102,"NumPad9"),u(103,"NumPad_Multiply"),u(104,"NumPad_Add"),u(105,"NumPad_Separator"),u(106,"NumPad_Subtract"),u(107,"NumPad_Decimal"),u(108,"NumPad_Divide")})();var f;(function(u){function d(r){return M.keyCodeToStr(r)}u.toString=d;function a(r){return M.strToKeyCode(r)}u.fromString=a;function c(r){return S.keyCodeToStr(r)}u.toUserSettingsUS=c;function i(r){return n.keyCodeToStr(r)}u.toUserSettingsGeneral=i;function s(r){return S.strToKeyCode(r)||n.strToKeyCode(r)}u.fromUserSettings=s})(f=e.KeyCodeUtils||(e.KeyCodeUtils={}));var m;(function(u){u[u.CtrlCmd=2048]="CtrlCmd",u[u.Shift=1024]="Shift",u[u.Alt=512]="Alt",u[u.WinCtrl=256]="WinCtrl",u[u.KeyCode=255]="KeyCode"})(m||(m={}));var t;(function(u){u[u.CtrlCmd=2048]="CtrlCmd",u[u.Shift=1024]="Shift",u[u.Alt=512]="Alt",u[u.WinCtrl=256]="WinCtrl"})(t=e.KeyMod||(e.KeyMod={}));function b(u,d){const a=(d&65535)<<16>>>0;return(u|a)>>>0}e.KeyChord=b;function I(u,d){if(u===0)return null;const a=(u&65535)>>>0,c=(u&4294901760)>>>16;return c!==0?new g([y(a,d),y(c,d)]):new g([y(a,d)])}e.createKeybinding=I;function y(u,d){const a=!!(u&2048),c=!!(u&256),i=d===2?c:a,s=!!(u&1024),r=!!(u&512),o=d===2?a:c,l=u&255;return new h(i,s,r,o,l)}e.createSimpleKeybinding=y;class h{constructor(d,a,c,i,s){this.ctrlKey=d,this.shiftKey=a,this.altKey=c,this.metaKey=i,this.keyCode=s}equals(d){return this.ctrlKey===d.ctrlKey&&this.shiftKey===d.shiftKey&&this.altKey===d.altKey&&this.metaKey===d.metaKey&&this.keyCode===d.keyCode}getHashCode(){const d=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",c=this.altKey?"1":"0",i=this.metaKey?"1":"0";return`${d}${a}${c}${i}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=h;class g{constructor(d){if(d.length===0)throw(0,w.illegalArgument)("parts");this.parts=d}getHashCode(){let d="";for(let a=0,c=this.parts.length;a<c;a++)a!==0&&(d+=";"),d+=this.parts[a].getHashCode();return d}equals(d){if(d===null||this.parts.length!==d.parts.length)return!1;for(let a=0;a<this.parts.length;a++)if(!this.parts[a].equals(d.parts[a]))return!1;return!0}}e.ChordKeybinding=g;class P{constructor(d,a,c,i,s,r){this.ctrlKey=d,this.shiftKey=a,this.altKey=c,this.metaKey=i,this.keyLabel=s,this.keyAriaLabel=r}}e.ResolvedKeybindingPart=P;class v{}e.ResolvedKeybinding=v}),define(J[2],Z([0,1,43,63]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let M=null;function S(r){M=r}if(e.setDisposableTracker=S,k){const r="__is_disposable_tracked__";S(new class{trackDisposable(o){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[r]||console.log(l)},3e3)}setParent(o,l){if(o&&o!==u.None)try{o[r]=!0}catch{}}markAsDisposed(o){if(o&&o!==u.None)try{o[r]=!0}catch{}}markAsSingleton(o){}})}function n(r){return M?.trackDisposable(r),r}function f(r){M?.markAsDisposed(r)}function m(r,o){M?.setParent(r,o)}function t(r,o){if(!!M)for(const l of r)M.setParent(l,o)}function b(r){return M?.markAsSingleton(r),r}e.markAsSingleton=b;class I extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=I;function y(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=y;function h(r){if(A.Iterable.is(r)){let o=[];for(const l of r)if(l)try{l.dispose()}catch(p){o.push(p)}if(o.length===1)throw o[0];if(o.length>1)throw new I(o);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=h;function g(...r){const o=P(()=>h(r));return t(r,o),o}e.combinedDisposable=g;function P(r){const o=n({dispose:(0,w.once)(()=>{f(o),r()})});return o}e.toDisposable=P;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,n(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return m(o,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new v,n(this),m(this._store,this)}dispose(){f(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,n(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&m(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&m(o,null),o}}e.MutableDisposable=d;class a{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class c{constructor(){this.references=new Map}acquire(o,...l){let p=this.references.get(o);p||(p={counter:0,object:this.createReferencedObject(o,...l)},this.references.set(o,p));const{object:E}=p,L=(0,w.once)(()=>{--p.counter==0&&(this.destroyReferencedObject(o,p.object),this.references.delete(o))});return p.counter++,{object:E,dispose:L}}}e.ReferenceCollection=c;class i{constructor(o){this.referenceCollection=o}async acquire(o,...l){const p=this.referenceCollection.acquire(o,...l);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(E){throw p.dispose(),E}}}e.AsyncReferenceCollection=i;class s{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=s}),define(J[104],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(M){this.element=M,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class A{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let M=this._first;for(;M!==w.Undefined;){const S=M.next;M.prev=w.Undefined,M.next=w.Undefined,M=S}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,S){const n=new w(M);if(this._first===w.Undefined)this._first=n,this._last=n;else if(S){const m=this._last;this._last=n,n.prev=m,m.next=n}else{const m=this._first;this._first=n,n.next=m,m.prev=n}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(n))}}shift(){if(this._first!==w.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==w.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==w.Undefined&&M.next!==w.Undefined){const S=M.prev;S.next=M.next,M.next.prev=S}else M.prev===w.Undefined&&M.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):M.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):M.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==w.Undefined;)yield M.element,M=M.next}}e.LinkedList=A}),function(){function q(k){const M=[];typeof k=="number"&&M.push("code/timeOrigin",k);function S(f){M.push(f,Date.now())}function n(){const f=[];for(let m=0;m<M.length;m+=2)f.push({name:M[m],startTime:M[m+1]});return f}return{mark:S,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const S of performance.getEntriesByType("mark"))M.push({name:S.name,startTime:Math.round(k+S.startTime)});return M}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function w(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=w(A))}(),define(J[3],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const w="en";let A=!1,k=!1,M=!1,S=!1,n=!1,f=!1,m=!1,t,b=w,I,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const g=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=g&&h?.sandboxed,typeof navigator=="object"&&!g)y=navigator.userAgent,A=y.indexOf("Windows")>=0,k=y.indexOf("Macintosh")>=0,m=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=y.indexOf("Linux")>=0,f=!0,t=navigator.language,b=t;else if(typeof h=="object"){A=h.platform==="win32",k=h.platform==="darwin",M=h.platform==="linux",S=M&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,t=w,b=w;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const o=JSON.parse(r),l=o.availableLanguages["*"];t=o.locale,b=l||w,I=o._translationsConfigFile}catch(o){}n=!0}else console.error("Unable to resolve platform.");var P;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function v(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=v;let u=0;k?u=1:A?u=3:M&&(u=2),e.isWindows=A,e.isMacintosh=k,e.isLinux=M,e.isLinuxSnap=S,e.isNative=n,e.isWeb=f,e.isIOS=m,e.platform=u,e.userAgent=y,e.language=b;var d;(function(r){function o(){return e.language}r.value=o;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=l;function p(){return e.language==="en"}r.isDefault=p})(d=e.Language||(e.Language={})),e.locale=t,e.translationsConfigFile=I,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeSetImmediateId)for(let L=0,T=l.length;L<T;L++){const W=l[L];if(W.id===E.data.vscodeSetImmediateId){l.splice(L,1),W.callback();return}}});let p=0;return E=>{const L=++p;l.push({id:L,callback:E}),e.globals.postMessage({vscodeSetImmediateId:L},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const o=Promise.resolve();return l=>o.then(l)}();var a;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||m?2:A?1:3;let c=!0,i=!1;function s(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,c=new Uint16Array(r.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=s}),define(J[31],Z([0,1,3]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let A;if(typeof w.globals.vscode!="undefined"&&typeof w.globals.vscode.process!="undefined"){const k=w.globals.vscode.process;A={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()},nextTick(M){return(0,w.setImmediate)(M)}}}else typeof process!="undefined"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:A={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},nextTick(k){return(0,w.setImmediate)(k)},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.nextTick=A.nextTick,e.arch=A.arch}),define(J[8],Z([0,1,31]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,k=97,M=90,S=122,n=46,f=47,m=92,t=58,b=63;class I extends Error{constructor(a,c,i){let s;typeof c=="string"&&c.indexOf("not ")===0?(s="must not be",c=c.replace(/^not /,"")):s="must be";const r=a.indexOf(".")!==-1?"property":"argument";let o=`The "${a}" ${r} ${s} of type ${c}`;o+=`. Received type ${typeof i}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function y(d,a){if(typeof d!="string")throw new I(a,"string",d)}function h(d){return d===f||d===m}function g(d){return d===f}function P(d){return d>=A&&d<=M||d>=k&&d<=S}function v(d,a,c,i){let s="",r=0,o=-1,l=0,p=0;for(let E=0;E<=d.length;++E){if(E<d.length)p=d.charCodeAt(E);else{if(i(p))break;p=f}if(i(p)){if(!(o===E-1||l===1))if(l===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==n||s.charCodeAt(s.length-2)!==n){if(s.length>2){const L=s.lastIndexOf(c);L===-1?(s="",r=0):(s=s.slice(0,L),r=s.length-1-s.lastIndexOf(c)),o=E,l=0;continue}else if(s.length!==0){s="",r=0,o=E,l=0;continue}}a&&(s+=s.length>0?`${c}..`:"..",r=2)}else s.length>0?s+=`${c}${d.slice(o+1,E)}`:s=d.slice(o+1,E),r=E-o-1;o=E,l=0}else p===n&&l!==-1?++l:l=-1}return s}function u(d,a){if(a===null||typeof a!="object")throw new I("pathObject","Object",a);const c=a.dir||a.root,i=a.base||`${a.name||""}${a.ext||""}`;return c?c===a.root?`${c}${i}`:`${c}${d}${i}`:i}e.win32={resolve(...d){let a="",c="",i=!1;for(let s=d.length-1;s>=-1;s--){let r;if(s>=0){if(r=d[s],y(r,"path"),r.length===0)continue}else a.length===0?r=w.cwd():(r=w.env[`=${a}`]||w.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===m)&&(r=`${a}\\`));const o=r.length;let l=0,p="",E=!1;const L=r.charCodeAt(0);if(o===1)h(L)&&(l=1,E=!0);else if(h(L))if(E=!0,h(r.charCodeAt(1))){let T=2,W=T;for(;T<o&&!h(r.charCodeAt(T));)T++;if(T<o&&T!==W){const C=r.slice(W,T);for(W=T;T<o&&h(r.charCodeAt(T));)T++;if(T<o&&T!==W){for(W=T;T<o&&!h(r.charCodeAt(T));)T++;(T===o||T!==W)&&(p=`\\\\${C}\\${r.slice(W,T)}`,l=T)}}}else l=1;else P(L)&&r.charCodeAt(1)===t&&(p=r.slice(0,2),l=2,o>2&&h(r.charCodeAt(2))&&(E=!0,l=3));if(p.length>0)if(a.length>0){if(p.toLowerCase()!==a.toLowerCase())continue}else a=p;if(i){if(a.length>0)break}else if(c=`${r.slice(l)}\\${c}`,i=E,E&&a.length>0)break}return c=v(c,!i,"\\",h),i?`${a}\\${c}`:`${a}${c}`||"."},normalize(d){y(d,"path");const a=d.length;if(a===0)return".";let c=0,i,s=!1;const r=d.charCodeAt(0);if(a===1)return g(r)?"\\":d;if(h(r))if(s=!0,h(d.charCodeAt(1))){let l=2,p=l;for(;l<a&&!h(d.charCodeAt(l));)l++;if(l<a&&l!==p){const E=d.slice(p,l);for(p=l;l<a&&h(d.charCodeAt(l));)l++;if(l<a&&l!==p){for(p=l;l<a&&!h(d.charCodeAt(l));)l++;if(l===a)return`\\\\${E}\\${d.slice(p)}\\`;l!==p&&(i=`\\\\${E}\\${d.slice(p,l)}`,c=l)}}}else c=1;else P(r)&&d.charCodeAt(1)===t&&(i=d.slice(0,2),c=2,a>2&&h(d.charCodeAt(2))&&(s=!0,c=3));let o=c<a?v(d.slice(c),!s,"\\",h):"";return o.length===0&&!s&&(o="."),o.length>0&&h(d.charCodeAt(a-1))&&(o+="\\"),i===void 0?s?`\\${o}`:o:s?`${i}\\${o}`:`${i}${o}`},isAbsolute(d){y(d,"path");const a=d.length;if(a===0)return!1;const c=d.charCodeAt(0);return h(c)||a>2&&P(c)&&d.charCodeAt(1)===t&&h(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let a,c;for(let r=0;r<d.length;++r){const o=d[r];y(o,"path"),o.length>0&&(a===void 0?a=c=o:a+=`\\${o}`)}if(a===void 0)return".";let i=!0,s=0;if(typeof c=="string"&&h(c.charCodeAt(0))){++s;const r=c.length;r>1&&h(c.charCodeAt(1))&&(++s,r>2&&(h(c.charCodeAt(2))?++s:i=!1))}if(i){for(;s<a.length&&h(a.charCodeAt(s));)s++;s>=2&&(a=`\\${a.slice(s)}`)}return e.win32.normalize(a)},relative(d,a){if(y(d,"from"),y(a,"to"),d===a)return"";const c=e.win32.resolve(d),i=e.win32.resolve(a);if(c===i||(d=c.toLowerCase(),a=i.toLowerCase(),d===a))return"";let s=0;for(;s<d.length&&d.charCodeAt(s)===m;)s++;let r=d.length;for(;r-1>s&&d.charCodeAt(r-1)===m;)r--;const o=r-s;let l=0;for(;l<a.length&&a.charCodeAt(l)===m;)l++;let p=a.length;for(;p-1>l&&a.charCodeAt(p-1)===m;)p--;const E=p-l,L=o<E?o:E;let T=-1,W=0;for(;W<L;W++){const V=d.charCodeAt(s+W);if(V!==a.charCodeAt(l+W))break;V===m&&(T=W)}if(W!==L){if(T===-1)return i}else{if(E>L){if(a.charCodeAt(l+W)===m)return i.slice(l+W+1);if(W===2)return i.slice(l+W)}o>L&&(d.charCodeAt(s+W)===m?T=W:W===2&&(T=3)),T===-1&&(T=0)}let C="";for(W=s+T+1;W<=r;++W)(W===r||d.charCodeAt(W)===m)&&(C+=C.length===0?"..":"\\..");return l+=T,C.length>0?`${C}${i.slice(l,p)}`:(i.charCodeAt(l)===m&&++l,i.slice(l,p))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const a=e.win32.resolve(d);if(a.length<=2)return d;if(a.charCodeAt(0)===m){if(a.charCodeAt(1)===m){const c=a.charCodeAt(2);if(c!==b&&c!==n)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(P(a.charCodeAt(0))&&a.charCodeAt(1)===t&&a.charCodeAt(2)===m)return`\\\\?\\${a}`;return d},dirname(d){y(d,"path");const a=d.length;if(a===0)return".";let c=-1,i=0;const s=d.charCodeAt(0);if(a===1)return h(s)?d:".";if(h(s)){if(c=i=1,h(d.charCodeAt(1))){let l=2,p=l;for(;l<a&&!h(d.charCodeAt(l));)l++;if(l<a&&l!==p){for(p=l;l<a&&h(d.charCodeAt(l));)l++;if(l<a&&l!==p){for(p=l;l<a&&!h(d.charCodeAt(l));)l++;if(l===a)return d;l!==p&&(c=i=l+1)}}}}else P(s)&&d.charCodeAt(1)===t&&(c=a>2&&h(d.charCodeAt(2))?3:2,i=c);let r=-1,o=!0;for(let l=a-1;l>=i;--l)if(h(d.charCodeAt(l))){if(!o){r=l;break}}else o=!1;if(r===-1){if(c===-1)return".";r=c}return d.slice(0,r)},basename(d,a){a!==void 0&&y(a,"ext"),y(d,"path");let c=0,i=-1,s=!0,r;if(d.length>=2&&P(d.charCodeAt(0))&&d.charCodeAt(1)===t&&(c=2),a!==void 0&&a.length>0&&a.length<=d.length){if(a===d)return"";let o=a.length-1,l=-1;for(r=d.length-1;r>=c;--r){const p=d.charCodeAt(r);if(h(p)){if(!s){c=r+1;break}}else l===-1&&(s=!1,l=r+1),o>=0&&(p===a.charCodeAt(o)?--o==-1&&(i=r):(o=-1,i=l))}return c===i?i=l:i===-1&&(i=d.length),d.slice(c,i)}for(r=d.length-1;r>=c;--r)if(h(d.charCodeAt(r))){if(!s){c=r+1;break}}else i===-1&&(s=!1,i=r+1);return i===-1?"":d.slice(c,i)},extname(d){y(d,"path");let a=0,c=-1,i=0,s=-1,r=!0,o=0;d.length>=2&&d.charCodeAt(1)===t&&P(d.charCodeAt(0))&&(a=i=2);for(let l=d.length-1;l>=a;--l){const p=d.charCodeAt(l);if(h(p)){if(!r){i=l+1;break}continue}s===-1&&(r=!1,s=l+1),p===n?c===-1?c=l:o!==1&&(o=1):c!==-1&&(o=-1)}return c===-1||s===-1||o===0||o===1&&c===s-1&&c===i+1?"":d.slice(c,s)},format:u.bind(null,"\\"),parse(d){y(d,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return a;const c=d.length;let i=0,s=d.charCodeAt(0);if(c===1)return h(s)?(a.root=a.dir=d,a):(a.base=a.name=d,a);if(h(s)){if(i=1,h(d.charCodeAt(1))){let T=2,W=T;for(;T<c&&!h(d.charCodeAt(T));)T++;if(T<c&&T!==W){for(W=T;T<c&&h(d.charCodeAt(T));)T++;if(T<c&&T!==W){for(W=T;T<c&&!h(d.charCodeAt(T));)T++;T===c?i=T:T!==W&&(i=T+1)}}}}else if(P(s)&&d.charCodeAt(1)===t){if(c<=2)return a.root=a.dir=d,a;if(i=2,h(d.charCodeAt(2))){if(c===3)return a.root=a.dir=d,a;i=3}}i>0&&(a.root=d.slice(0,i));let r=-1,o=i,l=-1,p=!0,E=d.length-1,L=0;for(;E>=i;--E){if(s=d.charCodeAt(E),h(s)){if(!p){o=E+1;break}continue}l===-1&&(p=!1,l=E+1),s===n?r===-1?r=E:L!==1&&(L=1):r!==-1&&(L=-1)}return l!==-1&&(r===-1||L===0||L===1&&r===l-1&&r===o+1?a.base=a.name=d.slice(o,l):(a.name=d.slice(o,r),a.base=d.slice(o,l),a.ext=d.slice(r,l))),o>0&&o!==i?a.dir=d.slice(0,o-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let a="",c=!1;for(let i=d.length-1;i>=-1&&!c;i--){const s=i>=0?d[i]:w.cwd();y(s,"path"),s.length!==0&&(a=`${s}/${a}`,c=s.charCodeAt(0)===f)}return a=v(a,!c,"/",g),c?`/${a}`:a.length>0?a:"."},normalize(d){if(y(d,"path"),d.length===0)return".";const a=d.charCodeAt(0)===f,c=d.charCodeAt(d.length-1)===f;return d=v(d,!a,"/",g),d.length===0?a?"/":c?"./":".":(c&&(d+="/"),a?`/${d}`:d)},isAbsolute(d){return y(d,"path"),d.length>0&&d.charCodeAt(0)===f},join(...d){if(d.length===0)return".";let a;for(let c=0;c<d.length;++c){const i=d[c];y(i,"path"),i.length>0&&(a===void 0?a=i:a+=`/${i}`)}return a===void 0?".":e.posix.normalize(a)},relative(d,a){if(y(d,"from"),y(a,"to"),d===a||(d=e.posix.resolve(d),a=e.posix.resolve(a),d===a))return"";const c=1,i=d.length,s=i-c,r=1,o=a.length-r,l=s<o?s:o;let p=-1,E=0;for(;E<l;E++){const T=d.charCodeAt(c+E);if(T!==a.charCodeAt(r+E))break;T===f&&(p=E)}if(E===l)if(o>l){if(a.charCodeAt(r+E)===f)return a.slice(r+E+1);if(E===0)return a.slice(r+E)}else s>l&&(d.charCodeAt(c+E)===f?p=E:E===0&&(p=0));let L="";for(E=c+p+1;E<=i;++E)(E===i||d.charCodeAt(E)===f)&&(L+=L.length===0?"..":"/..");return`${L}${a.slice(r+p)}`},toNamespacedPath(d){return d},dirname(d){if(y(d,"path"),d.length===0)return".";const a=d.charCodeAt(0)===f;let c=-1,i=!0;for(let s=d.length-1;s>=1;--s)if(d.charCodeAt(s)===f){if(!i){c=s;break}}else i=!1;return c===-1?a?"/":".":a&&c===1?"//":d.slice(0,c)},basename(d,a){a!==void 0&&y(a,"ext"),y(d,"path");let c=0,i=-1,s=!0,r;if(a!==void 0&&a.length>0&&a.length<=d.length){if(a===d)return"";let o=a.length-1,l=-1;for(r=d.length-1;r>=0;--r){const p=d.charCodeAt(r);if(p===f){if(!s){c=r+1;break}}else l===-1&&(s=!1,l=r+1),o>=0&&(p===a.charCodeAt(o)?--o==-1&&(i=r):(o=-1,i=l))}return c===i?i=l:i===-1&&(i=d.length),d.slice(c,i)}for(r=d.length-1;r>=0;--r)if(d.charCodeAt(r)===f){if(!s){c=r+1;break}}else i===-1&&(s=!1,i=r+1);return i===-1?"":d.slice(c,i)},extname(d){y(d,"path");let a=-1,c=0,i=-1,s=!0,r=0;for(let o=d.length-1;o>=0;--o){const l=d.charCodeAt(o);if(l===f){if(!s){c=o+1;break}continue}i===-1&&(s=!1,i=o+1),l===n?a===-1?a=o:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||i===-1||r===0||r===1&&a===i-1&&a===c+1?"":d.slice(a,i)},format:u.bind(null,"/"),parse(d){y(d,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return a;const c=d.charCodeAt(0)===f;let i;c?(a.root="/",i=1):i=0;let s=-1,r=0,o=-1,l=!0,p=d.length-1,E=0;for(;p>=i;--p){const L=d.charCodeAt(p);if(L===f){if(!l){r=p+1;break}continue}o===-1&&(l=!1,o=p+1),L===n?s===-1?s=p:E!==1&&(E=1):s!==-1&&(E=-1)}if(o!==-1){const L=r===0&&c?1:r;s===-1||E===0||E===1&&s===o-1&&s===r+1?a.base=a.name=d.slice(L,o):(a.name=d.slice(L,s),a.base=d.slice(L,o),a.ext=d.slice(s,o))}return r>0?a.dir=d.slice(0,r-1):c&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[105],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var w;(function(M){M[M.stdout=0]="stdout",M[M.stderr=1]="stderr"})(w=e.Source||(e.Source={}));var A;(function(M){M[M.Success=0]="Success",M[M.Unknown=1]="Unknown",M[M.AccessDenied=2]="AccessDenied",M[M.ProcessNotFound=3]="ProcessNotFound"})(A=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(M,...S){const n=S.reduce((t,b)=>(t[b]=!0,t),{}),f=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(M).filter(t=>!n[t]).forEach(t=>{for(let b=0;b<f.length;b++)if(t.search(f[b])!==-1){delete M[t];break}})}e.sanitizeProcessEnvironment=k}),define(J[77],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var w;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(w=e.ScanCode||(e.ScanCode={}));const A=[],k=Object.create(null),M=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>M[n]||0,toEnum:n=>k[n]||0,toString:n=>A[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class S{constructor(f,m,t,b,I){this.ctrlKey=f,this.shiftKey=m,this.altKey=t,this.metaKey=b,this.scanCode=I}equals(f){return this.ctrlKey===f.ctrlKey&&this.shiftKey===f.shiftKey&&this.altKey===f.altKey&&this.metaKey===f.metaKey&&this.scanCode===f.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=S,function(){function n(f,m){A[f]=m,k[m]=f,M[m.toLowerCase()]=f}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let f=0;f<=193;f++)e.IMMUTABLE_CODE_TO_KEY_CODE[f]=-1;for(let f=0;f<=112;f++)e.IMMUTABLE_KEY_CODE_TO_CODE[f]=-1;function n(f,m){e.IMMUTABLE_CODE_TO_KEY_CODE[f]=m,m!==0&&m!==3&&m!==5&&m!==4&&m!==6&&m!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[m]=f)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(J[106],Z([0,1,57,77]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class k{static _readModifiers(S){S=S.toLowerCase().trim();let n=!1,f=!1,m=!1,t=!1,b;do b=!1,/^ctrl(\+|\-)/.test(S)&&(n=!0,S=S.substr("ctrl-".length),b=!0),/^shift(\+|\-)/.test(S)&&(f=!0,S=S.substr("shift-".length),b=!0),/^alt(\+|\-)/.test(S)&&(m=!0,S=S.substr("alt-".length),b=!0),/^meta(\+|\-)/.test(S)&&(t=!0,S=S.substr("meta-".length),b=!0),/^win(\+|\-)/.test(S)&&(t=!0,S=S.substr("win-".length),b=!0),/^cmd(\+|\-)/.test(S)&&(t=!0,S=S.substr("cmd-".length),b=!0);while(b);let I;const y=S.indexOf(" ");return y>0?(I=S.substring(0,y),S=S.substring(y)):(I=S,S=""),{remains:S,ctrl:n,shift:f,alt:m,meta:t,key:I}}static parseSimpleKeybinding(S){const n=this._readModifiers(S),f=w.KeyCodeUtils.fromUserSettings(n.key);return[new w.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,f),n.remains]}static parseKeybinding(S,n){if(!S)return null;const f=[];let m;do[m,S]=this.parseSimpleKeybinding(S),f.push(m);while(S.length>0);return new w.ChordKeybinding(f)}static parseSimpleUserBinding(S){const n=this._readModifiers(S),f=n.key.match(/^\[([^\]]+)\]$/);if(f){const t=f[1],b=A.ScanCodeUtils.lowerCaseToEnum(t);return[new A.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,b),n.remains]}const m=w.KeyCodeUtils.fromUserSettings(n.key);return[new w.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,m),n.remains]}static parseUserBinding(S){if(!S)return[];const n=[];let f;for(;S.length>0;)[f,S]=this.parseSimpleUserBinding(S),n.push(f);return n}}e.KeybindingParser=k}),define(J[107],Z([0,1,3]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=w.globals.performance&&typeof w.globals.performance.now=="function";class k{constructor(S){this._highResolution=A&&S,this._startTime=this._now(),this._stopTime=-1}static create(S=!0){return new k(S)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=k}),define(J[5],Z([0,1,16,43,2,104,107]),function(q,e,w,A,k,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(d){d.None=()=>k.Disposable.None;function a(Q){return(O,z=null,U)=>{let X=!1,H;return H=Q(_=>{if(!X)return H?H.dispose():X=!0,O.call(z,_)},null,U),X&&H.dispose(),H}}d.once=a;function c(Q,O){return p((z,U=null,X)=>Q(H=>z.call(U,O(H)),null,X))}d.map=c;function i(Q,O){return p((z,U=null,X)=>Q(H=>{O(H),z.call(U,H)},null,X))}d.forEach=i;function s(Q,O){return p((z,U=null,X)=>Q(H=>O(H)&&z.call(U,H),null,X))}d.filter=s;function r(Q){return Q}d.signal=r;function o(...Q){return(O,z=null,U)=>(0,k.combinedDisposable)(...Q.map(X=>X(H=>O.call(z,H),null,U)))}d.any=o;function l(Q,O,z){let U=z;return c(Q,X=>(U=O(U,X),U))}d.reduce=l;function p(Q){let O;const z=new I({onFirstListenerAdd(){O=Q(z.fire,z)},onLastListenerRemove(){O.dispose()}});return z.event}function E(Q,O,z=100,U=!1,X){let H,_,j,F=0;const D=new I({leakWarningThreshold:X,onFirstListenerAdd(){H=Q(R=>{F++,_=O(_,R),U&&!j&&(D.fire(_),_=void 0),clearTimeout(j),j=setTimeout(()=>{const N=_;_=void 0,j=void 0,(!U||F>1)&&D.fire(N),F=0},z)})},onLastListenerRemove(){H.dispose()}});return D.event}d.debounce=E;function L(Q,O=(z,U)=>z===U){let z=!0,U;return s(Q,X=>{const H=z||!O(X,U);return z=!1,U=X,H})}d.latch=L;function T(Q,O){return[d.filter(Q,O),d.filter(Q,z=>!O(z))]}d.split=T;function W(Q,O=!1,z=[]){let U=z.slice(),X=Q(j=>{U?U.push(j):_.fire(j)});const H=()=>{U&&U.forEach(j=>_.fire(j)),U=null},_=new I({onFirstListenerAdd(){X||(X=Q(j=>_.fire(j)))},onFirstListenerDidAdd(){U&&(O?setTimeout(H):H())},onLastListenerRemove(){X&&X.dispose(),X=null}});return _.event}d.buffer=W;class C{constructor(O){this.event=O}map(O){return new C(c(this.event,O))}forEach(O){return new C(i(this.event,O))}filter(O){return new C(s(this.event,O))}reduce(O,z){return new C(l(this.event,O,z))}latch(){return new C(L(this.event))}debounce(O,z=100,U=!1,X){return new C(E(this.event,O,z,U,X))}on(O,z,U){return this.event(O,z,U)}once(O,z,U){return a(this.event)(O,z,U)}}function V(Q){return new C(Q)}d.chain=V;function x(Q,O,z=U=>U){const U=(...j)=>_.fire(z(...j)),X=()=>Q.on(O,U),H=()=>Q.removeListener(O,U),_=new I({onFirstListenerAdd:X,onLastListenerRemove:H});return _.event}d.fromNodeEventEmitter=x;function se(Q,O,z=U=>U){const U=(...j)=>_.fire(z(...j)),X=()=>Q.addEventListener(O,U),H=()=>Q.removeEventListener(O,U),_=new I({onFirstListenerAdd:X,onLastListenerRemove:H});return _.event}d.fromDOMEventEmitter=se;function G(Q){return new Promise(O=>a(Q)(O))}d.toPromise=G})(n=e.Event||(e.Event={}));class f{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${f._idPool++}`}start(a){this._stopWatch=new S.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let m=-1;function t(d){const a=m;return m=d,{dispose(){m=a}}}e.setGlobalLeakWarningThreshold=t;class b{constructor(a,c=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let c=m;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),c<=0||a<c)return;this._stacks||(this._stacks=new Map);const i=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(i)||0;if(this._stacks.set(i,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let r,o=0;for(const[l,p]of this._stacks)(!r||o<p)&&(r=l,o=p);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${o}):`),console.warn(r)}return()=>{const r=this._stacks.get(i)||0;this._stacks.set(i,r-1)}}}class I{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=m>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(a,c,i)=>{this._listeners||(this._listeners=new M.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(c?[a,c]:a);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,c);const o=this._leakageMon?.check(this._listeners.size),l=(0,k.toDisposable)(()=>{o&&o(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return i instanceof k.DisposableStore?i.add(l):Array.isArray(i)&&i.push(l),l}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new M.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,a]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,i]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,i):c[0].call(c[1],i)}catch(s){(0,w.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=I;class y extends I{async fireAsync(a,c,i){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,a]);for(;this._asyncDeliveryQueue.size>0&&!c.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),o=[],l={...r,waitUntil:p=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");i&&(p=i(p,typeof s=="function"?s:s[0])),o.push(p)}};try{typeof s=="function"?s.call(void 0,l):s[0].call(s[1],l)}catch(p){(0,w.onUnexpectedError)(p);continue}Object.freeze(o),await Promise.allSettled(o).then(p=>{for(const E of p)E.status==="rejected"&&(0,w.onUnexpectedError)(E.reason)})}}}}e.AsyncEmitter=y;class h extends I{constructor(a){super(a);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=h;class g extends h{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=g;class P{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new I({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const c={event:a,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const i=()=>{this.hasListeners&&this.unhook(c);const s=this.events.indexOf(c);this.events.splice(s,1)};return(0,k.toDisposable)((0,A.once)(i))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(c=>this.emitter.fire(c))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=P;class v{constructor(){this.buffers=[]}wrapEvent(a){return(c,i,s)=>a(r=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>c.call(i,r)):c.call(i,r)},void 0,s)}bufferEvents(a){const c=[];this.buffers.push(c);const i=a();return this.buffers.pop(),c.forEach(s=>s()),i}}e.EventBufferer=v;class u{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=k.Disposable.None,this.emitter=new I({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=u}),define(J[24],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(n,f){const m=setTimeout(n.bind(f),0);return{dispose(){clearTimeout(m)}}});var k;(function(n){function f(m){return m===n.None||m===n.Cancelled||m instanceof M?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}n.isCancellationToken=f,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(k=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?A:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=k.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=S}),define(J[108],Z([0,1,5]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class A{constructor(){this._icons=new Map,this._onDidRegister=new w.Emitter}add(b){const I=this._icons.get(b.id);I?b.description?I.description=b.description:console.error(`Duplicate registration of codicon ${b.id}`):(this._icons.set(b.id,b),this._onDidRegister.fire(b))}get(b){return this._icons.get(b)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new A;e.iconRegistry=k;function M(t,b){return new n(t,b)}e.registerCodicon=M;function S(t){return t?t.replace(/\$\((.*?)\)/g,(b,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=S;class n{constructor(b,I,y){this.id=b,this.definition=I,this.description=y,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function f(t,b){const I=["codicon","codicon-"+t];return b&&I.push("codicon-modifier-"+b),I}e.getClassNamesArray=f;var m;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const b=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function I(g){if(g instanceof n)return["codicon","codicon-"+g.id];const P=b.exec(g.id);if(!P)return I(n.error);let[,v,u]=P;const d=["codicon","codicon-"+v];return u&&d.push("codicon-modifier-"+u.substr(1)),d}t.asClassNameArray=I;function y(g){return I(g).join(" ")}t.asClassName=y;function h(g){return"."+I(g).join(".")}t.asCSSSelector=h})(m=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(J[64],Z([0,1,16,2]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(d){const a=d;return a?[a.on,a.pause,a.resume,a.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=k;function M(d){const a=d;return a?k(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=M;function S(d,a){return new n(d,a)}e.newWriteableStream=S;class n{constructor(a,c){this.reducer=a,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(c=>c(a))}emitError(a){this.listeners.error.length===0?(0,w.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(c=>c(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,c){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(a,c){if(this.state.destroyed)return;let i;switch(a){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const s=i.indexOf(c);s>=0&&i.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(d,a){const c=[];let i;for(;(i=d.read())!==null;)c.push(i);return a(c)}e.consumeReadable=f;function m(d,a,c){const i=[];let s;for(;(s=d.read())!==null&&i.length<c;)i.push(s);return s===null&&i.length>0?a(i):{read:()=>{if(i.length>0)return i.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return d.read()}}}e.peekReadable=m;function t(d,a){return new Promise((c,i)=>{const s=[];b(d,{onData:r=>{a&&s.push(r)},onError:r=>{a?i(r):c(void 0)},onEnd:()=>{c(a?a(s):void 0)}})})}e.consumeStream=t;function b(d,a){d.on("error",c=>a.onError(c)),d.on("end",()=>a.onEnd()),d.on("data",c=>a.onData(c))}e.listenStream=b;function I(d,a){return new Promise((c,i)=>{const s=new A.DisposableStore,r=[],o=E=>{if(r.push(E),r.length>a)return s.dispose(),d.pause(),c({stream:d,buffer:r,ended:!1})},l=E=>i(E),p=()=>c({stream:d,buffer:r,ended:!0});s.add((0,A.toDisposable)(()=>d.removeListener("error",l))),d.on("error",l),s.add((0,A.toDisposable)(()=>d.removeListener("end",p))),d.on("end",p),s.add((0,A.toDisposable)(()=>d.removeListener("data",o))),d.on("data",o)})}e.peekStream=I;function y(d,a){const c=S(a);return c.end(d),c}e.toStream=y;function h(){const d=S(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=h;function g(d){let a=!1;return{read:()=>a?null:(a=!0,d)}}e.toReadable=g;function P(d,a,c){const i=S(c);return b(d,{onData:s=>i.write(a.data(s)),onError:s=>i.error(a.error?a.error(s):s),onEnd:()=>i.end()}),i}e.transform=P;function v(d,a,c){let i=!1;return{read:()=>{const s=a.read();return i?s:(i=!0,s!==null?c([d,s]):d)}}}e.prefixedReadable=v;function u(d,a,c){let i=!1;const s=S(c);return b(a,{onData:r=>i?s.write(r):(i=!0,s.write(c([d,r]))),onError:r=>s.error(r),onEnd:()=>{i||(i=!0,s.write(d)),s.end()}}),s}e.prefixedStream=u}),define(J[17],Z([0,1,64]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined";let k,M;class S{constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}static alloc(o){return A?new S(Buffer.allocUnsafe(o)):new S(new Uint8Array(o))}static wrap(o){return A&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new S(o)}static fromString(o,l){return!(l?.dontUseNodeBuffer||!1)&&A?new S(Buffer.from(o)):(k||(k=new TextEncoder),new S(k.encode(o)))}static concat(o,l){if(typeof l=="undefined"){l=0;for(let L=0,T=o.length;L<T;L++)l+=o[L].byteLength}const p=S.alloc(l);let E=0;for(let L=0,T=o.length;L<T;L++){const W=o[L];p.set(W,E),E+=W.byteLength}return p}toString(){return A?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(o,l){return new S(this.buffer.subarray(o,l))}set(o,l){o instanceof S?this.buffer.set(o.buffer,l):this.buffer.set(o,l)}readUInt32BE(o){return m(this.buffer,o)}writeUInt32BE(o,l){t(this.buffer,o,l)}readUInt32LE(o){return b(this.buffer,o)}writeUInt32LE(o,l){I(this.buffer,o,l)}readUInt8(o){return y(this.buffer,o)}writeUInt8(o,l){h(this.buffer,o,l)}}e.VSBuffer=S;function n(r,o){return r[o+0]<<0>>>0|r[o+1]<<8>>>0}e.readUInt16LE=n;function f(r,o,l){r[l+0]=o&255,o=o>>>8,r[l+1]=o&255}e.writeUInt16LE=f;function m(r,o){return r[o]*2**24+r[o+1]*2**16+r[o+2]*2**8+r[o+3]}e.readUInt32BE=m;function t(r,o,l){r[l+3]=o,o=o>>>8,r[l+2]=o,o=o>>>8,r[l+1]=o,o=o>>>8,r[l]=o}e.writeUInt32BE=t;function b(r,o){return r[o+0]<<0>>>0|r[o+1]<<8>>>0|r[o+2]<<16>>>0|r[o+3]<<24>>>0}e.readUInt32LE=b;function I(r,o,l){r[l+0]=o&255,o=o>>>8,r[l+1]=o&255,o=o>>>8,r[l+2]=o&255,o=o>>>8,r[l+3]=o&255}e.writeUInt32LE=I;function y(r,o){return r[o]}e.readUInt8=y;function h(r,o,l){r[l]=o}e.writeUInt8=h;function g(r){return w.consumeReadable(r,o=>S.concat(o))}e.readableToBuffer=g;function P(r){return w.toReadable(r)}e.bufferToReadable=P;function v(r){return w.consumeStream(r,o=>S.concat(o))}e.streamToBuffer=v;async function u(r){return r.ended?S.concat(r.buffer):S.concat([...r.buffer,await v(r.stream)])}e.bufferedStreamToBuffer=u;function d(r){return w.toStream(r,o=>S.concat(o))}e.bufferToStream=d;function a(r){return w.transform(r,{data:o=>typeof o=="string"?S.fromString(o):S.wrap(o)},o=>S.concat(o))}e.streamToBufferReadableStream=a;function c(r){return w.newWriteableStream(o=>S.concat(o),r)}e.newWriteableBufferStream=c;function i(r,o){return w.prefixedReadable(r,o,l=>S.concat(l))}e.prefixedBufferReadable=i;function s(r,o){return w.prefixedStream(r,o,l=>S.concat(l))}e.prefixedBufferStream=s}),define(J[25],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function w(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=w;const A=/{(\d+)}/g;function k(K,...re){return re.length===0?K:K.replace(A,function(ae,de){const pe=parseInt(de,10);return isNaN(pe)||pe<0||pe>=re.length?ae:re[pe]})}e.format=k;const M=/{([^}]+)}/g;function S(K,re){return K.replace(M,(ae,de)=>re[de]??ae)}e.format2=S;function n(K){return K.replace(/[<>&]/g,function(re){switch(re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return re}})}e.escape=n;function f(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function m(K,re){let ae=0;const de=re.charCodeAt(0);for(let pe=K.length-1;pe>=0;pe--)K.charCodeAt(pe)===de&&ae++;return ae}e.count=m;function t(K,re,ae="\u2026"){return K.length<=re?K:`${K.substr(0,re)}${ae}`}e.truncate=t;function b(K,re=" "){const ae=I(K,re);return y(ae,re)}e.trim=b;function I(K,re){if(!K||!re)return K;const ae=re.length;if(ae===0||K.length===0)return K;let de=0;for(;K.indexOf(re,de)===de;)de=de+ae;return K.substring(de)}e.ltrim=I;function y(K,re){if(!K||!re)return K;const ae=re.length,de=K.length;if(ae===0||de===0)return K;let pe=de,ke=-1;for(;ke=K.lastIndexOf(re,pe-1),!(ke===-1||ke+ae!==pe);){if(ke===0)return"";pe=ke}return K.substring(0,pe)}e.rtrim=y;function h(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function g(K){return K.replace(/\*/g,"")}e.stripWildcards=g;function P(K,re,ae={}){if(!K)throw new Error("Cannot create regex from empty string");re||(K=f(K)),ae.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let de="";return ae.global&&(de+="g"),ae.matchCase||(de+="i"),ae.multiline&&(de+="m"),ae.unicode&&(de+="u"),new RegExp(K,de)}e.createRegExp=P;function v(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function u(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function d(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=d;function a(K){return K.split(/\r\n|\r|\n/)}e.splitLines=a;function c(K){for(let re=0,ae=K.length;re<ae;re++){const de=K.charCodeAt(re);if(de!==32&&de!==9)return re}return-1}e.firstNonWhitespaceIndex=c;function i(K,re=0,ae=K.length){for(let de=re;de<ae;de++){const pe=K.charCodeAt(de);if(pe!==32&&pe!==9)return K.substring(re,de)}return K.substring(re,ae)}e.getLeadingWhitespace=i;function s(K,re=K.length-1){for(let ae=re;ae>=0;ae--){const de=K.charCodeAt(ae);if(de!==32&&de!==9)return ae}return-1}e.lastNonWhitespaceIndex=s;function r(K,re){return K<re?-1:K>re?1:0}e.compare=r;function o(K,re,ae=0,de=K.length,pe=0,ke=re.length){for(;ae<de&&pe<ke;ae++,pe++){let Ce=K.charCodeAt(ae),ze=re.charCodeAt(pe);if(Ce<ze)return-1;if(Ce>ze)return 1}const Fe=de-ae,We=ke-pe;return Fe<We?-1:Fe>We?1:0}e.compareSubstring=o;function l(K,re){return p(K,re,0,K.length,0,re.length)}e.compareIgnoreCase=l;function p(K,re,ae=0,de=K.length,pe=0,ke=re.length){for(;ae<de&&pe<ke;ae++,pe++){let Ce=K.charCodeAt(ae),ze=re.charCodeAt(pe);if(Ce===ze)continue;const he=Ce-ze;if(!(he===32&&L(ze))&&!(he===-32&&L(Ce)))return E(Ce)&&E(ze)?he:o(K.toLowerCase(),re.toLowerCase(),ae,de,pe,ke)}const Fe=de-ae,We=ke-pe;return Fe<We?-1:Fe>We?1:0}e.compareSubstringIgnoreCase=p;function E(K){return K>=97&&K<=122}e.isLowerAsciiLetter=E;function L(K){return K>=65&&K<=90}e.isUpperAsciiLetter=L;function T(K){return E(K)||L(K)}function W(K,re){return K.length===re.length&&C(K,re)}e.equalsIgnoreCase=W;function C(K,re,ae=K.length){for(let de=0;de<ae;de++){const pe=K.charCodeAt(de),ke=re.charCodeAt(de);if(pe!==ke){if(T(pe)&&T(ke)){const Fe=Math.abs(pe-ke);if(Fe!==0&&Fe!==32)return!1}else if(String.fromCharCode(pe).toLowerCase()!==String.fromCharCode(ke).toLowerCase())return!1}}return!0}function V(K,re){const ae=re.length;return re.length>K.length?!1:C(K,re,ae)}e.startsWithIgnoreCase=V;function x(K,re){let ae,de=Math.min(K.length,re.length);for(ae=0;ae<de;ae++)if(K.charCodeAt(ae)!==re.charCodeAt(ae))return ae;return de}e.commonPrefixLength=x;function se(K,re){let ae,de=Math.min(K.length,re.length);const pe=K.length-1,ke=re.length-1;for(ae=0;ae<de;ae++)if(K.charCodeAt(pe-ae)!==re.charCodeAt(ke-ae))return ae;return de}e.commonSuffixLength=se;function G(K){return 55296<=K&&K<=56319}e.isHighSurrogate=G;function Q(K){return 56320<=K&&K<=57343}e.isLowSurrogate=Q;function O(K,re){return(K-55296<<10)+(re-56320)+65536}e.computeCodePoint=O;function z(K,re,ae){const de=K.charCodeAt(ae);if(G(de)&&ae+1<re){const pe=K.charCodeAt(ae+1);if(Q(pe))return O(de,pe)}return de}e.getNextCodePoint=z;function U(K,re){const ae=K.charCodeAt(re-1);if(Q(ae)&&re>1){const de=K.charCodeAt(re-2);if(G(de))return O(de,ae)}return ae}function X(K,re){const ae=Be.getInstance(),de=re,pe=K.length,ke=z(K,pe,re);re+=ke>=65536?2:1;let Fe=ae.getGraphemeBreakType(ke);for(;re<pe;){const We=z(K,pe,re),Ce=ae.getGraphemeBreakType(We);if(Ue(Fe,Ce))break;re+=We>=65536?2:1,Fe=Ce}return re-de}e.nextCharLength=X;function H(K,re){const ae=Be.getInstance(),de=re,pe=U(K,re);re-=pe>=65536?2:1;let ke=ae.getGraphemeBreakType(pe);for(;re>0;){const Fe=U(K,re),We=ae.getGraphemeBreakType(Fe);if(Ue(We,ke))break;re-=Fe>=65536?2:1,ke=We}return de-re}e.prevCharLength=H;function _(K,re){const ae=Be.getInstance(),de=K.length,pe=re,ke=z(K,de,re),Fe=ae.getGraphemeBreakType(ke);re+=ke>=65536?2:1;let We=Fe;for(;re<de;){const ze=z(K,de,re),he=ae.getGraphemeBreakType(ze);if(Ue(We,he))break;re+=ze>=65536?2:1,We=he}const Ce=re;for(re=pe,We=Fe;re>0;){const ze=U(K,re),he=ae.getGraphemeBreakType(ze);if(Ue(he,We))break;re-=ze>=65536?2:1,We=he}return[re,Ce]}function j(K,re){return re>0&&Q(K.charCodeAt(re))?_(K,re-1):_(K,re)}e.getCharContainingOffset=j;const F=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function D(K){return F.test(K)}e.containsRTL=D;const R=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function N(K){return R.test(K)}e.containsEmoji=N;const B=/^[\t\n\r\x20-\x7E]*$/;function $(K){return B.test(K)}e.isBasicASCII=$,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Y(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Y;function ee(K){for(let re=0,ae=K.length;re<ae;re++)if(ie(K.charCodeAt(re)))return!0;return!1}e.containsFullWidthCharacter=ee;function ie(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=ie;function oe(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=oe;function ce(K,re){if(K.length<re)return K;const ae=/\b/g;let de=0;for(;ae.test(K)&&!(K.length-ae.lastIndex<re);)de=ae.lastIndex,ae.lastIndex+=1;return K.substring(de).replace(/^\s/,"")}e.lcut=ce;const ne=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,ve=/\x1b\[0?m/g;function fe(K){return K&&(K=K.replace(ne,""),K=K.replace(le,""),K=K.replace(ve,"")),K}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=we;function Ae(K){return we(K)?K.substr(1):K}e.stripUTF8BOM=Ae;function Se(K,re){if(!K||!re||K.length<re.length)return!1;const ae=re.length,de=K.toLowerCase();let pe=0,ke=-1;for(;pe<ae;){const Fe=de.indexOf(re[pe],ke+1);if(Fe<0)return!1;ke=Fe,pe++}return!0}e.fuzzyContains=Se;function me(K,re=!1){return K?(re&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=me;function Ee(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Ee;function De(K,re=1){if(re===0)return"";let ae=-1;do ae=K.indexOf(`
`,ae+1),re--;while(re>0&&ae>=0);return ae===-1?K:(K[ae-1]==="\r"&&ae--,K.substr(0,ae))}e.getNLines=De;function Te(K){const re=90-65+1;return K=K%(2*re),K<re?String.fromCharCode(97+K):String.fromCharCode(65+K-re)}e.singleLetterHash=Te;function Ne(K){return Be.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=Ne;function Ue(K,re){return K===0?re!==5&&re!==7:K===2&&re===3?!1:K===4||K===2||K===3||re===4||re===2||re===3?!0:!(K===8&&(re===8||re===9||re===11||re===12)||(K===11||K===9)&&(re===9||re===10)||(K===12||K===10)&&re===10||re===5||re===13||re===7||K===1||K===13&&re===14||K===6&&re===6)}e.breakBetweenGraphemeBreakType=Ue;var Ge;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=st()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(re){if(re<32)return re===10?3:re===13?2:4;if(re<127)return 0;const ae=this._data,de=ae.length/3;let pe=1;for(;pe<=de;)if(re<ae[3*pe])pe=2*pe;else if(re>ae[3*pe+1])pe=2*pe+1;else return ae[3*pe+2];return 0}}Be._INSTANCE=null;function st(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ze(K,re){if(K===0)return 0;const ae=ot(K,re);if(ae!==void 0)return ae;const de=U(re,K);return K-=Ye(de),K}e.getLeftDeleteOffset=Ze;function ot(K,re){let ae=U(re,K);for(K-=Ye(ae);ut(ae)||ae===65039||ae===8419;){if(K===0)return;ae=U(re,K),K-=Ye(ae)}if(!!oe(ae)){if(K>=0){const de=U(re,K);de===8205&&(K-=Ye(de))}return K}}function Ye(K){return K>=65536?2:1}function ut(K){return 127995<=K&&K<=127999}var xe;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={}))}),define(J[78],Z([0,1,25]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function A(v){return k(v,0)}e.hash=A;function k(v,u){switch(typeof v){case"object":return v===null?M(349,u):Array.isArray(v)?f(v,u):m(v,u);case"string":return n(v,u);case"boolean":return S(v,u);case"number":return M(v,u);case"undefined":return M(937,u);default:return M(617,u)}}e.doHash=k;function M(v,u){return(u<<5)-u+v|0}function S(v,u){return M(v?433:863,u)}function n(v,u){u=M(149417,u);for(let d=0,a=v.length;d<a;d++)u=M(v.charCodeAt(d),u);return u}e.stringHash=n;function f(v,u){return u=M(104579,u),v.reduce((d,a)=>k(a,d),u)}function m(v,u){return u=M(181387,u),Object.keys(v).sort().reduce((d,a)=>(d=n(a,d),k(v[a],d)),u)}class t{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=k(u,this._value),this._value}}e.Hasher=t;var b;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function I(v,u,d=32){const a=d-u,c=~((1<<a)-1);return(v<<u|(c&v)>>>a)>>>0}function y(v,u=0,d=v.byteLength,a=0){for(let c=0;c<d;c++)v[u+c]=a}function h(v,u,d="0"){for(;v.length<u;)v=d+v;return v}function g(v,u=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(d=>d.toString(16).padStart(2,"0")).join(""):h((v>>>0).toString(16),u/4)}e.toHexString=g;class P{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const d=u.length;if(d===0)return;const a=this._buff;let c=this._buffLen,i=this._leftoverHighSurrogate,s,r;for(i!==0?(s=i,r=-1,i=0):(s=u.charCodeAt(0),r=0);;){let o=s;if(w.isHighSurrogate(s))if(r+1<d){const l=u.charCodeAt(r+1);w.isLowSurrogate(l)?(r++,o=w.computeCodePoint(s,l)):o=65533}else{i=s;break}else w.isLowSurrogate(s)&&(o=65533);if(c=this._push(a,c,o),r++,r<d)s=u.charCodeAt(r);else break}this._buffLen=c,this._leftoverHighSurrogate=i}_push(u,d,a){return a<128?u[d++]=a:a<2048?(u[d++]=192|(a&1984)>>>6,u[d++]=128|(a&63)>>>0):a<65536?(u[d++]=224|(a&61440)>>>12,u[d++]=128|(a&4032)>>>6,u[d++]=128|(a&63)>>>0):(u[d++]=240|(a&1835008)>>>18,u[d++]=128|(a&258048)>>>12,u[d++]=128|(a&4032)>>>6,u[d++]=128|(a&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=P._bigBlock32,d=this._buffDV;for(let E=0;E<64;E+=4)u.setUint32(E,d.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)u.setUint32(E,I(u.getUint32(E-12,!1)^u.getUint32(E-32,!1)^u.getUint32(E-56,!1)^u.getUint32(E-64,!1),1),!1);let a=this._h0,c=this._h1,i=this._h2,s=this._h3,r=this._h4,o,l,p;for(let E=0;E<80;E++)E<20?(o=c&i|~c&s,l=1518500249):E<40?(o=c^i^s,l=1859775393):E<60?(o=c&i|c&s|i&s,l=2400959708):(o=c^i^s,l=3395469782),p=I(a,5)+o+r+l+u.getUint32(E*4,!1)&4294967295,r=s,s=i,i=I(c,30),c=a,a=p;this._h0=this._h0+a&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=P,P._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[13],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(L){return Array.isArray(L)}e.isArray=w;function A(L){return typeof L=="string"}e.isString=A;function k(L){return Array.isArray(L)&&L.every(T=>A(T))}e.isStringArray=k;function M(L){return typeof L=="object"&&L!==null&&!Array.isArray(L)&&!(L instanceof RegExp)&&!(L instanceof Date)}e.isObject=M;function S(L){return typeof L=="number"&&!isNaN(L)}e.isNumber=S;function n(L){return!!L&&typeof L[Symbol.iterator]=="function"}e.isIterable=n;function f(L){return L===!0||L===!1}e.isBoolean=f;function m(L){return typeof L=="undefined"}e.isUndefined=m;function t(L){return!b(L)}e.isDefined=t;function b(L){return m(L)||L===null}e.isUndefinedOrNull=b;function I(L,T){if(!L)throw new Error(T?`Unexpected type, expected '${T}'`:"Unexpected type")}e.assertType=I;function y(L){if(b(L))throw new Error("Assertion Failed: argument is undefined or null");return L}e.assertIsDefined=y;function h(...L){const T=[];for(let W=0;W<L.length;W++){const C=L[W];if(b(C))throw new Error(`Assertion Failed: argument at index ${W} is undefined or null`);T.push(C)}return T}e.assertAllDefined=h;const g=Object.prototype.hasOwnProperty;function P(L){if(!M(L))return!1;for(let T in L)if(g.call(L,T))return!1;return!0}e.isEmptyObject=P;function v(L){return typeof L=="function"}e.isFunction=v;function u(...L){return L.length>0&&L.every(v)}e.areFunctions=u;function d(L,T){const W=Math.min(L.length,T.length);for(let C=0;C<W;C++)a(L[C],T[C])}e.validateConstraints=d;function a(L,T){if(A(T)){if(typeof L!==T)throw new Error(`argument does not match constraint: typeof ${T}`)}else if(v(T)){try{if(L instanceof T)return}catch{}if(!b(L)&&L.constructor===T||T.length===1&&T.call(void 0,L)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function c(L){let T=[],W=Object.getPrototypeOf(L);for(;Object.prototype!==W;)T=T.concat(Object.getOwnPropertyNames(W)),W=Object.getPrototypeOf(W);return T}e.getAllPropertyNames=c;function i(L){const T=[];for(const W of c(L))typeof L[W]=="function"&&T.push(W);return T}e.getAllMethodNames=i;function s(L,T){const W=V=>function(){const x=Array.prototype.slice.call(arguments,0);return T(V,x)};let C={};for(const V of L)C[V]=W(V);return C}e.createProxyObject=s;function r(L){return L===null?void 0:L}e.withNullAsUndefined=r;function o(L){return typeof L=="undefined"?null:L}e.withUndefinedAsNull=o;function l(L){return class{constructor(){return new Proxy({},{get(T,W){if(T[W])return T[W];throw new Error(`Not Implemented: ${L}->${String(W)}`)}})}}}e.NotImplementedProxy=l;function p(L,T="Unreachable"){throw new Error(T)}e.assertNever=p;function E(L){return!!L&&typeof L.then=="function"&&typeof L.catch=="function"}e.isPromise=E}),define(J[29],Z([0,1,8,3,25,13]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function S(r){return r===47||r===92}e.isPathSeparator=S;function n(r){return r.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=n;function f(r){return r.indexOf("/")===-1&&(r=n(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=f;function m(r,o=w.posix.sep){if(!r)return"";const l=r.length,p=r.charCodeAt(0);if(S(p)){if(S(r.charCodeAt(1))&&!S(r.charCodeAt(2))){let L=3;const T=L;for(;L<l&&!S(r.charCodeAt(L));L++);if(T!==L&&!S(r.charCodeAt(L+1))){for(L+=1;L<l;L++)if(S(r.charCodeAt(L)))return r.slice(0,L+1).replace(/[\\/]/g,o)}}return o}else if(v(p)&&r.charCodeAt(1)===58)return S(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let E=r.indexOf("://");if(E!==-1){for(E+=3;E<l;E++)if(S(r.charCodeAt(E)))return r.slice(0,E+1)}return""}e.getRoot=m;function t(r){if(!A.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let l=2;const p=l;for(;l<r.length&&(o=r.charCodeAt(l),o!==92);l++);return!(p===l||(o=r.charCodeAt(l+1),isNaN(o)||o===92))}e.isUNC=t;const b=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,o=A.isWindows){const l=o?b:I;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||o&&y.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=h;function g(r,o,l){const p=r===o;return!l||p?p:!r||!o?!1:(0,k.equalsIgnoreCase)(r,o)}e.isEqual=g;function P(r,o,l,p=w.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(l){if(!(0,k.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let L=o.length;return o.charAt(o.length-1)===p&&L--,r.charAt(L)===p}return o.charAt(o.length-1)!==p&&(o+=p),r.indexOf(o)===0}e.isEqualOrParent=P;function v(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=v;function u(r,o){return A.isWindows&&r.endsWith(":")&&(r+=w.sep),(0,w.isAbsolute)(r)||(r=(0,w.join)(o,r)),r=(0,w.normalize)(r),A.isWindows?(r=(0,k.rtrim)(r,w.sep),r.endsWith(":")&&(r+=w.sep)):(r=(0,k.rtrim)(r,w.sep),r||(r=w.sep)),r}e.sanitizeFilePath=u;function d(r){const o=(0,w.normalize)(r);return A.isWindows?r.length>3?!1:a(o)&&(r.length===2||o.charCodeAt(2)===92):o===w.posix.sep}e.isRootOrDriveLetter=d;function a(r){return A.isWindows?v(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function c(r){return a(r)?r[0]:void 0}e.getDriveLetter=c;function i(r,o,l){return o.length>r.length?-1:r===o?0:(l&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=i;function s(r){const o=r.split(":");let l,p,E;if(o.forEach(L=>{const T=Number(L);(0,M.isNumber)(T)?p===void 0?p=T:E===void 0&&(E=T):l=l?[l,L].join(":"):L}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:p!==void 0?p:void 0,column:E!==void 0?E:p!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(J[44],Z([0,1,13]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const P=Array.isArray(g)?[]:{};return Object.keys(g).forEach(v=>{g[v]&&typeof g[v]=="object"?P[v]=A(g[v]):P[v]=g[v]}),P}e.deepClone=A;function k(g){if(!g||typeof g!="object")return g;const P=[g];for(;P.length>0;){const v=P.shift();Object.freeze(v);for(const u in v)if(M.call(v,u)){const d=v[u];typeof d=="object"&&!Object.isFrozen(d)&&P.push(d)}}return g}e.deepFreeze=k;const M=Object.prototype.hasOwnProperty;function S(g,P){return n(g,P,new Set)}e.cloneAndChange=S;function n(g,P,v){if((0,w.isUndefinedOrNull)(g))return g;const u=P(g);if(typeof u!="undefined")return u;if((0,w.isArray)(g)){const d=[];for(const a of g)d.push(n(a,P,v));return d}if((0,w.isObject)(g)){if(v.has(g))throw new Error("Cannot clone recursive data-structure");v.add(g);const d={};for(let a in g)M.call(g,a)&&(d[a]=n(g[a],P,v));return v.delete(g),d}return g}function f(g,P,v=!0){return(0,w.isObject)(g)?((0,w.isObject)(P)&&Object.keys(P).forEach(u=>{u in g?v&&((0,w.isObject)(g[u])&&(0,w.isObject)(P[u])?f(g[u],P[u],v):g[u]=P[u]):g[u]=P[u]}),g):P}e.mixin=f;function m(g,P){if(g===P)return!0;if(g==null||P===null||P===void 0||typeof g!=typeof P||typeof g!="object"||Array.isArray(g)!==Array.isArray(P))return!1;let v,u;if(Array.isArray(g)){if(g.length!==P.length)return!1;for(v=0;v<g.length;v++)if(!m(g[v],P[v]))return!1}else{const d=[];for(u in g)d.push(u);d.sort();const a=[];for(u in P)a.push(u);if(a.sort(),!m(d,a))return!1;for(v=0;v<d.length;v++)if(!m(g[d[v]],P[d[v]]))return!1}return!0}e.equals=m;function t(g){const P=new Set;return JSON.stringify(g,(v,u)=>{if((0,w.isObject)(u)||Array.isArray(u)){if(P.has(u))return"[Circular]";P.add(u)}return u})}e.safeStringify=t;function b(g,P,v){const u=P(g);return typeof u=="undefined"?v:u}e.getOrDefault=b;function I(g,P){const v=Object.create(null);return!g||!P||Object.keys(P).forEach(d=>{const a=g[d],c=P[d];m(a,c)||(v[d]=c)}),v}e.distinct=I;function y(g,P){const v=P.toLowerCase(),u=Object.keys(g).find(d=>d.toLowerCase()===v);return u?g[u]:g[P]}e.getCaseInsensitive=y;function h(g,P){const v=Object.create(null);for(const u of Object.keys(g))P(u,g[u])&&(v[u]=g[u]);return v}e.filter=h}),define(J[7],Z([0,1,8,3]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,M=/^\//,S=/^\/\//;function n(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!k.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!M.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(r,o){return!r&&!o?"file":r}function m(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==b&&(o=b+o):o=b;break}return o}const t="",b="/",I=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(o,l,p,E,L,T=!1){typeof o=="object"?(this.scheme=o.scheme||t,this.authority=o.authority||t,this.path=o.path||t,this.query=o.query||t,this.fragment=o.fragment||t):(this.scheme=f(o,T),this.authority=l||t,this.path=m(this.scheme,p||t),this.query=E||t,this.fragment=L||t,n(this,T))}static isUri(o){return o instanceof y?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return d(this,!1)}with(o){if(!o)return this;let{scheme:l,authority:p,path:E,query:L,fragment:T}=o;return l===void 0?l=this.scheme:l===null&&(l=t),p===void 0?p=this.authority:p===null&&(p=t),E===void 0?E=this.path:E===null&&(E=t),L===void 0?L=this.query:L===null&&(L=t),T===void 0?T=this.fragment:T===null&&(T=t),l===this.scheme&&p===this.authority&&E===this.path&&L===this.query&&T===this.fragment?this:new g(l,p,E,L,T)}static parse(o,l=!1){const p=I.exec(o);return p?new g(p[2]||t,s(p[4]||t),s(p[5]||t),s(p[7]||t),s(p[9]||t),l):new g(t,t,t,t,t)}static file(o){let l=t;if(A.isWindows&&(o=o.replace(/\\/g,b)),o[0]===b&&o[1]===b){const p=o.indexOf(b,2);p===-1?(l=o.substring(2),o=b):(l=o.substring(2,p),o=o.substring(p)||b)}return new g("file",l,o,t,t)}static from(o){const l=new g(o.scheme,o.authority,o.path,o.query,o.fragment);return n(l,!0),l}static joinPath(o,...l){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return A.isWindows&&o.scheme==="file"?p=y.file(w.win32.join(d(o,!0),...l)).path:p=w.posix.join(o.path,...l),o.with({path:p})}toString(o=!1){return a(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof y)return o;{const l=new g(o);return l._formatted=o.external,l._fsPath=o._sep===h?o.fsPath:null,l}}else return o}}e.URI=y;const h=A.isWindows?1:void 0;class g extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(o=!1){return o?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=h),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const P={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(r,o){let l,p=-1;for(let E=0;E<r.length;E++){const L=r.charCodeAt(E);if(L>=97&&L<=122||L>=65&&L<=90||L>=48&&L<=57||L===45||L===46||L===95||L===126||o&&L===47)p!==-1&&(l+=encodeURIComponent(r.substring(p,E)),p=-1),l!==void 0&&(l+=r.charAt(E));else{l===void 0&&(l=r.substr(0,E));const T=P[L];T!==void 0?(p!==-1&&(l+=encodeURIComponent(r.substring(p,E)),p=-1),l+=T):p===-1&&(p=E)}}return p!==-1&&(l+=encodeURIComponent(r.substring(p))),l!==void 0?l:r}function u(r){let o;for(let l=0;l<r.length;l++){const p=r.charCodeAt(l);p===35||p===63?(o===void 0&&(o=r.substr(0,l)),o+=P[p]):o!==void 0&&(o+=r[l])}return o!==void 0?o:r}function d(r,o){let l;return r.authority&&r.path.length>1&&r.scheme==="file"?l=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?o?l=r.path.substr(1):l=r.path[1].toLowerCase()+r.path.substr(2):l=r.path,A.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=d;function a(r,o){const l=o?u:v;let p="",{scheme:E,authority:L,path:T,query:W,fragment:C}=r;if(E&&(p+=E,p+=":"),(L||E==="file")&&(p+=b,p+=b),L){let V=L.indexOf("@");if(V!==-1){const x=L.substr(0,V);L=L.substr(V+1),V=x.indexOf(":"),V===-1?p+=l(x,!1):(p+=l(x.substr(0,V),!1),p+=":",p+=l(x.substr(V+1),!1)),p+="@"}L=L.toLowerCase(),V=L.indexOf(":"),V===-1?p+=l(L,!1):(p+=l(L.substr(0,V),!1),p+=L.substr(V))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const V=T.charCodeAt(1);V>=65&&V<=90&&(T=`/${String.fromCharCode(V+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const V=T.charCodeAt(0);V>=65&&V<=90&&(T=`${String.fromCharCode(V+32)}:${T.substr(2)}`)}p+=l(T,!0)}return W&&(p+="?",p+=l(W,!1)),C&&(p+="#",p+=o?C:v(C,!1)),p}function c(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+c(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(i)?r.replace(i,o=>c(o)):r}}),define(J[109],Z([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(m){const t=m;return t&&typeof t.type=="string"&&typeof t.severity=="string"}e.isRemoteConsoleLog=A;function k(m){const t=[];let b;try{const I=JSON.parse(m.arguments),y=I[I.length-1];y&&y.__$stack&&(I.pop(),b=y.__$stack),t.push(...I)}catch(I){t.push("Unable to log remote console arguments",m.arguments)}return{args:t,stack:b}}e.parse=k;function M(m){if(typeof m!="string")return M(k(m).stack);const t=m;if(t){const b=S(t),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(I&&I.length===4)return{uri:w.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}e.getFirstFrame=M;function S(m){if(!m)return m;const t=m.indexOf(`
`);return t===-1?m:m.substring(0,t)}function n(m,t){const{args:b,stack:I}=k(m),y=typeof b[0]=="string"&&b.length===1;let h=S(I);h&&(h=`(${h.trim()})`);let g=[];if(typeof b[0]=="string"?h&&y?g=[`%c[${t}] %c${b[0]} %c${h}`,f("blue"),f(""),f("grey")]:g=[`%c[${t}] %c${b[0]}`,f("blue"),f(""),...b.slice(1)]:g=[`%c[${t}]%`,f("blue"),...b],h&&!y&&g.push(h),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,g)}e.log=n;function f(m){return`color: ${m}`}});var bt=this&&this.__classPrivateFieldSet||function(q,e,w,A,k){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?q!==e||!k:!e.has(q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?k.call(q,w):k?k.value=w:e.set(q,w),w},qe=this&&this.__classPrivateFieldGet||function(q,e,w,A){if(w==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?q!==e||!A:!e.has(q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?A:w==="a"?A.call(q):A?A.value:e.get(q)};define(J[37],Z([0,1,25,7]),function(q,e,w,A){"use strict";var k,M,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function n(i,s,r){let o=i.get(s);return o===void 0&&(o=r,i.set(s,o)),o}e.getOrSet=n;function f(i){const s=[];return i.forEach((r,o)=>{s.push(`${o} => ${r}`)}),`Map(${i.size}) {${s.join(", ")}}`}e.mapToString=f;function m(i){const s=[];return i.forEach(r=>{s.push(r)}),`Set(${i.size}) {${s.join(", ")}}`}e.setToString=m;class t{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const r=s.charCodeAt(0),o=this._value.charCodeAt(this._pos);return r-o}value(){return this._value[this._pos]}}e.StringIterator=t;class b{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,w.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,w.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class I{constructor(s=!0,r=!0){this._splitOnBackslash=s,this._caseSensitive=r}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,w.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,w.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=I;var y;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(y||(y={}));class h{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new I(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,w.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,w.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,w.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,w.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class P{constructor(s){this._iter=s}static forUris(s=()=>!1){return new P(new h(s))}static forPaths(){return new P(new I)}static forStrings(){return new P(new t)}static forConfigKeys(){return new P(new b)}clear(){this._root=void 0}set(s,r){const o=this._iter.reset(s);let l;for(this._root||(this._root=new g,this._root.segment=o.value()),l=this._root;;){const E=o.cmp(l.segment);if(E>0)l.left||(l.left=new g,l.left.segment=o.value()),l=l.left;else if(E<0)l.right||(l.right=new g,l.right.segment=o.value()),l=l.right;else if(o.hasNext())o.next(),l.mid||(l.mid=new g,l.mid.segment=o.value()),l=l.mid;else break}const p=l.value;return l.value=r,l.key=s,p}get(s){return this._getNode(s)?.value}_getNode(s){const r=this._iter.reset(s);let o=this._root;for(;o;){const l=r.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(s){const r=this._getNode(s);return!(r?.value===void 0&&r?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,r){const o=this._iter.reset(s),l=[];let p=this._root;for(;p;){const E=o.cmp(p.segment);if(E>0)l.push([1,p]),p=p.left;else if(E<0)l.push([-1,p]),p=p.right;else if(o.hasNext())o.next(),l.push([0,p]),p=p.mid;else{for(r?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;l.length>0&&p.isEmpty();){let[L,T]=l.pop();switch(L){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}p=T}break}}}findSubstr(s){const r=this._iter.reset(s);let o=this._root,l;for(;o;){const p=r.cmp(o.segment);if(p>0)o=o.left;else if(p<0)o=o.right;else if(r.hasNext())r.next(),l=o.value||l,o=o.mid;else break}return o&&o.value||l}findSuperstr(s){const r=this._iter.reset(s);let o=this._root;for(;o;){const l=r.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(s){for(const[r,o]of this)s(o,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const r=[s];for(;r.length>0;){const o=r.pop();o&&(o.value&&(yield[o.key,o.value]),o.left&&r.push(o.left),o.mid&&r.push(o.mid),o.right&&r.push(o.right))}}}e.TernarySearchTree=P;class v{constructor(s,r){this[k]="ResourceMap",s instanceof v?(this.map=new Map(s.map),this.toKey=r??v.defaultToKey):(this.map=new Map,this.toKey=s??v.defaultToKey)}set(s,r){return this.map.set(this.toKey(s),r),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,r){typeof r!="undefined"&&(s=s.bind(r));for(let[o,l]of this.map)s(l,A.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield A.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[A.URI.parse(s[0]),s[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[A.URI.parse(s[0]),s[1]]}}e.ResourceMap=v,v.defaultToKey=i=>i.toString();var u;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(u=e.Touch||(e.Touch={}));class d{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,r=0){const o=this._map.get(s);if(!!o)return r!==0&&this.touch(o,r),o.value}set(s,r,o=0){let l=this._map.get(s);if(l)l.value=r,o!==0&&this.touch(l,o);else{switch(l={key:s,value:r,next:void 0,previous:void 0},o){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(s,l),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const r=this._map.get(s);if(!!r)return this._map.delete(s),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,r){const o=this._state;let l=this._head;for(;l;){if(r?s.bind(r)(l.value,l.key,this):s(l.value,l.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const s=this,r=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:o.key,done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return l}values(){const s=this,r=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:o.value,done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return l}entries(){const s=this,r=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(s._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:[o.key,o.value],done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return l}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let r=this._head,o=this.size;for(;r&&o>s;)this._map.delete(r.key),r=r.next,o--;this._head=r,this._size=o,r&&(r.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const r=s.next,o=s.previous;if(!r||!o)throw new Error("Invalid list");r.previous=o,o.next=r}s.next=void 0,s.previous=void 0,this._state++}touch(s,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(s===this._head)return;const o=s.next,l=s.previous;s===this._tail?(l.next=void 0,this._tail=l):(o.previous=l,l.next=o),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(r===2){if(s===this._tail)return;const o=s.next,l=s.previous;s===this._head?(o.previous=void 0,this._head=o):(o.previous=l,l.next=o),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((r,o)=>{s.push([o,r])}),s}fromJSON(s){this.clear();for(const[r,o]of s)this.set(r,o)}}e.LinkedMap=d;class a extends d{constructor(s,r=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,r=2){return super.get(s,r)}peek(s){return super.get(s,0)}set(s,r){return super.set(s,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class c{constructor(s){S.set(this,void 0),bt(this,S,s,"f")}get size(){return qe(this,S,"f").size}forEach(s,r){qe(this,S,"f").forEach(s,r)}get(s){return qe(this,S,"f").get(s)}has(s){return qe(this,S,"f").has(s)}entries(){return qe(this,S,"f").entries()}keys(){return qe(this,S,"f").keys()}values(){return qe(this,S,"f").values()}[(S=new WeakMap,Symbol.iterator)](){return qe(this,S,"f").entries()}}e.ReadonlyMapView=c}),define(J[110],Z([0,1,17,25,7]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function M(t){return JSON.stringify(t,f)}e.stringify=M;function S(t){let b=JSON.parse(t);return b=m(b),b}e.parse=S;var n;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(n=e.MarshalledId||(e.MarshalledId={}));function f(t,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,A.regExpFlags)(b)}:b}function m(t,b=0){if(!t||b>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return k.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof w.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let I=0;I<t.length;++I)t[I]=m(t[I],b+1);else for(const I in t)Object.hasOwnProperty.call(t,I)&&(t[I]=m(t[I],b+1))}return t}e.revive=m}),define(J[10],Z([0,1,3,7]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractive="vscode-interactive",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,m,t){this._hosts[f]=m,this._ports[f]=t}setConnectionToken(f,m){this._connectionTokens[f]=m}rewrite(f){if(this._delegate)return this._delegate(f);const m=f.authority;let t=this._hosts[m];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const b=this._ports[m],I=this._connectionTokens[m];let y=`path=${encodeURIComponent(f.path)}`;return typeof I=="string"&&(y+=`&tkn=${encodeURIComponent(I)}`),A.URI.from({scheme:w.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${t}:${b}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new M;class S{asBrowserUri(f,m){const t=this.toUri(f,m);return t.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===k.file&&(w.isNative||typeof w.globals.importScripts=="function"&&w.globals.origin===`${k.vscodeFileResource}://${S.FALLBACK_AUTHORITY}`)?t.with({scheme:k.vscodeFileResource,authority:t.authority||S.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(f,m){const t=this.toUri(f,m);return t.scheme===k.vscodeFileResource?t.with({scheme:k.file,authority:t.authority!==S.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(f,m){return A.URI.isUri(f)?f:A.URI.parse(m.toUrl(f))}}S.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new S}),define(J[65],Z([0,1,37]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new w.LRUCache(1e4);function k(m){return f(m,"NFC",A)}e.normalizeNFC=k;const M=new w.LRUCache(1e4);function S(m){return f(m,"NFD",M)}e.normalizeNFD=S;const n=/[^\u0000-\u0080]/;function f(m,t,b){if(!m)return m;const I=b.get(m);if(I)return I;let y;return n.test(m)?y=m.normalize(t):y=m,b.set(m,y),y}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(t){return S(t).replace(m,"")}}()}),define(J[15],Z([0,1,29,10,8,3,25,7]),function(q,e,w,A,k,M,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(y){return(0,n.uriToFsPath)(y,!0)}e.originalFSPath=f;class m{constructor(h){this._ignorePathCasing=h}compare(h,g,P=!1){return h===g?0:(0,S.compare)(this.getComparisonKey(h,P),this.getComparisonKey(g,P))}isEqual(h,g,P=!1){return h===g?!0:!h||!g?!1:this.getComparisonKey(h,P)===this.getComparisonKey(g,P)}getComparisonKey(h,g=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,g,P=!1){if(h.scheme===g.scheme){if(h.scheme===A.Schemas.file)return w.isEqualOrParent(f(h),f(g),this._ignorePathCasing(h))&&h.query===g.query&&(P||h.fragment===g.fragment);if((0,e.isEqualAuthority)(h.authority,g.authority))return w.isEqualOrParent(h.path,g.path,this._ignorePathCasing(h),"/")&&h.query===g.query&&(P||h.fragment===g.fragment)}return!1}joinPath(h,...g){return n.URI.joinPath(h,...g)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return k.posix.basename(h.path)}extname(h){return k.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let g;return h.scheme===A.Schemas.file?g=n.URI.file(k.dirname(f(h))).path:(g=k.posix.dirname(h.path),h.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),g="/")),h.with({path:g})}normalizePath(h){if(!h.path.length)return h;let g;return h.scheme===A.Schemas.file?g=n.URI.file(k.normalize(f(h))).path:g=k.posix.normalize(h.path),h.with({path:g})}relativePath(h,g){if(h.scheme!==g.scheme||!(0,e.isEqualAuthority)(h.authority,g.authority))return;if(h.scheme===A.Schemas.file){const u=k.relative(f(h),f(g));return M.isWindows?w.toSlashes(u):u}let P=h.path||"/",v=g.path||"/";if(this._ignorePathCasing(h)){let u=0;for(const d=Math.min(P.length,v.length);u<d&&!(P.charCodeAt(u)!==v.charCodeAt(u)&&P.charAt(u).toLowerCase()!==v.charAt(u).toLowerCase());u++);P=v.substr(0,u)+P.substr(u)}return k.posix.relative(P,v)}resolvePath(h,g){if(h.scheme===A.Schemas.file){const P=n.URI.file(k.resolve(f(h),g));return h.with({authority:P.authority,path:P.path})}return g=w.toPosixPath(g),h.with({path:k.posix.resolve(h.path,g)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,g){return h===g||(0,S.equalsIgnoreCase)(h,g)}hasTrailingPathSeparator(h,g=k.sep){if(h.scheme===A.Schemas.file){const P=f(h);return P.length>w.getRoot(P).length&&P[P.length-1]===g}else{const P=h.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,g=k.sep){return(0,e.hasTrailingPathSeparator)(h,g)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,g=k.sep){let P=!1;if(h.scheme===A.Schemas.file){const v=f(h);P=v!==void 0&&v.length===w.getRoot(v).length&&v[v.length-1]===g}else{g="/";const v=h.path;P=v.length===1&&v.charCodeAt(v.length-1)===47}return!P&&!(0,e.hasTrailingPathSeparator)(h,g)?h.with({path:h.path+"/"}):h}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(y=>y.scheme===A.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new m(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(y,h){const g=[];for(let P=0;P<y.length;P++){const v=h(y[P]);y.some((u,d)=>d===P?!1:(0,e.isEqualOrParent)(v,h(u)))||g.push(y[P])}return g}e.distinctParents=t;var b;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function h(g){const P=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(d=>{const[a,c]=d.split(":");a&&c&&P.set(a,c)});const u=g.path.substring(0,g.path.indexOf(";"));return u&&P.set(y.META_DATA_MIME,u),P}y.parseMetaData=h})(b=e.DataUri||(e.DataUri={}));function I(y,h,g){if(h){let P=y.path;return P&&P[0]!==k.posix.sep&&(P=k.posix.sep+P),y.with({scheme:g,authority:h,path:P})}return y.with({scheme:g})}e.toLocalResource=I}),define(J[9],Z([0,1,24,16,5,2,15]),function(q,e,w,A,k,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function n(z){return!!z&&typeof z.then=="function"}e.isThenable=n;function f(z){const U=new w.CancellationTokenSource,X=z(U.token),H=new Promise((_,j)=>{const F=U.token.onCancellationRequested(()=>{F.dispose(),U.dispose(),j((0,A.canceled)())});Promise.resolve(X).then(D=>{F.dispose(),U.dispose(),_(D)},D=>{F.dispose(),U.dispose(),j(D)})});return new class{cancel(){U.cancel()}then(_,j){return H.then(_,j)}catch(_){return this.then(void 0,_)}finally(_){return H.finally(_)}}}e.createCancelablePromise=f;function m(z,U,X){return Promise.race([z,new Promise(H=>U.onCancellationRequested(()=>H(X)))])}e.raceCancellation=m;async function t(z){let U=-1;const X=z.map((_,j)=>_.then(F=>(U=j,F))),H=await Promise.race(X);return z.forEach((_,j)=>{j!==U&&_.cancel()}),H}e.raceCancellablePromises=t;function b(z,U,X){let H;const _=setTimeout(()=>{H?.(void 0),X?.()},U);return Promise.race([z.finally(()=>clearTimeout(_)),new Promise(j=>H=j)])}e.raceTimeout=b;function I(z){return new Promise((U,X)=>{const H=z();n(H)?H.then(U,X):U(H)})}e.asPromise=I;class y{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const X=()=>{this.queuedPromise=null;const H=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,H};this.queuedPromise=new Promise(H=>{this.activePromise.then(X,X).then(H)})}return new Promise((X,H)=>{this.queuedPromise.then(X,H)})}return this.activePromise=U(),new Promise((X,H)=>{this.activePromise.then(_=>{this.activePromise=null,X(_)},_=>{this.activePromise=null,H(_)})})}}e.Throttler=y;class h{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=h;class g{constructor(){this.promiseMap=new Map}queue(U,X){const _=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(X).finally(()=>{this.promiseMap.get(U)===_&&this.promiseMap.delete(U)});return this.promiseMap.set(U,_),_}}e.SequencerByKey=g;class P{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,X=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((H,_)=>{this.doResolve=H,this.doReject=_}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const H=this.task;return this.task=null,H()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},X),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,A.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=P;class v{constructor(U){this.delayer=new P(U),this.throttler=new y}trigger(U,X){return this.delayer.trigger(()=>this.throttler.queue(U),X)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class u{constructor(){this._isOpen=!1,this._promise=new Promise((U,X)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class d extends u{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function a(z,U){return U?new Promise((X,H)=>{const _=setTimeout(()=>{j.dispose(),X()},z),j=U.onCancellationRequested(()=>{clearTimeout(_),j.dispose(),H((0,A.canceled)())})}):f(X=>a(z,X))}e.timeout=a;function c(z,U=0){const X=setTimeout(z,U);return(0,M.toDisposable)(()=>clearTimeout(X))}e.disposableTimeout=c;function i(z){const U=[];let X=0;const H=z.length;function _(){return X<H?z[X++]():null}function j(F){F!=null&&U.push(F);const D=_();return D?D.then(j):Promise.resolve(U)}return Promise.resolve(null).then(j)}e.sequence=i;function s(z,U=H=>!!H,X=null){let H=0;const _=z.length,j=()=>{if(H>=_)return Promise.resolve(X);const F=z[H++];return Promise.resolve(F()).then(R=>U(R)?Promise.resolve(R):j())};return j()}e.first=s;function r(z,U=H=>!!H,X=null){if(z.length===0)return Promise.resolve(X);let H=z.length;const _=()=>{H=-1;for(const j of z)j.cancel?.()};return new Promise((j,F)=>{for(const D of z)D.then(R=>{--H>=0&&U(R)?(_(),j(R)):H===0&&j(X)}).catch(R=>{--H>=0&&(_(),F(R))})})}e.firstParallel=r;class o{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((X,H)=>{this.outstandingPromises.push({factory:U,c:X,e:H}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const X=U.factory();X.then(U.c,U.e),X.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class l extends o{constructor(){super(1)}}e.Queue=l;class p{constructor(){this.queues=new Map}queueFor(U,X=S.extUri){const H=X.getComparisonKey(U);let _=this.queues.get(H);return _||(_=new l,k.Event.once(_.onFinished)(()=>{_?.dispose(),this.queues.delete(H)}),this.queues.set(H,_)),_}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=p;class E{constructor(U,X){this._token=-1,typeof U=="function"&&typeof X=="number"&&this.setIfNotSet(U,X)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,X){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},X)}setIfNotSet(U,X){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},X))}}e.TimeoutTimer=E;class L{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,X){this.cancel(),this._token=setInterval(()=>{U()},X)}}e.IntervalTimer=L;class T{constructor(U,X){this.timeoutToken=-1,this.runner=U,this.timeout=X,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class W extends T{constructor(U,X){super(U,X);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=W;class C extends M.Disposable{constructor(U,X,H,_){super();this.maxWorkChunkSize=U,this.maxPendingWork=X,this.throttleDelay=H,this.handler=_,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.maxPendingWork)return!1}else if(this.pending+U.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new T(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=C,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const z=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=U=>{const X=setTimeout(()=>U(z));let H=!1;return{dispose(){H||(H=!0,clearTimeout(X))}}}}else e.runWhenIdle=(z,U)=>{const X=requestIdleCallback(z,typeof U=="number"?{timeout:U}:void 0);let H=!1;return{dispose(){H||(H=!0,cancelIdleCallback(X))}}}}();class V{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(X){this._error=X}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function x(z,U,X){let H;for(let _=0;_<X;_++)try{return await z()}catch(j){H=j,await a(U)}throw H}e.retry=x;class se{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,X,H){return this._pending={taskId:U,cancel:()=>H?.(),promise:X},X.then(()=>this.donePending(U),()=>this.donePending(U)),X}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let X,H;const _=new Promise((j,F)=>{X=j,H=F});this._next={run:U,promise:_,promiseResolve:X,promiseReject:H}}return this._next.promise}}e.TaskSequentializer=se;class G{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class Q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,X)=>{this.completeCallback=U,this.errorCallback=X})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(X=>{this.completeCallback(U),this.resolved=!0,X()})}error(U){return new Promise(X=>{this.errorCallback(U),this.rejected=!0,X()})}cancel(){new Promise(U=>{this.errorCallback((0,A.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=Q;var O;(function(z){async function U(X){let H;const _=await Promise.all(X.map(j=>j.then(F=>F,F=>{H||(H=F)})));if(typeof H!="undefined")throw H;return _}z.settled=U})(O=e.Promises||(e.Promises={}))}),define(J[111],Z([0,1,9,29,37,8,25]),function(q,e,w,A,k,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const f="**",m="/",t="[/\\\\]",b="[^/\\\\]",I=/\//g;function y(_){switch(_){case 0:return"";case 1:return`${b}*?`;default:return`(?:${t}|${b}+${t}|${t}${b}+)*?`}}function h(_,j){if(!_)return[];const F=[];let D=!1,R=!1,N="";for(const B of _){switch(B){case j:if(!D&&!R){F.push(N),N="";continue}break;case"{":D=!0;break;case"}":D=!1;break;case"[":R=!0;break;case"]":R=!1;break}N+=B}return N&&F.push(N),F}e.splitGlobAware=h;function g(_){if(!_)return"";let j="";const F=h(_,m);if(F.every(D=>D===f))j=".*";else{let D=!1;F.forEach((R,N)=>{if(R===f){D||(j+=y(2),D=!0);return}let B=!1,$="",Y=!1,ee="";for(const ie of R){if(ie!=="}"&&B){$+=ie;continue}if(Y&&(ie!=="]"||!ee)){let oe;ie==="-"?oe=ie:(ie==="^"||ie==="!")&&!ee?oe="^":ie===m?oe="":oe=S.escapeRegExpCharacters(ie),ee+=oe;continue}switch(ie){case"{":B=!0;continue;case"[":Y=!0;continue;case"}":j+=`(?:${h($,",").map(ne=>g(ne)).join("|")})`,B=!1,$="";break;case"]":j+="["+ee+"]",Y=!1,ee="";break;case"?":j+=b;continue;case"*":j+=y(1);continue;default:j+=S.escapeRegExpCharacters(ie)}}N<F.length-1&&(F[N+1]!==f||N+2<F.length)&&(j+=t),D=!1})}return j}const P=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new k.LRUCache(1e4),s=function(){return!1},r=function(){return null};function o(_,j){if(!_)return r;let F;typeof _!="string"?F=_.pattern:F=_,F=F.trim();const D=`${F}_${!!j.trimForExclusions}`;let R=i.get(D);if(R)return l(R,_);let N;if(P.test(F)){const B=F.substr(4);R=function($,Y){return typeof $=="string"&&$.endsWith(B)?F:null}}else(N=v.exec(p(F,j)))?R=E(N[1],F):(j.trimForExclusions?d:u).test(F)?R=L(F,j):(N=a.exec(p(F,j)))?R=T(N[1].substr(1),F,!0):(N=c.exec(p(F,j)))?R=T(N[1],F,!1):R=W(F);return i.set(D,R),l(R,_)}function l(_,j){return typeof j=="string"?_:function(F,D){return A.isEqualOrParent(F,j.base)?_(M.relative(j.base,F),D):null}}function p(_,j){return j.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function E(_,j){const F=`/${_}`,D=`\\${_}`,R=function(B,$){return typeof B!="string"?null:$?$===_?j:null:B===_||B.endsWith(F)||B.endsWith(D)?j:null},N=[_];return R.basenames=N,R.patterns=[j],R.allBasenames=N,R}function L(_,j){const F=H(_.slice(1,-1).split(",").map($=>o($,j)).filter($=>$!==r),_),D=F.length;if(!D)return r;if(D===1)return F[0];const R=function($,Y){for(let ee=0,ie=F.length;ee<ie;ee++)if(F[ee]($,Y))return _;return null},N=F.find($=>!!$.allBasenames);N&&(R.allBasenames=N.allBasenames);const B=F.reduce(($,Y)=>Y.allPaths?$.concat(Y.allPaths):$,[]);return B.length&&(R.allPaths=B),R}function T(_,j,F){const D=M.sep===M.posix.sep,R=D?_:_.replace(I,M.sep),N=M.sep+R,B=M.posix.sep+_,$=F?function(Y,ee){return typeof Y=="string"&&(Y===R||Y.endsWith(N)||!D&&(Y===_||Y.endsWith(B)))?j:null}:function(Y,ee){return typeof Y=="string"&&(Y===R||!D&&Y===_)?j:null};return $.allPaths=[(F?"*/":"./")+_],$}function W(_){try{const j=new RegExp(`^${g(_)}$`);return function(F){return j.lastIndex=0,typeof F=="string"&&j.test(F)?_:null}}catch(j){return r}}function C(_,j,F){return!_||typeof j!="string"?!1:V(_)(j,void 0,F)}e.match=C;function V(_,j={}){if(!_)return s;if(typeof _=="string"||Q(_)){const F=o(_,j);if(F===r)return s;const D=function(R,N){return!!F(R,N)};return F.allBasenames&&(D.allBasenames=F.allBasenames),F.allPaths&&(D.allPaths=F.allPaths),D}return U(_,j)}e.parse=V;function x(_){if(!_)return;let j;return F=>(j||(j=(_()||Promise.resolve([])).then(D=>D?G(D):{})),j.then(D=>!!D[F]))}e.hasSiblingPromiseFn=x;function se(_){if(!_)return;let j;return F=>{if(!j){const D=_();j=D?G(D):{}}return!!j[F]}}e.hasSiblingFn=se;function G(_){const j={};for(const F of _)j[F]=!0;return j}function Q(_){const j=_;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=Q;function O(_){return _.allBasenames||[]}e.getBasenameTerms=O;function z(_){return _.allPaths||[]}e.getPathTerms=z;function U(_,j){const F=H(Object.getOwnPropertyNames(_).map($=>X($,_[$],j)).filter($=>$!==r)),D=F.length;if(!D)return r;if(!F.some($=>!!$.requiresSiblings)){if(D===1)return F[0];const $=function(ie,oe){for(let ce=0,ne=F.length;ce<ne;ce++){const le=F[ce](ie,oe);if(le)return le}return null},Y=F.find(ie=>!!ie.allBasenames);Y&&($.allBasenames=Y.allBasenames);const ee=F.reduce((ie,oe)=>oe.allPaths?ie.concat(oe.allPaths):ie,[]);return ee.length&&($.allPaths=ee),$}const R=function($,Y,ee){let ie;for(let oe=0,ce=F.length;oe<ce;oe++){const ne=F[oe];ne.requiresSiblings&&ee&&(Y||(Y=M.basename($)),ie||(ie=Y.substr(0,Y.length-M.extname($).length)));const le=ne($,Y,ie,ee);if(le)return le}return null},N=F.find($=>!!$.allBasenames);N&&(R.allBasenames=N.allBasenames);const B=F.reduce(($,Y)=>Y.allPaths?$.concat(Y.allPaths):$,[]);return B.length&&(R.allPaths=B),R}function X(_,j,F){if(j===!1)return r;const D=o(_,F);if(D===r)return r;if(typeof j=="boolean")return D;if(j){const R=j.when;if(typeof R=="string"){const N=(B,$,Y,ee)=>{if(!ee||!D(B,$))return null;const ie=R.replace("$(basename)",Y),oe=ee(ie);return(0,w.isThenable)(oe)?oe.then(ce=>ce?_:null):oe?_:null};return N.requiresSiblings=!0,N}}return D}function H(_,j){const F=_.filter($=>!!$.basenames);if(F.length<2)return _;const D=F.reduce(($,Y)=>{const ee=Y.basenames;return ee?$.concat(ee):$},[]);let R;if(j){R=[];for(let $=0,Y=D.length;$<Y;$++)R.push(j)}else R=F.reduce(($,Y)=>{const ee=Y.patterns;return ee?$.concat(ee):$},[]);const N=function($,Y){if(typeof $!="string")return null;if(!Y){let ie;for(ie=$.length;ie>0;ie--){const oe=$.charCodeAt(ie-1);if(oe===47||oe===92)break}Y=$.substr(ie)}const ee=D.indexOf(Y);return ee!==-1?R[ee]:null};N.basenames=D,N.patterns=R,N.allBasenames=D;const B=_.filter($=>!$.basenames);return B.push(N),B}}),define(J[32],Z([0,1,29,10,8,3,15,25,7]),function(q,e,w,A,k,M,S,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function m(o,l,p){if(typeof o=="string"&&(o=f.URI.file(o)),p){const L=p.getWorkspaceFolder(o);if(L){const T=p.getWorkspace().folders.length>1;let W;if((0,S.isEqual)(L.uri,o)?W="":W=(0,S.relativePath)(L.uri,o),T){const C=L.name?L.name:(0,S.basename)(L.uri);W=W?C+" \u2022 "+W:C}return W}}if(o.scheme!==A.Schemas.file&&o.scheme!==A.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,w.hasDriveLetter)(o.fsPath))return(0,k.normalize)(b(o.fsPath));let E=(0,k.normalize)(o.fsPath);return!M.isWindows&&l?.userHome&&(E=y(E,l.userHome.fsPath)),E}e.getPathLabel=m;function t(o){if(!o)return;typeof o=="string"&&(o=f.URI.file(o));const l=(0,S.basename)(o)||(o.scheme===A.Schemas.file?o.fsPath:o.path);return M.isWindows&&(0,w.isRootOrDriveLetter)(l)?b(l):l}e.getBaseLabel=t;function b(o){return(0,w.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=b;let I=Object.create(null);function y(o,l){if(M.isWindows||!o||!l)return o;let p=I.original===l?I.normalized:void 0;return p||(p=`${(0,n.rtrim)(l,k.posix.sep)}${k.posix.sep}`,I={original:l,normalized:p}),(M.isLinux?o.startsWith(p):(0,n.startsWithIgnoreCase)(o,p))&&(o=`~/${o.substr(p.length)}`),o}e.tildify=y;function h(o,l){return o.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=h;const g="\u2026",P="\\\\",v="~";function u(o,l=k.sep){const p=new Array(o.length);let E=!1;for(let L=0;L<o.length;L++){let T=o[L];if(T===""){p[L]=`.${l}`;continue}if(!T){p[L]=T;continue}E=!0;let W="";T.indexOf(P)===0?(W=T.substr(0,T.indexOf(P)+P.length),T=T.substr(T.indexOf(P)+P.length)):T.indexOf(l)===0?(W=T.substr(0,T.indexOf(l)+l.length),T=T.substr(T.indexOf(l)+l.length)):T.indexOf(v)===0&&(W=T.substr(0,T.indexOf(v)+v.length),T=T.substr(T.indexOf(v)+v.length));const C=T.split(l);for(let V=1;E&&V<=C.length;V++)for(let x=C.length-V;E&&x>=0;x--){E=!1;let se=C.slice(x,x+V).join(l);for(let G=0;!E&&G<o.length;G++)if(G!==L&&o[G]&&o[G].indexOf(se)>-1){const Q=x+V===C.length,O=x>0&&o[G].indexOf(l)>-1?l+se:se,z=o[G].endsWith(O);E=!Q||z}if(!E){let G="";(C[0].endsWith(":")||W!=="")&&(x===1&&(x=0,V++,se=C[0]+l+se),x>0&&(G=C[0]+l),G=W+G),x>0&&(G=G+g+l),G=G+se,x+V<C.length&&(G=G+l+g),p[L]=G}}E&&(p[L]=T)}return p}e.shorten=u;var d;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function a(o,l=Object.create(null)){const p=[];let E=!1,L="";for(const T of o)if(T==="$"||E&&T==="{")L&&p.push({value:L,type:d.TEXT}),L="",E=!0;else if(T==="}"&&E){const W=l[L];if(typeof W=="string")W.length&&p.push({value:W,type:d.VARIABLE});else if(W){const C=p[p.length-1];(!C||C.type!==d.SEPARATOR)&&p.push({value:W.label,type:d.SEPARATOR})}L="",E=!1}else L+=T;return L&&!E&&p.push({value:L,type:d.TEXT}),p.filter((T,W)=>{if(T.type===d.SEPARATOR){const C=p[W-1],V=p[W+1];return[C,V].every(x=>x&&(x.type===d.VARIABLE||x.type===d.TEXT)&&x.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=a;function c(o,l){return M.isMacintosh||l?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):o.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function i(o,l){return M.isMacintosh||l?o.replace(/\(&&\w\)|&&/g,""):M.isWindows?o.replace(/&&|&/g,p=>p==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function s(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(o){const l=o.indexOf("/")!==-1?k.posix:k.win32,p=l.basename(o),E=l.dirname(o);return p.length?{name:p,parentPath:E}:{name:E,parentPath:""}}e.splitName=r}),define(J[28],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(f){return w.test(f)}e.isUUID=A;const k=new Uint8Array(16),M=[];for(let f=0;f<256;f++)M.push(f.toString(16).padStart(2,"0"));let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(f){for(let m=0;m<f.length;m++)f[m]=Math.floor(Math.random()*256);return f};function n(){S(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let f=0,m="";return m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m+="-",m+=M[k[f++]],m+=M[k[f++]],m+="-",m+=M[k[f++]],m+=M[k[f++]],m+="-",m+=M[k[f++]],m+=M[k[f++]],m+="-",m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m+=M[k[f++]],m}e.generateUuid=n}),define(J[112],Z([0,1,58,30,43]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(S,n){if(await new Promise((t,b)=>{const I=A.createReadStream(S),y=w.createHash("sha1");I.pipe(y);const h=(0,k.once)((g,P)=>{I.removeAllListeners(),y.removeAllListeners(),g?b(g):t(P)});I.once("error",h),I.once("end",h),y.once("error",h),y.once("data",g=>h(void 0,g.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=M}),define(J[79],Z([0,1,239]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class A{constructor(M="utf8"){this.stringDecoder=new w.StringDecoder(M),this.remaining=null}write(M){const S=[],n=this.remaining?this.remaining+this.stringDecoder.write(M):this.stringDecoder.write(M);if(n.length<1)return S;let f=0,m,t=f;for(;t<n.length;)if(m=n.charCodeAt(t),m===13||m===10){if(S.push(n.substring(f,t)),t++,t<n.length){const b=m;m=n.charCodeAt(t),(b===13&&m===10||b===10&&m===13)&&t++}f=t}else t++;return this.remaining=f<n.length?n.substr(f):null,S}end(){return this.remaining}}e.LineDecoder=A}),define(J[113],Z([0,1,26]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(n){const f=n.replace(/\-/g,":").toLowerCase();return!A.has(f)}function M(){return new Promise(async(n,f)=>{const m=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await S())}catch(t){f(t)}finally{clearTimeout(m)}})}e.getMac=M;function S(){return new Promise((n,f)=>{try{const m=(0,w.networkInterfaces)();for(let t in m){const b=m[t];if(b){for(const{mac:I}of b)if(k(I))return n(I)}}f("Unable to retrieve mac address (unexpected format)")}catch(m){f(m)}})}}),define(J[66],Z([0,1,26,16,37,28,113]),function(q,e,w,A,k,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(t){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(t)}value(){if(this._value===void 0){let t=0,b=0;const I=(0,w.networkInterfaces)();for(let y in I){const h=I[y];if(h)for(const{mac:g,internal:P}of h)P||(b+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(t+=1))}this._value=b>0?t/b:0}return this._value}};let n;async function f(){return n||(n=(async()=>await m()||M.generateUuid())()),n}e.getMachineId=f;async function m(){try{const t=await new Promise((I,y)=>{q(["crypto"],I,y)}),b=await(0,S.getMac)();return t.createHash("sha256").update(b,"utf8").digest("hex")}catch(t){A.onUnexpectedError(t);return}}}),define(J[18],Z([0,1,30,26,114,9,29,65,8,3,15,7,28]),function(q,e,w,A,k,M,S,n,f,m,t,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function h(O,z=y.UNLINK){if((0,S.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return z===y.UNLINK?P(O):g(O)}async function g(O){try{const z=(0,f.join)((0,A.tmpdir)(),(0,I.generateUuid)());try{await e.Promises.rename(O,z)}catch(U){return P(O)}P(z).catch(U=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function P(O){return e.Promises.rmdir(O,{recursive:!0,maxRetries:3})}function v(O){if((0,S.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");w.rmdirSync(O,{recursive:!0})}e.rimrafSync=v;async function u(O,z){return c(await(z?d(O):(0,k.promisify)(w.readdir)(O)))}async function d(O){try{return await(0,k.promisify)(w.readdir)(O,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const z=[],U=await u(O);for(const X of U){let H=!1,_=!1,j=!1;try{const F=await e.Promises.lstat((0,f.join)(O,X));H=F.isFile(),_=F.isDirectory(),j=F.isSymbolicLink()}catch(F){console.warn("[node.js fs] unexpected error from lstat after readdir: ",F)}z.push({name:X,isFile:()=>H,isDirectory:()=>_,isSymbolicLink:()=>j})}return z}function a(O){return c(w.readdirSync(O))}e.readdirSync=a;function c(O){return O.map(z=>typeof z=="string"?m.isMacintosh?(0,n.normalizeNFC)(z):z:(z.name=m.isMacintosh?(0,n.normalizeNFC)(z.name):z.name,z))}async function i(O){const z=await u(O),U=[];for(const X of z)await r.existsDirectory((0,f.join)(O,X))&&U.push(X);return U}function s(O,z=1e3){return new Promise(U=>{let X=!1;const H=setInterval(()=>{X||(X=!0,w.access(O,_=>{X=!1,_&&(clearInterval(H),U(void 0))}))},z)})}e.whenDeleted=s;var r;(function(O){async function z(H){let _;try{if(_=await e.Promises.lstat(H),!_.isSymbolicLink())return{stat:_}}catch(j){}try{return{stat:await e.Promises.stat(H),symbolicLink:_?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};if(m.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(F){if(F.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};throw F}throw j}}O.stat=z;async function U(H){try{const{stat:_,symbolicLink:j}=await O.stat(H);return _.isFile()&&j?.dangling!==!0}catch(_){}return!1}O.existsFile=U;async function X(H){try{const{stat:_,symbolicLink:j}=await O.stat(H);return _.isDirectory()&&j?.dangling!==!0}catch(_){}return!1}O.existsDirectory=X})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new M.ResourceQueue;function l(O,z,U){return o.queueFor(b.URI.file(O),t.extUriBiasedIgnorePathCase).queue(()=>{const X=T(U);return new Promise((H,_)=>E(O,z,X,j=>j?_(j):H()))})}let p=!0;function E(O,z,U,X){if(!p)return w.writeFile(O,z,{mode:U.mode,flag:U.flag},X);w.open(O,U.flag,U.mode,(H,_)=>{if(H)return X(H);w.writeFile(_,z,j=>{if(j)return w.close(_,()=>X(j));w.fdatasync(_,F=>(F&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",F),p=!1),w.close(_,D=>X(D))))})})}function L(O,z,U){const X=T(U);if(!p)return w.writeFileSync(O,z,{mode:X.mode,flag:X.flag});const H=w.openSync(O,X.flag,X.mode);try{w.writeFileSync(H,z);try{w.fdatasyncSync(H)}catch(_){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",_),p=!1}}finally{w.closeSync(H)}}e.writeFileSync=L;function T(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function W(O,z){if(O===z)return;async function U(X){try{const H=await e.Promises.lstat(X);if(H.isDirectory()||H.isSymbolicLink())return;await e.Promises.utimes(X,H.atime,new Date)}catch(H){}}try{await e.Promises.rename(O,z),await U(z)}catch(X){if(O.toLowerCase()!==z.toLowerCase()&&X.code==="EXDEV"||O.endsWith("."))await C(O,z,{preserveSymlinks:!1}),await h(O,y.MOVE),await U(z);else throw X}}async function C(O,z,U){return x(O,z,{root:{source:O,target:z},options:U,handledSourcePaths:new Set})}const V=511;async function x(O,z,U){if(U.handledSourcePaths.has(O))return;U.handledSourcePaths.add(O);const{stat:X,symbolicLink:H}=await r.stat(O);if(H){if(U.options.preserveSymlinks)try{return await Q(O,z,U)}catch(_){console.warn("[node.js fs] copy of symlink failed: ",_)}if(H.dangling)return}return X.isDirectory()?se(O,z,X.mode&V,U):G(O,z,X.mode&V)}async function se(O,z,U,X){await e.Promises.mkdir(z,{recursive:!0,mode:U});const H=await u(O);for(const _ of H)await x((0,f.join)(O,_),(0,f.join)(z,_),X)}async function G(O,z,U){await e.Promises.copyFile(O,z),await e.Promises.chmod(z,U)}async function Q(O,z,U){let X=await e.Promises.readlink(O);(0,S.isEqualOrParent)(X,U.root.source,!m.isLinux)&&(X=(0,f.join)(U.root.target,X.substr(U.root.source.length+1))),await e.Promises.symlink(X,z)}e.Promises=new class{get access(){return(0,k.promisify)(w.access)}get stat(){return(0,k.promisify)(w.stat)}get lstat(){return(0,k.promisify)(w.lstat)}get utimes(){return(0,k.promisify)(w.utimes)}get read(){return(0,k.promisify)(w.read)}get readFile(){return(0,k.promisify)(w.readFile)}get write(){return(0,k.promisify)(w.write)}get appendFile(){return(0,k.promisify)(w.appendFile)}get fdatasync(){return(0,k.promisify)(w.fdatasync)}get truncate(){return(0,k.promisify)(w.truncate)}get rename(){return(0,k.promisify)(w.rename)}get copyFile(){return(0,k.promisify)(w.copyFile)}get open(){return(0,k.promisify)(w.open)}get close(){return(0,k.promisify)(w.close)}get symlink(){return(0,k.promisify)(w.symlink)}get readlink(){return(0,k.promisify)(w.readlink)}get chmod(){return(0,k.promisify)(w.chmod)}get mkdir(){return(0,k.promisify)(w.mkdir)}get unlink(){return(0,k.promisify)(w.unlink)}get rmdir(){return(0,k.promisify)(w.rmdir)}get realpath(){return(0,k.promisify)(w.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return i}get writeFile(){return l}get rm(){return h}get move(){return W}get copy(){return C}}}),define(J[80],Z([0,1,30,8,25,18]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function S(t){const b=(0,A.dirname)(t);if(t===b)return t;const I=((0,A.basename)(t)||t).toLowerCase();try{const h=(0,M.readdirSync)(b).filter(g=>g.toLowerCase()===I);if(h.length===1){const g=S(b);if(g)return(0,A.join)(g,h[0])}else if(h.length>1){const g=h.indexOf(I);if(g>=0){const P=S(b);if(P)return(0,A.join)(P,h[g])}}}catch(y){}return null}e.realcaseSync=S;async function n(t){try{return await M.Promises.realpath(t)}catch(b){const I=m(t);return await M.Promises.access(I,w.constants.R_OK),I}}e.realpath=n;function f(t){try{return w.realpathSync(t)}catch(b){const I=m(t);return w.accessSync(I,w.constants.R_OK),I}}e.realpathSync=f;function m(t){return(0,k.rtrim)((0,A.normalize)(t),A.sep)}}),define(J[115],Z([0,1,59]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function A(n,f,m,t=1){let b=!1;return new Promise(I=>{const y=setTimeout(()=>{if(!b)return b=!0,I(0)},m);k(n,f,t,h=>{if(!b)return b=!0,clearTimeout(y),I(h)})})}e.findFreePort=A;function k(n,f,m,t){if(f===0)return t(0);const b=new w.Socket;b.once("connect",()=>(S(b),k(n+m,f-1,m,t))),b.once("data",()=>{}),b.once("error",I=>(S(b),I.code!=="ECONNREFUSED"?k(n+m,f-1,m,t):t(n))),b.connect(n,"127.0.0.1")}function M(n,f,m){let t=!1,b,I=1;const y=w.createServer({pauseOnConnect:!0});function h(g,P){t||(t=!0,y.removeAllListeners(),y.close(),b&&clearTimeout(b),P(g))}return new Promise(g=>{b=setTimeout(()=>{h(0,g)},m),y.on("listening",()=>{h(n,g)}),y.on("error",P=>{P&&(P.code==="EADDRINUSE"||P.code==="EACCES")&&I<f?(n++,I++,y.listen(n,"127.0.0.1")):h(0,g)}),y.on("close",()=>{h(0,g)}),y.listen(n,"127.0.0.1")})}e.findFreePortFaster=M;function S(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(f){console.error(f)}}}),define(J[116],Z([0,1,26,8,18]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,S=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var f;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(f||(f={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let t;process.env.PROCESSOR_ARCHITEW6432?t=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?t=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?t=1:t=0;class b{constructor(c,i,s){this.exePath=c,this.displayName=i,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function I({useAlternateBitness:a=!1}={}){return a?m===0?process.env["ProgramFiles(x86)"]||null:t===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:a=!1,findPreview:c=!1}={}){const i=I({useAlternateBitness:a});if(!i)return null;const s=A.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(s))return null;let r=-1,o=null;for(const E of await k.Promises.readdir(s)){let L=-1;if(c){const W=E.indexOf("-");if(W<0)continue;const C=E.substring(0,W);if(!M.test(C)||E.substring(W+1)!=="preview")continue;L=parseInt(C,10)}else{if(!M.test(E))continue;L=parseInt(E,10)}if(L<=r)continue;const T=A.join(s,E,"pwsh.exe");!await k.SymlinkSupport.existsFile(T)||(o=T,r=L)}if(!o)return null;const l=i.includes("x86")?" (x86)":"",p=c?" Preview":"";return new b(o,`PowerShell${p}${l}`,!0)}async function h({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const c=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:i,pwshMsixName:s}=a?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:S,pwshMsixName:"PowerShell (Store)"};for(const r of await k.Promises.readdir(c))if(i.test(r)){const o=A.join(c,r,"pwsh.exe");return new b(o,s)}return null}function g(){const a=A.join(w.homedir(),".dotnet","tools","pwsh.exe");return new b(a,".NET Core PowerShell Global Tool")}function P(){const a=A.join(process.env.windir,m===1&&t!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(a,"Windows PowerShell",!0)}async function*v(){let a=await y();a&&(yield a),a=await y({useAlternateBitness:!0}),a&&(yield a),a=await h(),a&&(yield a),a=g(),a&&(yield a),a=await y({findPreview:!0}),a&&(yield a),a=await h({findPreview:!0}),a&&(yield a),a=await y({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=P(),a&&(yield a)}async function*u(){for await(const a of v())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=u;async function d(){for await(const a of u())return a;return null}e.getFirstAvailablePowerShellInstallation=d}),define(J[81],Z([0,1,41,10]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(S){return new Promise((n,f)=>{let m;const t=new Map;function b(y,h,g,P,v){const u=t.get(h);if(y===S||u){const d={name:I(g),cmd:g,pid:y,ppid:h,load:P,mem:v};t.set(y,d),y===S&&(m=d),u&&(u.children||(u.children=[]),u.children.push(d),u.children.length>1&&(u.children=u.children.sort((a,c)=>a.pid-c.pid)))}}function I(y){const h=/--disable-blink-features=Auxclick/,g=/\\watcher\\win32\\CodeHelper\.exe/,P=/--crashes-directory/,v=/\\pipe\\winpty-control/,u=/conhost\.exe/,d=/--type=([a-zA-Z-]+)/;if(g.exec(y))return"watcherService ";if(P.exec(y))return"electron-crash-reporter";if(v.exec(y))return"winpty-process";if(u.exec(y))return"console-window-host (Windows internal process)";let a=d.exec(y);if(a&&a.length===2)return a[1]==="renderer"?h.exec(y)?"shared-process":"window":a[1];const c=/[a-zA-Z-]+\.js/g;let i="";do a=c.exec(y),a&&(i+=a+" ");while(a);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,g)=>{q(["windows-process-tree"],h,g)}).then(h=>{h.getProcessList(S,g=>{h.getProcessCpuUsage(g,P=>{const v=new Map;P.forEach(u=>{const d=y(u.commandLine||"");v.set(u.pid,{name:I(d),cmd:d,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),m=v.get(S),m?(v.forEach(u=>{const d=v.get(u.ppid);d&&(d.children||(d.children=[]),d.children.push(u))}),v.forEach(u=>{u.children&&(u.children=u.children.sort((d,a)=>d.pid-a.pid))}),n(m)):f(new Error(`Root process ${S} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let y=function(){let h=[m];const g=[];for(;h.length;){const v=h.shift();v&&(g.push(v.pid),v.children&&(h=h.concat(v.children)))}let P=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",q).fsPath);P+=" "+g.join(" "),(0,w.exec)(P,{},(v,u,d)=>{if(v||d)f(v||new Error(d.toString()));else{const a=u.toString().split(`
`);for(let c=0;c<g.length;c++){const i=t.get(g[c]);i.load=parseFloat(a[c])}if(!m){f(new Error(`Root process ${S} not found`));return}n(m)}})};(0,w.exec)("which ps",{},(h,g,P)=>{if(h||P)if(process.platform!=="linux")f(h||new Error(P.toString()));else{const v=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh",q).fsPath);(0,w.exec)(v,{},(u,d,a)=>{u||a?f(u||new Error(a.toString())):(M(d,b),y())})}else{const v=g.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${v} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,a,c)=>{d||c&&!c.includes("screen size is bogus")?f(d||new Error(c.toString())):(M(a,b),process.platform==="linux"?y():m?n(m):f(new Error(`Root process ${S} not found`)))})}})}})}e.listProcesses=k;function M(S,n){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=S.toString().split(`
`);for(const t of m){const b=f.exec(t.trim());b&&b.length===6&&n(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(J[117],Z([0,1,30,29,2,65,8,3,18]),function(q,e,w,A,k,M,S,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function m(I,y,h){return b({path:I,isDirectory:!1},y,h)}e.watchFile=m;function t(I,y,h){return b({path:I,isDirectory:!0},y,h)}e.watchFolder=t,e.CHANGE_BUFFER_DELAY=100;function b(I,y,h){if(n.isMacintosh&&(0,A.isEqualOrParent)(I.path,"/Volumes/"))return h(`Refusing to watch ${I.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const g=(0,S.basename)(I.path),P=new Map;let v=!1,u=[(0,k.toDisposable)(()=>{P.forEach(d=>(0,k.dispose)(d)),P.clear()})];try{const d=(0,w.watch)(I.path);u.push((0,k.toDisposable)(()=>{d.removeAllListeners(),d.close()}));const a=new Set;I.isDirectory&&f.Promises.readdir(I.path).then(c=>c.forEach(i=>a.add(i))),d.on("error",(c,i)=>{v||h(`Failed to watch ${I.path} for changes using fs.watch() (${c}, ${i})`)}),d.on("change",(c,i)=>{if(v)return;let s="";if(i&&(s=i.toString(),n.isMacintosh&&(s=(0,M.normalizeNFC)(s))),!s||c!=="change"&&c!=="rename")return;const r=I.isDirectory?(0,S.join)(I.path,s):I.path;if(I.isDirectory)if(c==="rename"){const o=P.get(r);o&&(0,k.dispose)(o);const l=setTimeout(async()=>{P.delete(r);const p=await f.Promises.exists(r);if(v)return;let E;p?a.has(s)?E="changed":(E="added",a.add(s)):(a.delete(s),E="deleted"),y(E,r)},e.CHANGE_BUFFER_DELAY);P.set(r,(0,k.toDisposable)(()=>clearTimeout(l)))}else{let o;a.has(s)?o="changed":(o="added",a.add(s)),y(o,r)}else if(c==="rename"||s!==g){const o=setTimeout(async()=>{const l=await f.Promises.exists(r);v||(l?(y("changed",r),u=[b(I,y,h)]):y("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(u),u=[(0,k.toDisposable)(()=>clearTimeout(o))]}else y("changed",r)})}catch(d){f.Promises.exists(I.path).then(a=>{a&&!v&&h(`Failed to watch ${I.path} for changes using fs.watch() (${d.toString()})`)})}return(0,k.toDisposable)(()=>{v=!0,u=(0,k.dispose)(u)})}}),define(J[118],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[119],Z([0,1,14,13,118]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){w.ipcMain.on(k.CONTEXT_MENU_CHANNEL,(n,f,m,t,b)=>{const I=S(n,t,m);I.popup({window:(0,A.withNullAsUndefined)(w.BrowserWindow.fromWebContents(n.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{I&&n.sender.send(k.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=M;function S(n,f,m){const t=new w.Menu;return m.forEach(b=>{let I;b.type==="separator"?I=new w.MenuItem({type:b.type}):Array.isArray(b.submenu)?I=new w.MenuItem({submenu:S(n,f,b.submenu),label:b.label}):I=new w.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(y,h,g)=>n.sender.send(f,b.id,g)}),t.append(I)}),t}});var ue=this&&this.__decorate||function(q,e,w,A){var k=arguments.length,M=k<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,w):A,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(q,e,w,A);else for(var n=q.length-1;n>=0;n--)(S=q[n])&&(M=(k<3?S(M):k>3?S(e,w,M):S(e,w))||M);return k>3&&M&&Object.defineProperty(e,w,M),M};define(J[35],Z([0,1,34,9,17,24,46,16,5,2,110,25,13]),function(q,e,w,A,k,M,S,n,f,m,t,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function h(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function P(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(v||(v={}));class u{constructor(_){this.buffer=_,this.pos=0}read(_){const j=this.buffer.slice(this.pos,this.pos+_);return this.pos+=j.byteLength,j}}class d{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}var a;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(a||(a={}));function c(H){const _=k.VSBuffer.alloc(4);return _.writeUInt32BE(H,0),_}function i(H){return H.read(4).readUInt32BE(0)}function s(H){const _=k.VSBuffer.alloc(1);return _.writeUInt8(H,0),_}const r={Undefined:s(a.Undefined),String:s(a.String),Buffer:s(a.Buffer),VSBuffer:s(a.VSBuffer),Array:s(a.Array),Object:s(a.Object)},o=typeof Buffer!="undefined";function l(H,_){if(typeof _=="undefined")H.write(r.Undefined);else if(typeof _=="string"){const j=k.VSBuffer.fromString(_);H.write(r.String),H.write(c(j.byteLength)),H.write(j)}else if(o&&Buffer.isBuffer(_)){const j=k.VSBuffer.wrap(_);H.write(r.Buffer),H.write(c(j.byteLength)),H.write(j)}else if(_ instanceof k.VSBuffer)H.write(r.VSBuffer),H.write(c(_.byteLength)),H.write(_);else if(Array.isArray(_)){H.write(r.Array),H.write(c(_.length));for(const j of _)l(H,j)}else{const j=k.VSBuffer.fromString(JSON.stringify(_));H.write(r.Object),H.write(c(j.byteLength)),H.write(j)}}function p(H){switch(H.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return H.read(i(H)).toString();case a.Buffer:return H.read(i(H)).buffer;case a.VSBuffer:return H.read(i(H));case a.Array:{const j=i(H),F=[];for(let D=0;D<j;D++)F.push(p(H));return F}case a.Object:return JSON.parse(H.read(i(H)).toString())}}class E{constructor(_,j,F=null,D=1e3){this.protocol=_,this.ctx=j,this.logger=F,this.timeoutDelay=D,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(R=>this.onRawMessage(R)),this.sendResponse({type:200})}registerChannel(_,j){this.channels.set(_,j),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case 200:{const j=this.send([_.type]);this.logger&&this.logger.logOutgoing(j,0,1,P(_.type));return}case 201:case 202:case 204:case 203:{const j=this.send([_.type,_.id],_.data);this.logger&&this.logger.logOutgoing(j,_.id,1,P(_.type),_.data);return}}}send(_,j=void 0){const F=new d;return l(F,_),l(F,j),this.sendBuffer(F.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(j){return 0}}onRawMessage(_){const j=new u(_),F=p(j),D=p(j),R=F[0];switch(R){case 100:return this.logger&&this.logger.logIncoming(_.byteLength,F[1],1,`${h(R)}: ${F[2]}.${F[3]}`,D),this.onPromise({type:R,id:F[1],channelName:F[2],name:F[3],arg:D});case 102:return this.logger&&this.logger.logIncoming(_.byteLength,F[1],1,`${h(R)}: ${F[2]}.${F[3]}`,D),this.onEventListen({type:R,id:F[1],channelName:F[2],name:F[3],arg:D});case 101:return this.logger&&this.logger.logIncoming(_.byteLength,F[1],1,`${h(R)}`),this.disposeActiveRequest({type:R,id:F[1]});case 103:return this.logger&&this.logger.logIncoming(_.byteLength,F[1],1,`${h(R)}`),this.disposeActiveRequest({type:R,id:F[1]})}}onPromise(_){const j=this.channels.get(_.channelName);if(!j){this.collectPendingRequest(_);return}const F=new M.CancellationTokenSource;let D;try{D=j.call(this.ctx,_.name,_.arg,F.token)}catch(B){D=Promise.reject(B)}const R=_.id;D.then(B=>{this.sendResponse({id:R,data:B,type:201}),this.activeRequests.delete(_.id)},B=>{B instanceof Error?this.sendResponse({id:R,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.sendResponse({id:R,data:B,type:203}),this.activeRequests.delete(_.id)});const N=(0,m.toDisposable)(()=>F.cancel());this.activeRequests.set(_.id,N)}onEventListen(_){const j=this.channels.get(_.channelName);if(!j){this.collectPendingRequest(_);return}const F=_.id,R=j.listen(this.ctx,_.name,_.arg)(N=>this.sendResponse({id:F,data:N,type:204}));this.activeRequests.set(_.id,R)}disposeActiveRequest(_){const j=this.activeRequests.get(_.id);j&&(j.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let j=this.pendingRequests.get(_.channelName);j||(j=[],this.pendingRequests.set(_.channelName,j));const F=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:_,timeoutTimer:F})}flushPendingRequests(_){const j=this.pendingRequests.get(_);if(j){for(const F of j)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}e.ChannelServer=E;var L;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(L=e.RequestInitiator||(e.RequestInitiator={}));class T{constructor(_,j=null){this.protocol=_,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=j}getChannel(_){const j=this;return{call(F,D,R){return j.isDisposed?Promise.reject(n.canceled()):j.requestPromise(_,F,D,R)},listen(F,D){return j.isDisposed?Promise.reject(n.canceled()):j.requestEvent(_,F,D)}}}requestPromise(_,j,F,D=M.CancellationToken.None){const R=this.lastRequestId++,B={id:R,type:100,channelName:_,name:j,arg:F};if(D.isCancellationRequested)return Promise.reject(n.canceled());let $;return new Promise((ee,ie)=>{if(D.isCancellationRequested)return ie(n.canceled());const oe=()=>{const ve=fe=>{switch(fe.type){case 201:this.handlers.delete(R),ee(fe.data);break;case 202:this.handlers.delete(R);const we=new Error(fe.data.message);we.stack=fe.data.stack,we.name=fe.data.name,ie(we);break;case 203:this.handlers.delete(R),ie(fe.data);break}};this.handlers.set(R,ve),this.sendRequest(B)};let ce=null;this.state===v.Idle?oe():(ce=(0,A.createCancelablePromise)(ve=>this.whenInitialized()),ce.then(()=>{ce=null,oe()}));const ne=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:R,type:101}),ie(n.canceled())},le=D.onCancellationRequested(ne);$=(0,m.combinedDisposable)((0,m.toDisposable)(ne),le),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(_,j,F){const D=this.lastRequestId++,N={id:D,type:102,channelName:_,name:j,arg:F};let B=null;const $=new f.Emitter({onFirstListenerAdd:()=>{B=(0,A.createCancelablePromise)(ee=>this.whenInitialized()),B.then(()=>{B=null,this.activeRequests.add($),this.sendRequest(N)})},onLastListenerRemove:()=>{B?(B.cancel(),B=null):(this.activeRequests.delete($),this.sendRequest({id:D,type:103}))}}),Y=ee=>$.fire(ee.data);return this.handlers.set(D,Y),$.event}sendRequest(_){switch(_.type){case 100:case 102:{const j=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger&&this.logger.logOutgoing(j,_.id,0,`${h(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const j=this.send([_.type,_.id]);this.logger&&this.logger.logOutgoing(j,_.id,0,h(_.type));return}}}send(_,j=void 0){const F=new d;return l(F,_),l(F,j),this.sendBuffer(F.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(j){return 0}}onBuffer(_){const j=new u(_),F=p(j),D=p(j),R=F[0];switch(R){case 200:return this.logger&&this.logger.logIncoming(_.byteLength,0,0,P(R)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(_.byteLength,F[1],0,P(R),D),this.onResponse({type:F[0],id:F[1],data:D})}}onResponse(_){if(_.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(_.id);j&&j(_)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}ue([S.memoize],T.prototype,"onDidInitializePromise",null),e.ChannelClient=T;class W{constructor(_){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,_(({protocol:j,onDidClientDisconnect:F})=>{f.Event.once(j.onMessage)(R=>{const N=new u(R),B=p(N),$=new E(j,B),Y=new T(j);this.channels.forEach((ie,oe)=>$.registerChannel(oe,ie));const ee={channelServer:$,channelClient:Y,ctx:B};this._connections.add(ee),this._onDidAddConnection.fire(ee),F(()=>{$.dispose(),Y.dispose(),this._connections.delete(ee),this._onDidRemoveConnection.fire(ee)})})})}get connections(){const _=[];return this._connections.forEach(j=>_.push(j)),_}getChannel(_,j){const F=this;return{call(D,R,N){let B;if((0,I.isFunction)(j)){let Y=(0,w.getRandomElement)(F.connections.filter(j));B=Y?Promise.resolve(Y):f.Event.toPromise(f.Event.filter(F.onDidAddConnection,j))}else B=j.routeCall(F,D,R);const $=B.then(Y=>Y.channelClient.getChannel(_));return V($).call(D,R,N)},listen(D,R){if((0,I.isFunction)(j))return F.getMulticastEvent(_,j,D,R);const N=j.routeEvent(F,D,R).then(B=>B.channelClient.getChannel(_));return V(N).listen(D,R)}}}getMulticastEvent(_,j,F,D){const R=this;let N=new m.DisposableStore;const B=new f.Emitter({onFirstListenerAdd:()=>{N=new m.DisposableStore;const $=new f.EventMultiplexer,Y=new Map,ee=oe=>{const ne=oe.channelClient.getChannel(_).listen(F,D),le=$.add(ne);Y.set(oe,le)},ie=oe=>{const ce=Y.get(oe);!ce||(ce.dispose(),Y.delete(oe))};R.connections.filter(j).forEach(ee),f.Event.filter(R.onDidAddConnection,j)(ee,void 0,N),R.onDidRemoveConnection(ie,void 0,N),$.event(B.fire,B,N),N.add($)},onLastListenerRemove:()=>{N.dispose()}});return B.event}registerChannel(_,j){this.channels.set(_,j),this._connections.forEach(F=>{F.channelServer.registerChannel(_,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=W;class C{constructor(_,j,F=null){const D=new d;l(D,j),_.send(D.buffer),this.channelClient=new T(_,F),this.channelServer=new E(_,j,F)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,j){this.channelServer.registerChannel(_,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=C;function V(H){return{call(_,j,F){return H.then(D=>D.call(_,j,F))},listen(_,j){const F=new f.Relay;return H.then(D=>F.input=D.listen(_,j)),F.event}}}e.getDelayedChannel=V;function x(H){let _=!1;return{call(j,F,D){return _?H.call(j,F,D):(0,A.timeout)(0).then(()=>_=!0).then(()=>H.call(j,F,D))},listen(j,F){if(_)return H.listen(j,F);const D=new f.Relay;return(0,A.timeout)(0).then(()=>_=!0).then(()=>D.input=H.listen(j,F)),D.event}}}e.getNextTickChannel=x;class se{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const j of _.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await f.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=se;var G;(function(H){function _(D,R){const N=D,B=R&&R.disableMarshalling,$=new Map;for(const Y in N)F(Y)&&$.set(Y,f.Event.buffer(N[Y],!0));return new class{listen(Y,ee){const ie=$.get(ee);if(ie)return ie;throw new Error(`Event not found: ${ee}`)}call(Y,ee,ie){const oe=N[ee];if(typeof oe=="function"){if(!B&&Array.isArray(ie))for(let ce=0;ce<ie.length;ce++)ie[ce]=(0,t.revive)(ie[ce]);return oe.apply(N,ie)}throw new Error(`Method not found: ${ee}`)}}}H.fromService=_;function j(D,R){const N=R&&R.disableMarshalling;return new Proxy({},{get(B,$){if(typeof $=="string")return R?.properties?.has($)?R.properties.get($):F($)?D.listen($):async function(...Y){let ee;R&&!(0,I.isUndefinedOrNull)(R.context)?ee=[R.context,...Y]:ee=Y;const ie=await D.call($,ee);return N?ie:(0,t.revive)(ie)};throw new Error(`Property not found: ${String($)}`)}})}H.toService=j;function F(D){return D[0]==="o"&&D[1]==="n"&&b.isUpperAsciiLetter(D.charCodeAt(2))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){let _=H.toString();if(_!=="[object Object]")return _}return H}function z(H){return Array.isArray(H)?H.map(O):O(H)}function U(H,_,j,F,D,R,N){N=z(N);const B=Q[D],$=B[F%B.length];let Y=[`%c[${H}]%c[${String(_).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${R}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(R)?(Y=Y.concat(N),Y.push(")")):Y.push(N),console.log.apply(console,Y)}e.logWithColors=U;class X{constructor(_,j){this._outgoingPrefix=_,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,j,F,D,R){this._totalOutgoing+=_,U(this._outgoingPrefix,this._totalOutgoing,_,j,F,D,R)}logIncoming(_,j,F,D,R){this._totalIncoming+=_,U(this._incomingPrefix,this._totalIncoming,_,j,F,D,R)}}e.IPCLogger=X}),define(J[120],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class w{constructor(k,M){this.sender=k,this.onMessage=M}send(k){try{this.sender.send("vscode:message",k.buffer)}catch(M){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=w}),define(J[121],Z([0,1,17,5,35]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(f){this.port=f,this.onMessage=A.Event.fromDOMEventEmitter(this.port,"message",m=>w.VSBuffer.wrap(m.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class S extends k.IPCClient{constructor(f,m){const t=new M(f);super(t,m);this.protocol=t}dispose(){this.protocol.disconnect()}}e.Client=S}),define(J[82],Z([0,1,17,5,2,3,31,35]),function(q,e,w,A,k,M,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var f;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function t(){return m||(m=w.VSBuffer.alloc(0)),m}class b{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,l){if(o===0)return t();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const T=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=o),T}if(this._chunks[0].byteLength>o){const T=this._chunks[0].slice(0,o);return l&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),T}let p=w.VSBuffer.alloc(o),E=0,L=0;for(;o>0;){const T=this._chunks[L];if(T.byteLength>o){const W=T.slice(0,o);p.set(W,E),E+=o,l&&(this._chunks[L]=T.slice(o),this._totalLength-=o),o-=o}else p.set(T,E),E+=T.byteLength,l?(this._chunks.shift(),this._totalLength-=T.byteLength):L++,o-=T.byteLength}return p}}e.ChunkStream=b;var I;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(I||(I={}));var y;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(y=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(o,l,p,E){this.type=o,this.id=l,this.ack=p,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends k.Disposable{constructor(o){super();this._onMessage=this._register(new A.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const p=this._state.messageType,E=this._state.id,L=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(p,E,L,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class P{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=w.VSBuffer.alloc(13);l.writeUInt8(o.type,0),l.writeUInt32BE(o.id,1),l.writeUInt32BE(o.ack,5),l.writeUInt32BE(o.data.byteLength,9),this._writeSoon(l,o.data)}_bufferAdd(o,l){const p=this._totalLength===0;return this._data.push(o,l),this._totalLength+=o.byteLength+l.byteLength,p}_bufferTake(){const o=w.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,l){this._bufferAdd(o,l)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class v extends k.Disposable{constructor(o){super();this._onMessage=new A.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new A.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new P(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new h(1,0,0,o))}}e.Protocol=v;class u extends n.IPCClient{constructor(o,l,p=null){super(o,l,p);this.protocol=o}static fromSocket(o,l){return new u(new v(o),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=u;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new A.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,S.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class a{constructor(o){this.data=o,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],l=0,p=this._first;for(;p;)o[l++]=p.data,p=p.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const l=new a(o);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class i{constructor(){this.lastRuns=[];const o=Date.now();for(let l=0;l<i._HISTORY_LENGTH;l++)this.lastRuns[l]=o-1e3*l;setInterval(()=>{for(let l=i._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}load(){const o=Date.now(),l=(1+i._HISTORY_LENGTH)*1e3;let p=0;for(let E=0;E<i._HISTORY_LENGTH;E++)o-this.lastRuns[E]<=l&&p++;return 1-p/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}i._HISTORY_LENGTH=10,i._INSTANCE=null;class s{constructor(o,l=null,p=i.getInstance()){this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=p,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(E=>this._receiveMessage(E))),this._socketDisposables.push(this._socket.onClose(E=>this._onSocketClose.fire(E))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new h(5,0,0,t());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const l=new h(4,0,0,t());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,l){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new P(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.push(this._socket.onClose(p=>this._onSocketClose.fire(p))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let l=0,p=o.length;l<p;l++)this._socketWriter.write(o[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new h(6,0,0,t())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const l=this._outgoingUnackMsg.toArray();for(let p=0,E=l.length;p<E;p++)this._socketWriter.write(l[p]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const p=new h(1,l,this._incomingAckId,o);this._outgoingUnackMsg.push(p),this._isReconnecting||(this._socketWriter.write(p),this._recvAckCheck())}sendControl(o){const l=new h(2,0,0,o);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),l=Date.now()-o.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new h(3,0,this._incomingAckId,t());this._socketWriter.write(o)}}e.PersistentProtocol=s}),define(J[122],Z([0,1,14,17,5,2,35,120]),function(q,e,w,A,k,M,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(t,b){const I=k.Event.fromNodeEventEmitter(w.ipcMain,b,(h,g)=>({event:h,message:g})),y=k.Event.filter(I,({event:h})=>h.sender.id===t);return k.Event.map(y,({message:h})=>h&&A.VSBuffer.wrap(h))}class m extends S.IPCServer{constructor(){super(m.getOnDidClientConnect())}static getOnDidClientConnect(){const b=k.Event.fromNodeEventEmitter(w.ipcMain,"vscode:hello",({sender:I})=>I);return k.Event.map(b,I=>{const y=I.id,h=m.Clients.get(y);h&&h.dispose();const g=new k.Emitter;m.Clients.set(y,(0,M.toDisposable)(()=>g.fire()));const P=f(y,"vscode:message"),v=k.Event.any(k.Event.signal(f(y,"vscode:disconnect")),g.event);return{protocol:new n.Protocol(I,P),onDidClientDisconnect:v}})}}e.Server=m,m.Clients=new Map}),define(J[83],Z([0,1,14,5,28,121]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class S extends M.Client{constructor(m,t){super({addEventListener:(b,I)=>m.addListener(b,I),removeEventListener:(b,I)=>m.removeListener(b,I),postMessage:b=>m.postMessage(b),start:()=>m.start(),close:()=>m.close()},t)}}e.Client=S;async function n(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,k.generateUuid)();f.webContents.send("vscode:createMessageChannel",m);const t=A.Event.fromNodeEventEmitter(w.ipcMain,"vscode:createMessageChannelResult",(I,y)=>({nonce:y,port:I.ports[0]})),{port:b}=await A.Event.toPromise(A.Event.once(A.Event.filter(t,I=>I.nonce===m)));return b}e.connect=n}),define(J[84],Z([0,1,9,5,2,13]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var S;(function(t){t[t.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(S=e.StorageHint||(e.StorageHint={}));var n;(function(t){t[t.None=0]="None",t[t.Initialized=1]="Initialized",t[t.Closed=2]="Closed"})(n||(n={}));class f extends k.Disposable{constructor(b,I=Object.create(null)){super();this.database=b,this.options=I,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new w.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){b.changed?.forEach((I,y)=>this.accept(y,I)),b.deleted?.forEach(I=>this.accept(I,void 0))}accept(b,I){if(this.state===n.Closed)return;let y=!1;(0,M.isUndefinedOrNull)(I)?y=this.cache.delete(b):this.cache.get(b)!==I&&(this.cache.set(b,I),y=!0),y&&this._onDidChangeStorage.fire(b)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,I){const y=this.cache.get(b);return(0,M.isUndefinedOrNull)(y)?I:y}getBoolean(b,I){const y=this.get(b);return(0,M.isUndefinedOrNull)(y)?I:y==="true"}getNumber(b,I){const y=this.get(b);return(0,M.isUndefinedOrNull)(y)?I:parseInt(y,10)}async set(b,I){if(this.state===n.Closed)return;if((0,M.isUndefinedOrNull)(I))return this.delete(b);const y=String(I);if(this.cache.get(b)!==y)return this.cache.set(b,y),this.pendingInserts.set(b,y),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async delete(b){if(!(this.state===n.Closed||!this.cache.delete(b)))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(b){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class m{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert&&b.insert.forEach((I,y)=>this.items.set(y,I)),b.delete&&b.delete.forEach(I=>this.items.delete(I))}async close(){}}e.InMemoryStorageDatabase=m}),define(J[123],Z([0,1,9,5,37,8,18]),function(q,e,w,A,k,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(t,b=Object.create(null)){this.path=t,this.options=b,this.name=(0,M.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return A.Event.None}async getItems(){const t=await this.whenConnected,b=new Map;return(await this.all(t,"SELECT * FROM ItemTable")).forEach(y=>b.set(y.key,y.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${b.size} rows`),b}async updateItems(t){const b=await this.whenConnected;return this.doUpdateItems(b,t)}doUpdateItems(t,b){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${b.insert?(0,k.mapToString)(b.insert):"0"}), delete(${b.delete?(0,k.setToString)(b.delete):"0"})`),this.transaction(t,()=>{const I=b.insert,y=b.delete;if(I&&I.size>0){const h=[];h.push([]);let g=0;I.forEach((P,v)=>{let u=h[g];u.length>n.MAX_HOST_PARAMETERS&&(g++,u=[],h.push(u)),u.push(v,P)}),h.forEach(P=>{this.prepare(t,`INSERT INTO ItemTable VALUES ${new Array(P.length/2).fill("(?,?)").join(",")}`,v=>v.run(P),()=>{const v=[];let u=0;return I.forEach((d,a)=>{v.push(a),u+=d.length}),`Keys: ${v.join(", ")} Length: ${u}`})})}if(y&&y.size){const h=[];h.push([]);let g=0;y.forEach(P=>{let v=h[g];v.length>n.MAX_HOST_PARAMETERS&&(g++,v=[],h.push(v)),v.push(P)}),h.forEach(P=>{this.prepare(t,`DELETE FROM ItemTable WHERE key IN (${new Array(P.length).fill("?").join(",")})`,v=>v.run(P),()=>{const v=[];return y.forEach(u=>{v.push(u)}),`Keys: ${v.join(", ")}`})})}})}async close(t){this.logger.trace(`[storage ${this.name}] close()`);const b=await this.whenConnected;return this.doClose(b,t)}doClose(t,b){return new Promise((I,y)=>{t.db.close(h=>(h&&this.handleSQLiteError(t,`[storage ${this.name}] close(): ${h}`),this.path===n.IN_MEMORY_PATH?I():!t.isErroneous&&!t.isInMemory?this.backup().then(I,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),I())):typeof b=="function"?S.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const P=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:b()}).then(()=>P(),v=>(P(),Promise.reject(v)))})).then(I,y):y(h||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const t=this.toBackupPath(this.path);return S.Promises.copy(this.path,t,{preserveSymlinks:!1})}toBackupPath(t){return`${t}.backup`}async checkIntegrity(t){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${t})`);const b=await this.whenConnected,I=await this.get(b,t?"PRAGMA integrity_check":"PRAGMA quick_check"),y=t?I.integrity_check:I.quick_check;return b.isErroneous?`${y} (last error: ${b.lastError})`:b.isInMemory?`${y} (in-memory!)`:y}async connect(t,b=!0){this.logger.trace(`[storage ${this.name}] open(${t}, retryOnBusy: ${b})`);try{return await this.doConnect(t)}catch(I){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${I}`),I.code==="SQLITE_BUSY"&&b)return await(0,w.timeout)(n.BUSY_OPEN_TIMEOUT),this.connect(t,!1);try{await S.Promises.unlink(t);try{await S.Promises.rename(this.toBackupPath(t),t)}catch(y){}return await this.doConnect(t)}catch(y){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${y}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(t,b){t.isErroneous=!0,t.lastError=b,this.logger.error(b)}doConnect(t){return new Promise((b,I)=>{new Promise((y,h)=>{q(["@vscode/sqlite3"],y,h)}).then(y=>{const h={db:new(this.logger.isTracing?y.verbose().Database:y.Database)(t,g=>g?h.db?h.db.close(()=>I(g)):I(g):this.exec(h,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(h),P=>h.db.close(()=>I(P)))),isInMemory:t===n.IN_MEMORY_PATH};h.db.on("error",g=>this.handleSQLiteError(h,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&h.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},I)})}exec(t,b){return new Promise((I,y)=>{t.db.exec(b,h=>h?(this.handleSQLiteError(t,`[storage ${this.name}] exec(): ${h}`),y(h)):I())})}get(t,b){return new Promise((I,y)=>{t.db.get(b,(h,g)=>h?(this.handleSQLiteError(t,`[storage ${this.name}] get(): ${h}`),y(h)):I(g))})}all(t,b){return new Promise((I,y)=>{t.db.all(b,(h,g)=>h?(this.handleSQLiteError(t,`[storage ${this.name}] all(): ${h}`),y(h)):I(g))})}transaction(t,b){return new Promise((I,y)=>{t.db.serialize(()=>{t.db.run("BEGIN TRANSACTION"),b(),t.db.run("END TRANSACTION",h=>h?(this.handleSQLiteError(t,`[storage ${this.name}] transaction(): ${h}`),y(h)):I())})})}prepare(t,b,I,y){const h=t.db.prepare(b),g=P=>{this.handleSQLiteError(t,`[storage ${this.name}] prepare(): ${P} (${b}). Details: ${y()}`)};h.on("error",g),I(h),h.finalize(P=>{P&&g(P),h.removeListener("error",g)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class f{constructor(t){t&&typeof t.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=t.logTrace),t&&typeof t.logError=="function"&&(this.logError=t.logError)}get isTracing(){return!!this.logTrace}trace(t){this.logTrace&&this.logTrace(t)}error(t){this.logError&&this.logError(t)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[124],Z([12,11]),function(q,e){return q.create("vs/base/common/date",e)}),define(J[125],Z([0,1,124]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,k=A*60,M=k*24,S=M*7,n=M*30,f=M*365;function m(b,I){typeof b!="number"&&(b=b.getTime());const y=Math.round((new Date().getTime()-b)/1e3);if(y<-30)return(0,w.localize)(0,null,m(new Date().getTime()+y*1e3,!1));if(y<30)return(0,w.localize)(1,null);let h;return y<A?(h=y,I?h===1?(0,w.localize)(2,null,h):(0,w.localize)(3,null,h):h===1?(0,w.localize)(4,null,h):(0,w.localize)(5,null,h)):y<k?(h=Math.floor(y/A),I?h===1?(0,w.localize)(6,null,h):(0,w.localize)(7,null,h):h===1?(0,w.localize)(8,null,h):(0,w.localize)(9,null,h)):y<M?(h=Math.floor(y/k),I?h===1?(0,w.localize)(10,null,h):(0,w.localize)(11,null,h):h===1?(0,w.localize)(12,null,h):(0,w.localize)(13,null,h)):y<S?(h=Math.floor(y/M),I?h===1?(0,w.localize)(14,null,h):(0,w.localize)(15,null,h):h===1?(0,w.localize)(16,null,h):(0,w.localize)(17,null,h)):y<n?(h=Math.floor(y/S),I?h===1?(0,w.localize)(18,null,h):(0,w.localize)(19,null,h):h===1?(0,w.localize)(20,null,h):(0,w.localize)(21,null,h)):y<f?(h=Math.floor(y/n),I?h===1?(0,w.localize)(22,null,h):(0,w.localize)(23,null,h):h===1?(0,w.localize)(24,null,h):(0,w.localize)(25,null,h)):(h=Math.floor(y/f),I?h===1?(0,w.localize)(26,null,h):(0,w.localize)(27,null,h):h===1?(0,w.localize)(28,null,h):(0,w.localize)(29,null,h))}e.fromNow=m;function t(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=t}),define(J[126],Z([12,11]),function(q,e){return q.create("vs/base/common/errorMessage",e)}),define(J[67],Z([0,1,34,13,126]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function M(m,t){return t&&(m.stack||m.stacktrace)?k.localize(0,null,n(m),S(m.stack)||S(m.stacktrace)):n(m)}function S(m){return Array.isArray(m)?m.join(`
`):m}function n(m){return typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?k.localize(1,null,m.message):m.message||k.localize(2,null)}function f(m=null,t=!1){if(!m)return k.localize(3,null);if(Array.isArray(m)){const b=w.coalesce(m),I=f(b[0],t);return b.length>1?k.localize(4,null,I,b.length):I}if(A.isString(m))return m;if(m.detail){const b=m.detail;if(b.error)return M(b.error,t);if(b.exception)return M(b.exception,t)}return m.stack?M(m,t):m.message?m.message:k.localize(5,null)}e.toErrorMessage=f}),define(J[127],Z([12,11]),function(q,e){return q.create("vs/base/common/keybindingLabels",e)}),define(J[128],Z([0,1,127]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class A{constructor(S,n,f=n){this.modifierLabels=[null],this.modifierLabels[2]=S,this.modifierLabels[1]=n,this.modifierLabels[3]=f}toLabel(S,n,f){if(n.length===0)return null;const m=[];for(let t=0,b=n.length;t<b;t++){const I=n[t],y=f(I);if(y===null)return null;m[t]=k(I,y,this.modifierLabels[S])}return m.join(" ")}}e.ModifierLabelProvider=A,e.UILabelProvider=new A({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:w.localize(0,null),shiftKey:w.localize(1,null),altKey:w.localize(2,null),metaKey:w.localize(3,null),separator:"+"},{ctrlKey:w.localize(4,null),shiftKey:w.localize(5,null),altKey:w.localize(6,null),metaKey:w.localize(7,null),separator:"+"}),e.AriaLabelProvider=new A({ctrlKey:w.localize(8,null),shiftKey:w.localize(9,null),altKey:w.localize(10,null),metaKey:w.localize(11,null),separator:"+"},{ctrlKey:w.localize(12,null),shiftKey:w.localize(13,null),altKey:w.localize(14,null),metaKey:w.localize(15,null),separator:"+"},{ctrlKey:w.localize(16,null),shiftKey:w.localize(17,null),altKey:w.localize(18,null),metaKey:w.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new A({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new A({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function k(M,S,n){if(S===null)return"";const f=[];return M.ctrlKey&&f.push(n.ctrlKey),M.shiftKey&&f.push(n.shiftKey),M.altKey&&f.push(n.altKey),M.metaKey&&f.push(n.metaKey),S!==""&&f.push(S),f.join(n.separator)}}),define(J[129],Z([12,11]),function(q,e){return q.create("vs/base/node/processes",e)}),define(J[68],Z([0,1,41,29,10,44,8,3,31,13,79,18,129]),function(q,e,w,A,k,M,S,n,f,m,t,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function y(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(a,c){if(n.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};c&&(i.cwd=c);const s=w.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],i);return new Promise(r=>{s.once("error",o=>{r({success:!1,error:o})}),s.once("exit",(o,l)=>{r(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?y(i.status):1})}else if(n.isLinux||n.isMacintosh)try{const i=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",q).fsPath;return new Promise(s=>{w.execFile(i,[a.pid.toString()],{encoding:"utf8",shell:!0},(r,o,l)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function g(a=f.env){return a.comspec||"cmd.exe"}e.getWindowsShell=g;class P{constructor(c,i,s,r){if(i!==void 0&&s!==void 0&&r!==void 0)this.cmd=c,this.args=i,this.shell=s,this.options=r;else{const o=c;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(f.env).forEach(l=>{o[l]=f.env[l]}),Object.keys(this.options.env).forEach(l=>{o[l]=this.options.env[l]}),this.options.env=o}}getSanitizedCommand(){let c=this.cmd.toLowerCase();const i=c.lastIndexOf(S.sep);return i!==-1&&(c=c.substring(i+1)),P.WellKnowCommands[c]?c:"other"}start(c){return n.isWindows&&(this.options&&this.options.cwd&&A.isUNC(this.options.cwd)||!this.options&&A.isUNC(f.cwd()))?Promise.reject(new Error(I.localize(0,null))):this.useExec().then(i=>{let s,r;const o=new Promise((l,p)=>{s=l,r=p});if(i){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=w.exec(l,this.options,(p,E,L)=>{this.childProcess=null;const T=p;T&&T.killed?r({killed:this.terminateRequested,stdout:E.toString(),stderr:L.toString()}):this.handleExec(s,c,p,E,L)})}else{let l=null;const p=E=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(E,s,c,r);const L={terminated:this.terminateRequested};m.isNumber(E)&&(L.cmdCode=E),s(L)};if(this.shell&&n.isWindows){const E=M.deepClone(this.options);E.windowsVerbatimArguments=!0,E.detached=!1;let L=!1,T=!1;const W=[];let C=this.ensureQuotes(this.cmd);W.push(C.value),L=C.quoted,this.args&&this.args.forEach(x=>{C=this.ensureQuotes(x),W.push(C.value),T=T&&C.quoted});const V=["/s","/c"];L?T?V.push('"'+W.join(" ")+'"'):W.length>1?V.push('"'+W[0]+'" '+W.slice(1).join(" ")):V.push('"'+W[0]+'"'):V.push(W.join(" ")),l=w.spawn(g(),V,E)}else this.cmd&&(l=w.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(m.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",E=>{this.childProcess=null,r({terminated:this.terminateRequested,error:E})}),l.pid&&(this.childProcess.on("close",p),this.handleSpawn(l,s,c,r,!0)))}return o})}handleClose(c,i,s,r){}ensureQuotes(c){return P.regexp.test(c)?{value:'"'+c+'"',quoted:!0}:{value:c,quoted:c.length>0&&c[0]==='"'&&c[c.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(c=>c.pid,c=>-1):new Promise(c=>{this.pidResolve=c})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(c=>(this.terminateRequested=!0,h(c,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),c=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(c=>{if(!this.shell||!n.isWindows)return c(!1);const i=w.spawn(g(),["/s","/c"]);i.on("error",s=>c(!0)),i.on("exit",s=>c(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class v extends P{constructor(c,i,s,r){super(c,i,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(c,i,s,r,o){[r,o].forEach((l,p)=>{const E=new t.LineDecoder;E.write(l).forEach(W=>{i({line:W,source:p===0?0:1})});const T=E.end();T&&i({line:T,source:p===0?0:1})}),c({terminated:this.terminateRequested,error:s})}handleSpawn(c,i,s,r,o){const l=new t.LineDecoder,p=new t.LineDecoder;c.stdout.on("data",E=>{l.write(E).forEach(T=>s({line:T,source:0}))}),c.stderr.on("data",E=>{p.write(E).forEach(T=>s({line:T,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=p}handleClose(c,i,s,r){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&s({line:o,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&s({line:l,source:1})}}e.LineProcess=v;function u(a){let c=[],i=!1;const s=function(r){if(i){c.push(r);return}(!a.send(r,l=>{if(l&&console.error(l),i=!1,c.length>0){const p=c.slice(0);c=[],p.forEach(E=>s(E))}})||n.isWindows)&&(i=!0)};return{send:s}}e.createQueuedSender=u;var d;(function(a){async function c(i,s,r){if(S.isAbsolute(i))return i;if(s===void 0&&(s=f.cwd()),S.dirname(i)!=="."||(r===void 0&&m.isString(f.env.PATH)&&(r=f.env.PATH.split(S.delimiter)),r===void 0||r.length===0))return S.join(s,i);async function l(p){if(await b.Promises.exists(p)){let E;try{E=await b.Promises.stat(p)}catch(L){L.message.startsWith("EACCES")&&(E=await b.Promises.lstat(p))}return E?!E.isDirectory():!1}return!1}for(let p of r){let E;if(S.isAbsolute(p)?E=S.join(p,i):E=S.join(s,p,i),await l(E))return E;let L=E+".com";if(await l(L)||(L=E+".exe",await l(L)))return L}return S.join(s,i)}a.findExecutable=c})(d=e.win32||(e.win32={}))}),define(J[130],Z([0,1,26,3,116,68]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function S(y,h){return y===1?A.isWindows?b():M.getWindowsShell(h):m(y,h)}e.getSystemShell=S;function n(y,h){return y===1?A.isWindows?I(h):M.getWindowsShell(h):m(y,h)}e.getSystemShellSync=n;let f=null;function m(y,h){if(A.isLinux&&y===2||A.isMacintosh&&y===3)return"/bin/bash";if(!f){let g;if(A.isWindows)g="/bin/bash";else{if(g=h.SHELL,!g)try{g=(0,w.userInfo)().shell}catch(P){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}f=g}return f}let t=null;async function b(){return t||(t=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),t}function I(y){if(t)return t;const h=A.isWindows&&parseFloat((0,w.release)())>=10,g=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),P=`${y.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?P:M.getWindowsShell(y)}}),define(J[85],Z([0,1,41,9,17,24,109,16,5,2,44,3,68,35]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends y.ChannelServer{constructor(v){super({send:u=>{try{process.send&&process.send(u.buffer.toString("base64"))}catch(d){}},onMessage:f.Event.fromNodeEventEmitter(process,"message",u=>k.VSBuffer.wrap(Buffer.from(u,"base64")))},v);process.once("disconnect",()=>this.dispose())}}e.Server=h;class g{constructor(v,u){this.modulePath=v,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const d=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new A.Delayer(d),this.child=null,this._client=null}getChannel(v){const u=this;return{call(d,a,c){return u.requestPromise(v,d,a,c)},listen(d,a){return u.requestEvent(v,d,a)}}}requestPromise(v,u,d,a=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(n.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(v),i=(0,A.createCancelablePromise)(o=>c.call(u,d,o)),s=a.onCancellationRequested(()=>i.cancel()),r=(0,m.toDisposable)(()=>i.cancel());return this.activeRequests.add(r),i.finally(()=>{s.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(v,u,d){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let a;const c=new f.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(v).listen(u,d)(c.fire,c),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,t.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),b.isMacintosh&&u.env&&delete u.env.DYLD_LIBRARY_PATH,this.child=(0,w.fork)(this.modulePath,v,u);const d=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,S.isRemoteConsoleLog)(l)){(0,S.log)(l,`IPC Library: ${this.options.serverName}`);return}d.fire(k.VSBuffer.wrap(Buffer.from(l,"base64")))});const c=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,i=l=>this.child&&this.child.connected&&c.send(l.buffer.toString("base64")),s=d.event,r={send:i,onMessage:s};this._client=new y.ChannelClient(r);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,p)=>{process.removeListener("exit",o),this.activeRequests.forEach(E=>(0,m.dispose)(E)),this.activeRequests.clear(),l!==0&&p!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+p),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:p})})}return this._client}getCachedChannel(v){let u=this.channels.get(v);return u||(u=this.client.getChannel(v),this.channels.set(v,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(J[131],Z([12,11]),function(q,e){return q.create("vs/code/electron-main/app",e)}),define(J[132],Z([12,11]),function(q,e){return q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[133],Z([12,11]),function(q,e){return q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[134],Z([12,11]),function(q,e){return q.create("vs/platform/environment/node/argv",e)}),define(J[135],Z([12,11]),function(q,e){return q.create("vs/platform/environment/node/argvHelper",e)}),define(J[136],Z([12,11]),function(q,e){return q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[137],Z([12,11]),function(q,e){return q.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[138],Z([12,11]),function(q,e){return q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[139],Z([12,11]),function(q,e){return q.create("vs/platform/files/common/fileService",e)}),define(J[140],Z([12,11]),function(q,e){return q.create("vs/platform/files/common/files",e)}),define(J[141],Z([12,11]),function(q,e){return q.create("vs/platform/files/common/io",e)}),define(J[142],Z([12,11]),function(q,e){return q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[143],Z([12,11]),function(q,e){return q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[144],Z([12,11]),function(q,e){return q.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[145],Z([12,11]),function(q,e){return q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[146],Z([12,11]),function(q,e){return q.create("vs/platform/request/common/request",e)}),define(J[147],Z([12,11]),function(q,e){return q.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[148],Z([12,11]),function(q,e){return q.create("vs/platform/update/common/update.config.contribution",e)}),define(J[149],Z([12,11]),function(q,e){return q.create("vs/platform/windows/electron-main/window",e)}),define(J[150],Z([12,11]),function(q,e){return q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[151],Z([12,11]),function(q,e){return q.create("vs/platform/workspaces/common/workspaces",e)}),define(J[152],Z([12,11]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[153],Z([12,11]),function(q,e){return q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[154],Z([0,1,5,2]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this._onCloseEmitter=new w.Emitter,this._onReloadEmitter=new w.Emitter,this._onTerminateEmitter=new w.Emitter,this._onAttachEmitter=new w.Emitter}call(n,f,m){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(n,f,m){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class M extends A.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,f,m){this.channel.call("attach",[n,f,m])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,f){this.channel.call("terminate",[n,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,f,m){return this.channel.call("openExtensionDevelopmentHostWindow",[n,f||{},m])}}e.ExtensionHostDebugChannelClient=M}),define(J[155],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class w{constructor(S){this.driver=S}listen(S,n){throw new Error(`No event found: ${n}`)}call(S,n,f){switch(n){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=w;class A{constructor(S){this.channel=S}click(S,n,f){return this.channel.call("click",[S,n,f])}doubleClick(S){return this.channel.call("doubleClick",S)}setValue(S,n){return this.channel.call("setValue",[S,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(S){return this.channel.call("isActiveElement",S)}getElements(S,n){return this.channel.call("getElements",[S,n])}getElementXY(S,n,f){return this.channel.call("getElementXY",[S,n,f])}typeInEditor(S,n){return this.channel.call("typeInEditor",[S,n])}getTerminalBuffer(S){return this.channel.call("getTerminalBuffer",S)}writeInTerminal(S,n){return this.channel.call("writeInTerminal",[S,n])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=A;class k{constructor(S){this.channel=S}registerWindowDriver(S){return this.channel.call("registerWindowDriver",S)}reloadWindowDriver(S){return this.channel.call("reloadWindowDriver",S)}}e.WindowDriverRegistryChannelClient=k}),define(J[156],Z([0,1,125,46,10,8,31,15,7]),function(q,e,w,A,k,M,S,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class m{constructor(h,g,P){this._args=h,this.paths=g,this.productService=P}get appRoot(){return(0,M.dirname)(k.FileAccess.asFileUri("",q).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,n.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,n.joinPath)(f.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return f.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return f.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=S.env.VSCODE_PORTABLE;return h?f.URI.file((0,M.join)(h,"argv.json")):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,n.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,M.resolve)(h):(0,M.normalize)((0,M.join)(k.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,M.resolve)(h):(0,M.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,M.resolve)(h);const g=S.env.VSCODE_EXTENSIONS;if(g)return g;const P=S.env.VSCODE_PORTABLE;return P?(0,M.join)(P,"extensions"):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(g=>/^[^:/?#]+?:\/\//.test(g)?f.URI.parse(g):f.URI.file((0,M.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?f.URI.parse(h):f.URI.file((0,M.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return t(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!S.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,n.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return f.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([A.memoize],m.prototype,"appRoot",null),ue([A.memoize],m.prototype,"userHome",null),ue([A.memoize],m.prototype,"userDataPath",null),ue([A.memoize],m.prototype,"appSettingsHome",null),ue([A.memoize],m.prototype,"tmpDir",null),ue([A.memoize],m.prototype,"userRoamingDataHome",null),ue([A.memoize],m.prototype,"settingsResource",null),ue([A.memoize],m.prototype,"userDataSyncHome",null),ue([A.memoize],m.prototype,"userDataSyncLogResource",null),ue([A.memoize],m.prototype,"sync",null),ue([A.memoize],m.prototype,"machineSettingsResource",null),ue([A.memoize],m.prototype,"globalStorageHome",null),ue([A.memoize],m.prototype,"workspaceStorageHome",null),ue([A.memoize],m.prototype,"keybindingsResource",null),ue([A.memoize],m.prototype,"keyboardLayoutResource",null),ue([A.memoize],m.prototype,"argvResource",null),ue([A.memoize],m.prototype,"snippetsHome",null),ue([A.memoize],m.prototype,"isExtensionDevelopment",null),ue([A.memoize],m.prototype,"untitledWorkspacesHome",null),ue([A.memoize],m.prototype,"installSourcePath",null),ue([A.memoize],m.prototype,"builtinExtensionsPath",null),ue([A.memoize],m.prototype,"extensionsPath",null),ue([A.memoize],m.prototype,"extensionDevelopmentLocationURI",null),ue([A.memoize],m.prototype,"extensionDevelopmentKind",null),ue([A.memoize],m.prototype,"extensionTestsLocationURI",null),ue([A.memoize],m.prototype,"debugExtensionHost",null),ue([A.memoize],m.prototype,"serviceMachineIdResource",null),ue([A.memoize],m.prototype,"telemetryLogResource",null),ue([A.memoize],m.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=m;function t(y,h){return I(y["inspect-extensions"],y["inspect-brk-extensions"],5870,h,y.debugId)}e.parseExtensionHostPort=t;function b(y,h){return I(y["inspect-search"],y["inspect-brk-search"],5876,h)}e.parseSearchPort=b;function I(y,h,g,P,v){const d=Number(h||y)||(P?null:g),a=d?Boolean(!!h):!1;return{port:d,break:a,debugId:v}}}),define(J[86],Z([0,1,240,3,134]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,k.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},category:{type:"string",cat:"e",description:(0,k.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,k.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,k.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,k.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,k.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,k.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const S={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(h,g,P=S){const v={},u=[],d=[];for(let s in g){const r=g[s];r.alias&&(v[s]=r.alias),r.type==="string"||r.type==="string[]"?(u.push(s),r.deprecates&&u.push(r.deprecates)):r.type==="boolean"&&(d.push(s),r.deprecates&&d.push(r.deprecates))}const a=w(h,{string:u,boolean:d,alias:v}),c={},i=a;c._=a._.map(s=>String(s)).filter(s=>s.length>0),delete i._;for(let s in g){const r=g[s];r.alias&&delete i[r.alias];let o=i[s];r.deprecates&&i.hasOwnProperty(r.deprecates)&&(o||(o=i[r.deprecates]),delete i[r.deprecates]),typeof o!="undefined"&&(r.type==="string[]"?o&&!Array.isArray(o)&&(o=[o]):r.type==="string"&&Array.isArray(o)&&(o=o.pop(),P.onMultipleValues(s,o)),c[s]=o),delete i[s]}for(let s in i)P.onUnknownOption(s);return c}e.parseArgs=n;function f(h,g){let P="";return g.args&&(Array.isArray(g.args)?P=` <${g.args.join("> <")}>`:P=` <${g.args}>`),g.alias?`-${g.alias} --${h}${P}`:`--${h}${P}`}function m(h,g){let P=0,v=[];for(const c in h){const i=h[c],s=f(c,i);P=Math.max(P,s.length),v.push([s,i.description])}let u=P+2+1;if(g-u<25)return v.reduce((c,i)=>c.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);let d=g-u-1,a=[];for(const c of v){let i=c[0],s=b(c[1],d),r=t(u-i.length-2);a.push("  "+i+r+s[0]);for(let o=1;o<s.length;o++)a.push(t(u)+s[o])}return a}e.formatOptions=m;function t(h){return" ".repeat(h)}function b(h,g){let P=[];for(;h.length;){let v=h.length<g?h.length:h.lastIndexOf(" ",g),u=h.slice(0,v).trim();h=h.slice(v),P.push(u)}return P}function I(h,g,P,v,u=!0){const d=process.stdout.isTTY&&process.stdout.columns||80;let a=[`${h} ${P}`];a.push(""),a.push(`${(0,k.localize)(32,null)}: ${g} [${(0,k.localize)(33,null)}][${(0,k.localize)(34,null)}...]`),a.push(""),u&&(A.isWindows?a.push((0,k.localize)(35,null,g)):a.push((0,k.localize)(36,null,g)),a.push(""));const c={};for(const i in v){const s=v[i];if(s.description&&s.cat){let r=c[s.cat];r||(c[s.cat]=r={}),r[i]=s}}for(let i in c){const s=i;let r=c[s];r&&(a.push(M[s]),a.push(...m(r,d)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=I;function y(h,g){return`${h||(0,k.localize)(37,null)}
${g||(0,k.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=y}),define(J[157],Z([0,1,59,154,86]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends A.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,f,m){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(m[0],m[1],m[2]):super.call(n,f,m)}async openExtensionDevelopmentHostWindow(n,f,m){const t=(0,k.parseArgs)(n,k.OPTIONS);t.debugRenderer=m;const b=t.extensionDevelopmentPath;if(!b)return{success:!1};let I;const y=Object.keys(f);for(let d of y){let a=f[d];a===null||(I||(I=Object.create(null)),I[d]=a)}const[h]=this.windowsMainService.openExtensionDevelopmentHostWindow(b,{context:5,cli:t,userEnv:I});if(!m)return{success:!0};const g=h.win;if(!g)return{success:!0};const P=g.webContents.debugger;let v=P.isAttached()?Infinity:0;const u=(0,w.createServer)(d=>{v++==0&&P.attach();let a=!1;const c=r=>{a||d.write(JSON.stringify(r)+"\0")},i=(r,o,l,p)=>c({method:o,params:l,sessionId:p});g.on("close",()=>{P.removeListener("message",i),d.end(),a=!0}),P.addListener("message",i);let s=Buffer.alloc(0);d.on("data",r=>{s=Buffer.concat([s,r]);for(let o=s.indexOf(0);o!==-1;o=s.indexOf(0)){let l;try{const p=s.slice(0,o).toString("utf8");s=s.slice(o+1),l=JSON.parse(p)}catch(p){console.error("error reading cdp line",p)}P.sendCommand(l.method,l.params,l.sessionId).then(p=>c({id:l.id,sessionId:l.sessionId,result:p})).catch(p=>c({id:l.id,sessionId:l.sessionId,error:{code:0,message:p.message}}))}}),d.on("error",r=>{console.error("error on cdp pipe:",r)}),d.on("close",()=>{a=!0,--v==0&&P.detach()})});return await new Promise(d=>u.listen(0,d)),g.on("close",()=>u.close()),{rendererDebugPort:u.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),function(){"use strict";function q(e,w,A,k){function M(n){const f=S(n),m=[f];return e.isAbsolute(f)||m.unshift(k),e.resolve(...m)}function S(n){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,A);const t=n["user-data-dir"];if(t)return t;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(b,"AppData","Roaming")}break;case"darwin":m=e.join(w.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,A)}return{getUserDataPath:M}}if(typeof define=="function")define(J[158],Z([0,159,26,10,15,31]),function(e,w,A,k,M,S){const n=M.dirname(k.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(M.joinPath(n,"package.json").fsPath);return q(w,A,f.name,S.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),w=require("path"),A=require("os");module.exports=q(w,A,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[160],Z([0,1,26,156,158]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends A.AbstractNativeEnvironmentService{constructor(n,f){super(n,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,k.getUserDataPath)(n)},f)}}e.NativeEnvironmentService=M}),define(J[161],Z([0,1,30,26,8]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function M(S){const n=(0,k.join)((0,A.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return w.writeFileSync(n,""),S&&console.log(`Marker file for --wait created: ${n}`),n}catch(f){S&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=M}),define(J[162],Z([0,1,137]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function M(I){return I=I.trim(),I==="*"||A.test(I)}e.isValidVersionStr=M;function S(I){if(!M(I))return null;if(I=I.trim(),I==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=I.match(A);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=S;function n(I){if(!I)return null;let y=I.majorBase,h=I.majorMustEqual,g=I.minorBase,P=I.minorMustEqual,v=I.patchBase,u=I.patchMustEqual;I.hasCaret&&(y===0||(P=!1),u=!1);let d=0;if(I.preRelease){const a=k.exec(I.preRelease);if(a){const[,c,i,s]=a;d=Date.UTC(Number(c),Number(i)-1,Number(s))}}return{majorBase:y,majorMustEqual:h,minorBase:g,minorMustEqual:P,patchBase:v,patchMustEqual:u,isMinimum:I.hasGreaterEquals,notBefore:d}}e.normalizeVersion=n;function f(I,y,h){let g;typeof I=="string"?g=n(S(I)):g=I;let P;y instanceof Date?P=y.getTime():typeof y=="string"&&(P=new Date(y).getTime());let v;if(typeof h=="string"?v=n(S(h)):v=h,!g||!v)return!1;let u=g.majorBase,d=g.minorBase,a=g.patchBase,c=v.majorBase,i=v.minorBase,s=v.patchBase,r=v.notBefore,o=v.majorMustEqual,l=v.minorMustEqual,p=v.patchMustEqual;return v.isMinimum?u>c?!0:u<c?!1:d>i?!0:d<i||P&&P<r?!1:a>=s:(u===1&&c===0&&(!o||!l||!p)&&(c=1,i=0,s=0,o=!0,l=!1,p=!1),u<c?!1:u>c?!o:d<i?!1:d>i?!l:a<s?!1:a>s?!p:!(P&&P<r))}e.isValidVersion=f;function m(I,y,h,g){return h.isBuiltin||typeof h.main=="undefined"?!0:b(I,y,h.engines.vscode,g)}e.isValidExtensionVersion=m;function t(I,y,h){return I==="*"||b(y,h,I)}e.isEngineValid=t;function b(I,y,h,g=[]){let P=n(S(h));if(!P)return g.push(w.localize(0,null,h)),!1;if(P.majorBase===0){if(!P.majorMustEqual||!P.minorMustEqual)return g.push(w.localize(1,null,h)),!1}else if(!P.majorMustEqual)return g.push(w.localize(2,null,h)),!1;return f(I,y,P)?!0:(g.push(w.localize(3,null,I,h)),!1)}}),define(J[163],Z([0,1,2,10,35,85]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S extends w.Disposable{constructor(f,m,t,b){super();this.folders=f,this.onDidFilesChange=m,this.onLogMessage=t,this.verboseLogging=b,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(A.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=S.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(m=>!this.isDisposed&&this.onDidFilesChange(m))),this._register(this.service.onDidLogMessage(m=>this.onLogMessage(m))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=S,S.MAX_RESTARTS=5}),define(J[164],Z([0,1,2,10,35,85]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S extends w.Disposable{constructor(f,m,t,b,I={}){super();this.folders=f,this.onDidFilesChange=m,this.onLogMessage=t,this.verboseLogging=b,this.watcherOptions=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new M.Client(A.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=S.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=k.ProxyChannel.toService((0,k.getNextTickChannel)(f.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(m=>!this.isDisposed&&this.onDidFilesChange(m))),this._register(this.service.onDidLogMessage(m=>this.onLogMessage(m))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=S,S.MAX_RESTARTS=5}),define(J[165],Z([0,1,41,111,10,79]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class S{constructor(f,m,t,b,I){this.watchedFolder=f,this.eventCallback=t,this.logCallback=b,this.verboseLogging=I,this.restartCounter=0,Array.isArray(m)?this.ignored=m.map(y=>(0,A.parse)(y)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}, excludes: ${m.join(",")}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=(0,w.spawn)(k.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",q).fsPath,f);const m=new M.LineDecoder;this.handle.stdout.on("data",t=>{const b=[];for(const I of m.write(t)){const y=I.split("|");if(y.length===2){const h=Number(y[0]),g=y[1];if(h>=0&&h<3){if(this.ignored&&this.ignored.some(P=>P(g))){this.verboseLogging&&this.log(g);continue}b.push({type:S.changeTypeMap[h],path:g})}else this.log(y[1])}}b.length>0&&this.eventCallback(b)}),this.handle.on("error",t=>this.onError(t)),this.handle.stderr.on("data",t=>this.onError(t)),this.handle.on("exit",(t,b)=>this.onExit(t,b))}onError(f){this.error("process error: "+f.toString())}onExit(f,m){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${m})`),this.restartCounter<=S.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=S,S.MAX_RESTARTS=5,S.changeTypeMap=[0,1,2]}),define(J[166],Z([0,1,8,25,165]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M{constructor(n,f,m,t){this.onDidFilesChange=f,this.onLogMessage=m,this.verboseLogging=t,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(w.posix.sep)&&(this.folder.path=(0,A.rtrim)(this.folder.path,w.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new k.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=M}),define(J[69],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(k,M=[],S=!1){this.ctor=k,this.staticArguments=M,this.supportsDelayedInstantiation=S}}e.SyncDescriptor=w}),define(J[167],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=w;class A{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(let S of this._nodes.values())S.outgoing.size===0&&M.push(S);return M}insertEdge(M,S){const n=this.lookupOrInsertNode(M),f=this.lookupOrInsertNode(S);n.outgoing.set(this._hashFn(S),f),f.incoming.set(this._hashFn(M),n)}removeNode(M){const S=this._hashFn(M);this._nodes.delete(S);for(let n of this._nodes.values())n.outgoing.delete(S),n.incoming.delete(S)}lookupOrInsertNode(M){const S=this._hashFn(M);let n=this._nodes.get(S);return n||(n=new w(M),this._nodes.set(S,n)),n}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){let M=[];for(let[S,n]of this._nodes)M.push(`${S}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(let[M,S]of this._nodes){const n=new Set([M]),f=this._findCycle(S,n);if(f)return f}}_findCycle(M,S){for(let[n,f]of M.outgoing){if(S.has(n))return[...S,n].join(" -> ");S.add(n);const m=this._findCycle(f,S);if(m)return m;S.delete(n)}}}e.Graph=A}),define(J[4],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function f(m){return m[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=f})(w=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function A(n,f,m,t){f[w.DI_TARGET]===f?f[w.DI_DEPENDENCIES].push({id:n,index:m,optional:t}):(f[w.DI_DEPENDENCIES]=[{id:n,index:m,optional:t}],f[w.DI_TARGET]=f)}function k(n){if(w.serviceIds.has(n))return w.serviceIds.get(n);const f=function(m,t,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(f,m,b,!1)};return f.toString=()=>n,w.serviceIds.set(n,f),f}e.createDecorator=k;function M(n){return n}e.refineServiceDecorator=M;function S(n){return function(f,m,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");A(n,f,t,!0)}}e.optional=S}),define(J[70],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function A(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=A}),define(J[87],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,w.createDecorator)("encryptionMainService");class A{constructor(M){this.machineId=M}encryption(){return new Promise((M,S)=>q(["vscode-encrypt"],M,S))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch(S){return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch(S){return M}}}e.EncryptionMainService=A}),define(J[47],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(J[168],Z([0,1,10,3,31,136,4]),function(q,e,w,A,k,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.CURRENT_TARGET_PLATFORM=e.getTargetPlatform=e.getTargetPlatformFromOS=e.toTargetPlatform=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var n;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(n=e.TargetPlatform||(e.TargetPlatform={}));function f(v){switch(v){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=f;function m(v,u){let d;switch(v){case 1:d=3;break;case 3:d=2;break;case 2:d=1;break}return t(d,u)}e.getTargetPlatformFromOS=m;function t(v,u){switch(v){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=t,e.CURRENT_TARGET_PLATFORM=A.isWeb?"web":t(A.platform,k.arch);function b(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=b;var I;(function(v){v[v.NoneOrRelevance=0]="NoneOrRelevance",v[v.LastUpdatedDate=1]="LastUpdatedDate",v[v.Title=2]="Title",v[v.PublisherName=3]="PublisherName",v[v.InstallCount=4]="InstallCount",v[v.PublishedDate=5]="PublishedDate",v[v.AverageRating=6]="AverageRating",v[v.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var y;(function(v){v[v.Default=0]="Default",v[v.Ascending=1]="Ascending",v[v.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var h;(function(v){v.Install="install",v.Uninstall="uninstall"})(h=e.StatisticType||(e.StatisticType={}));var g;(function(v){v[v.None=0]="None",v[v.Install=1]="Install",v[v.Update=2]="Update"})(g=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,S.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class P extends Error{constructor(u,d){super(u);this.code=d,this.name=d}}e.ExtensionManagementError=P,e.IExtensionManagementService=(0,S.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,S.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,S.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=w.FileAccess.asBrowserUri("./media/defaultIcon.png",q).toString(!0),e.ExtensionsLabel=(0,M.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,M.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,S.createDecorator)("IExtensionManagementCLIService")}),define(J[169],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,w.createDecorator)("extensionUrlTrustService")}),define(J[170],Z([0,1,25,4]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=k;function M(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(S=e.ExtensionType||(e.ExtensionType={}));class n{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,I){if(typeof b=="undefined"||b===null)return typeof I=="undefined"||I===null;if(typeof I=="undefined"||I===null)return!1;if(typeof b=="string"||typeof I=="string"){let y=typeof b=="string"?b:b.value,h=typeof I=="string"?I:I.value;return w.equalsIgnoreCase(y,h)}return b._lower===I._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.ExtensionIdentifier=n;function f(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function m(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=m,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[171],Z([0,1,25,170]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(h,g){return h.uuid&&g.uuid?h.uuid===g.uuid:h.id===g.id?!0:(0,w.compareIgnoreCase)(h.id,g.id)===0}e.areSameExtensions=k;class M{constructor(g,P){this.version=P,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof M?k(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=M;function S(h,g){return`${h}.${g}`}e.getExtensionId=S;function n(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function f(h,g){return n(S(h,g))}e.getGalleryExtensionId=f;function m(h,g){const P=[],v=u=>{for(const d of P)if(d.some(a=>k(g(a),g(u))))return d;return null};for(const u of h){const d=v(u);d?d.push(u):P.push([u])}return P}e.groupByExtension=m;function t(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function b(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function I(h){const g=new Set;for(const P of h)P.malicious&&g.add(P.id.id);return g}e.getMaliciousExtensionsSet=I;function y(h,g){const P=[],v=g.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const u=v.shift();if(u&&P.every(d=>!k(d.identifier,{id:u}))){const d=h.filter(a=>k(a.identifier,{id:u}));d.length===1&&(P.push(d[0]),v.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return P}e.getExtensionDependencies=y}),define(J[88],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,w.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,w.createDecorator)("externalTerminal")}),define(J[172],Z([0,1,41,10,8,3,105,18,68,138,88]),function(q,e,w,A,k,M,S,n,f,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=m.localize(0,null);class I{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends I{openTerminal(a,c){return this.spawnTerminal(w,a,f.getWindowsShell(),c)}spawnTerminal(a,c,i,s){const r=c.windowsExec||y.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const o=k.basename(r).toLowerCase();if(o==="cmder"||o==="cmder.exe")return a.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return r.indexOf(" ")>=0&&l.push('""'),l.push(r),(o==="wt"||o==="wt.exe")&&l.push("-d ."),new Promise((p,E)=>{const L=P(process),T=a.spawn(i,l,{cwd:s,env:L});T.on("error",E),T.on("exit",()=>p())})}runInTerminal(a,c,i,s,r){const o="windowsExec"in r&&r.windowsExec?r.windowsExec:y.getDefaultTerminalWindows();return new Promise((l,p)=>{const E=`"${c} - ${b}"`,L=`""${i.join('" "')}" & pause"`,T=["/c","start",E,"/wait",o,"/c",L],W=Object.assign({},P(process),s);Object.keys(W).filter(x=>W[x]===null).forEach(x=>delete W[x]);const C={cwd:c,env:W,windowsVerbatimArguments:!0};w.spawn(y.CMD,T,C).on("error",x=>{p(v(x))}),l(void 0)})}static getDefaultTerminalWindows(){if(!y._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return y._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=y,y.CMD="cmd.exe";class h extends I{openTerminal(a,c){return this.spawnTerminal(w,a,c)}runInTerminal(a,c,i,s,r){const o=r.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((l,p)=>{if(o===t.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const E=o===t.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",T=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${E}.scpt`,q).fsPath,"-t",a||b,"-w",c];for(let V of i)T.push("-a"),T.push(V);if(s){const V=Object.assign({},P(process),s);for(let x in V){const se=V[x];se===null?(T.push("-u"),T.push(x)):(T.push("-e"),T.push(`${x}=${se}`))}}let W="";const C=w.spawn(h.OSASCRIPT,T);C.on("error",V=>{p(v(V))}),C.stderr.on("data",V=>{W+=V.toString()}),C.on("exit",V=>{if(V===0)l(void 0);else if(W){const x=W.split(`
`,1);p(new Error(x[0]))}else p(new Error(m.localize(1,null,E,V)))})}else p(new Error(m.localize(2,null,o)))})}spawnTerminal(a,c,i){const s=c.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((r,o)=>{const l=["-a",s];i&&l.push(i);const p=P(process),E=a.spawn("/usr/bin/open",l,{cwd:i,env:p});E.on("error",o),E.on("exit",()=>r())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class g extends I{openTerminal(a,c){return this.spawnTerminal(w,a,c)}runInTerminal(a,c,i,s,r){const o=r.linuxExec?Promise.resolve(r.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((l,p)=>{let E=[];o.then(L=>{L.indexOf("gnome-terminal")>=0?E.push("-x"):E.push("-e"),E.push("bash"),E.push("-c");const T=`${u(i)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;E.push(`''${T}''`);const W=Object.assign({},P(process),s);Object.keys(W).filter(se=>W[se]===null).forEach(se=>delete W[se]);const C={cwd:c,env:W};let V="";const x=w.spawn(L,E,C);x.on("error",se=>{p(v(se))}),x.stderr.on("data",se=>{V+=se.toString()}),x.on("exit",se=>{if(se===0)l(void 0);else if(V){const G=V.split(`
`,1);p(new Error(G[0]))}else p(new Error(m.localize(4,null,L,se)))})})})}static async getDefaultTerminalLinuxReady(){return g._DEFAULT_TERMINAL_LINUX_READY||(g._DEFAULT_TERMINAL_LINUX_READY=new Promise(async a=>{M.isLinux?await n.Promises.exists("/etc/debian_version")?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm"):a("xterm")})),g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,c,i){const s=c.linuxExec?Promise.resolve(c.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,o)=>{s.then(l=>{const p=P(process),E=a.spawn(l,[],{cwd:i,env:p});E.on("error",o),E.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=m.localize(3,null);function P(d){const a={...d.env};return(0,S.sanitizeProcessEnvironment)(a),a}function v(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(m.localize(5,null,d.path)):d}function u(d){let a="";for(let c of d)c.indexOf(" ")>=0?a+='"'+c+'"':a+=c,a+=" ";return a}}),define(J[19],Z([0,1,37,8,25,13,7,140,4]),function(q,e,w,A,k,M,S,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function m(O){return O.create===!0}e.isFileOpenForWriteOptions=m;var t;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var b;(function(O){O[O.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var I;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=y;function h(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=h;function g(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function P(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=P;var v;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(z,U){super(z);this.code=U}}e.FileSystemProviderError=u;function d(O,z){const U=new u(O.toString(),z);return c(U,z),U}e.createFileSystemProviderError=d;function a(O){return O||d((0,n.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=a;function c(O,z){return O.name=z?`${z} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=c;function i(O){if(!O)return v.Unknown;if(O instanceof u)return O.code;const z=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!z)return v.Unknown;switch(z[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=i;function s(O){if(O instanceof L)return O.fileOperationResult;switch(i(O)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class o{constructor(z,U,X){this.resource=z,this.operation=U,this.target=X}isOperation(z){return this.operation===z}}e.FileOperationEvent=o;var l;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class p{constructor(z,U){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const X of z)switch(X.type){case 1:this.added||(this.added=w.TernarySearchTree.forUris(()=>U)),this.added.set(X.resource,X);break;case 0:this.updated||(this.updated=w.TernarySearchTree.forUris(()=>U)),this.updated.set(X.resource,X);break;case 2:this.deleted||(this.deleted=w.TernarySearchTree.forUris(()=>U)),this.deleted.set(X.resource,X);break}}contains(z,...U){return this.doContains(z,{includeChildren:!1},...U)}affects(z,...U){return this.doContains(z,{includeChildren:!0},...U)}doContains(z,U,...X){if(!z)return!1;const H=X.length>0;return!!((!H||X.includes(1))&&(this.added?.get(z)||U.includeChildren&&this.added?.findSuperstr(z))||(!H||X.includes(0))&&(this.updated?.get(z)||U.includeChildren&&this.updated?.findSuperstr(z))||(!H||X.includes(2))&&(this.deleted?.findSubstr(z)||U.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=p;function E(O,z,U){return!O||!z||O===z||z.length>O.length?!1:(z.charAt(z.length-1)!==A.sep&&(z+=A.sep),U?(0,k.startsWithIgnoreCase)(O,z):O.indexOf(z)===0)}e.isParent=E;class L extends Error{constructor(z,U,X){super(z);this.fileOperationResult=U,this.options=X}}e.FileOperationError=L;class T extends L{constructor(z,U,X){super(z,2,X);this.stat=U}}e.NotModifiedSinceFileOperationError=T;var W;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(W=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var C;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(C=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function V(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=V;async function x(O,z){if(!z.canHandleResource(S.URI.from({scheme:O.scheme})))return new Promise(U=>{const X=z.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===O.scheme&&H.added&&(X.dispose(),U())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class se{static formatSize(z){return(0,M.isNumber)(z)||(z=0),z<se.KB?(0,n.localize)(1,null,z.toFixed(0)):z<se.MB?(0,n.localize)(2,null,(z/se.KB).toFixed(2)):z<se.GB?(0,n.localize)(3,null,(z/se.MB).toFixed(2)):z<se.TB?(0,n.localize)(4,null,(z/se.GB).toFixed(2)):(0,n.localize)(5,null,(z/se.TB).toFixed(2))}}e.ByteSize=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;var G;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function Q(O){return{maxFileSize:O===0?300*se.MB:16*se.GB,maxHeapSize:O===0?700*se.MB:2*700*se.MB}}e.getPlatformLimits=Q}),define(J[54],Z([0,1,241,135,86,19]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function S(I,y){const h={onUnknownOption:P=>{console.warn((0,A.localize)(0,null,P))},onMultipleValues:(P,v)=>{console.warn((0,A.localize)(1,null,P,v))}},g=(0,k.parseArgs)(I,k.OPTIONS,y?h:void 0);return g.goto&&g._.forEach(P=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(P),(0,A.localize)(2,null))),g["max-memory"]&&w(parseInt(g["max-memory"])>=M.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${M.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function n(I){const y=I.findIndex(h=>!/^-/.test(h));if(y>-1)return[...I.slice(0,y),...I.slice(y+1)]}function f(I){let[,...y]=I;process.env.VSCODE_DEV&&(y=n(y)||[]);const h=!b(process.env);return S(y,h)}e.parseMainProcessArgv=f;function m(I){const[,,...y]=I;return S(y,!0)}e.parseCLIProcessArgv=m;function t(I,...y){const h=I.indexOf("--");return h===-1?I.push(...y):I.splice(h,0,...y),I}e.addArg=t;function b(I){return I.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),define(J[89],Z([0,1,41,159,24,67,16,3,28,130,54]),function(q,e,w,A,k,M,S,n,f,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function b(h,g,P){return g["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):n.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,t.isLaunchedFromCli)(P)&&!g["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,t.isLaunchedFromCli)(P)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),I||(I=new Promise(async v=>{const u=new k.CancellationTokenSource,d=setTimeout(()=>{h.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),u.dispose(!0),v({})},1e4);try{const a=await y(h,u.token);v(a)}catch(a){(0,S.isPromiseCanceledError)(a)||h.error(`[resolve shell env] Unable to resolve shell environment (${a}). Proceeding without shell environment...`),v({})}finally{clearTimeout(d),u.dispose()}})),I)}e.resolveShellEnv=b;let I;async function y(h,g){const P=new Promise(async(v,u)=>{const d=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",d);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",a);const c=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(c+"(.*)"+c),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};h.trace("getUnixShellEnvironment#env",s);const r=await(0,m.getSystemShell)(n.OS,s);if(h.trace("getUnixShellEnvironment#shell",r),g.isCancellationRequested)return u(S.canceled);const o=A.basename(r);let l,p;/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,p=["-Login","-Command"]):(l=`'${process.execPath}' -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,p=["-ilc"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(p),l);const E=(0,w.spawn)(r,[...p,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});g.onCancellationRequested(()=>(E.kill(),u(S.canceled))),E.on("error",W=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(W)),v({})});const L=[];E.stdout.on("data",W=>L.push(W));const T=[];E.stderr.on("data",W=>T.push(W)),E.on("close",(W,C)=>{const V=Buffer.concat(L).toString("utf8");h.trace("getUnixShellEnvironment#raw",V);const x=Buffer.concat(T).toString("utf8");if(x.trim()&&h.trace("getUnixShellEnvironment#stderr",x),W||C)return u(new Error(`Failed to get environment (code ${W}, signal ${C})`));const se=i.exec(V),G=se?se[1]:"{}";try{const Q=JSON.parse(G);d?Q.ELECTRON_RUN_AS_NODE=d:delete Q.ELECTRON_RUN_AS_NODE,a?Q.ELECTRON_NO_ATTACH_CONSOLE=a:delete Q.ELECTRON_NO_ATTACH_CONSOLE,delete Q.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",Q),v(Q)}catch(Q){h.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(Q)),u(Q)}})});try{return await P}catch(v){return h.error("getUnixShellEnvironment#error",(0,M.toErrorMessage)(v)),{}}}}),define(J[90],Z([0,1,3,7,19]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function M(f){return f.map(m=>({type:m.type,resource:A.URI.file(m.path)}))}e.toFileChanges=M;function S(f){const m=new n;for(const t of f)m.processEvent(t);return m.normalize()}e.normalizeFileChanges=S;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(m){const t=this.mapPathToChange.get(m.path);if(t){const b=t.type,I=m.type;b===1&&I===2?(this.mapPathToChange.delete(m.path),this.normalized.splice(this.normalized.indexOf(t),1)):b===2&&I===1?t.type=0:b===1&&I===0||(t.type=I)}else this.normalized.push(m),this.mapPathToChange.set(m.path,m)}normalize(){const m=[],t=[];return this.normalized.filter(b=>b.type!==2?(m.push(b),!1):!0).sort((b,I)=>b.path.length-I.path.length).filter(b=>t.some(I=>(0,k.isParent)(b.path,I,!w.isLinux))?!1:(t.push(b.path),!0)).concat(m)}}}),define(J[173],Z([0,1,9,2,8,80,18,117,90]),function(q,e,w,A,k,M,S,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class m extends A.Disposable{constructor(b,I,y,h){super();this.path=b,this.onDidFilesChange=I,this.onLogMessage=y,this.verboseLogging=h,this.fileChangesDelayer=this._register(new w.ThrottledDelayer(n.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(b){this.verboseLogging=b}async startWatching(){try{const{stat:b,symbolicLink:I}=await S.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let y=this.path;if(I)try{y=await(0,M.realpath)(y)}catch(h){if(this.onError(h),I.dangling)return}b.isDirectory()?this._register((0,n.watchFolder)(y,(h,g)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,k.join)(this.path,(0,k.basename)(g))})},h=>this.onError(h))):this._register((0,n.watchFile)(y,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(b){b.code!=="ENOENT"&&this.onError(b)}}onFileChange(b){this.fileChangesBuffer.push(b),this.verboseLogging&&this.onVerbose(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),this.fileChangesDelayer.trigger(async()=>{const I=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=(0,f.normalizeFileChanges)(I);if(this.verboseLogging)for(const h of y)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);y.length>0&&this.onDidFilesChange(y)})}onError(b){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${b}`})}onVerbose(b){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=m}),define(J[71],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...k){this._entries=new Map;for(let[M,S]of k)this.set(M,S)}set(k,M){const S=this._entries.get(k);return this._entries.set(k,M),S}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=w}),define(J[174],Z([0,1,9,16,69,167,4,71]),function(q,e,w,A,k,M,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class m extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class t{constructor(h=new n.ServiceCollection,g=!1,P){this._activeInstantiations=new Set,this._services=h,this._strict=g,this._parent=P,this._services.set(S.IInstantiationService,this)}createChild(h){return new t(h,this._strict,this)}invokeFunction(h,...g){let P=I.traceInvocation(h),v=!1;try{return h({get:(d,a)=>{if(v)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(d,P);if(!c&&a!==S.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return c}},...g)}finally{v=!0,P.stop()}}createInstance(h,...g){let P,v;return h instanceof k.SyncDescriptor?(P=I.traceCreation(h.ctor),v=this._createInstance(h.ctor,h.staticArguments.concat(g),P)):(P=I.traceCreation(h),v=this._createInstance(h,g,P)),P.stop(),v}_createInstance(h,g=[],P){let v=S._util.getServiceDependencies(h).sort((a,c)=>a.index-c.index),u=[];for(const a of v){let c=this._getOrCreateServiceInstance(a.id,P);if(!c&&this._strict&&!a.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${a.id}.`);u.push(c)}let d=v.length>0?v[0].index:g.length;if(g.length!==d){console.warn(`[createInstance] First service dependency of ${h.name} at position ${d+1} conflicts with ${g.length} static arguments`);let a=d-g.length;a>0?g=g.concat(new Array(a)):g=g.slice(0,d)}return new h(...[...g,...u])}_setServiceInstance(h,g){if(this._services.get(h)instanceof k.SyncDescriptor)this._services.set(h,g);else if(this._parent)this._parent._setServiceInstance(h,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let g=this._services.get(h);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):g}_getOrCreateServiceInstance(h,g){let P=this._getServiceInstanceOrDescriptor(h);return P instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,P,g.branch(h,!0)):(g.branch(h,!1),P)}_safeCreateAndCacheServiceInstance(h,g,P){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,g,P)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,g,P){const v=new M.Graph(a=>a.id.toString());let u=0;const d=[{id:h,desc:g,_trace:P}];for(;d.length;){const a=d.pop();if(v.lookupOrInsertNode(a),u++>1e3)throw new m(v);for(let c of S._util.getServiceDependencies(a.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(c.id);if(!i&&!c.optional&&console.warn(`[createInstance] ${h} depends on ${c.id} which is NOT registered.`),i instanceof k.SyncDescriptor){const s={id:c.id,desc:i,_trace:a._trace.branch(c.id,!0)};v.insertEdge(a,s),d.push(s)}}}for(;;){const a=v.roots();if(a.length===0){if(!v.isEmpty())throw new m(v);break}for(const{data:c}of a){if(this._getServiceInstanceOrDescriptor(c.id)instanceof k.SyncDescriptor){const s=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,s)}v.removeNode(c)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,g,P=[],v,u){if(this._services.get(h)instanceof k.SyncDescriptor)return this._createServiceInstance(g,P,v,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,g,P,v,u);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(h,g=[],P,v){if(P){const u=new w.IdleValue(()=>this._createInstance(h,g,v));return new Proxy(Object.create(null),{get(d,a){if(a in d)return d[a];let c=u.value,i=c[a];return typeof i!="function"||(i=i.bind(c),d[a]=i),i},set(d,a,c){return u.value[a]=c,!0}})}else return this._createInstance(h,g,v)}}e.InstantiationService=t;var b;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(b||(b={}));class I{constructor(h,g){this.type=h,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return f?new I(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):I._None}static traceCreation(h){return f?new I(0,h.name):I._None}branch(h,g){let P=new I(2,h.toString());return this._dep.push([h,g,P]),P}stop(){let h=Date.now()-this._start;I._totals+=h;let g=!1;function P(u,d){let a=[],c=new Array(u+1).join("	");for(const[i,s,r]of d._dep)if(s&&r){g=!0,a.push(`${c}CREATES -> ${i}`);let o=P(u+1,r);o&&a.push(o)}else a.push(`${c}uses -> ${i}`);return a.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${I._totals.toFixed(2)}ms)`];(h>2||g)&&console.log(v.join(`
`))}}I._None=new class extends I{constructor(){super(-1,null)}stop(){}branch(){return this}},I._totals=0}),define(J[175],Z([0,1,16,128,57]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class M extends k.ResolvedKeybinding{constructor(n,f){super();if(f.length===0)throw(0,w.illegalArgument)("parts");this._os=n,this._parts=f}getLabel(){return A.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return A.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:A.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return A.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new k.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=M}),define(J[176],Z([0,1,57,175]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends A.BaseResolvedKeybinding{constructor(S,n){super(n,S.parts)}_keyCodeToUILabel(S){if(this._os===2)switch(S){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return w.KeyCodeUtils.toString(S)}_getLabel(S){return S.isDuplicateModifierCase()?"":this._keyCodeToUILabel(S.keyCode)}_getAriaLabel(S){return S.isDuplicateModifierCase()?"":w.KeyCodeUtils.toString(S.keyCode)}_keyCodeToElectronAccelerator(S){if(S>=93&&S<=108)return null;switch(S){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return w.KeyCodeUtils.toString(S)}_getElectronAccelerator(S){return S.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(S.keyCode)}_getUserSettingsLabel(S){if(S.isDuplicateModifierCase())return"";const n=w.KeyCodeUtils.toUserSettingsUS(S.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(S){return k.getDispatchStr(S)}static getDispatchStr(S){if(S.isModifierKey())return null;let n="";return S.ctrlKey&&(n+="ctrl+"),S.shiftKey&&(n+="shift+"),S.altKey&&(n+="alt+"),S.metaKey&&(n+="meta+"),n+=w.KeyCodeUtils.toString(S.keyCode),n}_getSingleModifierDispatchPart(S){return S.keyCode===5&&!S.shiftKey&&!S.altKey&&!S.metaKey?"ctrl":S.keyCode===4&&!S.ctrlKey&&!S.altKey&&!S.metaKey?"shift":S.keyCode===6&&!S.ctrlKey&&!S.shiftKey&&!S.metaKey?"alt":S.keyCode===57&&!S.ctrlKey&&!S.shiftKey&&!S.altKey?"meta":null}}e.USLayoutResolvedKeybinding=k}),define(J[177],Z([0,1,9]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function A(k,M){if(k.length===0)return Promise.resolve(!1);const S=[];let n=!1;for(let f of k){if(f===!0)return Promise.resolve(!0);(0,w.isThenable)(f)&&S.push(f.then(m=>{m&&(n=!0)},m=>{M(m),n=!0}))}return w.Promises.settled(S).then(()=>n)}e.handleVetos=A}),define(J[6],Z([0,1,67,5,2,3,4]),function(q,e,w,A,k,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function n(){return new Date().toISOString()}var f;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class m extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=m;class t extends m{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...s){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([i,...s]))}debug(i,...s){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([i,...s]))}info(i,...s){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([i,...s]))}warn(i,...s){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([i,...s]))}error(i,...s){if(this.checkLogLevel(f.Error))if(i instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=i.stack,this.log(f.Error,this.format(r))}else this.log(f.Error,this.format([i,...s]))}critical(i,...s){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([i,...s]))}flush(){}format(i){let s="";for(let r=0;r<i.length;r++){let o=i[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch(l){}s+=(r>0?" ":"")+o}return s}}e.AbstractMessageLogger=t;class b extends m{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!M.isWindows}trace(i,...s){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...s):console.log(`[main ${n()}]`,i,...s))}debug(i,...s){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...s):console.log(`[main ${n()}]`,i,...s))}info(i,...s){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,i,...s):console.log(`[main ${n()}]`,i,...s))}warn(i,...s){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,i,...s):console.warn(`[main ${n()}]`,i,...s))}error(i,...s){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,i,...s):console.error(`[main ${n()}]`,i,...s))}critical(i,...s){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,i,...s):console.error(`[main ${n()}]`,i,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class I extends m{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...s){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",i,...s)}debug(i,...s){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...s)}info(i,...s){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",i,...s)}warn(i,...s){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",i,...s)}error(i,...s){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",i,...s)}critical(i,...s){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...s)}dispose(){}flush(){}}e.ConsoleLogger=I;class y extends m{constructor(i,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(s)}trace(i,...s){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(i),...s])}debug(i,...s){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(i),...s])}info(i,...s){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(i),...s])}warn(i,...s){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(i),...s])}error(i,...s){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(i),...s])}critical(i,...s){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(i),...s])}extractMessage(i){return typeof i=="string"?i:(0,w.toErrorMessage)(i,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class h extends m{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const s of this.logServices)s.setLevel(i);super.setLevel(i)}trace(i,...s){for(const r of this.logServices)r.trace(i,...s)}debug(i,...s){for(const r of this.logServices)r.debug(i,...s)}info(i,...s){for(const r of this.logServices)r.info(i,...s)}warn(i,...s){for(const r of this.logServices)r.warn(i,...s)}error(i,...s){for(const r of this.logServices)r.error(i,...s)}critical(i,...s){for(const r of this.logServices)r.critical(i,...s)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=h;class g extends k.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...s){this.logger.trace(i,...s)}debug(i,...s){this.logger.debug(i,...s)}info(i,...s){this.logger.info(i,...s)}warn(i,...s){this.logger.warn(i,...s)}error(i,...s){this.logger.error(i,...s)}critical(i,...s){this.logger.critical(i,...s)}flush(){this.logger.flush()}}e.LogService=g;class P extends k.Disposable{constructor(i,s){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(r))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,s){let r=this.loggers.get(i.toString());return r||(r=this.doCreateLogger(i,s?.always?f.Trace:this.logLevel,s),this.loggers.set(i.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class v{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(i){}getLevel(){return f.Info}trace(i,...s){}debug(i,...s){}info(i,...s){}warn(i,...s){}error(i,...s){}critical(i,...s){}dispose(){}flush(){}}e.NullLogService=v;function u(c){if(c.verbose)return f.Trace;if(typeof c.logLevel=="string"){const i=d(c.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function d(c){switch(c){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=d;function a(c){switch(c){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=a});var te=this&&this.__param||function(q,e){return function(w,A){e(w,A,q)}};define(J[178],Z([0,1,9,17,40,76,47,19,4,6]),function(q,e,w,A,k,M,S,n,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var t;(function(I){I.ERROR_INVALID_FILE="ERROR_INVALID_FILE",I.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(t=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,f.createDecorator)(e.UserConfigurationFileServiceId);let b=class{constructor(y,h,g){this.environmentService=y,this.fileService=h,this.logService=g,this.queue=new w.Queue}async updateSettings(y,h){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,y,h))}async doWrite(y,h,g){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,y.toString(),h);const{value:P,mtime:v,etag:u}=await this.fileService.readFile(y,{atomic:!0});let d=P.toString();const a=[];if((0,k.parse)(d,a,{allowTrailingComma:!0,allowEmptyContent:!0}),a.length)throw new Error("ERROR_INVALID_FILE");const c=this.getEdits(h,d,g)[0];if(c){d=d.substring(0,c.offset)+c.content+d.substring(c.offset+c.length);try{await this.fileService.writeFile(y,A.VSBuffer.fromString(d),{etag:u,mtime:v})}catch(i){if(i.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:y,path:h},g,P){return h.length?(0,M.setProperty)(g,h,y,P):[{content:JSON.stringify(y,null,P.insertSpaces&&P.tabSize?" ".repeat(P.tabSize):"	"),length:g.length,offset:0}]}};b=ue([te(0,S.IEnvironmentService),te(1,n.IFileService),te(2,m.ILogService)],b),e.UserConfigurationFileService=b}),define(J[91],Z([0,1,6]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function A(M,S){switch(S){case w.LogLevel.Trace:return M.trace;case w.LogLevel.Debug:return M.debug;case w.LogLevel.Info:return M.info;case w.LogLevel.Warning:return M.warn;case w.LogLevel.Error:return M.error;case w.LogLevel.Critical:return M.critical;default:throw new Error("Invalid log level")}}class k extends w.AbstractLogger{constructor(S=w.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(S),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(S){this._logger=S;for(const{level:n,args:f}of this.buffer)A(S,n).apply(S,f);this.buffer=[]}_log(S,...n){this._logger?A(this._logger,S).apply(this._logger,n):this.getLevel()<=S&&this.buffer.push({level:S,args:n})}trace(S,...n){this._log(w.LogLevel.Trace,S,...n)}debug(S,...n){this._log(w.LogLevel.Debug,S,...n)}info(S,...n){this._log(w.LogLevel.Info,S,...n)}warn(S,...n){this._log(w.LogLevel.Warning,S,...n)}error(S,...n){this._log(w.LogLevel.Error,S,...n)}critical(S,...n){this._log(w.LogLevel.Critical,S,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=k}),define(J[179],Z([0,1,9,17,15,19,4,91,6]),function(q,e,w,A,k,M,S,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const m=5*M.ByteSize.MB;let t=class extends f.AbstractLogger{constructor(y,h,g,P,v){super();this.name=y,this.resource=h,this.donotUseFormatters=P,this.fileService=v,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new w.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const y=arguments[0];if(y instanceof Error){const h=Array.prototype.slice.call(arguments);h[0]=y.stack,this._log(f.LogLevel.Error,this.format(h))}else this._log(f.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,this.format(arguments))}flush(){}log(y,h){this._log(y,this.format(h))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(y){if(y.fileOperationResult!==3)throw y}}_log(y,h){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>m&&(await this.fileService.writeFile(this.getBackupResource(),A.VSBuffer.fromString(g)),g=""),this.donotUseFormatters?g+=h:g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(y)}] ${h}
`,await this.fileService.writeFile(this.resource,A.VSBuffer.fromString(g))})}getCurrentTimestamp(){const y=P=>P<10?`0${P}`:P,h=P=>P<10?`00${P}`:P<100?`0${P}`:P,g=new Date;return`${g.getFullYear()}-${y(g.getMonth()+1)}-${y(g.getDate())} ${y(g.getHours())}:${y(g.getMinutes())}:${y(g.getSeconds())}.${h(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(y){return""}}stringifyLogLevel(y){switch(y){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}format(y){let h="";for(let g=0;g<y.length;g++){let P=y[g];if(typeof P=="object")try{P=JSON.stringify(P)}catch(v){}h+=(g>0?" ":"")+P}return h}};t=ue([te(4,M.IFileService)],t),e.FileLogger=t;let b=class extends f.AbstractLoggerService{constructor(y,h,g){super(y.getLevel(),y.onDidChangeLogLevel);this.instantiationService=h,this.fileService=g}doCreateLogger(y,h,g){const P=new n.BufferLogService(h);return(0,M.whenProviderRegistered)(y,this.fileService).then(()=>P.logger=this.instantiationService.createInstance(t,(0,k.basename)(y),y,P.getLevel(),!!g?.donotUseFormatters)),P}};b=ue([te(0,f.ILogService),te(1,S.IInstantiationService),te(2,M.IFileService)],b),e.FileLoggerService=b}),define(J[180],Z([0,1,5,7,6]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(I){this.service=I,this.onDidChangeLogLevel=w.Event.buffer(I.onDidChangeLogLevel,!0)}listen(I,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(I,y,h){switch(y){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=M;class S{constructor(I){this.channel=I}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(I){S.setLevel(this.channel,I)}static setLevel(I,y){return I.call("setLevel",y)}}e.LogLevelChannelClient=S;class n{constructor(I){this.loggerService=I,this.loggers=new Map}listen(I,y){throw new Error(`Event not found: ${y}`)}async call(I,y,h){switch(y){case"createLogger":this.createLogger(A.URI.revive(h[0]),h[1]);return;case"log":return this.log(A.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${y}`)}createLogger(I,y){this.loggers.set(I.toString(),this.loggerService.createLogger(I,y))}consoleLog(I,y){let h=console.log;switch(I){case k.LogLevel.Error:h=console.error;break;case k.LogLevel.Warning:h=console.warn;break;case k.LogLevel.Info:h=console.info;break}h.call(console,...y)}log(I,y){const h=this.loggers.get(I.toString());if(!h)throw new Error("Create the logger before logging");for(const[g,P]of y)switch(g){case k.LogLevel.Trace:h.trace(P);break;case k.LogLevel.Debug:h.debug(P);break;case k.LogLevel.Info:h.info(P);break;case k.LogLevel.Warning:h.warn(P);break;case k.LogLevel.Error:h.error(P);break;case k.LogLevel.Critical:h.critical(P);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class f extends k.AbstractLoggerService{constructor(I,y,h){super(I,y);this.channel=h}createConsoleMainLogger(){return new k.AdapterLogger({log:(I,y)=>{this.channel.call("consoleLog",[I,y])}})}doCreateLogger(I,y,h){return new m(this.channel,I,y,h)}}e.LoggerChannelClient=f;class m extends k.AbstractMessageLogger{constructor(I,y,h,g){super(g?.always);this.channel=I,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[y,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,y){const h=[[I,y]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(I){this.channel.call("log",[this.file,I])}}class t extends k.LogService{constructor(I,y){super(y);this.parent=I,this._register(I.onDidChangeLogLevel(h=>y.setLevel(h)))}setLevel(I){super.setLevel(I),this.parent.setLevel(I)}}e.FollowerLogService=t}),define(J[92],Z([0,1,19,6]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(f,m,t,b){try{const I=await new Promise((y,h)=>{q(["spdlog"],y,h)});return I.setFlushOn(A.LogLevel.Trace),I.createAsyncRotatingLogger(f,m,t,b)}catch(I){console.error(I)}return null}function M(f,m,t,b){const I=q.__$__nodeRequire("spdlog");return I.setFlushOn(A.LogLevel.Trace),I.createRotatingLogger(f,m,t,b)}e.createRotatingLogger=M;function S(f,m,t){switch(m){case A.LogLevel.Trace:f.trace(t);break;case A.LogLevel.Debug:f.debug(t);break;case A.LogLevel.Info:f.info(t);break;case A.LogLevel.Warning:f.warn(t);break;case A.LogLevel.Error:f.error(t);break;case A.LogLevel.Critical:f.critical(t);break;default:throw new Error("Invalid log level")}}class n extends A.AbstractMessageLogger{constructor(m,t,b,I){super();this.name=m,this.filepath=t,this.rotating=b,this.buffer=[],this.setLevel(I),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}_createSpdLogLogger(){const m=this.rotating?6:1,t=30/m*w.ByteSize.MB;return k(this.name,this.filepath,t,m).then(b=>{if(b){this._logger=b,this._logger.setLevel(this.getLevel());for(const{level:I,message:y}of this.buffer)S(this._logger,I,y);this.buffer=[]}})}log(m,t){this._logger?S(this._logger,m,t):this.getLevel()<=m&&this.buffer.push({level:m,message:t})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(J[181],Z([0,1,10,15,28,19,179,6,92]),function(q,e,w,A,k,M,S,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let m=class extends n.AbstractLoggerService{constructor(b,I){super(b.getLevel(),b.onDidChangeLogLevel);this.fileService=I}doCreateLogger(b,I,y){if(b.scheme===w.Schemas.file){const h=new f.SpdLogLogger(y?.name||(0,k.generateUuid)(),b.fsPath,!y?.donotRotate,I);return y?.donotUseFormatters&&h.clearFormatters(),h}else return new S.FileLogger(y?.name??(0,A.basename)(b),b,I,!!y?.donotUseFormatters,this.fileService)}};m=ue([te(0,n.ILogService),te(1,M.IFileService)],m),e.LoggerService=m}),define(J[182],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function w(S){return S.submenu!==void 0}e.isMenubarMenuItemSubmenu=w;function A(S){return S.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=A;function k(S){return S.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function M(S){return!w(S)&&!A(S)&&!k(S)}e.isMenubarMenuItemAction=M}),define(J[48],Z([0,1,10,3,31,15]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let S;if(typeof A.globals.vscode!="undefined"&&typeof A.globals.vscode.context!="undefined"){const n=A.globals.vscode.context.configuration();if(n)S=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof q?.__$__nodeRequire=="function"){const n=(0,M.dirname)(w.FileAccess.asFileUri("",q));S=q.__$__nodeRequire((0,M.joinPath)(n,"product.json").fsPath);const f=q.__$__nodeRequire((0,M.joinPath)(n,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(S,{nameShort:`${S.nameShort} Dev`,nameLong:`${S.nameLong} Dev`,dataFolderName:`${S.dataFolderName}-dev`}),Object.assign(S,{version:f.version})}else S={},Object.keys(S).length===0&&Object.assign(S,{version:"1.60.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=S}),define(J[93],Z([0,1,17,16,141,19,48]),function(q,e,w,A,k,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(b,I,y,h,g,P){let v;try{await f(b,I,y,h,g,P)}catch(u){v=u}finally{v&&g.errorTransformer&&(v=g.errorTransformer(v)),typeof v!="undefined"&&y.error(v),y.end()}}e.readFileIntoStream=n;async function f(b,I,y,h,g,P){m(P);const v=await b.open(I,{create:!1});try{m(P);let u=0,d=0,a=g&&typeof g.length=="number"?g.length:void 0,c=w.VSBuffer.alloc(Math.min(g.bufferSize,typeof a=="number"?a:g.bufferSize)),i=g&&typeof g.position=="number"?g.position:0,s=0;do d=await b.read(v,i,c.buffer,s,c.byteLength-s),i+=d,s+=d,u+=d,typeof a=="number"&&(a-=d),s===c.byteLength&&(await y.write(h(c)),c=w.VSBuffer.alloc(Math.min(g.bufferSize,typeof a=="number"?a:g.bufferSize)),s=0);while(d>0&&(typeof a!="number"||a>0)&&m(P)&&t(u,g));if(s>0){let r=s;typeof a=="number"&&(r=Math.min(s,a)),y.write(h(c.slice(0,r)))}}catch(u){throw(0,M.ensureFileSystemProviderError)(u)}finally{await b.close(v)}}function m(b){if(b.isCancellationRequested)throw(0,A.canceled)();return!0}function t(b,I){if(I?.limits){if(typeof I.limits.memory=="number"&&b>I.limits.memory)throw(0,M.createFileSystemProviderError)((0,k.localize)(0,null,S.default.nameShort),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&b>I.limits.size)throw(0,M.createFileSystemProviderError)((0,k.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[183],Z([0,1,34,9,17,24,5,63,2,37,10,72,15,64,139,19,93,6]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class Ve extends f.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new S.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new S.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new S.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new S.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new S.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new S.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new A.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new g.FileChangesEvent(c,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new A.ThrottledWorker(Ve.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ve.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ve.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new g.FileChangesEvent(c,!0)))),this.watchedResources=m.TernarySearchTree.forUris(c=>{const i=this.getProvider(c.scheme);return i?!this.isPathCaseSensitive(i):!1}),this.writeQueue=this._register(new A.ResourceQueue)}registerProvider(a,c){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:c});const i=new f.DisposableStore;return i.add(c.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(c)))),i.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:a}))),typeof c.onDidErrorOccur=="function"&&i.add(c.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:c}),this.provider.delete(a),(0,f.dispose)(i)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(i){c.push(i)}}),!this.provider.has(a)&&await A.Promises.settled(c)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,c){const i=this.provider.get(a.scheme);return!!(i&&i.capabilities&c)}listCapabilities(){return n.Iterable.map(this.provider,([a,c])=>({scheme:a,capabilities:c.capabilities}))}async withProvider(a){if(!(0,I.isAbsolutePath)(a))throw new g.FileOperationError((0,h.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const c=this.provider.get(a.scheme);if(!c){const i=new Error;throw i.name="ENOPRO",i.message=(0,h.localize)(1,null,a.toString()),i}return c}async withReadProvider(a){const c=await this.withProvider(a);if((0,g.hasOpenReadWriteCloseCapability)(c)||(0,g.hasReadWriteCapability)(c)||(0,g.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const c=await this.withProvider(a);if((0,g.hasOpenReadWriteCloseCapability)(c)||(0,g.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,c){try{return await this.doResolveFile(a,c)}catch(i){throw(0,g.toFileSystemProviderErrorCode)(i)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,h.localize)(2,null,this.resourceForError(a)),1):(0,g.ensureFileSystemProviderError)(i)}}async doResolveFile(a,c){const i=await this.withProvider(a),s=this.isPathCaseSensitive(i),r=c?.resolveTo,o=c?.resolveSingleChildDescendants,l=c?.resolveMetadata,p=await i.stat(a);let E;return this.toFileStat(i,a,p,void 0,!!l,(L,T)=>{if(!E&&(E=m.TernarySearchTree.forUris(()=>!s),E.set(a,!0),r))for(const W of r)E.set(W,!0);return E.get(L.resource)||E.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&o?T===1:!1})}async toFileStat(a,c,i,s,r,o){const{providerExtUri:l}=this.getExtUri(a),p={resource:c,name:l.basename(c),isFile:(i.type&g.FileType.File)!=0,isDirectory:(i.type&g.FileType.Directory)!=0,isSymbolicLink:(i.type&g.FileType.SymbolicLink)!=0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&g.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,g.etag)({mtime:i.mtime,size:i.size})};if(p.isDirectory&&o(p,s)){try{const E=await a.readdir(c),L=await A.Promises.settled(E.map(async([T,W])=>{try{const C=l.joinPath(c,T),V=r?await a.stat(C):{type:W};return await this.toFileStat(a,C,V,E.length,r,o)}catch(C){return this.logService.trace(C),null}}));p.children=(0,w.coalesce)(L)}catch(E){this.logService.trace(E),p.children=[]}return p}return p}async resolveAll(a){return A.Promises.settled(a.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async exists(a){const c=await this.withProvider(a);try{return!!await c.stat(a)}catch(i){return!1}}async canCreateFile(a,c){try{await this.doValidateCreateFile(a,c)}catch(i){return i}return!0}async doValidateCreateFile(a,c){if(!c?.overwrite&&await this.exists(a))throw new g.FileOperationError((0,h.localize)(3,null,this.resourceForError(a)),3,c)}async createFile(a,c=k.VSBuffer.fromString(""),i){await this.doValidateCreateFile(a,i);const s=await this.writeFile(a,c);return this._onDidRunOperation.fire(new g.FileOperationEvent(a,0,s)),s}async writeFile(a,c,i){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:r}=this.getExtUri(s);try{await this.validateWriteFile(s,a,i)||await this.mkdirp(s,r.dirname(a));let l;if((0,g.hasReadWriteCapability)(s)&&!(c instanceof k.VSBuffer))if((0,y.isReadableStream)(c)){const p=await(0,y.peekStream)(c,3);p.ended?l=k.VSBuffer.concat(p.buffer):l=p}else l=(0,y.peekReadable)(c,p=>k.VSBuffer.concat(p),3);else l=c;!(0,g.hasOpenReadWriteCloseCapability)(s)||(0,g.hasReadWriteCapability)(s)&&l instanceof k.VSBuffer?await this.doWriteUnbuffered(s,a,i,l):await this.doWriteBuffered(s,a,i,l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l)}catch(o){throw new g.FileOperationError((0,h.localize)(4,null,this.resourceForError(a),(0,g.ensureFileSystemProviderError)(o).toString()),(0,g.toFileOperationResult)(o),i)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,c,i){if(!!i?.unlock&&!(a.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(c)));let r;try{r=await a.stat(c)}catch(o){return}if((r.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,h.localize)(6,null,this.resourceForError(c)),0,i);if(this.throwIfFileIsReadonly(c,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==g.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,g.etag)({mtime:i.mtime,size:r.size}))throw new g.FileOperationError((0,h.localize)(7,null),3,i);return r}async readFile(a,c){const i=await this.withReadProvider(a);return c?.atomic?this.doReadFileAtomic(i,a,c):this.doReadFile(i,a,c)}async doReadFileAtomic(a,c,i){return new Promise((s,r)=>{this.writeQueue.queueFor(c,this.getExtUri(a).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(a,c,i);s(o)}catch(o){r(o)}})})}async doReadFile(a,c,i){const s=await this.doReadFileStream(a,c,{...i,preferUnbuffered:!0});return{...s,value:await(0,k.streamToBuffer)(s.value)}}async readFileStream(a,c){const i=await this.withReadProvider(a);return this.doReadFileStream(i,a,c)}async doReadFileStream(a,c,i){const s=new M.CancellationTokenSource,r=this.validateReadFile(c,i).then(l=>l,l=>{throw s.cancel(),l});let o;try{return typeof i?.etag=="string"&&i.etag!==g.ETAG_DISABLED&&await r,!((0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasFileReadStreamCapability)(a))||(0,g.hasReadWriteCapability)(a)&&i?.preferUnbuffered?o=this.readFileUnbuffered(a,c,i):(0,g.hasFileReadStreamCapability)(a)?o=this.readFileStreamed(a,c,s.token,i):o=this.readFileBuffered(a,c,s.token,i),{...await r,value:o}}catch(l){o&&await(0,y.consumeStream)(o);const p=(0,h.localize)(8,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(l).toString());throw l instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(p,l.stat,i):new g.FileOperationError(p,(0,g.toFileOperationResult)(l),i)}}readFileStreamed(a,c,i,s=Object.create(null)){const r=a.readFileStream(c,s,i);return(0,y.transform)(r,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new g.FileOperationError((0,h.localize)(9,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(o).toString()),(0,g.toFileOperationResult)(o),s)},o=>k.VSBuffer.concat(o))}readFileBuffered(a,c,i,s=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,P.readFileIntoStream)(a,c,r,o=>o,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new g.FileOperationError((0,h.localize)(10,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(o).toString()),(0,g.toFileOperationResult)(o),s)},i),r}readFileUnbuffered(a,c,i){const s=(0,y.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r=await a.readFile(c);typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.validateReadFileLimits(c,r.byteLength,i),s.end(k.VSBuffer.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async validateReadFile(a,c){const i=await this.resolve(a,{resolveMetadata:!0});if(i.isDirectory)throw new g.FileOperationError((0,h.localize)(11,null,this.resourceForError(a)),0,c);if(typeof c?.etag=="string"&&c.etag!==g.ETAG_DISABLED&&c.etag===i.etag)throw new g.NotModifiedSinceFileOperationError((0,h.localize)(12,null),i,c);return this.validateReadFileLimits(a,i.size,c),i}validateReadFileLimits(a,c,i){if(i?.limits){let s;if(typeof i.limits.memory=="number"&&c>i.limits.memory&&(s=9),typeof i.limits.size=="number"&&c>i.limits.size&&(s=7),typeof s=="number")throw new g.FileOperationError((0,h.localize)(13,null,this.resourceForError(a)),s)}}async canMove(a,c,i){return this.doCanMoveCopy(a,c,"move",i)}async canCopy(a,c,i){return this.doCanMoveCopy(a,c,"copy",i)}async doCanMoveCopy(a,c,i,s){if(a.toString()!==c.toString())try{const r=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(r,a,o,c,i,s)}catch(r){return r}return!0}async move(a,c,i){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),o=await this.doMoveCopy(s,a,r,c,"move",!!i),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,o==="move"?2:3,l)),l}async copy(a,c,i){const s=await this.withReadProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),o=await this.doMoveCopy(s,a,r,c,"copy",!!i),l=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,o==="copy"?3:2,l)),l}async doMoveCopy(a,c,i,s,r,o){if(c.toString()===s.toString())return r;const{exists:l,isSameResourceWithDifferentPathCase:p}=await this.doValidateMoveCopy(a,c,i,s,r,o);if(l&&!p&&o&&await this.del(s,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(s)),r==="copy"){if(a===i&&(0,g.hasFileFolderCopyCapability)(a))await a.copy(c,s,{overwrite:o});else{const E=await this.resolve(c);E.isDirectory?await this.doCopyFolder(a,E,i,s):await this.doCopyFile(a,c,i,s)}return r}else return a===i?(await a.rename(c,s,{overwrite:o}),r):(await this.doMoveCopy(a,c,i,s,"copy",o),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(a,c,i,s){if((0,g.hasOpenReadWriteCloseCapability)(a)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(a,c,i,s);if((0,g.hasOpenReadWriteCloseCapability)(a)&&(0,g.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(a,c,i,s);if((0,g.hasReadWriteCapability)(a)&&(0,g.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(a,c,i,s);if((0,g.hasReadWriteCapability)(a)&&(0,g.hasReadWriteCapability)(i))return this.doPipeUnbuffered(a,c,i,s)}async doCopyFolder(a,c,i,s){await i.mkdir(s),Array.isArray(c.children)&&await A.Promises.settled(c.children.map(async r=>{const o=this.getExtUri(i).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.doCopyFolder(a,await this.resolve(r.resource),i,o):this.doCopyFile(a,r.resource,i,o)}))}async doValidateMoveCopy(a,c,i,s,r,o){let l=!1;if(a===i){const{providerExtUri:E,isPathCaseSensitive:L}=this.getExtUri(a);if(L||(l=E.isEqual(c,s)),l&&r==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(c),this.resourceForError(s)));if(!l&&E.isEqualOrParent(s,c))throw new Error((0,h.localize)(15,null,this.resourceForError(c),this.resourceForError(s)))}const p=await this.exists(s);if(p&&!l){if(!o)throw new g.FileOperationError((0,h.localize)(16,null,this.resourceForError(c),this.resourceForError(s)),4);if(a===i){const{providerExtUri:E}=this.getExtUri(a);if(E.isEqualOrParent(c,s))throw new Error((0,h.localize)(17,null,this.resourceForError(c),this.resourceForError(s)))}}return{exists:p,isSameResourceWithDifferentPathCase:l}}getExtUri(a){const c=this.isPathCaseSensitive(a);return{providerExtUri:c?I.extUri:I.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(c,a);const i=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,0,i)),i}async mkdirp(a,c){const i=[],{providerExtUri:s}=this.getExtUri(a);for(;!s.isEqual(c,s.dirname(c));)try{if(((await a.stat(c)).type&g.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(c)));break}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(s.basename(c)),c=s.dirname(c)}for(let r=i.length-1;r>=0;r--){c=s.joinPath(c,i[r]);try{await a.mkdir(c)}catch(o){if((0,g.toFileSystemProviderErrorCode)(o)!==g.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(a,c){try{await this.doValidateDelete(a,c)}catch(i){return i}return!0}async doValidateDelete(a,c){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!c?.useTrash&&!(i.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(a)));let r;try{r=await i.stat(a)}catch(l){}if(r)this.throwIfFileIsReadonly(a,r);else throw new g.FileOperationError((0,h.localize)(20,null,this.resourceForError(a)),1);if(!!!c?.recursive){const l=await this.resolve(a);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(a)))}return i}async del(a,c){const i=await this.doValidateDelete(a,c),s=!!c?.useTrash,r=!!c?.recursive;await i.delete(a,{recursive:r,useTrash:s}),this._onDidRunOperation.fire(new g.FileOperationEvent(a,1))}onDidChangeFile(a,c){this._onDidChangeFilesRaw.fire({changes:a});let i,s;{for(const r of a)this.watchedResources.has(r.resource)?(i||(i=[]),i.push(r)):(s||(s=[]),s.push(r));i&&this._onDidFilesChange.fire(new g.FileChangesEvent(i,!c))}if(s){const r=c?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(s)&&Ve.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,c={recursive:!1,excludes:[]}){const i=new f.DisposableStore;{let s=!1,r=()=>{s=!0};i.add((0,f.toDisposable)(()=>r())),this.doWatch(a,c).then(o=>{s?(0,f.dispose)(o):r=()=>(0,f.dispose)(o)},o=>this.logService.error(o))}return c.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),i.add((0,f.toDisposable)(()=>{const s=this.watchedResources.get(a);typeof s=="number"&&(s<=1?this.watchedResources.delete(a):this.watchedResources.set(a,s-1))}))),i}async doWatch(a,c){const i=await this.withProvider(a),s=this.toWatchKey(i,a,c),r=this.activeWatchers.get(s)||{count:0,disposable:i.watch(a,c)};return this.activeWatchers.has(s)||this.activeWatchers.set(s,r),r.count+=1,(0,f.toDisposable)(()=>{r.count--,r.count===0&&((0,f.dispose)(r.disposable),this.activeWatchers.delete(s))})}toWatchKey(a,c,i){const{providerExtUri:s}=this.getExtUri(a);return[s.getComparisonKey(c),String(i.recursive),i.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,f.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,c,i,s){return this.writeQueue.queueFor(c,this.getExtUri(a).providerExtUri).queue(async()=>{const r=await a.open(c,{create:!0,unlock:i?.unlock??!1});try{(0,y.isReadableStream)(s)||(0,y.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(a,r,s):await this.doWriteReadableBufferedQueued(a,r,s)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await a.close(r)}})}async doWriteStreamBufferedQueued(a,c,i){let s=0,r;if((0,y.isReadableBufferedStream)(i)){if(i.buffer.length>0){const o=k.VSBuffer.concat(i.buffer);await this.doWriteBuffer(a,c,o,o.byteLength,s,0),s+=o.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise(async(o,l)=>{(0,y.listenStream)(r,{onData:async p=>{r.pause();try{await this.doWriteBuffer(a,c,p,p.byteLength,s,0)}catch(E){return l(E)}s+=p.byteLength,setTimeout(()=>r.resume())},onError:p=>l(p),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(a,c,i){let s=0,r;for(;(r=i.read())!==null;)await this.doWriteBuffer(a,c,r,r.byteLength,s,0),s+=r.byteLength}async doWriteBuffer(a,c,i,s,r,o){let l=0;for(;l<s;)l+=await a.write(c,r+l,i.buffer,o+l,s-l)}async doWriteUnbuffered(a,c,i,s){return this.writeQueue.queueFor(c,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,c,i,s))}async doWriteUnbufferedQueued(a,c,i,s){let r;s instanceof k.VSBuffer?r=s:(0,y.isReadableStream)(s)?r=await(0,k.streamToBuffer)(s):(0,y.isReadableBufferedStream)(s)?r=await(0,k.bufferedStreamToBuffer)(s):r=(0,k.readableToBuffer)(s),await a.writeFile(c,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(a,c,i,s){return this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,c,i,s))}async doPipeBufferedQueued(a,c,i,s){let r,o;try{r=await a.open(c,{create:!1}),o=await i.open(s,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.BUFFER_SIZE);let p=0,E=0,L=0;do L=await a.read(r,p,l.buffer,E,l.byteLength-E),await this.doWriteBuffer(i,o,l,L,p,E),p+=L,E+=L,E===l.byteLength&&(E=0);while(L>0)}catch(l){throw(0,g.ensureFileSystemProviderError)(l)}finally{await A.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async doPipeUnbuffered(a,c,i,s){return this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,c,i,s))}async doPipeUnbufferedQueued(a,c,i,s){return i.writeFile(s,await a.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,c,i,s){return this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,c,i,s))}async doPipeUnbufferedToBufferedQueued(a,c,i,s){const r=await i.open(s,{create:!0,unlock:!1});try{const o=await a.readFile(c);await this.doWriteBuffer(i,r,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await i.close(r)}}async doPipeBufferedToUnbuffered(a,c,i,s){const r=await(0,k.streamToBuffer)(this.readFileBuffered(a,c,M.CancellationToken.None));await this.doWriteUnbuffered(i,s,void 0,r)}throwIfFileSystemIsReadonly(a,c){if(a.capabilities&2048)throw new g.FileOperationError((0,h.localize)(22,null,this.resourceForError(c)),6);return a}throwIfFileIsReadonly(a,c){if((c.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,h.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===t.Schemas.file?a.fsPath:a.toString(!0)}};u.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},u=ue([te(0,v.ILogService)],u),e.FileService=u}),define(J[184],Z([0,1,34,9,17,5,29,2,8,3,15,64,18,142,19,93,173,163,164,90,166,6]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g,P,v,u,d,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class i extends n.Disposable{constructor(r,o){super();this.logService=r,this.options=o,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=M.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new A.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,m.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:o,symbolicLink:l}=await I.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(o,l),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(r){try{const o=await I.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),l=[];return await Promise.all(o.map(async p=>{try{let E;p.isSymbolicLink()?E=(await this.stat((0,t.joinPath)(r,p.name))).type:E=this.toType(p),l.push([p.name,E])}catch(E){this.logService.trace(E)}})),l}catch(o){throw this.toFileSystemProviderError(o)}}toType(r,o){let l;return o?.dangling?l=h.FileType.Unknown:r.isFile()?l=h.FileType.File:r.isDirectory()?l=h.FileType.Directory:l=h.FileType.Unknown,o&&(l|=h.FileType.SymbolicLink),l}async readFile(r){try{const o=this.toFilePath(r);return await I.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(r,o,l){const p=(0,b.newWriteableStream)(E=>k.VSBuffer.concat(E.map(L=>k.VSBuffer.wrap(L))).buffer);return(0,g.readFileIntoStream)(this,r,p,E=>E.buffer,{...o,bufferSize:this.BUFFER_SIZE},l),p}async writeFile(r,o,l){let p;try{const E=this.toFilePath(r);if(!l.create||!l.overwrite){if(await I.Promises.exists(E)){if(!l.overwrite)throw(0,h.createFileSystemProviderError)((0,y.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,h.createFileSystemProviderError)((0,y.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(r,{create:!0,unlock:l.unlock}),await this.write(p,0,o,0,o.byteLength)}catch(E){throw await this.toFileSystemProviderWriteError(r,E)}finally{typeof p=="number"&&await this.close(p)}}async open(r,o){try{const l=this.toFilePath(r);if((0,h.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:L}=await I.SymlinkSupport.stat(l);L.mode&128||await I.Promises.chmod(l,L.mode|128)}catch(L){this.logService.trace(L)}let p;if((0,h.isFileOpenForWriteOptions)(o)){if(m.isWindows)try{await I.Promises.truncate(l,0),p="r+"}catch(L){L.code!=="ENOENT"&&this.logService.trace(L)}p||(p="w")}else p="r";const E=await I.Promises.open(l,p);return this.mapHandleToPos.set(E,0),(0,h.isFileOpenForWriteOptions)(o)&&this.writeHandles.set(E,r),E}catch(l){throw(0,h.isFileOpenForWriteOptions)(o)?await this.toFileSystemProviderWriteError(r,l):this.toFileSystemProviderError(l)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await I.Promises.fdatasync(r)}catch(o){this.canFlush=!1,this.logService.error(o)}return await I.Promises.close(r)}catch(o){throw this.toFileSystemProviderError(o)}}async read(r,o,l,p,E){const L=this.normalizePos(r,o);let T=null;try{const W=await I.Promises.read(r,l,p,E,L);return typeof W=="number"?T=W:T=W.bytesRead,T}catch(W){throw this.toFileSystemProviderError(W)}finally{this.updatePos(r,L,T)}}normalizePos(r,o){return o===this.mapHandleToPos.get(r)?null:o}updatePos(r,o,l){const p=this.mapHandleToPos.get(r);typeof p=="number"&&(typeof o=="number"||(typeof l=="number"?this.mapHandleToPos.set(r,p+l):this.mapHandleToPos.delete(r)))}async write(r,o,l,p,E){return(0,A.retry)(()=>this.doWrite(r,o,l,p,E),100,3)}async doWrite(r,o,l,p,E){const L=this.normalizePos(r,o);let T=null;try{const W=await I.Promises.write(r,l,p,E,L);return typeof W=="number"?T=W:T=W.bytesWritten,T}catch(W){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),W)}finally{this.updatePos(r,L,T)}}async mkdir(r){try{await I.Promises.mkdir(this.toFilePath(r))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(r,o){try{const l=this.toFilePath(r);await this.doDelete(l,o)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(r,o){o.recursive?await I.Promises.rm(r,I.RimRafMode.MOVE):await I.Promises.unlink(r)}async rename(r,o,l){const p=this.toFilePath(r),E=this.toFilePath(o);if(p!==E)try{await this.validateTargetDeleted(r,o,"move",l.overwrite),await I.Promises.move(p,E)}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,y.localize)(2,null,(0,f.basename)(p),(0,f.basename)((0,f.dirname)(E)),L.toString()))),this.toFileSystemProviderError(L)}}async copy(r,o,l){const p=this.toFilePath(r),E=this.toFilePath(o);if(p!==E)try{await this.validateTargetDeleted(r,o,"copy",l.overwrite),await I.Promises.copy(p,E,{preserveSymlinks:!0})}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,y.localize)(3,null,(0,f.basename)(p),(0,f.basename)((0,f.dirname)(E)),L.toString()))),this.toFileSystemProviderError(L)}}async validateTargetDeleted(r,o,l,p){const E=this.toFilePath(r),L=this.toFilePath(o);let T=!1;if(!!(this.capabilities&1024)||(T=(0,S.isEqual)(E,L,!0)),T&&l==="copy")throw(0,h.createFileSystemProviderError)((0,y.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!T&&await I.Promises.exists(L)){if(!p)throw(0,h.createFileSystemProviderError)((0,y.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(r,o){return o.recursive?this.watchRecursive(r,o.excludes):this.watchNonRecursive(r)}watchRecursive(r,o){const l={path:this.toFilePath(r),excludes:o},p=(0,w.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,n.toDisposable)(()=>{p(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof v.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,o;this.options?.watcher?.usePolling?(r=u.FileWatcher,o=this.options?.watcher):this.recursiveFoldersToWatch.length===1?m.isWindows?r=a.FileWatcher:r=u.FileWatcher:r=v.FileWatcher,this.recursiveWatcher=new r(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,d.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===c.LogLevel.Trace,o),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)}))}}watchNonRecursive(r){const o=new P.FileWatcher(this.toFilePath(r),p=>this._onDidChangeFile.fire((0,d.toFileChanges)(p)),p=>{p.type==="error"&&this._onDidWatchErrorOccur.fire(p.message),this.logService[p.type](p.message)},this.logService.getLevel()===c.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)});return(0,n.combinedDisposable)(o,l)}toFilePath(r){return(0,f.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof h.FileSystemProviderError)return r;let o;switch(r.code){case"ENOENT":o=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=h.FileSystemProviderErrorCode.NoPermissions;break;default:o=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(r,o)}async toFileSystemProviderWriteError(r,o){let l=this.toFileSystemProviderError(o);if(r&&l.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:p}=await I.SymlinkSupport.stat(this.toFilePath(r));p.mode&128||(l=(0,h.createFileSystemProviderError)(o,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(p){this.logService.trace(p)}return l}dispose(){super.dispose(),(0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,n.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=i}),define(J[20],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService")}),define(J[185],Z([0,1,58,6,20]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(n,f){this.productService=n,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(f);if(!m)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,t,b]=m;let I=this.trustedExtensionUrlPublicKeys.get(n);if(!I){if(I=this.productService.trustedExtensionUrlPublicKeys[n],!I||I.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...I])}const y=Buffer.from(decodeURIComponent(b),"base64");if(y.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const h=y.slice(0,6),g=y.readUIntBE(0,6),P=Date.now()-g;if(P<0||P>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const v=y.slice(6),u=w.createVerify("SHA256");u.write(h),u.write(Buffer.from(t)),u.end();for(let d=0;d<I.length;d++){let a=I[d];if(a!==null){if(typeof a=="string")try{a=w.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),I[d]=a}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${d+1} for ${n}:`,c),I[d]=null;continue}if(u.verify(a,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};M=ue([te(0,k.IProductService),te(1,A.ILogService)],M),e.ExtensionUrlTrustService=M}),define(J[55],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,w.createDecorator)("protocolMainService")}),define(J[186],Z([0,1,14,2,37,10,3,15,7,28,47,6]),function(q,e,w,A,k,M,S,n,f,m,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let I=class extends A.Disposable{constructor(h,g){super();this.logService=g,this.validRoots=k.TernarySearchTree.forUris(()=>!S.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(f.URI.file(h.appRoot)),this.addValidFileRoot(f.URI.file(h.extensionsPath)),this.addValidFileRoot(h.globalStorageHome),this.addValidFileRoot(h.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:h}=w.session;h.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(g,P)=>this.handleResourceRequest(g,P)),h.protocol.interceptFileProtocol(M.Schemas.file,(g,P)=>this.handleFileRequest(g,P)),this._register((0,A.toDisposable)(()=>{h.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),h.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(h){return this.validRoots.get(h)?A.Disposable.None:(this.validRoots.set(h,!0),(0,A.toDisposable)(()=>this.validRoots.delete(h)))}handleFileRequest(h,g){const P=f.URI.parse(h.url);return this.logService.error(`Refused to load resource ${P.fsPath} from ${M.Schemas.file}: protocol (original URL: ${h.url})`),g({error:-3})}handleResourceRequest(h,g){const P=f.URI.parse(h.url),v=M.FileAccess.asFileUri(P);return this.validRoots.findSubstr(v)?g({path:v.fsPath}):this.validExtensions.has((0,n.extname)(v))?g({path:v.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${v.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${h.url})`),g({error:-3}))}createIPCObjectUrl(){let h;const g=f.URI.from({scheme:"vscode",path:(0,m.generateUuid)()}),P=g.toString(),v=async()=>h;return w.ipcMain.handle(P,v),this.logService.trace(`IPC Object URL: Registered new channel ${P}.`),{resource:g,update:u=>h=u,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${P}.`),w.ipcMain.removeHandler(P)}}}};I=ue([te(0,t.INativeEnvironmentService),te(1,b.ILogService)],I),e.ProtocolMainService=I}),define(J[38],Z([0,1,102,13]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(S,n){w.ok(A.isString(S)),w.ok(A.isObject(n)),w.ok(!this.data.has(S),"There is already an extension with this id"),this.data.set(S,n)}knows(S){return this.data.has(S)}as(S){return this.data.get(S)||null}}e.Registry=new k}),define(J[187],Z([0,1,5,38]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class M{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,m){this.schemasById[k(f)]=m,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const S=new M;A.Registry.add(e.Extensions.JSONContribution,S)}),define(J[49],Z([0,1,5,13,132,187,38]),function(q,e,w,A,k,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var n;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(n=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var f;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const m=S.Registry.as(M.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new w.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new w.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(u,d=!0){this.registerConfigurations([u],d)}registerConfigurations(u,d=!0){const a=[];u.forEach(c=>{a.push(...this.validateAndRegisterProperties(c,d,c.extensionInfo)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterConfigurations(u){const d=[],a=c=>{if(c.properties)for(const i in c.properties)d.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,c.properties[i]);c.allOf&&c.allOf.forEach(i=>a(i))};for(const c of u){a(c);const i=this.configurationContributors.indexOf(c);i!==-1&&this.configurationContributors.splice(i,1)}m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}registerDefaultConfigurations(u){const d=[],a=[];for(const c of u)for(const i in c)if(d.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...c[i]};const s={type:"object",default:this.defaultValues[i],description:k.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};a.push(I(i)),this.configurationProperties[i]=s,this.defaultLanguageConfigurationOverridesNode.properties[i]=s}else{this.defaultValues[i]=c[i];const s=this.configurationProperties[i];s&&(this.updatePropertyDefaultValue(i,s),this.updateSchema(i,s))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterDefaultConfigurations(u){const d=[];for(const a of u)for(const c in a)if(d.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const i=this.configurationProperties[c];i&&(this.updatePropertyDefaultValue(c,i),this.updateSchema(c,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const d of u)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(u,d=!0,a,c=3){c=A.isUndefinedOrNull(u.scope)?c:u.scope;let i=[],s=u.properties;if(s)for(let o in s){if(d&&g(o)){delete s[o];continue}const l=s[o];if(this.updatePropertyDefaultValue(o,l),e.OVERRIDE_PROPERTY_PATTERN.test(o)?l.scope=void 0:(l.scope=A.isUndefinedOrNull(l.scope)?c:l.scope,l.restricted=A.isUndefinedOrNull(l.restricted)?!!a?.restrictedConfigurations?.includes(o):l.restricted),s[o].hasOwnProperty("included")&&!s[o].included){this.excludedConfigurationProperties[o]=s[o],delete s[o];continue}else this.configurationProperties[o]=s[o];!s[o].deprecationMessage&&s[o].markdownDeprecationMessage&&(s[o].deprecationMessage=s[o].markdownDeprecationMessage),i.push(o)}let r=u.allOf;if(r)for(let o of r)i.push(...this.validateAndRegisterProperties(o,d,a,c));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(u){const d=a=>{let c=a.properties;if(c)for(const s in c)this.updateSchema(s,c[s]);let i=a.allOf;i&&i.forEach(d)};d(u)}updateSchema(u,d){switch(e.allSettings.properties[u]=d,d.scope){case 1:e.applicationSettings.properties[u]=d;break;case 2:e.machineSettings.properties[u]=d;break;case 6:e.machineOverridableSettings.properties[u]=d;break;case 3:e.windowSettings.properties[u]=d;break;case 4:e.resourceSettings.properties[u]=d;break;case 5:e.resourceSettings.properties[u]=d,this.resourceLanguageSettingsSchema.properties[u]=d;break}}removeFromSchema(u,d){switch(delete e.allSettings.properties[u],d.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const d=`[${u}]`,a={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,a),e.allSettings.properties[d]=a,e.applicationSettings.properties[d]=a,e.machineSettings.properties[d]=a,e.machineOverridableSettings.properties[d]=a,e.windowSettings.properties[d]=a,e.resourceSettings.properties[d]=a}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,d){let a=this.defaultValues[u];A.isUndefined(a)&&(a=d.default),A.isUndefined(a)&&(a=y(d.type)),d.default=a}}const b="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(b);function I(v){return v.substring(1,v.length-1)}e.overrideIdentifierFromKey=I;function y(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const h=new t;S.Registry.add(e.Extensions.Configuration,h);function g(v){return v.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(v)?k.localize(5,null,v):h.getConfigurationProperties()[v]!==void 0?k.localize(6,null,v):null:k.localize(4,null)}e.validateProperty=g;function P(){const v=[],u=h.getConfigurationProperties();for(const d of Object.keys(u))v.push([d,u[d].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=P}),define(J[21],Z([0,1,44,13,7,49,4,38]),function(q,e,w,A,k,M,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function f(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof k.URI)}e.isConfigurationOverrides=f;var m;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(m=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function b(s,r){const o=r?s?r.keys.filter(C=>s.keys.indexOf(C)===-1):[...r.keys]:[],l=s?r?s.keys.filter(C=>r.keys.indexOf(C)===-1):[...s.keys]:[],p=[];if(r&&s){for(const C of s.keys)if(r.keys.indexOf(C)!==-1){const V=v(s.contents,C),x=v(r.contents,C);w.equals(V,x)||p.push(C)}}const E=[],L=C=>{const V={};for(const x of C)for(const se of x.identifiers)V[c(se)]=x;return V},T=r?L(r.overrides):{},W=s?L(s.overrides):{};if(Object.keys(T).length)for(const C of o){const V=T[C];V&&E.push([(0,M.overrideIdentifierFromKey)(C),V.keys])}if(Object.keys(W).length)for(const C of l){const V=W[C];V&&E.push([(0,M.overrideIdentifierFromKey)(C),V.keys])}if(Object.keys(T).length&&Object.keys(W).length)for(const C of p){const V=W[C],x=T[C];if(V&&x){const se=b({contents:V.contents,keys:V.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});E.push([(0,M.overrideIdentifierFromKey)(C),[...se.added,...se.removed,...se.updated]])}}return{added:o,removed:l,updated:p,overrides:E}}e.compare=b;function I(s,r){const o=[];for(const l of Object.keys(s))if(M.OVERRIDE_PROPERTY_PATTERN.test(l)){const p={};for(const E in s[l])p[E]=s[l][E];o.push({identifiers:[(0,M.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(p),contents:y(p,r)})}return o}e.toOverrides=I;function y(s,r){const o=Object.create(null);for(let l in s)h(o,l,s[l],r);return o}e.toValuesTree=y;function h(s,r,o,l){const p=r.split("."),E=p.pop();let L=s;for(let T=0;T<p.length;T++){let W=p[T],C=L[W];switch(typeof C){case"undefined":C=L[W]=Object.create(null);break;case"object":break;default:l(`Ignoring ${r} as ${p.slice(0,T+1).join(".")} is ${JSON.stringify(C)}`);return}L=C}if(typeof L=="object"&&L!==null)try{L[E]=o}catch(T){l(`Ignoring ${r} as ${p.join(".")} is ${JSON.stringify(L)}`)}else l(`Ignoring ${r} as ${p.join(".")} is ${JSON.stringify(L)}`)}e.addToValueTree=h;function g(s,r){const o=r.split(".");P(s,o)}e.removeFromValueTree=g;function P(s,r){const o=r.shift();if(r.length===0){delete s[o];return}if(Object.keys(s).indexOf(o)!==-1){const l=s[o];typeof l=="object"&&!Array.isArray(l)&&(P(l,r),Object.keys(l).length===0&&delete s[o])}}function v(s,r,o){function l(L,T){let W=L;for(const C of T){if(typeof W!="object"||W===null)return;W=W[C]}return W}const p=r.split("."),E=l(s,p);return typeof E=="undefined"?o:E}e.getConfigurationValue=v;function u(s,r,o){Object.keys(r).forEach(l=>{l!=="__proto__"&&(l in s?A.isObject(s[l])&&A.isObject(r[l])?u(s[l],r[l],o):o&&(s[l]=r[l]):s[l]=r[l])})}e.merge=u;function d(){const s=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=d;function a(){const s=Object.create(null),r=n.Registry.as(M.Extensions.Configuration).getConfigurationProperties();for(let o in r){let l=r[o].default;h(s,o,l,p=>console.error(`Conflict in default settings: ${p}`))}return s}e.getDefaultValues=a;function c(s){return`[${s}]`}e.keyFromOverrideIdentifier=c;function i(s,r,o){const l=s.inspect(r),p=s.inspect(o);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:l.defaultValue}e.getMigratedSettingValue=i}),define(J[188],Z([0,1,34,5,40,2,37,44,13,7,21,49,38]),function(q,e,w,A,k,M,S,n,f,m,t,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(i={},s=[],r=[]){this._contents=i,this._keys=s,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,s){const r=this.getContentsForOverrideIdentifer(s);return r?i?(0,t.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const s of this.overrides)if(s.identifiers.indexOf(i)!==-1)return s.keys;return[]}override(i){const s=this.getContentsForOverrideIdentifer(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const o of w.distinct([...Object.keys(this.contents),...Object.keys(s)])){let l=this.contents[o],p=s[o];p&&(typeof l=="object"&&typeof p=="object"?(l=n.deepClone(l),this.mergeContents(l,p)):l=p),r[o]=l}return new y(r,this.keys,this.overrides)}merge(...i){const s=n.deepClone(this.contents),r=n.deepClone(this.overrides),o=[...this.keys];for(const l of i){this.mergeContents(s,l.contents);for(const p of l.overrides){const[E]=r.filter(L=>w.equals(L.identifiers,p.identifiers));E?this.mergeContents(E.contents,p.contents):r.push(n.deepClone(p))}for(const p of l.keys)o.indexOf(p)===-1&&o.push(p)}return new y(s,o,r)}freeze(){return this.isFrozen=!0,this}mergeContents(i,s){for(const r of Object.keys(s)){if(r in i&&f.isObject(i[r])&&f.isObject(s[r])){this.mergeContents(i[r],s[r]);continue}i[r]=n.deepClone(s[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?n.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const s of this.overrides)if(s.identifiers.indexOf(i)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,s){this.addKey(i),(0,t.addToValueTree)(this.contents,i,s,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let s=this.keys.length;for(let r=0;r<s;r++)i.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,i)}removeKey(i){let s=this.keys.indexOf(i);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=y;class h extends y{constructor(){const i=(0,t.getDefaultValues)(),s=(0,t.getConfigurationKeys)(),r=[];for(const o of Object.keys(i))b.OVERRIDE_PROPERTY_PATTERN.test(o)&&r.push({identifiers:[(0,b.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(i[o]),contents:(0,t.toValuesTree)(i[o],l=>console.error(`Conflict in default settings file: ${l}`))});super(i,s,r)}}e.DefaultConfigurationModel=h;class g{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,s){if(!f.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,s)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,s){this._raw=i;const{contents:r,keys:o,overrides:l,restricted:p}=this.doParseRaw(i,s);this._configurationModel=new y(r,o,l),this._restrictedConfigurations=p||[]}doParseContent(i){let s={},r=null,o=[],l=[],p=[];function E(T){Array.isArray(o)?o.push(T):r!==null&&(o[r]=T)}let L={onObjectBegin:()=>{let T={};E(T),l.push(o),o=T,r=null},onObjectProperty:T=>{r=T},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{let T=[];E(T),l.push(o),o=T,r=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:E,onError:(T,W,C)=>{p.push({error:T,offset:W,length:C})}};if(i)try{k.visit(i,L),s=o[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return s}doParseRaw(i,s){const r=I.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,r,!0,s);i=o.raw;const l=(0,t.toValuesTree)(i,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),p=Object.keys(i),E=(0,t.toOverrides)(i,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:l,keys:p,overrides:E,restricted:o.restricted}}filter(i,s,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[]};const l={},p=[];for(let E in i)if(b.OVERRIDE_PROPERTY_PATTERN.test(E)&&r){const L=this.filter(i[E],s,!1,o);l[E]=L.raw,p.push(...L.restricted)}else{const L=s[E],T=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&p.push(E),(T===void 0||o.scopes===void 0||o.scopes.includes(T))&&(o.skipRestricted&&L?.restricted||(l[E]=i[E]))}return{raw:l,restricted:p}}}e.ConfigurationModelParser=g;class P extends M.Disposable{constructor(i,s,r,o){super();this.userSettingsResource=i,this.scopes=s,this.fileService=o,this._onDidChange=this._register(new A.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(A.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class v{constructor(i,s,r=new y,o=new y,l=new S.ResourceMap,p=new y,E=new S.ResourceMap,L=!0){this._defaultConfiguration=i,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=o,this._folderConfigurations=l,this._memoryConfiguration=p,this._memoryConfigurationByResource=E,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new S.ResourceMap,this._userConfiguration=null}getValue(i,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(i)}updateValue(i,s,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new y,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,s===void 0?o.removeValue(i):o.setValue(i,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,s,r){const o=this.getConsolidateConfigurationModel(s,r),l=this.getFolderConfigurationModelForResource(s.resource,r),p=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,E=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),L=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),T=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),W=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),C=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,V=l?s.overrideIdentifier?l.freeze().override(s.overrideIdentifier).getValue(i):l.freeze().getValue(i):void 0,x=s.overrideIdentifier?p.override(s.overrideIdentifier).getValue(i):p.getValue(i),se=o.getValue(i),G=w.distinct(w.flatten(o.overrides.map(Q=>Q.identifiers))).filter(Q=>o.getOverrideValue(i,Q)!==void 0);return{defaultValue:E,userValue:L,userLocalValue:T,userRemoteValue:W,workspaceValue:C,workspaceFolderValue:V,memoryValue:x,value:se,default:E!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userRemote:W!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspace:C!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspaceFolder:V!==void 0?{value:l?.freeze().getValue(i),override:s.overrideIdentifier?l?.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:p.getValue(i),override:s.overrideIdentifier?p.getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(i){const s=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,s){this._folderConfigurations.set(i,s),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const r=s.filter(o=>b.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const l=(0,b.overrideIdentifierFromKey)(o),p=this._defaultConfiguration.getKeysForOverrideIdentifier(l),E=i.getKeysForOverrideIdentifier(l),L=[...E.filter(T=>p.indexOf(T)===-1),...p.filter(T=>E.indexOf(T)===-1),...p.filter(T=>!n.equals(this._defaultConfiguration.override(l).getValue(T),i.override(l).getValue(T)))];return[l,L]});return this.updateDefaultConfiguration(i),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:r,removed:o,overrides:l}=(0,t.compare)(this.localUserConfiguration,i),p=[...s,...r,...o];return p.length&&this.updateLocalUserConfiguration(i),{keys:p,overrides:l}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:r,removed:o,overrides:l}=(0,t.compare)(this.remoteUserConfiguration,i);let p=[...s,...r,...o];return p.length&&this.updateRemoteUserConfiguration(i),{keys:p,overrides:l}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:r,removed:o,overrides:l}=(0,t.compare)(this.workspaceConfiguration,i);let p=[...s,...r,...o];return p.length&&this.updateWorkspaceConfiguration(i),{keys:p,overrides:l}}compareAndUpdateFolderConfiguration(i,s){const r=this.folderConfigurations.get(i),{added:o,updated:l,removed:p,overrides:E}=(0,t.compare)(r,s);let L=[...o,...l,...p];return(L.length||!r)&&this.updateFolderConfiguration(i,s),{keys:L,overrides:E}}compareAndDeleteFolderConfiguration(i){const s=this.folderConfigurations.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:o,removed:l,overrides:p}=(0,t.compare)(s,void 0);return{keys:[...r,...o,...l],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,s){let r=this.getConsolidatedConfigurationModelForResource(i,s);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&i){const o=s.getFolder(i);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const l=this._memoryConfigurationByResource.get(i);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let s=this._foldersConsolidatedConfigurations.get(i);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(s=r.merge(o),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(i,s)):s=r}return s}getFolderConfigurationModelForResource(i,s){if(s&&i){const r=s.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,s)=>{const{contents:r,overrides:o,keys:l}=this._folderConfigurations.get(s);return i.push([s,{contents:r,overrides:o,keys:l}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>i.add(s)),this.userConfiguration.freeze().keys.forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o))),[...s.values()]}static parse(i){const s=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),o=this.parseConfigurationModel(i.workspace),l=i.folders.reduce((p,E)=>(p.set(m.URI.revive(E[0]),this.parseConfigurationModel(E[1])),p),new S.ResourceMap);return new v(s,r,new y,o,l,new y,new S.ResourceMap,!1)}static parseConfigurationModel(i){return new y(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=v;function u(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,s=new Map;for(const o of c)o.keys.forEach(l=>i.add(l)),o.overrides.forEach(([l,p])=>{const E=(0,S.getOrSet)(s,l,new Set);p.forEach(L=>E.add(L))});const r=[];return s.forEach((o,l)=>r.push([l,[...o.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=u;class d{constructor(i,s,r,o){this.change=i,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const l=new Set;i.keys.forEach(E=>l.add(E)),i.overrides.forEach(([,E])=>E.forEach(L=>l.add(L))),this.affectedKeys=[...l.values()];const p=new y;this.affectedKeys.forEach(E=>p.setValue(E,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(i,s,this.currentWorkspace);return!n.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(i,s){let r=(0,t.toValuesTree)({[s]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(i=i[o],!i)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=d;class a extends d{constructor(i,s,r,o){super({keys:i.allKeys(),overrides:[]},void 0,i,s);this.source=r,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=a}),define(J[189],Z([0,1,9,5,2,15,21,188,49,38]),function(q,e,w,A,k,M,S,n,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class t extends k.Disposable{constructor(I,y){super();this.settingsResource=I,this._onDidChangeConfiguration=this._register(new A.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new n.UserSettings(this.settingsResource,void 0,M.extUriBiasedIgnorePathCase,y)),this.configuration=new n.Configuration(new n.DefaultConfigurationModel,new n.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const I=await this.userConfiguration.loadConfiguration();this.configuration=new n.Configuration(new n.DefaultConfigurationModel,I)}getConfigurationData(){return this.configuration.toData()}getValue(I,y){const h=typeof I=="string"?I:void 0,g=(0,S.isConfigurationOverrides)(I)?I:(0,S.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(h,g,void 0)}updateValue(I,y,h,g){return Promise.reject(new Error("not supported"))}inspect(I){return this.configuration.inspect(I,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const I=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(I)}onDidChangeUserConfiguration(I){const y=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(I);this.trigger(h,y,1)}onDidDefaultConfigurationChange(I){const y=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new n.DefaultConfigurationModel,I);this.trigger(h,y,6)}trigger(I,y,h){const g=new n.ConfigurationChangeEvent(I,{data:y},this.configuration);g.source=h,g.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(I){switch(I){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=t}),define(J[190],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,w.createDecorator)("remoteAuthorityResolverService");var A;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(A=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(S,n=A.Unknown,f){super(S);this._message=S,this._code=n,this._detail=f,this.isHandled=n===A.NotAvailable&&f===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(S){return S instanceof k&&S._code===A.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof k&&S._code===A.NoResolverFound}static isHandled(S){return S instanceof k&&S.isHandled}}e.RemoteAuthorityResolverError=k}),define(J[191],Z([0,1,9,17,24,16,5,2,28,82,190]),function(q,e,w,A,k,M,S,n,f,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var I;(function(F){F[F.Management=1]="Management",F[F.ExtensionHost=2]="ExtensionHost",F[F.Tunnel=3]="Tunnel"})(I=e.ConnectionType||(e.ConnectionType={}));function y(F){switch(F){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(F){const D=new k.CancellationTokenSource;return setTimeout(()=>D.cancel(),F),D.token}function g(F,D){if(F.isCancellationRequested||D.isCancellationRequested)return k.CancellationToken.Cancelled;const R=new k.CancellationTokenSource;return F.onCancellationRequested(()=>R.cancel()),D.onCancellationRequested(()=>R.cancel()),R.token}class P{constructor(D){this._state="pending",this._disposables=new n.DisposableStore,this.promise=new Promise((R,N)=>{this._resolvePromise=R,this._rejectPromise=N}),D.isCancellationRequested?this._timeout():this._disposables.add(D.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(D){this._state==="pending"?this._disposables.add(D):D.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const D=new Error("Time limit reached");return D.code="ETIMEDOUT",D.syscall="connect",D}resolve(D){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(D))}reject(D){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(D))}}function v(F,D){const R=new P(D);return R.registerDisposable(F.onControlMessage(N=>{const B=JSON.parse(N.toString()),$=U(B);$?R.reject($):R.resolve(B)})),R.promise}function u(F,D,R,N,B,$){const Y=new P($);return D.connect(R,N,B,(ee,ie)=>{Y.didTimeout?(ee&&F.error(ee),ie?.dispose()):ee||!ie?Y.reject(ee):Y.resolve(ie)}),Y.promise}function d(F,D){const R=new P(D);return F.then(N=>{R.didTimeout||R.resolve(N)},N=>{R.didTimeout||R.reject(N)}),R.promise}async function a(F,D,R,N){const B=_(F,D);F.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let $;try{$=await u(F.logService,F.socketFactory,F.host,F.port,`reconnectionToken=${F.reconnectionToken}&reconnection=${F.reconnectionProtocol?"true":"false"}`,N)}catch(oe){throw F.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),F.logService.error(oe),oe}F.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let Y,ee;F.reconnectionProtocol?(F.reconnectionProtocol.beginAcceptReconnection($,null),Y=F.reconnectionProtocol,ee=!1):(Y=new m.PersistentProtocol($,null),ee=!0),F.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const ie={type:"auth",auth:F.connectionToken||"00000000000000000000"};Y.sendControl(A.VSBuffer.fromString(JSON.stringify(ie)));try{const oe=await v(Y,g(N,h(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const le=new Error("Unexpected handshake message");throw le.code="VSCODE_CONNECTION_ERROR",le}F.logService.trace(`${B} 4/6. received SignRequest control message.`);const ce=await d(F.signService.sign(oe.data),N),ne={type:"connectionType",commit:F.commit,signedData:ce,desiredConnectionType:D};return R&&(ne.args=R),F.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(A.VSBuffer.fromString(JSON.stringify(ne))),{protocol:Y,ownsProtocol:ee}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(F.logService.error(`${B} the handshake timed out. Error:`),F.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(F.logService.error(`${B} received error control message when negotiating connection. Error:`),F.logService.error(oe)),ee&&z(Y),oe}}async function c(F,D,R,N){const B=Date.now(),$=_(F,D),{protocol:Y,ownsProtocol:ee}=await a(F,D,R,N),ie=new P(N);return ie.registerDisposable(Y.onControlMessage(oe=>{const ce=JSON.parse(oe.toString()),ne=U(ce);ne?(F.logService.error(`${$} received error control message when negotiating connection. Error:`),F.logService.error(ne),ee&&z(Y),ie.reject(ne)):(F.reconnectionProtocol&&F.reconnectionProtocol.endAcceptReconnection(),F.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${j(B)}!`),ie.resolve({protocol:Y,firstMessage:ce}))})),ie.promise}async function i(F,D){const{protocol:R}=await c(F,1,void 0,D);return{protocol:R}}async function s(F,D,R){const{protocol:N,firstMessage:B}=await c(F,2,D,R),$=B&&B.debugPort;return{protocol:N,debugPort:$}}async function r(F,D,R){const N=Date.now(),B=_(F,3),{protocol:$}=await a(F,3,D,R);return F.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${j(N)}!`),$}async function o(F,D,R){const{host:N,port:B,connectionToken:$}=await F.addressProvider.getAddress();return{commit:F.commit,host:N,port:B,connectionToken:$,reconnectionToken:D,reconnectionProtocol:R,socketFactory:F.socketFactory,signService:F.signService,logService:F.logService}}async function l(F,D,R){try{const N=(0,f.generateUuid)(),B=await o(F,N,null),{protocol:$}=await i(B,k.CancellationToken.None);return new Q(F,D,R,N,$)}catch(N){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(N),G.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(N)),N}}e.connectRemoteAgentManagement=l;async function p(F,D){try{const R=(0,f.generateUuid)(),N=await o(F,R,null),{protocol:B,debugPort:$}=await s(N,D,k.CancellationToken.None);return new O(F,D,R,B,$)}catch(R){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(R),G.triggerPermanentFailure(0,0,t.RemoteAuthorityResolverError.isHandled(R)),R}}e.connectRemoteAgentExtensionHost=p;async function E(F,D,R){const N=await o(F,(0,f.generateUuid)(),null);return await r(N,{host:D,port:R},k.CancellationToken.None)}e.connectRemoteAgentTunnel=E;function L(F){return(0,w.createCancelablePromise)(D=>new Promise((R,N)=>{const B=setTimeout(R,F*1e3);D.onCancellationRequested(()=>{clearTimeout(B),R()})}))}var T;(function(F){F[F.ConnectionLost=0]="ConnectionLost",F[F.ReconnectionWait=1]="ReconnectionWait",F[F.ReconnectionRunning=2]="ReconnectionRunning",F[F.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",F[F.ConnectionGain=4]="ConnectionGain"})(T=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class W{constructor(D,R){this.reconnectionToken=D,this.millisSinceLastIncomingData=R,this.type=0}}e.ConnectionLostEvent=W;class C{constructor(D,R,N,B){this.reconnectionToken=D,this.millisSinceLastIncomingData=R,this.durationSeconds=N,this.cancellableTimer=B,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=C;class V{constructor(D,R,N){this.reconnectionToken=D,this.millisSinceLastIncomingData=R,this.attempt=N,this.type=2}}e.ReconnectionRunningEvent=V;class x{constructor(D,R,N){this.reconnectionToken=D,this.millisSinceLastIncomingData=R,this.attempt=N,this.type=4}}e.ConnectionGainEvent=x;class se{constructor(D,R,N,B){this.reconnectionToken=D,this.millisSinceLastIncomingData=R,this.attempt=N,this.handled=B,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class G extends n.Disposable{constructor(D,R,N,B){super();this._connectionType=D,this._onDidStateChange=this._register(new S.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=R,this.reconnectionToken=N,this.protocol=B,this._isReconnecting=!1,this._onDidStateChange.fire(new x(this.reconnectionToken,0,0)),this._register(B.onSocketClose($=>{const Y=H(this._connectionType,this.reconnectionToken,!0);$?$.type===0?(this._options.logService.info(`${Y} received socket close event (hadError: ${$.hadError}).`),$.error&&this._options.logService.error($.error)):(this._options.logService.info(`${Y} received socket close event (wasClean: ${$.wasClean}, code: ${$.code}, reason: ${$.reason}).`),$.event&&this._options.logService.error($.event)):this._options.logService.info(`${Y} received socket close event.`),this._beginReconnecting()})),this._register(B.onSocketTimeout(()=>{const $=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${$} received socket timeout event.`),this._beginReconnecting()})),G._instances.push(this),G._permanentFailure&&this._gotoPermanentFailure(G._permanentFailureMillisSinceLastIncomingData,G._permanentFailureAttempt,G._permanentFailureHandled)}static triggerPermanentFailure(D,R,N){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=D,this._permanentFailureAttempt=R,this._permanentFailureHandled=N,this._instances.forEach(B=>B._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(G._permanentFailure)return;const D=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${D} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const R=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const B=N<R.length?R[N]:R[R.length-1];try{if(B>0){const Y=L(B);this._onDidStateChange.fire(new C(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,Y)),this._options.logService.info(`${D} waiting for ${B} seconds before reconnecting...`);try{await Y}catch{}}if(G._permanentFailure){this._options.logService.error(`${D} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this._options.logService.info(`${D} resolving connection...`);const $=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${D} connecting to ${$.host}:${$.port}...`),await this._reconnect($,h(b)),this._options.logService.info(`${D} reconnected!`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch($){if($.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${D} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error($),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this._options.logService.error(`${D} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error($),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(t.RemoteAuthorityResolverError.isTemporarilyNotAvailable($)){this._options.logService.info(`${D} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if(($.code==="ETIMEDOUT"||$.code==="ENETUNREACH"||$.code==="ECONNREFUSED"||$.code==="ECONNRESET")&&$.syscall==="connect"){this._options.logService.info(`${D} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if((0,M.isPromiseCanceledError)($)){this._options.logService.info(`${D} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if($ instanceof t.RemoteAuthorityResolverError){this._options.logService.error(`${D} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error($),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,t.RemoteAuthorityResolverError.isHandled($));break}this._options.logService.error(`${D} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error($),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!G._permanentFailure)}_gotoPermanentFailure(D,R,N){this._onDidStateChange.fire(new se(this.reconnectionToken,D,R,N)),z(this.protocol)}}G._permanentFailure=!1,G._permanentFailureMillisSinceLastIncomingData=0,G._permanentFailureAttempt=0,G._permanentFailureHandled=!1,G._instances=[];class Q extends G{constructor(D,R,N,B,$){super(1,D,B,$);this.client=this._register(new m.Client($,{remoteAuthority:R,clientId:N},D.ipcLogger))}async _reconnect(D,R){await i(D,R)}}e.ManagementPersistentConnection=Q;class O extends G{constructor(D,R,N,B,$){super(2,D,N,B);this._startArguments=R,this.debugPort=$}async _reconnect(D,R){await s(D,this._startArguments,R)}}e.ExtensionHostPersistentConnection=O;function z(F){try{F.acceptDisconnect();const D=F.getSocket();F.dispose(),D.dispose()}catch(D){(0,M.onUnexpectedError)(D)}}function U(F){if(F&&F.type==="error"){const D=new Error(`Connection error: ${F.reason}`);return D.code="VSCODE_CONNECTION_ERROR",D}return null}function X(F,D){for(;F.length<D;)F+=" ";return F}function H(F,D,R){return`[remote-connection][${X(y(F),13)}][${D.substr(0,5)}\u2026][${R?"reconnect":"initial"}]`}function _(F,D){return`${H(D,F.reconnectionToken,!!F.reconnectionProtocol)}[${F.host}:${F.port}]`}function j(F){return`${Date.now()-F} ms`}}),define(J[73],Z([0,1,10]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function A(m){return m.scheme===w.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=A;function k(m){if(!m)return;const t=m.indexOf("+");return t<0?m:m.substr(0,t)}e.getRemoteName=k;function M(m){return m.scheme!==w.Schemas.file&&m.scheme!==w.Schemas.vscodeRemote}e.isVirtualResource=M;function S(m){if(m.folders.length)return m.folders.every(t=>M(t.uri))?m.folders[0].uri:void 0;if(m.configuration&&M(m.configuration))return m.configuration}e.getVirtualWorkspaceLocation=S;function n(m){return S(m)?.scheme}e.getVirtualWorkspaceScheme=n;function f(m){return S(m)!==void 0}e.isVirtualWorkspace=f}),define(J[94],Z([0,1,5,3,4,6]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService");var S;(function(y){y.Http="http",y.Https="https"})(S=e.TunnelProtocol||(e.TunnelProtocol={}));var n;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(n=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function f(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=f,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=m,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function t(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=t;function b(y,h){return h?h!==1&&y<1024:!A.isWindows&&y<1024}e.isPortPrivileged=b;let I=class{constructor(h){this.logService=h,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new w.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h,g){return this._tunnelProvider=h,h?(this._canElevate=g.elevation,this._canMakePublic=g.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async h=>{const g=[],P=Array.from(this._tunnels.values());for(let v of P){const u=Array.from(v.values());for(let d of u){const a=await d.value;a&&g.push(a)}}h(g)})}async dispose(){for(const h of this._tunnels.values()){for(const{value:g}of h.values())await g.then(P=>P?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,g,P,v,u=!1,d=!1,a){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${P} on local port ${v}.`),!h)return;g||(g="localhost");const c=this.retainOrCreateTunnel(h,g,P,v,u,d,a);return c?c.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(i);return(i.tunnelRemoteHost!==g||i.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,public:h.public,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const g=this._tunnels.get(h.tunnelRemoteHost);if(g){const P=g.get(h.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,P))}}}}async tryDisposeTunnel(h,g,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${g}.`);const v=P.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(g),v}}async closeTunnel(h,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${g} `);const P=this._tunnels.get(h);if(P&&P.has(g)){const v=P.get(g);v.refcount=0,await this.tryDisposeTunnel(h,g,v)}}addTunnelToMap(h,g,P){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(g,{refcount:1,value:P})}async removeEmptyTunnelFromMap(h,g){const P=this._tunnels.get(h);P&&(await P.get(g)||P.delete(g),P.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,g){let P=[h];m(h)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):t(h)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const v=P.map(u=>this._tunnels.get(u));for(const u of v){const d=u?.get(g);if(d)return d}}canTunnel(h){return!!f(h)}createWithProvider(h,g,P,v,u,d,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${P} on local port ${v}.`);const i={elevationRequired:u?b(v===void 0?P:v):!1},s={remoteAddress:{host:g,port:P},localAddressPort:v,public:d,protocol:a},r=h.forwardPort(s,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(g,P,r),r}};I=ue([te(0,M.ILogService)],I),e.AbstractTunnelService=I}),define(J[50],Z([0,1,17,146,49,4,38]),function(q,e,w,A,k,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function n(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=n;function f(h){return h.res.statusCode===204}async function m(h){if(!n(h))throw new Error("Server returned "+h.res.statusCode);return f(h)?null:(await(0,w.streamToBuffer)(h.stream)).toString()}e.asText=m;async function t(h){if(!n(h))throw new Error("Server returned "+h.res.statusCode);if(f(h))return null;const P=(await(0,w.streamToBuffer)(h.stream)).toString();try{return JSON.parse(P)}catch(v){throw v.message+=`:
`+P,v}}e.asJson=t;function b(h){y(h)}e.updateProxyConfigurationsScope=b;let I;function y(h){const g=S.Registry.as(k.Extensions.Configuration);I&&g.deregisterConfigurations([I]),I={id:"http",order:15,title:(0,A.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(4,null),(0,A.localize)(5,null),(0,A.localize)(6,null),(0,A.localize)(7,null)],default:"override",description:(0,A.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(9,null),restricted:!0}}},g.registerConfiguration(I)}y(2)}),define(J[192],Z([0,1,193,13]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(S,n){return S.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:S.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function M(S,n,f={}){const m=(0,w.parse)(S),t=f.proxyUrl||k(m,n);if(!t)return null;const b=(0,w.parse)(t);if(!/^https?:$/.test(b.protocol||""))return null;const I={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,A.isBoolean)(f.strictSSL)?f.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((y,h)=>{q(["http-proxy-agent"],y,h)}))(I):new(await new Promise((y,h)=>{q(["https-proxy-agent"],y,h)}))(I)}e.getProxyAgent=M}),define(J[194],Z([0,1,17,28]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(M,S,n){let f=n&&n.get("storage.serviceMachineId",0)||null;if(f)return f;try{const t=(await S.readFile(M.serviceMachineIdResource)).value.toString();f=(0,A.isUUID)(t)?t:null}catch(m){f=null}if(!f){f=(0,A.generateUuid)();try{await S.writeFile(M.serviceMachineIdResource,w.VSBuffer.fromString(f))}catch(m){}}return n&&n.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=k}),define(J[74],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,w.createDecorator)(e.SIGN_SERVICE_ID)}),define(J[195],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class w{vsda(){return new Promise((k,M)=>q(["vsda"],k,M))}async sign(k){try{const M=await this.vsda(),S=new M.signer;if(S)return S.sign(k)}catch(M){}return k}}e.SignService=w}),define(J[39],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,w.createDecorator)("stateMainService")}),define(J[22],Z([0,1,14,9,5,2,3,31,13,4,177,6,39]),function(q,e,w,A,k,M,S,n,f,m,t,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,m.createDecorator)("lifecycleMainService");var y;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(y=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let h=class lt extends M.Disposable{constructor(P,v){super();this.logService=P,this.stateMainService=v,this._onBeforeShutdown=this._register(new k.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new k.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new k.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new k.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new k.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(lt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(lt.QUIT_AND_RESTART_KEY)}registerListeners(){const P=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),S.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};w.app.addListener("before-quit",P);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!S.isMacintosh)&&w.app.quit()};w.app.addListener("window-all-closed",v),w.app.once("will-quit",u=>{this.logService.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),w.app.removeListener("before-quit",P),w.app.removeListener("window-all-closed",v),w.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const P=[];return this._onWillShutdown.fire({join(v){P.push(v)}}),this.pendingWillShutdownPromise=(async()=>{try{await A.Promises.settled(P)}catch(v){this.logService.error(v)}try{await this.stateMainService.close()}catch(v){this.logService.error(v)}})(),this.pendingWillShutdownPromise}set phase(P){if(P<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===P)return;this.logService.trace(`lifecycle (main): phase changed (value: ${P})`),this._phase=P;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(P){if(P<=this._phase)return;let v=this.phaseWhen.get(P);v||(v=new A.Barrier,this.phaseWhen.set(P,v)),await v.wait()}registerWindow(P){const v=new M.DisposableStore;this.windowCounter++,v.add(P.onWillLoad(d=>this._onWillLoadWindow.fire({window:P,workspace:d.workspace,reason:d.reason})));const u=(0,f.assertIsDefined)(P.win);u.on("close",d=>{const a=P.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${P.id}`),d.preventDefault(),this.unload(P,1).then(c=>{if(c){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(P),P.close()})}),u.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${P.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!S.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(P,v){await this.unload(P,3)||P.reload(v)}async unload(P,v){if(!P.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${P.id}`);const u=this._quitRequested?2:v;let d=await this.onBeforeUnloadWindowInRenderer(P,u);return d?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${P.id})`),this.handleWindowUnloadVeto(d)):(d=await this.onBeforeUnloadWindowInMain(P,u),d?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${P.id})`),this.handleWindowUnloadVeto(d)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${P.id})`),await this.onWillUnloadWindowInRenderer(P,u),!1))}handleWindowUnloadVeto(P){return P?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(P){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(P),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(P,v){return new Promise(u=>{const d=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${d}`,c=`vscode:cancel${d}`;w.ipcMain.once(a,()=>{u(!1)}),w.ipcMain.once(c,()=>{u(!0)}),P.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:c,reason:v})})}onBeforeUnloadWindowInMain(P,v){const u=[];return this._onBeforeUnloadWindow.fire({reason:v,window:P,veto(d){u.push(d)}}),(0,t.handleVetos)(u,d=>this.logService.error(d))}onWillUnloadWindowInRenderer(P,v){return new Promise(u=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;w.ipcMain.once(a,()=>u()),P.send("vscode:onWillUnload",{replyChannel:a,reason:v})})}quit(P){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${P}`),P&&this.stateMainService.setItem(lt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),w.app.quit()}),this.pendingQuitPromise)}async relaunch(P){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(P?.addArgs&&v.push(...P.addArgs),P?.removeArgs)for(const a of P.removeArgs){const c=v.indexOf(a);c>=0&&v.splice(c,1)}const u=()=>{try{if(S.isWindows){const a=(0,n.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),w.app.relaunch({args:v})};w.app.once("quit",u),await this.quit(!0)&&w.app.removeListener("quit",u)}async kill(P){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,A.timeout)(1e3),(async()=>{for(const v of w.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let u;v.webContents&&!v.webContents.isDestroyed()?u=new Promise(d=>v.once("closed",d)):u=Promise.resolve(),v.destroy(),await u}})()]),w.app.exit(P)}};h.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",h=ue([te(0,b.ILogService),te(1,I.IStateMainService)],h),e.LifecycleMainService=h}),define(J[196],Z([0,1,5,2,4,22]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,k.createDecorator)("keyboardLayoutMainService");let S=class extends A.Disposable{constructor(m){super();this._onDidChangeKeyboardLayout=this._register(new w.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,m.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const m=await new Promise((t,b)=>{q(["native-keymap"],t,b)});this._keyboardLayoutData=n(m),m.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(m),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};S=ue([te(0,M.ILifecycleMainService)],S),e.KeyboardLayoutMainService=S;function n(f){const m=f.getKeyMap(),t=f.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:t}}}),define(J[95],Z([0,1,9,5,2,13,84,4]),function(q,e,w,A,k,M,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,n.createDecorator)("storageService");var m;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(m=e.WillSaveStateReason||(e.WillSaveStateReason={}));var t;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(t=e.StorageScope||(e.StorageScope={}));var b;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));class I extends k.Disposable{constructor(P={flushInterval:I.DEFAULT_FLUSH_INTERVAL}){super();this.options=P,this._onDidChangeValue=this._register(new A.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new w.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,w.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(P,v){v===f?(P===0?this._globalKeyTargets=void 0:P===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:P})):this._onDidChangeValue.fire({scope:P,key:v,target:this.getKeyTargets(P)[v]})}emitWillSaveState(P){this._onWillSaveState.fire({reason:P})}get(P,v,u){return this.getStorage(v)?.get(P,u)}getBoolean(P,v,u){return this.getStorage(v)?.getBoolean(P,u)}getNumber(P,v,u){return this.getStorage(v)?.getNumber(P,u)}store(P,v,u,d){if((0,M.isUndefinedOrNull)(v)){this.remove(P,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(P,u,d),this.getStorage(u)?.set(P,v)})}remove(P,v){this.withPausedEmitters(()=>{this.updateKeyTarget(P,v,void 0),this.getStorage(v)?.delete(P)})}withPausedEmitters(P){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{P()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(P,v){const u=[],d=this.getKeyTargets(P);for(const a of Object.keys(d))d[a]===v&&u.push(a);return u}updateKeyTarget(P,v,u){const d=this.getKeyTargets(v);typeof u=="number"?d[P]!==u&&(d[P]=u,this.getStorage(v)?.set(f,JSON.stringify(d))):typeof d[P]=="number"&&(delete d[P],this.getStorage(v)?.set(f,JSON.stringify(d)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(P){return P===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(P){const v=this.get(f,P);if(v)try{return JSON.parse(v)}catch(u){}return Object.create(null)}isNew(P){return this.getBoolean(e.IS_NEW_KEY,P)===!0}async flush(P=m.NONE){this._onWillSaveState.fire({reason:P}),await w.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const P=this.getStorage(0)?.items??new Map,v=this.getStorage(1)?.items??new Map;return h(P,v,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=I,I.DEFAULT_FLUSH_INTERVAL=60*1e3;class y extends I{constructor(){super();this.globalStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(P=>this.emitDidChangeValue(1,P))),this._register(this.globalStorage.onDidChangeStorage(P=>this.emitDidChangeValue(0,P)))}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(P){}}e.InMemoryStorageService=y;async function h(g,P,v,u){const d=l=>{try{return JSON.parse(l)}catch(p){return l}},a=new Map,c=new Map;g.forEach((l,p)=>{a.set(p,l),c.set(p,d(l))});const i=new Map,s=new Map;P.forEach((l,p)=>{i.set(p,l),s.set(p,d(l))}),console.group(`Storage: Global (path: ${v})`);let r=[];a.forEach((l,p)=>{r.push({key:p,value:l})}),console.table(r),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${u})`);let o=[];i.forEach((l,p)=>{o.push({key:p,value:l})}),console.table(o),console.groupEnd(),console.log(s)}e.logStorage=h}),define(J[197],Z([0,1,3,31,7,28]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function S(m){if(w.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function n(m,t,b,I,y,h,g,P,v,u){const d=Object.create(null);d["common.machineId"]=g,d.sessionID=(0,M.generateUuid)()+Date.now(),d.commitHash=y,d.version=h,d["common.platformVersion"]=(t||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,w.PlatformToString)(w.platform),d["common.nodePlatform"]=A.platform,d["common.nodeArch"]=I,d["common.product"]=u||"desktop";const a=f(P||[]);a&&(d["common.msftInternal"]=a);let c=0;const i=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),w.isLinuxSnap&&(d["common.snap"]="true");const s=S(b);s&&(d["common.platformDetail"]=s);try{const r=await m.readFile(k.URI.file(v));d["common.source"]=r.value.toString().slice(0,30)}catch(r){}return d}e.resolveCommonProperties=n;function f(m){const t=A.env.USERDNSDOMAIN;if(!t)return!1;const b=t.toLowerCase();return m.some(I=>b===I)}e.verifyMicrosoftInternalDomain=f}),define(J[33],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(J[198],Z([0,1,26,63,40,10,8,3,7,66,18,81,70,19,20,33]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function P(c,i){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,o=new Map,l=2e4;function p(T,W,C,V){const x=W.substring(T.length+1);return new Promise(async se=>{let G;try{G=await t.Promises.readdir(W,{withFileTypes:!0})}catch(z){se();return}if(V.count>=l){V.count+=G.length,V.maxReached=!0,se();return}let Q=G.length;if(Q===0){se();return}let O=G;V.count+G.length>l&&(V.maxReached=!0,Q=l-V.count,O=G.slice(0,Q)),V.count+=G.length;for(const z of O)if(z.isDirectory()){if(C.includes(z.name)||await p(T,(0,S.join)(W,z.name),C,V),--Q==0){se();return}}else{const U=z.name.lastIndexOf(".");if(U>=0){const X=z.name.substring(U+1);X&&r.set(X,(r.get(X)??0)+1)}for(const X of s)X.relativePathPattern?.test(x)!==!1&&X.filePattern.test(z.name)&&o.set(X.tag,(o.get(X.tag)??0)+1);if(--Q==0){se();return}}})}const E={count:0,maxReached:!1};await p(c,c,i,E);const L=await d(c);return{configFiles:v(o),fileTypes:v(r),fileCount:E.count,maxFilesReached:E.maxReached,launchConfigFiles:L}}e.collectWorkspaceStats=P;function v(c){return[...A.Iterable.map(c.entries(),([i,s])=>({name:i,count:s}))].sort((i,s)=>s.count-i.count)}function u(){const c={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},i=w.cpus();return i&&i.length>0&&(c.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),c}e.getMachineInfo=u;async function d(c){try{const i=new Map,s=(0,S.join)(c,".vscode","launch.json"),r=await t.Promises.readFile(s),o=[],l=(0,k.parse)(r.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,k.getNodeType)(l)==="object"&&l.configurations)for(const p of l.configurations){const E=p.type;E&&(i.has(E)?i.set(E,i.get(E)+1):i.set(E,1))}return v(i)}catch(i){return[]}}e.collectLaunchConfigs=d;let a=class{constructor(i,s){this.telemetryService=i,this.productService=s}formatMachineInfo(i){const s=[];return s.push(`OS Version:       ${i.os}`),s.push(`CPUs:             ${i.cpus}`),s.push(`Memory (System):  ${i.memory}`),s.push(`VM:               ${i.vmHint}`),s.join(`
`)}formatEnvironment(i){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const r=w.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(w.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||s.push(`Load (avg):       ${w.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${i.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(i,s){return Promise.all([(0,b.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async r=>{let[o,l]=r,p=this.formatProcessList(i,o);return s.forEach(E=>{if((0,I.isRemoteDiagnosticError)(E))p+=`
${E.errorMessage}`,l+=`
${E.errorMessage}`;else if(p+=`

Remote: ${E.hostName}`,E.processes&&(p+=`
${this.formatProcessList(i,E.processes)}`),E.workspaceMetadata){l+=`
|  Remote: ${E.hostName}`;for(const L of Object.keys(E.workspaceMetadata)){const T=E.workspaceMetadata[L];let W=`${T.fileCount} files`;T.maxFilesReached&&(W=`more than ${W}`),l+=`|    Folder (${L}): ${W}`,l+=this.formatWorkspaceStats(T)}}}),{processInfo:p,workspaceInfo:l}})}async getSystemInfo(i,s){const{memory:r,vmHint:o,os:l,cpus:p}=u(),E={os:l,memory:r,cpus:p,vmHint:o,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:s};return n.isWindows||(E.load=`${w.loadavg().map(L=>Math.round(L)).join(", ")}`),n.isLinux&&(E.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(E)}async getDiagnostics(i,s){const r=[];return(0,b.listProcesses)(i.mainPID).then(async o=>(r.push(""),r.push(this.formatEnvironment(i)),r.push(""),r.push(this.formatProcessList(i,o)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(i))),s.forEach(l=>{if((0,I.isRemoteDiagnosticError)(l))r.push(`
${l.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${l.hostName}`),r.push(this.formatMachineInfo(l.machineInfo)),l.processes&&r.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const p of Object.keys(l.workspaceMetadata)){const E=l.workspaceMetadata[p];let L=`${E.fileCount} files`;E.maxFilesReached&&(L=`more than ${L}`),r.push(`Folder (${p}): ${L}`),r.push(this.formatWorkspaceStats(E))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(i){const s=[],r=60;let o=0;const l=(T,W)=>{const C=` ${T}(${W})`;o+C.length>r?(s.push(p),p="|                 ",o=p.length):o+=C.length,p+=C};let p="|      File types:";const E=10;let L=i.fileTypes.length>E?E:i.fileTypes.length;for(let T=0;T<L;T++){const W=i.fileTypes[T];l(W.name,W.count)}if(s.push(p),i.configFiles.length>=0&&(p="|      Conf files:",o=0,i.configFiles.forEach(T=>{l(T.name,T.count)}),s.push(p)),i.launchConfigFiles.length>0){let T="|      Launch Configs:";i.launchConfigFiles.forEach(W=>{T+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),s.push(T)}return s.join(`
`)}expandGPUFeatures(i){const s=Math.max(...Object.keys(i).map(r=>r.length));return Object.keys(i).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${i[r]}`).join(`
                  `)}formatWorkspaceMetadata(i){const s=[],r=[];return i.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(l=>{const p=f.URI.revive(l);if(p.scheme===M.Schemas.file){const E=p.fsPath;r.push(P(E,["node_modules",".git"]).then(L=>{let T=`${L.fileCount} files`;L.maxFilesReached&&(T=`more than ${T}`),s.push(`|    Folder (${(0,S.basename)(E)}): ${T}`),s.push(this.formatWorkspaceStats(L))}).catch(L=>{s.push(`|      Error: Unable to collect workspace stats for folder ${E} (${L.toString()})`)}))}else s.push(`|    Folder (${p.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(i,s){const r=new Map;i.windows.forEach(l=>r.set(l.pid,l.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(i.mainPID,r,o,s,0),o.join(`
`)}formatProcessItem(i,s,r,o,l){const p=l===0;let E;p?E=o.pid===i?`${this.productService.applicationName} main`:"remote agent":(E=`${"  ".repeat(l)} ${o.name}`,o.name==="window"&&(E=`${E} (${s.get(o.pid)})`));const L=process.platform==="win32"?o.mem:w.totalmem()*(o.mem/100);r.push(`${o.load.toFixed(0).padStart(5," ")}	${(L/y.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${E}`),Array.isArray(o.children)&&o.children.forEach(T=>this.formatProcessItem(i,s,r,T,l+1))}async reportWorkspaceStats(i){for(const{uri:s}of i.folders){const r=f.URI.revive(s);if(r.scheme!==M.Schemas.file)continue;const o=r.fsPath;try{const l=await P(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:p.name,count:p.count})}),l.launchConfigFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:p.name,count:p.count})}),l.configFiles.forEach(p=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:p.name,count:p.count})})}catch{}}}};a=ue([te(0,g.ITelemetryService),te(1,h.IProductService)],a),e.DiagnosticsService=a}),define(J[199],Z([0,1,34,24,16,44,3,7,47,168,171,162,19,4,6,20,50,194,95,33]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g,P,v,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var a;(function(D){D[D.None=0]="None",D[D.IncludeVersions=1]="IncludeVersions",D[D.IncludeFiles=2]="IncludeFiles",D[D.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",D[D.IncludeSharedAccounts=8]="IncludeSharedAccounts",D[D.IncludeVersionProperties=16]="IncludeVersionProperties",D[D.ExcludeNonValidated=32]="ExcludeNonValidated",D[D.IncludeInstallationTargets=64]="IncludeInstallationTargets",D[D.IncludeAssetUri=128]="IncludeAssetUri",D[D.IncludeStatistics=256]="IncludeStatistics",D[D.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",D[D.Unpublished=4096]="Unpublished"})(a||(a={}));function c(...D){return String(D.reduce((R,N)=>R|N,0))}var i;(function(D){D[D.Tag=1]="Tag",D[D.ExtensionId=4]="ExtensionId",D[D.Category=5]="Category",D[D.ExtensionName=7]="ExtensionName",D[D.Target=8]="Target",D[D.Featured=9]="Featured",D[D.SearchText=10]="SearchText",D[D.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class p{constructor(R=l){this.state=R}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(R,N=this.state.pageSize){return new p({...this.state,pageNumber:R,pageSize:N})}withFilter(R,...N){const B=[...this.state.criteria,...N.length?N.map($=>({filterType:R,value:$})):[{filterType:R}]];return new p({...this.state,criteria:B})}withSortBy(R){return new p({...this.state,sortBy:R})}withSortOrder(R){return new p({...this.state,sortOrder:R})}withFlags(...R){return new p({...this.state,flags:R.reduce((N,B)=>N|B,0)})}withAssetTypes(...R){return new p({...this.state,assetTypes:R})}get raw(){const{criteria:R,pageNumber:N,pageSize:B,sortBy:$,sortOrder:Y,flags:ee,assetTypes:ie}=this.state;return{filters:[{criteria:R,pageNumber:N,pageSize:B,sortBy:$,sortOrder:Y}],assetTypes:ie,flags:ee}}get searchText(){const R=this.state.criteria.filter(N=>N.filterType===i.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(R=>String(R.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function E(D,R){const N=(D||[]).filter(B=>B.statisticName===R)[0];return N?N.value:0}function L(D){const R="Microsoft.VisualStudio.Code.Translation.";return D.files.filter(B=>B.assetType.indexOf(R)===0).reduce((B,$)=>{const Y=V(D,$.assetType);return Y&&B.push([$.assetType.substring(R.length),Y]),B},[])}function T(D){if(D.properties){const R=D.properties.filter($=>$.key===s.Repository),N=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=R.filter($=>N.test($.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return V(D,s.Repository)}function W(D){return{uri:`${D.fallbackAssetUri}/${s.VSIX}?redirect=true${D.targetPlatform?`&targetPlatform=${D.targetPlatform}`:""}`,fallbackUri:`${D.fallbackAssetUri}/${s.VSIX}${D.targetPlatform?`?targetPlatform=${D.targetPlatform}`:""}`}}function C(D){const R=V(D,s.Icon);if(R)return R;const N=m.DefaultIconPath;return{uri:N,fallbackUri:N}}function V(D,R){return D.files.filter(B=>B.assetType===R)[0]?{uri:`${D.assetUri}/${R}`,fallbackUri:`${D.fallbackAssetUri}/${R}`}:null}function x(D,R){const N=D.properties?D.properties.filter($=>$.key===R):[],B=N.length>0&&N[0].value;return B?B.split(",").map($=>(0,t.adoptToGalleryExtensionId)($)):[]}function se(D){const R=D.properties?D.properties.filter(N=>N.key===r.Engine):[];return R.length>0&&R[0].value||""}function G(D){const R=D.properties?D.properties.filter(B=>B.key===r.LocalizedLanguages):[],N=R.length>0&&R[0].value||"";return N?N.split(","):[]}function Q(D){return D.indexOf("preview")!==-1}function O(D){return D.targetPlatform?(0,m.toTargetPlatform)(D.targetPlatform):"undefined"}function z(D){const R=(0,w.distinct)(D.versions.map(O)),N=!!D.tags?.includes(m.WEB_EXTENSION_TAG),B=R.indexOf("web");return N?B===-1&&R.push("web"):B!==-1&&R.splice(B,1),R}function U(D,R){return R==="web"&&!D.includes("web")}function X(D,R,N){if(U(R,N))return!1;if(D==="undefined"||D==="universal")return!0;if(D==="unknown")return!1;if(D===N)return!0;switch(N){case"win32-x64":return D==="win32-ia32";case"win32-arm64":return D==="win32-ia32";default:return!1}}function H(D,R,N,B){const $=z(D);let Y=D.versions[0];return Y=D.versions.find(ee=>ee.version===Y.version&&X(O(ee),$,m.CURRENT_TARGET_PLATFORM))||Y,_(D,Y,$,R,N,B)}function _(D,R,N,B,$,Y){const ee={manifest:V(R,s.Manifest),readme:V(R,s.Details),changelog:V(R,s.Changelog),license:V(R,s.License),repository:T(R),download:W(R),icon:C(R),coreTranslations:L(R)};return{identifier:{id:(0,t.getGalleryExtensionId)(D.publisher.publisherName,D.extensionName),uuid:D.extensionId},name:D.extensionName,version:R.version,displayName:D.displayName,publisherId:D.publisher.publisherId,publisher:D.publisher.publisherName,publisherDisplayName:D.publisher.displayName,description:D.shortDescription||"",installCount:E(D.statistics,"install"),rating:E(D.statistics,"averagerating"),ratingCount:E(D.statistics,"ratingcount"),categories:D.categories||[],tags:D.tags||[],releaseDate:Date.parse(D.releaseDate),lastUpdated:Date.parse(D.lastUpdated),allTargetPlatforms:N,assets:ee,properties:{dependencies:x(R,r.Dependency),extensionPack:x(R,r.ExtensionPack),engine:se(R),localizedLanguages:G(R),targetPlatform:O(R)},preview:Q(D.flags),telemetryData:{index:($.pageNumber-1)*$.pageSize+B,querySource:Y}}}let j=class{constructor(R,N,B,$,Y,ee,ie){this.requestService=R,this.logService=N,this.environmentService=B,this.telemetryService=$,this.fileService=Y,this.productService=ee;const oe=ee.extensionsGallery;this.extensionsGalleryUrl=oe&&oe.serviceUrl,this.extensionsControlUrl=oe&&oe.controlUrl,this.commonHeadersPromise=F(ee.version,this.environmentService,this.fileService,ie)}api(R=""){return`${this.extensionsGalleryUrl}${R}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(R,N){const B=[];let $=new p().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,R.length).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExtensionName,...R.map(({id:ee})=>ee.toLowerCase()));R.every(ee=>!ee.version)&&($=$.withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties,a.IncludeLatestVersionOnly));const{galleryExtensions:Y}=await this.queryGallery($,A.CancellationToken.None);for(let ee=0;ee<Y.length;ee++){const ie=Y[ee];if(!ie.versions.length)continue;const oe=(0,t.getGalleryExtensionId)(ie.publisher.publisherName,ie.extensionName),ce=R.find(ne=>(0,t.areSameExtensions)(ne,{id:oe}))?.version;if(ce){const ne=ie.versions.find(le=>le.version===ce);ne&&B.push(_(ie,ne,z(ie),ee,$))}else B.push(H(ie,ee,$))}return B}async getCompatibleExtension(R,N){const B=(0,m.isIExtensionIdentifier)(R)?null:R;if(B){if(U(B.allTargetPlatforms,N))return null;if(await this.isExtensionCompatible(B,N))return B}const{id:$,uuid:Y}=B?B.identifier:R;let ee=new p().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");Y?ee=ee.withFilter(i.ExtensionId,Y):ee=ee.withFilter(i.ExtensionName,$);const{galleryExtensions:ie}=await this.queryGallery(ee,A.CancellationToken.None),[oe]=ie;if(!oe||!oe.versions.length)return null;const ce=z(oe);if(U(ce,N))return null;for(let ne of oe.versions){if(!se(ne)){const le=await this.getEngine(ne);ne={...ne,properties:[...ne.properties||[],{key:r.Engine,value:le}]}}if(await this.isRawExtensionVersionCompatible(ne,ce,N))return _(oe,ne,ce,0,ee)}return null}async isExtensionCompatible(R,N){if(!X(R.properties.targetPlatform,R.allTargetPlatforms,N))return!1;let B=R.properties.engine;if(!B){const $=await this.getManifest(R,A.CancellationToken.None);if(!$)throw new Error("Manifest was not found");B=$.engines.vscode}return(0,b.isEngineValid)(B,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(R,N,B){if(!X(O(R),N,B))return!1;const $=await this.getEngine(R);return(0,b.isEngineValid)($,this.productService.version,this.productService.date)}async query(R,N){const B=A.CancellationToken.isCancellationToken(R)?{}:R,$=A.CancellationToken.isCancellationToken(R)?R:N;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let Y=B.text||"";const ee=(0,M.getOrDefault)(B,ve=>ve.pageSize,50);let ie=new p().withFlags(a.IncludeLatestVersionOnly,a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,ee).withFilter(i.Target,"Microsoft.VisualStudio.Code");Y?(Y=Y.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,fe,we)=>(ie=ie.withFilter(i.Category,we||fe),"")),Y=Y.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,fe,we)=>(ie=ie.withFilter(i.Tag,we||fe),"")),Y=Y.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(i.Featured),"")),Y=Y.trim(),Y&&(Y=Y.length<200?Y:Y.substring(0,200),ie=ie.withFilter(i.SearchText,Y)),ie=ie.withSortBy(0)):B.ids?ie=ie.withFilter(i.ExtensionId,...B.ids):B.names?ie=ie.withFilter(i.ExtensionName,...B.names):ie=ie.withSortBy(4),typeof B.sortBy=="number"&&(ie=ie.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(ie=ie.withSortOrder(B.sortOrder));const{galleryExtensions:oe,total:ce}=await this.queryGallery(ie,$),ne=oe.map((ve,fe)=>H(ve,fe,ie,B.source)),le=async(ve,fe)=>{if(fe.isCancellationRequested)throw(0,k.canceled)();const we=ie.withPage(ve+1),{galleryExtensions:Ae}=await this.queryGallery(we,fe);return Ae.map((Se,me)=>H(Se,me,we,B.source))};return{firstPage:ne,total:ce,pageSize:ie.pageSize,getPage:le}}async queryGallery(R,N){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,a.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,c(a.Unpublished));const B=await this.commonHeadersPromise,$=JSON.stringify(R.raw),Y={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String($.length)},ee=new Date().getTime();let ie,oe,ce=0;try{if(ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:$,headers:Y},N),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:ce};const ne=await(0,P.asJson)(ie);if(ne){const le=ne.results[0],ve=le.extensions,fe=le.resultMetadata&&le.resultMetadata.filter(we=>we.metadataType==="ResultCount")[0];return ce=fe&&fe.metadataItems.filter(we=>we.name==="TotalCount")[0].count||0,{galleryExtensions:ve,total:ce}}return{galleryExtensions:[],total:ce}}catch(ne){throw oe=ne,ne}finally{this.telemetryService.publicLog2("galleryService:query",{...R.telemetryData,requestBodySize:String($.length),duration:new Date().getTime()-ee,success:!!ie&&(0,P.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:oe?(0,k.isPromiseCanceledError)(oe)?"canceled":(0,k.getErrorMessage)(oe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ce)})}}async reportStatistic(R,N,B,$){if(!this.isEnabled())return;const Y=S.isWeb?this.api(`/itemName/${R}.${N}/version/${B}/statType/${$==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${R}/extensions/${N}/${B}/stats?statType=${$}`),ee=S.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",oe={...await this.commonHeadersPromise,Accept:ee};try{await this.requestService.request({type:"POST",url:Y,headers:oe},A.CancellationToken.None)}catch(ce){}}async download(R,N,B){this.logService.trace("ExtensionGalleryService#download",R.identifier.id);const $=(0,t.getGalleryExtensionTelemetryData)(R),Y=new Date().getTime(),ee=ne=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...$,duration:ne}),ie=B===1?"install":B===2?"update":"",oe=ie?{uri:`${R.assets.download.uri}${n.URI.parse(R.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${R.assets.download.fallbackUri}${n.URI.parse(R.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:R.assets.download,ce=await this.getAsset(oe);await this.fileService.writeFile(N,ce.stream),ee(new Date().getTime()-Y)}async getReadme(R,N){if(R.assets.readme){const B=await this.getAsset(R.assets.readme,{},N);return await(0,P.asText)(B)||""}return""}async getManifest(R,N){if(R.assets.manifest){const B=await this.getAsset(R.assets.manifest,{},N),$=await(0,P.asText)(B);return $?JSON.parse($):null}return null}async getManifestFromRawExtensionVersion(R,N){const B=V(R,s.Manifest);if(!B)throw new Error("Manifest was not found");const $={"Accept-Encoding":"gzip"},Y=await this.getAsset(B,{headers:$});return await(0,P.asJson)(Y)}async getCoreTranslation(R,N){const B=R.assets.coreTranslations.filter($=>$[0]===N.toUpperCase())[0];if(B){const $=await this.getAsset(B[1]),Y=await(0,P.asText)($);return Y?JSON.parse(Y):null}return null}async getChangelog(R,N){if(R.assets.changelog){const B=await this.getAsset(R.assets.changelog,{},N);return await(0,P.asText)(B)||""}return""}async getAllCompatibleVersions(R,N){let B=new p().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");R.identifier.uuid?B=B.withFilter(i.ExtensionId,R.identifier.uuid):B=B.withFilter(i.ExtensionName,R.identifier.id);const{galleryExtensions:$}=await this.queryGallery(B,A.CancellationToken.None);if(!$.length)return[];const Y=z($[0]);if(U(Y,N))return[];const ee=[];for(const ie of $[0].versions)try{await this.isRawExtensionVersionCompatible(ie,Y,N)&&ee.push({version:ie.version,date:ie.lastUpdated})}catch(oe){}return ee}async getAsset(R,N={},B=A.CancellationToken.None){const $=await this.commonHeadersPromise,Y={type:"GET"},ee={...$,...N.headers||{}};N={...N,...Y,headers:ee};const ie=R.uri,oe=R.fallbackUri,ce={...N,url:ie};try{const ne=await this.requestService.request(ce,B);if(ne.res.statusCode===200)return ne;const le=await(0,P.asText)(ne);throw new Error(`Expected 200, got back ${ne.res.statusCode} instead.

${le}`)}catch(ne){if((0,k.isPromiseCanceledError)(ne))throw ne;const le=(0,k.getErrorMessage)(ne);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:le});const ve={...N,url:oe};return this.requestService.request(ve,B)}}async getEngine(R){let N=se(R);if(!N){const B=await this.getManifestFromRawExtensionVersion(R,A.CancellationToken.None);if(!B)throw new Error("Manifest was not found");N=B.engines.vscode}return N}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const R=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},A.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const N=await(0,P.asJson)(R),B=new Map;if(N)for(const $ of N.malicious){const Y=B.get($)||{id:{id:$},malicious:!0,slow:!1};Y.malicious=!0,B.set($,Y)}return[...B.values()]}};j=ue([te(0,P.IRequestService),te(1,h.ILogService),te(2,f.IEnvironmentService),te(3,d.ITelemetryService),te(4,I.IFileService),te(5,g.IProductService),te(6,(0,y.optional)(u.IStorageService))],j),e.ExtensionGalleryService=j;async function F(D,R,N,B){const $={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D}`},Y=await(0,v.getServiceMachineId)(R,N,B);return $["X-Market-User-Id"]=Y,$}e.resolveMarketplaceHeaders=F}),define(J[200],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class w{constructor(M){this.appender=M}listen(M,S){throw new Error(`Event not found: ${S}`)}call(M,S,{eventName:n,data:f}){return this.appender.log(n,f),Promise.resolve(null)}}e.TelemetryAppenderChannel=w;class A{constructor(M){this.channel=M}log(M,S){return this.channel.call("log",{eventName:M,data:S}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=A}),define(J[201],Z([0,1,2,44,25,147,21,49,4,48,38]),function(q,e,w,A,k,M,S,n,f,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let b=class{constructor(h,g){this._configurationService=g,this._experimentProperties={},this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appender=h.appender,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(P),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(P=>{const v=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!v})}))}setExperimentProperty(h,g){this._experimentProperties[h]=g}setEnabled(h){this._enabled=h}_updateUserOptIn(){const h=this._configurationService?.getValue(I);this._userOptIn=h?h.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const h=await this._commonProperties;let g=h.sessionID,P=h["common.instanceId"],v=h["common.machineId"],u=h["common.firstSessionDate"],d=h["common.msftInternal"];return{sessionId:g,instanceId:P,machineId:v,firstSessionDate:u,msftInternal:d}}dispose(){this._disposables.dispose()}publicLog(h,g,P){return this.isOptedIn?this._commonProperties.then(v=>{g=(0,A.mixin)(g,v),g=(0,A.mixin)(g,this._experimentProperties),g=(0,A.cloneAndChange)(g,u=>{if(typeof u=="string")return this._cleanupInfo(u,P)}),this._appender.log(h,g)},v=>{console.error(v)}):Promise.resolve(void 0)}publicLog2(h,g,P){return this.publicLog(h,g,P)}publicLogError(h,g){return this.sendErrorTelemetry?this.publicLog(h,g,!0):Promise.resolve(void 0)}publicLogError2(h,g){return this.publicLogError(h,g)}_cleanupInfo(h,g){let P=h;if(g){const v=[];for(let c of this._cleanupPatterns)for(;;){const i=c.exec(h);if(!i)break;v.push([i.index,c.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(P="";;){const c=d.exec(h);if(!c)break;!u.test(c[0])&&v.every(([i,s])=>c.index<i||c.index>=s)&&(P+=h.substring(a,c.index)+"<REDACTED: user-file-path>",a=d.lastIndex)}a<h.length&&(P+=h.substr(a))}for(let v of this._cleanupPatterns)P=P.replace(v,"");return P}};b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",b=ue([te(1,(0,f.optional)(S.IConfigurationService))],b),e.TelemetryService=b;const I="telemetry";t.Registry.as(n.Extensions.Configuration).registerConfiguration({id:I,order:110,type:"object",title:(0,M.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,M.localize)(2,null,m.default.nameLong,m.default.privacyStatementUrl):(0,M.localize)(1,null,m.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[96],Z([0,1,9,44,13,21]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(h,g){return Promise.resolve(void 0)}publicLog2(h,g){return this.publicLog(h,g)}publicLogError(h,g){return Promise.resolve(void 0)}publicLogError2(h,g){return this.publicLogError(h,g)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class S{async publicLog(g,P,v){}async publicLogError(g,P,v){}}e.NullEndpointTelemetryService=S;function n(...h){return{log:(g,P)=>h.forEach(v=>v.log(g,P)),flush:()=>w.Promises.settled(h.map(g=>g.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(h,g){return g.onDidChangeConfiguration(P=>{P.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(P.source),configurationKeys:I(P.sourceConfig)})})}e.configurationTelemetry=f;function m(h){const g=Object.create(null),P=Object.create(null),v=Object.create(null);b(h,v);for(let u in v){u=u.length>150?u.substr(u.length-149):u;const d=v[u];typeof d=="number"?P[u]=d:typeof d=="boolean"?P[u]=d?1:0:typeof d=="string"?g[u]=d.substring(0,1023):typeof d!="undefined"&&d!==null&&(g[u]=d)}return{properties:g,measurements:P}}e.validateTelemetryData=m;function t(h){if(!h)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(v=>{h.indexOf(`${v}+`)===0&&(g=v)}),g}e.cleanRemoteAuthority=t;function b(h,g,P=0,v){if(!!h)for(let u of Object.getOwnPropertyNames(h)){const d=h[u],a=v?v+u:u;Array.isArray(d)?g[a]=(0,A.safeStringify)(d):d instanceof Date?g[a]=d.toISOString():(0,k.isObject)(d)?P<2?b(d,g,P+1,a+"."):g[a]=(0,A.safeStringify)(d):g[a]=d}}function I(h){if(!h)return[];const g=[];return y(g,"",h),g}function y(h,g,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(v=>y(h,g?`${g}.${v}`:v,P[v])):h.push(g)}}),define(J[202],Z([0,1]),function(q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(J[203],Z([0,1,108,5,2,4,38,202]),function(q,e,w,A,k,M,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var f;(function(P){function v(u){return u&&typeof u=="object"&&typeof u.id=="string"}P.isThemeColor=v})(f=e.ThemeColor||(e.ThemeColor={}));function m(P){return{id:P}}e.themeColorFromId=m;var t;(function(P){function v(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||f.isThemeColor(s.color))}P.isThemeIcon=v;const u=new RegExp(`^\\$\\((${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?)\\)$`);function d(s){const r=u.exec(s);if(!r)return;let[,o]=r;return{id:o}}P.fromString=d;function a(s,r){let o=s.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),r&&(o=`${o}~${r}`),{id:o}}P.modify=a;function c(s,r){return s.id===r.id&&s.color?.id===r.color?.id}P.isEqual=c;function i(s,r){return{id:s.id,color:r?m(r):void 0}}P.asThemeIcon=i,P.asClassNameArray=w.CSSIcon.asClassNameArray,P.asClassName=w.CSSIcon.asClassName,P.asCSSSelector=w.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=w.Codicon.file,e.FolderThemeIcon=w.Codicon.folder;function b(P){switch(P){case n.ColorScheme.DARK:return"vs-dark";case n.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class I{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,k.toDisposable)(()=>{const u=this.themingParticipants.indexOf(v);this.themingParticipants.splice(u,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new I;S.Registry.add(e.Extensions.ThemingContribution,y);function h(P){return y.onColorThemeChange(P)}e.registerThemingParticipant=h;class g extends k.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(u=>this.onThemeChange(u)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,u){let d=this.theme.getColor(v);return d&&u&&(d=u(d,this.theme)),d?d.toString():null}}e.Themable=g}),define(J[60],Z([0,1,14,3,4,39]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const S="#FFFFFF",n="#1E1E1E",f="#000000",m="theme",t="themeBackground",b="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let I=class{constructor(h){this.stateMainService=h}getBackgroundColor(){if((A.isWindows||A.isMacintosh)&&w.nativeTheme.shouldUseInvertedColorScheme)return f;let h=this.stateMainService.getItem(t,null);if(!h){let g;(A.isWindows||A.isMacintosh)&&w.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(m,"vs-dark").split(" ")[0],h=g==="hc-black"?f:g==="vs"?S:n}return A.isMacintosh&&h.toUpperCase()===n&&(h="#171717"),h}saveWindowSplash(h,g){this.stateMainService.setItems([{key:m,data:g.baseTheme},{key:t,data:g.colorInfo.background},{key:b,data:g}]),typeof h=="number"&&this.updateBackgroundColor(h,g)}updateBackgroundColor(h,g){for(const P of w.BrowserWindow.getAllWindows())if(P.id===h){P.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(b)}};I=ue([te(0,M.IStateMainService)],I),e.ThemeMainService=I}),define(J[42],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var A;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(A=e.StateType||(e.StateType={}));var k;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,S)=>({type:"idle",updateType:M,error:S}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,w.createDecorator)("updateService")}),define(J[204],Z([0,1,3,148,49,38]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,A.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,A.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,A.localize)(2,null),(0,A.localize)(3,null),(0,A.localize)(4,null),(0,A.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,A.localize)(6,null),deprecationMessage:(0,A.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,A.localize)(8,null),description:(0,A.localize)(9,null),included:w.isWindows&&!w.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,A.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(J[205],Z([0,1,5,42]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(n){this.service=n}listen(n,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(n,f,m){switch(f){case"checkForUpdates":return this.service.checkForUpdates(m);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=k;class M{constructor(n){this.channel=n,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event,this._state=A.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=M}),define(J[97],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,w.createDecorator)("urlService")}),define(J[206],Z([0,1,7]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class A{constructor(n){this.handler=n}listen(n,f){throw new Error(`Event not found: ${f}`)}call(n,f,m){switch(f){case"handleURL":return this.handler.handleURL(w.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=A;class k{constructor(n){this.channel=n}handleURL(n,f){return this.channel.call("handleURL",[n.toJSON(),f])}}e.URLHandlerChannelClient=k;class M{constructor(n){this.next=n}async routeCall(n,f,m,t){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(m){const b=w.URI.revive(m);if(b&&b.query){const I=/\bwindowId=(\d+)/.exec(b.query);if(I){const y=I[1],h=new RegExp(`window:${y}`),g=n.connections.find(P=>h.test(P.ctx));if(g)return g}}}return this.next.routeCall(n,f,m,t)}routeEvent(n,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=M}),define(J[207],Z([0,1,9,2,7,20]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class S extends A.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(m,t){const b=[...this.handlers.values()];return(0,w.first)(b.map(I=>()=>I.handleURL(m,t)),void 0,!1).then(I=>I||!1)}registerHandler(m){return this.handlers.add(m),(0,A.toDisposable)(()=>this.handlers.delete(m))}}e.AbstractURLService=S;let n=class extends S{constructor(m){super();this.productService=m}create(m){let{authority:t,path:b,query:I,fragment:y}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return t&&b&&b.indexOf("/")!==0&&(b=`/${b}`),k.URI.from({scheme:this.productService.urlProtocol,authority:t,path:b,query:I,fragment:y})}};n=ue([te(0,M.IProductService)],n),e.NativeURLService=n}),define(J[208],Z([0,1,14,9,5,2,3,7]),function(q,e,w,A,k,M,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(t){try{return n.URI.parse(t)}catch(b){return null}}class m{constructor(b,I,y,h,g){if(this.urlService=I,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,this.uris=b,S.isWindows){const u=h.isBuilt?[]:[`"${h.appRoot}"`];u.push("--open-url","--"),w.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,u)}const P=k.Event.map(k.Event.fromNodeEventEmitter(w.app,"open-url",(u,d)=>({event:u,url:d})),({event:u,url:d})=>(u.preventDefault(),d));this.disposables.add(P(u=>{const d=f(u);!d||this.urlService.open(d,{originalUrl:u})})),y.getWindows().filter(u=>u.isReady).length>0?this.flush():k.Event.once(y.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const b=[];for(const I of this.uris)await this.urlService.open(I.uri,{originalUrl:I.url})||b.push(I);b.length!==0&&(this.uris=b,this.flushDisposable=(0,A.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=m}),define(J[209],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,w.createDecorator)("webviewManagerService")}),define(J[210],Z([0,1,14,2,10,7]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class S extends A.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);w.protocol.registerFileProtocol(k.Schemas.vscodeWebview,f)}handleWebviewRequest(f,m){try{const t=M.URI.parse(f.url),b=S.validWebviewFilePaths.get(t.path);if(typeof b=="string"){const I=`vs/workbench/contrib/webview/browser/pre/${b}`,y=k.FileAccess.asFileUri(I,q);return m(decodeURIComponent(y.fsPath))}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=S,S.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(J[61],Z([0,1,3]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(m){return!!m.workspaceUri}e.isWorkspaceToOpen=A;function k(m){return!!m.folderUri}e.isFolderToOpen=k;function M(m){return!!m.fileUri}e.isFileToOpen=M;function S(m){const t=n(m),b=m.getValue("window.menuBarVisibility");return b==="default"||t==="native"&&b==="compact"||w.isMacintosh&&w.isNative?"classic":b}e.getMenuBarVisibility=S;function n(m){if(w.isWeb)return"custom";const t=m.getValue("window");if(t){if(w.isMacintosh&&t.nativeTabs===!0||w.isMacintosh&&t.nativeFullScreen===!1)return"native";const y=t.titleBarStyle;if(y==="native"||y==="custom")return y}return w.isLinux?"native":"custom"}e.getTitleBarStyle=n;function f(m=0){return Math.pow(1.2,m)}e.zoomLevelToZoomFactor=f}),define(J[36],Z([0,1,4]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var A;(function(m){m[m.INITIAL=1]="INITIAL",m[m.LOAD=2]="LOAD",m[m.RELOAD=3]="RELOAD"})(A=e.LoadReason||(e.LoadReason={}));var k;(function(m){m[m.CLOSE=1]="CLOSE",m[m.QUIT=2]="QUIT",m[m.RELOAD=3]="RELOAD",m[m.LOAD=4]="LOAD"})(k=e.UnloadReason||(e.UnloadReason={}));var M;(function(m){m[m.CLI=0]="CLI",m[m.DOCK=1]="DOCK",m[m.MENU=2]="MENU",m[m.DIALOG=3]="DIALOG",m[m.DESKTOP=4]="DESKTOP",m[m.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}));const S=function(m=1){return{width:1024,height:768,mode:m}};e.defaultWindowState=S;var n;(function(m){m[m.Maximized=0]="Maximized",m[m.Normal=1]="Normal",m[m.Minimized=2]="Minimized",m[m.Fullscreen=3]="Fullscreen"})(n=e.WindowMode||(e.WindowMode={}));var f;(function(m){m[m.UNRESPONSIVE=1]="UNRESPONSIVE",m[m.CRASHED=2]="CRASHED",m[m.LOAD=3]="LOAD"})(f=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,w.createDecorator)("windowsMainService")}),define(J[211],Z([0,1,14,5,2,210,36]),function(q,e,w,A,k,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let n=class extends k.Disposable{constructor(m){super();this.windowsMainService=m,this._onFoundInFrame=this._register(new A.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,t){let b;if(typeof m.windowId=="number"){const{windowId:I}=m,y=this.windowsMainService.getWindowById(I);if(!y?.win)throw new Error(`Invalid windowId: ${I}`);b=y.win.webContents}else{const{webContentsId:I}=m;if(b=w.webContents.fromId(I),!b)throw new Error(`Invalid webContentsId: ${I}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(t)}async findInFrame(m,t,b,I){const y=this.getFrameByName(m,t),h=y;if(typeof h.findInFrame=="function"){h.findInFrame(b,{findNext:I.findNext,forward:I.forward});const g=(P,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),y.removeListener("found-in-frame",g))};y.on("found-in-frame",g)}}async stopFindInFrame(m,t,b){const y=this.getFrameByName(m,t);typeof y.stopFindInFrame=="function"&&y.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}getFrameByName(m,t){const b=this.windowsMainService.getWindowById(m.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${m}`);const I=b.win.webContents.mainFrame.framesInSubtree.find(y=>y.name===t);if(!I)throw new Error(`Unknown frame: ${t}`);return I}};n=ue([te(0,S.IWindowsMainService)],n),e.WebviewMainService=n}),define(J[212],Z([0,1,9,5,2]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends k.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:f,getActiveWindowId:m}){super();this.disposables=this._register(new k.DisposableStore),A.Event.latch(A.Event.any(n,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,w.createCancelablePromise)(()=>m()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch(b){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(J[213],Z([0,1,37,15,7,4]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,M.createDecorator)("contextService");var S;(function(I){I[I.EMPTY=1]="EMPTY",I[I.FOLDER=2]="FOLDER",I[I.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function n(I){const y=I;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.isWorkspace=n;function f(I){const y=I;return!!(y&&typeof y=="object"&&k.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.isWorkspaceFolder=f;class m{constructor(y,h,g,P){this._id=y,this._configuration=g,this._ignorePathCasing=P,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(y){this._id=y.id,this._configuration=y.configuration,this._ignorePathCasing=y._ignorePathCasing,this.folders=y.folders}get folders(){return this._folders}set folders(y){this._folders=y,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(y){this._configuration=y}getFolder(y){return y&&this._foldersMap.findSubstr(y.with({scheme:y.scheme,authority:y.authority,path:y.path}))||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing);for(const y of this.folders)this._foldersMap.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=m;class t{constructor(y,h){this.raw=h,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,A.joinPath)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function b(I){return new t({uri:I,index:0,name:(0,A.basenameOrAuthority)(I)},{uri:I.toString()})}e.toWorkspaceFolder=b}),define(J[27],Z([0,1,29,40,76,32,10,8,3,15,7,151,4,73,213]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,b.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(O){return(typeof O=="string"?(0,n.extname)(O):(0,m.extname)(O))===g}e.hasWorkspaceFileExtension=P,e.IWorkspacesService=(0,I.createDecorator)("workspacesService");function v(O){return O.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function u(O){return O.hasOwnProperty("folderUri")}e.isRecentFolder=u;function d(O){return O.hasOwnProperty("fileUri")}e.isRecentFile=d;function a(O){const z=O;return typeof z?.id=="string"&&t.URI.isUri(z.uri)}e.isSingleFolderWorkspaceIdentifier=a;function c(O){if(O.configuration)return{id:O.id,configPath:O.configuration};if(O.folders.length===1)return{id:O.id,uri:O.folders[0].uri}}e.toWorkspaceIdentifier=c;function i(O){const z=O;return typeof z?.id=="string"&&t.URI.isUri(z.configPath)}e.isWorkspaceIdentifier=i;function s(O){const z=O;if(z?.uri)return{id:z.id,uri:t.URI.revive(z.uri)};const U=O;if(U?.configPath)return{id:U.id,configPath:t.URI.revive(U.configPath)};if(O?.id)return{id:O.id}}e.reviveIdentifier=s;function r(O,z){return m.extUriBiasedIgnorePathCase.isEqualOrParent(O,z.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function o(O){return l(O)||p(O)}e.isStoredWorkspaceFolder=o;function l(O){const z=O;return typeof z?.path=="string"&&(!z.name||typeof z.name=="string")}e.isRawFileWorkspaceFolder=l;function p(O){const z=O;return typeof z?.uri=="string"&&(!z.name||typeof z.name=="string")}e.isRawUriWorkspaceFolder=p;function E(O,z,U,X,H=!f.isWindows,_){if(O.scheme!==X.scheme)return{name:U,uri:O.toString(!0)};let j=z?void 0:_.relativePath(X,O);if(j!==void 0)j.length===0?j=".":f.isWindows&&O.scheme===S.Schemas.file&&!H&&(j=j.replace(/\//g,"\\"));else if(O.scheme===S.Schemas.file)j=O.fsPath,f.isWindows&&(j=(0,M.normalizeDriveLetter)(j),H&&(j=(0,w.toSlashes)(j)));else{if(!_.isEqualAuthority(O.authority,X.authority))return{name:U,uri:O.toString(!0)};j=O.path}return{name:U,path:j}}e.getStoredWorkspaceFolder=E;function L(O,z,U){let X=[],H=new Set;const _=U.dirname(z);for(let j of O){let F;if(l(j))j.path&&(F=U.resolvePath(_,j.path));else if(p(j))try{F=t.URI.parse(j.uri),F.path[0]!=="/"&&(F=F.with({path:"/"+F.path}))}catch(D){console.warn(D)}if(F){let D=U.getComparisonKey(F);if(!H.has(D)){H.add(D);const R=j.name||U.basenameOrAuthority(F);X.push(new h.WorkspaceFolder({uri:F,name:R,index:X.length},j))}}}return X}e.toWorkspaceFolders=L;function T(O,z,U,X,H){let _=W(z,O);const j=H.dirname(z),F=H.dirname(X),D=[],R=C(_.folders);for(const Y of _.folders){const ee=l(Y)?H.resolvePath(j,Y.path):t.URI.parse(Y.uri);let ie;U?ie=!1:ie=!l(Y)||(0,n.isAbsolute)(Y.path),D.push(E(ee,ie,Y.name,F,R,H))}const N={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},B=k.setProperty(O,["folders"],D,N);let $=k.applyEdits(O,B);return _.remoteAuthority===(0,y.getRemoteAuthority)(X)&&($=k.applyEdits($,k.removeProperty($,["remoteAuthority"],N))),$}e.rewriteWorkspaceFileForNewLocation=T;function W(O,z){let U=A.parse(z);if(U&&Array.isArray(U.folders))U.folders=U.folders.filter(X=>o(X));else throw new Error(`${O} looks like an invalid workspace file.`);return U}function C(O){return f.isWindows?O.some(z=>l(z)&&z.path.indexOf("/")>=0):!0}e.useSlashForPath=C;function V(O){return O.workspace&&typeof O.workspace=="object"&&typeof O.workspace.id=="string"&&typeof O.workspace.configPath=="string"}function x(O){return typeof O.folderUri=="string"}function se(O){return typeof O.fileUri=="string"}function G(O,z){const U={workspaces:[],files:[]};if(O){const X=function(_,j){for(let F=0;F<_.length;F++)try{j(_[F],F)}catch(D){z.warn(`Error restoring recent entry ${JSON.stringify(_[F])}: ${D.toString()}. Skip entry.`)}},H=O;if(Array.isArray(H.entries))X(H.entries,_=>{const j=_.label,F=_.remoteAuthority;V(_)?U.workspaces.push({label:j,remoteAuthority:F,workspace:{id:_.workspace.id,configPath:t.URI.parse(_.workspace.configPath)}}):x(_)?U.workspaces.push({label:j,remoteAuthority:F,folderUri:t.URI.parse(_.folderUri)}):se(_)&&U.files.push({label:j,remoteAuthority:F,fileUri:t.URI.parse(_.fileUri)})});else{const _=O;Array.isArray(_.workspaces3)&&X(_.workspaces3,(j,F)=>{const D=Array.isArray(_.workspaceLabels)&&_.workspaceLabels[F]||void 0;typeof j=="object"&&typeof j.id=="string"&&typeof j.configURIPath=="string"?U.workspaces.push({label:D,workspace:{id:j.id,configPath:t.URI.parse(j.configURIPath)}}):typeof j=="string"&&U.workspaces.push({label:D,folderUri:t.URI.parse(j)})}),Array.isArray(_.files2)&&X(_.files2,(j,F)=>{const D=Array.isArray(_.fileLabels)&&_.fileLabels[F]||void 0;typeof j=="string"&&U.files.push({label:D,fileUri:t.URI.parse(j)})})}}return U}e.restoreRecentlyOpened=G;function Q(O){const z={entries:[]};for(const U of O.workspaces)u(U)?z.entries.push({folderUri:U.folderUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority}):z.entries.push({workspace:{id:U.workspace.id,configPath:U.workspace.configPath.toString()},label:U.label,remoteAuthority:U.remoteAuthority});for(const U of O.files)z.entries.push({fileUri:U.fileUri.toString(),label:U.label,remoteAuthority:U.remoteAuthority});return z}e.toStoreData=Q}),define(J[51],Z([0,1,4,27]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,w.createDecorator)("backupMainService");function k(M){const S=M;return S&&(0,A.isWorkspaceIdentifier)(S.workspace)}e.isWorkspaceBackupInfo=k}),define(J[52],Z([0,1,14,9,78,32,2,65,8,3,13,18,133,4,39,27]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let P=class gt{constructor(u){this.stateMainService=u,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new A.Queue}pickFileFolder(u,d){return this.doPick({...u,pickFolders:!0,pickFiles:!0,title:(0,I.localize)(0,null)},d)}pickFolder(u,d){return this.doPick({...u,pickFolders:!0,title:(0,I.localize)(1,null)},d)}pickFile(u,d){return this.doPick({...u,pickFiles:!0,title:(0,I.localize)(2,null)},d)}pickWorkspace(u,d){const a=(0,I.localize)(3,null),c=(0,M.mnemonicButtonLabel)((0,I.localize)(4,null)),i=g.WORKSPACE_FILTER;return this.doPick({...u,pickFiles:!0,title:a,filters:i,buttonLabel:c},d)}async doPick(u,d){const a={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters};a.defaultPath=u.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(a.properties=void 0,u.pickFiles&&u.pickFolders&&(a.properties=["multiSelections","openDirectory","openFile","createDirectory"])),a.properties||(a.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),m.isMacintosh&&a.properties.push("treatPackageAsDirectory");const c=d||w.BrowserWindow.getFocusedWindow(),i=await this.showOpenDialog(a,(0,t.withNullAsUndefined)(c));if(i&&i.filePaths&&i.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,(0,f.dirname)(i.filePaths[0])),i.filePaths}getWindowDialogQueue(u){if(u){let d=this.windowDialogQueues.get(u.id);return d||(d=new A.Queue,this.windowDialogQueues.set(u.id,d)),d}else return this.noWindowDialogueQueue}showMessageBox(u,d){return this.getWindowDialogQueue(d).queue(async()=>d?w.dialog.showMessageBox(d,u):w.dialog.showMessageBox(u))}async showSaveDialog(u,d){const a=this.acquireFileDialogLock(u,d);if(!a)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(d).queue(async()=>{let c;return d?c=await w.dialog.showSaveDialog(d,u):c=await w.dialog.showSaveDialog(u),c.filePath=this.normalizePath(c.filePath),c})}finally{(0,S.dispose)(a)}}normalizePath(u){return u&&m.isMacintosh&&(u=(0,n.normalizeNFC)(u)),u}normalizePaths(u){return u.map(d=>this.normalizePath(d))}async showOpenDialog(u,d){u.defaultPath&&(await b.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const a=this.acquireFileDialogLock(u,d);if(!a)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(d).queue(async()=>{let c;return d?c=await w.dialog.showOpenDialog(d,u):c=await w.dialog.showOpenDialog(u),c.filePaths=this.normalizePaths(c.filePaths),c})}finally{(0,S.dispose)(a)}}acquireFileDialogLock(u,d){if(!d)return S.Disposable.None;let a=this.windowFileDialogLocks.get(d.id);a||(a=new Set,this.windowFileDialogLocks.set(d.id,a));const c=(0,k.hash)(u);if(!a.has(c))return a.add(c),(0,S.toDisposable)(()=>{a?.delete(c),a?.size===0&&this.windowFileDialogLocks.delete(d.id)})}};P.workingDirPickerStorageKey="pickerWorkingDir",P=ue([te(0,h.IStateMainService)],P),e.DialogMainService=P}),define(J[214],Z([0,1,5,2,27]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends A.Disposable{constructor(n,f){super();this.logService=n,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new w.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(w.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,f)=>(n?n.push(f):n=[f],n),M.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const f=new Map,m=new Set;return n.forEach(t=>{const b=this.storageMainService.globalStorage.get(t.key);typeof b=="string"?f.set(t.key,b):m.add(t.key)}),{changed:Array.from(f.entries()),deleted:Array.from(m.values())}}listen(n,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(n,f,m){const t=(0,k.reviveIdentifier)(m.workspace),b=await this.withStorageInitialized(t);switch(f){case"getItems":return Array.from(b.items.entries());case"updateItems":{const I=m;if(I.insert)for(const[y,h]of I.insert)b.set(y,h);I.delete&&I.delete.forEach(y=>b.delete(y));break}case"close":{if(t)return b.close();break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(n){const f=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await f.init()}catch(m){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${m}`)}return f}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[215],Z([0,1,5,2,8,28,18,84,123,6,95,33,27]),function(q,e,w,A,k,M,S,n,f,m,t,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class y extends A.Disposable{constructor(v){super();this.logService=v,this._onDidChangeStorage=this._register(new w.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new w.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const v=await this.doCreate();this.storage.dispose(),this.storage=v,this._register(v.onDidChangeStorage(d=>this._onDidChangeStorage.fire({key:d}))),await this.doInit(v);const u=v.getBoolean(t.IS_NEW_KEY);u===void 0?v.set(t.IS_NEW_KEY,!0):u&&v.set(t.IS_NEW_KEY,!1)}catch(v){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${v}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===m.LogLevel.Trace?v=>this.logService.trace(v):void 0,logError:v=>this.logService.error(v)}}doInit(v){return v.init()}get items(){return this.storage.items}get(v,u){return this.storage.get(v,u)}set(v,u){return this.storage.set(v,u)}delete(v){return this.storage.delete(v)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class h extends y{constructor(v,u,d){super(u);this.options=v,this.environmentService=d}async doCreate(){let v;return this.options.useInMemoryStorage?v=f.SQLiteStorageDatabase.IN_MEMORY_PATH:v=(0,k.join)(this.environmentService.globalStorageHome.fsPath,h.STORAGE_NAME),new n.Storage(new f.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}))}async doInit(v){await super.doInit(v),this.updateTelemetryState(v)}updateTelemetryState(v){v.get(b.instanceStorageKey,void 0)===void 0&&v.set(b.instanceStorageKey,(0,M.generateUuid)()),v.get(b.firstSessionDateStorageKey,void 0)===void 0&&v.set(b.firstSessionDateStorageKey,new Date().toUTCString());const a=v.get(b.currentSessionDateStorageKey,void 0),c=new Date().toUTCString();v.set(b.lastSessionDateStorageKey,typeof a=="undefined"?null:a),v.set(b.currentSessionDateStorageKey,c)}}e.GlobalStorageMain=h,h.STORAGE_NAME="state.vscdb";class g extends y{constructor(v,u,d,a){super(d);this.workspace=v,this.options=u,this.environmentService=a}async doCreate(){const{storageFilePath:v,wasCreated:u}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new f.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}),{hint:u?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const v=(0,k.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),u=(0,k.join)(v,g.WORKSPACE_STORAGE_NAME);return await S.Promises.exists(v)?{storageFilePath:u,wasCreated:!1}:(await S.Promises.mkdir(v,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(v),{storageFilePath:u,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(v){let u;if((0,I.isSingleFolderWorkspaceIdentifier)(this.workspace)?u={folder:this.workspace.uri.toString()}:(0,I.isWorkspaceIdentifier)(this.workspace)&&(u={workspace:this.workspace.configPath.toString()}),u)try{const d=(0,k.join)(v,g.WORKSPACE_META_NAME);await S.Promises.exists(d)||await S.Promises.writeFile(d,JSON.stringify(u,void 0,2))}catch(d){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${d}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(J[98],Z([0,1,43,2,47,4,22,6,215]),function(q,e,w,A,k,M,S,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let m=class extends A.Disposable{constructor(b,I,y){super();this.logService=b,this.environmentService=I,this.lifecycleMainService=y,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async b=>{b.workspace&&this.workspaceStorage(b.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(b=>{b.join(this.globalStorage.close());for(const[,I]of this.mapWorkspaceToStorage)b.join(I.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const b=new f.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,w.once)(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),b}createWorkspaceStorage(b){return new f.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(b){let I=this.mapWorkspaceToStorage.get(b.id);return I||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),I=this.createWorkspaceStorage(b),this.mapWorkspaceToStorage.set(b.id,I),(0,w.once)(I.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)})),I}};m=ue([te(0,n.ILogService),te(1,k.IEnvironmentService),te(2,S.ILifecycleMainService)],m),e.StorageMainService=m}),define(J[99],Z([0,1,15,7,27]),function(q,e,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function M(f,m,t){for(const I of f){const y=I.openedWorkspace;if((0,k.isWorkspaceIdentifier)(y)){const h=t(y);if(h){if(h.folders.some(g=>w.extUriBiasedIgnorePathCase.isEqualOrParent(m,g.uri)))return I}else if(w.extUriBiasedIgnorePathCase.isEqualOrParent(m,y.configPath))return I}}const b=f.filter(I=>(0,k.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqualOrParent(m,I.openedWorkspace.uri));if(b.length)return b.sort((I,y)=>-(I.openedWorkspace.uri.path.length-y.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function S(f,m){for(const t of f)if((0,k.isWorkspaceIdentifier)(t.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.configPath,m)||(0,k.isSingleFolderWorkspaceIdentifier)(t.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(t.openedWorkspace.uri,m))return t}e.findWindowOnWorkspaceOrFolder=S;function n(f,m){const t=b=>m.some(I=>w.extUriBiasedIgnorePathCase.isEqual(A.URI.file(I),A.URI.file(b)));for(const b of f)if(b.config?.extensionDevelopmentPath?.some(I=>t(I)))return b}e.findWindowOnExtensionDevelopmentPath=n}),define(J[216],Z([0,1,14,2,3,15,7,21,22,6,39,36,27]),function(q,e,w,A,k,M,S,n,f,m,t,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class mt extends A.Disposable{constructor(d,a,c,i,s){super();this.windowsMainService=d,this.stateMainService=a,this.lifecycleMainService=c,this.logService=i,this.configurationService=s,this._state=h(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){w.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(d=>this.onBeforeCloseWindow(d)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(d=>{d.newCount-d.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(d=>this.onBeforeCloseWindow(d))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const d={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!d.lastActiveWindow){let i=this.windowsMainService.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.windowsMainService.getWindows().find(s=>!s.isExtensionDevelopmentHost)),i&&(d.lastActiveWindow=this.toWindowState(i))}const a=this.windowsMainService.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);a&&(d.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(d.openedWindows=this.windowsMainService.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>this.toWindowState(i)));const c=P(d);this.stateMainService.setItem(mt.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(d){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(d);d.isExtensionDevelopmentHost&&!d.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!d.isExtensionDevelopmentHost&&d.openedWorkspace&&this._state.openedWindows.forEach(c=>{const i=(0,I.isWorkspaceIdentifier)(d.openedWorkspace)&&c.workspace?.id===d.openedWorkspace.id,s=(0,I.isSingleFolderWorkspaceIdentifier)(d.openedWorkspace)&&c.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(c.folderUri,d.openedWorkspace.uri);(i||s)&&(c.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(d){return{workspace:(0,I.isWorkspaceIdentifier)(d.openedWorkspace)?d.openedWorkspace:void 0,folderUri:(0,I.isSingleFolderWorkspaceIdentifier)(d.openedWorkspace)?d.openedWorkspace.uri:void 0,backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.serializeWindowState()}}getNewWindowState(d){const a=this.doGetNewWindowState(d),c=this.configurationService.getValue("window");let i;return a.hasDefaultState?i=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(i=!!(this.lifecycleMainService.wasRestarted||c?.restoreFullscreen),i&&k.isMacintosh&&this.windowsMainService.getWindows().some(s=>s.isFullScreen)&&(i=!1)),a.mode===3&&!i&&(a.mode=1),a}doGetNewWindowState(d){const a=this.windowsMainService.getLastActiveWindow();if(!d.extensionTestsPath){if(!!d.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=d.workspace;if((0,I.isWorkspaceIdentifier)(l)){const E=this.state.openedWindows.filter(L=>L.workspace&&L.workspace.id===l.id).map(L=>L.uiState);if(E.length)return E[0]}if((0,I.isSingleFolderWorkspaceIdentifier)(l)){const E=this.state.openedWindows.filter(L=>L.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(L.folderUri,l.uri)).map(L=>L.uiState);if(E.length)return E[0]}else if(d.backupPath){const E=this.state.openedWindows.filter(L=>L.backupPath===d.backupPath).map(L=>L.uiState);if(E.length)return E[0]}const p=this.lastClosedState||this.state.lastActiveWindow;if(!a&&p)return p.uiState}let c;const i=w.screen.getAllDisplays();if(i.length===1)c=i[0];else{if(k.isMacintosh){const l=w.screen.getCursorScreenPoint();c=w.screen.getDisplayNearestPoint(l)}!c&&a&&(c=w.screen.getDisplayMatching(a.getBounds())),c||(c=w.screen.getPrimaryDisplay()||i[0])}let s=(0,b.defaultWindowState)();s.x=Math.round(c.bounds.x+c.bounds.width/2-s.width/2),s.y=Math.round(c.bounds.y+c.bounds.height/2-s.height/2);const r=this.configurationService.getValue("window");let o=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")s.mode=0,o=!1;else if(r.newWindowDimensions==="fullscreen")s.mode=3,o=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&a){const l=a.serializeWindowState();l.mode===3?s.mode=3:s=l,o=s.mode!==3&&r.newWindowDimensions==="offset"}}return o&&(s=this.ensureNoOverlap(s)),s.hasDefaultState=!0,s}ensureNoOverlap(d){if(this.windowsMainService.getWindows().length===0)return d;d.x=typeof d.x=="number"?d.x:0,d.y=typeof d.y=="number"?d.y:0;const a=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;a.some(c=>c.x===d.x||c.y===d.y);)d.x+=30,d.y+=30;return d}};y.windowsStateStorageKey="windowsState",y=ue([te(0,b.IWindowsMainService),te(1,t.IStateMainService),te(2,f.ILifecycleMainService),te(3,m.ILogService),te(4,n.IConfigurationService)],y),e.WindowsStateHandler=y;function h(u){const d={openedWindows:[]},a=u||{openedWindows:[]};return a.lastActiveWindow&&(d.lastActiveWindow=g(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(d.lastPluginDevelopmentHostWindow=g(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(d.openedWindows=a.openedWindows.map(c=>g(c))),d}e.restoreWindowsState=h;function g(u){const d={uiState:u.uiState};return u.backupPath&&(d.backupPath=u.backupPath),u.remoteAuthority&&(d.remoteAuthority=u.remoteAuthority),u.folder&&(d.folderUri=S.URI.parse(u.folder)),u.workspaceIdentifier&&(d.workspace={id:u.workspaceIdentifier.id,configPath:S.URI.parse(u.workspaceIdentifier.configURIPath)}),d}function P(u){return{lastActiveWindow:u.lastActiveWindow&&v(u.lastActiveWindow),lastPluginDevelopmentHostWindow:u.lastPluginDevelopmentHostWindow&&v(u.lastPluginDevelopmentHostWindow),openedWindows:u.openedWindows.map(d=>v(d))}}e.getWindowsStateStoreData=P;function v(u){return{workspaceIdentifier:u.workspace&&{id:u.workspace.id,configURIPath:u.workspace.configPath.toString()},folder:u.folderUri&&u.folderUri.toString(),backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.uiState}}}),define(J[100],Z([0,1,58,30,10,3,15]),function(q,e,w,A,k,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function n(m){function t(){let b=m.scheme===k.Schemas.file?(0,S.originalFSPath)(m):m.toString();return M.isLinux||(b=b.toLowerCase()),(0,w.createHash)("md5").update(b).digest("hex")}return{id:t(),configPath:m}}e.getWorkspaceIdentifier=n;function f(m,t){function b(){if(m.scheme!==k.Schemas.file)return(0,w.createHash)("md5").update(m.toString()).digest("hex");if(!t)try{t=(0,A.statSync)(m.fsPath)}catch(h){return}let y;return M.isLinux?y=t.ino:M.isMacintosh?y=t.birthtime.getTime():M.isWindows&&(typeof t.birthtimeMs=="number"?y=Math.floor(t.birthtimeMs):y=t.birthtime.getTime()),(0,w.createHash)("md5").update(m.fsPath).update(y?String(y):"").digest("hex")}const I=b();if(typeof I=="string")return{id:I,uri:m}}e.getSingleFolderWorkspaceIdentifier=f}),define(J[56],Z([0,1,58,59,26,17,16,5,2,8,3,28,35,82,217]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(E){this.socket=E,this._errorListener=L=>{if(L){if(L.code==="EPIPE")return;(0,S.onUnexpectedError)(L)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(E){const L=T=>E(M.VSBuffer.wrap(T));return this.socket.on("data",L),{dispose:()=>this.socket.off("data",L)}}onClose(E){const L=T=>{E({type:0,hadError:T,error:void 0})};return this.socket.on("close",L),{dispose:()=>this.socket.off("close",L)}}onEnd(E){return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(E){if(!this.socket.destroyed)try{this.socket.write(E.buffer,L=>{if(L){if(L.code==="EPIPE")return;(0,S.onUnexpectedError)(L)}})}catch(L){if(L.code==="EPIPE")return;(0,S.onUnexpectedError)(L)}}end(){this.socket.end()}drain(){return new Promise((E,L)=>{if(this.socket.bufferSize===0){E();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),E()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=g;var P;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize"})(P||(P={}));var v;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(v||(v={}));class u extends f.Disposable{constructor(E,L,T,W){super();this._onDidZlibFlush=this._register(new n.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new n.Emitter),this._onClose=this._register(new n.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=E,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=L,this._recordInflateBytes=W,L?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",C=>{console.error(C),(0,S.onUnexpectedError)(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibInflate.on("data",C=>{this._pendingInflateData.push(C)}),T&&(this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",C=>{console.error(C),(0,S.onUnexpectedError)(C),this._onClose.fire({type:0,hadError:!0,error:C})}),this._zlibDeflate.on("data",C=>{this._pendingDeflateData.push(C)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new y.ChunkStream,this._register(this.socket.onData(C=>this._acceptChunk(C))),this._register(this.socket.onClose(C=>this._onClose.fire(C)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):M.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this._onData.event(E)}onClose(E){return this._onClose.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){this._totalOutgoingDataBytes+=E.byteLength,this._zlibDeflate?(this._zlibDeflate.write(E.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let L=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,L=L.slice(0,L.length-4),this._isEnded||this._write(M.VSBuffer.wrap(L),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(E,!1)}_write(E,L){let T=2;E.byteLength<126?T+=0:E.byteLength<2**16?T+=2:T+=8;const W=M.VSBuffer.alloc(T);if(L?W.writeUInt8(194,0):W.writeUInt8(130,0),E.byteLength<126)W.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){W.writeUInt8(126,1);let C=1;W.writeUInt8(E.byteLength>>>8&255,++C),W.writeUInt8(E.byteLength>>>0&255,++C)}else{W.writeUInt8(127,1);let C=1;W.writeUInt8(0,++C),W.writeUInt8(0,++C),W.writeUInt8(0,++C),W.writeUInt8(0,++C),W.writeUInt8(E.byteLength>>>24&255,++C),W.writeUInt8(E.byteLength>>>16&255,++C),W.writeUInt8(E.byteLength>>>8&255,++C),W.writeUInt8(E.byteLength>>>0&255,++C)}this._totalOutgoingWireBytes+=W.byteLength+E.byteLength,this.socket.write(M.VSBuffer.concat([W,E]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(E){if(E.byteLength!==0){for(this._totalIncomingWireBytes+=E.byteLength,this._incomingData.acceptChunk(E);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const L=this._incomingData.peek(this._state.readLen),W=(L.readUInt8(0)&128)>>>7,C=L.readUInt8(1),V=(C&128)>>>7,x=C&127;this._state.state=2,this._state.readLen=2+(V?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=W,this._state.mask=0}else if(this._state.state===2){const L=this._incomingData.read(this._state.readLen),T=L.readUInt8(1),W=(T&128)>>>7;let C=T&127,V=1;C===126?C=L.readUInt8(++V)*2**8+L.readUInt8(++V):C===127&&(C=L.readUInt8(++V)*0+L.readUInt8(++V)*0+L.readUInt8(++V)*0+L.readUInt8(++V)*0+L.readUInt8(++V)*2**24+L.readUInt8(++V)*2**16+L.readUInt8(++V)*2**8+L.readUInt8(++V));let x=0;W&&(x=L.readUInt8(++V)*2**24+L.readUInt8(++V)*2**16+L.readUInt8(++V)*2**8+L.readUInt8(++V)),this._state.state=3,this._state.readLen=C,this._state.mask=x}else if(this._state.state===3){const L=this._incomingData.read(this._state.readLen);d(L,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(L.buffer)),this._zlibInflate.write(L.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const T=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=T.length,this._onData.fire(M.VSBuffer.wrap(T))})):(this._totalIncomingDataBytes+=L.byteLength,this._onData.fire(L))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await n.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=u;function d(p,E){if(E===0)return;let L=p.byteLength>>>2;for(let se=0;se<L;se++){const G=p.readUInt32BE(se*4);p.writeUInt32BE(G^E,se*4)}let T=L*4,W=p.byteLength-T;const C=E>>>24&255,V=E>>>16&255,x=E>>>8&255;W>=1&&p.writeUInt8(p.readUInt8(T)^C,T),W>=2&&p.writeUInt8(p.readUInt8(T+1)^V,T+1),W>=3&&p.writeUInt8(p.readUInt8(T+2)^x,T+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function c(){const p=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;let E;return e.XDG_RUNTIME_DIR?E=(0,m.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${p}.sock`):E=(0,m.join)((0,k.tmpdir)(),`vscode-ipc-${p}.sock`),s(E),E}e.createRandomIPCHandle=c;function i(p,E,L){const T=(0,w.createHash)("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${L}-${E}-sock`;let W;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?W=(0,m.join)(e.XDG_RUNTIME_DIR,`vscode-${T.substr(0,8)}-${L}-${E}.sock`):W=(0,m.join)(p,`${L}-${E}.sock`),s(W),W}e.createStaticIPCHandle=i;function s(p){const E=a[t.platform];typeof E=="number"&&p.length>=E&&console.warn(`WARNING: IPC handle "${p}" is longer than ${E} chars, try a shorter --user-data-dir`)}class r extends I.IPCServer{constructor(E){super(r.toClientConnectionEvent(E));this.server=E}static toClientConnectionEvent(E){const L=n.Event.fromNodeEventEmitter(E,"connection");return n.Event.map(L,T=>({protocol:new y.Protocol(new g(T)),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(T,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function o(p){return new Promise((E,L)=>{const T=(0,A.createServer)();T.on("error",L),T.listen(p,()=>{T.removeListener("error",L),E(new r(T))})})}e.serve=o;function l(p,E){return new Promise((L,T)=>{const W=(0,A.createConnection)(p,()=>{W.removeListener("error",T),L(y.Client.fromSocket(new g(W),E))});W.once("error",T)})}e.connect=l}),define(J[218],Z([0,1,56]),function(q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class A{constructor(f){this.driver=f}listen(f,m){throw new Error("No event found")}call(f,m,t){switch(m){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(t);case"reloadWindow":return this.driver.reloadWindow(t);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(t[0],t[1]);case"click":return this.driver.click(t[0],t[1],t[2],t[3]);case"doubleClick":return this.driver.doubleClick(t[0],t[1]);case"setValue":return this.driver.setValue(t[0],t[1],t[2]);case"getTitle":return this.driver.getTitle(t[0]);case"isActiveElement":return this.driver.isActiveElement(t[0],t[1]);case"getElements":return this.driver.getElements(t[0],t[1],t[2]);case"getElementXY":return this.driver.getElementXY(t[0],t[1],t[2]);case"typeInEditor":return this.driver.typeInEditor(t[0],t[1],t[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(t[0],t[1]);case"writeInTerminal":return this.driver.writeInTerminal(t[0],t[1],t[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(t);case"getLocalizedStrings":return this.driver.getLocalizedStrings(t)}throw new Error(`Call not found: ${m}`)}}e.DriverChannel=A;class k{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,m){return this.channel.call("dispatchKeybinding",[f,m])}click(f,m,t,b){return this.channel.call("click",[f,m,t,b])}doubleClick(f,m){return this.channel.call("doubleClick",[f,m])}setValue(f,m,t){return this.channel.call("setValue",[f,m,t])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,m){return this.channel.call("isActiveElement",[f,m])}getElements(f,m,t){return this.channel.call("getElements",[f,m,t])}getElementXY(f,m,t,b){return this.channel.call("getElementXY",[f,m,t,b])}typeInEditor(f,m,t){return this.channel.call("typeInEditor",[f,m,t])}getTerminalBuffer(f,m){return this.channel.call("getTerminalBuffer",[f,m])}writeInTerminal(f,m,t){return this.channel.call("writeInTerminal",[f,m,t])}getLocaleInfo(f){return this.channel.call("getLocaleInfo",f)}getLocalizedStrings(f){return this.channel.call("getLocalizedStrings",f)}}e.DriverChannelClient=k;class M{constructor(f){this.registry=f}listen(f,m){throw new Error(`Event not found: ${m}`)}call(f,m,t){switch(m){case"registerWindowDriver":return this.registry.registerWindowDriver(t);case"reloadWindowDriver":return this.registry.reloadWindowDriver(t)}throw new Error(`Call not found: ${m}`)}}e.WindowDriverRegistryChannel=M;async function S(n){const f=await(0,w.connect)(n,"driverClient"),m=f.getChannel("driver"),t=new k(m);return{client:f,driver:t}}e.connect=S}),define(J[219],Z([0,1,9,5,106,57,2,3,77,35,56,155,218,176,22,36]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function P(d){return d<21}let v=class{constructor(a,c,i,s){this.windowServer=a,this.options=c,this.windowsMainService=i,this.lifecycleMainService=s,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new A.Emitter}async registerWindowDriver(a){return this.registeredWindowIds.add(a),this.reloadingWindowIds.delete(a),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(a){this.reloadingWindowIds.add(a)}async getWindowIds(){return this.windowsMainService.getWindows().map(a=>a.id).filter(a=>this.registeredWindowIds.has(a)&&!this.reloadingWindowIds.has(a))}async capturePage(a){await this.whenUnfrozen(a);const c=this.windowsMainService.getWindowById(a);if(!c?.win)throw new Error("Invalid window");return(await c.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(a){await this.whenUnfrozen(a);const c=this.windowsMainService.getWindowById(a);if(!c)throw new Error("Invalid window");this.reloadingWindowIds.add(a),this.lifecycleMainService.reload(c)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(a,c){await this.whenUnfrozen(a);const i=k.KeybindingParser.parseUserBinding(c);for(let s of i)await this._dispatchKeybinding(a,s)}async _dispatchKeybinding(a,c){if(c instanceof f.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const i=this.windowsMainService.getWindowById(a);if(!i?.win)throw new Error("Invalid window");const s=i.win.webContents,r=new M.SimpleKeybinding(!1,!1,!1,!1,c.keyCode),l=new y.USLayoutResolvedKeybinding(r.toChord(),n.OS).getElectronAccelerator(),p=[];c.ctrlKey&&p.push("ctrl"),c.metaKey&&p.push("meta"),c.shiftKey&&p.push("shift"),c.altKey&&p.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:l,modifiers:p}),P(c.keyCode)||s.sendInputEvent({type:"char",keyCode:l,modifiers:p}),s.sendInputEvent({type:"keyUp",keyCode:l,modifiers:p}),await(0,w.timeout)(100)}async click(a,c,i,s){await(await this.getWindowDriver(a)).click(c,i,s)}async doubleClick(a,c){await(await this.getWindowDriver(a)).doubleClick(c)}async setValue(a,c,i){await(await this.getWindowDriver(a)).setValue(c,i)}async getTitle(a){return await(await this.getWindowDriver(a)).getTitle()}async isActiveElement(a,c){return await(await this.getWindowDriver(a)).isActiveElement(c)}async getElements(a,c,i){return await(await this.getWindowDriver(a)).getElements(c,i)}async getElementXY(a,c,i,s){return await(await this.getWindowDriver(a)).getElementXY(c,i,s)}async typeInEditor(a,c,i){await(await this.getWindowDriver(a)).typeInEditor(c,i)}async getTerminalBuffer(a,c){return await(await this.getWindowDriver(a)).getTerminalBuffer(c)}async writeInTerminal(a,c,i){await(await this.getWindowDriver(a)).writeInTerminal(c,i)}async getLocaleInfo(a){return await(await this.getWindowDriver(a)).getLocaleInfo()}async getLocalizedStrings(a){return await(await this.getWindowDriver(a)).getLocalizedStrings()}async getWindowDriver(a){await this.whenUnfrozen(a);const c=`window:${a}`,i=new m.StaticRouter(r=>r===c),s=this.windowServer.getChannel("windowDriver",i);return new b.WindowDriverChannelClient(s)}async whenUnfrozen(a){for(;this.reloadingWindowIds.has(a);)await A.Event.toPromise(this.onDidReloadingChange.event)}};v=ue([te(2,g.IWindowsMainService),te(3,h.ILifecycleMainService)],v),e.Driver=v;async function u(d,a,c,i){const s=c.driverVerbose,r=i.createInstance(v,d,{verbose:s}),o=new I.WindowDriverRegistryChannel(r);d.registerChannel("windowDriverRegistry",o);const l=await(0,t.serve)(a),p=new I.DriverChannel(r);return l.registerChannel("driver",p),(0,S.combinedDisposable)(l,d)}e.serve=u}),define(J[23],Z([0,1,46,8,56,47,160,4]),function(q,e,w,A,k,M,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,n.refineServiceDecorator)(M.IEnvironmentService);class f extends S.NativeEnvironmentService{get cachedLanguagesPath(){return(0,A.join)(this.userDataPath,"clp")}get backupHome(){return(0,A.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,A.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,A.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ue([w.memoize],f.prototype,"cachedLanguagesPath",null),ue([w.memoize],f.prototype,"backupHome",null),ue([w.memoize],f.prototype,"backupWorkspacesPath",null),ue([w.memoize],f.prototype,"mainIPCHandle",null),ue([w.memoize],f.prototype,"mainLockfile",null),ue([w.memoize],f.prototype,"sandbox",null),ue([w.memoize],f.prototype,"driverVerbose",null),ue([w.memoize],f.prototype,"disableUpdates",null),ue([w.memoize],f.prototype,"disableKeytar",null),ue([w.memoize],f.prototype,"codeCachePath",null),ue([w.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(J[220],Z([0,1,58,30,29,10,8,3,15,7,18,51,21,23,19,6,27]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{constructor(d,a,c){this.configurationService=a,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(i,s)=>(0,k.isEqual)(i,s,!n.isLinux)},this.backupHome=d.backupHome,this.workspacesJsonPath=d.backupWorkspacesPath}async initialize(){let d;try{d=JSON.parse(await t.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(i){d=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(d.emptyWorkspaceInfos);let a=[];try{Array.isArray(d.rootURIWorkspaces)&&(a=d.rootURIWorkspaces.map(i=>({workspace:{id:i.id,configPath:m.URI.parse(i.configURIPath)},remoteAuthority:i.remoteAuthority})))}catch(i){}this.workspaces=await this.validateWorkspaces(a);let c=[];try{Array.isArray(d.folderURIWorkspaces)&&(c=d.folderURIWorkspaces.map(i=>m.URI.parse(i)))}catch(i){}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==h.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===h.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||h.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(d,a){this.workspaces.some(i=>d.workspace.id===i.workspace.id)||(this.workspaces.push(d),this.saveSync());const c=this.getBackupPath(d.workspace.id);return a&&this.moveBackupFolderSync(c,a),c}moveBackupFolderSync(d,a){if(A.existsSync(d)&&this.convertToEmptyWindowBackupSync(d),A.existsSync(a))try{A.renameSync(a,d)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(d){const a=d.id,c=this.workspaces.findIndex(i=>i.workspace.id===a);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(d){return this.folders.some(a=>this.backupUriComparer.isEqual(d,a))||(this.folders.push(d),this.saveSync()),this.getBackupPath(this.getFolderHash(d))}unregisterFolderBackupSync(d){const a=this.folders.findIndex(c=>this.backupUriComparer.isEqual(d,c));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(d,a){const c=d||this.getRandomEmptyWindowId();return this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:a}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(d){const a=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,d));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(d){return(0,S.join)(this.backupHome,d)}async validateWorkspaces(d){if(!Array.isArray(d))return[];const a=new Set,c=[];for(let i of d){const s=i.workspace;if(!(0,P.isWorkspaceIdentifier)(s))return[];if(!a.has(s.id)){a.add(s.id);const r=this.getBackupPath(s.id);await this.doHasBackups(r)?s.configPath.scheme!==M.Schemas.file||await t.Promises.exists(s.configPath.fsPath)?c.push(i):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return c}async validateFolders(d){if(!Array.isArray(d))return[];const a=[],c=new Set;for(let i of d){const s=this.backupUriComparer.getComparisonKey(i);if(!c.has(s)){c.add(s);const r=this.getBackupPath(this.getFolderHash(i));await this.doHasBackups(r)?i.scheme!==M.Schemas.file||await t.Promises.exists(i.fsPath)?a.push(i):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return a}async validateEmptyWorkspaces(d){if(!Array.isArray(d))return[];const a=[],c=new Set;for(let i of d){const s=i.backupFolder;if(typeof s!="string")return[];if(!c.has(s)){c.add(s);const r=this.getBackupPath(s);await this.doHasBackups(r)?a.push(i):await this.deleteStaleBackup(r)}}return a}async deleteStaleBackup(d){try{await t.Promises.exists(d)&&await t.Promises.rm(d,t.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(d){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,a));)a=this.getRandomEmptyWindowId();const c=this.getBackupPath(a);try{await t.Promises.rename(d,c)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(d){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(i=>!!i.backupFolder&&this.backupPathComparer.isEqual(i.backupFolder,a));)a=this.getRandomEmptyWindowId();const c=this.getBackupPath(a);try{A.renameSync(d,c)}catch(i){return this.logService.error(`Backup: Could not rename backup folder: ${i.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const d=[];for(const a of this.workspaces)await this.hasBackups(a)&&d.push(a.workspace);for(const a of this.folders)await this.hasBackups(a)&&d.push(a);return d}hasBackups(d){let a;return m.URI.isUri(d)?a=this.getBackupPath(this.getFolderHash(d)):(0,b.isWorkspaceBackupInfo)(d)?a=this.getBackupPath(d.workspace.id):a=d.backupFolder,this.doHasBackups(a)}async doHasBackups(d){try{const a=await t.Promises.readdir(d);for(const c of a)try{if((await t.Promises.readdir((0,S.join)(d,c))).length>0)return!0}catch(i){}}catch(a){}return!1}saveSync(){try{(0,t.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(d){this.logService.error(`Backup: Could not save workspaces.json: ${d.toString()}`)}}async save(){try{await t.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(d){this.logService.error(`Backup: Could not save workspaces.json: ${d.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(d=>({id:d.workspace.id,configURIPath:d.workspace.configPath.toString(),remoteAuthority:d.remoteAuthority})),folderURIWorkspaces:this.folders.map(d=>d.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(d){let a;return d.scheme===M.Schemas.file?a=n.isLinux?d.fsPath:d.fsPath.toLowerCase():a=d.toString().toLowerCase(),(0,w.createHash)("md5").update(a).digest("hex")}};v=ue([te(0,y.IEnvironmentMainService),te(1,I.IConfigurationService),te(2,g.ILogService)],v),e.BackupMainService=v}),define(J[221],Z([0,1,59,56]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,M,S,n){const f=t=>n(t,void 0),m=w.createConnection({host:k,port:M},()=>{m.removeListener("error",f);const t=Buffer.alloc(16);for(let h=0;h<16;h++)t[h]=Math.round(Math.random()*256);const b=t.toString("base64");let I=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${M}/?${S}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${b}`];m.write(I.join(`\r
`)+`\r
\r
`);const y=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",y),n(void 0,new A.NodeSocket(m)))};m.on("data",y)});m.once("error",f)}}}),define(J[222],Z([0,1,59,9,2,115,21,6,20,191,94,221,74]),function(q,e,w,A,k,M,S,n,f,m,t,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function y(v,u,d,a,c){return new h(v,u,d,a,c).waitForReady()}class h extends k.Disposable{constructor(u,d,a,c,i){super();this.defaultTunnelHost=d,this.suggestedLocalPort=i,this.public=!1,this._socketsDispose=new Map,this._options=u,this._server=w.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(d=>{d()})}async waitForReady(){let u=await(0,M.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),d=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),d=this._server.address(),d||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),d=this._server.address()),this.tunnelLocalPort=d.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${d.port}`,this}async _onConnection(u){u.pause();const d=await(0,m.connectRemoteAgentTunnel)(this._options,this.tunnelRemoteHost,this.tunnelRemotePort),a=d.getSocket().socket,c=d.readEntireBuffer();d.dispose(),c.byteLength>0&&u.write(c.buffer),u.on("end",()=>{this._socketsDispose.delete(u.localAddress),a.end()}),u.on("close",()=>a.end()),u.on("error",()=>{this._socketsDispose.delete(u.localAddress),a.destroy()}),a.on("end",()=>u.end()),a.on("close",()=>u.end()),a.on("error",()=>{u.destroy()}),u.pipe(a),a.pipe(u),this._socketsDispose.set(u.localAddress,()=>{u.end(),a.end()})}}let g=class extends t.AbstractTunnelService{constructor(u,d,a,c,i){super(d);this.socketFactory=u,this.signService=a,this.productService=c,this.configurationService=i}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(u,d,a,c,i,s,r){const o=this.getTunnelFromMap(d,a);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,d,a,c,i,s,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${a} on local port ${c}.`);const l={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:u,signService:this.signService,logService:this.logService,ipcLogger:null},p=y(l,this.defaultTunnelHost,d,a,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(d,a,p),p}}};g=ue([te(1,n.ILogService),te(2,I.ISignService),te(3,f.IProductService),te(4,S.IConfigurationService)],g),e.BaseTunnelService=g;let P=class extends g{constructor(u,d,a,c){super(b.nodeSocketFactory,u,d,a,c)}};P=ue([te(0,n.ILogService),te(1,I.ISignService),te(2,f.IProductService),te(3,S.IConfigurationService)],P),e.TunnelService=P}),define(J[223],Z([0,1,193,17,16,2,13,21,47,89,6,192,217]),function(q,e,w,A,k,M,S,n,f,m,t,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let y=class extends M.Disposable{constructor(g,P,v){super();this.environmentService=P,this.logService=v,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,P){this.logService.trace("RequestService#request",g.url);const{proxyUrl:v,strictSSL:u}=this,d={...process.env,...await(0,m.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},a=g.agent?g.agent:await(0,b.getProxyAgent)(g.url||"",d,{proxyUrl:v,strictSSL:u});return g.agent=a,g.strictSSL=u,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,P)}async getNodeRequest(g){return((0,w.parse)(g.url).protocol==="https:"?await new Promise((u,d)=>{q(["https"],u,d)}):await new Promise((u,d)=>{q(["http"],u,d)})).request}_request(g,P){return new Promise(async(v,u)=>{let d;const a=(0,w.parse)(g.url),c=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),i={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,S.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(i.auth=g.user+":"+g.password),d=c(i,s=>{const r=(0,S.isNumber)(g.followRedirects)?g.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&r>0&&s.headers.location)this._request({...g,url:s.headers.location,followRedirects:r-1},P).then(v,u);else{let o=s;s.headers["content-encoding"]==="gzip"&&(o=s.pipe((0,I.createGunzip)())),v({res:s,stream:(0,A.streamToBufferReadableStream)(o)})}}),d.on("error",u),g.timeout&&d.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&d.write(g.data),d.end(),P.onCancellationRequested(()=>{d.abort(),u((0,k.canceled)())})})}async resolveProxy(g){}};y=ue([te(0,n.IConfigurationService),te(1,f.INativeEnvironmentService),te(2,t.ILogService)],y),e.RequestService=y}),define(J[224],Z([0,1,14,223]),function(q,e,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(S){return w.net.request}class M extends A.RequestService{request(n,f){return super.request({...n||{},getRawRequest:k},f)}}e.RequestMainService=M}),define(J[225],Z([0,1,14,9,5,2,10,13,83,23,22,6,48,55,60]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends M.Disposable{constructor(v,u,d,a,c,i,s){super();this.machineId=v,this.userEnv=u,this.environmentMainService=d,this.lifecycleMainService=a,this.logService=c,this.themeMainService=i,this.protocolMainService=s,this.firstWindowConnectionBarrier=new A.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new k.Emitter),this.onDidError=k.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),w.ipcMain.on("vscode:createSharedProcessMessageChannel",async(v,u)=>this.onWindowConnection(v,u))}async onWindowConnection(v,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const d=await this.connect();if(v.sender.isDestroyed())return d.close();v.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[d])}onWillShutdown(){const v=this.window;!v||(!v.isDestroyed()&&!v.webContents.isDestroyed()&&v.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(v.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{v.close()}catch(u){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(v=>w.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),v()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(v=>w.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),v()}))})()),this._whenIpcReady}createWindow(){const v=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new w.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:S.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${v.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),v.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:I.default}),this.window.loadURL(S.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",q).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=v=>{this.logService.trace("SharedProcess#close prevented"),v.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(v,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(v,u,d)=>this._onDidError.fire({type:3,details:{reason:d,exitCode:u}})))}async connect(){await this.whenIpcReady;const v=(0,n.assertIsDefined)(this.window);return(0,f.connect)(v)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};g=ue([te(2,m.IEnvironmentMainService),te(3,t.ILifecycleMainService),te(4,b.ILogService),te(5,h.IThemeMainService),te(6,y.IProtocolMainService)],g),e.SharedProcess=g}),define(J[226],Z([0,1,9,17,8,13,7,23,19,6]),function(q,e,w,A,k,M,S,n,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class t{constructor(y,h,g){this.storagePath=y,this.logService=h,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new w.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,h){const g=this.storage[y];return(0,M.isUndefinedOrNull)(g)?h:g}setItem(y,h){this.setItems([{key:y,data:h}])}setItems(y){let h=!1;for(const{key:g,data:P}of y)this.storage[g]!==P&&((0,M.isUndefinedOrNull)(P)?(0,M.isUndefined)(this.storage[g])||(this.storage[g]=void 0,h=!0):(this.storage[g]=P,h=!0));h&&this.save()}removeItem(y){(0,M.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(y){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),y)}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,A.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(h){this.logService.error(h)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=t;let b=class yt{constructor(y,h,g){this.fileStorage=new t(S.URI.file((0,k.join)(y.userDataPath,yt.STATE_FILE)),h,g)}async init(){return this.fileStorage.init()}getItem(y,h){return this.fileStorage.getItem(y,h)}setItem(y,h){this.fileStorage.setItem(y,h)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}};b.STATE_FILE="storage.json",b=ue([te(0,n.IEnvironmentMainService),te(1,m.ILogService),te(2,f.IFileService)],b),e.StateMainService=b}),define(J[75],Z([0,1,9,24,5,21,23,22,6,20,50,42]),function(q,e,w,A,k,M,S,n,f,m,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function I(h,g,P){return`${P.updateUrl}/api/update/${h}/${g}/${P.commit}`}e.createUpdateURL=I;let y=class{constructor(g,P,v,u,d,a){this.lifecycleMainService=g,this.configurationService=P,this.environmentMainService=v,this.requestService=u,this.logService=d,this.productService=a,this._state=b.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=(0,M.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),P=this.getProductQuality(g);if(!P){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(P),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(b.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,w.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},A.CancellationToken.None).then(g=>g.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};y=ue([te(0,n.ILifecycleMainService),te(1,M.IConfigurationService),te(2,S.IEnvironmentMainService),te(3,t.IRequestService),te(4,f.ILogService),te(5,m.IProductService)],y),e.AbstractUpdateService=y}),define(J[227],Z([0,1,14,46,5,2,21,23,22,6,20,50,33,42,75]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends h.AbstractUpdateService{constructor(v,u,d,a,c,i,s){super(v,u,a,c,i,s);this.telemetryService=d,this.disposables=new M.DisposableStore}get onRawError(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"error",(v,u)=>u)}get onRawUpdateNotAvailable(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-available",(v,u,d)=>({url:u,version:d,productVersion:d}))}get onRawUpdateDownloaded(){return k.Event.fromNodeEventEmitter(w.autoUpdater,"update-downloaded",(v,u,d,a)=>({releaseNotes:u,version:d,productVersion:d,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const d=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(y.State.Idle(1,d))}buildUpdateFeedUrl(v){let u;this.productService.darwinUniversalAssetId?u=this.productService.darwinUniversalAssetId:u=process.arch==="x64"?"darwin":"darwin-arm64";const d=(0,h.createUpdateURL)(u,v,this.productService);try{w.autoUpdater.setFeedURL({url:d})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return d}doCheckForUpdates(v){this.setState(y.State.CheckingForUpdates(v)),w.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(y.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(y.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(y.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),w.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ue([A.memoize],g.prototype,"onRawError",null),ue([A.memoize],g.prototype,"onRawUpdateNotAvailable",null),ue([A.memoize],g.prototype,"onRawUpdateAvailable",null),ue([A.memoize],g.prototype,"onRawUpdateDownloaded",null),g=ue([te(0,f.ILifecycleMainService),te(1,S.IConfigurationService),te(2,I.ITelemetryService),te(3,n.IEnvironmentMainService),te(4,b.IRequestService),te(5,m.ILogService),te(6,t.IProductService)],g),e.DarwinUpdateService=g}),define(J[228],Z([0,1,41,30,9,5,8,23,22,6,33,42]),function(q,e,w,A,k,M,S,n,f,m,t,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let I=class{constructor(g,P,v){if(this.lifecycleMainService=g,this.logService=v,this._state=b.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,P.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,u=>this.logService.error(u))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,k.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};I=ue([te(0,f.ILifecycleMainService),te(1,n.IEnvironmentMainService),te(2,m.ILogService)],I);let y=class extends I{constructor(g,P,v,u,d,a){super(v,u,d);this.snap=g,this.snapRevision=P,this.telemetryService=a;const c=(0,A.watch)(S.dirname(this.snap)),i=M.Event.fromNodeEventEmitter(c,"change",(l,p)=>p),s=M.Event.filter(i,l=>l==="current"),o=M.Event.debounce(s,(l,p)=>p,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{o.dispose(),c.close()})}doCheckForUpdates(){this.setState(b.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,w.spawn)("sleep 3 && "+S.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((v,u)=>(0,A.realpath)(`${S.dirname(this.snap)}/current`,(d,a)=>d?u(d):v(a))),P=S.basename(g);return this.snapRevision!==P}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};y=ue([te(2,f.ILifecycleMainService),te(3,n.IEnvironmentMainService),te(4,m.ILogService),te(5,t.ITelemetryService)],y),e.SnapUpdateService=y}),define(J[45],Z([0,1,14,30,5,40,32,2,10,8,3,15,13,18,153,51,52,23,4,6,20,99,27,100]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g,P,v,u,d,a,c,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,u.createDecorator)("workspacesManagementMainService");let r=class extends n.Disposable{constructor(l,p,E,L,T){super();this.environmentMainService=l,this.logService=p,this.backupMainService=E,this.dialogMainService=L,this.productService=T,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new k.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new k.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(l){return this.doResolveLocalWorkspace(l,p=>(0,A.readFileSync)(p,"utf8"))}resolveLocalWorkspace(l){return this.doResolveLocalWorkspace(l,p=>y.Promises.readFile(p,"utf8"))}doResolveLocalWorkspace(l,p){if(!!this.isWorkspacePath(l)&&l.scheme===f.Schemas.file)try{const E=p(l.fsPath);return E instanceof Promise?E.then(L=>this.doResolveWorkspace(l,L),L=>{}):this.doResolveWorkspace(l,E)}catch{return}}isWorkspacePath(l){return(0,i.isUntitledWorkspace)(l,this.environmentMainService)||(0,i.hasWorkspaceFileExtension)(l)}doResolveWorkspace(l,p){try{const E=this.doParseStoredWorkspace(l,p),L=(0,s.getWorkspaceIdentifier)(l);return{id:L.id,configPath:L.configPath,folders:(0,i.toWorkspaceFolders)(E.folders,L.configPath,b.extUriBiasedIgnorePathCase),remoteAuthority:E.remoteAuthority,transient:E.transient}}catch(E){this.logService.warn(E.toString())}}doParseStoredWorkspace(l,p){const E=(0,M.parse)(p);if(E&&Array.isArray(E.folders))E.folders=E.folders.filter(L=>(0,i.isStoredWorkspaceFolder)(L));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return E}async createUntitledWorkspace(l,p){const{workspace:E,storedWorkspace:L}=this.newUntitledWorkspace(l,p),T=E.configPath.fsPath;return await y.Promises.mkdir((0,m.dirname)(T),{recursive:!0}),await y.Promises.writeFile(T,JSON.stringify(L,null,"	")),E}createUntitledWorkspaceSync(l,p){const{workspace:E,storedWorkspace:L}=this.newUntitledWorkspace(l,p),T=E.configPath.fsPath;return(0,A.mkdirSync)((0,m.dirname)(T),{recursive:!0}),(0,y.writeFileSync)(T,JSON.stringify(L,null,"	")),E}newUntitledWorkspace(l=[],p){const E=(Date.now()+Math.round(Math.random()*1e3)).toString(),L=(0,b.joinPath)(this.untitledWorkspacesHome,E),T=(0,b.joinPath)(L,i.UNTITLED_WORKSPACE_NAME),W=[];for(const C of l)W.push((0,i.getStoredWorkspaceFolder)(C.uri,!0,C.name,L,!t.isWindows,b.extUriBiasedIgnorePathCase));return{workspace:(0,s.getWorkspaceIdentifier)(T),storedWorkspace:{folders:W,remoteAuthority:p}}}async getWorkspaceIdentifier(l){return(0,s.getWorkspaceIdentifier)(l)}isUntitledWorkspace(l){return(0,i.isUntitledWorkspace)(l.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(l){!this.isUntitledWorkspace(l)||(this.doDeleteUntitledWorkspaceSync(l),this._onDidDeleteUntitledWorkspace.fire(l))}async deleteUntitledWorkspace(l){this.deleteUntitledWorkspaceSync(l)}doDeleteUntitledWorkspaceSync(l){const p=(0,b.originalFSPath)(l.configPath);try{(0,y.rimrafSync)((0,m.dirname)(p));const E=(0,m.join)(this.environmentMainService.workspaceStorageHome.fsPath,l.id);(0,A.existsSync)(E)&&(0,y.writeFileSync)((0,m.join)(E,"obsolete"),"")}catch(E){this.logService.warn(`Unable to delete untitled workspace ${p} (${E}).`)}}getUntitledWorkspacesSync(){const l=[];try{const p=(0,y.readdirSync)(this.untitledWorkspacesHome.fsPath).map(E=>(0,b.joinPath)(this.untitledWorkspacesHome,E,i.UNTITLED_WORKSPACE_NAME));for(const E of p){const L=(0,s.getWorkspaceIdentifier)(E),T=this.resolveLocalWorkspaceSync(E);T?l.push({workspace:L,remoteAuthority:T.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(L)}}catch(p){p.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${p}).`)}return l}async enterWorkspace(l,p,E){if(!l||!l.win||!l.isReady||!await this.isValidTargetWorkspacePath(l,p,E))return;const T=this.doEnterWorkspace(l,(0,s.getWorkspaceIdentifier)(E));if(!!T)return this._onDidEnterWorkspace.fire({window:l,workspace:T.workspace}),T}async isValidTargetWorkspacePath(l,p,E){if(!E)return!0;if((0,i.isWorkspaceIdentifier)(l.openedWorkspace)&&b.extUriBiasedIgnorePathCase.isEqual(l.openedWorkspace.configPath,E))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(p,E)){const L={title:this.productService.nameLong,type:"info",buttons:[(0,S.mnemonicButtonLabel)((0,h.localize)(0,null))],message:(0,h.localize)(1,null,(0,b.basename)(E)),detail:(0,h.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(L,(0,I.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(l,p){if(!l.config)return;l.focus();let E;return l.config.extensionDevelopmentPath||(E=this.backupMainService.registerWorkspaceBackupSync({workspace:p,remoteAuthority:l.remoteAuthority},l.config.backupPath)),(0,i.isWorkspaceIdentifier)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&this.deleteUntitledWorkspaceSync(l.openedWorkspace),l.config.workspace=p,l.config.backupPath=E,{workspace:p,backupPath:E}}};r=ue([te(0,v.IEnvironmentMainService),te(1,d.ILogService),te(2,g.IBackupMainService),te(3,P.IDialogMainService),te(4,a.IProductService)],r),e.WorkspacesManagementMainService=r}),define(J[101],Z([0,1,14,34,24,3,13,7,18,21,54,4,6,97,36,27,45]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,b.createDecorator)(e.ID);let v=class{constructor(d,a,c,i,s){this.logService=d,this.windowsMainService=a,this.urlService=c,this.workspacesManagementMainService=i,this.configurationService=s}async start(d,a){this.logService.trace("Received data from other instance: ",d,a),M.isMacintosh&&w.app.focus({steal:!0});const c=this.parseOpenUrl(d);if(c.length){let i=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(i=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),i.then(()=>{for(const{uri:s,url:r}of c)this.urlService.open(s,{originalUrl:r})})}else return this.startOpenWindow(d,a)}parseOpenUrl(d){return d["open-url"]&&d._urls&&d._urls.length>0?(0,A.coalesce)(d._urls.map(a=>{try{return{uri:n.URI.parse(a),url:a}}catch(c){return null}})):[]}async startOpenWindow(d,a){const c=(0,t.isLaunchedFromCli)(a)?0:4;let i=[];const s=d.wait&&d.waitMarkerFilePath?n.URI.file(d.waitMarkerFilePath):void 0,r=d.remote||void 0;if(d.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(d.extensionDevelopmentPath,{context:c,cli:d,userEnv:a,waitMarkerFileURI:s,remoteAuthority:r});else if(!d._.length&&!d["folder-uri"]&&!d["file-uri"]){let o=!1;if(d["new-window"]||d["unity-launch"])o=!0;else if(d["reuse-window"])o=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!M.isMacintosh}if(o)i=this.windowsMainService.open({context:c,cli:d,userEnv:a,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:s,remoteAuthority:r});else{const l=this.windowsMainService.getLastActiveWindow();l?(l.focus(),i=[l]):i=this.windowsMainService.open({context:c,cli:d,forceEmpty:!0,remoteAuthority:r})}}else i=this.windowsMainService.open({context:c,cli:d,userEnv:a,forceNewWindow:d["new-window"],preferNewWindow:!d["reuse-window"]&&!d.wait,forceReuseWindow:d["reuse-window"],diffMode:d.diff,addMode:d.add,noRecentEntry:!!d["skip-add-to-recently-opened"],waitMarkerFileURI:s,gotoLineMode:d.goto,remoteAuthority:r});if(s&&i.length===1&&i[0])return Promise.race([i[0].whenClosedOrLoaded,(0,f.whenDeleted)(s.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const d=[];return w.BrowserWindow.getAllWindows().forEach(a=>{const c=this.windowsMainService.getWindowById(a.id);c?d.push(this.codeWindowToInfo(c)):d.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:d,screenReader:!!w.app.accessibilitySupportEnabled,gpuFeatureStatus:w.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(d){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(i=>new Promise(s=>{const r=i.remoteAuthority;if(r){const o=`vscode:getDiagnosticInfoResponse${i.id}`,l={includeProcesses:d.includeProcesses,folders:d.includeWorkspaceMetadata?this.getFolderURIs(i):void 0};i.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:o,args:l}),w.ipcMain.once(o,(p,E)=>{E||s({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),s(E)}),setTimeout(()=>{s({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else s(void 0)})))).filter(i=>!!i)}getFolderURIs(d){const a=[],c=d.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(c))a.push(c.uri);else if((0,g.isWorkspaceIdentifier)(c)){const i=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);i&&i.folders.forEach(r=>{a.push(r.uri)})}return a}codeWindowToInfo(d){const a=this.getFolderURIs(d),c=(0,S.assertIsDefined)(d.win);return this.browserWindowToInfo(c,a,d.remoteAuthority)}browserWindowToInfo(d,a=[],c){return{pid:d.webContents.getOSProcessId(),title:d.getTitle(),folderURIs:a,remoteAuthority:c}}};v=ue([te(0,I.ILogService),te(1,h.IWindowsMainService),te(2,y.IURLService),te(3,P.IWorkspacesManagementMainService),te(4,m.IConfigurationService)],v),e.LaunchMainService=v}),define(J[53],Z([0,1,41,14,26,114,46,5,32,2,10,8,3,7,80,66,18,145,52,23,4,22,6,20,33,60,36,27,45]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g,P,v,u,d,a,c,i,s,r,o,l,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let L=class ct extends m.Disposable{constructor(W,C,V,x,se,G,Q,O,z,U){super();this.sharedProcess=W,this.windowsMainService=C,this.dialogMainService=V,this.lifecycleMainService=x,this.environmentMainService=se,this.telemetryService=G,this.logService=Q,this.productService=O,this.themeMainService=z,this.workspacesManagementMainService=U,this.onDidOpenWindow=n.Event.map(this.windowsMainService.onDidOpenWindow,X=>X.id),this.onDidMaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(A.app,"browser-window-maximize",(X,H)=>H.id),X=>!!this.windowsMainService.getWindowById(X)),this.onDidUnmaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(A.app,"browser-window-unmaximize",(X,H)=>H.id),X=>!!this.windowsMainService.getWindowById(X)),this.onDidBlurWindow=n.Event.filter(n.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(X,H)=>H.id),X=>!!this.windowsMainService.getWindowById(X)),this.onDidFocusWindow=n.Event.any(n.Event.map(n.Event.filter(n.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),X=>!!X),X=>X.id),n.Event.filter(n.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(X,H)=>H.id),X=>!!this.windowsMainService.getWindowById(X))),this.onDidResumeOS=n.Event.fromNodeEventEmitter(A.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new n.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=n.Event.debounce(n.Event.any(n.Event.filter(n.Event.fromNodeEventEmitter(A.screen,"display-metrics-changed",(X,H,_)=>_),X=>!(Array.isArray(X)&&X.length===1&&X[0]==="workArea")),n.Event.fromNodeEventEmitter(A.screen,"display-added"),n.Event.fromNodeEventEmitter(A.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){A.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:A.nativeTheme.shouldUseInvertedColorScheme||A.nativeTheme.shouldUseHighContrastColors,dark:A.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(C=>({id:C.id,workspace:C.openedWorkspace,title:C.win?.getTitle()??"",filename:C.getRepresentedFilename(),dirty:C.isDocumentEdited()}))}async getWindowCount(W){return this.windowsMainService.getWindowCount()}async getActiveWindowId(W){const C=A.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(C)return C.id}openWindow(W,C,V){return Array.isArray(C)?this.doOpenWindow(W,C,V):this.doOpenEmptyWindow(W,C)}async doOpenWindow(W,C,V=Object.create(null)){C.length>0&&this.windowsMainService.open({context:5,contextWindowId:W,urisToOpen:C,cli:this.environmentMainService.args,forceNewWindow:V.forceNewWindow,forceReuseWindow:V.forceReuseWindow,preferNewWindow:V.preferNewWindow,diffMode:V.diffMode,addMode:V.addMode,gotoLineMode:V.gotoLineMode,noRecentEntry:V.noRecentEntry,waitMarkerFileURI:V.waitMarkerFileURI,remoteAuthority:V.remoteAuthority||void 0})}async doOpenEmptyWindow(W,C){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:W},C)}async toggleFullScreen(W){const C=this.windowById(W);C&&C.toggleFullScreen()}async handleTitleDoubleClick(W){const C=this.windowById(W);C&&C.handleTitleDoubleClick()}async isMaximized(W){const C=this.windowById(W);return C?.win?C.win.isMaximized():!1}async maximizeWindow(W){const C=this.windowById(W);C?.win&&C.win.maximize()}async unmaximizeWindow(W){const C=this.windowById(W);C?.win&&C.win.unmaximize()}async minimizeWindow(W){const C=this.windowById(W);C?.win&&C.win.minimize()}async focusWindow(W,C){C&&typeof C.windowId=="number"&&(W=C.windowId);const V=this.windowById(W);V&&V.focus({force:C?.force??!1})}async setMinimumSize(W,C,V){const x=this.windowById(W);if(x?.win){const[se,G]=x.win.getSize(),[Q,O]=x.win.getMinimumSize(),[z,U]=[C??Q,V??O],[X,H]=[Math.max(se,z),Math.max(G,U)];(Q!==z||O!==U)&&x.win.setMinimumSize(z,U),(se!==X||G!==H)&&x.win.setSize(X,H)}}async saveWindowSplash(W,C){this.themeMainService.saveWindowSplash(W,C)}async installShellCommand(W){const{source:C,target:V}=await this.getShellCommandLink();try{const{symbolicLink:x}=await P.SymlinkSupport.stat(C);if(x&&!x.dangling){const se=await(0,h.realpath)(C);if(V===se)return}await P.Promises.unlink(C)}catch(x){if(x.code!=="ENOENT")throw x}try{await P.Promises.symlink(V,C)}catch(x){if(x.code!=="EACCES"&&x.code!=="ENOENT")throw x;const{response:se}=await this.showMessageBox(W,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const G=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${V}' '${C}'\\" with administrator privileges"`;await(0,M.promisify)(w.exec)(G)}catch(G){throw new Error((0,v.localize)(3,null,C))}}}async uninstallShellCommand(W){const{source:C}=await this.getShellCommandLink();try{await P.Promises.unlink(C)}catch(V){switch(V.code){case"EACCES":const{response:x}=await this.showMessageBox(W,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(x===0)try{const se=`osascript -e "do shell script \\"rm '${C}'\\" with administrator privileges"`;await(0,M.promisify)(w.exec)(se)}catch(se){throw new Error((0,v.localize)(7,null,C))}break;case"ENOENT":break;default:throw V}}}async getShellCommandLink(){const W=(0,b.resolve)(this.environmentMainService.appRoot,"bin","code"),C=`/usr/local/bin/${this.productService.applicationName}`;if(!await P.Promises.exists(W))throw new Error((0,v.localize)(8,null,W));return{source:C,target:W}}async showMessageBox(W,C){return this.dialogMainService.showMessageBox(C,this.toBrowserWindow(W))}async showSaveDialog(W,C){return this.dialogMainService.showSaveDialog(C,this.toBrowserWindow(W))}async showOpenDialog(W,C){return this.dialogMainService.showOpenDialog(C,this.toBrowserWindow(W))}toBrowserWindow(W){const C=this.windowById(W);if(C?.win)return C.win}async pickFileFolderAndOpen(W,C){const V=await this.dialogMainService.pickFileFolder(C);V&&(this.sendPickerTelemetry(V,C.telemetryEventName||"openFileFolder",C.telemetryExtraData),this.doOpenPicked(await Promise.all(V.map(async x=>await P.SymlinkSupport.existsDirectory(x)?{folderUri:y.URI.file(x)}:{fileUri:y.URI.file(x)})),C,W))}async pickFolderAndOpen(W,C){const V=await this.dialogMainService.pickFolder(C);V&&(this.sendPickerTelemetry(V,C.telemetryEventName||"openFolder",C.telemetryExtraData),this.doOpenPicked(V.map(x=>({folderUri:y.URI.file(x)})),C,W))}async pickFileAndOpen(W,C){const V=await this.dialogMainService.pickFile(C);V&&(this.sendPickerTelemetry(V,C.telemetryEventName||"openFile",C.telemetryExtraData),this.doOpenPicked(V.map(x=>({fileUri:y.URI.file(x)})),C,W))}async pickWorkspaceAndOpen(W,C){const V=await this.dialogMainService.pickWorkspace(C);V&&(this.sendPickerTelemetry(V,C.telemetryEventName||"openWorkspace",C.telemetryExtraData),this.doOpenPicked(V.map(x=>({workspaceUri:y.URI.file(x)})),C,W))}doOpenPicked(W,C,V){this.windowsMainService.open({context:3,contextWindowId:V,cli:this.environmentMainService.args,urisToOpen:W,forceNewWindow:C.forceNewWindow})}sendPickerTelemetry(W,C,V){const x=W?W.length:0;this.telemetryService.publicLog(C,{...V,outcome:x?"success":"canceled",numberOfPaths:x})}async showItemInFolder(W,C){A.shell.showItemInFolder(C)}async setRepresentedFilename(W,C){const V=this.windowById(W);V&&V.setRepresentedFilename(C)}async setDocumentEdited(W,C){const V=this.windowById(W);V&&V.setDocumentEdited(C)}async openExternal(W,C){return I.isLinuxSnap?this.safeSnapOpenExternal(C):A.shell.openExternal(C),!0}safeSnapOpenExternal(W){const C=process.env.GDK_PIXBUF_MODULE_FILE,V=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,A.shell.openExternal(W),process.env.GDK_PIXBUF_MODULE_FILE=C,process.env.GDK_PIXBUF_MODULEDIR=V}moveItemToTrash(W,C){return A.shell.trashItem(C)}async isAdmin(){let W;return I.isWindows?W=(await new Promise((C,V)=>{q(["native-is-elevated"],C,V)}))():W=process.getuid()===0,W}async writeElevated(W,C,V,x){const se=await new Promise((G,Q)=>{q(["sudo-prompt"],G,Q)});return new Promise((G,Q)=>{const O=[`"${this.cliPath}"`];x?.unlock&&O.push("--file-chmod"),O.push("--file-write",`"${C.fsPath}"`,`"${V.fsPath}"`);const z={name:this.productService.nameLong.replace("-",""),icns:I.isMacintosh&&this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(O.join(" "),z,(U,X,H)=>{X&&this.logService.trace(`[sudo-prompt] received stdout: ${X}`),H&&this.logService.trace(`[sudo-prompt] received stderr: ${H}`),U?Q(U):G(void 0)})})}get cliPath(){return I.isWindows?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):I.isLinux?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,b.join)(this.environmentMainService.appRoot,"bin","code"):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}async killProcess(W,C,V){process.kill(C,V)}async readClipboardText(W,C){return A.clipboard.readText(C)}async writeClipboardText(W,C,V){return A.clipboard.writeText(C,V)}async readClipboardFindText(W){return A.clipboard.readFindText()}async writeClipboardFindText(W,C){return A.clipboard.writeFindText(C)}async writeClipboardBuffer(W,C,V,x){return A.clipboard.writeBuffer(C,Buffer.from(V),x)}async readClipboardBuffer(W,C){return A.clipboard.readBuffer(C)}async hasClipboard(W,C,V){return A.clipboard.has(C,V)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){A.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){A.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){A.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){A.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){A.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(W,C){const V=this.windowById(W);V&&V.updateTouchBar(C)}async notifyReady(W){const C=this.windowById(W);C&&C.setReady()}async relaunch(W,C){return this.lifecycleMainService.relaunch(C)}async reload(W,C){const V=this.windowById(W);if(V){if((0,p.isWorkspaceIdentifier)(V.openedWorkspace)){const x=V.openedWorkspace.configPath;if(x.scheme===t.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(x))?.transient)return this.openWindow(V.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(V,C?.disableExtensions!==void 0?{_:[],"disable-extensions":C.disableExtensions}:void 0)}}async closeWindow(W){this.closeWindowById(W,W)}async closeWindowById(W,C){const V=this.windowById(C);if(V?.win)return V.win.close()}async quit(W){const C=this.windowsMainService.getLastActiveWindow();C?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&C.win?C.win.close():this.lifecycleMainService.quit()}async exit(W,C){await this.lifecycleMainService.kill(C)}async resolveProxy(W,C){const x=this.windowById(W)?.win?.webContents?.session;if(x)return x.resolveProxy(C)}async openDevTools(W,C){const V=this.windowById(W);V?.win&&V.win.webContents.openDevTools(C)}async toggleDevTools(W){const C=this.windowById(W);C?.win&&C.win.webContents.toggleDevTools()}async sendInputEvent(W,C){const V=this.windowById(W);V?.win&&(C.type==="mouseDown"||C.type==="mouseUp")&&V.win.webContents.sendInputEvent(C)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(W,C,V,x){if(!I.isWindows)return;const se=await new Promise((G,Q)=>{q(["vscode-windows-registry"],G,Q)});try{return se.GetStringRegKey(C,V,x)}catch{return}}async getPassword(W,C,V){const x=await this.withKeytar(),se=await x.getPassword(C,V);if(se)try{let{content:G,hasNextChunk:Q}=JSON.parse(se);if(!G||!Q)return se;let O=1;for(;Q;){const z=await x.getPassword(C,`${V}-${O}`),U=JSON.parse(z);G+=U.content,Q=U.hasNextChunk,O++}return G}catch{return se}return se}async setPassword(W,C,V,x){const se=await this.withKeytar(),G=3,Q=async(O,z,U)=>{let X=0,H;for(;X<G;)try{await se.setPassword(O,z,U);return}catch(_){H=_,this.logService.warn("Error attempting to set a password: ",_),X++,await new Promise(j=>setTimeout(j,200))}throw H};if(I.isWindows&&x.length>ct.MAX_PASSWORD_LENGTH){let O=0,z=0,U=!0;for(;U;){const X=x.substring(O,O+ct.PASSWORD_CHUNK_SIZE);O+=ct.PASSWORD_CHUNK_SIZE,U=x.length-O>0;const H={content:X,hasNextChunk:U};await Q(C,z?`${V}-${z}`:V,JSON.stringify(H)),z++}}else await Q(C,V,x);this._onDidChangePassword.fire({service:C,account:V})}async deletePassword(W,C,V){const se=await(await this.withKeytar()).deletePassword(C,V);return se&&this._onDidChangePassword.fire({service:C,account:V}),se}async findPassword(W,C){return(await this.withKeytar()).findPassword(C)}async findCredentials(W,C){return(await this.withKeytar()).findCredentials(C)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((W,C)=>{q(["keytar"],W,C)})}windowById(W){if(typeof W=="number")return this.windowsMainService.getWindowById(W)}};L.MAX_PASSWORD_LENGTH=2500,L.PASSWORD_CHUNK_SIZE=L.MAX_PASSWORD_LENGTH-100,ue([S.memoize],L.prototype,"cliPath",null),L=ue([te(1,l.IWindowsMainService),te(2,u.IDialogMainService),te(3,c.ILifecycleMainService),te(4,d.IEnvironmentMainService),te(5,r.ITelemetryService),te(6,i.ILogService),te(7,s.IProductService),te(8,o.IThemeMainService),te(9,E.IWorkspacesManagementMainService)],L),e.NativeHostMainService=L}),define(J[229],Z([0,1,14,24,5,78,2,28,87,6,53,20,36]),function(q,e,w,A,k,M,S,n,f,m,t,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let h=class extends S.Disposable{constructor(P,v,u,d,a){super();this.logService=P,this.windowsMainService=v,this.nativeHostMainService=u,this.encryptionMainService=d,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const P=k.Event.fromNodeEventEmitter(w.app,"login",(v,u,d,a,c)=>({event:v,webContents:u,req:d,authInfo:a,callback:c}));this._register(P(this.onLogin,this))}async onLogin({event:P,authInfo:v,req:u,callback:d}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&u.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}P.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}d(a?.username,a?.password)}async resolveProxyCredentials(P){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(P);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(P){this.logService.trace("auth#doResolveProxyCredentials - enter",P);const v=String((0,M.hash)({scheme:P.scheme,host:P.host,port:P.port}));let u,d;try{const s=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(s){const r=JSON.parse(await this.encryptionMainService.decrypt(s));u=r.username,d=r.password}}catch(s){this.logService.error(s)}if(this.state!==y.StoredCredentialsUsed&&typeof u=="string"&&typeof d=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:u,password:d};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const c={authInfo:P,username:this.sessionCredentials?.username??u,password:this.sessionCredentials?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,n.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",A.CancellationToken.None,c),this.state=y.LoginDialogShown;const i=await new Promise(s=>{const r=async(o,l,p)=>{if(l===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",r),p){const E={username:p.username,password:p.password};try{if(p.remember){const L=await this.encryptionMainService.encrypt(JSON.stringify(E));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v,L)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(L){this.logService.error(L)}s({username:E.username,password:E.password})}else s(void 0)};a.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=i,i}};h=ue([te(0,m.ILogService),te(1,I.IWindowsMainService),te(2,t.INativeHostMainService),te(3,f.IEncryptionMainService),te(4,b.IProductService)],h),e.ProxyAuthHandler=h}),define(J[230],Z([0,1,14,26,32,2,10,3,81,143,70,52,23,4,101,6,53,48,20,55,61]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g,P,v,u,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,y.createDecorator)("issueMainService");let c=class St{constructor(s,r,o,l,p,E,L,T,W){this.userEnv=s,this.environmentMainService=r,this.launchMainService=o,this.logService=l,this.diagnosticsService=p,this.dialogMainService=E,this.nativeHostMainService=L,this.protocolMainService=T,this.productService=W,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){w.ipcMain.on("vscode:issueSystemInfoRequest",async s=>{const[r,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),l=await this.diagnosticsService.getSystemInfo(r,o);this.safeSend(s,"vscode:issueSystemInfoResponse",l)}),w.ipcMain.on("vscode:listProcesses",async s=>{const r=[];try{const o=await this.launchMainService.getMainProcessId();r.push({name:(0,m.localize)(0,null),rootProcess:await(0,f.listProcesses)(o)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(p=>{(0,t.isRemoteDiagnosticError)(p)?r.push({name:p.hostName,rootProcess:p}):p.processes&&r.push({name:p.hostName,rootProcess:p.processes})})}catch(o){this.logService.error(`Listing processes failed: ${o}`)}this.safeSend(s,"vscode:listProcessesResponse",r)}),w.ipcMain.on("vscode:issueReporterClipboard",async s=>{const r={title:this.productService.nameLong,message:(0,m.localize)(1,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,m.localize)(2,null)),(0,k.mnemonicButtonLabel)((0,m.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const o=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",o.response===0)}}),w.ipcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const r=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",r)}),w.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,m.localize)(4,null),type:"warning",buttons:[(0,k.mnemonicButtonLabel)((0,m.localize)(5,null)),(0,k.mnemonicButtonLabel)((0,m.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),w.ipcMain.on("vscode:workbenchCommand",(s,r)=>{const{id:o,from:l,args:p}=r;let E;switch(l){case"issueReporter":E=this.issueReporterParentWindow;break;case"processExplorer":E=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${l}`)}E&&E.webContents.send("vscode:runAction",{id:o,from:l,args:p})}),w.ipcMain.on("vscode:openExternal",(s,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),w.ipcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),w.ipcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),w.ipcMain.on("vscode:windowsInfoRequest",async s=>{const r=await this.launchMainService.getMainProcessInfo();this.safeSend(s,"vscode:windowsInfoResponse",r.windows)})}safeSend(s,r,...o){s.sender.isDestroyed()||s.sender.send(r,...o)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=w.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new M.DisposableStore,o=r.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(l,o,{backgroundColor:s.styles.backgroundColor,title:(0,m.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1}),o.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,A.type)(),arch:(0,A.arch)(),release:(0,A.release)()},product:v.default}),this.issueReporterWindow.loadURL(S.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",q).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=w.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new M.DisposableStore,o=r.add(this.protocolMainService.createIPCObjectUrl()),l=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(l,o,{backgroundColor:s.styles.backgroundColor,title:(0,m.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0}),o.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:v.default}),this.processExplorerWindow.loadURL(S.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",q).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(s,r,o){const l=new w.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:o.title,backgroundColor:o.backgroundColor||St.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:S.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,a.zoomLevelToZoomFactor)(o.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:o.alwaysOnTop});return l.setMenuBarVisibility(!1),l}async getSystemStatus(){const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,r)}getWindowPosition(s,r,o){let l;const p=w.screen.getAllDisplays();if(p.length===1)l=p[0];else{if(n.isMacintosh){const T=w.screen.getCursorScreenPoint();l=w.screen.getDisplayNearestPoint(T)}!l&&s&&(l=w.screen.getDisplayMatching(s.getBounds())),l||(l=w.screen.getPrimaryDisplay()||p[0])}const E={width:r,height:o},L=l.bounds;return E.x=L.x+L.width/2-E.width/2,E.y=L.y+L.height/2-E.height/2,L.width>0&&L.height>0&&(E.x<L.x&&(E.x=L.x),E.y<L.y&&(E.y=L.y),E.x>L.x+L.width&&(E.x=L.x),E.y>L.y+L.height&&(E.y=L.y),E.width>L.width&&(E.width=L.width),E.height>L.height&&(E.height=L.height)),E}async getPerformanceInfo(){try{const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,r)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}};c.DEFAULT_BACKGROUND_COLOR="#1E1E1E",c=ue([te(1,I.IEnvironmentMainService),te(2,h.ILaunchMainService),te(3,g.ILogService),te(4,t.IDiagnosticsService),te(5,b.IDialogMainService),te(6,P.INativeHostMainService),te(7,d.IProtocolMainService),te(8,u.IProductService)],c),e.IssueMainService=c}),define(J[231],Z([0,1,24,21,23,22,6,53,20,50,33,42,75]),function(q,e,w,A,k,M,S,n,f,m,t,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let y=class extends I.AbstractUpdateService{constructor(g,P,v,u,d,a,c,i){super(g,P,u,d,a,i);this.telemetryService=v,this.nativeHostMainService=c}buildUpdateFeedUrl(g){return(0,I.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(b.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},w.CancellationToken.None).then(m.asJson).then(P=>{!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(P))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const v=g?P.message||P:void 0;this.setState(b.State.Idle(1,v))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(b.State.Idle(1))}};y=ue([te(0,M.ILifecycleMainService),te(1,A.IConfigurationService),te(2,t.ITelemetryService),te(3,k.IEnvironmentMainService),te(4,m.IRequestService),te(5,S.ILogService),te(6,n.INativeHostMainService),te(7,f.IProductService)],y),e.LinuxUpdateService=y}),define(J[232],Z([0,1,41,30,26,9,24,46,8,7,112,18,21,23,19,22,6,53,20,50,33,42,75]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g,P,v,u,d,a,c,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function s(p,E=1e3){for(;!p();)await(0,M.timeout)(E)}let r;function o(){return typeof r=="undefined"&&(r=A.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),r}let l=class extends i.AbstractUpdateService{constructor(E,L,T,W,C,V,x,se,G){super(E,L,W,C,V,G);this.telemetryService=T,this.fileService=x,this.nativeHostMainService=se}get cachePath(){const E=f.join((0,k.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return b.Promises.mkdir(E,{recursive:!0}).then(()=>E)}initialize(){super.initialize(),o()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(E){let L="win32";return process.arch!=="ia32"&&(L+=`-${process.arch}`),o()===1?L+="-archive":this.productService.target==="user"&&(L+="-user"),(0,i.createUpdateURL)(L,E,this.productService)}doCheckForUpdates(E){!this.url||(this.setState(c.State.CheckingForUpdates(E)),this.requestService.request({url:this.url},S.CancellationToken.None).then(d.asJson).then(L=>{const T=o();return!L||!L.url||!L.version||!L.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!E}),this.setState(c.State.Idle(T)),Promise.resolve(null)):T===1?(this.setState(c.State.AvailableForDownload(L)),Promise.resolve(null)):(this.setState(c.State.Downloading(L)),this.cleanup(L.version).then(()=>this.getUpdatePackagePath(L.version).then(W=>b.Promises.exists(W).then(C=>{if(C)return Promise.resolve(W);const V=L.url,x=L.hash,se=`${W}.tmp`;return this.requestService.request({url:V},S.CancellationToken.None).then(G=>this.fileService.writeFile(m.URI.file(se),G.stream)).then(x?()=>(0,t.checksum)(se,L.hash):()=>{}).then(()=>b.Promises.rename(se,W)).then(()=>W)})).then(W=>{const C=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:W},C&&L.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(L)):this.setState(c.State.Ready(L))})))}).then(void 0,L=>{this.logService.error(L),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!E});const T=E?L.message||L:void 0;this.setState(c.State.Idle(o(),T))}))}async doDownloadUpdate(E){E.update.url&&this.nativeHostMainService.openExternal(void 0,E.update.url),this.setState(c.State.Idle(o()))}async getUpdatePackagePath(E){const L=await this.cachePath;return f.join(L,`CodeSetup-${this.productService.quality}-${E}.exe`)}async cleanup(E=null){const L=E?V=>!new RegExp(`${this.productService.quality}-${E}\\.exe$`).test(V):()=>!0,T=await this.cachePath,C=(await b.Promises.readdir(T)).filter(L).map(async V=>{try{await b.Promises.unlink(f.join(T,V))}catch(x){}});await Promise.all(C)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const E=this.state.update;this.setState(c.State.Updating(E));const L=await this.cachePath;this.availableUpdate.updateFilePath=f.join(L,`CodeSetup-${this.productService.quality}-${E.version}.flag`),await b.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,w.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(o()))});const W=`${this.productService.win32MutexName}-ready`,C=await new Promise((V,x)=>{q(["windows-mutex"],V,x)});s(()=>C.isActive(W)).then(()=>this.setState(c.State.Ready(E)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?A.unlinkSync(this.availableUpdate.updateFilePath):(0,w.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return o()}};ue([n.memoize],l.prototype,"cachePath",null),l=ue([te(0,g.ILifecycleMainService),te(1,I.IConfigurationService),te(2,a.ITelemetryService),te(3,y.IEnvironmentMainService),te(4,d.IRequestService),te(5,P.ILogService),te(6,h.IFileService),te(7,v.INativeHostMainService),te(8,u.IProductService)],l),e.Win32UpdateService=l}),define(J[233],Z([0,1,14,9,24,5,32,2,10,8,72,3,7,149,51,21,52,23,54,199,19,22,6,20,55,98,33,203,60,61,36,27,45]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g,P,v,u,d,a,c,i,s,r,o,l,p,E,L,T,W,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var V;(function(se){se[se.NONE=0]="NONE",se[se.LOADING=1]="LOADING",se[se.NAVIGATING=2]="NAVIGATING",se[se.READY=3]="READY"})(V||(V={}));let x=class extends n.Disposable{constructor(G,Q,O,z,U,X,H,_,j,F,D,R,N,B){super();this.logService=Q,this.environmentMainService=O,this.fileService=z,this.configurationService=X,this.themeMainService=H,this.workspacesManagementMainService=_,this.backupMainService=j,this.telemetryService=F,this.dialogMainService=D,this.lifecycleMainService=R,this.productService=N,this.protocolMainService=B,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[$,Y]=this.restoreWindowState(G.state);this.windowState=$,this.logService.trace("window#ctor: using window state",$);const ee=this.windowState.mode===0||this.windowState.mode===3,ie=this.configurationService.getValue("window"),oe={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:L.WindowMinimumSize.WIDTH,minHeight:L.WindowMinimumSize.HEIGHT,show:!ee,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",q).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,L.zoomLevelToZoomFactor)(ie?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};b.isLinux?oe.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):b.isWindows&&!this.environmentMainService.isBuilt&&(oe.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),b.isMacintosh&&!this.useNativeFullScreen()&&(oe.fullscreenable=!1),b.isMacintosh&&(oe.acceptFirstMouse=!0,ie?.clickThroughInactive===!1&&(oe.acceptFirstMouse=!1));const ce=b.isMacintosh&&ie?.nativeTabs===!0;ce&&(oe.tabbingIdentifier=this.productService.nameShort);const ne=(0,L.getTitleBarStyle)(this.configurationService)==="custom";if(ne&&(oe.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,b.isMacintosh||(oe.frame=!1)),(0,t.mark)("code/willCreateCodeBrowserWindow"),this._win=new w.BrowserWindow(oe),(0,t.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),b.isMacintosh&&ne&&this._win.setSheetOffset(22),b.isMacintosh&&Y&&(!ce||w.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(le=>typeof le=="number")){const le=this.windowState;this._win.setBounds({width:le.width,height:le.height,x:le.x,y:le.y})}ee&&((0,t.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,t.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,d.resolveMarketplaceHeaders)(this.productService.version,this.environmentMainService,this.fileService,{get:$=>U.globalStorage.get($),store:($,Y)=>U.globalStorage.set($,Y)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(G){b.isMacintosh?this._win.setRepresentedFilename(G):this.representedFilename=G}getRepresentedFilename(){return b.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(G){b.isMacintosh&&this._win.setDocumentEdited(G),this.documentEdited=G}isDocumentEdited(){return b.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(G){b.isMacintosh&&G?.force&&w.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(G=>{if(this.isReady)return G(this);this.whenReadyCallbacks.push(G)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(G=>{function Q(){O.dispose(),z.dispose(),G()}const O=this.onDidClose(()=>Q()),z=this.onWillLoad(()=>Q())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(U,X)=>this.onWindowError(2,X)),this._win.webContents.on("did-fail-load",(U,X,H)=>this.onWindowError(3,{reason:H,exitCode:X})),this._win.webContents.on("will-prevent-unload",U=>{U.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const G=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),Q=U=>{for(let X=U;X;X=X.parent)if(X.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},O=U=>U.resourceType==="xhr"||Q(U.frame);this._win.webContents.session.webRequest.onBeforeRequest((U,X)=>{const H=I.URI.parse(U.url);return H.path.endsWith(".svg")&&!(G.has(H.scheme)||H.path.includes(f.Schemas.vscodeRemoteResource))?X({cancel:!O(U)}):X({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((U,X)=>{const H=U.responseHeaders,_=H["content-type"]||H["Content-Type"];if(_&&Array.isArray(_)){const j=I.URI.parse(U.url);if(j.path.endsWith(".svg")&&G.has(j.scheme))return H["Content-Type"]=["image/svg+xml"],X({cancel:!1,responseHeaders:H});if(!j.path.includes(f.Schemas.vscodeRemoteResource)&&_.some(F=>F.toLowerCase().includes("image/svg")))return X({cancel:!O(U)})}return X({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",U=>{this.currentConfig&&(this.currentConfig.maximized=!0),w.app.emit("browser-window-maximize",U,this._win)}),this._win.on("unmaximize",U=>{this.currentConfig&&(this.currentConfig.maximized=!1),w.app.emit("browser-window-unmaximize",U,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(U=>this.onDidDeleteUntitledWorkspace(U)));const z=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:z},async(U,X)=>{const H=await this.marketplaceHeadersPromise;X({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,H)})})}async onWindowError(G,Q){switch(G){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${Q?.reason||"<unknown>"}, code: ${Q?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${Q?.reason||"<unknown>"}, code: ${Q?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:G,reason:Q?.reason,code:Q?.exitCode}),G){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(G===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const O=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,S.mnemonicButtonLabel)((0,y.localize)(0,null)),(0,S.mnemonicButtonLabel)((0,y.localize)(1,null)),(0,S.mnemonicButtonLabel)((0,y.localize)(2,null))],message:(0,y.localize)(3,null),detail:(0,y.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;O.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):O.response===2&&this.destroyWindow()}else if(G===2){let O;Q?O=(0,y.localize)(6,null,Q.reason,Q.exitCode??"<unknown>"):O=(0,y.localize)(5,null);const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,S.mnemonicButtonLabel)((0,y.localize)(7,null)),(0,S.mnemonicButtonLabel)((0,y.localize)(8,null))],message:O,detail:(0,y.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;z.response===0?this.reload():z.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(G){this.openedWorkspace?.id===G.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const G=this.getMenuBarVisibility();G!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=G,this.setMenuBarVisibility(G));let Q=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;Q?.endsWith("/")&&(Q=Q.substr(0,Q.length-1));const O=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Q||"").indexOf("@")===-1&&(Q!==this.currentHttpProxy||O!==this.currentNoProxy)){this.currentHttpProxy=Q,this.currentNoProxy=O;const z=Q||"",U=O?`${O},<local>`:"<local>";this.logService.trace(`Setting proxy to '${z}', bypassing '${U}'`),this._win.webContents.session.setProxy({proxyRules:z,proxyBypassRules:U,pacScript:""})}}addTabbedWindow(G){b.isMacintosh&&G.win&&this._win.addTabbedWindow(G.win)}load(G,Q=Object.create(null)){this.isDocumentEdited()&&(!Q.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),Q.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(G,Q),this.readyState===0?this.currentConfig=G:(this.pendingLoadConfig=G,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",q).toString(!0));const O=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new A.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:G.workspace,reason:Q.isReload?3:O?2:1})}updateConfiguration(G,Q){const O=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(O){const z=(0,u.isLaunchedFromCli)(O)&&!(0,u.isLaunchedFromCli)(G.userEnv),U=this.isExtensionDevelopmentHost;(z||U)&&(G.userEnv={...O,...G.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(G.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),Q.disableExtensions!==void 0&&(G["disable-extensions"]=Q.disableExtensions),G.fullscreen=this.isFullScreen,G.maximized=this._win.isMaximized(),G.partsSplash=this.themeMainService.getWindowSplash(),(0,t.mark)("code/willOpenNewWindow"),G.perfMarks=(0,t.getMarks)(),this.configObjectUrl.update(G)}async reload(G){const Q=Object.assign({},this.currentConfig);Q.workspace=await this.validateWorkspaceBeforeReload(Q),delete Q.filesToOpenOrCreate,delete Q.filesToDiff,delete Q.filesToWait,this.isExtensionDevelopmentHost&&G&&(Q.verbose=G.verbose,Q.debugId=G.debugId,Q["inspect-extensions"]=G["inspect-extensions"],Q["inspect-brk-extensions"]=G["inspect-brk-extensions"],Q["extensions-dir"]=G["extensions-dir"]),Q.isInitialStartup=!1,this.load(Q,{isReload:!0,disableExtensions:G?.["disable-extensions"]})}async validateWorkspaceBeforeReload(G){if((0,W.isWorkspaceIdentifier)(G.workspace)){const Q=G.workspace.configPath;if(Q.scheme===f.Schemas.file&&!await this.fileService.exists(Q))return}else if((0,W.isSingleFolderWorkspaceIdentifier)(G.workspace)){const Q=G.workspace.uri;if(Q.scheme===f.Schemas.file&&!await this.fileService.exists(Q))return}return G.workspace}serializeWindowState(){if(!this._win)return(0,T.defaultWindowState)();if(this.isFullScreen){let O;try{O=w.screen.getDisplayMatching(this.getBounds())}catch(X){}const z=(0,T.defaultWindowState)();return{mode:3,display:O?O.id:void 0,width:this.windowState.width||z.width,height:this.windowState.height||z.height,x:this.windowState.x||0,y:this.windowState.y||0}}const G=Object.create(null);let Q;if(!b.isMacintosh&&this._win.isMaximized()?Q=0:Q=1,Q===0?G.mode=0:G.mode=1,Q===1||Q===0){let O;Q===1?O=this.getBounds():O=this._win.getNormalBounds(),G.x=O.x,G.y=O.y,G.width=O.width,G.height=O.height}return G}restoreWindowState(G){(0,t.mark)("code/willRestoreCodeWindowState");let Q=!1;if(G)try{const O=w.screen.getAllDisplays();Q=O.length>1,G=this.validateWindowState(G,O)}catch(O){this.logService.warn(`Unexpected error validating window state: ${O}
${O.stack}`)}return(0,t.mark)("code/didRestoreCodeWindowState"),[G||(0,T.defaultWindowState)(),Q]}validateWindowState(G,Q){if(this.logService.trace(`window#validateWindowState: validating window state on ${Q.length} display(s)`,G),typeof G.x!="number"||typeof G.y!="number"||typeof G.width!="number"||typeof G.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(G.width<=0||G.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(Q.length===1){const U=this.getWorkingArea(Q[0]);if(U){let X=function(){!G||typeof G.x!="number"||typeof G.y!="number"||!U||(G.x<U.x&&(G.x=U.x),G.y<U.y&&(G.y=U.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",U),X(),G.width>U.width&&(G.width=U.width),G.height>U.height&&(G.height=U.height),G.x>U.x+U.width-128&&(G.x=U.x+U.width-G.width),G.y>U.y+U.height-128&&(G.y=U.y+U.height-G.height),X()}return G}if(G.display&&G.mode===3){const U=Q.find(X=>X.id===G.display);if(U&&typeof U.bounds?.x=="number"&&typeof U.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const X=(0,T.defaultWindowState)(3);return X.x=U.bounds.x,X.y=U.bounds.y,X}}let O,z;try{O=w.screen.getDisplayMatching({x:G.x,y:G.y,width:G.width,height:G.height}),z=this.getWorkingArea(O)}catch(U){}if(O&&z&&G.x+G.width>z.x&&G.y+G.height>z.y&&G.x<z.x+z.width&&G.y<z.y+z.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",z),G}getWorkingArea(G){if(G.workArea.width>0&&G.workArea.height>0)return G.workArea;if(G.bounds.width>0&&G.bounds.height>0)return G.bounds}getBounds(){const[G,Q]=this._win.getPosition(),[O,z]=this._win.getSize();return{x:G,y:Q,width:O,height:z}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(G){this.useNativeFullScreen()?this.setNativeFullScreen(G):this.setSimpleFullScreen(G),this.sendWhenReady(G?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(G){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(G)}setSimpleFullScreen(G){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(G),this._win.webContents.focus()}useNativeFullScreen(){const G=this.configurationService.getValue("window");return!G||typeof G.nativeFullScreen!="boolean"||G.nativeTabs?!0:G.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let G=(0,L.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(G)<0&&(G="classic"),G}setMenuBarVisibility(G,Q=!0){b.isMacintosh||(G==="toggle"&&Q&&this.send("vscode:showInfoMessage",(0,y.localize)(10,null)),G==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(G)}):this.doSetMenuBarVisibility(G))}doSetMenuBarVisibility(G){const Q=this.isFullScreen;switch(G){case"classic":this._win.setMenuBarVisibility(!Q),this._win.autoHideMenuBar=Q;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(b.isMacintosh)switch(w.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(G,Q,...O){this.isReady?this.send(G,...O):this.ready().then(()=>{Q.isCancellationRequested||this.send(G,...O)})}send(G,...Q){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${G} for window that is destroyed`);return}this._win.webContents.send(G,...Q)}}updateTouchBar(G){!b.isMacintosh||this.touchBarGroups.forEach((Q,O)=>{const z=G[O];Q.segments=this.createTouchBarGroupSegments(z)})}createTouchBar(){if(!!b.isMacintosh){for(let G=0;G<10;G++){const Q=this.createTouchBarGroup();this.touchBarGroups.push(Q)}this._win.setTouchBar(new w.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(G=[]){const Q=this.createTouchBarGroupSegments(G),O=new w.TouchBar.TouchBarSegmentedControl({segments:Q,mode:"buttons",segmentStyle:"automatic",change:z=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:O.segments[z].id,from:"touchbar"})}});return O}createTouchBarGroupSegments(G=[]){return G.map(O=>{let z;O.icon&&!p.ThemeIcon.isThemeIcon(O.icon)&&O.icon?.dark?.scheme===f.Schemas.file&&(z=w.nativeImage.createFromPath(I.URI.revive(O.icon.dark).fsPath),z.isEmpty()&&(z=void 0));let U;return typeof O.title=="string"?U=O.title:U=O.title.value,{id:O.id,label:z?void 0:U,icon:z}})}dispose(){super.dispose(),this._win=null}};x=ue([te(1,i.ILogService),te(2,v.IEnvironmentMainService),te(3,a.IFileService),te(4,o.IStorageMainService),te(5,g.IConfigurationService),te(6,E.IThemeMainService),te(7,C.IWorkspacesManagementMainService),te(8,h.IBackupMainService),te(9,l.ITelemetryService),te(10,P.IDialogMainService),te(11,c.ILifecycleMainService),te(12,s.IProductService),te(13,r.IProtocolMainService)],x),e.CodeWindow=x}),define(J[62],Z([0,1,14,34,9,5,32,2,10,3,15,7,18,152,4,22,6,39,27,45]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g,P,v,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,h.createDecorator)("workspacesHistoryMainService");let a=class je extends n.Disposable{constructor(p,E,L,T){super();this.stateMainService=p,this.logService=E,this.workspacesManagementMainService=L,this.lifecycleMainService=T,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(p=>this.addRecentlyOpened([{workspace:p.workspace}])))}handleWindowsJumpList(){!m.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(p){const E=[],L=[];for(let T of p)if((0,u.isRecentWorkspace)(T))!this.workspacesManagementMainService.isUntitledWorkspace(T.workspace)&&s(E,T.workspace)===-1&&E.push(T);else if((0,u.isRecentFolder)(T))r(E,T.folderUri)===-1&&E.push(T);else{const W=o(L,T.fileUri)>=0,C=T.fileUri.scheme===f.Schemas.file&&je.COMMON_FILES_FILTER.indexOf((0,t.basename)(T.fileUri))>=0;!W&&!C&&(L.push(T),m.isWindows&&T.fileUri.scheme===f.Schemas.file&&w.app.addRecentDocument(T.fileUri.fsPath))}this.addEntriesFromStorage(E,L),E.length>je.MAX_TOTAL_RECENT_ENTRIES&&(E.length=je.MAX_TOTAL_RECENT_ENTRIES),L.length>je.MAX_TOTAL_RECENT_ENTRIES&&(L.length=je.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:E,files:L}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(p){const E=C=>{const V=i(C);for(const x of p)if(t.extUriBiasedIgnorePathCase.isEqual(x,V))return!1;return!0},L=this.getRecentlyOpened(),T=L.workspaces.filter(E),W=L.files.filter(E);(T.length!==L.workspaces.length||W.length!==L.files.length)&&(this.saveRecentlyOpened({files:W,workspaces:T}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!m.isMacintosh)return;w.app.clearRecentDocuments();const p=this.getRecentlyOpened(),E=[];let L=0;for(let W=0;W<p.workspaces.length&&L<je.MAX_MACOS_DOCK_RECENT_WORKSPACES;W++){const C=i(p.workspaces[W]);if(C.scheme===f.Schemas.file){const V=(0,t.originalFSPath)(C);await I.Promises.exists(V)&&(E.push(V),L++)}}const T=[];for(let W=0;W<p.files.length&&L<je.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;W++){const C=i(p.files[W]);if(C.scheme===f.Schemas.file){const V=(0,t.originalFSPath)(C);if(je.COMMON_FILES_FILTER.includes((0,t.basename)(C))||E.includes(V))continue;await I.Promises.exists(V)&&(T.push(V),L++)}}T.reverse().forEach(W=>w.app.addRecentDocument(W)),E.reverse().forEach(W=>w.app.addRecentDocument(W))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),w.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(p){const E=[],L=[],T=p?.config?.workspace;(0,u.isWorkspaceIdentifier)(T)&&!this.workspacesManagementMainService.isUntitledWorkspace(T)?E.push({workspace:T}):(0,u.isSingleFolderWorkspaceIdentifier)(T)&&E.push({folderUri:T.uri});const W=p?.config?.filesToOpenOrCreate;if(W)for(let C of W){const V=C.fileUri;V&&o(L,V)===-1&&L.push({fileUri:V})}return this.addEntriesFromStorage(E,L),{workspaces:E,files:L}}addEntriesFromStorage(p,E){let L=this.getRecentlyOpenedFromStorage();for(let T of L.workspaces){let W=(0,u.isRecentFolder)(T)?r(p,T.folderUri):s(p,T.workspace);W>=0?p[W].label=p[W].label||T.label:p.push(T)}for(let T of L.files){let W=o(E,T.fileUri);W>=0?E[W].label=E[W].label||T.label:E.push(T)}}getRecentlyOpenedFromStorage(){const p=this.stateMainService.getItem(je.recentlyOpenedStorageKey);return(0,u.restoreRecentlyOpened)(p,this.logService)}saveRecentlyOpened(p){const E=(0,u.toStoreData)(p);this.stateMainService.setItem(je.recentlyOpenedStorageKey,E)}updateWindowsJumpList(){if(!m.isWindows)return;const p=[];if(p.push({type:"tasks",items:[{type:"task",title:(0,y.localize)(0,null),description:(0,y.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let E=[];for(let W of w.app.getJumpListSettings().removedItems){const C=W.args;if(C){const V=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(C);V&&E.push(b.URI.parse(V[2]))}}this.removeRecentlyOpened(E);let L=!1;const T=(0,A.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(W=>{const C=(0,u.isRecentWorkspace)(W)?W.workspace:W.folderUri,{title:V,description:x}=this.getWindowsJumpListLabel(C,W.label);let se;return b.URI.isUri(C)?se=`--folder-uri "${C.toString()}"`:(L=!0,se=`--file-uri "${C.configPath.toString()}"`),{type:"task",title:V.substr(0,255),description:x.substr(0,255),program:process.execPath,args:se,iconPath:"explorer.exe",iconIndex:0}}));T.length>0&&p.push({type:"custom",name:L?(0,y.localize)(2,null):(0,y.localize)(3,null),items:T})}p.push({type:"recent"});try{w.app.setJumpList(p)}catch(E){this.logService.warn("updateWindowsJumpList#setJumpList",E)}}getWindowsJumpListLabel(p,E){if(E)return{title:(0,S.splitName)(E).name,description:E};if(b.URI.isUri(p))return{title:(0,t.basename)(p),description:c(p)};if(this.workspacesManagementMainService.isUntitledWorkspace(p))return{title:(0,y.localize)(4,null),description:""};let L=(0,t.basename)(p.configPath);return L.endsWith(u.WORKSPACE_EXTENSION)&&(L=L.substr(0,L.length-u.WORKSPACE_EXTENSION.length-1)),{title:(0,y.localize)(5,null,L),description:c(p.configPath)}}};a.MAX_TOTAL_RECENT_ENTRIES=100,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=ue([te(0,v.IStateMainService),te(1,P.ILogService),te(2,d.IWorkspacesManagementMainService),te(3,g.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a;function c(l){return l.scheme==="file"?(0,S.normalizeDriveLetter)(l.fsPath):l.toString()}function i(l){return(0,u.isRecentFolder)(l)?l.folderUri:(0,u.isRecentFile)(l)?l.fileUri:l.workspace.configPath}function s(l,p){return l.findIndex(E=>(0,u.isRecentWorkspace)(E)&&E.workspace.id===p.id)}function r(l,p){return l.findIndex(E=>(0,u.isRecentFolder)(E)&&t.extUriBiasedIgnorePathCase.isEqual(E.folderUri,p))}function o(l,p){return l.findIndex(E=>t.extUriBiasedIgnorePathCase.isEqual(E.fileUri,p))}}),define(J[234],Z([0,1,14,9,24,32,3,7,144,21,23,22,6,182,53,20,39,33,42,61,36,62]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g,P,v,u,d,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let s=class wt{constructor(l,p,E,L,T,W,C,V,x,se,G){this.updateService=l,this.configurationService=p,this.windowsMainService=E,this.environmentMainService=L,this.telemetryService=T,this.workspacesHistoryMainService=W,this.stateMainService=C,this.lifecycleMainService=V,this.logService=x,this.nativeHostMainService=se,this.productService=G,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new A.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new A.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(S.isMacintosh||(0,d.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const l=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);l&&(l.menus&&(this.menubarMenus=l.menus),l.keybindings&&(this.keybindings=l.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(W,C,V)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(W,C,V)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:C?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(W,C,V)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(V),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(W,C,V)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(V),telemetryExtraData:{from:i}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const l=this.productService.twitterUrl;l&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(l,"openTwitterUrl"));const p=this.productService.requestFeatureUrl;p&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(p,"openUserVoiceUrl"));const E=this.productService.reportIssueUrl;E&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(E,"openReportIssues"));const L=this.productService.licenseUrl;L&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(S.language){const W=L.indexOf("?")>0?"&":"?";this.openUrl(`${L}${W}lang=${S.language}`,"openLicenseUrl")}else this.openUrl(L,"openLicenseUrl")});const T=this.productService.privacyStatementUrl;T&&L&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(T,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(l=>this.onDidChangeWindowsCount(l)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let l=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof l!="boolean"?!0:l}get currentEnableNativeTabs(){if(!S.isMacintosh)return!1;let l=this.configurationService.getValue("window.nativeTabs");return typeof l!="boolean"?!1:l}updateMenu(l,p){this.menubarMenus=l.menus,this.keybindings=l.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,l),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(l){!S.isMacintosh||(l.oldCount===0&&l.newCount>0||l.oldCount>0&&l.newCount===0)&&(this.closedLastWindow=l.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!S.isMacintosh||(this.noActiveWindow=!w.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const l=w.Menu.getApplicationMenu();if(l&&this.oldMenus.push(l),Object.keys(this.menubarMenus).length===0){w.Menu.setApplicationMenu(S.isMacintosh?new w.Menu:null);return}const p=new w.Menu;let E;if(S.isMacintosh){const T=new w.Menu;E=new w.MenuItem({label:this.productService.nameShort,submenu:T}),this.setMacApplicationMenu(T),p.append(E)}if(S.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const T=new w.Menu;T.append(new w.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),w.app.dock.setMenu(T)}if(this.shouldDrawMenu("File")){const T=new w.Menu,W=new w.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:T});this.setMenuById(T,"File"),p.append(W)}if(this.shouldDrawMenu("Edit")){const T=new w.Menu,W=new w.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:T});this.setMenuById(T,"Edit"),p.append(W)}if(this.shouldDrawMenu("Selection")){const T=new w.Menu,W=new w.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:T});this.setMenuById(T,"Selection"),p.append(W)}if(this.shouldDrawMenu("View")){const T=new w.Menu,W=new w.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:T});this.setMenuById(T,"View"),p.append(W)}if(this.shouldDrawMenu("Go")){const T=new w.Menu,W=new w.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:T});this.setMenuById(T,"Go"),p.append(W)}if(this.shouldDrawMenu("Run")){const T=new w.Menu,W=new w.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:T});this.setMenuById(T,"Run"),p.append(W)}if(this.shouldDrawMenu("Terminal")){const T=new w.Menu,W=new w.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:T});this.setMenuById(T,"Terminal"),p.append(W)}let L;if(this.shouldDrawMenu("Window")){const T=new w.Menu;L=new w.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:T,role:"window"}),this.setMacWindowMenu(T)}if(L&&p.append(L),this.shouldDrawMenu("Help")){const T=new w.Menu,W=new w.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:T,role:"help"});this.setMenuById(T,"Help"),p.append(W)}p.items&&p.items.length>0?w.Menu.setApplicationMenu(p):w.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(l){const p=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),E=this.getUpdateMenuItems();let L;if(this.shouldDrawMenu("Preferences")){const Q=new w.Menu;this.setMenuById(Q,"Preferences"),L=new w.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:Q})}const T=new w.Menu,W=new w.MenuItem({label:f.localize(12,null),role:"services",submenu:T}),C=new w.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),V=new w.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new w.MenuItem({label:f.localize(15,null),role:"unhide"}),se=new w.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:()=>{const Q=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!w.BrowserWindow.getFocusedWindow()||Q?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),G=[p];G.push(...E),L&&G.push(r(),L),G.push(r(),W,r(),C,V,x,r(),se),G.forEach(Q=>l.append(Q))}shouldDrawMenu(l){if(!S.isMacintosh&&(0,d.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(l){case"File":case"Help":if(S.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[l];case"Window":if(S.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[l]}}setMenu(l,p){p.forEach(E=>{if((0,y.isMenubarMenuItemSeparator)(E))l.append(r());else if((0,y.isMenubarMenuItemSubmenu)(E)){const L=new w.Menu,T=new w.MenuItem({label:this.mnemonicLabel(E.label),submenu:L});this.setMenu(L,E.submenu.items),l.append(T)}else(0,y.isMenubarMenuItemRecentAction)(E)?l.append(this.createOpenRecentMenuItem(E)):(0,y.isMenubarMenuItemAction)(E)&&(E.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(l),S.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[E.id]?l.append(new w.MenuItem(this.likeAction(E.id,{label:this.mnemonicLabel(E.label),click:this.fallbackMenuHandlers[E.id]}))):l.append(this.createMenuItem(E.label,E.id,!1,E.checked)):l.append(this.createMenuItem(E.label,E.id,E.enabled!==!1,!!E.checked)):l.append(this.createMenuItem(E.label,E.id,E.enabled!==!1,!!E.checked)))})}setMenuById(l,p){this.menubarMenus&&this.menubarMenus[p]&&this.setMenu(l,this.menubarMenus[p].items)}insertCheckForUpdatesItems(l){const p=this.getUpdateMenuItems();p.length&&(p.forEach(E=>l.append(E)),l.append(r()))}createOpenRecentMenuItem(l){const p=n.URI.revive(l.uri),E=l.id,L=E==="openRecentFile"?{fileUri:p}:E==="openRecentWorkspace"?{workspaceUri:p}:{folderUri:p};return new w.MenuItem(this.likeAction(E,{label:l.label,click:(T,W,C)=>{const V=this.isOptionClick(C);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[L],forceNewWindow:V,gotoLineMode:!1,remoteAuthority:l.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([p])}},!1))}isOptionClick(l){return!!(l&&(!S.isMacintosh&&(l.ctrlKey||l.shiftKey)||S.isMacintosh&&(l.metaKey||l.altKey)))}createRoleMenuItem(l,p,E){const L={label:this.mnemonicLabel(l),role:E,enabled:!0};return new w.MenuItem(this.withKeybinding(p,L))}setMacWindowMenu(l){const p=new w.MenuItem({label:f.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),E=new w.MenuItem({label:f.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),L=new w.MenuItem({label:f.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),T=this.createMenuItem(f.localize(20,null),"workbench.action.switchWindow"),W=[];this.currentEnableNativeTabs&&(W.push(r()),W.push(this.createMenuItem(f.localize(21,null),"workbench.action.newWindowTab")),W.push(this.createRoleMenuItem(f.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),W.push(this.createRoleMenuItem(f.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),W.push(this.createRoleMenuItem(f.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),W.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[p,E,r(),T,...W,r(),L].forEach(C=>l.append(C))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new w.MenuItem({label:this.mnemonicLabel(f.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new w.MenuItem({label:f.localize(27,null),enabled:!1})];case"available for download":return[new w.MenuItem({label:this.mnemonicLabel(f.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new w.MenuItem({label:f.localize(29,null),enabled:!1})];case"downloaded":return[new w.MenuItem({label:this.mnemonicLabel(f.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new w.MenuItem({label:f.localize(31,null),enabled:!1})];case"ready":return[new w.MenuItem({label:this.mnemonicLabel(f.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(l,p,E,L){const T=this.mnemonicLabel(l),W=typeof p=="function"?p:(G,Q,O)=>{const z=G?G.userSettingsLabel:null;let U=p;Array.isArray(p)&&(U=this.isOptionClick(O)?p[1]:p[0]),z&&O.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:z}):this.runActionInRenderer({type:"commandId",commandId:U})},C=typeof E=="boolean"?E:this.windowsMainService.getWindowCount()>0,V=typeof L=="boolean"?L:!1,x={label:T,click:W,enabled:C};V&&(x.type="checkbox",x.checked=V);let se;return typeof p=="string"?se=p:Array.isArray(p)&&(se=p[0]),S.isMacintosh&&(se==="editor.action.clipboardCutAction"?x.role="cut":se==="editor.action.clipboardCopyAction"?x.role="copy":se==="editor.action.clipboardPasteAction"&&(x.role="paste"),se==="undo"?x.click=this.makeContextAwareClickHandler(W,{inDevTools:G=>G.undo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?x.click=this.makeContextAwareClickHandler(W,{inDevTools:G=>G.redo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(x.click=this.makeContextAwareClickHandler(W,{inDevTools:G=>G.selectAll(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("selectAll:")}))),new w.MenuItem(this.withKeybinding(se,x))}makeContextAwareClickHandler(l,p){return(E,L,T)=>{const W=w.BrowserWindow.getFocusedWindow();if(!W)return p.inNoWindow();if(W.webContents.isDevToolsFocused()&&W.webContents.devToolsWebContents)return p.inDevTools(W.webContents.devToolsWebContents);l(E,L||W,T)}}runActionInRenderer(l){let p=w.BrowserWindow.getFocusedWindow();if(!p){const L=this.windowsMainService.getLastActiveWindow();L?.isMinimized()&&(p=L.win)}const E=p?this.windowsMainService.getWindowById(p.id):void 0;if(E){if(this.logService.trace("menubar#runActionInRenderer",l),S.isMacintosh&&!this.environmentMainService.isBuilt&&!E.isReady&&(l.type==="commandId"&&l.commandId==="workbench.action.toggleDevTools"||l.type!=="commandId"&&l.userSettingsLabel==="alt+cmd+i"))return;if(l.type==="commandId"){const L={id:l.commandId,from:"menu"};E.sendWhenReady("vscode:runAction",k.CancellationToken.None,L)}else{const L={userSettingsLabel:l.userSettingsLabel};E.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,L)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",l)}withKeybinding(l,p){const E=typeof l=="string"?this.keybindings[l]:void 0;if(E?.label){if(E.isNative!==!1)p.accelerator=E.label,p.userSettingsLabel=E.userSettingsLabel;else if(typeof p.label=="string"){const L=p.label.indexOf("[");L>=0?p.label=`${p.label.substr(0,L)} [${E.label}]`:p.label=`${p.label} [${E.label}]`}}else p.accelerator=void 0;return p}likeAction(l,p,E=!p.accelerator){E&&(p=this.withKeybinding(l,p));const L=p.click;return p.click=(T,W,C)=>{this.reportMenuActionTelemetry(l),L&&L(T,W,C)},p}openUrl(l,p){this.nativeHostMainService.openExternal(void 0,l),this.reportMenuActionTelemetry(p)}reportMenuActionTelemetry(l){this.telemetryService.publicLog2("workbenchActionExecuted",{id:l,from:i})}mnemonicLabel(l){return(0,M.mnemonicMenuLabel)(l,!this.currentEnableMenuBarMnemonics)}};s.lastKnownMenubarStorageKey="lastKnownMenubarData",s=ue([te(0,u.IUpdateService),te(1,m.IConfigurationService),te(2,a.IWindowsMainService),te(3,t.IEnvironmentMainService),te(4,v.ITelemetryService),te(5,c.IWorkspacesHistoryMainService),te(6,P.IStateMainService),te(7,b.ILifecycleMainService),te(8,I.ILogService),te(9,h.INativeHostMainService),te(10,g.IProductService)],s),e.Menubar=s;function r(){return new w.MenuItem({type:"separator"})}}),define(J[235],Z([0,1,4,22,6,234]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,w.createDecorator)("menubarMainService");let S=class{constructor(f,m,t){this.instantiationService=f,this.lifecycleMainService=m,this.logService=t,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(M.Menubar)}async updateMenubar(f,m){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(m,f)}};S=ue([te(0,w.IInstantiationService),te(1,A.ILifecycleMainService),te(2,k.ILogService)],S),e.MenubarMainService=S}),define(J[236],Z([0,1,14,30,26,34,24,5,29,43,32,2,10,8,72,3,31,15,13,7,150,51,21,52,23,19,4,22,6,48,20,55,73,39,61,233,99,216,27,100,62,45]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g,P,v,u,d,a,c,i,s,r,o,l,p,E,L,T,W,C,V,x,se,G,Q,O,z,U,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function H(F){return(0,O.isWorkspaceIdentifier)(F?.workspace)}function _(F){return(0,O.isSingleFolderWorkspaceIdentifier)(F?.workspace)}let j=class Je extends b.Disposable{constructor(D,R,N,B,$,Y,ee,ie,oe,ce,ne,le,ve,fe,we){super();this.machineId=D,this.initialUserEnv=R,this.logService=N,this.stateMainService=B,this.environmentMainService=$,this.lifecycleMainService=Y,this.backupMainService=ee,this.configurationService=ie,this.workspacesHistoryMainService=oe,this.workspacesManagementMainService=ce,this.instantiationService=ne,this.dialogMainService=le,this.fileService=ve,this.productService=fe,this.protocolMainService=we,this._onDidOpenWindow=this._register(new n.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new n.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new n.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new n.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new Q.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(D=>this._onDidSignalReadyWindow.fire(D.window))),this._register(this.onDidSignalReadyWindow(D=>{if(D.config?.extensionDevelopmentPath||D.config?.extensionTestsPath){const R=new b.DisposableStore;if(R.add(n.Event.any(D.onDidClose,D.onDidDestroy)(()=>R.dispose())),D.config.extensionDevelopmentPath)for(const N of D.config.extensionDevelopmentPath)R.add(this.protocolMainService.addValidFileRoot(d.URI.file(N)));D.config.extensionTestsPath&&R.add(this.protocolMainService.addValidFileRoot(d.URI.file(D.config.extensionTestsPath)))}}))}openEmptyWindow(D,R){let N=this.environmentMainService.args;const B=R?.remoteAuthority||void 0,$=!0,Y=R?.forceReuseWindow,ee=!Y;return this.open({...D,cli:N,forceEmpty:$,forceNewWindow:ee,forceReuseWindow:Y,remoteAuthority:B})}open(D){this.logService.trace("windowsManager#open"),D.addMode&&(D.initialStartup||!this.getLastActiveWindow())&&(D.addMode=!1);const R=[],N=[],B=[],$=[],Y=[];let ee,ie=0;const oe=this.getPathsToOpen(D);this.logService.trace("windowsManager#open pathsToOpen",oe);for(const fe of oe)_(fe)?D.addMode?R.push(fe):N.push(fe):H(fe)?B.push(fe):fe.fileUri?(ee||(ee={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:fe.remoteAuthority}),ee.filesToOpenOrCreate.push(fe)):fe.backupPath?Y.push({backupFolder:(0,y.basename)(fe.backupPath),remoteAuthority:fe.remoteAuthority}):ie++;D.diffMode&&ee?.filesToOpenOrCreate.length===2&&(ee.filesToDiff=ee.filesToOpenOrCreate,ee.filesToOpenOrCreate=[]),ee&&D.waitMarkerFileURI&&(ee.filesToWait={paths:[...ee.filesToDiff,...ee.filesToOpenOrCreate],waitMarkerFileUri:D.waitMarkerFileURI}),D.initialStartup?($.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),B.push(...$),Y.push(...this.backupMainService.getEmptyWindowBackupPaths())):Y.length=0;const{windows:ce,filesOpenedInWindow:ne}=this.doOpen(D,B,N,Y,ie,ee,R);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${B.length}, foldersToOpen: ${N.length}, emptyToRestore: ${Y.length}, emptyToOpen: ${ie})`),ce.length>1)if(ne)ne.focus();else{const fe=this.windowsStateHandler.state.lastActiveWindow&&!D.forceEmpty&&!D.cli._.length&&!D.cli["file-uri"]&&!D.cli["folder-uri"]&&!(D.urisToOpen&&D.urisToOpen.length);let we=!0,Ae=!0;if(fe){const Se=ce.filter(me=>this.windowsStateHandler.state.lastActiveWindow&&me.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Se.length&&(Se[0].focus(),we=!1,Ae=!1)}if(we)for(let Se=ce.length-1;Se>=0;Se--){const me=ce[Se];if(!(me.openedWorkspace&&$.some(Ee=>me.openedWorkspace&&Ee.workspace.id===me.openedWorkspace.id)||me.backupPath&&Y.some(Ee=>me.backupPath&&Ee.backupFolder===(0,y.basename)(me.backupPath)))){me.focus(),Ae=!1;break}}Ae&&ce[ce.length-1].focus()}const le=ee&&ee.filesToDiff.length>0;if(!ce.some(fe=>fe.isExtensionDevelopmentHost)&&!le&&!D.noRecentEntry){const fe=[];for(const we of oe)H(we)&&!we.transient?fe.push({label:we.label,workspace:we.workspace,remoteAuthority:we.remoteAuthority}):_(we)?fe.push({label:we.label,folderUri:we.workspace.uri,remoteAuthority:we.remoteAuthority}):we.fileUri&&fe.push({label:we.label,fileUri:we.fileUri,remoteAuthority:we.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(fe)}const ve=D.waitMarkerFileURI;return D.context===0&&ve&&ce.length===1&&ce[0]&&(async()=>{await ce[0].whenClosedOrLoaded;try{await this.fileService.del(ve)}catch(fe){}})(),ce}doOpen(D,R,N,B,$,Y,ee){const ie=[];let oe;function ce(Se,me){ie.push(Se),me&&(oe=Se,Y=void 0)}let{openFolderInNewWindow:ne,openFilesInNewWindow:le}=this.shouldOpenNewWindow(D);if(!D.initialStartup&&ee.length>0){const Se=ee[0].remoteAuthority,me=this.getLastActiveWindowForAuthority(Se);me&&ce(this.doAddFoldersToExistingWindow(me,ee.map(Ee=>Ee.workspace.uri)))}const ve=N.length+R.length+B.length;if(Y&&ve===0){const Se=Y.filesToOpenOrCreate[0]||Y.filesToDiff[0],me=this.getWindows().filter(De=>Y&&De.remoteAuthority===Y.remoteAuthority);let Ee;Se?.fileUri&&!le&&((D.context===4||D.context===0||D.context===1)&&(Ee=(0,G.findWindowOnFile)(me,Se.fileUri,De=>De.configPath.scheme===I.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(De.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(me))),Ee?(0,O.isWorkspaceIdentifier)(Ee.openedWorkspace)?R.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,O.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?N.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(D,Ee,Y),!0):ce(this.openInBrowserWindow({userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,filesToOpen:Y,forceNewWindow:!0,remoteAuthority:Y.remoteAuthority,forceNewTabbedWindow:D.forceNewTabbedWindow}),!0)}const fe=(0,M.distinct)(R,Se=>Se.workspace.id);if(fe.length>0){const Se=(0,M.coalesce)(fe.map(me=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.configPath)));if(Se.length>0){const me=Se[0],Ee=Y?.remoteAuthority===me.remoteAuthority?Y:void 0;ce(this.doOpenFilesInExistingWindow(D,me,Ee),!!Ee),ne=!0}fe.forEach(me=>{if(Se.some(Te=>Te.openedWorkspace&&Te.openedWorkspace.id===me.workspace.id))return;const Ee=me.remoteAuthority,De=Y?.remoteAuthority===Ee?Y:void 0;ce(this.doOpenFolderOrWorkspace(D,me,ne,De),!!De),ne=!0})}const we=(0,M.distinct)(N,Se=>v.extUriBiasedIgnorePathCase.getComparisonKey(Se.workspace.uri));if(we.length>0){const Se=(0,M.coalesce)(we.map(me=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.uri)));if(Se.length>0){const me=Se[0],Ee=Y?.remoteAuthority===me.remoteAuthority?Y:void 0;ce(this.doOpenFilesInExistingWindow(D,me,Ee),!!Ee),ne=!0}we.forEach(me=>{if(Se.some(Te=>(0,O.isSingleFolderWorkspaceIdentifier)(Te.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Te.openedWorkspace.uri,me.workspace.uri)))return;const Ee=me.remoteAuthority,De=Y?.remoteAuthority===Ee?Y:void 0;ce(this.doOpenFolderOrWorkspace(D,me,ne,De),!!De),ne=!0})}const Ae=(0,M.distinct)(B,Se=>Se.backupFolder);if(Ae.length>0&&Ae.forEach(Se=>{const me=Se.remoteAuthority,Ee=Y?.remoteAuthority===me?Y:void 0;ce(this.openInBrowserWindow({userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,filesToOpen:Ee,remoteAuthority:me,forceNewWindow:!0,forceNewTabbedWindow:D.forceNewTabbedWindow,emptyWindowBackupInfo:Se}),!!Ee),ne=!0}),ie.length===0||Y){Y&&!$&&$++;const Se=Y?Y.remoteAuthority:D.remoteAuthority;for(let me=0;me<$;me++)ce(this.doOpenEmpty(D,ne,Se,Y),!!Y),ne=!0}return{windows:(0,M.distinct)(ie),filesOpenedInWindow:oe}}doOpenFilesInExistingWindow(D,R,N){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),R.focus();const B={filesToOpenOrCreate:N?.filesToOpenOrCreate,filesToDiff:N?.filesToDiff,filesToWait:N?.filesToWait,termProgram:D?.userEnv?.TERM_PROGRAM};return R.sendWhenReady("vscode:openFiles",S.CancellationToken.None,B),R}doAddFoldersToExistingWindow(D,R){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),D.focus();const N={foldersToAdd:R};return D.sendWhenReady("vscode:addFolders",S.CancellationToken.None,N),D}doOpenEmpty(D,R,N,B,$){return!R&&!$&&typeof D.contextWindowId=="number"&&($=this.getWindowById(D.contextWindowId)),this.openInBrowserWindow({userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,remoteAuthority:N,forceNewWindow:R,forceNewTabbedWindow:D.forceNewTabbedWindow,filesToOpen:B,windowToUse:$})}doOpenFolderOrWorkspace(D,R,N,B,$){return!N&&!$&&typeof D.contextWindowId=="number"&&($=this.getWindowById(D.contextWindowId)),this.openInBrowserWindow({workspace:R.workspace,userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,remoteAuthority:R.remoteAuthority,forceNewWindow:N,forceNewTabbedWindow:D.forceNewTabbedWindow,filesToOpen:B,windowToUse:$})}getPathsToOpen(D){let R,N=!1,B=!1;if(D.urisToOpen&&D.urisToOpen.length>0?(R=this.doExtractPathsFromAPI(D),N=!0):D.forceEmpty?R=[Object.create(null)]:D.cli._.length||D.cli["folder-uri"]||D.cli["file-uri"]?(R=this.doExtractPathsFromCLI(D.cli),R.length===0&&R.push(Object.create(null)),N=!0):(R=this.doGetPathsFromLastSession(),R.length===0&&R.push(Object.create(null)),B=!0),!D.addMode&&N){const $=R.filter(Y=>_(Y));if($.length>1){const Y=$[0].remoteAuthority;if($.every(ee=>ee.remoteAuthority===Y)){const ee=this.workspacesManagementMainService.createUntitledWorkspaceSync($.map(ie=>({uri:ie.workspace.uri})));R.push({workspace:ee,remoteAuthority:Y}),R=R.filter(ie=>!_(ie))}}}return D.initialStartup&&!B&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&R.unshift(...this.doGetPathsFromLastSession().filter($=>H($)||_($)||$.backupPath)),R}doExtractPathsFromAPI(D){const R=[],N={gotoLineMode:D.gotoLineMode,remoteAuthority:D.remoteAuthority};for(const B of(0,M.coalesce)(D.urisToOpen||[])){const $=this.resolveOpenable(B,N);if($)$.label=B.label,R.push($);else{const Y=this.resourceFromOpenable(B),ee={title:this.productService.nameLong,type:"info",buttons:[(0,t.mnemonicButtonLabel)((0,a.localize)(0,null))],defaultId:0,message:Y.scheme===I.Schemas.file?(0,a.localize)(1,null):(0,a.localize)(2,null),detail:Y.scheme===I.Schemas.file?(0,a.localize)(3,null,(0,t.getPathLabel)(Y.fsPath,this.environmentMainService)):(0,a.localize)(4,null,Y.toString()),noLink:!0};this.dialogMainService.showMessageBox(ee,(0,u.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))}}return R}doExtractPathsFromCLI(D){const R=[],N={ignoreFileNotFound:!0,gotoLineMode:D.goto,remoteAuthority:D.remote||void 0,forceOpenWorkspaceAsFile:!1},B=D["folder-uri"];if(B)for(const ee of B){const ie=this.cliArgToUri(ee);if(ie){const oe=this.resolveOpenable({folderUri:ie},N);oe&&R.push(oe)}}const $=D["file-uri"];if($)for(const ee of $){const ie=this.cliArgToUri(ee);if(ie){const oe=this.resolveOpenable((0,O.hasWorkspaceFileExtension)(ee)?{workspaceUri:ie}:{fileUri:ie},N);oe&&R.push(oe)}}const Y=D._;for(const ee of Y){const ie=N.remoteAuthority?this.doResolvePathRemote(ee,N):this.doResolveFilePath(ee,N);ie&&R.push(ie)}return R}cliArgToUri(D){try{const R=d.URI.parse(D);if(!R.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${D}`);return}return R}catch(R){this.logService.error(`Invalid URI input string: ${D}, ${R.message}`)}}doGetPathsFromLastSession(){const D=this.getRestoreWindowsSetting();switch(D){case"none":return[];case"one":case"all":case"preserve":case"folders":const R=[];D!=="one"&&R.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&R.push(this.windowsStateHandler.state.lastActiveWindow);const N=[];for(const B of R)if(B.workspace){const $=this.resolveOpenable({workspaceUri:B.workspace.configPath},{remoteAuthority:B.remoteAuthority,rejectTransientWorkspaces:!0});H($)&&N.push($)}else if(B.folderUri){const $=this.resolveOpenable({folderUri:B.folderUri},{remoteAuthority:B.remoteAuthority});_($)&&N.push($)}else D!=="folders"&&B.backupPath&&N.push({backupPath:B.backupPath,remoteAuthority:B.remoteAuthority});return N}}getRestoreWindowsSetting(){let D;return this.lifecycleMainService.wasRestarted?D="all":(D=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(D)||(D="all")),D}resolveOpenable(D,R=Object.create(null)){let N=this.resourceFromOpenable(D);return N.scheme===I.Schemas.file?((0,x.isFileToOpen)(D)&&(R={...R,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(N.fsPath,R)):this.doResolveRemoteOpenable(D,R)}doResolveRemoteOpenable(D,R){let N=this.resourceFromOpenable(D);const B=(0,C.getRemoteAuthority)(N)||R.remoteAuthority;if(N=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(N)),(0,x.isFileToOpen)(D)){if(R.gotoLineMode){const{path:$,line:Y,column:ee}=(0,f.parseLineAndColumnAware)(N.path);return{fileUri:N.with({path:$}),selection:Y?{startLineNumber:Y,startColumn:ee||1}:void 0,remoteAuthority:B}}return{fileUri:N,remoteAuthority:B}}else if((0,x.isWorkspaceToOpen)(D))return{workspace:(0,z.getWorkspaceIdentifier)(N),remoteAuthority:B};return{workspace:(0,z.getSingleFolderWorkspaceIdentifier)(N),remoteAuthority:B}}resourceFromOpenable(D){return(0,x.isWorkspaceToOpen)(D)?D.workspaceUri:(0,x.isFolderToOpen)(D)?D.folderUri:D.fileUri}doResolveFilePath(D,R){let N,B;R.gotoLineMode&&({path:D,line:N,column:B}=(0,f.parseLineAndColumnAware)(D)),D=(0,f.sanitizeFilePath)((0,y.normalize)(D),(0,P.cwd)());try{const $=(0,A.statSync)(D);if($.isFile()){if(!R.forceOpenWorkspaceAsFile){const Y=this.workspacesManagementMainService.resolveLocalWorkspaceSync(d.URI.file(D));if(Y)return Y.transient&&R.rejectTransientWorkspaces?void 0:{workspace:{id:Y.id,configPath:Y.configPath},remoteAuthority:Y.remoteAuthority,exists:!0,transient:Y.transient}}return{fileUri:d.URI.file(D),selection:N?{startLineNumber:N,startColumn:B||1}:void 0,exists:!0}}else if($.isDirectory())return{workspace:(0,z.getSingleFolderWorkspaceIdentifier)(d.URI.file(D),$),exists:!0}}catch($){const Y=d.URI.file(D);if(this.workspacesHistoryMainService.removeRecentlyOpened([Y]),R.ignoreFileNotFound)return{fileUri:Y,exists:!1}}}doResolvePathRemote(D,R){const N=D.charCodeAt(0),B=R.remoteAuthority;let $,Y;R.gotoLineMode&&({path:D,line:$,column:Y}=(0,f.parseLineAndColumnAware)(D)),N!==47&&((0,f.isWindowsDriveLetter)(N)&&D.charCodeAt(D.charCodeAt(1))===58&&(D=(0,f.toSlashes)(D)),D=`/${D}`);const ee=d.URI.from({scheme:I.Schemas.vscodeRemote,authority:B,path:D});if(D.charCodeAt(D.length-1)!==47){if((0,O.hasWorkspaceFileExtension)(D))return R.forceOpenWorkspaceAsFile?{fileUri:ee,selection:$?{startLineNumber:$,startColumn:Y||1}:void 0,remoteAuthority:R.remoteAuthority}:{workspace:(0,z.getWorkspaceIdentifier)(ee),remoteAuthority:B};if(R.gotoLineMode||y.posix.basename(D).indexOf(".")!==-1)return{fileUri:ee,selection:$?{startLineNumber:$,startColumn:Y||1}:void 0,remoteAuthority:B}}return{workspace:(0,z.getSingleFolderWorkspaceIdentifier)(ee),remoteAuthority:B}}shouldOpenNewWindow(D){const R=this.configurationService.getValue("window"),N=R?.openFoldersInNewWindow||"default",B=R?.openFilesInNewWindow||"off";let $=(D.preferNewWindow||D.forceNewWindow)&&!D.forceReuseWindow;!D.forceNewWindow&&!D.forceReuseWindow&&(N==="on"||N==="off")&&($=N==="on");let Y=!1;return D.forceNewWindow||D.forceReuseWindow?Y=!!D.forceNewWindow&&!D.forceReuseWindow:(g.isMacintosh?D.context===1&&(Y=!0):D.context!==3&&D.context!==2&&!(D.userEnv&&D.userEnv.TERM_PROGRAM==="vscode")&&(Y=!0),!D.cli.extensionDevelopmentPath&&(B==="on"||B==="off")&&(Y=B==="on")),{openFolderInNewWindow:!!$,openFilesInNewWindow:Y}}openExtensionDevelopmentHostWindow(D,R){const N=(0,G.findWindowOnExtensionDevelopmentPath)(this.getWindows(),D);if(N)return this.lifecycleMainService.reload(N,R.cli),N.focus(),[N];let B=R.cli["folder-uri"]||[],$=R.cli["file-uri"]||[],Y=R.cli._;if(!Y.length&&!B.length&&!$.length&&!R.cli.extensionTestsPath){const ce=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ne=ce&&(ce.workspace||ce.folderUri);ne&&(d.URI.isUri(ne)?ne.scheme===I.Schemas.file?Y=[ne.fsPath]:B=[ne.toString()]:ne.configPath.scheme===I.Schemas.file?Y=[(0,v.originalFSPath)(ne.configPath)]:$=[ne.configPath.toString()])}let ee=R.remoteAuthority;for(const ce of D)if(ce.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ne=d.URI.parse(ce),le=(0,C.getRemoteAuthority)(ne);le&&(ee?le!==ee&&this.logService.error("more than one extension development path authority"):ee=le)}Y=Y.filter(ce=>{const ne=d.URI.file(ce);return(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:(0,C.getRemoteAuthority)(ne)===ee}),B=B.filter(ce=>{const ne=this.cliArgToUri(ce);return ne&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,C.getRemoteAuthority)(ne)===ee:!1}),$=$.filter(ce=>{const ne=this.cliArgToUri(ce);return ne&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,C.getRemoteAuthority)(ne)===ee:!1}),R.cli._=Y,R.cli["folder-uri"]=B,R.cli["file-uri"]=$;const ie=!Y.length&&!B.length&&!$.length,oe={context:R.context,cli:R.cli,forceNewWindow:!0,forceEmpty:ie,userEnv:R.userEnv,noRecentEntry:!0,waitMarkerFileURI:R.waitMarkerFileURI,remoteAuthority:ee};return this.open(oe)}openInBrowserWindow(D){const R=this.configurationService.getValue("window"),N={...this.environmentMainService.args,...D.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:D.emptyWindowBackupInfo?(0,y.join)(this.environmentMainService.backupHome,D.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:D.remoteAuthority,workspace:D.workspace,userEnv:{...this.initialUserEnv,...D.userEnv},filesToOpenOrCreate:D.filesToOpen?.filesToOpenOrCreate,filesToDiff:D.filesToOpen?.filesToDiff,filesToWait:D.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:L.default,isInitialStartup:D.initialStartup,perfMarks:(0,h.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof R?.zoomLevel=="number"?R.zoomLevel:void 0,autoDetectHighContrast:R?.autoDetectHighContrast??!0,accessibilitySupport:w.app.accessibilitySupportEnabled,colorScheme:{dark:w.nativeTheme.shouldUseDarkColors,highContrast:w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors}};let B;if(!D.forceNewWindow&&!D.forceNewTabbedWindow&&(B=D.windowToUse||this.getLastActiveWindow(),B&&B.focus()),B){const $=B.config;!N.extensionDevelopmentPath&&$&&!!$.extensionDevelopmentPath&&(N.extensionDevelopmentPath=$.extensionDevelopmentPath,N.verbose=$.verbose,N["inspect-brk-extensions"]=$["inspect-brk-extensions"],N.debugId=$.debugId,N["inspect-extensions"]=$["inspect-extensions"],N["extensions-dir"]=$["extensions-dir"])}else{const $=this.windowsStateHandler.getNewWindowState(N);(0,h.mark)("code/willCreateCodeWindow");const Y=B=this.instantiationService.createInstance(se.CodeWindow,{state:$,extensionDevelopmentPath:N.extensionDevelopmentPath,isExtensionTestHost:!!N.extensionTestsPath});if((0,h.mark)("code/didCreateCodeWindow"),D.forceNewTabbedWindow){const ie=this.getLastActiveWindow();ie&&ie.addTabbedWindow(Y)}Je.WINDOWS.push(Y),this._onDidOpenWindow.fire(Y),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(Y.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(Y)),(0,m.once)(Y.onDidClose)(()=>this.onWindowClosed(Y)),(0,m.once)(Y.onDidDestroy)(()=>this._onDidDestroyWindow.fire(Y));const ee=(0,u.assertIsDefined)(Y.win?.webContents);ee.removeAllListeners("devtools-reload-page"),ee.on("devtools-reload-page",()=>this.lifecycleMainService.reload(Y)),this.lifecycleMainService.registerWindow(Y)}return N.windowId=B.id,B.isReady?this.lifecycleMainService.unload(B,4).then($=>{$||this.doOpenInBrowserWindow(B,N,D)}):this.doOpenInBrowserWindow(B,N,D),B}doOpenInBrowserWindow(D,R,N){if(!R.extensionDevelopmentPath)if((0,O.isWorkspaceIdentifier)(R.workspace))R.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:R.workspace,remoteAuthority:R.remoteAuthority});else if((0,O.isSingleFolderWorkspaceIdentifier)(R.workspace))R.backupPath=this.backupMainService.registerFolderBackupSync(R.workspace.uri);else{const B=N.emptyWindowBackupInfo&&N.emptyWindowBackupInfo.backupFolder;R.backupPath=this.backupMainService.registerEmptyWindowBackupSync(B,R.remoteAuthority)}D.load(R)}onWindowClosed(D){const R=Je.WINDOWS.indexOf(D);Je.WINDOWS.splice(R,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const D=w.BrowserWindow.getFocusedWindow();if(D)return this.getWindowById(D.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(D){return this.doGetLastActiveWindow(this.getWindows().filter(R=>R.remoteAuthority===D))}doGetLastActiveWindow(D){const R=Math.max.apply(Math,D.map(N=>N.lastFocusTime));return D.find(N=>N.lastFocusTime===R)}sendToFocused(D,...R){const N=this.getFocusedWindow()||this.getLastActiveWindow();N&&N.sendWhenReady(D,S.CancellationToken.None,...R)}sendToAll(D,R,N){for(const B of this.getWindows())N&&N.indexOf(B.id)>=0||B.sendWhenReady(D,S.CancellationToken.None,R)}getWindows(){return Je.WINDOWS}getWindowCount(){return Je.WINDOWS.length}getWindowById(D){const R=this.getWindows().filter(N=>N.id===D);return(0,M.firstOrDefault)(R)}getWindowByWebContents(D){const R=w.BrowserWindow.fromWebContents(D);if(!!R)return this.getWindowById(R.id)}};j.WINDOWS=[],j=ue([te(2,E.ILogService),te(3,V.IStateMainService),te(4,r.IEnvironmentMainService),te(5,p.ILifecycleMainService),te(6,c.IBackupMainService),te(7,i.IConfigurationService),te(8,U.IWorkspacesHistoryMainService),te(9,X.IWorkspacesManagementMainService),te(10,l.IInstantiationService),te(11,s.IDialogMainService),te(12,o.IFileService),te(13,T.IProductService),te(14,W.IProtocolMainService)],j),e.WindowsMainService=j}),define(J[237],Z([0,1,51,36,62,45]),function(q,e,w,A,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let S=class{constructor(f,m,t,b){this.workspacesManagementMainService=f,this.windowsMainService=m,this.workspacesHistoryMainService=t,this.backupMainService=b,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,m){const t=this.windowsMainService.getWindowById(f);if(t)return this.workspacesManagementMainService.enterWorkspace(t,this.windowsMainService.getWindows(),m)}createUntitledWorkspace(f,m,t){return this.workspacesManagementMainService.createUntitledWorkspace(m,t)}deleteUntitledWorkspace(f,m){return this.workspacesManagementMainService.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(f,m){return this.workspacesManagementMainService.getWorkspaceIdentifier(m)}async getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}async addRecentlyOpened(f,m){return this.workspacesHistoryMainService.addRecentlyOpened(m)}async removeRecentlyOpened(f,m){return this.workspacesHistoryMainService.removeRecentlyOpened(m)}async clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};S=ue([te(0,M.IWorkspacesManagementMainService),te(1,A.IWindowsMainService),te(2,k.IWorkspacesHistoryMainService),te(3,w.IBackupMainService)],S),e.WorkspacesMainService=S}),define(J[238],Z([0,1,14,30,26,17,16,29,43,40,32,2,10,8,3,15,13,7,28,66,119,35,122,83,229,131,51,220,21,178,157,70,52,219,87,23,54,89,169,185,88,172,19,69,4,71,230,196,101,22,6,180,235,53,20,73,225,74,39,214,98,197,33,200,201,96,42,205,227,231,228,232,97,206,207,208,209,211,36,236,212,27,62,237,45]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g,P,v,u,d,a,c,i,s,r,o,l,p,E,L,T,W,C,V,x,se,G,Q,O,z,U,X,H,_,j,F,D,R,N,B,$,Y,ee,ie,oe,ce,ne,le,ve,fe,we,Ae,Se,me,Ee,De,Te,Ne,Ue,Ge,Be,st,Ze,ot,Ye,ut,xe,K,re,ae,de,pe,ke,Fe,We){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ce=class extends b.Disposable{constructor(he,ye,be,ge,Ie,Me,Pe,Le,Re,$e){super();this.mainProcessNodeIpcServer=he,this.userEnv=ye,this.mainInstantiationService=be,this.logService=ge,this.environmentMainService=Ie,this.lifecycleMainService=Me,this.configurationService=Pe,this.stateMainService=Le,this.fileService=Re,this.productService=$e,this.configureSession(),this.registerListeners()}configureSession(){const he=ge=>ge?.startsWith(`${I.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);w.session.defaultSession.setPermissionRequestHandler((ge,Ie,Me,Pe)=>he(Pe.requestingUrl)?Me(ye.has(Ie)):Me(!1)),w.session.defaultSession.setPermissionCheckHandler((ge,Ie,Me,Pe)=>he(Pe.requestingUrl)?ye.has(Ie):!1);const be=w.session.defaultSession;typeof be.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&be.setCodeCachePath((0,y.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,S.setUnexpectedErrorHandler)(be=>this.onUnexpectedError(be)),process.on("uncaughtException",be=>(0,S.onUnexpectedError)(be)),process.on("unhandledRejection",be=>(0,S.onUnexpectedError)(be)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,a.registerContextMenuListener)(),w.app.on("accessibility-support-changed",(be,ge)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ge)}),w.app.on("activate",(be,ge)=>{this.logService.trace("app#activate"),ge||this.windowsMainService?.openEmptyWindow({context:1})}),w.app.on("web-contents-created",(be,ge)=>{ge.on("will-navigate",Ie=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),ge.setWindowOpenHandler(({url:Ie})=>(this.nativeHostMainService?.openExternal(void 0,Ie),{action:"deny"}))});let he=[],ye;w.app.on("open-file",(be,ge)=>{this.logService.trace("app#open-file: ",ge),be.preventDefault(),he.push(this.getWindowOpenableFromPathSync(ge)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:he,gotoLineMode:!1,preferNewWindow:!0}),he=[],ye=void 0},100)}),w.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),w.ipcMain.handle("vscode:fetchShellEnv",be=>{const ge=this.windowsMainService?.getWindowByWebContents(be.sender);let Ie,Me;return ge?.config?(Ie=ge.config,Me={...process.env,...ge.config.userEnv}):(Ie=this.environmentMainService.args,Me=process.env),(0,Q.resolveShellEnv)(this.logService,Ie,Me)}),w.ipcMain.handle("vscode:writeNlsFile",(be,ge,Ie)=>{const Me=this.validateNlsPath([ge]);if(!Me||typeof Ie!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Me,M.VSBuffer.fromString(Ie))}),w.ipcMain.handle("vscode:readNlsFile",async(be,...ge)=>{const Ie=this.validateNlsPath(ge);if(!Ie)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ie)).value.toString()}),w.ipcMain.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),w.ipcMain.on("vscode:openDevTools",be=>be.sender.openDevTools()),w.ipcMain.on("vscode:reloadWindow",be=>be.sender.reload())}validateNlsPath(he){let ye;for(const be of he)typeof be=="string"&&(typeof ye!="string"?ye=be:ye=(0,y.join)(ye,be));if(!(typeof ye!="string"||!(0,y.isAbsolute)(ye)||!(0,n.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!h.isLinux)))return v.URI.file(ye)}onUnexpectedError(he){if(he){const ye={message:`[uncaught exception in main]: ${he.message}`,stack:he.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${he}`),he.stack&&this.logService.error(he.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const he=this.productService.win32AppUserModelId;h.isWindows&&he&&w.app.setAppUserModelId(he);try{h.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!w.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&w.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Re){this.logService.error(Re)}const ye=new i.Server;this.logService.trace("Resolving machine identifier...");const be=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${be}`);const{sharedProcess:ge,sharedProcessReady:Ie,sharedProcessClient:Me}=this.setupSharedProcess(be),Pe=await this.initServices(be,ge,Ie);if(this.environmentMainService.driverHandle){const Re=await(0,V.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,Pe);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Re)}this._register(Pe.createInstance(r.ProxyAuthHandler)),Pe.invokeFunction(Re=>this.initChannels(Re,ye,Me));const Le=Pe.invokeFunction(Re=>this.openFirstWindow(Re,ye));Pe.invokeFunction(Re=>this.afterWindowOpen(Re,ge)),this.environmentMainService.args.trace&&Pe.invokeFunction(Re=>this.stopTracingEventually(Re,Le))}async resolveMachineId(){let he=this.stateMainService.getItem(Se.machineIdKey);return(!he||h.isMacintosh&&he==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(he=await(0,d.getMachineId)(),this.stateMainService.setItem(Se.machineIdKey,he)),he}setupSharedProcess(he){const ye=this._register(this.mainInstantiationService.createInstance(ne.SharedProcess,he,this.userEnv)),be=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ie=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new s.Client(Ie,"main")})(),ge=(async()=>(await ye.whenReady(),be))();return{sharedProcess:ye,sharedProcessReady:ge,sharedProcessClient:be}}async initServices(he,ye,be){const ge=new F.ServiceCollection;switch(process.platform){case"win32":ge.set(Te.IUpdateService,new _.SyncDescriptor(st.Win32UpdateService));break;case"linux":h.isLinuxSnap?ge.set(Te.IUpdateService,new _.SyncDescriptor(Be.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(Te.IUpdateService,new _.SyncDescriptor(Ge.LinuxUpdateService));break;case"darwin":ge.set(Te.IUpdateService,new _.SyncDescriptor(Ue.DarwinUpdateService));break}ge.set(re.IWindowsMainService,new _.SyncDescriptor(ae.WindowsMainService,[he,this.userEnv])),ge.set(C.IDialogMainService,new _.SyncDescriptor(C.DialogMainService)),ge.set(N.ILaunchMainService,new _.SyncDescriptor(N.LaunchMainService)),ge.set(W.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(be.then(Me=>Me.getChannel("diagnostics"))))),ge.set(D.IIssueMainService,new _.SyncDescriptor(D.IssueMainService,[this.userEnv])),ge.set(x.IEncryptionMainService,new _.SyncDescriptor(x.EncryptionMainService,[he])),ge.set(R.IKeyboardLayoutMainService,new _.SyncDescriptor(R.KeyboardLayoutMainService)),ge.set(ie.INativeHostMainService,new _.SyncDescriptor(ie.NativeHostMainService,[ye])),ge.set(xe.IWebviewManagerService,new _.SyncDescriptor(K.WebviewMainService)),ge.set(pe.IWorkspacesService,new _.SyncDescriptor(Fe.WorkspacesMainService)),ge.set(We.IWorkspacesManagementMainService,new _.SyncDescriptor(We.WorkspacesManagementMainService)),ge.set(ke.IWorkspacesHistoryMainService,new _.SyncDescriptor(ke.WorkspacesHistoryMainService)),ge.set(ee.IMenubarMainService,new _.SyncDescriptor(ee.MenubarMainService)),ge.set(O.IExtensionUrlTrustService,new _.SyncDescriptor(z.ExtensionUrlTrustService)),ge.set(we.IStorageMainService,new _.SyncDescriptor(we.StorageMainService)),h.isWindows?ge.set(U.IExternalTerminalMainService,new _.SyncDescriptor(X.WindowsExternalTerminalService)):h.isMacintosh?ge.set(U.IExternalTerminalMainService,new _.SyncDescriptor(X.MacExternalTerminalService)):h.isLinux&&ge.set(U.IExternalTerminalMainService,new _.SyncDescriptor(X.LinuxExternalTerminalService));const Ie=new p.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(l.IBackupMainService,Ie),ge.set(Ze.IURLService,new _.SyncDescriptor(Ye.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const Me=(0,c.getDelayedChannel)(be.then(Ke=>Ke.getChannel("telemetryAppender"))),Pe=new me.TelemetryAppenderClient(Me),Le=(0,Ae.resolveCommonProperties)(this.fileService,(0,k.release)(),(0,k.hostname)(),process.arch,this.productService.commit,this.productService.version,he,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Re=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],$e={appender:Pe,commonProperties:Le,piiPaths:Re,sendErrorTelemetry:!0};ge.set(Se.ITelemetryService,new _.SyncDescriptor(Ee.TelemetryService,[$e]))}else ge.set(Se.ITelemetryService,De.NullTelemetryService);return await Ie.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(he,ye,be){const ge=c.ProxyChannel.fromService(he.get(N.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge),ye.registerChannel(L.UserConfigurationFileServiceId,c.ProxyChannel.fromService(new L.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const Ie=new Ne.UpdateChannel(he.get(Te.IUpdateService));ye.registerChannel("update",Ie);const Me=c.ProxyChannel.fromService(he.get(D.IIssueMainService));ye.registerChannel("issue",Me);const Pe=c.ProxyChannel.fromService(he.get(x.IEncryptionMainService));ye.registerChannel("encryption",Pe);const Le=c.ProxyChannel.fromService(he.get(le.ISignService));ye.registerChannel("sign",Le);const Re=c.ProxyChannel.fromService(he.get(R.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",Re),this.nativeHostMainService=he.get(ie.INativeHostMainService);const $e=c.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",$e),be.then(He=>He.registerChannel("nativeHost",$e));const Ke=c.ProxyChannel.fromService(he.get(pe.IWorkspacesService));ye.registerChannel("workspaces",Ke);const et=c.ProxyChannel.fromService(he.get(ee.IMenubarMainService));ye.registerChannel("menubar",et);const tt=c.ProxyChannel.fromService(he.get(Ze.IURLService));ye.registerChannel("url",tt);const ht=c.ProxyChannel.fromService(he.get(O.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",ht);const _e=c.ProxyChannel.fromService(he.get(xe.IWebviewManagerService));ye.registerChannel("webview",_e);const it=this._register(new fe.StorageDatabaseChannel(this.logService,he.get(we.IStorageMainService)));ye.registerChannel("storage",it),be.then(He=>He.registerChannel("storage",it));const nt=c.ProxyChannel.fromService(he.get(U.IExternalTerminalMainService));ye.registerChannel("externalTerminal",nt);const Xe=new Y.LogLevelChannel(he.get($.ILogService));ye.registerChannel("logLevel",Xe),be.then(He=>He.registerChannel("logLevel",Xe));const rt=new Y.LoggerChannel(he.get($.ILoggerService));ye.registerChannel("logger",rt),be.then(He=>He.registerChannel("logger",rt));const at=new T.ElectronExtensionHostDebugBroadcastChannel(he.get(re.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",at)}openFirstWindow(he,ye){const be=this.windowsMainService=he.get(re.IWindowsMainService),ge=he.get(Ze.IURLService),Ie=he.get(ie.INativeHostMainService);this.lifecycleMainService.phase=2;const Me=[],Pe=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Oe=>{try{return{uri:v.URI.parse(Oe),url:Oe}}catch{return}}).filter(Oe=>{if(!Oe||this.shouldBlockURI(Oe.uri))return!1;const Qe=this.getWindowOpenableFromProtocolLink(Oe.uri);return Qe?(Me.push(Qe),!1):!0}),Le=this,Re=this.environmentMainService,$e=this.productService;ge.registerHandler({async handleURL(Oe,Qe){if(Oe.scheme===$e.urlProtocol&&Oe.path==="workspace"&&(Oe=Oe.with({authority:"file",path:v.URI.parse(Oe.query).path,query:""})),Le.shouldBlockURI(Oe))return!0;const vt=Le.getWindowOpenableFromProtocolLink(Oe);if(vt){const[ft]=be.open({context:5,cli:{...Re.args},urisToOpen:[vt],gotoLineMode:!0});return ft.focus(),!0}if(h.isMacintosh&&be.getWindowCount()===0){const[ft]=be.open({context:5,cli:{...Re.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ce.getRemoteAuthority)(Oe)});return await ft.ready(),ge.open(Oe,Qe)}return!1}});const Ke=this._register(new de.ActiveWindowManager({onDidOpenWindow:Ie.onDidOpenWindow,onDidFocusWindow:Ie.onDidFocusWindow,getActiveWindowId:()=>Ie.getActiveWindowId(-1)})),et=new c.StaticRouter(Oe=>Ke.getActiveClientId().then(Qe=>Oe===Qe)),tt=new ot.URLHandlerRouter(et),ht=ye.getChannel("urlHandler",tt);ge.registerHandler(new ot.URLHandlerChannelClient(ht)),this._register(new ut.ElectronURLListener(Pe,ge,be,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,it=global.macOpenFiles,nt=(0,G.isLaunchedFromCli)(process.env)?0:4,Xe=_e._.length,rt=!!_e["folder-uri"],at=!!_e["file-uri"],He=_e["skip-add-to-recently-opened"]===!0,dt=_e.wait&&_e.waitMarkerFilePath?v.URI.file(_e.waitMarkerFilePath):void 0,pt=_e.remote||void 0;return Me.length>0?be.open({context:nt,cli:_e,urisToOpen:Me,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!Xe&&!rt&&!at?be.open({context:nt,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:He,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:pt}):it.length&&!Xe&&!rt&&!at?be.open({context:1,cli:_e,urisToOpen:it.map(Oe=>this.getWindowOpenableFromPathSync(Oe)),noRecentEntry:He,waitMarkerFileURI:dt,initialStartup:!0}):be.open({context:nt,cli:_e,forceNewWindow:_e["new-window"]||!Xe&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:He,waitMarkerFileURI:dt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:pt})}shouldBlockURI(he){return!!(he.authority===I.Schemas.file&&h.isWindows&&w.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,t.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,t.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,t.getPathLabel)(he.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(he){if(!!he.path){if(he.authority===I.Schemas.file)return{fileUri:v.URI.file(he.fsPath)};if(he.authority===I.Schemas.vscodeRemote){const ye=he.path.indexOf(y.posix.sep,1);if(ye!==-1){const be=he.path.substring(1,ye),ge=he.path.substring(ye),Ie=v.URI.from({scheme:I.Schemas.vscodeRemote,authority:be,path:ge,query:he.query,fragment:he.fragment});return(0,pe.hasWorkspaceFileExtension)(ge)?{workspaceUri:Ie}:/:[\d]+$/.test(ge)?{fileUri:Ie}:{folderUri:Ie}}}}}getWindowOpenableFromPathSync(he){try{if((0,A.statSync)(he).isDirectory())return{folderUri:v.URI.file(he)};if((0,pe.hasWorkspaceFileExtension)(he))return{workspaceUri:v.URI.file(he)}}catch(ye){}return{fileUri:v.URI.file(he)}}async afterWindowOpen(he,ye){this.lifecycleMainService.phase=3;let be=!1;(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>be=!0);const ge=he.get(Se.ITelemetryService);this._register(ye.onDidError(({type:Pe,details:Le})=>{let Re;switch(Pe){case 1:Re="SharedProcess: detected unresponsive window";break;case 2:Re=`SharedProcess: crashed (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break;case 3:Re=`SharedProcess: failed to load (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break}(0,S.onUnexpectedError)(new Error(Re)),ge.publicLog2("sharedprocesserror",{type:Pe,reason:Le?.reason,code:Le?.exitCode,visible:ye.isVisible(),shuttingdown:be})}));const Ie=this.productService.win32MutexName;if(h.isWindows&&Ie)try{const Pe=q.__$__nodeRequire("windows-mutex").Mutex,Le=new Pe(Ie);(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Le.release())}catch(Pe){this.logService.error(Pe)}w.protocol.registerHttpProtocol(I.Schemas.vscodeRemoteResource,(Pe,Le)=>{Le({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})});const Me=he.get(Te.IUpdateService);(Me instanceof st.Win32UpdateService||Me instanceof Ge.LinuxUpdateService||Me instanceof Ue.DarwinUpdateService)&&Me.initialize(),(0,Q.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const Le=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,m.stripComments)(Le))["enable-crash-reporter"]===void 0){const $e=this.configurationService.getValue("telemetry.enableCrashReporter"),Ke=typeof $e=="boolean"?$e:!0,et=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,u.generateUuid)()}"`,"}"],tt=Le.substring(0,Le.length-2).concat(`,
`,et.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(tt))}}catch(Pe){this.logService.error(Pe)}}stopTracingEventually(he,ye){this.logService.info("Tracing: waiting for windows to get ready...");const be=he.get(C.IDialogMainService);let ge=!1;const Ie=async Pe=>{if(ge)return;ge=!0;const Le=await w.contentTracing.stopRecording((0,g.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Pe?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Le}`):be.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,Le),buttons:[(0,t.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,P.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))},Me=setTimeout(()=>Ie(!0),3e4);Promise.all(ye.map(Pe=>Pe.ready())).then(()=>{clearTimeout(Me),Ie(!1)})}};Ce=ue([te(2,j.IInstantiationService),te(3,$.ILogService),te(4,se.IEnvironmentMainService),te(5,B.ILifecycleMainService),te(6,E.IConfigurationService),te(7,ve.IStateMainService),te(8,H.IFileService),te(9,oe.IProductService)],Ce),e.CodeApplication=Ce}),define(J[242],Z([0,1,14,30,34,9,67,16,29,43,32,10,8,72,3,31,25,18,35,56,238,11,21,189,198,23,54,161,19,183,184,69,174,71,22,91,6,181,92,48,20,55,186,94,222,50,224,74,195,39,226,96,60,204]),function(q,e,w,A,k,M,S,n,f,m,t,b,I,y,h,g,P,v,u,d,a,c,i,s,r,o,l,p,E,L,T,W,C,V,x,se,G,Q,O,z,U,X,H,_,j,F,D,R,N,B,$,Y,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ie{main(){try{this.startup()}catch(ne){console.error(ne.message),w.app.exit(1)}}async startup(){(0,n.setUnexpectedErrorHandler)(me=>console.error(me));const[ne,le,ve,fe,we,Ae,Se]=this.createServices();try{try{await this.initServices(ve,fe,we)}catch(me){throw this.handleStartupDataDirError(ve,Se.nameLong,me),me}await ne.invokeFunction(async me=>{const Ee=me.get(G.ILogService),De=me.get(x.ILifecycleMainService),Te=me.get(E.IFileService),Ne=await this.claimInstance(Ee,ve,De,ne,Se,!0);return v.Promises.writeFile(ve.mainLockfile,String(process.pid)).catch(Ue=>{Ee.warn(`Error writing main lockfile: ${Ue.stack}`)}),Ae.logger=new O.SpdLogLogger("main",(0,I.join)(ve.logsPath,"main.log"),!0,Ae.getLevel()),(0,m.once)(De.onWillShutdown)(Ue=>{Te.dispose(),fe.dispose(),Ue.join(v.Promises.unlink(ve.mainLockfile).catch(()=>{}))}),ne.createInstance(a.CodeApplication,Ne,le).startup()})}catch(me){ne.invokeFunction(this.quit,me)}}createServices(){const ne=new V.ServiceCollection,le={_serviceBrand:void 0,...z.default};ne.set(U.IProductService,le);const ve=new o.EnvironmentMainService(this.resolveArgs(),le),fe=this.patchEnvironment(ve);ne.set(o.IEnvironmentMainService,ve);const we=new se.BufferLogService,Ae=new G.MultiplexLogService([new G.ConsoleMainLogger((0,G.getLogLevel)(ve)),we]);process.once("exit",()=>Ae.dispose()),ne.set(G.ILogService,Ae);const Se=new L.FileService(Ae);ne.set(E.IFileService,Se);const me=new T.DiskFileSystemProvider(Ae);Se.registerProvider(b.Schemas.file,me),ne.set(G.ILoggerService,new Q.LoggerService(Ae,Se));const Ee=new s.ConfigurationService(ve.settingsResource,Se);ne.set(i.IConfigurationService,Ee),ne.set(x.ILifecycleMainService,new W.SyncDescriptor(x.LifecycleMainService));const De=new $.StateMainService(ve,Ae,Se);return ne.set(B.IStateMainService,De),ne.set(F.IRequestService,new W.SyncDescriptor(D.RequestMainService)),ne.set(ee.IThemeMainService,new W.SyncDescriptor(ee.ThemeMainService)),ne.set(R.ISignService,new W.SyncDescriptor(N.SignService)),ne.set(_.ITunnelService,new W.SyncDescriptor(j.TunnelService)),ne.set(X.IProtocolMainService,new W.SyncDescriptor(H.ProtocolMainService)),[new C.InstantiationService(ne,!0),fe,ve,Ee,De,we,le]}patchEnvironment(ne){const le={VSCODE_IPC_HOOK:ne.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ve=>{const fe=process.env[ve];typeof fe=="string"&&(le[ve]=fe)}),Object.assign(process.env,le),le}initServices(ne,le,ve){return M.Promises.settled([Promise.all([ne.extensionsPath,ne.codeCachePath,ne.logsPath,ne.globalStorageHome.fsPath,ne.workspaceStorageHome.fsPath,ne.backupHome].map(fe=>fe?v.Promises.mkdir(fe,{recursive:!0}):void 0)),le.initialize(),ve.init()])}async claimInstance(ne,le,ve,fe,we,Ae){let Se;try{(0,y.mark)("code/willStartMainServer"),Se=await(0,d.serve)(le.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,m.once)(ve.onWillShutdown)(()=>Se.dispose())}catch(me){if(me.code!=="EADDRINUSE")throw this.handleStartupDataDirError(le,we.nameLong,me),me;let Ee;try{Ee=await(0,d.connect)(le.mainIPCHandle,"main")}catch(Ne){if(!Ae||h.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,we.nameShort),(0,c.localize)(1,null),we.nameLong),Ne;try{(0,A.unlinkSync)(le.mainIPCHandle)}catch(Ue){throw ne.warn("Could not delete obsolete instance handle",Ue),Ue}return this.claimInstance(ne,le,ve,fe,we,!1)}if(le.extensionTestsLocationURI&&!le.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ne.error(Ne),Ee.dispose(),new Error(Ne)}let De;!le.args.wait&&!le.args.status&&(De=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,we.nameShort),(0,c.localize)(3,null),we.nameLong)},1e4));const Te=u.ProxyChannel.toService(Ee.getChannel("launch"),{disableMarshalling:!0});if(le.args.status)return fe.invokeFunction(async()=>{const Ne=new r.DiagnosticsService(Y.NullTelemetryService,we),Ue=await Te.getMainProcessInfo(),Ge=await Te.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ne.getDiagnostics(Ue,Ge);throw console.log(Be),new n.ExpectedError});throw h.isWindows&&await this.windowsAllowSetForegroundWindow(Te,ne),ne.trace("Sending env to running instance..."),await Te.start(le.args,process.env),Ee.dispose(),De&&clearTimeout(De),new n.ExpectedError("Sent env to running instance. Terminating...")}if(le.args.status)throw ne.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new n.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Se}handleStartupDataDirError(ne,le,ve){if(ve.code==="EACCES"||ve.code==="EPERM"){const fe=(0,k.coalesce)([ne.userDataPath,ne.extensionsPath,d.XDG_RUNTIME_DIR]).map(we=>(0,t.getPathLabel)(we,ne));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,S.toErrorMessage)(ve),fe.join(`
`)),le)}}showStartupWarningDialog(ne,le,ve){w.dialog.showMessageBoxSync({title:ve,type:"warning",buttons:[(0,t.mnemonicButtonLabel)((0,c.localize)(6,null))],message:ne,detail:le,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ne,le){if(h.isWindows){const ve=await ne.getMainProcessId();le.trace("Sending some foreground love to the running instance:",ve);try{(await new Promise((fe,we)=>{q(["windows-foreground-love"],fe,we)})).allowSetForegroundWindow(ve)}catch(fe){le.error(fe)}}}quit(ne,le){const ve=ne.get(G.ILogService),fe=ne.get(x.ILifecycleMainService);let we=0;le&&(le.isExpected?le.message&&ve.trace(le.message):(we=1,le.stack?ve.error(le.stack):ve.error(`Startup error: ${le.toString()}`))),fe.kill(we)}resolveArgs(){const ne=this.validatePaths((0,l.parseMainProcessArgv)(process.argv));if(ne.wait&&!ne.waitMarkerFilePath){const le=(0,p.createWaitMarkerFile)(ne.verbose);le&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",le),ne.waitMarkerFilePath=le)}return ne}validatePaths(ne){if(ne["open-url"]&&(ne._urls=ne._,ne._=[]),!ne.remote){const le=this.doValidatePaths(ne._,ne.goto);ne._=le}return ne}doValidatePaths(ne,le){const ve=(0,g.cwd)(),fe=ne.map(Se=>{let me=String(Se),Ee;le&&(Ee=(0,f.parseLineAndColumnAware)(me),me=Ee.path),me&&(me=this.preparePath(ve,me));const De=(0,f.sanitizeFilePath)(me,ve),Te=(0,I.basename)(De);return Te&&!(0,f.isValidBasename)(Te)?null:le&&Ee?(Ee.path=De,this.toPath(Ee)):De}),we=h.isWindows||h.isMacintosh,Ae=(0,k.distinct)(fe,Se=>Se&&we?Se.toLowerCase():Se||"");return(0,k.coalesce)(Ae)}preparePath(ne,le){return h.isWindows&&(le=(0,P.rtrim)(le,'"')),le=(0,P.trim)((0,P.trim)(le," "),"	"),h.isWindows&&(le=(0,I.resolve)(ne,le),le=(0,P.rtrim)(le,".")),le}toPath(ne){const le=[ne.path];return typeof ne.line=="number"&&le.push(String(ne.line)),typeof ne.column=="number"&&le.push(String(ne.column)),le.join(":")}}new ie().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e7d7e9a9348e6a8cc8c03f877d39cb72e5dfb1ff/core/vs/code/electron-main/main.js.map
