/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/iterator","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],be=function(re){for(var e=[],c=0,M=re.length;c<M;c++)e[c]=we[re[c]];return e};define(we[39],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function c(M,E){if(!M)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=c}),define(we[50],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const c=Object.prototype.hasOwnProperty;function M(t){const y=[];for(let n in t)c.call(t,n)&&y.push(t[n]);return y}e.values=M;function E(t,y){for(let n in t)if(c.call(t,n)&&y({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=E;function T(t,y){const n=Object.create(null);for(const d of t){const r=y(d);let u=n[r];u||(u=n[r]=[]),u.push(d)}return n}e.groupBy=T;function A(t){const y=Object.create(null);return t&&t.forEach((n,d)=>{y[d]=n}),y}e.fromMap=A;function P(t,y){const n=[],d=[];for(let r of t)y.has(r)||n.push(r);for(let r of y)t.has(r)||d.push(r);return{removed:n,added:d}}e.diffSets=P;function S(t,y){const n=[],d=[];for(let[r,u]of t)y.has(r)||n.push(u);for(let[r,u]of y)t.has(r)||d.push(u);return{removed:n,added:d}}e.diffMaps=S;class I{constructor(){this.map=new Map}add(y,n){let d=this.map.get(y);d||(d=new Set,this.map.set(y,d)),d.add(n)}delete(y,n){const d=this.map.get(y);!d||(d.delete(n),d.size===0&&this.map.delete(y))}forEach(y,n){const d=this.map.get(y);!d||d.forEach(n)}}e.SetMap=I}),define(we[51],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function c(A){return(P,S,I)=>{let t=null,y=null;if(typeof I.value=="function"?(t="value",y=I.value):typeof I.get=="function"&&(t="get",y=I.get),!y)throw new Error("not supported");I[t]=A(y,S)}}e.createDecorator=c;function M(A,P,S){let I=null,t=null;if(typeof S.value=="function"?(I="value",t=S.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(I="get",t=S.get),!t)throw new Error("not supported");const y=`$memoize$${P}`;S[I]=function(...n){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[y]}}e.memoize=M;function E(A,P,S){return c((I,t)=>{const y=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...d){this[n]||(this[n]=S?S():void 0),clearTimeout(this[y]),P&&(this[n]=P(this[n],...d),d=[this[n]]),this[y]=setTimeout(()=>{I.apply(this,d),this[n]=S?S():void 0},A)}})}e.debounce=E;function T(A,P,S){return c((I,t)=>{const y=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,d=`$throttle$lastRun$${t}`,r=`$throttle$pending$${t}`;return function(...u){if(this[n]||(this[n]=S?S():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),P&&(this[n]=P(this[n],...u)),this[r])return;const p=this[d]+A;p<=Date.now()?(this[d]=Date.now(),I.apply(this,[this[n]]),this[n]=S?S():void 0):(this[r]=!0,this[y]=setTimeout(()=>{this[r]=!1,this[d]=Date.now(),I.apply(this,[this[n]]),this[n]=S?S():void 0},p-Date.now()))}})}e.throttle=T}),define(we[16],be([0,1,15]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function M(G,ue=0){return G[G.length-(1+ue)]}e.tail=M;function E(G){if(G.length===0)throw new Error("Invalid tail call");return[G.slice(0,G.length-1),G[G.length-1]]}e.tail2=E;function T(G,ue,oe=(Ee,Te)=>Ee===Te){if(G===ue)return!0;if(!G||!ue||G.length!==ue.length)return!1;for(let Ee=0,Te=G.length;Ee<Te;Ee++)if(!oe(G[Ee],ue[Ee]))return!1;return!0}e.equals=T;function A(G,ue,oe){let Ee=0,Te=G.length-1;for(;Ee<=Te;){const Re=(Ee+Te)/2|0,Ne=oe(G[Re],ue);if(Ne<0)Ee=Re+1;else if(Ne>0)Te=Re-1;else return Re}return-(Ee+1)}e.binarySearch=A;function P(G,ue){let oe=0,Ee=G.length;if(Ee===0)return 0;for(;oe<Ee;){const Te=Math.floor((oe+Ee)/2);ue(G[Te])?Ee=Te:oe=Te+1}return oe}e.findFirstInSorted=P;function S(G,ue,oe){if(G=G|0,G>=ue.length)throw new TypeError("invalid index");let Ee=ue[Math.floor(ue.length*Math.random())],Te=[],Re=[],Ne=[];for(let Qe of ue){const He=oe(Qe,Ee);He<0?Te.push(Qe):He>0?Re.push(Qe):Ne.push(Qe)}return G<Te.length?S(G,Te,oe):G<Te.length+Ne.length?Ne[0]:S(G-(Te.length+Ne.length),Re,oe)}e.quickSelect=S;function I(G,ue){const oe=[];let Ee;for(const Te of G.slice(0).sort(ue))!Ee||ue(Ee[0],Te)!==0?(Ee=[Te],oe.push(Ee)):Ee.push(Te);return oe}e.groupBy=I;function t(G,ue,oe){const Ee=[];function Te(Qe,He,qe){if(He===0&&qe.length===0)return;const B=Ee[Ee.length-1];B&&B.start+B.deleteCount===Qe?(B.deleteCount+=He,B.toInsert.push(...qe)):Ee.push({start:Qe,deleteCount:He,toInsert:qe})}let Re=0,Ne=0;for(;;){if(Re===G.length){Te(Re,0,ue.slice(Ne));break}if(Ne===ue.length){Te(Re,G.length-Re,[]);break}const Qe=G[Re],He=ue[Ne],qe=oe(Qe,He);qe===0?(Re+=1,Ne+=1):qe<0?(Te(Re,1,[]),Re+=1):qe>0&&(Te(Re,0,[He]),Ne+=1)}return Ee}e.sortedDiff=t;function y(G,ue,oe){const Ee=t(G,ue,oe),Te=[],Re=[];for(const Ne of Ee)Te.push(...G.slice(Ne.start,Ne.start+Ne.deleteCount)),Re.push(...Ne.toInsert);return{removed:Te,added:Re}}e.delta=y;function n(G,ue,oe){if(oe===0)return[];const Ee=G.slice(0,oe).sort(ue);return r(G,ue,Ee,oe,G.length),Ee}e.top=n;function d(G,ue,oe,Ee,Te){return oe===0?Promise.resolve([]):new Promise((Re,Ne)=>{(async()=>{const Qe=G.length,He=G.slice(0,oe).sort(ue);for(let qe=oe,B=Math.min(oe+Ee,Qe);qe<Qe;qe=B,B=Math.min(B+Ee,Qe)){if(qe>oe&&await new Promise(K=>setTimeout(K)),Te&&Te.isCancellationRequested)throw(0,c.canceled)();r(G,ue,He,qe,B)}return He})().then(Re,Ne)})}e.topAsync=d;function r(G,ue,oe,Ee,Te){for(const Re=oe.length;Ee<Te;Ee++){const Ne=G[Ee];if(ue(Ne,oe[Re-1])<0){oe.pop();const Qe=P(oe,He=>ue(Ne,He)<0);oe.splice(Qe,0,Ne)}}}function u(G){return G.filter(ue=>!!ue)}e.coalesce=u;function p(G){let ue=0;for(let oe=0;oe<G.length;oe++)G[oe]&&(G[ue]=G[oe],ue+=1);G.length=ue}e.coalesceInPlace=p;function k(G,ue,oe){G.splice(oe,0,G.splice(ue,1)[0])}e.move=k;function w(G){return!Array.isArray(G)||G.length===0}e.isFalsyOrEmpty=w;function l(G){return Array.isArray(G)&&G.length>0}e.isNonEmptyArray=l;function v(G,ue){if(!ue)return G.filter((Ee,Te)=>G.indexOf(Ee)===Te);const oe=Object.create(null);return G.filter(Ee=>{const Te=ue(Ee);return oe[Te]?!1:(oe[Te]=!0,!0)})}e.distinct=v;function D(G){const ue=new Set;return G.filter(oe=>ue.has(oe)?!1:(ue.add(oe),!0))}e.distinctES6=D;function i(G){const ue=Object.create(null);return oe=>{const Ee=G(oe);return ue[Ee]?!1:(ue[Ee]=!0,!0)}}e.uniqueFilter=i;function s(G,ue){for(let oe=G.length-1;oe>=0;oe--){const Ee=G[oe];if(ue(Ee))return oe}return-1}e.lastIndex=s;function a(G,ue){return G.length>0?G[0]:ue}e.firstOrDefault=a;function o(G,ue,oe=(Ee,Te)=>Ee===Te){let Ee=0;for(let Te=0,Re=Math.min(G.length,ue.length);Te<Re&&oe(G[Te],ue[Te]);Te++)Ee++;return Ee}e.commonPrefixLength=o;function _(G){return[].concat(...G)}e.flatten=_;function m(G,ue){let oe=typeof ue=="number"?G:0;typeof ue=="number"?oe=G:(oe=0,ue=G);const Ee=[];if(oe<=ue)for(let Te=oe;Te<ue;Te++)Ee.push(Te);else for(let Te=oe;Te>ue;Te--)Ee.push(Te);return Ee}e.range=m;function g(G,ue,oe){return G.reduce((Ee,Te)=>(Ee[ue(Te)]=oe?oe(Te):Te,Ee),Object.create(null))}e.index=g;function C(G,ue){return G.push(ue),()=>R(G,ue)}e.insert=C;function R(G,ue){const oe=G.indexOf(ue);if(oe>-1)return G.splice(oe,1),ue}e.remove=R;function h(G,ue,oe){const Ee=G.slice(0,ue),Te=G.slice(ue);return Ee.concat(oe,Te)}e.arrayInsert=h;function b(G,ue){let oe;if(typeof ue=="number"){let Ee=ue;oe=()=>{const Te=Math.sin(Ee++)*179426549;return Te-Math.floor(Te)}}else oe=Math.random;for(let Ee=G.length-1;Ee>0;Ee-=1){const Te=Math.floor(oe()*(Ee+1)),Re=G[Ee];G[Ee]=G[Te],G[Te]=Re}}e.shuffle=b;function f(G,ue){const oe=G.indexOf(ue);oe>-1&&(G.splice(oe,1),G.unshift(ue))}e.pushToStart=f;function F(G,ue){const oe=G.indexOf(ue);oe>-1&&(G.splice(oe,1),G.push(ue))}e.pushToEnd=F;function O(G,ue){return Array.isArray(G)?G.map(ue):ue(G)}e.mapArrayOrNot=O;function q(G){return Array.isArray(G)?G:[G]}e.asArray=q;function Q(G){return G[Math.floor(Math.random()*G.length)]}e.getRandomElement=Q;function $(G,ue){for(const oe of G){const Ee=ue(oe);if(Ee!==void 0)return Ee}}e.mapFind=$;function z(G,ue,oe){const Ee=W(G,ue),Te=G.length,Re=oe.length;G.length=Te+Re;for(let Ne=Te-1;Ne>=Ee;Ne--)G[Ne+Re]=G[Ne];for(let Ne=0;Ne<Re;Ne++)G[Ne+Ee]=oe[Ne]}e.insertInto=z;function N(G,ue,oe,Ee){const Te=W(G,ue),Re=G.splice(Te,oe);return z(G,Te,Ee),Re}e.splice=N;function W(G,ue){return ue<0?Math.max(ue+G.length,0):Math.min(ue,G.length)}function j(G,ue){let oe=Number.MAX_SAFE_INTEGER,Ee=0;return G.forEach((Te,Re)=>{const Ne=ue(Te);Ne<oe&&(oe=Ne,Ee=Re)}),Ee}e.minIndex=j;function Y(G,ue){let oe=Number.MIN_SAFE_INTEGER,Ee=0;return G.forEach((Te,Re)=>{const Ne=ue(Te);Ne>oe&&(oe=Ne,Ee=Re)}),Ee}e.maxIndex=Y;class de{constructor(ue){this.items=ue,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ue){let oe=this.firstIdx;for(;oe<this.items.length&&ue(this.items[oe]);)oe++;const Ee=oe===this.firstIdx?null:this.items.slice(this.firstIdx,oe);return this.firstIdx=oe,Ee}takeFromEndWhile(ue){let oe=this.lastIdx;for(;oe>=0&&ue(this.items[oe]);)oe--;const Ee=oe===this.lastIdx?null:this.items.slice(oe+1,this.lastIdx+1);return this.lastIdx=oe,Ee}}e.ArrayQueue=de}),define(we[52],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(we[102],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var M;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(i){i.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(i,s=!1){let a=0,o=i.length,_="",m=0,g=16,C=0;function R(Q){let $=0,z=0;for(;$<Q;){const N=i.charCodeAt(a);if(N>=48&&N<=57)z=z*16+N-48;else if(N>=65&&N<=70)z=z*16+N-65+10;else if(N>=97&&N<=102)z=z*16+N-97+10;else break;a++,$++}return $<Q&&(z=-1),z}function h(Q){a=Q,_="",m=0,g=16,C=0}function b(){const Q=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&I(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&I(i.charCodeAt(a)))for(a++;a<i.length&&I(i.charCodeAt(a));)a++;else return C=3,i.substring(Q,a);let $=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&I(i.charCodeAt(a))){for(a++;a<i.length&&I(i.charCodeAt(a));)a++;$=a}else C=3;return i.substring(Q,$)}function f(){let Q="",$=a;for(;;){if(a>=o){Q+=i.substring($,a),C=2;break}const z=i.charCodeAt(a);if(z===34){Q+=i.substring($,a),a++;break}if(z===92){if(Q+=i.substring($,a),a++,a>=o){C=2;break}switch(i.charCodeAt(a++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const W=R(4);W>=0?Q+=String.fromCharCode(W):C=4;break;default:C=5}$=a;continue}if(z>=0&&z<=31)if(S(z)){Q+=i.substring($,a),C=2;break}else C=6;a++}return Q}function F(){if(_="",C=0,m=a,a>=o)return m=o,g=17;let Q=i.charCodeAt(a);if(P(Q)){do a++,_+=String.fromCharCode(Q),Q=i.charCodeAt(a);while(P(Q));return g=15}if(S(Q))return a++,_+=String.fromCharCode(Q),Q===13&&i.charCodeAt(a)===10&&(a++,_+=`
`),g=14;switch(Q){case 123:return a++,g=1;case 125:return a++,g=2;case 91:return a++,g=3;case 93:return a++,g=4;case 58:return a++,g=6;case 44:return a++,g=5;case 34:return a++,_=f(),g=10;case 47:const $=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<o&&!S(i.charCodeAt(a));)a++;return _=i.substring($,a),g=12}if(i.charCodeAt(a+1)===42){a+=2;const z=o-1;let N=!1;for(;a<z;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,N=!0;break}a++}return N||(a++,C=1),_=i.substring($,a),g=13}return _+=String.fromCharCode(Q),a++,g=16;case 45:if(_+=String.fromCharCode(Q),a++,a===o||!I(i.charCodeAt(a)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return _+=b(),g=11;default:for(;a<o&&O(Q);)a++,Q=i.charCodeAt(a);if(m!==a){switch(_=i.substring(m,a),_){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return _+=String.fromCharCode(Q),a++,g=16}}function O(Q){if(P(Q)||S(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let Q;do Q=F();while(Q>=12&&Q<=15);return Q}return{setPosition:h,getPosition:()=>a,scan:s?q:F,getToken:()=>g,getTokenValue:()=>_,getTokenOffset:()=>m,getTokenLength:()=>a-m,getTokenError:()=>C}}e.createScanner=A;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function S(i){return i===10||i===13||i===8232||i===8233}function I(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function y(i,s){const a=[],o=new Object;let _;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function C(R,h,b,f){m.value=R,m.offset=h,m.length=b,m.type=f,m.colonOffset=void 0,_=m}try{l(i,{onObjectBegin:(R,h)=>{if(s<=R)throw o;_=void 0,g=s>R,a.push("")},onObjectProperty:(R,h,b)=>{if(s<h||(C(R,h,b,"property"),a[a.length-1]=R,s<=h+b))throw o},onObjectEnd:(R,h)=>{if(s<=R)throw o;_=void 0,a.pop()},onArrayBegin:(R,h)=>{if(s<=R)throw o;_=void 0,a.push(0)},onArrayEnd:(R,h)=>{if(s<=R)throw o;_=void 0,a.pop()},onLiteralValue:(R,h,b)=>{if(s<h||(C(R,h,b,D(R)),s<=h+b))throw o},onSeparator:(R,h,b)=>{if(s<=h)throw o;if(R===":"&&_&&_.type==="property")_.colonOffset=h,g=!1,_=void 0;else if(R===","){const f=a[a.length-1];typeof f=="number"?a[a.length-1]=f+1:(g=!0,a[a.length-1]=""),_=void 0}}})}catch(R){if(R!==o)throw R}return{path:a,previousNode:_,isAtPropertyKey:g,matches:R=>{let h=0;for(let b=0;h<R.length&&b<a.length;b++)if(R[h]===a[b]||R[h]==="*")h++;else if(R[h]!=="**")return!1;return h===R.length}}}e.getLocation=y;function n(i,s=[],a=T.DEFAULT){let o=null,_=[];const m=[];function g(R){Array.isArray(_)?_.push(R):o!==null&&(_[o]=R)}return l(i,{onObjectBegin:()=>{const R={};g(R),m.push(_),_=R,o=null},onObjectProperty:R=>{o=R},onObjectEnd:()=>{_=m.pop()},onArrayBegin:()=>{const R=[];g(R),m.push(_),_=R,o=null},onArrayEnd:()=>{_=m.pop()},onLiteralValue:g,onError:(R,h,b)=>{s.push({error:R,offset:h,length:b})}},a),_[0]}e.parse=n;function d(i,s=[],a=T.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function _(R){o.type==="property"&&(o.length=R-o.offset,o=o.parent)}function m(R){return o.children.push(R),R}l(i,{onObjectBegin:R=>{o=m({type:"object",offset:R,length:-1,parent:o,children:[]})},onObjectProperty:(R,h,b)=>{o=m({type:"property",offset:h,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:R,offset:h,length:b,parent:o})},onObjectEnd:(R,h)=>{o.length=R+h-o.offset,o=o.parent,_(R+h)},onArrayBegin:(R,h)=>{o=m({type:"array",offset:R,length:-1,parent:o,children:[]})},onArrayEnd:(R,h)=>{o.length=R+h-o.offset,o=o.parent,_(R+h)},onLiteralValue:(R,h,b)=>{m({type:D(R),offset:h,length:b,parent:o,value:R}),_(h+b)},onSeparator:(R,h,b)=>{o.type==="property"&&(R===":"?o.colonOffset=h:R===","&&_(h))},onError:(R,h,b)=>{s.push({error:R,offset:h,length:b})}},a);const C=o.children[0];return C&&delete C.parent,C}e.parseTree=d;function r(i,s){if(!i)return;let a=i;for(let o of s)if(typeof o=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let _=!1;for(const m of a.children)if(Array.isArray(m.children)&&m.children[0].value===o){a=m.children[1],_=!0;break}if(!_)return}else{const _=o;if(a.type!=="array"||_<0||!Array.isArray(a.children)||_>=a.children.length)return;a=a.children[_]}return a}e.findNodeAtLocation=r;function u(i){if(!i.parent||!i.parent.children)return[];const s=u(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;s.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&s.push(a)}return s}e.getNodePath=u;function p(i){switch(i.type){case"array":return i.children.map(p);case"object":const s=Object.create(null);for(let a of i.children){const o=a.children[1];o&&(s[a.children[0].value]=p(o))}return s;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=p;function k(i,s,a=!1){return s>=i.offset&&s<i.offset+i.length||a&&s===i.offset+i.length}e.contains=k;function w(i,s,a=!1){if(k(i,s,a)){const o=i.children;if(Array.isArray(o))for(let _=0;_<o.length&&o[_].offset<=s;_++){const m=w(o[_],s,a);if(m)return m}return i}}e.findNodeAtOffset=w;function l(i,s,a=T.DEFAULT){const o=A(i,!1);function _(oe){return oe?()=>oe(o.getTokenOffset(),o.getTokenLength()):()=>!0}function m(oe){return oe?Ee=>oe(Ee,o.getTokenOffset(),o.getTokenLength()):()=>!0}const g=_(s.onObjectBegin),C=m(s.onObjectProperty),R=_(s.onObjectEnd),h=_(s.onArrayBegin),b=_(s.onArrayEnd),f=m(s.onLiteralValue),F=m(s.onSeparator),O=_(s.onComment),q=m(s.onError),Q=a&&a.disallowComments,$=a&&a.allowTrailingComma;function z(){for(;;){const oe=o.scan();switch(o.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:Q||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(oe){case 12:case 13:Q?N(10):O();break;case 16:N(1);break;case 15:case 14:break;default:return oe}}}function N(oe,Ee=[],Te=[]){if(q(oe),Ee.length+Te.length>0){let Re=o.getToken();for(;Re!==17;){if(Ee.indexOf(Re)!==-1){z();break}else if(Te.indexOf(Re)!==-1)break;Re=z()}}}function W(oe){const Ee=o.getTokenValue();return oe?f(Ee):C(Ee),z(),!0}function j(){switch(o.getToken()){case 11:let oe=0;try{oe=JSON.parse(o.getTokenValue()),typeof oe!="number"&&(N(2),oe=0)}catch(Ee){N(2)}f(oe);break;case 7:f(null);break;case 8:f(!0);break;case 9:f(!1);break;default:return!1}return z(),!0}function Y(){return o.getToken()!==10?(N(3,[],[2,5]),!1):(W(!1),o.getToken()===6?(F(":"),z(),ue()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function de(){g(),z();let oe=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(oe||N(4,[],[]),F(","),z(),o.getToken()===2&&$)break}else oe&&N(6,[],[]);Y()||N(4,[],[2,5]),oe=!0}return R(),o.getToken()!==2?N(7,[2],[]):z(),!0}function G(){h(),z();let oe=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(oe||N(4,[],[]),F(","),z(),o.getToken()===4&&$)break}else oe&&N(6,[],[]);ue()||N(4,[],[4,5]),oe=!0}return b(),o.getToken()!==4?N(8,[4],[]):z(),!0}function ue(){switch(o.getToken()){case 3:return G();case 1:return de();case 10:return W(!0);default:return j()}}return z(),o.getToken()===17?a.allowEmptyContent?!0:(N(4,[],[]),!1):ue()?(o.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=l;function v(i,s){let a=A(i),o=[],_,m=0,g;do switch(g=a.getPosition(),_=a.scan(),_){case 12:case 13:case 17:m!==g&&o.push(i.substring(m,g)),s!==void 0&&o.push(a.getTokenValue().replace(/[^\r\n]/g,s)),m=a.getPosition();break}while(_!==17);return o.join("")}e.stripComments=v;function D(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),define(we[103],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(E){this.executor=E,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(E){this._error=E}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(E){return new c(()=>E(this.getValue()))}}e.Lazy=c}),function(re,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(re=typeof globalThis!="undefined"?globalThis:re||self,re.marked=e())}(this,function(){"use strict";function re(Pe,ye){for(var De=0;De<ye.length;De++){var Z=ye[De];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(Pe,Z.key,Z)}}function e(Pe,ye,De){return ye&&re(Pe.prototype,ye),De&&re(Pe,De),Pe}function c(Pe,ye){if(!!Pe){if(typeof Pe=="string")return M(Pe,ye);var De=Object.prototype.toString.call(Pe).slice(8,-1);if(De==="Object"&&Pe.constructor&&(De=Pe.constructor.name),De==="Map"||De==="Set")return Array.from(Pe);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return M(Pe,ye)}}function M(Pe,ye){(ye==null||ye>Pe.length)&&(ye=Pe.length);for(var De=0,Z=new Array(ye);De<ye;De++)Z[De]=Pe[De];return Z}function E(Pe,ye){var De=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(De)return(De=De.call(Pe)).next.bind(De);if(Array.isArray(Pe)||(De=c(Pe))||ye&&Pe&&typeof Pe.length=="number"){De&&(Pe=De);var Z=0;return function(){return Z>=Pe.length?{done:!0}:{done:!1,value:Pe[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var T={exports:{}};function A(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function P(Pe){T.exports.defaults=Pe}T.exports={defaults:A(),getDefaults:A,changeDefaults:P};var S=/[&<>"']/,I=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(ye){return n[ye]};function r(Pe,ye){if(ye){if(S.test(Pe))return Pe.replace(I,d)}else if(t.test(Pe))return Pe.replace(y,d);return Pe}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(Pe){return Pe.replace(u,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var k=/(^|[^\[])\^/g;function w(Pe,ye){Pe=Pe.source||Pe,ye=ye||"";var De={replace:function(le,ge){return ge=ge.source||ge,ge=ge.replace(k,"$1"),Pe=Pe.replace(le,ge),De},getRegex:function(){return new RegExp(Pe,ye)}};return De}var l=/[^\w:]/g,v=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function D(Pe,ye,De){if(Pe){var Z;try{Z=decodeURIComponent(p(De)).replace(l,"").toLowerCase()}catch(le){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ye&&!v.test(De)&&(De=_(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch(le){return null}return De}var i={},s=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function _(Pe,ye){i[" "+Pe]||(s.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=R(Pe,"/",!0)),Pe=i[" "+Pe];var De=Pe.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:Pe.replace(a,"$1")+ye:ye.charAt(0)==="/"?De?ye:Pe.replace(o,"$1")+ye:Pe+ye}var m={exec:function(){}};function g(Pe){for(var ye=1,De,Z;ye<arguments.length;ye++){De=arguments[ye];for(Z in De)Object.prototype.hasOwnProperty.call(De,Z)&&(Pe[Z]=De[Z])}return Pe}function C(Pe,ye){var De=Pe.replace(/\|/g,function(ge,me,Ie){for(var Be=!1,Me=me;--Me>=0&&Ie[Me]==="\\";)Be=!Be;return Be?"|":" |"}),Z=De.split(/ \|/),le=0;if(Z[0].trim()||Z.shift(),Z[Z.length-1].trim()||Z.pop(),Z.length>ye)Z.splice(ye);else for(;Z.length<ye;)Z.push("");for(;le<Z.length;le++)Z[le]=Z[le].trim().replace(/\\\|/g,"|");return Z}function R(Pe,ye,De){var Z=Pe.length;if(Z===0)return"";for(var le=0;le<Z;){var ge=Pe.charAt(Z-le-1);if(ge===ye&&!De)le++;else if(ge!==ye&&De)le++;else break}return Pe.substr(0,Z-le)}function h(Pe,ye){if(Pe.indexOf(ye[1])===-1)return-1;for(var De=Pe.length,Z=0,le=0;le<De;le++)if(Pe[le]==="\\")le++;else if(Pe[le]===ye[0])Z++;else if(Pe[le]===ye[1]&&(Z--,Z<0))return le;return-1}function b(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function f(Pe,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=Pe),ye>>=1,Pe+=Pe;return De+Pe}var F={escape:r,unescape:p,edit:w,cleanUrl:D,resolveUrl:_,noopTest:m,merge:g,splitCells:C,rtrim:R,findClosingBracket:h,checkSanitizeDeprecation:b,repeatString:f},O=T.exports.defaults,q=F.rtrim,Q=F.splitCells,$=F.escape,z=F.findClosingBracket;function N(Pe,ye,De,Z){var le=ye.href,ge=ye.title?$(ye.title):null,me=Pe[1].replace(/\\([\[\]])/g,"$1");return Pe[0].charAt(0)!=="!"?(Z.state.inLink=!0,{type:"link",raw:De,href:le,title:ge,text:me,tokens:Z.inlineTokens(me,[])}):{type:"image",raw:De,href:le,title:ge,text:$(me)}}function W(Pe,ye){var De=Pe.match(/^(\s+)(?:```)/);if(De===null)return ye;var Z=De[1];return ye.split(`
`).map(function(le){var ge=le.match(/^\s+/);if(ge===null)return le;var me=ge[0];return me.length>=Z.length?le.slice(Z.length):le}).join(`
`)}var j=function(){function Pe(De){this.options=De||O}var ye=Pe.prototype;return ye.space=function(Z){var le=this.rules.block.newline.exec(Z);if(le)return le[0].length>1?{type:"space",raw:le[0]}:{raw:`
`}},ye.code=function(Z){var le=this.rules.block.code.exec(Z);if(le){var ge=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:q(ge,`
`)}}},ye.fences=function(Z){var le=this.rules.block.fences.exec(Z);if(le){var ge=le[0],me=W(ge,le[3]||"");return{type:"code",raw:ge,lang:le[2]?le[2].trim():le[2],text:me}}},ye.heading=function(Z){var le=this.rules.block.heading.exec(Z);if(le){var ge=le[2].trim();if(/#$/.test(ge)){var me=q(ge,"#");(this.options.pedantic||!me||/ $/.test(me))&&(ge=me.trim())}var Ie={type:"heading",raw:le[0],depth:le[1].length,text:ge,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},ye.hr=function(Z){var le=this.rules.block.hr.exec(Z);if(le)return{type:"hr",raw:le[0]}},ye.blockquote=function(Z){var le=this.rules.block.blockquote.exec(Z);if(le){var ge=le[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},ye.list=function(Z){var le=this.rules.block.list.exec(Z);if(le){var ge,me,Ie,Be,Me,je,Je,ie,pe,ne,U=le[1].trim(),Ce=U.length>1,Se={type:"list",raw:"",ordered:Ce,start:Ce?+U.slice(0,-1):"",loose:!1,items:[]};U=Ce?"\\d{1,9}\\"+U.slice(-1):"\\"+U,this.options.pedantic&&(U=Ce?U:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+U+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");Z&&!(this.rules.block.hr.test(Z)||!(le=Ge.exec(Z)));){pe=le[2].split(`
`),this.options.pedantic?(Be=2,ne=pe[0].trimLeft()):(Be=le[2].search(/[^ ]/),Be=le[1].length+(Be>4?1:Be),ne=pe[0].slice(Be-le[1].length)),je=!1,ge=le[0],!pe[0]&&/^ *$/.test(pe[1])&&(ge=le[1]+pe.slice(0,2).join(`
`)+`
`,Se.loose=!0,pe=[]);var We=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Me=1;Me<pe.length;Me++){if(ie=pe[Me],this.options.pedantic&&(ie=ie.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),We.test(ie)){ge=le[1]+pe.slice(0,Me).join(`
`)+`
`;break}if(!je){ie.trim()||(je=!0),ie.search(/[^ ]/)>=Be?ne+=`
`+ie.slice(Be):ne+=`
`+ie;continue}if(ie.search(/[^ ]/)>=Be||!ie.trim()){ne+=`
`+ie.slice(Be);continue}else{ge=le[1]+pe.slice(0,Me).join(`
`)+`
`;break}}Se.loose||(Je?Se.loose=!0:/\n *\n *$/.test(ge)&&(Je=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(ne),me&&(Ie=me[0]!=="[ ] ",ne=ne.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:ge,task:!!me,checked:Ie,loose:!1,text:ne}),Se.raw+=ge,Z=Z.slice(ge.length)}Se.items[Se.items.length-1].raw=ge.trimRight(),Se.items[Se.items.length-1].text=ne.trimRight(),Se.raw=Se.raw.trimRight();var it=Se.items.length;for(Me=0;Me<it;Me++)this.lexer.state.top=!1,Se.items[Me].tokens=this.lexer.blockTokens(Se.items[Me].text,[]),Se.items[Me].tokens.some(function(mt){return mt.type==="space"})&&(Se.loose=!0,Se.items[Me].loose=!0);return Se}},ye.html=function(Z){var le=this.rules.block.html.exec(Z);if(le){var ge={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};return this.options.sanitize&&(ge.type="paragraph",ge.text=this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]),ge.tokens=[],this.lexer.inline(ge.text,ge.tokens)),ge}},ye.def=function(Z){var le=this.rules.block.def.exec(Z);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var ge=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:le[0],href:le[2],title:le[3]}}},ye.table=function(Z){var le=this.rules.block.table.exec(Z);if(le){var ge={type:"table",header:Q(le[1]).map(function(Je){return{text:Je}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]?le[3].replace(/\n$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=le[0];var me=ge.align.length,Ie,Be,Me,je;for(Ie=0;Ie<me;Ie++)/^ *-+: *$/.test(ge.align[Ie])?ge.align[Ie]="right":/^ *:-+: *$/.test(ge.align[Ie])?ge.align[Ie]="center":/^ *:-+ *$/.test(ge.align[Ie])?ge.align[Ie]="left":ge.align[Ie]=null;for(me=ge.rows.length,Ie=0;Ie<me;Ie++)ge.rows[Ie]=Q(ge.rows[Ie],ge.header.length).map(function(Je){return{text:Je}});for(me=ge.header.length,Be=0;Be<me;Be++)ge.header[Be].tokens=[],this.lexer.inlineTokens(ge.header[Be].text,ge.header[Be].tokens);for(me=ge.rows.length,Be=0;Be<me;Be++)for(je=ge.rows[Be],Me=0;Me<je.length;Me++)je[Me].tokens=[],this.lexer.inlineTokens(je[Me].text,je[Me].tokens);return ge}}},ye.lheading=function(Z){var le=this.rules.block.lheading.exec(Z);if(le){var ge={type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.paragraph=function(Z){var le=this.rules.block.paragraph.exec(Z);if(le){var ge={type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.text=function(Z){var le=this.rules.block.text.exec(Z);if(le){var ge={type:"text",raw:le[0],text:le[0],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.escape=function(Z){var le=this.rules.inline.escape.exec(Z);if(le)return{type:"escape",raw:le[0],text:$(le[1])}},ye.tag=function(Z){var le=this.rules.inline.tag.exec(Z);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]):le[0]}},ye.link=function(Z){var le=this.rules.inline.link.exec(Z);if(le){var ge=le[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var me=q(ge.slice(0,-1),"\\");if((ge.length-me.length)%2==0)return}else{var Ie=z(le[2],"()");if(Ie>-1){var Be=le[0].indexOf("!")===0?5:4,Me=Be+le[1].length+Ie;le[2]=le[2].substring(0,Ie),le[0]=le[0].substring(0,Me).trim(),le[3]=""}}var je=le[2],Je="";if(this.options.pedantic){var ie=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(je);ie&&(je=ie[1],Je=ie[3])}else Je=le[3]?le[3].slice(1,-1):"";return je=je.trim(),/^</.test(je)&&(this.options.pedantic&&!/>$/.test(ge)?je=je.slice(1):je=je.slice(1,-1)),N(le,{href:je&&je.replace(this.rules.inline._escapes,"$1"),title:Je&&Je.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},ye.reflink=function(Z,le){var ge;if((ge=this.rules.inline.reflink.exec(Z))||(ge=this.rules.inline.nolink.exec(Z))){var me=(ge[2]||ge[1]).replace(/\s+/g," ");if(me=le[me.toLowerCase()],!me||!me.href){var Ie=ge[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return N(ge,me,ge[0],this.lexer)}},ye.emStrong=function(Z,le,ge){ge===void 0&&(ge="");var me=this.rules.inline.emStrong.lDelim.exec(Z);if(!!me&&!(me[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=me[1]||me[2]||"";if(!Ie||Ie&&(ge===""||this.rules.inline.punctuation.exec(ge))){var Be=me[0].length-1,Me,je,Je=Be,ie=0,pe=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,le=le.slice(-1*Z.length+Be);(me=pe.exec(le))!=null;)if(Me=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Me){if(je=Me.length,me[3]||me[4]){Je+=je;continue}else if((me[5]||me[6])&&Be%3&&!((Be+je)%3)){ie+=je;continue}if(Je-=je,!(Je>0)){if(je=Math.min(je,je+Je+ie),Math.min(Be,je)%2){var ne=Z.slice(1,Be+me.index+je);return{type:"em",raw:Z.slice(0,Be+me.index+je+1),text:ne,tokens:this.lexer.inlineTokens(ne,[])}}var U=Z.slice(2,Be+me.index+je-1);return{type:"strong",raw:Z.slice(0,Be+me.index+je+1),text:U,tokens:this.lexer.inlineTokens(U,[])}}}}}},ye.codespan=function(Z){var le=this.rules.inline.code.exec(Z);if(le){var ge=le[2].replace(/\n/g," "),me=/[^ ]/.test(ge),Ie=/^ /.test(ge)&&/ $/.test(ge);return me&&Ie&&(ge=ge.substring(1,ge.length-1)),ge=$(ge,!0),{type:"codespan",raw:le[0],text:ge}}},ye.br=function(Z){var le=this.rules.inline.br.exec(Z);if(le)return{type:"br",raw:le[0]}},ye.del=function(Z){var le=this.rules.inline.del.exec(Z);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2],[])}},ye.autolink=function(Z,le){var ge=this.rules.inline.autolink.exec(Z);if(ge){var me,Ie;return ge[2]==="@"?(me=$(this.options.mangle?le(ge[1]):ge[1]),Ie="mailto:"+me):(me=$(ge[1]),Ie=me),{type:"link",raw:ge[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},ye.url=function(Z,le){var ge;if(ge=this.rules.inline.url.exec(Z)){var me,Ie;if(ge[2]==="@")me=$(this.options.mangle?le(ge[0]):ge[0]),Ie="mailto:"+me;else{var Be;do Be=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(Be!==ge[0]);me=$(ge[0]),ge[1]==="www."?Ie="http://"+me:Ie=me}return{type:"link",raw:ge[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},ye.inlineText=function(Z,le){var ge=this.rules.inline.text.exec(Z);if(ge){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):$(ge[0]):ge[0]:me=$(this.options.smartypants?le(ge[0]):ge[0]),{type:"text",raw:ge[0],text:me}}},Pe}(),Y=F.noopTest,de=F.edit,G=F.merge,ue={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:Y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ue._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ue._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ue.def=de(ue.def).replace("label",ue._label).replace("title",ue._title).getRegex(),ue.bullet=/(?:[*+-]|\d{1,9}[.)])/,ue.listItemStart=de(/^( *)(bull) */).replace("bull",ue.bullet).getRegex(),ue.list=de(ue.list).replace(/bull/g,ue.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ue.def.source+")").getRegex(),ue._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ue._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ue.html=de(ue.html,"i").replace("comment",ue._comment).replace("tag",ue._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ue.paragraph=de(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.blockquote=de(ue.blockquote).replace("paragraph",ue.paragraph).getRegex(),ue.normal=G({},ue),ue.gfm=G({},ue.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ue.gfm.table=de(ue.gfm.table).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.pedantic=G({},ue.normal,{html:de(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ue._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Y,paragraph:de(ue.normal._paragraph).replace("hr",ue.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ue.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=de(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=de(ue._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=de(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=de(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=de(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=de(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=de(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=de(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=de(oe.reflink).replace("label",oe._label).getRegex(),oe.reflinkSearch=de(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=G({},oe),oe.pedantic=G({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:de(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:de(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=G({},oe.normal,{escape:de(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=de(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=G({},oe.gfm,{br:de(oe.br).replace("{2,}","*").getRegex(),text:de(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Ee={block:ue,inline:oe},Te=j,Re=T.exports.defaults,Ne=Ee.block,Qe=Ee.inline,He=F.repeatString;function qe(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(Pe){var ye="",De,Z,le=Pe.length;for(De=0;De<le;De++)Z=Pe.charCodeAt(De),Math.random()>.5&&(Z="x"+Z.toString(16)),ye+="&#"+Z+";";return ye}var K=function(){function Pe(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||Re,this.options.tokenizer=this.options.tokenizer||new Te,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:Ne.normal,inline:Qe.normal};this.options.pedantic?(Z.block=Ne.pedantic,Z.inline=Qe.pedantic):this.options.gfm&&(Z.block=Ne.gfm,this.options.breaks?Z.inline=Qe.breaks:Z.inline=Qe.gfm),this.tokenizer.rules=Z}Pe.lex=function(Z,le){var ge=new Pe(le);return ge.lex(Z)},Pe.lexInline=function(Z,le){var ge=new Pe(le);return ge.inlineTokens(Z)};var ye=Pe.prototype;return ye.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},ye.blockTokens=function(Z,le){var ge=this;le===void 0&&(le=[]),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var me,Ie,Be,Me;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Je){return(me=Je.call({lexer:ge},Z,le))?(Z=Z.substring(me.raw.length),le.push(me),!0):!1}))){if(me=this.tokenizer.space(Z)){Z=Z.substring(me.raw.length),me.type&&le.push(me);continue}if(me=this.tokenizer.code(Z)){Z=Z.substring(me.raw.length),Ie=le[le.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):le.push(me);continue}if(me=this.tokenizer.fences(Z)){Z=Z.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.heading(Z)){Z=Z.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.hr(Z)){Z=Z.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.blockquote(Z)){Z=Z.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.list(Z)){Z=Z.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.html(Z)){Z=Z.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.def(Z)){Z=Z.substring(me.raw.length),Ie=le[le.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(Z)){Z=Z.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.lheading(Z)){Z=Z.substring(me.raw.length),le.push(me);continue}if(Be=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Je=Infinity,ie=Z.slice(1),pe=void 0;ge.options.extensions.startBlock.forEach(function(ne){pe=ne.call({lexer:this},ie),typeof pe=="number"&&pe>=0&&(Je=Math.min(Je,pe))}),Je<Infinity&&Je>=0&&(Be=Z.substring(0,Je+1))}(),this.state.top&&(me=this.tokenizer.paragraph(Be))){Ie=le[le.length-1],Me&&Ie.type==="paragraph"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):le.push(me),Me=Be.length!==Z.length,Z=Z.substring(me.raw.length);continue}if(me=this.tokenizer.text(Z)){Z=Z.substring(me.raw.length),Ie=le[le.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):le.push(me);continue}if(Z){var je="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return this.state.top=!0,le},ye.inline=function(Z,le){this.inlineQueue.push({src:Z,tokens:le})},ye.inlineTokens=function(Z,le){var ge=this;le===void 0&&(le=[]);var me,Ie,Be,Me=Z,je,Je,ie;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(je=this.tokenizer.rules.inline.reflinkSearch.exec(Me))!=null;)pe.includes(je[0].slice(je[0].lastIndexOf("[")+1,-1))&&(Me=Me.slice(0,je.index)+"["+He("a",je[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(je=this.tokenizer.rules.inline.blockSkip.exec(Me))!=null;)Me=Me.slice(0,je.index)+"["+He("a",je[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(je=this.tokenizer.rules.inline.escapedEmSt.exec(Me))!=null;)Me=Me.slice(0,je.index)+"++"+Me.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(Je||(ie=""),Je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(U){return(me=U.call({lexer:ge},Z,le))?(Z=Z.substring(me.raw.length),le.push(me),!0):!1}))){if(me=this.tokenizer.escape(Z)){Z=Z.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.tag(Z)){Z=Z.substring(me.raw.length),Ie=le[le.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):le.push(me);continue}if(me=this.tokenizer.link(Z)){Z=Z.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(me.raw.length),Ie=le[le.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):le.push(me);continue}if(me=this.tokenizer.emStrong(Z,Me,ie)){Z=Z.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.codespan(Z)){Z=Z.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.br(Z)){Z=Z.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.del(Z)){Z=Z.substring(me.raw.length),le.push(me);continue}if(me=this.tokenizer.autolink(Z,B)){Z=Z.substring(me.raw.length),le.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(Z,B))){Z=Z.substring(me.raw.length),le.push(me);continue}if(Be=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var U=Infinity,Ce=Z.slice(1),Se=void 0;ge.options.extensions.startInline.forEach(function(Ge){Se=Ge.call({lexer:this},Ce),typeof Se=="number"&&Se>=0&&(U=Math.min(U,Se))}),U<Infinity&&U>=0&&(Be=Z.substring(0,U+1))}(),me=this.tokenizer.inlineText(Be,qe)){Z=Z.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(ie=me.raw.slice(-1)),Je=!0,Ie=le[le.length-1],Ie&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):le.push(me);continue}if(Z){var ne="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(ne);break}else throw new Error(ne)}}return le},e(Pe,null,[{key:"rules",get:function(){return{block:Ne,inline:Qe}}}]),Pe}(),ee=T.exports.defaults,ae=F.cleanUrl,V=F.escape,se=function(){function Pe(De){this.options=De||ee}var ye=Pe.prototype;return ye.code=function(Z,le,ge){var me=(le||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(Z,me);Ie!=null&&Ie!==Z&&(ge=!0,Z=Ie)}return Z=Z.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+V(me,!0)+'">'+(ge?Z:V(Z,!0))+`</code></pre>
`:"<pre><code>"+(ge?Z:V(Z,!0))+`</code></pre>
`},ye.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ye.html=function(Z){return Z},ye.heading=function(Z,le,ge,me){return this.options.headerIds?"<h"+le+' id="'+this.options.headerPrefix+me.slug(ge)+'">'+Z+"</h"+le+`>
`:"<h"+le+">"+Z+"</h"+le+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(Z,le,ge){var me=le?"ol":"ul",Ie=le&&ge!==1?' start="'+ge+'"':"";return"<"+me+Ie+`>
`+Z+"</"+me+`>
`},ye.listitem=function(Z){return"<li>"+Z+`</li>
`},ye.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(Z){return"<p>"+Z+`</p>
`},ye.table=function(Z,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+le+`</table>
`},ye.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ye.tablecell=function(Z,le){var ge=le.header?"th":"td",me=le.align?"<"+ge+' align="'+le.align+'">':"<"+ge+">";return me+Z+"</"+ge+`>
`},ye.strong=function(Z){return"<strong>"+Z+"</strong>"},ye.em=function(Z){return"<em>"+Z+"</em>"},ye.codespan=function(Z){return"<code>"+Z+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(Z){return"<del>"+Z+"</del>"},ye.link=function(Z,le,ge){if(Z=ae(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ge;var me='<a href="'+V(Z)+'"';return le&&(me+=' title="'+le+'"'),me+=">"+ge+"</a>",me},ye.image=function(Z,le,ge){if(Z=ae(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ge;var me='<img src="'+Z+'" alt="'+ge+'"';return le&&(me+=' title="'+le+'"'),me+=this.options.xhtml?"/>":">",me},ye.text=function(Z){return Z},Pe}(),fe=function(){function Pe(){}var ye=Pe.prototype;return ye.strong=function(Z){return Z},ye.em=function(Z){return Z},ye.codespan=function(Z){return Z},ye.del=function(Z){return Z},ye.html=function(Z){return Z},ye.text=function(Z){return Z},ye.link=function(Z,le,ge){return""+ge},ye.image=function(Z,le,ge){return""+ge},ye.br=function(){return""},Pe}(),Ae=function(){function Pe(){this.seen={}}var ye=Pe.prototype;return ye.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(Z,le){var ge=Z,me=0;if(this.seen.hasOwnProperty(ge)){me=this.seen[Z];do me++,ge=Z+"-"+me;while(this.seen.hasOwnProperty(ge))}return le||(this.seen[Z]=me,this.seen[ge]=0),ge},ye.slug=function(Z,le){le===void 0&&(le={});var ge=this.serialize(Z);return this.getNextSafeSlug(ge,le.dryrun)},Pe}(),xe=se,$e=fe,ve=Ae,Xe=T.exports.defaults,H=F.unescape,J=function(){function Pe(De){this.options=De||Xe,this.options.renderer=this.options.renderer||new xe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new $e,this.slugger=new ve}Pe.parse=function(Z,le){var ge=new Pe(le);return ge.parse(Z)},Pe.parseInline=function(Z,le){var ge=new Pe(le);return ge.parseInline(Z)};var ye=Pe.prototype;return ye.parse=function(Z,le){le===void 0&&(le=!0);var ge="",me,Ie,Be,Me,je,Je,ie,pe,ne,U,Ce,Se,Ge,We,it,mt,vt,nt,ot,lt=Z.length;for(me=0;me<lt;me++){if(U=Z[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[U.type]&&(ot=this.options.extensions.renderers[U.type].call({parser:this},U),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(U.type))){ge+=ot||"";continue}switch(U.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(U.tokens),U.depth,H(this.parseInline(U.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(U.text,U.lang,U.escaped);continue}case"table":{for(pe="",ie="",Me=U.header.length,Ie=0;Ie<Me;Ie++)ie+=this.renderer.tablecell(this.parseInline(U.header[Ie].tokens),{header:!0,align:U.align[Ie]});for(pe+=this.renderer.tablerow(ie),ne="",Me=U.rows.length,Ie=0;Ie<Me;Ie++){for(Je=U.rows[Ie],ie="",je=Je.length,Be=0;Be<je;Be++)ie+=this.renderer.tablecell(this.parseInline(Je[Be].tokens),{header:!1,align:U.align[Be]});ne+=this.renderer.tablerow(ie)}ge+=this.renderer.table(pe,ne);continue}case"blockquote":{ne=this.parse(U.tokens),ge+=this.renderer.blockquote(ne);continue}case"list":{for(Ce=U.ordered,Se=U.start,Ge=U.loose,Me=U.items.length,ne="",Ie=0;Ie<Me;Ie++)it=U.items[Ie],mt=it.checked,vt=it.task,We="",it.task&&(nt=this.renderer.checkbox(mt),Ge?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=nt+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=nt+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:nt}):We+=nt),We+=this.parse(it.tokens,Ge),ne+=this.renderer.listitem(We,vt,mt);ge+=this.renderer.list(ne,Ce,Se);continue}case"html":{ge+=this.renderer.html(U.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(U.tokens));continue}case"text":{for(ne=U.tokens?this.parseInline(U.tokens):U.text;me+1<lt&&Z[me+1].type==="text";)U=Z[++me],ne+=`
`+(U.tokens?this.parseInline(U.tokens):U.text);ge+=le?this.renderer.paragraph(ne):ne;continue}default:{var Ft='Token with "'+U.type+'" type was not found.';if(this.options.silent){console.error(Ft);return}else throw new Error(Ft)}}}return ge},ye.parseInline=function(Z,le){le=le||this.renderer;var ge="",me,Ie,Be,Me=Z.length;for(me=0;me<Me;me++){if(Ie=Z[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(Be=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),Be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){ge+=Be||"";continue}switch(Ie.type){case"escape":{ge+=le.text(Ie.text);break}case"html":{ge+=le.html(Ie.text);break}case"link":{ge+=le.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,le));break}case"image":{ge+=le.image(Ie.href,Ie.title,Ie.text);break}case"strong":{ge+=le.strong(this.parseInline(Ie.tokens,le));break}case"em":{ge+=le.em(this.parseInline(Ie.tokens,le));break}case"codespan":{ge+=le.codespan(Ie.text);break}case"br":{ge+=le.br();break}case"del":{ge+=le.del(this.parseInline(Ie.tokens,le));break}case"text":{ge+=le.text(Ie.text);break}default:{var je='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return ge},Pe}(),he=K,Le=J,Ve=j,tt=se,ut=fe,ht=Ae,St=F.merge,Pt=F.checkSanitizeDeprecation,dt=F.escape,bt=T.exports.getDefaults,ft=T.exports.changeDefaults,Et=T.exports.defaults;function Ye(Pe,ye,De){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=St({},Ye.defaults,ye||{}),Pt(ye),De){var Z=ye.highlight,le;try{le=he.lex(Pe,ye)}catch(Be){return De(Be)}var ge=function(Me){var je;if(!Me)try{ye.walkTokens&&Ye.walkTokens(le,ye.walkTokens),je=Le.parse(le,ye)}catch(Je){Me=Je}return ye.highlight=Z,Me?De(Me):De(null,je)};if(!Z||Z.length<3||(delete ye.highlight,!le.length))return ge();var me=0;Ye.walkTokens(le,function(Be){Be.type==="code"&&(me++,setTimeout(function(){Z(Be.text,Be.lang,function(Me,je){if(Me)return ge(Me);je!=null&&je!==Be.text&&(Be.text=je,Be.escaped=!0),me--,me===0&&ge()})},0))}),me===0&&ge();return}try{var Ie=he.lex(Pe,ye);return ye.walkTokens&&Ye.walkTokens(Ie,ye.walkTokens),Le.parse(Ie,ye)}catch(Be){if(Be.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+dt(Be.message+"",!0)+"</pre>";throw Be}}Ye.options=Ye.setOptions=function(Pe){return St(Ye.defaults,Pe),ft(Ye.defaults),Ye},Ye.getDefaults=bt,Ye.defaults=Et,Ye.use=function(){for(var Pe=this,ye=arguments.length,De=new Array(ye),Z=0;Z<ye;Z++)De[Z]=arguments[Z];var le=St.apply(void 0,[{}].concat(De)),ge=Ye.defaults.extensions||{renderers:{},childTokens:{}},me;De.forEach(function(Ie){if(Ie.extensions&&(me=!0,Ie.extensions.forEach(function(Me){if(!Me.name)throw new Error("extension name required");if(Me.renderer){var je=ge.renderers?ge.renderers[Me.name]:null;je?ge.renderers[Me.name]=function(){for(var Je=arguments.length,ie=new Array(Je),pe=0;pe<Je;pe++)ie[pe]=arguments[pe];var ne=Me.renderer.apply(this,ie);return ne===!1&&(ne=je.apply(this,ie)),ne}:ge.renderers[Me.name]=Me.renderer}if(Me.tokenizer){if(!Me.level||Me.level!=="block"&&Me.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Me.level]?ge[Me.level].unshift(Me.tokenizer):ge[Me.level]=[Me.tokenizer],Me.start&&(Me.level==="block"?ge.startBlock?ge.startBlock.push(Me.start):ge.startBlock=[Me.start]:Me.level==="inline"&&(ge.startInline?ge.startInline.push(Me.start):ge.startInline=[Me.start]))}Me.childTokens&&(ge.childTokens[Me.name]=Me.childTokens)})),Ie.renderer&&function(){var Me=Ye.defaults.renderer||new tt,je=function(pe){var ne=Me[pe];Me[pe]=function(){for(var U=arguments.length,Ce=new Array(U),Se=0;Se<U;Se++)Ce[Se]=arguments[Se];var Ge=Ie.renderer[pe].apply(Me,Ce);return Ge===!1&&(Ge=ne.apply(Me,Ce)),Ge}};for(var Je in Ie.renderer)je(Je);le.renderer=Me}(),Ie.tokenizer&&function(){var Me=Ye.defaults.tokenizer||new Ve,je=function(pe){var ne=Me[pe];Me[pe]=function(){for(var U=arguments.length,Ce=new Array(U),Se=0;Se<U;Se++)Ce[Se]=arguments[Se];var Ge=Ie.tokenizer[pe].apply(Me,Ce);return Ge===!1&&(Ge=ne.apply(Me,Ce)),Ge}};for(var Je in Ie.tokenizer)je(Je);le.tokenizer=Me}(),Ie.walkTokens){var Be=Ye.defaults.walkTokens;le.walkTokens=function(Me){Ie.walkTokens.call(Pe,Me),Be&&Be(Me)}}me&&(le.extensions=ge),Ye.setOptions(le)})},Ye.walkTokens=function(Pe,ye){for(var De=function(){var me=le.value;switch(ye(me),me.type){case"table":{for(var Ie=E(me.header),Be;!(Be=Ie()).done;){var Me=Be.value;Ye.walkTokens(Me.tokens,ye)}for(var je=E(me.rows),Je;!(Je=je()).done;)for(var ie=Je.value,pe=E(ie),ne;!(ne=pe()).done;){var U=ne.value;Ye.walkTokens(U.tokens,ye)}break}case"list":{Ye.walkTokens(me.items,ye);break}default:Ye.defaults.extensions&&Ye.defaults.extensions.childTokens&&Ye.defaults.extensions.childTokens[me.type]?Ye.defaults.extensions.childTokens[me.type].forEach(function(Ce){Ye.walkTokens(me[Ce],ye)}):me.tokens&&Ye.walkTokens(me.tokens,ye)}},Z=E(Pe),le;!(le=Z()).done;)De()},Ye.parseInline=function(Pe,ye){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");ye=St({},Ye.defaults,ye||{}),Pt(ye);try{var De=he.lexInline(Pe,ye);return ye.walkTokens&&Ye.walkTokens(De,ye.walkTokens),Le.parseInline(De,ye)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+dt(Z.message+"",!0)+"</pre>";throw Z}},Ye.Parser=Le,Ye.parser=Le.parse,Ye.Renderer=tt,Ye.TextRenderer=ut,Ye.Lexer=he,Ye.lexer=he.lex,Ye.Tokenizer=Ve,Ye.Slugger=ht,Ye.parse=Ye;var Ct=Ye;return Ct}),define(we[75],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(A,P,S){return Math.min(Math.max(A,P),S)}e.clamp=c;function M(A,P){return(P+A%P)%P}e.rot=M;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class T{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function re(E){const T=[];typeof E=="number"&&T.push("code/timeOrigin",E);function A(S){T.push(S,Date.now())}function P(){const S=[];for(let I=0;I<T.length;I+=2)S.push({name:T[I],startTime:T[I+1]});return S}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(E+A.startTime)});return T}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function c(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=c(M))}(),define(we[34],be([0,1,3]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new c.Emitter}add(y){const n=this._icons.get(y.id);n?y.description?n.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const E=new M;e.iconRegistry=E;function T(t,y){return new P(t,y)}e.registerCodicon=T;function A(t){return t?t.replace(/\$\((.*?)\)/g,(y,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=A;class P{constructor(y,n,d){this.id=y,this.definition=n,this.description=d,E.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function S(t,y){const n=["codicon","codicon-"+t];return y&&n.push("codicon-modifier-"+y),n}e.getClassNamesArray=S;var I;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const y=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(u){if(u instanceof P)return["codicon","codicon-"+u.id];const p=y.exec(u.id);if(!p)return n(P.error);let[,k,w]=p;const l=["codicon","codicon-"+k];return w&&l.push("codicon-modifier-"+w.substr(1)),l}t.asClassNameArray=n;function d(u){return n(u).join(" ")}t.asClassName=d;function r(u){return"."+n(u).join(".")}t.asCSSSelector=r})(I=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(we[104],be([0,1,15,7]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(l){const v=l;return v?[v.on,v.pause,v.resume,v.destroy].every(D=>typeof D=="function"):!1}e.isReadableStream=E;function T(l){const v=l;return v?E(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=T;function A(l,v){return new P(l,v)}e.newWriteableStream=A;class P{constructor(v,D){this.reducer=v,this.options=D,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(D=>this.pendingWritePromises.push(D))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v!="undefined"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(D=>D(v))}emitError(v){this.listeners.error.length===0?(0,c.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(D=>D(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,D){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(D),this.resume();break;case"end":this.listeners.end.push(D),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(D),this.state.flowing&&this.flowErrors();break}}removeListener(v,D){if(this.state.destroyed)return;let i;switch(v){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const s=i.indexOf(D);s>=0&&i.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const D=[...this.pendingWritePromises];this.pendingWritePromises.length=0,D.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(l,v){const D=[];let i;for(;(i=l.read())!==null;)D.push(i);return v(D)}e.consumeReadable=S;function I(l,v,D){const i=[];let s;for(;(s=l.read())!==null&&i.length<D;)i.push(s);return s===null&&i.length>0?v(i):{read:()=>{if(i.length>0)return i.shift();if(typeof s!="undefined"){const a=s;return s=void 0,a}return l.read()}}}e.peekReadable=I;function t(l,v){return new Promise((D,i)=>{const s=[];y(l,{onData:a=>{v&&s.push(a)},onError:a=>{v?i(a):D(void 0)},onEnd:()=>{D(v?v(s):void 0)}})})}e.consumeStream=t;function y(l,v){l.on("error",D=>v.onError(D)),l.on("end",()=>v.onEnd()),l.on("data",D=>v.onData(D))}e.listenStream=y;function n(l,v){return new Promise((D,i)=>{const s=new M.DisposableStore,a=[],o=g=>{if(a.push(g),a.length>v)return s.dispose(),l.pause(),D({stream:l,buffer:a,ended:!1})},_=g=>i(g),m=()=>D({stream:l,buffer:a,ended:!0});s.add((0,M.toDisposable)(()=>l.removeListener("error",_))),l.on("error",_),s.add((0,M.toDisposable)(()=>l.removeListener("end",m))),l.on("end",m),s.add((0,M.toDisposable)(()=>l.removeListener("data",o))),l.on("data",o)})}e.peekStream=n;function d(l,v){const D=A(v);return D.end(l),D}e.toStream=d;function r(){const l=A(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=r;function u(l){let v=!1;return{read:()=>v?null:(v=!0,l)}}e.toReadable=u;function p(l,v,D){const i=A(D);return y(l,{onData:s=>i.write(v.data(s)),onError:s=>i.error(v.error?v.error(s):s),onEnd:()=>i.end()}),i}e.transform=p;function k(l,v,D){let i=!1;return{read:()=>{const s=v.read();return i?s:(i=!0,s!==null?D([l,s]):l)}}}e.prefixedReadable=k;function w(l,v,D){let i=!1;const s=A(D);return y(v,{onData:a=>i?s.write(a):(i=!0,s.write(D([l,a]))),onError:a=>s.error(a),onEnd:()=>{i||(i=!0,s.write(l)),s.end()}}),s}e.prefixedStream=w}),define(we[23],be([0,1,104]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let E,T;class A{constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}static alloc(o){return M?new A(Buffer.allocUnsafe(o)):new A(new Uint8Array(o))}static wrap(o){return M&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new A(o)}static fromString(o,_){return!(_?.dontUseNodeBuffer||!1)&&M?new A(Buffer.from(o)):(E||(E=new TextEncoder),new A(E.encode(o)))}static concat(o,_){if(typeof _=="undefined"){_=0;for(let C=0,R=o.length;C<R;C++)_+=o[C].byteLength}const m=A.alloc(_);let g=0;for(let C=0,R=o.length;C<R;C++){const h=o[C];m.set(h,g),g+=h.byteLength}return m}toString(){return M?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(o,_){return new A(this.buffer.subarray(o,_))}set(o,_){o instanceof A?this.buffer.set(o.buffer,_):this.buffer.set(o,_)}readUInt32BE(o){return I(this.buffer,o)}writeUInt32BE(o,_){t(this.buffer,o,_)}readUInt32LE(o){return y(this.buffer,o)}writeUInt32LE(o,_){n(this.buffer,o,_)}readUInt8(o){return d(this.buffer,o)}writeUInt8(o,_){r(this.buffer,o,_)}}e.VSBuffer=A;function P(a,o){return a[o+0]<<0>>>0|a[o+1]<<8>>>0}e.readUInt16LE=P;function S(a,o,_){a[_+0]=o&255,o=o>>>8,a[_+1]=o&255}e.writeUInt16LE=S;function I(a,o){return a[o]*2**24+a[o+1]*2**16+a[o+2]*2**8+a[o+3]}e.readUInt32BE=I;function t(a,o,_){a[_+3]=o,o=o>>>8,a[_+2]=o,o=o>>>8,a[_+1]=o,o=o>>>8,a[_]=o}e.writeUInt32BE=t;function y(a,o){return a[o+0]<<0>>>0|a[o+1]<<8>>>0|a[o+2]<<16>>>0|a[o+3]<<24>>>0}e.readUInt32LE=y;function n(a,o,_){a[_+0]=o&255,o=o>>>8,a[_+1]=o&255,o=o>>>8,a[_+2]=o&255,o=o>>>8,a[_+3]=o&255}e.writeUInt32LE=n;function d(a,o){return a[o]}e.readUInt8=d;function r(a,o,_){a[_]=o}e.writeUInt8=r;function u(a){return c.consumeReadable(a,o=>A.concat(o))}e.readableToBuffer=u;function p(a){return c.toReadable(a)}e.bufferToReadable=p;function k(a){return c.consumeStream(a,o=>A.concat(o))}e.streamToBuffer=k;async function w(a){return a.ended?A.concat(a.buffer):A.concat([...a.buffer,await k(a.stream)])}e.bufferedStreamToBuffer=w;function l(a){return c.toStream(a,o=>A.concat(o))}e.bufferToStream=l;function v(a){return c.transform(a,{data:o=>typeof o=="string"?A.fromString(o):A.wrap(o)},o=>A.concat(o))}e.streamToBufferReadableStream=v;function D(a){return c.newWriteableStream(o=>A.concat(o),a)}e.newWriteableBufferStream=D;function i(a,o){return c.prefixedReadable(a,o,_=>A.concat(_))}e.prefixedBufferReadable=i;function s(a,o){return c.prefixedStream(a,o,_=>A.concat(_))}e.prefixedBufferStream=s}),define(we[35],be([0,1,9]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(M||(M={})),function(E){const T="error",A="warning",P="warn",S="info",I="ignore";function t(n){return n?c.equalsIgnoreCase(T,n)?E.Error:c.equalsIgnoreCase(A,n)||c.equalsIgnoreCase(P,n)?E.Warning:c.equalsIgnoreCase(S,n)?E.Info:E.Ignore:E.Ignore}E.fromValue=t;function y(n){switch(n){case E.Error:return T;case E.Warning:return A;case E.Info:return S;default:return I}}E.toString=y}(M||(M={})),e.default=M}),define(we[40],be([0,1,17,26,9,10]),function(re,e,c,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(a){return a===47||a===92}e.isPathSeparator=A;function P(a){return a.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=P;function S(a){return a.indexOf("/")===-1&&(a=P(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=S;function I(a,o=c.posix.sep){if(!a)return"";const _=a.length,m=a.charCodeAt(0);if(A(m)){if(A(a.charCodeAt(1))&&!A(a.charCodeAt(2))){let C=3;const R=C;for(;C<_&&!A(a.charCodeAt(C));C++);if(R!==C&&!A(a.charCodeAt(C+1))){for(C+=1;C<_;C++)if(A(a.charCodeAt(C)))return a.slice(0,C+1).replace(/[\\/]/g,o)}}return o}else if(k(m)&&a.charCodeAt(1)===58)return A(a.charCodeAt(2))?a.slice(0,2)+o:a.slice(0,2);let g=a.indexOf("://");if(g!==-1){for(g+=3;g<_;g++)if(A(a.charCodeAt(g)))return a.slice(0,g+1)}return""}e.getRoot=I;function t(a){if(!M.isWindows||!a||a.length<5)return!1;let o=a.charCodeAt(0);if(o!==92||(o=a.charCodeAt(1),o!==92))return!1;let _=2;const m=_;for(;_<a.length&&(o=a.charCodeAt(_),o!==92);_++);return!(m===_||(o=a.charCodeAt(_+1),isNaN(o)||o===92))}e.isUNC=t;const y=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(a,o=M.isWindows){const _=o?y:n;return!(!a||a.length===0||/^\s+$/.test(a)||(_.lastIndex=0,_.test(a))||o&&d.test(a)||a==="."||a===".."||o&&a[a.length-1]==="."||o&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=r;function u(a,o,_){const m=a===o;return!_||m?m:!a||!o?!1:(0,E.equalsIgnoreCase)(a,o)}e.isEqual=u;function p(a,o,_,m=c.sep){if(a===o)return!0;if(!a||!o||o.length>a.length)return!1;if(_){if(!(0,E.startsWithIgnoreCase)(a,o))return!1;if(o.length===a.length)return!0;let C=o.length;return o.charAt(o.length-1)===m&&C--,a.charAt(C)===m}return o.charAt(o.length-1)!==m&&(o+=m),a.indexOf(o)===0}e.isEqualOrParent=p;function k(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=k;function w(a,o){return M.isWindows&&a.endsWith(":")&&(a+=c.sep),(0,c.isAbsolute)(a)||(a=(0,c.join)(o,a)),a=(0,c.normalize)(a),M.isWindows?(a=(0,E.rtrim)(a,c.sep),a.endsWith(":")&&(a+=c.sep)):(a=(0,E.rtrim)(a,c.sep),a||(a=c.sep)),a}e.sanitizeFilePath=w;function l(a){const o=(0,c.normalize)(a);return M.isWindows?a.length>3?!1:v(o)&&(a.length===2||o.charCodeAt(2)===92):o===c.posix.sep}e.isRootOrDriveLetter=l;function v(a){return M.isWindows?k(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=v;function D(a){return v(a)?a[0]:void 0}e.getDriveLetter=D;function i(a,o,_){return o.length>a.length?-1:a===o?0:(_&&(a=a.toLowerCase(),o=o.toLowerCase()),a.indexOf(o))}e.indexOfPath=i;function s(a){const o=a.split(":");let _,m,g;if(o.forEach(C=>{const R=Number(C);(0,T.isNumber)(R)?m===void 0?m=R:g===void 0&&(g=R):_=_?[_,C].join(":"):C}),!_)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:_,line:m!==void 0?m:void 0,column:g!==void 0?g:m!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(we[22],be([0,1,10]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const p=Array.isArray(u)?[]:{};return Object.keys(u).forEach(k=>{u[k]&&typeof u[k]=="object"?p[k]=M(u[k]):p[k]=u[k]}),p}e.deepClone=M;function E(u){if(!u||typeof u!="object")return u;const p=[u];for(;p.length>0;){const k=p.shift();Object.freeze(k);for(const w in k)if(T.call(k,w)){const l=k[w];typeof l=="object"&&!Object.isFrozen(l)&&p.push(l)}}return u}e.deepFreeze=E;const T=Object.prototype.hasOwnProperty;function A(u,p){return P(u,p,new Set)}e.cloneAndChange=A;function P(u,p,k){if((0,c.isUndefinedOrNull)(u))return u;const w=p(u);if(typeof w!="undefined")return w;if((0,c.isArray)(u)){const l=[];for(const v of u)l.push(P(v,p,k));return l}if((0,c.isObject)(u)){if(k.has(u))throw new Error("Cannot clone recursive data-structure");k.add(u);const l={};for(let v in u)T.call(u,v)&&(l[v]=P(u[v],p,k));return k.delete(u),l}return u}function S(u,p,k=!0){return(0,c.isObject)(u)?((0,c.isObject)(p)&&Object.keys(p).forEach(w=>{w in u?k&&((0,c.isObject)(u[w])&&(0,c.isObject)(p[w])?S(u[w],p[w],k):u[w]=p[w]):u[w]=p[w]}),u):p}e.mixin=S;function I(u,p){if(u===p)return!0;if(u==null||p===null||p===void 0||typeof u!=typeof p||typeof u!="object"||Array.isArray(u)!==Array.isArray(p))return!1;let k,w;if(Array.isArray(u)){if(u.length!==p.length)return!1;for(k=0;k<u.length;k++)if(!I(u[k],p[k]))return!1}else{const l=[];for(w in u)l.push(w);l.sort();const v=[];for(w in p)v.push(w);if(v.sort(),!I(l,v))return!1;for(k=0;k<l.length;k++)if(!I(u[l[k]],p[l[k]]))return!1}return!0}e.equals=I;function t(u){const p=new Set;return JSON.stringify(u,(k,w)=>{if((0,c.isObject)(w)||Array.isArray(w)){if(p.has(w))return"[Circular]";p.add(w)}return w})}e.safeStringify=t;function y(u,p,k){const w=p(u);return typeof w=="undefined"?k:w}e.getOrDefault=y;function n(u,p){const k=Object.create(null);return!u||!p||Object.keys(p).forEach(l=>{const v=u[l],D=p[l];I(v,D)||(k[l]=D)}),k}e.distinct=n;function d(u,p){const k=p.toLowerCase(),w=Object.keys(u).find(l=>l.toLowerCase()===k);return w?u[w]:u[p]}e.getCaseInsensitive=d;function r(u,p){const k=Object.create(null);for(const w of Object.keys(u))p(w,u[w])&&(k[w]=u[w]);return k}e.filter=r});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[20],be([0,1,9,2]),function(re,e,c,M){"use strict";var E,T,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(i,s,a){let o=i.get(s);return o===void 0&&(o=a,i.set(s,o)),o}e.getOrSet=P;function S(i){const s=[];return i.forEach((a,o)=>{s.push(`${o} => ${a}`)}),`Map(${i.size}) {${s.join(", ")}}`}e.mapToString=S;function I(i){const s=[];return i.forEach(a=>{s.push(a)}),`Set(${i.size}) {${s.join(", ")}}`}e.setToString=I;class t{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const a=s.charCodeAt(0),o=this._value.charCodeAt(this._pos);return a-o}value(){return this._value[this._pos]}}e.StringIterator=t;class y{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,c.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,c.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class n{constructor(s=!0,a=!0){this._splitOnBackslash=s,this._caseSensitive=a}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,c.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,c.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var d;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(d||(d={}));class r{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,c.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,c.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,c.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,c.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=r;class u{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class p{constructor(s){this._iter=s}static forUris(s=()=>!1){return new p(new r(s))}static forPaths(){return new p(new n)}static forStrings(){return new p(new t)}static forConfigKeys(){return new p(new y)}clear(){this._root=void 0}set(s,a){const o=this._iter.reset(s);let _;for(this._root||(this._root=new u,this._root.segment=o.value()),_=this._root;;){const g=o.cmp(_.segment);if(g>0)_.left||(_.left=new u,_.left.segment=o.value()),_=_.left;else if(g<0)_.right||(_.right=new u,_.right.segment=o.value()),_=_.right;else if(o.hasNext())o.next(),_.mid||(_.mid=new u,_.mid.segment=o.value()),_=_.mid;else break}const m=_.value;return _.value=a,_.key=s,m}get(s){return this._getNode(s)?.value}_getNode(s){const a=this._iter.reset(s);let o=this._root;for(;o;){const _=a.cmp(o.segment);if(_>0)o=o.left;else if(_<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else break}return o}has(s){const a=this._getNode(s);return!(a?.value===void 0&&a?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,a){const o=this._iter.reset(s),_=[];let m=this._root;for(;m;){const g=o.cmp(m.segment);if(g>0)_.push([1,m]),m=m.left;else if(g<0)_.push([-1,m]),m=m.right;else if(o.hasNext())o.next(),_.push([0,m]),m=m.mid;else{for(a?(m.left=void 0,m.mid=void 0,m.right=void 0):m.value=void 0;_.length>0&&m.isEmpty();){let[C,R]=_.pop();switch(C){case 1:R.left=void 0;break;case 0:R.mid=void 0;break;case-1:R.right=void 0;break}m=R}break}}}findSubstr(s){const a=this._iter.reset(s);let o=this._root,_;for(;o;){const m=a.cmp(o.segment);if(m>0)o=o.left;else if(m<0)o=o.right;else if(a.hasNext())a.next(),_=o.value||_,o=o.mid;else break}return o&&o.value||_}findSuperstr(s){const a=this._iter.reset(s);let o=this._root;for(;o;){const _=a.cmp(o.segment);if(_>0)o=o.left;else if(_<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(s){for(const[a,o]of this)s(o,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const a=[s];for(;a.length>0;){const o=a.pop();o&&(o.value&&(yield[o.key,o.value]),o.left&&a.push(o.left),o.mid&&a.push(o.mid),o.right&&a.push(o.right))}}}e.TernarySearchTree=p;class k{constructor(s,a){this[E]="ResourceMap",s instanceof k?(this.map=new Map(s.map),this.toKey=a??k.defaultToKey):(this.map=new Map,this.toKey=s??k.defaultToKey)}set(s,a){return this.map.set(this.toKey(s),a),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,a){typeof a!="undefined"&&(s=s.bind(a));for(let[o,_]of this.map)s(_,M.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield M.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[M.URI.parse(s[0]),s[1]]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[M.URI.parse(s[0]),s[1]]}}e.ResourceMap=k,k.defaultToKey=i=>i.toString();var w;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class l{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,a=0){const o=this._map.get(s);if(!!o)return a!==0&&this.touch(o,a),o.value}set(s,a,o=0){let _=this._map.get(s);if(_)_.value=a,o!==0&&this.touch(_,o);else{switch(_={key:s,value:a,next:void 0,previous:void 0},o){case 0:this.addItemLast(_);break;case 1:this.addItemFirst(_);break;case 2:this.addItemLast(_);break;default:this.addItemLast(_);break}this._map.set(s,_),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const a=this._map.get(s);if(!!a)return this._map.delete(s),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,a){const o=this._state;let _=this._head;for(;_;){if(a?s.bind(a)(_.value,_.key,this):s(_.value,_.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");_=_.next}}keys(){const s=this,a=this._state;let o=this._head;const _={[Symbol.iterator](){return _},next(){if(s._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const m={value:o.key,done:!1};return o=o.next,m}else return{value:void 0,done:!0}}};return _}values(){const s=this,a=this._state;let o=this._head;const _={[Symbol.iterator](){return _},next(){if(s._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const m={value:o.value,done:!1};return o=o.next,m}else return{value:void 0,done:!0}}};return _}entries(){const s=this,a=this._state;let o=this._head;const _={[Symbol.iterator](){return _},next(){if(s._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const m={value:[o.key,o.value],done:!1};return o=o.next,m}else return{value:void 0,done:!0}}};return _}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let a=this._head,o=this.size;for(;a&&o>s;)this._map.delete(a.key),a=a.next,o--;this._head=a,this._size=o,a&&(a.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const a=s.next,o=s.previous;if(!a||!o)throw new Error("Invalid list");a.previous=o,o.next=a}s.next=void 0,s.previous=void 0,this._state++}touch(s,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(s===this._head)return;const o=s.next,_=s.previous;s===this._tail?(_.next=void 0,this._tail=_):(o.previous=_,_.next=o),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(a===2){if(s===this._tail)return;const o=s.next,_=s.previous;s===this._head?(o.previous=void 0,this._head=o):(o.previous=_,_.next=o),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((a,o)=>{s.push([o,a])}),s}fromJSON(s){this.clear();for(const[a,o]of s)this.set(a,o)}}e.LinkedMap=l;class v extends l{constructor(s,a=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,a=2){return super.get(s,a)}peek(s){return super.get(s,0)}set(s,a){return super.set(s,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=v;class D{constructor(s){A.set(this,void 0),et(this,A,s,"f")}get size(){return Oe(this,A,"f").size}forEach(s,a){Oe(this,A,"f").forEach(s,a)}get(s){return Oe(this,A,"f").get(s)}has(s){return Oe(this,A,"f").has(s)}entries(){return Oe(this,A,"f").entries()}keys(){return Oe(this,A,"f").keys()}values(){return Oe(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Oe(this,A,"f").entries()}}e.ReadonlyMapView=D}),define(we[105],be([0,1,20,9]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...V){return function(se,fe){for(let Ae=0,xe=V.length;Ae<xe;Ae++){const $e=V[Ae](se,fe);if($e)return $e}return null}}e.or=E,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(V,se,fe){if(!fe||fe.length<se.length)return null;let Ae;return V?Ae=M.startsWithIgnoreCase(fe,se):Ae=fe.indexOf(se)===0,Ae?se.length>0?[{start:0,end:se.length}]:[]:null}function A(V,se){const fe=se.toLowerCase().indexOf(V.toLowerCase());return fe===-1?null:[{start:fe,end:fe+V.length}]}e.matchesContiguousSubString=A;function P(V,se){return S(V.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=P;function S(V,se,fe,Ae){if(fe===V.length)return[];if(Ae===se.length)return null;if(V[fe]===se[Ae]){let xe=null;return(xe=S(V,se,fe+1,Ae+1))?k({start:Ae,end:Ae+1},xe):null}return S(V,se,fe,Ae+1)}function I(V){return 97<=V&&V<=122}function t(V){return 65<=V&&V<=90}e.isUpper=t;function y(V){return 48<=V&&V<=57}function n(V){return V===32||V===9||V===10||V===13}const d=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(V=>d.add(V.charCodeAt(0)));function r(V){return n(V)||d.has(V)}function u(V,se){return V===se||r(V)&&r(se)}function p(V){return I(V)||t(V)||y(V)}function k(V,se){return se.length===0?se=[V]:V.end===se[0].start?se[0].start=V.start:se.unshift(V),se}function w(V,se){for(let fe=se;fe<V.length;fe++){const Ae=V.charCodeAt(fe);if(t(Ae)||y(Ae)||fe>0&&!p(V.charCodeAt(fe-1)))return fe}return V.length}function l(V,se,fe,Ae){if(fe===V.length)return[];if(Ae===se.length)return null;if(V[fe]!==se[Ae].toLowerCase())return null;{let xe=null,$e=Ae+1;for(xe=l(V,se,fe+1,Ae+1);!xe&&($e=w(se,$e))<se.length;)xe=l(V,se,fe+1,$e),$e++;return xe===null?null:k({start:Ae,end:Ae+1},xe)}}function v(V){let se=0,fe=0,Ae=0,xe=0,$e=0;for(let he=0;he<V.length;he++)$e=V.charCodeAt(he),t($e)&&se++,I($e)&&fe++,p($e)&&Ae++,y($e)&&xe++;const ve=se/V.length,Xe=fe/V.length,H=Ae/V.length,J=xe/V.length;return{upperPercent:ve,lowerPercent:Xe,alphaPercent:H,numericPercent:J}}function D(V){const{upperPercent:se,lowerPercent:fe}=V;return fe===0&&se>.6}function i(V){const{upperPercent:se,lowerPercent:fe,alphaPercent:Ae,numericPercent:xe}=V;return fe>.2&&se<.8&&Ae>.6&&xe<.2}function s(V){let se=0,fe=0,Ae=0,xe=0;for(let $e=0;$e<V.length;$e++)Ae=V.charCodeAt($e),t(Ae)&&se++,I(Ae)&&fe++,n(Ae)&&xe++;return(se===0||fe===0)&&xe===0?V.length<=30:se<=5}function a(V,se){if(!se||(se=se.trim(),se.length===0)||!s(V)||se.length>60)return null;const fe=v(se);if(!i(fe)){if(!D(fe))return null;se=se.toLowerCase()}let Ae=null,xe=0;for(V=V.toLowerCase();xe<se.length&&(Ae=l(V,se,0,xe))===null;)xe=w(se,xe+1);return Ae}e.matchesCamelCase=a;function o(V,se,fe=!1){if(!se||se.length===0)return null;let Ae=null,xe=0;for(V=V.toLowerCase(),se=se.toLowerCase();xe<se.length&&(Ae=_(V,se,0,xe,fe))===null;)xe=m(se,xe+1);return Ae}e.matchesWords=o;function _(V,se,fe,Ae,xe){if(fe===V.length)return[];if(Ae===se.length)return null;if(u(V.charCodeAt(fe),se.charCodeAt(Ae))){let $e=null,ve=Ae+1;if($e=_(V,se,fe+1,Ae+1,xe),!xe)for(;!$e&&(ve=m(se,ve))<se.length;)$e=_(V,se,fe+1,ve,xe),ve++;return $e===null?null:k({start:Ae,end:Ae+1},$e)}else return null}function m(V,se){for(let fe=se;fe<V.length;fe++)if(r(V.charCodeAt(fe))||fe>0&&r(V.charCodeAt(fe-1)))return fe;return V.length}const g=E(e.matchesPrefix,a,A),C=E(e.matchesPrefix,a,P),R=new c.LRUCache(1e4);function h(V,se,fe=!1){if(typeof V!="string"||typeof se!="string")return null;let Ae=R.get(V);Ae||(Ae=new RegExp(M.convertSimple2RegExpPattern(V),"i"),R.set(V,Ae));const xe=Ae.exec(se);return xe?[{start:xe.index,end:xe.index+xe[0].length}]:fe?C(V,se):g(V,se)}e.matchesFuzzy=h;function b(V,se){const fe=Qe(V,V.toLowerCase(),0,se,se.toLowerCase(),0,!0);return fe?F(fe):null}e.matchesFuzzy2=b;function f(V,se,fe,Ae,xe,$e){const ve=Math.min(13,V.length);for(;fe<ve;fe++){const Xe=Qe(V,se,fe,Ae,xe,$e,!1);if(Xe)return Xe}return[0,$e]}e.anyScore=f;function F(V){if(typeof V=="undefined")return[];const se=[],fe=V[1];for(let Ae=V.length-1;Ae>1;Ae--){const xe=V[Ae]+fe,$e=se[se.length-1];$e&&$e.end===xe?$e.end=xe+1:se.push({start:xe,end:xe+1})}return se}e.createMatches=F;const O=128;function q(){const V=[],se=[];for(let fe=0;fe<=O;fe++)se[fe]=0;for(let fe=0;fe<=O;fe++)V.push(se.slice(0));return V}function Q(V){const se=[];for(let fe=0;fe<=V;fe++)se[fe]=0;return se}const $=Q(2*O),z=Q(2*O),N=q(),W=q(),j=q(),Y=!1;function de(V,se,fe,Ae,xe){function $e(Xe,H,J=" "){for(;Xe.length<H;)Xe=J+Xe;return Xe}let ve=` |   |${Ae.split("").map(Xe=>$e(Xe,3)).join("|")}
`;for(let Xe=0;Xe<=fe;Xe++)Xe===0?ve+=" |":ve+=`${se[Xe-1]}|`,ve+=V[Xe].slice(0,xe+1).map(H=>$e(H.toString(),3)).join("|")+`
`;return ve}function G(V,se,fe,Ae){V=V.substr(se),fe=fe.substr(Ae),console.log(de(W,V,V.length,fe,fe.length)),console.log(de(j,V,V.length,fe,fe.length)),console.log(de(N,V,V.length,fe,fe.length))}function ue(V,se){if(se<0||se>=V.length)return!1;const fe=V.codePointAt(se);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(fe)}}function oe(V,se){if(se<0||se>=V.length)return!1;switch(V.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function Ee(V,se,fe){return se[V]!==fe[V]}function Te(V,se,fe,Ae,xe,$e,ve=!1){for(;se<fe&&xe<$e;)V[se]===Ae[xe]&&(ve&&($[se]=xe),se+=1),xe+=1;return se===fe}e.isPatternInWord=Te;var Re;(function(V){V[V.Diag=1]="Diag",V[V.Left=2]="Left",V[V.LeftLeft=3]="LeftLeft"})(Re||(Re={}));var Ne;(function(V){V.Default=[-100,0];function se(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}V.isDefault=se})(Ne=e.FuzzyScore||(e.FuzzyScore={}));function Qe(V,se,fe,Ae,xe,$e,ve){const Xe=V.length>O?O:V.length,H=Ae.length>O?O:Ae.length;if(fe>=Xe||$e>=H||Xe-fe>H-$e||!Te(se,fe,Xe,xe,$e,H,!0))return;He(Xe,H,fe,$e,se,xe);let J=1,he=1,Le=fe,Ve=$e;const tt=[!1];for(J=1,Le=fe;Le<Xe;J++,Le++){const dt=$[Le],bt=z[Le],ft=Le+1<Xe?z[Le+1]:H;for(he=dt-$e+1,Ve=dt;Ve<ft;he++,Ve++){let Et=Number.MIN_SAFE_INTEGER,Ye=!1;Ve<=bt&&(Et=qe(V,se,Le,fe,Ae,xe,Ve,H,$e,N[J-1][he-1]===0,tt));let Ct=0;Et!==Number.MAX_SAFE_INTEGER&&(Ye=!0,Ct=Et+W[J-1][he-1]);const Pe=Ve>dt,ye=Pe?W[J][he-1]+(N[J][he-1]>0?-5:0):0,De=Ve>dt+1&&N[J][he-1]>0,Z=De?W[J][he-2]+(N[J][he-2]>0?-5:0):0;if(De&&(!Pe||Z>=ye)&&(!Ye||Z>=Ct))W[J][he]=Z,j[J][he]=3,N[J][he]=0;else if(Pe&&(!Ye||ye>=Ct))W[J][he]=ye,j[J][he]=2,N[J][he]=0;else if(Ye)W[J][he]=Ct,j[J][he]=1,N[J][he]=N[J-1][he-1]+1;else throw new Error("not possible")}}if(Y&&G(V,fe,Ae,$e),!tt[0]&&!ve)return;J--,he--;const ut=[W[J][he],$e];let ht=0,St=0;for(;J>=1;){let dt=he;do{const bt=j[J][dt];if(bt===3)dt=dt-2;else if(bt===2)dt=dt-1;else break}while(dt>=1);ht>1&&se[fe+J-1]===xe[$e+he-1]&&!Ee(dt+$e-1,Ae,xe)&&ht+1>N[J][dt]&&(dt=he),dt===he?ht++:ht=1,St||(St=dt),J--,he=dt-1,ut.push(he)}H===Xe&&(ut[0]+=2);const Pt=St-Xe;return ut[0]-=Pt,ut}e.fuzzyScore=Qe;function He(V,se,fe,Ae,xe,$e){let ve=V-1,Xe=se-1;for(;ve>=fe&&Xe>=Ae;)xe[ve]===$e[Xe]&&(z[ve]=Xe,ve--),Xe--}function qe(V,se,fe,Ae,xe,$e,ve,Xe,H,J,he){if(se[fe]!==$e[ve])return Number.MIN_SAFE_INTEGER;let Le=1,Ve=!1;return ve===fe-Ae?Le=V[fe]===xe[ve]?7:5:Ee(ve,xe,$e)&&(ve===0||!Ee(ve-1,xe,$e))?(Le=V[fe]===xe[ve]?7:5,Ve=!0):ue($e,ve)&&(ve===0||!ue($e,ve-1))?Le=5:(ue($e,ve-1)||oe($e,ve-1))&&(Le=5,Ve=!0),Le>1&&fe===Ae&&(he[0]=!0),Ve||(Ve=Ee(ve,xe,$e)||ue($e,ve-1)||oe($e,ve-1)),fe===Ae?ve>H&&(Le-=Ve?3:5):J?Le+=Ve?2:0:Le+=Ve?0:1,ve+1===Xe&&(Le-=Ve?3:5),Le}function B(V,se,fe,Ae,xe,$e,ve){return ee(V,se,fe,Ae,xe,$e,!0,ve)}e.fuzzyScoreGracefulAggressive=B;function K(V,se,fe,Ae,xe,$e,ve){return ee(V,se,fe,Ae,xe,$e,!1,ve)}e.fuzzyScoreGraceful=K;function ee(V,se,fe,Ae,xe,$e,ve,Xe){let H=Qe(V,se,fe,Ae,xe,$e,Xe);if(H&&!ve)return H;if(V.length>=3){const J=Math.min(7,V.length-1);for(let he=fe+1;he<J;he++){const Le=ae(V,he);if(Le){const Ve=Qe(Le,Le.toLowerCase(),fe,Ae,xe,$e,Xe);Ve&&(Ve[0]-=3,(!H||Ve[0]>H[0])&&(H=Ve))}}}return H}function ae(V,se){if(se+1>=V.length)return;const fe=V[se],Ae=V[se+1];if(fe!==Ae)return V.slice(0,se)+Ae+fe+V.slice(se+2)}}),define(we[106],be([0,1,34,105,9]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${T.source}`,"g");function P(u){return u.replace(A,(p,k)=>k?p:`\\${p}`)}e.escapeIcons=P;const S=new RegExp(`\\\\${T.source}`,"g");function I(u){return u.replace(S,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=I;const t=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function y(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(t,(p,k,w,l)=>w?p:k||l||"")}e.stripIcons=y;function n(u){const p=u.indexOf(e.iconStartMarker);return p===-1?{text:u}:d(u,p)}e.parseLabelWithIcons=n;function d(u,p){const k=[];let w="";function l(m){if(m){w+=m;for(const g of m)k.push(i)}}let v=-1,D="",i=0,s,a,o=p;const _=u.length;for(l(u.substr(0,p));o<_;)s=u[o],a=u[o+1],s===e.iconStartMarker[0]&&a===e.iconStartMarker[1]?(v=o,l(D),D=e.iconStartMarker,o++):s===")"&&v!==-1?(i+=o-v+1,v=-1,D=""):v!==-1?/^[a-z0-9\-]$/i.test(s)?D+=s:(l(D),v=-1,D=""):l(s),o++;return l(D),{text:w,iconOffsets:k}}function r(u,p,k=!1){const{text:w,iconOffsets:l}=p;if(!l||l.length===0)return(0,M.matchesFuzzy)(u,w,k);const v=(0,E.ltrim)(w," "),D=w.length-v.length,i=(0,M.matchesFuzzy)(u,v,k);if(i)for(const s of i){const a=l[s.start+D]+D;s.start+=a,s.end+=a}return i}e.matchesFuzzyIconAware=r}),define(we[76],be([0,1,15,106]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class T{constructor(d="",r=!1){if(this.value=d,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1)}appendText(d,r=0){return this.value+=I(this.supportThemeIcons?(0,M.escapeIcons)(d):d).replace(/([ \t]+)/g,(u,p)=>"&nbsp;".repeat(p.length)).replace(/^>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,r){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=r,this.value+="\n```\n",this}}e.MarkdownString=T;function A(n){return P(n)?!n.value:Array.isArray(n)?n.every(A):!0}e.isEmptyMarkdownString=A;function P(n){return n instanceof T?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function S(n,d){return n===d?!0:!n||!d?!1:n.value===d.value&&n.isTrusted===d.isTrusted&&n.supportThemeIcons===d.supportThemeIcons}e.markdownStringEqual=S;function I(n){return n.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function y(n){const d=[],r=n.split("|").map(p=>p.trim());n=r[0];const u=r[1];if(u){const p=/height=(\d+)/.exec(u),k=/width=(\d+)/.exec(u),w=p?p[1]:"",l=k?k[1]:"",v=isFinite(parseInt(l)),D=isFinite(parseInt(w));v&&d.push(`width="${l}"`),D&&d.push(`height="${w}"`)}return{href:n,dimensions:d}}e.parseHrefAndDimensions=y}),define(we[53],be([0,1,23,9,2]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(t){return JSON.stringify(t,S)}e.stringify=T;function A(t){let y=JSON.parse(t);return y=I(y),y}e.parse=A;var P;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function S(t,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,M.regExpFlags)(y)}:y}function I(t,y=0){if(!t||y>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return E.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof c.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=I(t[n],y+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=I(t[n],y+1))}return t}e.revive=I}),define(we[11],be([0,1,26,2]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(E=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,I,t){this._hosts[S]=I,this._ports[S]=t}setConnectionToken(S,I){this._connectionTokens[S]=I}rewrite(S){if(this._delegate)return this._delegate(S);const I=S.authority;let t=this._hosts[I];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const y=this._ports[I],n=this._connectionTokens[I];let d=`path=${encodeURIComponent(S.path)}`;return typeof n=="string"&&(d+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:c.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${t}:${y}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new T;class A{asBrowserUri(S,I){const t=this.toUri(S,I);return t.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===E.file&&(c.isNative||typeof c.globals.importScripts=="function"&&c.globals.origin===`${E.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?t.with({scheme:E.vscodeFileResource,authority:t.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(S,I){const t=this.toUri(S,I);return t.scheme===E.vscodeFileResource?t.with({scheme:E.file,authority:t.authority!==A.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(S,I){return M.URI.isUri(S)?S:M.URI.parse(I.toUrl(S))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(we[24],be([0,1,40,11,17,26,9,2]),function(re,e,c,M,E,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(d){return(0,P.uriToFsPath)(d,!0)}e.originalFSPath=S;class I{constructor(r){this._ignorePathCasing=r}compare(r,u,p=!1){return r===u?0:(0,A.compare)(this.getComparisonKey(r,p),this.getComparisonKey(u,p))}isEqual(r,u,p=!1){return r===u?!0:!r||!u?!1:this.getComparisonKey(r,p)===this.getComparisonKey(u,p)}getComparisonKey(r,u=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,u,p=!1){if(r.scheme===u.scheme){if(r.scheme===M.Schemas.file)return c.isEqualOrParent(S(r),S(u),this._ignorePathCasing(r))&&r.query===u.query&&(p||r.fragment===u.fragment);if((0,e.isEqualAuthority)(r.authority,u.authority))return c.isEqualOrParent(r.path,u.path,this._ignorePathCasing(r),"/")&&r.query===u.query&&(p||r.fragment===u.fragment)}return!1}joinPath(r,...u){return P.URI.joinPath(r,...u)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return E.posix.basename(r.path)}extname(r){return E.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let u;return r.scheme===M.Schemas.file?u=P.URI.file(E.dirname(S(r))).path:(u=E.posix.dirname(r.path),r.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),u="/")),r.with({path:u})}normalizePath(r){if(!r.path.length)return r;let u;return r.scheme===M.Schemas.file?u=P.URI.file(E.normalize(S(r))).path:u=E.posix.normalize(r.path),r.with({path:u})}relativePath(r,u){if(r.scheme!==u.scheme||!(0,e.isEqualAuthority)(r.authority,u.authority))return;if(r.scheme===M.Schemas.file){const w=E.relative(S(r),S(u));return T.isWindows?c.toSlashes(w):w}let p=r.path||"/",k=u.path||"/";if(this._ignorePathCasing(r)){let w=0;for(const l=Math.min(p.length,k.length);w<l&&!(p.charCodeAt(w)!==k.charCodeAt(w)&&p.charAt(w).toLowerCase()!==k.charAt(w).toLowerCase());w++);p=k.substr(0,w)+p.substr(w)}return E.posix.relative(p,k)}resolvePath(r,u){if(r.scheme===M.Schemas.file){const p=P.URI.file(E.resolve(S(r),u));return r.with({authority:p.authority,path:p.path})}return u=c.toPosixPath(u),r.with({path:E.posix.resolve(r.path,u)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,u){return r===u||(0,A.equalsIgnoreCase)(r,u)}hasTrailingPathSeparator(r,u=E.sep){if(r.scheme===M.Schemas.file){const p=S(r);return p.length>c.getRoot(p).length&&p[p.length-1]===u}else{const p=r.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,u=E.sep){return(0,e.hasTrailingPathSeparator)(r,u)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,u=E.sep){let p=!1;if(r.scheme===M.Schemas.file){const k=S(r);p=k!==void 0&&k.length===c.getRoot(k).length&&k[k.length-1]===u}else{u="/";const k=r.path;p=k.length===1&&k.charCodeAt(k.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(r,u)?r.with({path:r.path+"/"}):r}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(d=>d.scheme===M.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new I(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(d,r){const u=[];for(let p=0;p<d.length;p++){const k=r(d[p]);d.some((w,l)=>l===p?!1:(0,e.isEqualOrParent)(k,r(w)))||u.push(d[p])}return u}e.distinctParents=t;var y;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function r(u){const p=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(l=>{const[v,D]=l.split(":");v&&D&&p.set(v,D)});const w=u.path.substring(0,u.path.indexOf(";"));return w&&p.set(d.META_DATA_MIME,w),p}d.parseMetaData=r})(y=e.DataUri||(e.DataUri={}));function n(d,r,u){if(r){let p=d.path;return p&&p[0]!==E.posix.sep&&(p=E.posix.sep+p),d.with({scheme:u,authority:r,path:p})}return d.with({scheme:u})}e.toLocalResource=n}),define(we[13],be([0,1,21,15,3,7,24]),function(re,e,c,M,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(z){return!!z&&typeof z.then=="function"}e.isThenable=P;function S(z){const N=new c.CancellationTokenSource,W=z(N.token),j=new Promise((Y,de)=>{const G=N.token.onCancellationRequested(()=>{G.dispose(),N.dispose(),de((0,M.canceled)())});Promise.resolve(W).then(ue=>{G.dispose(),N.dispose(),Y(ue)},ue=>{G.dispose(),N.dispose(),de(ue)})});return new class{cancel(){N.cancel()}then(Y,de){return j.then(Y,de)}catch(Y){return this.then(void 0,Y)}finally(Y){return j.finally(Y)}}}e.createCancelablePromise=S;function I(z,N,W){return Promise.race([z,new Promise(j=>N.onCancellationRequested(()=>j(W)))])}e.raceCancellation=I;async function t(z){let N=-1;const W=z.map((Y,de)=>Y.then(G=>(N=de,G))),j=await Promise.race(W);return z.forEach((Y,de)=>{de!==N&&Y.cancel()}),j}e.raceCancellablePromises=t;function y(z,N,W){let j;const Y=setTimeout(()=>{j?.(void 0),W?.()},N);return Promise.race([z.finally(()=>clearTimeout(Y)),new Promise(de=>j=de)])}e.raceTimeout=y;function n(z){return new Promise((N,W)=>{const j=z();P(j)?j.then(N,W):N(j)})}e.asPromise=n;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(W,W).then(j)})}return new Promise((W,j)=>{this.queuedPromise.then(W,j)})}return this.activePromise=N(),new Promise((W,j)=>{this.activePromise.then(Y=>{this.activePromise=null,W(Y)},Y=>{this.activePromise=null,j(Y)})})}}e.Throttler=d;class r{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=r;class u{constructor(){this.promiseMap=new Map}queue(N,W){const Y=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(N)===Y&&this.promiseMap.delete(N)});return this.promiseMap.set(N,Y),Y}}e.SequencerByKey=u;class p{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,W=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,Y)=>{this.doResolve=j,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},W),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=p;class k{constructor(N){this.delayer=new p(N),this.throttler=new d}trigger(N,W){return this.delayer.trigger(()=>this.throttler.queue(N),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=k;class w{constructor(){this._isOpen=!1,this._promise=new Promise((N,W)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=w;class l extends w{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function v(z,N){return N?new Promise((W,j)=>{const Y=setTimeout(()=>{de.dispose(),W()},z),de=N.onCancellationRequested(()=>{clearTimeout(Y),de.dispose(),j((0,M.canceled)())})}):S(W=>v(z,W))}e.timeout=v;function D(z,N=0){const W=setTimeout(z,N);return(0,T.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=D;function i(z){const N=[];let W=0;const j=z.length;function Y(){return W<j?z[W++]():null}function de(G){G!=null&&N.push(G);const ue=Y();return ue?ue.then(de):Promise.resolve(N)}return Promise.resolve(null).then(de)}e.sequence=i;function s(z,N=j=>!!j,W=null){let j=0;const Y=z.length,de=()=>{if(j>=Y)return Promise.resolve(W);const G=z[j++];return Promise.resolve(G()).then(oe=>N(oe)?Promise.resolve(oe):de())};return de()}e.first=s;function a(z,N=j=>!!j,W=null){if(z.length===0)return Promise.resolve(W);let j=z.length;const Y=()=>{j=-1;for(const de of z)de.cancel?.()};return new Promise((de,G)=>{for(const ue of z)ue.then(oe=>{--j>=0&&N(oe)?(Y(),de(oe)):j===0&&de(W)}).catch(oe=>{--j>=0&&(Y(),G(oe))})})}e.firstParallel=a;class o{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((W,j)=>{this.outstandingPromises.push({factory:N,c:W,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const W=N.factory();W.then(N.c,N.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class _ extends o{constructor(){super(1)}}e.Queue=_;class m{constructor(){this.queues=new Map}queueFor(N,W=A.extUri){const j=W.getComparisonKey(N);let Y=this.queues.get(j);return Y||(Y=new _,E.Event.once(Y.onFinished)(()=>{Y?.dispose(),this.queues.delete(j)}),this.queues.set(j,Y)),Y}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=m;class g{constructor(N,W){this._token=-1,typeof N=="function"&&typeof W=="number"&&this.setIfNotSet(N,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},W)}setIfNotSet(N,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},W))}}e.TimeoutTimer=g;class C{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,W){this.cancel(),this._token=setInterval(()=>{N()},W)}}e.IntervalTimer=C;class R{constructor(N,W){this.timeoutToken=-1,this.runner=N,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class h extends R{constructor(N,W){super(N,W);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=h;class b extends T.Disposable{constructor(N,W,j,Y){super();this.maxWorkChunkSize=N,this.maxPendingWork=W,this.throttleDelay=j,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.maxPendingWork)return!1}else if(this.pending+N.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...N),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=b,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const z=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const W=setTimeout(()=>N(z));let j=!1;return{dispose(){j||(j=!0,clearTimeout(W))}}}}else e.runWhenIdle=(z,N)=>{const W=requestIdleCallback(z,typeof N=="number"?{timeout:N}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(W))}}}}();class f{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=f;async function F(z,N,W){let j;for(let Y=0;Y<W;Y++)try{return await z()}catch(de){j=de,await v(N)}throw j}e.retry=F;class O{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(N,W,j){return this._pending={taskId:N,cancel:()=>j?.(),promise:W},W.then(()=>this.donePending(N),()=>this.donePending(N)),W}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let W,j;const Y=new Promise((de,G)=>{W=de,j=G});this._next={run:N,promise:Y,promiseResolve:W,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=O;class q{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class Q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,W)=>{this.completeCallback=N,this.errorCallback=W})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(W=>{this.completeCallback(N),this.resolved=!0,W()})}error(N){return new Promise(W=>{this.errorCallback(N),this.rejected=!0,W()})}cancel(){new Promise(N=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,N()})}}e.DeferredPromise=Q;var $;(function(z){async function N(W){let j;const Y=await Promise.all(W.map(de=>de.then(G=>G,G=>{j||(j=G)})));if(typeof j!="undefined")throw j;return Y}z.settled=N})($=e.Promises||(e.Promises={}))}),define(we[107],be([0,1,13,17]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new c.IdleValue(()=>{const R=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:R,collatorIsNumeric:R.resolvedOptions().numeric}}),T=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(R,h,b=!1){const f=R||"",F=h||"",O=E.value.collator.compare(f,F);return E.value.collatorIsNumeric&&O===0&&f!==F?f<F?-1:1:O}e.compareFileNames=P;function S(R,h){const b=T.value.collator;return R=R||"",h=h||"",D(b,R,h)}e.compareFileNamesDefault=S;function I(R,h){const b=T.value.collator;return R=R||"",h=h||"",o(R,h)||D(b,R,h)}e.compareFileNamesUpper=I;function t(R,h){const b=T.value.collator;return R=R||"",h=h||"",a(R,h)||D(b,R,h)}e.compareFileNamesLower=t;function y(R,h){return R=R||"",h=h||"",R===h?0:R<h?-1:1}e.compareFileNamesUnicode=y;function n(R,h,b=!1){b||(R=R&&R.toLowerCase(),h=h&&h.toLowerCase());const[f,F]=l(R),[O,q]=l(h);return f!==O?f<O?-1:1:F===q?0:F<q?-1:1}e.noIntlCompareFileNames=n;function d(R,h){const[b,f]=l(R),[F,O]=l(h);let q=E.value.collator.compare(f,O);if(q===0){if(E.value.collatorIsNumeric&&f!==O)return f<O?-1:1;if(q=E.value.collator.compare(b,F),E.value.collatorIsNumeric&&q===0&&b!==F)return b<F?-1:1}return q}e.compareFileExtensions=d;function r(R,h){R=R||"",h=h||"";const b=v(R),f=v(h),F=T.value.collator,O=A.value.collator;return D(O,b,f)||D(F,R,h)}e.compareFileExtensionsDefault=r;function u(R,h){R=R||"",h=h||"";const b=v(R),f=v(h),F=T.value.collator,O=A.value.collator;return D(O,b,f)||o(R,h)||D(F,R,h)}e.compareFileExtensionsUpper=u;function p(R,h){R=R||"",h=h||"";const b=v(R),f=v(h),F=T.value.collator,O=A.value.collator;return D(O,b,f)||a(R,h)||D(F,R,h)}e.compareFileExtensionsLower=p;function k(R,h){R=R||"",h=h||"";const b=v(R).toLowerCase(),f=v(h).toLowerCase();return b!==f?b<f?-1:1:R!==h?R<h?-1:1:0}e.compareFileExtensionsUnicode=k;const w=/^(.*?)(\.([^.]*))?$/;function l(R,h=!1){const b=R?w.exec(R):[];let f=[b&&b[1]||"",b&&b[3]||""];return h&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function v(R){const h=R?w.exec(R):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function D(R,h,b){let f=R.compare(h,b);return f!==0?f:h.length!==b.length?h.length<b.length?-1:1:0}function i(R){const h=R.charAt(0);return h.toLocaleUpperCase()!==h}function s(R){const h=R.charAt(0);return h.toLocaleLowerCase()!==h}function a(R,h){return i(R)&&s(h)?-1:s(R)&&i(h)?1:0}function o(R,h){return s(R)&&i(h)?-1:i(R)&&s(h)?1:0}function _(R,h,b=!1){return b||(R=R&&R.toLowerCase(),h=h&&h.toLowerCase()),R===h?0:R<h?-1:1}function m(R,h,b=!1){const f=R.split(M.sep),F=h.split(M.sep),O=f.length-1,q=F.length-1;let Q,$;for(let z=0;;z++){if(Q=O===z,$=q===z,Q&&$)return P(f[z],F[z],b);if(Q)return-1;if($)return 1;const N=_(f[z],F[z],b);if(N!==0)return N}}e.comparePaths=m;function g(R,h,b){const f=R.toLowerCase(),F=h.toLowerCase(),O=C(R,h,b);if(O)return O;const q=f.endsWith(b),Q=F.endsWith(b);if(q!==Q)return q?-1:1;const $=P(f,F);return $!==0?$:f.localeCompare(F)}e.compareAnything=g;function C(R,h,b){const f=R.toLowerCase(),F=h.toLowerCase(),O=f.startsWith(b),q=F.startsWith(b);if(O!==q)return O?-1:1;if(O&&q){if(f.length<F.length)return-1;if(f.length>F.length)return 1}return 0}e.compareByPrefix=C}),define(we[27],be([0,1,13,40,20,17,9]),function(re,e,c,M,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const S="**",I="/",t="[/\\\\]",y="[^/\\\\]",n=/\//g;function d(Y){switch(Y){case 0:return"";case 1:return`${y}*?`;default:return`(?:${t}|${y}+${t}|${t}${y}+)*?`}}function r(Y,de){if(!Y)return[];const G=[];let ue=!1,oe=!1,Ee="";for(const Te of Y){switch(Te){case de:if(!ue&&!oe){G.push(Ee),Ee="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}Ee+=Te}return Ee&&G.push(Ee),G}e.splitGlobAware=r;function u(Y){if(!Y)return"";let de="";const G=r(Y,I);if(G.every(ue=>ue===S))de=".*";else{let ue=!1;G.forEach((oe,Ee)=>{if(oe===S){ue||(de+=d(2),ue=!0);return}let Te=!1,Re="",Ne=!1,Qe="";for(const He of oe){if(He!=="}"&&Te){Re+=He;continue}if(Ne&&(He!=="]"||!Qe)){let qe;He==="-"?qe=He:(He==="^"||He==="!")&&!Qe?qe="^":He===I?qe="":qe=A.escapeRegExpCharacters(He),Qe+=qe;continue}switch(He){case"{":Te=!0;continue;case"[":Ne=!0;continue;case"}":de+=`(?:${r(Re,",").map(K=>u(K)).join("|")})`,Te=!1,Re="";break;case"]":de+="["+Qe+"]",Ne=!1,Qe="";break;case"?":de+=y;continue;case"*":de+=d(1);continue;default:de+=A.escapeRegExpCharacters(He)}}Ee<G.length-1&&(G[Ee+1]!==S||Ee+2<G.length)&&(de+=t),ue=!1})}return de}const p=/^\*\*\/\*\.[\w\.-]+$/,k=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,v=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new E.LRUCache(1e4),s=function(){return!1},a=function(){return null};function o(Y,de){if(!Y)return a;let G;typeof Y!="string"?G=Y.pattern:G=Y,G=G.trim();const ue=`${G}_${!!de.trimForExclusions}`;let oe=i.get(ue);if(oe)return _(oe,Y);let Ee;if(p.test(G)){const Te=G.substr(4);oe=function(Re,Ne){return typeof Re=="string"&&Re.endsWith(Te)?G:null}}else(Ee=k.exec(m(G,de)))?oe=g(Ee[1],G):(de.trimForExclusions?l:w).test(G)?oe=C(G,de):(Ee=v.exec(m(G,de)))?oe=R(Ee[1].substr(1),G,!0):(Ee=D.exec(m(G,de)))?oe=R(Ee[1],G,!1):oe=h(G);return i.set(ue,oe),_(oe,Y)}function _(Y,de){return typeof de=="string"?Y:function(G,ue){return M.isEqualOrParent(G,de.base)?Y(T.relative(de.base,G),ue):null}}function m(Y,de){return de.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function g(Y,de){const G=`/${Y}`,ue=`\\${Y}`,oe=function(Te,Re){return typeof Te!="string"?null:Re?Re===Y?de:null:Te===Y||Te.endsWith(G)||Te.endsWith(ue)?de:null},Ee=[Y];return oe.basenames=Ee,oe.patterns=[de],oe.allBasenames=Ee,oe}function C(Y,de){const G=j(Y.slice(1,-1).split(",").map(Re=>o(Re,de)).filter(Re=>Re!==a),Y),ue=G.length;if(!ue)return a;if(ue===1)return G[0];const oe=function(Re,Ne){for(let Qe=0,He=G.length;Qe<He;Qe++)if(G[Qe](Re,Ne))return Y;return null},Ee=G.find(Re=>!!Re.allBasenames);Ee&&(oe.allBasenames=Ee.allBasenames);const Te=G.reduce((Re,Ne)=>Ne.allPaths?Re.concat(Ne.allPaths):Re,[]);return Te.length&&(oe.allPaths=Te),oe}function R(Y,de,G){const ue=T.sep===T.posix.sep,oe=ue?Y:Y.replace(n,T.sep),Ee=T.sep+oe,Te=T.posix.sep+Y,Re=G?function(Ne,Qe){return typeof Ne=="string"&&(Ne===oe||Ne.endsWith(Ee)||!ue&&(Ne===Y||Ne.endsWith(Te)))?de:null}:function(Ne,Qe){return typeof Ne=="string"&&(Ne===oe||!ue&&Ne===Y)?de:null};return Re.allPaths=[(G?"*/":"./")+Y],Re}function h(Y){try{const de=new RegExp(`^${u(Y)}$`);return function(G){return de.lastIndex=0,typeof G=="string"&&de.test(G)?Y:null}}catch(de){return a}}function b(Y,de,G){return!Y||typeof de!="string"?!1:f(Y)(de,void 0,G)}e.match=b;function f(Y,de={}){if(!Y)return s;if(typeof Y=="string"||Q(Y)){const G=o(Y,de);if(G===a)return s;const ue=function(oe,Ee){return!!G(oe,Ee)};return G.allBasenames&&(ue.allBasenames=G.allBasenames),G.allPaths&&(ue.allPaths=G.allPaths),ue}return N(Y,de)}e.parse=f;function F(Y){if(!Y)return;let de;return G=>(de||(de=(Y()||Promise.resolve([])).then(ue=>ue?q(ue):{})),de.then(ue=>!!ue[G]))}e.hasSiblingPromiseFn=F;function O(Y){if(!Y)return;let de;return G=>{if(!de){const ue=Y();de=ue?q(ue):{}}return!!de[G]}}e.hasSiblingFn=O;function q(Y){const de={};for(const G of Y)de[G]=!0;return de}function Q(Y){const de=Y;return de&&typeof de.base=="string"&&typeof de.pattern=="string"}e.isRelativePattern=Q;function $(Y){return Y.allBasenames||[]}e.getBasenameTerms=$;function z(Y){return Y.allPaths||[]}e.getPathTerms=z;function N(Y,de){const G=j(Object.getOwnPropertyNames(Y).map(Re=>W(Re,Y[Re],de)).filter(Re=>Re!==a)),ue=G.length;if(!ue)return a;if(!G.some(Re=>!!Re.requiresSiblings)){if(ue===1)return G[0];const Re=function(He,qe){for(let B=0,K=G.length;B<K;B++){const ee=G[B](He,qe);if(ee)return ee}return null},Ne=G.find(He=>!!He.allBasenames);Ne&&(Re.allBasenames=Ne.allBasenames);const Qe=G.reduce((He,qe)=>qe.allPaths?He.concat(qe.allPaths):He,[]);return Qe.length&&(Re.allPaths=Qe),Re}const oe=function(Re,Ne,Qe){let He;for(let qe=0,B=G.length;qe<B;qe++){const K=G[qe];K.requiresSiblings&&Qe&&(Ne||(Ne=T.basename(Re)),He||(He=Ne.substr(0,Ne.length-T.extname(Re).length)));const ee=K(Re,Ne,He,Qe);if(ee)return ee}return null},Ee=G.find(Re=>!!Re.allBasenames);Ee&&(oe.allBasenames=Ee.allBasenames);const Te=G.reduce((Re,Ne)=>Ne.allPaths?Re.concat(Ne.allPaths):Re,[]);return Te.length&&(oe.allPaths=Te),oe}function W(Y,de,G){if(de===!1)return a;const ue=o(Y,G);if(ue===a)return a;if(typeof de=="boolean")return ue;if(de){const oe=de.when;if(typeof oe=="string"){const Ee=(Te,Re,Ne,Qe)=>{if(!Qe||!ue(Te,Re))return null;const He=oe.replace("$(basename)",Ne),qe=Qe(He);return(0,c.isThenable)(qe)?qe.then(B=>B?Y:null):qe?Y:null};return Ee.requiresSiblings=!0,Ee}}return ue}function j(Y,de){const G=Y.filter(Re=>!!Re.basenames);if(G.length<2)return Y;const ue=G.reduce((Re,Ne)=>{const Qe=Ne.basenames;return Qe?Re.concat(Qe):Re},[]);let oe;if(de){oe=[];for(let Re=0,Ne=ue.length;Re<Ne;Re++)oe.push(de)}else oe=G.reduce((Re,Ne)=>{const Qe=Ne.patterns;return Qe?Re.concat(Qe):Re},[]);const Ee=function(Re,Ne){if(typeof Re!="string")return null;if(!Ne){let He;for(He=Re.length;He>0;He--){const qe=Re.charCodeAt(He-1);if(qe===47||qe===92)break}Ne=Re.substr(He)}const Qe=ue.indexOf(Ne);return Qe!==-1?oe[Qe]:null};Ee.basenames=ue,Ee.patterns=oe,Ee.allBasenames=ue;const Te=Y.filter(Re=>!Re.basenames);return Te.push(Ee),Te}}),define(we[77],be([0,1,40,11,17,26,24,9,2]),function(re,e,c,M,E,T,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function I(o,_,m){if(typeof o=="string"&&(o=S.URI.file(o)),m){const C=m.getWorkspaceFolder(o);if(C){const R=m.getWorkspace().folders.length>1;let h;if((0,A.isEqual)(C.uri,o)?h="":h=(0,A.relativePath)(C.uri,o),R){const b=C.name?C.name:(0,A.basename)(C.uri);h=h?b+" \u2022 "+h:b}return h}}if(o.scheme!==M.Schemas.file&&o.scheme!==M.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,c.hasDriveLetter)(o.fsPath))return(0,E.normalize)(y(o.fsPath));let g=(0,E.normalize)(o.fsPath);return!T.isWindows&&_?.userHome&&(g=d(g,_.userHome.fsPath)),g}e.getPathLabel=I;function t(o){if(!o)return;typeof o=="string"&&(o=S.URI.file(o));const _=(0,A.basename)(o)||(o.scheme===M.Schemas.file?o.fsPath:o.path);return T.isWindows&&(0,c.isRootOrDriveLetter)(_)?y(_):_}e.getBaseLabel=t;function y(o){return(0,c.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=y;let n=Object.create(null);function d(o,_){if(T.isWindows||!o||!_)return o;let m=n.original===_?n.normalized:void 0;return m||(m=`${(0,P.rtrim)(_,E.posix.sep)}${E.posix.sep}`,n={original:_,normalized:m}),(T.isLinux?o.startsWith(m):(0,P.startsWithIgnoreCase)(o,m))&&(o=`~/${o.substr(m.length)}`),o}e.tildify=d;function r(o,_){return o.replace(/^~($|\/|\\)/,`${_}$1`)}e.untildify=r;const u="\u2026",p="\\\\",k="~";function w(o,_=E.sep){const m=new Array(o.length);let g=!1;for(let C=0;C<o.length;C++){let R=o[C];if(R===""){m[C]=`.${_}`;continue}if(!R){m[C]=R;continue}g=!0;let h="";R.indexOf(p)===0?(h=R.substr(0,R.indexOf(p)+p.length),R=R.substr(R.indexOf(p)+p.length)):R.indexOf(_)===0?(h=R.substr(0,R.indexOf(_)+_.length),R=R.substr(R.indexOf(_)+_.length)):R.indexOf(k)===0&&(h=R.substr(0,R.indexOf(k)+k.length),R=R.substr(R.indexOf(k)+k.length));const b=R.split(_);for(let f=1;g&&f<=b.length;f++)for(let F=b.length-f;g&&F>=0;F--){g=!1;let O=b.slice(F,F+f).join(_);for(let q=0;!g&&q<o.length;q++)if(q!==C&&o[q]&&o[q].indexOf(O)>-1){const Q=F+f===b.length,$=F>0&&o[q].indexOf(_)>-1?_+O:O,z=o[q].endsWith($);g=!Q||z}if(!g){let q="";(b[0].endsWith(":")||h!=="")&&(F===1&&(F=0,f++,O=b[0]+_+O),F>0&&(q=b[0]+_),q=h+q),F>0&&(q=q+u+_),q=q+O,F+f<b.length&&(q=q+_+u),m[C]=q}}g&&(m[C]=R)}return m}e.shorten=w;var l;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function v(o,_=Object.create(null)){const m=[];let g=!1,C="";for(const R of o)if(R==="$"||g&&R==="{")C&&m.push({value:C,type:l.TEXT}),C="",g=!0;else if(R==="}"&&g){const h=_[C];if(typeof h=="string")h.length&&m.push({value:h,type:l.VARIABLE});else if(h){const b=m[m.length-1];(!b||b.type!==l.SEPARATOR)&&m.push({value:h.label,type:l.SEPARATOR})}C="",g=!1}else C+=R;return C&&!g&&m.push({value:C,type:l.TEXT}),m.filter((R,h)=>{if(R.type===l.SEPARATOR){const b=m[h-1],f=m[h+1];return[b,f].every(F=>F&&(F.type===l.VARIABLE||F.type===l.TEXT)&&F.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=v;function D(o,_){return T.isMacintosh||_?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):o.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=D;function i(o,_){return T.isMacintosh||_?o.replace(/\(&&\w\)|&&/g,""):T.isWindows?o.replace(/&&|&/g,m=>m==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function s(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=s;function a(o){const _=o.indexOf("/")!==-1?E.posix:E.win32,m=_.basename(o),g=_.dirname(o);return m.length?{name:m,parentPath:g}:{name:g,parentPath:""}}e.splitName=a}),define(we[78],be([0,1,27,11,17,24,9]),function(re,e,c,M,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(o){o.text="text/plain",o.binary="application/octet-stream",o.unknown="application/unknown",o.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let S=[],I=[],t=[];function y(o,_=!1){const m=n(o);S.push(m),m.userConfigured?t.push(m):I.push(m),_&&!m.userConfigured&&S.forEach(g=>{g.mime===m.mime||g.userConfigured||(m.extension&&g.extension===m.extension&&console.warn(`Overwriting extension <<${m.extension}>> to now point to mime <<${m.mime}>>`),m.filename&&g.filename===m.filename&&console.warn(`Overwriting filename <<${m.filename}>> to now point to mime <<${m.mime}>>`),m.filepattern&&g.filepattern===m.filepattern&&console.warn(`Overwriting filepattern <<${m.filepattern}>> to now point to mime <<${m.mime}>>`),m.firstline&&g.firstline===m.firstline&&console.warn(`Overwriting firstline <<${m.firstline}>> to now point to mime <<${m.mime}>>`))})}e.registerTextMime=y;function n(o){return{id:o.id,mime:o.mime,filename:o.filename,extension:o.extension,filepattern:o.filepattern,firstline:o.firstline,userConfigured:o.userConfigured,filenameLowercase:o.filename?o.filename.toLowerCase():void 0,extensionLowercase:o.extension?o.extension.toLowerCase():void 0,filepatternLowercase:o.filepattern?(0,c.parse)(o.filepattern.toLowerCase()):void 0,filepatternOnPath:o.filepattern?o.filepattern.indexOf(E.posix.sep)>=0:!1}}function d(o){o?(S=S.filter(_=>!_.userConfigured),t=[]):(S=[],I=[],t=[])}e.clearTextMimes=d;function r(o,_){let m;if(o)switch(o.scheme){case M.Schemas.file:m=o.fsPath;break;case M.Schemas.data:m=T.DataUri.parseMetaData(o).get(T.DataUri.META_DATA_LABEL);break;default:m=o.path}if(!m)return[P.unknown];m=m.toLowerCase();const g=(0,E.basename)(m),C=u(m,g,t);if(C)return[C,P.text];const R=u(m,g,I);if(R)return[R,P.text];if(_){const h=p(_);if(h)return[h,P.text]}return[P.unknown]}e.guessMimeTypes=r;function u(o,_,m){let g=null,C=null,R=null;for(let h=m.length-1;h>=0;h--){const b=m[h];if(_===b.filenameLowercase){g=b;break}if(b.filepattern&&(!C||b.filepattern.length>C.filepattern.length)){const f=b.filepatternOnPath?o:_;b.filepatternLowercase?.(f)&&(C=b)}b.extension&&(!R||b.extension.length>R.extension.length)&&_.endsWith(b.extensionLowercase)&&(R=b)}return g?g.mime:C?C.mime:R?R.mime:null}function p(o){if((0,A.startsWithUTF8BOM)(o)&&(o=o.substr(1)),o.length>0)for(let _=S.length-1;_>=0;_--){const m=S[_];if(!m.firstline)continue;const g=o.match(m.firstline);if(g&&g.length>0)return m.mime}return null}function k(o){return o?typeof o=="string"?o===P.binary||o===P.text||o===P.unknown:o.length===1&&k(o[0]):!0}e.isUnspecific=k;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function v(o){const _=(0,E.extname)(o),m=w[_.toLowerCase()];return m!==void 0?m:D(o)}e.getMediaOrTextMime=v;function D(o){const _=(0,E.extname)(o);return l[_.toLowerCase()]}e.getMediaMime=D;function i(o){for(const _ in l)if(l[_]===o)return _}e.getExtensionForMimeType=i;const s=/^(.+)\/(.+?)(;.+)?$/;function a(o,_){const m=s.exec(o);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:_?void 0:o}e.normalizeMimeType=a}),define(we[108],be([0,1,2]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class E{constructor(y){this._uriTransformer=y}transformIncoming(y){const n=this._uriTransformer.transformIncoming(y);return n===y?y:M(c.URI.from(n))}transformOutgoing(y){const n=this._uriTransformer.transformOutgoing(y);return n===y?y:M(c.URI.from(n))}transformOutgoingURI(y){const n=this._uriTransformer.transformOutgoing(y);return n===y?y:c.URI.from(n)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function T(t,y,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof c.URI)return y.transformOutgoing(t);for(let d in t)if(Object.hasOwnProperty.call(t,d)){const r=T(t[d],y,n+1);r!==null&&(t[d]=r)}}return null}function A(t,y){const n=T(t,y,0);return n===null?t:n}e.transformOutgoingURIs=A;function P(t,y,n,d){if(!t||d>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?c.URI.revive(y.transformIncoming(t)):y.transformIncoming(t);for(let r in t)if(Object.hasOwnProperty.call(t,r)){const u=P(t[r],y,n,d+1);u!==null&&(t[r]=u)}}return null}function S(t,y){const n=P(t,y,!1,0);return n===null?t:n}e.transformIncomingURIs=S;function I(t,y){const n=P(t,y,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=I}),define(we[36],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(S){return c.test(S)}e.isUUID=M;const E=new Uint8Array(16),T=[];for(let S=0;S<256;S++)T.push(S.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(S){for(let I=0;I<S.length;I++)S[I]=Math.floor(Math.random()*256);return S};function P(){A(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let S=0,I="";return I+=T[E[S++]],I+=T[E[S++]],I+=T[E[S++]],I+=T[E[S++]],I+="-",I+=T[E[S++]],I+=T[E[S++]],I+="-",I+=T[E[S++]],I+=T[E[S++]],I+="-",I+=T[E[S++]],I+=T[E[S++]],I+="-",I+=T[E[S++]],I+=T[E[S++]],I+=T[E[S++]],I+=T[E[S++]],I+=T[E[S++]],I+=T[E[S++]],I}e.generateUuid=P}),define(we[109],be([0,1,227]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class E extends c.CharacterClassifier{constructor(P){super(0);for(let S=0,I=P.length;S<I;S++)this.set(P.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=E;function T(A){let P={};return S=>(P.hasOwnProperty(S)||(P[S]=A(S)),P[S])}e.getMapForWordSeparators=T(A=>new E(A))}),define(we[79],be([0,1,22]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var E;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(E=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(u){u[u.TextDefined=0]="TextDefined",u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(u){u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var P;(function(u){u[u.LF=0]="LF",u[u.CRLF=1]="CRLF"})(P=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(p){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,p.tabSize|0),this.indentSize=p.tabSize|0,this.insertSpaces=Boolean(p.insertSpaces),this.defaultEOL=p.defaultEOL|0,this.trimAutoWhitespace=Boolean(p.trimAutoWhitespace),this.bracketPairColorizationOptions=p.bracketPairColorizationOptions}equals(p){return this.tabSize===p.tabSize&&this.indentSize===p.indentSize&&this.insertSpaces===p.insertSpaces&&this.defaultEOL===p.defaultEOL&&this.trimAutoWhitespace===p.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,p.bracketPairColorizationOptions)}createChangeEvent(p){return{tabSize:this.tabSize!==p.tabSize,indentSize:this.indentSize!==p.indentSize,insertSpaces:this.insertSpaces!==p.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==p.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class I{constructor(p,k){this._findMatchBrand=void 0,this.range=p,this.matches=k}}e.FindMatch=I;var t;(function(u){u[u.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",u[u.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",u[u.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",u[u.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var y;(function(u){u[u.Left=0]="Left",u[u.Right=1]="Right",u[u.None=2]="None"})(y=e.PositionAffinity||(e.PositionAffinity={}));var n;(function(u){u[u.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(n=e.ModelConstants||(e.ModelConstants={}));class d{constructor(p,k,w,l,v,D){this.identifier=p,this.range=k,this.text=w,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=v,this._isTracked=D}}e.ValidAnnotatedEditOperation=d;class r{constructor(p,k,w){this.reverseEdits=p,this.changes=k,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=r}),define(we[110],be([0,1,9,109,111,41,79]),function(re,e,c,M,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class S{constructor(l,v,D,i){this.searchString=l,this.isRegex=v,this.matchCase=D,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=I(this.searchString):l=this.searchString.indexOf(`
`)>=0;let v=null;try{v=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch(i){return null}if(!v)return null;let D=!this.isRegex&&!l;return D&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(D=this.matchCase),new t(v,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,D?this.searchString:null)}}e.SearchParams=S;function I(w){if(!w||w.length===0)return!1;for(let l=0,v=w.length;l<v;l++)if(w.charCodeAt(l)===92){if(l++,l>=v)break;const i=w.charCodeAt(l);if(i===110||i===114||i===87||i===119)return!0}return!1}e.isMultilineRegexSource=I;class t{constructor(l,v,D){this.regex=l,this.wordSeparators=v,this.simpleSearch=D}}e.SearchData=t;function y(w,l,v){if(!v)return new A.FindMatch(w,null);let D=[];for(let i=0,s=l.length;i<s;i++)D[i]=l[i];return new A.FindMatch(w,D)}e.createFindMatch=y;class n{constructor(l){let v=[],D=0;for(let i=0,s=l.length;i<s;i++)l.charCodeAt(i)===10&&(v[D++]=i);this._lineFeedsOffsets=v}findLineFeedCountBeforeOffset(l){const v=this._lineFeedsOffsets;let D=0,i=v.length-1;if(i===-1||l<=v[0])return 0;for(;D<i;){const s=D+((i-D)/2>>0);v[s]>=l?i=s-1:v[s+1]>=l?(D=s,i=s):D=s+1}return D+1}}class d{static findMatches(l,v,D,i,s){const a=v.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(l,D,new k(a.wordSeparators,a.regex),i,s):this._doFindMatchesLineByLine(l,D,a,i,s):[]}static _getMultilineMatchRange(l,v,D,i,s,a){let o,_=0;i?(_=i.findLineFeedCountBeforeOffset(s),o=v+s+_):o=v+s;let m;if(i){let h=i.findLineFeedCountBeforeOffset(s+a.length)-_;m=o+a.length+h}else m=o+a.length;const g=l.getPositionAt(o),C=l.getPositionAt(m);return new T.Range(g.lineNumber,g.column,C.lineNumber,C.column)}static _doFindMatchesMultiline(l,v,D,i,s){const a=l.getOffsetAt(v.getStartPosition()),o=l.getValueInRange(v,1),_=l.getEOL()===`\r
`?new n(o):null,m=[];let g=0,C;for(D.reset(0);C=D.next(o);)if(m[g++]=y(this._getMultilineMatchRange(l,a,o,_,C.index,C[0]),C,i),g>=s)return m;return m}static _doFindMatchesLineByLine(l,v,D,i,s){const a=[];let o=0;if(v.startLineNumber===v.endLineNumber){const m=l.getLineContent(v.startLineNumber).substring(v.startColumn-1,v.endColumn-1);return o=this._findMatchesInLine(D,m,v.startLineNumber,v.startColumn-1,o,a,i,s),a}const _=l.getLineContent(v.startLineNumber).substring(v.startColumn-1);o=this._findMatchesInLine(D,_,v.startLineNumber,v.startColumn-1,o,a,i,s);for(let m=v.startLineNumber+1;m<v.endLineNumber&&o<s;m++)o=this._findMatchesInLine(D,l.getLineContent(m),m,0,o,a,i,s);if(o<s){const m=l.getLineContent(v.endLineNumber).substring(0,v.endColumn-1);o=this._findMatchesInLine(D,m,v.endLineNumber,0,o,a,i,s)}return a}static _findMatchesInLine(l,v,D,i,s,a,o,_){const m=l.wordSeparators;if(!o&&l.simpleSearch){const R=l.simpleSearch,h=R.length,b=v.length;let f=-h;for(;(f=v.indexOf(R,f+h))!==-1;)if((!m||p(m,v,b,f,h))&&(a[s++]=new A.FindMatch(new T.Range(D,f+1+i,D,f+1+h+i),null),s>=_))return s;return s}const g=new k(l.wordSeparators,l.regex);let C;g.reset(0);do if(C=g.next(v),C&&(a[s++]=y(new T.Range(D,C.index+1+i,D,C.index+1+C[0].length+i),C,o),s>=_))return s;while(C);return s}static findNextMatch(l,v,D,i){const s=v.parseSearchRequest();if(!s)return null;const a=new k(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(l,D,a,i):this._doFindNextMatchLineByLine(l,D,a,i)}static _doFindNextMatchMultiline(l,v,D,i){const s=new E.Position(v.lineNumber,1),a=l.getOffsetAt(s),o=l.getLineCount(),_=l.getValueInRange(new T.Range(s.lineNumber,s.column,o,l.getLineMaxColumn(o)),1),m=l.getEOL()===`\r
`?new n(_):null;D.reset(v.column-1);let g=D.next(_);return g?y(this._getMultilineMatchRange(l,a,_,m,g.index,g[0]),g,i):v.lineNumber!==1||v.column!==1?this._doFindNextMatchMultiline(l,new E.Position(1,1),D,i):null}static _doFindNextMatchLineByLine(l,v,D,i){const s=l.getLineCount(),a=v.lineNumber,o=l.getLineContent(a),_=this._findFirstMatchInLine(D,o,a,v.column,i);if(_)return _;for(let m=1;m<=s;m++){const g=(a+m-1)%s,C=l.getLineContent(g+1),R=this._findFirstMatchInLine(D,C,g+1,1,i);if(R)return R}return null}static _findFirstMatchInLine(l,v,D,i,s){l.reset(i-1);const a=l.next(v);return a?y(new T.Range(D,a.index+1,D,a.index+1+a[0].length),a,s):null}static findPreviousMatch(l,v,D,i){const s=v.parseSearchRequest();if(!s)return null;const a=new k(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(l,D,a,i):this._doFindPreviousMatchLineByLine(l,D,a,i)}static _doFindPreviousMatchMultiline(l,v,D,i){const s=this._doFindMatchesMultiline(l,new T.Range(1,1,v.lineNumber,v.column),D,i,10*P);if(s.length>0)return s[s.length-1];const a=l.getLineCount();return v.lineNumber!==a||v.column!==l.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(l,new E.Position(a,l.getLineMaxColumn(a)),D,i):null}static _doFindPreviousMatchLineByLine(l,v,D,i){const s=l.getLineCount(),a=v.lineNumber,o=l.getLineContent(a).substring(0,v.column-1),_=this._findLastMatchInLine(D,o,a,i);if(_)return _;for(let m=1;m<=s;m++){const g=(s+a-m-1)%s,C=l.getLineContent(g+1),R=this._findLastMatchInLine(D,C,g+1,i);if(R)return R}return null}static _findLastMatchInLine(l,v,D,i){let s=null,a;for(l.reset(0);a=l.next(v);)s=y(new T.Range(D,a.index+1,D,a.index+1+a[0].length),a,i);return s}}e.TextModelSearch=d;function r(w,l,v,D,i){if(D===0)return!0;const s=l.charCodeAt(D-1);if(w.get(s)!==0||s===13||s===10)return!0;if(i>0){const a=l.charCodeAt(D);if(w.get(a)!==0)return!0}return!1}function u(w,l,v,D,i){if(D+i===v)return!0;const s=l.charCodeAt(D+i);if(w.get(s)!==0||s===13||s===10)return!0;if(i>0){const a=l.charCodeAt(D+i-1);if(w.get(a)!==0)return!0}return!1}function p(w,l,v,D,i){return r(w,l,v,D,i)&&u(w,l,v,D,i)}e.isValidMatch=p;class k{constructor(l,v){this._wordSeparators=l,this._searchRegex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(l){this._searchRegex.lastIndex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(l){const v=l.length;let D;do{if(this._prevMatchStartIndex+this._prevMatchLength===v||(D=this._searchRegex.exec(l),!D))return null;const i=D.index,s=D[0].length;if(i===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){c.getNextCodePoint(l,v,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=s,!this._wordSeparators||p(this._wordSeparators,l,v,i,s))return D}while(D);return null}}e.Searcher=k}),define(we[112],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class M{constructor(P){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let S=0,I=P.notIn.length;S<I;S++)switch(P.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=M;class E{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of P)T(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),T(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),T(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),T(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&T(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=E;function T(A,P,S){A.has(P)?A.get(P).push(S):A.set(P,[S])}}),define(we[54],be([0,1,27,17]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(T,A,P,S){if(Array.isArray(T)){let I=0;for(const t of T){const y=E(t,A,P,S);if(y===10)return y;y>I&&(I=y)}return I}else{if(typeof T=="string")return S?T==="*"?5:T===P?10:0:0;if(T){const{language:I,pattern:t,scheme:y,hasAccessToAllModels:n}=T;if(!S&&!n)return 0;let d=0;if(y)if(y===A.scheme)d=10;else if(y==="*")d=5;else return 0;if(I)if(I===P)d=10;else if(I==="*")d=Math.max(d,5);else return 0;if(t){let r;if(typeof t=="string"?r=t:r={...t,base:(0,M.normalize)(t.base)},r===A.fsPath||(0,c.match)(r,A.fsPath))d=10;else return 0}return d}else return 0}}e.score=E}),define(we[113],be([0,1,3,7]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class E{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,P){return this._map.set(A,P),this.fire([A]),(0,M.toDisposable)(()=>{this._map.get(A)===P&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,P){let S=null,I=!1;return this._promises.set(A,P.then(t=>{this._promises.delete(A),!(I||!t)&&(S=this.register(A,t))})),(0,M.toDisposable)(()=>{I=!0,S&&S.dispose()})}getPromise(A){const P=this.get(A);if(P)return Promise.resolve(P);const S=this._promises.get(A);return S?S.then(I=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=E}),define(we[80],be([0,1,23,26]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(E||(E={}));function T(y){for(let n=0,d=y.length;n<d;n+=4){const r=y[n+0],u=y[n+1],p=y[n+2],k=y[n+3];y[n+0]=k,y[n+1]=p,y[n+2]=u,y[n+3]=r}}function A(y){const n=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return M.isLittleEndian()||T(n),c.VSBuffer.wrap(n)}function P(y){const n=y.buffer;if(M.isLittleEndian()||T(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const d=new Uint8Array(n.byteLength);return d.set(n),new Uint32Array(d.buffer,d.byteOffset,d.length/4)}}function S(y){const n=new Uint32Array(I(y));let d=0;if(n[d++]=y.id,y.type==="full")n[d++]=1,n[d++]=y.data.length,n.set(y.data,d),d+=y.data.length;else{n[d++]=2,n[d++]=y.deltas.length;for(const r of y.deltas)n[d++]=r.start,n[d++]=r.deleteCount,r.data?(n[d++]=r.data.length,n.set(r.data,d),d+=r.data.length):n[d++]=0}return A(n)}e.encodeSemanticTokensDto=S;function I(y){let n=0;if(n+=1+1,y.type==="full")n+=1+y.data.length;else{n+=1,n+=(1+1+1)*y.deltas.length;for(const d of y.deltas)d.data&&(n+=d.data.length)}return n}function t(y){const n=P(y);let d=0;const r=n[d++];if(n[d++]===1){const w=n[d++],l=n.subarray(d,d+w);return d+=w,{id:r,type:"full",data:l}}const p=n[d++];let k=[];for(let w=0;w<p;w++){const l=n[d++],v=n[d++],D=n[d++];let i;D>0&&(i=n.subarray(d,d+D),d+=D),k[w]={start:l,deleteCount:v,data:i}}return{id:r,type:"delta",deltas:k}}e.decodeSemanticTokensDto=t}),define(we[114],be([18,19]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(we[55],be([0,1,16,10,114]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(I,t){return t&&(I.stack||I.stacktrace)?E.localize(0,null,P(I),A(I.stack)||A(I.stacktrace)):P(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function P(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?E.localize(1,null,I.message):I.message||E.localize(2,null)}function S(I=null,t=!1){if(!I)return E.localize(3,null);if(Array.isArray(I)){const y=c.coalesce(I),n=S(y[0],t);return y.length>1?E.localize(4,null,n,y.length):n}if(M.isString(I))return I;if(I.detail){const y=I.detail;if(y.error)return T(y.error,t);if(y.exception)return T(y.exception,t)}return I.stack?T(I,t):I.message?I.message:E.localize(5,null)}e.toErrorMessage=S}),define(we[115],be([18,19]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(we[116],be([0,1,115,26,117]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=A;class P{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,he){this._values[J]=he}}e.ValidatedEditorOptions=P;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class I{constructor(J,he,Le,Ve){this.id=J,this.name=he,this.defaultValue=Le,this.schema=Ve}compute(J,he,Le){return Le}}class t{constructor(J,he=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=he}validate(J){return this.defaultValue}}class y{constructor(J,he,Le,Ve){this.id=J,this.name=he,this.defaultValue=Le,this.schema=Ve}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,he,Le){return Le}}function n(H,J){return typeof H=="undefined"?J:H==="false"?!1:Boolean(H)}e.boolean=n;class d extends y{constructor(J,he,Le,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=Le),super(J,he,Le,Ve)}validate(J){return n(J,this.defaultValue)}}class r extends y{constructor(J,he,Le,Ve,tt,ut=void 0){typeof ut!="undefined"&&(ut.type="integer",ut.default=Le,ut.minimum=Ve,ut.maximum=tt),super(J,he,Le,ut),this.minimum=Ve,this.maximum=tt}static clampedInt(J,he,Le,Ve){if(typeof J=="undefined")return he;let tt=parseInt(J,10);return isNaN(tt)?he:(tt=Math.max(Le,tt),tt=Math.min(Ve,tt),tt|0)}validate(J){return r.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class u extends y{constructor(J,he,Le,Ve,tt){typeof tt!="undefined"&&(tt.type="number",tt.default=Le),super(J,he,Le,tt),this.validationFn=Ve}static clamp(J,he,Le){return J<he?he:J>Le?Le:J}static float(J,he){if(typeof J=="number")return J;if(typeof J=="undefined")return he;const Le=parseFloat(J);return isNaN(Le)?he:Le}validate(J){return this.validationFn(u.float(J,this.defaultValue))}}class p extends y{static string(J,he){return typeof J!="string"?he:J}constructor(J,he,Le,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=Le),super(J,he,Le,Ve)}validate(J){return p.string(J,this.defaultValue)}}function k(H,J,he){return typeof H!="string"||he.indexOf(H)===-1?J:H}e.stringSet=k;class w extends y{constructor(J,he,Le,Ve,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.enum=Ve,tt.default=Le),super(J,he,Le,tt),this._allowedValues=Ve}validate(J){return k(J,this.defaultValue,this._allowedValues)}}class l extends I{constructor(J,he,Le,Ve,tt,ut,ht=void 0){typeof ht!="undefined"&&(ht.type="string",ht.enum=tt,ht.default=Ve),super(J,he,Le,ht),this._allowedValues=tt,this._convert=ut}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function v(H){switch(H){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class D extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",description:c.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,he,Le){return Le===0?J.accessibilitySupport:Le}}class i extends I{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:c.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{insertSpace:n(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function a(H){switch(H){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var o;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(o=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function _(H){switch(H){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=_;function m(H){switch(H){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}class g extends t{constructor(){super(127,[65,32])}compute(J,he,Le){const Ve=["monaco-editor"];return he.get(32)&&Ve.push(he.get(32)),J.extraEditorClassName&&Ve.push(J.extraEditorClassName),he.get(65)==="default"?Ve.push("mouse-default"):he.get(65)==="copy"&&Ve.push("mouse-copy"),he.get(100)&&Ve.push("showUnused"),he.get(125)&&Ve.push("showDeprecated"),Ve.join(" ")}}class C extends d{constructor(){super(31,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(J,he,Le){return Le&&J.emptySelectionClipboard}}class R extends I{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:c.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:c.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{cursorMoveOnType:n(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":k(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":k(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(he.loop,this.defaultValue.loop)}}}class h extends I{constructor(){super(43,"fontLigatures",h.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?h.OFF:J==="true"?h.ON:J:Boolean(J)?h.ON:h.OFF}}e.EditorFontLigatures=h,h.OFF='"liga" off, "calt" off',h.ON='"liga" on, "calt" on';class b extends t{constructor(){super(42)}compute(J,he,Le){return J.fontInfo}}class f extends y{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(22,null)})}validate(J){let he=u.float(J,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(he,6,100)}compute(J,he,Le){return J.fontInfo.fontSize}}class F extends I{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:F.MINIMUM_VALUE,maximum:F.MAXIMUM_VALUE,errorMessage:c.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:F.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(r.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,F.MINIMUM_VALUE,F.MAXIMUM_VALUE))}}F.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],F.MINIMUM_VALUE=1,F.MAXIMUM_VALUE=1e3;class O extends I{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[c.localize(25,null),c.localize(26,null),c.localize(27,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(29,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(30,null),...he},"editor.gotoLocation.multipleDeclarations":{description:c.localize(31,null),...he},"editor.gotoLocation.multipleImplementations":{description:c.localize(32,null),...he},"editor.gotoLocation.multipleReferences":{description:c.localize(33,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Le,description:c.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Le,description:c.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Le,description:c.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Le,description:c.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Le,description:c.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{multiple:k(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??k(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??k(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??k(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??k(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??k(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class q extends I{constructor(){const J={enabled:!0,delay:300,sticky:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:c.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:c.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:c.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),delay:r.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:n(he.sticky,this.defaultValue.sticky)}}}var Q;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(Q=e.RenderMinimap||(e.RenderMinimap={}));class $ extends t{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(J,he,Le){return $.computeLayout(he,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const he=J.height/J.lineHeight,Le=J.scrollBeyondLastLine?he-1:0,Ve=(J.viewLineCount+Le)/(J.pixelRatio*J.height),tt=Math.floor(J.viewLineCount/Ve);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Le,desiredRatio:Ve,minimapLineCount:tt}}static _computeMinimapLayout(J,he){const Le=J.outerWidth,Ve=J.outerHeight,tt=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const ut=he.stableMinimapLayoutInput,ht=ut&&J.outerHeight===ut.outerHeight&&J.lineHeight===ut.lineHeight&&J.typicalHalfwidthCharacterWidth===ut.typicalHalfwidthCharacterWidth&&J.pixelRatio===ut.pixelRatio&&J.scrollBeyondLastLine===ut.scrollBeyondLastLine&&J.minimap.enabled===ut.minimap.enabled&&J.minimap.side===ut.minimap.side&&J.minimap.size===ut.minimap.size&&J.minimap.showSlider===ut.minimap.showSlider&&J.minimap.renderCharacters===ut.minimap.renderCharacters&&J.minimap.maxColumn===ut.minimap.maxColumn&&J.minimap.scale===ut.minimap.scale&&J.verticalScrollbarWidth===ut.verticalScrollbarWidth&&J.isViewportWrapping===ut.isViewportWrapping,St=J.lineHeight,Pt=J.typicalHalfwidthCharacterWidth,dt=J.scrollBeyondLastLine,bt=J.minimap.renderCharacters;let ft=tt>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Et=J.minimap.maxColumn,Ye=J.minimap.size,Ct=J.minimap.side,Pe=J.verticalScrollbarWidth,ye=J.viewLineCount,De=J.remainingWidth,Z=J.isViewportWrapping,le=bt?2:3;let ge=Math.floor(tt*Ve);const me=ge/tt;let Ie=!1,Be=!1,Me=le*ft,je=ft/tt,Je=1;if(Ye==="fill"||Ye==="fit"){const{typicalViewportLineCount:Ge,extraLinesBeyondLastLine:We,desiredRatio:it,minimapLineCount:mt}=$.computeContainedMinimapLineCount({viewLineCount:ye,scrollBeyondLastLine:dt,height:Ve,lineHeight:St,pixelRatio:tt});if(ye/mt>1)Ie=!0,Be=!0,ft=1,Me=1,je=ft/tt;else{let nt=!1,ot=ft+1;if(Ye==="fit"){const lt=Math.ceil((ye+We)*Me);Z&&ht&&De<=he.stableFitRemainingWidth?(nt=!0,ot=he.stableFitMaxMinimapScale):nt=lt>ge}if(Ye==="fill"||nt){Ie=!0;const lt=ft;Me=Math.min(St*tt,Math.max(1,Math.floor(1/it))),Z&&ht&&De<=he.stableFitRemainingWidth&&(ot=he.stableFitMaxMinimapScale),ft=Math.min(ot,Math.max(1,Math.floor(Me/le))),ft>lt&&(Je=Math.min(2,ft/lt)),je=ft/tt/Je,ge=Math.ceil(Math.max(Ge,ye+We)*Me),Z?(he.stableMinimapLayoutInput=J,he.stableFitRemainingWidth=De,he.stableFitMaxMinimapScale=ft):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const ie=Math.floor(Et*je),pe=Math.min(ie,Math.max(0,Math.floor((De-Pe-2)*je/(Pt+je)))+e.MINIMAP_GUTTER_WIDTH);let ne=Math.floor(tt*pe);const U=ne/tt;ne=Math.floor(ne*Je);const Ce=bt?1:2,Se=Ct==="left"?0:Le-pe-Pe;return{renderMinimap:Ce,minimapLeft:Se,minimapWidth:pe,minimapHeightIsEditorHeight:Ie,minimapIsSampling:Be,minimapScale:ft,minimapLineHeight:Me,minimapCanvasInnerWidth:ne,minimapCanvasInnerHeight:ge,minimapCanvasOuterWidth:U,minimapCanvasOuterHeight:me}}static computeLayout(J,he){const Le=he.outerWidth|0,Ve=he.outerHeight|0,tt=he.lineHeight|0,ut=he.lineNumbersDigitCount|0,ht=he.typicalHalfwidthCharacterWidth,St=he.maxDigitWidth,Pt=he.pixelRatio,dt=he.viewLineCount,bt=J.get(122),ft=bt==="inherit"?J.get(121):bt,Et=ft==="inherit"?J.get(117):ft,Ye=J.get(120),Ct=J.get(2),Pe=he.isDominatedByLongLines,ye=J.get(48),De=J.get(59).renderType!==0,Z=J.get(60),le=J.get(94),ge=J.get(64),me=J.get(92),Ie=me.verticalScrollbarSize,Be=me.verticalHasArrows,Me=me.arrowSize,je=me.horizontalScrollbarSize,Je=J.get(57),ie=J.get(36);let pe;if(typeof Je=="string"&&/^\d+(\.\d+)?ch$/.test(Je)){const Nt=parseFloat(Je.substr(0,Je.length-2));pe=r.clampedInt(Nt*ht,0,0,1e3)}else pe=r.clampedInt(Je,0,0,1e3);ie&&(pe+=16);let ne=0;if(De){const Nt=Math.max(ut,Z);ne=Math.round(Nt*St)}let U=0;ye&&(U=tt);let Ce=0,Se=Ce+U,Ge=Se+ne,We=Ge+pe;const it=Le-U-ne-pe;let mt=!1,vt=!1,nt=-1;Ct!==2&&(ft==="inherit"&&Pe?(mt=!0,vt=!0):Et==="on"||Et==="bounded"?vt=!0:Et==="wordWrapColumn"&&(nt=Ye));const ot=$._computeMinimapLayout({outerWidth:Le,outerHeight:Ve,lineHeight:tt,typicalHalfwidthCharacterWidth:ht,pixelRatio:Pt,scrollBeyondLastLine:le,minimap:ge,verticalScrollbarWidth:Ie,viewLineCount:dt,remainingWidth:it,isViewportWrapping:vt},he.memory||new S);ot.renderMinimap!==0&&ot.minimapLeft===0&&(Ce+=ot.minimapWidth,Se+=ot.minimapWidth,Ge+=ot.minimapWidth,We+=ot.minimapWidth);const lt=it-ot.minimapWidth,Ft=Math.max(1,Math.floor((lt-Ie-2)/ht)),_t=Be?Me:0;return vt&&(nt=Math.max(1,Ft),Et==="bounded"&&(nt=Math.min(nt,Ye))),{width:Le,height:Ve,glyphMarginLeft:Ce,glyphMarginWidth:U,lineNumbersLeft:Se,lineNumbersWidth:ne,decorationsLeft:Ge,decorationsWidth:pe,contentLeft:We,contentWidth:lt,minimap:ot,viewportColumn:Ft,isWordWrapMinified:mt,isViewportWrapping:vt,wrappingColumn:nt,verticalScrollbarWidth:Ie,horizontalScrollbarHeight:je,overviewRuler:{top:_t,width:Ie,height:Ve-2*_t,right:0}}}}e.EditorLayoutInfoComputer=$;class z extends I{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:c.localize(42,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class N extends I{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:c.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,description:c.localize(45,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(he.fontFamily,this.defaultValue.fontFamily)}}}class W extends u{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>u.clamp(J,0,150),{markdownDescription:c.localize(46,null)})}compute(J,he,Le){return J.fontInfo.lineHeight}}class j extends I{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:c.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(48,null),c.localize(49,null),c.localize(50,null)],default:J.size,description:c.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:c.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:c.localize(53,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:c.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:c.localize(56,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),size:k(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:k(he.side,this.defaultValue.side,["right","left"]),showSlider:k(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(he.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(he.scale,1,1,3),maxColumn:r.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Y(H){return H==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class de extends I{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(58,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{top:r.clampedInt(he.top,0,0,1e3),bottom:r.clampedInt(he.bottom,0,0,1e3)}}}class G extends I{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:c.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:c.localize(60,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),cycle:n(he.cycle,this.defaultValue.cycle)}}}class ue extends t{constructor(){super(128)}compute(J,he,Le){return J.pixelRatio}}class oe extends I{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:c.localize(61,null)},comments:{type:"boolean",default:J.comments,description:c.localize(62,null)},other:{type:"boolean",default:J.other,description:c.localize(63,null)}}}],default:J,description:c.localize(64,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const he=J,Le={other:n(he.other,this.defaultValue.other),comments:n(he.comments,this.defaultValue.comments),strings:n(he.strings,this.defaultValue.strings)};return Le.other&&Le.comments&&Le.strings?!0:!Le.other&&!Le.comments&&!Le.strings?!1:Le}return this.defaultValue}}var Ee;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(Ee=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Te extends I{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(65,null),c.localize(66,null),c.localize(67,null),c.localize(68,null)],default:"on",description:c.localize(69,null)})}validate(J){let he=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(he=4,Le=J):J==="interval"?he=3:J==="relative"?he=2:J==="on"?he=1:he=0),{renderType:he,renderFn:Le}}}function Re(H){const J=H.get(87);return J==="editable"?H.get(80):J!=="on"}e.filterValidationDecorations=Re;class Ne extends I{constructor(){const J=[],he={type:"number",description:c.localize(70,null)};super(91,"rulers",J,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:c.localize(71,null),format:"color-hex"}}}]},default:J,description:c.localize(72,null)})}validate(J){if(Array.isArray(J)){let he=[];for(let Le of J)if(typeof Le=="number")he.push({column:r.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const Ve=Le;he.push({column:r.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return he.sort((Le,Ve)=>Le.column-Ve.column),he}return this.defaultValue}}function Qe(H,J){if(typeof H!="string")return J;switch(H){case"hidden":return 2;case"visible":return 3;default:return 1}}class He extends I{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(73,null),c.localize(74,null),c.localize(75,null)],default:"auto",description:c.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(77,null),c.localize(78,null),c.localize(79,null)],default:"auto",description:c.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:c.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:c.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:c.localize(83,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J,Le=r.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=r.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Qe(he.vertical,this.defaultValue.vertical),horizontal:Qe(he.horizontal,this.defaultValue.horizontal),useShadows:n(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:r.clampedInt(he.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:r.clampedInt(he.verticalSliderSize,Ve,0,1e3),scrollByPage:n(he.scrollByPage,this.defaultValue.scrollByPage)}}}class qe extends I{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:c.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[c.localize(85,null),c.localize(86,null),c.localize(87,null)],default:J.mode,description:c.localize(88,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{enabled:n(he.enabled,this.defaultValue.enabled),mode:k(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class B extends I{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:c.localize(89,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class K extends I{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(90,null),c.localize(91,null)],default:J.insertMode,description:c.localize(92,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:c.localize(93,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:c.localize(94,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:c.localize(95,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:c.localize(96,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:c.localize(97,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:c.localize(98,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:c.localize(99,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[c.localize(100,null),c.localize(101,null),c.localize(102,null)],default:J.previewMode,description:c.localize(103,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:c.localize(104,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(105,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(106,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(107,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(108,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(109,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(110,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(111,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(112,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(113,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(114,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(115,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(116,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(117,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(118,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(119,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(120,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(121,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(122,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(123,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(124,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(125,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(126,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(127,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(128,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(129,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(130,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(131,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(132,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(133,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(134,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(135,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const he=J;return{insertMode:k(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(he.showIcons,this.defaultValue.showIcons),showStatusBar:n(he.showStatusBar,this.defaultValue.showStatusBar),preview:n(he.preview,this.defaultValue.preview),previewMode:k(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(he.showMethods,this.defaultValue.showMethods),showFunctions:n(he.showFunctions,this.defaultValue.showFunctions),showConstructors:n(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(he.showDeprecated,this.defaultValue.showDeprecated),showFields:n(he.showFields,this.defaultValue.showFields),showVariables:n(he.showVariables,this.defaultValue.showVariables),showClasses:n(he.showClasses,this.defaultValue.showClasses),showStructs:n(he.showStructs,this.defaultValue.showStructs),showInterfaces:n(he.showInterfaces,this.defaultValue.showInterfaces),showModules:n(he.showModules,this.defaultValue.showModules),showProperties:n(he.showProperties,this.defaultValue.showProperties),showEvents:n(he.showEvents,this.defaultValue.showEvents),showOperators:n(he.showOperators,this.defaultValue.showOperators),showUnits:n(he.showUnits,this.defaultValue.showUnits),showValues:n(he.showValues,this.defaultValue.showValues),showConstants:n(he.showConstants,this.defaultValue.showConstants),showEnums:n(he.showEnums,this.defaultValue.showEnums),showEnumMembers:n(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(he.showKeywords,this.defaultValue.showKeywords),showWords:n(he.showWords,this.defaultValue.showWords),showColors:n(he.showColors,this.defaultValue.showColors),showFiles:n(he.showFiles,this.defaultValue.showFiles),showReferences:n(he.showReferences,this.defaultValue.showReferences),showFolders:n(he.showFolders,this.defaultValue.showFolders),showTypeParameters:n(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(he.showSnippets,this.defaultValue.showSnippets),showUsers:n(he.showUsers,this.defaultValue.showUsers),showIssues:n(he.showIssues,this.defaultValue.showIssues)}}}class ee extends I{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(136,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ae extends t{constructor(){super(129,[80])}compute(J,he,Le){return he.get(80)?!0:J.tabFocusMode}}var V;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(V=e.WrappingIndent||(e.WrappingIndent={}));function se(H){switch(H){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class fe extends t{constructor(){super(131,[130])}compute(J,he,Le){const Ve=he.get(130);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const Ae="Consolas, 'Courier New', monospace",xe="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?xe:M.isLinux?$e:Ae,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ve(H){return e.editorOptionsRegistry[H.id]=H,H}var Xe;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.autoClosingBrackets=5]="autoClosingBrackets",H[H.autoClosingDelete=6]="autoClosingDelete",H[H.autoClosingOvertype=7]="autoClosingOvertype",H[H.autoClosingQuotes=8]="autoClosingQuotes",H[H.autoIndent=9]="autoIndent",H[H.automaticLayout=10]="automaticLayout",H[H.autoSurround=11]="autoSurround",H[H.bracketPairColorization=12]="bracketPairColorization",H[H.codeLens=13]="codeLens",H[H.codeLensFontFamily=14]="codeLensFontFamily",H[H.codeLensFontSize=15]="codeLensFontSize",H[H.colorDecorators=16]="colorDecorators",H[H.columnSelection=17]="columnSelection",H[H.comments=18]="comments",H[H.contextmenu=19]="contextmenu",H[H.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",H[H.cursorBlinking=21]="cursorBlinking",H[H.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",H[H.cursorStyle=23]="cursorStyle",H[H.cursorSurroundingLines=24]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",H[H.cursorWidth=26]="cursorWidth",H[H.disableLayerHinting=27]="disableLayerHinting",H[H.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",H[H.domReadOnly=29]="domReadOnly",H[H.dragAndDrop=30]="dragAndDrop",H[H.emptySelectionClipboard=31]="emptySelectionClipboard",H[H.extraEditorClassName=32]="extraEditorClassName",H[H.fastScrollSensitivity=33]="fastScrollSensitivity",H[H.find=34]="find",H[H.fixedOverflowWidgets=35]="fixedOverflowWidgets",H[H.folding=36]="folding",H[H.foldingStrategy=37]="foldingStrategy",H[H.foldingHighlight=38]="foldingHighlight",H[H.foldingImportsByDefault=39]="foldingImportsByDefault",H[H.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=41]="fontFamily",H[H.fontInfo=42]="fontInfo",H[H.fontLigatures=43]="fontLigatures",H[H.fontSize=44]="fontSize",H[H.fontWeight=45]="fontWeight",H[H.formatOnPaste=46]="formatOnPaste",H[H.formatOnType=47]="formatOnType",H[H.glyphMargin=48]="glyphMargin",H[H.gotoLocation=49]="gotoLocation",H[H.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",H[H.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",H[H.hover=52]="hover",H[H.inDiffEditor=53]="inDiffEditor",H[H.inlineSuggest=54]="inlineSuggest",H[H.letterSpacing=55]="letterSpacing",H[H.lightbulb=56]="lightbulb",H[H.lineDecorationsWidth=57]="lineDecorationsWidth",H[H.lineHeight=58]="lineHeight",H[H.lineNumbers=59]="lineNumbers",H[H.lineNumbersMinChars=60]="lineNumbersMinChars",H[H.linkedEditing=61]="linkedEditing",H[H.links=62]="links",H[H.matchBrackets=63]="matchBrackets",H[H.minimap=64]="minimap",H[H.mouseStyle=65]="mouseStyle",H[H.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=67]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",H[H.multiCursorModifier=69]="multiCursorModifier",H[H.multiCursorPaste=70]="multiCursorPaste",H[H.occurrencesHighlight=71]="occurrencesHighlight",H[H.overviewRulerBorder=72]="overviewRulerBorder",H[H.overviewRulerLanes=73]="overviewRulerLanes",H[H.padding=74]="padding",H[H.parameterHints=75]="parameterHints",H[H.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",H[H.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",H[H.quickSuggestions=78]="quickSuggestions",H[H.quickSuggestionsDelay=79]="quickSuggestionsDelay",H[H.readOnly=80]="readOnly",H[H.renameOnType=81]="renameOnType",H[H.renderControlCharacters=82]="renderControlCharacters",H[H.renderIndentGuides=83]="renderIndentGuides",H[H.renderFinalNewline=84]="renderFinalNewline",H[H.renderLineHighlight=85]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=87]="renderValidationDecorations",H[H.renderWhitespace=88]="renderWhitespace",H[H.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",H[H.roundedSelection=90]="roundedSelection",H[H.rulers=91]="rulers",H[H.scrollbar=92]="scrollbar",H[H.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=94]="scrollBeyondLastLine",H[H.scrollPredominantAxis=95]="scrollPredominantAxis",H[H.selectionClipboard=96]="selectionClipboard",H[H.selectionHighlight=97]="selectionHighlight",H[H.selectOnLineNumbers=98]="selectOnLineNumbers",H[H.showFoldingControls=99]="showFoldingControls",H[H.showUnused=100]="showUnused",H[H.snippetSuggestions=101]="snippetSuggestions",H[H.smartSelect=102]="smartSelect",H[H.smoothScrolling=103]="smoothScrolling",H[H.stickyTabStops=104]="stickyTabStops",H[H.stopRenderingLineAfter=105]="stopRenderingLineAfter",H[H.suggest=106]="suggest",H[H.suggestFontSize=107]="suggestFontSize",H[H.suggestLineHeight=108]="suggestLineHeight",H[H.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",H[H.suggestSelection=110]="suggestSelection",H[H.tabCompletion=111]="tabCompletion",H[H.tabIndex=112]="tabIndex",H[H.unusualLineTerminators=113]="unusualLineTerminators",H[H.useShadowDOM=114]="useShadowDOM",H[H.useTabStops=115]="useTabStops",H[H.wordSeparators=116]="wordSeparators",H[H.wordWrap=117]="wordWrap",H[H.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=120]="wordWrapColumn",H[H.wordWrapOverride1=121]="wordWrapOverride1",H[H.wordWrapOverride2=122]="wordWrapOverride2",H[H.wrappingIndent=123]="wrappingIndent",H[H.wrappingStrategy=124]="wrappingStrategy",H[H.showDeprecated=125]="showDeprecated",H[H.inlayHints=126]="inlayHints",H[H.editorClassName=127]="editorClassName",H[H.pixelRatio=128]="pixelRatio",H[H.tabFocusMode=129]="tabFocusMode",H[H.layoutInfo=130]="layoutInfo",H[H.wrappingInfo=131]="wrappingInfo"})(Xe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ve(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(137,null)})),acceptSuggestionOnEnter:ve(new w(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(138,null),""],markdownDescription:c.localize(139,null)})),accessibilitySupport:ve(new D),accessibilityPageSize:ve(new r(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(140,null)})),ariaLabel:ve(new p(4,"ariaLabel",c.localize(141,null))),autoClosingBrackets:ve(new w(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(142,null),c.localize(143,null),""],description:c.localize(144,null)})),autoClosingDelete:ve(new w(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(145,null),""],description:c.localize(146,null)})),autoClosingOvertype:ve(new w(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(147,null),""],description:c.localize(148,null)})),autoClosingQuotes:ve(new w(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(149,null),c.localize(150,null),""],description:c.localize(151,null)})),autoIndent:ve(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[c.localize(152,null),c.localize(153,null),c.localize(154,null),c.localize(155,null),c.localize(156,null)],description:c.localize(157,null)})),automaticLayout:ve(new d(10,"automaticLayout",!1)),autoSurround:ve(new w(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(158,null),c.localize(159,null),c.localize(160,null),""],description:c.localize(161,null)})),bracketPairColorization:ve(new B),stickyTabStops:ve(new d(104,"stickyTabStops",!1,{description:c.localize(162,null)})),codeLens:ve(new d(13,"codeLens",!0,{description:c.localize(163,null)})),codeLensFontFamily:ve(new p(14,"codeLensFontFamily","",{description:c.localize(164,null)})),codeLensFontSize:ve(new r(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(165,null)})),colorDecorators:ve(new d(16,"colorDecorators",!0,{description:c.localize(166,null)})),columnSelection:ve(new d(17,"columnSelection",!1,{description:c.localize(167,null)})),comments:ve(new i),contextmenu:ve(new d(19,"contextmenu",!0)),copyWithSyntaxHighlighting:ve(new d(20,"copyWithSyntaxHighlighting",!0,{description:c.localize(168,null)})),cursorBlinking:ve(new l(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],a,{description:c.localize(169,null)})),cursorSmoothCaretAnimation:ve(new d(22,"cursorSmoothCaretAnimation",!1,{description:c.localize(170,null)})),cursorStyle:ve(new l(23,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],m,{description:c.localize(171,null)})),cursorSurroundingLines:ve(new r(24,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(172,null)})),cursorSurroundingLinesStyle:ve(new w(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(173,null),c.localize(174,null)],description:c.localize(175,null)})),cursorWidth:ve(new r(26,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(176,null)})),disableLayerHinting:ve(new d(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:ve(new d(28,"disableMonospaceOptimizations",!1)),domReadOnly:ve(new d(29,"domReadOnly",!1)),dragAndDrop:ve(new d(30,"dragAndDrop",!0,{description:c.localize(177,null)})),emptySelectionClipboard:ve(new C),extraEditorClassName:ve(new p(32,"extraEditorClassName","")),fastScrollSensitivity:ve(new u(33,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:c.localize(178,null)})),find:ve(new R),fixedOverflowWidgets:ve(new d(35,"fixedOverflowWidgets",!1)),folding:ve(new d(36,"folding",!0,{description:c.localize(179,null)})),foldingStrategy:ve(new w(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(180,null),c.localize(181,null)],description:c.localize(182,null)})),foldingHighlight:ve(new d(38,"foldingHighlight",!0,{description:c.localize(183,null)})),foldingImportsByDefault:ve(new d(39,"foldingImportsByDefault",!1,{description:c.localize(184,null)})),unfoldOnClickAfterEndOfLine:ve(new d(40,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(185,null)})),fontFamily:ve(new p(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(186,null)})),fontInfo:ve(new b),fontLigatures2:ve(new h),fontSize:ve(new f),fontWeight:ve(new F),formatOnPaste:ve(new d(46,"formatOnPaste",!1,{description:c.localize(187,null)})),formatOnType:ve(new d(47,"formatOnType",!1,{description:c.localize(188,null)})),glyphMargin:ve(new d(48,"glyphMargin",!0,{description:c.localize(189,null)})),gotoLocation:ve(new O),hideCursorInOverviewRuler:ve(new d(50,"hideCursorInOverviewRuler",!1,{description:c.localize(190,null)})),highlightActiveIndentGuide:ve(new d(51,"highlightActiveIndentGuide",!0,{description:c.localize(191,null)})),hover:ve(new q),inDiffEditor:ve(new d(53,"inDiffEditor",!1)),letterSpacing:ve(new u(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>u.clamp(H,-5,20),{description:c.localize(192,null)})),lightbulb:ve(new z),lineDecorationsWidth:ve(new y(57,"lineDecorationsWidth",10)),lineHeight:ve(new W),lineNumbers:ve(new Te),lineNumbersMinChars:ve(new r(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ve(new d(61,"linkedEditing",!1,{description:c.localize(193,null)})),links:ve(new d(62,"links",!0,{description:c.localize(194,null)})),matchBrackets:ve(new w(63,"matchBrackets","always",["always","near","never"],{description:c.localize(195,null)})),minimap:ve(new j),mouseStyle:ve(new w(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ve(new u(66,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:c.localize(196,null)})),mouseWheelZoom:ve(new d(67,"mouseWheelZoom",!1,{markdownDescription:c.localize(197,null)})),multiCursorMergeOverlapping:ve(new d(68,"multiCursorMergeOverlapping",!0,{description:c.localize(198,null)})),multiCursorModifier:ve(new l(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Y,{markdownEnumDescriptions:[c.localize(199,null),c.localize(200,null)],markdownDescription:c.localize(201,null)})),multiCursorPaste:ve(new w(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(202,null),c.localize(203,null)],markdownDescription:c.localize(204,null)})),occurrencesHighlight:ve(new d(71,"occurrencesHighlight",!0,{description:c.localize(205,null)})),overviewRulerBorder:ve(new d(72,"overviewRulerBorder",!0,{description:c.localize(206,null)})),overviewRulerLanes:ve(new r(73,"overviewRulerLanes",3,0,3)),padding:ve(new de),parameterHints:ve(new G),peekWidgetDefaultFocus:ve(new w(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(207,null),c.localize(208,null)],description:c.localize(209,null)})),definitionLinkOpensInPeek:ve(new d(77,"definitionLinkOpensInPeek",!1,{description:c.localize(210,null)})),quickSuggestions:ve(new oe),quickSuggestionsDelay:ve(new r(79,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(211,null)})),readOnly:ve(new d(80,"readOnly",!1)),renameOnType:ve(new d(81,"renameOnType",!1,{description:c.localize(212,null),markdownDeprecationMessage:c.localize(213,null)})),renderControlCharacters:ve(new d(82,"renderControlCharacters",!1,{description:c.localize(214,null)})),renderIndentGuides:ve(new d(83,"renderIndentGuides",!0,{description:c.localize(215,null)})),renderFinalNewline:ve(new d(84,"renderFinalNewline",!0,{description:c.localize(216,null)})),renderLineHighlight:ve(new w(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(217,null)],description:c.localize(218,null)})),renderLineHighlightOnlyWhenFocus:ve(new d(86,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(219,null)})),renderValidationDecorations:ve(new w(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ve(new w(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(220,null),c.localize(221,null),c.localize(222,null),""],description:c.localize(223,null)})),revealHorizontalRightPadding:ve(new r(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ve(new d(90,"roundedSelection",!0,{description:c.localize(224,null)})),rulers:ve(new Ne),scrollbar:ve(new He),scrollBeyondLastColumn:ve(new r(93,"scrollBeyondLastColumn",5,0,1073741824,{description:c.localize(225,null)})),scrollBeyondLastLine:ve(new d(94,"scrollBeyondLastLine",!0,{description:c.localize(226,null)})),scrollPredominantAxis:ve(new d(95,"scrollPredominantAxis",!0,{description:c.localize(227,null)})),selectionClipboard:ve(new d(96,"selectionClipboard",!0,{description:c.localize(228,null),included:M.isLinux})),selectionHighlight:ve(new d(97,"selectionHighlight",!0,{description:c.localize(229,null)})),selectOnLineNumbers:ve(new d(98,"selectOnLineNumbers",!0)),showFoldingControls:ve(new w(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[c.localize(230,null),c.localize(231,null)],description:c.localize(232,null)})),showUnused:ve(new d(100,"showUnused",!0,{description:c.localize(233,null)})),showDeprecated:ve(new d(125,"showDeprecated",!0,{description:c.localize(234,null)})),inlayHints:ve(new N),snippetSuggestions:ve(new w(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(235,null),c.localize(236,null),c.localize(237,null),c.localize(238,null)],description:c.localize(239,null)})),smartSelect:ve(new ee),smoothScrolling:ve(new d(103,"smoothScrolling",!1,{description:c.localize(240,null)})),stopRenderingLineAfter:ve(new r(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ve(new K),inlineSuggest:ve(new qe),suggestFontSize:ve(new r(107,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(241,null)})),suggestLineHeight:ve(new r(108,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(242,null)})),suggestOnTriggerCharacters:ve(new d(109,"suggestOnTriggerCharacters",!0,{description:c.localize(243,null)})),suggestSelection:ve(new w(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(244,null),c.localize(245,null),c.localize(246,null)],description:c.localize(247,null)})),tabCompletion:ve(new w(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(248,null),c.localize(249,null),c.localize(250,null)],description:c.localize(251,null)})),tabIndex:ve(new r(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ve(new w(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(252,null),c.localize(253,null),c.localize(254,null)],description:c.localize(255,null)})),useShadowDOM:ve(new d(114,"useShadowDOM",!0)),useTabStops:ve(new d(115,"useTabStops",!0,{description:c.localize(256,null)})),wordSeparators:ve(new p(116,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:c.localize(257,null)})),wordWrap:ve(new w(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(258,null),c.localize(259,null),c.localize(260,null),c.localize(261,null)],description:c.localize(262,null)})),wordWrapBreakAfterCharacters:ve(new p(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ve(new p(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ve(new r(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(263,null)})),wordWrapOverride1:ve(new w(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ve(new w(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ve(new l(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],se,{enumDescriptions:[c.localize(264,null),c.localize(265,null),c.localize(266,null),c.localize(267,null)],description:c.localize(268,null)})),wrappingStrategy:ve(new w(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[c.localize(269,null),c.localize(270,null)],description:c.localize(271,null)})),editorClassName:ve(new g),pixelRatio:ve(new ue),tabFocusMode:ve(new ae),layoutInfo:ve(new $),wrappingInfo:ve(new fe)}}),define(we[118],be([18,19]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[119],be([18,19]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[120],be([18,19]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(we[121],be([18,19]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(we[122],be([18,19]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(we[123],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[124],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[125],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(we[126],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[127],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[128],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[129],be([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[130],be([18,19]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(we[131],be([18,19]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(we[132],be([18,19]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[133],be([18,19]),function(re,e){return re.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[134],be([18,19]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[135],be([18,19]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[136],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var c;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(c=e.EditorActivation||(e.EditorActivation={}));var M;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var E;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[137],be([0,1,119]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function T(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=T;function A(n){if(!T(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=n.match(M);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=A;function P(n){if(!n)return null;let d=n.majorBase,r=n.majorMustEqual,u=n.minorBase,p=n.minorMustEqual,k=n.patchBase,w=n.patchMustEqual;n.hasCaret&&(d===0||(p=!1),w=!1);let l=0;if(n.preRelease){const v=E.exec(n.preRelease);if(v){const[,D,i,s]=v;l=Date.UTC(Number(D),Number(i)-1,Number(s))}}return{majorBase:d,majorMustEqual:r,minorBase:u,minorMustEqual:p,patchBase:k,patchMustEqual:w,isMinimum:n.hasGreaterEquals,notBefore:l}}e.normalizeVersion=P;function S(n,d,r){let u;typeof n=="string"?u=P(A(n)):u=n;let p;d instanceof Date?p=d.getTime():typeof d=="string"&&(p=new Date(d).getTime());let k;if(typeof r=="string"?k=P(A(r)):k=r,!u||!k)return!1;let w=u.majorBase,l=u.minorBase,v=u.patchBase,D=k.majorBase,i=k.minorBase,s=k.patchBase,a=k.notBefore,o=k.majorMustEqual,_=k.minorMustEqual,m=k.patchMustEqual;return k.isMinimum?w>D?!0:w<D?!1:l>i?!0:l<i||p&&p<a?!1:v>=s:(w===1&&D===0&&(!o||!_||!m)&&(D=1,i=0,s=0,o=!0,_=!1,m=!1),w<D?!1:w>D?!o:l<i?!1:l>i?!_:v<s?!1:v>s?!m:!(p&&p<a))}e.isValidVersion=S;function I(n,d,r,u){return r.isBuiltin||typeof r.main=="undefined"?!0:y(n,d,r.engines.vscode,u)}e.isValidExtensionVersion=I;function t(n,d,r){return n==="*"||y(d,r,n)}e.isEngineValid=t;function y(n,d,r,u=[]){let p=P(A(r));if(!p)return u.push(c.localize(0,null,r)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return u.push(c.localize(1,null,r)),!1}else if(!p.majorMustEqual)return u.push(c.localize(2,null,r)),!1;return S(n,d,p)?!0:(u.push(c.localize(3,null,n,r)),!1)}}),define(we[81],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(E,T=[],A=!1){this.ctor=E,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=c}),define(we[56],be([0,1,81]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function E(A,P,S){P instanceof c.SyncDescriptor||(P=new c.SyncDescriptor(P,[],S)),M.push([A,P])}e.registerSingleton=E;function T(){return M}e.getSingletonServiceDescriptors=T}),define(we[138],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=c;class M{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const P=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),S),S.incoming.set(this._hashFn(T),P)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let P=this._nodes.get(A);return P||(P=new c(T),this._nodes.set(A,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[A,P]of this._nodes)T.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,A]of this._nodes){const P=new Set([T]),S=this._findCycle(A,P);if(S)return S}}_findCycle(T,A){for(let[P,S]of T.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const I=this._findCycle(S,A);if(I)return I;A.delete(P)}}}e.Graph=M}),define(we[4],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function S(I){return I[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=S})(c=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function M(P,S,I,t){S[c.DI_TARGET]===S?S[c.DI_DEPENDENCIES].push({id:P,index:I,optional:t}):(S[c.DI_DEPENDENCIES]=[{id:P,index:I,optional:t}],S[c.DI_TARGET]=S)}function E(P){if(c.serviceIds.has(P))return c.serviceIds.get(P);const S=function(I,t,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(S,I,y,!1)};return S.toString=()=>P,c.serviceIds.set(P,S),S}e.createDecorator=E;function T(P){return P}e.refineServiceDecorator=T;function A(P){return function(S,I,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");M(P,S,t,!0)}}e.optional=A}),define(we[139],be([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,c.createDecorator)("modelService");function M(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(we[140],be([0,1,3,57,7,20,75,54,139]),function(re,e,c,M,E,T,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function I(u){return typeof u=="string"?!1:Array.isArray(u)?u.every(I):!!u.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new c.Emitter}get onDidChange(){return this._onDidChange.event}register(p,k){let w={selector:p,provider:k,_score:-1,_time:this._clock++};return this._entries.push(w),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(w){let l=this._entries.indexOf(w);l>=0&&(this._entries.splice(l,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),w=void 0)}})}has(p){return this.all(p).length>0}all(p){if(!p)return[];this._updateScores(p);const k=[];for(let w of this._entries)w._score>0&&k.push(w.provider);return k}ordered(p){const k=[];return this._orderedForEach(p,w=>k.push(w.provider)),k}orderedGroups(p){const k=[];let w,l;return this._orderedForEach(p,v=>{w&&l===v._score?w.push(v.provider):(l=v._score,w=[v.provider],k.push(w))}),k}_orderedForEach(p,k){if(!!p){this._updateScores(p);for(const w of this._entries)w._score>0&&k(w)}}_updateScores(p){let k={uri:p.uri.toString(),language:p.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===k.language&&this._lastCandidate.uri===k.uri)){this._lastCandidate=k;for(let w of this._entries)if(w._score=(0,P.score)(w.selector,p.uri,p.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(p)),I(w.selector)&&w._score>0){for(let l of this._entries)l._score=0;w._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(p,k){return p._score<k._score?1:p._score>k._score?-1:p._time<k._time?1:p._time>k._time?-1:0}}e.LanguageFeatureRegistry=t;const y=new WeakMap;let n=0;function d(u){let p=y.get(u);return p===void 0&&(p=++n,y.set(u,p)),p}class r{constructor(p,k,w=Number.MAX_SAFE_INTEGER){this._registry=p,this.min=k,this.max=w,this._cache=new T.LRUCache(50,.7)}_key(p){return p.id+this._registry.all(p).reduce((k,w)=>(0,M.doHash)(d(w),k),0)}_clamp(p){return p===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(p*1.3)))}get(p){const k=this._key(p),w=this._cache.get(k);return this._clamp(w?.value)}update(p,k){const w=this._key(p);let l=this._cache.get(w);return l||(l=new A.MovingAverage,this._cache.set(w,l)),l.update(k),this.get(p)}}e.LanguageFeatureRequestDelays=r}),define(we[58],be([0,1,2,41,140,113,34]),function(re,e,c,M,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var P;(function(h){h[h.Null=0]="Null",h[h.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));class S{constructor(b,f){this.language=b,this.id=f}}e.LanguageIdentifier=S;var I;(function(h){h[h.NotSet=-1]="NotSet",h[h.None=0]="None",h[h.Italic=1]="Italic",h[h.Bold=2]="Bold",h[h.Underline=4]="Underline"})(I=e.FontStyle||(e.FontStyle={}));var t;(function(h){h[h.None=0]="None",h[h.DefaultForeground=1]="DefaultForeground",h[h.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var y;(function(h){h[h.Other=0]="Other",h[h.Comment=1]="Comment",h[h.String=2]="String",h[h.RegEx=4]="RegEx"})(y=e.StandardTokenType||(e.StandardTokenType={}));var n;(function(h){h[h.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",h[h.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",h[h.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",h[h.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",h[h.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",h[h.ITALIC_MASK=2048]="ITALIC_MASK",h[h.BOLD_MASK=4096]="BOLD_MASK",h[h.UNDERLINE_MASK=8192]="UNDERLINE_MASK",h[h.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",h[h.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",h[h.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",h[h.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",h[h.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",h[h.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",h[h.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",h[h.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",h[h.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",h[h.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(n=e.MetadataConsts||(e.MetadataConsts={}));class d{static getLanguageId(b){return(b&255)>>>0}static getTokenType(b){return(b&1792)>>>8}static getFontStyle(b){return(b&14336)>>>11}static getForeground(b){return(b&8372224)>>>14}static getBackground(b){return(b&4286578688)>>>23}static getClassNameFromMetadata(b){let f=this.getForeground(b),F="mtk"+f,O=this.getFontStyle(b);return O&1&&(F+=" mtki"),O&2&&(F+=" mtkb"),O&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(b,f){const F=this.getForeground(b),O=this.getFontStyle(b);let q=`color: ${f[F]};`;return O&1&&(q+="font-style: italic;"),O&2&&(q+="font-weight: bold;"),O&4&&(q+="text-decoration: underline;"),q}}e.TokenMetadata=d;var r;(function(h){h[h.Method=0]="Method",h[h.Function=1]="Function",h[h.Constructor=2]="Constructor",h[h.Field=3]="Field",h[h.Variable=4]="Variable",h[h.Class=5]="Class",h[h.Struct=6]="Struct",h[h.Interface=7]="Interface",h[h.Module=8]="Module",h[h.Property=9]="Property",h[h.Event=10]="Event",h[h.Operator=11]="Operator",h[h.Unit=12]="Unit",h[h.Value=13]="Value",h[h.Constant=14]="Constant",h[h.Enum=15]="Enum",h[h.EnumMember=16]="EnumMember",h[h.Keyword=17]="Keyword",h[h.Text=18]="Text",h[h.Color=19]="Color",h[h.File=20]="File",h[h.Reference=21]="Reference",h[h.Customcolor=22]="Customcolor",h[h.Folder=23]="Folder",h[h.TypeParameter=24]="TypeParameter",h[h.User=25]="User",h[h.Issue=26]="Issue",h[h.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let h=Object.create(null);return h[0]="symbol-method",h[1]="symbol-function",h[2]="symbol-constructor",h[3]="symbol-field",h[4]="symbol-variable",h[5]="symbol-class",h[6]="symbol-struct",h[7]="symbol-interface",h[8]="symbol-module",h[9]="symbol-property",h[10]="symbol-event",h[11]="symbol-operator",h[12]="symbol-unit",h[13]="symbol-value",h[14]="symbol-constant",h[15]="symbol-enum",h[16]="symbol-enum-member",h[17]="symbol-keyword",h[27]="symbol-snippet",h[18]="symbol-text",h[19]="symbol-color",h[20]="symbol-file",h[21]="symbol-reference",h[22]="symbol-customcolor",h[23]="symbol-folder",h[24]="symbol-type-parameter",h[25]="account",h[26]="issues",function(b){const f=h[b];let F=f&&A.iconRegistry.get(f);return F||(console.info("No codicon found for CompletionItemKind "+b),F=A.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let h=Object.create(null);return h.method=0,h.function=1,h.constructor=2,h.field=3,h.variable=4,h.class=5,h.struct=6,h.interface=7,h.module=8,h.property=9,h.event=10,h.operator=11,h.unit=12,h.value=13,h.constant=14,h.enum=15,h["enum-member"]=16,h.enumMember=16,h.keyword=17,h.snippet=27,h.text=18,h.color=19,h.file=20,h.reference=21,h.customcolor=22,h.folder=23,h["type-parameter"]=24,h.typeParameter=24,h.account=25,h.issue=26,function(b,f){let F=h[b];return typeof F=="undefined"&&!f&&(F=9),F}}();var u;(function(h){h[h.Deprecated=1]="Deprecated"})(u=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(h){h[h.KeepWhitespace=1]="KeepWhitespace",h[h.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var k;(function(h){h[h.Invoke=0]="Invoke",h[h.TriggerCharacter=1]="TriggerCharacter",h[h.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(k=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(h){h[h.Automatic=0]="Automatic",h[h.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var l;(function(h){h[h.Invoke=1]="Invoke",h[h.Auto=2]="Auto"})(l=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var v;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(v=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var D;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(D=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(h){return h&&c.URI.isUri(h.uri)&&M.Range.isIRange(h.range)&&(M.Range.isIRange(h.originSelectionRange)||M.Range.isIRange(h.targetSelectionRange))}e.isLocationLink=i;var s;(function(h){h[h.File=0]="File",h[h.Module=1]="Module",h[h.Namespace=2]="Namespace",h[h.Package=3]="Package",h[h.Class=4]="Class",h[h.Method=5]="Method",h[h.Property=6]="Property",h[h.Field=7]="Field",h[h.Constructor=8]="Constructor",h[h.Enum=9]="Enum",h[h.Interface=10]="Interface",h[h.Function=11]="Function",h[h.Variable=12]="Variable",h[h.Constant=13]="Constant",h[h.String=14]="String",h[h.Number=15]="Number",h[h.Boolean=16]="Boolean",h[h.Array=17]="Array",h[h.Object=18]="Object",h[h.Key=19]="Key",h[h.Null=20]="Null",h[h.EnumMember=21]="EnumMember",h[h.Struct=22]="Struct",h[h.Event=23]="Event",h[h.Operator=24]="Operator",h[h.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var a;(function(h){h[h.Deprecated=1]="Deprecated"})(a=e.SymbolTag||(e.SymbolTag={}));var o;(function(h){const b=new Map;b.set("file",0),b.set("module",1),b.set("namespace",2),b.set("package",3),b.set("class",4),b.set("method",5),b.set("property",6),b.set("field",7),b.set("constructor",8),b.set("enum",9),b.set("interface",10),b.set("function",11),b.set("variable",12),b.set("constant",13),b.set("string",14),b.set("number",15),b.set("boolean",16),b.set("array",17),b.set("object",18),b.set("key",19),b.set("null",20),b.set("enum-member",21),b.set("struct",22),b.set("event",23),b.set("operator",24),b.set("type-parameter",25);const f=new Map;f.set(0,"file"),f.set(1,"module"),f.set(2,"namespace"),f.set(3,"package"),f.set(4,"class"),f.set(5,"method"),f.set(6,"property"),f.set(7,"field"),f.set(8,"constructor"),f.set(9,"enum"),f.set(10,"interface"),f.set(11,"function"),f.set(12,"variable"),f.set(13,"constant"),f.set(14,"string"),f.set(15,"number"),f.set(16,"boolean"),f.set(17,"array"),f.set(18,"object"),f.set(19,"key"),f.set(20,"null"),f.set(21,"enum-member"),f.set(22,"struct"),f.set(23,"event"),f.set(24,"operator"),f.set(25,"type-parameter");function F(Q){return b.get(Q)}h.fromString=F;function O(Q){return f.get(Q)}h.toString=O;function q(Q,$){const z=f.get(Q);let N=z&&A.iconRegistry.get("symbol-"+z);return N||(console.info("No codicon found for SymbolKind "+Q),N=A.Codicon.symbolProperty),`${$?"inline":"block"} ${N.classNames}`}h.toCssClassName=q})(o=e.SymbolKinds||(e.SymbolKinds={}));class _{constructor(b){this.value=b}}e.FoldingRangeKind=_,_.Comment=new _("comment"),_.Imports=new _("imports"),_.Region=new _("region");var m;(function(h){h[h.Collapsed=0]="Collapsed",h[h.Expanded=1]="Expanded"})(m=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var g;(function(h){h[h.Editing=0]="Editing",h[h.Preview=1]="Preview"})(g=e.CommentMode||(e.CommentMode={}));var C;(function(h){h[h.Other=0]="Other",h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(C=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var R;(function(h){h[h.None=0]="None",h[h.Option=1]="Option",h[h.Default=2]="Default",h[h.Preferred=3]="Preferred"})(R=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[42],be([0,1,26,9,4]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=c.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",c.isMacintosh),A.set("isLinux",c.isLinux),A.set("isWindows",c.isWindows),A.set("isWeb",c.isWeb),A.set("isMacNative",c.isMacintosh&&!c.isWeb),A.set("isEdge",T.indexOf("Edg/")>=0),A.set("isFirefox",T.indexOf("Firefox")>=0),A.set("isChrome",T.indexOf("Chrome")>=0),A.set("isSafari",T.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var S;(function(b){b[b.False=0]="False",b[b.True=1]="True",b[b.Defined=2]="Defined",b[b.Not=3]="Not",b[b.Equals=4]="Equals",b[b.NotEquals=5]="NotEquals",b[b.And=6]="And",b[b.Regex=7]="Regex",b[b.NotRegex=8]="NotRegex",b[b.Or=9]="Or",b[b.In=10]="In",b[b.NotIn=11]="NotIn",b[b.Greater=12]="Greater",b[b.GreaterEquals=13]="GreaterEquals",b[b.Smaller=14]="Smaller",b[b.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return y.INSTANCE}static true(){return n.INSTANCE}static has(f){return d.create(f)}static equals(f,F){return r.create(f,F)}static notEquals(f,F){return k.create(f,F)}static regex(f,F){return s.create(f,F)}static in(f,F){return u.create(f,F)}static not(f){return w.create(f)}static and(...f){return o.create(f,null)}static or(...f){return _.create(f,null,!0)}static greater(f,F){return l.create(f,F)}static less(f,F){return D.create(f,F)}static deserialize(f,F=!1){if(!!f)return this._deserializeOrExpression(f,F)}static _deserializeOrExpression(f,F){let O=f.split("||");return _.create(O.map(q=>this._deserializeAndExpression(q,F)),null,!0)}static _deserializeAndExpression(f,F){let O=f.split("&&");return o.create(O.map(q=>this._deserializeOne(q,F)),null)}static _deserializeOne(f,F){if(f=f.trim(),f.indexOf("!=")>=0){let O=f.split("!=");return k.create(O[0].trim(),this._deserializeValue(O[1],F))}if(f.indexOf("==")>=0){let O=f.split("==");return r.create(O[0].trim(),this._deserializeValue(O[1],F))}if(f.indexOf("=~")>=0){let O=f.split("=~");return s.create(O[0].trim(),this._deserializeRegexValue(O[1],F))}if(f.indexOf(" in ")>=0){let O=f.split(" in ");return u.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(f)){const O=f.split(">=");return v.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(f)){const O=f.split(">");return l.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(f)){const O=f.split("<=");return i.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(f)){const O=f.split("<");return D.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(f)?w.create(f.substr(1).trim()):d.create(f)}static _deserializeValue(f,F){if(f=f.trim(),f==="true")return!0;if(f==="false")return!1;let O=/^'([^']*)'$/.exec(f);return O?O[1].trim():f}static _deserializeRegexValue(f,F){if((0,M.isFalsyOrWhitespace)(f)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=f.indexOf("/"),q=f.lastIndexOf("/");if(O===q||O<0){if(F)throw new Error(`bad regexp-value '${f}', missing /-enclosure`);return console.warn(`bad regexp-value '${f}', missing /-enclosure`),null}let Q=f.slice(O+1,q),$=f[q+1]==="i"?"i":"";try{return new RegExp(Q,$)}catch(z){if(F)throw new Error(`bad regexp-value '${f}', parse error: ${z}`);return console.warn(`bad regexp-value '${f}', parse error: ${z}`),null}}}e.ContextKeyExpr=I;function t(b,f){return b.cmp(f)}class y{constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return n.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class n{constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=n,n.INSTANCE=new n;class d{constructor(f,F){this.key=f,this.negated=F,this.type=2}static create(f,F=null){const O=A.get(f);return typeof O=="boolean"?O?n.INSTANCE:y.INSTANCE:new d(f,F)}cmp(f){return f.type!==this.type?this.type-f.type:g(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return this.negated||(this.negated=w.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=d;class r{constructor(f,F,O){this.key=f,this.value=F,this.negated=O,this.type=4}static create(f,F,O=null){if(typeof F=="boolean")return F?d.create(f,O):w.create(f,O);const q=A.get(f);return typeof q=="boolean"?F===(q?"true":"false")?n.INSTANCE:y.INSTANCE:new r(f,F,O)}cmp(f){return f.type!==this.type?this.type-f.type:C(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(f){return f.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=r;class u{constructor(f,F){this.key=f,this.valueKey=F,this.type=10,this.negated=null}static create(f,F){return new u(f,F)}cmp(f){return f.type!==this.type?this.type-f.type:C(this.key,this.valueKey,f.key,f.valueKey)}equals(f){return f.type===this.type?this.key===f.key&&this.valueKey===f.valueKey:!1}evaluate(f){const F=f.getValue(this.valueKey),O=f.getValue(this.key);return Array.isArray(F)?F.indexOf(O)>=0:typeof O=="string"&&typeof F=="object"&&F!==null?P.call(F,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(f){return f.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=p.create(this)),this.negated}}e.ContextKeyInExpr=u;class p{constructor(f){this._actual=f,this.type=11}static create(f){return new p(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new p(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class k{constructor(f,F,O){this.key=f,this.value=F,this.negated=O,this.type=5}static create(f,F,O=null){if(typeof F=="boolean")return F?w.create(f,O):d.create(f,O);const q=A.get(f);return typeof q=="boolean"?F===(q?"true":"false")?y.INSTANCE:n.INSTANCE:new k(f,F,O)}cmp(f){return f.type!==this.type?this.type-f.type:C(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(f){return f.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=k;class w{constructor(f,F){this.key=f,this.negated=F,this.type=3}static create(f,F=null){const O=A.get(f);return typeof O=="boolean"?O?y.INSTANCE:n.INSTANCE:new w(f,F)}cmp(f){return f.type!==this.type?this.type-f.type:g(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!f.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(f){return f.mapNot(this.key)}negate(){return this.negated||(this.negated=d.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=w;class l{constructor(f,F,O){this.key=f,this.value=F,this.negated=O,this.type=12}static create(f,F,O=null){return new l(f,F,O)}cmp(f){return f.type!==this.type?this.type-f.type:C(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class v{constructor(f,F,O){this.key=f,this.value=F,this.negated=O,this.type=13}static create(f,F,O=null){return new v(f,F,O)}cmp(f){return f.type!==this.type?this.type-f.type:C(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=v;class D{constructor(f,F,O){this.key=f,this.value=F,this.negated=O,this.type=14}static create(f,F,O=null){return new D(f,F,O)}cmp(f){return f.type!==this.type?this.type-f.type:C(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=D;class i{constructor(f,F,O){this.key=f,this.value=F,this.negated=O,this.type=15}static create(f,F,O=null){return new i(f,F,O)}cmp(f){return f.type!==this.type?this.type-f.type:C(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class s{constructor(f,F){this.key=f,this.regexp=F,this.type=7,this.negated=null}static create(f,F){return new s(f,F)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.key<f.key)return-1;if(this.key>f.key)return 1;const F=this.regexp?this.regexp.source:"",O=f.regexp?f.regexp.source:"";return F<O?-1:F>O?1:0}equals(f){if(f.type===this.type){const F=this.regexp?this.regexp.source:"",O=f.regexp?f.regexp.source:"";return this.key===f.key&&F===O}return!1}evaluate(f){let F=f.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const f=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${f}`}keys(){return[this.key]}map(f){return f.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=a.create(this)),this.negated}}e.ContextKeyRegexExpr=s;class a{constructor(f){this._actual=f,this.type=8}static create(f){return new a(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new a(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=a;class o{constructor(f,F){this.expr=f,this.negated=F,this.type=6}static create(f,F){return o._normalizeArr(f,F)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const q=t(this.expr[F],f.expr[F]);if(q!==0)return q}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(f.expr[F]))return!1;return!0}return!1}evaluate(f){for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].evaluate(f))return!1;return!0}static _normalizeArr(f,F){const O=[];let q=!1;for(const Q of f)if(!!Q){if(Q.type===1){q=!0;continue}if(Q.type===0)return y.INSTANCE;if(Q.type===6){O.push(...Q.expr);continue}O.push(Q)}if(O.length===0&&q)return n.INSTANCE;if(O.length!==0){if(O.length===1)return O[0];O.sort(t);for(let Q=1;Q<O.length;Q++)O[Q-1].equals(O[Q])&&(O.splice(Q,1),Q--);if(O.length===1)return O[0];for(;O.length>1;){const Q=O[O.length-1];if(Q.type!==9)break;O.pop();const $=O.pop(),z=O.length===0,N=_.create(Q.expr.map(W=>o.create([W,$],null)),null,z);N&&(O.push(N),O.sort(t))}return O.length===1?O[0]:new o(O,F)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(let F of this.expr)f.push(...F.keys());return f}map(f){return new o(this.expr.map(F=>F.map(f)),null)}negate(){if(!this.negated){const f=[];for(let F of this.expr)f.push(F.negate());this.negated=_.create(f,this,!0)}return this.negated}}class _{constructor(f,F){this.expr=f,this.negated=F,this.type=9}static create(f,F,O){return _._normalizeArr(f,F,O)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let F=0,O=this.expr.length;F<O;F++){const q=t(this.expr[F],f.expr[F]);if(q!==0)return q}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let F=0,O=this.expr.length;F<O;F++)if(!this.expr[F].equals(f.expr[F]))return!1;return!0}return!1}evaluate(f){for(let F=0,O=this.expr.length;F<O;F++)if(this.expr[F].evaluate(f))return!0;return!1}static _normalizeArr(f,F,O){let q=[],Q=!1;if(f){for(let $=0,z=f.length;$<z;$++){const N=f[$];if(!!N){if(N.type===0){Q=!0;continue}if(N.type===1)return n.INSTANCE;if(N.type===9){q=q.concat(N.expr);continue}q.push(N)}}if(q.length===0&&Q)return y.INSTANCE;q.sort(t)}if(q.length!==0){if(q.length===1)return q[0];for(let $=1;$<q.length;$++)q[$-1].equals(q[$])&&(q.splice($,1),$--);if(q.length===1)return q[0];if(O){for(let $=0;$<q.length;$++)for(let z=$+1;z<q.length;z++)R(q[$],q[z])&&(q.splice(z,1),z--);if(q.length===1)return q[0]}return new _(q,F)}}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(let F of this.expr)f.push(...F.keys());return f}map(f){return new _(this.expr.map(F=>F.map(f)),null)}negate(){if(!this.negated){let f=[];for(let F of this.expr)f.push(F.negate());for(;f.length>1;){const F=f.shift(),O=f.shift(),q=[];for(const $ of h(F))for(const z of h(O))q.push(o.create([$,z],null));const Q=f.length===0;f.unshift(_.create(q,null,Q))}this.negated=f[0]}return this.negated}}class m extends d{constructor(f,F,O){super(f,null);this._defaultValue=F,typeof O=="object"?m._info.push({...O,key:f}):O!==!0&&m._info.push({key:f,description:O,type:F!=null?typeof F:void 0})}static all(){return m._info.values()}bindTo(f){return f.createKey(this.key,this._defaultValue)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(f){return r.create(this.key,f)}notEqualsTo(f){return k.create(this.key,f)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(b,f){return b<f?-1:b>f?1:0}function C(b,f,F,O){return b<F?-1:b>F?1:f<O?-1:f>O?1:0}function R(b,f){if(f.type===6&&b.type!==9&&b.type!==6){for(const q of f.expr)if(b.equals(q))return!0}const F=b.negate(),O=h(F).concat(h(f));O.sort(t);for(let q=0;q<O.length;q++){const $=O[q].negate();for(let z=q+1;z<O.length;z++){const N=O[z];if($.equals(N))return!0}}return!1}e.implies=R;function h(b){return b.type===9?b.expr:[b]}}),define(we[141],be([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(we[25],be([0,1,9,4]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function E(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=E;function T(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class P{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,n){if(typeof y=="undefined"||y===null)return typeof n=="undefined"||n===null;if(typeof n=="undefined"||n===null)return!1;if(typeof y=="string"||typeof n=="string"){let d=typeof y=="string"?y:y.value,r=typeof n=="string"?n:n.value;return c.equalsIgnoreCase(d,r)}return y._lower===n._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=P;function S(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function I(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=I,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[142],be([0,1,9,25]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(r,u){return r.uuid&&u.uuid?r.uuid===u.uuid:r.id===u.id?!0:(0,c.compareIgnoreCase)(r.id,u.id)===0}e.areSameExtensions=E;class T{constructor(u,p){this.version=p,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof T?E(this,u)&&this.version===u.version:!1}}e.ExtensionIdentifierWithVersion=T;function A(r,u){return`${r}.${u}`}e.getExtensionId=A;function P(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function S(r,u){return P(A(r,u))}e.getGalleryExtensionId=S;function I(r,u){const p=[],k=w=>{for(const l of p)if(l.some(v=>E(u(v),u(w))))return l;return null};for(const w of r){const l=k(w);l?l.push(w):p.push([w])}return p}e.groupByExtension=I;function t(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function y(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(r){const u=new Set;for(const p of r)p.malicious&&u.add(p.id.id);return u}e.getMaliciousExtensionsSet=n;function d(r,u){const p=[],k=u.manifest.extensionDependencies?.slice(0)??[];for(;k.length;){const w=k.shift();if(w&&p.every(l=>!E(l.identifier,{id:w}))){const l=r.filter(v=>E(v.identifier,{id:w}));l.length===1&&(p.push(l[0]),k.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.getExtensionDependencies=d}),define(we[59],be([0,1,20,17,9,10,2,120,4]),function(re,e,c,M,E,T,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function I($){return $.create===!0}e.isFileOpenForWriteOptions=I;var t;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var y;(function($){$[$.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var n;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d($){return!!($.capabilities&2)}e.hasReadWriteCapability=d;function r($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=r;function u($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function p($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=p;var k;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(k=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(z,N){super(z);this.code=N}}e.FileSystemProviderError=w;function l($,z){const N=new w($.toString(),z);return D(N,z),N}e.createFileSystemProviderError=l;function v($){return $||l((0,P.localize)(0,null),k.Unknown)}e.ensureFileSystemProviderError=v;function D($,z){return $.name=z?`${z} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=D;function i($){if(!$)return k.Unknown;if($ instanceof w)return $.code;const z=/^(.+) \(FileSystemError\)$/.exec($.name);if(!z)return k.Unknown;switch(z[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileExceedsMemoryLimit:return k.FileExceedsMemoryLimit;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}e.toFileSystemProviderErrorCode=i;function s($){if($ instanceof C)return $.fileOperationResult;switch(i($)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 10;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileExceedsMemoryLimit:return 9;case k.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var a;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY"})(a=e.FileOperation||(e.FileOperation={}));class o{constructor(z,N,W){this.resource=z,this.operation=N,this.target=W}isOperation(z){return this.operation===z}}e.FileOperationEvent=o;var _;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(_=e.FileChangeType||(e.FileChangeType={}));class m{constructor(z,N){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const W of z)switch(W.type){case 1:this.added||(this.added=c.TernarySearchTree.forUris(()=>N)),this.added.set(W.resource,W);break;case 0:this.updated||(this.updated=c.TernarySearchTree.forUris(()=>N)),this.updated.set(W.resource,W);break;case 2:this.deleted||(this.deleted=c.TernarySearchTree.forUris(()=>N)),this.deleted.set(W.resource,W);break}}contains(z,...N){return this.doContains(z,{includeChildren:!1},...N)}affects(z,...N){return this.doContains(z,{includeChildren:!0},...N)}doContains(z,N,...W){if(!z)return!1;const j=W.length>0;return!!((!j||W.includes(1))&&(this.added?.get(z)||N.includeChildren&&this.added?.findSuperstr(z))||(!j||W.includes(0))&&(this.updated?.get(z)||N.includeChildren&&this.updated?.findSuperstr(z))||(!j||W.includes(2))&&(this.deleted?.findSubstr(z)||N.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=m;function g($,z,N){return!$||!z||$===z||z.length>$.length?!1:(z.charAt(z.length-1)!==M.sep&&(z+=M.sep),N?(0,E.startsWithIgnoreCase)($,z):$.indexOf(z)===0)}e.isParent=g;class C extends Error{constructor(z,N,W){super(z);this.fileOperationResult=N,this.options=W}}e.FileOperationError=C;class R extends C{constructor(z,N,W){super(z,2,W);this.stat=N}}e.NotModifiedSinceFileOperationError=R;var h;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(h=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var b;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(b=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function f($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=f;async function F($,z){if(!z.canHandleResource(A.URI.from({scheme:$.scheme})))return new Promise(N=>{const W=z.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===$.scheme&&j.added&&(W.dispose(),N())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(z){return(0,T.isNumber)(z)||(z=0),z<O.KB?(0,P.localize)(1,null,z.toFixed(0)):z<O.MB?(0,P.localize)(2,null,(z/O.KB).toFixed(2)):z<O.GB?(0,P.localize)(3,null,(z/O.MB).toFixed(2)):z<O.TB?(0,P.localize)(4,null,(z/O.GB).toFixed(2)):(0,P.localize)(5,null,(z/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var q;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function Q($){return{maxFileSize:$===0?300*O.MB:16*O.GB,maxHeapSize:$===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=Q}),define(we[60],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...E){this._entries=new Map;for(let[T,A]of E)this.set(T,A)}set(E,T){const A=this._entries.get(E);return this._entries.set(E,T),A}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=c}),define(we[143],be([0,1,13,15,81,138,4,60]),function(re,e,c,M,E,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class I extends Error{constructor(r){super("cyclic dependency between services");this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class t{constructor(r=new P.ServiceCollection,u=!1,p){this._activeInstantiations=new Set,this._services=r,this._strict=u,this._parent=p,this._services.set(A.IInstantiationService,this)}createChild(r){return new t(r,this._strict,this)}invokeFunction(r,...u){let p=n.traceInvocation(r),k=!1;try{return r({get:(l,v)=>{if(k)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const D=this._getOrCreateServiceInstance(l,p);if(!D&&v!==A.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return D}},...u)}finally{k=!0,p.stop()}}createInstance(r,...u){let p,k;return r instanceof E.SyncDescriptor?(p=n.traceCreation(r.ctor),k=this._createInstance(r.ctor,r.staticArguments.concat(u),p)):(p=n.traceCreation(r),k=this._createInstance(r,u,p)),p.stop(),k}_createInstance(r,u=[],p){let k=A._util.getServiceDependencies(r).sort((v,D)=>v.index-D.index),w=[];for(const v of k){let D=this._getOrCreateServiceInstance(v.id,p);if(!D&&this._strict&&!v.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${v.id}.`);w.push(D)}let l=k.length>0?k[0].index:u.length;if(u.length!==l){console.warn(`[createInstance] First service dependency of ${r.name} at position ${l+1} conflicts with ${u.length} static arguments`);let v=l-u.length;v>0?u=u.concat(new Array(v)):u=u.slice(0,l)}return new r(...[...u,...w])}_setServiceInstance(r,u){if(this._services.get(r)instanceof E.SyncDescriptor)this._services.set(r,u);else if(this._parent)this._parent._setServiceInstance(r,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let u=this._services.get(r);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):u}_getOrCreateServiceInstance(r,u){let p=this._getServiceInstanceOrDescriptor(r);return p instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,p,u.branch(r,!0)):(u.branch(r,!1),p)}_safeCreateAndCacheServiceInstance(r,u,p){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,u,p)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,u,p){const k=new T.Graph(v=>v.id.toString());let w=0;const l=[{id:r,desc:u,_trace:p}];for(;l.length;){const v=l.pop();if(k.lookupOrInsertNode(v),w++>1e3)throw new I(k);for(let D of A._util.getServiceDependencies(v.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(D.id);if(!i&&!D.optional&&console.warn(`[createInstance] ${r} depends on ${D.id} which is NOT registered.`),i instanceof E.SyncDescriptor){const s={id:D.id,desc:i,_trace:v._trace.branch(D.id,!0)};k.insertEdge(v,s),l.push(s)}}}for(;;){const v=k.roots();if(v.length===0){if(!k.isEmpty())throw new I(k);break}for(const{data:D}of v){if(this._getServiceInstanceOrDescriptor(D.id)instanceof E.SyncDescriptor){const s=this._createServiceInstanceWithOwner(D.id,D.desc.ctor,D.desc.staticArguments,D.desc.supportsDelayedInstantiation,D._trace);this._setServiceInstance(D.id,s)}k.removeNode(D)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,u,p=[],k,w){if(this._services.get(r)instanceof E.SyncDescriptor)return this._createServiceInstance(u,p,k,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,u,p,k,w);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(r,u=[],p,k){if(p){const w=new c.IdleValue(()=>this._createInstance(r,u,k));return new Proxy(Object.create(null),{get(l,v){if(v in l)return l[v];let D=w.value,i=D[v];return typeof i!="function"||(i=i.bind(D),l[v]=i),i},set(l,v,D){return w.value[v]=D,!0}})}else return this._createInstance(r,u,k)}}e.InstantiationService=t;var y;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(y||(y={}));class n{constructor(r,u){this.type=r,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return S?new n(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(r){return S?new n(0,r.name):n._None}branch(r,u){let p=new n(2,r.toString());return this._dep.push([r,u,p]),p}stop(){let r=Date.now()-this._start;n._totals+=r;let u=!1;function p(w,l){let v=[],D=new Array(w+1).join("	");for(const[i,s,a]of l._dep)if(s&&a){u=!0,v.push(`${D}CREATES -> ${i}`);let o=p(w+1,a);o&&v.push(o)}else v.push(`${D}uses -> ${i}`);return v.join(`
`)}let k=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(r>2||u)&&console.log(k.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(we[14],be([0,1,55,3,7,26,4]),function(re,e,c,M,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function P(){return new Date().toISOString()}var S;(function(D){D[D.Trace=0]="Trace",D[D.Debug=1]="Debug",D[D.Info=2]="Info",D[D.Warning=3]="Warning",D[D.Error=4]="Error",D[D.Critical=5]="Critical",D[D.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class I extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class t extends I{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...s){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([i,...s]))}debug(i,...s){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([i,...s]))}info(i,...s){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([i,...s]))}warn(i,...s){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([i,...s]))}error(i,...s){if(this.checkLogLevel(S.Error))if(i instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=i.stack,this.log(S.Error,this.format(a))}else this.log(S.Error,this.format([i,...s]))}critical(i,...s){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([i,...s]))}flush(){}format(i){let s="";for(let a=0;a<i.length;a++){let o=i[a];if(typeof o=="object")try{o=JSON.stringify(o)}catch(_){}s+=(a>0?" ":"")+o}return s}}e.AbstractMessageLogger=t;class y extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!T.isWindows}trace(i,...s){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...s):console.log(`[main ${P()}]`,i,...s))}debug(i,...s){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...s):console.log(`[main ${P()}]`,i,...s))}info(i,...s){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...s):console.log(`[main ${P()}]`,i,...s))}warn(i,...s){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,i,...s):console.warn(`[main ${P()}]`,i,...s))}error(i,...s){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,i,...s):console.error(`[main ${P()}]`,i,...s))}critical(i,...s){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,i,...s):console.error(`[main ${P()}]`,i,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class n extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...s){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",i,...s)}debug(i,...s){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...s)}info(i,...s){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",i,...s)}warn(i,...s){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",i,...s)}error(i,...s){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",i,...s)}critical(i,...s){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...s)}dispose(){}flush(){}}e.ConsoleLogger=n;class d extends I{constructor(i,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(s)}trace(i,...s){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(i),...s])}debug(i,...s){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(i),...s])}info(i,...s){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(i),...s])}warn(i,...s){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(i),...s])}error(i,...s){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(i),...s])}critical(i,...s){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(i),...s])}extractMessage(i){return typeof i=="string"?i:(0,c.toErrorMessage)(i,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class r extends I{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const s of this.logServices)s.setLevel(i);super.setLevel(i)}trace(i,...s){for(const a of this.logServices)a.trace(i,...s)}debug(i,...s){for(const a of this.logServices)a.debug(i,...s)}info(i,...s){for(const a of this.logServices)a.info(i,...s)}warn(i,...s){for(const a of this.logServices)a.warn(i,...s)}error(i,...s){for(const a of this.logServices)a.error(i,...s)}critical(i,...s){for(const a of this.logServices)a.critical(i,...s)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=r;class u extends E.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...s){this.logger.trace(i,...s)}debug(i,...s){this.logger.debug(i,...s)}info(i,...s){this.logger.info(i,...s)}warn(i,...s){this.logger.warn(i,...s)}error(i,...s){this.logger.error(i,...s)}critical(i,...s){this.logger.critical(i,...s)}flush(){this.logger.flush()}}e.LogService=u;class p extends E.Disposable{constructor(i,s){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(a))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,s){let a=this.loggers.get(i.toString());return a||(a=this.doCreateLogger(i,s?.always?S.Trace:this.logLevel,s),this.loggers.set(i.toString(),a),s?.always||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class k{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(i){}getLevel(){return S.Info}trace(i,...s){}debug(i,...s){}info(i,...s){}warn(i,...s){}error(i,...s){}critical(i,...s){}dispose(){}flush(){}}e.NullLogService=k;function w(D){if(D.verbose)return S.Trace;if(typeof D.logLevel=="string"){const i=l(D.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function l(D){switch(D){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=l;function v(D){switch(D){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=v}),define(we[82],be([0,1,35,121,4]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var A;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function I(r,u){return u-r}S.compare=I;const t=Object.create(null);t[S.Error]=(0,M.localize)(0,null),t[S.Warning]=(0,M.localize)(1,null),t[S.Info]=(0,M.localize)(2,null);function y(r){return t[r]||""}S.toString=y;function n(r){switch(r){case c.default.Error:return S.Error;case c.default.Warning:return S.Warning;case c.default.Info:return S.Info;case c.default.Ignore:return S.Hint}}S.fromSeverity=n;function d(r){switch(r){case S.Error:return c.default.Error;case S.Warning:return c.default.Warning;case S.Info:return c.default.Info;case S.Hint:return c.default.Ignore}}S.toSeverity=d}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(S){const I="";function t(n){return y(n,!0)}S.makeKey=t;function y(n,d){let r=[I];return n.source?r.push(n.source.replace("\xA6","\\\xA6")):r.push(I),n.code?typeof n.code=="string"?r.push(n.code.replace("\xA6","\\\xA6")):r.push(n.code.value.replace("\xA6","\\\xA6")):r.push(I),n.severity!==void 0&&n.severity!==null?r.push(A.toString(n.severity)):r.push(I),n.message&&d?r.push(n.message.replace("\xA6","\\\xA6")):r.push(I),n.startLineNumber!==void 0&&n.startLineNumber!==null?r.push(n.startLineNumber.toString()):r.push(I),n.startColumn!==void 0&&n.startColumn!==null?r.push(n.startColumn.toString()):r.push(I),n.endLineNumber!==void 0&&n.endLineNumber!==null?r.push(n.endLineNumber.toString()):r.push(I),n.endColumn!==void 0&&n.endColumn!==null?r.push(n.endColumn.toString()):r.push(I),r.push(I),r.join("\xA6")}S.makeKeyOptionalMessage=y})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(we[144],be([0,1,3,35,4]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,E.createDecorator)("notificationService");var T;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new S,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=P;class S{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=S}),define(we[145],be([0,1,7,9,2,4]),function(re,e,c,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return c.Disposable.None},registerValidator(){return c.Disposable.None},registerExternalUriResolver(){return c.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return c.Disposable.None},async open(){return!1},async resolveExternalUri(P){return{resolved:P,dispose(){}}}});function A(P,S){return E.URI.isUri(P)?(0,M.equalsIgnoreCase)(P.scheme,S):(0,M.startsWithIgnoreCase)(P,S+":")}e.matchesScheme=A});var Ue=this&&this.__decorate||function(re,e,c,M){var E=arguments.length,T=E<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,c):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(re,e,c,M);else for(var P=re.length-1;P>=0;P--)(A=re[P])&&(T=(E<3?A(T):E>3?A(e,c,T):A(e,c))||T);return E>3&&T&&Object.defineProperty(e,c,T),T},ze=this&&this.__param||function(re,e){return function(c,M){e(c,M,re)}};define(we[146],be([0,1,13,21,7,4]),function(re,e,c,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var A;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(y){this.callback=y}get value(){return this._value}report(y){this._value=y,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let S=class extends E.Disposable{constructor(y,n){super();this.deferred=new c.DeferredPromise,n.withProgress(y,d=>(this.reporter=d,this.lastStep&&d.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};S=Ue([ze(1,e.IProgressService)],S),e.UnmanagedProgress=S;class I extends E.Disposable{constructor(y){super();this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(y){this.stop();const n=++this.currentOperationId,d=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>d.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:d.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(we[28],be([0,1,39,10]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(A,P){c.ok(M.isString(A)),c.ok(M.isObject(P)),c.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new E}),define(we[83],be([0,1,3,28]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new c.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,I){this.schemasById[E(S)]=I,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;M.Registry.add(e.Extensions.JSONContribution,A)}),define(we[61],be([0,1,3,10,118,83,28]),function(re,e,c,M,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(k){k.Multiline="multilineText",k.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(k){k[k.APPLICATION=1]="APPLICATION",k[k.MACHINE=2]="MACHINE",k[k.WINDOW=3]="WINDOW",k[k.RESOURCE=4]="RESOURCE",k[k.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",k[k.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const I=A.Registry.as(T.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new c.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new c.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,l=!0){this.registerConfigurations([w],l)}registerConfigurations(w,l=!0){const v=[];w.forEach(D=>{v.push(...this.validateAndRegisterProperties(D,l,D.extensionInfo)),this.configurationContributors.push(D),this.registerJSONConfiguration(D)}),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterConfigurations(w){const l=[],v=D=>{if(D.properties)for(const i in D.properties)l.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,D.properties[i]);D.allOf&&D.allOf.forEach(i=>v(i))};for(const D of w){v(D);const i=this.configurationContributors.indexOf(D);i!==-1&&this.configurationContributors.splice(i,1)}I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}registerDefaultConfigurations(w){const l=[],v=[];for(const D of w)for(const i in D)if(l.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...D[i]};const s={type:"object",default:this.defaultValues[i],description:E.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};v.push(n(i)),this.configurationProperties[i]=s,this.defaultLanguageConfigurationOverridesNode.properties[i]=s}else{this.defaultValues[i]=D[i];const s=this.configurationProperties[i];s&&(this.updatePropertyDefaultValue(i,s),this.updateSchema(i,s))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(w){const l=[];for(const v of w)for(const D in v)if(l.push(D),delete this.defaultValues[D],e.OVERRIDE_PROPERTY_PATTERN.test(D))delete this.configurationProperties[D],delete this.defaultLanguageConfigurationOverridesNode.properties[D];else{const i=this.configurationProperties[D];i&&(this.updatePropertyDefaultValue(D,i),this.updateSchema(D,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const l of w)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,l=!0,v,D=3){D=M.isUndefinedOrNull(w.scope)?D:w.scope;let i=[],s=w.properties;if(s)for(let o in s){if(l&&u(o)){delete s[o];continue}const _=s[o];if(this.updatePropertyDefaultValue(o,_),e.OVERRIDE_PROPERTY_PATTERN.test(o)?_.scope=void 0:(_.scope=M.isUndefinedOrNull(_.scope)?D:_.scope,_.restricted=M.isUndefinedOrNull(_.restricted)?!!v?.restrictedConfigurations?.includes(o):_.restricted),s[o].hasOwnProperty("included")&&!s[o].included){this.excludedConfigurationProperties[o]=s[o],delete s[o];continue}else this.configurationProperties[o]=s[o];!s[o].deprecationMessage&&s[o].markdownDeprecationMessage&&(s[o].deprecationMessage=s[o].markdownDeprecationMessage),i.push(o)}let a=w.allOf;if(a)for(let o of a)i.push(...this.validateAndRegisterProperties(o,l,v,D));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const l=v=>{let D=v.properties;if(D)for(const s in D)this.updateSchema(s,D[s]);let i=v.allOf;i&&i.forEach(l)};l(w)}updateSchema(w,l){switch(e.allSettings.properties[w]=l,l.scope){case 1:e.applicationSettings.properties[w]=l;break;case 2:e.machineSettings.properties[w]=l;break;case 6:e.machineOverridableSettings.properties[w]=l;break;case 3:e.windowSettings.properties[w]=l;break;case 4:e.resourceSettings.properties[w]=l;break;case 5:e.resourceSettings.properties[w]=l,this.resourceLanguageSettingsSchema.properties[w]=l;break}}removeFromSchema(w,l){switch(delete e.allSettings.properties[w],l.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const l=`[${w}]`,v={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,v),e.allSettings.properties[l]=v,e.applicationSettings.properties[l]=v,e.machineSettings.properties[l]=v,e.machineOverridableSettings.properties[l]=v,e.windowSettings.properties[l]=v,e.resourceSettings.properties[l]=v}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,l){let v=this.defaultValues[w];M.isUndefined(v)&&(v=l.default),M.isUndefined(v)&&(v=d(l.type)),l.default=v}}const y="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(y);function n(k){return k.substring(1,k.length-1)}e.overrideIdentifierFromKey=n;function d(k){switch(Array.isArray(k)?k[0]:k){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const r=new t;A.Registry.add(e.Extensions.Configuration,r);function u(k){return k.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(k)?E.localize(5,null,k):r.getConfigurationProperties()[k]!==void 0?E.localize(6,null,k):null:E.localize(4,null)}e.validateProperty=u;function p(){const k=[],w=r.getConfigurationProperties();for(const l of Object.keys(w))k.push([l,w[l].scope]);return k.push(["launch",4]),k.push(["task",4]),k}e.getScopes=p}),define(we[84],be([0,1,22,10,2,61,4,28]),function(re,e,c,M,E,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function S(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof E.URI)}e.isConfigurationOverrides=S;var I;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function y(s,a){const o=a?s?a.keys.filter(b=>s.keys.indexOf(b)===-1):[...a.keys]:[],_=s?a?s.keys.filter(b=>a.keys.indexOf(b)===-1):[...s.keys]:[],m=[];if(a&&s){for(const b of s.keys)if(a.keys.indexOf(b)!==-1){const f=k(s.contents,b),F=k(a.contents,b);c.equals(f,F)||m.push(b)}}const g=[],C=b=>{const f={};for(const F of b)for(const O of F.identifiers)f[D(O)]=F;return f},R=a?C(a.overrides):{},h=s?C(s.overrides):{};if(Object.keys(R).length)for(const b of o){const f=R[b];f&&g.push([(0,T.overrideIdentifierFromKey)(b),f.keys])}if(Object.keys(h).length)for(const b of _){const f=h[b];f&&g.push([(0,T.overrideIdentifierFromKey)(b),f.keys])}if(Object.keys(R).length&&Object.keys(h).length)for(const b of m){const f=h[b],F=R[b];if(f&&F){const O=y({contents:f.contents,keys:f.keys,overrides:[]},{contents:F.contents,keys:F.keys,overrides:[]});g.push([(0,T.overrideIdentifierFromKey)(b),[...O.added,...O.removed,...O.updated]])}}return{added:o,removed:_,updated:m,overrides:g}}e.compare=y;function n(s,a){const o=[];for(const _ of Object.keys(s))if(T.OVERRIDE_PROPERTY_PATTERN.test(_)){const m={};for(const g in s[_])m[g]=s[_][g];o.push({identifiers:[(0,T.overrideIdentifierFromKey)(_).trim()],keys:Object.keys(m),contents:d(m,a)})}return o}e.toOverrides=n;function d(s,a){const o=Object.create(null);for(let _ in s)r(o,_,s[_],a);return o}e.toValuesTree=d;function r(s,a,o,_){const m=a.split("."),g=m.pop();let C=s;for(let R=0;R<m.length;R++){let h=m[R],b=C[h];switch(typeof b){case"undefined":b=C[h]=Object.create(null);break;case"object":break;default:_(`Ignoring ${a} as ${m.slice(0,R+1).join(".")} is ${JSON.stringify(b)}`);return}C=b}if(typeof C=="object"&&C!==null)try{C[g]=o}catch(R){_(`Ignoring ${a} as ${m.join(".")} is ${JSON.stringify(C)}`)}else _(`Ignoring ${a} as ${m.join(".")} is ${JSON.stringify(C)}`)}e.addToValueTree=r;function u(s,a){const o=a.split(".");p(s,o)}e.removeFromValueTree=u;function p(s,a){const o=a.shift();if(a.length===0){delete s[o];return}if(Object.keys(s).indexOf(o)!==-1){const _=s[o];typeof _=="object"&&!Array.isArray(_)&&(p(_,a),Object.keys(_).length===0&&delete s[o])}}function k(s,a,o){function _(C,R){let h=C;for(const b of R){if(typeof h!="object"||h===null)return;h=h[b]}return h}const m=a.split("."),g=_(s,m);return typeof g=="undefined"?o:g}e.getConfigurationValue=k;function w(s,a,o){Object.keys(a).forEach(_=>{_!=="__proto__"&&(_ in s?M.isObject(s[_])&&M.isObject(a[_])?w(s[_],a[_],o):o&&(s[_]=a[_]):s[_]=a[_])})}e.merge=w;function l(){const s=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=l;function v(){const s=Object.create(null),a=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let o in a){let _=a[o].default;r(s,o,_,m=>console.error(`Conflict in default settings: ${m}`))}return s}e.getDefaultValues=v;function D(s){return`[${s}]`}e.keyFromOverrideIdentifier=D;function i(s,a,o){const _=s.inspect(a),m=s.inspect(o);return typeof _.userValue!="undefined"||typeof _.workspaceValue!="undefined"||typeof _.workspaceFolderValue!="undefined"?_.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:_.defaultValue}e.getMigratedSettingValue=i}),define(we[147],be([0,1,16,3,102,7,20,22,10,2,84,61,28]),function(re,e,c,M,E,T,A,P,S,I,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(i={},s=[],a=[]){this._contents=i,this._keys=s,this._overrides=a,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,s){const a=this.getContentsForOverrideIdentifer(s);return a?i?(0,t.getConfigurationValue)(a,i):a:void 0}getKeysForOverrideIdentifier(i){for(const s of this.overrides)if(s.identifiers.indexOf(i)!==-1)return s.keys;return[]}override(i){const s=this.getContentsForOverrideIdentifer(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let a={};for(const o of c.distinct([...Object.keys(this.contents),...Object.keys(s)])){let _=this.contents[o],m=s[o];m&&(typeof _=="object"&&typeof m=="object"?(_=P.deepClone(_),this.mergeContents(_,m)):_=m),a[o]=_}return new d(a,this.keys,this.overrides)}merge(...i){const s=P.deepClone(this.contents),a=P.deepClone(this.overrides),o=[...this.keys];for(const _ of i){this.mergeContents(s,_.contents);for(const m of _.overrides){const[g]=a.filter(C=>c.equals(C.identifiers,m.identifiers));g?this.mergeContents(g.contents,m.contents):a.push(P.deepClone(m))}for(const m of _.keys)o.indexOf(m)===-1&&o.push(m)}return new d(s,o,a)}freeze(){return this.isFrozen=!0,this}mergeContents(i,s){for(const a of Object.keys(s)){if(a in i&&S.isObject(i[a])&&S.isObject(s[a])){this.mergeContents(i[a],s[a]);continue}i[a]=P.deepClone(s[a])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?P.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const s of this.overrides)if(s.identifiers.indexOf(i)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,s){this.addKey(i),(0,t.addToValueTree)(this.contents,i,s,a=>{throw new Error(a)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let s=this.keys.length;for(let a=0;a<s;a++)i.indexOf(this.keys[a])===0&&(s=a);this.keys.splice(s,1,i)}removeKey(i){let s=this.keys.indexOf(i);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=d;class r extends d{constructor(){const i=(0,t.getDefaultValues)(),s=(0,t.getConfigurationKeys)(),a=[];for(const o of Object.keys(i))y.OVERRIDE_PROPERTY_PATTERN.test(o)&&a.push({identifiers:[(0,y.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(i[o]),contents:(0,t.toValuesTree)(i[o],_=>console.error(`Conflict in default settings file: ${_}`))});super(i,s,a)}}e.DefaultConfigurationModel=r;class u{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,s){if(!S.isUndefinedOrNull(i)){const a=this.doParseContent(i);this.parseRaw(a,s)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,s){this._raw=i;const{contents:a,keys:o,overrides:_,restricted:m}=this.doParseRaw(i,s);this._configurationModel=new d(a,o,_),this._restrictedConfigurations=m||[]}doParseContent(i){let s={},a=null,o=[],_=[],m=[];function g(R){Array.isArray(o)?o.push(R):a!==null&&(o[a]=R)}let C={onObjectBegin:()=>{let R={};g(R),_.push(o),o=R,a=null},onObjectProperty:R=>{a=R},onObjectEnd:()=>{o=_.pop()},onArrayBegin:()=>{let R=[];g(R),_.push(o),o=R,a=null},onArrayEnd:()=>{o=_.pop()},onLiteralValue:g,onError:(R,h,b)=>{m.push({error:R,offset:h,length:b})}};if(i)try{E.visit(i,C),s=o[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return s}doParseRaw(i,s){const a=n.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,a,!0,s);i=o.raw;const _=(0,t.toValuesTree)(i,C=>console.error(`Conflict in settings file ${this._name}: ${C}`)),m=Object.keys(i),g=(0,t.toOverrides)(i,C=>console.error(`Conflict in settings file ${this._name}: ${C}`));return{contents:_,keys:m,overrides:g,restricted:o.restricted}}filter(i,s,a,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[]};const _={},m=[];for(let g in i)if(y.OVERRIDE_PROPERTY_PATTERN.test(g)&&a){const C=this.filter(i[g],s,!1,o);_[g]=C.raw,m.push(...C.restricted)}else{const C=s[g],R=C?typeof C.scope!="undefined"?C.scope:3:void 0;C?.restricted&&m.push(g),(R===void 0||o.scopes===void 0||o.scopes.includes(R))&&(o.skipRestricted&&C?.restricted||(_[g]=i[g]))}return{raw:_,restricted:m}}}e.ConfigurationModelParser=u;class p extends T.Disposable{constructor(i,s,a,o){super();this.userSettingsResource=i,this.scopes=s,this.fileService=o,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,_=>_.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class k{constructor(i,s,a=new d,o=new d,_=new A.ResourceMap,m=new d,g=new A.ResourceMap,C=!0){this._defaultConfiguration=i,this._localUserConfiguration=s,this._remoteUserConfiguration=a,this._workspaceConfiguration=o,this._folderConfigurations=_,this._memoryConfiguration=m,this._memoryConfigurationByResource=g,this._freeze=C,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(i,s,a){return this.getConsolidateConfigurationModel(s,a).getValue(i)}updateValue(i,s,a={}){let o;a.resource?(o=this._memoryConfigurationByResource.get(a.resource),o||(o=new d,this._memoryConfigurationByResource.set(a.resource,o))):o=this._memoryConfiguration,s===void 0?o.removeValue(i):o.setValue(i,s),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,s,a){const o=this.getConsolidateConfigurationModel(s,a),_=this.getFolderConfigurationModelForResource(s.resource,a),m=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,g=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),C=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),R=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),h=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),b=a?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,f=_?s.overrideIdentifier?_.freeze().override(s.overrideIdentifier).getValue(i):_.freeze().getValue(i):void 0,F=s.overrideIdentifier?m.override(s.overrideIdentifier).getValue(i):m.getValue(i),O=o.getValue(i),q=c.distinct(c.flatten(o.overrides.map(Q=>Q.identifiers))).filter(Q=>o.getOverrideValue(i,Q)!==void 0);return{defaultValue:g,userValue:C,userLocalValue:R,userRemoteValue:h,workspaceValue:b,workspaceFolderValue:f,memoryValue:F,value:O,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,user:C!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userRemote:h!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspace:b!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspaceFolder:f!==void 0?{value:_?.freeze().getValue(i),override:s.overrideIdentifier?_?.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:m.getValue(i),override:s.overrideIdentifier?m.getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(i){const s=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,s){this._folderConfigurations.set(i,s),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const a=s.filter(o=>y.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const _=(0,y.overrideIdentifierFromKey)(o),m=this._defaultConfiguration.getKeysForOverrideIdentifier(_),g=i.getKeysForOverrideIdentifier(_),C=[...g.filter(R=>m.indexOf(R)===-1),...m.filter(R=>g.indexOf(R)===-1),...m.filter(R=>!P.equals(this._defaultConfiguration.override(_).getValue(R),i.override(_).getValue(R)))];return[_,C]});return this.updateDefaultConfiguration(i),{keys:s,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:a,removed:o,overrides:_}=(0,t.compare)(this.localUserConfiguration,i),m=[...s,...a,...o];return m.length&&this.updateLocalUserConfiguration(i),{keys:m,overrides:_}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:a,removed:o,overrides:_}=(0,t.compare)(this.remoteUserConfiguration,i);let m=[...s,...a,...o];return m.length&&this.updateRemoteUserConfiguration(i),{keys:m,overrides:_}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:a,removed:o,overrides:_}=(0,t.compare)(this.workspaceConfiguration,i);let m=[...s,...a,...o];return m.length&&this.updateWorkspaceConfiguration(i),{keys:m,overrides:_}}compareAndUpdateFolderConfiguration(i,s){const a=this.folderConfigurations.get(i),{added:o,updated:_,removed:m,overrides:g}=(0,t.compare)(a,s);let C=[...o,..._,...m];return(C.length||!a)&&this.updateFolderConfiguration(i,s),{keys:C,overrides:g}}compareAndDeleteFolderConfiguration(i){const s=this.folderConfigurations.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:a,updated:o,removed:_,overrides:m}=(0,t.compare)(s,void 0);return{keys:[...a,...o,..._],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,s){let a=this.getConsolidatedConfigurationModelForResource(i,s);return i.overrideIdentifier?a.override(i.overrideIdentifier):a}getConsolidatedConfigurationModelForResource({resource:i},s){let a=this.getWorkspaceConsolidatedConfiguration();if(s&&i){const o=s.getFolder(i);o&&(a=this.getFolderConsolidatedConfiguration(o.uri)||a);const _=this._memoryConfigurationByResource.get(i);_&&(a=a.merge(_))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let s=this._foldersConsolidatedConfigurations.get(i);if(!s){const a=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(s=a.merge(o),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(i,s)):s=a}return s}getFolderConfigurationModelForResource(i,s){if(s&&i){const a=s.getFolder(i);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,s)=>{const{contents:a,overrides:o,keys:_}=this._folderConfigurations.get(s);return i.push([s,{contents:a,overrides:o,keys:_}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>i.add(s)),this.userConfiguration.freeze().keys.forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(a=>i.add(a))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>s.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>s.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(a=>s.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o))),[...s.values()]}static parse(i){const s=this.parseConfigurationModel(i.defaults),a=this.parseConfigurationModel(i.user),o=this.parseConfigurationModel(i.workspace),_=i.folders.reduce((m,g)=>(m.set(I.URI.revive(g[0]),this.parseConfigurationModel(g[1])),m),new A.ResourceMap);return new k(s,a,new d,o,_,new d,new A.ResourceMap,!1)}static parseConfigurationModel(i){return new d(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=k;function w(...D){if(D.length===0)return{keys:[],overrides:[]};if(D.length===1)return D[0];const i=new Set,s=new Map;for(const o of D)o.keys.forEach(_=>i.add(_)),o.overrides.forEach(([_,m])=>{const g=(0,A.getOrSet)(s,_,new Set);m.forEach(C=>g.add(C))});const a=[];return s.forEach((o,_)=>a.push([_,[...o.values()]])),{keys:[...i.values()],overrides:a}}e.mergeChanges=w;class l{constructor(i,s,a,o){this.change=i,this.previous=s,this.currentConfiguraiton=a,this.currentWorkspace=o,this._previousConfiguration=void 0;const _=new Set;i.keys.forEach(g=>_.add(g)),i.overrides.forEach(([,g])=>g.forEach(C=>_.add(C))),this.affectedKeys=[..._.values()];const m=new d;this.affectedKeys.forEach(g=>m.setValue(g,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=k.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(s){const a=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(i,s,this.currentWorkspace);return!P.equals(a,o)}return!0}return!1}doesAffectedKeysTreeContains(i,s){let a=(0,t.toValuesTree)({[s]:!0},()=>{}),o;for(;typeof a=="object"&&(o=Object.keys(a)[0]);){if(i=i[o],!i)return!1;a=a[o]}return!0}}e.ConfigurationChangeEvent=l;class v extends l{constructor(i,s,a,o){super({keys:i.allKeys(),overrides:[]},void 0,i,s);this.source=a,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=v}),define(we[85],be([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,c.createDecorator)("remoteAuthorityResolverService");var M;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(A,P=M.Unknown,S){super(A);this._message=A,this._code=P,this._detail=S,this.isHandled=P===M.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(A){return A instanceof E&&A._code===M.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof E&&A._code===M.NoResolverFound}static isHandled(A){return A instanceof E&&A.isHandled}}e.RemoteAuthorityResolverError=E}),define(we[86],be([0,1,11]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(I){return I.scheme===c.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=M;function E(I){if(!I)return;const t=I.indexOf("+");return t<0?I:I.substr(0,t)}e.getRemoteName=E;function T(I){return I.scheme!==c.Schemas.file&&I.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=T;function A(I){if(I.folders.length)return I.folders.every(t=>T(t.uri))?I.folders[0].uri:void 0;if(I.configuration&&T(I.configuration))return I.configuration}e.getVirtualWorkspaceLocation=A;function P(I){return A(I)?.scheme}e.getVirtualWorkspaceScheme=P;function S(I){return A(I)!==void 0}e.isVirtualWorkspace=S}),define(we[148],be([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var M;(function(r){r.Shell="terminal.integrated.shell.",r.ShellArgs="terminal.integrated.shellArgs.",r.DefaultProfile="terminal.integrated.defaultProfile.",r.Profiles="terminal.integrated.profiles."})(M=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var E;(function(r){r.ShellLinux="terminal.integrated.shell.linux",r.ShellMacOs="terminal.integrated.shell.osx",r.ShellWindows="terminal.integrated.shell.windows",r.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",r.AutomationShellLinux="terminal.integrated.automationShell.linux",r.AutomationShellMacOs="terminal.integrated.automationShell.osx",r.AutomationShellWindows="terminal.integrated.automationShell.windows",r.ShellArgsLinux="terminal.integrated.shellArgs.linux",r.ShellArgsMacOs="terminal.integrated.shellArgs.osx",r.ShellArgsWindows="terminal.integrated.shellArgs.windows",r.ProfilesWindows="terminal.integrated.profiles.windows",r.ProfilesMacOs="terminal.integrated.profiles.osx",r.ProfilesLinux="terminal.integrated.profiles.linux",r.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",r.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",r.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",r.UseWslProfiles="terminal.integrated.useWslProfiles",r.TabsEnabled="terminal.integrated.tabs.enabled",r.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",r.TabsHideCondition="terminal.integrated.tabs.hideCondition",r.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",r.TabsShowActions="terminal.integrated.tabs.showActions",r.TabsLocation="terminal.integrated.tabs.location",r.TabsFocusMode="terminal.integrated.tabs.focusMode",r.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",r.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",r.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",r.CopyOnSelection="terminal.integrated.copyOnSelection",r.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",r.FontFamily="terminal.integrated.fontFamily",r.FontSize="terminal.integrated.fontSize",r.LetterSpacing="terminal.integrated.letterSpacing",r.LineHeight="terminal.integrated.lineHeight",r.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",r.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",r.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",r.BellDuration="terminal.integrated.bellDuration",r.FontWeight="terminal.integrated.fontWeight",r.FontWeightBold="terminal.integrated.fontWeightBold",r.CursorBlinking="terminal.integrated.cursorBlinking",r.CursorStyle="terminal.integrated.cursorStyle",r.CursorWidth="terminal.integrated.cursorWidth",r.Scrollback="terminal.integrated.scrollback",r.DetectLocale="terminal.integrated.detectLocale",r.DefaultLocation="terminal.integrated.defaultLocation",r.GpuAcceleration="terminal.integrated.gpuAcceleration",r.RightClickBehavior="terminal.integrated.rightClickBehavior",r.Cwd="terminal.integrated.cwd",r.ConfirmOnExit="terminal.integrated.confirmOnExit",r.ConfirmOnKill="terminal.integrated.confirmOnKill",r.EnableBell="terminal.integrated.enableBell",r.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",r.AllowChords="terminal.integrated.allowChords",r.AllowMnemonics="terminal.integrated.allowMnemonics",r.EnvMacOs="terminal.integrated.env.osx",r.EnvLinux="terminal.integrated.env.linux",r.EnvWindows="terminal.integrated.env.windows",r.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",r.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",r.ShowExitAlert="terminal.integrated.showExitAlert",r.SplitCwd="terminal.integrated.splitCwd",r.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",r.WordSeparators="terminal.integrated.wordSeparators",r.TitleMode="terminal.integrated.titleMode",r.EnableFileLinks="terminal.integrated.enableFileLinks",r.UnicodeVersion="terminal.integrated.unicodeVersion",r.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",r.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",r.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",r.LocalEchoStyle="terminal.integrated.localEchoStyle",r.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",r.CustomGlyphs="terminal.integrated.customGlyphs",r.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",r.PersistentSessionExperimentalSerializer="terminal.integrated.persistentSessionExperimentalSerializer",r.InheritEnv="terminal.integrated.inheritEnv",r.ShowLinkHover="terminal.integrated.showLinkHover"})(E=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(r){r.CommandPrompt="cmd",r.PowerShell="pwsh",r.Wsl="wsl",r.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var A;(function(r){r[r.Api=0]="Api",r[r.Process=1]="Process",r[r.Sequence=2]="Sequence"})(A=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(r){r.LocalPty="localPty",r.PtyHost="ptyHost",r.Log="log",r.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,c.createDecorator)("ptyService");var S;(function(r){r[r.BeatInterval=5e3]="BeatInterval",r[r.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",r[r.SecondWaitMultiplier=1]="SecondWaitMultiplier",r[r.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(S=e.HeartbeatConstants||(e.HeartbeatConstants={}));var I;(function(r){r[r.Panel=1]="Panel",r[r.Editor=2]="Editor"})(I=e.TerminalLocation||(e.TerminalLocation={}));var t;(function(r){r.TerminalView="view",r.Editor="editor"})(t=e.TerminalLocationString||(e.TerminalLocationString={}));var y;(function(r){r[r.GraceTime=6e4]="GraceTime",r[r.ShortGraceTime=6e3]="ShortGraceTime"})(y=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var n;(function(r){r[r.HighWatermarkChars=1e5]="HighWatermarkChars",r[r.LowWatermarkChars=5e3]="LowWatermarkChars",r[r.CharCountAckSize=5e3]="CharCountAckSize"})(n=e.FlowControlConstants||(e.FlowControlConstants={}));var d;(function(r){r.GitBash="Git Bash",r.Pwsh="PowerShell"})(d=e.ProfileSource||(e.ProfileSource={}))}),define(we[149],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,T,A=5){let P;return P=T(S=>{const I=typeof S=="string"?S:S.data;let t=this._terminalBufferMap.get(E);if(t){t.data.push(I);return}const y=setTimeout(()=>this.flushBuffer(E),A);t={data:[I],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(E),P.dispose()}},this._terminalBufferMap.set(E,t)}),P}stopBuffering(E){const T=this._terminalBufferMap.get(E);T&&T.dispose()}flushBuffer(E){const T=this._terminalBufferMap.get(E);T&&(this._terminalBufferMap.delete(E),this._callback(E,T.data.join("")))}}e.TerminalDataBufferer=c}),define(we[150],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var c;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(c=e.ColorScheme||(e.ColorScheme={}))}),define(we[43],be([0,1,34,3,7,4,28,150]),function(re,e,c,M,E,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var S;(function(p){function k(w){return w&&typeof w=="object"&&typeof w.id=="string"}p.isThemeColor=k})(S=e.ThemeColor||(e.ThemeColor={}));function I(p){return{id:p}}e.themeColorFromId=I;var t;(function(p){function k(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||S.isThemeColor(s.color))}p.isThemeIcon=k;const w=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function l(s){const a=w.exec(s);if(!a)return;let[,o]=a;return{id:o}}p.fromString=l;function v(s,a){let o=s.id;const _=o.lastIndexOf("~");return _!==-1&&(o=o.substring(0,_)),a&&(o=`${o}~${a}`),{id:o}}p.modify=v;function D(s,a){return s.id===a.id&&s.color?.id===a.color?.id}p.isEqual=D;function i(s,a){return{id:s.id,color:a?I(a):void 0}}p.asThemeIcon=i,p.asClassNameArray=c.CSSIcon.asClassNameArray,p.asClassName=c.CSSIcon.asClassName,p.asCSSSelector=c.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function y(p){switch(p){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(k){return this.themingParticipants.push(k),this.onThemingParticipantAddedEmitter.fire(k),(0,E.toDisposable)(()=>{const w=this.themingParticipants.indexOf(k);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new n;A.Registry.add(e.Extensions.ThemingContribution,d);function r(p){return d.onColorThemeChange(p)}e.registerThemingParticipant=r;class u extends E.Disposable{constructor(k){super();this.themeService=k,this.theme=k.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(k){this.theme=k,this.updateStyles()}updateStyles(){}getColor(k,w){let l=this.theme.getColor(k);return l&&w&&(l=w(l,this.theme)),l?l.toString():null}}e.Themable=u}),define(we[151],be([0,1,13,34,3,122,83,28,43]),function(re,e,c,M,E,T,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class I{constructor(){this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(k,w,l,v){const D=this.iconsById[k];if(D){if(l&&!D.description){D.description=l,this.iconSchema.properties[k].markdownDescription=`${l} $(${k})`;const a=this.iconReferenceSchema.enum.indexOf(k);a!==-1&&(this.iconReferenceSchema.enumDescriptions[a]=l),this._onDidChange.fire()}return D}let i={id:k,description:l,defaults:w,deprecationMessage:v};this.iconsById[k]=i;let s={$ref:"#/definitions/icons"};return v&&(s.deprecationMessage=v),l&&(s.markdownDescription=`${l}: $(${k})`),this.iconSchema.properties[k]=s,this.iconReferenceSchema.enum.push(k),this.iconReferenceSchema.enumDescriptions.push(l||""),this._onDidChange.fire(),{id:k}}deregisterIcon(k){delete this.iconsById[k],delete this.iconSchema.properties[k];const w=this.iconReferenceSchema.enum.indexOf(k);w!==-1&&(this.iconReferenceSchema.enum.splice(w,1),this.iconReferenceSchema.enumDescriptions.splice(w,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(k=>this.iconsById[k])}getIcon(k){return this.iconsById[k]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(k,w){const l=this.iconFontsById[k];if(l)return l;let v={id:k,definition:w};return this.iconFontsById[k]=v,this._onDidChange.fire(),v}deregisterIconFont(k){delete this.iconFontsById[k]}getIconFonts(){return Object.keys(this.iconFontsById).map(k=>this.iconFontsById[k])}getIconFont(k){return this.iconFontsById[k]}toString(){const k=(D,i)=>D.id.localeCompare(i.id),w=D=>{for(;S.ThemeIcon.isThemeIcon(D.defaults);)D=this.iconsById[D.defaults.id];return`codicon codicon-${D?D.id:""}`};let l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const v=Object.keys(this.iconsById).map(D=>this.iconsById[D]);for(const D of v.filter(i=>!!i.description).sort(k))l.push(`|<i class="${w(D)}"></i>|${D.id}|${S.ThemeIcon.isThemeIcon(D.defaults)?D.defaults.id:D.id}|${D.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const D of v.filter(i=>!S.ThemeIcon.isThemeIcon(i.defaults)).sort(k))l.push(`|<i class="${w(D)}"></i>|${D.id}|`);return l.join(`
`)}}const t=new I;P.Registry.add(e.Extensions.IconContribution,t);function y(p,k,w,l){return t.registerIcon(p,k,w,l)}e.registerIcon=y;function n(){return t}e.getIconRegistry=n;function d(){for(const p of M.iconRegistry.all)t.registerIcon(p.id,p.definition,p.description);M.iconRegistry.onDidRegister(p=>t.registerIcon(p.id,p.definition,p.description))}d(),e.iconsSchemaId="vscode://schemas/icons";let r=P.Registry.as(A.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,t.getIconSchema());const u=new c.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.widgetClose=y("widget-close",M.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=y("goto-previous-location",M.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=y("goto-next-location",M.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=S.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(we[44],be([0,1,20,24,2,4]),function(re,e,c,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var A;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function P(n){const d=n;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=P;function S(n){const d=n;return!!(d&&typeof d=="object"&&E.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=S;class I{constructor(d,r,u,p){this._id=d,this._configuration=u,this._ignorePathCasing=p,this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(d){this._id=d.id,this._configuration=d.configuration,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d.with({scheme:d.scheme,authority:d.authority,path:d.path}))||null}updateFoldersMap(){this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=I;class t{constructor(d,r){this.raw=r,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,M.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function y(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=y}),define(we[62],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const T=this._idPool++;return this._data.set(T,E),this.logDebugInfo(),T}get(E,T){return this._data.has(E)?this._data.get(E)[T]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!c.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=c,c.enableDebugLogging=!1}),define(we[63],be([0,1,2,3,4]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,E.createDecorator)("IExtHostEditorTabs");class T{constructor(){this._onDidChangeTabs=new M.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(P){this._tabs=P.map(S=>({name:S.name,group:S.group,resource:c.URI.revive(S.resource),isActive:S.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(we[45],be([0,1,11,4]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class E{constructor(){this._systemSchemes=new Set(Object.keys(c.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(A,P){P===null?this._providerInfo.delete(A):this._providerInfo.set(A,P)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=E,e.IExtHostFileSystemInfo=(0,M.createDecorator)("IExtHostFileSystemInfo")}),define(we[29],be([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(we[152],be([0,1,13]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(A,P,S){this._deferredPromises=new Map,this._id=A,this._shared=P,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new c.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of I.values())t.complete()}catch(t){for(const y of I.values())y.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,P){let S=this._value[A];return typeof S=="undefined"&&(S=P),S}update(A,P){this._value[A]=P;let S=this._deferredPromises.get(A);if(S!==void 0)return S.p;const I=new c.DeferredPromise;return this._deferredPromises.set(A,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class E extends M{constructor(A,P){super(A.identifier.value,!0,P);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=E}),define(we[153],be([0,1,3,2,14]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let T=class{constructor(P,S){this._logService=P,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new c.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new c.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(P,S,I){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(P)).acceptModelChanged(S.value,I)}$acceptDirtyStateChanged(P,S){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(P)).acceptDirty(S)}$acceptModelSaved(P){const S=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(P));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(P,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",P.path,S);const I=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(P));I.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:I.apiNotebook})}};T=Ue([ze(0,E.ILogService)],T),e.ExtHostNotebookDocuments=T}),define(we[12],be([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class M{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=M});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[154],be([0,1,25,3]),function(re,e,c,M){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(P,S){E.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=c.ExtensionIdentifier.toKey(P.identifier),et(this,E,S,"f"),Oe(this,E,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(P){return Oe(this,E,"f").get(this._id,P)}store(P,S){return Oe(this,E,"f").store(this._id,P,S)}delete(P){return Oe(this,E,"f").delete(this._id,P)}}e.ExtensionSecrets=T,E=new WeakMap}),define(we[87],be([0,1,4,3]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(we[64],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var c;(function(w){w[w.Upsert=0]="Upsert",w[w.RemoveChild=1]="RemoveChild",w[w.Invalidated=2]="Invalidated",w[w.SetProp=3]="SetProp",w[w.Bulk=4]="Bulk"})(c=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,E=(w,l)=>{const v={controllerId:l};return M.set(w,v),v};e.createPrivateApiFor=E;const T=w=>M.get(w);e.getPrivateApiFor=T;const A=(w,l,v,D)=>{let i=v;return{enumerable:!0,configurable:!1,get(){return i},set(s){if(!D(i,s)){const a=i;i=s,w.listener?.({op:3,key:l,value:s,previous:a})}}}},P=(w,l)=>w===l,S={range:(w,l)=>w===l?!0:!w||!l?!1:w.isEqual(l),label:P,description:P,busy:P,error:P,canResolveChildren:P,tags:(w,l)=>!(w.length!==l.length||w.some(v=>!l.find(D=>v.id===D.id)))},I=Object.keys(S),t=(w,l)=>({range:A(w,"range",void 0,S.range),label:A(w,"label",l,S.label),description:A(w,"description",void 0,S.description),canResolveChildren:A(w,"canResolveChildren",!1,S.canResolveChildren),busy:A(w,"busy",!1,S.busy),error:A(w,"error",void 0,S.error),tags:A(w,"tags",[],S.tags)}),y=(w,l)=>{const v=new Map;for(const D of I)S[D](w[D],l[D])||v.set(D,l[D]);return v};e.diffTestItems=y;class n extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.DuplicateTestItemError=n;class d extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class r extends Error{constructor(l,v,D){super(`TestItem with ID "${l}" is from controller "${v}" and cannot be added as a child of an item from controller "${D}".`)}}e.MixedTestItemController=r;const u=w=>{const l=(0,e.getPrivateApiFor)(w);let v=new Map;return{get size(){return v.size},forEach(D,i){for(const s of v.values())D.call(i,s,this)},replace(D){const i=new Map,s=new Set(v.keys()),a={op:4,ops:[]};for(const o of D){if(!(o instanceof p))throw new d(o.id);const _=(0,e.getPrivateApiFor)(o).controllerId;if(_!==l.controllerId)throw new r(o.id,_,l.controllerId);if(i.has(o.id))throw new n(o.id);i.set(o.id,o),s.delete(o.id),a.ops.push({op:0,item:o})}for(const o of s.keys())a.ops.push({op:1,id:o});l.listener?.(a),v=i},add(D){if(!(D instanceof p))throw new d(D.id);v.set(D.id,D),l.listener?.({op:0,item:D})},delete(D){v.delete(D)&&l.listener?.({op:1,id:D})},get(D){return v.get(D)},toJSON(){return Array.from(v.values())},[Symbol.iterator](){return v.values()}}};class p{constructor(l,v,D,i){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const s=(0,e.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof k?void 0:s.parent}},children:{value:u(this),enumerable:!0,writable:!1},...t(s,D)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=p;class k extends p{constructor(l,v){super(l,l,v,void 0)}}e.TestItemRootImpl=k}),define(we[65],be([0,1,4,3,12]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(P){function S(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,protocol:t.protocol}}P.fromApiTunnel=S;function I(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.public,protocol:t.protocol}}P.fromServiceTunnel=I})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let A=class{constructor(S){this.onDidChangeTunnels=new M.Emitter().event}async $applyCandidateFilter(S){return S}async openTunnel(S,I){}async getTunnels(){return[]}async setTunnelExtensionFunctions(S){return{dispose:()=>{}}}registerPortsAttributesProvider(S,I){return{dispose:()=>{}}}async $providePortAttributes(S,I,t,y,n){return[]}async $forwardPort(S,I){}async $closeTunnel(S){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=Ue([ze(0,E.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[6],be([0,1,16,15,76,20,78,10,2,36,59,85]),function(re,e,c,M,E,T,A,P,S,I,t,y){"use strict";var n,d,r,u,p,k,w,l,v,D,i,s,a,o,_,m,g,C,R,h;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function b(x){function L(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(L,x),Object.setPrototypeOf(L.prototype,x.prototype),L}let f=p=class{constructor(L){n.set(this,void 0),et(this,n,L,"f")}static from(...L){let te=L;return new p(function(){if(te){for(const _e of te)_e&&typeof _e.dispose=="function"&&_e.dispose();te=void 0}})}dispose(){typeof Oe(this,n,"f")=="function"&&(Oe(this,n,"f").call(this),et(this,n,void 0,"f"))}};n=new WeakMap,f=p=Ue([b],f),e.Disposable=f;let F=k=class{constructor(L,te){if(L<0)throw(0,M.illegalArgument)("line must be non-negative");if(te<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=L,this._character=te}static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let _e=1;_e<L.length;_e++){const Ke=L[_e];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let _e=1;_e<L.length;_e++){const Ke=L[_e];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(L){if(!L)return!1;if(L instanceof k)return!0;let{line:te,character:_e}=L;return typeof te=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,te=0){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return typeof L=="undefined"?_e=0:typeof L=="number"?_e=L:(_e=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),_e===0&&te===0?this:new k(this.line+_e,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return typeof L=="undefined"?_e=this.line:typeof L=="number"?_e=L:(_e=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),_e===this.line&&te===this.character?this:new k(_e,te)}toJSON(){return{line:this.line,character:this.character}}};F=k=Ue([b],F),e.Position=F;let O=w=class{constructor(L,te,_e,Ke){let Ze,st;if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ke=="number"?(Ze=new F(L,te),st=new F(_e,Ke)):L instanceof F&&te instanceof F&&(Ze=L,st=te),!Ze||!st)throw new Error("Invalid arguments");Ze.isBefore(st)?(this._start=Ze,this._end=st):(this._start=st,this._end=Ze)}static isRange(L){return L instanceof w?!0:L?F.isPosition(L.start)&&F.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof w?this.contains(L._start)&&this.contains(L._end):L instanceof F?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const te=F.Max(L.start,this._start),_e=F.Min(L.end,this._end);if(!te.isAfter(_e))return new w(te,_e)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=F.Min(L.start,this._start),_e=F.Max(L.end,this.end);return new w(te,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,te=this.end){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return L?F.isPosition(L)?_e=L:(_e=L.start||this.start,te=L.end||this.end):_e=this.start,_e.isEqual(this._start)&&te.isEqual(this.end)?this:new w(_e,te)}toJSON(){return[this.start,this.end]}};O=w=Ue([b],O),e.Range=O;let q=l=class extends O{constructor(L,te,_e,Ke){let Ze,st;if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ke=="number"?(Ze=new F(L,te),st=new F(_e,Ke)):L instanceof F&&te instanceof F&&(Ze=L,st=te),!Ze||!st)throw new Error("Invalid arguments");super(Ze,st);this._anchor=Ze,this._active=st}static isSelection(L){return L instanceof l?!0:L?O.isRange(L)&&F.isPosition(L.anchor)&&F.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};q=l=Ue([b],q),e.Selection=q;class Q{constructor(L,te,_e){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(te),this.connectionToken=_e}}e.ResolvedAuthority=Q;class $ extends Error{constructor(L,te=y.RemoteAuthorityResolverErrorCode.Unknown,_e){super(L);this._message=L,this._code=te,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,$.prototype)}static NotAvailable(L,te){return new $(L,y.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new $(L,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=$;var z;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(z=e.EndOfLine||(e.EndOfLine={}));var N;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(N=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let W=v=class{constructor(L,te){this._range=L,this._newText=te}static isTextEdit(L){return L instanceof v?!0:L?O.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new v(L,te)}static insert(L,te){return v.replace(new O(L,L),te)}static delete(L){return v.replace(L,"")}static setEndOfLine(L){const te=new v(new O(new F(0,0),new F(0,0)),"");return te.newEol=L,te}get range(){return this._range}set range(L){if(L&&!O.isRange(L))throw(0,M.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,M.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,M.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};W=v=Ue([b],W),e.TextEdit=W;var j;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace"})(j=e.FileEditType||(e.FileEditType={}));let Y=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,te,_e,Ke){this._edits.push({_type:1,from:L,to:te,options:_e,metadata:Ke})}createFile(L,te,_e){this._edits.push({_type:1,from:void 0,to:L,options:te,metadata:_e})}deleteFile(L,te,_e){this._edits.push({_type:1,from:L,to:void 0,options:te,metadata:_e})}replaceNotebookMetadata(L,te,_e){this._edits.push({_type:3,metadata:_e,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(L,te,_e,Ke,Ze){let st,at,yt=[],At;if(Wt.isNotebookRange(te)&&Rt.isNotebookCellDataArray(_e)&&!Rt.isNotebookCellDataArray(Ke)?(st=te.start,at=te.end,yt=_e,At=Ke):typeof te=="number"&&typeof _e=="number"&&Rt.isNotebookCellDataArray(Ke)&&(st=te,at=_e,yt=Ke,At=Ze),st===void 0||at===void 0)throw new Error("Invalid arguments");(st!==at||yt.length>0)&&this._edits.push({_type:5,uri:L,index:st,count:at-st,cells:yt,metadata:At})}replaceNotebookCellMetadata(L,te,_e,Ke){this._edits.push({_type:3,metadata:Ke,uri:L,edit:{editType:8,index:te,metadata:_e}})}replace(L,te,_e,Ke){this._edits.push({_type:2,uri:L,edit:new W(te,_e),metadata:Ke})}insert(L,te,_e,Ke){this.replace(L,new O(te,te),_e,Ke)}delete(L,te,_e){this.replace(L,te,"",_e)}has(L){return this._edits.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const _e of te)_e&&this._edits.push({_type:2,uri:L,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ke=this._edits[_e];Ke._type===2&&Ke.uri.toString()===L.toString()&&(this._edits[_e]=void 0)}(0,c.coalesceInPlace)(this._edits)}}get(L){const te=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===L.toString()&&te.push(_e.edit);return te}entries(){const L=new T.ResourceMap;for(let te of this._edits)if(te._type===2){let _e=L.get(te.uri);_e||(_e=[te.uri,[]],L.set(te.uri,_e)),_e[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Y=Ue([b],Y),e.WorkspaceEdit=Y;let de=D=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof D?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=D._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this._tabstop++){if(typeof L=="function"){const _e=new D;_e._tabstop=this._tabstop,L(_e),this._tabstop=_e._tabstop,L=_e.value}else L=D._escape(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this._tabstop++){const _e=L.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const _e=new D;_e._tabstop=this._tabstop,te(_e),this._tabstop=_e._tabstop,te=_e.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};de=D=Ue([b],de),e.SnippetString=de;var G;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(G=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=i=class{constructor(L,te){if(this.uri=L,te)if(te instanceof O)this.range=te;else if(te instanceof F)this.range=new O(te,te);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof i?!0:L?O.isRange(L.range)&&S.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};oe=i=Ue([b],oe),e.Location=oe;let Ee=class{constructor(L,te){this.location=L,this.message=te}static is(L){return L?typeof L.message=="string"&&L.location&&O.isRange(L.location.range)&&S.URI.isUri(L.location.uri):!1}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};Ee=Ue([b],Ee),e.DiagnosticRelatedInformation=Ee;let Te=class{constructor(L,te,_e=ue.Error){if(!O.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=_e}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,c.equals)(L.tags,te.tags)&&(0,c.equals)(L.relatedInformation,te.relatedInformation,Ee.isEqual)}};Te=Ue([b],Te),e.Diagnostic=Te;let Re=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};Re=Ue([b],Re),e.Hover=Re;var Ne;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(Ne=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Qe=class{constructor(L,te=Ne.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:Ne[this.kind]}}};Qe=Ue([b],Qe),e.DocumentHighlight=Qe;var He;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(He=e.SymbolKind||(e.SymbolKind={}));var qe;(function(x){x[x.Deprecated=1]="Deprecated"})(qe=e.SymbolTag||(e.SymbolTag={}));let B=s=class{constructor(L,te,_e,Ke,Ze){this.name=L,this.kind=te,this.containerName=Ze,typeof _e=="string"&&(this.containerName=_e),Ke instanceof oe?this.location=Ke:_e instanceof O&&(this.location=new oe(Ke,_e)),s.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:He[this.kind],location:this.location,containerName:this.containerName}}};B=s=Ue([b],B),e.SymbolInformation=B;let K=a=class{constructor(L,te,_e,Ke,Ze){this.name=L,this.detail=te,this.kind=_e,this.range=Ke,this.selectionRange=Ze,this.children=[],a.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(a.validate)}};K=a=Ue([b],K),e.DocumentSymbol=K;var ee;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(L,te){this.title=L,this.kind=te}};ae=Ue([b],ae),e.CodeAction=ae;let V=o=class{constructor(L){this.value=L}append(L){return new o(this.value?this.value+o.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+o.sep)}};V.sep=".",V=o=Ue([b],V),e.CodeActionKind=V,V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll");let se=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};se=Ue([b],se),e.SelectionRange=se;class fe{constructor(L,te,_e,Ke,Ze,st){this.kind=L,this.name=te,this.detail=_e,this.uri=Ke,this.range=Ze,this.selectionRange=st}}e.CallHierarchyItem=fe;class Ae{constructor(L,te){this.fromRanges=te,this.from=L}}e.CallHierarchyIncomingCall=Ae;class xe{constructor(L,te){this.fromRanges=te,this.to=L}}e.CallHierarchyOutgoingCall=xe;var $e;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})($e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let ve=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};ve=Ue([b],ve),e.CodeLens=ve;let Xe=_=class{constructor(L,te=!1){d.set(this,void 0),et(this,d,new E.MarkdownString(L,{supportThemeIcons:te}),"f")}static isMarkdownString(L){return L instanceof _?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Oe(this,d,"f").value}set value(L){Oe(this,d,"f").value=L}get isTrusted(){return Oe(this,d,"f").isTrusted}set isTrusted(L){Oe(this,d,"f").isTrusted=L}get supportThemeIcons(){return Oe(this,d,"f").supportThemeIcons}set supportThemeIcons(L){Oe(this,d,"f").supportThemeIcons=L}appendText(L){return Oe(this,d,"f").appendText(L),this}appendMarkdown(L){return Oe(this,d,"f").appendMarkdown(L),this}appendCodeblock(L,te){return Oe(this,d,"f").appendCodeblock(te??"",L),this}};d=new WeakMap,Xe=_=Ue([b],Xe),e.MarkdownString=Xe;let H=class{constructor(L,te){this.label=L,this.documentation=te}};H=Ue([b],H),e.ParameterInformation=H;let J=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};J=Ue([b],J),e.SignatureInformation=J;let he=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};he=Ue([b],he),e.SignatureHelp=he;var Le;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(Le=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ve;(function(x){x[x.Other=0]="Other",x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Ve=e.InlayHintKind||(e.InlayHintKind={}));let tt=class{constructor(L,te,_e){this.text=L,this.position=te,this.kind=_e}};tt=Ue([b],tt),e.InlayHint=tt;var ut;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ut=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ht;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(ht=e.CompletionItemKind||(e.CompletionItemKind={}));var St;(function(x){x[x.Deprecated=1]="Deprecated"})(St=e.CompletionItemTag||(e.CompletionItemTag={}));let Pt=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&ht[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Pt=Ue([b],Pt),e.CompletionItem=Pt;let dt=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};dt=Ue([b],dt),e.CompletionList=dt;let bt=class{constructor(L,te,_e){this.text=L,this.range=te,this.command=_e}};bt=Ue([b],bt),e.InlineSuggestion=bt;let ft=class{constructor(L){this.items=L}};ft=Ue([b],ft),e.InlineSuggestions=ft;var Et;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Et=e.ViewColumn||(e.ViewColumn={}));var Ye;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Ye=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ct;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(Ct=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var De;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Z;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(Z=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var le;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(le=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function L(te){switch(te){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=L}(De=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ge=class{constructor(L,te){if(te&&!S.URI.isUri(te))throw(0,M.illegalArgument)("target");if(!O.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.target=te}};ge=Ue([b],ge),e.DocumentLink=ge;let me=class{constructor(L,te,_e,Ke){this.red=L,this.green=te,this.blue=_e,this.alpha=Ke}};me=Ue([b],me),e.Color=me;let Ie=class{constructor(L,te){if(te&&!(te instanceof me))throw(0,M.illegalArgument)("color");if(!O.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.color=te}};Ie=Ue([b],Ie),e.ColorInformation=Ie;let Be=class{constructor(L){if(!L||typeof L!="string")throw(0,M.illegalArgument)("label");this.label=L}};Be=Ue([b],Be),e.ColorPresentation=Be;var Me;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Me=e.ColorFormat||(e.ColorFormat={}));var je;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(je=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Je{constructor(L,te,_e){if(this.startIndex=L,this.length=te,this.tooltip=_e,typeof L!="number"||L<0)throw(0,M.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=Je;var ie;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(ie=e.TerminalLocation||(e.TerminalLocation={}));class pe{constructor(L){this.options=L,typeof L!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=pe;var ne;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(ne=e.TaskRevealKind||(e.TaskRevealKind={}));var U;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(U=e.TaskPanelKind||(e.TaskPanelKind={}));let Ce=m=class{constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,M.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}get id(){return this._id}};Ce.Clean=new m("clean","Clean"),Ce.Build=new m("build","Build"),Ce.Rebuild=new m("rebuild","Rebuild"),Ce.Test=new m("test","Test"),Ce=m=Ue([b],Ce),e.TaskGroup=Ce;function Se(x){let L="";for(let te=0;te<x.length;te++)L+=x[te].replace(/,/g,",,")+",";return L}let Ge=class{constructor(L,te,_e){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=L,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=_e):this._options=te)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let te of this._args)L.push(te);return Se(L)}};Ge=Ue([b],Ge),e.ProcessExecution=Ge;let We=class{constructor(L,te,_e){if(this._args=[],Array.isArray(te)){if(!L)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L,this._args=te,this._options=_e}else{if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L,this._options=te}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)L.push(typeof te=="string"?te:te.value);return Se(L)}};We=Ue([b],We),e.ShellExecution=We;var it;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(it=e.ShellQuoting||(e.ShellQuoting={}));var mt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(mt=e.TaskScope||(e.TaskScope={}));class vt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,I.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=vt;let nt=g=class{constructor(L,te,_e,Ke,Ze,st){this.__deprecated=!1,this._definition=this.definition=L;let at;typeof te=="string"?(this._name=this.name=te,this._source=this.source=_e,this.execution=Ke,at=Ze,this.__deprecated=!0):te===mt.Global||te===mt.Workspace?(this.target=te,this._name=this.name=_e,this._source=this.source=Ke,this.execution=Ze,at=st):(this.target=te,this._name=this.name=_e,this._source=this.source=Ke,this.execution=Ze,at=st),typeof at=="string"?(this._problemMatchers=[at],this._hasDefinedMatchers=!0):Array.isArray(at)?(this._problemMatchers=at,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ge?this._definition={type:g.ProcessType,id:this._execution.computeId()}:this._execution instanceof We?this._definition={type:g.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:g.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:g.EmptyType,id:(0,I.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const te=this._definition.type;(g.EmptyType===te||g.ProcessType===te||g.ShellType===te||g.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};nt.ExtensionCallbackType="customExecution",nt.ProcessType="process",nt.ShellType="shell",nt.EmptyType="$empty",nt=g=Ue([b],nt),e.Task=nt;var ot;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(ot=e.ProgressLocation||(e.ProgressLocation={}));let lt=class{constructor(L,te=Ft.None){this.collapsibleState=te,S.URI.isUri(L)?this.resourceUri=L:this.label=L}};lt=Ue([b],lt),e.TreeItem=lt;var Ft;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(Ft=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let _t=class{constructor(L,te){this.id=L,this.color=te}};_t=Ue([b],_t),e.ThemeIcon=_t,_t.File=new _t("file"),_t.Folder=new _t("folder");let Nt=class{constructor(L){this.id=L}};Nt=Ue([b],Nt),e.ThemeColor=Nt;var ui;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(ui=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(L,te){if(typeof L!="string"&&(!L||!S.URI.isUri(L)&&!S.URI.isUri(L.uri)))throw(0,M.illegalArgument)("base");if(typeof te!="string")throw(0,M.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=S.URI.file(L),this.base=L):S.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=te}};kt=Ue([b],kt),e.RelativePattern=kt;let Ut=class{constructor(L,te,_e,Ke){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof _e=="string"&&(this.hitCondition=_e),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,I.generateUuid)()),this._id}};Ut=Ue([b],Ut),e.Breakpoint=Ut;let ei=class extends Ut{constructor(L,te,_e,Ke,Ze){super(te,_e,Ke,Ze);if(L===null)throw(0,M.illegalArgument)("location");this.location=L}};ei=Ue([b],ei),e.SourceBreakpoint=ei;let gt=class extends Ut{constructor(L,te,_e,Ke,Ze){super(te,_e,Ke,Ze);this.functionName=L}};gt=Ue([b],gt),e.FunctionBreakpoint=gt;let Qt=class extends Ut{constructor(L,te,_e,Ke,Ze,st,at){super(Ke,Ze,st,at);if(!te)throw(0,M.illegalArgument)("dataId");this.label=L,this.dataId=te,this.canPersist=_e}};Qt=Ue([b],Qt),e.DataBreakpoint=Qt;let zt=class{constructor(L,te,_e){this.command=L,this.args=te||[],this.options=_e}};zt=Ue([b],zt),e.DebugAdapterExecutable=zt;let ti=class{constructor(L,te){this.port=L,this.host=te}};ti=Ue([b],ti),e.DebugAdapterServer=ti;let ii=class{constructor(L){this.path=L}};ii=Ue([b],ii),e.DebugAdapterNamedPipeServer=ii;let It=class{constructor(L){this.implementation=L}};It=Ue([b],It),e.DebugAdapterInlineImplementation=It;let Yt=class{constructor(L,te){this.range=L,this.expression=te}};Yt=Ue([b],Yt),e.EvaluatableExpression=Yt;var vi;(function(x){x[x.Automatic=0]="Automatic",x[x.Explicit=1]="Explicit"})(vi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let $t=class{constructor(L,te){this.range=L,this.text=te}};$t=Ue([b],$t),e.InlineValueText=$t;let ct=class{constructor(L,te,_e=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=_e}};ct=Ue([b],ct),e.InlineValueVariableLookup=ct;let ni=class{constructor(L,te){this.range=L,this.expression=te}};ni=Ue([b],ni),e.InlineValueEvaluatableExpression=ni;let Mt=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};Mt=Ue([b],Mt),e.InlineValueContext=Mt;var Ht;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Ht=e.FileChangeType||(e.FileChangeType={}));let Jt=C=class extends Error{constructor(L,te=t.FileSystemProviderErrorCode.Unknown,_e){super(S.URI.isUri(L)?L.toString(!0):L);this.code=_e?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(L){return new C(L,t.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(L){return new C(L,t.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(L){return new C(L,t.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(L){return new C(L,t.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(L){return new C(L,t.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(L){return new C(L,t.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}};Jt=C=Ue([b],Jt),e.FileSystemError=Jt;let ri=class{constructor(L,te,_e){this.start=L,this.end=te,this.kind=_e}};ri=Ue([b],ri),e.FoldingRange=ri;var ci;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(ci=e.FoldingRangeKind||(e.FoldingRangeKind={}));var wi;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var di;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(di=e.CommentMode||(e.CommentMode={}));class si{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.SemanticTokensLegend=si;function bi(x){return typeof x=="undefined"||(0,P.isStringArray)(x)}class Vt{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let te=0,_e=L.tokenTypes.length;te<_e;te++)this._tokenTypeStrToInt.set(L.tokenTypes[te],te);for(let te=0,_e=L.tokenModifiers.length;te<_e;te++)this._tokenModifierStrToInt.set(L.tokenModifiers[te],te)}}push(L,te,_e,Ke,Ze){if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ke=="number"&&(typeof Ze=="number"||typeof Ze=="undefined"))return typeof Ze=="undefined"&&(Ze=0),this._pushEncoded(L,te,_e,Ke,Ze);if(O.isRange(L)&&typeof te=="string"&&bi(_e))return this._push(L,te,_e);throw(0,M.illegalArgument)()}_push(L,te,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=L.start.line,Ze=L.start.character,st=L.end.character-L.start.character,at=this._tokenTypeStrToInt.get(te);let yt=0;if(_e)for(const At of _e){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Lt=this._tokenModifierStrToInt.get(At);yt|=1<<Lt>>>0}this._pushEncoded(Ke,Ze,st,at,yt)}_pushEncoded(L,te,_e,Ke,Ze){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let At=0,Lt=0;for(let Ot=0;Ot<yt;Ot++){let xt=this._data[5*Ot],ai=this._data[5*Ot+1];xt===0?(xt=At,ai+=Lt):xt+=At,this._data[5*Ot]=xt,this._data[5*Ot+1]=ai,At=xt,Lt=ai}}let st=L,at=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(at-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=at,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=Ze,this._prevLine=L,this._prevChar=te}static _sortAndDeltaEncode(L){let te=[];const _e=L.length/5|0;for(let at=0;at<_e;at++)te[at]=at;te.sort((at,yt)=>{const At=L[5*at],Lt=L[5*yt];if(At===Lt){const Ot=L[5*at+1],xt=L[5*yt+1];return Ot-xt}return At-Lt});const Ke=new Uint32Array(L.length);let Ze=0,st=0;for(let at=0;at<_e;at++){const yt=5*te[at],At=L[yt+0],Lt=L[yt+1],Ot=L[yt+2],xt=L[yt+3],ai=L[yt+4],xi=At-Ze,qi=xi===0?Lt-st:Lt,li=5*at;Ke[li+0]=xi,Ke[li+1]=qi,Ke[li+2]=Ot,Ke[li+3]=xt,Ke[li+4]=ai,Ze=At,st=Lt}return Ke}build(L){return this._dataIsSortedAndDeltaEncoded?new jt(new Uint32Array(this._data),L):new jt(Vt._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=Vt;class jt{constructor(L,te){this.resultId=te,this.data=L}}e.SemanticTokens=jt;class Ei{constructor(L,te,_e){this.start=L,this.deleteCount=te,this.data=_e}}e.SemanticTokensEdit=Ei;class _i{constructor(L,te){this.resultId=te,this.edits=L}}e.SemanticTokensEdits=_i;var qt;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(qt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(x){x[x.Initial=1]="Initial",x[x.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Xt=class{constructor(){}};Xt.Back={iconPath:new _t("arrow-left")},Xt=Ue([b],Xt),e.QuickInputButtons=Xt;var Si;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Si=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(L,te,_e){this.badge=L,this.tooltip=te,this.color=_e}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Di;let Gt=class{constructor(L){this.kind=L}};Gt=Ue([b],Gt),e.ColorTheme=Gt;var hi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast"})(hi=e.ColorThemeKind||(e.ColorThemeKind={}));class Wt{constructor(L,te){if(L<0)throw(0,M.illegalArgument)("start must be positive");if(te<0)throw(0,M.illegalArgument)("end must be positive");L<=te?(this._start=L,this._end=te):(this._start=te,this._end=L)}static isNotebookRange(L){return L instanceof Wt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let te=this._start,_e=this._end;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(_e=L.end),te===this._start&&_e===this._end?this:new Wt(te,_e)}}e.NotebookRange=Wt;class Rt{constructor(L,te,_e,Ke,Ze,st,at){this.kind=L,this.value=te,this.languageId=_e,this.mime=Ke,this.outputs=Ze??[],this.metadata=st,this.executionSummary=at,Rt.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>Rt.isNotebookCellData(te))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Rt;class Fe{constructor(L){this.cells=L}}e.NotebookData=Fe;class Tt{constructor(L,te){this.data=L,this.mime=te;const _e=(0,A.normalizeMimeType)(te,!0);if(!_e)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(L){return L instanceof Tt?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return Tt.json(te,"application/vnd.code.notebook.error")}static stdout(L){return Tt.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Tt.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new Tt(L,te)}static text(L,te=A.Mimes.text){const _e=Oe(Tt,r,"f",u).encode(String(L));return new Tt(_e,te)}static json(L,te="application/json"){const _e=JSON.stringify(L,void 0,"	");return Tt.text(_e,te)}}e.NotebookCellOutputItem=Tt,r=Tt,u={value:new TextEncoder};class Kt{constructor(L,te,_e){this.items=Kt.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=_e):(this.id=(0,I.generateUuid)(),this.metadata=te??_e)}static isNotebookCellOutput(L){return L instanceof Kt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,P.isArray)(L.items)}static ensureUniqueMimeTypes(L,te=!1){const _e=new Set,Ke=new Set;for(let Ze=0;Ze<L.length;Ze++){const st=L[Ze],at=(0,A.normalizeMimeType)(st.mime);if(!_e.has(at)){_e.add(at);continue}Ke.add(Ze),te&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Ke.size===0?L:L.filter((Ze,st)=>!Ke.has(st))}}e.NotebookCellOutput=Kt;var pt;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(pt=e.NotebookCellKind||(e.NotebookCellKind={}));var Ci;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Ci=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var fi;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(fi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class mi{constructor(L,te){this.text=L,this.alignment=te}}e.NotebookCellStatusBarItem=mi;var Ii;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Ii=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(L,te=[]){this.uri=L,this.provides=(0,c.asArray)(te)}}e.NotebookRendererScript=Pi;let oi=class{constructor(L,te){this.label=L,this.timestamp=te}};oi=Ue([b],oi),e.TimelineItem=oi;var Ai;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(Ai=e.ExtensionMode||(e.ExtensionMode={}));var gi;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(gi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ti;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=4]="RegEx"})(Ti=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.LinkedEditingRanges=Ri;class Fi{constructor(L,te){this._port=L,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let X=class{constructor(L,te,_e){this.include=L,this.exclude=te,this.profile=_e}};X=Ue([b],X),e.TestRunRequest=X;let ce=R=class{constructor(L){this.message=L}static diff(L,te,_e){const Ke=new R(L);return Ke.expectedOutput=te,Ke.actualOutput=_e,Ke}};ce=R=Ue([b],ce),e.TestMessage=ce;let ke=class{constructor(L,te){if(this.id=L,this.label=te,/\s/.test(L))throw new Error(`Test tag ID "${L}" may not include whitespace`)}};ke=Ue([b],ke),e.TestTag=ke;let rt=class{constructor(L,te){this.covered=L,this.total=te}};rt=Ue([b],rt),e.CoveredCount=rt;let wt=h=class{constructor(L,te,_e,Ke){this.uri=L,this.statementCoverage=te,this.branchCoverage=_e,this.functionCoverage=Ke}static fromDetails(L,te){const _e=new rt(0,0),Ke=new rt(0,0),Ze=new rt(0,0);for(const at of te)if("branches"in at){_e.total+=1,_e.covered+=at.executionCount>0?1:0;for(const yt of at.branches)Ke.total+=1,Ke.covered+=yt.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=at.executionCount>0?1:0;const st=new h(L,_e,Ke.total>0?Ke:void 0,Ze.total>0?Ze:void 0);return st.detailedCoverage=te,st}};wt=h=Ue([b],wt),e.FileCoverage=wt;let Dt=class{constructor(L,te,_e=[]){this.executionCount=L,this.location=te,this.branches=_e}};Dt=Ue([b],Dt),e.StatementCoverage=Dt;let Oi=class{constructor(L,te){this.executionCount=L,this.location=te}};Oi=Ue([b],Oi),e.BranchCoverage=Oi;let Ni=class{constructor(L,te){this.executionCount=L,this.location=te}};Ni=Ue([b],Ni),e.FunctionCoverage=Ni;var zi;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(zi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Hi;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(Hi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Vi;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(Vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ji{constructor(L,te,_e,Ke,Ze,st){this.kind=L,this.name=te,this.detail=_e,this.uri=Ke,this.range=Ze,this.selectionRange=st}}e.TypeHierarchyItem=ji}),define(we[88],be([0,1,39,11,9,228,117,6,16]),function(re,e,c,M,E,T,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function t(r,u){u?I.set(r,u):I.delete(r)}e.setWordDefinitionFor=t;function y(r){return I.get(r)}e.getWordDefinitionFor=y;class n extends T.MirrorTextModel{constructor(u,p,k,w,l,v,D,i){super(p,k,w,l);this._proxy=u,this._languageId=v,this._isDirty=D,this._notebook=i,this._isDisposed=!1}dispose(){(0,c.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return(0,S.equals)(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===M.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(p){return p?u._getTextInRange(p):u.getText()},get eol(){return u._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(p){return u._lineAt(p)},offsetAt(p){return u._offsetAt(p)},positionAt(p){return u._positionAt(p)},validateRange(p){return u._validateRange(p)},validatePosition(p){return u._validatePosition(p)},getWordRangeAtPosition(p,k){return u._getWordRangeAtPosition(p,k)}}}return Object.freeze(this._document)}_acceptLanguageId(u){(0,c.ok)(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){(0,c.ok)(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const p=this._validateRange(u);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const k=this._eol,w=p.start.line,l=p.end.line,v=[];v.push(this._lines[w].substring(p.start.character));for(let D=w+1;D<l;D++)v.push(this._lines[D]);return v.push(this._lines[l].substring(0,p.end.character)),v.join(k)}_lineAt(u){let p;if(u instanceof P.Position?p=u.line:typeof u=="number"&&(p=u),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new d(p,this._lines[p],p===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getPrefixSum(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(u),k=this._lines[p.index].length;return new P.Position(p.index,Math.min(p.remainder,k))}_validateRange(u){if(!(u instanceof P.Range))throw new Error("Invalid argument");const p=this._validatePosition(u.start),k=this._validatePosition(u.end);return p===u.start&&k===u.end?u:new P.Range(p.line,p.character,k.line,k.character)}_validatePosition(u){if(!(u instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:p,character:k}=u,w=!1;if(p<0)p=0,k=0,w=!0;else if(p>=this._lines.length)p=this._lines.length-1,k=this._lines[p].length,w=!0;else{const l=this._lines[p].length;k<0?(k=0,w=!0):k>l&&(k=l,w=!0)}return w?new P.Position(p,k):u}_getWordRangeAtPosition(u,p){const k=this._validatePosition(u);if(!p)p=y(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const w=(0,A.getWordAtText)(k.character+1,(0,A.ensureValidWordDefinition)(p),this._lines[k.line],0);if(w)return new P.Range(k.line,w.startColumn-1,k.line,w.endColumn-1)}}e.ExtHostDocumentData=n;class d{constructor(u,p,k){this._line=u,this._text=p,this._isLastLine=k}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=d}),define(we[155],be([0,1,6,3,229,7,54,20,2,36]),function(re,e,c,M,E,T,A,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,d,r,u){this._notebook=r,this._selector=u,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,I.generateUuid)()}),this._init(),this._disposables.add(d.onDidChangeDocument(k=>{const w=this._cellUris.get(k.document.uri);w!==void 0&&(this._cellLengths.changeValue(w,this._cells[w].document.getText().length+1),this._cellLines.changeValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=k=>{k===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(k=>p(k.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const n=[],d=[];for(const r of this._notebook.getCells())r.kind===c.NotebookCellKind.Code&&(!this._selector||(0,A.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),n.push(r.document.getText().length+1),d.push(r.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(d))}get version(){return this._versionId}getText(n){if(!n){let w="";for(const l of this._cells)w+=l.document.getText()+`
`;return w=w.slice(0,-1),w}if(n.isEmpty)return"";const d=this.locationAt(n.start),r=this.locationAt(n.end),u=this._cellUris.get(d.uri),p=this._cellUris.get(r.uri);if(u===void 0||p===void 0)return"";if(u===p)return this._cells[u].document.getText(new c.Range(d.range.start,r.range.end));const k=[this._cells[u].document.getText(new c.Range(d.range.start,new c.Position(this._cells[u].document.lineCount,0)))];for(let w=u+1;w<p;w++)k.push(this._cells[w].document.getText());return k.push(this._cells[p].document.getText(new c.Range(new c.Position(0,0),r.range.end))),k.join(`
`)}offsetAt(n){const d=this._cellLines.getIndexOf(n.line),r=this._cellLengths.getPrefixSum(d.index-1),u=this._cells[d.index].document.offsetAt(n.with(d.remainder));return r+u}positionAt(n){if(typeof n=="number"){const r=this._cellLengths.getIndexOf(n),u=this._cellLines.getPrefixSum(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(u)}const d=this._cellUris.get(n.uri);if(d!==void 0){const r=this._cellLines.getPrefixSum(d-1);return new c.Position(r+n.range.start.line,n.range.start.character)}return new c.Position(0,0)}locationAt(n){c.Range.isRange(n)||(n=new c.Range(n,n));const d=this._cellLines.getIndexOf(n.start.line);let r=d;n.isEmpty||(r=this._cellLines.getIndexOf(n.end.line));const u=new c.Position(d.remainder,n.start.character),p=new c.Position(r.remainder,n.end.character),k=new c.Range(u,p),w=this._cells[d.index];return new c.Location(w.document.uri,w.document.validateRange(k))}contains(n){return this._cellUris.has(n)}validateRange(n){const d=this.validatePosition(n.start),r=this.validatePosition(n.end);return n.with(d,r)}validatePosition(n){const d=this._cellLines.getIndexOf(n.line),r=new c.Position(d.remainder,n.character),u=this._cells[d.index].document.validatePosition(r),p=this._cellLines.getPrefixSum(d.index-1);return new c.Position(p+u.line,u.character)}}e.ExtHostNotebookConcatDocument=t}),define(we[156],be([0,1,6,12,3]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(P){this._actual=new c.ColorTheme(c.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let S=P==="light"?c.ColorThemeKind.Light:P==="dark"?c.ColorThemeKind.Dark:c.ColorThemeKind.HighContrast;this._actual=new c.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Ue([ze(0,M.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(we[66],be([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class M{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=M}),define(we[157],be([0,1,23]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(S){let I=this.buffers.indexOf(S);return I<0&&(I=this.buffers.length,this.buffers.push(S)),I}}function E(P,S){if(S.serializeBuffersForPostMessage){const I=new M,t=(d,r)=>{if(r instanceof ArrayBuffer){const u=I.add(r);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(r)){const u=T(r);if(u){const p=I.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:u,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},y=JSON.stringify(P,t),n=I.buffers.map(d=>{const r=new Uint8Array(d);return c.VSBuffer.wrap(r)});return{message:y,buffers:n}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=E;function T(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(P,S){const I=S.map(n=>{const d=new ArrayBuffer(n.byteLength);return new Uint8Array(d).set(n.buffer),d}),t=S.length?(n,d)=>{if(typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const r=d,{index:u}=r,p=I[u];if(r.view)switch(r.view.type){case 1:return new Int8Array(p,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return d}:void 0;return{message:JSON.parse(P,t),arrayBuffers:I}}e.deserializeWebviewMessage=A}),define(we[158],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var c;(function(M){function E(A){const P={items:new Map};return A.types.forEach((S,I)=>{P.items.set(S,{asString:async()=>A.items[I].asString})}),P}M.toITreeDataTransfer=E;async function T(A){const P={types:[],items:[]},S=Array.from(A.items.entries());for(const I of S)P.types.push(I[0]),P.items.push({asString:await I[1].asString()});return P}M.toTreeDataTransferDTO=T})(c=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(we[67],be([0,1,11,2]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(P,S){return P.scheme===c.Schemas.http||P.scheme===c.Schemas.https?P:(S&&S.authority&&S.isRemote&&P.scheme===c.Schemas.file&&(P=M.URI.from({scheme:c.Schemas.vscodeRemote,authority:S.authority,path:P.path})),M.URI.from({scheme:c.Schemas.https,authority:`${P.scheme}+${T(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=E;function T(P){return P.replace(/./g,S=>{const I=S.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?S:"-"+I.toString(16).padStart(4,"0")})}function A(P){return P.replace(/-([0-9a-f]{4})/g,(S,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=A}),define(we[159],be([0,1,3,7,67]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(P,S,I){this._proxy=P,this._editors=S,this._initData=I,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const t=S.getVisibleTextEditors();for(const y of this._insets.values())t.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,S,I,t,y){let n;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===P){n=l;break}if(!n)throw new Error("not a visible editor");const d=this,r=this._handlePool++,u=new c.Emitter,p=new c.Emitter,k=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,E.asWebviewUri)(l,d._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(l){this._options=l,d._proxy.$setOptions(r,l)}get options(){return this._options}set html(l){this._html=l,d._proxy.$setHtml(r,l)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(l){return d._proxy.$postMessage(r,l)}},w=new class{constructor(){this.editor=P,this.line=S,this.height=I,this.webview=k,this.onDidDispose=p.event}dispose(){d._insets.has(r)&&(d._insets.delete(r),d._proxy.$disposeEditorInset(r),p.fire(),p.dispose(),u.dispose())}};return this._proxy.$createEditorInset(r,n.id,n.value.document.uri,S+1,I,t||{},y.identifier,y.extensionLocation),this._insets.set(r,{editor:P,inset:w,onDidReceiveMessage:u}),w}$onDidDispose(P){const S=this._insets.get(P);S&&S.inset.dispose()}$onDidReceiveMessage(P,S){const I=this._insets.get(P);I&&I.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=T}),define(we[160],be([0,1,130,10,2,7,4,42,28,16,11]),function(re,e,c,M,E,T,A,P,S,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.ActiveEditorDirtyContext=new P.RawContextKey("activeEditorIsDirty",!1,(0,c.localize)(2,null)),e.ActiveEditorPinnedContext=new P.RawContextKey("activeEditorIsNotPreview",!1,(0,c.localize)(3,null)),e.ActiveEditorStickyContext=new P.RawContextKey("activeEditorIsPinned",!1,(0,c.localize)(4,null)),e.ActiveEditorReadonlyContext=new P.RawContextKey("activeEditorIsReadonly",!1,(0,c.localize)(5,null)),e.ActiveEditorCanRevertContext=new P.RawContextKey("activeEditorCanRevert",!1,(0,c.localize)(6,null)),e.ActiveEditorContext=new P.RawContextKey("activeEditor",null,{type:"string",description:(0,c.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new P.RawContextKey("activeEditorAvailableEditorIds","",(0,c.localize)(8,null)),e.TextCompareEditorVisibleContext=new P.RawContextKey("textCompareEditorVisible",!1,(0,c.localize)(9,null)),e.TextCompareEditorActiveContext=new P.RawContextKey("textCompareEditorActive",!1,(0,c.localize)(10,null)),e.EditorGroupEditorsCountContext=new P.RawContextKey("groupEditorsCount",0,(0,c.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new P.RawContextKey("activeEditorGroupEmpty",!1,(0,c.localize)(12,null)),e.ActiveEditorGroupIndexContext=new P.RawContextKey("activeEditorGroupIndex",0,(0,c.localize)(13,null)),e.ActiveEditorGroupLastContext=new P.RawContextKey("activeEditorGroupLast",!1,(0,c.localize)(14,null)),e.ActiveEditorGroupLockedContext=new P.RawContextKey("activeEditorGroupLocked",!1,(0,c.localize)(15,null)),e.MultipleEditorGroupsContext=new P.RawContextKey("multipleEditorGroups",!1,(0,c.localize)(16,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new P.RawContextKey("editorIsOpen",!1,(0,c.localize)(17,null)),e.InEditorZenModeContext=new P.RawContextKey("inZenMode",!1,(0,c.localize)(18,null)),e.IsCenteredLayoutContext=new P.RawContextKey("isCenteredLayout",!1,(0,c.localize)(19,null)),e.SplitEditorsVertically=new P.RawContextKey("splitEditorsVertically",!1,(0,c.localize)(20,null)),e.EditorAreaVisibleContext=new P.RawContextKey("editorAreaVisible",!0,(0,c.localize)(21,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function y(h){return typeof h?.getViewState=="function"}e.isTextEditorPane=y;function n(h){if(l(h))return!1;const b=h;return E.URI.isUri(b?.resource)}e.isResourceEditorInput=n;function d(h){if(l(h))return!1;const b=h;return b?.original!==void 0&&b.modified!==void 0}e.isResourceDiffEditorInput=d;function r(h){if(l(h))return!1;const b=h;return b?b.resource===void 0||b.resource.scheme===t.Schemas.untitled||b.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=r;var u;(function(h){h[h.SHORT=0]="SHORT",h[h.MEDIUM=1]="MEDIUM",h[h.LONG=2]="LONG"})(u=e.Verbosity||(e.Verbosity={}));var p;(function(h){h[h.EXPLICIT=1]="EXPLICIT",h[h.AUTO=2]="AUTO",h[h.FOCUS_CHANGE=3]="FOCUS_CHANGE",h[h.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(p=e.SaveReason||(e.SaveReason={}));var k;(function(h){h[h.None=0]="None",h[h.Readonly=2]="Readonly",h[h.Untitled=4]="Untitled",h[h.Singleton=8]="Singleton",h[h.RequiresTrust=16]="RequiresTrust"})(k=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class w extends T.Disposable{}e.AbstractEditorInput=w;function l(h){return h instanceof w}e.isEditorInput=l;function v(h){const b=h;return E.URI.isUri(b?.preferredResource)}function D(h){const b=h;return l(b?.primary)&&l(b?.secondary)}e.isSideBySideEditorInput=D;function i(h){return l(h?.editor)}e.isEditorInputWithOptions=i;function s(h){const b=h;return i(h)&&b?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function a(h){const b=h;return typeof b?.groupId=="number"&&l(b.editor)}e.isEditorIdentifier=a;var o;(function(h){h[h.PRIMARY=1]="PRIMARY",h[h.SECONDARY=2]="SECONDARY",h[h.BOTH=3]="BOTH"})(o=e.SideBySideEditor||(e.SideBySideEditor={}));class _{getOriginalUri(b,f){if(!b)return;const F=D(b)?b.primary:d(b)?b.modified:void 0,O=D(b)?b.secondary:d(b)?b.original:void 0;if(f?.supportSideBySide&&F&&O){if(f?.supportSideBySide===o.BOTH)return{primary:this.getOriginalUri(F,{filterByScheme:f.filterByScheme}),secondary:this.getOriginalUri(O,{filterByScheme:f.filterByScheme})};b=f.supportSideBySide===o.PRIMARY?F:O}if(d(b))return;const q=v(b)?b.preferredResource:b.resource;return!q||!f||!f.filterByScheme?q:this.filterUri(q,f.filterByScheme)}getCanonicalUri(b,f){if(!b)return;const F=D(b)?b.primary:d(b)?b.modified:void 0,O=D(b)?b.secondary:d(b)?b.original:void 0;if(f?.supportSideBySide&&F&&O){if(f?.supportSideBySide===o.BOTH)return{primary:this.getCanonicalUri(F,{filterByScheme:f.filterByScheme}),secondary:this.getCanonicalUri(O,{filterByScheme:f.filterByScheme})};b=f.supportSideBySide===o.PRIMARY?F:O}if(d(b))return;const q=b.resource;return!q||!f||!f.filterByScheme?q:this.filterUri(q,f.filterByScheme)}filterUri(b,f){if(Array.isArray(f)){if(f.some(F=>b.scheme===F))return b}else if(f===b.scheme)return b}}e.EditorResourceAccessor=new _;var m;(function(h){h[h.LEFT=0]="LEFT",h[h.RIGHT=1]="RIGHT"})(m=e.CloseDirection||(e.CloseDirection={}));class g{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(b){const f=this.instantiationService=b.get(A.IInstantiationService);for(const[F,O]of this.editorSerializerConstructors)this.createEditorSerializer(F,O,f);this.editorSerializerConstructors.clear()}createEditorSerializer(b,f,F){const O=F.createInstance(f);this.editorSerializerInstances.set(b,O)}registerFileEditorFactory(b){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=b}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(b,f){if(this.editorSerializerConstructors.has(b)||this.editorSerializerInstances.has(b))throw new Error(`A editor serializer with type ID '${b}' was already registered.`);return this.instantiationService?this.createEditorSerializer(b,f,this.instantiationService):this.editorSerializerConstructors.set(b,f),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete(b),this.editorSerializerInstances.delete(b)})}getEditorSerializer(b){return this.editorSerializerInstances.get(typeof b=="string"?b:b.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new g);async function C(h,b){if(!h||!h.length)return[];const f=await Promise.all(h.map(async F=>{const O=E.URI.revive(F.fileUri);if(!O||(await b.activateProvider(O.scheme),!b.canHandleResource(O)))return;const q=typeof F.exists=="boolean"?F.exists:await b.exists(O);if(!q&&F.openOnlyIfExists)return;const Q=q&&!(0,M.isUndefined)(F.selection)?{selection:F.selection,pinned:!0,override:F.editorOverrideId}:{pinned:!0,override:F.editorOverrideId};let $;return q?$={resource:O,options:Q,forceFile:!0}:$={resource:O,options:Q,forceUntitled:!0},$}));return(0,I.coalesce)(f)}e.pathsToEditors=C;var R;(function(h){h[h.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",h[h.SEQUENTIAL=1]="SEQUENTIAL"})(R=e.EditorsOrder||(e.EditorsOrder={}))}),define(we[161],be([0,1,3,42,131,4,7,20,28,16,50,22,34,151]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,d.registerIcon)("default-view-icon",n.Codicon.window,(0,E.localize)(0,null));var r;(function(_){_.ViewContainersRegistry="workbench.registry.view.containers",_.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var u;(function(_){_[_.Sidebar=0]="Sidebar",_[_.Panel=1]="Panel"})(u=e.ViewContainerLocation||(e.ViewContainerLocation={}));function p(_){switch(_){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=p;function k(_){return`viewContainer.${_}.enabled`}e.getEnabledViewContainerContextKey=k;class w extends A.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new c.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new c.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,I.flatten)([...this.viewContainers.values()])}registerViewContainer(m,g,C){const R=this.get(m.id);if(R)return R;const h=m;return h.openCommandActionDescriptor=C?.donotRegisterOpenCommand?void 0:h.openCommandActionDescriptor??{id:h.id},(0,P.getOrSet)(this.viewContainers,g,[]).push(h),C?.isDefault&&this.defaultViewContainers.push(h),this._onDidRegister.fire({viewContainer:h,viewContainerLocation:g}),h}deregisterViewContainer(m){for(const g of this.viewContainers.keys()){const C=this.viewContainers.get(g),R=C?.indexOf(m);if(R!==-1){C?.splice(R,1),C.length===0&&this.viewContainers.delete(g),this._onDidDeregister.fire({viewContainer:m,viewContainerLocation:g});return}}}get(m){return this.all.filter(g=>g.id===m)[0]}getViewContainers(m){return[...this.viewContainers.get(m)||[]]}getViewContainerLocation(m){return[...this.viewContainers.keys()].filter(g=>this.getViewContainers(g).filter(C=>C?.id===m.id).length>0)[0]}getDefaultViewContainer(m){return this.defaultViewContainers.find(g=>this.getViewContainerLocation(g)===m)}}S.Registry.add(r.ViewContainersRegistry,new w);var l;(function(_){_.Open="2_open",_.Debug="4_debug",_.SCM="5_scm",_.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function v(_,m){const g=_.group??l.More,C=m.group??l.More;return g!==C?g.localeCompare(C):(_.order??5)-(m.order??5)}class D extends A.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new c.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new c.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new c.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new c.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(m,g){this.registerViews2([{views:m,viewContainer:g}])}registerViews2(m){m.forEach(({views:g,viewContainer:C})=>this.addViews(g,C)),this._onViewsRegistered.fire(m)}deregisterViews(m,g){const C=this.removeViews(m,g);C.length&&this._onViewsDeregistered.fire({views:C,viewContainer:g})}moveViews(m,g){for(const C of this._views.keys())if(C!==g){const R=this.removeViews(m,C);R.length&&(this.addViews(R,g),this._onDidChangeContainer.fire({views:R,from:C,to:g}))}}getViews(m){return this._views.get(m)||[]}getView(m){for(const g of this._viewContainers){const C=(this._views.get(g)||[]).filter(R=>R.id===m)[0];if(C)return C}return null}getViewContainer(m){for(const g of this._viewContainers)if((this._views.get(g)||[]).filter(R=>R.id===m)[0])return g;return null}registerViewWelcomeContent(m,g){return this._viewWelcomeContents.add(m,g),this._onDidChangeViewWelcomeContent.fire(m),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(m,g),this._onDidChangeViewWelcomeContent.fire(m)})}registerViewWelcomeContent2(m,g){const C=new Map;for(const[R,h]of g)this._viewWelcomeContents.add(m,h),C.set(R,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(m,h),this._onDidChangeViewWelcomeContent.fire(m)}));return this._onDidChangeViewWelcomeContent.fire(m),C}getViewWelcomeContent(m){const g=[];return this._viewWelcomeContents.forEach(m,C=>g.push(C)),g.sort(v)}addViews(m,g){let C=this._views.get(g);C||(C=[],this._views.set(g,C),this._viewContainers.push(g));for(const R of m){if(this.getView(R.id)!==null)throw new Error((0,E.localize)(1,null,R.id));C.push(R)}}removeViews(m,g){const C=this._views.get(g);if(!C)return[];const R=[],h=[];for(const b of C)m.includes(b)?R.push(b):h.push(b);return R.length&&(h.length?this._views.set(g,h):(this._views.delete(g),this._viewContainers.splice(this._viewContainers.indexOf(g),1))),R}}S.Registry.add(r.ViewsRegistry,new D),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,E.localize)(2,null));function i(_){return`view.${_}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var s;(function(_){_[_.Default=0]="Default",_[_.Expand=1]="Expand"})(s=e.ViewVisibilityState||(e.ViewVisibilityState={}));var a;(function(_){_[_.None=0]="None",_[_.Collapsed=1]="Collapsed",_[_.Expanded=2]="Expanded"})(a=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class o{constructor(m,g){this.resolved=!1,this._hasResolve=!1,(0,y.mixin)(this,m),this._hasResolve=!!g,this.resolve=async C=>{if(g&&!this.resolved){const R=await g(C);R&&(this.tooltip=this.tooltip??R.tooltip,this.command=this.command??R.command)}C.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(we[162],be([0,1,3,13,132]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new c.Emitter,this._onExit=new c.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,S,I,t){const y={command:P};if(S&&Object.keys(S).length>0&&(y.arguments=S),this.internalSend("request",y),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const d=this.pendingRequests.get(y.seq);if(d){this.pendingRequests.delete(y.seq);const r={type:"response",seq:0,request_seq:y.seq,success:!1,command:P,message:(0,E.localize)(0,null,t,P)};d(r)}},t)}return I&&this.pendingRequests.set(y.seq,I),y.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,S){return P.type!=="event"||S.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,M.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const S=P,I=this.pendingRequests.get(S.request_seq);I&&(this.pendingRequests.delete(S.request_seq),I(S));break}}}internalSend(P,S){S.type=P,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((S,I)=>P.set(I,S)),await(0,M.timeout)(500),P.forEach((S,I)=>{S({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(we[163],be([0,1,9,2,17,22,11]),function(re,e,c,M,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function S(a,o,_){return a.replace(P,function(m,g){return o&&g.length>0&&g[0]!=="_"?m:_&&_.hasOwnProperty(g)?_[g]:m})}e.formatPII=S;function I(a){const o={};for(const _ of Object.keys(a))_.startsWith("!")||(o[_]=a[_]);return o}e.filterExceptionsFromTelemetry=I;function t(a){return a.configuration.request==="attach"&&!y(a)&&(!a.parentSession||t(a.parentSession))}e.isSessionAttach=t;function y(a){let o=a.configuration.type;if(!!o)return o==="vslsShare"&&(o=a.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(o,"extensionhost")||(0,c.equalsIgnoreCase)(o,"pwa-extensionhost")?a:a.parentSession?y(a.parentSession):void 0}e.getExtensionHostDebugSession=y;function n(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=n;function d(a,o,_){let m,g=0,C=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,R=null;for(;R=C.exec(a);){let h=R.index+1,b=h+R[0].length;if(h<=o&&b>=_){m=R[0],g=h;break}}if(m){let h=/\w+/g,b=null;for(;(b=h.exec(m))&&!(b.index+1+g+b[0].length>=_););b&&(m=m.substring(0,h.lastIndex))}return m?{start:g,end:g+m.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(a){return!!(a&&a.match(r))}e.isUri=u;function p(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(u(a.path))return M.URI.parse(a.path);if((0,E.isAbsolute)(a.path))return M.URI.file(a.path)}return a.path}function k(a){if(typeof a.path=="object"){const o=M.URI.revive(a.path);if(o)return o.scheme===A.Schemas.file?o.fsPath:o.toString()}return a.path}function w(a,o){const _=o?p:k,m=(0,T.deepClone)(a);return v(m,(g,C)=>{g&&C&&(C.path=_(C))}),m}e.convertToDAPaths=w;function l(a,o){const _=o?p:k,m=(0,T.deepClone)(a);return v(m,(g,C)=>{!g&&C&&(C.path=_(C))}),m}e.convertToVSCPaths=l;function v(a,o){switch(a.type){case"event":const _=a;switch(_.event){case"output":o(!1,_.body.source);break;case"loadedSource":o(!1,_.body.source);break;case"breakpoint":o(!1,_.body.breakpoint.source);break;default:break}break;case"request":const m=a;switch(m.command){case"setBreakpoints":o(!0,m.arguments.source);break;case"breakpointLocations":o(!0,m.arguments.source);break;case"source":o(!0,m.arguments.source);break;case"gotoTargets":o(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(C=>o(!1,C));break;default:break}break;case"response":const g=a;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(C=>o(!1,C.source));break;case"loadedSources":g.body.sources.forEach(C=>o(!1,C));break;case"scopes":g.body.scopes.forEach(C=>o(!1,C.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(C=>o(!1,C.source));break;case"setBreakpoints":g.body.breakpoints.forEach(C=>o(!1,C.source));break;default:break}break}}function D(a){return a.filter(o=>!o.presentation?.hidden).sort((o,_)=>o.presentation?_.presentation?o.presentation.group?_.presentation.group?o.presentation.group!==_.presentation.group?o.presentation.group.localeCompare(_.presentation.group):i(o.presentation.order,_.presentation.order):-1:_.presentation.group?1:i(o.presentation.order,_.presentation.order):-1:_.presentation?1:0)}e.getVisibleAndSorted=D;function i(a,o){return typeof a!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:a-o}async function s(a,o){const _=a.getValue("debug.saveBeforeStart",{overrideIdentifier:o.activeTextEditorMode});if(_!=="none"&&(await o.saveAll(),_==="allEditorsInActiveGroup")){const m=o.activeEditorPane;m&&await o.save({editor:m.input,groupId:m.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=s}),define(we[89],be([0,1,27,78,11,17,26,42]),function(re,e,c,M,E,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var S;(function(h){h[h.Markup=1]="Markup",h[h.Code=2]="Code"})(S=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var I;(function(h){h[h.Running=1]="Running",h[h.Idle=2]="Idle"})(I=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(h){h[h.Pending=2]="Pending",h[h.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var y;(function(h){h[h.WithHardKernelDependency=0]="WithHardKernelDependency",h[h.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",h[h.Pure=2]="Pure",h[h.Never=3]="Never"})(y=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var n;(function(h){h.Always="always",h.Never="never",h.Optional="optional"})(n=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(h){h[h.ModelChange=1]="ModelChange",h[h.Move=2]="Move",h[h.ChangeLanguage=5]="ChangeLanguage",h[h.Initialize=6]="Initialize",h[h.ChangeCellMetadata=7]="ChangeCellMetadata",h[h.Output=8]="Output",h[h.OutputItem=9]="OutputItem",h[h.ChangeCellContent=10]="ChangeCellContent",h[h.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",h[h.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",h[h.ChangeCellMime=13]="ChangeCellMime",h[h.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var r;(function(h){h[h.Handle=0]="Handle",h[h.Index=1]="Index"})(r=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(h){h[h.Replace=1]="Replace",h[h.Output=2]="Output",h[h.Metadata=3]="Metadata",h[h.CellLanguage=4]="CellLanguage",h[h.DocumentMetadata=5]="DocumentMetadata",h[h.Move=6]="Move",h[h.OutputItems=7]="OutputItems",h[h.PartialMetadata=8]="PartialMetadata",h[h.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var p;(function(h){h.scheme=E.Schemas.vscodeNotebookCell;const b=/^ch(\d{7,})/;function f($,z){return $.with({scheme:h.scheme,fragment:`ch${z.toString().padStart(7,"0")}${$.scheme!==E.Schemas.file?$.scheme:""}`})}h.generate=f;function F($){if($.scheme!==h.scheme)return;const z=b.exec($.fragment);return z?{handle:Number(z[1]),notebook:$.with({scheme:$.fragment.substr(z[0].length)||E.Schemas.file,fragment:null})}:void 0}h.parse=F;function O($){if($.scheme!==E.Schemas.vscodeNotebookCellMetadata)return;const z=b.exec($.fragment);return z?{handle:Number(z[1]),notebook:$.with({scheme:$.fragment.substr(z[0].length)||E.Schemas.file,fragment:null})}:void 0}h.parseCellMetadataUri=O;function q($,z,N){return $.with({scheme:N,fragment:`ch${z.toString().padStart(7,"0")}${$.scheme!==E.Schemas.file?$.scheme:""}`})}h.generateCellUri=q;function Q($,z){if($.scheme!==z)return;const N=b.exec($.fragment);return N?{handle:Number(N[1]),notebook:$.with({scheme:$.fragment.substr(N[0].length)||E.Schemas.file,fragment:null})}:void 0}h.parseCellUri=Q})(p=e.CellUri||(e.CellUri={}));const k=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[M.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(h){return k.get(h)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=w;function l(h){return k.get(h)?.supportedByCore??!1}e.mimeTypeSupportedByCore=l;function v(h){return k.get(h)?.mergeable??!1}e.mimeTypeIsMergeable=v;function D(h,b){return A.isWindows&&(h=h.replace(/\//g,"\\"),b=b.replace(/\//g,"\\")),c.match(h,b)}function i(h,b,f){let F=0;for(let O=0;O<b.length;O++){if(D(b[O],h))return F;F++}for(let O=0;O<f.length;O++){if(D(f[O],h))return F;F++}return F}function s(h,b,f){return h.sort((F,O)=>i(F,b,f)-i(O,b,f))}e.sortMimeTypes=s;function a(h,b,f,F=(O,q)=>O===q){const O=[];function q(z,N,W){if(N===0&&W.length===0)return;const j=O[O.length-1];j&&j.start+j.deleteCount===z?(j.deleteCount+=N,j.toInsert.push(...W)):O.push({start:z,deleteCount:N,toInsert:W})}let Q=0,$=0;for(;;){if(Q===h.length){q(Q,0,b.slice($));break}if($===b.length){q(Q,h.length-Q,[]);break}const z=h[Q],N=b[$];if(F(z,N)){Q+=1,$+=1;continue}f(N)?(q(Q,1,[]),Q+=1):(q(Q,0,[N]),$+=1)}return O}e.diff=a,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new P.RawContextKey("notebookEditorCursorAtBoundary","none");var o;(function(h){h.default="default",h.option="option"})(o=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function _(h){const b=h;return!!((typeof b.include=="string"||c.isRelativePattern(b.include))&&(typeof b.exclude=="string"||c.isRelativePattern(b.exclude)))}e.isDocumentExcludePattern=_;function m(h,b,f){if(Array.isArray(h.viewType)&&h.viewType.indexOf(b)>=0||h.viewType===b)return!0;if(h.filenamePattern){let F=_(h.filenamePattern)?h.filenamePattern.include:h.filenamePattern,O=_(h.filenamePattern)?h.filenamePattern.exclude:void 0;if(c.match(F,(0,T.basename)(f.fsPath).toLowerCase()))return!(O&&c.match(O,(0,T.basename)(f.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=m;class g{constructor(b){this.textModel=b}getElements(){const b=new Int32Array(this.textModel.cells.length);for(let f=0;f<this.textModel.cells.length;f++)b[f]=this.textModel.cells[f].getHashValue();return b}}e.CellSequence=g,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var C;(function(h){h[h.Left=1]="Left",h[h.Right=2]="Right"})(C=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class R{static create(b){return`${R._prefix}${b}`}static parse(b){if(b.startsWith(R._prefix))return b.substr(R._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=R,R._prefix="notebook/"}),define(we[164],be([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState",E[E.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(we[165],be([0,1,134,4,42]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,c.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,c.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,c.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[166],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=c;function M(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=M}),define(we[90],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var c;(function(y){y[y.Unset=0]="Unset",y[y.Queued=1]="Queued",y[y.Running=2]="Running",y[y.Passed=3]="Passed",y[y.Failed=4]="Failed",y[y.Skipped=5]="Skipped",y[y.Errored=6]="Errored"})(c=e.TestResultState||(e.TestResultState={}));var M;(function(y){y[y.Run=2]="Run",y[y.Debug=4]="Debug",y[y.Coverage=8]="Coverage",y[y.HasNonDefaultProfile=16]="HasNonDefaultProfile",y[y.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(y){y[y.Error=0]="Error",y[y.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var T;(function(y){y[y.NotExpandable=0]="NotExpandable",y[y.Expandable=1]="Expandable",y[y.BusyExpanding=2]="BusyExpanding",y[y.Expanded=3]="Expanded"})(T=e.TestItemExpandState||(e.TestItemExpandState={}));const A=(y,n)=>{n.expand!==void 0&&(y.expand=n.expand),n.item!==void 0&&(y.item=y.item?Object.assign(y.item,n.item):n.item)};e.applyTestItemUpdate=A;var P;(function(y){y[y.Function=0]="Function",y[y.Statement=1]="Statement"})(P=e.DetailType||(e.DetailType={}));var S;(function(y){y[y.Add=0]="Add",y[y.Update=1]="Update",y[y.Remove=2]="Remove",y[y.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",y[y.Retire=4]="Retire",y[y.AddTag=5]="AddTag",y[y.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class I{add(n){}update(n){}remove(n,d){}complete(){}}e.IncrementalChangeCollector=I;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const d=this.createChangeCollector();for(const r of n)switch(r[0]){case 0:{const u=r[1];if(u.parent){if(this.items.has(u.parent)){const p=this.items.get(u.parent);p.children.add(u.item.extId);const k=this.createItem(u,p);this.items.set(u.item.extId,k),d.add(k)}}else{const p=this.createItem(u);this.roots.add(p),this.items.set(u.item.extId,p),d.add(p)}u.expand===2&&this.busyControllerCount++;break}case 1:{const u=r[1],p=this.items.get(u.extId);if(!p)break;u.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,u.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,u),d.update(p);break}case 2:{const u=this.items.get(r[1]);if(!u)break;u.parent?this.items.get(u.parent).children.delete(u.item.extId):this.roots.delete(u);const p=[[r[1]]];for(;p.length;)for(const k of p.pop()){const w=this.items.get(k);w&&(p.push(w.children),this.items.delete(k),d.remove(w,w!==u),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(r[1]);break;case 3:this.updatePendingRoots(r[1]);break;case 5:this._tags.set(r[1].id,r[1]);break;case 6:this._tags.delete(r[1]);break}d.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new I}}e.AbstractIncrementalTestCollection=t}),define(we[68],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(T){T.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class E{constructor(A,P=A.length){if(this.path=A,this.viewEnd=P,A.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(A,P,S=A.parent){if(A.id===P)return new E([P]);let I=[A.id];for(let t=S;t&&t.id!==P;t=t.parent)I.push(t.id);return I.push(P),new E(I.reverse())}static isRoot(A){return!A.includes("\0")}static fromString(A){return new E(A.split("\0"))}static join(A,P){return new E([...A.path,P])}static joinToString(A,P){return A.toString()+"\0"+P}static compare(A,P){return A===P?0:P.startsWith(A+"\0")?2:A.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new E(this.path,A)}compare(A){if(typeof A=="string")return E.compare(this.toString(),A);for(let P=0;P<A.viewEnd&&P<this.viewEnd;P++)if(A.path[P]!==this.path[P])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=E}),define(we[167],be([0,1,17,91,10,22,26,77,135]),function(re,e,c,M,E,T,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(y,n,d){this._contributedVariables=new Map,this._context=y,this._labelService=n,d&&(this._envVariablesPromise=d.then(r=>this.prepareEnv(r)))}prepareEnv(y){if(A.isWindows){const n=Object.create(null);return Object.keys(y).forEach(d=>{n[d.toLowerCase()]=y[d]}),n}return y}resolveWithEnvironment(y,n,d){return this.recursiveResolve(this.prepareEnv(y),n?n.uri:void 0,d)}async resolveAsync(y,n){return this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,n)}async resolveAnyBase(y,n,d,r){const u=T.deepClone(n);return A.isWindows&&u.windows?Object.keys(u.windows).forEach(p=>u[p]=u.windows[p]):A.isMacintosh&&u.osx?Object.keys(u.osx).forEach(p=>u[p]=u.osx[p]):A.isLinux&&u.linux&&Object.keys(u.linux).forEach(p=>u[p]=u.linux[p]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(await this._envVariablesPromise,y?y.uri:void 0,u,d,r)}async resolveAnyAsync(y,n,d){return this.resolveAnyBase(y,n,d)}async resolveAnyMap(y,n,d){const r=new Map;return{newConfig:await this.resolveAnyBase(y,n,d,r),resolvedVariables:r}}resolveWithInteractionReplace(y,n,d,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,n,d,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,n){if(this._contributedVariables.has(y))throw new Error("Variable "+y+" is contributed twice.");this._contributedVariables.set(y,n)}recursiveResolve(y,n,d,r,u){if(E.isString(d))return this.resolveString(y,n,d,r,u);if(E.isArray(d))return d.map(p=>this.recursiveResolve(y,n,p,r,u));if(E.isObject(d)){let p=Object.create(null);return Object.keys(d).forEach(k=>{const w=this.resolveString(y,n,k,r,u);p[w]=this.recursiveResolve(y,n,d[k],r,u)}),p}return d}resolveString(y,n,d,r,u){return d.replace(I.VARIABLE_REGEXP,(k,w)=>{if(w.includes(I.VARIABLE_LHS))return k;let l=this.evaluateSingleVariable(y,k,w,n,r);return u&&u.set(w,l),l!==k&&E.isString(l)&&l.match(I.VARIABLE_REGEXP)&&(l=this.resolveString(y,n,l,r,u)),l})}fsPath(y){return this._labelService?this._labelService.getUriLabel(y,{noPrefix:!0}):y.fsPath}evaluateSingleVariable(y,n,d,r,u){let p;const k=d.split(":");k.length>1&&(d=k[0],p=k[1]);const w=()=>{const D=this._context.getFilePath();if(D)return D;throw new Error((0,S.localize)(0,null,n))},l=()=>{const D=w();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,S.localize)(1,null,n,c.basename(D)))},v=()=>{if(p){const D=this._context.getFolderUri(p);if(D)return D;throw new Error((0,S.localize)(2,null,n,p))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,n)):new Error((0,S.localize)(4,null,n))};switch(d){case"env":if(p){if(y){const D=y[A.isWindows?p.toLowerCase():p];if(E.isString(D))return D}return""}throw new Error((0,S.localize)(5,null,n));case"config":if(p){const D=this._context.getConfigurationValue(r,p);if(E.isUndefinedOrNull(D))throw new Error((0,S.localize)(6,null,n,p));if(E.isObject(D))throw new Error((0,S.localize)(7,null,n,p));return D}throw new Error((0,S.localize)(8,null,n));case"command":return this.resolveFromMap(n,p,u,"command");case"input":return this.resolveFromMap(n,p,u,"input");default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(v()));case"cwd":return r||p?(0,P.normalizeDriveLetter)(this.fsPath(v())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return c.basename(this.fsPath(v()));case"lineNumber":const D=this._context.getLineNumber();if(D)return D;throw new Error((0,S.localize)(9,null,n));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,S.localize)(10,null,n));case"file":return w();case"fileWorkspaceFolder":return l();case"relativeFile":return r||p?c.relative(this.fsPath(v()),w()):w();case"relativeFileDirname":const s=c.dirname(w());if(r||p){const m=c.relative(this.fsPath(v()),s);return m.length===0?".":m}return s;case"fileDirname":return c.dirname(w());case"fileExtname":return c.extname(w());case"fileBasename":return c.basename(w());case"fileBasenameNoExtension":const a=c.basename(w());return a.slice(0,a.length-c.extname(a).length);case"fileDirnameBasename":return c.basename(c.dirname(w()));case"execPath":const o=this._context.getExecPath();return o||n;case"execInstallFolder":const _=this._context.getAppRoot();return _||n;case"pathSeparator":return c.sep;default:try{const m=p?`${d}:${p}`:d;return this.resolveFromMap(n,m,u,void 0)}catch(m){return n}}}}resolveFromMap(y,n,d,r){if(n&&d){const u=r===void 0?d[n]:d[r+":"+n];if(typeof u=="string")return u;throw new Error((0,S.localize)(11,null,y))}return y}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[92],be([0,1,4,160]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var E;(function(u){u[u.UP=0]="UP",u[u.DOWN=1]="DOWN",u[u.LEFT=2]="LEFT",u[u.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var T;(function(u){u[u.HORIZONTAL=0]="HORIZONTAL",u[u.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(u){u[u.FIRST=0]="FIRST",u[u.LAST=1]="LAST",u[u.NEXT=2]="NEXT",u[u.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var P;(function(u){u[u.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",u[u.EVEN=1]="EVEN",u[u.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(u){u[u.COPY_EDITORS=0]="COPY_EDITORS",u[u.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function I(u){const p=u;return(0,M.isEditorInput)(p?.editor)&&(0,M.isEditorInput)(p?.replacement)}e.isEditorReplacement=I;var t;(function(u){u[u.CREATION_TIME=0]="CREATION_TIME",u[u.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",u[u.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(u){u[u.GROUP_ACTIVE=0]="GROUP_ACTIVE",u[u.GROUP_INDEX=1]="GROUP_INDEX",u[u.GROUP_LOCKED=2]="GROUP_LOCKED",u[u.EDITOR_OPEN=3]="EDITOR_OPEN",u[u.EDITOR_CLOSE=4]="EDITOR_CLOSE",u[u.EDITOR_MOVE=5]="EDITOR_MOVE",u[u.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",u[u.EDITOR_LABEL=7]="EDITOR_LABEL",u[u.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",u[u.EDITOR_PIN=9]="EDITOR_PIN",u[u.EDITOR_STICKY=10]="EDITOR_STICKY",u[u.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(y=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(u){u[u.NEW_EDITOR=1]="NEW_EDITOR",u[u.MOVE_EDITOR=2]="MOVE_EDITOR",u[u.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function d(u){const p=u;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=d;function r(u){return u.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=r}),define(we[168],be([0,1,4,92]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(T){const A=T;return typeof T=="number"||(0,M.isEditorGroup)(A)}e.isPreferredGroup=E}),define(we[8],be([0,1,16,23,76,230,53,22,10,2,41,58,136,82,64,89,68,168,6]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r,u,p,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(ie){function pe(U){const{selectionStartLineNumber:Ce,selectionStartColumn:Se,positionLineNumber:Ge,positionColumn:We}=U,it=new w.Position(Ce-1,Se-1),mt=new w.Position(Ge-1,We-1);return new w.Selection(it,mt)}ie.to=pe;function ne(U){const{anchor:Ce,active:Se}=U;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:Se.line+1,positionColumn:Se.character+1}}ie.from=ne})(l=e.Selection||(e.Selection={}));var v;(function(ie){function pe(U){if(!U)return;const{start:Ce,end:Se}=U;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:Se.line+1,endColumn:Se.character+1}}ie.from=pe;function ne(U){if(!U)return;const{startLineNumber:Ce,startColumn:Se,endLineNumber:Ge,endColumn:We}=U;return new w.Range(Ce-1,Se-1,Ge-1,We-1)}ie.to=ne})(v=e.Range||(e.Range={}));var D;(function(ie){function pe(ne){switch(ne){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}ie.to=pe})(D=e.TokenType||(e.TokenType={}));var i;(function(ie){function pe(U){return new w.Position(U.lineNumber-1,U.column-1)}ie.to=pe;function ne(U){return{lineNumber:U.line+1,column:U.character+1}}ie.from=ne})(i=e.Position||(e.Position={}));var s;(function(ie){function pe(U){switch(U){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}ie.from=pe;function ne(U){switch(U){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}ie.to=ne})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var a;(function(ie){function pe(U){let Ce;return U.code&&((0,S.isString)(U.code)||(0,S.isNumber)(U.code)?Ce=String(U.code):Ce={value:String(U.code.value),target:U.code.target}),{...v.from(U.range),message:U.message,source:U.source,code:Ce,severity:_.from(U.severity),relatedInformation:U.relatedInformation&&U.relatedInformation.map(o.from),tags:Array.isArray(U.tags)?(0,c.coalesce)(U.tags.map(s.from)):void 0}}ie.from=pe;function ne(U){const Ce=new w.Diagnostic(v.to(U),U.message,_.to(U.severity));return Ce.source=U.source,Ce.code=(0,S.isString)(U.code)?U.code:U.code?.value,Ce.relatedInformation=U.relatedInformation&&U.relatedInformation.map(o.to),Ce.tags=U.tags&&(0,c.coalesce)(U.tags.map(s.to)),Ce}ie.to=ne})(a=e.Diagnostic||(e.Diagnostic={}));var o;(function(ie){function pe(U){return{...v.from(U.location.range),message:U.message,resource:U.location.uri}}ie.from=pe;function ne(U){return new w.DiagnosticRelatedInformation(new w.Location(U.resource,v.to(U)),U.message)}ie.to=ne})(o=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var _;(function(ie){function pe(U){switch(U){case w.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}ie.from=pe;function ne(U){switch(U){case d.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}ie.to=ne})(_=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var m;(function(ie){function pe(U){return typeof U=="number"&&U>=w.ViewColumn.One?U-1:U===w.ViewColumn.Beside?k.SIDE_GROUP:k.ACTIVE_GROUP}ie.from=pe;function ne(U){if(typeof U=="number"&&U>=0)return U+1;throw new Error("invalid 'EditorGroupColumn'")}ie.to=ne})(m=e.ViewColumn||(e.ViewColumn={}));function g(ie){return typeof ie.range!="undefined"}function C(ie){return ie.length===0?!0:!!g(ie[0])}e.isDecorationOptionsArr=C;var R;(function(ie){function pe(We){return We.map(ie.from)}ie.fromMany=pe;function ne(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function U(We){let it;if(ne(We)){const{language:ot,value:lt}=We;it={value:"```"+ot+`
`+lt+"\n```\n"}}else w.MarkdownString.isMarkdownString(We)?it={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons}:typeof We=="string"?it={value:We}:it={value:""};const mt=Object.create(null);it.uris=mt;const vt=ot=>{try{let lt=I.URI.parse(ot,!0);lt=lt.with({query:Ce(lt.query,mt)}),mt[ot]=lt}catch(lt){}return""},nt=new T.Renderer;return nt.link=vt,nt.image=ot=>vt(E.parseHrefAndDimensions(ot).href),T(it.value,{renderer:nt}),it}ie.from=U;function Ce(We,it){if(!We)return We;let mt;try{mt=(0,A.parse)(We)}catch(nt){}if(!mt)return We;let vt=!1;return mt=(0,P.cloneAndChange)(mt,nt=>{if(I.URI.isUri(nt)){const ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ot]=nt,vt=!0,ot}else return}),vt?JSON.stringify(mt):We}function Se(We){const it=new w.MarkdownString(We.value,We.supportThemeIcons);return it.isTrusted=We.isTrusted,it}ie.to=Se;function Ge(We){if(!!We)return typeof We=="string"?We:ie.from(We)}ie.fromStrict=Ge})(R=e.MarkdownString||(e.MarkdownString={}));function h(ie){return C(ie)?ie.map(pe=>({range:v.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?R.fromMany(pe.hoverMessage):pe.hoverMessage?R.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):ie.map(pe=>({range:v.from(pe)}))}e.fromRangeOrRangeWithMessage=h;function b(ie){return typeof ie=="undefined"?ie:typeof ie=="string"?I.URI.file(ie):ie}e.pathOrURIToURI=b;var f;(function(ie){function pe(ne){return typeof ne=="undefined"?ne:{contentText:ne.contentText,contentIconPath:ne.contentIconPath?b(ne.contentIconPath):void 0,border:ne.border,borderColor:ne.borderColor,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,color:ne.color,backgroundColor:ne.backgroundColor,margin:ne.margin,width:ne.width,height:ne.height}}ie.from=pe})(f=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(ie){function pe(ne){return typeof ne=="undefined"?ne:{backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?b(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?f.from(ne.before):void 0,after:ne.after?f.from(ne.after):void 0}}ie.from=pe})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var O;(function(ie){function pe(ne){if(typeof ne=="undefined")return ne;switch(ne){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}ie.from=pe})(O=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var q;(function(ie){function pe(ne){return{isWholeLine:ne.isWholeLine,rangeBehavior:ne.rangeBehavior?O.from(ne.rangeBehavior):void 0,overviewRulerLane:ne.overviewRulerLane,light:ne.light?F.from(ne.light):void 0,dark:ne.dark?F.from(ne.dark):void 0,backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?b(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?f.from(ne.before):void 0,after:ne.after?f.from(ne.after):void 0}}ie.from=pe})(q=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Q;(function(ie){function pe(U){return{text:U.newText,eol:U.newEol&&he.from(U.newEol),range:v.from(U.range)}}ie.from=pe;function ne(U){const Ce=new w.TextEdit(v.to(U.range),U.text);return Ce.newEol=typeof U.eol=="undefined"?void 0:he.to(U.eol),Ce}ie.to=ne})(Q=e.TextEdit||(e.TextEdit={}));var $;(function(ie){function pe(U,Ce,Se){const Ge={edits:[]};if(U instanceof w.WorkspaceEdit)for(let We of U._allEntries())if(We._type===1)Ge.edits.push({_type:1,oldUri:We.from,newUri:We.to,options:We.options,metadata:We.metadata});else if(We._type===2){const it=Ce?.getDocument(We.uri);Ge.edits.push({_type:2,resource:We.uri,edit:Q.from(We.edit),modelVersionId:it?.version,metadata:We.metadata})}else We._type===3?Ge.edits.push({_type:3,metadata:We.metadata,resource:We.uri,edit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version}):We._type===5&&Ge.edits.push({_type:3,metadata:We.metadata,resource:We.uri,notebookVersionId:Se?.getNotebookDocument(We.uri,!0)?.apiNotebook.version,edit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(Et.from)}});return Ge}ie.from=pe;function ne(U){const Ce=new w.WorkspaceEdit;for(const Se of U.edits)Se.edit?Ce.replace(I.URI.revive(Se.resource),v.to(Se.edit.range),Se.edit.text):Ce.renameFile(I.URI.revive(Se.oldUri),I.URI.revive(Se.newUri),Se.options);return Ce}ie.to=ne})($=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(ie){const pe=Object.create(null);pe[w.SymbolKind.File]=0,pe[w.SymbolKind.Module]=1,pe[w.SymbolKind.Namespace]=2,pe[w.SymbolKind.Package]=3,pe[w.SymbolKind.Class]=4,pe[w.SymbolKind.Method]=5,pe[w.SymbolKind.Property]=6,pe[w.SymbolKind.Field]=7,pe[w.SymbolKind.Constructor]=8,pe[w.SymbolKind.Enum]=9,pe[w.SymbolKind.Interface]=10,pe[w.SymbolKind.Function]=11,pe[w.SymbolKind.Variable]=12,pe[w.SymbolKind.Constant]=13,pe[w.SymbolKind.String]=14,pe[w.SymbolKind.Number]=15,pe[w.SymbolKind.Boolean]=16,pe[w.SymbolKind.Array]=17,pe[w.SymbolKind.Object]=18,pe[w.SymbolKind.Key]=19,pe[w.SymbolKind.Null]=20,pe[w.SymbolKind.EnumMember]=21,pe[w.SymbolKind.Struct]=22,pe[w.SymbolKind.Event]=23,pe[w.SymbolKind.Operator]=24,pe[w.SymbolKind.TypeParameter]=25;function ne(Ce){return typeof pe[Ce]=="number"?pe[Ce]:6}ie.from=ne;function U(Ce){for(const Se in pe)if(pe[Se]===Ce)return Number(Se);return w.SymbolKind.Property}ie.to=U})(z=e.SymbolKind||(e.SymbolKind={}));var N;(function(ie){function pe(U){switch(U){case w.SymbolTag.Deprecated:return 1}}ie.from=pe;function ne(U){switch(U){case 1:return w.SymbolTag.Deprecated}}ie.to=ne})(N=e.SymbolTag||(e.SymbolTag={}));var W;(function(ie){function pe(U){return{name:U.name,kind:z.from(U.kind),tags:U.tags&&U.tags.map(N.from),containerName:U.containerName,location:ue.from(U.location)}}ie.from=pe;function ne(U){const Ce=new w.SymbolInformation(U.name,z.to(U.kind),U.containerName,ue.to(U.location));return Ce.tags=U.tags&&U.tags.map(N.to),Ce}ie.to=ne})(W=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var j;(function(ie){function pe(U){const Ce={name:U.name||"!!MISSING: name!!",detail:U.detail,range:v.from(U.range),selectionRange:v.from(U.selectionRange),kind:z.from(U.kind),tags:U.tags?.map(N.from)??[]};return U.children&&(Ce.children=U.children.map(pe)),Ce}ie.from=pe;function ne(U){const Ce=new w.DocumentSymbol(U.name,U.detail,z.to(U.kind),v.to(U.range),v.to(U.selectionRange));return(0,c.isNonEmptyArray)(U.tags)&&(Ce.tags=U.tags.map(N.to)),U.children&&(Ce.children=U.children.map(ne)),Ce}ie.to=ne})(j=e.DocumentSymbol||(e.DocumentSymbol={}));var Y;(function(ie){function pe(U){const Ce=new w.CallHierarchyItem(z.to(U.kind),U.name,U.detail||"",I.URI.revive(U.uri),v.to(U.range),v.to(U.selectionRange));return Ce._sessionId=U._sessionId,Ce._itemId=U._itemId,Ce}ie.to=pe;function ne(U,Ce,Se){if(Ce=Ce??U._sessionId,Se=Se??U._itemId,Ce===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Se,name:U.name,detail:U.detail,kind:z.from(U.kind),uri:U.uri,range:v.from(U.range),selectionRange:v.from(U.selectionRange),tags:U.tags?.map(N.from)}}ie.from=ne})(Y=e.CallHierarchyItem||(e.CallHierarchyItem={}));var de;(function(ie){function pe(ne){return new w.CallHierarchyIncomingCall(Y.to(ne.from),ne.fromRanges.map(U=>v.to(U)))}ie.to=pe})(de=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var G;(function(ie){function pe(ne){return new w.CallHierarchyOutgoingCall(Y.to(ne.to),ne.fromRanges.map(U=>v.to(U)))}ie.to=pe})(G=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ue;(function(ie){function pe(U){return{range:U.range&&v.from(U.range),uri:U.uri}}ie.from=pe;function ne(U){return new w.Location(I.URI.revive(U.uri),v.to(U.range))}ie.to=ne})(ue=e.location||(e.location={}));var oe;(function(ie){function pe(U){const Ce=U,Se=U;return{originSelectionRange:Ce.originSelectionRange?v.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:Se.uri,range:v.from(Ce.targetRange?Ce.targetRange:Se.range),targetSelectionRange:Ce.targetSelectionRange?v.from(Ce.targetSelectionRange):void 0}}ie.from=pe;function ne(U){return{targetUri:I.URI.revive(U.uri),targetRange:v.to(U.range),targetSelectionRange:U.targetSelectionRange?v.to(U.targetSelectionRange):void 0,originSelectionRange:U.originSelectionRange?v.to(U.originSelectionRange):void 0}}ie.to=ne})(oe=e.DefinitionLink||(e.DefinitionLink={}));var Ee;(function(ie){function pe(U){return{range:v.from(U.range),contents:R.fromMany(U.contents)}}ie.from=pe;function ne(U){return new w.Hover(U.contents.map(R.to),v.to(U.range))}ie.to=ne})(Ee=e.Hover||(e.Hover={}));var Te;(function(ie){function pe(U){return{range:v.from(U.range),expression:U.expression}}ie.from=pe;function ne(U){return new w.EvaluatableExpression(v.to(U.range),U.expression)}ie.to=ne})(Te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Re;(function(ie){function pe(U){if(U instanceof w.InlineValueText)return{type:"text",range:v.from(U.range),text:U.text};if(U instanceof w.InlineValueVariableLookup)return{type:"variable",range:v.from(U.range),variableName:U.variableName,caseSensitiveLookup:U.caseSensitiveLookup};if(U instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:v.from(U.range),expression:U.expression};throw new Error("Unknown 'InlineValue' type")}ie.from=pe;function ne(U){switch(U.type){case"text":return{range:v.to(U.range),text:U.text};case"variable":return{range:v.to(U.range),variableName:U.variableName,caseSensitiveLookup:U.caseSensitiveLookup};case"expression":return{range:v.to(U.range),expression:U.expression}}}ie.to=ne})(Re=e.InlineValue||(e.InlineValue={}));var Ne;(function(ie){function pe(U){return{frameId:U.frameId,stoppedLocation:v.from(U.stoppedLocation)}}ie.from=pe;function ne(U){return new w.InlineValueContext(U.frameId,v.to(U.stoppedLocation))}ie.to=ne})(Ne=e.InlineValueContext||(e.InlineValueContext={}));var Qe;(function(ie){function pe(U){return{range:v.from(U.range),kind:U.kind}}ie.from=pe;function ne(U){return new w.DocumentHighlight(v.to(U.range),U.kind)}ie.to=ne})(Qe=e.DocumentHighlight||(e.DocumentHighlight={}));var He;(function(ie){function pe(ne){switch(ne){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}ie.to=pe})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function(ie){function pe(ne){return{triggerKind:He.to(ne.triggerKind),triggerCharacter:ne.triggerCharacter}}ie.to=pe})(qe=e.CompletionContext||(e.CompletionContext={}));var B;(function(ie){function pe(U){switch(U){case w.CompletionItemTag.Deprecated:return 1}}ie.from=pe;function ne(U){switch(U){case 1:return w.CompletionItemTag.Deprecated}}ie.to=ne})(B=e.CompletionItemTag||(e.CompletionItemTag={}));var K;(function(ie){const pe=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function ne(Se){return pe.get(Se)??9}ie.from=ne;const U=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function Ce(Se){return U.get(Se)??w.CompletionItemKind.Property}ie.to=Ce})(K=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(ie){function pe(ne,U){const Ce=new w.CompletionItem(ne.label);return Ce.insertText=ne.insertText,Ce.kind=K.to(ne.kind),Ce.tags=ne.tags?.map(B.to),Ce.detail=ne.detail,Ce.documentation=E.isMarkdownString(ne.documentation)?R.to(ne.documentation):ne.documentation,Ce.sortText=ne.sortText,Ce.filterText=ne.filterText,Ce.preselect=ne.preselect,Ce.commitCharacters=ne.commitCharacters,t.Range.isIRange(ne.range)?Ce.range=v.to(ne.range):typeof ne.range=="object"&&(Ce.range={inserting:v.to(ne.range.insert),replacing:v.to(ne.range.replace)}),Ce.keepWhitespace=typeof ne.insertTextRules=="undefined"?!1:Boolean(ne.insertTextRules&1),typeof ne.insertTextRules!="undefined"&&ne.insertTextRules&4?Ce.insertText=new w.SnippetString(ne.insertText):(Ce.insertText=ne.insertText,Ce.textEdit=Ce.range instanceof w.Range?new w.TextEdit(Ce.range,Ce.insertText):void 0),ne.additionalTextEdits&&ne.additionalTextEdits.length>0&&(Ce.additionalTextEdits=ne.additionalTextEdits.map(Se=>Q.to(Se))),Ce.command=U&&ne.command?U.fromInternal(ne.command):void 0,Ce}ie.to=pe})(ee=e.CompletionItem||(e.CompletionItem={}));var ae;(function(ie){function pe(U){return{label:U.label,documentation:U.documentation?R.fromStrict(U.documentation):void 0}}ie.from=pe;function ne(U){return{label:U.label,documentation:E.isMarkdownString(U.documentation)?R.to(U.documentation):U.documentation}}ie.to=ne})(ae=e.ParameterInformation||(e.ParameterInformation={}));var V;(function(ie){function pe(U){return{label:U.label,documentation:U.documentation?R.fromStrict(U.documentation):void 0,parameters:Array.isArray(U.parameters)?U.parameters.map(ae.from):[],activeParameter:U.activeParameter}}ie.from=pe;function ne(U){return{label:U.label,documentation:E.isMarkdownString(U.documentation)?R.to(U.documentation):U.documentation,parameters:Array.isArray(U.parameters)?U.parameters.map(ae.to):[],activeParameter:U.activeParameter}}ie.to=ne})(V=e.SignatureInformation||(e.SignatureInformation={}));var se;(function(ie){function pe(U){return{activeSignature:U.activeSignature,activeParameter:U.activeParameter,signatures:Array.isArray(U.signatures)?U.signatures.map(V.from):[]}}ie.from=pe;function ne(U){return{activeSignature:U.activeSignature,activeParameter:U.activeParameter,signatures:Array.isArray(U.signatures)?U.signatures.map(V.to):[]}}ie.to=ne})(se=e.SignatureHelp||(e.SignatureHelp={}));var fe;(function(ie){function pe(U){return{text:U.text,position:i.from(U.position),kind:Ae.from(U.kind??w.InlayHintKind.Other),whitespaceBefore:U.whitespaceBefore,whitespaceAfter:U.whitespaceAfter}}ie.from=pe;function ne(U){const Ce=new w.InlayHint(U.text,i.to(U.position),Ae.to(U.kind));return Ce.whitespaceAfter=U.whitespaceAfter,Ce.whitespaceBefore=U.whitespaceBefore,Ce}ie.to=ne})(fe=e.InlayHint||(e.InlayHint={}));var Ae;(function(ie){function pe(U){return U}ie.from=pe;function ne(U){return U}ie.to=ne})(Ae=e.InlayHintKind||(e.InlayHintKind={}));var xe;(function(ie){function pe(U){return{range:v.from(U.range),url:U.target,tooltip:U.tooltip}}ie.from=pe;function ne(U){let Ce;if(U.url)try{Ce=typeof U.url=="string"?I.URI.parse(U.url,!0):I.URI.revive(U.url)}catch(Se){}return new w.DocumentLink(v.to(U.range),Ce)}ie.to=ne})(xe=e.DocumentLink||(e.DocumentLink={}));var $e;(function(ie){function pe(U){const Ce=new w.ColorPresentation(U.label);return U.textEdit&&(Ce.textEdit=Q.to(U.textEdit)),U.additionalTextEdits&&(Ce.additionalTextEdits=U.additionalTextEdits.map(Se=>Q.to(Se))),Ce}ie.to=pe;function ne(U){return{label:U.label,textEdit:U.textEdit?Q.from(U.textEdit):void 0,additionalTextEdits:U.additionalTextEdits?U.additionalTextEdits.map(Ce=>Q.from(Ce)):void 0}}ie.from=ne})($e=e.ColorPresentation||(e.ColorPresentation={}));var ve;(function(ie){function pe(U){return new w.Color(U[0],U[1],U[2],U[3])}ie.to=pe;function ne(U){return[U.red,U.green,U.blue,U.alpha]}ie.from=ne})(ve=e.Color||(e.Color={}));var Xe;(function(ie){function pe(U){return{range:v.from(U.range)}}ie.from=pe;function ne(U){return new w.SelectionRange(v.to(U.range))}ie.to=ne})(Xe=e.SelectionRange||(e.SelectionRange={}));var H;(function(ie){function pe(ne){switch(ne){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}ie.to=pe})(H=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var J;(function(ie){function pe(U){switch(U){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}ie.from=pe;function ne(U){switch(U){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}ie.to=ne})(J=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var he;(function(ie){function pe(U){if(U===w.EndOfLine.CRLF)return 1;if(U===w.EndOfLine.LF)return 0}ie.from=pe;function ne(U){if(U===1)return w.EndOfLine.CRLF;if(U===0)return w.EndOfLine.LF}ie.to=ne})(he=e.EndOfLine||(e.EndOfLine={}));var Le;(function(ie){function pe(ne){if(typeof ne=="object")return ne.viewId;switch(ne){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ie.from=pe})(Le=e.ProgressLocation||(e.ProgressLocation={}));var Ve;(function(ie){function pe(ne){const U={start:ne.start+1,end:ne.end+1};return ne.kind&&(U.kind=tt.from(ne.kind)),U}ie.from=pe})(Ve=e.FoldingRange||(e.FoldingRange={}));var tt;(function(ie){function pe(ne){if(ne)switch(ne){case w.FoldingRangeKind.Comment:return y.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return y.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return y.FoldingRangeKind.Region}}ie.from=pe})(tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ut;(function(ie){function pe(ne){if(ne)return{pinned:typeof ne.preview=="boolean"?!ne.preview:void 0,inactive:ne.background,preserveFocus:ne.preserveFocus,selection:typeof ne.selection=="object"?v.from(ne.selection):void 0,override:typeof ne.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ie.from=pe})(ut=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ht;(function(ie){function pe(U){return U instanceof w.RelativePattern||typeof U=="string"?U:ne(U)?new w.RelativePattern(U.base,U.pattern):U}ie.from=pe;function ne(U){const Ce=U;return Ce&&typeof Ce.base=="string"&&typeof Ce.pattern=="string"}})(ht=e.GlobPattern||(e.GlobPattern={}));var St;(function(ie){function pe(ne){if(ne){if(Array.isArray(ne))return ne.map(pe);if(typeof ne=="string")return ne;{const U=ne;return{language:U.language,scheme:U.scheme,pattern:typeof U.pattern=="undefined"?void 0:ht.from(U.pattern),exclusive:U.exclusive}}}else return}ie.from=pe})(St=e.LanguageSelector||(e.LanguageSelector={}));var Pt;(function(ie){function pe(U){return{start:U.start,end:U.end}}ie.from=pe;function ne(U){return new w.NotebookRange(U.start,U.end)}ie.to=ne})(Pt=e.NotebookRange||(e.NotebookRange={}));var dt;(function(ie){function pe(U){return{timing:typeof U.runStartTime=="number"&&typeof U.runEndTime=="number"?{startTime:U.runStartTime,endTime:U.runEndTime}:void 0,executionOrder:U.executionOrder,success:U.lastRunSuccess}}ie.to=pe;function ne(U){return{lastRunSuccess:U.success,runStartTime:U.timing?.startTime,runEndTime:U.timing?.endTime,executionOrder:U.executionOrder}}ie.from=ne})(dt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var bt;(function(ie){function pe(U){switch(U){case w.NotebookCellKind.Markup:return u.CellKind.Markup;case w.NotebookCellKind.Code:default:return u.CellKind.Code}}ie.from=pe;function ne(U){switch(U){case u.CellKind.Markup:return w.NotebookCellKind.Markup;case u.CellKind.Code:default:return w.NotebookCellKind.Code}}ie.to=ne})(bt=e.NotebookCellKind||(e.NotebookCellKind={}));var ft;(function(ie){function pe(U){const Ce={metadata:U.metadata??Object.create(null),cells:[]};for(let Se of U.cells)w.NotebookCellData.validate(Se),Ce.cells.push(Et.from(Se));return Ce}ie.from=pe;function ne(U){const Ce=new w.NotebookData(U.cells.map(Et.to));return(0,S.isEmptyObject)(U.metadata)||(Ce.metadata=U.metadata),Ce}ie.to=ne})(ft=e.NotebookData||(e.NotebookData={}));var Et;(function(ie){function pe(U){return{cellKind:bt.from(U.kind),language:U.languageId,mime:U.mime,source:U.value,metadata:U.metadata,internalMetadata:dt.from(U.executionSummary??{}),outputs:U.outputs?U.outputs.map(Ct.from):[]}}ie.from=pe;function ne(U){return new w.NotebookCellData(bt.to(U.cellKind),U.source,U.language,U.mime,U.outputs?U.outputs.map(Ct.to):void 0,U.metadata,U.internalMetadata?dt.to(U.internalMetadata):void 0)}ie.to=ne})(Et=e.NotebookCellData||(e.NotebookCellData={}));var Ye;(function(ie){function pe(U){return{mime:U.mime,valueBytes:M.VSBuffer.wrap(U.data)}}ie.from=pe;function ne(U){return new w.NotebookCellOutputItem(U.valueBytes.buffer,U.mime)}ie.to=ne})(Ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(ie){function pe(U){return{outputId:U.id,items:U.items.map(Ye.from),metadata:U.metadata}}ie.from=pe;function ne(U){const Ce=U.items.map(Ye.to);return new w.NotebookCellOutput(Ce,U.outputId,U.metadata)}ie.to=ne})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Pe;(function(ie){function pe(Se){if(Se!=null){if(Se instanceof w.RelativePattern||typeof Se=="string")return Se;if(Ce(Se))return new w.RelativePattern(Se.base,Se.pattern);if(U(Se))return{include:ht.from(Se.include)||void 0,exclude:ht.from(Se.exclude)||void 0}}}ie.from=pe;function ne(Se){return typeof Se=="string"?Se:Ce(Se)?{base:Se.base,pattern:Se.pattern}:{include:Se.include,exclude:Se.exclude}}ie.to=ne;function U(Se){const Ge=Se,We=ht.from(Ge.include);if(!(We&&We instanceof w.RelativePattern||typeof We=="string"))return!1;const it=ht.from(Ge.exclude);return!!(it&&it instanceof w.RelativePattern||typeof it=="string")}function Ce(Se){const Ge=Se;return Ge&&typeof Ge.base=="string"&&typeof Ge.pattern=="string"}})(Pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ye;(function(ie){function pe(ne){return{backgroundColor:ne.backgroundColor,borderColor:ne.borderColor,top:ne.top?f.from(ne.top):void 0}}ie.from=pe})(ye=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var De;(function(ie){function pe(ne,U,Ce){const Se=typeof ne.command=="string"?{title:"",command:ne.command}:ne.command;return{alignment:ne.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:U.toInternal(Se,Ce),text:ne.text,tooltip:ne.tooltip,accessibilityInformation:ne.accessibilityInformation,priority:ne.priority}}ie.from=pe})(De=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Z;(function(ie){function pe(ne){return{transientOutputs:ne?.transientOutputs??!1,transientCellMetadata:ne?.transientCellMetadata??{},transientDocumentMetadata:ne?.transientDocumentMetadata??{}}}ie.from=pe})(Z=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var le;(function(ie){function pe(U){return{uri:U.uri,provides:U.provides}}ie.from=pe;function ne(U){return new w.NotebookRendererScript(I.URI.revive(U.uri),U.provides)}ie.to=ne})(le=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ge;(function(ie){function pe(U){return{message:R.fromStrict(U.message)||"",type:0,expected:U.expectedOutput,actual:U.actualOutput,location:U.location?ue.from(U.location):void 0}}ie.from=pe;function ne(U){const Ce=new w.TestMessage(typeof U.message=="string"?U.message:R.to(U.message));return Ce.actualOutput=U.actual,Ce.expectedOutput=U.expected,Ce}ie.to=ne})(ge=e.TestMessage||(e.TestMessage={}));var me;(function(ie){let pe;(function(ne){ne.Delimiter="\0"})(pe||(pe={})),ie.namespace=(ne,U)=>ne+"\0"+U,ie.denamespace=ne=>{const U=ne.indexOf("\0");return{ctrlId:ne.slice(0,U),tagId:ne.slice(U+1)}}})(me=e.TestTag||(e.TestTag={}));var Ie;(function(ie){function pe(Se){const Ge=(0,r.getPrivateApiFor)(Se).controllerId;return{extId:p.TestId.fromExtHostTestItem(Se,Ge).toString(),label:Se.label,uri:Se.uri,tags:Se.tags.map(We=>me.namespace(Ge,We.id)),range:v.from(Se.range)||null,description:Se.description||null,error:Se.error&&R.fromStrict(Se.error)||null}}ie.from=pe;function ne(Se){return{id:p.TestId.fromString(Se.extId).localId,label:Se.label,uri:I.URI.revive(Se.uri),tags:(Se.tags||[]).map(Ge=>{const{tagId:We}=me.denamespace(Ge);return new w.TestTag(We,We)}),range:v.to(Se.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Se.description||void 0}}ie.toPlain=ne;function U(Se){const Ge=p.TestId.fromString(Se.extId),We=new r.TestItemImpl(Ge.controllerId,Ge.localId,Se.label,I.URI.revive(Se.uri));return We.range=v.to(Se.range||void 0),We.description=Se.description||void 0,We}function Ce(Se){let Ge;for(const We of Se.tests){const it=U(We.item);(0,r.getPrivateApiFor)(it).parent=Ge,Ge=it}return Ge}ie.toItemFromContext=Ce})(Ie=e.TestItem||(e.TestItem={})),function(ie){function pe(U){return{id:U.id,label:U.label}}ie.from=pe;function ne(U){return new w.TestTag(U.id,U.label)}ie.to=ne}(me=e.TestTag||(e.TestTag={}));var Be;(function(ie){const pe=(U,Ce)=>{const Se={...Ie.toPlain(U.item),parent:void 0,taskStates:U.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(We=>We.type===0).map(ge.to)})),children:U.children.map(Ge=>Ce.get(Ge)).filter(S.isDefined).map(Ge=>pe(Ge,Ce))};for(const Ge of Se.children)Ge.parent=Se;return Se};function ne(U){const Ce=[],Se=new Map;for(const Ge of U.items)Se.set(Ge.item.extId,Ge),U.request.targets.some(We=>We.controllerId===Ge.controllerId&&We.testIds.includes(Ge.item.extId))&&Ce.push(Ge);return{completedAt:U.completedAt,results:Ce.map(Ge=>pe(Ge,Se))}}ie.to=ne})(Be=e.TestResults||(e.TestResults={}));var Me;(function(ie){function pe(Se){return{covered:Se.covered,total:Se.covered}}function ne(Se){return"line"in Se?i.from(Se):v.from(Se)}function U(Se){return"branches"in Se?{count:Se.executionCount,location:ne(Se.location),type:1,branches:Se.branches.length?Se.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&ne(Ge.location)})):void 0}:{type:0,count:Se.executionCount,location:ne(Se.location)}}ie.fromDetailed=U;function Ce(Se){return{uri:Se.uri,statement:pe(Se.statementCoverage),branch:Se.branchCoverage&&pe(Se.branchCoverage),function:Se.functionCoverage&&pe(Se.functionCoverage),details:Se.detailedCoverage?.map(U)}}ie.fromFile=Ce})(Me=e.TestCoverage||(e.TestCoverage={}));var je;(function(ie){function pe(ne){switch(ne){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}ie.to=pe})(je=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Je;(function(ie){function pe(U){const Ce=new w.TypeHierarchyItem(z.to(U.kind),U.name,U.detail||"",I.URI.revive(U.uri),v.to(U.range),v.to(U.selectionRange));return Ce._sessionId=U._sessionId,Ce._itemId=U._itemId,Ce}ie.to=pe;function ne(U,Ce,Se){if(Ce=Ce??U._sessionId,Se=Se??U._itemId,Ce===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Se,kind:z.from(U.kind),name:U.name,detail:U.detail??"",uri:U.uri,range:v.from(U.range),selectionRange:v.from(U.selectionRange),tags:U.tags?.map(N.from)}}ie.from=ne})(Je=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[169],be([0,1,2,15,6,8,231]),function(re,e,c,M,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(I,t,y,n={timeout:1500,errors:3}){this._logService=I,this._documents=t,this._mainThreadBulkEdits=y,this._thresholds=n,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(t,y,n)=>{const r={dispose:this._callbacks.push([t,y,I])};return Array.isArray(n)&&n.push(r),r}}async $participateInSave(I,t){const y=c.URI.revive(I);let n=!1;const d=setTimeout(()=>n=!0,this._thresholds.timeout),r=[];try{for(let u of[...this._callbacks]){if(n)break;const p=this._documents.getDocument(y),k=await this._deliverEventAsyncAndBlameBadListeners(u,{document:p,reason:T.TextDocumentSaveReason.to(t)});r.push(k)}}finally{clearTimeout(d)}return r}_deliverEventAsyncAndBlameBadListeners([I,t,y],n){const d=this._badListeners.get(I);return typeof d=="number"&&d>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,I,t,n).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const u=this._badListeners.get(I);this._badListeners.set(I,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,t,y,n){const d=[],r=Date.now(),{document:u,reason:p}=n,{version:k}=u,w=Object.freeze({document:u,reason:p,waitUntil(l){if(Object.isFrozen(d))throw(0,M.illegalState)("waitUntil can not be called async");d.push(Promise.resolve(l))}});try{t.apply(y,[w])}catch(l){return Promise.reject(l)}return Object.freeze(d),new Promise((l,v)=>{const D=setTimeout(()=>v(new Error("timeout")),this._thresholds.timeout);return Promise.all(d).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(D),l(i)}).catch(i=>{clearTimeout(D),v(i)})}).then(l=>{const v={edits:[]};for(const D of l)if(Array.isArray(D)&&D.every(i=>i instanceof E.TextEdit))for(const{newText:i,newEol:s,range:a}of D)v.edits.push({_type:2,resource:u.uri,edit:{range:a&&T.Range.from(a),text:i,eol:s&&T.EndOfLine.from(s)}});if(v.edits.length!==0)return k===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(v):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(we[170],be([0,1,3,27,2,8,6]),function(re,e,c,M,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class P{constructor(t,y,n,d,r){this._onDidCreate=new c.Emitter,this._onDidChange=new c.Emitter,this._onDidDelete=new c.Emitter,this._config=0,n&&(this._config+=1),d&&(this._config+=2),r&&(this._config+=4);const u=(0,M.parse)(y),p=t(k=>{if(!n)for(let w of k.created){const l=E.URI.revive(w);u(l.fsPath)&&this._onDidCreate.fire(l)}if(!d)for(let w of k.changed){const l=E.URI.revive(w);u(l.fsPath)&&this._onDidChange.fire(l)}if(!r)for(let w of k.deleted){const l=E.URI.revive(w);u(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=A.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,p)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(t,y,n){this._logService=y,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new c.Emitter,this._onDidRenameFile=new c.Emitter,this._onDidCreateFile=new c.Emitter,this._onDidDeleteFile=new c.Emitter,this._onWillRenameFile=new c.AsyncEmitter,this._onWillCreateFile=new c.AsyncEmitter,this._onWillDeleteFile=new c.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,y,n,d){return new P(this._onFileSystemEvent.event,t,y,n,d)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,y){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:y.map(n=>({oldUri:E.URI.revive(n.source),newUri:E.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:y.map(n=>E.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:y.map(n=>E.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,y){return(n,d,r)=>{const u=function(k){n.call(d,k)};return u.extension=t,y.event(u,void 0,r)}}async $onWillRunFileOperation(t,y,n,d){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:y.map(r=>({oldUri:E.URI.revive(r.source),newUri:E.URI.revive(r.target)}))},n,d);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:y.map(r=>E.URI.revive(r.target))},n,d);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:y.map(r=>E.URI.revive(r.target))},n,d)}}async _fireWillEvent(t,y,n,d){const r=new Set,u=[];if(await t.fireAsync(y,d,async(k,w)=>{const l=Date.now(),v=await Promise.resolve(k);v instanceof A.WorkspaceEdit&&(u.push(v),r.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-l>n&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),d.isCancellationRequested||u.length===0)return;const p={edits:[]};for(let k of u){let{edits:w}=T.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);p.edits=p.edits.concat(w)}return{edit:p,extensionNames:Array.from(r)}}}e.ExtHostFileSystemEventService=S}),define(we[171],be([0,1,11,22,2,8,6,89]),function(re,e,c,M,E,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(n,d,r,u){this.start=n,this.deletedCount=d,this.deletedItems=r,this.items=u}static asApiEvents(n){return n.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(r=>r.apiCell)}))}}class I{constructor(n,d,r){this.notebook=n,this._extHostDocument=d,this._cellData=r,this.handle=r.handle,this.uri=E.URI.revive(r.uri),this.cellKind=r.cellKind,this._outputs=r.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=r.internalMetadata??{},this._metadata=Object.freeze(r.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(r.internalMetadata??{}))}static asModelAddData(n,d){return{EOL:d.eol,lines:d.source,modeId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get mime(){return n._mime},set mime(r){n._mime=r},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(T.NotebookCellOutput.to)}setOutputItems(n,d,r){const u=r.map(T.NotebookCellOutputItem.to),p=this._outputs.find(k=>k.id===n);p&&(d||(p.items.length=0),p.items.push(...u))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=I;class t{constructor(n,d,r,u,p,k){this._proxy=n,this._textDocumentsAndEditors=d,this._textDocuments=r,this._emitter=u,this.uri=p,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=k.viewType,this._metadata=Object.freeze(k.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,k.cells]],!0),this._versionId=k.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===c.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(d){return d=n._validateIndex(d),n._cells[d].apiCell},getCells(d){return(d?n._getCells(d):n._cells).map(u=>u.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,d){this._versionId=n.versionId,this._isDirty=d;for(const r of n.rawEvents)r.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1):r.kind===P.NotebookCellsChangeType.Move?this._moveCell(r.index,r.newIdx):r.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(r.index,r.outputs):r.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems):r.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(r.index,r.language):r.kind===P.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(r.index,r.mime):r.kind===P.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(r.index,r.metadata):r.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(r.index,r.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let d=n.start|0,r=n.end|0;return d<0&&(d=0),r>this._cells.length&&(r=this._cells.length),n.with({start:d,end:r})}_getCells(n){n=this._validateRange(n);const d=[];for(let r=n.start;r<n.end;r++)d.push(this._cells[r]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,d){if(this._disposed)return;const r=[],u=[],p=[];n.reverse().forEach(k=>{const l=k[2].map(i=>{const s=new I(this,this._textDocumentsAndEditors,i);return d||u.push(I.asModelAddData(this.apiNotebook,i)),s}),v=new S(k[0],k[1],[],l),D=this._cells.splice(k[0],k[1],...l);for(const i of D)p.push(i.uri),v.deletedItems.push(i.apiCell);r.push(v)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:p}),d||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(r)}))}_moveCell(n,d){const r=this._cells.splice(n,1);this._cells.splice(d,0,...r);const u=[new S(n,1,r.map(p=>p.apiCell),[]),new S(d,0,[],r)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(u)}))}_setCellOutputs(n,d){const r=this._cells[n];r.setOutputs(d),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[r.apiCell]}))}_setCellOutputItems(n,d,r,u){const p=this._cells[n];p.setOutputItems(d,r,u),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(n,d){const r=this._cells[n];r.apiCell.document.languageId!==d&&this._textDocuments.$acceptModelModeChanged(r.uri,d)}_changeCellMime(n,d){const r=this._cells[n];r.apiCell.mime=d}_changeCellMetadata(n,d){const r=this._cells[n],u=r.apiCell.metadata;r.setMetadata(d);const p=r.apiCell.metadata;(0,M.equals)(u,p)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:r.apiCell}))}_changeCellInternalMetadata(n,d){const r=this._cells[n],u=r.internalMetadata;if(r.setInternalMetadata(d),u.runState!==d.runState){const p=d.runState??A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:r.apiCell,state:p}))}}getCellFromApiCell(n){return this._cells.find(d=>d.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(d=>d.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(we[93],be([0,1,6,8,15]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,I){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:I})}replaceCells(S,I,t){this._throwIfFinalized(),!(S===I&&t.length===0)&&this._collectedEdits.push({editType:1,index:S,count:I-S,cells:t.map(M.NotebookCellData.from)})}}class A{constructor(S,I,t,y,n,d){this.id=S,this._proxy=I,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=y,this._viewColumn=d}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(I){if(!Array.isArray(I)||!I.every(c.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");S._selections=I,S._trySetSelections(I)},get visibleRanges(){return S._visibleRanges},revealRange(I,t){S._proxy.$tryRevealRange(S.id,M.NotebookRange.from(I),t??c.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(I){const t=new T(this.document.version);return I(t),S._applyEdit(t.finalize())},setDecorations(I,t){return S.setDecorations(I,t)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(M.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const I=[];let t=-1;for(let y=0;y<S.cellEdits.length;y++){if(t<0){I.push(S.cellEdits[y]),t++;continue}const d=I[t],r=S.cellEdits[y];if(d.editType===1&&r.editType===1&&d.index===r.index){d.cells.push(...S.cellEdits[y].cells),d.count+=S.cellEdits[y].count;continue}I.push(S.cellEdits[y]),t++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,I)}setDecorations(S,I){if(!(I.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return I.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(I),S.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(we[172],be([0,1,8,146,125,21,51]),function(re,e,c,M,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class P{constructor(y){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=y}withProgress(y,n,d){const r=this._handles++,{title:u,location:p,cancellable:k}=n,w={label:(0,E.localize)(0,null,y.displayName||y.name),id:y.identifier.value};return this._proxy.$startProgress(r,{location:c.ProgressLocation.from(p),title:u,source:w,cancellable:k},y),this._withProgress(r,d,!!k)}_withProgress(y,n,d){let r;d&&(r=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(y,r));const u=k=>{this._proxy.$progressEnd(k),this._mapHandleToCancellationSource.delete(k),r&&r.dispose()};let p;try{p=n(new I(this._proxy,y),d&&r?r.token:T.CancellationToken.None)}catch(k){throw u(y),k}return p.then(k=>u(y),k=>u(y)),p}$acceptProgressCanceled(y){const n=this._mapHandleToCancellationSource.get(y);n&&(n.cancel(),this._mapHandleToCancellationSource.delete(y))}}e.ExtHostProgress=P;function S(t,y){return t.message=y.message,typeof y.increment=="number"&&(typeof t.increment=="number"?t.increment+=y.increment:t.increment=y.increment),t}class I extends M.Progress{constructor(y,n){super(d=>this.throttledReport(d));this._proxy=y,this._handle=n}throttledReport(y){this._proxy.$progressReport(this._handle,y)}}Ue([(0,A.throttle)(100,(t,y)=>S(t,y),()=>Object.create(null))],I.prototype,"throttledReport",null)}),define(we[94],be([0,1,39,15,52,8,6]),function(re,e,c,M,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(n,d,r){const u=P._Keys.nextId();n.$registerTextEditorDecorationType(d.identifier,u,T.DecorationRenderOptions.from(r)),this.value=Object.freeze({key:u,dispose(){n.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=P,P._Keys=new E.IdGenerator("TextEditorDecorationType");class S{constructor(n,d){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=d.undoStopBefore,this._undoStopAfter=d.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,d){this._throwIfFinalized();let r=null;if(n instanceof A.Position)r=new A.Range(n,n);else if(n instanceof A.Range)r=n;else throw new Error("Unrecognized location");this._pushEdit(r,d,!1)}insert(n,d){this._throwIfFinalized(),this._pushEdit(new A.Range(n,n),d,!0)}delete(n){this._throwIfFinalized();let d=null;if(n instanceof A.Range)d=n;else throw new Error("Unrecognized location");this._pushEdit(d,null,!0)}_pushEdit(n,d,r){const u=this._document.validateRange(n);this._collectedEdits.push({range:u,text:d,forceMoveMarkers:r})}setEndOfLine(n){if(this._throwIfFinalized(),n!==A.EndOfLine.LF&&n!==A.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=S;class I{constructor(n,d,r,u){this._proxy=n,this._id=d,this._accept(r),this._logService=u;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(k){p._setTabSize(k)},get insertSpaces(){return p._insertSpaces},set insertSpaces(k){p._setInsertSpaces(k)},get cursorStyle(){return p._cursorStyle},set cursorStyle(k){p._setCursorStyle(k)},get lineNumbers(){return p._lineNumbers},set lineNumbers(k){p._setLineNumbers(k)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const d=Math.floor(n);return d>0?d:null}if(typeof n=="string"){const d=parseInt(n,10);return isNaN(d)?null:d>0?d:null}return null}_setTabSize(n){const d=this._validateTabSize(n);if(d!==null){if(typeof d=="number"){if(this._tabSize===d)return;this._tabSize=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:d}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const d=this._validateInsertSpaces(n);if(typeof d=="boolean"){if(this._insertSpaces===d)return;this._insertSpaces=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:d}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(n)})))}assign(n){const d={};let r=!1;if(typeof n.tabSize!="undefined"){const u=this._validateTabSize(n.tabSize);u==="auto"?(r=!0,d.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,r=!0,d.tabSize=u)}if(typeof n.insertSpaces!="undefined"){const u=this._validateInsertSpaces(n.insertSpaces);u==="auto"?(r=!0,d.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,r=!0,d.insertSpaces=u)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,r=!0,d.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,r=!0,d.lineNumbers=T.TextEditorLineNumbersStyle.from(n.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,d))}_warnOnError(n){n.catch(d=>this._logService.warn(d))}}e.ExtHostTextEditorOptions=I;class t{constructor(n,d,r,u,p,k,w,l){this.id=n,this._proxy=d,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new I(this._proxy,this.id,k,r),this._visibleRanges=w,this._viewColumn=l;const v=this;this.value=Object.freeze({get document(){return u.getValue()},set document(D){throw(0,M.readonly)("document")},get selection(){return v._selections&&v._selections[0]},set selection(D){if(!(D instanceof A.Selection))throw(0,M.illegalArgument)("selection");v._selections=[D],v._trySetSelection()},get selections(){return v._selections},set selections(D){if(!Array.isArray(D)||D.some(i=>!(i instanceof A.Selection)))throw(0,M.illegalArgument)("selections");v._selections=D,v._trySetSelection()},get visibleRanges(){return v._visibleRanges},set visibleRanges(D){throw(0,M.readonly)("visibleRanges")},get options(){return v._options.value},set options(D){v._disposed||v._options.assign(D)},get viewColumn(){return v._viewColumn},set viewColumn(D){throw(0,M.readonly)("viewColumn")},edit(D,i={undoStopBefore:!0,undoStopAfter:!0}){if(v._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new S(u.getValue(),i);return D(s),v._applyEdit(s)},insertSnippet(D,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(v._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=v._selections.map(o=>T.Range.from(o));else if(i instanceof A.Position){const{lineNumber:o,column:_}=T.Position.from(i);a=[{startLineNumber:o,startColumn:_,endLineNumber:o,endColumn:_}]}else if(i instanceof A.Range)a=[T.Range.from(i)];else{a=[];for(const o of i)if(o instanceof A.Range)a.push(T.Range.from(o));else{const{lineNumber:_,column:m}=T.Position.from(o);a.push({startLineNumber:_,startColumn:m,endLineNumber:_,endColumn:m})}}return d.$tryInsertSnippet(n,D.value,a,s)},setDecorations(D,i){const s=i.length===0;s&&!v._hasDecorationsForKey.has(D.key)||(s?v._hasDecorationsForKey.delete(D.key):v._hasDecorationsForKey.add(D.key),v._runOnProxy(()=>{if(T.isDecorationOptionsArr(i))return d.$trySetDecorations(n,D.key,T.fromRangeOrRangeWithMessage(i));{const a=new Array(4*i.length);for(let o=0,_=i.length;o<_;o++){const m=i[o];a[4*o]=m.start.line+1,a[4*o+1]=m.start.character+1,a[4*o+2]=m.end.line+1,a[4*o+3]=m.end.character+1}return d.$trySetDecorationsFast(n,D.key,a)}}))},revealRange(D,i){v._runOnProxy(()=>d.$tryRevealRange(n,T.Range.from(D),i||A.TextEditorRevealType.Default))},show(D){d.$tryShowEditor(n,T.ViewColumn.from(D))},hide(){d.$tryHideEditor(n)}})}dispose(){(0,c.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,c.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,c.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,c.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,c.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const d=n.finalize();if(d.edits.length===0&&!d.setEndOfLine)return Promise.resolve(!0);const r=d.edits.map(p=>p.range);r.sort((p,k)=>p.end.line===k.end.line?p.end.character===k.end.character?p.start.line===k.start.line?p.start.character-k.start.character:p.start.line-k.start.line:p.end.character-k.end.character:p.end.line-k.end.line);for(let p=0,k=r.length-1;p<k;p++){const w=r[p].end;if(r[p+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=d.edits.map(p=>({range:T.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,d.documentVersionId,u,{setEndOfLine:typeof d.setEndOfLine=="number"?T.EndOfLine.from(d.setEndOfLine):void 0,undoStopBefore:d.undoStopBefore,undoStopAfter:d.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,d=>(d instanceof Error&&d.name==="DISPOSED"||this._logService.warn(d),null))}}e.ExtHostTextEditor=t}),define(we[173],be([0,1,128,24,2,3,7,161,13,6,10,16,8,21,158]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(w,l){if((0,t.isString)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let v;return Array.isArray(w.highlights)&&(v=w.highlights.filter(D=>D.length===2&&typeof D[0]=="number"&&typeof D[1]=="number"),v=v.length?v:void 0),{label:w.label,highlights:v}}}class p{constructor(l,v,D){this._proxy=l,this.commands=v,this.logService=D,this.treeViews=new Map;function i(s){return s&&s.$treeViewId&&s.$treeItemHandle}v.registerArgumentProcessor({processArgument:s=>i(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(a=>i(a)?this.convertArgument(a):a):s})}registerTreeDataProvider(l,v,D){const i=this.createTreeView(l,{treeDataProvider:v},D);return{dispose:()=>i.dispose()}}createTreeView(l,v,D){if(!v||!v.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=v.dragAndDropController!==void 0,s=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!v.showCollapseAll,canSelectMany:!!v.canSelectMany,canDragAndDrop:i}),a=this.createExtHostTreeView(l,v,D);return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get message(){return a.message},set message(o){a.message=o},get title(){return a.title},set title(o){a.title=o},get description(){return a.description},set description(o){a.description=o},reveal:(o,_)=>a.reveal(o,_),dispose:async()=>{await s,this.treeViews.delete(l),a.dispose()}}}$getChildren(l,v){const D=this.treeViews.get(l);return D?D.getChildren(v):Promise.reject(new Error((0,c.localize)(0,null,l)))}async $onDrop(l,v,D){const i=this.treeViews.get(l);if(!i)return Promise.reject(new Error((0,c.localize)(1,null,l)));const s=r.TreeDataTransferConverter.toITreeDataTransfer(v);if(s.items.has(P.TREE_ITEM_DATA_TRANSFER_TYPE)){const o=JSON.parse(await s.items.get(P.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(_=>i.getExtensionElement(_)).filter(_=>!!_);o.length>0?s.items.set(P.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(o)}):s.items.delete(P.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(s,D)}async $hasResolve(l){const v=this.treeViews.get(l);if(!v)throw new Error((0,c.localize)(2,null,l));return v.hasResolve}$resolve(l,v,D){const i=this.treeViews.get(l);if(!i)throw new Error((0,c.localize)(3,null,l));return i.resolveTreeItem(v,D)}$setExpanded(l,v,D){const i=this.treeViews.get(l);if(!i)throw new Error((0,c.localize)(4,null,l));i.setExpanded(v,D)}$setSelection(l,v){const D=this.treeViews.get(l);if(!D)throw new Error((0,c.localize)(5,null,l));D.setSelection(v)}$setVisible(l,v){const D=this.treeViews.get(l);if(!D)throw new Error((0,c.localize)(6,null,l));D.setVisible(v)}createExtHostTreeView(l,v,D){const i=new k(l,v,this._proxy,this.commands.converter,this.logService,D);return this.treeViews.set(l,i),i}convertArgument(l){const v=this.treeViews.get(l.$treeViewId);return v?v.getExtensionElement(l.$treeItemHandle):null}}e.ExtHostTreeViews=p;class k extends A.Disposable{constructor(l,v,D,i,s,a){super();if(this.viewId=l,this.proxy=D,this.commands=i,this.logService=s,this.extension=a,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,a.contributes&&a.contributes.views)for(const m in a.contributes.views)for(const g of a.contributes.views[m])g.id===l&&(this._title=g.name);this.dataProvider=v.treeDataProvider,this.dndController=v.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(m=>this._onDidChangeData.fire({message:!1,element:m}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(m=>this._onDidChangeData.fire({message:!1,element:m})));let o,_;this._register(T.Event.debounce(this._onDidChangeData.event,(m,g)=>(m||(m={message:!1,elements:[]}),g.element!==!1&&(o||(o=new Promise(C=>_=C),this.refreshPromise=this.refreshPromise.then(()=>o)),Array.isArray(g.element)?m.elements.push(...g.element):m.elements.push(g.element)),g.message&&(m.message=!0),m),200,!0)(({message:m,elements:g})=>{g.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const C=_;return o=null,this.refresh(g).then(()=>C())})),m&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,t.isUndefinedOrNull)(l))}async getChildren(l){const v=l?this.getExtensionElement(l):void 0;if(l&&!v)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let D=this.getChildrenNodes(l);return D||(D=await this.fetchChildrenNodes(v)),D?D.map(i=>i.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,v){v=v||{select:!0,focus:!1};const D=(0,t.isUndefinedOrNull)(v.select)?!0:v.select,i=(0,t.isUndefinedOrNull)(v.focus)?!1:v.focus,s=(0,t.isUndefinedOrNull)(v.expand)?!1:v.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(a=>this.resolveTreeNode(l,a[a.length-1]).then(o=>this.proxy.$reveal(this.viewId,{item:o.item,parentChain:a.map(_=>_.item)},{select:D,focus:i,expand:s})),a=>this.logService.error(a)):this.proxy.$reveal(this.viewId,void 0,{select:D,focus:i,expand:s})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}setExpanded(l,v){const D=this.getExtensionElement(l);D&&(v?this._onDidExpandElement.fire(Object.freeze({element:D})):this._onDidCollapseElement.fire(Object.freeze({element:D})))}setSelection(l){(0,y.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(l,v){const D=this.getExtensionElement(v);if(!!D)return(0,S.asPromise)(()=>this.dndController?.onDrop(l,D))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,v){if(!this.dataProvider.resolveTreeItem)return;const D=this.elements.get(l);if(D){const i=this.nodes.get(D);if(i){const s=await this.dataProvider.resolveTreeItem(i.extensionItem,D,v)??i.extensionItem;return i.item.tooltip=this.getTooltip(s.tooltip),i.item.command=this.getCommand(i.disposableStore,s.command),i.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(v=>v?this.resolveUnknownParentChain(v).then(D=>this.resolveTreeNode(v,D[D.length-1]).then(i=>(D.push(i),D))):Promise.resolve([]))}resolveParent(l){const v=this.nodes.get(l);return v?Promise.resolve(v.parent?this.elements.get(v.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,v){const D=this.nodes.get(l);return D?Promise.resolve(D):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(i=>this.createHandle(l,i,v,!0)).then(i=>this.getChildren(v?v.item.handle:void 0).then(()=>{const s=this.getExtensionElement(i);if(s){const a=this.nodes.get(s);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(l){if(l){let v;if(typeof l=="string"){const D=this.getExtensionElement(l);v=D?this.nodes.get(D):void 0}else v=l;return v&&v.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const v=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const D=l?this.nodes.get(l):void 0,i=await this.dataProvider.getChildren(l);if(v.token.isCancellationRequested)return;const s=await Promise.all((0,y.coalesce)(i||[]).map(async a=>{const o=await this.dataProvider.getTreeItem(a);return o&&!v.token.isCancellationRequested?this.createAndRegisterTreeNode(a,o,D):null}));return v.token.isCancellationRequested?void 0:(0,y.coalesce)(s)}finally{v.dispose()}}refresh(l){if(l.some(D=>!D))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const D=this.getHandlesToRefresh(l);if(D.length)return this.refreshHandles(D)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const v=new Set,D=l.map(s=>this.nodes.get(s));for(const s of D)if(s&&!v.has(s.item.handle)){let a=s;for(;a&&a.parent&&D.findIndex(o=>a&&a.parent&&o&&o.item.handle===a.parent.item.handle)===-1;){const o=this.elements.get(a.parent.item.handle);a=o?this.nodes.get(o):void 0}a&&!a.parent&&v.add(s.item.handle)}const i=[];return v.forEach(s=>{const a=this.elements.get(s);if(a){const o=this.nodes.get(a);o&&(!o.parent||!v.has(o.parent.item.handle))&&i.push(s)}}),i}refreshHandles(l){const v={};return Promise.all(l.map(D=>this.refreshNode(D).then(i=>{i&&(v[D]=i.item)}))).then(()=>Object.keys(v).length?this.proxy.$refresh(this.viewId,v):void 0)}refreshNode(l){const v=this.getExtensionElement(l);if(v){const D=this.nodes.get(v);if(D)return this.clearChildren(v),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(i=>{if(i){const s=this.createTreeNode(v,i,D.parent);return this.updateNodeCache(v,s,D,D.parent),D.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,v,D){const i=this.createTreeNode(l,v,D);if(v.id&&this.elements.has(i.item.handle))throw new Error((0,c.localize)(7,null,v.id));return this.addNodeToCache(l,i),this.addNodeToParentCache(i,D),i}getTooltip(l){return I.MarkdownString.isMarkdownString(l)?n.MarkdownString.from(l):l}getCommand(l,v){return v?this.commands.toInternal(v,l):void 0}createTreeNode(l,v,D){const i=new A.DisposableStore,s=this.createHandle(l,v,D),a=this.getLightIconPath(v);return{item:{handle:s,parentHandle:D?D.item.handle:void 0,label:u(v.label,this.extension),description:v.description,resourceUri:v.resourceUri,tooltip:this.getTooltip(v.tooltip),command:this.getCommand(i,v.command),contextValue:v.contextValue,icon:a,iconDark:this.getDarkIconPath(v)||a,themeIcon:this.getThemeIcon(v),collapsibleState:(0,t.isUndefinedOrNull)(v.collapsibleState)?I.TreeItemCollapsibleState.None:v.collapsibleState,accessibilityInformation:v.accessibilityInformation},extensionItem:v,parent:D,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(l){return l.iconPath instanceof I.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:v,label:D,resourceUri:i},s,a){if(v)return`${k.ID_HANDLE_PREFIX}/${v}`;const o=u(D,this.extension),_=s?s.item.handle:k.LABEL_HANDLE_PREFIX;let m=o?o.label:i?(0,M.basename)(i):"";m=m.indexOf("/")!==-1?m.replace("/","//"):m;const g=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,C=this.getChildrenNodes(s)||[];let R,h=0;do{if(R=`${_}/${h}:${m}`,a||!this.elements.has(R)||g===R)break;h++}while(h<=C.length);return R}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof I.ThemeIcon))return typeof l.iconPath=="string"||E.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof I.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return E.URI.isUri(l)?l:E.URI.file(l)}addNodeToCache(l,v){this.elements.set(v.item.handle,l),this.nodes.set(l,v)}updateNodeCache(l,v,D,i){this.elements.delete(v.item.handle),this.nodes.delete(l),v.item.handle!==D.item.handle&&this.elements.delete(D.item.handle),this.addNodeToCache(l,v);const s=this.getChildrenNodes(i)||[],a=s.filter(o=>o.item.handle===D.item.handle)[0];a&&s.splice(s.indexOf(a),1,v)}addNodeToParentCache(l,v){v?(v.children||(v.children=[]),v.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const v=this.nodes.get(l);if(v){if(v.children)for(const D of v.children){const i=this.elements.get(D.item.handle);i&&this.clear(i)}v.children=void 0}}else this.clearAll()}clear(l){const v=this.nodes.get(l);if(v){if(v.children)for(const D of v.children){const i=this.elements.get(D.item.handle);i&&this.clear(i)}this.nodes.delete(l),this.elements.delete(v.item.handle),v.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}k.LABEL_HANDLE_PREFIX="0",k.ID_HANDLE_PREFIX="1"}),define(we[174],be([0,1,13,3,7,10,64,8,90,68]),function(re,e,c,M,E,T,A,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends E.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new A.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const d of this.tree.values())this.updateExpandability(d)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const d=this.diff[this.diff.length-1];if(d&&n[0]===1){if(d[0]===1&&d[1].extId===n[1].extId){(0,S.applyTestItemUpdate)(d[1],n[1]);return}if(d[0]===0&&d[1].item.extId===n[1].extId){(0,S.applyTestItemUpdate)(d[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,d){const r=this.tree.get(n);if(!!r){if((r.expandLevels===void 0||d>r.expandLevels)&&(r.expandLevels=d),r.expand===1){const u=this.resolveChildren(r);return u.isOpen()?this.expandChildren(r,d-1):u.wait().then(()=>this.expandChildren(r,d-1))}else if(r.expand===3)return r.resolveBarrier?.isOpen()===!1?r.resolveBarrier.wait().then(()=>this.expandChildren(r,d-1)):this.expandChildren(r,d-1)}}dispose(){for(const n of this.tree.values())(0,A.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,d){switch(d.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(I.TestId.joinToString(n.fullId,d.id));break;case 0:this.upsertItem(d.item,n);break;case 4:for(const w of d.ops)this.onTestItemEvent(n,w);break;case 3:const{key:r,value:u,previous:p}=d,k=n.fullId.toString();switch(r){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(u,p,k);break;case"range":this.pushDiff([1,{extId:k,item:{range:P.Range.from(u)}}]);break;case"error":this.pushDiff([1,{extId:k,item:{error:P.MarkdownString.fromStrict(u)||null}}]);break;default:this.pushDiff([1,{extId:k,item:{[r]:u??null}}]);break}break;default:(0,T.assertNever)(d)}}upsertItem(n,d){if(!(n instanceof A.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const r=I.TestId.fromExtHostTestItem(n,this.root.id,d?.actual),u=(0,A.getPrivateApiFor)(n);u.parent&&u.parent!==d?.actual&&u.parent.children.delete(n.id);let p=this.tree.get(r.toString());if(!p){p={fullId:r,actual:n,parent:d?r.parentId:null,expandLevels:d?.expandLevels?d.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(p.fullId.toString(),p),this.setItemParent(n,d),this.pushDiff([0,{parent:p.parent&&p.parent.toString(),controllerId:this.controllerId,expand:p.expand,item:P.TestItem.from(n)}]),this.connectItemAndChildren(n,p,d);return}if(p.actual===n){this.connectItem(n,p,d);return}const k=p.actual.children,w=p.actual,l=(0,A.diffTestItems)(w,n);(0,A.getPrivateApiFor)(w).listener=void 0,p.actual=n,p.expand=0;for(const[v,D]of l)this.onTestItemEvent(p,{op:3,key:v,value:D,previous:w[v]});this.connectItemAndChildren(n,p,d);for(const v of k)n.children.get(v.id)||this.removeItem(I.TestId.joinToString(r,v.id))}diffTagRefs(n,d,r){const u=new Set(d.map(p=>p.id));for(const p of n)u.delete(p.id)||this.incrementTagRefs(p);this.pushDiff([1,{extId:r,item:{tags:n.map(p=>P.TestTag.namespace(this.controllerId,p.id))}}]),u.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const d=this.tags.get(n.id);d?d.refCount++:(this.tags.set(n.id,{label:n.label,refCount:1}),this.pushDiff([5,{id:P.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label,label:n.label}]))}decrementTagRefs(n){const d=this.tags.get(n);d&&!--d.refCount&&(this.tags.delete(n),this.pushDiff([6,P.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,d){(0,A.getPrivateApiFor)(n).parent=d&&d.actual!==this.root?d.actual:void 0}connectItem(n,d,r){this.setItemParent(n,r);const u=(0,A.getPrivateApiFor)(n);u.parent=r?.actual,u.listener=p=>this.onTestItemEvent(d,p),this.updateExpandability(d)}connectItemAndChildren(n,d,r){this.connectItem(n,d,r);for(const u of n.children)this.upsertItem(u,d)}updateExpandability(n){let d;this._resolveHandler?n.resolveBarrier?d=n.resolveBarrier.isOpen()?3:2:d=n.actual.canResolveChildren?1:0:d=0,d!==n.expand&&(n.expand=d,this.pushDiff([1,{extId:n.fullId.toString(),expand:d}]),d===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,d){if(d<0)return;const r=[];for(const u of n.actual.children){const p=this.expand(I.TestId.joinToString(n.fullId,u.id),d);(0,c.isThenable)(p)&&r.push(p)}if(r.length)return Promise.all(r).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const p=new c.Barrier;return p.open(),p}n.expand=2,this.pushExpandStateUpdate(n);const d=n.resolveBarrier=new c.Barrier,r=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=p.stack||p.message||String(p))};let u;try{u=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(p){r(p)}return(0,c.isThenable)(u)?u.catch(r).then(()=>{d.open(),this.updateExpandability(n)}):(d.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const d=this.tree.get(n);if(!d)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const r=[d];for(;r.length;){const u=r.pop();if(!!u){(0,A.getPrivateApiFor)(u.actual).listener=void 0;for(const p of u.actual.tags)this.decrementTagRefs(p.id);this.tree.delete(u.fullId.toString());for(const p of u.actual.children)r.push(this.tree.get(I.TestId.joinToString(u.fullId,p.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(we[175],be([0,1,4,141]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(M.IEnvironmentService)}),define(we[176],be([0,1,25,3,17]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=T;class A{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(c.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(c.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let y of t.activationEvents)y==="onUri"&&(y=`onUri:${c.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(y)||this._activationMap.set(y,[]),this._activationMap.get(y).push(t)}}keepOnly(t){const y=new Set;t.forEach(n=>y.add(c.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>y.has(c.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,y){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=A._findLoopingExtensions(this._extensionDescriptions);if(y=y.concat(n.map(d=>d.identifier)),y.length>0){const d=new Set;y.forEach(r=>d.add(c.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!d.has(c.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(n)}static _findLoopingExtensions(t){const y=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,k){this.addNode(p),this.addNode(k),this._arcs.has(p)?this._arcs.get(p).push(k):this._arcs.set(p,[k])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,k){const w=y.getArcs(p);for(let l=0;l<w.length;l++)if(!k.has(w[l]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let p of t){const k=c.ExtensionIdentifier.toKey(p.identifier);if(n.set(k,p),p.extensionDependencies)for(let w of p.extensionDependencies){const l=c.ExtensionIdentifier.toKey(w);y.addArc(k,l)}}let d=new Set;y.getNodes().filter(p=>y.getArcs(p).length===0).forEach(p=>d.add(p));let r=y.getNodes().filter(p=>!d.has(p)),u;do{u=!1;for(let p=0;p<r.length;p++){const k=r[p];y.hasOnlyGoodArcs(k,d)&&(r.splice(p,1),p--,d.add(k),u=!0)}}while(u);return r.map(p=>n.get(p))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(c.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const y=this._activationMap.get(t);return y?y.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const y=this._extensionsMap.get(c.ExtensionIdentifier.toKey(t));return y||void 0}}e.ExtensionDescriptionRegistry=A;var P;(function(I){I[I.Builtin=0]="Builtin",I[I.User=1]="User",I[I.Dev=2]="Dev"})(P||(P={}));function S(I,t){const y=I.isBuiltin?0:I.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(y!==n)return y-n;const d=E.posix.basename(I.extensionLocation.path),r=E.posix.basename(t.extensionLocation.path);return d<r?-1:d>r?1:0}}),define(we[177],be([0,1,23]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function T(P){const S=c.VSBuffer.alloc(1);switch(P){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=T;function A(P,S){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=A}),define(we[30],be([0,1,3,2,4,25,142]),function(re,e,c,M,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");var P;(function(w){w[w.None=0]="None",w[w.LocalProcess=1]="LocalProcess",w[w.LocalWebWorker=2]="LocalWebWorker",w[w.Remote=3]="Remote"})(P=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class S{constructor(l){this.dependency=l}}e.MissingExtensionDependency=S;var I;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(I=e.ExtensionHostKind||(e.ExtensionHostKind={}));class t{constructor(l,v,D,i){this.codeLoadingTime=l,this.activateCallTime=v,this.activateResolvedTime=D,this.activationReason=i}}e.ActivationTimes=t;class y{constructor(l,v){this.description=l,this.value=v}}e.ExtensionPointContribution=y,e.ExtensionHostLogFileName="exthost";var n;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(n=e.ActivationKind||(e.ActivationKind={}));function d(w){w.enableProposedApi||r(w)}e.checkProposedApiEnabled=d;function r(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=r;function u(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,A.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=u;function p(w,l){return{identifier:new T.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!l,extensionLocation:w.location,...w.manifest,uuid:w.identifier.uuid}}e.toExtensionDescription=p;class k{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None}activateByEvent(l){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(l){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(l,v){return Promise.resolve()}_onWillActivateExtension(l){}_onDidActivateExtension(l,v,D,i,s){}_onDidActivateExtensionError(l,v){}_onExtensionRuntimeError(l,v){}_onExtensionHostExit(l){}}e.NullExtensionService=k}),define(we[178],be([0,1,25,30,14]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class A{constructor(r,u,p,k){this.startup=r,this.codeLoadingTime=u,this.activateCallTime=p,this.activateResolvedTime=k}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class P{constructor(r){this._startup=r,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(r,u){return r===-1||u===-1?-1:u-r}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=P;class S{constructor(r,u,p,k,w,l){this.activationFailed=r,this.activationFailedError=u,this.activationTimes=p,this.module=k,this.exports=w,this.subscriptions=l}}e.ActivatedExtension=S;class I extends S{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class t extends S{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class y extends S{constructor(r){super(!0,r,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=y;let n=class{constructor(r,u,p,k,w){this._logService=w,this._registry=r,this._resolvedExtensionsSet=new Set,u.forEach(l=>this._resolvedExtensionsSet.add(c.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,p.forEach(l=>this._hostExtensionsMap.set(c.ExtensionIdentifier.toKey(l),l)),this._host=k,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(r){const u=c.ExtensionIdentifier.toKey(r);return this._activatedExtensions.has(u)}getActivatedExtension(r){const u=c.ExtensionIdentifier.toKey(r),p=this._activatedExtensions.get(u);if(!p)throw new Error("Extension `"+r.value+"` is not known or not activated");return p}activateByEvent(r,u){if(this._alreadyActivatedEvents[r])return T;const p=this._registry.getExtensionDescriptionsForActivationEvent(r);return this._activateExtensions(p.map(k=>({id:k.identifier,reason:{startup:u,extensionId:k.identifier,activationEvent:r}}))).then(()=>{this._alreadyActivatedEvents[r]=!0})}activateById(r,u){const p=this._registry.getExtensionDescription(r);if(!p)throw new Error("Extension `"+r+"` is not known");return this._activateExtensions([{id:p.identifier,reason:u}])}_handleActivateRequest(r,u,p){if(this._hostExtensionsMap.has(c.ExtensionIdentifier.toKey(r.id))){u[c.ExtensionIdentifier.toKey(r.id)]=r;return}const k=this._registry.getExtensionDescription(r.id);if(!k){const v=new Error(`Cannot activate unknown extension '${r.id.value}'`);this._host.onExtensionActivationError(r.id,v,new M.MissingExtensionDependency(r.id.value)),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(r.id),new y(v));return}const w=typeof k.extensionDependencies=="undefined"?[]:k.extensionDependencies;let l=!0;for(let v=0,D=w.length;v<D;v++){const i=w[v];if(this._resolvedExtensionsSet.has(c.ExtensionIdentifier.toKey(i)))continue;const s=this._activatedExtensions.get(c.ExtensionIdentifier.toKey(i));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const m=k.displayName||k.identifier.value,g=this._registry.getExtensionDescription(i),C=g&&g.displayName||i,R=new Error(`Cannot activate the '${m}' extension because its dependency '${C}' failed to activate`);R.detail=s.activationFailedError,this._host.onExtensionActivationError(k.identifier,R,null),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(k.identifier),new y(R));return}if(this._hostExtensionsMap.has(c.ExtensionIdentifier.toKey(i))){l=!1,u[c.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(c.ExtensionIdentifier.toKey(i)),reason:r.reason};continue}const a=this._registry.getExtensionDescription(i);if(a){l=!1,u[c.ExtensionIdentifier.toKey(i)]={id:a.identifier,reason:r.reason};continue}const o=k.displayName||k.identifier.value,_=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(k.identifier,_,new M.MissingExtensionDependency(i)),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(k.identifier),new y(_));return}l?u[c.ExtensionIdentifier.toKey(k.identifier)]=r:p.push(r)}_activateExtensions(r){if(r.length===0||(r=r.filter(w=>!this._activatedExtensions.has(c.ExtensionIdentifier.toKey(w.id))),r.length===0))return Promise.resolve(void 0);const u=Object.create(null),p=[];for(let w=0,l=r.length;w<l;w++)this._handleActivateRequest(r[w],u,p);for(let w=0,l=p.length;w<l;w++){const v=c.ExtensionIdentifier.toKey(p[w].id);u[v]&&delete u[v]}const k=Object.keys(u).map(w=>u[w]);return p.length===0?Promise.all(k.map(w=>this._activateExtension(w.id,w.reason))).then(w=>{}):this._activateExtensions(k).then(w=>this._activateExtensions(p))}_activateExtension(r,u){const p=c.ExtensionIdentifier.toKey(r);if(this._activatedExtensions.has(p))return Promise.resolve(void 0);const k=this._activatingExtensions.get(p);if(k)return k;const w=this._host.actualActivateExtension(r,u).then(void 0,l=>{const v=new Error;return l&&l.name&&(v.name=l.name),l&&l.message?v.message=`Activating extension '${r.value}' failed: ${l.message}.`:v.message=`Activating extension '${r.value}' failed: ${l}.`,l&&l.stack&&(v.stack=l.stack),this._host.onExtensionActivationError(r,v,null),this._logService.error(`Activating extension ${r.value} failed due to an error:`),this._logService.error(l),new y(l)}).then(l=>{this._activatedExtensions.set(p,l),this._activatingExtensions.delete(p)});return this._activatingExtensions.set(p,w),w}};n=Ue([ze(4,E.ILogService)],n),e.ExtensionsActivator=n}),define(we[179],be([0,1,15]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,A)=>{this._actualOk=T,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,c.onUnexpectedError)(T))}then(T,A){return this._ensureActual().then(T,A)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=M}),define(we[46],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(I,t){this._proxyIdentifierBrand=void 0,this.isMain=I,this.sid=t,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const M=[];function E(S){const I=new c(!0,S);return M[I.nid]=I,I}e.createMainContextProxyIdentifier=E;function T(S){const I=new c(!1,S);return M[I.nid]=I,I}e.createExtHostContextProxyIdentifier=T;function A(S){return M[S].sid}e.getStringIdentifierForProxy=A;class P{constructor(I){this.value=I}}e.SerializableObjectWithBuffers=P}),define(we[5],be([0,1,53,2,46]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var A;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var y;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(y=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(l){l.name="$ident";function v(i,s){return Object.defineProperty(i,l.name,{value:s,enumerable:!0}),i}l.mixin=v;function D(i){return i[l.name]}l.of=D})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class d{static mixin(v){return v._id=d._n++,v}}e.IdObject=d,d._n=0;var r;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n"})(r=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function k(l){if(l&&l.edits)for(const v of l.edits)typeof v.resource=="object"?v.resource=M.URI.revive(v.resource):(v.newUri=M.URI.revive(v.newUri),v.oldUri=M.URI.revive(v.oldUri)),v.metadata&&v.metadata.iconPath&&(v.metadata=(0,c.revive)(v.metadata));return l}e.reviveWorkspaceEditDto=k;var w;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,E.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[69],be([0,1,5,3,4]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(P){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,S){return this._proxy.$getPassword(P,S)}store(P,S,I){return this._proxy.$setPassword(P,S,I)}delete(P,S){return this._proxy.$deletePassword(P,S)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(we[70],be([0,1,4,14,5,12]),function(re,e,c,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(S,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(E.MainContext.MainThreadTelemetry)}report(S,I,t){const y=this.getUsageKey(S,I);this._reportedUsages.has(y)||(this._reportedUsages.add(y),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:S}))}getUsageKey(S,I){return`${S}-${I.identifier.value}`}};A=Ue([ze(0,T.IExtHostRpcService),ze(1,M.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(P,S,I){}})}),define(we[180],be([0,1,3,5,6,25]),function(re,e,c,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new c.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,I,t,y={}){const n=T.ExtensionIdentifier.toKey(S.identifier),d=this._inFlightRequests.get(n)||[],r=[...t].sort().join(" ");let u=d.find(p=>p.scopes===r);if(u)return u.result;{const p=this._getSession(S,n,I,t,y);u={scopes:r,result:p},d.push(u),this._inFlightRequests.set(n,d);try{await p}finally{const k=d.findIndex(w=>w.scopes===r);k>-1&&(d.splice(k),this._inFlightRequests.set(n,d))}return p}}async _getSession(S,I,t,y,n={}){await this._proxy.$ensureProvider(t);const d=S.displayName||S.name;return this._proxy.$getSession(t,y,I,d,n)}async removeSession(S,I){const t=this._authenticationProviders.get(S);return t?t.provider.removeSession(I):this._proxy.$removeSession(S,I)}registerAuthenticationProvider(S,I,t,y){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:I,provider:t,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(d=>d.id===S)||this._providers.push({id:S,label:I});const n=t.onDidChangeSessions(d=>{this._proxy.$sendDidChangeSessions(S,{added:d.added??[],changed:d.changed??[],removed:d.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,I,y?.supportsMultipleAccounts??!1),new E.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(S);const d=this._providers.findIndex(r=>r.id===S);d>-1&&this._providers.splice(d),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,I){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,I){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,I){const t=this._authenticationProviders.get(S);if(t)return Promise.resolve(t.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,I){return this._onDidChangeSessions.fire({provider:{id:S,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(we[181],be([0,1,5,12,8]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(P,S){this._extHostDocumentsAndEditors=S,this._proxy=P.getProxy(c.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const S=E.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};T=Ue([ze(0,M.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(we[182],be([0,1,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(T){const A=T.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(P){return A.$writeText(P)}})}}e.ExtHostClipboard=M}),define(we[47],be([0,1,10,6,8,22,5,16,14,53,41,111,2,7,4,12]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(i,s){this._commands=new Map,this._apiCommands=new Map,this._proxy=i.getProxy(A.MainContext.MainThreadCommands),this._logService=s,this.converter=new k(this,a=>{const o=this._apiCommands.get(a);return o?.result===l.Void?o:void 0},s),this._argumentProcessors=[{processArgument(a){return(0,I.revive)(a)}},{processArgument(a){return(0,T.cloneAndChange)(a,function(o){if(t.Range.isIRange(o))return E.Range.to(o);if(y.Position.isIPosition(o))return E.Position.to(o);if(t.Range.isIRange(o.range)&&n.URI.isUri(o.uri))return E.location.to(o);if(!Array.isArray(o))return o})}}]}registerArgumentProcessor(i){this._argumentProcessors.push(i)}registerApiCommand(i){const s=this.registerCommand(!1,i.id,async(...a)=>{const o=i.args.map((m,g)=>{if(!m.validate(a[g]))throw new Error(`Invalid argument '${m.name}' when running '${i.id}', received: ${a[g]}`);return m.convert(a[g])}),_=await this.executeCommand(i.internalId,...o);return i.result.convert(_,a,this.converter)},void 0,{description:i.description,args:i.args,returns:i.result.description});return this._apiCommands.set(i.id,i),new M.Disposable(()=>{s.dispose(),this._apiCommands.delete(i.id)})}registerCommand(i,s,a,o,_){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:a,thisArg:o,description:_}),i&&this._proxy.$registerCommand(s),new M.Disposable(()=>{this._commands.delete(s)&&i&&this._proxy.$unregisterCommand(s)})}executeCommand(i,...s){return this._logService.trace("ExtHostCommands#executeCommand",i),this._doExecuteCommand(i,s,!0)}async _doExecuteCommand(i,s,a){if(this._commands.has(i))return this._executeContributedCommand(i,s);{const o=(0,T.cloneAndChange)(s,function(_){if(_ instanceof M.Position)return E.Position.from(_);if(_ instanceof M.Range)return E.Range.from(_);if(_ instanceof M.Location)return E.location.from(_);if(M.NotebookRange.isNotebookRange(_))return E.NotebookRange.from(_);if(!Array.isArray(_))return _});try{const _=await this._proxy.$executeCommand(i,o,a);return(0,I.revive)(_)}catch(_){if(_ instanceof Error&&_.message==="$executeCommand:retry")return this._doExecuteCommand(i,s,!1);throw _}}}async _executeContributedCommand(i,s){const a=this._commands.get(i);if(!a)throw new Error("Unknown command");let{callback:o,thisArg:_,description:m}=a;if(m)for(let g=0;g<m.args.length;g++)try{(0,c.validateConstraint)(s[g],m.args[g].constraint)}catch(C){throw new Error(`Running the contributed command: '${i}' failed. Illegal argument '${m.args[g].name}' - ${m.args[g].description}`)}try{return await o.apply(_,s)}catch(g){if(i===this.converter.delegatingCommandId){const C=this.converter.getActualCommand(...s);C&&(i=C.command)}throw this._logService.error(g,i),new Error(`Running the contributed command: '${i}' failed.`)}}$executeContributedCommand(i,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",i),this._commands.has(i)?(s=s.map(a=>this._argumentProcessors.reduce((o,_)=>_.processArgument(o),a)),this._executeContributedCommand(i,s)):Promise.reject(new Error(`Contributed command '${i}' does not exist.`))}getCommands(i=!1){return this._logService.trace("ExtHostCommands#getCommands",i),this._proxy.$getCommands().then(s=>(i&&(s=s.filter(a=>a[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const i=Object.create(null);for(let[s,a]of this._commands){let{description:o}=a;o&&(i[s]=o)}return Promise.resolve(i)}};p=Ue([ze(0,u.IExtHostRpcService),ze(1,S.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class k{constructor(i,s,a){this._commands=i,this._lookupApiCommand=s,this._logService=a,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(i,s){if(!i)return;const a={$ident:void 0,id:i.command,title:i.title,tooltip:i.tooltip};if(!i.command)return a;const o=this._lookupApiCommand(i.command);if(o)a.id=o.internalId,a.arguments=o.args.map((_,m)=>_.convert(i.arguments&&i.arguments[m]));else if((0,P.isNonEmptyArray)(i.arguments)){const _=++this._cachIdPool;this._cache.set(_,i),s.add((0,d.toDisposable)(()=>{this._cache.delete(_),this._logService.trace("CommandsConverter#DISPOSE",_)})),a.$ident=_,a.id=this.delegatingCommandId,a.arguments=[_],this._logService.trace("CommandsConverter#CREATE",i.command,_)}return a}fromInternal(i){const s=A.ObjectIdentifier.of(i);return typeof s=="number"?this._cache.get(s):{command:i.id,title:i.title,arguments:i.arguments}}getActualCommand(...i){return this._cache.get(i[0])}_executeConvertedCommand(...i){const s=this.getActualCommand(...i);return this._logService.trace("CommandsConverter#EXECUTE",i[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=k;class w{constructor(i,s,a,o){this.name=i,this.description=s,this.validate=a,this.convert=o}optional(){return new w(this.name,`(optional) ${this.description}`,i=>i==null||this.validate(i),i=>i===void 0?void 0:i===null?null:this.convert(i))}with(i,s){return new w(i??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=w,w.Uri=new w("uri","Uri of a text document",D=>n.URI.isUri(D),D=>D),w.Position=new w("position","A position in a text document",D=>M.Position.isPosition(D),E.Position.from),w.Range=new w("range","A range in a text document",D=>M.Range.isRange(D),E.Range.from),w.Selection=new w("selection","A selection in a text document",D=>M.Selection.isSelection(D),E.Selection.from),w.Number=new w("number","",D=>typeof D=="number",D=>D),w.String=new w("string","",D=>typeof D=="string",D=>D),w.CallHierarchyItem=new w("item","A call hierarchy item",D=>D instanceof M.CallHierarchyItem,E.CallHierarchyItem.from),w.TypeHierarchyItem=new w("item","A type hierarchy item",D=>D instanceof M.TypeHierarchyItem,E.TypeHierarchyItem.from);class l{constructor(i,s){this.description=i,this.convert=s}}e.ApiCommandResult=l,l.Void=new l("no result",D=>D);class v{constructor(i,s,a,o,_){this.id=i,this.internalId=s,this.description=a,this.args=o,this.result=_}}e.ApiCommand=v}),define(we[183],be([0,1,8,6,58,47,16,80]),function(re,e,c,M,E,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new T.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(c.DocumentHighlight.to))),new T.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,d)=>{if((0,A.isFalsyOrEmpty)(n))return;class r extends M.SymbolInformation{static to(p){const k=new r(p.name,c.SymbolKind.to(p.kind),p.containerName||"",new M.Location(d[0],c.Range.to(p.range)));return k.detail=p.detail,k.range=k.location.range,k.selectionRange=c.Range.to(p.selectionRange),k.children=p.children?p.children.map(r.to):[],k}}return n.map(r.to)})),new T.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new T.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new T.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,new T.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(c.TextEdit.to))),new T.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new T.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new T.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new T.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new T.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(c.location.to))),new T.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(c.Hover.to))),new T.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(d=>M.Position.isPosition(d)),n=>n.map(c.Position.from))],new T.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(d=>{let r;for(const u of d.reverse())r=new M.SelectionRange(c.Range.to(u),r);return r}))),new T.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[T.ApiCommandArgument.String.with("query","Search string")],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const d=[];if(Array.isArray(n))for(let r of n)d.push(...r[1].map(c.WorkspaceSymbol.to));return d})),new T.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyItem.to))),new T.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyIncomingCall.to))),new T.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(c.CallHierarchyOutgoingCall.to))),new T.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("newName","The new symbol name")],new T.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return c.WorkspaceEdit.to(n)}})),new T.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new T.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(c.DocumentLink.to))),new T.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,P.decodeSemanticTokensDto)(n);if(d.type==="full")return new M.SemanticTokens(d.data,void 0)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,P.decodeSemanticTokensDto)(n);if(d.type==="full")return new M.SemanticTokens(d.data,void 0)})),new T.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new T.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,d,r)=>{if(!n)return new M.CompletionList([]);const u=n.suggestions.map(p=>c.CompletionItem.to(p,r));return new M.CompletionList(u,n.incomplete)})),new T.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new T.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return c.SignatureHelp.to(n)})),new T.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new T.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,d,r)=>t(u=>new M.CodeLens(c.Range.to(u.range),u.command&&r.fromInternal(u.command)))(n))),new T.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?c.Selection.from(n):c.Range.from(n)),T.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new T.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,d,r)=>t(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(u.command)}else{const p=new M.CodeAction(u.title,u.kind?new M.CodeActionKind(u.kind):void 0);return u.edit&&(p.edit=c.WorkspaceEdit.to(u.edit)),u.command&&(p.command=r.fromInternal(u.command)),p.isPreferred=u.isPreferred,p}})(n))),new T.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(d=>new M.ColorInformation(c.Range.to(d.range),c.Color.to(d.color))):[])),new T.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new T.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,c.Color.from),new T.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:c.Range.from(n.range)}))],new T.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(c.ColorPresentation.to):[])),new T.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(c.InlayHint.to))),new T.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new T.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(d=>c.NotebookExclusiveDocumentPattern.to(d))})))),new T.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(c.InlineValue.to))),new T.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional(),T.ApiCommandArgument.String.with("label","").optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[T.ApiCommandArgument.Uri.with("resource","Resource to open"),T.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)])).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[T.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),T.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),T.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[c.ViewColumn.from(n.viewColumn),c.TextEditorOpenOptions.from(n)]).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(c.TypeHierarchyItem.to)))];class I{static register(d){S.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=I;function t(n){return d=>{if(Array.isArray(d))return d.map(n)}}function y(n){if(!Array.isArray(n))return;const d=[];for(const r of n)E.isLocationLink(r)?d.push(c.DefinitionLink.to(r)):d.push(c.location.to(r));return d}}),define(we[184],be([0,1,13,51,3,7,2,58,25,8,6,5]),function(re,e,c,M,E,T,A,P,S,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(d,r,u){const p=d.getProxy(y.MainContext.MainThreadComments);class k{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,r.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===6){const _=this._commentControllers.get(o.handle);return _||o}else if(o&&o.$mid===7){const _=this._commentControllers.get(o.commentControlHandle);if(!_)return o;const m=_.getCommentThread(o.commentThreadHandle);return m||o}else if(o&&o.$mid===8){const _=this._commentControllers.get(o.thread.commentControlHandle);if(!_)return o;const m=_.getCommentThread(o.thread.commentThreadHandle);return m?{thread:m,text:o.text}:o}else if(o&&o.$mid===9){const _=this._commentControllers.get(o.thread.commentControlHandle);if(!_)return o;const m=_.getCommentThread(o.thread.commentThreadHandle);if(!m)return o;let g=o.commentUniqueId,C=m.getCommentByUniqueId(g);return C||o}else if(o&&o.$mid===10){const _=this._commentControllers.get(o.thread.commentControlHandle);if(!_)return o;const m=_.getCommentThread(o.thread.commentThreadHandle);if(!m)return o;let g=o.text,C=o.commentUniqueId,R=m.getCommentByUniqueId(C);return R?(R.body=g,R):o}return o}})}createCommentController(o,_,m){const g=k.handlePool++,C=new l(o,g,_,m);this._commentControllers.set(C.handle,C);const R=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(o.identifier))||[];return R.push(C),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(o.identifier),R),C.value}$createCommentThreadTemplate(o,_,m){const g=this._commentControllers.get(o);!g||g.$createCommentThreadTemplate(_,m)}async $updateCommentThreadTemplate(o,_,m){const g=this._commentControllers.get(o);!g||g.$updateCommentThreadTemplate(_,m)}$deleteCommentThread(o,_){const m=this._commentControllers.get(o);m&&m.$deleteCommentThread(_)}$provideCommentingRanges(o,_,m){const g=this._commentControllers.get(o);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const C=u.getDocument(A.URI.revive(_));return(0,c.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(C,m)).then(R=>R?R.map(h=>I.Range.from(h)):void 0)}$toggleReaction(o,_,m,g,C){const R=this._commentControllers.get(o);return!R||!R.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const h=R.getCommentThread(_);if(h){const b=h.getCommentByUniqueId(g.uniqueIdInThread);if(R!==void 0&&b&&R.reactionHandler)return R.reactionHandler(b,i(C))}return Promise.resolve(void 0)})}dispose(){}}k.handlePool=0;class w{constructor(o,_,m,g,C,R,h){this._commentControllerHandle=_,this._id=m,this._uri=g,this._range=C,this._comments=R,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${o}.${this.handle}`),p.$createCommentThread(_,this.handle,this._id,this._uri,I.Range.from(this._range),h),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=R,this._localDisposables.push({dispose:()=>{p.$deleteCommentThread(_,this.handle)}});const b=this;this.value={get uri(){return b.uri},get range(){return b.range},set range(f){b.range=f},get comments(){return b.comments},set comments(f){b.comments=f},get collapsibleState(){return b.collapsibleState},set collapsibleState(f){b.collapsibleState=f},get canReply(){return b.canReply},set canReply(f){b.canReply=f},get contextValue(){return b.contextValue},set contextValue(f){b.contextValue=f},get label(){return b.label},set label(f){b.label=f},dispose:()=>{b.dispose()}}}set threadId(o){this._id=o}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(o){o.isEqual(this._range)||(this._range=o,this.modifications.range=o,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(o){this._canReply!==o&&(this._canReply=o,this.modifications.canReply=o,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(o){this._label=o,this.modifications.label=o,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(o){this._contextValue=o,this.modifications.contextValue=o,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(o){this._comments=o,this.modifications.comments=o,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(o){this._collapseState=o,this.modifications.collapsibleState=o,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const o=m=>Object.prototype.hasOwnProperty.call(this.modifications,m),_={};o("range")&&(_.range=I.Range.from(this._range)),o("label")&&(_.label=this.label),o("contextValue")&&(_.contextValue=this.contextValue),o("comments")&&(_.comments=this._comments.map(m=>v(this,m,this._commentsMap))),o("collapsibleState")&&(_.collapseState=s(this._collapseState)),o("canReply")&&(_.canReply=this.canReply),this.modifications={},p.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,_)}getCommentByUniqueId(o){for(let _ of this._commentsMap){let m=_[0],g=_[1];if(o===g)return m}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(o=>o.dispose())}}w._handlePool=0,Ue([(0,M.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(o,_,m,g){this._extension=o,this._handle=_,this._id=m,this._label=g,this._threads=new Map,p.$registerCommentController(this.handle,m,g);const C=this;this.value=Object.freeze({id:C.id,label:C.label,get options(){return C.options},set options(R){C.options=R},get commentingRangeProvider(){return C.commentingRangeProvider},set commentingRangeProvider(R){C.commentingRangeProvider=R},get reactionHandler(){return C.reactionHandler},set reactionHandler(R){C.reactionHandler=R},createCommentThread(R,h,b){return C.createCommentThread(R,h,b).value},dispose:()=>{C.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{p.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(o){this._reactionHandler=o,p.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!o})}get options(){return this._options}set options(o){this._options=o,p.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(o,_,m,g){if(typeof o=="string"){const C=new w(this.id,this.handle,o,_,m,g,this._extension.identifier);return this._threads.set(C.handle,C),C}else{const C=new w(this.id,this.handle,void 0,o,_,m,this._extension.identifier);return this._threads.set(C.handle,C),C}}$createCommentThreadTemplate(o,_){const m=new w(this.id,this.handle,void 0,A.URI.revive(o),I.Range.to(_),[],this._extension.identifier);return m.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(m.handle,m),m}$updateCommentThreadTemplate(o,_){let m=this._threads.get(o);m&&(m.range=I.Range.to(_))}$deleteCommentThread(o){let _=this._threads.get(o);_&&_.dispose(),this._threads.delete(o)}getCommentThread(o){return this._threads.get(o)}dispose(){this._threads.forEach(o=>{o.dispose()}),this._localDisposables.forEach(o=>o.dispose())}}function v(a,o,_){let m=_.get(o);m||(m=++a.commentHandle,_.set(o,m));const g=o.author&&o.author.iconPath?o.author.iconPath.toString():void 0;return{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:m,body:I.MarkdownString.from(o.body),userName:o.author.name,userIconPath:g,label:o.label,commentReactions:o.reactions?o.reactions.map(C=>D(C)):void 0}}function D(a){return{label:a.label,iconPath:a.iconPath?I.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function i(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?A.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function s(a){if(a!==void 0)switch(a){case t.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}return new k}e.createExtHostComments=n}),define(we[95],be([0,1,2,5,6,4,12,14,16,9,17]),function(re,e,c,M,E,T,A,P,S,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class pi{constructor(d,r){this._logService=r,this._provider=new Map,this._proxy=d.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,r){const u=pi._handlePool++;this._provider.set(u,{provider:d,extensionId:r}),this._proxy.$registerDecorationProvider(u,r.value);const p=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(k=>{if(!k){this._proxy.$onDidChange(u,null);return}let w=(0,S.asArray)(k);if(w.length<=pi._maxEventSize){this._proxy.$onDidChange(u,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,w.length);const l=w.map(i=>({uri:i,rank:(0,I.count)(i.path,"/")})),v=(0,S.groupBy)(l,(i,s)=>i.rank-s.rank||(0,I.compare)(i.uri.path,s.uri.path));let D=[];e:for(let i of v){let s;for(let a of i){let o=(0,t.dirname)(a.uri.path);if(s!==o&&(s=o,D.push(a.uri)>=pi._maxEventSize))break e}}this._proxy.$onDidChange(u,D)});return new E.Disposable(()=>{p?.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(d,r,u){if(!this._provider.has(d))return Object.create(null);const p=Object.create(null),{provider:k,extensionId:w}=this._provider.get(d);return await Promise.all(r.map(async l=>{try{const{uri:v,id:D}=l,i=await Promise.resolve(k.provideFileDecoration(c.URI.revive(v),u));if(!i)return;try{E.FileDecoration.validate(i),p[D]=[i.propagate,i.tooltip,i.badge,i.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${w.value}': ${s}`)}}catch(v){this._logService.error(v)}})),p}};y._handlePool=0,y._maxEventSize=250,y=Ue([ze(0,A.IExtHostRpcService),ze(1,P.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(we[185],be([0,1,123,82,2,5,6,8,3,14,20]),function(re,e,c,M,E,T,A,P,S,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class y{constructor(r,u,p,k,w){this._name=r,this._owner=u,this._maxDiagnosticsPerFile=p,this._proxy=k,this._onDidChangeDiagnostics=w,this._isDisposed=!1,this._data=new t.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,u){if(!r){this.clear();return}this._checkDisposed();let p=[];if(E.URI.isUri(r)){if(!u){this.delete(r);return}this._data.set(r,u.slice()),p=[r]}else if(Array.isArray(r)){p=[];let w;r=[...r].sort(y._compareIndexedTuplesByUri);for(const l of r){const[v,D]=l;if((!w||v.toString()!==w.toString())&&(w&&this._data.get(w).length===0&&this._data.delete(w),w=v,p.push(v),this._data.set(v,[])),D){const i=this._data.get(v);i&&i.push(...D)}else{const i=this._data.get(v);i&&(i.length=0)}}}if(this._onDidChangeDiagnostics.fire(p),!this._proxy)return;const k=[];for(let w of p){let l=[];const v=this._data.get(w);if(v)if(v.length>this._maxDiagnosticsPerFile){l=[];const D=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(let s of v)if(s.severity===D[i]&&l.push(P.Diagnostic.from(s))===this._maxDiagnosticsPerFile)break e;l.push({severity:M.MarkerSeverity.Info,message:(0,c.localize)(0,null,v.length-this._maxDiagnosticsPerFile),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=v.map(D=>P.Diagnostic.from(D));k.push([w,l])}this._proxy.$changeMany(this._owner,k)}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,u){this._checkDisposed();for(let p of this._data.keys())r.apply(u,[p,this.get(p),this])}get(r){this._checkDisposed();const u=this._data.get(r);return Array.isArray(u)?Object.freeze(u.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,u){return r[0].toString()<u[0].toString()?-1:r[0].toString()>u[0].toString()?1:0}}e.DiagnosticCollection=y;let n=class Zt{constructor(r,u){this._logService=u,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:p=>p.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,Zt._mapper),this._proxy=r.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(r){const u=new t.ResourceMap;for(const p of r)u.set(p,p);return{uris:Object.freeze(Array.from(u.values()))}}createDiagnosticCollection(r,u){const{_collections:p,_proxy:k,_onDidChangeDiagnostics:w,_logService:l}=this,v=new class{$changeMany(s,a){k.$changeMany(s,a),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,s,a.length===0?"CLEARING":a)}$clear(s){k.$clear(s),l.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,s)}dispose(){k.dispose()}};let D;if(!u)u="_generated_diagnostic_collection_name_#"+Zt._idPool++,D=u;else if(!p.has(u))D=u;else{this._logService.warn(`DiagnosticCollection with name '${u}' does already exist.`);do D=u+Zt._idPool++;while(p.has(D))}return new class extends y{constructor(){super(u,D,Zt._maxDiagnosticsPerFile,v,w);p.set(D,this)}dispose(){super.dispose(),p.delete(D)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const u=new Map,p=[];for(const k of this._collections.values())k.forEach((w,l)=>{let v=u.get(w.toString());typeof v=="undefined"&&(v=p.length,u.set(w.toString(),v),p.push([w,[]])),p[v][1]=p[v][1].concat(...l)});return p}}_getDiagnostics(r){let u=[];for(let p of this._collections.values())p.has(r)&&(u=u.concat(p.get(r)));return u}$acceptMarkersChange(r){if(!this._mirrorCollection){const u="_generated_mirror",p=new y(u,u,Zt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(u,p),this._mirrorCollection=p}for(const[u,p]of r)this._mirrorCollection.set(E.URI.revive(u),p.map(P.Diagnostic.to))}};n._idPool=0,n._maxDiagnosticsPerFile=1e3,n=Ue([ze(1,I.ILogService)],n),e.ExtHostDiagnostics=n}),define(we[186],be([0,1,2,5]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(A){this._proxy=A.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(P=>P?P.map(S=>c.URI.revive(S)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(P=>P?c.URI.revive(P):void 0)}}e.ExtHostDialogs=E}),define(we[187],be([0,1,15,2,6,5,11,21,9]),function(re,e,c,M,E,T,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(y,n,d){this._documentsAndEditors=n,this._logService=d,this._documentContentProviders=new Map,this._proxy=y.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,n){if(Object.keys(A.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const d=I._handlePool++;this._documentContentProviders.set(d,n),this._proxy.$registerTextContentProvider(d,y);let r;return typeof n.onDidChange=="function"&&(r=n.onDidChange(u=>{if(u.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(d,u).then(p=>{if(!p&&typeof p!="string")return;const k=this._documentsAndEditors.getDocument(u);if(!k)return;const w=(0,S.splitLines)(p);if(!k.equalLines(w))return this._proxy.$onVirtualDocumentChange(u,p)},c.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(d)&&this._proxy.$unregisterTextContentProvider(d),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(y,n){const d=this._documentContentProviders.get(y);return d?Promise.resolve(d.provideTextDocumentContent(M.URI.revive(n),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(we[188],be([0,1,3,7,2,5,88,8,10,22,6]),function(re,e,c,M,E,T,A,P,S,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(d,r){this._onDidAddDocument=new c.Emitter,this._onDidRemoveDocument=new c.Emitter,this._onDidChangeDocument=new c.Emitter,this._onDidSaveDocument=new c.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=r,this._documentsAndEditors.onDidRemoveDocuments(u=>{for(const p of u)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(u=>{for(const p of u)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const r=this._documentsAndEditors.getDocument(d);if(r)return r}getDocument(d){const r=this.getDocumentData(d);if(!r?.document)throw new Error(`Unable to retrieve document from URI '${d}'`);return r.document}ensureDocumentData(d){const r=this._documentsAndEditors.getDocument(d);if(r)return Promise.resolve(r);let u=this._documentLoader.get(d.toString());return u||(u=this._proxy.$tryOpenDocument(d).then(p=>{this._documentLoader.delete(d.toString());const k=E.URI.revive(p);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(k))},p=>(this._documentLoader.delete(d.toString()),Promise.reject(p))),this._documentLoader.set(d.toString(),u)),u}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(r=>E.URI.revive(r))}$acceptModelModeChanged(d,r){const u=E.URI.revive(d),p=this._documentsAndEditors.getDocument(u);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(r),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(d){const r=E.URI.revive(d),u=this._documentsAndEditors.getDocument(r);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(u.document)}$acceptDirtyStateChanged(d,r){const u=E.URI.revive(d),p=this._documentsAndEditors.getDocument(u);if(!p)throw new Error("unknown document");p._acceptIsDirty(r),this._onDidChangeDocument.fire({document:p.document,contentChanges:[],reason:void 0})}$acceptModelChanged(d,r,u){const p=E.URI.revive(d),k=this._documentsAndEditors.getDocument(p);if(!k)throw new Error("unknown document");k._acceptIsDirty(u),k.onEvents(r);let w;r.isUndoing?w=t.TextDocumentChangeReason.Undo:r.isRedoing&&(w=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:k.document,contentChanges:r.changes.map(l=>({range:P.Range.to(l.range),rangeOffset:l.rangeOffset,rangeLength:l.rangeLength,text:l.text})),reason:w}))}setWordDefinitionFor(d,r){(0,A.setWordDefinitionFor)(d,r)}}e.ExtHostDocuments=y}),define(we[48],be([0,1,39,3,7,2,4,5,88,12,94,8,14,20,11,189,103]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class k{constructor(v){this.value=v,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(v,D){this._extHostRpc=v,this._logService=D,this._activeEditorId=null,this._editors=new Map,this._documents=new d.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(v){this.acceptDocumentsAndEditorsDelta(v)}acceptDocumentsAndEditorsDelta(v){const D=[],i=[],s=[];if(v.removedDocuments)for(const a of v.removedDocuments){const o=T.URI.revive(a),_=this._documents.get(o);_?.unref()&&(this._documents.delete(o),D.push(_.value))}if(v.addedDocuments)for(const a of v.addedDocuments){const o=T.URI.revive(a.uri);let _=this._documents.get(o);if(_&&o.scheme!==r.Schemas.vscodeNotebookCell&&o.scheme!==r.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);_||(_=new k(new S.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),o,a.lines,a.EOL,a.versionId,a.modeId,a.isDirty,a.notebook)),this._documents.set(o,_),i.push(_.value)),_.ref()}if(v.removedEditors)for(const a of v.removedEditors){const o=this._editors.get(a);this._editors.delete(a),o&&s.push(o)}if(v.addedEditors)for(const a of v.addedEditors){const o=T.URI.revive(a.documentUri);c.ok(this._documents.has(o),`document '${o}' does not exist`),c.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const _=this._documents.get(o).value,m=new t.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>_.document),a.selections.map(y.Selection.to),a.options,a.visibleRanges.map(g=>y.Range.to(g)),typeof a.editorPosition=="number"?y.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,m)}v.newActiveEditor!==void 0&&(c.ok(v.newActiveEditor===null||this._editors.has(v.newActiveEditor),`active editor '${v.newActiveEditor}' does not exist`),this._activeEditorId=v.newActiveEditor),(0,E.dispose)(D),(0,E.dispose)(s),v.removedDocuments&&this._onDidRemoveDocuments.fire(D),v.addedDocuments&&this._onDidAddDocuments.fire(i),(v.removedEditors||v.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),v.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(v){return this._documents.get(v)?.value}allDocuments(){return u.Iterable.map(this._documents.values(),v=>v.value)}getEditor(v){return this._editors.get(v)}activeEditor(v){if(!this._activeEditorId)return;const D=this._editors.get(this._activeEditorId);return v?D:D?.value}allEditors(){return[...this._editors.values()]}};w=Ue([ze(0,I.IExtHostRpcService),ze(1,n.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[190],be([0,1,2,5,7,6,8,232,9,23]),function(re,e,c,M,E,T,A,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(d){this._stateMachine=void 0,this._schemes.push(d)}delete(d){const r=this._schemes.indexOf(d);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const d=this._schemes.sort(),r=[];let u,p,k=14,w=14;for(const l of d){let v=u?(0,S.commonPrefixLength)(u,l):0;for(v===0?p=1:p=w;v<l.length;v++)v+1===l.length?(k=w,w=9):w+=1,r.push([p,l.toUpperCase().charCodeAt(v),w]),r.push([p,l.toLowerCase().charCodeAt(v),w]),p=w;u=l,w=k}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new P.StateMachine(r)}}provideDocumentLinks(d){this._initStateMachine();const r=[],u=P.LinkComputer.computeLinks({getLineContent(p){return d.lineAt(p-1).text},getLineCount(){return d.lineCount}},this._stateMachine);for(const p of u){const k=A.DocumentLink.to(p);k.target&&r.push(k)}return r}}class y{constructor(d,r){this._extHostLanguageFeatures=r,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=d.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(d,r,u,p={},k){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(w,u),this._enableProposedApi.set(w,k??!1);let l=2;p.isCaseSensitive&&(l+=1024),p.isReadonly&&(l+=2048),typeof u.copy=="function"&&(l+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&(l+=4),this._proxy.$registerFileSystemProvider(w,r,l).catch(D=>{console.error(`FAILED to register filesystem provider of ${d.value}-extension for the scheme ${r}`),console.error(D)});const v=u.onDidChangeFile(D=>{const i=[];for(const s of D){let{uri:a,type:o}=s;if(a.scheme!==r)continue;let _;switch(o){case T.FileChangeType.Changed:_=0;break;case T.FileChangeType.Created:_=1;break;case T.FileChangeType.Deleted:_=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:a,type:_})}this._proxy.$onFileSystemChange(w,i)});return(0,E.toDisposable)(()=>{v.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(w),this._enableProposedApi.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(d,r){const{type:u,ctime:p,mtime:k,size:w,permissions:l}=d;return r?{type:u,ctime:p,mtime:k,size:w,permissions:l}:{type:u,ctime:p,mtime:k,size:w}}$stat(d,r){return Promise.resolve(this._getFsProvider(d).stat(c.URI.revive(r))).then(u=>y._asIStat(u,this._enableProposedApi.get(d)??!1))}$readdir(d,r){return Promise.resolve(this._getFsProvider(d).readDirectory(c.URI.revive(r)))}$readFile(d,r){return Promise.resolve(this._getFsProvider(d).readFile(c.URI.revive(r))).then(u=>I.VSBuffer.wrap(u))}$writeFile(d,r,u,p){return Promise.resolve(this._getFsProvider(d).writeFile(c.URI.revive(r),u.buffer,p))}$delete(d,r,u){return Promise.resolve(this._getFsProvider(d).delete(c.URI.revive(r),u))}$rename(d,r,u,p){return Promise.resolve(this._getFsProvider(d).rename(c.URI.revive(r),c.URI.revive(u),p))}$copy(d,r,u,p){const k=this._getFsProvider(d);if(!k.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(k.copy(c.URI.revive(r),c.URI.revive(u),p))}$mkdir(d,r){return Promise.resolve(this._getFsProvider(d).createDirectory(c.URI.revive(r)))}$watch(d,r,u,p){const k=this._getFsProvider(d).watch(c.URI.revive(u),p);this._watches.set(r,k)}$unwatch(d,r){const u=this._watches.get(r);u&&(u.dispose(),this._watches.delete(r))}$open(d,r,u){const p=this._getFsProvider(d);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(c.URI.revive(r),u))}$close(d,r){const u=this._getFsProvider(d);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(r))}$read(d,r,u,p){const k=this._getFsProvider(d);if(!k.read)throw new Error('FileSystemProvider does not implement "read"');const w=I.VSBuffer.alloc(p);return Promise.resolve(k.read(r,u,w.buffer,0,p)).then(l=>w.slice(0,l))}$write(d,r,u,p){const k=this._getFsProvider(d);if(!k.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(k.write(r,u,p.buffer,0,p.byteLength))}_getFsProvider(d){const r=this._fsProvider.get(d);if(!r){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return r}}e.ExtHostFileSystem=y}),define(we[71],be([0,1,5,59,6,23,4,12,45]),function(re,e,c,M,E,T,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let I=class Bt{constructor(y,n){const d=y.getProxy(c.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return d.$stat(r).catch(Bt._handleError)},readDirectory(r){return d.$readdir(r).catch(Bt._handleError)},createDirectory(r){return d.$mkdir(r).catch(Bt._handleError)},async readFile(r){return d.$readFile(r).then(u=>u.buffer).catch(Bt._handleError)},writeFile(r,u){return d.$writeFile(r,T.VSBuffer.wrap(u)).catch(Bt._handleError)},delete(r,u){return d.$delete(r,{recursive:!1,useTrash:!1,...u}).catch(Bt._handleError)},rename(r,u,p){return d.$rename(r,u,{overwrite:!1,...p}).catch(Bt._handleError)},copy(r,u,p){return d.$copy(r,u,{overwrite:!1,...p}).catch(Bt._handleError)},isWritableFileSystem(r){const u=n.getCapabilities(r);if(typeof u=="number")return!(u&2048)}})}static _handleError(y){if(!(y instanceof Error))throw new E.FileSystemError(String(y));if(y.name==="ENOPRO")throw E.FileSystemError.Unavailable(y.message);switch(y.name){case M.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(y.message);case M.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(y.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(y.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(y.message);case M.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(y.message);case M.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(y.message);default:throw new E.FileSystemError(y.message,y.name)}}};I=Ue([ze(0,P.IExtHostRpcService),ze(1,S.IExtHostFileSystemInfo)],I),e.ExtHostConsumerFileSystem=I,e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(we[191],be([0,1,2,47]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(A,P,S,I){this._extHostNotebooks=P,this._textDocumentsAndEditors=S,this._commands=I;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",y=>!0,y=>y),new M.ApiCommandArgument("resource","Interactive resource Uri",y=>!0,y=>y),new M.ApiCommandArgument("controllerId","Notebook controller Id",y=>!0,y=>y),new M.ApiCommandArgument("title","Interactive editor title",y=>!0,y=>y)],new M.ApiCommandResult("Notebook and input URI",y=>{if(y.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(y.notebookEditorId);return{notebookUri:c.URI.revive(y.notebookUri),inputUri:c.URI.revive(y.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:c.URI.revive(y.notebookUri),inputUri:c.URI.revive(y.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(A,P,S,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],modeId:S,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(c.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=E}),define(we[192],be([0,1,7,5]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(A){this._handlePool=0,this._proxy=A.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,A),(0,c.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=E}),define(we[193],be([0,1,2,22,8,6,5,9,41,16,10,233,7,80,52,62,194,15,3]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r,u,p,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class l{constructor(B,K){this._documents=B,this._provider=K}async provideDocumentSymbols(B,K){const ee=this._documents.getDocument(B),ae=await this._provider.provideDocumentSymbols(ee,K);if(!(0,I.isFalsyOrEmpty)(ae))return ae[0]instanceof T.DocumentSymbol?ae.map(E.DocumentSymbol.from):l._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree(B){B=B.slice(0).sort((ae,V)=>{let se=ae.location.range.start.compareTo(V.location.range.start);return se===0&&(se=V.location.range.end.compareTo(ae.location.range.end)),se});const K=[],ee=[];for(const ae of B){const V={name:ae.name||"!!MISSING: name!!",kind:E.SymbolKind.from(ae.kind),tags:ae.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:E.Range.from(ae.location.range),selectionRange:E.Range.from(ae.location.range),children:[]};for(;;){if(ee.length===0){ee.push(V),K.push(V);break}const se=ee[ee.length-1];if(S.Range.containsRange(se.range,V.range)&&!S.Range.equalsRange(se.range,V.range)){se.children&&se.children.push(V),ee.push(V);break}ee.pop()}}return K}}class v{constructor(B,K,ee){this._documents=B,this._commands=K,this._provider=ee,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(B,K){const ee=this._documents.getDocument(B),ae=await this._provider.provideCodeLenses(ee,K);if(!ae||K.isCancellationRequested)return;const V=this._cache.add(ae),se=new n.DisposableStore;this._disposables.set(V,se);const fe={cacheId:V,lenses:[]};for(let Ae=0;Ae<ae.length;Ae++)fe.lenses.push({cacheId:[V,Ae],range:E.Range.from(ae[Ae].range),command:this._commands.toInternal(ae[Ae].command,se)});return fe}async resolveCodeLens(B,K){const ee=B.cacheId&&this._cache.get(...B.cacheId);if(!ee)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||ee.isResolved?ae=ee:ae=await this._provider.resolveCodeLens(ee,K),ae||(ae=ee),K.isCancellationRequested)return;const V=B.cacheId&&this._disposables.get(B.cacheId[0]);if(!!V)return B.command=this._commands.toInternal(ae.command??v._badCmd,V),B}releaseCodeLenses(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}}v._badCmd={command:"missing",title:"!!MISSING: command!!"};function D(qe){return Array.isArray(qe)?qe.map(E.DefinitionLink.from):qe?[E.DefinitionLink.from(qe)]:[]}class i{constructor(B,K){this._documents=B,this._provider=K}async provideDefinition(B,K,ee){const ae=this._documents.getDocument(B),V=E.Position.to(K),se=await this._provider.provideDefinition(ae,V,ee);return D(se)}}class s{constructor(B,K){this._documents=B,this._provider=K}async provideDeclaration(B,K,ee){const ae=this._documents.getDocument(B),V=E.Position.to(K),se=await this._provider.provideDeclaration(ae,V,ee);return D(se)}}class a{constructor(B,K){this._documents=B,this._provider=K}async provideImplementation(B,K,ee){const ae=this._documents.getDocument(B),V=E.Position.to(K),se=await this._provider.provideImplementation(ae,V,ee);return D(se)}}class o{constructor(B,K){this._documents=B,this._provider=K}async provideTypeDefinition(B,K,ee){const ae=this._documents.getDocument(B),V=E.Position.to(K),se=await this._provider.provideTypeDefinition(ae,V,ee);return D(se)}}class _{constructor(B,K){this._documents=B,this._provider=K}async provideHover(B,K,ee){const ae=this._documents.getDocument(B),V=E.Position.to(K),se=await this._provider.provideHover(ae,V,ee);if(!(!se||(0,I.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=ae.getWordRangeAtPosition(V)),se.range||(se.range=new T.Range(V,V)),E.Hover.from(se)}}class m{constructor(B,K){this._documents=B,this._provider=K}async provideEvaluatableExpression(B,K,ee){const ae=this._documents.getDocument(B),V=E.Position.to(K),se=await this._provider.provideEvaluatableExpression(ae,V,ee);if(se)return E.EvaluatableExpression.from(se)}}class g{constructor(B,K){this._documents=B,this._provider=K}async provideInlineValues(B,K,ee,ae){const V=this._documents.getDocument(B),se=await this._provider.provideInlineValues(V,E.Range.to(K),E.InlineValueContext.to(ee),ae);if(Array.isArray(se))return se.map(fe=>E.InlineValue.from(fe))}}class C{constructor(B,K){this._documents=B,this._provider=K}async provideDocumentHighlights(B,K,ee){const ae=this._documents.getDocument(B),V=E.Position.to(K),se=await this._provider.provideDocumentHighlights(ae,V,ee);if(Array.isArray(se))return se.map(E.DocumentHighlight.from)}}class R{constructor(B,K){this._documents=B,this._provider=K}async provideLinkedEditingRanges(B,K,ee){const ae=this._documents.getDocument(B),V=E.Position.to(K),se=await this._provider.provideLinkedEditingRanges(ae,V,ee);if(se&&Array.isArray(se.ranges))return{ranges:(0,I.coalesce)(se.ranges.map(E.Range.from)),wordPattern:se.wordPattern}}}class h{constructor(B,K){this._documents=B,this._provider=K}async provideReferences(B,K,ee,ae){const V=this._documents.getDocument(B),se=E.Position.to(K),fe=await this._provider.provideReferences(V,se,ee,ae);if(Array.isArray(fe))return fe.map(E.location.from)}}class b{constructor(B,K,ee,ae,V,se,fe){this._documents=B,this._commands=K,this._diagnostics=ee,this._provider=ae,this._logService=V,this._extension=se,this._apiDeprecation=fe,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(B,K,ee,ae){const V=this._documents.getDocument(B),se=y.Selection.isISelection(K)?E.Selection.to(K):E.Range.to(K),fe=[];for(const H of this._diagnostics.getDiagnostics(B))if(se.intersection(H.range)&&fe.push(H)>b._maxCodeActionsPerFile)break;const Ae={diagnostics:fe,only:ee.only?new T.CodeActionKind(ee.only):void 0,triggerKind:E.CodeActionTriggerKind.to(ee.trigger)},xe=await this._provider.provideCodeActions(V,se,Ae,ae);if(!(0,I.isNonEmptyArray)(xe)||ae.isCancellationRequested)return;const $e=this._cache.add(xe),ve=new n.DisposableStore;this._disposables.set($e,ve);const Xe=[];for(let H=0;H<xe.length;H++){const J=xe[H];!J||(b._isCommand(J)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Xe.push({_isSynthetic:!0,title:J.title,command:this._commands.toInternal(J,ve)})):(Ae.only&&(J.kind?Ae.only.contains(J.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action is of kind '${J.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Xe.push({cacheId:[$e,H],title:J.title,command:J.command&&this._commands.toInternal(J.command,ve),diagnostics:J.diagnostics&&J.diagnostics.map(E.Diagnostic.from),edit:J.edit&&E.WorkspaceEdit.from(J.edit),kind:J.kind&&J.kind.value,isPreferred:J.isPreferred,disabled:J.disabled?.reason})))}return{cacheId:$e,actions:Xe}}async resolveCodeAction(B,K){const[ee,ae]=B,V=this._cache.get(ee,ae);if(!V||b._isCommand(V)||!this._provider.resolveCodeAction)return;const se=await this._provider.resolveCodeAction(V,K)??V;return se?.edit?E.WorkspaceEdit.from(se.edit):void 0}releaseCodeActions(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}static _isCommand(B){return typeof B.command=="string"&&typeof B.title=="string"}}b._maxCodeActionsPerFile=1e3;class f{constructor(B,K){this._documents=B,this._provider=K}async provideDocumentFormattingEdits(B,K,ee){const ae=this._documents.getDocument(B),V=await this._provider.provideDocumentFormattingEdits(ae,K,ee);if(Array.isArray(V))return V.map(E.TextEdit.from)}}class F{constructor(B,K){this._documents=B,this._provider=K}async provideDocumentRangeFormattingEdits(B,K,ee,ae){const V=this._documents.getDocument(B),se=E.Range.to(K),fe=await this._provider.provideDocumentRangeFormattingEdits(V,se,ee,ae);if(Array.isArray(fe))return fe.map(E.TextEdit.from)}}class O{constructor(B,K){this._documents=B,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,K,ee,ae,V){const se=this._documents.getDocument(B),fe=E.Position.to(K),Ae=await this._provider.provideOnTypeFormattingEdits(se,fe,ee,ae,V);if(Array.isArray(Ae))return Ae.map(E.TextEdit.from)}}class q{constructor(B,K){this._provider=B,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(B,K){const ee=A.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols(B,K);if((0,I.isNonEmptyArray)(ae))for(const V of ae){if(!V)continue;if(!V.name){this._logService.warn("INVALID SymbolInformation, lacks name",V);continue}const se=A.IdObject.mixin(E.WorkspaceSymbol.from(V));this._symbolCache.set(se._id,V),ee.symbols.push(se)}return ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee}async resolveWorkspaceSymbol(B,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return B;const ee=this._symbolCache.get(B._id);if(ee){const ae=await this._provider.resolveWorkspaceSymbol(ee,K);return ae&&(0,M.mixin)(B,E.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(B){const K=this._resultCache.get(B);if(K){for(let[ee,ae]=K;ee<=ae;ee++)this._symbolCache.delete(ee);this._resultCache.delete(B)}}}class Q{constructor(B,K,ee){this._documents=B,this._provider=K,this._logService=ee}static supportsResolving(B){return typeof B.prepareRename=="function"}async provideRenameEdits(B,K,ee,ae){const V=this._documents.getDocument(B),se=E.Position.to(K);try{const fe=await this._provider.provideRenameEdits(V,se,ee,ae);return fe?E.WorkspaceEdit.from(fe):void 0}catch(fe){const Ae=Q._asMessage(fe);return Ae?{rejectReason:Ae,edits:void 0}:Promise.reject(fe)}}async resolveRenameLocation(B,K,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(B),V=E.Position.to(K);try{const se=await this._provider.prepareRename(ae,V,ee);let fe,Ae;if(T.Range.isRange(se)?(fe=se,Ae=ae.getText(se)):(0,t.isObject)(se)&&(fe=se.range,Ae=se.placeholder),!fe||!Ae)return;if(fe.start.line>V.line||fe.end.line<V.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(fe),text:Ae}}catch(se){const fe=Q._asMessage(se);return fe?{rejectReason:fe,range:void 0,text:void 0}:Promise.reject(se)}}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class ${constructor(B,K){this.resultId=B,this.tokens=K}}class z{constructor(B,K){this._documents=B,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(B,K,ee){const ae=this._documents.getDocument(B),V=K!==0?this._previousResults.get(K):null;let se=typeof V?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,V.resultId,ee):await this._provider.provideDocumentSemanticTokens(ae,ee);return V&&this._previousResults.delete(K),se?(se=z._fixProvidedSemanticTokens(se),this._send(z._convertToEdits(V,se),se)):null}async releaseDocumentSemanticColoring(B){this._previousResults.delete(B)}static _fixProvidedSemanticTokens(B){return z._isSemanticTokens(B)?z._isCorrectSemanticTokens(B)?B:new T.SemanticTokens(new Uint32Array(B.data),B.resultId):z._isSemanticTokensEdits(B)?z._isCorrectSemanticTokensEdits(B)?B:new T.SemanticTokensEdits(B.edits.map(K=>new T.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),B.resultId):B}static _isSemanticTokens(B){return B&&!!B.data}static _isCorrectSemanticTokens(B){return B.data instanceof Uint32Array}static _isSemanticTokensEdits(B){return B&&Array.isArray(B.edits)}static _isCorrectSemanticTokensEdits(B){for(const K of B.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(B,K){if(!z._isSemanticTokens(K)||!B||!B.tokens)return K;const ee=B.tokens,ae=ee.length,V=K.data,se=V.length;let fe=0;const Ae=Math.min(ae,se);for(;fe<Ae&&ee[fe]===V[fe];)fe++;if(fe===ae&&fe===se)return new T.SemanticTokensEdits([],K.resultId);let xe=0;const $e=Ae-fe;for(;xe<$e&&ee[ae-xe-1]===V[se-xe-1];)xe++;return new T.SemanticTokensEdits([{start:fe,deleteCount:ae-fe-xe,data:V.subarray(fe,se-xe)}],K.resultId)}_send(B,K){if(z._isSemanticTokens(B)){const ee=this._nextResultId++;return this._previousResults.set(ee,new $(B.resultId,B.data)),(0,d.encodeSemanticTokensDto)({id:ee,type:"full",data:B.data})}if(z._isSemanticTokensEdits(B)){const ee=this._nextResultId++;return z._isSemanticTokens(K)?this._previousResults.set(ee,new $(K.resultId,K.data)):this._previousResults.set(ee,new $(B.resultId)),(0,d.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(B.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class N{constructor(B,K){this._documents=B,this._provider=K}async provideDocumentRangeSemanticTokens(B,K,ee){const ae=this._documents.getDocument(B),V=await this._provider.provideDocumentRangeSemanticTokens(ae,E.Range.to(K),ee);return V?this._send(V):null}_send(B){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:B.data})}}e.DocumentRangeSemanticTokensAdapter=N;class W{constructor(B,K,ee,ae,V){this._documents=B,this._commands=K,this._provider=ee,this._apiDeprecation=ae,this._extension=V,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}async provideCompletionItems(B,K,ee,ae){const V=this._documents.getDocument(B),se=E.Position.to(K),fe=V.getWordRangeAtPosition(se)||new T.Range(se,se),Ae=fe.with({end:se}),xe=new p.StopWatch(!0),$e=await this._provider.provideCompletionItems(V,se,ae,E.CompletionContext.to(ee));if(!$e||ae.isCancellationRequested)return;const ve=Array.isArray($e)?new T.CompletionList($e):$e,Xe=W.supportsResolving(this._provider)?this._cache.add(ve.items):this._cache.add([]),H=new n.DisposableStore;this._disposables.set(Xe,H);const J=[],he={x:Xe,b:J,a:{replace:E.Range.from(fe),insert:E.Range.from(Ae)},c:ve.isIncomplete||void 0,d:xe.elapsed()};for(let Le=0;Le<ve.items.length;Le++){const Ve=ve.items[Le],tt=this._convertCompletionItem(Ve,[Xe,Le],Ae,fe);J.push(tt)}return he}async resolveCompletionItem(B,K){if(typeof this._provider.resolveCompletionItem!="function")return;const ee=this._cache.get(...B);if(!ee)return;const ae=await this._provider.resolveCompletionItem(ee,K);if(!!ae)return this._convertCompletionItem(ae,B)}releaseCompletionItems(B){this._disposables.get(B)?.dispose(),this._disposables.delete(B),this._cache.delete(B)}_convertCompletionItem(B,K,ee,ae){const V=this._disposables.get(K[0]);if(!V)throw Error("DisposableStore is missing...");const se={x:K,a:B.label,b:B.kind!==void 0?E.CompletionItemKind.from(B.kind):void 0,n:B.tags&&B.tags.map(E.CompletionItemTag.from),c:B.detail,d:typeof B.documentation=="undefined"?void 0:E.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters,l:B.additionalTextEdits&&B.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal(B.command,V)};B.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=B.textEdit.newText):typeof B.insertText=="string"?se.h=B.insertText:B.insertText instanceof T.SnippetString&&(se.h=B.insertText.value,se.i|=4);let fe;return B.textEdit?fe=B.textEdit.range:B.range&&(fe=B.range),T.Range.isRange(fe)?se.j=E.Range.from(fe):fe&&(!ee?.isEqual(fe.inserting)||!ae?.isEqual(fe.replacing))&&(se.j={insert:E.Range.from(fe.inserting),replace:E.Range.from(fe.replacing)}),se}}class j{constructor(B,K,ee){this._documents=B,this._provider=K,this._commands=ee,this._cache=new u.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(B,K,ee,ae){const V=this._documents.getDocument(B),se=E.Position.to(K),fe=await this._provider.provideInlineCompletionItems(V,se,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:E.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:ee.triggerKind},ae);if(!fe||ae.isCancellationRequested)return;const Ae=(0,t.isArray)(fe)?{items:fe}:fe,xe=this._cache.add(Ae.items);let $e;return{pid:xe,items:Ae.items.map((ve,Xe)=>{let H;return ve.command&&($e||($e=new n.DisposableStore,this._disposables.set(xe,$e)),H=this._commands.toInternal(ve.command,$e)),{text:ve.text,range:ve.range?E.Range.from(ve.range):void 0,command:H,idx:Xe}})}}disposeCompletions(B){this._cache.delete(B);const K=this._disposables.get(B);K&&K.clear(),this._disposables.delete(B)}handleDidShowCompletionItem(B,K){const ee=this._cache.get(B,K);ee&&Y.get(this._provider).fireOnDidShowCompletionItem({completionItem:ee})}}class Y{constructor(){this._onDidShowCompletionItemEmitter=new w.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(B){let K=Y.map.get(B);return K||(K=new Y,Y.map.set(B,K)),K}fireOnDidShowCompletionItem(B){this._onDidShowCompletionItemEmitter.fire(B)}}e.InlineCompletionController=Y,Y.map=new WeakMap;class de{constructor(B,K){this._documents=B,this._provider=K,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp(B,K,ee,ae){const V=this._documents.getDocument(B),se=E.Position.to(K),fe=this.reviveContext(ee),Ae=await this._provider.provideSignatureHelp(V,se,ae,fe);if(Ae){const xe=this._cache.add([Ae]);return{...E.SignatureHelp.from(Ae),id:xe}}}reviveContext(B){let K;if(B.activeSignatureHelp){const ee=E.SignatureHelp.to(B.activeSignatureHelp),ae=this._cache.get(B.activeSignatureHelp.id,0);ae?(K=ae,K.activeSignature=ee.activeSignature,K.activeParameter=ee.activeParameter):K=ee}return{...B,activeSignatureHelp:K}}releaseSignatureHelp(B){this._cache.delete(B)}}class G{constructor(B,K){this._documents=B,this._provider=K}async provideInlayHints(B,K,ee){const ae=this._documents.getDocument(B),V=await this._provider.provideInlayHints(ae,E.Range.to(K),ee);return V?{hints:V.map(E.InlayHint.from)}:void 0}}class ue{constructor(B,K){this._documents=B,this._provider=K,this._cache=new u.Cache("DocumentLink")}async provideLinks(B,K){const ee=this._documents.getDocument(B),ae=await this._provider.provideDocumentLinks(ee,K);if(!(!Array.isArray(ae)||ae.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(ue._validateLink).map(E.DocumentLink.from)};{const V=this._cache.add(ae),se={links:[],id:V};for(let fe=0;fe<ae.length;fe++){if(!ue._validateLink(ae[fe]))continue;const Ae=E.DocumentLink.from(ae[fe]);Ae.cacheId=[V,fe],se.links.push(Ae)}return se}}}static _validateLink(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,K){if(typeof this._provider.resolveDocumentLink!="function")return;const ee=this._cache.get(...B);if(!ee)return;const ae=await this._provider.resolveDocumentLink(ee,K);if(!(!ae||!ue._validateLink(ae)))return E.DocumentLink.from(ae)}releaseLinks(B){this._cache.delete(B)}}class oe{constructor(B,K){this._documents=B,this._provider=K}async provideColors(B,K){const ee=this._documents.getDocument(B),ae=await this._provider.provideDocumentColors(ee,K);return Array.isArray(ae)?ae.map(se=>({color:E.Color.from(se.color),range:E.Range.from(se.range)})):[]}async provideColorPresentations(B,K,ee){const ae=this._documents.getDocument(B),V=E.Range.to(K.range),se=E.Color.to(K.color),fe=await this._provider.provideColorPresentations(se,{document:ae,range:V},ee);if(!!Array.isArray(fe))return fe.map(E.ColorPresentation.from)}}class Ee{constructor(B,K){this._documents=B,this._provider=K}async provideFoldingRanges(B,K,ee){const ae=this._documents.getDocument(B),V=await this._provider.provideFoldingRanges(ae,K,ee);if(!!Array.isArray(V))return V.map(E.FoldingRange.from)}}class Te{constructor(B,K,ee){this._documents=B,this._provider=K,this._logService=ee}async provideSelectionRanges(B,K,ee){const ae=this._documents.getDocument(B),V=K.map(E.Position.to),se=await this._provider.provideSelectionRanges(ae,V,ee);if(!(0,I.isNonEmptyArray)(se))return[];if(se.length!==V.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const fe=[];for(let Ae=0;Ae<V.length;Ae++){const xe=[];fe.push(xe);let $e=V[Ae],ve=se[Ae];for(;;){if(!ve.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(xe.push(E.SelectionRange.from(ve)),!ve.parent)break;$e=ve.range,ve=ve.parent}}return fe}}class Re{constructor(B,K){this._documents=B,this._provider=K,this._idPool=new r.IdGenerator(""),this._cache=new Map}async prepareSession(B,K,ee){const ae=this._documents.getDocument(B),V=E.Position.to(K),se=await this._provider.prepareCallHierarchy(ae,V,ee);if(!se)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(se)?se.map(Ae=>this._cacheAndConvertItem(fe,Ae)):[this._cacheAndConvertItem(fe,se)]}async provideCallsTo(B,K,ee){const ae=this._itemFromCache(B,K);if(!ae)throw new Error("missing call hierarchy item");const V=await this._provider.provideCallHierarchyIncomingCalls(ae,ee);if(!!V)return V.map(se=>({from:this._cacheAndConvertItem(B,se.from),fromRanges:se.fromRanges.map(fe=>E.Range.from(fe))}))}async provideCallsFrom(B,K,ee){const ae=this._itemFromCache(B,K);if(!ae)throw new Error("missing call hierarchy item");const V=await this._provider.provideCallHierarchyOutgoingCalls(ae,ee);if(!!V)return V.map(se=>({to:this._cacheAndConvertItem(B,se.to),fromRanges:se.fromRanges.map(fe=>E.Range.from(fe))}))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,K){const ee=this._cache.get(B),ae=E.CallHierarchyItem.from(K,B,ee.size.toString(36));return ee.set(ae._itemId,K),ae}_itemFromCache(B,K){return this._cache.get(B)?.get(K)}}class Ne{constructor(B,K){this._documents=B,this._provider=K,this._idPool=new r.IdGenerator(""),this._cache=new Map}async prepareSession(B,K,ee){const ae=this._documents.getDocument(B),V=E.Position.to(K),se=await this._provider.prepareTypeHierarchy(ae,V,ee);if(!se)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(se)?se.map(Ae=>this._cacheAndConvertItem(fe,Ae)):[this._cacheAndConvertItem(fe,se)]}async provideSupertypes(B,K,ee){const ae=this._itemFromCache(B,K);if(!ae)throw new Error("missing type hierarchy item");const V=await this._provider.provideTypeHierarchySupertypes(ae,ee);if(!!V)return V.map(se=>this._cacheAndConvertItem(B,se))}async provideSubtypes(B,K,ee){const ae=this._itemFromCache(B,K);if(!ae)throw new Error("missing type hierarchy item");const V=await this._provider.provideTypeHierarchySubtypes(ae,ee);if(!!V)return V.map(se=>this._cacheAndConvertItem(B,se))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,K){const ee=this._cache.get(B),ae=E.TypeHierarchyItem.from(K,B,ee.size.toString(36));return ee.set(ae._itemId,K),ae}_itemFromCache(B,K){return this._cache.get(B)?.get(K)}}class Qe{constructor(B,K){this.adapter=B,this.extension=K}}class He{constructor(B,K,ee,ae,V,se,fe){this._adapter=new Map,this._uriTransformer=K,this._proxy=B.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=ae,this._diagnostics=V,this._logService=se,this._apiDeprecation=fe}_transformDocumentSelector(B){return(0,I.coalesce)((0,I.asArray)(B).map(K=>this._doTransformDocumentSelector(K)))}_doTransformDocumentSelector(B){if(typeof B=="string")return{$serialized:!0,language:B};if(B)return{$serialized:!0,language:B.language,scheme:this._transformScheme(B.scheme),pattern:typeof B.pattern=="undefined"?void 0:E.GlobPattern.from(B.pattern),exclusive:B.exclusive}}_transformScheme(B){return this._uriTransformer&&typeof B=="string"?this._uriTransformer.transformOutgoingScheme(B):B}_createDisposable(B){return new T.Disposable(()=>{this._adapter.delete(B),this._proxy.$unregister(B)})}_nextHandle(){return He._handlePool++}_withAdapter(B,K,ee,ae,V=!1){const se=this._adapter.get(B);if(!se)return Promise.resolve(ae);if(se.adapter instanceof K){let fe;se.extension&&(fe=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${K.name}'`));const Ae=ee(se.adapter,se.extension),xe=se.extension;return xe&&Promise.resolve(Ae).then(()=>this._logService.trace(`[${xe.identifier.value}] provider DONE after ${Date.now()-fe}ms`),$e=>{V&&$e instanceof k.CancellationError||(this._logService.error(`[${xe.identifier.value}] provider FAILED`),this._logService.error($e))}),Ae}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(B,K){const ee=this._nextHandle();return this._adapter.set(ee,new Qe(B,K)),ee}static _extLabel(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,K,ee,ae){const V=this._addNewAdapter(new l(this._documents,ee),B),se=ae&&ae.label||He._extLabel(B);return this._proxy.$registerDocumentSymbolProvider(V,this._transformDocumentSelector(K),se),this._createDisposable(V)}$provideDocumentSymbols(B,K,ee){return this._withAdapter(B,l,ae=>ae.provideDocumentSymbols(c.URI.revive(K),ee),void 0)}registerCodeLensProvider(B,K,ee){const ae=this._nextHandle(),V=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new v(this._documents,this._commands.converter,ee),B)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(K),V);let se=this._createDisposable(ae);if(V!==void 0){const fe=ee.onDidChangeCodeLenses(Ae=>this._proxy.$emitCodeLensEvent(V));se=T.Disposable.from(se,fe)}return se}$provideCodeLenses(B,K,ee){return this._withAdapter(B,v,ae=>ae.provideCodeLenses(c.URI.revive(K),ee),void 0)}$resolveCodeLens(B,K,ee){return this._withAdapter(B,v,ae=>ae.resolveCodeLens(K,ee),void 0)}$releaseCodeLenses(B,K){this._withAdapter(B,v,ee=>Promise.resolve(ee.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(B,K,ee){const ae=this._addNewAdapter(new i(this._documents,ee),B);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDefinition(B,K,ee,ae){return this._withAdapter(B,i,V=>V.provideDefinition(c.URI.revive(K),ee,ae),[])}registerDeclarationProvider(B,K,ee){const ae=this._addNewAdapter(new s(this._documents,ee),B);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDeclaration(B,K,ee,ae){return this._withAdapter(B,s,V=>V.provideDeclaration(c.URI.revive(K),ee,ae),[])}registerImplementationProvider(B,K,ee){const ae=this._addNewAdapter(new a(this._documents,ee),B);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideImplementation(B,K,ee,ae){return this._withAdapter(B,a,V=>V.provideImplementation(c.URI.revive(K),ee,ae),[])}registerTypeDefinitionProvider(B,K,ee){const ae=this._addNewAdapter(new o(this._documents,ee),B);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideTypeDefinition(B,K,ee,ae){return this._withAdapter(B,o,V=>V.provideTypeDefinition(c.URI.revive(K),ee,ae),[])}registerHoverProvider(B,K,ee,ae){const V=this._addNewAdapter(new _(this._documents,ee),B);return this._proxy.$registerHoverProvider(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideHover(B,K,ee,ae){return this._withAdapter(B,_,V=>V.provideHover(c.URI.revive(K),ee,ae),void 0)}registerEvaluatableExpressionProvider(B,K,ee,ae){const V=this._addNewAdapter(new m(this._documents,ee),B);return this._proxy.$registerEvaluatableExpressionProvider(V,this._transformDocumentSelector(K)),this._createDisposable(V)}$provideEvaluatableExpression(B,K,ee,ae){return this._withAdapter(B,m,V=>V.provideEvaluatableExpression(c.URI.revive(K),ee,ae),void 0)}registerInlineValuesProvider(B,K,ee,ae){const V=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new g(this._documents,ee),B);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(K),V);let fe=this._createDisposable(se);if(V!==void 0){const Ae=ee.onDidChangeInlineValues(xe=>this._proxy.$emitInlineValuesEvent(V));fe=T.Disposable.from(fe,Ae)}return fe}$provideInlineValues(B,K,ee,ae,V){return this._withAdapter(B,g,se=>se.provideInlineValues(c.URI.revive(K),ee,ae,V),void 0)}registerDocumentHighlightProvider(B,K,ee){const ae=this._addNewAdapter(new C(this._documents,ee),B);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDocumentHighlights(B,K,ee,ae){return this._withAdapter(B,C,V=>V.provideDocumentHighlights(c.URI.revive(K),ee,ae),void 0)}registerLinkedEditingRangeProvider(B,K,ee){const ae=this._addNewAdapter(new R(this._documents,ee),B);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideLinkedEditingRanges(B,K,ee,ae){return this._withAdapter(B,R,async V=>{const se=await V.provideLinkedEditingRanges(c.URI.revive(K),ee,ae);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?He._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider(B,K,ee){const ae=this._addNewAdapter(new h(this._documents,ee),B);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideReferences(B,K,ee,ae,V){return this._withAdapter(B,h,se=>se.provideReferences(c.URI.revive(K),ee,ae,V),void 0)}registerCodeActionProvider(B,K,ee,ae){const V=new n.DisposableStore,se=this._addNewAdapter(new b(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,B,this._apiDeprecation),B);return this._proxy.$registerQuickFixSupport(se,this._transformDocumentSelector(K),{providedKinds:ae?.providedCodeActionKinds?.map(fe=>fe.value),documentation:ae?.documentation?.map(fe=>({kind:fe.kind.value,command:this._commands.converter.toInternal(fe.command,V)}))},He._extLabel(B),Boolean(ee.resolveCodeAction)),V.add(this._createDisposable(se)),V}$provideCodeActions(B,K,ee,ae,V){return this._withAdapter(B,b,se=>se.provideCodeActions(c.URI.revive(K),ee,ae,V),void 0)}$resolveCodeAction(B,K,ee){return this._withAdapter(B,b,ae=>ae.resolveCodeAction(K,ee),void 0)}$releaseCodeActions(B,K){this._withAdapter(B,b,ee=>Promise.resolve(ee.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(B,K,ee){const ae=this._addNewAdapter(new f(this._documents,ee),B);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(K),B.identifier,B.displayName||B.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(B,K,ee,ae){return this._withAdapter(B,f,V=>V.provideDocumentFormattingEdits(c.URI.revive(K),ee,ae),void 0)}registerDocumentRangeFormattingEditProvider(B,K,ee){const ae=this._addNewAdapter(new F(this._documents,ee),B);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(K),B.identifier,B.displayName||B.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(B,K,ee,ae,V){return this._withAdapter(B,F,se=>se.provideDocumentRangeFormattingEdits(c.URI.revive(K),ee,ae,V),void 0)}registerOnTypeFormattingEditProvider(B,K,ee,ae){const V=this._addNewAdapter(new O(this._documents,ee),B);return this._proxy.$registerOnTypeFormattingSupport(V,this._transformDocumentSelector(K),ae,B.identifier),this._createDisposable(V)}$provideOnTypeFormattingEdits(B,K,ee,ae,V,se){return this._withAdapter(B,O,fe=>fe.provideOnTypeFormattingEdits(c.URI.revive(K),ee,ae,V,se),void 0)}registerWorkspaceSymbolProvider(B,K){const ee=this._addNewAdapter(new q(K,this._logService),B);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(B,K,ee){return this._withAdapter(B,q,ae=>ae.provideWorkspaceSymbols(K,ee),{symbols:[]})}$resolveWorkspaceSymbol(B,K,ee){return this._withAdapter(B,q,ae=>ae.resolveWorkspaceSymbol(K,ee),void 0)}$releaseWorkspaceSymbols(B,K){this._withAdapter(B,q,ee=>ee.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(B,K,ee){const ae=this._addNewAdapter(new Q(this._documents,ee,this._logService),B);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(K),Q.supportsResolving(ee)),this._createDisposable(ae)}$provideRenameEdits(B,K,ee,ae,V){return this._withAdapter(B,Q,se=>se.provideRenameEdits(c.URI.revive(K),ee,ae,V),void 0)}$resolveRenameLocation(B,K,ee,ae){return this._withAdapter(B,Q,V=>V.resolveRenameLocation(c.URI.revive(K),ee,ae),void 0)}registerDocumentSemanticTokensProvider(B,K,ee,ae){const V=this._nextHandle(),se=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(V,new Qe(new z(this._documents,ee),B)),this._proxy.$registerDocumentSemanticTokensProvider(V,this._transformDocumentSelector(K),ae,se);let fe=this._createDisposable(V);if(se){const Ae=ee.onDidChangeSemanticTokens(xe=>this._proxy.$emitDocumentSemanticTokensEvent(se));fe=T.Disposable.from(fe,Ae)}return fe}$provideDocumentSemanticTokens(B,K,ee,ae){return this._withAdapter(B,z,V=>V.provideDocumentSemanticTokens(c.URI.revive(K),ee,ae),null,!0)}$releaseDocumentSemanticTokens(B,K){this._withAdapter(B,z,ee=>ee.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(B,K,ee,ae){const V=this._addNewAdapter(new N(this._documents,ee),B);return this._proxy.$registerDocumentRangeSemanticTokensProvider(V,this._transformDocumentSelector(K),ae),this._createDisposable(V)}$provideDocumentRangeSemanticTokens(B,K,ee,ae){return this._withAdapter(B,N,V=>V.provideDocumentRangeSemanticTokens(c.URI.revive(K),ee,ae),null,!0)}registerCompletionItemProvider(B,K,ee,ae){const V=this._addNewAdapter(new W(this._documents,this._commands.converter,ee,this._apiDeprecation,B),B);return this._proxy.$registerSuggestSupport(V,this._transformDocumentSelector(K),ae,W.supportsResolving(ee),`${B.identifier.value}(${ae.join("")})`),this._createDisposable(V)}$provideCompletionItems(B,K,ee,ae,V){return this._withAdapter(B,W,se=>se.provideCompletionItems(c.URI.revive(K),ee,ae,V),void 0)}$resolveCompletionItem(B,K,ee){return this._withAdapter(B,W,ae=>ae.resolveCompletionItem(K,ee),void 0)}$releaseCompletionItems(B,K){this._withAdapter(B,W,ee=>ee.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider(B,K,ee){const ae=this._addNewAdapter(new j(this._documents,ee,this._commands.converter),B);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideInlineCompletions(B,K,ee,ae,V){return this._withAdapter(B,j,se=>se.provideInlineCompletions(c.URI.revive(K),ee,ae,V),void 0)}$handleInlineCompletionDidShow(B,K,ee){this._withAdapter(B,j,async ae=>{ae.handleDidShowCompletionItem(K,ee)},void 0)}$freeInlineCompletionsList(B,K){this._withAdapter(B,j,async ee=>{ee.disposeCompletions(K)},void 0)}registerSignatureHelpProvider(B,K,ee,ae){const V=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,se=this._addNewAdapter(new de(this._documents,ee),B);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(K),V),this._createDisposable(se)}$provideSignatureHelp(B,K,ee,ae,V){return this._withAdapter(B,de,se=>se.provideSignatureHelp(c.URI.revive(K),ee,ae,V),void 0)}$releaseSignatureHelp(B,K){this._withAdapter(B,de,ee=>ee.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider(B,K,ee){const ae=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,V=this._addNewAdapter(new G(this._documents,ee),B);this._proxy.$registerInlayHintsProvider(V,this._transformDocumentSelector(K),ae);let se=this._createDisposable(V);if(ae!==void 0){const fe=ee.onDidChangeInlayHints(Ae=>this._proxy.$emitInlayHintsEvent(ae));se=T.Disposable.from(se,fe)}return se}$provideInlayHints(B,K,ee,ae){return this._withAdapter(B,G,V=>V.provideInlayHints(c.URI.revive(K),ee,ae),void 0)}registerDocumentLinkProvider(B,K,ee){const ae=this._addNewAdapter(new ue(this._documents,ee),B);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(K),typeof ee.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(B,K,ee){return this._withAdapter(B,ue,ae=>ae.provideLinks(c.URI.revive(K),ee),void 0)}$resolveDocumentLink(B,K,ee){return this._withAdapter(B,ue,ae=>ae.resolveLink(K,ee),void 0)}$releaseDocumentLinks(B,K){this._withAdapter(B,ue,ee=>ee.releaseLinks(K),void 0)}registerColorProvider(B,K,ee){const ae=this._addNewAdapter(new oe(this._documents,ee),B);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDocumentColors(B,K,ee){return this._withAdapter(B,oe,ae=>ae.provideColors(c.URI.revive(K),ee),[])}$provideColorPresentations(B,K,ee,ae){return this._withAdapter(B,oe,V=>V.provideColorPresentations(c.URI.revive(K),ee,ae),void 0)}registerFoldingRangeProvider(B,K,ee){const ae=this._nextHandle(),V=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new Ee(this._documents,ee),B)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(K),V);let se=this._createDisposable(ae);if(V!==void 0){const fe=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(V));se=T.Disposable.from(se,fe)}return se}$provideFoldingRanges(B,K,ee,ae){return this._withAdapter(B,Ee,V=>V.provideFoldingRanges(c.URI.revive(K),ee,ae),void 0)}registerSelectionRangeProvider(B,K,ee){const ae=this._addNewAdapter(new Te(this._documents,ee,this._logService),B);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideSelectionRanges(B,K,ee,ae){return this._withAdapter(B,Te,V=>V.provideSelectionRanges(c.URI.revive(K),ee,ae),[])}registerCallHierarchyProvider(B,K,ee){const ae=this._addNewAdapter(new Re(this._documents,ee),B);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$prepareCallHierarchy(B,K,ee,ae){return this._withAdapter(B,Re,V=>Promise.resolve(V.prepareSession(c.URI.revive(K),ee,ae)),void 0)}$provideCallHierarchyIncomingCalls(B,K,ee,ae){return this._withAdapter(B,Re,V=>V.provideCallsTo(K,ee,ae),void 0)}$provideCallHierarchyOutgoingCalls(B,K,ee,ae){return this._withAdapter(B,Re,V=>V.provideCallsFrom(K,ee,ae),void 0)}$releaseCallHierarchy(B,K){this._withAdapter(B,Re,ee=>Promise.resolve(ee.releaseSession(K)),void 0)}registerTypeHierarchyProvider(B,K,ee){const ae=this._addNewAdapter(new Ne(this._documents,ee),B);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$prepareTypeHierarchy(B,K,ee,ae){return this._withAdapter(B,Ne,V=>Promise.resolve(V.prepareSession(c.URI.revive(K),ee,ae)),void 0)}$provideTypeHierarchySupertypes(B,K,ee,ae){return this._withAdapter(B,Ne,V=>V.provideSupertypes(K,ee,ae),void 0)}$provideTypeHierarchySubtypes(B,K,ee,ae){return this._withAdapter(B,Ne,V=>V.provideSubtypes(K,ee,ae),void 0)}$releaseTypeHierarchy(B,K){this._withAdapter(B,Ne,ee=>Promise.resolve(ee.releaseSession(K)),void 0)}static _serializeRegExp(B){return{pattern:B.source,flags:(0,P.regExpFlags)(B)}}static _serializeIndentationRule(B){return{decreaseIndentPattern:He._serializeRegExp(B.decreaseIndentPattern),increaseIndentPattern:He._serializeRegExp(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?He._serializeRegExp(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?He._serializeRegExp(B.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(B){return{beforeText:He._serializeRegExp(B.beforeText),afterText:B.afterText?He._serializeRegExp(B.afterText):void 0,previousLineText:B.previousLineText?He._serializeRegExp(B.previousLineText):void 0,action:B.action}}static _serializeOnEnterRules(B){return B.map(He._serializeOnEnterRule)}setLanguageConfiguration(B,K,ee){let{wordPattern:ae}=ee;if(ae&&(0,P.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(K,ae):this._documents.setWordDefinitionFor(K,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const V=this._nextHandle(),se={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?He._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?He._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?He._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(V,K,se),this._createDisposable(V)}$setWordDefinitions(B){for(const K of B)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=He,He._handlePool=0}),define(we[195],be([0,1,5,8,6,35,13]),function(re,e,c,M,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class P{constructor(I,t){this._handlePool=0,this._proxy=I.getProxy(c.MainContext.MainThreadLanguages),this._documents=t}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(I,t){await this._proxy.$changeLanguage(I,t);const y=this._documents.getDocumentData(I);if(!y)throw new Error(`document '${I.toString}' NOT found`);return y.document}async tokenAtPosition(I,t){const y=I.version,n=M.Position.from(t),d=await this._proxy.$tokensAtPosition(I.uri,n),r={type:E.StandardTokenType.Other,range:I.getWordRangeAtPosition(t)??new E.Range(t.line,t.character,t.line,t.character)};if(!d)return r;const u={range:M.Range.to(d.range),type:M.TokenType.to(d.type)};return!u.range.contains(t)||y!==I.version?r:u}createLanguageStatusItem(I){const t=this._handlePool++,y=this._proxy,n={selector:I,text:"",detail:"",severity:E.LanguageStatusSeverity.Information};let d;const r=()=>{d?.dispose(),d=(0,A.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(t,{selector:n.selector,text:n.text,message:typeof n.detail=="string"?n.detail:M.MarkdownString.from(n.detail),severity:n.severity===E.LanguageStatusSeverity.Error?T.default.Error:n.severity===E.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info})},0)},u={get selector(){return n.selector},set selector(p){n.selector=p,r()},get text(){return n.text},set text(p){n.text=p,r()},get detail(){return n.detail},set detail(p){n.detail=p,r()},get severity(){return n.severity},set severity(p){n.severity=p,r()},dispose(){d?.dispose(),y.$removeLanguageStatus(t)}};return r(),u}}e.ExtHostLanguages=P}),define(we[196],be([0,1,5,14,30]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(P){return P&&P.title}let A=class{constructor(S,I){this._logService=I,this._proxy=S.getProxy(c.MainContext.MainThreadMessageService)}showMessage(S,I,t,y,n){const d={extension:S};let r;typeof y=="string"||T(y)?r=[y,...n]:(d.modal=y?.modal,d.useCustom=y?.useCustom,d.detail=y?.detail,r=n),d.useCustom&&(0,E.checkProposedApiEnabled)(S);const u=[];for(let p=0;p<r.length;p++){const k=r[p];if(typeof k=="string")u.push({title:k,handle:p,isCloseAffordance:!1});else if(typeof k=="object"){let{title:w,isCloseAffordance:l}=k;u.push({title:w,isCloseAffordance:!!l,handle:p})}else this._logService.warn("Invalid message item:",k)}return this._proxy.$showMessage(I,t,d,u).then(p=>{if(typeof p=="number")return r[p]})}};A=Ue([ze(1,M.ILogService)],A),e.ExtHostMessageService=A}),define(we[197],be([0,1,23,3,57,7,20,9,10,2,62,5,8,6,46,171,93]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class k{constructor(l,v,D,i,s){this._textDocumentsAndEditors=D,this._textDocuments=i,this._extensionStoragePaths=s,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=v.converter,v.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===12){const o=a.notebookEditor?.notebookUri,_=a.cell.handle,g=this._documents.get(o)?.getCell(_);if(g)return g.apiCell}return a}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const v=this._editors.get(l);if(!v)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return v}getIdByEditor(l){for(const[v,D]of this._editors)if(D.apiEditor===l)return v}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,v){const D=this._documents.get(l);if(!D&&!v)throw new Error(`NO notebook document for '${l}'`);return D}_getProviderData(l){const v=this._notebookContentProviders.get(l);if(!v)throw new Error(`NO provider for '${l}'`);return v}registerNotebookContentProvider(l,v,D,i,s){if((0,P.isFalsyOrWhitespace)(v))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(v))throw new Error(`Notebook provider for '${v}' already registered`);this._notebookContentProviders.set(v,{extension:l,provider:D});let a;return D.onDidChangeNotebookContentOptions&&(a=D.onDidChangeNotebookContentOptions(()=>{const o=n.NotebookDocumentContentOptions.from(D.options);this._notebookProxy.$updateNotebookProviderOptions(v,o)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},v,n.NotebookDocumentContentOptions.from(i),k._convertNotebookRegistrationData(l,s)),new d.Disposable(()=>{a?.dispose(),this._notebookContentProviders.delete(v),this._notebookProxy.$unregisterNotebookProvider(v)})}static _convertNotebookRegistrationData(l,v){if(!v)return;const D=v.filenamePattern.map(i=>n.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(v.filenamePattern&&!D){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:v.displayName,filenamePattern:D,exclusive:v.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,v,D){const i=k._notebookStatusBarItemProviderHandlePool++,s=typeof D.onDidChangeCellStatusBarItems=="function"?k._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,D),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,s,v);let a;return s!==void 0&&(a=D.onDidChangeCellStatusBarItems(o=>this._notebookProxy.$emitCellStatusBarEvent(s))),new d.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,s),a&&a.dispose()})}async createNotebookDocument(l){const v=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&n.NotebookData.from(l.content)});return I.URI.revive(v)}async openNotebookDocument(l){const v=this._documents.get(l);if(v)return v.apiNotebook;const D=await this._notebookDocumentsProxy.$tryOpenNotebook(l),i=this._documents.get(I.URI.revive(D));return(0,S.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(l,v){I.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let D;typeof v=="object"?D={position:n.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(n.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:D={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,D),s=i&&this._editors.get(i)?.apiEditor;if(s)return s;throw i?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,v,D,i){const s=this._notebookStatusBarItemProviders.get(l),a=I.URI.revive(v),o=this._documents.get(a);if(!o||!s)return;const _=o.getCellFromIndex(D);if(!_)return;const m=await s.provideCellStatusBarItems(_.apiCell,i);if(!m)return;const g=new T.DisposableStore,C=this._statusBarCache.add([g]),h=(Array.isArray(m)?m:[m]).map(b=>n.NotebookStatusBarItem.from(b,this._commandsConverter,g));return{cacheId:C,items:h}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,v,D,i,s){if((0,P.isFalsyOrWhitespace)(v))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,D),this._notebookProxy.$registerNotebookSerializer(a,{id:l.identifier,location:l.extensionLocation},v,n.NotebookDocumentContentOptions.from(i),k._convertNotebookRegistrationData(l,s)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(l,v,D){const i=this._notebookSerializer.get(l);if(!i)throw new Error("NO serializer found");const s=await i.deserializeNotebook(v.buffer,D);return new r.SerializableObjectWithBuffers(n.NotebookData.from(s))}async $notebookToData(l,v,D){const i=this._notebookSerializer.get(l);if(!i)throw new Error("NO serializer found");const s=await i.serializeNotebook(n.NotebookData.to(v.value),D);return c.VSBuffer.wrap(s)}async $openNotebook(l,v,D,i,s){const{provider:a}=this._getProviderData(l),o=await a.openNotebook(I.URI.revive(v),{backupId:D,untitledDocumentData:i?.buffer},s);return new r.SerializableObjectWithBuffers({metadata:o.metadata??Object.create(null),cells:o.cells.map(n.NotebookCellData.from)})}async $saveNotebook(l,v,D){const i=this.getNotebookDocument(I.URI.revive(v)),{provider:s}=this._getProviderData(l);return await s.saveNotebook(i.apiNotebook,D),!0}async $saveNotebookAs(l,v,D,i){const s=this.getNotebookDocument(I.URI.revive(v)),{provider:a}=this._getProviderData(l);return await a.saveNotebookAs(I.URI.revive(D),s.apiNotebook,i),!0}async $backupNotebook(l,v,D){const i=this.getNotebookDocument(I.URI.revive(v)),s=this._getProviderData(l),a=this._extensionStoragePaths.workspaceValue(s.extension)??this._extensionStoragePaths.globalValue(s.extension),o=String((0,E.hash)([i.uri.toString(),this._backupIdPool++])),_=I.URI.joinPath(a,o),m=await s.provider.backupNotebook(i.apiNotebook,{destination:_},D);return i.updateBackup(m),m.id}_createExtHostEditor(l,v,D){if(this._editors.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const i=new p.ExtHostNotebookEditor(v,this._notebookEditorsProxy,l,D.visibleRanges.map(n.NotebookRange.to),D.selections.map(n.NotebookRange.to),typeof D.viewColumn=="number"?n.ViewColumn.to(D.viewColumn):void 0);this._editors.set(v,i)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const D of l.value.removedDocuments){const i=I.URI.revive(D),s=this._documents.get(i);s&&(s.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(a=>a.document.uri)}),this._onDidCloseNotebookDocument.fire(s.apiNotebook));for(const a of this._editors.values())a.notebookData.uri.toString()===i.toString()&&this._editors.delete(a.id)}if(l.value.addedDocuments){const D=[];for(const i of l.value.addedDocuments){const s=I.URI.revive(i.uri);if(this._documents.has(s))throw new Error(`adding EXISTING notebook ${s} `);const a=this,o=new u.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(_){a._onDidChangeNotebookCells.fire(_)},emitCellOutputsChange(_){a._onDidChangeCellOutputs.fire(_)},emitCellMetadataChange(_){a._onDidChangeCellMetadata.fire(_)},emitCellExecutionStateChange(_){a._onDidChangeCellExecutionState.fire(_)}},s,i);D.push(...i.cells.map(_=>u.ExtHostCell.asModelAddData(o.apiNotebook,_))),this._documents.get(s)?.dispose(),this._documents.set(s,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:D}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(l.value.addedEditors)for(const D of l.value.addedEditors){if(this._editors.has(D.id))return;const i=I.URI.revive(D.documentUri),s=this._documents.get(i);s&&this._createExtHostEditor(s,D.id,D)}const v=[];if(l.value.removedEditors)for(const D of l.value.removedEditors){const i=this._editors.get(D);i&&(this._editors.delete(D),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),v.push(i))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const D=new Set;this._visibleNotebookEditors.forEach(i=>D.add(i.id));for(const i of this._editors.values()){const s=D.has(i.id);i._acceptVisibility(s)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=k,k._notebookStatusBarItemProviderHandlePool=0}),define(we[198],be([0,1,3,52,14,5,12,8]),function(re,e,c,M,E,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(y,n){const d=S._Keys.nextId();y.$registerNotebookEditorDecorationType(d,P.NotebookDecorationRenderOptions.from(n)),this.value={key:d,dispose(){y.$removeNotebookEditorDecorationType(d)}}}}S._Keys=new M.IdGenerator("NotebookEditorDecorationType");let I=class{constructor(y,n,d){this._logService=y,this._extHostRpc=n,this._notebooksAndEditors=d,this._onDidChangeNotebookEditorSelection=new c.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new c.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(y){return new S(this._extHostRpc.getProxy(T.MainContext.MainThreadNotebookEditors),y).value}$acceptEditorPropertiesChanged(y,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,n);const d=this._notebooksAndEditors.getEditorById(y);n.visibleRanges&&d._acceptVisibleRanges(n.visibleRanges.ranges.map(P.NotebookRange.to)),n.selections&&d._acceptSelections(n.selections.selections.map(P.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:d.apiEditor,visibleRanges:d.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:d.apiEditor,selections:d.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const n in y)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(P.ViewColumn.to(y[n]))}};I=Ue([ze(0,E.ILogService),ze(1,A.IExtHostRpcService)],I),e.ExtHostNotebookEditors=I}),define(we[199],be([0,1,16,13,21,3,7,20,2,25,14,5,8,6,67,164,30,46]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r,u,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(s,a,o,_){this._initData=a,this._extHostNotebook=o,this._logService=_,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=s.getProxy(y.MainContext.MainThreadNotebookKernels)}createNotebookController(s,a,o,_,m,g){for(let Y of this._kernelData.values())if(Y.controller.id===a&&I.ExtensionIdentifier.equals(s.identifier,Y.extensionId))throw new Error(`notebook controller with id '${a}' ALREADY exist`);const C=this._handlePool++,R=this;this._logService.trace(`NotebookController[${C}], CREATED by ${s.identifier.value}, ${a}`);const h=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${s.identifier}'`);let b=!1;const f=new A.DisposableStore,F=new T.Emitter,O=new T.Emitter,q={id:`${s.identifier.value}/${a}`,notebookType:o,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:_||s.identifier.value,preloads:g?g.map(n.NotebookRendererScript.from):[]};let Q=m??h,$;this._proxy.$addKernel(C,q).catch(Y=>{console.log(Y),b=!0});let z=0;const N=()=>{if(b)return;const Y=++z;Promise.resolve().then(()=>{Y===z&&this._proxy.$updateKernel(C,q)})},W=new P.ResourceMap,j={get id(){return a},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return q.label},set label(Y){q.label=Y??s.displayName??s.name,N()},get detail(){return q.detail??""},set detail(Y){q.detail=Y,N()},get description(){return q.description??""},set description(Y){q.description=Y,N()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(Y){q.supportedLanguages=Y,N()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(Y){q.supportsExecutionOrder=Y,N()},get rendererScripts(){return q.preloads?q.preloads.map(n.NotebookRendererScript.to):[]},get executeHandler(){return Q},set executeHandler(Y){Q=Y??h},get interruptHandler(){return $},set interruptHandler(Y){$=Y,q.supportsInterrupt=Boolean(Y),N()},createNotebookCellExecution(Y){if(b)throw new Error("notebook controller is DISPOSED");if(!W.has(Y.notebook.uri))throw R._logService.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(W.keys()).map(de=>de.toString())),new Error(`notebook controller is NOT associated to notebook: ${Y.notebook.uri.toString()}`);return R._createNotebookCellExecution(Y)},dispose:()=>{b||(this._logService.trace(`NotebookController[${C}], DISPOSED`),b=!0,this._kernelData.delete(C),f.dispose(),F.dispose(),O.dispose(),this._proxy.$removeKernel(C))},updateNotebookAffinity(Y,de){R._proxy.$updateNotebookPriority(C,Y.uri,de)},onDidReceiveMessage:O.event,postMessage(Y,de){return(0,p.checkProposedApiEnabled)(s),R._proxy.$postMessage(C,de&&R._extHostNotebook.getIdByEditor(de),Y)},asWebviewUri(Y){return(0,p.checkProposedApiEnabled)(s),(0,r.asWebviewUri)(Y,R._initData.remote)}};return this._kernelData.set(C,{extensionId:s.identifier,controller:j,onDidReceiveMessage:O,onDidChangeSelection:F,associatedNotebooks:W}),j}$acceptNotebookAssociation(s,a,o){const _=this._kernelData.get(s);if(_){const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(a));o?_.associatedNotebooks.set(m.uri,!0):_.associatedNotebooks.delete(m.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,m.uri.toString(),o),_.onDidChangeSelection.fire({selected:o,notebook:m.apiNotebook})}}async $executeCells(s,a,o){const _=this._kernelData.get(s);if(!_)return;const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(a)),g=[];for(let C of o){const R=m.getCell(C);R&&g.push(R.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,m.uri.toString(),g.length),await _.controller.executeHandler.call(_.controller,g,m.apiNotebook,_.controller)}catch(C){this._logService.error(`NotebookController[${s}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(s,a,o){const _=this._kernelData.get(s);if(!_)return;const m=this._extHostNotebook.getNotebookDocument(S.URI.revive(a));if(_.controller.interruptHandler)await _.controller.interruptHandler.call(_.controller,m.apiNotebook);else for(let g of o){const C=m.getCell(g);C&&this._activeExecutions.get(C.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,a,o){const _=this._kernelData.get(s);if(!_)return;const m=this._extHostNotebook.getEditorById(a);_.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:o}))}_createNotebookCellExecution(s){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const _=new v(o.notebook,o,this._proxy);this._activeExecutions.set(o.uri,_);const m=_.onDidChangeState(()=>{_.state===l.Resolved&&(_.dispose(),m.dispose(),this._activeExecutions.delete(o.uri))});return _.asApiObject()}};w=Ue([ze(3,t.ILogService)],w),e.ExtHostNotebookKernels=w;var l;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(l||(l={}));class v extends A.Disposable{constructor(s,a,o){super();this._document=s,this._cell=a,this._proxy=o,this._handle=v.HANDLE++,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new D(10,_=>this.update(_)),this._executionOrder=a.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const a=Array.isArray(s)?s:[s];return this._proxy.$updateExecutions(new k.SerializableObjectWithBuffers(a))}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(s){let a=this._cell;if(s&&(a=this._document.getCellFromApiCell(s)),!a)throw new Error("INVALID cell");return a.handle}validateAndConvertOutputs(s){return s.map(a=>{const o=d.NotebookCellOutput.ensureUniqueMimeTypes(a.items,!0);return o===a.items?n.NotebookCellOutput.from(a):n.NotebookCellOutput.from({items:o,id:a.id,metadata:a.metadata})})}async updateOutputs(s,a,o){const _=this.cellIndexToHandle(a),m=this.validateAndConvertOutputs((0,c.asArray)(s));return this.updateSoon({editType:u.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:_,append:o,outputs:m})}async updateOutputItems(s,a,o){return s=d.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(s),!0),this.updateSoon({editType:u.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:s.map(n.NotebookCellOutputItem.from),outputId:a.id,append:o})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(o){s._executionOrder=o,s.update([{editType:u.CellExecutionUpdateType.ExecutionState,executionHandle:s._handle,executionOrder:s._executionOrder}])},start(o){if(s._state===l.Resolved||s._state===l.Started)throw new Error("Cannot call start again");s._state=l.Started,s._onDidChangeState.fire(),s.update({editType:u.CellExecutionUpdateType.ExecutionState,executionHandle:s._handle,runStartTime:o})},end(o,_){if(s._state===l.Resolved)throw new Error("Cannot call resolve twice");s._state=l.Resolved,s._onDidChangeState.fire(),s.updateSoon({editType:u.CellExecutionUpdateType.Complete,executionHandle:s._handle,runEndTime:_,lastRunSuccess:o}),s._collector.flush(),s._proxy.$removeExecution(s._handle)},clearOutput(o){return s.verifyStateForOutput(),s.updateOutputs([],o,!1)},appendOutput(o,_){return s.verifyStateForOutput(),s.updateOutputs(o,_,!0)},replaceOutput(o,_){return s.verifyStateForOutput(),s.updateOutputs(o,_,!1)},appendOutputItems(o,_){return s.verifyStateForOutput(),s.updateOutputItems(o,_,!0)},replaceOutputItems(o,_){return s.verifyStateForOutput(),s.updateOutputItems(o,_,!1)}})}}v.HANDLE=0;class D{constructor(s,a){this.delay=s,this.callback=a,this.batch=[],this.startedTimer=Date.now()}addItem(s){return this.batch.push(s),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const s=this.currentDeferred;this.currentDeferred=void 0;const a=this.batch;return this.batch=[],this.callback(a).finally(()=>s.complete())}}}),define(we[200],be([0,1,3,5,93]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(P,S){this._extHostNotebook=S,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,S,I){const t=this._extHostNotebook.getEditorById(P);this._rendererMessageEmitters.get(S)?.fire({editor:t.apiEditor,message:I})}createRendererMessaging(P,S){if(!P.contributes?.notebookRenderer?.some(n=>n.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);const I=!!P.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(n,d,r)=>{const u=I?n:p=>{const k={};t.set(k,p.editor),n({editor:k,message:p.message})};return this.getOrCreateEmitterFor(S).event(u,d,r)},postMessage:(n,d)=>{E.ExtHostNotebookEditor.apiEditorsToExtHost.has(n)&&([n,d]=[d,n]);const r=I?d:t.get(d),u=r&&E.ExtHostNotebookEditor.apiEditorsToExtHost.get(r);return this.proxy.$postMessage(u?.id,S,n)}}}getOrCreateEmitterFor(P){let S=this._rendererMessageEmitters.get(P);return S||(S=new c.Emitter({onLastListenerRemove:()=>{S?.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,S),S)}}e.ExtHostNotebookRenderers=T}),define(we[96],be([0,1,5,3,7,23,4,12]),function(re,e,c,M,E,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends E.Disposable{constructor(r,u,p,k,w){super();this._onDidAppend=this._register(new M.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=w,this._id=w.$register(this.name,u,p,k),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?T.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(u=>this._proxy.$clear(u,r))}show(r,u){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof r=="boolean"?r:u)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class I extends S{constructor(r,u,p){super(r,!1,void 0,u,p)}append(r){super.append(r),this._id.then(u=>this._proxy.$append(u,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=I;class t extends S{constructor(r,u,p){super(r,!0,u,void 0,p)}append(r){throw new Error("Not supported")}}class y{constructor(r,u){this.name=r,this._channel=u}append(r){this._channel.then(u=>u.append(r))}appendLine(r){this._channel.then(u=>u.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,u){this._channel.then(p=>p.show(r,u))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=y;let n=class{constructor(r){this._proxy=r.getProxy(c.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r,u){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new I(r,u.identifier.value,this._proxy)}createOutputChannelFromLogFile(r,u){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!u)throw new Error("illegal argument `file`. must not be falsy");return new t(r,u,this._proxy)}};n=Ue([ze(0,P.IExtHostRpcService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(we[201],be([0,1,13,21,3,7,5,2,6,15,16,35,43]),function(re,e,c,M,E,T,A,P,S,I,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(r,u,p){const k=r.getProxy(A.MainContext.MainThreadQuickOpen);class w{constructor(m,g){this._sessions=new Map,this._instances=0,this._workspace=m,this._commands=g}showQuickPick(m,g,C,R=M.CancellationToken.None){this._onDidSelectItem=void 0;const h=Promise.resolve(m),b=++this._instances,f=k.$show(b,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},R),F={},O=f.then(()=>F);return Promise.race([O,h]).then(q=>{if(q!==F)return h.then(Q=>{const $=[];for(let z=0;z<Q.length;z++){const N=Q[z];let W,j,Y,de,G;typeof N=="string"?W=N:(W=N.label,j=N.description,Y=N.detail,de=N.picked,G=N.alwaysShow),$.push({label:W,description:j,handle:z,detail:Y,picked:de,alwaysShow:G})}return C&&typeof C.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{C.onDidSelectItem(Q[z])}),k.$setItems(b,$),f.then(z=>{if(typeof z=="number")return Q[z];if(Array.isArray(z))return z.map(N=>Q[N])})})}).then(void 0,q=>{if(!(0,I.isPromiseCanceledError)(q))return k.$setError(b,q),Promise.reject(q)})}$onItemSelected(m){this._onDidSelectItem&&this._onDidSelectItem(m)}showInput(m,g=M.CancellationToken.None){return this._validateInput=m?m.validateInput:void 0,k.$input(m,typeof this._validateInput=="function",g).then(void 0,C=>{if(!(0,I.isPromiseCanceledError)(C))return Promise.reject(C)})}$validateInput(m){return this._validateInput?(0,c.asPromise)(()=>this._validateInput(m)):Promise.resolve(void 0)}async showWorkspaceFolderPick(m,g=M.CancellationToken.None){const C=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[m]);if(!C)return;const R=await this._workspace.getWorkspaceFolders2();if(!!R)return R.find(h=>h.uri.toString()===C.uri.toString())}createQuickPick(m,g){const C=new a(m,g,()=>this._sessions.delete(C._id));return this._sessions.set(C._id,C),C}createInputBox(m){const g=new o(m,()=>this._sessions.delete(g._id));return this._sessions.set(g._id,g),g}$onDidChangeValue(m,g){const C=this._sessions.get(m);C&&C._fireDidChangeValue(g)}$onDidAccept(m){const g=this._sessions.get(m);g&&g._fireDidAccept()}$onDidChangeActive(m,g){const C=this._sessions.get(m);C instanceof a&&C._fireDidChangeActive(g)}$onDidChangeSelection(m,g){const C=this._sessions.get(m);C instanceof a&&C._fireDidChangeSelection(g)}$onDidTriggerButton(m,g){const C=this._sessions.get(m);C&&C._fireDidTriggerButton(g)}$onDidTriggerItemButton(m,g,C){const R=this._sessions.get(m);R instanceof a&&R._fireDidTriggerItemButton(g,C)}$onDidHide(m){const g=this._sessions.get(m);g&&g._fireDidHide()}}class l{constructor(m,g){this._extensionId=m,this._onDidDispose=g,this._id=a._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(m){this._title=m,this.update({title:m})}get step(){return this._steps}set step(m){this._steps=m,this.update({step:m})}get totalSteps(){return this._totalSteps}set totalSteps(m){this._totalSteps=m,this.update({totalSteps:m})}get enabled(){return this._enabled}set enabled(m){this._enabled=m,this.update({enabled:m})}get busy(){return this._busy}set busy(m){this._busy=m,this.update({busy:m})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(m){this._ignoreFocusOut=m,this.update({ignoreFocusOut:m})}get value(){return this._value}set value(m){this._value=m,this.update({value:m})}get placeholder(){return this._placeholder}set placeholder(m){this._placeholder=m,this.update({placeholder:m})}get buttons(){return this._buttons}set buttons(m){this._buttons=m.slice(),this._handlesToButtons.clear(),m.forEach((g,C)=>{const R=g===S.QuickInputButtons.Back?-1:C;this._handlesToButtons.set(R,g)}),this.update({buttons:m.map((g,C)=>({...s(g),tooltip:g.tooltip,handle:g===S.QuickInputButtons.Back?-1:C}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(m){this._value=m,this._onDidChangeValueEmitter.fire(m)}_fireDidTriggerButton(m){const g=this._handlesToButtons.get(m);g&&this._onDidTriggerButtonEmitter.fire(g)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),k.$dispose(this._id))}update(m){if(!this._disposed){for(const g of Object.keys(m)){const C=m[g];this._pendingUpdate[g]=C===void 0?null:C}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){k.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}l._nextId=1;function v(_){if(_ instanceof S.ThemeIcon)return{id:_.id};const m=i(_),g=D(_);return{dark:typeof m=="string"?P.URI.file(m):m,light:typeof g=="string"?P.URI.file(g):g}}function D(_){return typeof _=="object"&&"light"in _?_.light:_}function i(_){return typeof _=="object"&&"dark"in _?_.dark:_}function s(_){const m=v(_.iconPath);let g,C;return"id"in m?C=n.ThemeIcon.asClassName(m):g=m,{iconPath:g,iconClass:C}}class a extends l{constructor(m,g,C){super(m,C);this.enableProposedApi=g,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(m){this._items=m.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),m.forEach((g,C)=>{this._handlesToItems.set(C,g),this._itemsToHandles.set(g,C)}),this.update({items:m.map((g,C)=>({label:g.label,description:g.description,handle:C,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,buttons:g.buttons&&this.enableProposedApi?g.buttons.map((R,h)=>({...s(R),tooltip:R.tooltip,handle:h})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(m){this._canSelectMany=m,this.update({canSelectMany:m})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(m){this._matchOnDescription=m,this.update({matchOnDescription:m})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(m){this._matchOnDetail=m,this.update({matchOnDetail:m})}get sortByLabel(){return this._sortByLabel}set sortByLabel(m){this._sortByLabel=m,this.update({sortByLabel:m})}get activeItems(){return this._activeItems}set activeItems(m){this._activeItems=m.filter(g=>this._itemsToHandles.has(g)),this.update({activeItems:this._activeItems.map(g=>this._itemsToHandles.get(g))})}get selectedItems(){return this._selectedItems}set selectedItems(m){this._selectedItems=m.filter(g=>this._itemsToHandles.has(g)),this.update({selectedItems:this._selectedItems.map(g=>this._itemsToHandles.get(g))})}_fireDidChangeActive(m){const g=(0,t.coalesce)(m.map(C=>this._handlesToItems.get(C)));this._activeItems=g,this._onDidChangeActiveEmitter.fire(g)}_fireDidChangeSelection(m){const g=(0,t.coalesce)(m.map(C=>this._handlesToItems.get(C)));this._selectedItems=g,this._onDidChangeSelectionEmitter.fire(g)}_fireDidTriggerItemButton(m,g){const C=this._handlesToItems.get(m);if(!C||!C.buttons||!C.buttons.length)return;const R=C.buttons[g];R&&this._onDidTriggerItemButtonEmitter.fire({button:R,item:C})}}class o extends l{constructor(m,g){super(m,g);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(m){this._password=m,this.update({password:m})}get prompt(){return this._prompt}set prompt(m){this._prompt=m,this.update({prompt:m})}get validationMessage(){return this._validationMessage}set validationMessage(m){this._validationMessage=m,this.update({validationMessage:m,severity:m?y.default.Error:y.default.Ignore})}}return new w(u,p)}e.createExtHostQuickOpen=d}),define(we[202],be([0,1,2,3,51,7,13,5,16,107,14,25,30,43,8]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(m){if(m)return typeof m.iconPath=="string"?c.URI.file(m.iconPath):c.URI.isUri(m.iconPath)||d.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function p(m,g){if(!m.iconPath&&!g.iconPath)return 0;if(m.iconPath){if(!g.iconPath)return 1}else return-1;const C=typeof m.iconPath=="string"?m.iconPath:c.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,R=typeof g.iconPath=="string"?g.iconPath:c.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,I.comparePaths)(C,R)}function k(m,g){let C=0;if(m.strikeThrough!==g.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==g.faded)return m.faded?1:-1;if(m.tooltip!==g.tooltip)return(m.tooltip||"").localeCompare(g.tooltip||"");if(C=p(m,g),C!==0)return C;if(m.light&&g.light)C=p(m.light,g.light);else{if(m.light)return 1;if(g.light)return-1}if(C!==0)return C;if(m.dark&&g.dark)C=p(m.dark,g.dark);else{if(m.dark)return 1;if(g.dark)return-1}return C}function w(m,g){if(m.command!==g.command)return m.command<g.command?-1:1;if(m.title!==g.title)return m.title<g.title?-1:1;if(m.tooltip!==g.tooltip){if(m.tooltip!==void 0&&g.tooltip!==void 0)return m.tooltip<g.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(m.arguments===g.arguments)return 0;if(m.arguments)if(g.arguments){if(m.arguments.length!==g.arguments.length)return m.arguments.length-g.arguments.length}else return 1;else return-1;for(let C=0;C<m.arguments.length;C++){const R=m.arguments[C],h=g.arguments[C];if(R!==h)return R<h?-1:1}return 0}function l(m,g){let C=(0,I.comparePaths)(m.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(C!==0)return C;if(m.command&&g.command)C=w(m.command,g.command);else{if(m.command)return 1;if(g.command)return-1}if(C!==0)return C;if(m.decorations&&g.decorations)C=k(m.decorations,g.decorations);else{if(m.decorations)return 1;if(g.decorations)return-1}return C}function v(m,g){for(let C=0;C<m.length;C++)if(m[C]!==g[C])return!1;return!0}function D(m,g){return m.command===g.command&&m.title===g.title&&m.tooltip===g.tooltip&&(m.arguments&&g.arguments?v(m.arguments,g.arguments):m.arguments===g.arguments)}function i(m,g){return(0,S.equals)(m,g,D)}class s{constructor(g,C,R){this._extension=g,this._proxy=C,this._sourceControlHandle=R,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(g){this._proxy.$setInputBoxValue(this._sourceControlHandle,g),this.updateValue(g)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(g){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,g),this._placeholder=g}get validateInput(){return(0,n.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(g){if((0,n.checkProposedApiEnabled)(this._extension),g&&typeof g!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=g,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!g)}get visible(){return this._visible}set visible(g){g=!!g,this._visible!==g&&(this._visible=g,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,g))}focus(){(0,n.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(g,C){(0,n.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,g,C)}$onInputBoxValueChange(g){this.updateValue(g)}updateValue(g){this._value=g,this._onDidChange.fire(g)}}e.ExtHostSCMInputBox=s;class a{constructor(g,C,R,h,b){this._proxy=g,this._commands=C,this._sourceControlHandle=R,this._id=h,this._label=b,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=a._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(g){this._label=g,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,g)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(g){this._hideWhenEmpty=g,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(g){this._resourceStates=[...g],this._onDidUpdateResourceStates.fire()}getResourceState(g){return this._resourceStatesMap.get(g)}$executeResourceCommand(g,C){const R=this._resourceStatesCommandsMap.get(g);return R?(0,A.asPromise)(()=>this._commands.executeCommand(R.command,...R.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this._resourceStates].sort(l),R=(0,S.sortedDiff)(this._resourceSnapshot,g,l).map(f=>{const F=f.toInsert.map(O=>{const q=this._resourceHandlePool++;this._resourceStatesMap.set(q,O);const Q=O.resourceUri;let $;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const Ee=new T.DisposableStore;$=this._commands.converter.toInternal(O.command,Ee),this._resourceStatesDisposablesMap.set(q,Ee)}else this._resourceStatesCommandsMap.set(q,O.command);const z=u(O.decorations),N=O.decorations&&u(O.decorations.light)||z,W=O.decorations&&u(O.decorations.dark)||z,j=[N,W],Y=O.decorations&&O.decorations.tooltip||"",de=O.decorations&&!!O.decorations.strikeThrough,G=O.decorations&&!!O.decorations.faded,ue=O.contextValue||"";return{rawResource:[q,Q,j,Y,de,G,ue,$],handle:q}});return{start:f.start,deleteCount:f.deleteCount,toInsert:F}}),h=R.map(({start:f,deleteCount:F,toInsert:O})=>[f,F,O.map(q=>q.rawResource)]),b=R.reverse();for(const{start:f,deleteCount:F,toInsert:O}of b){const q=O.map($=>$.handle),Q=this._handlesSnapshot.splice(f,F,...q);for(const $ of Q)this._resourceStatesMap.delete($),this._resourceStatesCommandsMap.delete($),this._resourceStatesDisposablesMap.get($)?.dispose(),this._resourceStatesDisposablesMap.delete($)}return this._resourceSnapshot=g,h}dispose(){this._disposed=!0,this._onDidDispose.fire()}}a._handlePool=0;class o{constructor(g,C,R,h,b,f){this._proxy=C,this._commands=R,this._id=h,this._label=b,this._rootUri=f,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=o._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new s(g,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,h,b,f)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(g){this._count!==g&&(this._count=g,this._proxy.$updateSourceControl(this.handle,{count:g}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(g){this._quickDiffProvider=g,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this._commitTemplate}set commitTemplate(g){g!==this._commitTemplate&&(this._commitTemplate=g,this._proxy.$updateSourceControl(this.handle,{commitTemplate:g}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(g){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=g;const C=this._commands.converter.toInternal(g,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:C})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(g){if(this._statusBarCommands&&g&&i(this._statusBarCommands,g))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=g;const C=(g||[]).map(R=>this._commands.converter.toInternal(R,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:C})}get selected(){return this._selected}createResourceGroup(g,C){const R=new a(this._proxy,this._commands,this.handle,g,C),h=M.Event.once(R.onDidDispose)(()=>this.createdResourceGroups.delete(R));return this.createdResourceGroups.set(R,h),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const g=[],C=[];for(const[R,h]of this.createdResourceGroups){h.dispose();const b=R.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(R),this.eventuallyUpdateResourceStates()});M.Event.once(R.onDidDispose)(()=>{this.updatedResourceGroups.delete(R),b.dispose(),this._groups.delete(R.handle),this._proxy.$unregisterGroup(this.handle,R.handle)}),g.push([R.handle,R.id,R.label,R.features]);const f=R._takeResourceStateSnapshot();f.length>0&&C.push([R.handle,f]),this._groups.set(R.handle,R)}this._proxy.$registerGroups(this.handle,g,C),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const g=[];this.updatedResourceGroups.forEach(C=>{const R=C._takeResourceStateSnapshot();R.length!==0&&g.push([C.handle,R])}),g.length>0&&this._proxy.$spliceResourceStates(this.handle,g),this.updatedResourceGroups.clear()}getResourceGroup(g){return this._groups.get(g)}setSelectionState(g){this._selected=g,this._onDidChangeSelection.fire(g)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(g=>g.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}o._handlePool=0,Ue([(0,E.debounce)(100)],o.prototype,"eventuallyAddResourceGroups",null),Ue([(0,E.debounce)(100)],o.prototype,"eventuallyUpdateResourceStates",null);let _=class Bi{constructor(g,C,R){this._commands=C,this.logService=R,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=g.getProxy(P.MainContext.MainThreadSCM),this._telemetry=g.getProxy(P.MainContext.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===3){const b=this._sourceControls.get(h.sourceControlHandle);if(!b)return h;const f=b.getResourceGroup(h.groupHandle);return f?f.getResourceState(h.handle):h}else if(h&&h.$mid===4){const b=this._sourceControls.get(h.sourceControlHandle);return b?b.getResourceGroup(h.groupHandle):h}else if(h&&h.$mid===5){const b=this._sourceControls.get(h.handle);return b||h}return h}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(g,C,R,h){this.logService.trace("ExtHostSCM#createSourceControl",g.identifier.value,C,R,h),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const b=Bi._handlePool++,f=new o(g,this._proxy,this._commands,C,R,h);this._sourceControls.set(b,f);const F=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(g.identifier))||[];return F.push(f),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(g.identifier),F),f}getLastInputBox(g){this.logService.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const C=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(g.identifier)),R=C&&C[C.length-1];return R&&R.inputBox}$provideOriginalResource(g,C,R){const h=c.URI.revive(C);this.logService.trace("ExtHostSCM#$provideOriginalResource",g,h.toString());const b=this._sourceControls.get(g);return!b||!b.quickDiffProvider||!b.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>b.quickDiffProvider.provideOriginalResource(h,R)).then(f=>f||null)}$onInputBoxValueChange(g,C){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",g);const R=this._sourceControls.get(g);return R&&R.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(g,C,R,h){this.logService.trace("ExtHostSCM#$executeResourceCommand",g,C,R);const b=this._sourceControls.get(g);if(!b)return Promise.resolve(void 0);const f=b.getResourceGroup(C);return f?f.$executeResourceCommand(R,h):Promise.resolve(void 0)}$validateInput(g,C,R){this.logService.trace("ExtHostSCM#$validateInput",g);const h=this._sourceControls.get(g);return!h||!h.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>h.inputBox.validateInput(C,R)).then(b=>{if(!b)return Promise.resolve(void 0);const f=r.MarkdownString.fromStrict(b.message);return f?Promise.resolve([f,b.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this._sourceControls.get(g)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=g,Promise.resolve(void 0)}};_._handlePool=0,_=Ue([ze(2,t.ILogService)],_),e.ExtHostSCM=_});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[203],be([0,1,6,5,126,7,8]),function(re,e,c,M,E,T,A){"use strict";var P,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class I{constructor(d,r,u,p,k=c.StatusBarAlignment.Left,w){P.set(this,void 0),S.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,et(this,P,d,"f"),et(this,S,r,"f"),this._entryId=I.ID_GEN++,this._extension=u,this._id=p,this._alignment=k,this._priority=w}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!I.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){this._command?.fromApi!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Oe(this,S,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Oe(this,S,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,P,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let d;this._extension?this._id?d=`${this._extension.identifier.value}.${this._id}`:d=this._extension.identifier.value:d=this._id;let r;this._name?r=this._name:r=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let u=this._color;this._backgroundColor&&(u=I.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const p=this._tooltip?A.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,P,"f").$setEntry(this._entryId,d,r,this._text,p,this._command?.internal,u,this._backgroundColor,this._alignment===c.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=I,P=new WeakMap,S=new WeakMap,I.ID_GEN=0,I.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class t{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const r={message:d};return this._messages.unshift(r),this._update(),new c.Disposable(()=>{const u=this._messages.indexOf(r);u>=0&&(this._messages.splice(u,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class y{constructor(d,r){this._proxy=d.getProxy(M.MainContext.MainThreadStatusBar),this._commands=r,this._statusMessage=new t(this)}createStatusBarEntry(d,r,u,p){return new I(this._proxy,this._commands,d,r,u,p)}setStatusBarMessage(d,r){const u=this._statusMessage.setMessage(d);let p;return typeof r=="number"?p=setTimeout(()=>u.dispose(),r):typeof r!="undefined"&&r.then(()=>u.dispose(),()=>u.dispose()),new c.Disposable(()=>{u.dispose(),clearTimeout(p)})}}e.ExtHostStatusBar=y}),define(we[72],be([0,1,5,3,4]),function(re,e,c,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(P){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,S){this._proxy.$registerExtensionStorageKeysToSync(P,S)}getValue(P,S,I){return this._proxy.$getValue(P,S).then(t=>t||I)}setValue(P,S,I){return this._proxy.$setValue(P,S,I)}$acceptValue(P,S,I){this._onDidChangeStorage.fire({shared:P,key:S,value:I})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(we[73],be([0,1,4,29,14,71,2]),function(re,e,c,M,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let P=class{constructor(I,t,y){this._logService=t,this._extHostFileSystem=y,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(I){return A.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,t=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(I){if(this._value)return A.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return A.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=Ue([ze(0,M.IExtHostInitDataService),ze(1,E.ILogService),ze(2,T.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(we[37],be([0,1,3,5,4,2,12,7,6,127,15,166,21,36,148,149,43,10]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r,u,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class w{constructor(m,g,C,R){this._proxy=m,this._id=g,this._creationOptions=C,this._name=R,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(b=>this._pidPromiseComplete=b);const h=this;this.value={get name(){return h._name||""},get processId(){return h._pidPromise},get creationOptions(){return h._creationOptions},get exitStatus(){return h._exitStatus},get state(){return h._state},sendText(b,f=!0){h._checkDisposed(),h._proxy.$sendText(h._id,b,f)},show(b){h._checkDisposed(),h._proxy.$show(h._id,b)},hide(){h._checkDisposed(),h._proxy.$hide(h._id)},dispose(){h._disposed||(h._disposed=!0,h._proxy.$dispose(h._id))},get dimensions(){if(!(h._cols===void 0||h._rows===void 0))return{columns:h._cols,rows:h._rows}}}}async create(m,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:m.name,shellPath:(0,k.withNullAsUndefined)(m.shellPath),shellArgs:(0,k.withNullAsUndefined)(m.shellArgs),cwd:(0,k.withNullAsUndefined)(m.cwd),env:(0,k.withNullAsUndefined)(m.env),icon:(0,k.withNullAsUndefined)(a(m.iconPath)),color:p.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:(0,k.withNullAsUndefined)(m.message),strictEnv:(0,k.withNullAsUndefined)(m.strictEnv),hideFromUser:(0,k.withNullAsUndefined)(m.hideFromUser),isFeatureTerminal:(0,k.withNullAsUndefined)(g?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,k.withNullAsUndefined)(g?.useShellEnvironment),location:g?.location||this._serializeParentTerminal(m.location,g?.resolvedExtHostIdentifier,g?.location)})}async createExtensionTerminal(m,g,C,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:C,color:p.ThemeColor.isThemeColor(R)?R.id:void 0,location:this._serializeParentTerminal(m,g)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(m,g,C){return typeof m=="object"&&"parentTerminal"in m?g?{parentTerminal:g}:void 0:(C&&(m=C),m)}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(m){this._name=m}setExitCode(m){this._exitStatus=Object.freeze({code:m})}setDimensions(m,g){return m===this._cols&&g===this._rows||m===0||g===0?!1:(this._cols=m,this._rows=g,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(m){this._pidPromiseComplete?(this._pidPromiseComplete(m),this._pidPromiseComplete=void 0):this._pidPromise.then(g=>{g!==m&&(this._pidPromise=Promise.resolve(m))})}}e.ExtHostTerminal=w;class l{constructor(m){this._pty=m,this.id=0,this.shouldPersist=!1,this._onProcessData=new c.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new c.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new c.Emitter,this._onProcessTitleChanged=new c.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new c.Emitter,this._onProcessShellTypeChanged=new c.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(m){this._pty.handleInput&&this._pty.handleInput(m)}resize(m,g){this._pty.setDimensions&&this._pty.setDimensions({columns:m,rows:g})}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(m){this._pty.onDidWrite(g=>this._onProcessData.fire(g)),this._pty.onDidClose&&this._pty.onDidClose((g=void 0)=>{this._onProcessExit.fire(g===void 0?void 0:g)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(g=>this._onProcessOverrideDimensions.fire(g&&{cols:g.columns,rows:g.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(g=>this._onProcessTitleChanged.fire(g)),this._pty.open(m||void 0),this._pty.setDimensions&&m&&this._pty.setDimensions(m),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=l;let v=1,D=class extends P.Disposable{constructor(m,g){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new c.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new c.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new c.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new c.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new c.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=g.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new u.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new c.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(m),this._register({dispose:()=>{for(const[C,R]of this._terminalProcesses)R.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(m=>m.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(m){return(m?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(m){return(m?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(m,g){const C=new w(this._proxy,(0,d.generateUuid)(),m,m.name),R=new l(m.pty);return C.createExtensionTerminal(this._resolveLocation(m.location),g?.resolvedExtHostIdentifier,a(m.iconPath),o(m.color)).then(h=>{const b=this._setupExtHostProcessListeners(h,R);this._terminalProcessDisposables[h]=b}),this._terminals.push(C),C.value}_resolveLocation(m){return typeof m=="object"&&"viewColumn"in m&&m.viewColumn!==void 0?{viewColumn:m.viewColumn,preserveFocus:m.preserveFocus}:typeof m=="object"&&"parentTerminal"in m?void 0:(m===r.TerminalLocation.Editor||m===r.TerminalLocation.Panel,m)}attachPtyToTerminal(m,g){if(!this._getTerminalById(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const R=new l(g),h=this._setupExtHostProcessListeners(m,R);this._terminalProcessDisposables[m]=h}async $acceptActiveTerminalChanged(m){const g=this._activeTerminal;if(m===null){this._activeTerminal=void 0,g!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const C=this._getTerminalById(m);C&&(this._activeTerminal=C,g!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(m,g){const C=this._getTerminalById(m);C&&this._onDidWriteTerminalData.fire({terminal:C.value,data:g})}async $acceptTerminalDimensions(m,g,C){const R=this._getTerminalById(m);R&&R.setDimensions(g,C)&&this._onDidChangeTerminalDimensions.fire({terminal:R.value,dimensions:R.value.dimensions})}async $acceptTerminalMaximumDimensions(m,g,C){this._terminalProcesses.get(m)?.resize(g,C)}async $acceptTerminalTitleChange(m,g){const C=this._getTerminalById(m);C&&(C.name=g)}async $acceptTerminalClosed(m,g){const C=this._getTerminalObjectIndexById(this._terminals,m);if(C!==null){const R=this._terminals.splice(C,1)[0];R.setExitCode(g),this._onDidCloseTerminal.fire(R.value)}}$acceptTerminalOpened(m,g,C,R){if(g){const f=this._getTerminalObjectIndexById(this._terminals,g);if(f!==null){this._terminals[f]._id=m,this._onDidOpenTerminal.fire(this.terminals[f]),this._terminals[f].isOpen=!0;return}}const h={name:R.name,shellPath:R.executable,shellArgs:R.args,cwd:typeof R.cwd=="string"?R.cwd:T.URI.revive(R.cwd),env:R.env,hideFromUser:R.hideFromUser},b=new w(this._proxy,m,h,C);this._terminals.push(b),this._onDidOpenTerminal.fire(b.value),b.isOpen=!0}async $acceptTerminalProcessId(m,g){const C=this._getTerminalById(m);C&&C._setProcessId(g)}async $startExtensionTerminal(m,g){const C=this._getTerminalById(m);if(!C)return{message:(0,I.localize)(0,null,m)};C.isOpen||await new Promise(h=>{const b=this.onDidOpenTerminal(async f=>{f===C.value&&(b.dispose(),h())})});const R=this._terminalProcesses.get(m);R?R.startSendingEvents(g):this._extensionTerminalAwaitingStart[m]={initialDimensions:g}}_setupExtHostProcessListeners(m,g){const C=new P.DisposableStore;C.add(g.onProcessReady(h=>this._proxy.$sendProcessReady(m,h.pid,h.cwd))),C.add(g.onProcessTitleChanged(h=>this._proxy.$sendProcessTitle(m,h))),this._bufferer.startBuffering(m,g.onProcessData),C.add(g.onProcessExit(h=>this._onProcessExit(m,h))),g.onProcessOverrideDimensions&&C.add(g.onProcessOverrideDimensions(h=>this._proxy.$sendOverrideDimensions(m,h))),this._terminalProcesses.set(m,g);const R=this._extensionTerminalAwaitingStart[m];return R&&g instanceof l&&(g.startSendingEvents(R.initialDimensions),delete this._extensionTerminalAwaitingStart[m]),C}$acceptProcessAckDataEvent(m,g){this._terminalProcesses.get(m)?.acknowledgeDataEvent(g)}$acceptProcessInput(m,g){this._terminalProcesses.get(m)?.input(g)}$acceptTerminalInteraction(m){const g=this._getTerminalById(m);g?.setInteractedWith()&&this._onDidChangeTerminalState.fire(g.value)}$acceptProcessResize(m,g,C){try{this._terminalProcesses.get(m)?.resize(g,C)}catch(R){if(R.code!=="EPIPE"&&R.code!=="ERR_IPC_CHANNEL_CLOSED")throw R}}$acceptProcessShutdown(m,g){this._terminalProcesses.get(m)?.shutdown(g)}$acceptProcessRequestInitialCwd(m){this._terminalProcesses.get(m)?.getInitialCwd().then(g=>this._proxy.$sendProcessInitialCwd(m,g))}$acceptProcessRequestCwd(m){this._terminalProcesses.get(m)?.getCwd().then(g=>this._proxy.$sendProcessCwd(m,g))}$acceptProcessRequestLatency(m){return m}registerLinkProvider(m){return this._linkProviders.add(m),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(m),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(m,g,C){if(this._profileProviders.has(g))throw new Error(`Terminal profile provider "${g}" already registered`);return this._profileProviders.set(g,C),this._proxy.$registerProfileProvider(g,m.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(g),this._proxy.$unregisterProfileProvider(g)})}async $createContributedProfileTerminal(m,g){const C=new n.CancellationTokenSource().token,R=await this._profileProviders.get(m)?.provideTerminalProfile(C);if(!C.isCancellationRequested){if(!R||!("options"in R))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in R.options){this.createExtensionTerminal(R.options,g);return}this.createTerminalFromOptions(R.options,g)}}async $provideLinks(m,g){const C=this._getTerminalById(m);if(!C)return[];this._terminalLinkCache.delete(m);const R=this._terminalLinkCancellationSource.get(m);R&&R.dispose(!0);const h=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(m,h);const b=[],f={terminal:C.value,line:g},F=[];for(const Q of this._linkProviders)F.push(new Promise(async $=>{h.token.onCancellationRequested(()=>$({provider:Q,links:[]}));const z=await Q.provideTerminalLinks(f,h.token)||[];h.token.isCancellationRequested||$({provider:Q,links:z})}));const O=await Promise.all(F);if(h.token.isCancellationRequested)return[];const q=new Map;for(const Q of O)Q&&Q.links.length>0&&b.push(...Q.links.map($=>{const z={id:v++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return q.set(z.id,{provider:Q.provider,link:$}),z}));return this._terminalLinkCache.set(m,q),b}$activateLink(m,g){const C=this._terminalLinkCache.get(m)?.get(g);!C||C.provider.handleTerminalLink(C.link)}_onProcessExit(m,g){this._bufferer.stopBuffering(m),this._terminalProcesses.delete(m),delete this._extensionTerminalAwaitingStart[m];const C=this._terminalProcessDisposables[m];C&&(C.dispose(),delete this._terminalProcessDisposables[m]),this._proxy.$sendProcessExit(m,g)}_getTerminalById(m){return this._getTerminalObjectById(this._terminals,m)}_getTerminalObjectById(m,g){const C=this._getTerminalObjectIndexById(m,g);return C!==null?m[C]:null}_getTerminalObjectIndexById(m,g){let C=null;return m.some((R,h)=>R._id===g?(C=h,!0):!1),C}getEnvironmentVariableCollection(m){let g=this._environmentVariableCollections.get(m.identifier.value);return g||(g=new i,this._setEnvironmentVariableCollection(m.identifier.value,g)),g}_syncEnvironmentVariableCollection(m,g){const C=(0,y.serializeEnvironmentVariableCollection)(g.map);this._proxy.$setEnvironmentVariableCollection(m,g.persistent,C.length===0?void 0:C)}$initEnvironmentVariableCollections(m){m.forEach(g=>{const C=g[0],R=new i(g[1]);this._setEnvironmentVariableCollection(C,R)})}$acceptDefaultProfile(m,g){this._defaultProfile=m,this._defaultAutomationProfile=g}_setEnvironmentVariableCollection(m,g){this._environmentVariableCollections.set(m,g),g.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(m,g)})}};D=Ue([ze(1,A.IExtHostRpcService)],D),e.BaseExtHostTerminalService=D;class i{constructor(m){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new c.Emitter,this.map=new Map(m)}get persistent(){return this._persistent}set persistent(m){this._persistent=m,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(m,g){this._setIfDiffers(m,{value:g,type:S.EnvironmentVariableMutatorType.Replace})}append(m,g){this._setIfDiffers(m,{value:g,type:S.EnvironmentVariableMutatorType.Append})}prepend(m,g){this._setIfDiffers(m,{value:g,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(m,g){const C=this.map.get(m);(!C||C.value!==g.value||C.type!==g.type)&&(this.map.set(m,g),this._onDidChangeCollection.fire())}get(m){return this.map.get(m)}forEach(m,g){this.map.forEach((C,R)=>m.call(g,R,C,this))}delete(m){this.map.delete(m),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=i;let s=class extends D{constructor(m){super(!1,m)}createTerminal(m,g,C){throw new t.NotSupportedError}createTerminalFromOptions(m,g){throw new t.NotSupportedError}};s=Ue([ze(0,A.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function a(_){if(!(!_||typeof _=="string"))return"id"in _?{id:_.id,color:_.color}:_}function o(_){return p.ThemeColor.isThemeColor(_)?_:void 0}});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[204],be([0,1,23,21,3,234,57,189,7,22,10,36,5,12,64,8,6,174,90,68]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r,u,p,k,w,l){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let D=class{constructor(f,F){this.resultsChangedEmitter=new E.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=f.getProxy(n.MainContext.MainThreadTesting),this.observer=new C(this.proxy),this.runTracker=new s(this.proxy),F.registerArgumentProcessor({processArgument:O=>O?.$mid===13?u.TestItem.toItemFromContext(O):O})}createTestController(f,F){if(this.controllers.has(f))throw new Error(`Attempt to insert a duplicate controller with ID "${f}"`);const O=new S.DisposableStore,q=O.add(new k.SingleUseTestCollection(f));q.root.label=F;const Q=new Map,$=this.proxy,z={items:q.root.children,get label(){return F},set label(W){F=W,q.root.label=W,$.$updateControllerLabel(f,F)},get id(){return f},createRunProfile:(W,j,Y,de,G)=>{let ue=(0,A.hash)(W);for(;Q.has(ue);)ue++;const oe=new R(this.proxy,f,ue,W,j,Y,de,G);return Q.set(ue,oe),oe},createTestItem(W,j,Y){return new r.TestItemImpl(f,W,j,Y)},createTestRun:(W,j,Y=!0)=>this.runTracker.createTestRun(f,q,W,j,Y),set resolveHandler(W){q.resolveHandler=W},get resolveHandler(){return q.resolveHandler},dispose:()=>{O.dispose()}};z.createRunConfiguration=z.createRunProfile,$.$registerTestController(f,F),O.add((0,S.toDisposable)(()=>$.$unregisterTestController(f)));const N={controller:z,collection:q,profiles:Q};return this.controllers.set(f,N),O.add((0,S.toDisposable)(()=>this.controllers.delete(f))),O.add(q.onDidGenerateDiff(W=>$.$publishDiff(f,W))),z}createTestObserver(){return this.observer.checkout()}async runTests(f,F=M.CancellationToken.None){const O=a(f);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.controllers.get(O.controllerId);if(!q)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:f.include?.map(Q=>Q.id)??[q.collection.root.id],profileGroup:h[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:f.exclude?.map(Q=>Q.id)},F)}$provideFileCoverage(f,F,O){return P.Iterable.find(this.runTracker.trackers,q=>q.id===f)?.getCoverage(F)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(f,F,O,q){return P.Iterable.find(this.runTracker.trackers,Q=>Q.id===f)?.getCoverage(F)?.resolveFileCoverage(O,q)??Promise.resolve([])}$configureRunProfile(f,F){this.controllers.get(f)?.profiles.get(F)?.configureHandler?.()}$publishTestResults(f){this.results=Object.freeze(f.map(F=>(0,I.deepFreeze)(u.TestResults.to(F))).concat(this.results).sort((F,O)=>O.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(f,F){const O=this.controllers.get(l.TestId.fromString(f).controllerId)?.collection;O&&(await O.expand(f,F<0?Infinity:F),O.flushDiff())}$acceptDiff(f){this.observer.applyDiff(f)}async $runControllerTests(f,F){const O=this.controllers.get(f.controllerId);if(!O)return;const{collection:q,profiles:Q}=O,$=Q.get(f.profileId);if(!$)return;const z=f.testIds.map(Y=>q.tree.get(Y)).filter(t.isDefined),N=f.excludeExtIds.map(Y=>O.collection.tree.get(Y)).filter(t.isDefined).filter(Y=>z.some(de=>de.fullId.compare(Y.fullId)===2));if(!z.length)return;const W=new p.TestRunRequest(z.some(Y=>Y.actual instanceof r.TestItemRootImpl)?void 0:z.map(Y=>Y.actual),N.map(Y=>Y.actual),$),j=this.runTracker.prepareForMainThreadTestRun(W,o.fromInternal(f,O.collection),F);try{await $.runHandler(W,F)}finally{j.isRunning&&!F.isCancellationRequested&&await E.Event.toPromise(j.onEnd),this.runTracker.cancelRunById(f.runId)}}$cancelExtensionTestRun(f){f===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(f)}};D=Ue([ze(0,d.IExtHostRpcService)],D),e.ExtHostTesting=D;class i extends S.Disposable{constructor(f,F,O){super();this.dto=f,this.proxy=F,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new E.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new M.CancellationTokenSource(O)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:q}of this.tasks.values())q.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(f){return this.tasks.get(f)?.coverage}createRun(f){const F=this.dto.id,O=this.dto.controllerId,q=(0,y.generateUuid)(),Q=new _(this.proxy,F,q),$=W=>(j,...Y)=>{if(z){console.warn(`Setting the state of test "${j.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(j)||(this.ensureTestIsKnown(j),W(j,...Y))};let z=!1;const N={isPersisted:this.dto.isPersisted,token:this.cts.token,name:f,get coverageProvider(){return Q.coverageProvider},set coverageProvider(W){Q.coverageProvider=W},enqueued:$(W=>{this.proxy.$updateTestStateInRun(F,q,l.TestId.fromExtHostTestItem(W,O).toString(),1)}),skipped:$(W=>{this.proxy.$updateTestStateInRun(F,q,l.TestId.fromExtHostTestItem(W,O).toString(),5)}),started:$(W=>{this.proxy.$updateTestStateInRun(F,q,l.TestId.fromExtHostTestItem(W,O).toString(),2)}),errored:$((W,j,Y)=>{this.proxy.$appendTestMessagesInRun(F,q,l.TestId.fromExtHostTestItem(W,O).toString(),j instanceof Array?j.map(u.TestMessage.from):[u.TestMessage.from(j)]),this.proxy.$updateTestStateInRun(F,q,l.TestId.fromExtHostTestItem(W,O).toString(),6,Y)}),failed:$((W,j,Y)=>{this.proxy.$appendTestMessagesInRun(F,q,l.TestId.fromExtHostTestItem(W,O).toString(),j instanceof Array?j.map(u.TestMessage.from):[u.TestMessage.from(j)]),this.proxy.$updateTestStateInRun(F,q,l.TestId.fromExtHostTestItem(W,O).toString(),4,Y)}),passed:$((W,j)=>{this.proxy.$updateTestStateInRun(F,q,l.TestId.fromExtHostTestItem(W,this.dto.controllerId).toString(),3,j)}),appendOutput:(W,j,Y)=>{z||(Y&&(this.dto.isIncluded(Y)?this.ensureTestIsKnown(Y):Y=void 0),this.proxy.$appendOutputToRun(F,q,c.VSBuffer.fromString(W),j&&u.location.from(j),Y&&l.TestId.fromExtHostTestItem(Y,O).toString()))},end:()=>{z||(z=!0,this.proxy.$finishedTestRunTask(F,q),this.tasks.delete(q),this.isRunning||this.dispose())}};return this.tasks.set(q,{run:N,coverage:Q}),this.proxy.$startedTestRunTask(F,{id:q,name:f,running:!0}),N}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(f){if(!(f instanceof r.TestItemImpl))throw new r.InvalidTestItemError(f.id);if(this.sharedTestIds.has(f.id))return;const F=[];for(;F.unshift(u.TestItem.from(f)),!(this.sharedTestIds.has(f.id)||(this.sharedTestIds.add(f.id),!f.parent));)f=f.parent;const O=this.dto.colllection.root;this.sharedTestIds.has(O.id)||(this.sharedTestIds.add(O.id),F.unshift(u.TestItem.from(O))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,F)}}class s{constructor(f){this.proxy=f,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(f,F,O){return this.getTracker(f,F,O)}cancelRunById(f){for(const F of this.tracked.values())if(F.id===f){F.dispose();return}}cancelAllRuns(){for(const f of this.tracked.values())f.dispose()}createTestRun(f,F,O,q,Q){const $=this.tracked.get(O);if($)return $.createRun(q);const z=o.fromPublic(f,F,O,Q),N=a(O);this.proxy.$startedExtensionTestRun({controllerId:f,profile:N&&{group:h[N.kind],id:N.profileId},exclude:O.exclude?.map(j=>j.id)??[],id:z.id,include:O.include?.map(j=>j.id)??[F.root.id],persist:Q});const W=this.getTracker(O,z);return W.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),W.createRun(q)}getTracker(f,F,O){const q=new i(F,this.proxy,O);return this.tracked.set(f,q),q.onEnd(()=>this.tracked.delete(f)),q}}e.TestRunCoordinator=s;const a=b=>{if(!!b.profile){if(!(b.profile instanceof R))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return b.profile}};class o{constructor(f,F,O,q,Q,$){this.controllerId=f,this.id=F,this.isPersisted=Q,this.colllection=$,this.includePrefix=O.map(z=>z+"\0"),this.excludePrefix=q.map(z=>z+"\0")}static fromPublic(f,F,O,q){return new o(f,(0,y.generateUuid)(),O.include?.map(Q=>l.TestId.fromExtHostTestItem(Q,f).toString())??[f],O.exclude?.map(Q=>l.TestId.fromExtHostTestItem(Q,f).toString())??[],q,F)}static fromInternal(f,F){return new o(f.controllerId,f.runId,f.testIds,f.excludeExtIds,!0,F)}isIncluded(f){const F=l.TestId.fromExtHostTestItem(f,this.controllerId).toString()+"\0";for(const O of this.excludePrefix)if(F===O||F.startsWith(O))return!1;for(const O of this.includePrefix)if(F===O||F.startsWith(O))return!0;return!1}}e.TestRunDto=o;class _{constructor(f,F,O){this.proxy=f,this.runId=F,this.taskId=O}set coverageProvider(f){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!f||(this._coverageProvider=f,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(f){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(f))());try{return(await this.fileCoverage)?.map(u.TestCoverage.fromFile)??[]}catch(F){throw this.fileCoverage=void 0,F}}async resolveFileCoverage(f,F){const O=await this.fileCoverage;let q=O?.[f];return!this._coverageProvider||!O||!q?[]:(q.detailedCoverage||(q=O[f]=await this._coverageProvider.resolveFileCoverage?.(q,F)??q),q.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class m extends w.IncrementalChangeCollector{constructor(f){super();this.emitter=f,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(f){this.added.add(f)}update(f){Object.assign(f.revived,u.TestItem.toPlain(f.item)),this.added.has(f)||this.updated.add(f)}remove(f){if(this.added.has(f)){this.added.delete(f);return}if(this.updated.delete(f),f.parent&&this.alreadyRemoved.has(f.parent)){this.alreadyRemoved.add(f.item.extId);return}this.removed.add(f)}getChangeEvent(){const{added:f,updated:F,removed:O}=this;return{get added(){return[...f].map(q=>q.revived)},get updated(){return[...F].map(q=>q.revived)},get removed(){return[...O].map(q=>q.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class g extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new E.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(f){return this.items.get(f)}getMirroredTestDataByReference(f){return this.items.get(f.id)}createItem(f,F){return{...f,revived:u.TestItem.toPlain(f.item),depth:F?F.depth+1:0,children:new Set}}createChangeCollector(){return new m(this.changeEmitter)}}e.MirroredTestCollection=g;class C{constructor(f){this.proxy=f}checkout(){this.current||(this.current=this.createObserverData());const f=this.current;return f.observers++,{onDidChangeTest:f.tests.onDidChangeTests,get tests(){return[...f.tests.rootTests].map(F=>F.revived)},dispose:(0,T.once)(()=>{--f.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(f){return this.current?.tests.getMirroredTestDataByReference(f)}applyDiff(f){this.current?.tests.apply(f)}createObserverData(){const f=new g;return this.proxy.$subscribeToDiffs(),{observers:0,tests:f}}}class R{constructor(f,F,O,q,Q,$,z=!1,N=void 0){this.controllerId=F,this.profileId=O,this._label=q,this.kind=Q,this.runHandler=$,this._isDefault=z,this._tag=N,v.set(this,void 0),et(this,v,f,"f");const W=h[Q];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);Oe(this,v,"f").$publishTestRunProfile({profileId:O,controllerId:F,tag:N?u.TestTag.namespace(this.controllerId,N.id):null,label:q,group:W,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(f){f!==this._label&&(this._label=f,Oe(this,v,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:f}))}get isDefault(){return this._isDefault}set isDefault(f){f!==this._isDefault&&(this._isDefault=f,Oe(this,v,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:f}))}get tag(){return this._tag}set tag(f){f?.id!==this._tag?.id&&(this._tag=f,Oe(this,v,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:f?u.TestTag.namespace(this.controllerId,f.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(f){f!==this._configureHandler&&(this._configureHandler=f,Oe(this,v,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!f}))}dispose(){Oe(this,v,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=R,v=new WeakMap;const h={[p.TestRunProfileKind.Coverage]:8,[p.TestRunProfileKind.Debug]:4,[p.TestRunProfileKind.Run]:2}}),define(we[205],be([0,1,3,16,5,94,8,6]),function(re,e,c,M,E,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(t,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new c.Emitter,this._onDidChangeTextEditorOptions=new c.Emitter,this._onDidChangeTextEditorVisibleRanges=new c.Emitter,this._onDidChangeTextEditorViewColumn=new c.Emitter,this._onDidChangeActiveTextEditor=new c.Emitter,this._onDidChangeVisibleTextEditors=new c.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const y=this._extHostDocumentsAndEditors.allEditors();return t?y:y.map(n=>n.value)}async showTextDocument(t,y,n){let d;typeof y=="number"?d={position:A.ViewColumn.from(y),preserveFocus:n}:typeof y=="object"?d={position:A.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?A.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:d={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(t.uri,d),u=r&&this._extHostDocumentsAndEditors.getEditor(r);if(u)return u.value;throw r?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,y){return new T.TextEditorDecorationType(this._proxy,t,y).value}$acceptEditorPropertiesChanged(t,y){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(y.options&&n._acceptOptions(y.options),y.selections){const d=y.selections.selections.map(A.Selection.to);n._acceptSelections(d)}if(y.visibleRanges){const d=M.coalesce(y.visibleRanges.map(A.Range.to));n._acceptVisibleRanges(d)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{...y.options,lineNumbers:A.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const d=P.TextEditorSelectionChangeKind.fromValue(y.selections.source),r=y.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:r,kind:d})}if(y.visibleRanges){const d=M.coalesce(y.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:d})}}$acceptEditorPositionData(t){for(const y in t){const n=this._extHostDocumentsAndEditors.getEditor(y);if(!n)throw new Error("Unknown text editor");const d=A.ViewColumn.to(t[y]);n.value.viewColumn!==d&&(n._acceptViewColumn(d),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:d}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=S}),define(we[206],be([0,1,2,4,5,7,6]),function(re,e,c,M,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class P{constructor(t,y){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const d=n.uri===void 0?void 0:c.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(S(d))?.get(n.handle)}return n}})}async $getTimeline(t,y,n,d,r){return this._providers.get(t)?.provideTimeline(c.URI.revive(y),n,d,r)}registerTimelineProvider(t,y,n,d){const r=new T.DisposableStore,u=this.convertTimelineItem(y.id,d,r).bind(this);let p;y.onDidChange&&(p=y.onDidChange(w=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:y.id}),this));const k=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...y,scheme:t,onDidChange:void 0,async provideTimeline(w,l,v,D){D?.resetCache&&(r.clear(),k.get(y.id)?.clear());const i=await y.provideTimeline(w,l,v);if(i==null)return;const s=u(w,D);return{...i,source:y.id,items:i.items.map(s)}},dispose(){for(const w of k.values())w.get(y.id)?.clear();p?.dispose(),r.dispose()}})}convertTimelineItem(t,y,n){return(d,r)=>{let u;if(r?.cacheResults){let p=this._itemsBySourceAndUriMap.get(t);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(t,p));const k=S(d);u=p.get(k),u===void 0&&(u=new Map,p.set(k,u))}return p=>{const{iconPath:k,...w}=p,l=`${t}|${p.id??p.timestamp}`;u?.set(l,p);let v,D,i;return p.iconPath&&(k instanceof A.ThemeIcon?i={id:k.id,color:k.color}:c.URI.isUri(k)?(v=k,D=k):{light:v,dark:D}=k),{...w,id:w.id??void 0,handle:l,source:t,command:p.command?y.toInternal(p.command,n):void 0,icon:v,iconDark:D,themeIcon:i,accessibilityInformation:p.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,T.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=P;function S(I){return I?.toString()}}),define(we[207],be([0,1,7,11,2,5]),function(re,e,c,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(S){this._openers=new Map,this._proxy=S.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,I,t,y){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const n=y.schemes.find(d=>!A.supportedSchemes.has(d));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,t),this._proxy.$registerUriOpener(I,y.schemes,S,y.label),(0,c.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(S,I,t){const y=this._openers.get(S);if(!y)throw new Error(`Unknown opener with id: ${S}`);const n=E.URI.revive(I);return y.canOpenExternalUri(n,t)}async $openUri(S,I,t){const y=this._openers.get(S);if(!y)throw new Error(`Unknown opener id: '${S}'`);return y.openExternalUri(E.URI.revive(I.resolvedUri),{sourceUri:E.URI.revive(I.sourceUri)},t)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(we[208],be([0,1,5,2,7,15,25]),function(re,e,c,M,E,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(I,t){if(this.handles.has(A.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const y=P.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(I)),this.handlers.set(y,t),this._proxy.$registerUriHandler(y,I),(0,E.toDisposable)(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(I)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(I,t){const y=this.handlers.get(I);if(!y)return Promise.resolve(void 0);try{y.handleUri(M.URI.revive(t))}catch(n){(0,T.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(I){return M.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=P,P.HandlePool=0});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[49],be([0,1,3,2,137,157,67,5]),function(re,e,c,M,E,T,A,P){"use strict";var S,I,t,y,n,d,r,u,p,k,w,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class v{constructor(g,C,R,h,b,f,F){S.set(this,void 0),I.set(this,void 0),t.set(this,void 0),y.set(this,void 0),n.set(this,void 0),d.set(this,void 0),r.set(this,""),u.set(this,void 0),p.set(this,!1),k.set(this,!1),w.set(this,!1),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new c.Emitter),this._onDidDispose=Oe(this,l,"f").event,et(this,S,g,"f"),et(this,I,C,"f"),et(this,u,R,"f"),et(this,y,h,"f"),et(this,n,b,"f"),et(this,d,f,"f"),et(this,w,D(f),"f"),et(this,t,F,"f")}dispose(){et(this,p,!0,"f"),Oe(this,l,"f").fire(),Oe(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return et(this,k,!0,"f"),(0,A.asWebviewUri)(g,Oe(this,y,"f").remote)}get cspSource(){return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,r,"f")}set html(g){this.assertNotDisposed(),Oe(this,r,"f")!==g&&(et(this,r,g,"f"),!Oe(this,k,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(et(this,k,!0,"f"),Oe(this,t,"f").report("Webview vscode-resource: uris",Oe(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,I,"f").$setHtml(Oe(this,S,"f"),g))}get options(){return this.assertNotDisposed(),Oe(this,u,"f")}set options(g){this.assertNotDisposed(),Oe(this,I,"f").$setOptions(Oe(this,S,"f"),a(Oe(this,d,"f"),Oe(this,n,"f"),g)),et(this,u,g,"f")}async postMessage(g){if(Oe(this,p,"f"))return!1;const C=(0,T.serializeWebviewMessage)(g,{serializeBuffersForPostMessage:Oe(this,w,"f")});return Oe(this,I,"f").$postMessage(Oe(this,S,"f"),C.message,...C.buffers)}assertNotDisposed(){if(Oe(this,p,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=v,S=new WeakMap,I=new WeakMap,t=new WeakMap,y=new WeakMap,n=new WeakMap,d=new WeakMap,r=new WeakMap,u=new WeakMap,p=new WeakMap,k=new WeakMap,w=new WeakMap,l=new WeakMap;function D(m){try{const g=(0,E.normalizeVersion)((0,E.parseVersion)(m.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=D;class i{constructor(g,C,R,h,b){this.initData=C,this.workspace=R,this._logService=h,this._deprecationService=b,this._webviews=new Map,this._webviewProxy=g.getProxy(P.MainContext.MainThreadWebviews)}$onMessage(g,C,...R){const h=this.getWebview(g);if(h){const{message:b}=(0,T.deserializeWebviewMessage)(C,R);h._onMessageEmitter.fire(b)}}$onMissingCsp(g,C){this._logService.warn(`${C} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,C,R){const h=new v(g,this._webviewProxy,o(C),this.initData,this.workspace,R,this._deprecationService);return this._webviews.set(g,h),h._onDidDispose(()=>{this._webviews.delete(g)}),h}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=i;function s(m){return{id:m.identifier,location:m.extensionLocation}}e.toExtensionData=s;function a(m,g,C){return{enableCommandUris:C.enableCommandUris,enableScripts:C.enableScripts,portMapping:C.portMapping,localResourceRoots:C.localResourceRoots||_(m,g)}}e.serializeWebviewOptions=a;function o(m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots?.map(g=>M.URI.from(g))}}e.reviveOptions=o;function _(m,g){return[...(g?.getWorkspaceFolders()||[]).map(C=>C.uri),m.extensionLocation]}}),define(we[209],be([0,1,21,57,7,11,24,2,8,49,62,5,6]),function(re,e,c,M,E,T,A,P,S,I,t,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class d{constructor(i,s){this.document=i,this._storagePath=s,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,s){await this.getEdit(i).undo(),s||this.disposeBackup()}async redo(i,s){await this.getEdit(i).redo(),s||this.disposeBackup()}disposeEdits(i){for(const s of i)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=v(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const s=this._edits.get(i,0);if(!s)throw new Error("No edit found");return s}}class r{constructor(){this._documents=new Map}get(i,s){return this._documents.get(this.key(i,s))}add(i,s,a){const o=this.key(i,s.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${i} resource:${s.uri}`);const _=new d(s,a);return this._documents.set(o,_),_}delete(i,s){const a=this.key(i,s.uri);this._documents.delete(a)}key(i,s){return`${i}@@@${s}`}}var u;(function(D){D[D.Text=0]="Text",D[D.Custom=1]="Custom"})(u||(u={}));class p{constructor(){this._providers=new Map}addTextProvider(i,s,a){return this.add(0,i,s,a)}addCustomProvider(i,s,a){return this.add(1,i,s,a)}get(i){return this._providers.get(i)}add(i,s,a,o){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:i,extension:a,provider:o}),new n.Disposable(()=>this._providers.delete(s))}}class k{constructor(i,s,a,o,_){this._extHostDocuments=s,this._extensionStoragePaths=a,this._extHostWebview=o,this._extHostWebviewPanels=_,this._editorProviders=new p,this._documents=new r,this._proxy=i.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,s,a,o){const _=new E.DisposableStore;return w(a)?(_.add(this._editorProviders.addTextProvider(s,i,a)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(i),s,o.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(i))):(_.add(this._editorProviders.addCustomProvider(s,i,a)),this.supportEditing(a)&&_.add(a.onDidChangeCustomDocument(m=>{const g=this.getCustomDocumentEntry(s,m.document.uri);if(l(m)){const C=g.addEdit(m);this._proxy.$onDidEdit(m.document.uri,s,C,m.label)}else this._proxy.$onContentChange(m.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(i),s,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(i))),n.Disposable.from(_,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(i,s,a,o,_){const m=this._editorProviders.get(s);if(!m)throw new Error(`No provider found for '${s}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${s}'`);const g=P.URI.revive(i),C=await m.provider.openCustomDocument(g,{backupId:a,untitledDocumentData:o?.buffer},_);let R;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(R=this._extensionStoragePaths.workspaceValue(m.extension)??this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(s,C,R),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(i,s){const a=this._editorProviders.get(s);if(!a)throw new Error(`No provider found for '${s}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${s}'`);const o=P.URI.revive(i),{document:_}=this.getCustomDocumentEntry(s,o);this._documents.delete(s,_),_.dispose()}async $resolveWebviewEditor(i,s,a,o,_,m){const g=this._editorProviders.get(a);if(!g)throw new Error(`No provider found for '${a}'`);const C=S.ViewColumn.to(_),R=this._extHostWebview.createNewWebview(s,o.webviewOptions,g.extension),h=this._extHostWebviewPanels.createNewWebviewPanel(s,a,o.title,C,o.panelOptions,R),b=P.URI.revive(i);switch(g.type){case 1:{const{document:f}=this.getCustomDocumentEntry(a,b);return g.provider.resolveCustomEditor(f,h,m)}case 0:{const f=this._extHostDocuments.getDocument(b);return g.provider.resolveCustomTextEditor(f,h,m)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,s,a){this.getCustomDocumentEntry(s,i).disposeEdits(a)}async $onMoveCustomEditor(i,s,a){const o=this._editorProviders.get(a);if(!o)throw new Error(`No provider found for '${a}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const _=this._extHostWebviewPanels.getWebviewPanel(i);if(!_)throw new Error("No webview found");const m=P.URI.revive(s),g=this._extHostDocuments.getDocument(m);await o.provider.moveCustomTextEditor(g,_,c.CancellationToken.None)}async $undo(i,s,a,o){return this.getCustomDocumentEntry(s,i).undo(a,o)}async $redo(i,s,a,o){return this.getCustomDocumentEntry(s,i).redo(a,o)}async $revert(i,s,a){const o=this.getCustomDocumentEntry(s,i);await this.getCustomEditorProvider(s).revertCustomDocument(o.document,a),o.disposeBackup()}async $onSave(i,s,a){const o=this.getCustomDocumentEntry(s,i);await this.getCustomEditorProvider(s).saveCustomDocument(o.document,a),o.disposeBackup()}async $onSaveAs(i,s,a,o){const _=this.getCustomDocumentEntry(s,i);return this.getCustomEditorProvider(s).saveCustomDocumentAs(_.document,P.URI.revive(a),o)}async $backup(i,s,a){const o=this.getCustomDocumentEntry(s,i),m=await this.getCustomEditorProvider(s).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},a);return o.updateBackup(m),m.id}getCustomDocumentEntry(i,s){const a=this._documents.get(i,P.URI.revive(s));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(i){const a=this._editorProviders.get(i)?.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=k;function w(D){return typeof D.resolveCustomTextEditor=="function"}function l(D){return typeof D.undo=="function"&&typeof D.redo=="function"}function v(D){const i=D.scheme===T.Schemas.file||D.scheme===T.Schemas.untitled?D.fsPath:D.toString();return(0,M.hash)(i)+""}});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[210],be([0,1,3,7,2,36,8,49,5,6]),function(re,e,c,M,E,T,A,P,S,I){"use strict";var t,y,n,d,r,u,p,k,w,l,v,D,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends M.Disposable{constructor(m,g,C,R,h,b,f){super();t.set(this,void 0),y.set(this,void 0),n.set(this,void 0),d.set(this,void 0),r.set(this,void 0),u.set(this,void 0),p.set(this,void 0),k.set(this,void 0),w.set(this,!0),l.set(this,!0),v.set(this,!1),D.set(this,this._register(new c.Emitter)),this.onDidDispose=Oe(this,D,"f").event,i.set(this,this._register(new c.Emitter)),this.onDidChangeViewState=Oe(this,i,"f").event,et(this,t,m,"f"),et(this,y,g,"f"),et(this,n,C,"f"),et(this,r,b,"f"),et(this,k,h,"f"),et(this,u,R,"f"),et(this,d,f,"f")}dispose(){Oe(this,v,"f")||(et(this,v,!0,"f"),Oe(this,D,"f").fire(),Oe(this,y,"f").$disposeWebview(Oe(this,t,"f")),Oe(this,d,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,d,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,n,"f")}get title(){return this.assertNotDisposed(),Oe(this,u,"f")}set title(m){this.assertNotDisposed(),Oe(this,u,"f")!==m&&(et(this,u,m,"f"),Oe(this,y,"f").$setTitle(Oe(this,t,"f"),m))}get iconPath(){return this.assertNotDisposed(),Oe(this,p,"f")}set iconPath(m){this.assertNotDisposed(),Oe(this,p,"f")!==m&&(et(this,p,m,"f"),Oe(this,y,"f").$setIconPath(Oe(this,t,"f"),E.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Oe(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,k,"f")=="number"&&Oe(this,k,"f")<0))return Oe(this,k,"f")}get active(){return this.assertNotDisposed(),Oe(this,l,"f")}get visible(){return this.assertNotDisposed(),Oe(this,w,"f")}_updateViewState(m){Oe(this,v,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(et(this,l,m.active,"f"),et(this,w,m.visible,"f"),et(this,k,m.viewColumn,"f"),Oe(this,i,"f").fire({webviewPanel:this}))}reveal(m,g){this.assertNotDisposed(),Oe(this,y,"f").$reveal(Oe(this,t,"f"),{viewColumn:m?A.ViewColumn.from(m):void 0,preserveFocus:!!g})}assertNotDisposed(){if(Oe(this,v,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,y=new WeakMap,n=new WeakMap,d=new WeakMap,r=new WeakMap,u=new WeakMap,p=new WeakMap,k=new WeakMap,w=new WeakMap,l=new WeakMap,v=new WeakMap,D=new WeakMap,i=new WeakMap;class a{constructor(m,g,C){this.webviews=g,this.workspace=C,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=m.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(m,g,C,R,h={}){const b=typeof R=="object"?R.viewColumn:R,f={viewColumn:A.ViewColumn.from(b),preserveFocus:typeof R=="object"&&!!R.preserveFocus},F=(0,P.shouldSerializeBuffersForPostMessage)(m),O=a.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(m),O,g,{title:C,panelOptions:o(h),webviewOptions:(0,P.serializeWebviewOptions)(m,this.workspace,h),serializeBuffersForPostMessage:F},f);const q=this.webviews.createNewWebview(O,h,m);return this.createNewWebviewPanel(O,g,C,b,h,q)}$onDidChangeWebviewPanelViewStates(m){const g=Object.keys(m);g.sort((C,R)=>{const h=m[C],b=m[R];return h.active?1:b.active?-1:+h.visible-+b.visible});for(const C of g){const R=this.getWebviewPanel(C);if(!R)continue;const h=m[C];R._updateViewState({active:h.active,visible:h.visible,viewColumn:A.ViewColumn.to(h.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this._webviewPanels.delete(m),this.webviews.deleteWebview(m)}registerWebviewPanelSerializer(m,g,C){if(this._serializers.has(g))throw new Error(`Serializer for '${g}' already registered`);return this._serializers.set(g,{serializer:C,extension:m}),this._proxy.$registerSerializer(g,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(m)}),new I.Disposable(()=>{this._serializers.delete(g),this._proxy.$unregisterSerializer(g)})}async $deserializeWebviewPanel(m,g,C,R){const h=this._serializers.get(g);if(!h)throw new Error(`No serializer found for '${g}'`);const{serializer:b,extension:f}=h,F=this.webviews.createNewWebview(m,C.webviewOptions,f),O=this.createNewWebviewPanel(m,g,C.title,R,C.panelOptions,F);await b.deserializeWebviewPanel(O,C.state)}createNewWebviewPanel(m,g,C,R,h,b){const f=new s(m,this._proxy,g,C,R,h,b);return this._webviewPanels.set(m,f),f}getWebviewPanel(m){return this._webviewPanels.get(m)}}e.ExtHostWebviewPanels=a;function o(_){return{enableFindWidget:_.enableFindWidget,retainContextWhenHidden:_.retainContextWhenHidden}}});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[211],be([0,1,3,7,49,5,6]),function(re,e,c,M,E,T,A){"use strict";var P,S,I,t,y,n,d,r,u,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class k extends M.Disposable{constructor(v,D,i,s,a,o){super();P.set(this,void 0),S.set(this,void 0),I.set(this,void 0),t.set(this,void 0),y.set(this,!1),n.set(this,void 0),d.set(this,void 0),r.set(this,void 0),u.set(this,this._register(new c.Emitter)),this.onDidChangeVisibility=Oe(this,u,"f").event,p.set(this,this._register(new c.Emitter)),this.onDidDispose=Oe(this,p,"f").event,et(this,I,i,"f"),et(this,d,s,"f"),et(this,P,v,"f"),et(this,S,D,"f"),et(this,t,a,"f"),et(this,n,o,"f")}dispose(){Oe(this,y,"f")||(et(this,y,!0,"f"),Oe(this,p,"f").fire(),Oe(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,d,"f")}set title(v){this.assertNotDisposed(),Oe(this,d,"f")!==v&&(et(this,d,v,"f"),Oe(this,S,"f").$setWebviewViewTitle(Oe(this,P,"f"),v))}get description(){return this.assertNotDisposed(),Oe(this,r,"f")}set description(v){this.assertNotDisposed(),Oe(this,r,"f")!==v&&(et(this,r,v,"f"),Oe(this,S,"f").$setWebviewViewDescription(Oe(this,P,"f"),v))}get visible(){return Oe(this,n,"f")}get webview(){return Oe(this,t,"f")}get viewType(){return Oe(this,I,"f")}_setVisible(v){v===Oe(this,n,"f")||Oe(this,y,"f")||(et(this,n,v,"f"),Oe(this,u,"f").fire())}show(v){this.assertNotDisposed(),Oe(this,S,"f").$show(Oe(this,P,"f"),!!v)}assertNotDisposed(){if(Oe(this,y,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,S=new WeakMap,I=new WeakMap,t=new WeakMap,y=new WeakMap,n=new WeakMap,d=new WeakMap,r=new WeakMap,u=new WeakMap,p=new WeakMap;class w{constructor(v,D){this._extHostWebview=D,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=v.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(v,D,i,s){if(this._viewProviders.has(D))throw new Error(`View provider for '${D}' already registered`);return this._viewProviders.set(D,{provider:i,extension:v}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(v),D,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(D),this._proxy.$unregisterWebviewViewProvider(D)})}async $resolveWebviewView(v,D,i,s,a){const o=this._viewProviders.get(D);if(!o)throw new Error(`No view provider found for '${D}'`);const{provider:_,extension:m}=o,g=this._extHostWebview.createNewWebview(v,{},m),C=new k(v,this._proxy,D,i,g,!0);this._webviewViews.set(v,C),await _.resolveWebviewView(C,{state:s},a)}async $onDidChangeWebviewViewVisibility(v,D){this.getWebviewView(v)._setVisible(D)}async $disposeWebviewView(v){const D=this.getWebviewView(v);this._webviewViews.delete(v),D.dispose(),this._extHostWebview.deleteWebview(v)}getWebviewView(v){const D=this._webviewViews.get(v);if(!D)throw new Error("No webview found");return D}}e.ExtHostWebviewViews=w}),define(we[97],be([0,1,3,5,2,11,9,4,12]),function(re,e,c,M,E,T,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class Ui{constructor(y){this._onDidChangeWindowState=new c.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ui.InitialState,this._proxy=y.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,n){let d;if(typeof y=="string"){d=y;try{y=E.URI.parse(y)}catch(r){return Promise.reject(`Invalid uri - '${y}'`)}}return(0,A.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,d,n)}async asExternalUri(y,n){if((0,A.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this._proxy.$asExternalUri(y,n);return E.URI.from(d)}};I.InitialState={focused:!0},I=Ue([ze(0,S.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(we[212],be([0,1,14,5,29,12]),function(re,e,c,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends c.AbstractLogger{constructor(S,I){super();this._proxy=S.getProxy(M.MainContext.MainThreadLog),this._logFile=I.logFile.toJSON(),this.setLevel(I.logLevel)}$setLevel(S){this.setLevel(S)}trace(S,...I){this.getLevel()<=c.LogLevel.Trace&&this._proxy.$log(this._logFile,c.LogLevel.Trace,Array.from(arguments))}debug(S,...I){this.getLevel()<=c.LogLevel.Debug&&this._proxy.$log(this._logFile,c.LogLevel.Debug,Array.from(arguments))}info(S,...I){this.getLevel()<=c.LogLevel.Info&&this._proxy.$log(this._logFile,c.LogLevel.Info,Array.from(arguments))}warn(S,...I){this.getLevel()<=c.LogLevel.Warning&&this._proxy.$log(this._logFile,c.LogLevel.Warning,Array.from(arguments))}error(S,...I){this.getLevel()<=c.LogLevel.Error&&this._proxy.$log(this._logFile,c.LogLevel.Error,Array.from(arguments))}critical(S,...I){this.getLevel()<=c.LogLevel.Critical&&this._proxy.$log(this._logFile,c.LogLevel.Critical,Array.from(arguments))}flush(){}};A=Ue([ze(0,T.IExtHostRpcService),ze(1,E.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(we[213],be([0,1,13,23,21,15,3,7,108,179,46]),function(re,e,c,M,E,T,A,P,S,I,t){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(h,b){try{return JSON.stringify(h,b)}catch(f){return"null"}}const d="$$ref$$",r={[d]:-1};class u{constructor(b,f){this.jsonString=b,this.referencedBuffers=f}}function p(h,b=null,f=!1){const F=[];return{jsonString:(f?n:JSON.stringify)(h,(q,Q)=>{if(typeof Q=="undefined")return r;if(typeof Q=="object"){if(Q instanceof M.VSBuffer){const $=F.push(Q)-1;return{[d]:$}}if(b)return b(q,Q)}return Q}),referencedBuffers:F}}e.stringifyJsonWithBufferRefs=p;function k(h,b,f){return JSON.parse(h,(F,O)=>{if(O){const q=O[d];if(typeof q=="number")return b[q];if(f&&O.$mid===1)return f.transformIncoming(O)}return O})}e.parseJsonAndRestoreBufferRefs=k;function w(h,b){return JSON.stringify(h,b)}function l(h){return h?(b,f)=>f&&f.$mid===1?h.transformOutgoing(f):f:null}var v;(function(h){h[h.LocalSide=0]="LocalSide",h[h.OtherSide=1]="OtherSide"})(v=e.RequestInitiator||(e.RequestInitiator={}));var D;(function(h){h[h.Responsive=0]="Responsive",h[h.Unresponsive=1]="Unresponsive"})(D=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},s=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class o extends P.Disposable{constructor(b,f=null,F=null){super();this[y]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=b,this._logger=f,this._uriTransformer=F,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let O=0,q=t.ProxyIdentifier.count;O<q;O++)this._locals[O]=null,this._proxies[O]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new c.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(O=>this._receiveOneMessage(O))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(b=>{this._pendingRPCReplies[b].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(b){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(b){this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(b){this._responsiveState!==b&&(this._responsiveState=b,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(b){return this._uriTransformer?(0,S.transformIncomingURIs)(b,this._uriTransformer):b}getProxy(b){const{nid:f,sid:F}=b;return this._proxies[f]||(this._proxies[f]=this._createProxy(f,F)),this._proxies[f]}_createProxy(b,f){let F={get:(O,q)=>(typeof q=="string"&&!O[q]&&q.charCodeAt(0)===36&&(O[q]=(...Q)=>this._remoteCall(b,q,Q)),q===a?f:O[q])};return new Proxy(Object.create(null),F)}set(b,f){return this._locals[b.nid]=f,f}assertRegistered(b){for(let f=0,F=b.length;f<F;f++){const O=b[f];if(!this._locals[O.nid])throw new Error(`Missing actor ${O.sid} (isMain: ${O.isMain})`)}}_receiveOneMessage(b){if(this._isDisposed)return;const f=b.byteLength,F=_.read(b,0),O=F.readUInt8(),q=F.readUInt32();switch(O){case 1:case 2:{let{rpcId:Q,method:$,args:z}=g.deserializeRequestJSONArgs(F);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(f,q,Q,$,z,O===2);break}case 3:case 4:{let{rpcId:Q,method:$,args:z}=g.deserializeRequestMixedArgs(F);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(f,q,Q,$,z,O===4);break}case 5:{this._logger&&this._logger.logIncoming(f,q,0,"ack"),this._onDidReceiveAcknowledge(q);break}case 6:{this._receiveCancel(f,q);break}case 7:{this._receiveReply(f,q,void 0);break}case 9:{let Q=g.deserializeReplyOKJSON(F);this._uriTransformer&&(Q=(0,S.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveReply(f,q,Q);break}case 10:{const Q=g.deserializeReplyOKJSONWithBuffers(F,this._uriTransformer);this._receiveReply(f,q,Q);break}case 8:{let Q=g.deserializeReplyOKVSBuffer(F);this._receiveReply(f,q,Q);break}case 11:{let Q=g.deserializeReplyErrError(F);this._uriTransformer&&(Q=(0,S.transformIncomingURIs)(Q,this._uriTransformer)),this._receiveReplyErr(f,q,Q);break}case 12:{this._receiveReplyErr(f,q,void 0);break}default:console.error("received unexpected message"),console.error(b)}}_receiveRequest(b,f,F,O,q,Q){this._logger&&this._logger.logIncoming(b,f,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(F)}.${O}(`,q);const $=String(f);let z,N;if(Q){const j=new E.CancellationTokenSource;q.push(j.token),z=this._invokeHandler(F,O,q),N=()=>j.cancel()}else z=this._invokeHandler(F,O,q),N=i;this._cancelInvokedHandlers[$]=N;const W=g.serializeAcknowledged(f);this._logger&&this._logger.logOutgoing(W.byteLength,f,1,"ack"),this._protocol.send(W),z.then(j=>{delete this._cancelInvokedHandlers[$];const Y=g.serializeReplyOK(f,j,this._uriReplacer);this._logger&&this._logger.logOutgoing(Y.byteLength,f,1,"reply:",j),this._protocol.send(Y)},j=>{delete this._cancelInvokedHandlers[$];const Y=g.serializeReplyErr(f,j);this._logger&&this._logger.logOutgoing(Y.byteLength,f,1,"replyErr:",j),this._protocol.send(Y)})}_receiveCancel(b,f){this._logger&&this._logger.logIncoming(b,f,1,"receiveCancel");const F=String(f);this._cancelInvokedHandlers[F]&&this._cancelInvokedHandlers[F]()}_receiveReply(b,f,F){this._logger&&this._logger.logIncoming(b,f,0,"receiveReply:",F);const O=String(f);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const q=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],q.resolveOk(F)}_receiveReplyErr(b,f,F){this._logger&&this._logger.logIncoming(b,f,0,"receiveReplyErr:",F);const O=String(f);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const q=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O];let Q;F&&(F.$isError?(Q=new Error,Q.name=F.name,Q.message=F.message,Q.stack=F.stack):Q=F),q.resolveErr(Q)}_invokeHandler(b,f,F){try{return Promise.resolve(this._doInvokeHandler(b,f,F))}catch(O){return Promise.reject(O)}}_doInvokeHandler(b,f,F){const O=this._locals[b];if(!O)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(b));let q=O[f];if(typeof q!="function")throw new Error("Unknown method "+f+" on actor "+(0,t.getStringIdentifierForProxy)(b));return q.apply(O,F)}_remoteCall(b,f,F){if(this._isDisposed)return Promise.reject(T.canceled());let O=null;if(F.length>0&&E.CancellationToken.isCancellationToken(F[F.length-1])&&(O=F.pop()),O&&O.isCancellationRequested)return Promise.reject(T.canceled());const q=g.serializeRequestArguments(F,this._uriReplacer),Q=++this._lastMessageId,$=String(Q),z=new I.LazyPromise;O&&O.onCancellationRequested(()=>{const W=g.serializeCancel(Q);this._logger&&this._logger.logOutgoing(W.byteLength,Q,0,"cancel"),this._protocol.send(g.serializeCancel(Q))}),this._pendingRPCReplies[$]=z,this._onWillSendRequest(Q);const N=g.serializeRequest(Q,b,f,q,!!O);return this._logger&&this._logger.logOutgoing(N.byteLength,Q,0,`request: ${(0,t.getStringIdentifierForProxy)(b)}.${f}(`,F),this._protocol.send(N),z}}e.RPCProtocol=o,y=s,o.UNRESPONSIVE_TIME=3*1e3;class _{constructor(b,f){this._buff=b,this._offset=f}static alloc(b,f,F){let O=new _(M.VSBuffer.alloc(F+1+4),0);return O.writeUInt8(b),O.writeUInt32(f),O}static read(b,f){return new _(b,f)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(b){this._buff.writeUInt8(b,this._offset),this._offset+=1}readUInt8(){const b=this._buff.readUInt8(this._offset);return this._offset+=1,b}writeUInt32(b){this._buff.writeUInt32BE(b,this._offset),this._offset+=4}readUInt32(){const b=this._buff.readUInt32BE(this._offset);return this._offset+=4,b}static sizeShortString(b){return 1+b.byteLength}writeShortString(b){this._buff.writeUInt8(b.byteLength,this._offset),this._offset+=1,this._buff.set(b,this._offset),this._offset+=b.byteLength}readShortString(){const b=this._buff.readUInt8(this._offset);this._offset+=1;const F=this._buff.slice(this._offset,this._offset+b).toString();return this._offset+=b,F}static sizeLongString(b){return 4+b.byteLength}writeLongString(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}readLongString(){const b=this._buff.readUInt32BE(this._offset);this._offset+=4;const F=this._buff.slice(this._offset,this._offset+b).toString();return this._offset+=b,F}writeBuffer(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}static sizeVSBuffer(b){return 4+b.byteLength}writeVSBuffer(b){this._buff.writeUInt32BE(b.byteLength,this._offset),this._offset+=4,this._buff.set(b,this._offset),this._offset+=b.byteLength}readVSBuffer(){const b=this._buff.readUInt32BE(this._offset);this._offset+=4;const f=this._buff.slice(this._offset,this._offset+b);return this._offset+=b,f}static sizeMixedArray(b){let f=0;f+=1;for(let F=0,O=b.length;F<O;F++){const q=b[F];switch(f+=1,q.type){case 1:f+=this.sizeLongString(q.value);break;case 2:f+=this.sizeVSBuffer(q.value);break;case 3:f+=this.sizeUInt8(),f+=this.sizeLongString(q.value);for(let Q=0;Q<q.buffers.length;++Q)f+=this.sizeVSBuffer(q.buffers[Q]);break;case 4:break}}return f}writeMixedArray(b){this._buff.writeUInt8(b.length,this._offset),this._offset+=1;for(let f=0,F=b.length;f<F;f++){const O=b[f];switch(O.type){case 1:this.writeUInt8(1),this.writeLongString(O.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(O.value);break;case 3:this.writeUInt8(3),this.writeUInt8(O.buffers.length),this.writeLongString(O.value);for(let q=0;q<O.buffers.length;++q)this.writeBuffer(O.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const b=this._buff.readUInt8(this._offset);this._offset+=1;let f=new Array(b);for(let F=0;F<b;F++)switch(this.readUInt8()){case 1:f[F]=this.readLongString();break;case 2:f[F]=this.readVSBuffer();break;case 3:const q=this.readUInt8(),Q=this.readLongString(),$=[];for(let z=0;z<q;++z)$.push(this.readVSBuffer());f[F]=new t.SerializableObjectWithBuffers(k(Q,$,null));break;case 4:f[F]=void 0;break}return f}}var m;(function(h){h[h.Simple=0]="Simple",h[h.Mixed=1]="Mixed"})(m||(m={}));class g{static _useMixedArgSerialization(b){for(let f=0,F=b.length;f<F;f++)if(b[f]instanceof M.VSBuffer||b[f]instanceof t.SerializableObjectWithBuffers||typeof b[f]=="undefined")return!0;return!1}static serializeRequestArguments(b,f){if(this._useMixedArgSerialization(b)){const F=[];for(let O=0,q=b.length;O<q;O++){const Q=b[O];if(Q instanceof M.VSBuffer)F[O]={type:2,value:Q};else if(typeof Q=="undefined")F[O]={type:4};else if(Q instanceof t.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:z}=p(Q.value,f);F[O]={type:3,value:M.VSBuffer.fromString($),buffers:z}}else F[O]={type:1,value:M.VSBuffer.fromString(w(Q,f))}}return{type:1,args:F}}return{type:0,args:w(b,f)}}static serializeRequest(b,f,F,O,q){switch(O.type){case 0:return this._requestJSONArgs(b,f,F,O.args,q);case 1:return this._requestMixedArgs(b,f,F,O.args,q)}}static _requestJSONArgs(b,f,F,O,q){const Q=M.VSBuffer.fromString(F),$=M.VSBuffer.fromString(O);let z=0;z+=_.sizeUInt8(),z+=_.sizeShortString(Q),z+=_.sizeLongString($);let N=_.alloc(q?2:1,b,z);return N.writeUInt8(f),N.writeShortString(Q),N.writeLongString($),N.buffer}static deserializeRequestJSONArgs(b){const f=b.readUInt8(),F=b.readShortString(),O=b.readLongString();return{rpcId:f,method:F,args:JSON.parse(O)}}static _requestMixedArgs(b,f,F,O,q){const Q=M.VSBuffer.fromString(F);let $=0;$+=_.sizeUInt8(),$+=_.sizeShortString(Q),$+=_.sizeMixedArray(O);let z=_.alloc(q?4:3,b,$);return z.writeUInt8(f),z.writeShortString(Q),z.writeMixedArray(O),z.buffer}static deserializeRequestMixedArgs(b){const f=b.readUInt8(),F=b.readShortString(),O=b.readMixedArray(),q=new Array(O.length);for(let Q=0,$=O.length;Q<$;Q++){const z=O[Q];typeof z=="string"?q[Q]=JSON.parse(z):q[Q]=z}return{rpcId:f,method:F,args:q}}static serializeAcknowledged(b){return _.alloc(5,b,0).buffer}static serializeCancel(b){return _.alloc(6,b,0).buffer}static serializeReplyOK(b,f,F){if(typeof f=="undefined")return this._serializeReplyOKEmpty(b);if(f instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(b,f);if(f instanceof t.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:q}=p(f.value,F,!0);return this._serializeReplyOKJSONWithBuffers(b,O,q)}else return this._serializeReplyOKJSON(b,n(f,F))}static _serializeReplyOKEmpty(b){return _.alloc(7,b,0).buffer}static _serializeReplyOKVSBuffer(b,f){let F=0;F+=_.sizeVSBuffer(f);let O=_.alloc(8,b,F);return O.writeVSBuffer(f),O.buffer}static deserializeReplyOKVSBuffer(b){return b.readVSBuffer()}static _serializeReplyOKJSON(b,f){const F=M.VSBuffer.fromString(f);let O=0;O+=_.sizeLongString(F);let q=_.alloc(9,b,O);return q.writeLongString(F),q.buffer}static _serializeReplyOKJSONWithBuffers(b,f,F){const O=M.VSBuffer.fromString(f);let q=0;q+=_.sizeUInt8(),q+=_.sizeLongString(O);for(const $ of F)q+=_.sizeVSBuffer($);let Q=_.alloc(10,b,q);Q.writeUInt8(F.length),Q.writeLongString(O);for(const $ of F)Q.writeBuffer($);return Q.buffer}static deserializeReplyOKJSON(b){const f=b.readLongString();return JSON.parse(f)}static deserializeReplyOKJSONWithBuffers(b,f){const F=b.readUInt8(),O=b.readLongString(),q=[];for(let Q=0;Q<F;++Q)q.push(b.readVSBuffer());return new t.SerializableObjectWithBuffers(k(O,q,f))}static serializeReplyErr(b,f){return f?this._serializeReplyErrEror(b,f):this._serializeReplyErrEmpty(b)}static _serializeReplyErrEror(b,f){const F=M.VSBuffer.fromString(n(T.transformErrorForSerialization(f),null));let O=0;O+=_.sizeLongString(F);let q=_.alloc(11,b,O);return q.writeLongString(F),q.buffer}static deserializeReplyErrError(b){const f=b.readLongString();return JSON.parse(f)}static _serializeReplyErrEmpty(b){return _.alloc(12,b,0).buffer}}var C;(function(h){h[h.RequestJSONArgs=1]="RequestJSONArgs",h[h.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",h[h.RequestMixedArgs=3]="RequestMixedArgs",h[h.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",h[h.Acknowledged=5]="Acknowledged",h[h.Cancel=6]="Cancel",h[h.ReplyOKEmpty=7]="ReplyOKEmpty",h[h.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",h[h.ReplyOKJSON=9]="ReplyOKJSON",h[h.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",h[h.ReplyErrError=11]="ReplyErrError",h[h.ReplyErrEmpty=12]="ReplyErrEmpty"})(C||(C={}));var R;(function(h){h[h.String=1]="String",h[h.VSBuffer=2]="VSBuffer",h[h.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",h[h.Undefined=4]="Undefined"})(R||(R={}))}),define(we[214],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const c=function(T){const A=P=>{self.removeEventListener("message",A);const S=P.data;Object.defineProperties(self,{postMessage:{value(I,t){S.postMessage(I,t)}},onmessage:{get(){return S.onmessage},set(I){S.onmessage=I}}}),S.addEventListener("message",I=>{self.dispatchEvent(new MessageEvent("message",{data:I.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",A)}.toString();class M extends EventTarget{constructor(T,A,P){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${c})('${A}'))`,I=new Blob([S],{type:"application/javascript"}),t=URL.createObjectURL(I),y=new MessageChannel,n=t,d={type:"_newWorker",id:n,port:y.port2,url:t,options:P};T(d,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:n};y.port1.postMessage(r),URL.revokeObjectURL(t),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(r){y.port1.onmessage=r}},onmessageerror:{get(){return y.port1.onmessageerror},set(r){y.port1.onmessageerror=r}}}),y.port1.addEventListener("messageerror",r=>{const u=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(u)}),y.port1.addEventListener("message",r=>{const u=new MessageEvent("message",{data:r.data});this.dispatchEvent(u)}),y.port1.start()}}e.NestedWorker=M}),define(we[215],be([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(we[216],be([0,1,11,17,26,2,4,86,44,175,215]),function(re,e,c,M,E,T,A,P,S,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,A.createDecorator)("pathService");let y=class $i{constructor(d,r,u,p){this.localUserHome=d,this.remoteAgentService=r,this.environmentService=u,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||E.OS)(),this.resolveUserHome=(async()=>{const k=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=k?.userHome||d})()}get defaultUriScheme(){return $i.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,r){if(d.remoteAuthority)return c.Schemas.vscodeRemote;const u=(0,P.getVirtualWorkspaceScheme)(r.getWorkspace());if(u)return u;const p=r.getWorkspace().folders[0];if(p)return p.uri.scheme;const k=r.getWorkspace().configuration;return k?k.scheme:c.Schemas.file}async userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?M.win32:M.posix)}async fileURI(d){let r="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const p=d.indexOf("/",2);p===-1?(r=d.substring(2),d="/"):(r=d.substring(2,p),d=d.substring(p)||"/")}return T.URI.from({scheme:c.Schemas.file,authority:r,path:d,query:"",fragment:""})}};y=Ue([ze(1,t.IRemoteAgentService),ze(2,I.IWorkbenchEnvironmentService),ze(3,S.IWorkspaceContextService)],y),e.AbstractPathService=y}),define(we[98],be([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(A,P){this.line=A,this.character=P}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,P){return new c(0,0)}with(A){return new c(0,0)}}e.Position=c;class M{constructor(A,P,S,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(A,P),this.end=new c(S,I)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new M(0,0,0,0)}with(A){return new M(0,0,0,0)}}e.Range=M;var E;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[38],be([0,1,16,27,22,40,9,4,17,15,98,10]),function(re,e,c,M,E,T,A,P,S,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",d=" characters skipped \u27EB",r=(n.length+d.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var u;(function(W){W[W.file=0]="file",W[W.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var p;(function(W){W[W.File=1]="File",W[W.Text=2]="Text"})(p=e.QueryType||(e.QueryType={}));function k(W){return!!W.preview}e.resultIsMatch=k;function w(W){return!!W.resource}e.isFileMatch=w;function l(W){return!!W.message}e.isProgressMessage=l;var v;(function(W){W[W.Normal=0]="Normal",W[W.NewSearchStarted=1]="NewSearchStarted"})(v=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class D{constructor(j){this.resource=j,this.results=[]}}e.FileMatch=D;class i{constructor(j,Y,de){this.ranges=Y;const G=Array.isArray(Y)?Y:[Y];if(de&&de.matchLines===1&&s(G)){j=(0,A.getNLines)(j,de.matchLines);let ue="",oe=0,Ee=0;const Te=Math.floor(de.charsPerLine/5),Re=[];for(const Ne of G){const Qe=Math.max(Ne.startColumn-Te,0),He=Ne.startColumn+de.charsPerLine;if(Qe>Ee+Te+r){const qe=n+(Qe-Ee)+d;ue+=qe+j.slice(Qe,He),oe+=Qe-(Ee+qe.length)}else ue+=j.slice(Ee,He);Re.push(new o(0,Ne.startColumn-oe,Ne.endColumn-oe)),Ee=He}this.preview={text:ue,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const ue=Array.isArray(Y)?Y[0].startLineNumber:Y.startLineNumber;this.preview={text:j,matches:(0,c.mapArrayOrNot)(Y,oe=>new a(oe.startLineNumber-ue,oe.startColumn,oe.endLineNumber-ue,oe.endColumn))}}}}e.TextSearchMatch=i;function s(W){const j=W[0].startLineNumber;for(const Y of W)if(Y.startLineNumber!==j||Y.endLineNumber!==j)return!1;return!0}class a{constructor(j,Y,de,G){this.startLineNumber=j,this.startColumn=Y,this.endLineNumber=de,this.endColumn=G}}e.SearchRange=a;class o extends a{constructor(j,Y,de){super(j,Y,j,de)}}e.OneLineRange=o;var _;(function(W){W.Default="default",W.FileNames="fileNames",W.Type="type",W.Modified="modified",W.CountDescending="countDescending",W.CountAscending="countAscending"})(_=e.SearchSortOrder||(e.SearchSortOrder={}));function m(W,j=!0){const Y=W&&W.files&&W.files.exclude,de=j&&W&&W.search&&W.search.exclude;if(!Y&&!de)return;if(!Y||!de)return Y||de;let G=Object.create(null);return G=E.mixin(G,E.deepClone(Y)),G=E.mixin(G,E.deepClone(de),!0),G}e.getExcludes=m;function g(W,j){return W.excludePattern&&M.match(W.excludePattern,j)?!1:W.includePattern||W.usingSearchPaths?W.includePattern&&M.match(W.includePattern,j)?!0:W.usingSearchPaths?!!W.folderQueries&&W.folderQueries.some(Y=>{const de=Y.folder.fsPath;if(T.isEqualOrParent(j,de)){const G=S.relative(de,j);return!Y.includePattern||!!M.match(Y.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=g;var C;(function(W){W[W.unknownEncoding=1]="unknownEncoding",W[W.regexParseError=2]="regexParseError",W[W.globParseError=3]="globParseError",W[W.invalidLiteral=4]="invalidLiteral",W[W.rgProcessError=5]="rgProcessError",W[W.other=6]="other",W[W.canceled=7]="canceled"})(C=e.SearchErrorCode||(e.SearchErrorCode={}));class R extends Error{constructor(j,Y){super(j);this.code=Y}}e.SearchError=R;function h(W){const j=W.message;if((0,I.isPromiseCanceledError)(W))return new R(j,C.canceled);try{const Y=JSON.parse(j);return new R(Y.message,Y.code)}catch(Y){return new R(j,C.other)}}e.deserializeSearchError=h;function b(W){const j={message:W.message,code:W.code};return new Error(JSON.stringify(j))}e.serializeSearchError=b;function f(W){return W.type==="error"?!0:W.type==="success"}e.isSerializedSearchComplete=f;function F(W){return W.type==="success"}e.isSerializedSearchSuccess=F;function O(W){return!!W.path}e.isSerializedFileMatch=O;function q(W,j){const Y=W.searchPath?W.searchPath:W.relativePath;return(0,A.fuzzyContains)(Y,j)}e.isFilePatternMatch=q;class Q{constructor(j){this.path=j,this.results=[]}addMatch(j){this.results.push(j)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=Q;function $(W,j){const Y={...W||{},...j||{}};return Object.keys(Y).filter(de=>{const G=Y[de];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=$;class z{constructor(j,Y){this._parsedIncludeExpression=null,this._excludeExpression={...j.excludePattern||{},...Y.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let de=j.includePattern;Y.includePattern&&(de?de={...de,...Y.includePattern}:de=Y.includePattern),de&&(this._parsedIncludeExpression=M.parse(de))}includedInQuerySync(j,Y,de){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(j,Y,de)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(j,Y,de))}includedInQuery(j,Y,de){const G=this._parsedExcludeExpression(j,Y,de),ue=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(j,Y,de):!0;return(0,y.isPromise)(G)?G.then(oe=>oe?!1:ue()):ue()}hasSiblingExcludeClauses(){return N(this._excludeExpression)}}e.QueryGlobTester=z;function N(W){for(const j in W)if(typeof W[j]!="boolean")return!0;return!1}}),define(we[31],be([0,1,16,13,21,3,20,11,75,24,9,10,2,129,4,14,144,44,45,29,12,6,38,5]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r,u,p,k,w,l,v,D,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(b,f,F){return new I.ExtUri(O=>g(O,F)).isEqual(b,f)}function o(b,f,F){return a(b.uri,f.uri,F)?0:(0,t.compare)(b.uri.toString(),f.uri.toString())}function _(b,f,F){return b.index!==f.index?b.index<f.index?-1:1:a(b.uri,f.uri,F)?(0,t.compare)(b.name,f.name):(0,t.compare)(b.uri.toString(),f.uri.toString())}function m(b,f,F,O){const q=b.slice(0).sort(($,z)=>F($,z,O)),Q=f.slice(0).sort(($,z)=>F($,z,O));return(0,c.delta)(q,Q,($,z)=>F($,z,O))}function g(b,f){const F=f.getCapabilities(b.scheme);return!(F&&F&1024)}class C extends k.Workspace{constructor(f,F,O,q,Q,$){super(f,O.map(z=>new k.WorkspaceFolder(z)),q,$);this._name=F,this._isUntitled=Q,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris($),O.forEach(z=>{this._workspaceFolders.push(z),this._structure.set(z.uri,z)})}static toExtHostWorkspace(f,F,O,q){if(!f)return{workspace:null,added:[],removed:[]};const{id:Q,name:$,folders:z,configuration:N,isUntitled:W}=f,j=[],Y=F;F?z.forEach((oe,Ee)=>{const Te=n.URI.revive(oe.uri),Re=C._findFolder(O||F,Te,q);Re?(Re.name=oe.name,Re.index=oe.index,j.push(Re)):j.push({uri:Te,name:oe.name,index:Ee})}):j.push(...z.map(({uri:oe,name:Ee,index:Te})=>({uri:n.URI.revive(oe),name:Ee,index:Te}))),j.sort((oe,Ee)=>oe.index<Ee.index?-1:1);const de=new C(Q,$,j,N?n.URI.revive(N):null,!!W,oe=>g(oe,q)),{added:G,removed:ue}=m(Y?Y.workspaceFolders:[],de.workspaceFolders,o,q);return{workspace:de,added:G,removed:ue}}static _findFolder(f,F,O){for(let q=0;q<f.folders.length;q++){const Q=f.workspaceFolders[q];if(a(Q.uri,F,O))return Q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(f,F){return F&&this._structure.get(f)&&(f=(0,I.dirname)(f)),this._structure.findSubstr(f)}resolveWorkspaceFolder(f){return this._structure.get(f)}}let R=class{constructor(f,F,O,q){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=q,this._extHostFileSystemInfo=O,this._requestIdProvider=new S.Counter,this._barrier=new M.Barrier,this._proxy=f.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=f.getProxy(s.MainContext.MainThreadMessageService);const Q=F.workspace;this._confirmedWorkspace=Q?new C(Q.id,Q.name,[],Q.configuration?n.URI.revive(Q.configuration):null,!!Q.isUntitled,$=>g($,O)):void 0}$initializeWorkspace(f,F){this._trusted=F,this.$acceptWorkspaceData(f),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:P.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(f,F,O,...q){const Q=[];if(Array.isArray(q)&&q.forEach(j=>{n.URI.isUri(j.uri)&&!Q.some(Y=>a(Y.uri,j.uri,this._extHostFileSystemInfo))&&Q.push({uri:j.uri,name:j.name||(0,I.basenameOrAuthority)(j.uri)})}),this._unconfirmedWorkspace||[F,O].some(j=>typeof j!="number"||j<0)||O===0&&Q.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(F+O>$.length)return!1;const z=$.slice(0);z.splice(F,O,...Q.map(j=>({uri:j.uri,name:j.name||(0,I.basenameOrAuthority)(j.uri),index:void 0})));for(let j=0;j<z.length;j++){const Y=z[j];if(z.some((de,G)=>G!==j&&a(Y.uri,de.uri,this._extHostFileSystemInfo)))return!1}z.forEach((j,Y)=>j.index=Y);const{added:N,removed:W}=m($,z,_,this._extHostFileSystemInfo);if(N.length===0&&W.length===0)return!1;if(this._proxy){const j=f.displayName||f.name;this._proxy.$updateWorkspaceFolders(j,F,O,Q).then(void 0,Y=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,d.localize)(0,null,j,Y.toString()),{extension:f},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(f,F){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(f,F)}async getWorkspaceFolder2(f,F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(f,F)}async resolveWorkspaceFolder(f){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(f)}getPath(){if(!this._actualWorkspace)return;const{folders:f}=this._actualWorkspace;if(f.length!==0)return f[0].uri.fsPath}getRelativePath(f,F){let O,q="";if(typeof f=="string"?(O=n.URI.file(f),q=f):typeof f!="undefined"&&(O=f,q=f.fsPath),!O)return q;const Q=this.getWorkspaceFolder(O,!0);if(!Q)return q;typeof F=="undefined"&&this._actualWorkspace&&(F=this._actualWorkspace.folders.length>1);let $=(0,I.relativePath)(Q.uri,O);return F&&Q.name&&($=`${Q.name}/${$}`),$}trySetWorkspaceFolders(f){this._actualWorkspace&&(this._unconfirmedWorkspace=C.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:f,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(f){const{workspace:F,added:O,removed:q}=C.toExtHostWorkspace(f,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=F||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:q}))}findFiles(f,F,O,q,Q=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${q.value}, entryPoint: findFiles`);let $;if(F===null?$=!1:F&&(typeof F=="string"?$=F:$=F.pattern),Q&&Q.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:N}=h(f);return this._proxy.$startFileSearch((0,y.withUndefinedAsNull)(z),(0,y.withUndefinedAsNull)(N),(0,y.withUndefinedAsNull)($),(0,y.withUndefinedAsNull)(O),Q).then(W=>Array.isArray(W)?W.map(j=>n.URI.revive(j)):[])}async findTextInFiles(f,F,O,q,Q=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${q.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),z=typeof F.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:N,folder:W}=h(F.include),j=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,Y={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:z,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:N,excludePattern:j},de=!1;if(this._activeSearchCallbacks[$]=G=>{if(de)return;const ue=n.URI.revive(G.resource);G.results.forEach(oe=>{(0,i.resultIsMatch)(oe)?O({uri:ue,preview:{text:oe.preview.text,matches:(0,c.mapArrayOrNot)(oe.preview.matches,Ee=>new D.Range(Ee.startLineNumber,Ee.startColumn,Ee.endLineNumber,Ee.endColumn))},ranges:(0,c.mapArrayOrNot)(oe.ranges,Ee=>new D.Range(Ee.startLineNumber,Ee.startColumn,Ee.endLineNumber,Ee.endColumn))}):O({uri:ue,text:oe.text,lineNumber:oe.lineNumber})})},Q.isCancellationRequested)return{};try{const G=await this._proxy.$startTextSearch(f,(0,y.withUndefinedAsNull)(W),Y,$,Q);return delete this._activeSearchCallbacks[$],G||{}}catch(G){throw delete this._activeSearchCallbacks[$],G}}$handleTextSearchResult(f,F){this._activeSearchCallbacks[F]&&this._activeSearchCallbacks[F](f)}saveAll(f){return this._proxy.$saveAll(f)}resolveProxy(f){return this._proxy.$resolveProxy(f)}get trusted(){return this._trusted}requestWorkspaceTrust(f){return this._proxy.$requestWorkspaceTrust(f)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};R=Ue([ze(0,v.IExtHostRpcService),ze(1,l.IExtHostInitDataService),ze(2,w.IExtHostFileSystemInfo),ze(3,u.ILogService)],R),e.ExtHostWorkspace=R,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function h(b){let f,F;return b&&(typeof b=="string"?f=b:(f=b.pattern,F=b.baseFolder||n.URI.file(b.base))),{includePattern:f,folder:F}}}),define(we[32],be([0,1,22,3,31,5,6,147,61,10,13,4,12,14,2]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(s,a){if(a){const o=a.split(".");let _=s;for(let m=0;_&&m<o.length;m++)_=_[o[m]];return _}}function p(s){return s instanceof r.URI}function k(s){return s&&s.uri instanceof r.URI&&s.languageId&&typeof s.languageId=="string"}function w(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function l(s){return s&&s.uri instanceof r.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function v(s){if(p(s))return{resource:s};if(k(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(w(s))return{overrideIdentifier:s.languageId};if(l(s))return{resource:s.uri};if(s===null)return{resource:null}}let D=class{constructor(a,o,_){this._proxy=a.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=_,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new i(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,o){this.getConfigProvider().then(_=>_.$acceptConfigurationChanged(a,o))}};D=Ue([ze(0,n.IExtHostRpcService),ze(1,E.IExtHostWorkspace),ze(2,d.ILogService)],D),e.ExtHostConfiguration=D;class i{constructor(a,o,_,m){this._onDidChangeConfiguration=new M.Emitter,this._proxy=a,this._logService=m,this._extHostWorkspace=o,this._configuration=P.Configuration.parse(_),this._configurationScopes=this._toMap(_.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,o){const _={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,_))}getConfiguration(a,o,_){const m=v(o)||{},g=this._toReadonlyValue(a?u(this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,m,_?.identifier);function C(h){if(h==null)return null;if(typeof h=="boolean")return h?1:4;switch(h){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const R={has(h){return typeof u(g,h)!="undefined"},get:(h,b)=>{this._validateConfigurationAccess(a?`${a}.${h}`:h,m,_?.identifier);let f=u(g,h);if(typeof f=="undefined")f=b;else{let F;const O=(q,Q)=>{let $;const z=()=>{F=F||(0,c.deepClone)(g),$=$||u(F,Q)};return(0,I.isObject)(q)?new Proxy(q,{get:(N,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return z(),()=>$;if(F)return $=$||u(F,Q),$[W];const j=N[W];return typeof W=="string"?O(j,`${Q}.${W}`):j},set:(N,W,j)=>(z(),$&&($[W]=j),!0),deleteProperty:(N,W)=>(z(),$&&delete $[W],!0),defineProperty:(N,W,j)=>(z(),$&&Object.defineProperty($,W,j),!0)}):q};f=O(f,h)}return f},update:(h,b,f,F)=>{h=a?`${a}.${h}`:h;const O=C(f);return b!==void 0?this._proxy.$updateConfigurationOption(O,h,b,m,F):this._proxy.$removeConfigurationOption(O,h,m,F)},inspect:h=>{h=a?`${a}.${h}`:h;const b=(0,c.deepClone)(this._configuration.inspect(h,m,this._extHostWorkspace.workspace));if(b)return{key:h,defaultValue:b.default?.value,globalValue:b.user?.value,workspaceValue:b.workspace?.value,workspaceFolderValue:b.workspaceFolder?.value,defaultLanguageValue:b.default?.override,globalLanguageValue:b.user?.override,workspaceLanguageValue:b.workspace?.override,workspaceFolderLanguageValue:b.workspaceFolder?.override,languageIds:b.overrideIdentifiers}}};return typeof g=="object"&&(0,c.mixin)(R,g,!1),Object.freeze(R)}_toReadonlyValue(a){const o=_=>(0,I.isObject)(_)?new Proxy(_,{get:(m,g)=>o(m[g]),set:(m,g,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(m,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(m,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):_;return o(a)}_validateConfigurationAccess(a,o,_){const m=S.OVERRIDE_PROPERTY_PATTERN.test(a)?4:this._configurationScopes.get(a),g=_?`[${_.value}] `:"";if(m===4){typeof o?.resource=="undefined"&&this._logService.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){o?.resource&&this._logService.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,o){const _=new P.ConfigurationChangeEvent(a,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(m,g)=>_.affectsConfiguration(m,v(g))})}_toMap(a){return a.reduce((o,_)=>(o.set(_[0],_[1]),o),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[99],be([0,1,2,13,3,5,6,31,48,32,21,37,12,29,4,11,26,14,70,165,15]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r,u,p,k,w,l,v){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(Q){function $(N){if(N!=null)return N}Q.from=$;function z(N){if(N!=null)return N}Q.to=z})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var s;(function(Q){function $(N){if(N!=null)return N}Q.from=$;function z(N){if(N!=null)return N}Q.to=z})(s=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var a;(function(Q){function $(N){if(N!=null)return N}Q.from=$;function z(N){if(N!=null)return N}Q.to=z})(a=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var o;(function(Q){function $(W){if(W){const j=W;return j&&!!j.process}else return!1}Q.is=$;function z(W){if(W==null)return;const j={process:W.process,args:W.args};return W.options&&(j.options=a.from(W.options)),j}Q.from=z;function N(W){if(W!=null)return new A.ProcessExecution(W.process,W.args,W.options)}Q.to=N})(o=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var _;(function(Q){function $(N){if(N!=null)return N}Q.from=$;function z(N){if(N!=null)return N}Q.to=z})(_=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var m;(function(Q){function $(W){if(W){const j=W;return j&&(!!j.commandLine||!!j.command)}else return!1}Q.is=$;function z(W){if(W==null)return;const j={};return W.commandLine!==void 0?j.commandLine=W.commandLine:(j.command=W.command,j.args=W.args),W.options&&(j.options=_.from(W.options)),j}Q.from=z;function N(W){if(!(W==null||W.command===void 0&&W.commandLine===void 0))return W.commandLine?new A.ShellExecution(W.commandLine,W.options):new A.ShellExecution(W.command,W.args?W.args:[],W.options)}Q.to=N})(m=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var g;(function(Q){function $(W){if(W){let j=W;return j&&j.customExecution==="customExecution"}else return!1}Q.is=$;function z(W){return{customExecution:"customExecution"}}Q.from=z;function N(W,j){return j.get(W)}Q.to=N})(g=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var C;(function(Q){function $(z,N){let W;return z.scope!==void 0&&typeof z.scope!="number"?W=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===A.TaskScope.Workspace&&N&&N.workspaceFile?W=N.workspaceFile:W=l.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:W}}Q.from=$})(C=e.TaskHandleDTO||(e.TaskHandleDTO={}));var R;(function(Q){function $(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}Q.from=$})(R=e.TaskGroupDTO||(e.TaskGroupDTO={}));var h;(function(Q){function $(W,j){if(W==null)return[];const Y=[];for(let de of W){const G=z(de,j);G&&Y.push(G)}return Y}Q.fromMany=$;function z(W,j){if(W==null)return;let Y;W.execution instanceof A.ProcessExecution?Y=o.from(W.execution):W.execution instanceof A.ShellExecution?Y=m.from(W.execution):W.execution&&W.execution instanceof A.CustomExecution&&(Y=g.from(W.execution));const de=i.from(W.definition);let G;return W.scope?typeof W.scope=="number"?G=W.scope:G=W.scope.uri:G=A.TaskScope.Workspace,!de||!G?void 0:{_id:W._id,definition:de,name:W.name,source:{extensionId:j.identifier.value,label:W.source,scope:G},execution:Y,isBackground:W.isBackground,group:R.from(W.group),presentationOptions:s.from(W.presentationOptions),problemMatchers:W.problemMatchers,hasDefinedMatchers:W.hasDefinedMatchers,runOptions:W.runOptions?W.runOptions:{reevaluateOnRerun:!0},detail:W.detail}}Q.from=z;async function N(W,j,Y){if(W==null)return;let de;o.is(W.execution)?de=o.to(W.execution):m.is(W.execution)?de=m.to(W.execution):g.is(W.execution)&&(de=g.to(W._id,Y));const G=i.to(W.definition);let ue;if(W.source&&(W.source.scope!==void 0?typeof W.source.scope=="number"?ue=W.source.scope:ue=await j.resolveWorkspaceFolder(c.URI.revive(W.source.scope)):ue=A.TaskScope.Workspace),!G||!ue)return;const oe=new A.Task(G,ue,W.name,W.source.label,de,W.problemMatchers);return W.isBackground!==void 0&&(oe.isBackground=W.isBackground),W.group!==void 0&&(oe.group=A.TaskGroup.from(W.group._id),oe.group&&(oe.group=new A.TaskGroup(oe.group.id,oe.group.label),W.group.isDefault&&(oe.group.isDefault=W.group.isDefault))),W.presentationOptions&&(oe.presentationOptions=s.to(W.presentationOptions)),W._id&&(oe._id=W._id),W.detail&&(oe.detail=W.detail),oe}Q.to=N})(h=e.TaskDTO||(e.TaskDTO={}));var b;(function(Q){function $(N){return N}Q.from=$;function z(N){if(!!N)return Object.assign(Object.create(null),N)}Q.to=z})(b=e.TaskFilterDTO||(e.TaskFilterDTO={}));class f{constructor($,z,N){this._id=z,this._task=N,D.set(this,void 0),et(this,D,$,"f")}get task(){return this._task}terminate(){Oe(this,D,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}D=new WeakMap;var F;(function(Q){function $(z){return{id:z._id,task:void 0}}Q.from=$})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let O=class{constructor($,z,N,W,j,Y,de,G){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=$.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=W,this._configurationService=j,this._terminalService=Y,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=de,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider($,z,N){if(!N)return new A.Disposable(()=>{});const W=this.nextHandle();return this._handlers.set(W,{type:z,provider:N,extension:$}),this._proxy.$registerTaskProvider(W,z),new A.Disposable(()=>{this._handlers.delete(W),this._proxy.$unregisterTaskProvider(W)})}registerTaskSystem($,z){this._proxy.$registerTaskSystem($,z)}fetchTasks($){return this._proxy.$fetchTasks(b.from($)).then(async z=>{const N=[];for(let W of z){const j=await h.to(W,this._workspaceProvider,this._providedCustomExecutions2);j&&N.push(j)}return N})}get taskExecutions(){const $=[];return this._taskExecutions.forEach(z=>$.push(z)),$}terminateTask($){if(!($ instanceof f))throw new Error("No valid task execution provided");return this._proxy.$terminateTask($._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask($,z,N){const W=this._providedCustomExecutions2.get($.id);if(W){if(this._activeCustomExecutions2.get($.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set($.id,W),this._terminalService.attachPtyToTerminal(z,await W.callback(N))}this._lastStartedTask=$.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution($)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask($){const z=await this.getTaskExecution($);this._taskExecutionPromises.delete($.id),this._taskExecutions.delete($.id),this.customExecutionComplete($),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess($){const z=await this.getTaskExecution($.id);this._onDidTaskProcessStarted.fire({execution:z,processId:$.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess($){const z=await this.getTaskExecution($.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:$.exitCode})}$provideTasks($,z){const N=this._handlers.get($);if(!N)return Promise.reject(new Error("no handler found"));const W=[],j=(0,M.asPromise)(()=>N.provider.provideTasks(t.CancellationToken.None)).then(Y=>this.provideTasksInternal(z,W,N,Y));return new Promise(Y=>{j.then(de=>{Promise.all(W).then(()=>{Y(de)})})})}async $resolveTask($,z){const N=this._handlers.get($);if(!N)return Promise.reject(new Error("no handler found"));if(z.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${N.type}].`);const W=await h.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!W)throw new Error("Unexpected: Task cannot be resolved.");const j=await N.provider.resolveTask(W,t.CancellationToken.None);if(!j)return;this.checkDeprecation(j,N);const Y=h.from(j,N.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==W.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(Y.execution)&&await this.addCustomExecution(Y,j,!0),await this.resolveTaskInternal(Y)}nextHandle(){return this._handleCounter++}async addCustomExecution($,z,N){const W=await this._proxy.$createTaskId($);!N&&!this._providedCustomExecutions2.has(W)&&this._notProvidedCustomExecutions.add(W),this._providedCustomExecutions2.set(W,z.execution)}async getTaskExecution($,z){if(typeof $=="string"){const j=this._taskExecutionPromises.get($);if(!j)throw new Error("Unexpected: The specified task is missing an execution");return j}let N=this._taskExecutionPromises.get($.id);if(N)return N;const W=new Promise(async(j,Y)=>{const de=z||await h.to($.task,this._workspaceProvider,this._providedCustomExecutions2);de?j(new f(this,$.id,de)):Y("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set($.id,W),W.then(j=>(this._taskExecutions.set($.id,j),j),j=>Promise.reject(j))}checkDeprecation($,z){$._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete($){this._activeCustomExecutions2.get($.id)&&this._activeCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.has($.id)&&this._lastStartedTask!==$.id&&(this._providedCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.delete($.id));let N=this._notProvidedCustomExecutions.values(),W=N.next();for(;!W.done;)!this._activeCustomExecutions2.has(W.value)&&this._lastStartedTask!==W.value&&(this._providedCustomExecutions2.delete(W.value),this._notProvidedCustomExecutions.delete(W.value)),W=N.next()}};O=Ue([ze(0,n.IExtHostRpcService),ze(1,d.IExtHostInitDataService),ze(2,P.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,y.IExtHostTerminalService),ze(6,k.ILogService),ze(7,w.IExtHostApiDeprecationService)],O),e.ExtHostTaskBase=O;let q=class extends O{constructor($,z,N,W,j,Y,de,G){super($,z,N,W,j,Y,de,G);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask($,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const N=h.from(z,$);if(N===void 0)throw new Error("Task is not valid");if(g.is(N.execution))await this.addCustomExecution(N,z,!1);else throw new v.NotSupportedError;const W=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),z);return this._proxy.$executeTask(N).catch(j=>{throw new Error(j)}),W}provideTasksInternal($,z,N,W){const j=[];if(W)for(let Y of W){this.checkDeprecation(Y,N),(!Y.definition||!$[Y.definition.type])&&this._logService.warn(`The task [${Y.source}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`);const de=h.from(Y,N.extension);de&&g.is(de.execution)?(j.push(de),z.push(this.addCustomExecution(de,Y,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:j,extension:N.extension}}async resolveTaskInternal($){if(g.is($.execution))return $;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables($,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,z,N){}};q=Ue([ze(0,n.IExtHostRpcService),ze(1,d.IExtHostInitDataService),ze(2,P.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,y.IExtHostTerminalService),ze(6,k.ILogService),ze(7,w.IExtHostApiDeprecationService)],q),e.WorkerExtHostTask=q,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")}),define(we[217],be([0,1,16,50,27,77,20,11,17,24,9,10,2,110,133,84,44,92,216,38]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r,u,p,k,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=class{constructor(C,R,h,b){this.configurationService=C,this.workspaceContextService=R,this.editorGroupsService=h,this.pathService=b}text(C,R,h={}){C=this.getContentPattern(C,h);const b=this.configurationService.getValue(),f=R&&R.some(O=>!this.configurationService.getValue({resource:O}).search.useRipgrep);return{...this.commonQuery(R?.map(p.toWorkspaceFolder),h),type:2,contentPattern:C,previewOptions:h.previewOptions,maxFileSize:h.maxFileSize,usePCRE2:b.search.usePCRE2||f||!1,beforeContext:h.beforeContext,afterContext:h.afterContext,userDisabledExcludesAndIgnoreFiles:h.disregardExcludeSettings&&h.disregardIgnoreFiles}}getContentPattern(C,R){const h=this.configurationService.getValue();C.isRegExp&&(C.pattern=C.pattern.replace(/\r?\n/g,"\\n"));const b={...C,wordSeparators:h.editor.wordSeparators};return this.isCaseSensitive(C,R)&&(b.isCaseSensitive=!0),this.isMultiline(C)&&(b.isMultiline=!0),b}file(C,R={}){return{...this.commonQuery(C,R),type:1,filePattern:R.filePattern?R.filePattern.trim():R.filePattern,exists:R.exists,sortByScore:R.sortByScore,cacheKey:R.cacheKey}}handleIncludeExclude(C,R){return C?(C=Array.isArray(C)?C.map(o):o(C),R?this.parseSearchPaths(C):{pattern:i(...Array.isArray(C)?C:[C])}):{}}commonQuery(C=[],R={}){const h=this.handleIncludeExclude(R.includePattern,R.expandPatterns),b=this.handleIncludeExclude(R.excludePattern,R.expandPatterns),f=C.length>1,F=(h.searchPaths&&h.searchPaths.length?h.searchPaths.map(Q=>this.getFolderQueryForSearchPath(Q,R,b)):C.map(Q=>this.getFolderQueryForRoot(Q,R,b,f))).filter(Q=>!!Q),O={_reason:R._reason,folderQueries:F,usingSearchPaths:!!(h.searchPaths&&h.searchPaths.length),extraFileResources:R.extraFileResources,excludePattern:b.pattern,includePattern:h.pattern,onlyOpenEditors:R.onlyOpenEditors,maxResults:R.maxResults};if(R.onlyOpenEditors){const $=c.coalesce(c.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(W=>W.resource)))).filter(N=>(0,l.pathIncludedInQuery)(O,N.fsPath)),z=this.commonQueryFromFileList($);return{...O,...z}}const q=R.extraFileResources&&R.extraFileResources.filter(Q=>(0,l.pathIncludedInQuery)(O,Q.fsPath));return O.extraFileResources=q&&q.length?q:void 0,O}commonQueryFromFileList(C){const R=[],h=new A.ResourceMap,b={};let f=!1;return C.forEach(F=>{if(F.scheme===P.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(F)){const q=this.workspaceContextService.getWorkspaceFolder(F)?.uri??F.with({path:S.dirname(F.fsPath)});let Q=h.get(q);Q||(f=!0,Q={folder:q,includePattern:{}},R.push(Q),h.set(q,Q));const $=S.relative(q.fsPath,F.fsPath);(0,y.assertIsDefined)(Q.includePattern)[$.replace(/\\/g,"/")]=!0}else F.fsPath&&(f=!0,b[F.fsPath]=!0)}),{folderQueries:R,includePattern:b,usingSearchPaths:!0,excludePattern:f?void 0:{"**/*":!0}}}isCaseSensitive(C,R){if(R.isSmartCase){if(C.isRegExp){if(t.containsUppercaseCharacter(C.pattern,!0))return!0}else if(t.containsUppercaseCharacter(C.pattern))return!0}return!!C.isCaseSensitive}isMultiline(C){return C.isMultiline||C.isRegExp&&(0,d.isMultilineRegexSource)(C.pattern)||C.pattern.indexOf(`
`)>=0?!0:!!C.isMultiline}parseSearchPaths(C){const R=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),b=(Array.isArray(C)?C:s(C)).map(z=>{const N=this.pathService.resolvedUserHome;return N?(0,T.untildify)(z,N.scheme===P.Schemas.file?N.fsPath:N.path):z}),f=M.groupBy(b,z=>R(z)?"searchPaths":"exprSegments"),F=(f.exprSegments||[]).map(z=>t.rtrim(z,"/")).map(z=>t.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),a(z))),O={},q=this.expandSearchPathPatterns(f.searchPaths||[]);q&&q.length&&(O.searchPaths=q);const Q=c.flatten(F),$=i(...Q);return $&&(O.pattern=$),O}getExcludesForFolder(C,R){return R.disregardExcludeSettings?void 0:(0,l.getExcludes)(C,!R.disregardSearchExcludeSettings)}expandSearchPathPatterns(C){if(!C||!C.length)return[];const R=c.flatten(C.map(b=>{let{pathPortion:f,globPortion:F}=D(b);F&&(F=_(F));const O=this.expandOneSearchPath(f);return c.flatten(O.map(q=>this.resolveOneSearchPathPattern(q,F)))})),h=new Map;return R.forEach(b=>{const f=b.searchPath.toString(),F=h.get(f);F?b.pattern&&(F.pattern=F.pattern||{},F.pattern[b.pattern]=!0):h.set(f,{searchPath:b.searchPath,pattern:b.pattern?i(b.pattern):void 0})}),Array.from(h.values())}expandOneSearchPath(C){if(S.isAbsolute(C)){const R=this.workspaceContextService.getWorkspace().folders;return R[0]&&R[0].uri.scheme!==P.Schemas.file?[{searchPath:R[0].uri.with({path:C})}]:[{searchPath:n.URI.file(S.normalize(C))}]}if(this.workspaceContextService.getWorkbenchState()===2){const R=this.workspaceContextService.getWorkspace().folders[0].uri;if(C=o(C),C.startsWith("../")||C===".."){const b=S.posix.resolve(R.path,C);return[{searchPath:R.with({path:b})}]}const h=_(C);return[{searchPath:R,pattern:h}]}else{if(C==="./"||C===".\\")return[];{const R=C.replace(/^\.[\/\\]/,""),b=this.workspaceContextService.getWorkspace().folders.map(f=>{const F=R.match(new RegExp(`^${t.escapeRegExpCharacters(f.name)}(?:/(.*)|$)`));return F?{match:F,folder:f}:null}).filter(y.isDefined);if(b.length)return b.map(f=>{const F=f.match[1];return{searchPath:f.folder.uri,pattern:F&&_(F)}});{const f=C.match(/\.[\/\\](.+)[\/\\]?/),F=f?f[1]:C,O=r.localize(0,null,F);throw new Error(O)}}}}resolveOneSearchPathPattern(C,R){const h=C.pattern&&R?`${C.pattern}/${R}`:C.pattern||R,b=[{searchPath:C.searchPath,pattern:h}];return h&&!h.endsWith("**")&&b.push({searchPath:C.searchPath,pattern:h+"/**"}),b}getFolderQueryForSearchPath(C,R,h){const b=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(C.searchPath),R,h,!1);return b?{...b,includePattern:C.pattern}:null}getFolderQueryForRoot(C,R,h,b){let f;const F=n.URI.isUri(C)?C:C.uri;if(h.searchPaths){const z=h.searchPaths.filter(N=>(0,I.isEqual)(N.searchPath,F))[0];if(z&&!z.pattern)return null;z&&(f=z.pattern)}const O=this.configurationService.getValue({resource:F}),Q={...this.getExcludesForFolder(O,R)||{},...f||{}},$=n.URI.isUri(C)?(0,I.basename)(C):C.name;return{folder:F,folderName:b?$:void 0,excludePattern:Object.keys(Q).length>0?Q:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof R.disregardIgnoreFiles=="boolean"?R.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof R.disregardGlobalIgnoreFiles=="boolean"?R.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof R.ignoreSymlinks=="boolean"?R.ignoreSymlinks:!O.search.followSymlinks}}};v=Ue([ze(0,u.IConfigurationService),ze(1,p.IWorkspaceContextService),ze(2,k.IEditorGroupsService),ze(3,w.IPathService)],v),e.QueryBuilder=v;function D(g){const C=g.match(/[\*\{\}\(\)\[\]\?]/);if(C){const R=C.index,h=g.substr(0,R).match(/[/|\\][^/\\]*$/);if(h){let b=g.substr(0,h.index);return b.match(/[/\\]/)||(b+="/"),{pathPortion:b,globPortion:g.substr((h.index||0)+1)}}}return{pathPortion:g}}function i(...g){return g.length?g.reduce((C,R)=>(C[R]=!0,C),Object.create(null)):void 0}function s(g){return E.splitGlobAware(g,",").map(C=>C.trim()).filter(C=>!!C.length)}function a(g){return[`**/${g}/**`,`**/${g}`].map(R=>R.replace(/\*\*\/\*\*/g,"**"))}function o(g){return g.replace(/\\/g,"/")}function _(g){return o(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function m(g,C){g=c.distinct(g,b=>b.toString());const R=[],h=C.getWorkspace();return g&&g.forEach(b=>{let f;if(C.getWorkbenchState()===2)f=(0,I.relativePath)(h.folders[0].uri,b),f&&f!=="."&&(f="./"+f);else{const F=C.getWorkspaceFolder(b);if(F){const O=F.name;if(h.folders.filter(Q=>Q.name===O).length===1){const Q=(0,I.relativePath)(F.uri,b);Q===""?f=`./${F.name}`:f=`./${F.name}/${Q}`}else f=b.fsPath}}f&&R.push(f)}),R}e.resolveResourcesForSearchIncludes=m}),define(we[218],be([0,1,24,2,21,15,4,217,38,44]),function(re,e,c,M,E,T,A,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function y(u,p){const k=p.activationEvents;if(!k)return Promise.resolve(void 0);const w=[],l=[];for(const o of k)if(/^workspaceContains:/.test(o)){const _=o.substr("workspaceContains:".length);_.indexOf("*")>=0||_.indexOf("?")>=0||u.forceUsingSearch?l.push(_):w.push(_)}if(w.length===0&&l.length===0)return Promise.resolve(void 0);let v;const D=new Promise((o,_)=>{v=o}),i=o=>v({activationEvent:o}),s=Promise.all(w.map(o=>n(u,o,i))).then(()=>{}),a=d(u,p.identifier,l,i);return Promise.all([s,a]).then(()=>{v(void 0)}),D}e.checkActivateWorkspaceContainsExtension=y;async function n(u,p,k){for(const w of u.folders)if(await u.exists(c.joinPath(M.URI.revive(w),p))){k(`workspaceContains:${p}`);return}}async function d(u,p,k,w){if(k.length===0)return Promise.resolve(void 0);const l=new E.CancellationTokenSource,v=u.checkExists(u.folders,k,l.token),D=setTimeout(async()=>{l.cancel(),w(`workspaceContainsTimeout:${k.join(",")}`)},t);let i=!1;try{i=await v}catch(s){T.isPromiseCanceledError(s)||T.onUnexpectedError(s)}l.dispose(),clearTimeout(D),i&&w(`workspaceContains:${k.join(",")}`)}function r(u,p,k,w){const l=u.get(A.IInstantiationService),v=u.get(S.ISearchService),i=l.createInstance(P.QueryBuilder).file(p.map(s=>(0,I.toWorkspaceFolder)(M.URI.revive(s))),{_reason:"checkExists",includePattern:k,exists:!0});return v.fileSearch(i,w).then(s=>!!s.limitHit,s=>T.isPromiseCanceledError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=r});var et=this&&this.__classPrivateFieldSet||function(re,e,c,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,c):E?E.value=c:e.set(re,c),c},Oe=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[33],be([0,1,124,17,74,24,13,7,20,2,14,5,32,178,72,31,30,176,15,25,23,152,6,85,4,29,73,12,60,65,37,3,218,69,154]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r,u,p,k,w,l,v,D,i,s,a,o,_,m,g,C,R,h,b,f,F){"use strict";var O,q,Q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let $=class Wi extends P.Disposable{constructor(j,Y,de,G,ue,oe,Ee,Te,Re,Ne){super();this._onDidChangeRemoteConnectionData=this._register(new h.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Y,this._extHostContext=de,this._initData=Ee,this._extHostWorkspace=G,this._extHostConfiguration=ue,this._logService=oe,this._extHostTunnelService=Re,this._extHostTerminalService=Ne,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new k.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new f.ExtHostSecretState(this._extHostContext),this._storagePath=Te,this._instaService=j.createChild(new g.ServiceCollection([r.IExtHostStorage,this._storage],[f.IExtHostSecretState,this._secretState]));const Qe=new Set;this._initData.hostExtensions.forEach(He=>Qe.add(l.ExtensionIdentifier.toKey(He))),this._activator=new d.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(He,qe,B)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(He,w.transformErrorForSerialization(qe),B)},actualActivateExtension:async(He,qe)=>{if(Qe.has(l.ExtensionIdentifier.toKey(He)))return await this._mainThreadExtensionsProxy.$activateExtension(He,qe),new d.HostExtension;const B=this._registry.getExtensionDescription(He);return this._activateExtension(B,qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(j){w.onUnexpectedError(j)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let j=[];try{j=this._registry.getAllExtensionDescriptions().map(ue=>ue.identifier).filter(ue=>this.isActivated(ue)).map(ue=>this._deactivate(ue))}catch(Y){}await Promise.all(j)}isActivated(j){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(j):!1}_activateByEvent(j,Y){return this._activator.activateByEvent(j,Y)}_activateById(j,Y){return this._activator.activateById(j,Y)}activateByIdWithErrors(j,Y){return this._activateById(j,Y).then(()=>{const de=this._activator.getActivatedExtension(j);if(de.activationFailed)return Promise.reject(de.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(j=>this._registry)}getExtensionExports(j){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(j).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const j=S.TernarySearchTree.forPaths(),Y=this._registry.getAllExtensionDescriptions().map(de=>{if(!!this._getEntryPoint(de))return this._hostUtils.realpath(de.extensionLocation.fsPath).then(G=>j.set(I.URI.file(G).fsPath,de))});this._extensionPathIndex=Promise.all(Y).then(()=>j)}return this._extensionPathIndex}_deactivate(j){let Y=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(j))return Y;const de=this._activator.getActivatedExtension(j);if(!de)return Y;try{typeof de.module.deactivate=="function"&&(Y=Promise.resolve(de.module.deactivate()).then(void 0,G=>(this._logService.error(G),Promise.resolve(void 0))))}catch(G){this._logService.error(G)}try{(0,P.dispose)(de.subscriptions)}catch(G){this._logService.error(G)}return Y}async _activateExtension(j,Y){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier),this._doActivateExtension(j,Y).then(de=>{const G=de.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(j.identifier,G.codeLoadingTime,G.activateCallTime,G.activateResolvedTime,Y),this._logExtensionActivationTimes(j,Y,"success",G),de},de=>{throw this._logExtensionActivationTimes(j,Y,"failure"),de})}_logExtensionActivationTimes(j,Y,de,G){const ue=z(j,Y);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ue,...G||{},outcome:de})}_doActivateExtension(j,Y){const de=z(j,Y);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",de);const G=this._getEntryPoint(j);if(!G)return Promise.resolve(new d.EmptyExtension(d.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${j.identifier.value} ${JSON.stringify(Y)}`),this._logService.flush();const ue=new d.ExtensionActivationTimesBuilder(Y.startup);return Promise.all([this._loadCommonJSModule(j.identifier,(0,T.joinPath)(j.extensionLocation,G),ue),this._loadExtensionContext(j)]).then(oe=>(E.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),Wi._callActivate(this._logService,j.identifier,oe[0],oe[1],ue))).then(oe=>(E.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),oe))}_loadExtensionContext(j){const Y=new D.ExtensionGlobalMemento(j,this._storage),de=new D.ExtensionMemento(j.identifier.value,!1,this._storage),G=new F.ExtensionSecrets(j,this._secretState),ue=j.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,oe=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([Y.whenReady,de.whenReady,this._storagePath.whenReady]).then(()=>{const Ee=this;let Te;return Object.freeze({globalState:Y,workspaceState:de,secrets:G,subscriptions:[],get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(Re){return M.join(j.extensionLocation.fsPath,Re)},get storagePath(){return Ee._storagePath.workspaceValue(j)?.fsPath},get globalStoragePath(){return Ee._storagePath.globalValue(j).fsPath},get logPath(){return M.join(Ee._initData.logsLocation.fsPath,j.identifier.value)},get logUri(){return I.URI.joinPath(Ee._initData.logsLocation,j.identifier.value)},get storageUri(){return Ee._storagePath.workspaceValue(j)},get globalStorageUri(){return Ee._storagePath.globalValue(j)},get extensionMode(){return ue},get extension(){return Te===void 0&&(Te=new N(Ee,j.identifier,j,oe)),Te},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(j),Ee.extensionRuntime},get environmentVariableCollection(){return Ee._extHostTerminalService.getEnvironmentVariableCollection(j)}})})}static _callActivate(j,Y,de,G,ue){return de=de||{activate:void 0,deactivate:void 0},this._callActivateOptional(j,Y,de,G,ue).then(oe=>new d.ActivatedExtension(!1,null,ue.build(),de,oe,G.subscriptions))}static _callActivateOptional(j,Y,de,G,ue){if(typeof de.activate=="function")try{ue.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const oe=typeof global=="object"?global:self,Ee=de.activate.apply(oe,[G]);return ue.activateCallStop(),ue.activateResolveStart(),Promise.resolve(Ee).then(Te=>(ue.activateResolveStop(),Te))}catch(oe){return Promise.reject(oe)}else return Promise.resolve(de)}_activateOneStartupFinished(j,Y){this._activateById(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:Y}).then(void 0,de=>{this._logService.error(de)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const j of this._registry.getAllExtensionDescriptions())if(j.activationEvents)for(const Y of j.activationEvents)Y==="onStartupFinished"&&this._activateOneStartupFinished(j,Y)}_handleEagerExtensions(){const j=this._activateByEvent("*",!0).then(void 0,ue=>{this._logService.error(ue)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ue=>this._handleWorkspaceContainsEagerExtensions(ue.added)));const Y=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],de=this._handleWorkspaceContainsEagerExtensions(Y),G=Promise.all([j,de]).then(()=>{});return Promise.race([G,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),G}_handleWorkspaceContainsEagerExtensions(j){return j.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Y=>this._handleWorkspaceContainsEagerExtension(j,Y))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(j,Y){if(this.isActivated(Y.identifier))return;const de=!this._initData.remote.isRemote&&!!this._initData.remote.authority,G={folders:j.map(oe=>oe.uri),forceUsingSearch:de,exists:oe=>this._hostUtils.exists(oe.fsPath),checkExists:(oe,Ee,Te)=>this._mainThreadWorkspaceProxy.$checkExists(oe,Ee,Te)},ue=await(0,b.checkActivateWorkspaceContainsExtension)(G,Y);if(!!ue)return this._activateById(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:ue.activationEvent}).then(void 0,oe=>this._logService.error(oe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(j){throw console.error(j),j}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:Y}=this._initData.environment;if(!j||!Y)throw new Error(c.localize(0,null));const de=await this._loadCommonJSModule(null,Y,new d.ExtensionActivationTimesBuilder(!1));if(!de||typeof de.run!="function")throw new Error(c.localize(1,null,Y.toString()));return new Promise((G,ue)=>{const oe=(Re,Ne)=>{Re?ue(Re):G(typeof Ne=="number"&&Ne>0?1:0)},Ee=(0,T.originalFSPath)(Y),Te=de.run(Ee,oe);Te&&Te.then&&Te.then(()=>{G(0)}).catch(Re=>{ue(Re.toString())})})}async $extensionTestsExit(j){this._logService.info(`extension host terminating: test runner requested exit with code ${j}`),this._logService.info(`exiting with code ${j}`),this._logService.flush(),this._hostUtils.exit(j)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(j,Y){return this._resolvers[j]=Y,(0,P.toDisposable)(()=>{delete this._resolvers[j]})}async _activateAndGetResolver(j){const Y=j.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const de=j.substr(0,Y);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${de}`,!1),{authorityPrefix:de,resolver:this._resolvers[de]}}async $resolveAuthority(j,Y){const{authorityPrefix:de,resolver:G}=await this._activateAndGetResolver(j);if(!G)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${de}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(G)),E.mark(`code/extHost/willResolveAuthority/${de}`);const ue=await G.resolve(j,{resolveAttempt:Y});E.mark(`code/extHost/didResolveAuthorityOK/${de}`);const oe={authority:j,host:ue.host,port:ue.port,connectionToken:ue.connectionToken},Ee={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted};return{type:"ok",value:{authority:oe,options:Ee,tunnelInformation:{environmentTunnels:ue.environmentTunnels}}}}catch(ue){if(E.mark(`code/extHost/didResolveAuthorityError/${de}`),ue instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ue._code,message:ue._message,detail:ue._detail}};throw ue}}async $getCanonicalURI(j,Y){const{authorityPrefix:de,resolver:G}=await this._activateAndGetResolver(j);if(!G)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${de}`);const ue=I.URI.revive(Y);if(typeof G.getCanonicalURI=="undefined")return ue;const oe=await(0,A.asPromise)(()=>G.getCanonicalURI(ue));return oe||ue}$startExtensionHost(j){return this._registry.keepOnly(j),this._startExtensionHost()}$activateByEvent(j,Y){return Y===1?this._activateByEvent(j,!1):this._readyToRunExtensions.wait().then(de=>this._activateByEvent(j,!1))}async $activate(j,Y){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(j)?(await this._activateById(j,Y),!0):!1}async $deltaExtensions(j,Y){j.forEach(G=>G.extensionLocation=I.URI.revive(G.extensionLocation));const de=await this.getExtensionPathIndex();return await Promise.all(Y.map(async G=>{const ue=this._registry.getExtensionDescription(G);if(!ue)return;const oe=await this._hostUtils.realpath(ue.extensionLocation.fsPath);de.delete(I.URI.file(oe).fsPath)})),await Promise.all(j.map(async G=>{const ue=await this._hostUtils.realpath(G.extensionLocation.fsPath);de.set(I.URI.file(ue).fsPath,G)})),this._registry.deltaExtensions(j,Y),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){let Y=v.VSBuffer.alloc(j),de=Math.random()%256;for(let G=0;G<j;G++)Y.writeUInt8(de,G);return Y}async $updateRemoteConnectionData(j){this._remoteConnectionData=j,this._onDidChangeRemoteConnectionData.fire()}};$=Ue([ze(0,a.IInstantiationService),ze(1,e.IHostUtils),ze(2,m.IExtHostRpcService),ze(3,u.IExtHostWorkspace),ze(4,n.IExtHostConfiguration),ze(5,t.ILogService),ze(6,o.IExtHostInitDataService),ze(7,_.IExtensionStoragePaths),ze(8,C.IExtHostTunnelService),ze(9,R.IExtHostTerminalService)],$),e.AbstractExtHostExtensionService=$;function z(W,j){return{id:W.identifier.value,name:W.name,extensionVersion:W.version,publisherDisplayName:W.publisher,activationEvents:W.activationEvents?W.activationEvents.join(","):null,isBuiltin:W.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class N{constructor(j,Y,de,G){O.set(this,void 0),q.set(this,void 0),Q.set(this,void 0),et(this,O,j,"f"),et(this,q,Y,"f"),et(this,Q,de.identifier,"f"),this.id=de.identifier.value,this.extensionUri=de.extensionLocation,this.extensionPath=M.normalize((0,T.originalFSPath)(de.extensionLocation)),this.packageJSON=de,this.extensionKind=G}get isActive(){return Oe(this,O,"f").isActivated(Oe(this,Q,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,O,"f").getExtensionExports(Oe(this,Q,"f"))}activate(){return Oe(this,O,"f").activateByIdWithErrors(Oe(this,Q,"f"),{startup:!1,extensionId:Oe(this,q,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=N,O=new WeakMap,q=new WeakMap,Q=new WeakMap}),define(we[100],be([0,1,17,2,3,13,5,6,162,31,33,48,167,32,163,12,4,10,91,63]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r,u,p,k,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let v=class{constructor(g,C,R,h,b,f){this._workspaceService=C,this._extensionService=R,this._editorsService=h,this._configurationService=b,this._editorTabs=f,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=g.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(O=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(g,C){const R=g;if(typeof R.sourceReference=="number"&&R.sourceReference>0){let h=`debug:${encodeURIComponent(R.path||"")}`,b="?";return C&&(h+=`${b}session=${encodeURIComponent(C.id)}`,b="&"),h+=`${b}ref=${R.sourceReference}`,M.URI.parse(h)}else{if(R.path)return M.URI.file(R.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(g){const C=[];for(const R of g.getAllExtensionDescriptions())if(R.contributes){const h=R.contributes.debuggers;if(h&&h.length>0)for(const b of h)(0,r.isDebuggerMainContribution)(b)&&C.push(b.type)}this._debugServiceProxy.$registerDebugTypes(C)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const g=[];return this._breakpoints.forEach(C=>g.push(C)),g}addBreakpoints(g){this.startBreakpoints();const C=g.filter(b=>{const f=b.id;return this._breakpoints.has(f)?!1:(this._breakpoints.set(f,b),!0)});this.fireBreakpointChanges(C,[],[]);const R=[],h=new Map;for(const b of C)if(b instanceof P.SourceBreakpoint){let f=h.get(b.location.uri.toString());f||(f={type:"sourceMulti",uri:b.location.uri,lines:[]},h.set(b.location.uri.toString(),f),R.push(f)),f.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character})}else b instanceof P.FunctionBreakpoint&&R.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName});return this._debugServiceProxy.$registerBreakpoints(R)}removeBreakpoints(g){this.startBreakpoints();const C=g.filter(f=>this._breakpoints.delete(f.id));this.fireBreakpointChanges([],C,[]);const R=C.filter(f=>f instanceof P.SourceBreakpoint).map(f=>f.id),h=C.filter(f=>f instanceof P.FunctionBreakpoint).map(f=>f.id),b=C.filter(f=>f instanceof P.DataBreakpoint).map(f=>f.id);return this._debugServiceProxy.$unregisterBreakpoints(R,h,b)}startDebugging(g,C,R){return this._debugServiceProxy.$startDebugging(g?g.uri:void 0,C,{parentSessionID:R.parentSession?R.parentSession.id:void 0,lifecycleManagedByParent:R.lifecycleManagedByParent,repl:R.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:R.noDebug,compact:R.compact,debugUI:R.debugUI})}stopDebugging(g){return this._debugServiceProxy.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,C,R){if(!C)return new P.Disposable(()=>{});const h=this._configProviderHandleCounter++;return this._configProviders.push({type:g,handle:h,provider:C}),this._debugServiceProxy.$registerDebugConfigurationProvider(g,R,!!C.provideDebugConfigurations,!!C.resolveDebugConfiguration,!!C.resolveDebugConfigurationWithSubstitutedVariables,h),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(b=>b.provider!==C),this._debugServiceProxy.$unregisterDebugConfigurationProvider(h)})}registerDebugAdapterDescriptorFactory(g,C,R){if(!R)return new P.Disposable(()=>{});if(!this.definesDebugType(g,C))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${C}' debugger.`);if(this.getAdapterDescriptorFactoryByType(C))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const h=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:C,handle:h,factory:R}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(C,h),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(b=>b.factory!==R),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(h)})}registerDebugAdapterTrackerFactory(g,C){if(!C)return new P.Disposable(()=>{});const R=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:g,handle:R,factory:C}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(h=>h.factory!==C)})}async $runInTerminal(g,C){return Promise.resolve(void 0)}async $substituteVariables(g,C){if(!this._variableResolver){const[b,f]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(b||[],this._editorsService,f)}let R;const h=await this.getFolder(g);return h&&(R={uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(R,C)}createDebugAdapter(g,C){if(g.type==="implementation")return new o(g.implementation)}createSignService(){}async $startDASession(g,C){const R=this,h=await this.getSession(C);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(h.type),h).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}' (extension might have failed to activate)`);const f=this.convertToDto(b),F=this.createDebugAdapter(f,h);if(!F)throw new Error(`Couldn't create a debug adapter for type '${h.type}'.`);const O=F;return this._debugAdapters.set(g,O),this.getDebugAdapterTrackers(h).then(q=>(q&&this._debugAdaptersTrackers.set(g,q),O.onMessage(async Q=>{if(Q.type==="request"&&Q.command==="handshake"){const $=Q,z={type:"response",seq:0,command:$.command,request_seq:$.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign($.arguments.value);z.body={signature:N},O.sendResponse(z)}else throw new Error("no signer")}catch(N){z.success=!1,z.message=N.message,O.sendResponse(z)}}else q&&q.onDidSendMessage&&q.onDidSendMessage(Q),Q=(0,r.convertToVSCPaths)(Q,!0),R._debugServiceProxy.$acceptDAMessage(g,Q)}),O.onError(Q=>{q&&q.onError&&q.onError(Q),this._debugServiceProxy.$acceptDAError(g,Q.name,Q.message,Q.stack)}),O.onExit(Q=>{q&&q.onExit&&q.onExit((0,k.withNullAsUndefined)(Q),void 0),this._debugServiceProxy.$acceptDAExit(g,(0,k.withNullAsUndefined)(Q),void 0)}),q&&q.onWillStartSession&&q.onWillStartSession(),O.startSession()))})}$sendDAMessage(g,C){C=(0,r.convertToDAPaths)(C,!1);const R=this._debugAdaptersTrackers.get(g);R&&R.onWillReceiveMessage&&R.onWillReceiveMessage(C);const h=this._debugAdapters.get(g);h&&h.sendMessage(C)}$stopDASession(g){const C=this._debugAdaptersTrackers.get(g);this._debugAdaptersTrackers.delete(g),C&&C.onWillStopSession&&C.onWillStopSession();const R=this._debugAdapters.get(g);return this._debugAdapters.delete(g),R?R.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const C=[],R=[],h=[];if(g.added)for(const b of g.added){const f=b.id;if(f&&!this._breakpoints.has(f)){let F;if(b.type==="function")F=new P.FunctionBreakpoint(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage);else if(b.type==="data")F=new P.DataBreakpoint(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage);else{const O=M.URI.revive(b.uri);F=new P.SourceBreakpoint(new P.Location(O,new P.Position(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage)}F._id=f,this._breakpoints.set(f,F),C.push(F)}}if(g.removed)for(const b of g.removed){const f=this._breakpoints.get(b);f&&(this._breakpoints.delete(b),R.push(f))}if(g.changed){for(const b of g.changed)if(b.id){const f=this._breakpoints.get(b.id);if(f){if(f instanceof P.FunctionBreakpoint&&b.type==="function"){const F=f;F.enabled=b.enabled,F.condition=b.condition,F.hitCondition=b.hitCondition,F.logMessage=b.logMessage,F.functionName=b.functionName}else if(f instanceof P.SourceBreakpoint&&b.type==="source"){const F=f;F.enabled=b.enabled,F.condition=b.condition,F.hitCondition=b.hitCondition,F.logMessage=b.logMessage,F.location=new P.Location(M.URI.revive(b.uri),new P.Position(b.line,b.character))}h.push(f)}}}this.fireBreakpointChanges(C,R,h)}$provideDebugConfigurations(g,C,R){return(0,T.asPromise)(async()=>{const h=this.getConfigProviderByHandle(g);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.getFolder(C);return h.provideDebugConfigurations(b,R)}).then(h=>{if(!h)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return h})}$resolveDebugConfiguration(g,C,R,h){return(0,T.asPromise)(async()=>{const b=this.getConfigProviderByHandle(g);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const f=await this.getFolder(C);return b.resolveDebugConfiguration(f,R,h)})}$resolveDebugConfigurationWithSubstitutedVariables(g,C,R,h){return(0,T.asPromise)(async()=>{const b=this.getConfigProviderByHandle(g);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const f=await this.getFolder(C);return b.resolveDebugConfigurationWithSubstitutedVariables(f,R,h)})}async $provideDebugAdapter(g,C){const R=this.getAdapterDescriptorFactoryByHandle(g);if(!R)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const h=await this.getSession(C);return this.getAdapterDescriptor(R,h).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}'`);return this.convertToDto(b)})}async $acceptDebugSessionStarted(g){const C=await this.getSession(g);this._onDidStartDebugSession.fire(C)}async $acceptDebugSessionTerminated(g){const C=await this.getSession(g);C&&(this._onDidTerminateDebugSession.fire(C),this._debugSessions.delete(C.id))}async $acceptDebugSessionActiveChanged(g){this._activeDebugSession=g?await this.getSession(g):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(g,C){const R=await this.getSession(g);R&&R._acceptNameChanged(C)}async $acceptDebugSessionCustomEvent(g,C){const h={session:await this.getSession(g),event:C.event,body:C.body};this._onDidReceiveDebugSessionCustomEvent.fire(h)}convertToDto(g){if(g instanceof P.DebugAdapterExecutable)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof P.DebugAdapterServer)return{type:"server",port:g.port,host:g.host};if(g instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:g.path};if(g instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(g){const C=this._adapterFactories.filter(R=>R.type===g);if(C.length>0)return C[0].factory}getAdapterDescriptorFactoryByHandle(g){const C=this._adapterFactories.filter(R=>R.handle===g);if(C.length>0)return C[0].factory}getConfigProviderByHandle(g){const C=this._configProviders.filter(R=>R.handle===g);if(C.length>0)return C[0].provider}definesDebugType(g,C){if(g.contributes){const R=g.contributes.debuggers;if(R&&R.length>0){for(const h of R)if(h.label&&h.type&&h.type===C)return!0}}return!1}getDebugAdapterTrackers(g){const R=g.configuration.type,h=this._trackerFactories.filter(b=>b.type===R||b.type==="*").map(b=>(0,T.asPromise)(()=>b.factory.createDebugAdapterTracker(g)).then(f=>f,f=>null));return Promise.race([Promise.all(h).then(b=>{const f=b.filter(F=>!!F);if(f.length>0)return new a(f)}),new Promise((b,f)=>{const F=setTimeout(()=>{clearTimeout(F),f(new Error("timeout"))},1e3)})]).catch(b=>{})}async getAdapterDescriptor(g,C){const R=C.configuration.debugServer;if(typeof R=="number")return Promise.resolve(new P.DebugAdapterServer(R));if(g){const b=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>g.createDebugAdapterDescriptor(C,this.daExecutableFromPackage(C,b))).then(f=>{if(f)return f})}const h=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(C,h))}daExecutableFromPackage(g,C){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(g,C,R){(g.length>0||C.length>0||R.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:g,removed:C,changed:R}))}async getSession(g){if(g)if(typeof g=="string"){const C=this._debugSessions.get(g);if(C)return C}else{let C=this._debugSessions.get(g.id);if(!C){const R=await this.getFolder(g.folderUri),h=g.parent?this._debugSessions.get(g.parent):void 0;C=new D(this._debugServiceProxy,g.id,g.type,g.name,R,g.configuration,h),this._debugSessions.set(C.id,C),this._debugServiceProxy.$sessionCached(C.id)}return C}throw new Error("cannot find session")}getFolder(g){if(g){const C=M.URI.revive(g);return this._workspaceService.resolveWorkspaceFolder(C)}return Promise.resolve(void 0)}};v=Ue([ze(0,u.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,y.IExtHostDocumentsAndEditors),ze(4,d.IExtHostConfiguration),ze(5,l.IExtHostEditorTabs)],v),e.ExtHostDebugServiceBase=v;class D{constructor(g,C,R,h,b,f,F){this._debugServiceProxy=g,this._id=C,this._type=R,this._name=h,this._workspaceFolder=b,this._configuration=f,this._parentSession=F}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(g){this._name=g,this._debugServiceProxy.$setDebugSessionName(this._id,g)}get parentSession(){return this._parentSession}_acceptNameChanged(g){this._name=g}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(g,C){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,g,C)}getDebugProtocolBreakpoint(g){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,g.id)}}e.ExtHostDebugSession=D;class i{constructor(g){this.value=Object.freeze({append(C){g.$appendDebugConsole(C)},appendLine(C){this.append(C+`
`)}})}}e.ExtHostDebugConsole=i;class s extends n.AbstractVariableResolverService{constructor(g,C,R,h,b){function f(){if(C){const F=C.activeEditor();if(F)return F.document.uri;const O=h.tabs.filter(q=>q.isActive);if(O.length>0)return O[0].resource}}super({getFolderUri:F=>{const O=g.filter(q=>q.name===F);if(O&&O.length>0)return O[0].uri},getWorkspaceFolderCount:()=>g.length,getConfigurationValue:(F,O)=>R.getConfiguration(void 0,F).get(O),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{const F=f();if(F)return c.normalize(F.fsPath)},getWorkspaceFolderPathForFile:()=>{if(b){const F=f();if(F){const O=b.getWorkspaceFolder(F);if(O)return c.normalize(O.uri.fsPath)}}},getSelectedText:()=>{if(C){const F=C.activeEditor();if(F&&!F.selection.isEmpty)return F.document.getText(F.selection)}},getLineNumber:()=>{if(C){const F=C.activeEditor();if(F)return String(F.selection.end.line+1)}}},void 0,Promise.resolve(w.env))}}e.ExtHostVariableResolverService=s;class a{constructor(g){this.trackers=g}onWillStartSession(){this.trackers.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.trackers.forEach(C=>C.onWillReceiveMessage?C.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.trackers.forEach(C=>C.onDidSendMessage?C.onDidSendMessage(g):void 0)}onWillStopSession(){this.trackers.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.trackers.forEach(C=>C.onError?C.onError(g):void 0)}onExit(g,C){this.trackers.forEach(R=>R.onExit?R.onExit(g,C):void 0)}}class o extends S.AbstractDebugAdapter{constructor(g){super();this.implementation=g,g.onDidSendMessage(C=>{this.acceptMessage(C)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.implementation.handleMessage(g)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let _=class extends v{constructor(g,C,R,h,b,f){super(g,C,R,h,b,f)}createVariableResolver(g,C,R){return new s(g,C,R,this._editorTabs)}};_=Ue([ze(0,u.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,t.IExtHostExtensionService),ze(3,y.IExtHostDocumentsAndEditors),ze(4,d.IExtHostConfiguration),ze(5,l.IExtHostEditorTabs)],_),e.WorkerExtHostDebugService=_}),define(we[219],be([0,1,74,2,5,32,30,25,12,29,4,33,91,14]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(l,v,D,i,s,a,o){this._apiFactory=l,this._extensionRegistry=v,this._instaService=D,this._extHostConfiguration=i,this._extHostExtensionService=s,this._initData=a,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),c.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const v=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,v,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(k,v,this._initData.environment.appUriScheme))}register(l){if(Array.isArray(l.nodeModuleName))for(let v of l.nodeModuleName)this._factories.set(v,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(v=>l.alternativeModuleName(v))}};r=Ue([ze(2,t.IInstantiationService),ze(3,T.IExtHostConfiguration),ze(4,y.IExtHostExtensionService),ze(5,I.IExtHostInitDataService),ze(6,d.ILogService)],r),e.RequireInterceptor=r;class u{constructor(l,v,D,i,s){this._apiFactory=l,this._extensionPaths=v,this._extensionRegistry=D,this._configProvider=i,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(l,v){const D=this._extensionPaths.findSubstr(v.fsPath);if(D){let i=this._extApiImpl.get(P.ExtensionIdentifier.toKey(D.identifier));return i||(i=this._apiFactory(D,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(D.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((s,a)=>i+=`	${a} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${v.fsPath}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(l,v){this.nodeModuleName="keytar";const{environment:D}=v,i=l.getProxy(E.MainContext.MainThreadKeytar);if(D.appRoot){let s=D.appRoot.fsPath;n.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,a)=>i.$getPassword(s,a),setPassword:(s,a,o)=>i.$setPassword(s,a,o),deletePassword:(s,a)=>i.$deletePassword(s,a),findPassword:s=>i.$findPassword(s),findCredentials(s){return i.$findCredentials(s)}}}load(l,v){return this._impl}alternativeModuleName(l){const v=l.length;if(v<=7||!this.alternativeNames)return;const D=v-7;if((l.charAt(D)==="/"||l.charAt(D)==="\\")&&l.endsWith("keytar")&&(l=l.replace(/\\/g,"/"),this.alternativeNames.has(l)))return"keytar"}};p=Ue([ze(0,S.IExtHostRpcService),ze(1,I.IExtHostInitDataService)],p);let k=class{constructor(l,v,D){this._extensionPaths=l,this._appUriScheme=v,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=D.getProxy(E.MainContext.MainThreadTelemetry);const i=D.getProxy(E.MainContext.MainThreadWindow);this._impl=(s,a)=>{const o=M.URI.parse(s);return a?this.callOriginal(s,a):o.scheme==="http"||o.scheme==="https"?i.$openUri(o,s,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?i.$openUri(o,s,{}):this.callOriginal(s,a)}}load(l,v,D){const i=this._extensionPaths.findSubstr(v.fsPath);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=D(l),this._impl}callOriginal(l,v){return this.sendNoForwardTelemetry(),this._original(l,v)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};k=Ue([ze(2,S.IExtHostRpcService)],k)}),define(we[220],be([0,1,13,15,74,7,2,5,213,14,56,60,29,143,12,66,33,37]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r,u,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(v,D,i,s){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new S.RPCProtocol(v,null,s),D=w._transform(D,this._rpcProtocol);const a=new y.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());a.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...D}),a.set(r.IExtHostRpcService,new r.ExtHostRpcService(this._rpcProtocol)),a.set(u.IURITransformerService,new u.URITransformerService(s)),a.set(p.IHostUtils,i);const o=new d.InstantiationService(a,!0),_=o.invokeFunction(R=>R.get(k.IExtHostTerminalService));this._disposables.add(_),this._logService=o.invokeFunction(R=>R.get(I.ILogService)),E.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",D),this._extensionService=o.invokeFunction(R=>R.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const m=new WeakMap;this._extensionService.getExtensionPathIndex().then(R=>{Error.prepareStackTrace=(h,b)=>{let f="",F,O;for(const q of b)f+=`
	at ${q.toString()}`,O=q.getFileName(),!F&&O&&(F=R.findSubstr(O));return m.set(h,F),`${h.name||"Error"}: ${h.message||""}${f}`}});const g=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),C=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(R=>{const h=M.transformErrorForSerialization(R),b=m.get(R);b?g.$onExtensionRuntimeError(b.identifier,h):C.$onUnexpectedError(h)})}terminate(v){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${v}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const D=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,c.timeout)(4e3),D]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(v,D){v.extensions.forEach(s=>s.extensionLocation=A.URI.revive(D.transformIncomingURIs(s.extensionLocation))),v.environment.appRoot=A.URI.revive(D.transformIncomingURIs(v.environment.appRoot));const i=v.environment.extensionDevelopmentLocationURI;return i&&(v.environment.extensionDevelopmentLocationURI=i.map(s=>A.URI.revive(D.transformIncomingURIs(s)))),v.environment.extensionTestsLocationURI=A.URI.revive(D.transformIncomingURIs(v.environment.extensionTestsLocationURI)),v.environment.globalStorageHome=A.URI.revive(D.transformIncomingURIs(v.environment.globalStorageHome)),v.environment.workspaceStorageHome=A.URI.revive(D.transformIncomingURIs(v.environment.workspaceStorageHome)),v.logsLocation=A.URI.revive(D.transformIncomingURIs(v.logsLocation)),v.logFile=A.URI.revive(D.transformIncomingURIs(v.logFile)),v.workspace=D.transformIncomingURIs(v.workspace),v}}e.ExtensionHostMain=w}),define(we[221],be([0,1,17,21,55,27,24,194,38]),function(re,e,c,M,E,T,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(n,d,r){this.config=n,this.provider=d,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&T.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&T.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const d=this.config.folderQueries||[];return new Promise((r,u)=>{const p=k=>{this.resultCount++,n(k)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(k=>{const w=k.toString(),l=c.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,l)||this.matchFile(p,{base:k,basename:l})}),Promise.all(d.map(k=>this.searchInFolder(k,p))).then(k=>{r({limitHit:this.isLimitHit,stats:k[0]||void 0})},k=>{u(new Error((0,E.toErrorMessage)(k)))})})}async searchInFolder(n,d){const r=new M.CancellationTokenSource,u=this.getSearchOptionsForFolder(n),p=this.initDirectoryTree(),k=new S.QueryGlobTester(this.config,n),w=!k.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(r),l=P.StopWatch.create();const v=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,r.token),D=l.elapsed(),i=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(v&&v.forEach(s=>{const a=c.posix.relative(n.folder.path,s.path);if(w){const o=c.basename(s.path);this.matchFile(d,{base:n.folder,relativePath:a,basename:o});return}this.addDirectoryEntries(p,n.folder,a,d)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,k,d),{providerTime:D,postProcessTime:i.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(n){const d=(0,S.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),r=(0,S.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:r,includes:d,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},d,r,u){if(r===this.filePattern){const k=c.basename(this.filePattern);this.matchFile(u,{base:d,relativePath:this.filePattern,basename:k})}function p(k){const w=c.basename(k),l=c.dirname(k);let v=n[l];v||(v=n[l]=[],p(l)),v.push({base:d,relativePath:k,basename:w})}p(r)}matchDirectoryTree({rootEntries:n,pathToEntries:d},r,u){const p=this,k=this.filePattern;function w(l){const v=T.hasSiblingFn(()=>l.map(D=>D.basename));for(let D=0,i=l.length;D<i;D++){const s=l[D],{relativePath:a,basename:o}=s;if(!r.includedInQuerySync(a,o,k!==o?v:void 0))continue;const _=d[a];if(_)w(_);else{if(a===k)continue;p.matchFile(u,s)}if(p.isLimitHit)break}}w(n)}matchFile(n,d){(!this.includePattern||d.relativePath&&this.includePattern(d.relativePath,d.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(d))}}class t{constructor(){this.sessions=new Map}fileSearch(n,d,r,u){const p=this.getSessionTokenSource(n.cacheKey),k=new I(n,d,p&&p.token);let w=0;const l=v=>{w+=v.length,r(v.map(D=>this.rawMatchToSearchItem(D)))};return this.doSearch(k,t.BATCH_SIZE,l,u).then(v=>({limitHit:v.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:v.stats}}))}clearCache(n){const d=this.getSessionTokenSource(n);d&&d.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:A.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,d,r,u){u.onCancellationRequested(()=>{n.cancel()});const p=w=>{w&&(k.push(w),d>0&&k.length>=d&&(r(k),k=[]))};let k=[];return n.search(p).then(w=>(k.length&&r(k),w),w=>(k.length&&r(k),Promise.reject(w)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(we[222],be([0,1,16,21,55,27,11,17,24,10,2,38]),function(re,e,c,M,E,T,A,P,S,I,t,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(l,v,D,i){this.query=l,this.provider=v,this.fileUtils=D,this.processType=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,v){const D=this.query.folderQueries||[],i=new M.CancellationTokenSource;return v.onCancellationRequested(()=>i.cancel()),new Promise((s,a)=>{this.collector=new r(l);let o=!1;const _=(m,g)=>{if(!o&&!this.isLimitHit){const C=this.resultSize(m);p(m)&&typeof this.query.maxResults=="number"&&this.resultCount+C>this.query.maxResults&&(this.isLimitHit=!0,o=!0,i.cancel(),m=this.trimResultToSize(m,this.query.maxResults-this.resultCount));const R=this.resultSize(m);this.resultCount+=R,(R>0||!p(m))&&this.collector.add(m,g)}};Promise.all(D.map((m,g)=>this.searchInFolder(m,C=>_(C,g),i.token))).then(m=>{i.dispose(),this.collector.flush();const g=m.some(C=>!!C&&!!C.limitHit);s({limitHit:this.isLimitHit||g,messages:(0,c.flatten)(m.map(C=>C?.message?(0,I.isArray)(C.message)?C.message:[C.message]:[])),stats:{type:this.processType}})},m=>{i.dispose();const g=(0,E.toErrorMessage)(m);a(new Error(g))})})}resultSize(l){return p(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,v){const D=Array.isArray(l.ranges)?l.ranges:[l.ranges],i=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:D.slice(0,v),preview:{matches:i.slice(0,v),text:l.preview.text},uri:l.uri}}async searchInFolder(l,v,D){const i=new y.QueryGlobTester(this.query,l),s=[],a={report:m=>{if(!this.validateProviderResult(m))return;const g=l.folder.scheme===A.Schemas.file?T.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(m.uri))):void 0,C=S.relativePath(l.folder,m.uri);if(C){const R=i.includedInQuery(C,P.basename(C),g);(0,I.isPromise)(R)?s.push(R.then(h=>{h&&v(m)})):R&&v(m)}}},o=this.getSearchOptionsForFolder(l),_=await this.provider.provideTextSearchResults(d(this.query.contentPattern),o,a,D);return s.length&&await Promise.all(s),_}validateProviderResult(l){if(p(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const v=(0,y.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),D=(0,y.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),i={folder:t.URI.from(l.folder),excludes:D,includes:v,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=n;function d(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class r{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new k(512,v=>this.sendItems(v))}add(l,v){this._currentFileMatch&&(this._currentFolderIdx!==v||!S.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=v,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(u(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=r;function u(w){return p(w)?{preview:{matches:(0,c.mapArrayOrNot)(w.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:w.preview.text},ranges:(0,c.mapArrayOrNot)(w.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function p(w){return!!w.preview}e.extensionResultIsMatch=p;class k{constructor(l,v){this.maxBatchSize=l,this.cb=v,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,v){!l||this.addItemToBatch(l,v)}addItems(l,v){!l||this.addItemsToBatch(l,v)}addItemToBatch(l,v){this.batch.push(l),this.batchSize+=v,this.onUpdate()}addItemsToBatch(l,v){this.batch=this.batch.concat(l),this.batchSize+=v,this.onUpdate()}onUpdate(){this.totalNumberCompleted<k.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},k.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=k,k.TIMEOUT=4e3,k.START_BATCH_AFTER_COUNT=50}),define(we[101],be([0,1,7,5,4,221,12,66,14,2,222]),function(re,e,c,M,E,T,A,P,S,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let y=class{constructor(u,p,k){this.extHostRpc=u,this._uriTransformer=p,this._logService=k,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,p){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const k=this._handlePool++;return this._textSearchProvider.set(k,p),this._proxy.$registerTextSearchProvider(k,this._transformScheme(u)),(0,c.toDisposable)(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(k),this._proxy.$unregisterProvider(k)})}registerFileSearchProvider(u,p){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const k=this._handlePool++;return this._fileSearchProvider.set(k,p),this._proxy.$registerFileSearchProvider(k,this._transformScheme(u)),(0,c.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(k),this._proxy.$unregisterProvider(k)})}$provideFileSearchResults(u,p,k,w){const l=n(k),v=this._fileSearchProvider.get(u);if(v)return this._fileSearchManager.fileSearch(l,v,D=>{this._proxy.$handleFileMatch(u,p,D.map(i=>i.resource))},w);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,p,k,w){const l=this._textSearchProvider.get(u);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const v=n(k);return this.createTextSearchManager(v,l).search(i=>this._proxy.$handleTextMatch(u,p,i),w)}$enableExtensionHostSearch(){}createTextSearchManager(u,p){return new t.TextSearchManager(u,p,{readdir:k=>Promise.resolve([]),toCanonicalName:k=>k},"textSearchProvider")}};y=Ue([ze(0,A.IExtHostRpcService),ze(1,P.IURITransformerService),ze(2,S.ILogService)],y),e.ExtHostSearch=y;function n(r){return{...r,folderQueries:r.folderQueries&&r.folderQueries.map(d),extraFileResources:r.extraFileResources&&r.extraFileResources.map(u=>I.URI.revive(u))}}e.reviveQuery=n;function d(r){return{...r,folder:I.URI.revive(r.folder)}}}),define(we[223],be([0,1,21,15,3,35,2,116,79,112,54,59,5,183,182,47,184,32,185,186,187,169,188,48,33,190,170,193,195,196,96,172,201,202,203,72,37,205,173,8,6,208,49,97,31,30,50,159,192,86,95,99,100,101,14,66,12,29,197,156,65,70,180,206,155,73,71,211,209,210,181,45,204,207,69,63,87,199,98,200,11,145,198,153,191]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r,u,p,k,w,l,v,D,i,s,a,o,_,m,g,C,R,h,b,f,F,O,q,Q,$,z,N,W,j,Y,de,G,ue,oe,Ee,Te,Re,Ne,Qe,He,qe,B,K,ee,ae,V,se,fe,Ae,xe,$e,ve,Xe,H,J,he,Le,Ve,tt,ut,ht,St,Pt,dt,bt,ft,Et,Ye,Ct,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function De(Z){const le=Z.get(ee.IExtHostInitDataService),ge=Z.get(Ve.IExtHostFileSystemInfo),me=Z.get(Xe.IExtHostConsumerFileSystem),Ie=Z.get(a.IExtHostExtensionService),Be=Z.get(de.IExtHostWorkspace),Me=Z.get(Pt.IExtHostTelemetry),je=Z.get(k.IExtHostConfiguration),Je=Z.get(B.IURITransformerService),ie=Z.get(K.IExtHostRpcService),pe=Z.get(O.IExtHostStorage),ne=Z.get(ve.IExtensionStoragePaths),U=Z.get(qe.ILogService),Ce=Z.get(se.IExtHostTunnelService),Se=Z.get(fe.IExtHostApiDeprecationService),Ge=Z.get(Y.IExtHostWindow),We=Z.get(ht.IExtHostSecretState),it=Z.get(St.IExtHostEditorTabs);ie.set(n.ExtHostContext.ExtHostFileSystemInfo,ge),ie.set(n.ExtHostContext.ExtHostLogService,U),ie.set(n.ExtHostContext.ExtHostWorkspace,Be),ie.set(n.ExtHostContext.ExtHostConfiguration,je),ie.set(n.ExtHostContext.ExtHostExtensionService,Ie),ie.set(n.ExtHostContext.ExtHostStorage,pe),ie.set(n.ExtHostContext.ExtHostTunnelService,Ce),ie.set(n.ExtHostContext.ExtHostWindow,Ge),ie.set(n.ExtHostContext.ExtHostSecretState,We),ie.set(n.ExtHostContext.ExtHostTelemetry,Me),ie.set(n.ExtHostContext.ExtHostEditorTabs,it);const mt=ie.set(n.ExtHostContext.ExtHostDecorations,Z.get(Re.IExtHostDecorations)),vt=ie.set(n.ExtHostContext.ExtHostDocumentsAndEditors,Z.get(s.IExtHostDocumentsAndEditors)),nt=ie.set(n.ExtHostContext.ExtHostCommands,Z.get(u.IExtHostCommands)),ot=ie.set(n.ExtHostContext.ExtHostTerminalService,Z.get(q.IExtHostTerminalService)),lt=ie.set(n.ExtHostContext.ExtHostDebugService,Z.get(Qe.IExtHostDebugService)),Ft=ie.set(n.ExtHostContext.ExtHostSearch,Z.get(He.IExtHostSearch)),_t=ie.set(n.ExtHostContext.ExtHostTask,Z.get(Ne.IExtHostTask)),Nt=ie.set(n.ExtHostContext.ExtHostOutputService,Z.get(R.IExtHostOutputService)),ui=ie.set(n.ExtHostContext.ExtHostUrls,new W.ExtHostUrls(ie)),kt=ie.set(n.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(ie,vt)),Ut=ie.set(n.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(ie,vt,U)),ei=ie.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new D.ExtHostDocumentSaveParticipant(U,kt,ie.getProxy(n.MainContext.MainThreadBulkEdits))),gt=ie.set(n.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(ie,nt,vt,kt,ne)),Qt=ie.set(n.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(U,gt)),zt=ie.set(n.ExtHostContext.ExtHostNotebookEditors,new Ct.ExtHostNotebookEditors(U,ie,gt)),ti=ie.set(n.ExtHostContext.ExtHostNotebookKernels,new dt.ExtHostNotebookKernels(ie,le,gt,U)),ii=ie.set(n.ExtHostContext.ExtHostNotebookRenderers,new ft.ExtHostNotebookRenderers(ie,gt)),It=ie.set(n.ExtHostContext.ExtHostEditors,new Q.ExtHostEditors(ie,vt)),Yt=ie.set(n.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(ie.getProxy(n.MainContext.MainThreadTreeViews),nt,U)),vi=ie.set(n.ExtHostContext.ExtHostEditorInsets,new oe.ExtHostEditorInsets(ie.getProxy(n.MainContext.MainThreadEditorInsets),It,le)),$t=ie.set(n.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(ie,U)),ct=ie.set(n.ExtHostContext.ExtHostLanguageFeatures,new m.ExtHostLanguageFeatures(ie,Je,kt,nt,$t,U,Se)),ni=ie.set(n.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(ie,ct)),Mt=ie.set(n.ExtHostContext.ExtHostFileSystemEventService,new _.ExtHostFileSystemEventService(ie,U,vt)),Ht=ie.set(n.ExtHostContext.ExtHostQuickOpen,(0,b.createExtHostQuickOpen)(ie,Be,nt)),Jt=ie.set(n.ExtHostContext.ExtHostSCM,new f.ExtHostSCM(ie,nt,U)),ri=ie.set(n.ExtHostContext.ExtHostComments,(0,p.createExtHostComments)(ie,nt,kt)),ci=ie.set(n.ExtHostContext.ExtHostProgress,new h.ExtHostProgress(ie.getProxy(n.MainContext.MainThreadProgress))),wi=ie.set(n.ExtHostContext.ExtHosLabelService,new Ee.ExtHostLabelService(ie)),di=ie.set(n.ExtHostContext.ExtHostTheming,new V.ExtHostTheming(ie)),si=ie.set(n.ExtHostContext.ExtHostAuthentication,new Ae.ExtHostAuthentication(ie)),bi=ie.set(n.ExtHostContext.ExtHostTimeline,new xe.ExtHostTimeline(ie,nt)),Vt=ie.set(n.ExtHostContext.ExtHostWebviews,new j.ExtHostWebviews(ie,{remote:le.remote},Be,U,Se)),jt=ie.set(n.ExtHostContext.ExtHostWebviewPanels,new he.ExtHostWebviewPanels(ie,Vt,Be)),Ei=ie.set(n.ExtHostContext.ExtHostCustomEditors,new J.ExtHostCustomEditors(ie,kt,ne,Vt,jt)),_i=ie.set(n.ExtHostContext.ExtHostWebviewViews,new H.ExtHostWebviewViews(ie,Vt)),qt=ie.set(n.ExtHostContext.ExtHostTesting,new tt.ExtHostTesting(ie,nt)),yi=ie.set(n.ExtHostContext.ExtHostUriOpeners,new ut.ExtHostUriOpeners(ie));ie.set(n.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(ie,gt,vt,nt));const Xt=(0,ue.values)(n.ExtHostContext);ie.assertRegistered(Xt);const Si=new Le.ExtHostBulkEdits(ie,vt),Di=new r.ExtHostClipboard(ie),Gt=new C.ExtHostMessageService(ie,U),hi=new l.ExtHostDialogs(ie),Wt=new F.ExtHostStatusBar(ie,nt.converter),Rt=new g.ExtHostLanguages(ie,kt);return d.ExtHostApiCommands.register(nt),function(Fe,Tt,Kt){const pt=function(){let X=!Fe.isUnderDevelopment;function ce(ke){X||(U.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function ke(rt){if(Array.isArray(rt))rt.forEach(ke);else if(typeof rt=="string")ce(rt);else{const wt=rt;typeof wt.scheme=="undefined"&&ce(rt),!Fe.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,G.throwProposedApiError)(Fe)}return rt}}(),Ci={getSession(X,ce,ke){return ke?.forceNewSession&&(0,G.checkProposedApiEnabled)(Fe),si.getSession(Fe,X,ce,ke)},get onDidChangeSessions(){return si.onDidChangeSessions},registerAuthenticationProvider(X,ce,ke,rt){return si.registerAuthenticationProvider(X,ce,ke,rt)}},ki={registerCommand(X,ce,ke){return nt.registerCommand(!0,X,ce,ke)},registerTextEditorCommand(X,ce,ke){return nt.registerCommand(!0,X,(...rt)=>{const wt=It.getActiveTextEditor();if(!wt){U.warn("Cannot execute "+X+" because there is no active text editor.");return}return wt.edit(Dt=>{ce.apply(ke,[wt,Dt,...rt])}).then(Dt=>{Dt||U.warn("Edits from command "+X+" were not applied.")},Dt=>{U.warn("An error occurred while running command "+X,Dt)})})},registerDiffInformationCommand:(X,ce,ke)=>((0,G.checkProposedApiEnabled)(Fe),nt.registerCommand(!0,X,async(...rt)=>{const wt=vt.activeEditor(!0);if(!wt){U.warn("Cannot execute "+X+" because there is no active text editor.");return}const Dt=await It.getDiffInformation(wt.id);ce.apply(ke,[Dt,...rt])})),executeCommand(X,...ce){return nt.executeCommand(X,...ce)},getCommands(X=!1){return nt.getCommands(X)}},fi={get machineId(){return le.telemetryInfo.machineId},get sessionId(){return le.telemetryInfo.sessionId},get language(){return le.environment.appLanguage},get appName(){return le.environment.appName},get appRoot(){return le.environment.appRoot?.fsPath??""},get appHost(){return le.environment.appHost},get uriScheme(){return le.environment.appUriScheme},get clipboard(){return Di.value},get shell(){return ot.getDefaultShell(!1)},get isTelemetryEnabled(){return Me.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Me.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(le.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,ce){return Ge.openUri(X,{allowTunneling:!!le.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===le.environment.appUriScheme)return ui.createAppUri(X);try{return await Ge.asExternalUri(X,{allowTunneling:!!le.remote.authority})}catch(ce){if((0,Ye.matchesScheme)(X,Et.Schemas.http)||(0,Ye.matchesScheme)(X,Et.Schemas.https))return X;throw ce}},get remoteName(){return(0,Te.getRemoteName)(le.remote.authority)},get uiKind(){return le.uiKind}};le.environment.extensionTestsLocationURI||Object.freeze(fi);const mi=le.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,Ii={createTestController(X,ce){return qt.createTestController(X,ce)},createTestObserver(){return(0,G.checkProposedApiEnabled)(Fe),qt.createTestObserver()},runTests(X){return(0,G.checkProposedApiEnabled)(Fe),qt.runTests(X)},get onDidChangeTestResults(){return(0,G.checkProposedApiEnabled)(Fe),qt.onResultsChanged},get testResults(){return(0,G.checkProposedApiEnabled)(Fe),qt.results}},Pi={getExtension(X){const ce=Tt.getExtensionDescription(X);if(ce)return new a.Extension(Ie,Fe.identifier,ce,mi)},get all(){return Tt.getAllExtensionDescriptions().map(X=>new a.Extension(Ie,Fe.identifier,X,mi))},get onDidChange(){return Tt.onDidChange}},oi={createDiagnosticCollection(X){return $t.createDiagnosticCollection(Fe.identifier,X)},get onDidChangeDiagnostics(){return $t.onDidChangeDiagnostics},getDiagnostics:X=>$t.getDiagnostics(X),getLanguages(){return Rt.getLanguages()},setTextDocumentLanguage(X,ce){return Rt.changeLanguage(X.uri,ce)},match(X,ce){return(0,t.score)(z.LanguageSelector.from(X),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(X,ce,ke){return ct.registerCodeActionProvider(Fe,pt(X),ce,ke)},registerCodeLensProvider(X,ce){return ct.registerCodeLensProvider(Fe,pt(X),ce)},registerDefinitionProvider(X,ce){return ct.registerDefinitionProvider(Fe,pt(X),ce)},registerDeclarationProvider(X,ce){return ct.registerDeclarationProvider(Fe,pt(X),ce)},registerImplementationProvider(X,ce){return ct.registerImplementationProvider(Fe,pt(X),ce)},registerTypeDefinitionProvider(X,ce){return ct.registerTypeDefinitionProvider(Fe,pt(X),ce)},registerHoverProvider(X,ce){return ct.registerHoverProvider(Fe,pt(X),ce,Fe.identifier)},registerEvaluatableExpressionProvider(X,ce){return ct.registerEvaluatableExpressionProvider(Fe,pt(X),ce,Fe.identifier)},registerInlineValuesProvider(X,ce){return ct.registerInlineValuesProvider(Fe,pt(X),ce,Fe.identifier)},registerDocumentHighlightProvider(X,ce){return ct.registerDocumentHighlightProvider(Fe,pt(X),ce)},registerLinkedEditingRangeProvider(X,ce){return ct.registerLinkedEditingRangeProvider(Fe,pt(X),ce)},registerReferenceProvider(X,ce){return ct.registerReferenceProvider(Fe,pt(X),ce)},registerRenameProvider(X,ce){return ct.registerRenameProvider(Fe,pt(X),ce)},registerDocumentSymbolProvider(X,ce,ke){return ct.registerDocumentSymbolProvider(Fe,pt(X),ce,ke)},registerWorkspaceSymbolProvider(X){return ct.registerWorkspaceSymbolProvider(Fe,X)},registerDocumentFormattingEditProvider(X,ce){return ct.registerDocumentFormattingEditProvider(Fe,pt(X),ce)},registerDocumentRangeFormattingEditProvider(X,ce){return ct.registerDocumentRangeFormattingEditProvider(Fe,pt(X),ce)},registerOnTypeFormattingEditProvider(X,ce,ke,...rt){return ct.registerOnTypeFormattingEditProvider(Fe,pt(X),ce,[ke].concat(rt))},registerDocumentSemanticTokensProvider(X,ce,ke){return ct.registerDocumentSemanticTokensProvider(Fe,pt(X),ce,ke)},registerDocumentRangeSemanticTokensProvider(X,ce,ke){return ct.registerDocumentRangeSemanticTokensProvider(Fe,pt(X),ce,ke)},registerSignatureHelpProvider(X,ce,ke,...rt){return typeof ke=="object"?ct.registerSignatureHelpProvider(Fe,pt(X),ce,ke):ct.registerSignatureHelpProvider(Fe,pt(X),ce,typeof ke=="undefined"?[]:[ke,...rt])},registerCompletionItemProvider(X,ce,...ke){return ct.registerCompletionItemProvider(Fe,pt(X),ce,ke)},registerInlineCompletionItemProvider(X,ce){return(0,G.checkProposedApiEnabled)(Fe),ct.registerInlineCompletionsProvider(Fe,pt(X),ce)},registerDocumentLinkProvider(X,ce){return ct.registerDocumentLinkProvider(Fe,pt(X),ce)},registerColorProvider(X,ce){return ct.registerColorProvider(Fe,pt(X),ce)},registerFoldingRangeProvider(X,ce){return ct.registerFoldingRangeProvider(Fe,pt(X),ce)},registerSelectionRangeProvider(X,ce){return ct.registerSelectionRangeProvider(Fe,X,ce)},registerCallHierarchyProvider(X,ce){return ct.registerCallHierarchyProvider(Fe,X,ce)},setLanguageConfiguration:(X,ce)=>ct.setLanguageConfiguration(Fe,X,ce),getTokenInformationAtPosition(X,ce){return(0,G.checkProposedApiEnabled)(Fe),Rt.tokenAtPosition(X,ce)},registerInlayHintsProvider(X,ce){return(0,G.checkProposedApiEnabled)(Fe),ct.registerInlayHintsProvider(Fe,X,ce)},registerTypeHierarchyProvider(X,ce){return(0,G.checkProposedApiEnabled)(Fe),ct.registerTypeHierarchyProvider(Fe,X,ce)},createLanguageStatusItem(X){return(0,G.checkProposedApiEnabled)(Fe),Rt.createLanguageStatusItem(X)}},Ai={get activeTextEditor(){return It.getActiveTextEditor()},get visibleTextEditors(){return It.getVisibleTextEditors()},get activeTerminal(){return ot.activeTerminal},get terminals(){return ot.terminals},async showTextDocument(X,ce,ke){const rt=await(A.URI.isUri(X)?Promise.resolve(gi.openTextDocument(X)):Promise.resolve(X));return It.showTextDocument(rt,ce,ke)},createTextEditorDecorationType(X){return It.createTextEditorDecorationType(Fe,X)},onDidChangeActiveTextEditor(X,ce,ke){return It.onDidChangeActiveTextEditor(X,ce,ke)},onDidChangeVisibleTextEditors(X,ce,ke){return It.onDidChangeVisibleTextEditors(X,ce,ke)},onDidChangeTextEditorSelection(X,ce,ke){return It.onDidChangeTextEditorSelection(X,ce,ke)},onDidChangeTextEditorOptions(X,ce,ke){return It.onDidChangeTextEditorOptions(X,ce,ke)},onDidChangeTextEditorVisibleRanges(X,ce,ke){return It.onDidChangeTextEditorVisibleRanges(X,ce,ke)},onDidChangeTextEditorViewColumn(X,ce,ke){return It.onDidChangeTextEditorViewColumn(X,ce,ke)},onDidCloseTerminal(X,ce,ke){return ot.onDidCloseTerminal(X,ce,ke)},onDidOpenTerminal(X,ce,ke){return ot.onDidOpenTerminal(X,ce,ke)},onDidChangeActiveTerminal(X,ce,ke){return ot.onDidChangeActiveTerminal(X,ce,ke)},onDidChangeTerminalDimensions(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),ot.onDidChangeTerminalDimensions(X,ce,ke)},onDidChangeTerminalState(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),ot.onDidChangeTerminalState(X,ce,ke)},onDidWriteTerminalData(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),ot.onDidWriteTerminalData(X,ce,ke)},get state(){return Ge.state},onDidChangeWindowState(X,ce,ke){return Ge.onDidChangeWindowState(X,ce,ke)},showInformationMessage(X,...ce){return Gt.showMessage(Fe,T.default.Info,X,ce[0],ce.slice(1))},showWarningMessage(X,...ce){return Gt.showMessage(Fe,T.default.Warning,X,ce[0],ce.slice(1))},showErrorMessage(X,...ce){return Gt.showMessage(Fe,T.default.Error,X,ce[0],ce.slice(1))},showQuickPick(X,ce,ke){return Ht.showQuickPick(X,!!Fe.enableProposedApi,ce,ke)},showWorkspaceFolderPick(X){return Ht.showWorkspaceFolderPick(X)},showInputBox(X,ce){return Ht.showInput(X,ce)},showOpenDialog(X){return hi.showOpenDialog(X)},showSaveDialog(X){return hi.showSaveDialog(X)},createStatusBarItem(X,ce,ke){let rt,wt,Dt;return typeof X=="string"?(rt=X,wt=ce,Dt=ke):(wt=X,Dt=ce),Wt.createStatusBarEntry(Fe,rt,wt,Dt)},setStatusBarMessage(X,ce){return Wt.setStatusBarMessage(X,ce)},withScmProgress(X){return Se.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),ci.withProgress(Fe,{location:N.ProgressLocation.SourceControl},(ce,ke)=>X({report(rt){}}))},withProgress(X,ce){return ci.withProgress(Fe,X,ce)},createOutputChannel(X){return Nt.createOutputChannel(X,Fe)},createWebviewPanel(X,ce,ke,rt){return jt.createWebviewPanel(Fe,X,ce,ke,rt)},createWebviewTextEditorInset(X,ce,ke,rt){return(0,G.checkProposedApiEnabled)(Fe),vi.createWebviewEditorInset(X,ce,ke,rt,Fe)},createTerminal(X,ce,ke){return typeof X=="object"?("location"in X&&(0,G.checkProposedApiEnabled)(Fe),"pty"in X?ot.createExtensionTerminal(X):ot.createTerminalFromOptions(X)):ot.createTerminal(X,ce,ke)},registerTerminalLinkProvider(X){return ot.registerLinkProvider(X)},registerTerminalProfileProvider(X,ce){return ot.registerProfileProvider(Fe,X,ce)},registerTreeDataProvider(X,ce){return Yt.registerTreeDataProvider(X,ce,Fe)},createTreeView(X,ce){return Yt.createTreeView(X,ce,Fe)},registerWebviewPanelSerializer:(X,ce)=>jt.registerWebviewPanelSerializer(Fe,X,ce),registerCustomEditorProvider:(X,ce,ke={})=>Ei.registerCustomEditorProvider(Fe,X,ce,ke),registerFileDecorationProvider(X){return mt.registerFileDecorationProvider(X,Fe.identifier)},registerUriHandler(X){return ui.registerUriHandler(Fe.identifier,X)},createQuickPick(){return Ht.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Ht.createInputBox(Fe.identifier)},get activeColorTheme(){return di.activeColorTheme},onDidChangeActiveColorTheme(X,ce,ke){return di.onDidChangeActiveColorTheme(X,ce,ke)},registerWebviewViewProvider(X,ce,ke){return _i.registerWebviewViewProvider(Fe,X,ce,ke?.webviewOptions)},get activeNotebookEditor(){return(0,G.checkProposedApiEnabled)(Fe),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),gt.onDidChangeActiveNotebookEditor(X,ce,ke)},get visibleNotebookEditors(){return(0,G.checkProposedApiEnabled)(Fe),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,G.checkProposedApiEnabled)(Fe),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),zt.onDidChangeNotebookEditorSelection(X,ce,ke)},onDidChangeNotebookEditorVisibleRanges(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),zt.onDidChangeNotebookEditorVisibleRanges(X,ce,ke)},showNotebookDocument(X,ce){return(0,G.checkProposedApiEnabled)(Fe),gt.showNotebookDocument(X,ce)},registerExternalUriOpener(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),yi.registerExternalUriOpener(Fe.identifier,X,ce,ke)},get openEditors(){return(0,G.checkProposedApiEnabled)(Fe),it.tabs},get onDidChangeOpenEditors(){return(0,G.checkProposedApiEnabled)(Fe),it.onDidChangeTabs},getInlineCompletionItemController(X){return(0,G.checkProposedApiEnabled)(Fe),m.InlineCompletionController.get(X)}},gi={get rootPath(){return Se.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Be.getPath()},set rootPath(X){throw M.readonly()},getWorkspaceFolder(X){return Be.getWorkspaceFolder(X)},get workspaceFolders(){return Be.getWorkspaceFolders()},get name(){return Be.name},set name(X){throw M.readonly()},get workspaceFile(){return Be.workspaceFile},set workspaceFile(X){throw M.readonly()},updateWorkspaceFolders:(X,ce,...ke)=>Be.updateWorkspaceFolders(Fe,X,ce||0,...ke),onDidChangeWorkspaceFolders:function(X,ce,ke){return Be.onDidChangeWorkspace(X,ce,ke)},asRelativePath:(X,ce)=>Be.getRelativePath(X,ce),findFiles:(X,ce,ke,rt)=>Be.findFiles(z.GlobPattern.from(X),z.GlobPattern.from(ce),ke,Fe.identifier,rt),findTextInFiles:(X,ce,ke,rt)=>{let wt,Dt;return typeof ce=="object"?(wt=ce,Dt=ke):(wt={},Dt=ce,rt=ke),Be.findTextInFiles(X,wt||{},Dt,Fe.identifier,rt)},saveAll:X=>Be.saveAll(X),applyEdit(X){return Si.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,ce,ke,rt)=>Mt.createFileSystemWatcher(z.GlobPattern.from(X),ce,ke,rt),get textDocuments(){return kt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw M.readonly()},openTextDocument(X){let ce;const ke=X;if(typeof X=="string")ce=Promise.resolve(A.URI.file(X));else if(A.URI.isUri(X))ce=Promise.resolve(X);else if(!ke||typeof ke=="object")ce=kt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(rt=>kt.ensureDocumentData(rt).then(wt=>wt.document))},onDidOpenTextDocument:(X,ce,ke)=>kt.onDidAddDocument(X,ce,ke),onDidCloseTextDocument:(X,ce,ke)=>kt.onDidRemoveDocument(X,ce,ke),onDidChangeTextDocument:(X,ce,ke)=>kt.onDidChangeDocument(X,ce,ke),onDidSaveTextDocument:(X,ce,ke)=>kt.onDidSaveDocument(X,ce,ke),onWillSaveTextDocument:(X,ce,ke)=>ei.getOnWillSaveTextDocumentEvent(Fe)(X,ce,ke),get notebookDocuments(){return gt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,ce){let ke;if(A.URI.isUri(X))ke=X,await gt.openNotebookDocument(X);else if(typeof X=="string")ke=A.URI.revive(await gt.createNotebookDocument({viewType:X,content:ce}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(X,ce,ke,rt){return gt.registerNotebookSerializer(Fe,X,ce,ke,Fe.enableProposedApi?rt:void 0)},registerNotebookContentProvider:(X,ce,ke,rt)=>((0,G.checkProposedApiEnabled)(Fe),gt.registerNotebookContentProvider(Fe,X,ce,ke,Fe.enableProposedApi?rt:void 0)),onDidChangeConfiguration:(X,ce,ke)=>Kt.onDidChangeConfiguration(X,ce,ke),getConfiguration(X,ce){return ce=arguments.length===1?void 0:ce,Kt.getConfiguration(X,ce,Fe)},registerTextDocumentContentProvider(X,ce){return Ut.registerTextDocumentContentProvider(X,ce)},registerTaskProvider:(X,ce)=>(Se.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(Fe,X,ce)),registerFileSystemProvider(X,ce,ke){return ni.registerFileSystemProvider(Fe.identifier,X,ce,ke,Fe.enableProposedApi)},get fs(){return me.value},registerFileSearchProvider:(X,ce)=>((0,G.checkProposedApiEnabled)(Fe),Ft.registerFileSearchProvider(X,ce)),registerTextSearchProvider:(X,ce)=>((0,G.checkProposedApiEnabled)(Fe),Ft.registerTextSearchProvider(X,ce)),registerRemoteAuthorityResolver:(X,ce)=>((0,G.checkProposedApiEnabled)(Fe),Ie.registerRemoteAuthorityResolver(X,ce)),registerResourceLabelFormatter:X=>((0,G.checkProposedApiEnabled)(Fe),wi.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,ce,ke)=>Mt.onDidCreateFile(X,ce,ke),onDidDeleteFiles:(X,ce,ke)=>Mt.onDidDeleteFile(X,ce,ke),onDidRenameFiles:(X,ce,ke)=>Mt.onDidRenameFile(X,ce,ke),onWillCreateFiles:(X,ce,ke)=>Mt.getOnWillCreateFileEvent(Fe)(X,ce,ke),onWillDeleteFiles:(X,ce,ke)=>Mt.getOnWillDeleteFileEvent(Fe)(X,ce,ke),onWillRenameFiles:(X,ce,ke)=>Mt.getOnWillRenameFileEvent(Fe)(X,ce,ke),openTunnel:X=>((0,G.checkProposedApiEnabled)(Fe),Ce.openTunnel(Fe,X).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,G.checkProposedApiEnabled)(Fe),Ce.getTunnels()},onDidChangeTunnels:(X,ce,ke)=>((0,G.checkProposedApiEnabled)(Fe),Ce.onDidChangeTunnels(X,ce,ke)),registerPortAttributesProvider:(X,ce)=>((0,G.checkProposedApiEnabled)(Fe),Ce.registerPortsAttributesProvider(X,ce)),registerTimelineProvider:(X,ce)=>((0,G.checkProposedApiEnabled)(Fe),bi.registerTimelineProvider(X,ce,Fe.identifier,nt.converter)),get isTrusted(){return Be.trusted},requestWorkspaceTrust:X=>((0,G.checkProposedApiEnabled)(Fe),Be.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,ce,ke)=>Be.onDidGrantWorkspaceTrust(X,ce,ke)},Ti={get inputBox(){return Se.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Fe)},createSourceControl(X,ce,ke){return Jt.createSourceControl(Fe,X,ce,ke)}},Ri={createCommentController(X,ce){return ri.createCommentController(Fe,X,ce)}},Fi={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(X,ce,ke){return lt.onDidStartDebugSession(X,ce,ke)},onDidTerminateDebugSession(X,ce,ke){return lt.onDidTerminateDebugSession(X,ce,ke)},onDidChangeActiveDebugSession(X,ce,ke){return lt.onDidChangeActiveDebugSession(X,ce,ke)},onDidReceiveDebugSessionCustomEvent(X,ce,ke){return lt.onDidReceiveDebugSessionCustomEvent(X,ce,ke)},onDidChangeBreakpoints(X,ce,ke){return lt.onDidChangeBreakpoints(X,ce,ke)},registerDebugConfigurationProvider(X,ce,ke){return lt.registerDebugConfigurationProvider(X,ce,ke||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,ce){return lt.registerDebugAdapterDescriptorFactory(Fe,X,ce)},registerDebugAdapterTrackerFactory(X,ce){return lt.registerDebugAdapterTrackerFactory(X,ce)},startDebugging(X,ce,ke){return!ke||typeof ke=="object"&&"configuration"in ke?lt.startDebugging(X,ce,{parentSession:ke}):lt.startDebugging(X,ce,ke||{})},stopDebugging(X){return lt.stopDebugging(X)},addBreakpoints(X){return lt.addBreakpoints(X)},removeBreakpoints(X){return lt.removeBreakpoints(X)},asDebugSourceUri(X,ce){return lt.asDebugSourceUri(X,ce)}},Mi={registerTaskProvider:(X,ce)=>_t.registerTaskProvider(Fe,X,ce),fetchTasks:X=>_t.fetchTasks(X),executeTask:X=>_t.executeTask(Fe,X),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(X,ce,ke)=>_t.onDidStartTask(X,ce,ke),onDidEndTask:(X,ce,ke)=>_t.onDidEndTask(X,ce,ke),onDidStartTaskProcess:(X,ce,ke)=>_t.onDidStartTaskProcess(X,ce,ke),onDidEndTaskProcess:(X,ce,ke)=>_t.onDidEndTaskProcess(X,ce,ke)},Li={createNotebookController(X,ce,ke,rt,wt){return ti.createNotebookController(Fe,X,ce,ke,rt,Fe.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(X,ce)=>gt.registerNotebookCellStatusBarItemProvider(Fe,X,ce),get onDidSaveNotebookDocument(){return(0,G.checkProposedApiEnabled)(Fe),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return(0,G.checkProposedApiEnabled)(Fe),zt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return ii.createRendererMessaging(Fe,X)},onDidChangeNotebookDocumentMetadata(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),Qt.onDidChangeNotebookDocumentMetadata(X,ce,ke)},onDidChangeNotebookCells(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCells(X,ce,ke)},onDidChangeNotebookCellExecutionState(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCellExecutionState(X,ce,ke)},onDidChangeCellOutputs(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),gt.onDidChangeCellOutputs(X,ce,ke)},onDidChangeCellMetadata(X,ce,ke){return(0,G.checkProposedApiEnabled)(Fe),gt.onDidChangeCellMetadata(X,ce,ke)},createConcatTextDocument(X,ce){return(0,G.checkProposedApiEnabled)(Fe),new $e.ExtHostNotebookConcatDocument(gt,kt,X,ce)}};return{version:le.version,authentication:Ci,commands:ki,comments:Ri,debug:Fi,env:fi,extensions:Pi,languages:oi,notebooks:Li,scm:Ti,tasks:Mi,tests:Ii,window:Ai,workspace:gi,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionList:N.InlineSuggestions,Hover:N.Hover,IndentAction:I.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:n.UIKind,Uri:A.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:bt.TextSearchCompleteMessageType,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=De}),define(we[224],be([0,1,56,96,31,95,32,47,48,37,99,100,101,72,65,70,97,71,45,69,87,63]),function(re,e,c,M,E,T,A,P,S,I,t,y,n,d,r,u,p,k,w,l,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService),(0,c.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,c.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration),(0,c.registerSingleton)(k.IExtHostConsumerFileSystem,k.ExtHostConsumerFileSystem),(0,c.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService),(0,c.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,c.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,c.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo),(0,c.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,c.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,c.registerSingleton)(d.IExtHostStorage,d.ExtHostStorage),(0,c.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,c.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService),(0,c.registerSingleton)(r.IExtHostTunnelService,r.ExtHostTunnelService),(0,c.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,c.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,c.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,c.registerSingleton)(v.IExtHostTelemetry,v.ExtHostTelemetry),(0,c.registerSingleton)(D.IExtHostEditorTabs,D.ExtHostEditorTabs)}),define(we[225],be([0,1,223,33,219,6,13,5,11]),function(re,e,c,M,E,T,A,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var I;(function(r){const u=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(k,...w)=>{w.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const l=w.slice(0,-1).join(","),v=w.pop().toString();return`(function anonymous(${l}) {
${v}
})`}});function p(...k){return u?self.eval(u.createScript("",...k)):new Function(...k)}r.create=p})(I||(I={}));class t extends E.RequireInterceptor{_installInterceptor(){}getModule(u,p){for(let k of this._alternatives){let w=k(u);if(w){u=w;break}}if(this._factories.has(u))return this._factories.get(u).load(u,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class y extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const u=this._extHostContext.getProxy(P.MainContext.MainThreadConsole);d(u,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(c.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(u){return u.browser}async _loadCommonJSModule(u,p,k){p=p.with({path:n(p.path,".js")}),u&&performance.mark(`code/extHost/willFetchExtensionCode/${u.value}`);const w=await fetch(S.FileAccess.asBrowserUri(p).toString(!0));if(u&&performance.mark(`code/extHost/didFetchExtensionCode/${u.value}`),w.status!==200)throw new Error(w.statusText);const l=await w.text(),v=`${p.toString(!0)}#vscode-extension`,D=`${l}
//# sourceURL=${v}`;let i;try{i=I.create(y._ttpExtensionScripts?.createScript("module")??"module",y._ttpExtensionScripts?.createScript("exports")??"exports",y._ttpExtensionScripts?.createScript("require")??"require",y._ttpExtensionScripts?.createScript(D)??D)}catch(_){throw console.error(u?`Loading code for extension ${u.value} failed: ${_.message}`:`Loading code failed: ${_.message}`),console.error(`${p.toString(!0)}${typeof _.line=="number"?` line ${_.line}`:""}${typeof _.column=="number"?` column ${_.column}`:""}`),console.error(_),_}const s={},a={exports:s},o=_=>{const m=this._fakeModules.getModule(_,p);if(m===void 0)throw new Error(`Cannot load module '${_}'`);return m};try{return k.codeLoadingStart(),u&&performance.mark(`code/extHost/willLoadExtensionCode/${u.value}`),i(a,s,o),a.exports!==s?a.exports:s}finally{u&&performance.mark(`code/extHost/didLoadExtensionCode/${u.value}`),k.codeLoadingStop()}}async $setRemoteEnvironment(u){}async _waitForDebuggerAttachment(u=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+u;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=y,y._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:r=>r});function n(r,u){return r.endsWith(u)?r:r+u}function d(r,u){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(l,v){const D=console[l];console[l]=function(){r.$logExtensionHostMessage({type:"__$console",severity:v,arguments:w(arguments)}),u&&D.apply(console,arguments)}}const k=1e5;function w(l){const v=[],D=[];if(l.length)for(let i=0;i<l.length;i++){if(typeof l[i]=="undefined")l[i]="undefined";else if(l[i]instanceof Error){const s=l[i];s.stack?l[i]=s.stack:l[i]=s.toString()}D.push(l[i])}try{const i=JSON.stringify(D,function(s,a){if(a&&typeof a=="object"){if(v.indexOf(a)!==-1)return"[Circular]";v.push(a)}return a});return i.length>k?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(we[226],be([0,1,56,14,33,73,225,212]),function(re,e,c,M,E,T,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(E.IExtHostExtensionService,A.ExtHostExtensionService),(0,c.registerSingleton)(M.ILogService,P.ExtHostLogService),(0,c.registerSingleton)(T.IExtensionStoragePaths,T.ExtensionStoragePaths)}),define(we[235],be([0,1,23,3,177,220,214,17,74,11,2,224,226]),function(re,e,c,M,E,T,A,P,S,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const d=fetch.bind(self);if(self.fetch=function(l,v){return l instanceof Request||/^file:/i.test(String(l))&&(l=I.FileAccess.asBrowserUri(t.URI.parse(String(l))).toString(!0)),d(l,v)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,v,D,i,s){return/^file:/i.test(v.toString())&&(v=I.FileAccess.asBrowserUri(t.URI.parse(v.toString())).toString(!0)),super.open(l,v,D??!0,i,s)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const l=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:D=>D}),v=self.Worker;Worker=function(D,i){/^file:/i.test(D.toString())&&(D=I.FileAccess.asBrowserUri(t.URI.parse(D.toString())).toString(!0));const s=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${D}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;i=i||{},i.name=i.name||P.basename(D.toString());const a=new Blob([s],{type:"application/javascript"}),o=URL.createObjectURL(a);return new v(l?l.createScriptURL(o):o,i)}}else self.Worker=class extends A.NestedWorker{constructor(l,v){super(n,l,{name:P.basename(l.toString()),...v})}};const r=new class{exit(l){y()}async exists(l){return!0}async realpath(l){return l}};class u{constructor(){const v=new MessageChannel,D=new M.Emitter;let i=!1;n(v.port2,[v.port2]),v.port1.onmessage=s=>{const{data:a}=s;if(!(a instanceof ArrayBuffer)){console.warn("UNKNOWN data received",a);return}const o=c.VSBuffer.wrap(new Uint8Array(a,0,a.byteLength));if((0,E.isMessageOfType)(o,2)){i=!0,k("received terminate message from renderer");return}D.fire(o)},this.protocol={onMessage:D.event,send:s=>{if(!i){const a=s.buffer.buffer.slice(s.buffer.byteOffset,s.buffer.byteOffset+s.buffer.byteLength);v.port1.postMessage(a,[a])}}}}}function p(l){return new Promise(v=>{const D=l.onMessage(i=>{D.dispose();const s=JSON.parse(i.toString());l.send((0,E.createMessageOfType)(0)),v({protocol:l,initData:s})});l.send((0,E.createMessageOfType)(1))})}let k=l=>y();function w(){const l=new u;S.mark("code/extHost/willConnectToRenderer"),p(l.protocol).then(v=>{S.mark("code/extHost/didWaitForInitData");const D=new T.ExtensionHostMain(v.protocol,v.initData,r,null);k=i=>D.terminate(i)})}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e7d7e9a9348e6a8cc8c03f877d39cb72e5dfb1ff/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
